%------------------------------------------------------------------------------
% File     : VBT00018_2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Definitions 00569_026210
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0063_VEBT_Definitions_00569_026210 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 11317 (2569 unt;1472 typ;   0 def)
%            Number of atoms       : 27803 (8194 equ)
%            Maximal formula atoms :   73 (   2 avg)
%            Number of connectives : 19965 (2007   ~; 354   |;2396   &)
%                                         (2063 <=>;13145  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   35 (   6 avg)
%            Maximal term depth    :   31 (   2 avg)
%            Number of types       :   12 (  11 usr)
%            Number of type conns  : 1237 (1070   >; 167   *;   0   +;   0  <<)
%            Number of predicates  :  222 ( 219 usr;   2 prp; 0-7 aty)
%            Number of functors    : 1242 (1242 usr;  42 con; 0-8 aty)
%            Number of variables   : 31968 (28853   !; 807   ?;31968   :)
%                                         (2308  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TF1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 17:44:17.246
%------------------------------------------------------------------------------
% Could-be-implicit typings (18)
tff(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

tff(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

tff(ty_t_Product__Type_Oprod,type,
    product_prod: ( $tType * $tType ) > $tType ).

tff(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

tff(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

tff(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

tff(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

tff(ty_t_String_Ochar,type,
    char: $tType ).

tff(ty_t_Real_Oreal,type,
    real: $tType ).

tff(ty_t_List_Olist,type,
    list: $tType > $tType ).

tff(ty_t_HOL_Obool,type,
    bool: $tType ).

tff(ty_t_Set_Oset,type,
    set: $tType > $tType ).

tff(ty_t_Rat_Orat,type,
    rat: $tType ).

tff(ty_t_Num_Onum,type,
    num: $tType ).

tff(ty_t_Nat_Onat,type,
    nat: $tType ).

tff(ty_t_Int_Oint,type,
    int: $tType ).

tff(ty_t_itself,type,
    itself: $tType > $tType ).

tff(ty_t_fun,type,
    fun: ( $tType * $tType ) > $tType ).

% Explicit typings (1454)
tff(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

tff(sy_c_ATP_058Lamp__a____,type,
    aTP_Lamp_a: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aa____,type,
    aTP_Lamp_aa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaa____,type,
    aTP_Lamp_aaa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aab____,type,
    aTP_Lamp_aab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aac____,type,
    aTP_Lamp_aac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aad____,type,
    aTP_Lamp_aad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aae____,type,
    aTP_Lamp_aae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaf____,type,
    aTP_Lamp_aaf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aag____,type,
    aTP_Lamp_aag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aah____,type,
    aTP_Lamp_aah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aai____,type,
    aTP_Lamp_aai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaj____,type,
    aTP_Lamp_aaj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aak____,type,
    aTP_Lamp_aak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aal____,type,
    aTP_Lamp_aal: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aam____,type,
    aTP_Lamp_aam: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aan____,type,
    aTP_Lamp_aan: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aao____,type,
    aTP_Lamp_aao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aap____,type,
    aTP_Lamp_aap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaq____,type,
    aTP_Lamp_aaq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aar____,type,
    aTP_Lamp_aar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aas____,type,
    aTP_Lamp_aas: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aat____,type,
    aTP_Lamp_aat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aau____,type,
    aTP_Lamp_aau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aav____,type,
    aTP_Lamp_aav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaw____,type,
    aTP_Lamp_aaw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aax____,type,
    aTP_Lamp_aax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aay____,type,
    aTP_Lamp_aay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaz____,type,
    aTP_Lamp_aaz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ab____,type,
    aTP_Lamp_ab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aba____,type,
    aTP_Lamp_aba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abb____,type,
    aTP_Lamp_abb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abc____,type,
    aTP_Lamp_abc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abd____,type,
    aTP_Lamp_abd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abe____,type,
    aTP_Lamp_abe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abf____,type,
    aTP_Lamp_abf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abg____,type,
    aTP_Lamp_abg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abh____,type,
    aTP_Lamp_abh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abi____,type,
    aTP_Lamp_abi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abj____,type,
    aTP_Lamp_abj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abk____,type,
    aTP_Lamp_abk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abl____,type,
    aTP_Lamp_abl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abm____,type,
    aTP_Lamp_abm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abn____,type,
    aTP_Lamp_abn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abo____,type,
    aTP_Lamp_abo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abp____,type,
    aTP_Lamp_abp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abq____,type,
    aTP_Lamp_abq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abr____,type,
    aTP_Lamp_abr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abs____,type,
    aTP_Lamp_abs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abt____,type,
    aTP_Lamp_abt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abu____,type,
    aTP_Lamp_abu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abv____,type,
    aTP_Lamp_abv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abw____,type,
    aTP_Lamp_abw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abx____,type,
    aTP_Lamp_abx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aby____,type,
    aTP_Lamp_aby: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abz____,type,
    aTP_Lamp_abz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ac____,type,
    aTP_Lamp_ac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aca____,type,
    aTP_Lamp_aca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acb____,type,
    aTP_Lamp_acb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acc____,type,
    aTP_Lamp_acc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acd____,type,
    aTP_Lamp_acd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ace____,type,
    aTP_Lamp_ace: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acf____,type,
    aTP_Lamp_acf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acg____,type,
    aTP_Lamp_acg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ach____,type,
    aTP_Lamp_ach: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aci____,type,
    aTP_Lamp_aci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acj____,type,
    aTP_Lamp_acj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ack____,type,
    aTP_Lamp_ack: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acl____,type,
    aTP_Lamp_acl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acm____,type,
    aTP_Lamp_acm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acn____,type,
    aTP_Lamp_acn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aco____,type,
    aTP_Lamp_aco: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acp____,type,
    aTP_Lamp_acp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acq____,type,
    aTP_Lamp_acq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acr____,type,
    aTP_Lamp_acr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acs____,type,
    aTP_Lamp_acs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__act____,type,
    aTP_Lamp_act: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acu____,type,
    aTP_Lamp_acu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acv____,type,
    aTP_Lamp_acv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acw____,type,
    aTP_Lamp_acw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acx____,type,
    aTP_Lamp_acx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acy____,type,
    aTP_Lamp_acy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acz____,type,
    aTP_Lamp_acz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ad____,type,
    aTP_Lamp_ad: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ada____,type,
    aTP_Lamp_ada: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adb____,type,
    aTP_Lamp_adb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adc____,type,
    aTP_Lamp_adc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__add____,type,
    aTP_Lamp_add: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ade____,type,
    aTP_Lamp_ade: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adf____,type,
    aTP_Lamp_adf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adg____,type,
    aTP_Lamp_adg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adh____,type,
    aTP_Lamp_adh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adi____,type,
    aTP_Lamp_adi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adj____,type,
    aTP_Lamp_adj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adk____,type,
    aTP_Lamp_adk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adl____,type,
    aTP_Lamp_adl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adm____,type,
    aTP_Lamp_adm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adn____,type,
    aTP_Lamp_adn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ado____,type,
    aTP_Lamp_ado: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adp____,type,
    aTP_Lamp_adp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adq____,type,
    aTP_Lamp_adq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adr____,type,
    aTP_Lamp_adr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ads____,type,
    aTP_Lamp_ads: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adt____,type,
    aTP_Lamp_adt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adu____,type,
    aTP_Lamp_adu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adv____,type,
    aTP_Lamp_adv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adw____,type,
    aTP_Lamp_adw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adx____,type,
    aTP_Lamp_adx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ady____,type,
    aTP_Lamp_ady: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adz____,type,
    aTP_Lamp_adz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ae____,type,
    aTP_Lamp_ae: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aea____,type,
    aTP_Lamp_aea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeb____,type,
    aTP_Lamp_aeb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aec____,type,
    aTP_Lamp_aec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aed____,type,
    aTP_Lamp_aed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aee____,type,
    aTP_Lamp_aee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aef____,type,
    aTP_Lamp_aef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeg____,type,
    aTP_Lamp_aeg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeh____,type,
    aTP_Lamp_aeh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aei____,type,
    aTP_Lamp_aei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aej____,type,
    aTP_Lamp_aej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aek____,type,
    aTP_Lamp_aek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ael____,type,
    aTP_Lamp_ael: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aem____,type,
    aTP_Lamp_aem: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aen____,type,
    aTP_Lamp_aen: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeo____,type,
    aTP_Lamp_aeo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aep____,type,
    aTP_Lamp_aep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeq____,type,
    aTP_Lamp_aeq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aer____,type,
    aTP_Lamp_aer: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aes____,type,
    aTP_Lamp_aes: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aet____,type,
    aTP_Lamp_aet: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeu____,type,
    aTP_Lamp_aeu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aev____,type,
    aTP_Lamp_aev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aew____,type,
    aTP_Lamp_aew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aex____,type,
    aTP_Lamp_aex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aey____,type,
    aTP_Lamp_aey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aez____,type,
    aTP_Lamp_aez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__af____,type,
    aTP_Lamp_af: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afa____,type,
    aTP_Lamp_afa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afb____,type,
    aTP_Lamp_afb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afc____,type,
    aTP_Lamp_afc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afd____,type,
    aTP_Lamp_afd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afe____,type,
    aTP_Lamp_afe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aff____,type,
    aTP_Lamp_aff: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afg____,type,
    aTP_Lamp_afg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afh____,type,
    aTP_Lamp_afh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afi____,type,
    aTP_Lamp_afi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afj____,type,
    aTP_Lamp_afj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afk____,type,
    aTP_Lamp_afk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afl____,type,
    aTP_Lamp_afl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afm____,type,
    aTP_Lamp_afm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afn____,type,
    aTP_Lamp_afn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afo____,type,
    aTP_Lamp_afo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afp____,type,
    aTP_Lamp_afp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afq____,type,
    aTP_Lamp_afq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afr____,type,
    aTP_Lamp_afr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afs____,type,
    aTP_Lamp_afs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aft____,type,
    aTP_Lamp_aft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afu____,type,
    aTP_Lamp_afu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afv____,type,
    aTP_Lamp_afv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afw____,type,
    aTP_Lamp_afw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afx____,type,
    aTP_Lamp_afx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afy____,type,
    aTP_Lamp_afy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afz____,type,
    aTP_Lamp_afz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ag____,type,
    aTP_Lamp_ag: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aga____,type,
    aTP_Lamp_aga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agb____,type,
    aTP_Lamp_agb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agc____,type,
    aTP_Lamp_agc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agd____,type,
    aTP_Lamp_agd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__age____,type,
    aTP_Lamp_age: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agf____,type,
    aTP_Lamp_agf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agg____,type,
    aTP_Lamp_agg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agh____,type,
    aTP_Lamp_agh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agi____,type,
    aTP_Lamp_agi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agj____,type,
    aTP_Lamp_agj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agk____,type,
    aTP_Lamp_agk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agl____,type,
    aTP_Lamp_agl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agm____,type,
    aTP_Lamp_agm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agn____,type,
    aTP_Lamp_agn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ago____,type,
    aTP_Lamp_ago: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agp____,type,
    aTP_Lamp_agp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agq____,type,
    aTP_Lamp_agq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agr____,type,
    aTP_Lamp_agr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ags____,type,
    aTP_Lamp_ags: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agt____,type,
    aTP_Lamp_agt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agu____,type,
    aTP_Lamp_agu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agv____,type,
    aTP_Lamp_agv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agw____,type,
    aTP_Lamp_agw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agx____,type,
    aTP_Lamp_agx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agy____,type,
    aTP_Lamp_agy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agz____,type,
    aTP_Lamp_agz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ah____,type,
    aTP_Lamp_ah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aha____,type,
    aTP_Lamp_aha: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahb____,type,
    aTP_Lamp_ahb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahc____,type,
    aTP_Lamp_ahc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahd____,type,
    aTP_Lamp_ahd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahe____,type,
    aTP_Lamp_ahe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahf____,type,
    aTP_Lamp_ahf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahg____,type,
    aTP_Lamp_ahg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahh____,type,
    aTP_Lamp_ahh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahi____,type,
    aTP_Lamp_ahi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahj____,type,
    aTP_Lamp_ahj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahk____,type,
    aTP_Lamp_ahk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahl____,type,
    aTP_Lamp_ahl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahm____,type,
    aTP_Lamp_ahm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahn____,type,
    aTP_Lamp_ahn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aho____,type,
    aTP_Lamp_aho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahp____,type,
    aTP_Lamp_ahp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahq____,type,
    aTP_Lamp_ahq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahr____,type,
    aTP_Lamp_ahr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahs____,type,
    aTP_Lamp_ahs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aht____,type,
    aTP_Lamp_aht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahu____,type,
    aTP_Lamp_ahu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahv____,type,
    aTP_Lamp_ahv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahw____,type,
    aTP_Lamp_ahw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahx____,type,
    aTP_Lamp_ahx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahy____,type,
    aTP_Lamp_ahy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahz____,type,
    aTP_Lamp_ahz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ai____,type,
    aTP_Lamp_ai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aia____,type,
    aTP_Lamp_aia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aib____,type,
    aTP_Lamp_aib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aic____,type,
    aTP_Lamp_aic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aid____,type,
    aTP_Lamp_aid: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aie____,type,
    aTP_Lamp_aie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aif____,type,
    aTP_Lamp_aif: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aig____,type,
    aTP_Lamp_aig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aih____,type,
    aTP_Lamp_aih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aii____,type,
    aTP_Lamp_aii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aij____,type,
    aTP_Lamp_aij: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aj____,type,
    aTP_Lamp_aj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ak____,type,
    aTP_Lamp_ak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__al____,type,
    aTP_Lamp_al: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__am____,type,
    aTP_Lamp_am: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__an____,type,
    aTP_Lamp_an: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ao____,type,
    aTP_Lamp_ao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ap____,type,
    aTP_Lamp_ap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aq____,type,
    aTP_Lamp_aq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ar____,type,
    aTP_Lamp_ar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__as____,type,
    aTP_Lamp_as: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__at____,type,
    aTP_Lamp_at: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__au____,type,
    aTP_Lamp_au: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__av____,type,
    aTP_Lamp_av: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aw____,type,
    aTP_Lamp_aw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ax____,type,
    aTP_Lamp_ax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ay____,type,
    aTP_Lamp_ay: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__az____,type,
    aTP_Lamp_az: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ba____,type,
    aTP_Lamp_ba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bb____,type,
    aTP_Lamp_bb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bc____,type,
    aTP_Lamp_bc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bd____,type,
    aTP_Lamp_bd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__be____,type,
    aTP_Lamp_be: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bf____,type,
    aTP_Lamp_bf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bg____,type,
    aTP_Lamp_bg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bh____,type,
    aTP_Lamp_bh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bi____,type,
    aTP_Lamp_bi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bj____,type,
    aTP_Lamp_bj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bk____,type,
    aTP_Lamp_bk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bl____,type,
    aTP_Lamp_bl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bm____,type,
    aTP_Lamp_bm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bn____,type,
    aTP_Lamp_bn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bo____,type,
    aTP_Lamp_bo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bp____,type,
    aTP_Lamp_bp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bq____,type,
    aTP_Lamp_bq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__br____,type,
    aTP_Lamp_br: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bs____,type,
    aTP_Lamp_bs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bt____,type,
    aTP_Lamp_bt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bu____,type,
    aTP_Lamp_bu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bv____,type,
    aTP_Lamp_bv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bw____,type,
    aTP_Lamp_bw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bx____,type,
    aTP_Lamp_bx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__by____,type,
    aTP_Lamp_by: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bz____,type,
    aTP_Lamp_bz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ca____,type,
    aTP_Lamp_ca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cb____,type,
    aTP_Lamp_cb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cc____,type,
    aTP_Lamp_cc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cd____,type,
    aTP_Lamp_cd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ce____,type,
    aTP_Lamp_ce: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cf____,type,
    aTP_Lamp_cf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cg____,type,
    aTP_Lamp_cg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ch____,type,
    aTP_Lamp_ch: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ci____,type,
    aTP_Lamp_ci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cj____,type,
    aTP_Lamp_cj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ck____,type,
    aTP_Lamp_ck: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cl____,type,
    aTP_Lamp_cl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cm____,type,
    aTP_Lamp_cm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cn____,type,
    aTP_Lamp_cn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__co____,type,
    aTP_Lamp_co: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cp____,type,
    aTP_Lamp_cp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cq____,type,
    aTP_Lamp_cq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cr____,type,
    aTP_Lamp_cr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cs____,type,
    aTP_Lamp_cs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ct____,type,
    aTP_Lamp_ct: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cu____,type,
    aTP_Lamp_cu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cv____,type,
    aTP_Lamp_cv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cw____,type,
    aTP_Lamp_cw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cx____,type,
    aTP_Lamp_cx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cy____,type,
    aTP_Lamp_cy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cz____,type,
    aTP_Lamp_cz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__da____,type,
    aTP_Lamp_da: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__db____,type,
    aTP_Lamp_db: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dc____,type,
    aTP_Lamp_dc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dd____,type,
    aTP_Lamp_dd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__de____,type,
    aTP_Lamp_de: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__df____,type,
    aTP_Lamp_df: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dg____,type,
    aTP_Lamp_dg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dh____,type,
    aTP_Lamp_dh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__di____,type,
    aTP_Lamp_di: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dj____,type,
    aTP_Lamp_dj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dk____,type,
    aTP_Lamp_dk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dl____,type,
    aTP_Lamp_dl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dm____,type,
    aTP_Lamp_dm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dn____,type,
    aTP_Lamp_dn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__do____,type,
    aTP_Lamp_do: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dp____,type,
    aTP_Lamp_dp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dq____,type,
    aTP_Lamp_dq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dr____,type,
    aTP_Lamp_dr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ds____,type,
    aTP_Lamp_ds: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dt____,type,
    aTP_Lamp_dt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__du____,type,
    aTP_Lamp_du: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dv____,type,
    aTP_Lamp_dv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dw____,type,
    aTP_Lamp_dw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dx____,type,
    aTP_Lamp_dx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dy____,type,
    aTP_Lamp_dy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dz____,type,
    aTP_Lamp_dz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ea____,type,
    aTP_Lamp_ea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eb____,type,
    aTP_Lamp_eb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ec____,type,
    aTP_Lamp_ec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ed____,type,
    aTP_Lamp_ed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ee____,type,
    aTP_Lamp_ee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ef____,type,
    aTP_Lamp_ef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eg____,type,
    aTP_Lamp_eg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eh____,type,
    aTP_Lamp_eh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ei____,type,
    aTP_Lamp_ei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ej____,type,
    aTP_Lamp_ej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ek____,type,
    aTP_Lamp_ek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__el____,type,
    aTP_Lamp_el: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__em____,type,
    aTP_Lamp_em: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__en____,type,
    aTP_Lamp_en: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eo____,type,
    aTP_Lamp_eo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ep____,type,
    aTP_Lamp_ep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eq____,type,
    aTP_Lamp_eq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__er____,type,
    aTP_Lamp_er: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__es____,type,
    aTP_Lamp_es: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__et____,type,
    aTP_Lamp_et: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eu____,type,
    aTP_Lamp_eu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ev____,type,
    aTP_Lamp_ev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ew____,type,
    aTP_Lamp_ew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ex____,type,
    aTP_Lamp_ex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ey____,type,
    aTP_Lamp_ey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ez____,type,
    aTP_Lamp_ez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fa____,type,
    aTP_Lamp_fa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fb____,type,
    aTP_Lamp_fb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fc____,type,
    aTP_Lamp_fc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fd____,type,
    aTP_Lamp_fd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fe____,type,
    aTP_Lamp_fe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ff____,type,
    aTP_Lamp_ff: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fg____,type,
    aTP_Lamp_fg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fh____,type,
    aTP_Lamp_fh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fi____,type,
    aTP_Lamp_fi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fj____,type,
    aTP_Lamp_fj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fk____,type,
    aTP_Lamp_fk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fl____,type,
    aTP_Lamp_fl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fm____,type,
    aTP_Lamp_fm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fn____,type,
    aTP_Lamp_fn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fo____,type,
    aTP_Lamp_fo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fp____,type,
    aTP_Lamp_fp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fq____,type,
    aTP_Lamp_fq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fr____,type,
    aTP_Lamp_fr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fs____,type,
    aTP_Lamp_fs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ft____,type,
    aTP_Lamp_ft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fu____,type,
    aTP_Lamp_fu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fv____,type,
    aTP_Lamp_fv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fw____,type,
    aTP_Lamp_fw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fx____,type,
    aTP_Lamp_fx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fy____,type,
    aTP_Lamp_fy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fz____,type,
    aTP_Lamp_fz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ga____,type,
    aTP_Lamp_ga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gb____,type,
    aTP_Lamp_gb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gc____,type,
    aTP_Lamp_gc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gd____,type,
    aTP_Lamp_gd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ge____,type,
    aTP_Lamp_ge: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gf____,type,
    aTP_Lamp_gf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gg____,type,
    aTP_Lamp_gg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gh____,type,
    aTP_Lamp_gh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gi____,type,
    aTP_Lamp_gi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gj____,type,
    aTP_Lamp_gj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gk____,type,
    aTP_Lamp_gk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gl____,type,
    aTP_Lamp_gl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gm____,type,
    aTP_Lamp_gm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gn____,type,
    aTP_Lamp_gn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__go____,type,
    aTP_Lamp_go: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gp____,type,
    aTP_Lamp_gp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gq____,type,
    aTP_Lamp_gq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gr____,type,
    aTP_Lamp_gr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gs____,type,
    aTP_Lamp_gs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gt____,type,
    aTP_Lamp_gt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gu____,type,
    aTP_Lamp_gu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gv____,type,
    aTP_Lamp_gv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gw____,type,
    aTP_Lamp_gw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gx____,type,
    aTP_Lamp_gx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gy____,type,
    aTP_Lamp_gy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gz____,type,
    aTP_Lamp_gz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ha____,type,
    aTP_Lamp_ha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hb____,type,
    aTP_Lamp_hb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hc____,type,
    aTP_Lamp_hc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hd____,type,
    aTP_Lamp_hd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__he____,type,
    aTP_Lamp_he: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hf____,type,
    aTP_Lamp_hf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hg____,type,
    aTP_Lamp_hg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hh____,type,
    aTP_Lamp_hh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hi____,type,
    aTP_Lamp_hi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hj____,type,
    aTP_Lamp_hj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hk____,type,
    aTP_Lamp_hk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hl____,type,
    aTP_Lamp_hl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hm____,type,
    aTP_Lamp_hm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hn____,type,
    aTP_Lamp_hn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ho____,type,
    aTP_Lamp_ho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hp____,type,
    aTP_Lamp_hp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hq____,type,
    aTP_Lamp_hq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hr____,type,
    aTP_Lamp_hr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hs____,type,
    aTP_Lamp_hs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ht____,type,
    aTP_Lamp_ht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hu____,type,
    aTP_Lamp_hu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hv____,type,
    aTP_Lamp_hv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hw____,type,
    aTP_Lamp_hw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hx____,type,
    aTP_Lamp_hx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hy____,type,
    aTP_Lamp_hy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hz____,type,
    aTP_Lamp_hz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ia____,type,
    aTP_Lamp_ia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ib____,type,
    aTP_Lamp_ib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ic____,type,
    aTP_Lamp_ic: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__id____,type,
    aTP_Lamp_id: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ie____,type,
    aTP_Lamp_ie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__if____,type,
    aTP_Lamp_if: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ig____,type,
    aTP_Lamp_ig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ih____,type,
    aTP_Lamp_ih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ii____,type,
    aTP_Lamp_ii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ij____,type,
    aTP_Lamp_ij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ik____,type,
    aTP_Lamp_ik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__il____,type,
    aTP_Lamp_il: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__im____,type,
    aTP_Lamp_im: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__in____,type,
    aTP_Lamp_in: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__io____,type,
    aTP_Lamp_io: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ip____,type,
    aTP_Lamp_ip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iq____,type,
    aTP_Lamp_iq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ir____,type,
    aTP_Lamp_ir: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__is____,type,
    aTP_Lamp_is: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__it____,type,
    aTP_Lamp_it: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iu____,type,
    aTP_Lamp_iu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__iv____,type,
    aTP_Lamp_iv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iw____,type,
    aTP_Lamp_iw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ix____,type,
    aTP_Lamp_ix: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iy____,type,
    aTP_Lamp_iy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iz____,type,
    aTP_Lamp_iz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ja____,type,
    aTP_Lamp_ja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jb____,type,
    aTP_Lamp_jb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jc____,type,
    aTP_Lamp_jc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jd____,type,
    aTP_Lamp_jd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__je____,type,
    aTP_Lamp_je: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jf____,type,
    aTP_Lamp_jf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jg____,type,
    aTP_Lamp_jg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jh____,type,
    aTP_Lamp_jh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ji____,type,
    aTP_Lamp_ji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jj____,type,
    aTP_Lamp_jj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jk____,type,
    aTP_Lamp_jk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jl____,type,
    aTP_Lamp_jl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jm____,type,
    aTP_Lamp_jm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jn____,type,
    aTP_Lamp_jn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jo____,type,
    aTP_Lamp_jo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jp____,type,
    aTP_Lamp_jp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jq____,type,
    aTP_Lamp_jq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jr____,type,
    aTP_Lamp_jr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__js____,type,
    aTP_Lamp_js: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jt____,type,
    aTP_Lamp_jt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ju____,type,
    aTP_Lamp_ju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jv____,type,
    aTP_Lamp_jv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jw____,type,
    aTP_Lamp_jw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jx____,type,
    aTP_Lamp_jx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jy____,type,
    aTP_Lamp_jy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jz____,type,
    aTP_Lamp_jz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ka____,type,
    aTP_Lamp_ka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kb____,type,
    aTP_Lamp_kb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kc____,type,
    aTP_Lamp_kc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kd____,type,
    aTP_Lamp_kd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ke____,type,
    aTP_Lamp_ke: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kf____,type,
    aTP_Lamp_kf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kg____,type,
    aTP_Lamp_kg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kh____,type,
    aTP_Lamp_kh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ki____,type,
    aTP_Lamp_ki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kj____,type,
    aTP_Lamp_kj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kk____,type,
    aTP_Lamp_kk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kl____,type,
    aTP_Lamp_kl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__km____,type,
    aTP_Lamp_km: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kn____,type,
    aTP_Lamp_kn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ko____,type,
    aTP_Lamp_ko: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kp____,type,
    aTP_Lamp_kp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kq____,type,
    aTP_Lamp_kq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kr____,type,
    aTP_Lamp_kr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ks____,type,
    aTP_Lamp_ks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kt____,type,
    aTP_Lamp_kt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ku____,type,
    aTP_Lamp_ku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kv____,type,
    aTP_Lamp_kv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kw____,type,
    aTP_Lamp_kw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kx____,type,
    aTP_Lamp_kx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ky____,type,
    aTP_Lamp_ky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kz____,type,
    aTP_Lamp_kz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__la____,type,
    aTP_Lamp_la: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lb____,type,
    aTP_Lamp_lb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lc____,type,
    aTP_Lamp_lc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ld____,type,
    aTP_Lamp_ld: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__le____,type,
    aTP_Lamp_le: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lf____,type,
    aTP_Lamp_lf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lg____,type,
    aTP_Lamp_lg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lh____,type,
    aTP_Lamp_lh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__li____,type,
    aTP_Lamp_li: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lj____,type,
    aTP_Lamp_lj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lk____,type,
    aTP_Lamp_lk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ll____,type,
    aTP_Lamp_ll: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lm____,type,
    aTP_Lamp_lm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ln____,type,
    aTP_Lamp_ln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lo____,type,
    aTP_Lamp_lo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lp____,type,
    aTP_Lamp_lp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lq____,type,
    aTP_Lamp_lq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lr____,type,
    aTP_Lamp_lr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ls____,type,
    aTP_Lamp_ls: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lt____,type,
    aTP_Lamp_lt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lu____,type,
    aTP_Lamp_lu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lv____,type,
    aTP_Lamp_lv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lw____,type,
    aTP_Lamp_lw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lx____,type,
    aTP_Lamp_lx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ly____,type,
    aTP_Lamp_ly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lz____,type,
    aTP_Lamp_lz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ma____,type,
    aTP_Lamp_ma: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mb____,type,
    aTP_Lamp_mb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mc____,type,
    aTP_Lamp_mc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__md____,type,
    aTP_Lamp_md: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__me____,type,
    aTP_Lamp_me: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mf____,type,
    aTP_Lamp_mf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mg____,type,
    aTP_Lamp_mg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mh____,type,
    aTP_Lamp_mh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mi____,type,
    aTP_Lamp_mi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mj____,type,
    aTP_Lamp_mj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mk____,type,
    aTP_Lamp_mk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ml____,type,
    aTP_Lamp_ml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mm____,type,
    aTP_Lamp_mm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mn____,type,
    aTP_Lamp_mn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mo____,type,
    aTP_Lamp_mo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mp____,type,
    aTP_Lamp_mp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mq____,type,
    aTP_Lamp_mq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mr____,type,
    aTP_Lamp_mr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ms____,type,
    aTP_Lamp_ms: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mt____,type,
    aTP_Lamp_mt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mu____,type,
    aTP_Lamp_mu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mv____,type,
    aTP_Lamp_mv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mw____,type,
    aTP_Lamp_mw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mx____,type,
    aTP_Lamp_mx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__my____,type,
    aTP_Lamp_my: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mz____,type,
    aTP_Lamp_mz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__na____,type,
    aTP_Lamp_na: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nb____,type,
    aTP_Lamp_nb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nc____,type,
    aTP_Lamp_nc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nd____,type,
    aTP_Lamp_nd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ne____,type,
    aTP_Lamp_ne: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nf____,type,
    aTP_Lamp_nf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ng____,type,
    aTP_Lamp_ng: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nh____,type,
    aTP_Lamp_nh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ni____,type,
    aTP_Lamp_ni: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nj____,type,
    aTP_Lamp_nj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nk____,type,
    aTP_Lamp_nk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nl____,type,
    aTP_Lamp_nl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nm____,type,
    aTP_Lamp_nm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nn____,type,
    aTP_Lamp_nn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__no____,type,
    aTP_Lamp_no: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__np____,type,
    aTP_Lamp_np: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nq____,type,
    aTP_Lamp_nq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nr____,type,
    aTP_Lamp_nr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ns____,type,
    aTP_Lamp_ns: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nt____,type,
    aTP_Lamp_nt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nu____,type,
    aTP_Lamp_nu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nv____,type,
    aTP_Lamp_nv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nw____,type,
    aTP_Lamp_nw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nx____,type,
    aTP_Lamp_nx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ny____,type,
    aTP_Lamp_ny: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nz____,type,
    aTP_Lamp_nz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oa____,type,
    aTP_Lamp_oa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ob____,type,
    aTP_Lamp_ob: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oc____,type,
    aTP_Lamp_oc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__od____,type,
    aTP_Lamp_od: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oe____,type,
    aTP_Lamp_oe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__of____,type,
    aTP_Lamp_of: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__og____,type,
    aTP_Lamp_og: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oh____,type,
    aTP_Lamp_oh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oi____,type,
    aTP_Lamp_oi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oj____,type,
    aTP_Lamp_oj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ok____,type,
    aTP_Lamp_ok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ol____,type,
    aTP_Lamp_ol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__om____,type,
    aTP_Lamp_om: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__on____,type,
    aTP_Lamp_on: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oo____,type,
    aTP_Lamp_oo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__op____,type,
    aTP_Lamp_op: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oq____,type,
    aTP_Lamp_oq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__or____,type,
    aTP_Lamp_or: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__os____,type,
    aTP_Lamp_os: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ot____,type,
    aTP_Lamp_ot: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ou____,type,
    aTP_Lamp_ou: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ov____,type,
    aTP_Lamp_ov: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ow____,type,
    aTP_Lamp_ow: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ox____,type,
    aTP_Lamp_ox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oy____,type,
    aTP_Lamp_oy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oz____,type,
    aTP_Lamp_oz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pa____,type,
    aTP_Lamp_pa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pb____,type,
    aTP_Lamp_pb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pc____,type,
    aTP_Lamp_pc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pd____,type,
    aTP_Lamp_pd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pe____,type,
    aTP_Lamp_pe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pf____,type,
    aTP_Lamp_pf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pg____,type,
    aTP_Lamp_pg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ph____,type,
    aTP_Lamp_ph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pi____,type,
    aTP_Lamp_pi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pj____,type,
    aTP_Lamp_pj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pk____,type,
    aTP_Lamp_pk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pl____,type,
    aTP_Lamp_pl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pm____,type,
    aTP_Lamp_pm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pn____,type,
    aTP_Lamp_pn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__po____,type,
    aTP_Lamp_po: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pp____,type,
    aTP_Lamp_pp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pq____,type,
    aTP_Lamp_pq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pr____,type,
    aTP_Lamp_pr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ps____,type,
    aTP_Lamp_ps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pt____,type,
    aTP_Lamp_pt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pu____,type,
    aTP_Lamp_pu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pv____,type,
    aTP_Lamp_pv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pw____,type,
    aTP_Lamp_pw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__px____,type,
    aTP_Lamp_px: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__py____,type,
    aTP_Lamp_py: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pz____,type,
    aTP_Lamp_pz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qa____,type,
    aTP_Lamp_qa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qb____,type,
    aTP_Lamp_qb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qc____,type,
    aTP_Lamp_qc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qd____,type,
    aTP_Lamp_qd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qe____,type,
    aTP_Lamp_qe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qf____,type,
    aTP_Lamp_qf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qg____,type,
    aTP_Lamp_qg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qh____,type,
    aTP_Lamp_qh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qi____,type,
    aTP_Lamp_qi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qj____,type,
    aTP_Lamp_qj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qk____,type,
    aTP_Lamp_qk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ql____,type,
    aTP_Lamp_ql: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qm____,type,
    aTP_Lamp_qm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qn____,type,
    aTP_Lamp_qn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qo____,type,
    aTP_Lamp_qo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qp____,type,
    aTP_Lamp_qp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qq____,type,
    aTP_Lamp_qq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qr____,type,
    aTP_Lamp_qr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qs____,type,
    aTP_Lamp_qs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qt____,type,
    aTP_Lamp_qt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qu____,type,
    aTP_Lamp_qu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qv____,type,
    aTP_Lamp_qv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qw____,type,
    aTP_Lamp_qw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qx____,type,
    aTP_Lamp_qx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qy____,type,
    aTP_Lamp_qy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qz____,type,
    aTP_Lamp_qz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ra____,type,
    aTP_Lamp_ra: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rb____,type,
    aTP_Lamp_rb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rc____,type,
    aTP_Lamp_rc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rd____,type,
    aTP_Lamp_rd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__re____,type,
    aTP_Lamp_re: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rf____,type,
    aTP_Lamp_rf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rg____,type,
    aTP_Lamp_rg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rh____,type,
    aTP_Lamp_rh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ri____,type,
    aTP_Lamp_ri: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rj____,type,
    aTP_Lamp_rj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rk____,type,
    aTP_Lamp_rk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rl____,type,
    aTP_Lamp_rl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rm____,type,
    aTP_Lamp_rm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rn____,type,
    aTP_Lamp_rn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ro____,type,
    aTP_Lamp_ro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rp____,type,
    aTP_Lamp_rp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rq____,type,
    aTP_Lamp_rq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rr____,type,
    aTP_Lamp_rr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rs____,type,
    aTP_Lamp_rs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rt____,type,
    aTP_Lamp_rt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ru____,type,
    aTP_Lamp_ru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rv____,type,
    aTP_Lamp_rv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rw____,type,
    aTP_Lamp_rw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rx____,type,
    aTP_Lamp_rx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ry____,type,
    aTP_Lamp_ry: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rz____,type,
    aTP_Lamp_rz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sa____,type,
    aTP_Lamp_sa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sb____,type,
    aTP_Lamp_sb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sc____,type,
    aTP_Lamp_sc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sd____,type,
    aTP_Lamp_sd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__se____,type,
    aTP_Lamp_se: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sf____,type,
    aTP_Lamp_sf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sg____,type,
    aTP_Lamp_sg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sh____,type,
    aTP_Lamp_sh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__si____,type,
    aTP_Lamp_si: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sj____,type,
    aTP_Lamp_sj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sk____,type,
    aTP_Lamp_sk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sl____,type,
    aTP_Lamp_sl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sm____,type,
    aTP_Lamp_sm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sn____,type,
    aTP_Lamp_sn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__so____,type,
    aTP_Lamp_so: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sp____,type,
    aTP_Lamp_sp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sq____,type,
    aTP_Lamp_sq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sr____,type,
    aTP_Lamp_sr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ss____,type,
    aTP_Lamp_ss: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__st____,type,
    aTP_Lamp_st: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__su____,type,
    aTP_Lamp_su: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sv____,type,
    aTP_Lamp_sv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sw____,type,
    aTP_Lamp_sw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sx____,type,
    aTP_Lamp_sx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sy____,type,
    aTP_Lamp_sy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sz____,type,
    aTP_Lamp_sz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ta____,type,
    aTP_Lamp_ta: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tb____,type,
    aTP_Lamp_tb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tc____,type,
    aTP_Lamp_tc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__td____,type,
    aTP_Lamp_td: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__te____,type,
    aTP_Lamp_te: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tf____,type,
    aTP_Lamp_tf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tg____,type,
    aTP_Lamp_tg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__th____,type,
    aTP_Lamp_th: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ti____,type,
    aTP_Lamp_ti: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tj____,type,
    aTP_Lamp_tj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tk____,type,
    aTP_Lamp_tk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tl____,type,
    aTP_Lamp_tl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tm____,type,
    aTP_Lamp_tm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tn____,type,
    aTP_Lamp_tn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__to____,type,
    aTP_Lamp_to: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tp____,type,
    aTP_Lamp_tp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tq____,type,
    aTP_Lamp_tq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tr____,type,
    aTP_Lamp_tr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ts____,type,
    aTP_Lamp_ts: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tt____,type,
    aTP_Lamp_tt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tu____,type,
    aTP_Lamp_tu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tv____,type,
    aTP_Lamp_tv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tw____,type,
    aTP_Lamp_tw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tx____,type,
    aTP_Lamp_tx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ty____,type,
    aTP_Lamp_ty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tz____,type,
    aTP_Lamp_tz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ua____,type,
    aTP_Lamp_ua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ub____,type,
    aTP_Lamp_ub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uc____,type,
    aTP_Lamp_uc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ud____,type,
    aTP_Lamp_ud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ue____,type,
    aTP_Lamp_ue: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uf____,type,
    aTP_Lamp_uf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ug____,type,
    aTP_Lamp_ug: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uh____,type,
    aTP_Lamp_uh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ui____,type,
    aTP_Lamp_ui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uj____,type,
    aTP_Lamp_uj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uk____,type,
    aTP_Lamp_uk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ul____,type,
    aTP_Lamp_ul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__um____,type,
    aTP_Lamp_um: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__un____,type,
    aTP_Lamp_un: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uo____,type,
    aTP_Lamp_uo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__up____,type,
    aTP_Lamp_up: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uq____,type,
    aTP_Lamp_uq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ur____,type,
    aTP_Lamp_ur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__us____,type,
    aTP_Lamp_us: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ut____,type,
    aTP_Lamp_ut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uu____,type,
    aTP_Lamp_uu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uv____,type,
    aTP_Lamp_uv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uw____,type,
    aTP_Lamp_uw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ux____,type,
    aTP_Lamp_ux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uy____,type,
    aTP_Lamp_uy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uz____,type,
    aTP_Lamp_uz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__va____,type,
    aTP_Lamp_va: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vb____,type,
    aTP_Lamp_vb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vc____,type,
    aTP_Lamp_vc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vd____,type,
    aTP_Lamp_vd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ve____,type,
    aTP_Lamp_ve: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vf____,type,
    aTP_Lamp_vf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vg____,type,
    aTP_Lamp_vg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vh____,type,
    aTP_Lamp_vh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vi____,type,
    aTP_Lamp_vi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vj____,type,
    aTP_Lamp_vj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vk____,type,
    aTP_Lamp_vk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vl____,type,
    aTP_Lamp_vl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vm____,type,
    aTP_Lamp_vm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vn____,type,
    aTP_Lamp_vn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vo____,type,
    aTP_Lamp_vo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vp____,type,
    aTP_Lamp_vp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vq____,type,
    aTP_Lamp_vq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vr____,type,
    aTP_Lamp_vr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vs____,type,
    aTP_Lamp_vs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vt____,type,
    aTP_Lamp_vt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vu____,type,
    aTP_Lamp_vu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vv____,type,
    aTP_Lamp_vv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vw____,type,
    aTP_Lamp_vw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vx____,type,
    aTP_Lamp_vx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vy____,type,
    aTP_Lamp_vy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vz____,type,
    aTP_Lamp_vz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wa____,type,
    aTP_Lamp_wa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wb____,type,
    aTP_Lamp_wb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wc____,type,
    aTP_Lamp_wc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wd____,type,
    aTP_Lamp_wd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__we____,type,
    aTP_Lamp_we: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wf____,type,
    aTP_Lamp_wf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wg____,type,
    aTP_Lamp_wg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wh____,type,
    aTP_Lamp_wh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wi____,type,
    aTP_Lamp_wi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wj____,type,
    aTP_Lamp_wj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wk____,type,
    aTP_Lamp_wk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wl____,type,
    aTP_Lamp_wl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wm____,type,
    aTP_Lamp_wm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wn____,type,
    aTP_Lamp_wn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wo____,type,
    aTP_Lamp_wo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wp____,type,
    aTP_Lamp_wp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wq____,type,
    aTP_Lamp_wq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wr____,type,
    aTP_Lamp_wr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ws____,type,
    aTP_Lamp_ws: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wt____,type,
    aTP_Lamp_wt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wu____,type,
    aTP_Lamp_wu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wv____,type,
    aTP_Lamp_wv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ww____,type,
    aTP_Lamp_ww: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wx____,type,
    aTP_Lamp_wx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wy____,type,
    aTP_Lamp_wy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wz____,type,
    aTP_Lamp_wz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xa____,type,
    aTP_Lamp_xa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xb____,type,
    aTP_Lamp_xb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xc____,type,
    aTP_Lamp_xc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xd____,type,
    aTP_Lamp_xd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xe____,type,
    aTP_Lamp_xe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xf____,type,
    aTP_Lamp_xf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xg____,type,
    aTP_Lamp_xg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xh____,type,
    aTP_Lamp_xh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xi____,type,
    aTP_Lamp_xi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xj____,type,
    aTP_Lamp_xj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xk____,type,
    aTP_Lamp_xk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xl____,type,
    aTP_Lamp_xl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xm____,type,
    aTP_Lamp_xm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xn____,type,
    aTP_Lamp_xn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xo____,type,
    aTP_Lamp_xo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xp____,type,
    aTP_Lamp_xp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xq____,type,
    aTP_Lamp_xq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xr____,type,
    aTP_Lamp_xr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xs____,type,
    aTP_Lamp_xs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xt____,type,
    aTP_Lamp_xt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xu____,type,
    aTP_Lamp_xu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xv____,type,
    aTP_Lamp_xv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xw____,type,
    aTP_Lamp_xw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xx____,type,
    aTP_Lamp_xx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xy____,type,
    aTP_Lamp_xy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xz____,type,
    aTP_Lamp_xz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ya____,type,
    aTP_Lamp_ya: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yb____,type,
    aTP_Lamp_yb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yc____,type,
    aTP_Lamp_yc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yd____,type,
    aTP_Lamp_yd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ye____,type,
    aTP_Lamp_ye: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yf____,type,
    aTP_Lamp_yf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yg____,type,
    aTP_Lamp_yg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yh____,type,
    aTP_Lamp_yh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yi____,type,
    aTP_Lamp_yi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yj____,type,
    aTP_Lamp_yj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yk____,type,
    aTP_Lamp_yk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yl____,type,
    aTP_Lamp_yl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ym____,type,
    aTP_Lamp_ym: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yn____,type,
    aTP_Lamp_yn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yo____,type,
    aTP_Lamp_yo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yp____,type,
    aTP_Lamp_yp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yq____,type,
    aTP_Lamp_yq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yr____,type,
    aTP_Lamp_yr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ys____,type,
    aTP_Lamp_ys: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yt____,type,
    aTP_Lamp_yt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yu____,type,
    aTP_Lamp_yu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yv____,type,
    aTP_Lamp_yv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yw____,type,
    aTP_Lamp_yw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yx____,type,
    aTP_Lamp_yx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yy____,type,
    aTP_Lamp_yy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yz____,type,
    aTP_Lamp_yz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__za____,type,
    aTP_Lamp_za: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zb____,type,
    aTP_Lamp_zb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zc____,type,
    aTP_Lamp_zc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zd____,type,
    aTP_Lamp_zd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ze____,type,
    aTP_Lamp_ze: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zf____,type,
    aTP_Lamp_zf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zg____,type,
    aTP_Lamp_zg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zh____,type,
    aTP_Lamp_zh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zi____,type,
    aTP_Lamp_zi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zj____,type,
    aTP_Lamp_zj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zk____,type,
    aTP_Lamp_zk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zl____,type,
    aTP_Lamp_zl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zm____,type,
    aTP_Lamp_zm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zn____,type,
    aTP_Lamp_zn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zo____,type,
    aTP_Lamp_zo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zp____,type,
    aTP_Lamp_zp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zq____,type,
    aTP_Lamp_zq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zr____,type,
    aTP_Lamp_zr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zs____,type,
    aTP_Lamp_zs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zt____,type,
    aTP_Lamp_zt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zu____,type,
    aTP_Lamp_zu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zv____,type,
    aTP_Lamp_zv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zw____,type,
    aTP_Lamp_zw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zx____,type,
    aTP_Lamp_zx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zy____,type,
    aTP_Lamp_zy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zz____,type,
    aTP_Lamp_zz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(fun(A,B)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set(B) * fun(C,A) * fun(B,D) ) > fun(fun(D,C),fun(B,A)) ) ).

tff(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,nat) * fun(B,nat) * product_prod(A,B) ) > nat ) ).

tff(sy_c_Binomial_Obinomial,type,
    binomial: nat > fun(nat,nat) ).

tff(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: fun(product_prod(int,int),fun(product_prod(int,int),bool)) ).

tff(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: ( nat * int ) > fun(int,int) ).

tff(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: ( num * num ) > num ).

tff(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: fun(product_prod(num,num),fun(product_prod(num,num),bool)) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > fun(nat,bool) ) ).

tff(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: ( nat * num ) > option(num) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_COMBB,type,
    combb: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( fun(B,C) * fun(A,B) ) > fun(A,C) ) ).

tff(sy_c_COMBC,type,
    combc: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,C)) * B ) > fun(A,C) ) ).

tff(sy_c_COMBS,type,
    combs: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,C)) * fun(A,B) ) > fun(A,C) ) ).

tff(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > product_prod(code_integer,bool) ).

tff(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

tff(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

tff(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: fun(num,code_integer) ).

tff(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

tff(sy_c_Code__Numeral_Onegative,type,
    code_negative: fun(num,code_integer) ).

tff(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

tff(sy_c_Code__Numeral_Opositive,type,
    code_positive: fun(num,code_integer) ).

tff(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: fun(num,int) ).

tff(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: fun(num,int) ).

tff(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complex_OArg,type,
    arg: complex > real ).

tff(sy_c_Complex_Ocis,type,
    cis: real > complex ).

tff(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

tff(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: ( real * real ) > complex ).

tff(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

tff(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

tff(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

tff(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

tff(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( fun(A,A) * A * filter(A) ) > $o ) ).

tff(sy_c_Divides_Oadjust__div,type,
    adjust_div: product_prod(int,int) > int ).

tff(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: ( int * int ) > int ).

tff(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: ( int * int * product_prod(int,int) ) > $o ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( product_prod(A,A) > $o ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( ( num * num ) > product_prod(A,A) ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( ( num * product_prod(A,A) ) > product_prod(A,A) ) ).

tff(sy_c_Extended__Nat_Oenat,type,
    extended_enat2: nat > extended_enat ).

tff(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : ( ( fun(nat,T) * T * extended_enat ) > T ) ).

tff(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,
    extend4730790105801354508finity: 
      !>[A: $tType] : A ).

tff(sy_c_Extended__Nat_Othe__enat,type,
    extended_the_enat: extended_enat > nat ).

tff(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( ( A * nat ) > A ) ).

tff(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( fun(A,bool) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( set(A) > filter(A) ) ).

tff(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : fun(set(B),nat) ).

tff(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B ) > fun(set(A),B) ) ).

tff(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * set(B) ) > $o ) ).

tff(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( fun(B,C) > fun(fun(A,B),fun(A,C)) ) ).

tff(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( fun(C,A) * fun(B,D) ) > fun(fun(A,B),fun(C,D)) ) ).

tff(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * B ) > A ) ).

tff(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_Obezw,type,
    bezw: ( nat * nat ) > product_prod(int,int) ).

tff(sy_c_GCD_Obezw__rel,type,
    bezw_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)) ).

tff(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)) ).

tff(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( itself(A) > nat ) ).

tff(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

tff(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * A * list(B) ) > A ) ).

tff(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

tff(sy_c_If,type,
    if: 
      !>[A: $tType] : ( ( bool * A * A ) > A ) ).

tff(sy_c_Int_OAbs__Integ,type,
    abs_Integ: fun(product_prod(nat,nat),int) ).

tff(sy_c_Int_ORep__Integ,type,
    rep_Integ: fun(int,product_prod(nat,nat)) ).

tff(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Onat,type,
    nat2: fun(int,nat) ).

tff(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( ( A * int ) > A ) ).

tff(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : fun(int,A) ).

tff(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : fun(list(A),fun(list(A),list(A))) ).

tff(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * list(A) ) > A ) ).

tff(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),list(A)),fun(product_prod(fun(A,B),list(A)),bool)) ).

tff(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list(A) * fun(A,list(B)) ) > list(B) ) ).

tff(sy_c_List_Ocan__select,type,
    can_select: 
      !>[A: $tType] : ( ( fun(A,bool) * set(A) ) > $o ) ).

tff(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( list(list(A)) > list(A) ) ).

tff(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( list(A) > fun(A,nat) ) ).

tff(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( list(A) > $o ) ).

tff(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(product_prod(nat,A)) ) ).

tff(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > option(product_prod(list(A),product_prod(A,list(A)))) ) ).

tff(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( fun(A,bool) > fun(list(A),list(A)) ) ).

tff(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > option(A) ) ).

tff(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * set(B) * fun(B,A) ) > $o ) ).

tff(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Oinsert,type,
    insert: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(nat,set(product_prod(list(A),list(A)))) ) ).

tff(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(A,bool)) > fun(fun(B,A),fun(B,fun(list(B),list(B)))) ) ).

tff(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(A,bool)) > fun(fun(B,A),fun(set(B),list(B))) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(B,fun(list(B),list(B))) ) ).

tff(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(set(B),list(B)) ) ).

tff(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : fun(set(A),list(A)) ).

tff(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : list(A) ).

tff(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,fun(list(A),B)) ) > fun(list(A),B) ) ).

tff(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(list(A),list(Aa)) ) ).

tff(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : fun(list(A),set(A)) ).

tff(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( fun(A,nat) > fun(list(A),nat) ) ).

tff(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Olist__ex1,type,
    list_ex1: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > $o ) ).

tff(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list(A) * nat * A ) > list(A) ) ).

tff(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(list(A),list(B))) ) ).

tff(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(list(A),fun(list(B),bool)) ) ).

tff(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( list(set(A)) > set(list(A)) ) ).

tff(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) ) > list(B) ) ).

tff(sy_c_List_Omember,type,
    member: 
      !>[A: $tType] : ( ( list(A) * A ) > $o ) ).

tff(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : fun(list(A),fun(list(A),bool)) ).

tff(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(list(A)) ) ).

tff(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( list(A) > fun(nat,A) ) ).

tff(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list(A) * set(nat) ) > list(A) ) ).

tff(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : fun(list(A),fun(list(A),bool)) ).

tff(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( ( nat * A ) > list(A) ) ).

tff(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > fun(list(A),list(A)) ) ).

tff(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set(A) * set(list(A)) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) ) > $o ) ).

tff(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,bool)),list(A)),fun(product_prod(fun(A,fun(A,bool)),list(A)),bool)) ).

tff(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( list(A) > list(list(A)) ) ).

tff(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > list(A) ) ).

tff(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : fun(list(list(A)),fun(list(list(A)),bool)) ).

tff(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oupt,type,
    upt: ( nat * nat ) > list(nat) ).

tff(sy_c_List_Oupto,type,
    upto: ( int * int ) > list(int) ).

tff(sy_c_List_Oupto__aux,type,
    upto_aux: ( int * int * list(int) ) > list(int) ).

tff(sy_c_List_Oupto__rel,type,
    upto_rel: fun(product_prod(int,int),fun(product_prod(int,int),bool)) ).

tff(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_Nat_OSuc,type,
    suc: fun(nat,nat) ).

tff(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : fun(nat,fun(fun(A,A),fun(A,A))) ).

tff(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( ( A * fun(nat,A) * nat ) > A ) ).

tff(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

tff(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) ) > fun(nat,T) ) ).

tff(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) * nat ) > fun(T,bool) ) ).

tff(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( fun(A,A) * nat * A ) > A ) ).

tff(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: list(nat) > nat ).

tff(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: fun(list(nat),fun(list(nat),bool)) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)) ).

tff(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: fun(product_prod(nat,nat),nat) ).

tff(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > set(nat) ).

tff(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: fun(set(nat),nat) ).

tff(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

tff(sy_c_NthRoot_Oroot,type,
    root: nat > fun(real,real) ).

tff(sy_c_NthRoot_Osqrt,type,
    sqrt: fun(real,real) ).

tff(sy_c_Num_OBitM,type,
    bitM: num > num ).

tff(sy_c_Num_Oinc,type,
    inc: num > num ).

tff(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( ( num * num ) > A ) ).

tff(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

tff(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

tff(sy_c_Num_Onum_OOne,type,
    one2: num ).

tff(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

tff(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

tff(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : fun(num,A) ).

tff(sy_c_Num_Opow,type,
    pow: ( num * num ) > num ).

tff(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

tff(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Osqr,type,
    sqr: num > num ).

tff(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : option(A) ).

tff(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > option(A) ) ).

tff(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,B) * option(A) ) > B ) ).

tff(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( fun(A,nat) * option(A) ) > nat ) ).

tff(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

tff(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

tff(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > fun(B,product_prod(A,B)) ) ).

tff(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(product_prod(A,B),product_prod(A,C))) ).

tff(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,C)) > fun(product_prod(A,B),C) ) ).

tff(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),A) ).

tff(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),B) ).

tff(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Rat_OFract,type,
    fract: ( int * int ) > rat ).

tff(sy_c_Rat_OFrct,type,
    frct: product_prod(int,int) > rat ).

tff(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Rat_Onormalize,type,
    normalize: product_prod(int,int) > product_prod(int,int) ).

tff(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > product_prod(int,int) ).

tff(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( ( A * A ) > real ) ).

tff(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

tff(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

tff(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > fun(A,A) ) ).

tff(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,B)) * set(product_prod(B,C)) ) > set(product_prod(A,C)) ) ).

tff(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : fun(bool,A) ).

tff(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( fun(nat,A) > A ) ).

tff(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( fun(nat,A) * A ) > $o ) ).

tff(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( fun(A,bool) > set(A) ) ).

tff(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(set(A),set(B)) ) ).

tff(sy_c_Set_Oinsert,type,
    insert2: 
      !>[A: $tType] : ( A > fun(set(A),set(A)) ) ).

tff(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( fun(nat,fun(A,A)) * nat * nat * A ) > A ) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : fun(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),fun(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool)) ).

tff(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

tff(sy_c_String_Ochar_OChar,type,
    char2: ( bool * bool * bool * bool * bool * bool * bool * bool ) > char ).

tff(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

tff(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : fun(char,A) ).

tff(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

tff(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : fun(A,char) ).

tff(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter(F) * fun(F,A) ) > A ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( ( A * set(A) ) > filter(A) ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > filter(A) ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( filter(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ocomplete,type,
    topolo2479028161051973599mplete: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : filter(product_prod(A,A)) ).

tff(sy_c_Transcendental_Oarccos,type,
    arccos: fun(real,real) ).

tff(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oarcsin,type,
    arcsin: fun(real,real) ).

tff(sy_c_Transcendental_Oarctan,type,
    arctan: fun(real,real) ).

tff(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

tff(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( fun(nat,A) > fun(nat,A) ) ).

tff(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Olog,type,
    log: real > fun(real,real) ).

tff(sy_c_Transcendental_Opi,type,
    pi: real ).

tff(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

tff(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( ( nat * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: ( bool * bool ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option(product_prod(nat,nat)) * nat * list(vEBT_VEBT) * vEBT_VEBT ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: fun(vEBT_VEBT,nat) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: fun(vEBT_VEBT,fun(nat,bool)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead,type,
    vEBT_VEBT_elim_dead: ( vEBT_VEBT * extended_enat ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead__rel,type,
    vEBT_V312737461966249ad_rel: fun(product_prod(vEBT_VEBT,extended_enat),fun(product_prod(vEBT_VEBT,extended_enat),bool)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: ( nat * nat ) > nat ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: ( nat * list(vEBT_VEBT) * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: ( nat * nat ) > nat ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),bool)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),bool)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),bool)) ).

tff(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > set(nat) ).

tff(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: fun(nat,fun(nat,bool)) ).

tff(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,bool) ) ).

tff(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : set(product_prod(set(A),set(A))) ).

tff(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( fun(A,nat) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( fun(A,nat) * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_aa,type,
    aa: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A ) > B ) ).

tff(sy_c_fAll,type,
    fAll: 
      !>[A: $tType] : ( fun(A,bool) > bool ) ).

tff(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_fEx,type,
    fEx: 
      !>[A: $tType] : fun(fun(A,bool),bool) ).

tff(sy_c_fFalse,type,
    fFalse: bool ).

tff(sy_c_fNot,type,
    fNot: fun(bool,bool) ).

tff(sy_c_fTrue,type,
    fTrue: bool ).

tff(sy_c_fconj,type,
    fconj: ( bool * bool ) > bool ).

tff(sy_c_fdisj,type,
    fdisj: ( bool * bool ) > bool ).

tff(sy_c_fequal,type,
    fequal: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_fimplies,type,
    fimplies: fun(bool,fun(bool,bool)) ).

tff(sy_c_member,type,
    member2: 
      !>[A: $tType] : fun(A,fun(set(A),bool)) ).

tff(sy_c_pp,type,
    pp: bool > $o ).

tff(sy_v_dega____,type,
    dega: nat ).

tff(sy_v_i____,type,
    i: nat ).

tff(sy_v_m____,type,
    m: nat ).

tff(sy_v_na____,type,
    na: nat ).

tff(sy_v_summarya____,type,
    summarya: vEBT_VEBT ).

tff(sy_v_treeLista____,type,
    treeLista: list(vEBT_VEBT) ).

% Relevant facts (9077)
tff(fact_0__C2_Ohyps_C_I3_J,axiom,
    m = na ).

% "2.hyps"(3)
tff(fact_1__092_060open_062i_A_060_A2_A_094_Am_092_060close_062,axiom,
    pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),i),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),m))) ).

% \<open>i < 2 ^ m\<close>
tff(fact_2__C2_Ohyps_C_I6_J,axiom,
    ! [X: vEBT_VEBT] :
      ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),treeLista)))
     => ~ ? [X_1: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X),X_1)) ) ).

% "2.hyps"(6)
tff(fact_3_inthall,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),N: nat] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X2)) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),N))) ) ) ).

% inthall
tff(fact_4__C2_Ohyps_C_I2_J,axiom,
    aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),treeLista) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),m) ).

% "2.hyps"(2)
tff(fact_5_intind,axiom,
    ! [A: $tType,I: nat,N: nat,P: fun(A,bool),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),N))
     => ( pp(aa(A,bool,P,X3))
       => pp(aa(A,bool,P,aa(nat,A,nth(A,replicate(A,N,X3)),I))) ) ) ).

% intind
tff(fact_6_in__set__member,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
    <=> member(A,Xs,X3) ) ).

% in_set_member
tff(fact_7__C2_OIH_C_I1_J,axiom,
    ! [X: vEBT_VEBT] :
      ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),treeLista)))
     => ( vEBT_invar_vebt(X,na)
        & ( vEBT_VEBT_elim_dead(X,extended_enat2(aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),na))) = X ) ) ) ).

% "2.IH"(1)
tff(fact_8_in__set__insert,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( insert(A,X3,Xs) = Xs ) ) ).

% in_set_insert
tff(fact_9_list__ex1__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( list_ex1(A,P,Xs)
    <=> ? [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X4))
          & ! [Y: A] :
              ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y),aa(list(A),set(A),set2(A),Xs)))
                & pp(aa(A,bool,P,Y)) )
             => ( Y = X4 ) ) ) ) ).

% list_ex1_iff
tff(fact_10_nth__mem,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,nth(A,Xs),N)),aa(list(A),set(A),set2(A),Xs))) ) ).

% nth_mem
tff(fact_11_list__ball__nth,axiom,
    ! [A: $tType,N: nat,Xs: list(A),P: fun(A,bool)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
           => pp(aa(A,bool,P,X2)) )
       => pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),N))) ) ) ).

% list_ball_nth
tff(fact_12_in__set__conv__nth,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
    <=> ? [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))
          & ( aa(nat,A,nth(A,Xs),I2) = X3 ) ) ) ).

% in_set_conv_nth
tff(fact_13_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),X3: A] :
      ( ! [I3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs)))
         => pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),I3))) )
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => pp(aa(A,bool,P,X3)) ) ) ).

% all_nth_imp_all_set
tff(fact_14_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X4)) )
    <=> ! [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))
         => pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),I2))) ) ) ).

% all_set_conv_all_nth
tff(fact_15__C2_Ohyps_C_I5_J,axiom,
    ~ ? [X_1: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,summarya),X_1)) ).

% "2.hyps"(5)
tff(fact_16__C2_Ohyps_C_I1_J,axiom,
    vEBT_invar_vebt(summarya,m) ).

% "2.hyps"(1)
tff(fact_17__C2_OIH_C_I2_J,axiom,
    vEBT_VEBT_elim_dead(summarya,extended_enat2(aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),m))) = summarya ).

% "2.IH"(2)
tff(fact_18_length__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] : ( aa(list(A),nat,size_size(list(A)),replicate(A,N,X3)) = N ) ).

% length_replicate
tff(fact_19_nth__replicate,axiom,
    ! [A: $tType,I: nat,N: nat,X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),N))
     => ( aa(nat,A,nth(A,replicate(A,N,X3)),I) = X3 ) ) ).

% nth_replicate
tff(fact_20_length__induct,axiom,
    ! [A: $tType,P: fun(list(A),bool),Xs: list(A)] :
      ( ! [Xs2: list(A)] :
          ( ! [Ys: list(A)] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),Ys)),aa(list(A),nat,size_size(list(A)),Xs2)))
             => pp(aa(list(A),bool,P,Ys)) )
         => pp(aa(list(A),bool,P,Xs2)) )
     => pp(aa(list(A),bool,P,Xs)) ) ).

% length_induct
tff(fact_21_replicate__eqI,axiom,
    ! [A: $tType,Xs: list(A),N: nat,X3: A] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = N )
     => ( ! [Y2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y2),aa(list(A),set(A),set2(A),Xs)))
           => ( Y2 = X3 ) )
       => ( Xs = replicate(A,N,X3) ) ) ) ).

% replicate_eqI
tff(fact_22_Ex__list__of__length,axiom,
    ! [A: $tType,N: nat] :
    ? [Xs2: list(A)] : ( aa(list(A),nat,size_size(list(A)),Xs2) = N ) ).

% Ex_list_of_length
tff(fact_23_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) != aa(list(A),nat,size_size(list(A)),Ys2) )
     => ( Xs != Ys2 ) ) ).

% neq_if_length_neq
tff(fact_24_replicate__length__same,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => ( X2 = X3 ) )
     => ( replicate(A,aa(list(A),nat,size_size(list(A)),Xs),X3) = Xs ) ) ).

% replicate_length_same
tff(fact_25_list__eq__iff__nth__eq,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( Xs = Ys2 )
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys2) )
        & ! [I2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))
           => ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,nth(A,Ys2),I2) ) ) ) ) ).

% list_eq_iff_nth_eq
tff(fact_26_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: fun(nat,fun(A,bool))] :
      ( ! [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),K))
         => ? [X_12: A] : pp(aa(A,bool,aa(nat,fun(A,bool),P,I2),X_12)) )
    <=> ? [Xs3: list(A)] :
          ( ( aa(list(A),nat,size_size(list(A)),Xs3) = K )
          & ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),K))
             => pp(aa(A,bool,aa(nat,fun(A,bool),P,I2),aa(nat,A,nth(A,Xs3),I2))) ) ) ) ).

% Skolem_list_nth
tff(fact_27_nth__equalityI,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys2) )
     => ( ! [I3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs)))
           => ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,nth(A,Ys2),I3) ) )
       => ( Xs = Ys2 ) ) ) ).

% nth_equalityI
tff(fact_28__C2_Ohyps_C_I4_J,axiom,
    dega = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),na),m) ).

% "2.hyps"(4)
tff(fact_29_less__exp,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ).

% less_exp
tff(fact_30_semiring__norm_I85_J,axiom,
    ! [M: num] : ( bit0(M) != one2 ) ).

% semiring_norm(85)
tff(fact_31_semiring__norm_I83_J,axiom,
    ! [N: num] : ( one2 != bit0(N) ) ).

% semiring_norm(83)
tff(fact_32_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: num,N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N)) ) ) ).

% numeral_less_iff
tff(fact_33_can__select__set__list__ex1,axiom,
    ! [A: $tType,P: fun(A,bool),A2: list(A)] :
      ( can_select(A,P,aa(list(A),set(A),set2(A),A2))
    <=> list_ex1(A,P,A2) ) ).

% can_select_set_list_ex1
tff(fact_34_enat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( extended_enat2(Nat) = extended_enat2(Nat2) )
    <=> ( Nat = Nat2 ) ) ).

% enat.inject
tff(fact_35_valid__eq,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_VEBT_valid(T2,D2)
    <=> vEBT_invar_vebt(T2,D2) ) ).

% valid_eq
tff(fact_36_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_invar_vebt(T2,D2)
     => vEBT_VEBT_valid(T2,D2) ) ).

% valid_eq1
tff(fact_37_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_VEBT_valid(T2,D2)
     => vEBT_invar_vebt(T2,D2) ) ).

% valid_eq2
tff(fact_38_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y22: num] :
      ( ( bit0(X22) = bit0(Y22) )
    <=> ( X22 = Y22 ) ) ).

% verit_eq_simplify(8)
tff(fact_39_semiring__norm_I87_J,axiom,
    ! [M: num,N: num] :
      ( ( bit0(M) = bit0(N) )
    <=> ( M = N ) ) ).

% semiring_norm(87)
tff(fact_40_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: num,N: num] :
          ( ( aa(num,A,numeral_numeral(A),M) = aa(num,A,numeral_numeral(A),N) )
        <=> ( M = N ) ) ) ).

% numeral_eq_iff
tff(fact_41_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ) ).

% numeral_plus_numeral
tff(fact_42_add__numeral__left,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [V: num,W: num,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),W)),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),W))),Z) ) ) ).

% add_numeral_left
tff(fact_43_enat__ord__number_I2_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),aa(num,extended_enat,numeral_numeral(extended_enat),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N))) ) ).

% enat_ord_number(2)
tff(fact_44_mem__Collect__eq,axiom,
    ! [A: $tType,A3: A,P: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),collect(A,P)))
    <=> pp(aa(A,bool,P,A3)) ) ).

% mem_Collect_eq
tff(fact_45_Collect__mem__eq,axiom,
    ! [A: $tType,A2: set(A)] : ( collect(A,aTP_Lamp_a(set(A),fun(A,bool),A2)) = A2 ) ).

% Collect_mem_eq
tff(fact_46_Collect__cong,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ! [X2: A] :
          ( pp(aa(A,bool,P,X2))
        <=> pp(aa(A,bool,Q,X2)) )
     => ( collect(A,P) = collect(A,Q) ) ) ).

% Collect_cong
tff(fact_47_ext,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),G: fun(A,B)] :
      ( ! [X2: A] : ( aa(A,B,F2,X2) = aa(A,B,G,X2) )
     => ( F2 = G ) ) ).

% ext
tff(fact_48_enat__ord__simps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),extended_enat2(M)),extended_enat2(N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% enat_ord_simps(2)
tff(fact_49_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),bit0(M)),bit0(N)))
    <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N)) ) ).

% semiring_norm(78)
tff(fact_50_semiring__norm_I75_J,axiom,
    ! [M: num] : ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),one2)) ).

% semiring_norm(75)
tff(fact_51_numeral__less__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),extended_enat2(N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(num,nat,numeral_numeral(nat),M)),N)) ) ).

% numeral_less_enat_iff
tff(fact_52_semiring__norm_I76_J,axiom,
    ! [N: num] : pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),one2),bit0(N))) ).

% semiring_norm(76)
tff(fact_53_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% is_num_normalize(1)
tff(fact_54_enat__iless,axiom,
    ! [N: extended_enat,M: nat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),N),extended_enat2(M)))
     => ? [K2: nat] : ( N = extended_enat2(K2) ) ) ).

% enat_iless
tff(fact_55_chain__incr,axiom,
    ! [A: $tType,Y3: fun(A,extended_enat),K: nat] :
      ( ! [I3: A] :
        ? [J: A] : pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),aa(A,extended_enat,Y3,I3)),aa(A,extended_enat,Y3,J)))
     => ? [J2: A] : pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),extended_enat2(K)),aa(A,extended_enat,Y3,J2))) ) ).

% chain_incr
tff(fact_56_can__select__def,axiom,
    ! [A: $tType,P: fun(A,bool),A2: set(A)] :
      ( can_select(A,P,A2)
    <=> ? [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
          & pp(aa(A,bool,P,X4))
          & ! [Y: A] :
              ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y),A2))
                & pp(aa(A,bool,P,Y)) )
             => ( Y = X4 ) ) ) ) ).

% can_select_def
tff(fact_57_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bit0(N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N)) ) ) ).

% numeral_Bit0
tff(fact_58_numeral__eq__enat,axiom,
    ! [K: num] : ( aa(num,extended_enat,numeral_numeral(extended_enat),K) = extended_enat2(aa(num,nat,numeral_numeral(nat),K)) ) ).

% numeral_eq_enat
tff(fact_59_less__enatE,axiom,
    ! [N: extended_enat,M: nat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),N),extended_enat2(M)))
     => ~ ! [K2: nat] :
            ( ( N = extended_enat2(K2) )
           => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K2),M)) ) ) ).

% less_enatE
tff(fact_60_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),A3)) ) ).

% verit_comp_simplify1(1)
tff(fact_61_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] : ( one2 != bit0(X22) ) ).

% verit_eq_simplify(10)
tff(fact_62_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Ma,N)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M))) ) ).

% high_bound_aux
tff(fact_63_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% nat_add_left_cancel_less
tff(fact_64_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% add_less_cancel_right
tff(fact_65_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% add_less_cancel_left
tff(fact_66_pow__sum,axiom,
    ! [A3: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2))),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),A3)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),B2) ) ).

% pow_sum
tff(fact_67_power__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,L: num] : ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),K)),aa(num,nat,numeral_numeral(nat),L)) = aa(num,A,numeral_numeral(A),pow(K,L)) ) ) ).

% power_numeral
tff(fact_68_the__enat_Osimps,axiom,
    ! [N: nat] : ( extended_the_enat(extended_enat2(N)) = N ) ).

% the_enat.simps
tff(fact_69_add__right__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3) )
        <=> ( B2 = C2 ) ) ) ).

% add_right_cancel
tff(fact_70_add__left__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add_left_cancel
tff(fact_71_length__subseqs,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(list(A)),nat,size_size(list(list(A))),subseqs(A,Xs)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_subseqs
tff(fact_72_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( vEBT_invar_vebt(T2,N)
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ).

% deg_not_0
tff(fact_73_enat_Osimps_I4_J,axiom,
    ! [T: $tType,F1: fun(nat,T),F22: T,Nat: nat] : ( extended_case_enat(T,F1,F22,extended_enat2(Nat)) = aa(nat,T,F1,Nat) ) ).

% enat.simps(4)
tff(fact_74_high__def,axiom,
    ! [X3: nat,N: nat] : ( vEBT_VEBT_high(X3,N) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% high_def
tff(fact_75_not__gr__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N))
        <=> ( N = zero_zero(A) ) ) ) ).

% not_gr_zero
tff(fact_76_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),zero_zero(A)) = A3 ) ) ).

% add.right_neutral
tff(fact_77_double__zero__sym,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% double_zero_sym
tff(fact_78_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [B2: A,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) = A3 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_left
tff(fact_79_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = A3 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_right
tff(fact_80_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_left
tff(fact_81_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_right
tff(fact_82_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4) = zero_zero(A) )
        <=> ( ( X3 = zero_zero(A) )
            & ( Y4 = zero_zero(A) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
tff(fact_83_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X3: A,Y4: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4) )
        <=> ( ( X3 = zero_zero(A) )
            & ( Y4 = zero_zero(A) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
tff(fact_84_add__0,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A3) = A3 ) ) ).

% add_0
tff(fact_85_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A3: nat] :
      ( ( A3 != zero_zero(nat) )
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),A3)) ) ).

% bot_nat_0.not_eq_extremum
tff(fact_86_neq0__conv,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ).

% neq0_conv
tff(fact_87_less__nat__zero__code,axiom,
    ! [N: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),zero_zero(nat))) ).

% less_nat_zero_code
tff(fact_88_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) = zero_zero(nat) )
    <=> ( ( M = zero_zero(nat) )
        & ( N = zero_zero(nat) ) ) ) ).

% add_is_0
tff(fact_89_Nat_Oadd__0__right,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),zero_zero(nat)) = M ) ).

% Nat.add_0_right
tff(fact_90_plus__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),extended_enat2(M)),extended_enat2(N)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ).

% plus_enat_simps(1)
tff(fact_91_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X3: A,N: nat,Y4: A] :
      ( ( replicate(A,M,X3) = replicate(A,N,Y4) )
    <=> ( ( M = N )
        & ( ( M != zero_zero(nat) )
         => ( X3 = Y4 ) ) ) ) ).

% replicate_eq_replicate
tff(fact_92_semiring__norm_I6_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit0(M)),bit0(N)) = bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ).

% semiring_norm(6)
tff(fact_93_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
tff(fact_94_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
tff(fact_95_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ).

% less_add_same_cancel2
tff(fact_96_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ).

% less_add_same_cancel1
tff(fact_97_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% add_less_same_cancel2
tff(fact_98_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% add_less_same_cancel1
tff(fact_99_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(nat,A,power_power(A,zero_zero(A)),aa(num,nat,numeral_numeral(nat),K)) = zero_zero(A) ) ) ).

% power_zero_numeral
tff(fact_100_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
        | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% add_gr_0
tff(fact_101_nat__zero__less__power__iff,axiom,
    ! [X3: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,power_power(nat,X3),N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),X3))
        | ( N = zero_zero(nat) ) ) ) ).

% nat_zero_less_power_iff
tff(fact_102_semiring__norm_I2_J,axiom,
    aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),one2) = bit0(one2) ).

% semiring_norm(2)
tff(fact_103_in__set__replicate,axiom,
    ! [A: $tType,X3: A,N: nat,Y4: A] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),replicate(A,N,Y4))))
    <=> ( ( X3 = Y4 )
        & ( N != zero_zero(nat) ) ) ) ).

% in_set_replicate
tff(fact_104_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A3: A,P: fun(A,bool)] :
      ( ? [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),replicate(A,N,A3))))
          & pp(aa(A,bool,P,X4)) )
    <=> ( pp(aa(A,bool,P,A3))
        & ( N != zero_zero(nat) ) ) ) ).

% Bex_set_replicate
tff(fact_105_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A3: A,P: fun(A,bool)] :
      ( ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),replicate(A,N,A3))))
         => pp(aa(A,bool,P,X4)) )
    <=> ( pp(aa(A,bool,P,A3))
        | ( N = zero_zero(nat) ) ) ) ).

% Ball_set_replicate
tff(fact_106_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A3: A,N: nat] :
          ( ( aa(nat,A,power_power(A,A3),N) = zero_zero(A) )
        <=> ( ( A3 = zero_zero(A) )
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ) ).

% power_eq_0_iff
tff(fact_107_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A3: A] :
          ( ( aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% zero_eq_power2
tff(fact_108_zero__less__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
        <=> ( A3 != zero_zero(A) ) ) ) ).

% zero_less_power2
tff(fact_109_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = zero_zero(A) )
        <=> ( ( X3 = zero_zero(A) )
            & ( Y4 = zero_zero(A) ) ) ) ) ).

% sum_power2_eq_zero_iff
tff(fact_110_enat__less__induct,axiom,
    ! [P: fun(extended_enat,bool),N: extended_enat] :
      ( ! [N2: extended_enat] :
          ( ! [M2: extended_enat] :
              ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),M2),N2))
             => pp(aa(extended_enat,bool,P,M2)) )
         => pp(aa(extended_enat,bool,P,N2)) )
     => pp(aa(extended_enat,bool,P,N)) ) ).

% enat_less_induct
tff(fact_111_zero__reorient,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [X3: A] :
          ( ( zero_zero(A) = X3 )
        <=> ( X3 = zero_zero(A) ) ) ) ).

% zero_reorient
tff(fact_112_subseqs__refl,axiom,
    ! [A: $tType,Xs: list(A)] : pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Xs),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs)))) ).

% subseqs_refl
tff(fact_113_gr__zeroI,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( ( N != zero_zero(A) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N)) ) ) ).

% gr_zeroI
tff(fact_114_not__less__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),N),zero_zero(A))) ) ).

% not_less_zero
tff(fact_115_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [M: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M),N))
         => ( N != zero_zero(A) ) ) ) ).

% gr_implies_not_zero
tff(fact_116_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N))
        <=> ( N != zero_zero(A) ) ) ) ).

% zero_less_iff_neq_zero
tff(fact_117_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A3) = A3 ) ) ).

% comm_monoid_add_class.add_0
tff(fact_118_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),zero_zero(A)) = A3 ) ) ).

% add.comm_neutral
tff(fact_119_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A3) = A3 ) ) ).

% add.group_left_neutral
tff(fact_120_bot__nat__0_Oextremum__strict,axiom,
    ! [A3: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A3),zero_zero(nat))) ).

% bot_nat_0.extremum_strict
tff(fact_121_gr0I,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ).

% gr0I
tff(fact_122_not__gr0,axiom,
    ! [N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
    <=> ( N = zero_zero(nat) ) ) ).

% not_gr0
tff(fact_123_not__less0,axiom,
    ! [N: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),zero_zero(nat))) ).

% not_less0
tff(fact_124_less__zeroE,axiom,
    ! [N: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),zero_zero(nat))) ).

% less_zeroE
tff(fact_125_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ( N != zero_zero(nat) ) ) ).

% gr_implies_not0
tff(fact_126_infinite__descent0,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( pp(aa(nat,bool,P,zero_zero(nat)))
     => ( ! [N2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
           => ( ~ pp(aa(nat,bool,P,N2))
             => ? [M2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N2))
                  & ~ pp(aa(nat,bool,P,M2)) ) ) )
       => pp(aa(nat,bool,P,N)) ) ) ).

% infinite_descent0
tff(fact_127_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: fun(A,nat),P: fun(A,bool),X3: A] :
      ( ! [X2: A] :
          ( ( aa(A,nat,V2,X2) = zero_zero(nat) )
         => pp(aa(A,bool,P,X2)) )
     => ( ! [X2: A] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(A,nat,V2,X2)))
           => ( ~ pp(aa(A,bool,P,X2))
             => ? [Y5: A] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,V2,Y5)),aa(A,nat,V2,X2)))
                  & ~ pp(aa(A,bool,P,Y5)) ) ) )
       => pp(aa(A,bool,P,X3)) ) ) ).

% infinite_descent0_measure
tff(fact_128_plus__nat_Oadd__0,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),zero_zero(nat)),N) = N ) ).

% plus_nat.add_0
tff(fact_129_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) = M )
     => ( N = zero_zero(nat) ) ) ).

% add_eq_self_zero
tff(fact_130_zero__power,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(nat,A,power_power(A,zero_zero(A)),N) = zero_zero(A) ) ) ) ).

% zero_power
tff(fact_131_power__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A,N: nat] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),N) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N)) ) ) ).

% power_divide
tff(fact_132_add__One__commute,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N) = aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2) ) ).

% add_One_commute
tff(fact_133_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),zero_zero(A))) ) ).

% less_numeral_extra(3)
tff(fact_134_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] : ( zero_zero(A) != aa(num,A,numeral_numeral(A),N) ) ) ).

% zero_neq_numeral
tff(fact_135_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),zero_zero(A)) = A3 ) ) ).

% verit_sum_simplify
tff(fact_136_power__not__zero,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A3: A,N: nat] :
          ( ( A3 != zero_zero(A) )
         => ( aa(nat,A,power_power(A,A3),N) != zero_zero(A) ) ) ) ).

% power_not_zero
tff(fact_137_pos__add__strict,axiom,
    ! [A: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% pos_add_strict
tff(fact_138_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ ! [C3: A] :
                ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C3) )
               => ( C3 = zero_zero(A) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
tff(fact_139_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% add_pos_pos
tff(fact_140_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),zero_zero(A))) ) ) ) ).

% add_neg_neg
tff(fact_141_less__imp__add__positive,axiom,
    ! [I: nat,J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ? [K2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K2))
          & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K2) = J3 ) ) ) ).

% less_imp_add_positive
tff(fact_142_half__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% half_gt_zero
tff(fact_143_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% half_gt_zero_iff
tff(fact_144_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),one2)) = A3 ) ) ).

% divide_numeral_1
tff(fact_145_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),N))) ) ).

% zero_less_numeral
tff(fact_146_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),N)),zero_zero(A))) ) ).

% not_numeral_less_zero
tff(fact_147_zero__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,A3),N))) ) ) ).

% zero_less_power
tff(fact_148_nat__power__less__imp__less,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),I))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,power_power(nat,I),M)),aa(nat,nat,power_power(nat,I),N)))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ).

% nat_power_less_imp_less
tff(fact_149_pow_Osimps_I1_J,axiom,
    ! [X3: num] : ( pow(X3,one2) = X3 ) ).

% pow.simps(1)
tff(fact_150_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X3: nat,N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(X3,N)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M))) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
tff(fact_151_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( wellorder(B)
     => ! [F2: fun(A,B),P: fun(A,bool),A3: A] :
          ( ! [X2: A] :
              ( ! [Y5: A] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,Y5)),aa(A,B,F2,X2)))
                 => pp(aa(A,bool,P,Y5)) )
             => pp(aa(A,bool,P,X2)) )
         => pp(aa(A,bool,P,A3)) ) ) ).

% measure_induct
tff(fact_152_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( wellorder(B)
     => ! [F2: fun(A,B),P: fun(A,bool),A3: A] :
          ( ! [X2: A] :
              ( ! [Y5: A] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,Y5)),aa(A,B,F2,X2)))
                 => pp(aa(A,bool,P,Y5)) )
             => pp(aa(A,bool,P,X2)) )
         => pp(aa(A,bool,P,A3)) ) ) ).

% measure_induct_rule
tff(fact_153_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% ab_semigroup_add_class.add_ac(1)
tff(fact_154_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( I = J3 )
            & ( K = L ) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
tff(fact_155_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: A,K: A,A3: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A3) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) ) ) ) ).

% group_cancel.add1
tff(fact_156_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) ) ) ) ).

% group_cancel.add2
tff(fact_157_add_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.assoc
tff(fact_158_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add.left_cancel
tff(fact_159_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3) )
        <=> ( B2 = C2 ) ) ) ).

% add.right_cancel
tff(fact_160_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) ) ) ).

% add.commute
tff(fact_161_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.left_commute
tff(fact_162_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
tff(fact_163_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
tff(fact_164_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( M != N )
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
        | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M)) ) ) ).

% nat_neq_iff
tff(fact_165_less__not__refl,axiom,
    ! [N: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N)) ).

% less_not_refl
tff(fact_166_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
     => ( M != N ) ) ).

% less_not_refl2
tff(fact_167_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),S),T2))
     => ( S != T2 ) ) ).

% less_not_refl3
tff(fact_168_less__irrefl__nat,axiom,
    ! [N: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N)) ).

% less_irrefl_nat
tff(fact_169_nat__less__induct,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N2))
             => pp(aa(nat,bool,P,M2)) )
         => pp(aa(nat,bool,P,N2)) )
     => pp(aa(nat,bool,P,N)) ) ).

% nat_less_induct
tff(fact_170_infinite__descent,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( ! [N2: nat] :
          ( ~ pp(aa(nat,bool,P,N2))
         => ? [M2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N2))
              & ~ pp(aa(nat,bool,P,M2)) ) )
     => pp(aa(nat,bool,P,N)) ) ).

% infinite_descent
tff(fact_171_linorder__neqE__nat,axiom,
    ! [X3: nat,Y4: nat] :
      ( ( X3 != Y4 )
     => ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),Y4))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Y4),X3)) ) ) ).

% linorder_neqE_nat
tff(fact_172_infinite__descent__measure,axiom,
    ! [A: $tType,P: fun(A,bool),V2: fun(A,nat),X3: A] :
      ( ! [X2: A] :
          ( ~ pp(aa(A,bool,P,X2))
         => ? [Y5: A] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,V2,Y5)),aa(A,nat,V2,X2)))
              & ~ pp(aa(A,bool,P,Y5)) ) )
     => pp(aa(A,bool,P,X3)) ) ).

% infinite_descent_measure
tff(fact_173_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( size(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,nat,size_size(A),X3) != aa(A,nat,size_size(A),Y4) )
         => ( X3 != Y4 ) ) ) ).

% size_neq_size_imp_neq
tff(fact_174_length__pos__if__in__set,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(list(A),nat,size_size(list(A)),Xs))) ) ).

% length_pos_if_in_set
tff(fact_175_zero__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,power_power(A,zero_zero(A)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = zero_zero(A) ) ) ).

% zero_power2
tff(fact_176_power2__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),zero_zero(A))) ) ).

% power2_less_0
tff(fact_177_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),zero_zero(A))) ) ).

% not_sum_power2_lt_zero
tff(fact_178_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))))
        <=> ( ( X3 != zero_zero(A) )
            | ( Y4 != zero_zero(A) ) ) ) ) ).

% sum_power2_gt_zero_iff
tff(fact_179_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),J3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L))) ) ) ).

% add_mono_thms_linordered_field(5)
tff(fact_180_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( I = J3 )
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L))) ) ) ).

% add_mono_thms_linordered_field(2)
tff(fact_181_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),J3))
            & ( K = L ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L))) ) ) ).

% add_mono_thms_linordered_field(1)
tff(fact_182_add__strict__mono,axiom,
    ! [A: $tType] :
      ( strict9044650504122735259up_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2))) ) ) ) ).

% add_strict_mono
tff(fact_183_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))) ) ) ).

% add_strict_left_mono
tff(fact_184_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))) ) ) ).

% add_strict_right_mono
tff(fact_185_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% add_less_imp_less_left
tff(fact_186_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% add_less_imp_less_right
tff(fact_187_add__lessD1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J3)),K))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),K)) ) ).

% add_lessD1
tff(fact_188_add__less__mono,axiom,
    ! [I: nat,J3: nat,K: nat,L: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),L))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),L))) ) ) ).

% add_less_mono
tff(fact_189_not__add__less1,axiom,
    ! [I: nat,J3: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J3)),I)) ).

% not_add_less1
tff(fact_190_not__add__less2,axiom,
    ! [J3: nat,I: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),I)),I)) ).

% not_add_less2
tff(fact_191_add__less__mono1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),K))) ) ).

% add_less_mono1
tff(fact_192_trans__less__add1,axiom,
    ! [I: nat,J3: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),M))) ) ).

% trans_less_add1
tff(fact_193_trans__less__add2,axiom,
    ! [I: nat,J3: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),J3))) ) ).

% trans_less_add2
tff(fact_194_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),L))
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),L) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N) )
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ).

% less_add_eq_less
tff(fact_195_add__self__div__2,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),M)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = M ) ).

% add_self_div_2
tff(fact_196_buildup__gives__valid,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => vEBT_invar_vebt(vEBT_vebt_buildup(N),N) ) ).

% buildup_gives_valid
tff(fact_197_div__less,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) = zero_zero(nat) ) ) ).

% div_less
tff(fact_198_div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,M: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) ) ) ).

% div_exp_eq
tff(fact_199_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) != zero_zero(A) )
         => ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M) != zero_zero(A) ) ) ) ).

% exp_add_not_zero_imp_left
tff(fact_200_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) != zero_zero(A) )
         => ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) != zero_zero(A) ) ) ) ).

% exp_add_not_zero_imp_right
tff(fact_201_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% field_less_half_sum
tff(fact_202_high__inv,axiom,
    ! [X3: nat,N: nat,Y4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))
     => ( vEBT_VEBT_high(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Y4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N))),X3),N) = Y4 ) ) ).

% high_inv
tff(fact_203_pos2,axiom,
    pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ).

% pos2
tff(fact_204_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),aa(num,A,numeral_numeral(A),bit0(one2)))) = X3 ) ) ).

% field_sum_of_halves
tff(fact_205_div__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),zero_zero(A)),A3) = zero_zero(A) ) ) ).

% div_0
tff(fact_206_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = zero_zero(A) )
        <=> ( ( A3 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divide_eq_0_iff
tff(fact_207_i0__less,axiom,
    ! [N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),zero_zero(extended_enat)),N))
    <=> ( N != zero_zero(extended_enat) ) ) ).

% i0_less
tff(fact_208_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_right
tff(fact_209_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_left
tff(fact_210_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = zero_zero(A) )
        <=> ( ( A3 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% mult_eq_0_iff
tff(fact_211_mult__zero__right,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),zero_zero(A)) = zero_zero(A) ) ) ).

% mult_zero_right
tff(fact_212_mult__zero__left,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),zero_zero(A)),A3) = zero_zero(A) ) ) ).

% mult_zero_left
tff(fact_213_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),N)) ) ) ).

% numeral_times_numeral
tff(fact_214_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [V: num,W: num,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W))),Z) ) ) ).

% mult_numeral_left_semiring_numeral
tff(fact_215_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),zero_zero(A)) = zero_zero(A) ) ) ).

% division_ring_divide_zero
tff(fact_216_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),zero_zero(A)) = zero_zero(A) ) ) ).

% bits_div_by_0
tff(fact_217_bits__div__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),zero_zero(A)),A3) = zero_zero(A) ) ) ).

% bits_div_0
tff(fact_218_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = B2 ) ) ) ) ).

% divide_cancel_right
tff(fact_219_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = B2 ) ) ) ) ).

% divide_cancel_left
tff(fact_220_div__by__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),zero_zero(A)) = zero_zero(A) ) ) ).

% div_by_0
tff(fact_221_half__negative__int__iff,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int))) ) ).

% half_negative_int_iff
tff(fact_222_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) ) ) ).

% times_divide_eq_right
tff(fact_223_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2) ) ) ).

% divide_divide_eq_right
tff(fact_224_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% divide_divide_eq_left
tff(fact_225_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,C2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),C2) ) ) ).

% times_divide_eq_left
tff(fact_226_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K) )
    <=> ( ( M = N )
        | ( K = zero_zero(nat) ) ) ) ).

% mult_cancel2
tff(fact_227_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N) )
    <=> ( ( M = N )
        | ( K = zero_zero(nat) ) ) ) ).

% mult_cancel1
tff(fact_228_mult__0__right,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),zero_zero(nat)) = zero_zero(nat) ) ).

% mult_0_right
tff(fact_229_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) = zero_zero(nat) )
    <=> ( ( M = zero_zero(nat) )
        | ( N = zero_zero(nat) ) ) ) ).

% mult_is_0
tff(fact_230_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Y4)) = zero_zero(A) )
        <=> ( ( X3 = zero_zero(A) )
            & ( Y4 = zero_zero(A) ) ) ) ) ).

% sum_squares_eq_zero_iff
tff(fact_231_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = zero_zero(A) ) )
          & ( ( C2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ) ).

% div_mult_mult1_if
tff(fact_232_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ).

% div_mult_mult2
tff(fact_233_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ).

% div_mult_mult1
tff(fact_234_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
tff(fact_235_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),B2) = A3 ) ) ) ).

% nonzero_mult_div_cancel_right
tff(fact_236_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
tff(fact_237_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
tff(fact_238_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),A3) = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
tff(fact_239_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
tff(fact_240_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = zero_zero(A) ) )
          & ( ( C2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
tff(fact_241_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% distrib_left_numeral
tff(fact_242_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [A3: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% distrib_right_numeral
tff(fact_243_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ).

% nat_mult_less_cancel_disj
tff(fact_244_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% nat_0_less_mult_iff
tff(fact_245_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ).

% mult_less_cancel2
tff(fact_246_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K = zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) = zero_zero(nat) ) )
      & ( ( K != zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) ) ) ) ).

% nat_mult_div_cancel_disj
tff(fact_247_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,W: num] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)) )
        <=> ( ( ( aa(num,A,numeral_numeral(A),W) != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W)) = B2 ) )
            & ( ( aa(num,A,numeral_numeral(A),W) = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
tff(fact_248_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W: num,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)) = A3 )
        <=> ( ( ( aa(num,A,numeral_numeral(A),W) != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W)) ) )
            & ( ( aa(num,A,numeral_numeral(A),W) = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
tff(fact_249_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W))),B2)) ) ) ).

% less_divide_eq_numeral1(1)
tff(fact_250_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W))),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W)))) ) ) ).

% divide_less_eq_numeral1(1)
tff(fact_251_div__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) ) ) ) ).

% div_mult_self1
tff(fact_252_div__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) ) ) ) ).

% div_mult_self2
tff(fact_253_div__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A3)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) ) ) ) ).

% div_mult_self3
tff(fact_254_div__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A3)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) ) ) ) ).

% div_mult_self4
tff(fact_255_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),M)),N) = M ) ) ).

% div_mult_self1_is_m
tff(fact_256_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),N) = M ) ) ).

% div_mult_self_is_m
tff(fact_257_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,M: num,N: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),M))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),N))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)))),B2) ) ) ).

% power_add_numeral2
tff(fact_258_power__add__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),M))),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),N))) = aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N))) ) ) ).

% power_add_numeral
tff(fact_259_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),N) = zero_zero(extended_enat) )
    <=> ( ( M = zero_zero(extended_enat) )
        & ( N = zero_zero(extended_enat) ) ) ) ).

% iadd_is_0
tff(fact_260_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
tff(fact_261_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_mult(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.assoc
tff(fact_262_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3) ) ) ).

% mult.commute
tff(fact_263_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.left_commute
tff(fact_264_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
          <=> ( A3 = B2 ) ) ) ) ).

% mult_right_cancel
tff(fact_265_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
          <=> ( A3 = B2 ) ) ) ) ).

% mult_left_cancel
tff(fact_266_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) != zero_zero(A) ) ) ) ) ).

% no_zero_divisors
tff(fact_267_divisors__zero,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = zero_zero(A) )
         => ( ( A3 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divisors_zero
tff(fact_268_mult__not__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) != zero_zero(A) )
         => ( ( A3 != zero_zero(A) )
            & ( B2 != zero_zero(A) ) ) ) ) ).

% mult_not_zero
tff(fact_269_combine__common__factor,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A3: A,E: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),E)),C2) ) ) ).

% combine_common_factor
tff(fact_270_distrib__right,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% distrib_right
tff(fact_271_distrib__left,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% distrib_left
tff(fact_272_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( comm_semiring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% comm_semiring_class.distrib
tff(fact_273_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% ring_class.ring_distribs(1)
tff(fact_274_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ring_class.ring_distribs(2)
tff(fact_275_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% divide_divide_eq_left'
tff(fact_276_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A,Y4: A,Z: A,W: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Z),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),W)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z)) ) ) ).

% divide_divide_times_eq
tff(fact_277_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A,Y4: A,Z: A,W: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Z),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),W)) ) ) ).

% times_divide_times_eq
tff(fact_278_div__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),Q2) ) ).

% div_mult2_eq
tff(fact_279_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X3: A,Y4: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4) = aa(A,A,aa(A,fun(A,A),times_times(A),Y4),X3) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),N)),Y4) = aa(A,A,aa(A,fun(A,A),times_times(A),Y4),aa(nat,A,power_power(A,X3),N)) ) ) ) ).

% power_commuting_commutes
tff(fact_280_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,N: nat] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N)) ) ) ).

% power_mult_distrib
tff(fact_281_power__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),N)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,A3),N)) ) ) ).

% power_commutes
tff(fact_282_power__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,M: nat,N: nat] : ( aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) = aa(nat,A,power_power(A,aa(nat,A,power_power(A,A3),M)),N) ) ) ).

% power_mult
tff(fact_283_mult__0,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),zero_zero(nat)),N) = zero_zero(nat) ) ).

% mult_0
tff(fact_284_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N) )
    <=> ( ( K = zero_zero(nat) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
tff(fact_285_left__add__mult__distrib,axiom,
    ! [I: nat,U: nat,J3: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J3)),U)),K) ) ).

% left_add_mult_distrib
tff(fact_286_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) ) ).

% add_mult_distrib2
tff(fact_287_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K)) ) ).

% add_mult_distrib
tff(fact_288_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord2810124833399127020strict(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
tff(fact_289_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% mult_less_cancel_right_disj
tff(fact_290_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ) ).

% mult_strict_right_mono
tff(fact_291_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ) ).

% mult_strict_right_mono_neg
tff(fact_292_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% mult_less_cancel_left_disj
tff(fact_293_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% mult_strict_left_mono
tff(fact_294_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% mult_strict_left_mono_neg
tff(fact_295_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% mult_less_cancel_left_pos
tff(fact_296_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ).

% mult_less_cancel_left_neg
tff(fact_297_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ) ).

% zero_less_mult_pos2
tff(fact_298_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ) ).

% zero_less_mult_pos
tff(fact_299_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A))) ) ) ) ) ).

% zero_less_mult_iff
tff(fact_300_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),zero_zero(A))) ) ) ) ).

% mult_pos_neg2
tff(fact_301_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ) ).

% mult_pos_pos
tff(fact_302_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ) ).

% mult_pos_neg
tff(fact_303_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ) ).

% mult_neg_pos
tff(fact_304_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ) ) ).

% mult_less_0_iff
tff(fact_305_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3)),zero_zero(A))) ) ).

% not_square_less_zero
tff(fact_306_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ) ).

% mult_neg_neg
tff(fact_307_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( A3 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
tff(fact_308_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A3 )
          <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) ) ) ) ) ).

% nonzero_divide_eq_eq
tff(fact_309_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = B2 )
           => ( A3 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) ) ) ) ) ).

% eq_divide_imp
tff(fact_310_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A3 ) ) ) ) ).

% divide_eq_imp
tff(fact_311_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = B2 ) )
            & ( ( C2 = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq
tff(fact_312_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A3 )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq
tff(fact_313_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y4: A,Z: A,X3: A,W: A] :
          ( ( Y4 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z) )
            <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z) = aa(A,A,aa(A,fun(A,A),times_times(A),W),Y4) ) ) ) ) ) ).

% frac_eq_eq
tff(fact_314_less__mult__imp__div__less,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),N)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),I)) ) ).

% less_mult_imp_div_less
tff(fact_315_realpow__pos__nth__unique,axiom,
    ! [N: nat,A3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
       => ? [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X2))
            & ( aa(nat,real,power_power(real,X2),N) = A3 )
            & ! [Y5: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y5))
                  & ( aa(nat,real,power_power(real,Y5),N) = A3 ) )
               => ( Y5 = X2 ) ) ) ) ) ).

% realpow_pos_nth_unique
tff(fact_316_realpow__pos__nth,axiom,
    ! [N: nat,A3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
       => ? [R: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
            & ( aa(nat,real,power_power(real,R),N) = A3 ) ) ) ) ).

% realpow_pos_nth
tff(fact_317_not__iless0,axiom,
    ! [N: extended_enat] : ~ pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),N),zero_zero(extended_enat))) ).

% not_iless0
tff(fact_318_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X3: A,Y4: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Y4))),zero_zero(A))) ) ).

% not_sum_squares_lt_zero
tff(fact_319_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2))) ) ) ) ) ).

% divide_strict_left_mono_neg
tff(fact_320_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2))) ) ) ) ) ).

% divide_strict_left_mono
tff(fact_321_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y4: A,Z: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y4)),X3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4))) ) ) ) ).

% mult_imp_less_div_pos
tff(fact_322_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y4: A,X3: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y4)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),Z)) ) ) ) ).

% mult_imp_div_pos_less
tff(fact_323_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ).

% pos_less_divide_eq
tff(fact_324_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% pos_divide_less_eq
tff(fact_325_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% neg_less_divide_eq
tff(fact_326_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ).

% neg_divide_less_eq
tff(fact_327_less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq
tff(fact_328_divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A3))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ) ) ) ) ).

% divide_less_eq
tff(fact_329_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,A3: A,B2: A] :
          ( ( ( Z = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),Z)),B2) = B2 ) )
          & ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),Z)),B2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z) ) ) ) ) ).

% add_divide_eq_if_simps(2)
tff(fact_330_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,A3: A,B2: A] :
          ( ( ( Z = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Z)) = A3 ) )
          & ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),Z)),B2)),Z) ) ) ) ) ).

% add_divide_eq_if_simps(1)
tff(fact_331_add__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y4: A,Z: A,X3: A,W: A] :
          ( ( Y4 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z)) ) ) ) ) ).

% add_frac_eq
tff(fact_332_add__frac__num,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y4: A,X3: A,Z: A] :
          ( ( Y4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y4))),Y4) ) ) ) ).

% add_frac_num
tff(fact_333_add__num__frac,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y4: A,Z: A,X3: A] :
          ( ( Y4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y4))),Y4) ) ) ) ).

% add_num_frac
tff(fact_334_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),Y4)),Z) ) ) ) ).

% add_divide_eq_iff
tff(fact_335_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Z)),Y4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z))),Z) ) ) ) ).

% divide_add_eq_iff
tff(fact_336_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),one2)) = A3 ) ) ).

% mult_numeral_1_right
tff(fact_337_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),one2)),A3) = A3 ) ) ).

% mult_numeral_1
tff(fact_338_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),Q2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Q2)),N))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2))) ) ) ).

% div_less_iff_less_mult
tff(fact_339_power__add,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,M: nat,N: nat] : ( aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),M)),aa(nat,A,power_power(A,A3),N)) ) ) ).

% power_add
tff(fact_340_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N) )
      <=> ( M = N ) ) ) ).

% nat_mult_eq_cancel1
tff(fact_341_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ).

% nat_mult_less_cancel1
tff(fact_342_mult__less__mono2,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),I)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),J3))) ) ) ).

% mult_less_mono2
tff(fact_343_mult__less__mono1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),K))) ) ) ).

% mult_less_mono1
tff(fact_344_enat__0__iff_I2_J,axiom,
    ! [X3: nat] :
      ( ( zero_zero(extended_enat) = extended_enat2(X3) )
    <=> ( X3 = zero_zero(nat) ) ) ).

% enat_0_iff(2)
tff(fact_345_enat__0__iff_I1_J,axiom,
    ! [X3: nat] :
      ( ( extended_enat2(X3) = zero_zero(extended_enat) )
    <=> ( X3 = zero_zero(nat) ) ) ).

% enat_0_iff(1)
tff(fact_346_zero__enat__def,axiom,
    zero_zero(extended_enat) = extended_enat2(zero_zero(nat)) ).

% zero_enat_def
tff(fact_347_split__div,axiom,
    ! [P: fun(nat,bool),M: nat,N: nat] :
      ( pp(aa(nat,bool,P,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)))
    <=> ( ( ( N = zero_zero(nat) )
         => pp(aa(nat,bool,P,zero_zero(nat))) )
        & ( ( N != zero_zero(nat) )
         => ! [I2: nat,J4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),N))
             => ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),I2)),J4) )
               => pp(aa(nat,bool,P,I2)) ) ) ) ) ) ).

% split_div
tff(fact_348_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),N)))) ) ).

% dividend_less_div_times
tff(fact_349_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N))))) ) ).

% dividend_less_times_div
tff(fact_350_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Y4))))
        <=> ( ( X3 != zero_zero(A) )
            | ( Y4 != zero_zero(A) ) ) ) ) ).

% sum_squares_gt_zero_iff
tff(fact_351_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num,B2: A,C2: A] :
          ( ( aa(num,A,numeral_numeral(A),W) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2) = B2 ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(num,A,numeral_numeral(A),W) = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
tff(fact_352_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W: num] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = aa(num,A,numeral_numeral(A),W) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(num,A,numeral_numeral(A),W) = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
tff(fact_353_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( ( X3 != Y4 )
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ) ).

% linorder_neqE_linordered_idom
tff(fact_354_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
        ? [X_13: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),X_13)) ) ).

% linordered_field_no_ub
tff(fact_355_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
        ? [Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y2),X)) ) ).

% linordered_field_no_lb
tff(fact_356_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) ) ) ).

% nat_mult_div_cancel1
tff(fact_357_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),W)),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
tff(fact_358_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(num,A,numeral_numeral(A),W)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W))) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
tff(fact_359_left__add__twice,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)),B2) ) ) ).

% left_add_twice
tff(fact_360_mult__2__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Z) ) ) ).

% mult_2_right
tff(fact_361_mult__2,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Z) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Z) ) ) ).

% mult_2
tff(fact_362_power2__eq__square,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3) ) ) ).

% power2_eq_square
tff(fact_363_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X3: A] : ( aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3)),X3)),X3) ) ) ).

% power4_eq_xxxx
tff(fact_364_power__even__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = aa(nat,A,power_power(A,aa(nat,A,power_power(A,A3),N)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% power_even_eq
tff(fact_365_num_Osize_I4_J,axiom,
    aa(num,nat,size_size(num),one2) = zero_zero(nat) ).

% num.size(4)
tff(fact_366_power2__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X3: A,Y4: A] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)),Y4)) ) ) ).

% power2_sum
tff(fact_367_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D1: A,D22: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),D1))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),D22))
           => ? [E2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),E2))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),E2),D1))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),E2),D22)) ) ) ) ) ).

% field_lbound_gt_zero
tff(fact_368_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ).

% add_divide_distrib
tff(fact_369_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),zero_zero(A)))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),zero_zero(A))) ) ) ) ).

% add_less_zeroD
tff(fact_370_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))) ) ) ) ).

% divide_strict_right_mono_neg
tff(fact_371_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))) ) ) ) ).

% divide_strict_right_mono
tff(fact_372_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A))) ) ) ) ) ).

% zero_less_divide_iff
tff(fact_373_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) )
            & ( C2 != zero_zero(A) ) ) ) ) ).

% divide_less_cancel
tff(fact_374_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),zero_zero(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ) ) ).

% divide_less_0_iff
tff(fact_375_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4))) ) ) ) ).

% divide_pos_pos
tff(fact_376_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),zero_zero(A))) ) ) ) ).

% divide_pos_neg
tff(fact_377_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),zero_zero(A))) ) ) ) ).

% divide_neg_pos
tff(fact_378_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4))) ) ) ) ).

% divide_neg_neg
tff(fact_379_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) = zero_zero(nat) )
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
        | ( N = zero_zero(nat) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
tff(fact_380_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),bit0(N))),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(num,A,numeral_numeral(A),N) ) ) ).

% numeral_Bit0_div_2
tff(fact_381_low__inv,axiom,
    ! [X3: nat,N: nat,Y4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))
     => ( vEBT_VEBT_low(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Y4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N))),X3),N) = X3 ) ) ).

% low_inv
tff(fact_382_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% double_eq_0_iff
tff(fact_383_buildup__nothing__in__leaf,axiom,
    ! [N: nat,X3: nat] : ~ vEBT_V5719532721284313246member(vEBT_vebt_buildup(N),X3) ).

% buildup_nothing_in_leaf
tff(fact_384_unset__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),zero_zero(nat)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% unset_bit_0
tff(fact_385_length__mul__elem,axiom,
    ! [A: $tType,Xs: list(list(A)),N: nat] :
      ( ! [X2: list(A)] :
          ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),X2),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
         => ( aa(list(A),nat,size_size(list(A)),X2) = N ) )
     => ( aa(list(A),nat,size_size(list(A)),concat(A,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(list(A)),nat,size_size(list(list(A))),Xs)),N) ) ) ).

% length_mul_elem
tff(fact_386_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [R2: A,A3: A,B2: A,C2: A,D2: A] :
          ( ( R2 != zero_zero(A) )
         => ( ( ( A3 = B2 )
              & ( C2 != D2 ) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),R2),C2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),R2),D2)) ) ) ) ) ).

% add_scale_eq_noteq
tff(fact_387_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) ) ) ) ).

% mult_less_iff1
tff(fact_388_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,X3: A,Y4: A] :
          ( ( aa(nat,A,power_power(A,U),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ) ) ).

% arith_geo_mean
tff(fact_389_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),bit0(V))),aa(num,int,numeral_numeral(int),bit0(W))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),W)) ) ).

% zdiv_numeral_Bit0
tff(fact_390_buildup__nothing__in__min__max,axiom,
    ! [N: nat,X3: nat] : ~ vEBT_VEBT_membermima(vEBT_vebt_buildup(N),X3) ).

% buildup_nothing_in_min_max
tff(fact_391_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X3: nat,N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_low(X3,N)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
tff(fact_392_both__member__options__def,axiom,
    ! [T2: vEBT_VEBT,X3: nat] :
      ( pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,T2),X3))
    <=> ( vEBT_V5719532721284313246member(T2,X3)
        | vEBT_VEBT_membermima(T2,X3) ) ) ).

% both_member_options_def
tff(fact_393_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),bit0(M)),bit0(N)))
    <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M),N)) ) ).

% semiring_norm(71)
tff(fact_394_semiring__norm_I68_J,axiom,
    ! [N: num] : pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),one2),N)) ).

% semiring_norm(68)
tff(fact_395_bot__nat__0_Oextremum,axiom,
    ! [A3: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),zero_zero(nat)),A3)) ).

% bot_nat_0.extremum
tff(fact_396_le0,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),zero_zero(nat)),N)) ).

% le0
tff(fact_397_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),N),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) ) ).

% unset_bit_nonnegative_int_iff
tff(fact_398_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% nat_add_left_cancel_le
tff(fact_399_enat__ord__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),extended_enat2(M)),extended_enat2(N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% enat_ord_simps(1)
tff(fact_400_le__zero__eq,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N),zero_zero(A)))
        <=> ( N = zero_zero(A) ) ) ) ).

% le_zero_eq
tff(fact_401_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: num,N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M),N)) ) ) ).

% numeral_le_iff
tff(fact_402_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% add_le_cancel_left
tff(fact_403_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% add_le_cancel_right
tff(fact_404_semiring__norm_I69_J,axiom,
    ! [M: num] : ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),bit0(M)),one2)) ).

% semiring_norm(69)
tff(fact_405_not__real__square__gt__zero,axiom,
    ! [X3: real] :
      ( ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),times_times(real),X3),X3)))
    <=> ( X3 = zero_zero(real) ) ) ).

% not_real_square_gt_zero
tff(fact_406_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),N),K)),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int))) ) ).

% unset_bit_negative_int_iff
tff(fact_407_times__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(M)),extended_enat2(N)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) ) ).

% times_enat_simps(1)
tff(fact_408_semiring__norm_I13_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),bit0(M)),bit0(N)) = bit0(bit0(aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ).

% semiring_norm(13)
tff(fact_409_semiring__norm_I12_J,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),one2),N) = N ) ).

% semiring_norm(12)
tff(fact_410_semiring__norm_I11_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),M),one2) = M ) ).

% semiring_norm(11)
tff(fact_411_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),aa(num,extended_enat,numeral_numeral(extended_enat),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N))) ) ).

% enat_ord_number(1)
tff(fact_412_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
tff(fact_413_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
tff(fact_414_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) ) ).

% le_add_same_cancel2
tff(fact_415_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) ) ).

% le_add_same_cancel1
tff(fact_416_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% add_le_same_cancel2
tff(fact_417_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% add_le_same_cancel1
tff(fact_418_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ).

% mult_le_cancel2
tff(fact_419_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ).

% nat_mult_le_cancel_disj
tff(fact_420_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),K))
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = zero_zero(int) ) ) ) ).

% div_neg_neg_trivial
tff(fact_421_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),L))
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = zero_zero(int) ) ) ) ).

% div_pos_pos_trivial
tff(fact_422_num__double,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),bit0(one2)),N) = bit0(N) ) ).

% num_double
tff(fact_423_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,M: num,N: num] : ( aa(nat,A,power_power(A,aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),M))),aa(num,nat,numeral_numeral(nat),N)) = aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ) ).

% power_mult_numeral
tff(fact_424_numeral__le__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),extended_enat2(N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),M)),N)) ) ).

% numeral_le_enat_iff
tff(fact_425_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W))),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W)))) ) ) ).

% divide_le_eq_numeral1(1)
tff(fact_426_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W))),B2)) ) ) ).

% le_divide_eq_numeral1(1)
tff(fact_427_power__mono__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,B2: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N)))
              <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ) ) ).

% power_mono_iff
tff(fact_428_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) ) ).

% half_nonnegative_int_iff
tff(fact_429_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),zero_zero(A)))
        <=> ( A3 = zero_zero(A) ) ) ) ).

% power2_less_eq_zero_iff
tff(fact_430_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
           => ( ( aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))) )
            <=> ( X3 = Y4 ) ) ) ) ) ).

% power2_eq_iff_nonneg
tff(fact_431_less__int__code_I1_J,axiom,
    ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),zero_zero(int))) ).

% less_int_code(1)
tff(fact_432_split__zdiv,axiom,
    ! [P: fun(int,bool),N: int,K: int] :
      ( pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),divide_divide(int),N),K)))
    <=> ( ( ( K = zero_zero(int) )
         => pp(aa(int,bool,P,zero_zero(int))) )
        & ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
         => ! [I2: int,J4: int] :
              ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),J4))
                & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J4),K))
                & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I2)),J4) ) )
             => pp(aa(int,bool,P,I2)) ) )
        & ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
         => ! [I2: int,J4: int] :
              ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),J4))
                & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),J4),zero_zero(int)))
                & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I2)),J4) ) )
             => pp(aa(int,bool,P,I2)) ) ) ) ) ).

% split_zdiv
tff(fact_433_zdiv__mono1,axiom,
    ! [A3: int,A4: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),A4))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A4),B2))) ) ) ).

% zdiv_mono1
tff(fact_434_zdiv__mono2,axiom,
    ! [A3: int,B4: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),A3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B4))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),B4),B2))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B4))) ) ) ) ).

% zdiv_mono2
tff(fact_435_q__pos__lemma,axiom,
    ! [B4: int,Q3: int,R3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B4),Q3)),R3)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R3),B4))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B4))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Q3)) ) ) ) ).

% q_pos_lemma
tff(fact_436_zdiv__eq__0__iff,axiom,
    ! [I: int,K: int] :
      ( ( aa(int,int,aa(int,fun(int,int),divide_divide(int),I),K) = zero_zero(int) )
    <=> ( ( K = zero_zero(int) )
        | ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),I))
          & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I),K)) )
        | ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),zero_zero(int)))
          & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),I)) ) ) ) ).

% zdiv_eq_0_iff
tff(fact_437_zmult__zless__mono2,axiom,
    ! [I: int,J3: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I),J3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),aa(int,int,aa(int,fun(int,int),times_times(int),K),J3))) ) ) ).

% zmult_zless_mono2
tff(fact_438_less__eq__real__def,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
    <=> ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
        | ( X3 = Y4 ) ) ) ).

% less_eq_real_def
tff(fact_439_int__div__neg__eq,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( A3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R2) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),R2),zero_zero(int)))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),R2))
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2) = Q2 ) ) ) ) ).

% int_div_neg_eq
tff(fact_440_int__div__pos__eq,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( A3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R2) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),R2))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R2),B2))
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2) = Q2 ) ) ) ) ).

% int_div_pos_eq
tff(fact_441_zdiv__mono1__neg,axiom,
    ! [A3: int,A4: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),A4))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),zero_zero(int)))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A4),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2))) ) ) ).

% zdiv_mono1_neg
tff(fact_442_zdiv__mono2__neg,axiom,
    ! [A3: int,B4: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A3),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B4))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),B4),B2))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B4)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2))) ) ) ) ).

% zdiv_mono2_neg
tff(fact_443_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L)))
    <=> ( ( K = zero_zero(int) )
        | ( L = zero_zero(int) )
        | ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
          & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),L)) )
        | ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
          & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int))) ) ) ) ).

% div_int_pos_iff
tff(fact_444_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),L),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L))) ) ) ).

% div_positive_int
tff(fact_445_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R2: int,B4: int,Q3: int,R3: int] :
      ( ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R2) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B4),Q3)),R3) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B4),Q3)),R3)))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R3),B4))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),R2))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B4))
             => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),B4),B2))
               => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Q2),Q3)) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
tff(fact_446_div__neg__pos__less0,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A3),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),zero_zero(int))) ) ) ).

% div_neg_pos_less0
tff(fact_447_div__nonneg__neg__le0,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),A3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),zero_zero(int)))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),zero_zero(int))) ) ) ).

% div_nonneg_neg_le0
tff(fact_448_div__nonpos__pos__le0,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),zero_zero(int))) ) ) ).

% div_nonpos_pos_le0
tff(fact_449_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),zero_zero(int)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),A3)) ) ) ).

% neg_imp_zdiv_neg_iff
tff(fact_450_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),zero_zero(int)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A3),zero_zero(int))) ) ) ).

% pos_imp_zdiv_neg_iff
tff(fact_451_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),I),K)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),I)) ) ) ).

% pos_imp_zdiv_pos_iff
tff(fact_452_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R2: int,B4: int,Q3: int,R3: int] :
      ( ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R2) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B4),Q3)),R3) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B4),Q3)),R3)),zero_zero(int)))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R2),B2))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),R3))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B4))
             => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),B4),B2))
               => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Q3),Q2)) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
tff(fact_453_unique__quotient__lemma,axiom,
    ! [B2: int,Q3: int,R3: int,Q2: int,R2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q3)),R3)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R2)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),R3))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R3),B2))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R2),B2))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Q3),Q2)) ) ) ) ) ).

% unique_quotient_lemma
tff(fact_454_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),zero_zero(int))) ) ) ).

% neg_imp_zdiv_nonneg_iff
tff(fact_455_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),A3)) ) ) ).

% pos_imp_zdiv_nonneg_iff
tff(fact_456_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),A3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)))
      <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),B2),A3))
          & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2)) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
tff(fact_457_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q3: int,R3: int,Q2: int,R2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q3)),R3)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R2)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),R2),zero_zero(int)))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),R2))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),R3))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Q2),Q3)) ) ) ) ) ).

% unique_quotient_lemma_neg
tff(fact_458_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),N) = zero_zero(extended_enat) )
    <=> ( ( M = zero_zero(extended_enat) )
        | ( N = zero_zero(extended_enat) ) ) ) ).

% imult_is_0
tff(fact_459_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),N),zero_zero(extended_enat)))
    <=> ( N = zero_zero(extended_enat) ) ) ).

% ile0_eq
tff(fact_460_i0__lb,axiom,
    ! [N: extended_enat] : pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),zero_zero(extended_enat)),N)) ).

% i0_lb
tff(fact_461_plus__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),K),zero_zero(int)) = K ) ).

% plus_int_code(1)
tff(fact_462_plus__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),zero_zero(int)),L) = L ) ).

% plus_int_code(2)
tff(fact_463_times__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),zero_zero(int)),L) = zero_zero(int) ) ).

% times_int_code(2)
tff(fact_464_times__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),K),zero_zero(int)) = zero_zero(int) ) ).

% times_int_code(1)
tff(fact_465_less__eq__int__code_I1_J,axiom,
    pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),zero_zero(int))) ).

% less_eq_int_code(1)
tff(fact_466_zdiv__zmult2__eq,axiom,
    ! [C2: int,A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),C2))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),C2) ) ) ).

% zdiv_zmult2_eq
tff(fact_467_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
          | ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
          | ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% verit_la_disequality
tff(fact_468_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),A3)) ) ).

% verit_comp_simplify1(2)
tff(fact_469_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),zero_zero(A))) ) ).

% le_numeral_extra(3)
tff(fact_470_zero__le,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3)) ) ).

% zero_le
tff(fact_471_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B4: B,A4: B] :
          ( ~ pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B4),A4))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),A4),B4)) ) ) ).

% verit_comp_simplify1(3)
tff(fact_472_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),J3))
            & ( K = L ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L))) ) ) ).

% add_mono_thms_linordered_semiring(3)
tff(fact_473_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( I = J3 )
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L))) ) ) ).

% add_mono_thms_linordered_semiring(2)
tff(fact_474_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),J3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L))) ) ) ).

% add_mono_thms_linordered_semiring(1)
tff(fact_475_add__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2))) ) ) ) ).

% add_mono
tff(fact_476_add__left__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))) ) ) ).

% add_left_mono
tff(fact_477_less__eqE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ~ ! [C3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C3) ) ) ) ).

% less_eqE
tff(fact_478_add__right__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))) ) ) ).

% add_right_mono
tff(fact_479_le__iff__add,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ? [C4: A] : ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C4) ) ) ) ).

% le_iff_add
tff(fact_480_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% add_le_imp_le_left
tff(fact_481_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% add_le_imp_le_right
tff(fact_482_le__num__One__iff,axiom,
    ! [X3: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),X3),one2))
    <=> ( X3 = one2 ) ) ).

% le_num_One_iff
tff(fact_483_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),zero_zero(nat)),N)) ).

% less_eq_nat.simps(1)
tff(fact_484_bot__nat__0_Oextremum__unique,axiom,
    ! [A3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),zero_zero(nat)))
    <=> ( A3 = zero_zero(nat) ) ) ).

% bot_nat_0.extremum_unique
tff(fact_485_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),zero_zero(nat)))
     => ( A3 = zero_zero(nat) ) ) ).

% bot_nat_0.extremum_uniqueI
tff(fact_486_le__0__eq,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),zero_zero(nat)))
    <=> ( N = zero_zero(nat) ) ) ).

% le_0_eq
tff(fact_487_nat__less__le,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
        & ( M != N ) ) ) ).

% nat_less_le
tff(fact_488_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% less_imp_le_nat
tff(fact_489_le__eq__less__or__eq,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
        | ( M = N ) ) ) ).

% le_eq_less_or_eq
tff(fact_490_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
        | ( M = N ) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% less_or_eq_imp_le
tff(fact_491_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( ( M != N )
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ).

% le_neq_implies_less
tff(fact_492_less__mono__imp__le__mono,axiom,
    ! [F2: fun(nat,nat),I: nat,J3: nat] :
      ( ! [I3: nat,J2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),J2))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,F2,I3)),aa(nat,nat,F2,J2))) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,F2,I)),aa(nat,nat,F2,J3))) ) ) ).

% less_mono_imp_le_mono
tff(fact_493_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),B3))
    <=> ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),B3)) ) ) ).

% subset_code(1)
tff(fact_494_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),N))
     => ~ ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N)) ) ) ).

% add_leE
tff(fact_495_le__add1,axiom,
    ! [N: nat,M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))) ).

% le_add1
tff(fact_496_le__add2,axiom,
    ! [N: nat,M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) ).

% le_add2
tff(fact_497_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% add_leD1
tff(fact_498_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N)) ) ).

% add_leD2
tff(fact_499_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),L))
     => ? [N2: nat] : ( L = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N2) ) ) ).

% le_Suc_ex
tff(fact_500_add__le__mono,axiom,
    ! [I: nat,J3: nat,K: nat,L: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),L))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),L))) ) ) ).

% add_le_mono
tff(fact_501_add__le__mono1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),K))) ) ).

% add_le_mono1
tff(fact_502_trans__le__add1,axiom,
    ! [I: nat,J3: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),M))) ) ).

% trans_le_add1
tff(fact_503_trans__le__add2,axiom,
    ! [I: nat,J3: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),J3))) ) ).

% trans_le_add2
tff(fact_504_nat__le__iff__add,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
    <=> ? [K3: nat] : ( N = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K3) ) ) ).

% nat_le_iff_add
tff(fact_505_mult__le__mono2,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),I)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),J3))) ) ).

% mult_le_mono2
tff(fact_506_mult__le__mono1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),K))) ) ).

% mult_le_mono1
tff(fact_507_mult__le__mono,axiom,
    ! [I: nat,J3: nat,K: nat,L: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),L))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),L))) ) ) ).

% mult_le_mono
tff(fact_508_le__square,axiom,
    ! [M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),M))) ).

% le_square
tff(fact_509_le__cube,axiom,
    ! [M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),M)))) ).

% le_cube
tff(fact_510_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),K))) ) ).

% div_le_mono
tff(fact_511_div__le__dividend,axiom,
    ! [M: nat,N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),M)) ).

% div_le_dividend
tff(fact_512_enat__ile,axiom,
    ! [N: extended_enat,M: nat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),N),extended_enat2(M)))
     => ? [K2: nat] : ( N = extended_enat2(K2) ) ) ).

% enat_ile
tff(fact_513_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),zero_zero(extended_enat)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),N)))
    <=> ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),zero_zero(extended_enat)),M))
        & pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),zero_zero(extended_enat)),N)) ) ) ).

% enat_0_less_mult_iff
tff(fact_514_L2__set__mult__ineq__lemma,axiom,
    ! [A3: real,C2: real,B2: real,D2: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,aa(real,fun(real,real),times_times(real),A3),C2))),aa(real,real,aa(real,fun(real,real),times_times(real),B2),D2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,A3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,D2),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,B2),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,C2),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ).

% L2_set_mult_ineq_lemma
tff(fact_515_iadd__le__enat__iff,axiom,
    ! [X3: extended_enat,Y4: extended_enat,N: nat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X3),Y4)),extended_enat2(N)))
    <=> ? [Y6: nat,X5: nat] :
          ( ( X3 = extended_enat2(X5) )
          & ( Y4 = extended_enat2(Y6) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X5),Y6)),N)) ) ) ).

% iadd_le_enat_iff
tff(fact_516_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ) ).

% mult_le_cancel_iff1
tff(fact_517_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ) ).

% mult_le_cancel_iff2
tff(fact_518_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = zero_zero(A) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
tff(fact_519_div__positive,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2))) ) ) ) ).

% div_positive
tff(fact_520_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
tff(fact_521_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),N)),zero_zero(A))) ) ).

% not_numeral_le_zero
tff(fact_522_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),N))) ) ).

% zero_le_numeral
tff(fact_523_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordere2520102378445227354miring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
tff(fact_524_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) ) ) ) ) ).

% zero_le_mult_iff
tff(fact_525_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),zero_zero(A))) ) ) ) ).

% mult_nonneg_nonpos2
tff(fact_526_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ) ).

% mult_nonpos_nonneg
tff(fact_527_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ) ).

% mult_nonneg_nonpos
tff(fact_528_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ) ).

% mult_nonneg_nonneg
tff(fact_529_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ).

% split_mult_neg_le
tff(fact_530_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) ) ) ) ).

% mult_le_0_iff
tff(fact_531_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ) ).

% mult_right_mono
tff(fact_532_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ) ).

% mult_right_mono_neg
tff(fact_533_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% mult_left_mono
tff(fact_534_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ) ).

% mult_nonpos_nonpos
tff(fact_535_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% mult_left_mono_neg
tff(fact_536_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,B2: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ).

% split_mult_pos_le
tff(fact_537_zero__le__square,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3))) ) ).

% zero_le_square
tff(fact_538_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_mono'
tff(fact_539_mult__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_mono
tff(fact_540_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),zero_zero(A)))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4) = zero_zero(A) )
            <=> ( ( X3 = zero_zero(A) )
                & ( Y4 = zero_zero(A) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
tff(fact_541_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4) = zero_zero(A) )
            <=> ( ( X3 = zero_zero(A) )
                & ( Y4 = zero_zero(A) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
tff(fact_542_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),zero_zero(A))) ) ) ) ).

% add_nonpos_nonpos
tff(fact_543_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% add_nonneg_nonneg
tff(fact_544_add__increasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% add_increasing2
tff(fact_545_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2)) ) ) ) ).

% add_decreasing2
tff(fact_546_add__increasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% add_increasing
tff(fact_547_add__decreasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2)) ) ) ) ).

% add_decreasing
tff(fact_548_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A,K: num,L: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),L)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),K),L))) ) ) ).

% div_mult2_numeral_eq
tff(fact_549_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2))) ) ) ) ).

% add_less_le_mono
tff(fact_550_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2))) ) ) ) ).

% add_le_less_mono
tff(fact_551_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),J3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L))) ) ) ).

% add_mono_thms_linordered_field(3)
tff(fact_552_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),J3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),L))) ) ) ).

% add_mono_thms_linordered_field(4)
tff(fact_553_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),zero_zero(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) ) ) ) ).

% divide_le_0_iff
tff(fact_554_divide__right__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))) ) ) ) ).

% divide_right_mono
tff(fact_555_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) ) ) ) ) ).

% zero_le_divide_iff
tff(fact_556_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4))) ) ) ) ).

% divide_nonneg_nonneg
tff(fact_557_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),zero_zero(A))) ) ) ) ).

% divide_nonneg_nonpos
tff(fact_558_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),zero_zero(A))) ) ) ) ).

% divide_nonpos_nonneg
tff(fact_559_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4))) ) ) ) ).

% divide_nonpos_nonpos
tff(fact_560_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2))) ) ) ) ).

% divide_right_mono_neg
tff(fact_561_zero__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A3),N))) ) ) ).

% zero_le_power
tff(fact_562_power__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,B2: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N))) ) ) ) ).

% power_mono
tff(fact_563_not__exp__less__eq__0__int,axiom,
    ! [N: nat] : ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),zero_zero(int))) ).

% not_exp_less_eq_0_int
tff(fact_564_ex__least__nat__le,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( pp(aa(nat,bool,P,N))
     => ( ~ pp(aa(nat,bool,P,zero_zero(nat)))
       => ? [K2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K2),N))
            & ! [I4: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I4),K2))
               => ~ pp(aa(nat,bool,P,I4)) )
            & pp(aa(nat,bool,P,K2)) ) ) ) ).

% ex_least_nat_le
tff(fact_565_mono__nat__linear__lb,axiom,
    ! [F2: fun(nat,nat),M: nat,K: nat] :
      ( ! [M3: nat,N2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N2))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,F2,M3)),aa(nat,nat,F2,N2))) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,F2,M)),K)),aa(nat,nat,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)))) ) ).

% mono_nat_linear_lb
tff(fact_566_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N))),M)) ).

% times_div_less_eq_dividend
tff(fact_567_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),N)),M)) ).

% div_times_less_eq_dividend
tff(fact_568_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% mult_le_cancel_left
tff(fact_569_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% mult_le_cancel_right
tff(fact_570_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% mult_left_less_imp_less
tff(fact_571_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_strict_mono
tff(fact_572_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% mult_less_cancel_left
tff(fact_573_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% mult_right_less_imp_less
tff(fact_574_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_strict_mono'
tff(fact_575_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% mult_less_cancel_right
tff(fact_576_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% mult_le_cancel_left_neg
tff(fact_577_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% mult_le_cancel_left_pos
tff(fact_578_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% mult_left_le_imp_le
tff(fact_579_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% mult_right_le_imp_le
tff(fact_580_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_le_less_imp_less
tff(fact_581_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_less_le_imp_less
tff(fact_582_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% add_strict_increasing2
tff(fact_583_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% add_strict_increasing
tff(fact_584_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% add_pos_nonneg
tff(fact_585_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),zero_zero(A))) ) ) ) ).

% add_nonpos_neg
tff(fact_586_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% add_nonneg_pos
tff(fact_587_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),zero_zero(A))) ) ) ) ).

% add_neg_nonpos
tff(fact_588_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( ! [E2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),E2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y4),E2))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ).

% field_le_epsilon
tff(fact_589_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Y4))),zero_zero(A)))
        <=> ( ( X3 = zero_zero(A) )
            & ( Y4 = zero_zero(A) ) ) ) ) ).

% sum_squares_le_zero_iff
tff(fact_590_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Y4)))) ) ).

% sum_squares_ge_zero
tff(fact_591_frac__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y4: A,X3: A,W: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),W))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),W),Z))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),W))) ) ) ) ) ) ).

% frac_le
tff(fact_592_frac__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A,W: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),W))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),W),Z))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),W))) ) ) ) ) ) ).

% frac_less
tff(fact_593_frac__less2,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A,W: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),W))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),W),Z))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),W))) ) ) ) ) ) ).

% frac_less2
tff(fact_594_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% divide_le_cancel
tff(fact_595_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),zero_zero(A))) ) ) ) ).

% divide_nonneg_neg
tff(fact_596_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4))) ) ) ) ).

% divide_nonneg_pos
tff(fact_597_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4))) ) ) ) ).

% divide_nonpos_neg
tff(fact_598_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),zero_zero(A))) ) ) ) ).

% divide_nonpos_pos
tff(fact_599_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% power_less_imp_less_base
tff(fact_600_four__x__squared,axiom,
    ! [X3: real] : ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% four_x_squared
tff(fact_601_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ).

% nat_mult_le_cancel1
tff(fact_602_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),K),N)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),K),M))) ) ) ).

% div_le_mono2
tff(fact_603_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% div_greater_zero_iff
tff(fact_604_divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A3))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ) ) ) ) ).

% divide_le_eq
tff(fact_605_le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq
tff(fact_606_divide__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2))) ) ) ) ) ).

% divide_left_mono
tff(fact_607_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ).

% neg_divide_le_eq
tff(fact_608_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% neg_le_divide_eq
tff(fact_609_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% pos_divide_le_eq
tff(fact_610_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ).

% pos_le_divide_eq
tff(fact_611_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y4: A,X3: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y4)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),Z)) ) ) ) ).

% mult_imp_div_pos_le
tff(fact_612_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y4: A,Z: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y4)),X3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4))) ) ) ) ).

% mult_imp_le_div_pos
tff(fact_613_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2))) ) ) ) ) ).

% divide_left_mono_neg
tff(fact_614_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,A3: A,B2: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
             => ( ( aa(nat,A,power_power(A,A3),N) = aa(nat,A,power_power(A,B2),N) )
              <=> ( A3 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
tff(fact_615_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat,B2: A] :
          ( ( aa(nat,A,power_power(A,A3),N) = aa(nat,A,power_power(A,B2),N) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
               => ( A3 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
tff(fact_616_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,power_power(nat,K),M))) ) ).

% self_le_ge2_pow
tff(fact_617_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,power_power(nat,N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% power2_nat_le_eq_le
tff(fact_618_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% power2_nat_le_imp_le
tff(fact_619_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),Q2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),Q2)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)),N)) ) ) ).

% less_eq_div_iff_mult_less_eq
tff(fact_620_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),W)),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
tff(fact_621_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(num,A,numeral_numeral(A),W)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W))) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
tff(fact_622_zero__le__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% zero_le_power2
tff(fact_623_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
             => ( X3 = Y4 ) ) ) ) ) ).

% power2_eq_imp_eq
tff(fact_624_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ) ).

% power2_le_imp_le
tff(fact_625_power__strict__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,B2: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N))) ) ) ) ) ).

% power_strict_mono
tff(fact_626_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) ) ) ) ).

% power2_less_imp_less
tff(fact_627_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% sum_power2_ge_zero
tff(fact_628_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),zero_zero(A)))
        <=> ( ( X3 = zero_zero(A) )
            & ( Y4 = zero_zero(A) ) ) ) ) ).

% sum_power2_le_zero_iff
tff(fact_629_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) ) ).

% zero_le_even_power'
tff(fact_630_add__0__iff,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [B2: A,A3: A] :
          ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% add_0_iff
tff(fact_631_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [W: A,Y4: A,X3: A,Z: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y4)),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4)) )
        <=> ( ( W = X3 )
            | ( Y4 = Z ) ) ) ) ).

% crossproduct_eq
tff(fact_632_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( A3 != B2 )
            & ( C2 != D2 ) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),D2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% crossproduct_noteq
tff(fact_633_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)),Y4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% sum_squares_bound
tff(fact_634_in__children__def,axiom,
    ! [N: nat,TreeList: list(vEBT_VEBT),X3: nat] :
      ( vEBT_V5917875025757280293ildren(N,TreeList,X3)
    <=> pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),vEBT_VEBT_high(X3,N))),vEBT_VEBT_low(X3,N))) ) ).

% in_children_def
tff(fact_635_both__member__options__ding,axiom,
    ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,N: nat,X3: nat] :
      ( vEBT_invar_vebt(vEBT_Node(Info,Deg,TreeList,Summary),N)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg)))
       => ( pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),vEBT_VEBT_low(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2))))))
         => pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,vEBT_Node(Info,Deg,TreeList,Summary)),X3)) ) ) ) ).

% both_member_options_ding
tff(fact_636_set__n__deg__not__0,axiom,
    ! [TreeList: list(vEBT_VEBT),N: nat,M: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
         => vEBT_invar_vebt(X2,N) )
     => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),N)) ) ) ).

% set_n_deg_not_0
tff(fact_637_low__def,axiom,
    ! [X3: nat,N: nat] : ( vEBT_VEBT_low(X3,N) = modulo_modulo(nat,X3,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% low_def
tff(fact_638_order__refl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),X3)) ) ).

% order_refl
tff(fact_639_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),A3)) ) ).

% dual_order.refl
tff(fact_640_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
           => ( ( modulo_modulo(A,X3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)) = modulo_modulo(A,X3,M) )
              | ( modulo_modulo(A,X3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,X3,M)),M) ) ) ) ) ) ).

% mod_double_modulus
tff(fact_641_incr__mult__lemma,axiom,
    ! [D2: int,P: fun(int,bool),K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D2))
     => ( ! [X2: int] :
            ( pp(aa(int,bool,P,X2))
           => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),D2))) )
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
         => ! [X: int] :
              ( pp(aa(int,bool,P,X))
             => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K),D2)))) ) ) ) ) ).

% incr_mult_lemma
tff(fact_642_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),zero_zero(A))) ) ) ).

% odd_power_less_zero
tff(fact_643_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A3),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% odd_0_le_power_imp_0_le
tff(fact_644_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I: num,N: nat,X3: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),I)),N)),aa(nat,A,semiring_1_of_nat(A),X3)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),I)),N)),X3)) ) ) ).

% numeral_power_less_of_nat_cancel_iff
tff(fact_645_even__odd__cases,axiom,
    ! [X3: nat] :
      ( ! [N2: nat] : ( X3 != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),N2) )
     => ~ ! [N2: nat] : ( X3 != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),aa(nat,nat,suc,N2)) ) ) ).

% even_odd_cases
tff(fact_646_nat_Oinject,axiom,
    ! [X22: nat,Y22: nat] :
      ( ( aa(nat,nat,suc,X22) = aa(nat,nat,suc,Y22) )
    <=> ( X22 = Y22 ) ) ).

% nat.inject
tff(fact_647_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( aa(nat,nat,suc,Nat) = aa(nat,nat,suc,Nat2) )
    <=> ( Nat = Nat2 ) ) ).

% old.nat.inject
tff(fact_648_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat,N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),M) = aa(nat,A,semiring_1_of_nat(A),N) )
        <=> ( M = N ) ) ) ).

% of_nat_eq_iff
tff(fact_649_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A] : ( modulo_modulo(A,modulo_modulo(A,A3,B2),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mod_trivial
tff(fact_650_real__divide__square__eq,axiom,
    ! [R2: real,A3: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),R2),A3)),aa(real,real,aa(real,fun(real,real),times_times(real),R2),R2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),A3),R2) ) ).

% real_divide_square_eq
tff(fact_651_VEBT_Oinject_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT,Y11: option(product_prod(nat,nat)),Y12: nat,Y13: list(vEBT_VEBT),Y14: vEBT_VEBT] :
      ( ( vEBT_Node(X11,X12,X13,X14) = vEBT_Node(Y11,Y12,Y13,Y14) )
    <=> ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
tff(fact_652_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),one_one(A)) = A3 ) ) ).

% mult.right_neutral
tff(fact_653_mult__1,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A3) = A3 ) ) ).

% mult_1
tff(fact_654_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),one_one(A)) = A3 ) ) ).

% bits_div_by_1
tff(fact_655_div__by__1,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),one_one(A)) = A3 ) ) ).

% div_by_1
tff(fact_656_power__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [N: nat] : ( aa(nat,A,power_power(A,one_one(A)),N) = one_one(A) ) ) ).

% power_one
tff(fact_657_bits__mod__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] : ( modulo_modulo(A,zero_zero(A),A3) = zero_zero(A) ) ) ).

% bits_mod_0
tff(fact_658_mod__self,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A] : ( modulo_modulo(A,A3,A3) = zero_zero(A) ) ) ).

% mod_self
tff(fact_659_mod__by__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A] : ( modulo_modulo(A,A3,zero_zero(A)) = A3 ) ) ).

% mod_by_0
tff(fact_660_mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A] : ( modulo_modulo(A,zero_zero(A),A3) = zero_zero(A) ) ) ).

% mod_0
tff(fact_661_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% Suc_less_eq
tff(fact_662_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N))) ) ).

% Suc_mono
tff(fact_663_lessI,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,suc,N))) ).

% lessI
tff(fact_664_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,N)),aa(nat,nat,suc,M)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M)) ) ).

% Suc_le_mono
tff(fact_665_mod__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_add_self2
tff(fact_666_mod__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_add_self1
tff(fact_667_add__Suc__right,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ).

% add_Suc_right
tff(fact_668_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = aa(num,int,numeral_numeral(int),V) )
    <=> ( M = aa(num,nat,numeral_numeral(nat),V) ) ) ).

% int_eq_iff_numeral
tff(fact_669_power__one__right,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(nat,A,power_power(A,A3),one_one(nat)) = A3 ) ) ).

% power_one_right
tff(fact_670_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( one_one(nat) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) )
    <=> ( ( M = one_one(nat) )
        & ( N = one_one(nat) ) ) ) ).

% nat_1_eq_mult_iff
tff(fact_671_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) = one_one(nat) )
    <=> ( ( M = one_one(nat) )
        & ( N = one_one(nat) ) ) ) ).

% nat_mult_eq_1_iff
tff(fact_672_mod__less,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ( modulo_modulo(nat,M,N) = M ) ) ).

% mod_less
tff(fact_673_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_left1
tff(fact_674_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = one_one(A) ) ) ) ) ).

% mult_cancel_left2
tff(fact_675_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_right1
tff(fact_676_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = one_one(A) ) ) ) ) ).

% mult_cancel_right2
tff(fact_677_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% zero_eq_1_divide_iff
tff(fact_678_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% one_divide_eq_0_iff
tff(fact_679_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( ( one_one(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3) )
        <=> ( ( A3 != zero_zero(A) )
            & ( A3 = B2 ) ) ) ) ).

% eq_divide_eq_1
tff(fact_680_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3) = one_one(A) )
        <=> ( ( A3 != zero_zero(A) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_eq_1
tff(fact_681_divide__self__if,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( ( A3 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),A3) = zero_zero(A) ) )
          & ( ( A3 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),A3) = one_one(A) ) ) ) ) ).

% divide_self_if
tff(fact_682_divide__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),A3) = one_one(A) ) ) ) ).

% divide_self
tff(fact_683_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( one_one(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A3 = B2 ) ) ) ) ).

% one_eq_divide_iff
tff(fact_684_div__self,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),A3) = one_one(A) ) ) ) ).

% div_self
tff(fact_685_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = one_one(A) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_1_iff
tff(fact_686_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),N) )
        <=> ( one2 = N ) ) ) ).

% one_eq_numeral_iff
tff(fact_687_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] :
          ( ( aa(num,A,numeral_numeral(A),N) = one_one(A) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_one_iff
tff(fact_688_power__inject__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( ( aa(nat,A,power_power(A,A3),M) = aa(nat,A,power_power(A,A3),N) )
          <=> ( M = N ) ) ) ) ).

% power_inject_exp
tff(fact_689_power__0__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,power_power(A,zero_zero(A)),aa(nat,nat,suc,N)) = zero_zero(A) ) ) ).

% power_0_Suc
tff(fact_690_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3),B2) = zero_zero(A) ) ) ).

% mod_mult_self1_is_0
tff(fact_691_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),B2) = zero_zero(A) ) ) ).

% mod_mult_self2_is_0
tff(fact_692_mod__by__1,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A] : ( modulo_modulo(A,A3,one_one(A)) = zero_zero(A) ) ) ).

% mod_by_1
tff(fact_693_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] : ( modulo_modulo(A,A3,one_one(A)) = zero_zero(A) ) ) ).

% bits_mod_by_1
tff(fact_694_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),M) = zero_zero(A) )
        <=> ( M = zero_zero(nat) ) ) ) ).

% of_nat_eq_0_iff
tff(fact_695_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( zero_zero(A) = aa(nat,A,semiring_1_of_nat(A),N) )
        <=> ( zero_zero(nat) = N ) ) ) ).

% of_nat_0_eq_iff
tff(fact_696_of__nat__0,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),zero_zero(nat)) = zero_zero(A) ) ) ).

% of_nat_0
tff(fact_697_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A3,B2)),B2) = zero_zero(A) ) ) ).

% mod_div_trivial
tff(fact_698_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A3,B2)),B2) = zero_zero(A) ) ) ).

% bits_mod_div_trivial
tff(fact_699_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ).

% of_nat_less_iff
tff(fact_700_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A3),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mult_self4
tff(fact_701_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A3),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mult_self3
tff(fact_702_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mult_self2
tff(fact_703_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mult_self1
tff(fact_704_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ).

% of_nat_le_iff
tff(fact_705_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: num] : ( aa(nat,A,semiring_1_of_nat(A),aa(num,nat,numeral_numeral(nat),N)) = aa(num,A,numeral_numeral(A),N) ) ) ).

% of_nat_numeral
tff(fact_706_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(nat,A,power_power(A,A3),aa(nat,nat,suc,zero_zero(nat))) = A3 ) ) ).

% power_Suc0_right
tff(fact_707_zero__less__Suc,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,suc,N))) ).

% zero_less_Suc
tff(fact_708_less__Suc0,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,suc,zero_zero(nat))))
    <=> ( N = zero_zero(nat) ) ) ).

% less_Suc0
tff(fact_709_of__nat__add,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_add
tff(fact_710_of__nat__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_mult
tff(fact_711_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,suc,zero_zero(nat)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) )
    <=> ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
        & ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% one_eq_mult_iff
tff(fact_712_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
        & ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% mult_eq_1_iff
tff(fact_713_of__nat__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),one_one(nat)) = one_one(A) ) ) ).

% of_nat_1
tff(fact_714_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( one_one(A) = aa(nat,A,semiring_1_of_nat(A),N) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_1_eq_iff
tff(fact_715_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),N) = one_one(A) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_eq_1_iff
tff(fact_716_mult__Suc__right,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) ) ).

% mult_Suc_right
tff(fact_717_less__one,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),one_one(nat)))
    <=> ( N = zero_zero(nat) ) ) ).

% less_one
tff(fact_718_div__by__Suc__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,suc,zero_zero(nat))) = M ) ).

% div_by_Suc_0
tff(fact_719_power__Suc__0,axiom,
    ! [N: nat] : ( aa(nat,nat,power_power(nat,aa(nat,nat,suc,zero_zero(nat))),N) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% power_Suc_0
tff(fact_720_nat__power__eq__Suc__0__iff,axiom,
    ! [X3: nat,M: nat] :
      ( ( aa(nat,nat,power_power(nat,X3),M) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( M = zero_zero(nat) )
        | ( X3 = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% nat_power_eq_Suc_0_iff
tff(fact_721_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [X3: nat,B2: nat,W: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),X3) = aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W) )
        <=> ( X3 = aa(nat,nat,power_power(nat,B2),W) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
tff(fact_722_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [B2: nat,W: nat,X3: nat] :
          ( ( aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W) = aa(nat,A,semiring_1_of_nat(A),X3) )
        <=> ( aa(nat,nat,power_power(nat,B2),W) = X3 ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
tff(fact_723_of__nat__power,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,power_power(nat,M),N)) = aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),M)),N) ) ) ).

% of_nat_power
tff(fact_724_mod__by__Suc__0,axiom,
    ! [M: nat] : ( modulo_modulo(nat,M,aa(nat,nat,suc,zero_zero(nat))) = zero_zero(nat) ) ).

% mod_by_Suc_0
tff(fact_725_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),L))
       => ( modulo_modulo(int,K,L) = K ) ) ) ).

% mod_pos_pos_trivial
tff(fact_726_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),K))
       => ( modulo_modulo(int,K,L) = K ) ) ) ).

% mod_neg_neg_trivial
tff(fact_727_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% zero_le_divide_1_iff
tff(fact_728_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% divide_le_0_1_iff
tff(fact_729_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% zero_less_divide_1_iff
tff(fact_730_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% less_divide_eq_1_pos
tff(fact_731_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ).

% less_divide_eq_1_neg
tff(fact_732_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ).

% divide_less_eq_1_pos
tff(fact_733_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% divide_less_eq_1_neg
tff(fact_734_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% divide_less_0_1_iff
tff(fact_735_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3) ) ) ) ).

% nonzero_divide_mult_cancel_right
tff(fact_736_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ).

% nonzero_divide_mult_cancel_left
tff(fact_737_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),M)),zero_zero(A)))
        <=> ( M = zero_zero(nat) ) ) ) ).

% of_nat_le_0_iff
tff(fact_738_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,X3: nat,Y4: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,B2),X3)),aa(nat,A,power_power(A,B2),Y4)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),Y4)) ) ) ) ).

% power_strict_increasing_iff
tff(fact_739_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),M)) ) ) ).

% of_nat_Suc
tff(fact_740_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),M))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),N)) ) ) ).

% one_le_mult_iff
tff(fact_741_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),bit0(V)),aa(num,int,numeral_numeral(int),bit0(W))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),modulo_modulo(int,aa(num,int,numeral_numeral(int),V),aa(num,int,numeral_numeral(int),W))) ) ).

% zmod_numeral_Bit0
tff(fact_742_real__of__nat__less__numeral__iff,axiom,
    ! [N: nat,W: num] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(num,real,numeral_numeral(real),W)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(num,nat,numeral_numeral(nat),W))) ) ).

% real_of_nat_less_numeral_iff
tff(fact_743_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(num,real,numeral_numeral(real),W)),aa(nat,real,semiring_1_of_nat(real),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(num,nat,numeral_numeral(nat),W)),N)) ) ).

% numeral_less_real_of_nat_iff
tff(fact_744_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(num,real,numeral_numeral(real),N)),aa(nat,real,semiring_1_of_nat(real),M)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),N)),M)) ) ).

% numeral_le_real_of_nat_iff
tff(fact_745_Suc__numeral,axiom,
    ! [N: num] : ( aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),N)) = aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ).

% Suc_numeral
tff(fact_746_Suc__mod__mult__self4,axiom,
    ! [N: nat,K: nat,M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K)),M)),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% Suc_mod_mult_self4
tff(fact_747_Suc__mod__mult__self3,axiom,
    ! [K: nat,N: nat,M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)),M)),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% Suc_mod_mult_self3
tff(fact_748_Suc__mod__mult__self2,axiom,
    ! [M: nat,N: nat,K: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% Suc_mod_mult_self2
tff(fact_749_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% Suc_mod_mult_self1
tff(fact_750_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% le_divide_eq_1_pos
tff(fact_751_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% le_divide_eq_1_neg
tff(fact_752_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% divide_le_eq_1_pos
tff(fact_753_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% divide_le_eq_1_neg
tff(fact_754_one__add__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)) = aa(num,A,numeral_numeral(A),bit0(one2)) ) ) ).

% one_add_one
tff(fact_755_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),one_one(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,B2),M)),aa(nat,A,power_power(A,B2),N)))
            <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M)) ) ) ) ) ).

% power_strict_decreasing_iff
tff(fact_756_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,X3: nat,Y4: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,B2),X3)),aa(nat,A,power_power(A,B2),Y4)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X3),Y4)) ) ) ) ).

% power_increasing_iff
tff(fact_757_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,semiring_1_of_nat(A),N)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% of_nat_0_less_iff
tff(fact_758_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ).

% one_mod_two_eq_one
tff(fact_759_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ).

% bits_one_mod_two_eq_one
tff(fact_760_add__2__eq__Suc_H,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,suc,aa(nat,nat,suc,N)) ) ).

% add_2_eq_Suc'
tff(fact_761_add__2__eq__Suc,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) = aa(nat,nat,suc,aa(nat,nat,suc,N)) ) ).

% add_2_eq_Suc
tff(fact_762_Suc__1,axiom,
    aa(nat,nat,suc,one_one(nat)) = aa(num,nat,numeral_numeral(nat),bit0(one2)) ).

% Suc_1
tff(fact_763_div2__Suc__Suc,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,M))),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% div2_Suc_Suc
tff(fact_764_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: nat,B2: nat,W: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,semiring_1_of_nat(A),X3)),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),aa(nat,nat,power_power(nat,B2),W))) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
tff(fact_765_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: nat,W: nat,X3: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W)),aa(nat,A,semiring_1_of_nat(A),X3)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,power_power(nat,B2),W)),X3)) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
tff(fact_766_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: nat,B2: nat,W: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),X3)),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X3),aa(nat,nat,power_power(nat,B2),W))) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
tff(fact_767_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: nat,W: nat,X3: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W)),aa(nat,A,semiring_1_of_nat(A),X3)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,B2),W)),X3)) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
tff(fact_768_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Y4: nat,X3: num,N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Y4) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N) )
        <=> ( Y4 = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X3)),N) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
tff(fact_769_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [X3: num,N: nat,Y4: nat] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N) = aa(nat,A,semiring_1_of_nat(A),Y4) )
        <=> ( aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X3)),N) = Y4 ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
tff(fact_770_mod2__Suc__Suc,axiom,
    ! [M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,M)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% mod2_Suc_Suc
tff(fact_771_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% one_plus_numeral
tff(fact_772_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ) ).

% numeral_plus_one
tff(fact_773_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),N)),one_one(A)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),N),one2)) ) ) ).

% numeral_le_one_iff
tff(fact_774_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(num,A,numeral_numeral(A),N)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),one2),N)) ) ) ).

% one_less_numeral_iff
tff(fact_775_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( aa(num,nat,numeral_numeral(nat),K) != one_one(nat) )
     => ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),K)),N)),aa(num,nat,numeral_numeral(nat),K)) = one_one(nat) ) ) ).

% Suc_times_numeral_mod_eq
tff(fact_776_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ).

% one_div_two_eq_zero
tff(fact_777_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ).

% bits_1_div_2
tff(fact_778_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),one_one(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,B2),M)),aa(nat,A,power_power(A,B2),N)))
            <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M)) ) ) ) ) ).

% power_decreasing_iff
tff(fact_779_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),X3)),N)))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),X3))
            | ( N = zero_zero(nat) ) ) ) ) ).

% of_nat_zero_less_power_iff
tff(fact_780_add__self__mod__2,axiom,
    ! [M: nat] : ( modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),M),aa(num,nat,numeral_numeral(nat),bit0(one2))) = zero_zero(nat) ) ).

% add_self_mod_2
tff(fact_781_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: nat,I: num,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,semiring_1_of_nat(A),X3)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),I)),N)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),I)),N))) ) ) ).

% of_nat_less_numeral_power_cancel_iff
tff(fact_782_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: nat,I: num,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),X3)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),I)),N)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),I)),N))) ) ) ).

% of_nat_le_numeral_power_cancel_iff
tff(fact_783_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I: num,N: nat,X3: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),I)),N)),aa(nat,A,semiring_1_of_nat(A),X3)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),I)),N)),X3)) ) ) ).

% numeral_power_le_of_nat_cancel_iff
tff(fact_784_mod2__gr__0,axiom,
    ! [M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))))
    <=> ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(nat) ) ) ).

% mod2_gr_0
tff(fact_785_zle__iff__zadd,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),W),Z))
    <=> ? [N3: nat] : ( Z = aa(int,int,aa(int,fun(int,int),plus_plus(int),W),aa(nat,int,semiring_1_of_nat(int),N3)) ) ) ).

% zle_iff_zadd
tff(fact_786_int__distrib_I1_J,axiom,
    ! [Z1: int,Z2: int,W: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z1),Z2)),W) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Z1),W)),aa(int,int,aa(int,fun(int,int),times_times(int),Z2),W)) ) ).

% int_distrib(1)
tff(fact_787_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z2: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z1),Z2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z1)),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z2)) ) ).

% int_distrib(2)
tff(fact_788_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),modulo_modulo(nat,M,N)),M)) ).

% mod_less_eq_dividend
tff(fact_789_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),modulo_modulo(nat,M,aa(nat,nat,suc,N))),N)) ).

% mod_Suc_le_divisor
tff(fact_790_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),N),K)),K)) ).

% unset_bit_less_eq
tff(fact_791_complete__real,axiom,
    ! [S2: set(real)] :
      ( ? [X: real] : pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X),S2))
     => ( ? [Z3: real] :
          ! [X2: real] :
            ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),S2))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),Z3)) )
       => ? [Y2: real] :
            ( ! [X: real] :
                ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X),S2))
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X),Y2)) )
            & ! [Z3: real] :
                ( ! [X2: real] :
                    ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),S2))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),Z3)) )
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y2),Z3)) ) ) ) ) ).

% complete_real
tff(fact_792_verit__la__generic,axiom,
    ! [A3: int,X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),X3))
      | ( A3 = X3 )
      | pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),A3)) ) ).

% verit_la_generic
tff(fact_793_nat__int__comparison_I3_J,axiom,
    ! [A3: nat,B2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),B2))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2))) ) ).

% nat_int_comparison(3)
tff(fact_794_zle__int,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% zle_int
tff(fact_795_zmod__int,axiom,
    ! [A3: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,A3,B2)) = modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),A3),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% zmod_int
tff(fact_796_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R4: fun(nat,fun(nat,bool))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( ! [X2: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),R4,X2),X2))
       => ( ! [X2: nat,Y2: nat,Z4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),R4,X2),Y2))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),R4,Y2),Z4))
               => pp(aa(nat,bool,aa(nat,fun(nat,bool),R4,X2),Z4)) ) )
         => ( ! [N2: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),R4,N2),aa(nat,nat,suc,N2)))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),R4,M),N)) ) ) ) ) ).

% transitive_stepwise_le
tff(fact_797_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P: fun(nat,bool)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( pp(aa(nat,bool,P,M))
       => ( ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N2))
             => ( pp(aa(nat,bool,P,N2))
               => pp(aa(nat,bool,P,aa(nat,nat,suc,N2))) ) )
         => pp(aa(nat,bool,P,N)) ) ) ) ).

% nat_induct_at_least
tff(fact_798_Nat_Oex__has__greatest__nat,axiom,
    ! [P: fun(nat,bool),K: nat,B2: nat] :
      ( pp(aa(nat,bool,P,K))
     => ( ! [Y2: nat] :
            ( pp(aa(nat,bool,P,Y2))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y2),B2)) )
       => ? [X2: nat] :
            ( pp(aa(nat,bool,P,X2))
            & ! [Y5: nat] :
                ( pp(aa(nat,bool,P,Y5))
               => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y5),X2)) ) ) ) ) ).

% Nat.ex_has_greatest_nat
tff(fact_799_full__nat__induct,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,M2)),N2))
             => pp(aa(nat,bool,P,M2)) )
         => pp(aa(nat,bool,P,N2)) )
     => pp(aa(nat,bool,P,N)) ) ).

% full_nat_induct
tff(fact_800_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,N)),M)) ) ).

% not_less_eq_eq
tff(fact_801_Suc__n__not__le__n,axiom,
    ! [N: nat] : ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,N)),N)) ).

% Suc_n_not_le_n
tff(fact_802_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
      | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M)) ) ).

% nat_le_linear
tff(fact_803_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
       => ( M = N ) ) ) ).

% le_antisym
tff(fact_804_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,suc,N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
        | ( M = aa(nat,nat,suc,N) ) ) ) ).

% le_Suc_eq
tff(fact_805_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% eq_imp_le
tff(fact_806_le__trans,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),K))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),K)) ) ) ).

% le_trans
tff(fact_807_Suc__le__D,axiom,
    ! [N: nat,M4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,N)),M4))
     => ? [M3: nat] : ( M4 = aa(nat,nat,suc,M3) ) ) ).

% Suc_le_D
tff(fact_808_le__refl,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N)) ).

% le_refl
tff(fact_809_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,suc,N))) ) ).

% le_SucI
tff(fact_810_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,suc,N)))
     => ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
       => ( M = aa(nat,nat,suc,N) ) ) ) ).

% le_SucE
tff(fact_811_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,M)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% Suc_leD
tff(fact_812_Suc__inject,axiom,
    ! [X3: nat,Y4: nat] :
      ( ( aa(nat,nat,suc,X3) = aa(nat,nat,suc,Y4) )
     => ( X3 = Y4 ) ) ).

% Suc_inject
tff(fact_813_n__not__Suc__n,axiom,
    ! [N: nat] : ( N != aa(nat,nat,suc,N) ) ).

% n_not_Suc_n
tff(fact_814_one__reorient,axiom,
    ! [A: $tType] :
      ( one(A)
     => ! [X3: A] :
          ( ( one_one(A) = X3 )
        <=> ( X3 = one_one(A) ) ) ) ).

% one_reorient
tff(fact_815_of__nat__mod,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),modulo_modulo(nat,M,N)) = modulo_modulo(A,aa(nat,A,semiring_1_of_nat(A),M),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_mod
tff(fact_816_mod__Suc__eq,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,modulo_modulo(nat,M,N)),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% mod_Suc_eq
tff(fact_817_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,modulo_modulo(nat,M,N))),N) = modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,M)),N) ) ).

% mod_Suc_Suc_eq
tff(fact_818_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N)) != zero_zero(A) ) ) ).

% of_nat_neq_0
tff(fact_819_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( aa(nat,nat,suc,modulo_modulo(nat,M,N)) = N )
       => ( modulo_modulo(nat,aa(nat,nat,suc,M),N) = zero_zero(nat) ) )
      & ( ( aa(nat,nat,suc,modulo_modulo(nat,M,N)) != N )
       => ( modulo_modulo(nat,aa(nat,nat,suc,M),N) = aa(nat,nat,suc,modulo_modulo(nat,M,N)) ) ) ) ).

% mod_Suc
tff(fact_820_mod__induct,axiom,
    ! [P: fun(nat,bool),N: nat,P2: nat,M: nat] :
      ( pp(aa(nat,bool,P,N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),P2))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),P2))
         => ( ! [N2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N2),P2))
               => ( pp(aa(nat,bool,P,N2))
                 => pp(aa(nat,bool,P,modulo_modulo(nat,aa(nat,nat,suc,N2),P2))) ) )
           => pp(aa(nat,bool,P,M)) ) ) ) ) ).

% mod_induct
tff(fact_821_real__of__nat__div__aux,axiom,
    ! [X3: nat,D2: nat] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),X3)),aa(nat,real,semiring_1_of_nat(real),D2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X3),D2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),modulo_modulo(nat,X3,D2))),aa(nat,real,semiring_1_of_nat(real),D2))) ) ).

% real_of_nat_div_aux
tff(fact_822_zless__iff__Suc__zadd,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z))
    <=> ? [N3: nat] : ( Z = aa(int,int,aa(int,fun(int,int),plus_plus(int),W),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N3))) ) ) ).

% zless_iff_Suc_zadd
tff(fact_823_One__nat__def,axiom,
    one_one(nat) = aa(nat,nat,suc,zero_zero(nat)) ).

% One_nat_def
tff(fact_824_Suc__eq__plus1,axiom,
    ! [N: nat] : ( aa(nat,nat,suc,N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)) ) ).

% Suc_eq_plus1
tff(fact_825_plus__1__eq__Suc,axiom,
    aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)) = suc ).

% plus_1_eq_Suc
tff(fact_826_Suc__eq__plus1__left,axiom,
    ! [N: nat] : ( aa(nat,nat,suc,N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),N) ) ).

% Suc_eq_plus1_left
tff(fact_827_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M))
     => ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),M) = one_one(nat) ) ) ).

% Suc_times_mod_eq
tff(fact_828_power__gt1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(nat,A,power_power(A,A3),aa(nat,nat,suc,N)))) ) ) ).

% power_gt1
tff(fact_829_nat__induct__non__zero,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,P,one_one(nat)))
       => ( ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
             => ( pp(aa(nat,bool,P,N2))
               => pp(aa(nat,bool,P,aa(nat,nat,suc,N2))) ) )
         => pp(aa(nat,bool,P,N)) ) ) ) ).

% nat_induct_non_zero
tff(fact_830_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ).

% mod_mult_right_eq
tff(fact_831_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A3,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ).

% mod_mult_left_eq
tff(fact_832_mult__mod__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),modulo_modulo(A,A3,B2)) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% mult_mod_right
tff(fact_833_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A3,B2)),C2) ) ) ).

% mod_mult_mult2
tff(fact_834_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,A4: A,B2: A,B4: A] :
          ( ( modulo_modulo(A,A3,C2) = modulo_modulo(A,A4,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B4,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B4),C2) ) ) ) ) ).

% mod_mult_cong
tff(fact_835_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A3,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ).

% mod_mult_eq
tff(fact_836_of__nat__mono,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [I: nat,J3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),I)),aa(nat,A,semiring_1_of_nat(A),J3))) ) ) ).

% of_nat_mono
tff(fact_837_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),C2) ) ) ).

% mod_add_right_eq
tff(fact_838_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),C2) ) ) ).

% mod_add_left_eq
tff(fact_839_mod__add__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,A4: A,B2: A,B4: A] :
          ( ( modulo_modulo(A,A3,C2) = modulo_modulo(A,A4,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B4,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B4),C2) ) ) ) ) ).

% mod_add_cong
tff(fact_840_mod__add__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),C2) ) ) ).

% mod_add_eq
tff(fact_841_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X3: nat,Y4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),X3)),Y4) = aa(A,A,aa(A,fun(A,A),times_times(A),Y4),aa(nat,A,semiring_1_of_nat(A),X3)) ) ) ).

% mult_of_nat_commute
tff(fact_842_power__mod,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A,N: nat] : ( modulo_modulo(A,aa(nat,A,power_power(A,modulo_modulo(A,A3,B2)),N),B2) = modulo_modulo(A,aa(nat,A,power_power(A,A3),N),B2) ) ) ).

% power_mod
tff(fact_843_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),M))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),modulo_modulo(int,M,K)),M)) ) ).

% zmod_le_nonneg_dividend
tff(fact_844_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( modulo_modulo(int,M,D2) = zero_zero(int) )
    <=> ? [Q4: int] : ( M = aa(int,int,aa(int,fun(int,int),times_times(int),D2),Q4) ) ) ).

% zmod_eq_0_iff
tff(fact_845_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( modulo_modulo(int,M,D2) = zero_zero(int) )
     => ? [Q5: int] : ( M = aa(int,int,aa(int,fun(int,int),times_times(int),D2),Q5) ) ) ).

% zmod_eq_0D
tff(fact_846_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),N: nat,N4: nat] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,N2)),aa(nat,A,F2,aa(nat,nat,suc,N2))))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,N)),aa(nat,A,F2,N4))) ) ) ) ).

% lift_Suc_mono_le
tff(fact_847_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),N: nat,N4: nat] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,aa(nat,nat,suc,N2))),aa(nat,A,F2,N2)))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,N4)),aa(nat,A,F2,N))) ) ) ) ).

% lift_Suc_antimono_le
tff(fact_848_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ? [N2: nat] : ( K = aa(nat,int,semiring_1_of_nat(int),N2) ) ) ).

% zero_le_imp_eq_int
tff(fact_849_nonneg__int__cases,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ~ ! [N2: nat] : ( K != aa(nat,int,semiring_1_of_nat(int),N2) ) ) ).

% nonneg_int_cases
tff(fact_850_int__plus,axiom,
    ! [N: nat,M: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(nat,int,semiring_1_of_nat(int),M)) ) ).

% int_plus
tff(fact_851_int__ops_I5_J,axiom,
    ! [A3: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_ops(5)
tff(fact_852_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),Z)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))),Z) ) ).

% zadd_int_left
tff(fact_853_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => ? [M3: nat] : ( N = aa(nat,nat,suc,M3) ) ) ).

% not0_implies_Suc
tff(fact_854_Zero__not__Suc,axiom,
    ! [M: nat] : ( zero_zero(nat) != aa(nat,nat,suc,M) ) ).

% Zero_not_Suc
tff(fact_855_Zero__neq__Suc,axiom,
    ! [M: nat] : ( zero_zero(nat) != aa(nat,nat,suc,M) ) ).

% Zero_neq_Suc
tff(fact_856_Suc__neq__Zero,axiom,
    ! [M: nat] : ( aa(nat,nat,suc,M) != zero_zero(nat) ) ).

% Suc_neq_Zero
tff(fact_857_zero__induct,axiom,
    ! [P: fun(nat,bool),K: nat] :
      ( pp(aa(nat,bool,P,K))
     => ( ! [N2: nat] :
            ( pp(aa(nat,bool,P,aa(nat,nat,suc,N2)))
           => pp(aa(nat,bool,P,N2)) )
       => pp(aa(nat,bool,P,zero_zero(nat))) ) ) ).

% zero_induct
tff(fact_858_diff__induct,axiom,
    ! [P: fun(nat,fun(nat,bool)),M: nat,N: nat] :
      ( ! [X2: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),P,X2),zero_zero(nat)))
     => ( ! [Y2: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),P,zero_zero(nat)),aa(nat,nat,suc,Y2)))
       => ( ! [X2: nat,Y2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),P,X2),Y2))
             => pp(aa(nat,bool,aa(nat,fun(nat,bool),P,aa(nat,nat,suc,X2)),aa(nat,nat,suc,Y2))) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),P,M),N)) ) ) ) ).

% diff_induct
tff(fact_859_nat__induct,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( pp(aa(nat,bool,P,zero_zero(nat)))
     => ( ! [N2: nat] :
            ( pp(aa(nat,bool,P,N2))
           => pp(aa(nat,bool,P,aa(nat,nat,suc,N2))) )
       => pp(aa(nat,bool,P,N)) ) ) ).

% nat_induct
tff(fact_860_vebt__buildup_Ocases,axiom,
    ! [X3: nat] :
      ( ( X3 != zero_zero(nat) )
     => ( ( X3 != aa(nat,nat,suc,zero_zero(nat)) )
       => ~ ! [Va: nat] : ( X3 != aa(nat,nat,suc,aa(nat,nat,suc,Va)) ) ) ) ).

% vebt_buildup.cases
tff(fact_861_old_Onat_Oexhaust,axiom,
    ! [Y4: nat] :
      ( ( Y4 != zero_zero(nat) )
     => ~ ! [Nat3: nat] : ( Y4 != aa(nat,nat,suc,Nat3) ) ) ).

% old.nat.exhaust
tff(fact_862_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat = aa(nat,nat,suc,X22) )
     => ( Nat != zero_zero(nat) ) ) ).

% nat.discI
tff(fact_863_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] : ( zero_zero(nat) != aa(nat,nat,suc,Nat2) ) ).

% old.nat.distinct(1)
tff(fact_864_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat2: nat] : ( aa(nat,nat,suc,Nat2) != zero_zero(nat) ) ).

% old.nat.distinct(2)
tff(fact_865_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] : ( zero_zero(nat) != aa(nat,nat,suc,X22) ) ).

% nat.distinct(1)
tff(fact_866_int__ops_I7_J,axiom,
    ! [A3: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),B2)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_ops(7)
tff(fact_867_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,suc,M)))
      <=> ( N = M ) ) ) ).

% not_less_less_Suc_eq
tff(fact_868_strict__inc__induct,axiom,
    ! [I: nat,J3: nat,P: fun(nat,bool)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ( ! [I3: nat] :
            ( ( J3 = aa(nat,nat,suc,I3) )
           => pp(aa(nat,bool,P,I3)) )
       => ( ! [I3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),J3))
             => ( pp(aa(nat,bool,P,aa(nat,nat,suc,I3)))
               => pp(aa(nat,bool,P,I3)) ) )
         => pp(aa(nat,bool,P,I)) ) ) ) ).

% strict_inc_induct
tff(fact_869_less__Suc__induct,axiom,
    ! [I: nat,J3: nat,P: fun(nat,fun(nat,bool))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ( ! [I3: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),P,I3),aa(nat,nat,suc,I3)))
       => ( ! [I3: nat,J2: nat,K2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),J2))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J2),K2))
               => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),P,I3),J2))
                 => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),P,J2),K2))
                   => pp(aa(nat,bool,aa(nat,fun(nat,bool),P,I3),K2)) ) ) ) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),P,I),J3)) ) ) ) ).

% less_Suc_induct
tff(fact_870_less__trans__Suc,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),K))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,I)),K)) ) ) ).

% less_trans_Suc
tff(fact_871_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% Suc_less_SucD
tff(fact_872_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,suc,M)))
       => ( M = N ) ) ) ).

% less_antisym
tff(fact_873_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M))
    <=> ? [M5: nat] :
          ( ( M = aa(nat,nat,suc,M5) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M5)) ) ) ).

% Suc_less_eq2
tff(fact_874_All__less__Suc,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( ! [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,suc,N)))
         => pp(aa(nat,bool,P,I2)) )
    <=> ( pp(aa(nat,bool,P,N))
        & ! [I2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),N))
           => pp(aa(nat,bool,P,I2)) ) ) ) ).

% All_less_Suc
tff(fact_875_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,suc,M))) ) ).

% not_less_eq
tff(fact_876_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,suc,N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
        | ( M = N ) ) ) ).

% less_Suc_eq
tff(fact_877_Ex__less__Suc,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( ? [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,suc,N)))
          & pp(aa(nat,bool,P,I2)) )
    <=> ( pp(aa(nat,bool,P,N))
        | ? [I2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),N))
            & pp(aa(nat,bool,P,I2)) ) ) ) ).

% Ex_less_Suc
tff(fact_878_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,suc,N))) ) ).

% less_SucI
tff(fact_879_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,suc,N)))
     => ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
       => ( M = N ) ) ) ).

% less_SucE
tff(fact_880_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ( ( aa(nat,nat,suc,M) != N )
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,M)),N)) ) ) ).

% Suc_lessI
tff(fact_881_Suc__lessE,axiom,
    ! [I: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,I)),K))
     => ~ ! [J2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J2))
           => ( K != aa(nat,nat,suc,J2) ) ) ) ).

% Suc_lessE
tff(fact_882_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,M)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% Suc_lessD
tff(fact_883_Nat_OlessE,axiom,
    ! [I: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),K))
     => ( ( K != aa(nat,nat,suc,I) )
       => ~ ! [J2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J2))
             => ( K != aa(nat,nat,suc,J2) ) ) ) ) ).

% Nat.lessE
tff(fact_884_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,suc,N))) ) ).

% le_imp_less_Suc
tff(fact_885_less__eq__Suc__le,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,N)),M)) ) ).

% less_eq_Suc_le
tff(fact_886_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,suc,N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% less_Suc_eq_le
tff(fact_887_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,suc,M)))
      <=> ( N = M ) ) ) ).

% le_less_Suc_eq
tff(fact_888_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,M)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% Suc_le_lessD
tff(fact_889_inc__induct,axiom,
    ! [I: nat,J3: nat,P: fun(nat,bool)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( pp(aa(nat,bool,P,J3))
       => ( ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),N2))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N2),J3))
               => ( pp(aa(nat,bool,P,aa(nat,nat,suc,N2)))
                 => pp(aa(nat,bool,P,N2)) ) ) )
         => pp(aa(nat,bool,P,I)) ) ) ) ).

% inc_induct
tff(fact_890_dec__induct,axiom,
    ! [I: nat,J3: nat,P: fun(nat,bool)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( pp(aa(nat,bool,P,I))
       => ( ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),N2))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N2),J3))
               => ( pp(aa(nat,bool,P,N2))
                 => pp(aa(nat,bool,P,aa(nat,nat,suc,N2))) ) ) )
         => pp(aa(nat,bool,P,J3)) ) ) ) ).

% dec_induct
tff(fact_891_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,M)),N))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% Suc_le_eq
tff(fact_892_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,M)),N)) ) ).

% Suc_leI
tff(fact_893_real__of__nat__div4,axiom,
    ! [N: nat,X3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),X3))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,semiring_1_of_nat(real),X3)))) ).

% real_of_nat_div4
tff(fact_894_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),one_one(A))) ) ).

% le_numeral_extra(4)
tff(fact_895_zero__neq__one,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( zero_zero(A) != one_one(A) ) ) ).

% zero_neq_one
tff(fact_896_div__mod__decomp__int,axiom,
    ! [A2: int,N: int] : ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),N)),N)),modulo_modulo(int,A2,N)) ) ).

% div_mod_decomp_int
tff(fact_897_add__Suc__shift,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,suc,N)) ) ).

% add_Suc_shift
tff(fact_898_add__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ).

% add_Suc
tff(fact_899_nat__arith_Osuc1,axiom,
    ! [A2: nat,K: nat,A3: nat] :
      ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),A3) )
     => ( aa(nat,nat,suc,A2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,suc,A3)) ) ) ).

% nat_arith.suc1
tff(fact_900_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),one_one(A))) ) ).

% less_numeral_extra(4)
tff(fact_901_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A3) = A3 ) ) ).

% comm_monoid_mult_class.mult_1
tff(fact_902_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),one_one(A)) = A3 ) ) ).

% mult.comm_neutral
tff(fact_903_of__nat__eq__enat,axiom,
    ! [N: nat] : ( aa(nat,extended_enat,semiring_1_of_nat(extended_enat),N) = extended_enat2(N) ) ).

% of_nat_eq_enat
tff(fact_904_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),N) )
    <=> ( M = N ) ) ).

% Suc_mult_cancel1
tff(fact_905_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% Suc_mult_le_cancel1
tff(fact_906_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,M)),N))) ).

% Suc_div_le_mono
tff(fact_907_nat__mult__1,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),one_one(nat)),N) = N ) ).

% nat_mult_1
tff(fact_908_nat__mult__1__right,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),one_one(nat)) = N ) ).

% nat_mult_1_right
tff(fact_909_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A,M: nat,N: nat] : ( modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)))),modulo_modulo(A,A3,aa(nat,A,semiring_1_of_nat(A),M))) ) ) ).

% mod_mult2_eq'
tff(fact_910_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: nat,M: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
         => ( ( N != zero_zero(nat) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),M))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),N)))) ) ) ) ).

% inverse_of_nat_le
tff(fact_911_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),aa(nat,nat,suc,N))),A3)) ) ) ) ).

% power_Suc_le_self
tff(fact_912_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),aa(nat,nat,suc,N))),one_one(A))) ) ) ) ).

% power_Suc_less_one
tff(fact_913_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),modulo_modulo(A,A3,B2)),A3)) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
tff(fact_914_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),modulo_modulo(A,A3,B2)),B2)) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
tff(fact_915_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo(A,A3,B2) = A3 )
        <=> ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = zero_zero(A) ) ) ) ).

% mod_eq_self_iff_div_eq_0
tff(fact_916_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,semiring_1_of_nat(A),N))) ) ).

% of_nat_0_le_iff
tff(fact_917_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q2: num,N: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit0(M)),aa(num,A,numeral_numeral(A),bit0(Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),bit0(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Q2)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),Q2)) ) ) ) ).

% cong_exp_iff_simps(9)
tff(fact_918_mod__eqE,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A3,C2) = modulo_modulo(A,B2,C2) )
         => ~ ! [D3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D3)) ) ) ) ).

% mod_eqE
tff(fact_919_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),one2)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% cong_exp_iff_simps(4)
tff(fact_920_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),zero_zero(A))) ) ).

% of_nat_less_0_iff
tff(fact_921_div__add1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,C2)),modulo_modulo(A,B2,C2))),C2)) ) ) ).

% div_add1_eq
tff(fact_922_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A,M: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,semiring_1_of_nat(A),M))),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% div_mult2_eq'
tff(fact_923_verit__le__mono__div,axiom,
    ! [A2: nat,B3: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A2),B3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A2),N)),if(nat,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),modulo_modulo(nat,B3,N)),zero_zero(nat)),one_one(nat),zero_zero(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),B3),N))) ) ) ).

% verit_le_mono_div
tff(fact_924_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ).

% of_nat_less_imp_less
tff(fact_925_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))) ) ) ).

% less_imp_of_nat_less
tff(fact_926_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),modulo_modulo(nat,M,N)),N)) ) ).

% mod_less_divisor
tff(fact_927_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),modulo_modulo(nat,M,N)),N)) ) ).

% mod_le_divisor
tff(fact_928_reals__Archimedean3,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ! [Y5: real] :
        ? [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y5),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N2)),X3))) ) ).

% reals_Archimedean3
tff(fact_929_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( modulo_modulo(nat,M,D2) = zero_zero(nat) )
     => ? [Q5: nat] : ( M = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),D2),Q5) ) ) ).

% mod_eq_0D
tff(fact_930_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
tff(fact_931_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)),zero_zero(int)))
       => ( modulo_modulo(int,K,L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L) ) ) ) ).

% mod_pos_neg_trivial
tff(fact_932_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),modulo_modulo(int,K,L)),L)) ) ).

% Euclidean_Division.pos_mod_bound
tff(fact_933_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int)))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),modulo_modulo(int,K,L))) ) ).

% neg_mod_bound
tff(fact_934_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,K,L))) ) ).

% Euclidean_Division.pos_mod_sign
tff(fact_935_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int)))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),modulo_modulo(int,K,L)),zero_zero(int))) ) ).

% neg_mod_sign
tff(fact_936_zmod__trivial__iff,axiom,
    ! [I: int,K: int] :
      ( ( modulo_modulo(int,I,K) = I )
    <=> ( ( K = zero_zero(int) )
        | ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),I))
          & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I),K)) )
        | ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),zero_zero(int)))
          & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),I)) ) ) ) ).

% zmod_trivial_iff
tff(fact_937_int__mod__pos__eq,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( A3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R2) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),R2))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R2),B2))
         => ( modulo_modulo(int,A3,B2) = R2 ) ) ) ) ).

% int_mod_pos_eq
tff(fact_938_int__mod__neg__eq,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( A3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R2) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),R2),zero_zero(int)))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),R2))
         => ( modulo_modulo(int,A3,B2) = R2 ) ) ) ) ).

% int_mod_neg_eq
tff(fact_939_pos__mod__conj,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,A3,B2)))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),modulo_modulo(int,A3,B2)),B2)) ) ) ).

% pos_mod_conj
tff(fact_940_neg__mod__conj,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),modulo_modulo(int,A3,B2)),zero_zero(int)))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),modulo_modulo(int,A3,B2))) ) ) ).

% neg_mod_conj
tff(fact_941_split__zmod,axiom,
    ! [P: fun(int,bool),N: int,K: int] :
      ( pp(aa(int,bool,P,modulo_modulo(int,N,K)))
    <=> ( ( ( K = zero_zero(int) )
         => pp(aa(int,bool,P,N)) )
        & ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
         => ! [I2: int,J4: int] :
              ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),J4))
                & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J4),K))
                & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I2)),J4) ) )
             => pp(aa(int,bool,P,J4)) ) )
        & ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
         => ! [I2: int,J4: int] :
              ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),J4))
                & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),J4),zero_zero(int)))
                & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I2)),J4) ) )
             => pp(aa(int,bool,P,J4)) ) ) ) ) ).

% split_zmod
tff(fact_942_int__ops_I1_J,axiom,
    aa(nat,int,semiring_1_of_nat(int),zero_zero(nat)) = zero_zero(int) ).

% int_ops(1)
tff(fact_943_nat__mod__eq__iff,axiom,
    ! [X3: nat,N: nat,Y4: nat] :
      ( ( modulo_modulo(nat,X3,N) = modulo_modulo(nat,Y4,N) )
    <=> ? [Q1: nat,Q22: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X3),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q1)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Y4),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q22)) ) ) ).

% nat_mod_eq_iff
tff(fact_944_nat__mod__eq__lemma,axiom,
    ! [X3: nat,N: nat,Y4: nat] :
      ( ( modulo_modulo(nat,X3,N) = modulo_modulo(nat,Y4,N) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y4),X3))
       => ? [Q5: nat] : ( X3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Y4),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q5)) ) ) ) ).

% nat_mod_eq_lemma
tff(fact_945_mod__eq__nat2E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( modulo_modulo(nat,M,Q2) = modulo_modulo(nat,N,Q2) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
       => ~ ! [S3: nat] : ( N != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Q2),S3)) ) ) ) ).

% mod_eq_nat2E
tff(fact_946_mod__eq__nat1E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( modulo_modulo(nat,M,Q2) = modulo_modulo(nat,N,Q2) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
       => ~ ! [S3: nat] : ( M != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Q2),S3)) ) ) ) ).

% mod_eq_nat1E
tff(fact_947_int__ops_I3_J,axiom,
    ! [N: num] : ( aa(nat,int,semiring_1_of_nat(int),aa(num,nat,numeral_numeral(nat),N)) = aa(num,int,numeral_numeral(int),N) ) ).

% int_ops(3)
tff(fact_948_power__Suc,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,power_power(A,A3),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,A3),N)) ) ) ).

% power_Suc
tff(fact_949_power__Suc2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,power_power(A,A3),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),N)),A3) ) ) ).

% power_Suc2
tff(fact_950_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),N: nat,M: nat] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,F2,N2)),aa(nat,A,F2,aa(nat,nat,suc,N2))))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,F2,N)),aa(nat,A,F2,M)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M)) ) ) ) ).

% lift_Suc_mono_less_iff
tff(fact_951_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),N: nat,N4: nat] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,F2,N2)),aa(nat,A,F2,aa(nat,nat,suc,N2))))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,F2,N)),aa(nat,A,F2,N4))) ) ) ) ).

% lift_Suc_mono_less
tff(fact_952_nat__int__comparison_I2_J,axiom,
    ! [A3: nat,B2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A3),B2))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2))) ) ).

% nat_int_comparison(2)
tff(fact_953_zmod__zmult2__eq,axiom,
    ! [C2: int,A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),C2))
     => ( modulo_modulo(int,A3,aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2),C2))),modulo_modulo(int,A3,B2)) ) ) ).

% zmod_zmult2_eq
tff(fact_954_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,suc,N)))
    <=> ( ( M = zero_zero(nat) )
        | ? [J4: nat] :
            ( ( M = aa(nat,nat,suc,J4) )
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),N)) ) ) ) ).

% less_Suc_eq_0_disj
tff(fact_955_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ? [M3: nat] : ( N = aa(nat,nat,suc,M3) ) ) ).

% gr0_implies_Suc
tff(fact_956_All__less__Suc2,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( ! [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,suc,N)))
         => pp(aa(nat,bool,P,I2)) )
    <=> ( pp(aa(nat,bool,P,zero_zero(nat)))
        & ! [I2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),N))
           => pp(aa(nat,bool,P,aa(nat,nat,suc,I2))) ) ) ) ).

% All_less_Suc2
tff(fact_957_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
    <=> ? [M6: nat] : ( N = aa(nat,nat,suc,M6) ) ) ).

% gr0_conv_Suc
tff(fact_958_Ex__less__Suc2,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( ? [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,suc,N)))
          & pp(aa(nat,bool,P,I2)) )
    <=> ( pp(aa(nat,bool,P,zero_zero(nat)))
        | ? [I2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),N))
            & pp(aa(nat,bool,P,aa(nat,nat,suc,I2))) ) ) ) ).

% Ex_less_Suc2
tff(fact_959_ex__least__nat__less,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( pp(aa(nat,bool,P,N))
     => ( ~ pp(aa(nat,bool,P,zero_zero(nat)))
       => ? [K2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K2),N))
            & ! [I4: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I4),K2))
               => ~ pp(aa(nat,bool,P,I4)) )
            & pp(aa(nat,bool,P,aa(nat,nat,suc,K2))) ) ) ) ).

% ex_least_nat_less
tff(fact_960_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),one_one(A))) ) ).

% zero_less_one_class.zero_le_one
tff(fact_961_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),one_one(A))) ) ).

% linordered_nonzero_semiring_class.zero_le_one
tff(fact_962_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),zero_zero(A))) ) ).

% not_one_le_zero
tff(fact_963_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
          & ( N = zero_zero(nat) ) )
        | ( ( M = zero_zero(nat) )
          & ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ) ).

% add_is_1
tff(fact_964_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,suc,zero_zero(nat)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) )
    <=> ( ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
          & ( N = zero_zero(nat) ) )
        | ( ( M = zero_zero(nat) )
          & ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ) ).

% one_is_add
tff(fact_965_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),zero_zero(A))) ) ).

% not_one_less_zero
tff(fact_966_zero__less__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),one_one(A))) ) ).

% zero_less_one
tff(fact_967_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),one_one(A))) ) ).

% less_numeral_extra(1)
tff(fact_968_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ~ ! [Q5: nat] : ( N != aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q5)) ) ) ).

% less_natE
tff(fact_969_less__add__Suc1,axiom,
    ! [I: nat,M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),M)))) ).

% less_add_Suc1
tff(fact_970_less__add__Suc2,axiom,
    ! [I: nat,M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I)))) ).

% less_add_Suc2
tff(fact_971_less__iff__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
    <=> ? [K3: nat] : ( N = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K3)) ) ) ).

% less_iff_Suc_add
tff(fact_972_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ? [K2: nat] : ( N = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K2)) ) ) ).

% less_imp_Suc_add
tff(fact_973_one__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(num,A,numeral_numeral(A),N))) ) ).

% one_le_numeral
tff(fact_974_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),N)),one_one(A))) ) ).

% not_numeral_less_one
tff(fact_975_less__1__mult,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),M),N))) ) ) ) ).

% less_1_mult
tff(fact_976_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% Suc_mult_less_cancel1
tff(fact_977_less__add__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)))) ) ).

% less_add_one
tff(fact_978_add__mono1,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),one_one(A)))) ) ) ).

% add_mono1
tff(fact_979_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = one_one(A) )
          <=> ( A3 = B2 ) ) ) ) ).

% right_inverse_eq
tff(fact_980_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),X3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X3)),one_one(A)) ) ) ).

% one_plus_numeral_commute
tff(fact_981_numeral__One,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(num,A,numeral_numeral(A),one2) = one_one(A) ) ) ).

% numeral_One
tff(fact_982_one__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(nat,A,power_power(A,A3),N))) ) ) ).

% one_le_power
tff(fact_983_power__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N5: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N5))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,A3),N5))) ) ) ) ).

% power_increasing
tff(fact_984_mult__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) ) ).

% mult_Suc
tff(fact_985_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option(product_prod(nat,nat)),Uv: list(vEBT_VEBT),Uw: vEBT_VEBT,Ux: nat] : ~ vEBT_V5719532721284313246member(vEBT_Node(Uu,zero_zero(nat),Uv,Uw),Ux) ).

% VEBT_internal.naive_member.simps(2)
tff(fact_986_nat__one__le__power,axiom,
    ! [I: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),I))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,power_power(nat,I),N))) ) ).

% nat_one_le_power
tff(fact_987_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X3: A,Y4: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4) = one_one(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),N)),aa(nat,A,power_power(A,Y4),N)) = one_one(A) ) ) ) ).

% left_right_inverse_power
tff(fact_988_zdiv__int,axiom,
    ! [A3: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A3),B2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% zdiv_int
tff(fact_989_power__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3)),N) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,A3),N)) ) ) ).

% power_one_over
tff(fact_990_power__0,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A3: A] : ( aa(nat,A,power_power(A,A3),zero_zero(nat)) = one_one(A) ) ) ).

% power_0
tff(fact_991_numerals_I1_J,axiom,
    aa(num,nat,numeral_numeral(nat),one2) = one_one(nat) ).

% numerals(1)
tff(fact_992_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) )
     => ( ( N = one_one(nat) )
        | ( M = zero_zero(nat) ) ) ) ).

% mult_eq_self_implies_10
tff(fact_993_Suc__ile__eq,axiom,
    ! [M: nat,N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),extended_enat2(aa(nat,nat,suc,M))),N))
    <=> pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),extended_enat2(M)),N)) ) ).

% Suc_ile_eq
tff(fact_994_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),modulo_modulo(A,A3,B2))) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
tff(fact_995_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( modulo_modulo(A,A3,B2) = A3 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
tff(fact_996_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num,Q2: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit0(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) = zero_zero(A) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(2)
tff(fact_997_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),one2)) = zero_zero(A) ) ) ).

% cong_exp_iff_simps(1)
tff(fact_998_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q2: num,N: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),bit0(Q2))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),bit0(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) ) ) ).

% cong_exp_iff_simps(6)
tff(fact_999_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q2: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit0(M)),aa(num,A,numeral_numeral(A),bit0(Q2))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),bit0(Q2))) ) ) ).

% cong_exp_iff_simps(8)
tff(fact_1000_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2))),modulo_modulo(A,A3,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) ) ) ).

% cancel_div_mod_rules(2)
tff(fact_1001_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),B2)),modulo_modulo(A,A3,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) ) ) ).

% cancel_div_mod_rules(1)
tff(fact_1002_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),B2)),modulo_modulo(A,A3,B2)) ) ) ).

% mod_div_decomp
tff(fact_1003_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),B2)),modulo_modulo(A,A3,B2)) = A3 ) ) ).

% div_mult_mod_eq
tff(fact_1004_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),B2)) = A3 ) ) ).

% mod_div_mult_eq
tff(fact_1005_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2))) = A3 ) ) ).

% mod_mult_div_eq
tff(fact_1006_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [B2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2))),modulo_modulo(A,A3,B2)) = A3 ) ) ).

% mult_div_mod_eq
tff(fact_1007_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),modulo_modulo(A,B2,C2))),C2)) ) ) ).

% div_mult1_eq
tff(fact_1008_real__archimedian__rdiv__eq__0,axiom,
    ! [X3: real,C2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),C2))
       => ( ! [M3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M3))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M3)),X3)),C2)) )
         => ( X3 = zero_zero(real) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
tff(fact_1009_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),aa(nat,nat,suc,N))),aa(nat,A,power_power(A,B2),aa(nat,nat,suc,N))))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% power_le_imp_le_base
tff(fact_1010_power__inject__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat,B2: A] :
          ( ( aa(nat,A,power_power(A,A3),aa(nat,nat,suc,N)) = aa(nat,A,power_power(A,B2),aa(nat,nat,suc,N)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
             => ( A3 = B2 ) ) ) ) ) ).

% power_inject_base
tff(fact_1011_div__less__mono,axiom,
    ! [A2: nat,B3: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A2),B3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( ( modulo_modulo(nat,A2,N) = zero_zero(nat) )
         => ( ( modulo_modulo(nat,B3,N) = zero_zero(nat) )
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A2),N)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),B3),N))) ) ) ) ) ).

% div_less_mono
tff(fact_1012_zmult__zless__mono2__lemma,axiom,
    ! [I: int,J3: int,K: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),K)),I)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),K)),J3))) ) ) ).

% zmult_zless_mono2_lemma
tff(fact_1013_mod__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( modulo_modulo(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N),Q2))),modulo_modulo(nat,M,N)) ) ).

% mod_mult2_eq
tff(fact_1014_div__mod__decomp,axiom,
    ! [A2: nat,N: nat] : ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A2),N)),N)),modulo_modulo(nat,A2,N)) ) ).

% div_mod_decomp
tff(fact_1015_split__pos__lemma,axiom,
    ! [K: int,P: fun(int,fun(int,bool)),N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),N),K)),modulo_modulo(int,N,K)))
      <=> ! [I2: int,J4: int] :
            ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),J4))
              & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J4),K))
              & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I2)),J4) ) )
           => pp(aa(int,bool,aa(int,fun(int,bool),P,I2),J4)) ) ) ) ).

% split_pos_lemma
tff(fact_1016_split__neg__lemma,axiom,
    ! [K: int,P: fun(int,fun(int,bool)),N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),N),K)),modulo_modulo(int,N,K)))
      <=> ! [I2: int,J4: int] :
            ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),J4))
              & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),J4),zero_zero(int)))
              & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I2)),J4) ) )
           => pp(aa(int,bool,aa(int,fun(int,bool),P,I2),J4)) ) ) ) ).

% split_neg_lemma
tff(fact_1017_zdiv__mono__strict,axiom,
    ! [A2: int,B3: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A2),B3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N))
       => ( ( modulo_modulo(int,A2,N) = zero_zero(int) )
         => ( ( modulo_modulo(int,B3,N) = zero_zero(int) )
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),N)),aa(int,int,aa(int,fun(int,int),divide_divide(int),B3),N))) ) ) ) ) ).

% zdiv_mono_strict
tff(fact_1018_numeral__1__eq__Suc__0,axiom,
    aa(num,nat,numeral_numeral(nat),one2) = aa(nat,nat,suc,zero_zero(nat)) ).

% numeral_1_eq_Suc_0
tff(fact_1019_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),X3)),X3)) ) ) ) ) ).

% mult_left_le_one_le
tff(fact_1020_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4)),X3)) ) ) ) ) ).

% mult_right_le_one_le
tff(fact_1021_mult__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),one_one(A))) ) ) ) ) ).

% mult_le_one
tff(fact_1022_mult__left__le,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),A3)) ) ) ) ).

% mult_left_le
tff(fact_1023_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
          <=> ( X3 = Y4 ) ) ) ) ).

% order_antisym_conv
tff(fact_1024_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ).

% linorder_le_cases
tff(fact_1025_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A3: A,B2: A,F2: fun(A,B),C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( ( aa(A,B,F2,B2) = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,A3)),C2)) ) ) ) ) ).

% ord_le_eq_subst
tff(fact_1026_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A3: A,F2: fun(B,A),B2: B,C2: B] :
          ( ( A3 = aa(B,A,F2,B2) )
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(B,A,F2,C2))) ) ) ) ) ).

% ord_eq_le_subst
tff(fact_1027_linorder__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ).

% linorder_linear
tff(fact_1028_order__eq__refl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A] :
          ( ( X3 = Y4 )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ).

% order_eq_refl
tff(fact_1029_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A3: A,B2: A,F2: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,B2)),C2))
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,X2)),aa(A,C,F2,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,A3)),C2)) ) ) ) ) ).

% order_subst2
tff(fact_1030_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A3: A,F2: fun(B,A),B2: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(B,A,F2,B2)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(B,A,F2,C2))) ) ) ) ) ).

% order_subst1
tff(fact_1031_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% Orderings.order_eq_iff
tff(fact_1032_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G))
        <=> ! [X4: A] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X4)),aa(A,B,G,X4))) ) ) ).

% le_fun_def
tff(fact_1033_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( ! [X2: A] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,G,X2)))
         => pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G)) ) ) ).

% le_funI
tff(fact_1034_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B),X3: A] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,G,X3))) ) ) ).

% le_funE
tff(fact_1035_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B),X3: A] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,G,X3))) ) ) ).

% le_funD
tff(fact_1036_antisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
           => ( A3 = B2 ) ) ) ) ).

% antisym
tff(fact_1037_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% dual_order.trans
tff(fact_1038_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( A3 = B2 ) ) ) ) ).

% dual_order.antisym
tff(fact_1039_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% dual_order.eq_iff
tff(fact_1040_linorder__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,bool)),A3: A,B2: A] :
          ( ! [A5: A,B5: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),B5))
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A5),B5)) )
         => ( ! [A5: A,B5: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),P,B5),A5))
               => pp(aa(A,bool,aa(A,fun(A,bool),P,A5),B5)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),P,A3),B2)) ) ) ) ).

% linorder_wlog
tff(fact_1041_order__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Z)) ) ) ) ).

% order_trans
tff(fact_1042_order_Otrans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% order.trans
tff(fact_1043_order__antisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
           => ( X3 = Y4 ) ) ) ) ).

% order_antisym
tff(fact_1044_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( ( B2 = C2 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% ord_le_eq_trans
tff(fact_1045_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% ord_eq_le_trans
tff(fact_1046_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( ( X3 = Y4 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ) ).

% order_class.order_eq_iff
tff(fact_1047_le__cases3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z)) )
         => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Z)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Z))
               => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),Y4)) )
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),Y4))
                 => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) )
               => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z))
                   => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),X3)) )
                 => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),X3))
                     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ) ) ) ) ) ).

% le_cases3
tff(fact_1048_nle__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & ( B2 != A3 ) ) ) ) ).

% nle_le
tff(fact_1049_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),M))) ) ) ).

% n_less_n_mult_m
tff(fact_1050_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N))) ) ) ).

% n_less_m_mult_n
tff(fact_1051_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N))) ) ) ).

% one_less_mult
tff(fact_1052_discrete,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),B2)) ) ) ).

% discrete
tff(fact_1053_zero__less__two,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))) ) ).

% zero_less_two
tff(fact_1054_realpow__pos__nth2,axiom,
    ! [A3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ? [R: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
          & ( aa(nat,real,power_power(real,R),aa(nat,nat,suc,N)) = A3 ) ) ) ).

% realpow_pos_nth2
tff(fact_1055_power__le__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),N)),one_one(A))) ) ) ) ).

% power_le_one
tff(fact_1056_power__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N5: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N5))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),N5)),aa(nat,A,power_power(A,A3),N))) ) ) ) ) ).

% power_decreasing
tff(fact_1057_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% less_divide_eq_1
tff(fact_1058_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),one_one(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            | ( A3 = zero_zero(A) ) ) ) ) ).

% divide_less_eq_1
tff(fact_1059_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ).

% order_less_imp_not_less
tff(fact_1060_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( Y4 != X3 ) ) ) ).

% order_less_imp_not_eq2
tff(fact_1061_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( X3 != Y4 ) ) ) ).

% order_less_imp_not_eq
tff(fact_1062_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
          | ( X3 = Y4 )
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ).

% linorder_less_linear
tff(fact_1063_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A,P: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
           => pp(P) ) ) ) ).

% order_less_imp_triv
tff(fact_1064_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ).

% order_less_not_sym
tff(fact_1065_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A3: A,B2: A,F2: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,B2)),C2))
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,X2)),aa(A,C,F2,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,A3)),C2)) ) ) ) ) ).

% order_less_subst2
tff(fact_1066_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A3: A,F2: fun(B,A),B2: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F2,B2)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X2)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F2,C2))) ) ) ) ) ).

% order_less_subst1
tff(fact_1067_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),X3)) ) ).

% order_less_irrefl
tff(fact_1068_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A3: A,B2: A,F2: fun(A,B),C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( ( aa(A,B,F2,B2) = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,A3)),C2)) ) ) ) ) ).

% ord_less_eq_subst
tff(fact_1069_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A3: A,F2: fun(B,A),B2: B,C2: B] :
          ( ( A3 = aa(B,A,F2,B2) )
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X2)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F2,C2))) ) ) ) ) ).

% ord_eq_less_subst
tff(fact_1070_order__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),Z))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Z)) ) ) ) ).

% order_less_trans
tff(fact_1071_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ).

% order_less_asym'
tff(fact_1072_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( ( X3 != Y4 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ) ).

% linorder_neq_iff
tff(fact_1073_order__less__asym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ).

% order_less_asym
tff(fact_1074_linorder__neqE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( ( X3 != Y4 )
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ) ).

% linorder_neqE
tff(fact_1075_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( A3 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
tff(fact_1076_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( A3 != B2 ) ) ) ).

% order.strict_implies_not_eq
tff(fact_1077_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% dual_order.strict_trans
tff(fact_1078_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
            | ( X3 = Y4 ) ) ) ) ).

% not_less_iff_gr_or_eq
tff(fact_1079_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% order.strict_trans
tff(fact_1080_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,bool)),A3: A,B2: A] :
          ( ! [A5: A,B5: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A5),B5))
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A5),B5)) )
         => ( ! [A5: A] : pp(aa(A,bool,aa(A,fun(A,bool),P,A5),A5))
           => ( ! [A5: A,B5: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),P,B5),A5))
                 => pp(aa(A,bool,aa(A,fun(A,bool),P,A5),B5)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A3),B2)) ) ) ) ) ).

% linorder_less_wlog
tff(fact_1081_exists__least__iff,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool)] :
          ( ? [X_12: A] : pp(aa(A,bool,P,X_12))
        <=> ? [N3: A] :
              ( pp(aa(A,bool,P,N3))
              & ! [M6: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M6),N3))
                 => ~ pp(aa(A,bool,P,M6)) ) ) ) ) ).

% exists_least_iff
tff(fact_1082_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),A3)) ) ).

% dual_order.irrefl
tff(fact_1083_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% dual_order.asym
tff(fact_1084_linorder__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( ( X3 != Y4 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ) ).

% linorder_cases
tff(fact_1085_antisym__conv3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y4: A,X3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
          <=> ( X3 = Y4 ) ) ) ) ).

% antisym_conv3
tff(fact_1086_less__induct,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),A3: A] :
          ( ! [X2: A] :
              ( ! [Y5: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y5),X2))
                 => pp(aa(A,bool,P,Y5)) )
             => pp(aa(A,bool,P,X2)) )
         => pp(aa(A,bool,P,A3)) ) ) ).

% less_induct
tff(fact_1087_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( ( B2 = C2 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% ord_less_eq_trans
tff(fact_1088_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% ord_eq_less_trans
tff(fact_1089_order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ).

% order.asym
tff(fact_1090_less__imp__neq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( X3 != Y4 ) ) ) ).

% less_imp_neq
tff(fact_1091_dense,axiom,
    ! [A: $tType] :
      ( dense_order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ? [Z4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Z4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),Y4)) ) ) ) ).

% dense
tff(fact_1092_gt__ex,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [X3: A] :
        ? [X_13: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),X_13)) ) ).

% gt_ex
tff(fact_1093_lt__ex,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [X3: A] :
        ? [Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y2),X3)) ) ).

% lt_ex
tff(fact_1094_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool),P3: fun(A,bool),Q: fun(A,bool),Q6: fun(A,bool)] :
          ( ? [Z3: A] :
            ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z3),X2))
             => ( pp(aa(A,bool,P,X2))
              <=> pp(aa(A,bool,P3,X2)) ) )
         => ( ? [Z3: A] :
              ! [X2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z3),X2))
               => ( pp(aa(A,bool,Q,X2))
                <=> pp(aa(A,bool,Q6,X2)) ) )
           => ? [Z4: A] :
              ! [X: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),X))
               => ( ( pp(aa(A,bool,P,X))
                    & pp(aa(A,bool,Q,X)) )
                <=> ( pp(aa(A,bool,P3,X))
                    & pp(aa(A,bool,Q6,X)) ) ) ) ) ) ) ).

% pinf(1)
tff(fact_1095_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool),P3: fun(A,bool),Q: fun(A,bool),Q6: fun(A,bool)] :
          ( ? [Z3: A] :
            ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z3),X2))
             => ( pp(aa(A,bool,P,X2))
              <=> pp(aa(A,bool,P3,X2)) ) )
         => ( ? [Z3: A] :
              ! [X2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z3),X2))
               => ( pp(aa(A,bool,Q,X2))
                <=> pp(aa(A,bool,Q6,X2)) ) )
           => ? [Z4: A] :
              ! [X: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),X))
               => ( ( pp(aa(A,bool,P,X))
                    | pp(aa(A,bool,Q,X)) )
                <=> ( pp(aa(A,bool,P3,X))
                    | pp(aa(A,bool,Q6,X)) ) ) ) ) ) ) ).

% pinf(2)
tff(fact_1096_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),X))
         => ( X != T2 ) ) ) ).

% pinf(3)
tff(fact_1097_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),X))
         => ( X != T2 ) ) ) ).

% pinf(4)
tff(fact_1098_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),X))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),T2)) ) ) ).

% pinf(5)
tff(fact_1099_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),T2),X)) ) ) ).

% pinf(7)
tff(fact_1100_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ord(C)
     => ! [F3: D] :
        ? [Z4: C] :
        ! [X: C] :
          ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),Z4),X))
         => ( F3 = F3 ) ) ) ).

% pinf(11)
tff(fact_1101_minf_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool),P3: fun(A,bool),Q: fun(A,bool),Q6: fun(A,bool)] :
          ( ? [Z3: A] :
            ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z3))
             => ( pp(aa(A,bool,P,X2))
              <=> pp(aa(A,bool,P3,X2)) ) )
         => ( ? [Z3: A] :
              ! [X2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z3))
               => ( pp(aa(A,bool,Q,X2))
                <=> pp(aa(A,bool,Q6,X2)) ) )
           => ? [Z4: A] :
              ! [X: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z4))
               => ( ( pp(aa(A,bool,P,X))
                    & pp(aa(A,bool,Q,X)) )
                <=> ( pp(aa(A,bool,P3,X))
                    & pp(aa(A,bool,Q6,X)) ) ) ) ) ) ) ).

% minf(1)
tff(fact_1102_minf_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool),P3: fun(A,bool),Q: fun(A,bool),Q6: fun(A,bool)] :
          ( ? [Z3: A] :
            ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z3))
             => ( pp(aa(A,bool,P,X2))
              <=> pp(aa(A,bool,P3,X2)) ) )
         => ( ? [Z3: A] :
              ! [X2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z3))
               => ( pp(aa(A,bool,Q,X2))
                <=> pp(aa(A,bool,Q6,X2)) ) )
           => ? [Z4: A] :
              ! [X: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z4))
               => ( ( pp(aa(A,bool,P,X))
                    | pp(aa(A,bool,Q,X)) )
                <=> ( pp(aa(A,bool,P3,X))
                    | pp(aa(A,bool,Q6,X)) ) ) ) ) ) ) ).

% minf(2)
tff(fact_1103_minf_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z4))
         => ( X != T2 ) ) ) ).

% minf(3)
tff(fact_1104_minf_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z4))
         => ( X != T2 ) ) ) ).

% minf(4)
tff(fact_1105_minf_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),T2)) ) ) ).

% minf(5)
tff(fact_1106_minf_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z4))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),T2),X)) ) ) ).

% minf(7)
tff(fact_1107_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ord(C)
     => ! [F3: D] :
        ? [Z4: C] :
        ! [X: C] :
          ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),X),Z4))
         => ( F3 = F3 ) ) ) ).

% minf(11)
tff(fact_1108_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),M)),aa(nat,A,power_power(A,A3),N)))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ) ).

% power_le_imp_le_exp
tff(fact_1109_div__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),one_one(A)) ) ) ) ).

% div_add_self1
tff(fact_1110_div__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),one_one(A)) ) ) ) ).

% div_add_self2
tff(fact_1111_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(nat,nat,power_power(nat,N),K))) ) ).

% power_gt_expt
tff(fact_1112_gt__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))),B2)) ) ) ).

% gt_half_sum
tff(fact_1113_less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A))))) ) ) ).

% less_half_sum
tff(fact_1114_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),N)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,A3),N)))) ) ) ).

% power_less_power_Suc
tff(fact_1115_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,A3),N)))) ) ) ).

% power_gt1_lemma
tff(fact_1116_power__0__left,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(nat,A,power_power(A,zero_zero(A)),N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(nat,A,power_power(A,zero_zero(A)),N) = zero_zero(A) ) ) ) ) ).

% power_0_left
tff(fact_1117_div__nat__eqI,axiom,
    ! [N: nat,Q2: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,Q2))))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) = Q2 ) ) ) ).

% div_nat_eqI
tff(fact_1118_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N5: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N5))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,A3),N5))) ) ) ) ).

% power_strict_increasing
tff(fact_1119_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),M)),aa(nat,A,power_power(A,A3),N)))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ) ).

% power_less_imp_less_exp
tff(fact_1120_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),aa(nat,nat,suc,N)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),N),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ).

% unset_bit_Suc
tff(fact_1121_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) = M )
      <=> ( N = one_one(nat) ) ) ) ).

% div_eq_dividend_iff
tff(fact_1122_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),one_one(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),M)) ) ) ).

% div_less_dividend
tff(fact_1123_conj__le__cong,axiom,
    ! [X3: int,X6: int,P: bool,P3: bool] :
      ( ( X3 = X6 )
     => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X6))
         => ( pp(P)
          <=> pp(P3) ) )
       => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
            & pp(P) )
        <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X6))
            & pp(P3) ) ) ) ) ).

% conj_le_cong
tff(fact_1124_imp__le__cong,axiom,
    ! [X3: int,X6: int,P: bool,P3: bool] :
      ( ( X3 = X6 )
     => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X6))
         => ( pp(P)
          <=> pp(P3) ) )
       => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
           => pp(P) )
        <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X6))
           => pp(P3) ) ) ) ) ).

% imp_le_cong
tff(fact_1125_split__mod,axiom,
    ! [P: fun(nat,bool),M: nat,N: nat] :
      ( pp(aa(nat,bool,P,modulo_modulo(nat,M,N)))
    <=> ( ( ( N = zero_zero(nat) )
         => pp(aa(nat,bool,P,M)) )
        & ( ( N != zero_zero(nat) )
         => ! [I2: nat,J4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),N))
             => ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),I2)),J4) )
               => pp(aa(nat,bool,P,J4)) ) ) ) ) ) ).

% split_mod
tff(fact_1126_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
     => ? [N2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
          & ( K = aa(nat,int,semiring_1_of_nat(int),N2) ) ) ) ).

% zero_less_imp_eq_int
tff(fact_1127_pos__int__cases,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
     => ~ ! [N2: nat] :
            ( ( K = aa(nat,int,semiring_1_of_nat(int),N2) )
           => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2)) ) ) ).

% pos_int_cases
tff(fact_1128_numeral__2__eq__2,axiom,
    aa(num,nat,numeral_numeral(nat),bit0(one2)) = aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))) ).

% numeral_2_eq_2
tff(fact_1129_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A] :
          ( ! [Z4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),one_one(A)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z4),X3)),Y4)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ).

% field_le_mult_one_interval
tff(fact_1130_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3)) ) ) ) ) ).

% mult_less_cancel_right2
tff(fact_1131_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),one_one(A))) ) ) ) ) ).

% mult_less_cancel_right1
tff(fact_1132_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3)) ) ) ) ) ).

% mult_less_cancel_left2
tff(fact_1133_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),one_one(A))) ) ) ) ) ).

% mult_less_cancel_left1
tff(fact_1134_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3)) ) ) ) ) ).

% mult_le_cancel_right2
tff(fact_1135_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),one_one(A))) ) ) ) ) ).

% mult_le_cancel_right1
tff(fact_1136_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3)) ) ) ) ) ).

% mult_le_cancel_left2
tff(fact_1137_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),one_one(A))) ) ) ) ) ).

% mult_le_cancel_left1
tff(fact_1138_convex__bound__le,axiom,
    ! [A: $tType] :
      ( linord6961819062388156250ring_1(A)
     => ! [X3: A,A3: A,Y4: A,U: A,V: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),U))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),V))
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y4))),A3)) ) ) ) ) ) ) ).

% convex_bound_le
tff(fact_1139_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% le_divide_eq_1
tff(fact_1140_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),one_one(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            | ( A3 = zero_zero(A) ) ) ) ) ).

% divide_le_eq_1
tff(fact_1141_power__Suc__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,A3),N))),aa(nat,A,power_power(A,A3),N))) ) ) ) ).

% power_Suc_less
tff(fact_1142_split__div_H,axiom,
    ! [P: fun(nat,bool),M: nat,N: nat] :
      ( pp(aa(nat,bool,P,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)))
    <=> ( ( ( N = zero_zero(nat) )
          & pp(aa(nat,bool,P,zero_zero(nat))) )
        | ? [Q4: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q4)),M))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,Q4))))
            & pp(aa(nat,bool,P,Q4)) ) ) ) ).

% split_div'
tff(fact_1143_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N5: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N5))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),N5)),aa(nat,A,power_power(A,A3),N))) ) ) ) ) ).

% power_strict_decreasing
tff(fact_1144_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))))
             => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)))),one_one(A)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ) ) ).

% divmod_digit_1(1)
tff(fact_1145_self__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(nat,A,power_power(A,A3),N))) ) ) ) ).

% self_le_power
tff(fact_1146_one__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,power_power(A,one_one(A)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(A) ) ) ).

% one_power2
tff(fact_1147_one__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(nat,A,power_power(A,A3),N))) ) ) ) ).

% one_less_power
tff(fact_1148_Suc__nat__number__of__add,axiom,
    ! [V: num,N: nat] : ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),one2))),N) ) ).

% Suc_nat_number_of_add
tff(fact_1149_nat__1__add__1,axiom,
    aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),one_one(nat)) = aa(num,nat,numeral_numeral(nat),bit0(one2)) ).

% nat_1_add_1
tff(fact_1150_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2),C2))),modulo_modulo(A,A3,B2)) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
tff(fact_1151_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N))) ) ).

% of_nat_less_two_power
tff(fact_1152_num_Osize_I5_J,axiom,
    ! [X22: num] : ( aa(num,nat,size_size(num),bit0(X22)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,size_size(num),X22)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size(5)
tff(fact_1153_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))))
    <=> ( ( N = zero_zero(nat) )
        | ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% less_2_cases_iff
tff(fact_1154_less__2__cases,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))))
     => ( ( N = zero_zero(nat) )
        | ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% less_2_cases
tff(fact_1155_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( linord715952674999750819strict(A)
     => ! [X3: A,A3: A,Y4: A,U: A,V: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),U))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),V))
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y4))),A3)) ) ) ) ) ) ) ).

% convex_bound_lt
tff(fact_1156_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))),B2))
           => ( modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) = modulo_modulo(A,A3,B2) ) ) ) ) ).

% divmod_digit_0(2)
tff(fact_1157_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))) = A3 )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))) = zero_zero(A) ) ) ) ).

% bits_stable_imp_add_self
tff(fact_1158_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat,M: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A3,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ).

% div_exp_mod_exp_eq
tff(fact_1159_power__odd__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,power_power(A,A3),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,aa(nat,A,power_power(A,A3),N)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% power_odd_eq
tff(fact_1160_nat__bit__induct,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( pp(aa(nat,bool,P,zero_zero(nat)))
     => ( ! [N2: nat] :
            ( pp(aa(nat,bool,P,N2))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
             => pp(aa(nat,bool,P,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N2))) ) )
       => ( ! [N2: nat] :
              ( pp(aa(nat,bool,P,N2))
             => pp(aa(nat,bool,P,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N2)))) )
         => pp(aa(nat,bool,P,N)) ) ) ) ).

% nat_bit_induct
tff(fact_1161_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% Suc_n_div_2_gt_zero
tff(fact_1162_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% div_2_gt_zero
tff(fact_1163_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))),B2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ) ).

% divmod_digit_0(1)
tff(fact_1164_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K))
       => ? [N2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,power_power(nat,B2),N2)),K))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),one_one(nat))))) ) ) ) ).

% ex_power_ivl2
tff(fact_1165_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),K))
       => ? [N2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,B2),N2)),K))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),one_one(nat))))) ) ) ) ).

% ex_power_ivl1
tff(fact_1166_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
            | ( X3 = Y4 ) ) ) ) ).

% order_le_imp_less_or_eq
tff(fact_1167_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ).

% linorder_le_less_linear
tff(fact_1168_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A3: A,B2: A,F2: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,B2)),C2))
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,X2)),aa(A,C,F2,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,A3)),C2)) ) ) ) ) ).

% order_less_le_subst2
tff(fact_1169_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A3: A,F2: fun(B,A),B2: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F2,B2)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F2,C2))) ) ) ) ) ).

% order_less_le_subst1
tff(fact_1170_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A3: A,B2: A,F2: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,B2)),C2))
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,X2)),aa(A,C,F2,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,A3)),C2)) ) ) ) ) ).

% order_le_less_subst2
tff(fact_1171_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A3: A,F2: fun(B,A),B2: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(B,A,F2,B2)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X2)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F2,C2))) ) ) ) ) ).

% order_le_less_subst1
tff(fact_1172_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Z)) ) ) ) ).

% order_less_le_trans
tff(fact_1173_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),Z))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Z)) ) ) ) ).

% order_le_less_trans
tff(fact_1174_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != B2 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% order_neq_le_trans
tff(fact_1175_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( ( A3 != B2 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% order_le_neq_trans
tff(fact_1176_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ).

% order_less_imp_le
tff(fact_1177_linorder__not__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ).

% linorder_not_less
tff(fact_1178_linorder__not__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ).

% linorder_not_le
tff(fact_1179_order__less__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
            & ( X3 != Y4 ) ) ) ) ).

% order_less_le
tff(fact_1180_order__le__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
            | ( X3 = Y4 ) ) ) ) ).

% order_le_less
tff(fact_1181_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% dual_order.strict_implies_order
tff(fact_1182_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% order.strict_implies_order
tff(fact_1183_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% dual_order.strict_iff_not
tff(fact_1184_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% dual_order.strict_trans2
tff(fact_1185_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% dual_order.strict_trans1
tff(fact_1186_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & ( A3 != B2 ) ) ) ) ).

% dual_order.strict_iff_order
tff(fact_1187_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
            | ( A3 = B2 ) ) ) ) ).

% dual_order.order_iff_strict
tff(fact_1188_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( ! [W2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),W2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),W2),Y4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),W2),Z)) ) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z)) ) ) ) ).

% dense_le_bounded
tff(fact_1189_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),X3))
         => ( ! [W2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),W2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),W2),X3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),W2)) ) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z)) ) ) ) ).

% dense_ge_bounded
tff(fact_1190_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% order.strict_iff_not
tff(fact_1191_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% order.strict_trans2
tff(fact_1192_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% order.strict_trans1
tff(fact_1193_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & ( A3 != B2 ) ) ) ) ).

% order.strict_iff_order
tff(fact_1194_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
            | ( A3 = B2 ) ) ) ) ).

% order.order_iff_strict
tff(fact_1195_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y4: A,X3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) ) ) ).

% not_le_imp_less
tff(fact_1196_less__le__not__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ) ).

% less_le_not_le
tff(fact_1197_dense__le,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Y4: A,Z: A] :
          ( ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z)) ) ) ).

% dense_le
tff(fact_1198_dense__ge,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z: A,Y4: A] :
          ( ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),X2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X2)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z)) ) ) ).

% dense_ge
tff(fact_1199_antisym__conv2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
          <=> ( X3 = Y4 ) ) ) ) ).

% antisym_conv2
tff(fact_1200_antisym__conv1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
          <=> ( X3 = Y4 ) ) ) ) ).

% antisym_conv1
tff(fact_1201_nless__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            | ( A3 = B2 ) ) ) ) ).

% nless_le
tff(fact_1202_leI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ).

% leI
tff(fact_1203_leD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) ) ) ).

% leD
tff(fact_1204_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),X))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),T2)) ) ) ).

% pinf(6)
tff(fact_1205_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z4),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),T2),X)) ) ) ).

% pinf(8)
tff(fact_1206_minf_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),T2)) ) ) ).

% minf(6)
tff(fact_1207_minf_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z4))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),T2),X)) ) ) ).

% minf(8)
tff(fact_1208_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) != aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) = zero_zero(nat) ) ) ).

% not_mod2_eq_Suc_0_eq_0
tff(fact_1209_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) != one_one(A) )
        <=> ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ) ).

% not_mod_2_eq_1_eq_0
tff(fact_1210_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) != zero_zero(A) )
        <=> ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ) ).

% not_mod_2_eq_0_eq_1
tff(fact_1211_nat__induct2,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( pp(aa(nat,bool,P,zero_zero(nat)))
     => ( pp(aa(nat,bool,P,one_one(nat)))
       => ( ! [N2: nat] :
              ( pp(aa(nat,bool,P,N2))
             => pp(aa(nat,bool,P,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
         => pp(aa(nat,bool,P,N)) ) ) ) ).

% nat_induct2
tff(fact_1212_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [E: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),E))
         => ~ ! [N2: nat] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N2)))),E)) ) ) ).

% nat_approx_posE
tff(fact_1213_set__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),zero_zero(nat)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% set_bit_0
tff(fact_1214_double__not__eq__Suc__double,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M) != aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% double_not_eq_Suc_double
tff(fact_1215_Suc__double__not__eq__double,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)) != aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% Suc_double_not_eq_double
tff(fact_1216_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),aa(nat,nat,suc,N)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),N),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ).

% set_bit_Suc
tff(fact_1217_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se8732182000553998342ip_bit(A,aa(nat,nat,suc,N),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se8732182000553998342ip_bit(A,N,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ).

% flip_bit_Suc
tff(fact_1218_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),N),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) ) ).

% set_bit_nonnegative_int_iff
tff(fact_1219_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),bit_se8732182000553998342ip_bit(int,N,K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) ) ).

% flip_bit_nonnegative_int_iff
tff(fact_1220_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),N),K)),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int))) ) ).

% set_bit_negative_int_iff
tff(fact_1221_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),bit_se8732182000553998342ip_bit(int,N,K)),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int))) ) ).

% flip_bit_negative_int_iff
tff(fact_1222_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),one_one(int))))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),W),Z)) ) ).

% zle_add1_eq_le
tff(fact_1223_int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = aa(nat,int,semiring_1_of_nat(int),N) )
    <=> ( M = N ) ) ).

% int_int_eq
tff(fact_1224_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less(fun(A,B)),F2),G))
        <=> ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G))
            & ~ pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),G),F2)) ) ) ) ).

% less_fun_def
tff(fact_1225_nat__int__comparison_I1_J,axiom,
    ! [A3: nat,B2: nat] :
      ( ( A3 = B2 )
    <=> ( aa(nat,int,semiring_1_of_nat(int),A3) = aa(nat,int,semiring_1_of_nat(int),B2) ) ) ).

% nat_int_comparison(1)
tff(fact_1226_int__if,axiom,
    ! [P: bool,A3: nat,B2: nat] :
      ( ( pp(P)
       => ( aa(nat,int,semiring_1_of_nat(int),if(nat,P,A3,B2)) = aa(nat,int,semiring_1_of_nat(int),A3) ) )
      & ( ~ pp(P)
       => ( aa(nat,int,semiring_1_of_nat(int),if(nat,P,A3,B2)) = aa(nat,int,semiring_1_of_nat(int),B2) ) ) ) ).

% int_if
tff(fact_1227_int__ops_I2_J,axiom,
    aa(nat,int,semiring_1_of_nat(int),one_one(nat)) = one_one(int) ).

% int_ops(2)
tff(fact_1228_zero__one__enat__neq_I1_J,axiom,
    zero_zero(extended_enat) != one_one(extended_enat) ).

% zero_one_enat_neq(1)
tff(fact_1229_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),N),K))) ).

% set_bit_greater_eq
tff(fact_1230_int__Suc,axiom,
    ! [N: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),one_one(int)) ) ).

% int_Suc
tff(fact_1231_int__ops_I4_J,axiom,
    ! [A3: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,A3)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A3)),one_one(int)) ) ).

% int_ops(4)
tff(fact_1232_real__arch__pow,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => ? [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(nat,real,power_power(real,X3),N2))) ) ).

% real_arch_pow
tff(fact_1233_odd__nonzero,axiom,
    ! [Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)),Z) != zero_zero(int) ) ).

% odd_nonzero
tff(fact_1234_int__ge__induct,axiom,
    ! [K: int,I: int,P: fun(int,bool)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),I))
     => ( pp(aa(int,bool,P,K))
       => ( ! [I3: int] :
              ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),I3))
             => ( pp(aa(int,bool,P,I3))
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)))) ) )
         => pp(aa(int,bool,P,I)) ) ) ) ).

% int_ge_induct
tff(fact_1235_int__gr__induct,axiom,
    ! [K: int,I: int,P: fun(int,bool)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),I))
     => ( pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))))
       => ( ! [I3: int] :
              ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),I3))
             => ( pp(aa(int,bool,P,I3))
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)))) ) )
         => pp(aa(int,bool,P,I)) ) ) ) ).

% int_gr_induct
tff(fact_1236_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),one_one(int))))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z))
        | ( W = Z ) ) ) ).

% zless_add1_eq
tff(fact_1237_one__enat__def,axiom,
    one_one(extended_enat) = extended_enat2(one_one(nat)) ).

% one_enat_def
tff(fact_1238_enat__1__iff_I1_J,axiom,
    ! [X3: nat] :
      ( ( extended_enat2(X3) = one_one(extended_enat) )
    <=> ( X3 = one_one(nat) ) ) ).

% enat_1_iff(1)
tff(fact_1239_enat__1__iff_I2_J,axiom,
    ! [X3: nat] :
      ( ( one_one(extended_enat) = extended_enat2(X3) )
    <=> ( X3 = one_one(nat) ) ) ).

% enat_1_iff(2)
tff(fact_1240_real__arch__pow__inv,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => ? [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,power_power(real,X3),N2)),Y4)) ) ) ).

% real_arch_pow_inv
tff(fact_1241_nat__less__real__le,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),N)),one_one(real))),aa(nat,real,semiring_1_of_nat(real),M))) ) ).

% nat_less_real_le
tff(fact_1242_nat__le__real__less,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),M)),one_one(real)))) ) ).

% nat_le_real_less
tff(fact_1243_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),one_one(int)),Z))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Z)) ) ).

% int_one_le_iff_zero_less
tff(fact_1244_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),M))
     => ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),N) = one_one(int) )
      <=> ( ( M = one_one(int) )
          & ( N = one_one(int) ) ) ) ) ).

% pos_zmult_eq_1_iff
tff(fact_1245_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)),Z)),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z),zero_zero(int))) ) ).

% odd_less_0_iff
tff(fact_1246_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),one_one(int))),Z))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z)) ) ).

% add1_zle_eq
tff(fact_1247_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),one_one(int))),Z)) ) ).

% zless_imp_add1_zle
tff(fact_1248_int__div__less__self,axiom,
    ! [X3: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),X3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),K))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X3),K)),X3)) ) ) ).

% int_div_less_self
tff(fact_1249_le__imp__0__less,axiom,
    ! [Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z))) ) ).

% le_imp_0_less
tff(fact_1250_two__realpow__ge__one,axiom,
    ! [N: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),bit0(one2))),N))) ).

% two_realpow_ge_one
tff(fact_1251_verit__le__mono__div__int,axiom,
    ! [A2: int,B3: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A2),B3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),N)),if(int,aa(int,bool,aa(int,fun(int,bool),fequal(int),modulo_modulo(int,B3,N)),zero_zero(int)),one_one(int),zero_zero(int)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),B3),N))) ) ) ).

% verit_le_mono_div_int
tff(fact_1252_real__arch__simple,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
        ? [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(nat,A,semiring_1_of_nat(A),N2))) ) ).

% real_arch_simple
tff(fact_1253_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
        ? [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(nat,A,semiring_1_of_nat(A),N2))) ) ).

% reals_Archimedean2
tff(fact_1254_exists__least__lemma,axiom,
    ! [P: fun(nat,bool)] :
      ( ~ pp(aa(nat,bool,P,zero_zero(nat)))
     => ( ? [X_1: nat] : pp(aa(nat,bool,P,X_1))
       => ? [N2: nat] :
            ( ~ pp(aa(nat,bool,P,N2))
            & pp(aa(nat,bool,P,aa(nat,nat,suc,N2))) ) ) ) ).

% exists_least_lemma
tff(fact_1255_pos__zmod__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),A3))
     => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A3)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),modulo_modulo(int,B2,A3))) ) ) ).

% pos_zmod_mult_2
tff(fact_1256_pos__zdiv__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),A3))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A3)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),B2),A3) ) ) ).

% pos_zdiv_mult_2
tff(fact_1257_neg__zdiv__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),zero_zero(int)))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A3)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),B2),one_one(int))),A3) ) ) ).

% neg_zdiv_mult_2
tff(fact_1258_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => ? [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N2)),X3))) ) ) ).

% ex_less_of_nat_mult
tff(fact_1259_linear__plus__1__le__power,axiom,
    ! [X3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),X3)),one_one(real))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),one_one(real))),N))) ) ).

% linear_plus_1_le_power
tff(fact_1260_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList: list(vEBT_VEBT),N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
         => vEBT_invar_vebt(X2,N) )
     => ( vEBT_invar_vebt(Summary,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
         => ( ( M = aa(nat,nat,suc,N) )
           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M) )
             => ( ~ ? [X_13: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary),X_13))
               => ( ! [X2: vEBT_VEBT] :
                      ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
                     => ~ ? [X_13: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X2),X_13)) )
                 => vEBT_invar_vebt(vEBT_Node(none(product_prod(nat,nat)),Deg,TreeList,Summary),Deg) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
tff(fact_1261_pochhammer__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z: A,N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Z),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),comm_s3205402744901411588hammer(A,Z,N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2)))),N)) ) ) ).

% pochhammer_double
tff(fact_1262_gcd__nat__induct,axiom,
    ! [P: fun(nat,fun(nat,bool)),M: nat,N: nat] :
      ( ! [M3: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),P,M3),zero_zero(nat)))
     => ( ! [M3: nat,N2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),P,N2),modulo_modulo(nat,M3,N2)))
             => pp(aa(nat,bool,aa(nat,fun(nat,bool),P,M3),N2)) ) )
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),P,M),N)) ) ) ).

% gcd_nat_induct
tff(fact_1263_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList: list(vEBT_VEBT),N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
         => vEBT_invar_vebt(X2,N) )
     => ( vEBT_invar_vebt(Summary,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
         => ( ( M = N )
           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M) )
             => ( ~ ? [X_13: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary),X_13))
               => ( ! [X2: vEBT_VEBT] :
                      ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
                     => ~ ? [X_13: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X2),X_13)) )
                 => vEBT_invar_vebt(vEBT_Node(none(product_prod(nat,nat)),Deg,TreeList,Summary),Deg) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
tff(fact_1264_concat__bit__Suc,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(aa(nat,nat,suc,N),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,bit_concat_bit(N,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),L))) ) ).

% concat_bit_Suc
tff(fact_1265_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,one_one(A)) = aa(num,A,numeral_numeral(A),bit0(one2)) ) ) ).

% dbl_simps(3)
tff(fact_1266_VEBT_Oinject_I2_J,axiom,
    ! [X21: bool,X222: bool,Y21: bool,Y222: bool] :
      ( ( vEBT_Leaf(X21,X222) = vEBT_Leaf(Y21,Y222) )
    <=> ( ( pp(X21)
        <=> pp(Y21) )
        & ( pp(X222)
        <=> pp(Y222) ) ) ) ).

% VEBT.inject(2)
tff(fact_1267_pochhammer__1,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A] : ( comm_s3205402744901411588hammer(A,A3,one_one(nat)) = A3 ) ) ).

% pochhammer_1
tff(fact_1268_concat__bit__0,axiom,
    ! [K: int,L: int] : ( aa(int,int,bit_concat_bit(zero_zero(nat),K),L) = L ) ).

% concat_bit_0
tff(fact_1269_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,zero_zero(A)) = zero_zero(A) ) ) ).

% dbl_simps(2)
tff(fact_1270_pochhammer__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A] : ( comm_s3205402744901411588hammer(A,A3,zero_zero(nat)) = one_one(A) ) ) ).

% pochhammer_0
tff(fact_1271_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A] : ( comm_s3205402744901411588hammer(A,A3,aa(nat,nat,suc,zero_zero(nat))) = A3 ) ) ).

% pochhammer_Suc0
tff(fact_1272_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_concat_bit(N,K),L)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),L)) ) ).

% concat_bit_nonnegative_iff
tff(fact_1273_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_concat_bit(N,K),L)),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int))) ) ).

% concat_bit_negative_iff
tff(fact_1274_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),bit0(K)) ) ) ).

% dbl_simps(5)
tff(fact_1275_pochhammer__of__nat,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X3: nat,N: nat] : ( comm_s3205402744901411588hammer(A,aa(nat,A,semiring_1_of_nat(A),X3),N) = aa(nat,A,semiring_1_of_nat(A),comm_s3205402744901411588hammer(nat,X3,N)) ) ) ).

% pochhammer_of_nat
tff(fact_1276_VEBT_Osize_I4_J,axiom,
    ! [X21: bool,X222: bool] : ( aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),vEBT_Leaf(X21,X222)) = zero_zero(nat) ) ).

% VEBT.size(4)
tff(fact_1277_VEBT_Oexhaust,axiom,
    ! [Y4: vEBT_VEBT] :
      ( ! [X112: option(product_prod(nat,nat)),X122: nat,X132: list(vEBT_VEBT),X142: vEBT_VEBT] : ( Y4 != vEBT_Node(X112,X122,X132,X142) )
     => ~ ! [X212: bool,X223: bool] : ( Y4 != vEBT_Leaf(X212,X223) ) ) ).

% VEBT.exhaust
tff(fact_1278_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT,X21: bool,X222: bool] : ( vEBT_Node(X11,X12,X13,X14) != vEBT_Leaf(X21,X222) ) ).

% VEBT.distinct(1)
tff(fact_1279_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: bool,Uv: bool,Uw: nat] : ~ vEBT_VEBT_membermima(vEBT_Leaf(Uu,Uv),Uw) ).

% VEBT_internal.membermima.simps(1)
tff(fact_1280_VEBT__internal_Oelim__dead_Osimps_I1_J,axiom,
    ! [A3: bool,B2: bool,Uu: extended_enat] : ( vEBT_VEBT_elim_dead(vEBT_Leaf(A3,B2),Uu) = vEBT_Leaf(A3,B2) ) ).

% VEBT_internal.elim_dead.simps(1)
tff(fact_1281_concat__bit__assoc,axiom,
    ! [N: nat,K: int,M: nat,L: int,R2: int] : ( aa(int,int,bit_concat_bit(N,K),aa(int,int,bit_concat_bit(M,L),R2)) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N),aa(int,int,bit_concat_bit(N,K),L)),R2) ) ).

% concat_bit_assoc
tff(fact_1282_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),comm_s3205402744901411588hammer(A,X3,N))) ) ) ).

% pochhammer_pos
tff(fact_1283_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,M: nat,N: nat] :
          ( ( comm_s3205402744901411588hammer(A,A3,M) != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( comm_s3205402744901411588hammer(A,A3,N) != zero_zero(A) ) ) ) ) ).

% pochhammer_neq_0_mono
tff(fact_1284_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer(A,A3,N) = zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( comm_s3205402744901411588hammer(A,A3,M) = zero_zero(A) ) ) ) ) ).

% pochhammer_eq_0_mono
tff(fact_1285_dbl__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X3: A] : ( neg_numeral_dbl(A,X3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),X3) ) ) ).

% dbl_def
tff(fact_1286_vebt__buildup_Osimps_I1_J,axiom,
    vEBT_vebt_buildup(zero_zero(nat)) = vEBT_Leaf(fFalse,fFalse) ).

% vebt_buildup.simps(1)
tff(fact_1287_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: bool,Uv: bool,D2: nat] :
      ( vEBT_VEBT_valid(vEBT_Leaf(Uu,Uv),D2)
    <=> ( D2 = one_one(nat) ) ) ).

% VEBT_internal.valid'.simps(1)
tff(fact_1288_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),comm_s3205402744901411588hammer(A,X3,N))) ) ) ).

% pochhammer_nonneg
tff(fact_1289_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,zero_zero(A),N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,zero_zero(A),N) = zero_zero(A) ) ) ) ) ).

% pochhammer_0_left
tff(fact_1290_invar__vebt_Ointros_I1_J,axiom,
    ! [A3: bool,B2: bool] : vEBT_invar_vebt(vEBT_Leaf(A3,B2),aa(nat,nat,suc,zero_zero(nat))) ).

% invar_vebt.intros(1)
tff(fact_1291_vebt__buildup_Osimps_I2_J,axiom,
    vEBT_vebt_buildup(aa(nat,nat,suc,zero_zero(nat))) = vEBT_Leaf(fFalse,fFalse) ).

% vebt_buildup.simps(2)
tff(fact_1292_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A3: bool,B2: bool,X3: nat] :
      ( vEBT_V5719532721284313246member(vEBT_Leaf(A3,B2),X3)
    <=> ( ( ( X3 = zero_zero(nat) )
         => pp(A3) )
        & ( ( X3 != zero_zero(nat) )
         => ( ( ( X3 = one_one(nat) )
             => pp(B2) )
            & ( X3 = one_one(nat) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
tff(fact_1293_bounded__Max__nat,axiom,
    ! [P: fun(nat,bool),X3: nat,M7: nat] :
      ( pp(aa(nat,bool,P,X3))
     => ( ! [X2: nat] :
            ( pp(aa(nat,bool,P,X2))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X2),M7)) )
       => ~ ! [M3: nat] :
              ( pp(aa(nat,bool,P,M3))
             => ~ ! [X: nat] :
                    ( pp(aa(nat,bool,P,X))
                   => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X),M3)) ) ) ) ) ).

% bounded_Max_nat
tff(fact_1294_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list(vEBT_VEBT),Uy: vEBT_VEBT,Uz: nat] : ~ vEBT_VEBT_membermima(vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux,Uy),Uz) ).

% VEBT_internal.membermima.simps(2)
tff(fact_1295_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat] : ( comm_s3205402744901411588hammer(A,A3,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)),N)) ) ) ).

% pochhammer_rec
tff(fact_1296_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat] : ( comm_s3205402744901411588hammer(A,A3,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,A3,N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(nat,A,semiring_1_of_nat(A),N))) ) ) ).

% pochhammer_Suc
tff(fact_1297_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z: A,N: nat] : ( comm_s3205402744901411588hammer(A,Z,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),N))),comm_s3205402744901411588hammer(A,Z,N)) ) ) ).

% pochhammer_rec'
tff(fact_1298_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z: A,N: nat,M: nat] : ( comm_s3205402744901411588hammer(A,Z,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,N)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),N)),M)) ) ) ).

% pochhammer_product'
tff(fact_1299_Euclid__induct,axiom,
    ! [P: fun(nat,fun(nat,bool)),A3: nat,B2: nat] :
      ( ! [A5: nat,B5: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),P,A5),B5))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),P,B5),A5)) )
     => ( ! [A5: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),P,A5),zero_zero(nat)))
       => ( ! [A5: nat,B5: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),P,A5),B5))
             => pp(aa(nat,bool,aa(nat,fun(nat,bool),P,A5),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A5),B5))) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),P,A3),B2)) ) ) ) ).

% Euclid_induct
tff(fact_1300_option_Osize_I3_J,axiom,
    ! [A: $tType] : ( aa(option(A),nat,size_size(option(A)),none(A)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size(3)
tff(fact_1301_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: fun(A,bool),K: A,F2: fun(A,nat),N: nat] :
      ( pp(aa(A,bool,P,K))
     => ( ! [X2: A] :
            ( pp(aa(A,bool,P,X2))
           => ? [Y5: A] :
                ( pp(aa(A,bool,P,Y5))
                & ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,F2,Y5)),aa(A,nat,F2,X2))) ) )
       => ? [Y2: A] :
            ( pp(aa(A,bool,P,Y2))
            & ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F2,Y2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F2,K)),N))) ) ) ) ).

% ex_has_greatest_nat_lemma
tff(fact_1302_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),modulo_modulo(A,A3,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N))) ) ) ) ) ).

% even_succ_mod_exp
tff(fact_1303_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ) ) ).

% even_succ_div_exp
tff(fact_1304_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,N)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,N),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ).

% signed_take_bit_Suc
tff(fact_1305_fact__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))),N))),semiring_char_0_fact(A,N)) ) ) ).

% fact_double
tff(fact_1306_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),one_one(nat)))
    <=> ( M = one_one(nat) ) ) ).

% nat_dvd_1_iff_1
tff(fact_1307_int__dvd__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N)) ) ).

% int_dvd_int_iff
tff(fact_1308_dvd__0__right,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),zero_zero(A))) ) ).

% dvd_0_right
tff(fact_1309_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),zero_zero(A)),A3))
        <=> ( A3 = zero_zero(A) ) ) ) ).

% dvd_0_left_iff
tff(fact_1310_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ).

% dvd_add_triv_left_iff
tff(fact_1311_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ).

% dvd_add_triv_right_iff
tff(fact_1312_dvd__1__left,axiom,
    ! [K: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(nat,nat,suc,zero_zero(nat))),K)) ).

% dvd_1_left
tff(fact_1313_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),aa(nat,nat,suc,zero_zero(nat))))
    <=> ( M = aa(nat,nat,suc,zero_zero(nat)) ) ) ).

% dvd_1_iff_1
tff(fact_1314_div__dvd__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),C2)) ) ) ) ) ).

% div_dvd_div
tff(fact_1315_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)))
    <=> ( ( K = zero_zero(nat) )
        | pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N)) ) ) ).

% nat_mult_dvd_cancel_disj
tff(fact_1316_of__nat__fact,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),semiring_char_0_fact(nat,N)) = semiring_char_0_fact(A,N) ) ) ).

% of_nat_fact
tff(fact_1317_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),zero_zero(A)) = zero_zero(A) ) ) ).

% signed_take_bit_of_0
tff(fact_1318_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),C2)) ) ) ) ).

% dvd_times_right_cancel_iff
tff(fact_1319_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),C2)) ) ) ) ).

% dvd_times_left_cancel_iff
tff(fact_1320_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( C2 = zero_zero(A) )
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ) ).

% dvd_mult_cancel_right
tff(fact_1321_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( C2 = zero_zero(A) )
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ) ).

% dvd_mult_cancel_left
tff(fact_1322_unit__prod,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),one_one(A))) ) ) ) ).

% unit_prod
tff(fact_1323_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ).

% dvd_add_times_triv_left_iff
tff(fact_1324_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ).

% dvd_add_times_triv_right_iff
tff(fact_1325_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)) = B2 ) ) ) ).

% dvd_mult_div_cancel
tff(fact_1326_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),A3) = B2 ) ) ) ).

% dvd_div_mult_self
tff(fact_1327_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3)) = A3 ) ) ) ).

% unit_div_1_div_1
tff(fact_1328_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3)),one_one(A))) ) ) ).

% unit_div_1_unit
tff(fact_1329_unit__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),one_one(A))) ) ) ) ).

% unit_div
tff(fact_1330_div__add,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ) ).

% div_add
tff(fact_1331_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( modulo_modulo(A,B2,A3) = zero_zero(A) ) ) ) ).

% dvd_imp_mod_0
tff(fact_1332_fact__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,zero_zero(nat)) = one_one(A) ) ) ).

% fact_0
tff(fact_1333_fact__1,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,one_one(nat)) = one_one(A) ) ) ).

% fact_1
tff(fact_1334_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,N)),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_Suc_1
tff(fact_1335_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(num,nat,numeral_numeral(nat),K)),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_numeral_of_1
tff(fact_1336_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),A3) = B2 ) ) ) ).

% unit_div_mult_self
tff(fact_1337_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3) ) ) ) ).

% unit_mult_div_div
tff(fact_1338_even__Suc,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N)))
    <=> ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% even_Suc
tff(fact_1339_even__Suc__Suc__iff,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,suc,N))))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% even_Suc_Suc_iff
tff(fact_1340_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [N: nat,A3: A,B2: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ) ).

% pow_divides_pow_iff
tff(fact_1341_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% fact_Suc_0
tff(fact_1342_fact__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N))),semiring_char_0_fact(A,N)) ) ) ).

% fact_Suc
tff(fact_1343_even__mult__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) ) ) ) ).

% even_mult_iff
tff(fact_1344_odd__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A,B2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)))
        <=> ~ ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) ) ) ) ).

% odd_add
tff(fact_1345_even__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) ) ) ) ).

% even_add
tff(fact_1346_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ).

% even_mod_2_iff
tff(fact_1347_odd__Suc__div__two,axiom,
    ! [N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% odd_Suc_div_two
tff(fact_1348_even__Suc__div__two,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% even_Suc_div_two
tff(fact_1349_fact__2,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(num,A,numeral_numeral(A),bit0(one2)) ) ) ).

% fact_2
tff(fact_1350_signed__take__bit__Suc__bit0,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,N)),aa(num,int,numeral_numeral(int),bit0(K))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% signed_take_bit_Suc_bit0
tff(fact_1351_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),W))))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W)))
            | ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ) ) ).

% zero_le_power_eq_numeral
tff(fact_1352_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),N)),zero_zero(A)))
        <=> ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ).

% power_less_zero_eq
tff(fact_1353_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),W))),zero_zero(A)))
        <=> ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ).

% power_less_zero_eq_numeral
tff(fact_1354_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ).

% even_plus_one_iff
tff(fact_1355_even__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,semiring_1_of_nat(A),N)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ) ).

% even_of_nat
tff(fact_1356_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),W))))
        <=> ( ( aa(num,nat,numeral_numeral(nat),W) = zero_zero(nat) )
            | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W)))
              & ( A3 != zero_zero(A) ) )
            | ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ) ) ).

% zero_less_power_eq_numeral
tff(fact_1357_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))),one_one(A)) ) ) ) ).

% odd_succ_div_two
tff(fact_1358_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ) ).

% even_succ_div_two
tff(fact_1359_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3)),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ) ).

% even_succ_div_2
tff(fact_1360_even__power,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,power_power(A,A3),N)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ) ).

% even_power
tff(fact_1361_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))))),one_one(A)) = A3 ) ) ) ).

% odd_two_times_div_two_succ
tff(fact_1362_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),W))),zero_zero(A)))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(num,nat,numeral_numeral(nat),W)))
            & ( ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W)))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) )
              | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W)))
                & ( A3 = zero_zero(A) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
tff(fact_1363_dvd__trans,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2)) ) ) ) ).

% dvd_trans
tff(fact_1364_dvd__refl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),A3)) ) ).

% dvd_refl
tff(fact_1365_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N)) ) ) ).

% of_nat_dvd_iff
tff(fact_1366_fact__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,M: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),semiring_char_0_fact(A,N)),semiring_char_0_fact(A,M))) ) ) ).

% fact_dvd
tff(fact_1367_dvd__fact,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),semiring_char_0_fact(nat,N))) ) ) ).

% dvd_fact
tff(fact_1368_fact__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),semiring_char_0_fact(nat,M)),semiring_char_0_fact(nat,N))) ) ).

% fact_mono_nat
tff(fact_1369_fact__ge__self,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),semiring_char_0_fact(nat,N))) ).

% fact_ge_self
tff(fact_1370_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
        <=> ( ( A3 = zero_zero(A) )
           => ( B2 = zero_zero(A) ) ) ) ) ).

% dvd_field_iff
tff(fact_1371_dvd__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),zero_zero(A)),A3))
         => ( A3 = zero_zero(A) ) ) ) ).

% dvd_0_left
tff(fact_1372_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semiri3467727345109120633visors(A) )
     => ! [N: nat] : ( semiring_char_0_fact(A,N) != zero_zero(A) ) ) ).

% fact_nonzero
tff(fact_1373_dvdE,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
         => ~ ! [K2: A] : ( A3 != aa(A,A,aa(A,fun(A,A),times_times(A),B2),K2) ) ) ) ).

% dvdE
tff(fact_1374_dvdI,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [A3: A,B2: A,K: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3)) ) ) ).

% dvdI
tff(fact_1375_dvd__def,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
        <=> ? [K3: A] : ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K3) ) ) ) ).

% dvd_def
tff(fact_1376_dvd__mult,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ).

% dvd_mult
tff(fact_1377_dvd__mult2,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ).

% dvd_mult2
tff(fact_1378_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2)) ) ) ).

% dvd_mult_left
tff(fact_1379_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ).

% dvd_triv_left
tff(fact_1380_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ).

% mult_dvd_mono
tff(fact_1381_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),C2)) ) ) ).

% dvd_mult_right
tff(fact_1382_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3))) ) ).

% dvd_triv_right
tff(fact_1383_division__decomp,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
         => ? [B6: A,C5: A] :
              ( ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),B6),C5) )
              & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B6),B2))
              & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C5),C2)) ) ) ) ).

% division_decomp
tff(fact_1384_dvd__productE,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [P2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
         => ~ ! [X2: A,Y2: A] :
                ( ( P2 = aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2) )
               => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),A3))
                 => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Y2),B2)) ) ) ) ) ).

% dvd_productE
tff(fact_1385_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A))) ) ) ) ).

% dvd_unit_imp_unit
tff(fact_1386_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3)) ) ) ).

% unit_imp_dvd
tff(fact_1387_one__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),one_one(A)),A3)) ) ).

% one_dvd
tff(fact_1388_dvd__add,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))) ) ) ) ).

% dvd_add
tff(fact_1389_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ) ).

% dvd_add_left_iff
tff(fact_1390_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2)) ) ) ) ).

% dvd_add_right_iff
tff(fact_1391_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
            <=> ( A3 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
tff(fact_1392_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
             => ( A3 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
tff(fact_1393_div__div__div__same,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [D2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D2),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),D2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),D2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ) ).

% div_div_div_same
tff(fact_1394_dvd__power__same,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X3: A,Y4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),Y4))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,X3),N)),aa(nat,A,power_power(A,Y4),N))) ) ) ).

% dvd_power_same
tff(fact_1395_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),zero_zero(nat)),A3))
     => ( A3 = zero_zero(nat) ) ) ).

% gcd_nat.extremum_uniqueI
tff(fact_1396_gcd__nat_Onot__eq__extremum,axiom,
    ! [A3: nat] :
      ( ( A3 != zero_zero(nat) )
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),A3),zero_zero(nat)))
        & ( A3 != zero_zero(nat) ) ) ) ).

% gcd_nat.not_eq_extremum
tff(fact_1397_gcd__nat_Oextremum__unique,axiom,
    ! [A3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),zero_zero(nat)),A3))
    <=> ( A3 = zero_zero(nat) ) ) ).

% gcd_nat.extremum_unique
tff(fact_1398_gcd__nat_Oextremum__strict,axiom,
    ! [A3: nat] :
      ~ ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),zero_zero(nat)),A3))
        & ( zero_zero(nat) != A3 ) ) ).

% gcd_nat.extremum_strict
tff(fact_1399_gcd__nat_Oextremum,axiom,
    ! [A3: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),A3),zero_zero(nat))) ).

% gcd_nat.extremum
tff(fact_1400_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
         => ( modulo_modulo(A,modulo_modulo(A,A3,B2),C2) = modulo_modulo(A,A3,C2) ) ) ) ).

% mod_mod_cancel
tff(fact_1401_dvd__mod,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [K: A,M: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),K),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),K),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),K),modulo_modulo(A,M,N))) ) ) ) ).

% dvd_mod
tff(fact_1402_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),modulo_modulo(A,A3,B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A3)) ) ) ) ).

% dvd_mod_imp_dvd
tff(fact_1403_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),modulo_modulo(A,A3,B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A3)) ) ) ) ).

% dvd_mod_iff
tff(fact_1404_signed__take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),times_times(int),K),L)) ) ).

% signed_take_bit_mult
tff(fact_1405_signed__take__bit__add,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% signed_take_bit_add
tff(fact_1406_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,M),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ).

% even_signed_take_bit_iff
tff(fact_1407_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),semiring_char_0_fact(nat,M)),semiring_char_0_fact(nat,N))) ) ) ).

% fact_less_mono_nat
tff(fact_1408_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),zero_zero(A)),one_one(A))) ) ).

% not_is_unit_0
tff(fact_1409_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),semiring_char_0_fact(A,N))) ) ).

% fact_ge_zero
tff(fact_1410_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( plus(B)
        & linorder(B)
        & dvd(B) )
     => ! [D2: B,S: B] :
        ? [Z4: B] :
        ! [X: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),Z4),X))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),dvd_dvd(B),D2),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),S)))
          <=> pp(aa(B,bool,aa(B,fun(B,bool),dvd_dvd(B),D2),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),S))) ) ) ) ).

% pinf(9)
tff(fact_1411_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( plus(B)
        & linorder(B)
        & dvd(B) )
     => ! [D2: B,S: B] :
        ? [Z4: B] :
        ! [X: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),Z4),X))
         => ( ~ pp(aa(B,bool,aa(B,fun(B,bool),dvd_dvd(B),D2),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),S)))
          <=> ~ pp(aa(B,bool,aa(B,fun(B,bool),dvd_dvd(B),D2),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),S))) ) ) ) ).

% pinf(10)
tff(fact_1412_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( plus(B)
        & linorder(B)
        & dvd(B) )
     => ! [D2: B,S: B] :
        ? [Z4: B] :
        ! [X: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X),Z4))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),dvd_dvd(B),D2),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),S)))
          <=> pp(aa(B,bool,aa(B,fun(B,bool),dvd_dvd(B),D2),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),S))) ) ) ) ).

% minf(9)
tff(fact_1413_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( plus(B)
        & linorder(B)
        & dvd(B) )
     => ! [D2: B,S: B] :
        ? [Z4: B] :
        ! [X: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X),Z4))
         => ( ~ pp(aa(B,bool,aa(B,fun(B,bool),dvd_dvd(B),D2),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),S)))
          <=> ~ pp(aa(B,bool,aa(B,fun(B,bool),dvd_dvd(B),D2),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),S))) ) ) ) ).

% minf(10)
tff(fact_1414_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),semiring_char_0_fact(A,N))) ) ).

% fact_gt_zero
tff(fact_1415_fact__not__neg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),semiring_char_0_fact(A,N)),zero_zero(A))) ) ).

% fact_not_neg
tff(fact_1416_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = zero_zero(A) )
          <=> ( A3 = zero_zero(A) ) ) ) ) ).

% dvd_div_eq_0_iff
tff(fact_1417_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A))) ) ) ) ).

% is_unit_mult_iff
tff(fact_1418_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2)) ) ) ) ).

% dvd_mult_unit_iff
tff(fact_1419_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2)) ) ) ) ).

% mult_unit_dvd_iff
tff(fact_1420_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2)) ) ) ) ).

% dvd_mult_unit_iff'
tff(fact_1421_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),C2)) ) ) ) ).

% mult_unit_dvd_iff'
tff(fact_1422_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
tff(fact_1423_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
tff(fact_1424_fact__ge__1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),semiring_char_0_fact(A,N))) ) ).

% fact_ge_1
tff(fact_1425_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,D2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D2),C2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),D2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ).

% div_mult_div_if_dvd
tff(fact_1426_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))) ) ) ).

% dvd_mult_imp_div
tff(fact_1427_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A3))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2) ) ) ) ).

% dvd_div_mult2_eq
tff(fact_1428_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2) ) ) ) ) ).

% div_div_eq_right
tff(fact_1429_div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) ) ) ) ).

% div_mult_swap
tff(fact_1430_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),C2) ) ) ) ).

% dvd_div_mult
tff(fact_1431_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2)) ) ) ) ).

% dvd_div_unit_iff
tff(fact_1432_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),C2)) ) ) ) ).

% div_unit_dvd_iff
tff(fact_1433_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
tff(fact_1434_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% div_plus_div_distrib_dvd_right
tff(fact_1435_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A3))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% div_plus_div_distrib_dvd_left
tff(fact_1436_div__power,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
         => ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),N) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N)) ) ) ) ).

% div_power
tff(fact_1437_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo(A,A3,B2) = zero_zero(A) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3)) ) ) ).

% mod_0_imp_dvd
tff(fact_1438_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
        <=> ( modulo_modulo(A,B2,A3) = zero_zero(A) ) ) ) ).

% dvd_eq_mod_eq_0
tff(fact_1439_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo(A,A3,B2) = zero_zero(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3)) ) ) ).

% mod_eq_0_iff_dvd
tff(fact_1440_fact__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),semiring_char_0_fact(A,M)),semiring_char_0_fact(A,N))) ) ) ).

% fact_mono
tff(fact_1441_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [M: nat,N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,A3),M)),aa(nat,A,power_power(A,A3),N))) ) ) ).

% le_imp_power_dvd
tff(fact_1442_power__le__dvd,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat,B2: A,M: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,A3),N)),B2))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,A3),M)),B2)) ) ) ) ).

% power_le_dvd
tff(fact_1443_dvd__power__le,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X3: A,Y4: A,N: nat,M: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),Y4))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,X3),N)),aa(nat,A,power_power(A,Y4),M))) ) ) ) ).

% dvd_power_le
tff(fact_1444_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
       => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),N),M)) ) ) ).

% nat_dvd_not_less
tff(fact_1445_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M)) ) ) ).

% dvd_pos_nat
tff(fact_1446_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),M))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),M),N))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),N),M))
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
tff(fact_1447_zdvd__not__zless,axiom,
    ! [M: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),M))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),M),N))
       => ~ pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),N),M)) ) ) ).

% zdvd_not_zless
tff(fact_1448_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),N)))
     => ( ( K != zero_zero(int) )
       => pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),M),N)) ) ) ).

% zdvd_mult_cancel
tff(fact_1449_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K != zero_zero(int) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),M),T2))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),T2))) ) ) ).

% zdvd_mono
tff(fact_1450_bezout__add__nat,axiom,
    ! [A3: nat,B2: nat] :
    ? [D3: nat,X2: nat,Y2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D3),A3))
      & pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D3),B2))
      & ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),X2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y2)),D3) )
        | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),Y2)),D3) ) ) ) ).

% bezout_add_nat
tff(fact_1451_bezout__lemma__nat,axiom,
    ! [D2: nat,A3: nat,B2: nat,X3: nat,Y4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D2),A3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D2),B2))
       => ( ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),X3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),D2) )
            | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),Y4)),D2) ) )
         => ? [X2: nat,Y2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D2),A3))
              & pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2)))
              & ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),X2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2)),Y2)),D2) )
                | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2)),X2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),Y2)),D2) ) ) ) ) ) ) ).

% bezout_lemma_nat
tff(fact_1452_zdvd__period,axiom,
    ! [A3: int,D2: int,X3: int,T2: int,C2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),A3),D2))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),A3),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),T2)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),A3),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),C2),D2))),T2))) ) ) ).

% zdvd_period
tff(fact_1453_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),K),aa(int,int,aa(int,fun(int,int),plus_plus(int),N),aa(int,int,aa(int,fun(int,int),times_times(int),K),M))))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),K),N)) ) ).

% zdvd_reduce
tff(fact_1454_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_semiring_1(A) )
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = comm_s3205402744901411588hammer(A,one_one(A),N) ) ) ).

% pochhammer_fact
tff(fact_1455_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),semiring_char_0_fact(nat,N))) ).

% fact_ge_Suc_0_nat
tff(fact_1456_unit__dvdE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ~ ( ( A3 != zero_zero(A) )
             => ! [C3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),times_times(A),A3),C3) ) ) ) ) ).

% unit_dvdE
tff(fact_1457_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( dvd(A)
        & semiring_0(A) )
     => ! [P: fun(A,bool),L: A] :
          ( ? [X4: A] : pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),times_times(A),L),X4)))
        <=> ? [X4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),L),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),zero_zero(A))))
              & pp(aa(A,bool,P,X4)) ) ) ) ).

% unity_coeff_ex
tff(fact_1458_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) ) ) ) ) ) ).

% dvd_div_eq_mult
tff(fact_1459_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ) ).

% div_dvd_iff_mult
tff(fact_1460_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ) ).

% dvd_div_iff_mult
tff(fact_1461_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( C2 != zero_zero(A) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),D2))
               => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),D2),C2) )
                <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),D2) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
tff(fact_1462_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = zero_zero(A) )
          <=> ( A3 = zero_zero(A) ) ) ) ) ).

% unit_div_eq_0_iff
tff(fact_1463_even__numeral,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: num] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(num,A,numeral_numeral(A),bit0(N)))) ) ).

% even_numeral
tff(fact_1464_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2) ) ) ) ) ).

% is_unit_div_mult2_eq
tff(fact_1465_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) ) ) ) ).

% unit_div_mult_swap
tff(fact_1466_unit__div__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2) ) ) ) ).

% unit_div_commute
tff(fact_1467_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),C2) ) ) ) ) ).

% div_mult_unit2
tff(fact_1468_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( ( A3 = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = C2 ) ) ) ) ).

% unit_eq_div2
tff(fact_1469_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = C2 )
          <=> ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% unit_eq_div1
tff(fact_1470_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
         => ( modulo_modulo(A,A3,B2) = zero_zero(A) ) ) ) ).

% unit_imp_mod_eq_0
tff(fact_1471_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,A3),N)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
            | ( N = zero_zero(nat) ) ) ) ) ).

% is_unit_power_iff
tff(fact_1472_fact__less__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),semiring_char_0_fact(A,M)),semiring_char_0_fact(A,N))) ) ) ) ).

% fact_less_mono
tff(fact_1473_fact__mod,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom(A)
        & semidom_modulo(A) )
     => ! [M: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( modulo_modulo(A,semiring_char_0_fact(A,N),semiring_char_0_fact(A,M)) = zero_zero(A) ) ) ) ).

% fact_mod
tff(fact_1474_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N)) ) ) ).

% dvd_imp_le
tff(fact_1475_fact__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),semiring_char_0_fact(A,N)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,power_power(nat,N),N)))) ) ).

% fact_le_power
tff(fact_1476_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N)) ) ) ).

% dvd_mult_cancel
tff(fact_1477_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N)) ) ) ).

% nat_mult_dvd_cancel1
tff(fact_1478_bezout__add__strong__nat,axiom,
    ! [A3: nat,B2: nat] :
      ( ( A3 != zero_zero(nat) )
     => ? [D3: nat,X2: nat,Y2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D3),A3))
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D3),B2))
          & ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),X2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y2)),D3) ) ) ) ).

% bezout_add_strong_nat
tff(fact_1479_zdvd__imp__le,axiom,
    ! [Z: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),Z),N))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z),N)) ) ) ).

% zdvd_imp_le
tff(fact_1480_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),modulo_modulo(nat,M,N)))
    <=> ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),N),M)) ) ).

% mod_greater_zero_iff_not_dvd
tff(fact_1481_real__of__nat__div,axiom,
    ! [D2: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D2),N))
     => ( aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),D2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,semiring_1_of_nat(real),D2)) ) ) ).

% real_of_nat_div
tff(fact_1482_option_Osize__neq,axiom,
    ! [A: $tType,X3: option(A)] : ( aa(option(A),nat,size_size(option(A)),X3) != zero_zero(nat) ) ).

% option.size_neq
tff(fact_1483_ex__has__least__nat,axiom,
    ! [A: $tType,P: fun(A,bool),K: A,M: fun(A,nat)] :
      ( pp(aa(A,bool,P,K))
     => ? [X2: A] :
          ( pp(aa(A,bool,P,X2))
          & ! [Y5: A] :
              ( pp(aa(A,bool,P,Y5))
             => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,M,X2)),aa(A,nat,M,Y5))) ) ) ) ).

% ex_has_least_nat
tff(fact_1484_even__zero,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),zero_zero(A))) ) ).

% even_zero
tff(fact_1485_is__unitE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ~ ( ( A3 != zero_zero(A) )
             => ! [B5: A] :
                  ( ( B5 != zero_zero(A) )
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B5),one_one(A)))
                   => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3) = B5 )
                     => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B5) = A3 )
                       => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B5) = one_one(A) )
                         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3) != aa(A,A,aa(A,fun(A,A),times_times(A),C2),B5) ) ) ) ) ) ) ) ) ) ).

% is_unitE
tff(fact_1486_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_left
tff(fact_1487_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),one_one(A)))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_right
tff(fact_1488_evenE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ~ ! [B5: A] : ( A3 != aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B5) ) ) ) ).

% evenE
tff(fact_1489_odd__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),one_one(A))) ) ).

% odd_one
tff(fact_1490_odd__even__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A,B2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% odd_even_add
tff(fact_1491_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) )
            & ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ) ) ).

% bit_eq_rec
tff(fact_1492_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [X3: A,M: nat,N: nat] :
          ( ( X3 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,X3),M)),aa(nat,A,power_power(A,X3),N)))
          <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),one_one(A)))
              | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ) ) ).

% dvd_power_iff
tff(fact_1493_dvd__power,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat,X3: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
            | ( X3 = one_one(A) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),aa(nat,A,power_power(A,X3),N))) ) ) ).

% dvd_power
tff(fact_1494_even__even__mod__4__iff,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))))) ) ).

% even_even_mod_4_iff
tff(fact_1495_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),M))
      <=> ( N = one_one(nat) ) ) ) ).

% dvd_mult_cancel1
tff(fact_1496_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),M)),M))
      <=> ( N = one_one(nat) ) ) ) ).

% dvd_mult_cancel2
tff(fact_1497_power__dvd__imp__le,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(nat,nat,power_power(nat,I),M)),aa(nat,nat,power_power(nat,I),N)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),one_one(nat)),I))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ).

% power_dvd_imp_le
tff(fact_1498_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,K,L)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K))
        | ( ( L = zero_zero(int) )
          & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) )
        | pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L)) ) ) ).

% mod_int_pos_iff
tff(fact_1499_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))) = A3 ) ) ) ).

% even_two_times_div_two
tff(fact_1500_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
        <=> ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ) ).

% even_iff_mod_2_eq_zero
tff(fact_1501_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
        <=> ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ) ).

% odd_iff_mod_2_eq_one
tff(fact_1502_power__mono__odd,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A3: A,B2: A] :
          ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N))) ) ) ) ).

% power_mono_odd
tff(fact_1503_odd__pos,axiom,
    ! [N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ).

% odd_pos
tff(fact_1504_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(nat,nat,power_power(nat,K),M)),aa(nat,nat,power_power(nat,K),N)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ).

% dvd_power_iff_le
tff(fact_1505_signed__take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ).

% signed_take_bit_int_less_exp
tff(fact_1506_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),A3)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            | ( M = zero_zero(nat) ) ) ) ) ).

% even_unset_bit_iff
tff(fact_1507_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),M),A3)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            & ( M != zero_zero(nat) ) ) ) ) ).

% even_set_bit_iff
tff(fact_1508_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se8732182000553998342ip_bit(A,M,A3)))
        <=> ~ ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            <=> ( M = zero_zero(nat) ) ) ) ) ).

% even_flip_bit_iff
tff(fact_1509_oddE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ~ ! [B5: A] : ( A3 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B5)),one_one(A)) ) ) ) ).

% oddE
tff(fact_1510_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
           => ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
           => ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ) ) ).

% mod2_eq_if
tff(fact_1511_parity__cases,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
           => ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) != zero_zero(A) ) )
         => ~ ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
             => ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) != one_one(A) ) ) ) ) ).

% parity_cases
tff(fact_1512_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A3),N)))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
            | ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ) ) ).

% zero_le_power_eq
tff(fact_1513_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A3: A] :
          ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A3),N)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ) ).

% zero_le_odd_power
tff(fact_1514_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A3),N))) ) ) ).

% zero_le_even_power
tff(fact_1515_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ).

% signed_take_bit_int_greater_eq_self_iff
tff(fact_1516_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),K))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),K)) ) ).

% signed_take_bit_int_less_self_iff
tff(fact_1517_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,A3),N)))
        <=> ( ( N = zero_zero(nat) )
            | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
              & ( A3 != zero_zero(A) ) )
            | ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ) ) ).

% zero_less_power_eq
tff(fact_1518_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: fun(A,bool),K: A,F2: fun(A,nat),B2: nat] :
      ( pp(aa(A,bool,P,K))
     => ( ! [Y2: A] :
            ( pp(aa(A,bool,P,Y2))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F2,Y2)),B2)) )
       => ? [X2: A] :
            ( pp(aa(A,bool,P,X2))
            & ! [Y5: A] :
                ( pp(aa(A,bool,P,Y5))
               => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,F2,Y5)),aa(A,nat,F2,X2))) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
tff(fact_1519_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),N)),zero_zero(A)))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
            & ( ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) )
              | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
                & ( A3 = zero_zero(A) ) ) ) ) ) ) ).

% power_le_zero_eq
tff(fact_1520_Bernoulli__inequality__even,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),X3))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3)),N))) ) ).

% Bernoulli_inequality_even
tff(fact_1521_square__fact__le__2__fact,axiom,
    ! [N: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),semiring_char_0_fact(real,N)),semiring_char_0_fact(real,N))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) ).

% square_fact_le_2_fact
tff(fact_1522_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,N))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N)))) ) ).

% fact_fact_dvd_fact
tff(fact_1523_div2__even__ext__nat,axiom,
    ! [X3: nat,Y4: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))) )
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),X3))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Y4)) )
       => ( X3 = Y4 ) ) ) ).

% div2_even_ext_nat
tff(fact_1524_flip__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( bit_se8732182000553998342ip_bit(A,zero_zero(nat),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% flip_bit_0
tff(fact_1525_fact__code,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),set_fo6178422350223883121st_nat(nat,times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2)),N,one_one(nat))) ) ) ).

% fact_code
tff(fact_1526_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N))))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
            | ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) = zero_zero(A) )
            | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
              & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))))) ) ) ) ) ).

% even_mult_exp_div_exp_iff
tff(fact_1527_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( vEBT_invar_vebt(A1,A22)
     => ( ( ? [A5: bool,B5: bool] : ( A1 = vEBT_Leaf(A5,B5) )
         => ( A22 != aa(nat,nat,suc,zero_zero(nat)) ) )
       => ( ! [TreeList2: list(vEBT_VEBT),N2: nat,Summary2: vEBT_VEBT,M3: nat,Deg2: nat] :
              ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),Deg2,TreeList2,Summary2) )
             => ( ( A22 = Deg2 )
               => ( ! [X: vEBT_VEBT] :
                      ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                     => vEBT_invar_vebt(X,N2) )
                 => ( vEBT_invar_vebt(Summary2,M3)
                   => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M3) )
                     => ( ( M3 = N2 )
                       => ( ( Deg2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),M3) )
                         => ( ~ ? [X_1: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2),X_1))
                           => ~ ! [X: vEBT_VEBT] :
                                  ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                                 => ~ ? [X_1: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X),X_1)) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList2: list(vEBT_VEBT),N2: nat,Summary2: vEBT_VEBT,M3: nat,Deg2: nat] :
                ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),Deg2,TreeList2,Summary2) )
               => ( ( A22 = Deg2 )
                 => ( ! [X: vEBT_VEBT] :
                        ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                       => vEBT_invar_vebt(X,N2) )
                   => ( vEBT_invar_vebt(Summary2,M3)
                     => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M3) )
                       => ( ( M3 = aa(nat,nat,suc,N2) )
                         => ( ( Deg2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),M3) )
                           => ( ~ ? [X_1: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2),X_1))
                             => ~ ! [X: vEBT_VEBT] :
                                    ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                                   => ~ ? [X_1: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X),X_1)) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList2: list(vEBT_VEBT),N2: nat,Summary2: vEBT_VEBT,M3: nat,Deg2: nat,Mi: nat,Ma2: nat] :
                  ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),Deg2,TreeList2,Summary2) )
                 => ( ( A22 = Deg2 )
                   => ( ! [X: vEBT_VEBT] :
                          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                         => vEBT_invar_vebt(X,N2) )
                     => ( vEBT_invar_vebt(Summary2,M3)
                       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M3) )
                         => ( ( M3 = N2 )
                           => ( ( Deg2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),M3) )
                             => ( ! [I4: nat] :
                                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M3)))
                                   => ( ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),X_12))
                                    <=> pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2),I4)) ) )
                               => ( ( ( Mi = Ma2 )
                                   => ! [X: vEBT_VEBT] :
                                        ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                                       => ~ ? [X_1: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X),X_1)) ) )
                                 => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Mi),Ma2))
                                   => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Ma2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg2)))
                                     => ~ ( ( Mi != Ma2 )
                                         => ! [I4: nat] :
                                              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M3)))
                                             => ( ( ( vEBT_VEBT_high(Ma2,N2) = I4 )
                                                 => pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),vEBT_VEBT_low(Ma2,N2))) )
                                                & ! [X: nat] :
                                                    ( ( ( vEBT_VEBT_high(X,N2) = I4 )
                                                      & pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),vEBT_VEBT_low(X,N2))) )
                                                   => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Mi),X))
                                                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X),Ma2)) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList2: list(vEBT_VEBT),N2: nat,Summary2: vEBT_VEBT,M3: nat,Deg2: nat,Mi: nat,Ma2: nat] :
                    ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),Deg2,TreeList2,Summary2) )
                   => ( ( A22 = Deg2 )
                     => ( ! [X: vEBT_VEBT] :
                            ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                           => vEBT_invar_vebt(X,N2) )
                       => ( vEBT_invar_vebt(Summary2,M3)
                         => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M3) )
                           => ( ( M3 = aa(nat,nat,suc,N2) )
                             => ( ( Deg2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),M3) )
                               => ( ! [I4: nat] :
                                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M3)))
                                     => ( ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),X_12))
                                      <=> pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2),I4)) ) )
                                 => ( ( ( Mi = Ma2 )
                                     => ! [X: vEBT_VEBT] :
                                          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                                         => ~ ? [X_1: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X),X_1)) ) )
                                   => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Mi),Ma2))
                                     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Ma2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg2)))
                                       => ~ ( ( Mi != Ma2 )
                                           => ! [I4: nat] :
                                                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M3)))
                                               => ( ( ( vEBT_VEBT_high(Ma2,N2) = I4 )
                                                   => pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),vEBT_VEBT_low(Ma2,N2))) )
                                                  & ! [X: nat] :
                                                      ( ( ( vEBT_VEBT_high(X,N2) = I4 )
                                                        & pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),vEBT_VEBT_low(X,N2))) )
                                                     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Mi),X))
                                                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X),Ma2)) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
tff(fact_1528_invar__vebt_Osimps,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( vEBT_invar_vebt(A1,A22)
    <=> ( ( ? [A6: bool,B7: bool] : ( A1 = vEBT_Leaf(A6,B7) )
          & ( A22 = aa(nat,nat,suc,zero_zero(nat)) ) )
        | ? [TreeList3: list(vEBT_VEBT),N3: nat,Summary3: vEBT_VEBT] :
            ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),A22,TreeList3,Summary3) )
            & ! [X4: vEBT_VEBT] :
                ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3)))
               => vEBT_invar_vebt(X4,N3) )
            & vEBT_invar_vebt(Summary3,N3)
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N3) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),N3) )
            & ~ ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary3),X_12))
            & ! [X4: vEBT_VEBT] :
                ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3)))
               => ~ ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X4),X_12)) ) )
        | ? [TreeList3: list(vEBT_VEBT),N3: nat,Summary3: vEBT_VEBT] :
            ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),A22,TreeList3,Summary3) )
            & ! [X4: vEBT_VEBT] :
                ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3)))
               => vEBT_invar_vebt(X4,N3) )
            & vEBT_invar_vebt(Summary3,aa(nat,nat,suc,N3))
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N3)) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),aa(nat,nat,suc,N3)) )
            & ~ ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary3),X_12))
            & ! [X4: vEBT_VEBT] :
                ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3)))
               => ~ ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X4),X_12)) ) )
        | ? [TreeList3: list(vEBT_VEBT),N3: nat,Summary3: vEBT_VEBT,Mi2: nat,Ma3: nat] :
            ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma3)),A22,TreeList3,Summary3) )
            & ! [X4: vEBT_VEBT] :
                ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3)))
               => vEBT_invar_vebt(X4,N3) )
            & vEBT_invar_vebt(Summary3,N3)
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N3) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),N3) )
            & ! [I2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N3)))
               => ( ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I2)),X_12))
                <=> pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary3),I2)) ) )
            & ( ( Mi2 = Ma3 )
             => ! [X4: vEBT_VEBT] :
                  ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3)))
                 => ~ ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X4),X_12)) ) )
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Mi2),Ma3))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Ma3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),A22)))
            & ( ( Mi2 != Ma3 )
             => ! [I2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N3)))
                 => ( ( ( vEBT_VEBT_high(Ma3,N3) = I2 )
                     => pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I2)),vEBT_VEBT_low(Ma3,N3))) )
                    & ! [X4: nat] :
                        ( ( ( vEBT_VEBT_high(X4,N3) = I2 )
                          & pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I2)),vEBT_VEBT_low(X4,N3))) )
                       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Mi2),X4))
                          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X4),Ma3)) ) ) ) ) ) )
        | ? [TreeList3: list(vEBT_VEBT),N3: nat,Summary3: vEBT_VEBT,Mi2: nat,Ma3: nat] :
            ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma3)),A22,TreeList3,Summary3) )
            & ! [X4: vEBT_VEBT] :
                ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3)))
               => vEBT_invar_vebt(X4,N3) )
            & vEBT_invar_vebt(Summary3,aa(nat,nat,suc,N3))
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N3)) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),aa(nat,nat,suc,N3)) )
            & ! [I2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N3))))
               => ( ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I2)),X_12))
                <=> pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary3),I2)) ) )
            & ( ( Mi2 = Ma3 )
             => ! [X4: vEBT_VEBT] :
                  ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3)))
                 => ~ ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X4),X_12)) ) )
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Mi2),Ma3))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Ma3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),A22)))
            & ( ( Mi2 != Ma3 )
             => ! [I2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N3))))
                 => ( ( ( vEBT_VEBT_high(Ma3,N3) = I2 )
                     => pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I2)),vEBT_VEBT_low(Ma3,N3))) )
                    & ! [X4: nat] :
                        ( ( ( vEBT_VEBT_high(X4,N3) = I2 )
                          & pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I2)),vEBT_VEBT_low(X4,N3))) )
                       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Mi2),X4))
                          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X4),Ma3)) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
tff(fact_1529_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),A3) = zero_zero(A) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
tff(fact_1530_diff__zero,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),zero_zero(A)) = A3 ) ) ).

% diff_zero
tff(fact_1531_zero__diff,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A3) = zero_zero(A) ) ) ).

% zero_diff
tff(fact_1532_diff__0__right,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),zero_zero(A)) = A3 ) ) ).

% diff_0_right
tff(fact_1533_diff__self,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),A3) = zero_zero(A) ) ) ).

% diff_self
tff(fact_1534_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2) = A3 ) ) ).

% add_diff_cancel_right'
tff(fact_1535_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) ) ) ).

% add_diff_cancel_right
tff(fact_1536_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),A3) = B2 ) ) ).

% add_diff_cancel_left'
tff(fact_1537_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) ) ) ).

% add_diff_cancel_left
tff(fact_1538_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),B2) = A3 ) ) ).

% diff_add_cancel
tff(fact_1539_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2) = A3 ) ) ).

% add_diff_cancel
tff(fact_1540_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2),B2) = modulo_modulo(A,A3,B2) ) ) ).

% minus_mod_self2
tff(fact_1541_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ).

% diff_Suc_Suc
tff(fact_1542_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),K) ) ).

% Suc_diff_diff
tff(fact_1543_diff__self__eq__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),M) = zero_zero(nat) ) ).

% diff_self_eq_0
tff(fact_1544_diff__0__eq__0,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),zero_zero(nat)),N) = zero_zero(nat) ) ).

% diff_0_eq_0
tff(fact_1545_diff__diff__cancel,axiom,
    ! [I: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),I)) = I ) ) ).

% diff_diff_cancel
tff(fact_1546_diff__diff__left,axiom,
    ! [I: nat,J3: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J3)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),K)) ) ).

% diff_diff_left
tff(fact_1547_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: bool,Q: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)))
        <=> ( pp(P)
           => pp(Q) ) ) ) ).

% of_bool_less_eq_iff
tff(fact_1548_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: bool] :
          ( ( aa(bool,A,zero_neq_one_of_bool(A),P) = zero_zero(A) )
        <=> ~ pp(P) ) ) ).

% of_bool_eq_0_iff
tff(fact_1549_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa(bool,A,zero_neq_one_of_bool(A),fFalse) = zero_zero(A) ) ) ).

% of_bool_eq(1)
tff(fact_1550_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: bool,Q: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)))
        <=> ( ~ pp(P)
            & pp(Q) ) ) ) ).

% of_bool_less_iff
tff(fact_1551_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa(bool,A,zero_neq_one_of_bool(A),fTrue) = one_one(A) ) ) ).

% of_bool_eq(2)
tff(fact_1552_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: bool] :
          ( ( aa(bool,A,zero_neq_one_of_bool(A),P) = one_one(A) )
        <=> pp(P) ) ) ).

% of_bool_eq_1_iff
tff(fact_1553_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: bool] : ( aa(nat,A,semiring_1_of_nat(A),aa(bool,nat,zero_neq_one_of_bool(nat),P)) = aa(bool,A,zero_neq_one_of_bool(A),P) ) ) ).

% of_nat_of_bool
tff(fact_1554_mi__ma__2__deg,axiom,
    ! [Mi3: nat,Ma: nat,Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,N: nat] :
      ( vEBT_invar_vebt(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma)),Deg,TreeList,Summary),N)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Mi3),Ma))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg))) ) ) ).

% mi_ma_2_deg
tff(fact_1555_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% diff_ge_0_iff_ge
tff(fact_1556_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ).

% diff_gt_0_iff_gt
tff(fact_1557_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),B2) = A3 ) ) ) ).

% le_add_diff_inverse2
tff(fact_1558_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) = A3 ) ) ) ).

% le_add_diff_inverse
tff(fact_1559_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),one_one(A)) = zero_zero(A) ) ) ).

% diff_numeral_special(9)
tff(fact_1560_diff__add__zero,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = zero_zero(A) ) ) ).

% diff_add_zero
tff(fact_1561_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [A3: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% left_diff_distrib_numeral
tff(fact_1562_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% right_diff_distrib_numeral
tff(fact_1563_div__diff,axiom,
    ! [A: $tType] :
      ( idom_modulo(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B2))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ) ).

% div_diff
tff(fact_1564_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(bool,A,zero_neq_one_of_bool(A),P)))
        <=> pp(P) ) ) ).

% zero_less_of_bool_iff
tff(fact_1565_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ).

% zero_less_diff
tff(fact_1566_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) = zero_zero(nat) ) ) ).

% diff_is_0_eq'
tff(fact_1567_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) = zero_zero(nat) )
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% diff_is_0_eq
tff(fact_1568_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(bool,A,zero_neq_one_of_bool(A),P)),one_one(A)))
        <=> ~ pp(P) ) ) ).

% of_bool_less_one_iff
tff(fact_1569_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: bool] : ( aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,P)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(bool,A,zero_neq_one_of_bool(A),P)) ) ) ).

% of_bool_not_iff
tff(fact_1570_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J3)),K) ) ) ).

% Nat.add_diff_assoc
tff(fact_1571_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)),I) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),I)),K) ) ) ).

% Nat.add_diff_assoc2
tff(fact_1572_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),J3) ) ) ).

% Nat.diff_diff_right
tff(fact_1573_diff__Suc__1,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,N)),one_one(nat)) = N ) ).

% diff_Suc_1
tff(fact_1574_Suc__0__mod__eq,axiom,
    ! [N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(bool,nat,zero_neq_one_of_bool(nat),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),aa(nat,nat,suc,zero_zero(nat))))) ) ).

% Suc_0_mod_eq
tff(fact_1575_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi3: nat,Ma: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,X3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),Deg))
     => ( pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma)),Deg,TreeList,Summary)),X3))
       => ( pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),vEBT_VEBT_low(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2))))))
          | ( X3 = Mi3 )
          | ( X3 = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
tff(fact_1576_Suc__pred,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))) = N ) ) ).

% Suc_pred
tff(fact_1577_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,suc,J3)) ) ) ).

% diff_Suc_diff_eq1
tff(fact_1578_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K))),I) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,J3)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),I)) ) ) ).

% diff_Suc_diff_eq2
tff(fact_1579_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X3: nat,Deg: nat,TreeList: list(vEBT_VEBT),Mi3: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),Deg))
       => ( pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),vEBT_VEBT_low(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2))))))
         => pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma)),Deg,TreeList,Summary)),X3)) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
tff(fact_1580_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [P2: bool] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(bool,A,zero_neq_one_of_bool(A),P2)))
        <=> pp(P2) ) ) ).

% odd_of_bool_self
tff(fact_1581_Suc__diff__1,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) = N ) ) ).

% Suc_diff_1
tff(fact_1582_even__diff,axiom,
    ! [A: $tType] :
      ( ring_parity(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ).

% even_diff
tff(fact_1583_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [B2: bool] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(bool,A,zero_neq_one_of_bool(A),B2)),aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ).

% of_bool_half_eq_0
tff(fact_1584_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))) = N ) ) ).

% odd_Suc_minus_one
tff(fact_1585_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
        | pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) ) ) ).

% even_diff_nat
tff(fact_1586_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A))))
        <=> ( N = zero_zero(nat) ) ) ) ).

% semiring_parity_class.even_mask_iff
tff(fact_1587_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% one_div_2_pow_eq
tff(fact_1588_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% bits_1_div_exp
tff(fact_1589_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)) ) ) ).

% odd_two_times_div_two_nat
tff(fact_1590_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( modulo_modulo(A,one_one(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% one_mod_2_pow_eq
tff(fact_1591_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))) ) ) ).

% dvd_diff_nat
tff(fact_1592_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),N),M))
       => ( M = N ) ) ) ).

% dvd_antisym
tff(fact_1593_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( ( A3 = B2 )
          <=> ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
tff(fact_1594_diff__right__commute,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) ) ) ).

% diff_right_commute
tff(fact_1595_diff__commute,axiom,
    ! [I: nat,J3: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J3)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),K)),J3) ) ).

% diff_commute
tff(fact_1596_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P2: bool,Q2: bool] :
          ( ( aa(bool,A,zero_neq_one_of_bool(A),P2) = aa(bool,A,zero_neq_one_of_bool(A),Q2) )
        <=> ( pp(P2)
          <=> pp(Q2) ) ) ) ).

% of_bool_eq_iff
tff(fact_1597_of__nat__diff,axiom,
    ! [A: $tType] :
      ( semiring_1_cancel(A)
     => ! [N: nat,M: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ) ).

% of_nat_diff
tff(fact_1598_of__bool__conj,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: bool,Q: bool] : ( aa(bool,A,zero_neq_one_of_bool(A),fconj(P,Q)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_conj
tff(fact_1599_diff__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,D2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2))) ) ) ) ).

% diff_mono
tff(fact_1600_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))) ) ) ).

% diff_left_mono
tff(fact_1601_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2))) ) ) ).

% diff_right_mono
tff(fact_1602_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2)) ) ) ) ).

% diff_eq_diff_less_eq
tff(fact_1603_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = zero_zero(A) ) ) ) ).

% eq_iff_diff_eq_0
tff(fact_1604_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2))) ) ) ).

% diff_strict_right_mono
tff(fact_1605_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))) ) ) ).

% diff_strict_left_mono
tff(fact_1606_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2)) ) ) ) ).

% diff_eq_diff_less
tff(fact_1607_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,D2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),D2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2))) ) ) ) ).

% diff_strict_mono
tff(fact_1608_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,bool),D4: A,Q: fun(A,bool)] :
          ( ! [X2: A,K2: A] :
              ( pp(aa(A,bool,P,X2))
            <=> pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4)))) )
         => ( ! [X2: A,K2: A] :
                ( pp(aa(A,bool,Q,X2))
              <=> pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4)))) )
           => ! [X: A,K4: A] :
                ( ( pp(aa(A,bool,P,X))
                  & pp(aa(A,bool,Q,X)) )
              <=> ( pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4))))
                  & pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4)))) ) ) ) ) ) ).

% inf_period(1)
tff(fact_1609_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,bool),D4: A,Q: fun(A,bool)] :
          ( ! [X2: A,K2: A] :
              ( pp(aa(A,bool,P,X2))
            <=> pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4)))) )
         => ( ! [X2: A,K2: A] :
                ( pp(aa(A,bool,Q,X2))
              <=> pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4)))) )
           => ! [X: A,K4: A] :
                ( ( pp(aa(A,bool,P,X))
                  | pp(aa(A,bool,Q,X)) )
              <=> ( pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4))))
                  | pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4)))) ) ) ) ) ) ).

% inf_period(2)
tff(fact_1610_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% right_diff_distrib'
tff(fact_1611_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [B2: A,C2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)) ) ) ).

% left_diff_distrib'
tff(fact_1612_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% right_diff_distrib
tff(fact_1613_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% left_diff_distrib
tff(fact_1614_add__diff__add,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,C2: A,B2: A,D2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2)) ) ) ).

% add_diff_add
tff(fact_1615_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% diff_diff_eq
tff(fact_1616_add__implies__diff,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [C2: A,B2: A,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) = A3 )
         => ( C2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) ) ) ) ).

% add_implies_diff
tff(fact_1617_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),B2) ) ) ).

% diff_add_eq_diff_diff_swap
tff(fact_1618_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2) ) ) ).

% diff_add_eq
tff(fact_1619_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2) ) ) ).

% diff_diff_eq2
tff(fact_1620_add__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) ) ) ).

% add_diff_eq
tff(fact_1621_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = C2 ) ) ) ).

% eq_diff_eq
tff(fact_1622_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = C2 )
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) ) ) ) ).

% diff_eq_eq
tff(fact_1623_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,K: A,A3: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A3) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) ) ) ) ).

% group_cancel.sub1
tff(fact_1624_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ).

% diff_divide_distrib
tff(fact_1625_dvd__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),Z))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),Z))) ) ) ) ).

% dvd_diff
tff(fact_1626_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( euclid5891614535332579305n_ring(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2))) ) ) ).

% dvd_diff_commute
tff(fact_1627_zero__induct__lemma,axiom,
    ! [P: fun(nat,bool),K: nat,I: nat] :
      ( pp(aa(nat,bool,P,K))
     => ( ! [N2: nat] :
            ( pp(aa(nat,bool,P,aa(nat,nat,suc,N2)))
           => pp(aa(nat,bool,P,N2)) )
       => pp(aa(nat,bool,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),I))) ) ) ).

% zero_induct_lemma
tff(fact_1628_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) = zero_zero(nat) )
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M) = zero_zero(nat) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
tff(fact_1629_minus__nat_Odiff__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),zero_zero(nat)) = M ) ).

% minus_nat.diff_0
tff(fact_1630_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A3,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2),C2) ) ) ).

% mod_diff_eq
tff(fact_1631_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,C2: A,A4: A,B2: A,B4: A] :
          ( ( modulo_modulo(A,A3,C2) = modulo_modulo(A,A4,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B4,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B4),C2) ) ) ) ) ).

% mod_diff_cong
tff(fact_1632_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A3,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2),C2) ) ) ).

% mod_diff_left_eq
tff(fact_1633_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2),C2) ) ) ).

% mod_diff_right_eq
tff(fact_1634_less__imp__diff__less,axiom,
    ! [J3: nat,K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),K))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),N)),K)) ) ).

% less_imp_diff_less
tff(fact_1635_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),L))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),N)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),M))) ) ) ).

% diff_less_mono2
tff(fact_1636_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
        | pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N)) ) ) ).

% dvd_minus_self
tff(fact_1637_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),N)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),M))) ) ).

% diff_le_mono2
tff(fact_1638_le__diff__iff_H,axiom,
    ! [A3: nat,C2: nat,B2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),C2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),B2),C2))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),C2),A3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),C2),B2)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),B2),A3)) ) ) ) ).

% le_diff_iff'
tff(fact_1639_diff__le__self,axiom,
    ! [M: nat,N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),M)) ).

% diff_le_self
tff(fact_1640_diff__le__mono,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),L)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),L))) ) ).

% diff_le_mono
tff(fact_1641_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ) ) ).

% Nat.diff_diff_eq
tff(fact_1642_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ) ).

% le_diff_iff
tff(fact_1643_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
       => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K) )
        <=> ( M = N ) ) ) ) ).

% eq_diff_iff
tff(fact_1644_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),N))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ).

% less_eq_dvd_minus
tff(fact_1645_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),M))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),N)) ) ) ) ).

% dvd_diffD1
tff(fact_1646_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),N))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),M)) ) ) ) ).

% dvd_diffD
tff(fact_1647_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),N) = M ) ).

% diff_add_inverse2
tff(fact_1648_diff__add__inverse,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)),N) = M ) ).

% diff_add_inverse
tff(fact_1649_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ).

% diff_cancel2
tff(fact_1650_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ).

% Nat.diff_cancel
tff(fact_1651_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K)) ) ).

% diff_mult_distrib
tff(fact_1652_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) ) ).

% diff_mult_distrib2
tff(fact_1653_bezout1__nat,axiom,
    ! [A3: nat,B2: nat] :
    ? [D3: nat,X2: nat,Y2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D3),A3))
      & pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),D3),B2))
      & ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),X2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y2)) = D3 )
        | ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),Y2)) = D3 ) ) ) ).

% bezout1_nat
tff(fact_1654_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi3: nat,Ma: nat,Va2: list(vEBT_VEBT),Vb: vEBT_VEBT,X3: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma)),zero_zero(nat),Va2,Vb),X3)
    <=> ( ( X3 = Mi3 )
        | ( X3 = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
tff(fact_1655_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(bool,A,zero_neq_one_of_bool(A),P))) ) ).

% zero_less_eq_of_bool
tff(fact_1656_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(bool,A,zero_neq_one_of_bool(A),P)),one_one(A))) ) ).

% of_bool_less_eq_one
tff(fact_1657_of__bool__def,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P2: bool] :
          ( ( pp(P2)
           => ( aa(bool,A,zero_neq_one_of_bool(A),P2) = one_one(A) ) )
          & ( ~ pp(P2)
           => ( aa(bool,A,zero_neq_one_of_bool(A),P2) = zero_zero(A) ) ) ) ) ).

% of_bool_def
tff(fact_1658_split__of__bool,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,bool),P2: bool] :
          ( pp(aa(A,bool,P,aa(bool,A,zero_neq_one_of_bool(A),P2)))
        <=> ( ( pp(P2)
             => pp(aa(A,bool,P,one_one(A))) )
            & ( ~ pp(P2)
             => pp(aa(A,bool,P,zero_zero(A))) ) ) ) ) ).

% split_of_bool
tff(fact_1659_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,bool),P2: bool] :
          ( pp(aa(A,bool,P,aa(bool,A,zero_neq_one_of_bool(A),P2)))
        <=> ~ ( ( pp(P2)
                & ~ pp(aa(A,bool,P,one_one(A))) )
              | ( ~ pp(P2)
                & ~ pp(aa(A,bool,P,zero_zero(A))) ) ) ) ) ).

% split_of_bool_asm
tff(fact_1660_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),zero_zero(A))) ) ) ).

% le_iff_diff_le_0
tff(fact_1661_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),zero_zero(A))) ) ) ).

% less_iff_diff_less_0
tff(fact_1662_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I: A,K: A,N: A,J3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),N))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),K)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),N))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),K)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),N),K)),J3)) ) ) ) ) ) ).

% add_le_add_imp_diff_le
tff(fact_1663_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I: A,K: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),aa(A,A,aa(A,fun(A,A),minus_minus(A),N),K))) ) ) ).

% add_le_imp_le_diff
tff(fact_1664_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))) ) ) ).

% diff_le_eq
tff(fact_1665_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2)) ) ) ).

% le_diff_eq
tff(fact_1666_diff__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),A3) = B2 ) ) ) ).

% diff_add
tff(fact_1667_le__add__diff,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A3))) ) ) ).

% le_add_diff
tff(fact_1668_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),B2)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
tff(fact_1669_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
tff(fact_1670_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
tff(fact_1671_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
tff(fact_1672_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),C2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
tff(fact_1673_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),B2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
tff(fact_1674_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
tff(fact_1675_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
tff(fact_1676_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,B2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) = A3 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
tff(fact_1677_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))) ) ) ).

% diff_less_eq
tff(fact_1678_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2)) ) ) ).

% less_diff_eq
tff(fact_1679_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [X3: A,Y4: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A3)),B2)) ) ) ).

% mult_diff_mult
tff(fact_1680_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( comm_ring(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Y4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) ) ) ).

% square_diff_square_factored
tff(fact_1681_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2) )
        <=> ( C2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),E)),D2) ) ) ) ).

% eq_add_iff2
tff(fact_1682_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),E)),C2) = D2 ) ) ) ).

% eq_add_iff1
tff(fact_1683_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),modulo_modulo(A,A3,B2)))) ) ).

% dvd_minus_mod
tff(fact_1684_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A3,C2) = modulo_modulo(A,B2,C2) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2))) ) ) ).

% mod_eq_dvd_iff
tff(fact_1685_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),aa(nat,nat,suc,M))) ).

% diff_less_Suc
tff(fact_1686_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,N))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ) ).

% Suc_diff_Suc
tff(fact_1687_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),M)) ) ) ).

% diff_less
tff(fact_1688_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) ) ) ).

% Suc_diff_le
tff(fact_1689_diff__less__mono,axiom,
    ! [A3: nat,B2: nat,C2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A3),B2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),C2),A3))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A3),C2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),B2),C2))) ) ) ).

% diff_less_mono
tff(fact_1690_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) ) ) ) ).

% less_diff_iff
tff(fact_1691_diff__add__0,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)) = zero_zero(nat) ) ).

% diff_add_0
tff(fact_1692_less__diff__conv,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),J3)) ) ).

% less_diff_conv
tff(fact_1693_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) = M ) ) ).

% add_diff_inverse_nat
tff(fact_1694_le__diff__conv,axiom,
    ! [J3: nat,K: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)),I))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K))) ) ).

% le_diff_conv
tff(fact_1695_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),J3)) ) ) ).

% Nat.le_diff_conv2
tff(fact_1696_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J3)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)) ) ) ).

% Nat.diff_add_assoc
tff(fact_1697_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),I)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)),I) ) ) ).

% Nat.diff_add_assoc2
tff(fact_1698_Nat_Ole__imp__diff__is__add,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),I) = K )
      <=> ( J3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),I) ) ) ) ).

% Nat.le_imp_diff_is_add
tff(fact_1699_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),N) ) ).

% diff_Suc_eq_diff_pred
tff(fact_1700_mod__if,axiom,
    ! [M: nat,N: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
       => ( modulo_modulo(nat,M,N) = M ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
       => ( modulo_modulo(nat,M,N) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N) ) ) ) ).

% mod_if
tff(fact_1701_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
     => ( modulo_modulo(nat,M,N) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N) ) ) ).

% mod_geq
tff(fact_1702_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
     => ( modulo_modulo(nat,M,N) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N) ) ) ).

% le_mod_geq
tff(fact_1703_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
     => ( ( modulo_modulo(nat,M,Q2) = modulo_modulo(nat,N,Q2) )
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),Q2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))) ) ) ).

% mod_eq_dvd_iff_nat
tff(fact_1704_choose__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))),semiring_char_0_fact(A,N))) ) ) ).

% choose_dvd
tff(fact_1705_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),E)),D2))) ) ) ).

% ordered_ring_class.le_add_iff2
tff(fact_1706_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),E)),C2)),D2)) ) ) ).

% ordered_ring_class.le_add_iff1
tff(fact_1707_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),E)),C2)),D2)) ) ) ).

% less_add_iff1
tff(fact_1708_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),E)),D2))) ) ) ).

% less_add_iff2
tff(fact_1709_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Z)),Y4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z))),Z) ) ) ) ).

% divide_diff_eq_iff
tff(fact_1710_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),Y4)),Z) ) ) ) ).

% diff_divide_eq_iff
tff(fact_1711_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y4: A,Z: A,X3: A,W: A] :
          ( ( Y4 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z)) ) ) ) ) ).

% diff_frac_eq
tff(fact_1712_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,A3: A,B2: A] :
          ( ( ( Z = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Z)) = A3 ) )
          & ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),Z)),B2)),Z) ) ) ) ) ).

% add_divide_eq_if_simps(4)
tff(fact_1713_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),one_one(A))) ) ) ).

% square_diff_one_factored
tff(fact_1714_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D4: A,T2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D2),D4))
         => ! [X: A,K4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),T2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4))),T2))) ) ) ) ).

% inf_period(3)
tff(fact_1715_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D4: A,T2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D2),D4))
         => ! [X: A,K4: A] :
              ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),T2)))
            <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4))),T2))) ) ) ) ).

% inf_period(4)
tff(fact_1716_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),B2)) = modulo_modulo(A,A3,B2) ) ) ).

% minus_div_mult_eq_mod
tff(fact_1717_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),modulo_modulo(A,A3,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),B2) ) ) ).

% minus_mod_eq_div_mult
tff(fact_1718_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),modulo_modulo(A,A3,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) ) ) ).

% minus_mod_eq_mult_div
tff(fact_1719_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2))) = modulo_modulo(A,A3,B2) ) ) ).

% minus_mult_div_eq_mod
tff(fact_1720_diff__Suc__less,axiom,
    ! [N: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,I))),N)) ) ).

% diff_Suc_less
tff(fact_1721_nat__diff__split,axiom,
    ! [P: fun(nat,bool),A3: nat,B2: nat] :
      ( pp(aa(nat,bool,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A3),B2)))
    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A3),B2))
         => pp(aa(nat,bool,P,zero_zero(nat))) )
        & ! [D5: nat] :
            ( ( A3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B2),D5) )
           => pp(aa(nat,bool,P,D5)) ) ) ) ).

% nat_diff_split
tff(fact_1722_nat__diff__split__asm,axiom,
    ! [P: fun(nat,bool),A3: nat,B2: nat] :
      ( pp(aa(nat,bool,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A3),B2)))
    <=> ~ ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A3),B2))
            & ~ pp(aa(nat,bool,P,zero_zero(nat))) )
          | ? [D5: nat] :
              ( ( A3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B2),D5) )
              & ~ pp(aa(nat,bool,P,D5)) ) ) ) ).

% nat_diff_split_asm
tff(fact_1723_less__diff__conv2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),K)),I))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K))) ) ) ).

% less_diff_conv2
tff(fact_1724_nat__diff__add__eq2,axiom,
    ! [I: nat,J3: nat,U: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),I)),U)),N)) ) ) ).

% nat_diff_add_eq2
tff(fact_1725_nat__diff__add__eq1,axiom,
    ! [J3: nat,I: nat,U: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),I))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J3)),U)),M)),N) ) ) ).

% nat_diff_add_eq1
tff(fact_1726_nat__le__add__iff2,axiom,
    ! [I: nat,J3: nat,U: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),N)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),I)),U)),N))) ) ) ).

% nat_le_add_iff2
tff(fact_1727_nat__le__add__iff1,axiom,
    ! [J3: nat,I: nat,U: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),I))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),N)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J3)),U)),M)),N)) ) ) ).

% nat_le_add_iff1
tff(fact_1728_nat__eq__add__iff2,axiom,
    ! [I: nat,J3: nat,U: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),N) )
      <=> ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),I)),U)),N) ) ) ) ).

% nat_eq_add_iff2
tff(fact_1729_nat__eq__add__iff1,axiom,
    ! [J3: nat,I: nat,U: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),I))
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),N) )
      <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J3)),U)),M) = N ) ) ) ).

% nat_eq_add_iff1
tff(fact_1730_dvd__minus__add,axiom,
    ! [Q2: nat,N: nat,R2: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Q2),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Q2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),R2),M)))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),Q2)))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),R2),M)),Q2)))) ) ) ) ).

% dvd_minus_add
tff(fact_1731_mod__nat__eqI,axiom,
    ! [R2: nat,N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),R2),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),R2),M))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),R2)))
         => ( modulo_modulo(nat,M,N) = R2 ) ) ) ) ).

% mod_nat_eqI
tff(fact_1732_fact__div__fact__le__pow,axiom,
    ! [R2: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),R2),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,N)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),R2)))),aa(nat,nat,power_power(nat,N),R2))) ) ).

% fact_div_fact_le_pow
tff(fact_1733_modulo__nat__def,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,M,N) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),N)) ) ).

% modulo_nat_def
tff(fact_1734_option_Osize_I4_J,axiom,
    ! [A: $tType,X22: A] : ( aa(option(A),nat,size_size(option(A)),some(A,X22)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size(4)
tff(fact_1735_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),fconj(aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)),zero_zero(A))),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M)))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))) ) ) ).

% exp_div_exp_eq
tff(fact_1736_frac__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y4: A,Z: A,X3: A,W: A] :
          ( ( Y4 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z))),zero_zero(A))) ) ) ) ) ).

% frac_le_eq
tff(fact_1737_frac__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y4: A,Z: A,X3: A,W: A] :
          ( ( Y4 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z))),zero_zero(A))) ) ) ) ) ).

% frac_less_eq
tff(fact_1738_power2__commute,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X3: A,Y4: A] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% power2_commute
tff(fact_1739_power__diff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A,N: nat,M: nat] :
          ( ( A3 != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A3),M)),aa(nat,A,power_power(A,A3),N)) ) ) ) ) ).

% power_diff
tff(fact_1740_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ).

% Suc_diff_eq_diff_pred
tff(fact_1741_Suc__pred_H,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( N = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ).

% Suc_pred'
tff(fact_1742_div__if,axiom,
    ! [M: nat,N: nat] :
      ( ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
          | ( N = zero_zero(nat) ) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) = zero_zero(nat) ) )
      & ( ~ ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
            | ( N = zero_zero(nat) ) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),N)) ) ) ) ).

% div_if
tff(fact_1743_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),N)) ) ) ) ).

% div_geq
tff(fact_1744_add__eq__if,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M = zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) = N ) )
      & ( ( M != zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),N)) ) ) ) ).

% add_eq_if
tff(fact_1745_nat__less__add__iff1,axiom,
    ! [J3: nat,I: nat,U: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),I))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),N)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J3)),U)),M)),N)) ) ) ).

% nat_less_add_iff1
tff(fact_1746_nat__less__add__iff2,axiom,
    ! [I: nat,J3: nat,U: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J3),U)),N)))
      <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),I)),U)),N))) ) ) ).

% nat_less_add_iff2
tff(fact_1747_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),modulo_modulo(nat,M,N)))),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% field_char_0_class.of_nat_div
tff(fact_1748_mult__eq__if,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M = zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) = zero_zero(nat) ) )
      & ( ( M != zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),N)) ) ) ) ).

% mult_eq_if
tff(fact_1749_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] : ( aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))) = modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% of_bool_odd_eq_mod_2
tff(fact_1750_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X3: fun(nat,fun(A,A)),Xa: nat,Xb: nat,Xc: A,Y4: A] :
      ( ( set_fo6178422350223883121st_nat(A,X3,Xa,Xb,Xc) = Y4 )
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Xb),Xa))
         => ( Y4 = Xc ) )
        & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Xb),Xa))
         => ( Y4 = set_fo6178422350223883121st_nat(A,X3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xa),one_one(nat)),Xb,aa(A,A,aa(nat,fun(A,A),X3,Xa),Xc)) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
tff(fact_1751_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType,B2: nat,A3: nat,F2: fun(nat,fun(A,A)),Acc: A] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),B2),A3))
       => ( set_fo6178422350223883121st_nat(A,F2,A3,B2,Acc) = Acc ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),B2),A3))
       => ( set_fo6178422350223883121st_nat(A,F2,A3,B2,Acc) = set_fo6178422350223883121st_nat(A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),one_one(nat)),B2,aa(A,A,aa(nat,fun(A,A),F2,A3),Acc)) ) ) ) ).

% fold_atLeastAtMost_nat.simps
tff(fact_1752_scaling__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,V: A,R2: A,S: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),V))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),R2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),R2),S))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),U),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),R2),aa(A,A,aa(A,fun(A,A),minus_minus(A),V),U))),S))),V)) ) ) ) ) ).

% scaling_mono
tff(fact_1753_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat,M: nat] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) != zero_zero(A) )
         => ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) != zero_zero(A) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
tff(fact_1754_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,N: nat,M: nat] :
          ( ( A3 != zero_zero(A) )
         => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
             => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A3),M)),aa(nat,A,power_power(A,A3),N)) = aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) ) )
            & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
             => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A3),M)),aa(nat,A,power_power(A,A3),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ) ) ) ).

% power_diff_power_eq
tff(fact_1755_power__eq__if,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [M: nat,P2: A] :
          ( ( ( M = zero_zero(nat) )
           => ( aa(nat,A,power_power(A,P2),M) = one_one(A) ) )
          & ( ( M != zero_zero(nat) )
           => ( aa(nat,A,power_power(A,P2),M) = aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(nat,A,power_power(A,P2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat)))) ) ) ) ) ).

% power_eq_if
tff(fact_1756_power__minus__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),A3) = aa(nat,A,power_power(A,A3),N) ) ) ) ).

% power_minus_mult
tff(fact_1757_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,K),M)),aa(nat,nat,power_power(nat,K),N)))) ) ).

% diff_le_diff_pow
tff(fact_1758_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),N)) ) ) ) ).

% le_div_geq
tff(fact_1759_pochhammer__product,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [M: nat,N: nat,Z: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( comm_s3205402744901411588hammer(A,Z,N) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,M)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ) ).

% pochhammer_product
tff(fact_1760_bits__induct,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [P: fun(A,bool),A3: A] :
          ( ! [A5: A] :
              ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A5),aa(num,A,numeral_numeral(A),bit0(one2))) = A5 )
             => pp(aa(A,bool,P,A5)) )
         => ( ! [A5: A,B5: bool] :
                ( pp(aa(A,bool,P,A5))
               => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),B5)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A5))),aa(num,A,numeral_numeral(A),bit0(one2))) = A5 )
                 => pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),B5)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A5)))) ) )
           => pp(aa(A,bool,P,A3)) ) ) ) ).

% bits_induct
tff(fact_1761_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat] :
          ( ( ( M = zero_zero(nat) )
           => ( semiring_char_0_fact(A,M) = one_one(A) ) )
          & ( ( M != zero_zero(nat) )
           => ( semiring_char_0_fact(A,M) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat)))) ) ) ) ) ).

% fact_num_eq_if
tff(fact_1762_fact__reduce,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( semiring_char_0_fact(A,N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ) ).

% fact_reduce
tff(fact_1763_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] : ( modulo_modulo(A,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)) ) ) ).

% exp_mod_exp
tff(fact_1764_list__decode_Ocases,axiom,
    ! [X3: nat] :
      ( ( X3 != zero_zero(nat) )
     => ~ ! [N2: nat] : ( X3 != aa(nat,nat,suc,N2) ) ) ).

% list_decode.cases
tff(fact_1765_power2__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X3: A,Y4: A] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)),Y4)) ) ) ).

% power2_diff
tff(fact_1766_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A3,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)) ) ) ) ).

% mult_exp_mod_exp_eq
tff(fact_1767_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(nat,nat,suc,zero_zero(nat)) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% even_mod_4_div_2
tff(fact_1768_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,power_power(int,K),M)),K) = aa(nat,int,power_power(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,zero_zero(nat)))) ) ) ) ).

% int_power_div_base
tff(fact_1769_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList: list(vEBT_VEBT),N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi3: nat,Ma: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
         => vEBT_invar_vebt(X2,N) )
     => ( vEBT_invar_vebt(Summary,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
         => ( ( M = N )
           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M) )
             => ( ! [I3: nat] :
                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M)))
                   => ( ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),X_12))
                    <=> pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary),I3)) ) )
               => ( ( ( Mi3 = Ma )
                   => ! [X2: vEBT_VEBT] :
                        ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
                       => ~ ? [X_13: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X2),X_13)) ) )
                 => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Mi3),Ma))
                   => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg)))
                     => ( ( ( Mi3 != Ma )
                         => ! [I3: nat] :
                              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M)))
                             => ( ( ( vEBT_VEBT_high(Ma,N) = I3 )
                                 => pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),vEBT_VEBT_low(Ma,N))) )
                                & ! [X2: nat] :
                                    ( ( ( vEBT_VEBT_high(X2,N) = I3 )
                                      & pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),vEBT_VEBT_low(X2,N))) )
                                   => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Mi3),X2))
                                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X2),Ma)) ) ) ) ) )
                       => vEBT_invar_vebt(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma)),Deg,TreeList,Summary),Deg) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
tff(fact_1770_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))))
             => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))),B2) = modulo_modulo(A,A3,B2) ) ) ) ) ) ).

% divmod_digit_1(2)
tff(fact_1771_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)),one_one(A))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N))))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ).

% even_mask_div_iff'
tff(fact_1772_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList: list(vEBT_VEBT),N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi3: nat,Ma: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
         => vEBT_invar_vebt(X2,N) )
     => ( vEBT_invar_vebt(Summary,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
         => ( ( M = aa(nat,nat,suc,N) )
           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M) )
             => ( ! [I3: nat] :
                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M)))
                   => ( ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),X_12))
                    <=> pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary),I3)) ) )
               => ( ( ( Mi3 = Ma )
                   => ! [X2: vEBT_VEBT] :
                        ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
                       => ~ ? [X_13: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X2),X_13)) ) )
                 => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Mi3),Ma))
                   => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg)))
                     => ( ( ( Mi3 != Ma )
                         => ! [I3: nat] :
                              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),M)))
                             => ( ( ( vEBT_VEBT_high(Ma,N) = I3 )
                                 => pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),vEBT_VEBT_low(Ma,N))) )
                                & ! [X2: nat] :
                                    ( ( ( vEBT_VEBT_high(X2,N) = I3 )
                                      & pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),vEBT_VEBT_low(X2,N))) )
                                   => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Mi3),X2))
                                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X2),Ma)) ) ) ) ) )
                       => vEBT_invar_vebt(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma)),Deg,TreeList,Summary),Deg) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
tff(fact_1773_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)),one_one(A))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N))))
        <=> ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) = zero_zero(A) )
            | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ) ) ).

% even_mask_div_iff
tff(fact_1774_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,R2: A,Q2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R2))
           => ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),product_Pair(A,A,Q2),R2)) = aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Q2)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),R2),aa(num,A,numeral_numeral(A),L))) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R2))
           => ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),product_Pair(A,A,Q2),R2)) = aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Q2)),R2) ) ) ) ) ).

% divmod_step_eq
tff(fact_1775_arcosh__1,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,arcosh(A),one_one(A)) = zero_zero(A) ) ) ).

% arcosh_1
tff(fact_1776_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,suc,M)))
     => ( semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))) ) ) ).

% fact_diff_Suc
tff(fact_1777_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [H: A,Z: A,K5: real,N: nat] :
          ( ( H != zero_zero(A) )
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),K5))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H))),K5))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H)),N)),aa(nat,A,power_power(A,Z),N))),H)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,A,power_power(A,Z),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),aa(nat,real,power_power(real,K5),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),real_V7770717601297561774m_norm(A,H)))) ) ) ) ) ).

% lemma_termdiff3
tff(fact_1778_Suc__if__eq,axiom,
    ! [A: $tType,F2: fun(nat,A),H: fun(nat,A),G: A,N: nat] :
      ( ! [N2: nat] : ( aa(nat,A,F2,aa(nat,nat,suc,N2)) = aa(nat,A,H,N2) )
     => ( ( aa(nat,A,F2,zero_zero(nat)) = G )
       => ( ( ( N = zero_zero(nat) )
           => ( aa(nat,A,F2,N) = G ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(nat,A,F2,N) = aa(nat,A,H,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ) ) ) ).

% Suc_if_eq
tff(fact_1779_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q2: A,R2: A] :
          ( unique5940410009612947441es_aux(A,aa(A,product_prod(A,A),product_Pair(A,A,Q2),R2))
        <=> ( R2 = zero_zero(A) ) ) ) ).

% divides_aux_eq
tff(fact_1780_artanh__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ( aa(A,A,artanh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% artanh_0
tff(fact_1781_arsinh__0,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,arsinh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% arsinh_0
tff(fact_1782_idiff__0__right,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),N),zero_zero(extended_enat)) = N ) ).

% idiff_0_right
tff(fact_1783_idiff__0,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),zero_zero(extended_enat)),N) = zero_zero(extended_enat) ) ).

% idiff_0
tff(fact_1784_idiff__enat__0__right,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),N),extended_enat2(zero_zero(nat))) = N ) ).

% idiff_enat_0_right
tff(fact_1785_idiff__enat__0,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(zero_zero(nat))),N) = extended_enat2(zero_zero(nat)) ) ).

% idiff_enat_0
tff(fact_1786_idiff__enat__enat,axiom,
    ! [A3: nat,B2: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(A3)),extended_enat2(B2)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A3),B2)) ) ).

% idiff_enat_enat
tff(fact_1787_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),W),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),one_one(int))))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z)) ) ).

% zle_diff1_eq
tff(fact_1788_minus__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),K),zero_zero(int)) = K ) ).

% minus_int_code(1)
tff(fact_1789_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z2: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),W),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z1),Z2)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z1)),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z2)) ) ).

% int_distrib(4)
tff(fact_1790_int__distrib_I3_J,axiom,
    ! [Z1: int,Z2: int,W: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z1),Z2)),W) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Z1),W)),aa(int,int,aa(int,fun(int,int),times_times(int),Z2),W)) ) ).

% int_distrib(3)
tff(fact_1791_int__diff__cases,axiom,
    ! [Z: int] :
      ~ ! [M3: nat,N2: nat] : ( Z != aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),M3)),aa(nat,int,semiring_1_of_nat(int),N2)) ) ).

% int_diff_cases
tff(fact_1792_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),K),aa(int,int,aa(int,fun(int,int),minus_minus(int),M),N)))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),K),N))
       => pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),K),M)) ) ) ).

% zdvd_zdiffD
tff(fact_1793_signed__take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)) ) ).

% signed_take_bit_diff
tff(fact_1794_int__le__induct,axiom,
    ! [I: int,K: int,P: fun(int,bool)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),K))
     => ( pp(aa(int,bool,P,K))
       => ( ! [I3: int] :
              ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I3),K))
             => ( pp(aa(int,bool,P,I3))
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I3),one_one(int)))) ) )
         => pp(aa(int,bool,P,I)) ) ) ) ).

% int_le_induct
tff(fact_1795_int__less__induct,axiom,
    ! [I: int,K: int,P: fun(int,bool)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I),K))
     => ( pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int))))
       => ( ! [I3: int] :
              ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I3),K))
             => ( pp(aa(int,bool,P,I3))
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I3),one_one(int)))) ) )
         => pp(aa(int,bool,P,I)) ) ) ) ).

% int_less_induct
tff(fact_1796_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X3: product_prod(vEBT_VEBT,nat)] :
      ( ! [Uu2: bool,Uv2: bool,D3: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),D3) )
     => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT,Deg3: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg2,TreeList2,Summary2)),Deg3) ) ) ).

% VEBT_internal.valid'.cases
tff(fact_1797_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y4: extended_enat,X3: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),Z),Y4))
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X3),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Y4),Z)) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X3),Y4)),Z) ) ) ).

% add_diff_assoc_enat
tff(fact_1798_Bolzano,axiom,
    ! [A3: real,B2: real,P: fun(real,fun(real,bool))] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
     => ( ! [A5: real,B5: real,C3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),P,A5),B5))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),P,B5),C3))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A5),B5))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),B5),C3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),P,A5),C3)) ) ) ) )
       => ( ! [X2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
               => ? [D6: real] :
                    ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D6))
                    & ! [A5: real,B5: real] :
                        ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A5),X2))
                          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B5))
                          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B5),A5)),D6)) )
                       => pp(aa(real,bool,aa(real,fun(real,bool),P,A5),B5)) ) ) ) )
         => pp(aa(real,bool,aa(real,fun(real,bool),P,A3),B2)) ) ) ) ).

% Bolzano
tff(fact_1799_plusinfinity,axiom,
    ! [D2: int,P3: fun(int,bool),P: fun(int,bool)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D2))
     => ( ! [X2: int,K2: int] :
            ( pp(aa(int,bool,P3,X2))
          <=> pp(aa(int,bool,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2)))) )
       => ( ? [Z3: int] :
            ! [X2: int] :
              ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z3),X2))
             => ( pp(aa(int,bool,P,X2))
              <=> pp(aa(int,bool,P3,X2)) ) )
         => ( ? [X_1: int] : pp(aa(int,bool,P3,X_1))
           => ? [X_13: int] : pp(aa(int,bool,P,X_13)) ) ) ) ) ).

% plusinfinity
tff(fact_1800_minusinfinity,axiom,
    ! [D2: int,P1: fun(int,bool),P: fun(int,bool)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D2))
     => ( ! [X2: int,K2: int] :
            ( pp(aa(int,bool,P1,X2))
          <=> pp(aa(int,bool,P1,aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2)))) )
       => ( ? [Z3: int] :
            ! [X2: int] :
              ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X2),Z3))
             => ( pp(aa(int,bool,P,X2))
              <=> pp(aa(int,bool,P1,X2)) ) )
         => ( ? [X_1: int] : pp(aa(int,bool,P1,X_1))
           => ? [X_13: int] : pp(aa(int,bool,P,X_13)) ) ) ) ) ).

% minusinfinity
tff(fact_1801_int__induct,axiom,
    ! [P: fun(int,bool),K: int,I: int] :
      ( pp(aa(int,bool,P,K))
     => ( ! [I3: int] :
            ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),I3))
           => ( pp(aa(int,bool,P,I3))
             => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)))) ) )
       => ( ! [I3: int] :
              ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I3),K))
             => ( pp(aa(int,bool,P,I3))
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I3),one_one(int)))) ) )
         => pp(aa(int,bool,P,I)) ) ) ) ).

% int_induct
tff(fact_1802_int__ops_I6_J,axiom,
    ! [A3: nat,B2: nat] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2)))
       => ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A3),B2)) = zero_zero(int) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2)))
       => ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A3),B2)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ) ) ).

% int_ops(6)
tff(fact_1803_decr__mult__lemma,axiom,
    ! [D2: int,P: fun(int,bool),K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D2))
     => ( ! [X2: int] :
            ( pp(aa(int,bool,P,X2))
           => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),D2))) )
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
         => ! [X: int] :
              ( pp(aa(int,bool,P,X))
             => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K),D2)))) ) ) ) ) ).

% decr_mult_lemma
tff(fact_1804_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),L),K))
       => ( modulo_modulo(int,K,L) = modulo_modulo(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L),L) ) ) ) ).

% mod_pos_geq
tff(fact_1805_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X3: product_prod(vEBT_VEBT,nat)] :
      ( ! [A5: bool,B5: bool,X2: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A5,B5)),X2) )
     => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT,Ux2: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Ux2) )
       => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList2: list(vEBT_VEBT),S3: vEBT_VEBT,X2: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3)),X2) ) ) ) ).

% VEBT_internal.naive_member.cases
tff(fact_1806_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [X7: fun(A,B)] :
          ( ? [K6: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K6))
              & ! [N3: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N3))),K6)) )
        <=> ? [N6: nat] :
            ! [N3: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N3))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N6)))) ) ) ).

% lemma_NBseq_def2
tff(fact_1807_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [X7: fun(A,B)] :
          ( ? [K6: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K6))
              & ! [N3: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N3))),K6)) )
        <=> ? [N6: nat] :
            ! [N3: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N3))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N6)))) ) ) ).

% lemma_NBseq_def
tff(fact_1808_zdiff__int__split,axiom,
    ! [P: fun(int,bool),X3: nat,Y4: nat] :
      ( pp(aa(int,bool,P,aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X3),Y4))))
    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y4),X3))
         => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X3)),aa(nat,int,semiring_1_of_nat(int),Y4)))) )
        & ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),Y4))
         => pp(aa(int,bool,P,zero_zero(int))) ) ) ) ).

% zdiff_int_split
tff(fact_1809_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L))) ) ).

% even_diff_iff
tff(fact_1810_real__of__nat__div2,axiom,
    ! [N: nat,X3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,semiring_1_of_nat(real),X3))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),X3))))) ).

% real_of_nat_div2
tff(fact_1811_real__of__nat__div3,axiom,
    ! [N: nat,X3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,semiring_1_of_nat(real),X3))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),X3)))),one_one(real))) ).

% real_of_nat_div3
tff(fact_1812_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),L),K))
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)),L)),one_one(int)) ) ) ) ).

% div_pos_geq
tff(fact_1813_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),K))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),aa(nat,nat,suc,N))))) ) ).

% signed_take_bit_int_less_eq
tff(fact_1814_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X3: product_prod(vEBT_VEBT,nat)] :
      ( ! [Uu2: bool,Uv2: bool,Uw2: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Uw2) )
     => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT,Uz2: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Uz2) )
       => ( ! [Mi: nat,Ma2: nat,Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT,X2: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2)),X2) )
         => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list(vEBT_VEBT),Vc: vEBT_VEBT,X2: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc)),X2) )
           => ~ ! [V3: nat,TreeList2: list(vEBT_VEBT),Vd: vEBT_VEBT,X2: nat] : ( X3 != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd)),X2) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
tff(fact_1815_neg__zmod__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),zero_zero(int)))
     => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A3)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),B2),one_one(int)),A3))),one_one(int)) ) ) ).

% neg_zmod_mult_2
tff(fact_1816_real__average__minus__second,axiom,
    ! [B2: real,A3: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),B2),A3)),aa(num,real,numeral_numeral(real),bit0(one2)))),A3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)),aa(num,real,numeral_numeral(real),bit0(one2))) ) ).

% real_average_minus_second
tff(fact_1817_real__average__minus__first,axiom,
    ! [A3: real,B2: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),A3),B2)),aa(num,real,numeral_numeral(real),bit0(one2)))),A3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)),aa(num,real,numeral_numeral(real),bit0(one2))) ) ).

% real_average_minus_first
tff(fact_1818_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A3: A,W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),W))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A3)),aa(num,real,numeral_numeral(real),W)) ) ) ).

% norm_divide_numeral
tff(fact_1819_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A3: A,W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W))) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A3)),aa(num,real,numeral_numeral(real),W)) ) ) ).

% norm_mult_numeral2
tff(fact_1820_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [W: num,A3: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),W)),real_V7770717601297561774m_norm(A,A3)) ) ) ).

% norm_mult_numeral1
tff(fact_1821_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,X3)),zero_zero(real)))
        <=> ( X3 = zero_zero(A) ) ) ) ).

% norm_le_zero_iff
tff(fact_1822_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),real_V7770717601297561774m_norm(A,X3)))
        <=> ( X3 != zero_zero(A) ) ) ) ).

% zero_less_norm_iff
tff(fact_1823_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] :
          ( ( real_V7770717601297561774m_norm(A,X3) = zero_zero(real) )
        <=> ( X3 = zero_zero(A) ) ) ) ).

% norm_eq_zero
tff(fact_1824_norm__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( real_V7770717601297561774m_norm(A,zero_zero(A)) = zero_zero(real) ) ) ).

% norm_zero
tff(fact_1825_norm__numeral,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [W: num] : ( real_V7770717601297561774m_norm(A,aa(num,A,numeral_numeral(A),W)) = aa(num,real,numeral_numeral(real),W) ) ) ).

% norm_numeral
tff(fact_1826_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: A,B2: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A3)),real_V7770717601297561774m_norm(A,B2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)))) ) ).

% norm_diff_ineq
tff(fact_1827_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: A,B2: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A3)),real_V7770717601297561774m_norm(A,B2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))) ) ).

% norm_triangle_ineq2
tff(fact_1828_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] : ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),zero_zero(real))) ) ).

% norm_not_less_zero
tff(fact_1829_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),real_V7770717601297561774m_norm(A,X3))) ) ).

% norm_ge_zero
tff(fact_1830_norm__mult,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X3: A,Y4: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4)) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,Y4)) ) ) ).

% norm_mult
tff(fact_1831_norm__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A3: A,B2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A3)),real_V7770717601297561774m_norm(A,B2)) ) ) ).

% norm_divide
tff(fact_1832_norm__power,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X3: A,N: nat] : ( real_V7770717601297561774m_norm(A,aa(nat,A,power_power(A,X3),N)) = aa(nat,real,power_power(real,real_V7770717601297561774m_norm(A,X3)),N) ) ) ).

% norm_power
tff(fact_1833_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A3)),real_V7770717601297561774m_norm(A,B2)) ) ) ) ).

% nonzero_norm_divide
tff(fact_1834_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [W: A,N: nat,Z: A] :
          ( ( aa(nat,A,power_power(A,W),N) = aa(nat,A,power_power(A,Z),N) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => ( real_V7770717601297561774m_norm(A,W) = real_V7770717601297561774m_norm(A,Z) ) ) ) ) ).

% power_eq_imp_eq_norm
tff(fact_1835_norm__mult__less,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [X3: A,R2: real,Y4: A,S: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),R2))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Y4)),S))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),R2),S))) ) ) ) ).

% norm_mult_less
tff(fact_1836_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [X3: A,Y4: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,Y4)))) ) ).

% norm_mult_ineq
tff(fact_1837_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,Y4: A,E: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,Y4))),E))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4))),E)) ) ) ).

% norm_triangle_lt
tff(fact_1838_norm__add__less,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,R2: real,Y4: A,S: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),R2))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Y4)),S))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4))),aa(real,real,aa(real,fun(real,real),plus_plus(real),R2),S))) ) ) ) ).

% norm_add_less
tff(fact_1839_norm__add__leD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: A,B2: A,C2: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))),C2))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,B2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,A3)),C2))) ) ) ).

% norm_add_leD
tff(fact_1840_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,Y4: A,E: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,Y4))),E))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4))),E)) ) ) ).

% norm_triangle_le
tff(fact_1841_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,Y4: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,Y4)))) ) ).

% norm_triangle_ineq
tff(fact_1842_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: A,R2: real,B2: A,S: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,A3)),R2))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,B2)),S))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),R2),S))) ) ) ) ).

% norm_triangle_mono
tff(fact_1843_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X3: A,N: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,power_power(A,X3),N))),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(A,X3)),N))) ) ).

% norm_power_ineq
tff(fact_1844_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,Y4: A,E1: real,Z: A,E22: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4))),E1))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),Z))),E22))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22))) ) ) ) ).

% norm_diff_triangle_less
tff(fact_1845_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,Y4: A,E: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,Y4))),E))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4))),E)) ) ) ).

% norm_triangle_le_diff
tff(fact_1846_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,Y4: A,E1: real,Z: A,E22: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4))),E1))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),Z))),E22))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22))) ) ) ) ).

% norm_diff_triangle_le
tff(fact_1847_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: A,B2: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,A3)),real_V7770717601297561774m_norm(A,B2)))) ) ).

% norm_triangle_ineq4
tff(fact_1848_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,Y4: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,X3)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,Y4)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4))))) ) ).

% norm_triangle_sub
tff(fact_1849_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [W: A,N: nat] :
          ( ( aa(nat,A,power_power(A,W),N) = one_one(A) )
         => ( ( real_V7770717601297561774m_norm(A,W) = one_one(real) )
            | ( N = zero_zero(nat) ) ) ) ) ).

% power_eq_1_iff
tff(fact_1850_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: A,B2: A,C2: A,D2: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2))))) ) ).

% norm_diff_triangle_ineq
tff(fact_1851_square__norm__one,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X3: A] :
          ( ( aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(A) )
         => ( real_V7770717601297561774m_norm(A,X3) = one_one(real) ) ) ) ).

% square_norm_one
tff(fact_1852_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A,W: A,M: nat] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),one_one(real)))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,W)),one_one(real)))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,Z),M)),aa(nat,A,power_power(A,W),M)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),W))))) ) ) ) ).

% norm_power_diff
tff(fact_1853_artanh__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X3: A] : ( aa(A,A,artanh(A),X3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),X3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% artanh_def
tff(fact_1854_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list(A),Ys2: list(B)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys2))))
     => ( aa(nat,product_prod(A,B),nth(product_prod(A,B),product(A,B,Xs,Ys2)),N) = aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(list(B),nat,size_size(list(B)),Ys2)))),aa(nat,B,nth(B,Ys2),modulo_modulo(nat,N,aa(list(B),nat,size_size(list(B)),Ys2)))) ) ) ).

% product_nth
tff(fact_1855_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q2: int,R2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),B2),zero_zero(int)))
     => ( eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),A3),one_one(int)),B2,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A3)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2),aa(int,product_prod(int,int),product_Pair(int,int,Q2),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),R2)),one_one(int)))) ) ) ).

% neg_eucl_rel_int_mult_2
tff(fact_1856_triangle__def,axiom,
    ! [N: nat] : ( nat_triangle(N) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,N))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% triangle_def
tff(fact_1857_binomial__code,axiom,
    ! [N: nat,K: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),K))
       => ( aa(nat,nat,binomial(N),K) = zero_zero(nat) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),K))
       => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)))
           => ( aa(nat,nat,binomial(N),K) = aa(nat,nat,binomial(N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)))
           => ( aa(nat,nat,binomial(N),K) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),set_fo6178422350223883121st_nat(nat,times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)),one_one(nat)),N,one_one(nat))),semiring_char_0_fact(nat,K)) ) ) ) ) ) ).

% binomial_code
tff(fact_1858_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q2: int,R2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),B2))
     => ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A3)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2),aa(int,product_prod(int,int),product_Pair(int,int,Q2),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),R2)))) ) ) ).

% pos_eucl_rel_int_mult_2
tff(fact_1859_ln__inj__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
       => ( ( aa(real,real,ln_ln(real),X3) = aa(real,real,ln_ln(real),Y4) )
        <=> ( X3 = Y4 ) ) ) ) ).

% ln_inj_iff
tff(fact_1860_ln__less__cancel__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,ln_ln(real),X3)),aa(real,real,ln_ln(real),Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ) ) ).

% ln_less_cancel_iff
tff(fact_1861_triangle__0,axiom,
    nat_triangle(zero_zero(nat)) = zero_zero(nat) ).

% triangle_0
tff(fact_1862_ln__le__cancel__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,ln_ln(real),X3)),aa(real,real,ln_ln(real),Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ) ) ).

% ln_le_cancel_iff
tff(fact_1863_ln__eq__zero__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( ( aa(real,real,ln_ln(real),X3) = zero_zero(real) )
      <=> ( X3 = one_one(real) ) ) ) ).

% ln_eq_zero_iff
tff(fact_1864_ln__gt__zero__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X3)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3)) ) ) ).

% ln_gt_zero_iff
tff(fact_1865_ln__less__zero__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,ln_ln(real),X3)),zero_zero(real)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real))) ) ) ).

% ln_less_zero_iff
tff(fact_1866_ln__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,ln_ln(A),one_one(A)) = zero_zero(A) ) ) ).

% ln_one
tff(fact_1867_binomial__0__Suc,axiom,
    ! [K: nat] : ( aa(nat,nat,binomial(zero_zero(nat)),aa(nat,nat,suc,K)) = zero_zero(nat) ) ).

% binomial_0_Suc
tff(fact_1868_binomial__1,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(N),aa(nat,nat,suc,zero_zero(nat))) = N ) ).

% binomial_1
tff(fact_1869_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( aa(nat,nat,binomial(N),K) = zero_zero(nat) )
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),K)) ) ).

% binomial_eq_0_iff
tff(fact_1870_binomial__Suc__Suc,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),aa(nat,nat,suc,K))) ) ).

% binomial_Suc_Suc
tff(fact_1871_binomial__n__0,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(N),zero_zero(nat)) = one_one(nat) ) ).

% binomial_n_0
tff(fact_1872_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] : ( aa(list(product_prod(A,B)),nat,size_size(list(product_prod(A,B))),product(A,B,Xs,Ys2)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys2)) ) ).

% length_product
tff(fact_1873_triangle__Suc,axiom,
    ! [N: nat] : ( nat_triangle(aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(N)),aa(nat,nat,suc,N)) ) ).

% triangle_Suc
tff(fact_1874_ln__ge__zero__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X3)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3)) ) ) ).

% ln_ge_zero_iff
tff(fact_1875_ln__le__zero__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,ln_ln(real),X3)),zero_zero(real)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real))) ) ) ).

% ln_le_zero_iff
tff(fact_1876_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,binomial(N),K)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N)) ) ).

% zero_less_binomial_iff
tff(fact_1877_unique__quotient,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int,Q3: int,R3: int] :
      ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2))
     => ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q3),R3))
       => ( Q2 = Q3 ) ) ) ).

% unique_quotient
tff(fact_1878_unique__remainder,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int,Q3: int,R3: int] :
      ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2))
     => ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q3),R3))
       => ( R2 = R3 ) ) ) ).

% unique_remainder
tff(fact_1879_eucl__rel__int__by0,axiom,
    ! [K: int] : eucl_rel_int(K,zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),K)) ).

% eucl_rel_int_by0
tff(fact_1880_div__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R2: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = Q2 ) ) ).

% div_int_unique
tff(fact_1881_mod__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R2: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2))
     => ( modulo_modulo(int,K,L) = R2 ) ) ).

% mod_int_unique
tff(fact_1882_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),K))
     => ( aa(nat,nat,binomial(N),K) = zero_zero(nat) ) ) ).

% binomial_eq_0
tff(fact_1883_ln__less__self,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,ln_ln(real),X3)),X3)) ) ).

% ln_less_self
tff(fact_1884_Suc__times__binomial,axiom,
    ! [K: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,K))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,binomial(N),K)) ) ).

% Suc_times_binomial
tff(fact_1885_Suc__times__binomial__eq,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,binomial(N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,K))),aa(nat,nat,suc,K)) ) ).

% Suc_times_binomial_eq
tff(fact_1886_binomial__symmetric,axiom,
    ! [K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
     => ( aa(nat,nat,binomial(N),K) = aa(nat,nat,binomial(N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ).

% binomial_symmetric
tff(fact_1887_choose__mult__lemma,axiom,
    ! [M: nat,R2: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R2)),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R2)),K)),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R2)),M)) ) ).

% choose_mult_lemma
tff(fact_1888_binomial__le__pow,axiom,
    ! [R2: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),R2),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,binomial(N),R2)),aa(nat,nat,power_power(nat,N),R2))) ) ).

% binomial_le_pow
tff(fact_1889_ln__bound,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,ln_ln(real),X3)),X3)) ) ).

% ln_bound
tff(fact_1890_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,binomial(N),K))) ) ).

% zero_less_binomial
tff(fact_1891_ln__gt__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X3))) ) ).

% ln_gt_zero
tff(fact_1892_ln__less__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,ln_ln(real),X3)),zero_zero(real))) ) ) ).

% ln_less_zero
tff(fact_1893_ln__gt__zero__imp__gt__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X3)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3)) ) ) ).

% ln_gt_zero_imp_gt_one
tff(fact_1894_ln__ge__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X3))) ) ).

% ln_ge_zero
tff(fact_1895_Suc__times__binomial__add,axiom,
    ! [A3: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,A3)),aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2))),aa(nat,nat,suc,A3))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,B2)),aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2))),A3)) ) ).

% Suc_times_binomial_add
tff(fact_1896_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(N),M)),aa(nat,nat,binomial(M),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K))) ) ) ) ).

% choose_mult
tff(fact_1897_binomial__Suc__Suc__eq__times,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,binomial(N),K))),aa(nat,nat,suc,K)) ) ).

% binomial_Suc_Suc_eq_times
tff(fact_1898_binomial__absorb__comp,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)),aa(nat,nat,binomial(N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),K)) ) ).

% binomial_absorb_comp
tff(fact_1899_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q2: int] :
      ( ( L != zero_zero(int) )
     => ( ( K = aa(int,int,aa(int,fun(int,int),times_times(int),Q2),L) )
       => eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q2),zero_zero(int))) ) ) ).

% eucl_rel_int_dividesI
tff(fact_1900_eucl__rel__int,axiom,
    ! [K: int,L: int] : eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L)),modulo_modulo(int,K,L))) ).

% eucl_rel_int
tff(fact_1901_ln__ge__zero__imp__ge__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X3)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3)) ) ) ).

% ln_ge_zero_imp_ge_one
tff(fact_1902_ln__add__one__self__le__self,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3))),X3)) ) ).

% ln_add_one_self_le_self
tff(fact_1903_ln__mult,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
       => ( aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),times_times(real),X3),Y4)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,ln_ln(real),X3)),aa(real,real,ln_ln(real),Y4)) ) ) ) ).

% ln_mult
tff(fact_1904_binomial__absorption,axiom,
    ! [K: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),aa(nat,nat,binomial(N),aa(nat,nat,suc,K))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),K)) ) ).

% binomial_absorption
tff(fact_1905_ln__eq__minus__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( ( aa(real,real,ln_ln(real),X3) = aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),one_one(real)) )
       => ( X3 = one_one(real) ) ) ) ).

% ln_eq_minus_one
tff(fact_1906_ln__div,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
       => ( aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),Y4)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),X3)),aa(real,real,ln_ln(real),Y4)) ) ) ) ).

% ln_div
tff(fact_1907_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,K)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))),aa(nat,nat,binomial(N),K)) = semiring_char_0_fact(nat,N) ) ) ).

% binomial_fact_lemma
tff(fact_1908_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,A,semiring_1_of_nat(A),K))),K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K)))) ) ) ).

% binomial_ge_n_over_k_pow_k
tff(fact_1909_binomial__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),K7))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K7)),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),K7))) ) ) ).

% binomial_mono
tff(fact_1910_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),N))) ).

% binomial_maximum'
tff(fact_1911_ln__2__less__1,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,ln_ln(real),aa(num,real,numeral_numeral(real),bit0(one2)))),one_one(real))) ).

% ln_2_less_1
tff(fact_1912_binomial__maximum,axiom,
    ! [N: nat,K: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ).

% binomial_maximum
tff(fact_1913_binomial__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),K7))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))),K))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K7),N))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,binomial(N),K7)),aa(nat,nat,binomial(N),K))) ) ) ) ).

% binomial_antimono
tff(fact_1914_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ).

% binomial_le_pow2
tff(fact_1915_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => ( aa(nat,nat,binomial(N),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),K)) ) ) ) ).

% choose_reduce_nat
tff(fact_1916_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,binomial(N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ).

% times_binomial_minus1_eq
tff(fact_1917_ln__le__minus__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,ln_ln(real),X3)),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),one_one(real)))) ) ).

% ln_le_minus_one
tff(fact_1918_ln__diff__le,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),X3)),aa(real,real,ln_ln(real),Y4))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y4)),Y4))) ) ) ).

% ln_diff_le
tff(fact_1919_ln__realpow,axiom,
    ! [X3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(real,real,ln_ln(real),aa(nat,real,power_power(real,X3),N)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,ln_ln(real),X3)) ) ) ).

% ln_realpow
tff(fact_1920_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
     => ( aa(nat,nat,binomial(N),K) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,N)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,K)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))) ) ) ).

% binomial_altdef_nat
tff(fact_1921_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),K7))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K7)),N))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),K7))) ) ) ).

% binomial_strict_mono
tff(fact_1922_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),K7))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K7),N))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,binomial(N),K7)),aa(nat,nat,binomial(N),K))) ) ) ) ).

% binomial_strict_antimono
tff(fact_1923_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),aa(nat,nat,suc,K)))) ) ).

% binomial_less_binomial_Suc
tff(fact_1924_central__binomial__odd,axiom,
    ! [N: nat] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(nat,nat,binomial(N),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))))) = aa(nat,nat,binomial(N),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% central_binomial_odd
tff(fact_1925_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(nat,nat,binomial(N),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(nat,nat,suc,K))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),K)) ) ) ).

% binomial_addition_formula
tff(fact_1926_fact__binomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),semiring_char_0_fact(A,N)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_binomial
tff(fact_1927_binomial__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),semiring_char_0_fact(A,N)),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))) ) ) ) ).

% binomial_fact
tff(fact_1928_choose__two,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(N),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% choose_two
tff(fact_1929_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q2: int,R2: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2))
    <=> ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),Q2)),R2) )
        & ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),R2))
            & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R2),L)) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
         => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int)))
             => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),R2))
                & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),R2),zero_zero(int))) ) )
            & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int)))
             => ( Q2 = zero_zero(int) ) ) ) ) ) ) ).

% eucl_rel_int_iff
tff(fact_1930_ln__one__plus__pos__lower__bound,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3)))) ) ) ).

% ln_one_plus_pos_lower_bound
tff(fact_1931_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))),N)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N)))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),N)))) ) ).

% central_binomial_lower_bound
tff(fact_1932_tanh__ln__real,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(real,real,tanh(real),aa(real,real,ln_ln(real),X3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real))) ) ) ).

% tanh_ln_real
tff(fact_1933_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R2: int] : ( adjust_div(aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Q2),aa(bool,int,zero_neq_one_of_bool(int),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),fequal(int),R2),zero_zero(int))))) ) ).

% Divides.adjust_div_eq
tff(fact_1934_ln__one__minus__pos__lower__bound,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,uminus_uminus(real),X3)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),X3)))) ) ) ).

% ln_one_minus_pos_lower_bound
tff(fact_1935_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ) ) ).

% signed_take_bit_rec
tff(fact_1936_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3))),X3))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% abs_ln_one_plus_x_minus_x_bound
tff(fact_1937_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X3: fun(A,nat),X22: A] : ( size_option(A,X3,some(A,X22)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,X3,X22)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% option.size_gen(2)
tff(fact_1938_set__decode__Suc,axiom,
    ! [N: nat,X3: nat] :
      ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),aa(nat,nat,suc,N)),nat_set_decode(X3)))
    <=> pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N),nat_set_decode(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% set_decode_Suc
tff(fact_1939_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),A3)) = A3 ) ) ).

% add.inverse_inverse
tff(fact_1940_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,uminus_uminus(A),B2) )
        <=> ( A3 = B2 ) ) ) ).

% neg_equal_iff_equal
tff(fact_1941_verit__minus__simplify_I4_J,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [B2: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,uminus_uminus(B),B2)) = B2 ) ) ).

% verit_minus_simplify(4)
tff(fact_1942_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A3)) = aa(A,A,abs_abs(A),A3) ) ) ).

% abs_idempotent
tff(fact_1943_abs__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A3)) = aa(A,A,abs_abs(A),A3) ) ) ).

% abs_abs
tff(fact_1944_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% neg_le_iff_le
tff(fact_1945_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = A3 )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% neg_equal_zero
tff(fact_1946_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( ( A3 = aa(A,A,uminus_uminus(A),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% equal_neg_zero
tff(fact_1947_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% neg_equal_0_iff_equal
tff(fact_1948_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),A3) )
        <=> ( zero_zero(A) = A3 ) ) ) ).

% neg_0_equal_iff_equal
tff(fact_1949_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ( aa(A,A,uminus_uminus(A),zero_zero(A)) = zero_zero(A) ) ) ).

% add.inverse_neutral
tff(fact_1950_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% neg_less_iff_less
tff(fact_1951_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,N: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) )
        <=> ( M = N ) ) ) ).

% neg_numeral_eq_iff
tff(fact_1952_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) ) ) ).

% mult_minus_right
tff(fact_1953_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) ) ) ).

% minus_mult_minus
tff(fact_1954_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A3)),B2) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) ) ) ).

% mult_minus_left
tff(fact_1955_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_add_distrib
tff(fact_1956_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = B2 ) ) ).

% minus_add_cancel
tff(fact_1957_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),B2)) = B2 ) ) ).

% add_minus_cancel
tff(fact_1958_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3) ) ) ).

% minus_diff_eq
tff(fact_1959_div__minus__minus,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ).

% div_minus_minus
tff(fact_1960_abs__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_0
tff(fact_1961_abs__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_zero
tff(fact_1962_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( ( aa(A,A,abs_abs(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% abs_eq_0
tff(fact_1963_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( ( zero_zero(A) = aa(A,A,abs_abs(A),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% abs_0_eq
tff(fact_1964_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),aa(A,A,uminus_uminus(A),Y4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),Y4)) ) ) ).

% dvd_minus_iff
tff(fact_1965_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,uminus_uminus(A),X3)),Y4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),Y4)) ) ) ).

% minus_dvd_iff
tff(fact_1966_abs__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : ( aa(A,A,abs_abs(A),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),N) ) ) ).

% abs_numeral
tff(fact_1967_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3) ) ) ).

% abs_mult_self_eq
tff(fact_1968_abs__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_1
tff(fact_1969_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_add_abs
tff(fact_1970_abs__divide,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A3: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_divide
tff(fact_1971_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A3)) = aa(A,A,abs_abs(A),A3) ) ) ).

% abs_minus_cancel
tff(fact_1972_abs__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A3)) = aa(A,A,abs_abs(A),A3) ) ) ).

% abs_minus
tff(fact_1973_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A] : ( modulo_modulo(A,aa(A,A,uminus_uminus(A),A3),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A3,B2)) ) ) ).

% mod_minus_minus
tff(fact_1974_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,abs_abs(A),M)),K))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),M),K)) ) ) ).

% abs_dvd_iff
tff(fact_1975_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),M),aa(A,A,abs_abs(A),K)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),M),K)) ) ) ).

% dvd_abs_iff
tff(fact_1976_abs__of__nat,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,semiring_1_of_nat(A),N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ).

% abs_of_nat
tff(fact_1977_negative__eq__positive,axiom,
    ! [N: nat,M: nat] :
      ( ( aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) = aa(nat,int,semiring_1_of_nat(int),M) )
    <=> ( ( N = zero_zero(nat) )
        & ( M = zero_zero(nat) ) ) ) ).

% negative_eq_positive
tff(fact_1978_negative__zle,axiom,
    ! [N: nat,M: nat] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N))),aa(nat,int,semiring_1_of_nat(int),M))) ).

% negative_zle
tff(fact_1979_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: bool] : ( aa(A,A,abs_abs(A),aa(bool,A,zero_neq_one_of_bool(A),P)) = aa(bool,A,zero_neq_one_of_bool(A),P) ) ) ).

% abs_bool_eq
tff(fact_1980_tanh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,tanh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% tanh_0
tff(fact_1981_tanh__real__zero__iff,axiom,
    ! [X3: real] :
      ( ( aa(real,real,tanh(real),X3) = zero_zero(real) )
    <=> ( X3 = zero_zero(real) ) ) ).

% tanh_real_zero_iff
tff(fact_1982_tanh__real__less__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,tanh(real),X3)),aa(real,real,tanh(real),Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ).

% tanh_real_less_iff
tff(fact_1983_tanh__real__le__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,tanh(real),X3)),aa(real,real,tanh(real),Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ).

% tanh_real_le_iff
tff(fact_1984_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% neg_less_eq_nonneg
tff(fact_1985_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% less_eq_neg_nonpos
tff(fact_1986_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% neg_le_0_iff_le
tff(fact_1987_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% neg_0_le_iff_le
tff(fact_1988_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% neg_less_0_iff_less
tff(fact_1989_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% neg_0_less_iff_less
tff(fact_1990_neg__less__pos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A3)),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% neg_less_pos
tff(fact_1991_less__neg__neg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% less_neg_neg
tff(fact_1992_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,uminus_uminus(A),A3)) = zero_zero(A) ) ) ).

% add.right_inverse
tff(fact_1993_ab__left__minus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),A3) = zero_zero(A) ) ) ).

% ab_left_minus
tff(fact_1994_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [B2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),zero_zero(B)),B2) = aa(B,B,uminus_uminus(B),B2) ) ) ).

% verit_minus_simplify(3)
tff(fact_1995_diff__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A3) = aa(A,A,uminus_uminus(A),A3) ) ) ).

% diff_0
tff(fact_1996_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N))) ) ) ).

% add_neg_numeral_simps(3)
tff(fact_1997_mult__minus1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),one_one(A))),Z) = aa(A,A,uminus_uminus(A),Z) ) ) ).

% mult_minus1
tff(fact_1998_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),Z) ) ) ).

% mult_minus1_right
tff(fact_1999_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),zero_zero(A)))
        <=> ( A3 = zero_zero(A) ) ) ) ).

% abs_le_zero_iff
tff(fact_2000_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% abs_le_self_iff
tff(fact_2001_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( aa(A,A,abs_abs(A),A3) = A3 ) ) ) ).

% abs_of_nonneg
tff(fact_2002_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3) ) ) ).

% uminus_add_conv_diff
tff(fact_2003_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) ) ) ).

% diff_minus_eq_add
tff(fact_2004_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,abs_abs(A),A3)))
        <=> ( A3 != zero_zero(A) ) ) ) ).

% zero_less_abs_iff
tff(fact_2005_divide__minus1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),X3) ) ) ).

% divide_minus1
tff(fact_2006_div__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),A3) ) ) ).

% div_minus1_right
tff(fact_2007_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),N) ) ) ).

% abs_neg_numeral
tff(fact_2008_abs__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),one_one(A))) = one_one(A) ) ) ).

% abs_neg_one
tff(fact_2009_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [B2: A,A3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A3),B2) ) ) ).

% minus_mod_self1
tff(fact_2010_abs__power__minus,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),N)) = aa(A,A,abs_abs(A),aa(nat,A,power_power(A,A3),N)) ) ) ).

% abs_power_minus
tff(fact_2011_negative__zless,axiom,
    ! [N: nat,M: nat] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N)))),aa(nat,int,semiring_1_of_nat(int),M))) ).

% negative_zless
tff(fact_2012_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% signed_take_bit_of_minus_1
tff(fact_2013_real__add__minus__iff,axiom,
    ! [X3: real,A3: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,uminus_uminus(real),A3)) = zero_zero(real) )
    <=> ( X3 = A3 ) ) ).

% real_add_minus_iff
tff(fact_2014_tanh__real__pos__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,tanh(real),X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3)) ) ).

% tanh_real_pos_iff
tff(fact_2015_tanh__real__neg__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,tanh(real),X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real))) ) ).

% tanh_real_neg_iff
tff(fact_2016_tanh__real__nonpos__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,tanh(real),X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real))) ) ).

% tanh_real_nonpos_iff
tff(fact_2017_tanh__real__nonneg__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,tanh(real),X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3)) ) ).

% tanh_real_nonneg_iff
tff(fact_2018_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_simps(1)
tff(fact_2019_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = zero_zero(A) ) ) ).

% add_neg_numeral_special(8)
tff(fact_2020_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% add_neg_numeral_special(7)
tff(fact_2021_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% diff_numeral_special(12)
tff(fact_2022_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
tff(fact_2023_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] :
          ( ( aa(A,A,uminus_uminus(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) )
        <=> ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
tff(fact_2024_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,abs_abs(A),B2))))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
            | ( B2 = zero_zero(A) ) ) ) ) ).

% zero_le_divide_abs_iff
tff(fact_2025_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,abs_abs(A),B2))),zero_zero(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divide_le_0_abs_iff
tff(fact_2026_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( aa(A,A,abs_abs(A),A3) = aa(A,A,uminus_uminus(A),A3) ) ) ) ).

% abs_of_nonpos
tff(fact_2027_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N)) = one_one(A) ) ) ).

% minus_one_mult_self
tff(fact_2028_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N)),A3)) = A3 ) ) ).

% left_minus_one_mult_self
tff(fact_2029_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A] : ( modulo_modulo(A,A3,aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% mod_minus1_right
tff(fact_2030_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = aa(num,real,numeral_numeral(real),W) ) ) ).

% norm_neg_numeral
tff(fact_2031_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),W)))),Y4) ) ) ).

% semiring_norm(168)
tff(fact_2032_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ) ).

% diff_numeral_simps(2)
tff(fact_2033_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N))) ) ) ).

% diff_numeral_simps(3)
tff(fact_2034_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W))),Y4) ) ) ).

% semiring_norm(172)
tff(fact_2035_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W)))),Y4) ) ) ).

% semiring_norm(171)
tff(fact_2036_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Y4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W)))),Y4) ) ) ).

% semiring_norm(170)
tff(fact_2037_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ) ).

% mult_neg_numeral_simps(3)
tff(fact_2038_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ) ).

% mult_neg_numeral_simps(2)
tff(fact_2039_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),N)) ) ) ).

% mult_neg_numeral_simps(1)
tff(fact_2040_artanh__minus__real,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( aa(real,real,artanh(real),aa(real,real,uminus_uminus(real),X3)) = aa(real,real,uminus_uminus(real),aa(real,real,artanh(real),X3)) ) ) ).

% artanh_minus_real
tff(fact_2041_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),N),M)) ) ) ).

% neg_numeral_le_iff
tff(fact_2042_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),N),M)) ) ) ).

% neg_numeral_less_iff
tff(fact_2043_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))))
        <=> ( M != one2 ) ) ) ).

% not_neg_one_le_neg_numeral_iff
tff(fact_2044_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))) ) ) ).

% le_divide_eq_numeral1(2)
tff(fact_2045_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),B2)) ) ) ).

% divide_le_eq_numeral1(2)
tff(fact_2046_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,W: num] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) )
        <=> ( ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = B2 ) )
            & ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
tff(fact_2047_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W: num,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = A3 )
        <=> ( ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) )
            & ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
tff(fact_2048_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))))
        <=> ( M != one2 ) ) ) ).

% neg_numeral_less_neg_one_iff
tff(fact_2049_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))) ) ) ).

% less_divide_eq_numeral1(2)
tff(fact_2050_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),B2)) ) ) ).

% divide_less_eq_numeral1(2)
tff(fact_2051_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A3)),N)))
        <=> ( ( A3 != zero_zero(A) )
            | ( N = zero_zero(nat) ) ) ) ) ).

% zero_less_power_abs_iff
tff(fact_2052_power2__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% power2_minus
tff(fact_2053_power2__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] : ( aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% power2_abs
tff(fact_2054_abs__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% abs_power2
tff(fact_2055_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% add_neg_numeral_special(9)
tff(fact_2056_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% diff_numeral_special(10)
tff(fact_2057_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),bit0(one2)) ) ) ).

% diff_numeral_special(11)
tff(fact_2058_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% minus_1_div_2_eq
tff(fact_2059_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ).

% bits_minus_1_mod_2_eq
tff(fact_2060_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ).

% minus_1_mod_2_eq
tff(fact_2061_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ) ).

% Power.ring_1_class.power_minus_even
tff(fact_2062_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),N) = aa(nat,A,power_power(A,A3),N) ) ) ) ).

% Parity.ring_1_class.power_minus_even
tff(fact_2063_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat,A3: A] :
          ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),N) = aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,A3),N)) ) ) ) ).

% power_minus_odd
tff(fact_2064_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: num,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W)))
         => ( aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A3)),aa(num,nat,numeral_numeral(nat),W)) = aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),W)) ) ) ) ).

% power_even_abs_numeral
tff(fact_2065_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),one2))) ) ) ).

% diff_numeral_special(4)
tff(fact_2066_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% diff_numeral_special(3)
tff(fact_2067_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% signed_take_bit_Suc_minus_bit0
tff(fact_2068_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% dbl_simps(4)
tff(fact_2069_set__decode__0,axiom,
    ! [X3: nat] :
      ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),nat_set_decode(X3)))
    <=> ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),X3)) ) ).

% set_decode_0
tff(fact_2070_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = one_one(A) ) ) ).

% power_minus1_even
tff(fact_2071_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N) = one_one(A) ) ) ) ).

% neg_one_even_power
tff(fact_2072_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% neg_one_odd_power
tff(fact_2073_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,zero_zero(nat)),A3) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% signed_take_bit_0
tff(fact_2074_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,abs_abs(A),A3))) ) ).

% abs_ge_minus_self
tff(fact_2075_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),B2)) ) ) ) ).

% abs_le_iff
tff(fact_2076_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),B2)) ) ) ).

% abs_le_D2
tff(fact_2077_abs__leI,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),B2)) ) ) ) ).

% abs_leI
tff(fact_2078_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A3) ) ) ) ).

% equation_minus_iff
tff(fact_2079_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = B2 )
        <=> ( aa(A,A,uminus_uminus(A),B2) = A3 ) ) ) ).

% minus_equation_iff
tff(fact_2080_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
         => ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,uminus_uminus(A),B2) ) ) ) ).

% verit_negate_coefficient(3)
tff(fact_2081_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,abs_abs(A),X3) = aa(A,A,abs_abs(A),Y4) )
        <=> ( ( X3 = Y4 )
            | ( X3 = aa(A,A,uminus_uminus(A),Y4) ) ) ) ) ).

% abs_eq_iff
tff(fact_2082_abs__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),A3)),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A3)),B2)) ) ) ) ).

% abs_less_iff
tff(fact_2083_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,abs_abs(A),A3))),zero_zero(A))) ) ).

% abs_minus_le_zero
tff(fact_2084_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,abs_abs(A),B2) )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
            & ( ( B2 = A3 )
              | ( B2 = aa(A,A,uminus_uminus(A),A3) ) ) ) ) ) ).

% eq_abs_iff'
tff(fact_2085_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,abs_abs(A),A3) = B2 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
            & ( ( A3 = B2 )
              | ( A3 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ) ).

% abs_eq_iff'
tff(fact_2086_abs__if,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [A3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
           => ( aa(A,A,abs_abs(A),A3) = aa(A,A,uminus_uminus(A),A3) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
           => ( aa(A,A,abs_abs(A),A3) = A3 ) ) ) ) ).

% abs_if
tff(fact_2087_abs__if__raw,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [X: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),zero_zero(A)))
           => ( aa(A,A,abs_abs(A),X) = aa(A,A,uminus_uminus(A),X) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),zero_zero(A)))
           => ( aa(A,A,abs_abs(A),X) = X ) ) ) ) ).

% abs_if_raw
tff(fact_2088_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( aa(A,A,abs_abs(A),A3) = aa(A,A,uminus_uminus(A),A3) ) ) ) ).

% abs_of_neg
tff(fact_2089_abs__real__def,axiom,
    ! [A3: real] :
      ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),zero_zero(real)))
       => ( aa(real,real,abs_abs(real),A3) = aa(real,real,uminus_uminus(real),A3) ) )
      & ( ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),zero_zero(real)))
       => ( aa(real,real,abs_abs(real),A3) = A3 ) ) ) ).

% abs_real_def
tff(fact_2090_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% abs_le_D1
tff(fact_2091_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,abs_abs(A),A3))) ) ).

% abs_ge_self
tff(fact_2092_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] :
          ( ( aa(A,A,abs_abs(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% abs_eq_0_iff
tff(fact_2093_abs__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_mult
tff(fact_2094_abs__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_one
tff(fact_2095_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) ) ) ).

% abs_minus_commute
tff(fact_2096_tanh__real__gt__neg1,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(real,real,tanh(real),X3))) ).

% tanh_real_gt_neg1
tff(fact_2097_power__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,power_power(A,A3),N)) = aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A3)),N) ) ) ).

% power_abs
tff(fact_2098_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [L: A,K: A] :
          ( ( aa(A,A,abs_abs(A),L) = aa(A,A,abs_abs(A),K) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),L),K)) ) ) ).

% dvd_if_abs_eq
tff(fact_2099_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,uminus_uminus(A),A3))) ) ) ).

% le_minus_iff
tff(fact_2100_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),A3)) ) ) ).

% minus_le_iff
tff(fact_2101_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3))) ) ) ).

% le_imp_neg_le
tff(fact_2102_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3))) ) ) ).

% verit_negate_coefficient(2)
tff(fact_2103_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A3)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),A3)) ) ) ).

% minus_less_iff
tff(fact_2104_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,uminus_uminus(A),A3))) ) ) ).

% less_minus_iff
tff(fact_2105_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,N: num] : ( aa(num,A,numeral_numeral(A),M) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% numeral_neq_neg_numeral
tff(fact_2106_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,N: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) != aa(num,A,numeral_numeral(A),N) ) ) ).

% neg_numeral_neq_numeral
tff(fact_2107_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A3)),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_mult_commute
tff(fact_2108_square__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),B2) )
        <=> ( ( A3 = B2 )
            | ( A3 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% square_eq_iff
tff(fact_2109_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( one_one(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% one_neq_neg_one
tff(fact_2110_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3)) ) ) ).

% is_num_normalize(8)
tff(fact_2111_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3)) ) ) ).

% add.inverse_distrib_swap
tff(fact_2112_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,K: A,A3: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A3) )
         => ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,uminus_uminus(A),A3)) ) ) ) ).

% group_cancel.neg1
tff(fact_2113_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),B2)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A3)),B2) ) ) ).

% minus_diff_commute
tff(fact_2114_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) ) ) ).

% minus_diff_minus
tff(fact_2115_div__minus__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A3)),B2) ) ) ).

% div_minus_right
tff(fact_2116_minus__divide__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A3)),B2) ) ) ).

% minus_divide_left
tff(fact_2117_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ).

% minus_divide_divide
tff(fact_2118_minus__divide__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_divide_right
tff(fact_2119_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A] : ( modulo_modulo(A,aa(A,A,uminus_uminus(A),modulo_modulo(A,A3,B2)),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A3),B2) ) ) ).

% mod_minus_eq
tff(fact_2120_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A,A4: A] :
          ( ( modulo_modulo(A,A3,B2) = modulo_modulo(A,A4,B2) )
         => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),A3),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A4),B2) ) ) ) ).

% mod_minus_cong
tff(fact_2121_mod__minus__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A] : ( modulo_modulo(A,A3,aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),modulo_modulo(A,aa(A,A,uminus_uminus(A),A3),B2)) ) ) ).

% mod_minus_right
tff(fact_2122_uminus__int__code_I1_J,axiom,
    aa(int,int,uminus_uminus(int),zero_zero(int)) = zero_zero(int) ).

% uminus_int_code(1)
tff(fact_2123_int__cases2,axiom,
    ! [Z: int] :
      ( ! [N2: nat] : ( Z != aa(nat,int,semiring_1_of_nat(int),N2) )
     => ~ ! [N2: nat] : ( Z != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) ) ) ).

% int_cases2
tff(fact_2124_signed__take__bit__minus,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,uminus_uminus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,uminus_uminus(int),K)) ) ).

% signed_take_bit_minus
tff(fact_2125_subset__decode__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),nat_set_decode(M)),nat_set_decode(N)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% subset_decode_imp_le
tff(fact_2126_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,abs_abs(A),A3))) ) ).

% abs_ge_zero
tff(fact_2127_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),A3)),zero_zero(A))) ) ).

% abs_not_less_zero
tff(fact_2128_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( aa(A,A,abs_abs(A),A3) = A3 ) ) ) ).

% abs_of_pos
tff(fact_2129_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)))) ) ).

% abs_triangle_ineq
tff(fact_2130_abs__mult__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),A3)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),B2)),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2))) ) ) ) ).

% abs_mult_less
tff(fact_2131_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)))) ) ).

% abs_triangle_ineq2_sym
tff(fact_2132_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))) ) ).

% abs_triangle_ineq3
tff(fact_2133_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))) ) ).

% abs_triangle_ineq2
tff(fact_2134_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% nonzero_abs_divide
tff(fact_2135_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N))) ) ).

% neg_numeral_le_numeral
tff(fact_2136_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)))) ) ).

% not_numeral_le_neg_numeral
tff(fact_2137_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( zero_zero(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% zero_neq_neg_numeral
tff(fact_2138_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)))) ) ).

% not_numeral_less_neg_numeral
tff(fact_2139_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N))) ) ).

% neg_numeral_less_numeral
tff(fact_2140_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% le_minus_one_simps(4)
tff(fact_2141_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A))) ) ).

% le_minus_one_simps(2)
tff(fact_2142_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( zero_zero(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% zero_neq_neg_one
tff(fact_2143_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = zero_zero(A) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A3) ) ) ) ).

% add_eq_0_iff
tff(fact_2144_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),A3) = zero_zero(A) ) ) ).

% ab_group_add_class.ab_left_minus
tff(fact_2145_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),A3) = B2 ) ) ) ).

% add.inverse_unique
tff(fact_2146_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = zero_zero(A) ) ) ) ).

% eq_neg_iff_add_eq_0
tff(fact_2147_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = zero_zero(A) ) ) ) ).

% neg_eq_iff_add_eq_0
tff(fact_2148_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% less_minus_one_simps(4)
tff(fact_2149_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A))) ) ).

% less_minus_one_simps(2)
tff(fact_2150_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [W: num,X3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,uminus_uminus(A),X3)) = aa(A,A,aa(A,fun(A,A),times_times(A),X3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) ) ).

% numeral_times_minus_swap
tff(fact_2151_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) ) ) ) ).

% nonzero_minus_divide_divide
tff(fact_2152_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% nonzero_minus_divide_right
tff(fact_2153_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),N) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% numeral_neq_neg_one
tff(fact_2154_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( one_one(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% one_neq_neg_numeral
tff(fact_2155_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [X3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X3),X3) = one_one(A) )
        <=> ( ( X3 = one_one(A) )
            | ( X3 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% square_eq_1_iff
tff(fact_2156_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
tff(fact_2157_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% diff_conv_add_uminus
tff(fact_2158_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) ) ) ) ).

% group_cancel.sub2
tff(fact_2159_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) ) ) ) ).

% dvd_div_neg
tff(fact_2160_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A3)),B2) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) ) ) ) ).

% dvd_neg_div
tff(fact_2161_real__minus__mult__self__le,axiom,
    ! [U: real,X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),U),U))),aa(real,real,aa(real,fun(real,real),times_times(real),X3),X3))) ).

% real_minus_mult_self_le
tff(fact_2162_int__cases,axiom,
    ! [Z: int] :
      ( ! [N2: nat] : ( Z != aa(nat,int,semiring_1_of_nat(int),N2) )
     => ~ ! [N2: nat] : ( Z != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N2))) ) ) ).

% int_cases
tff(fact_2163_int__of__nat__induct,axiom,
    ! [P: fun(int,bool),Z: int] :
      ( ! [N2: nat] : pp(aa(int,bool,P,aa(nat,int,semiring_1_of_nat(int),N2)))
     => ( ! [N2: nat] : pp(aa(int,bool,P,aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N2)))))
       => pp(aa(int,bool,P,Z)) ) ) ).

% int_of_nat_induct
tff(fact_2164_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),N) = one_one(int) )
     => ( ( M = one_one(int) )
        | ( M = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
tff(fact_2165_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),N) = one_one(int) )
    <=> ( ( ( M = one_one(int) )
          & ( N = one_one(int) ) )
        | ( ( M = aa(int,int,uminus_uminus(int),one_one(int)) )
          & ( N = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ) ).

% zmult_eq_1_iff
tff(fact_2166_minus__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),zero_zero(int)),L) = aa(int,int,uminus_uminus(int),L) ) ).

% minus_int_code(2)
tff(fact_2167_not__int__zless__negative,axiom,
    ! [N: nat,M: nat] : ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),M)))) ).

% not_int_zless_negative
tff(fact_2168_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo(int,K,aa(int,int,uminus_uminus(int),L)) != zero_zero(int) )
     => ( modulo_modulo(int,K,L) != zero_zero(int) ) ) ).

% zmod_zminus2_not_zero
tff(fact_2169_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo(int,aa(int,int,uminus_uminus(int),K),L) != zero_zero(int) )
     => ( modulo_modulo(int,K,L) != zero_zero(int) ) ) ).

% zmod_zminus1_not_zero
tff(fact_2170_minus__real__def,axiom,
    ! [X3: real,Y4: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y4) = aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,uminus_uminus(real),Y4)) ) ).

% minus_real_def
tff(fact_2171_tanh__real__lt__1,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,tanh(real),X3)),one_one(real))) ).

% tanh_real_lt_1
tff(fact_2172_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs(A)
        & dense_linorder(A) )
     => ! [X3: A] :
          ( ! [E2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),E2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X3)),E2)) )
         => ( X3 = zero_zero(A) ) ) ) ).

% dense_eq0_I
tff(fact_2173_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),Y4)),X3) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),X3)) ) ) ) ).

% abs_mult_pos
tff(fact_2174_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ordered_ring_abs(A)
     => ! [A3: A,B2: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
              | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) ) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% abs_eq_mult
tff(fact_2175_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A3)),N))) ) ).

% zero_le_power_abs
tff(fact_2176_abs__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y4))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),X3)),Y4) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4)) ) ) ) ).

% abs_div_pos
tff(fact_2177_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,A3: A,R2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A3))),R2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),R2)),X3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),R2))) ) ) ) ).

% abs_diff_le_iff
tff(fact_2178_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)))) ) ).

% abs_triangle_ineq4
tff(fact_2179_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A,C2: A,D2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2))))) ) ).

% abs_diff_triangle_ineq
tff(fact_2180_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,A3: A,R2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A3))),R2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),R2)),X3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),R2))) ) ) ) ).

% abs_diff_less_iff
tff(fact_2181_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)))) ) ).

% not_zero_le_neg_numeral
tff(fact_2182_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))),zero_zero(A))) ) ).

% neg_numeral_le_zero
tff(fact_2183_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)))) ) ).

% not_zero_less_neg_numeral
tff(fact_2184_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))),zero_zero(A))) ) ).

% neg_numeral_less_zero
tff(fact_2185_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% le_minus_one_simps(3)
tff(fact_2186_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A))) ) ).

% le_minus_one_simps(1)
tff(fact_2187_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A))) ) ).

% less_minus_one_simps(1)
tff(fact_2188_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% less_minus_one_simps(3)
tff(fact_2189_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A))) ) ).

% neg_numeral_le_one
tff(fact_2190_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M))) ) ).

% neg_one_le_numeral
tff(fact_2191_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% neg_numeral_le_neg_one
tff(fact_2192_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% not_numeral_le_neg_one
tff(fact_2193_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)))) ) ).

% not_one_le_neg_numeral
tff(fact_2194_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)))) ) ).

% not_neg_one_less_neg_numeral
tff(fact_2195_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)))) ) ).

% not_one_less_neg_numeral
tff(fact_2196_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% not_numeral_less_neg_one
tff(fact_2197_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M))) ) ).

% neg_one_less_numeral
tff(fact_2198_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A))) ) ).

% neg_numeral_less_one
tff(fact_2199_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( C2 = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) = aa(A,A,uminus_uminus(A),A3) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
tff(fact_2200_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = C2 )
          <=> ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
tff(fact_2201_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = A3 )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% minus_divide_eq_eq
tff(fact_2202_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = aa(A,A,uminus_uminus(A),B2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% eq_minus_divide_eq
tff(fact_2203_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A3 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% divide_eq_minus_1_iff
tff(fact_2204_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))),B2) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(1)
tff(fact_2205_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(2)
tff(fact_2206_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% uminus_numeral_One
tff(fact_2207_power__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,power_power(A,A3),N)) ) ) ).

% power_minus
tff(fact_2208_lemma__interval__lt,axiom,
    ! [A3: real,X3: real,B2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),B2))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [Y5: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y5))),D3))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Y5))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y5),B2)) ) ) ) ) ) ).

% lemma_interval_lt
tff(fact_2209_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: A,K: num] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),X3)),aa(num,nat,numeral_numeral(nat),bit0(K))) = aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(K))) ) ) ).

% power_minus_Bit0
tff(fact_2210_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A,Y4: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),X3)),Y4)) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) ) ) ).

% norm_uminus_minus
tff(fact_2211_sin__bound__lemma,axiom,
    ! [X3: real,Y4: real,U: real,V: real] :
      ( ( X3 = Y4 )
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),U)),V))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),U)),Y4))),V)) ) ) ).

% sin_bound_lemma
tff(fact_2212_int__cases4,axiom,
    ! [M: int] :
      ( ! [N2: nat] : ( M != aa(nat,int,semiring_1_of_nat(int),N2) )
     => ~ ! [N2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
           => ( M != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) ) ) ) ).

% int_cases4
tff(fact_2213_real__add__less__0__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,uminus_uminus(real),X3))) ) ).

% real_add_less_0_iff
tff(fact_2214_real__0__less__add__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),X3)),Y4)) ) ).

% real_0_less_add_iff
tff(fact_2215_real__0__le__add__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),X3)),Y4)) ) ).

% real_0_le_add_iff
tff(fact_2216_real__add__le__0__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,uminus_uminus(real),X3))) ) ).

% real_add_le_0_iff
tff(fact_2217_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),M))))
    <=> ( ( N = zero_zero(nat) )
        & ( M = zero_zero(nat) ) ) ) ).

% int_zle_neg
tff(fact_2218_nonpos__int__cases,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),zero_zero(int)))
     => ~ ! [N2: nat] : ( K != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) ) ) ).

% nonpos_int_cases
tff(fact_2219_negative__zle__0,axiom,
    ! [N: nat] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N))),zero_zero(int))) ).

% negative_zle_0
tff(fact_2220_zmod__zminus2__eq__if,axiom,
    ! [A3: int,B2: int] :
      ( ( ( modulo_modulo(int,A3,B2) = zero_zero(int) )
       => ( modulo_modulo(int,A3,aa(int,int,uminus_uminus(int),B2)) = zero_zero(int) ) )
      & ( ( modulo_modulo(int,A3,B2) != zero_zero(int) )
       => ( modulo_modulo(int,A3,aa(int,int,uminus_uminus(int),B2)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),modulo_modulo(int,A3,B2)),B2) ) ) ) ).

% zmod_zminus2_eq_if
tff(fact_2221_zmod__zminus1__eq__if,axiom,
    ! [A3: int,B2: int] :
      ( ( ( modulo_modulo(int,A3,B2) = zero_zero(int) )
       => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),A3),B2) = zero_zero(int) ) )
      & ( ( modulo_modulo(int,A3,B2) != zero_zero(int) )
       => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),A3),B2) = aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),modulo_modulo(int,A3,B2)) ) ) ) ).

% zmod_zminus1_eq_if
tff(fact_2222_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,abs_abs(A),X3)))) ) ).

% abs_add_one_gt_zero
tff(fact_2223_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% pos_minus_divide_less_eq
tff(fact_2224_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% pos_less_minus_divide_eq
tff(fact_2225_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% neg_minus_divide_less_eq
tff(fact_2226_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% neg_less_minus_divide_eq
tff(fact_2227_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A3))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ) ) ) ) ).

% minus_divide_less_eq
tff(fact_2228_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ) ) ) ).

% less_minus_divide_eq
tff(fact_2229_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num,B2: A,C2: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2) = B2 ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
tff(fact_2230_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W: num] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
tff(fact_2231_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,A3: A,B2: A] :
          ( ( ( Z = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),Z))),B2) = B2 ) )
          & ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),Z))),B2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z) ) ) ) ) ).

% add_divide_eq_if_simps(3)
tff(fact_2232_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Z))),Y4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z))),Z) ) ) ) ).

% minus_divide_add_eq_iff
tff(fact_2233_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Z))),Y4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),Z))),Z) ) ) ) ).

% minus_divide_diff_eq_iff
tff(fact_2234_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,A3: A,B2: A] :
          ( ( ( Z = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),Z)),B2) = aa(A,A,uminus_uminus(A),B2) ) )
          & ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),Z)),B2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z) ) ) ) ) ).

% add_divide_eq_if_simps(5)
tff(fact_2235_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,A3: A,B2: A] :
          ( ( ( Z = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),Z))),B2) = aa(A,A,uminus_uminus(A),B2) ) )
          & ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),Z))),B2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z) ) ) ) ) ).

% add_divide_eq_if_simps(6)
tff(fact_2236_even__minus,axiom,
    ! [A: $tType] :
      ( ring_parity(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ).

% even_minus
tff(fact_2237_lemma__interval,axiom,
    ! [A3: real,X3: real,B2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),B2))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [Y5: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y5))),D3))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),Y5))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y5),B2)) ) ) ) ) ) ).

% lemma_interval
tff(fact_2238_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))) )
        <=> ( ( X3 = Y4 )
            | ( X3 = aa(A,A,uminus_uminus(A),Y4) ) ) ) ) ).

% power2_eq_iff
tff(fact_2239_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: A,B2: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A3)),real_V7770717601297561774m_norm(A,B2)))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))) ) ).

% norm_triangle_ineq3
tff(fact_2240_int__cases3,axiom,
    ! [K: int] :
      ( ( K != zero_zero(int) )
     => ( ! [N2: nat] :
            ( ( K = aa(nat,int,semiring_1_of_nat(int),N2) )
           => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2)) )
       => ~ ! [N2: nat] :
              ( ( K = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) )
             => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2)) ) ) ) ).

% int_cases3
tff(fact_2241_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer(A,A3,N) = zero_zero(A) )
        <=> ? [K3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K3),N))
              & ( A3 = aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K3)) ) ) ) ) ).

% pochhammer_eq_0_iff
tff(fact_2242_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0(A)
        & idom(A) )
     => ! [N: nat,K: nat] :
          ( ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),K) = zero_zero(A) )
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),K)) ) ) ).

% pochhammer_of_nat_eq_0_iff
tff(fact_2243_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [N: nat,K: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),K))
         => ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),K) = zero_zero(A) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
tff(fact_2244_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ring_char_0(A)
        & idom(A) )
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),K) != zero_zero(A) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
tff(fact_2245_ln__add__one__self__le__self2,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3))),X3)) ) ).

% ln_add_one_self_le_self2
tff(fact_2246_not__zle__0__negative,axiom,
    ! [N: nat] : ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N))))) ).

% not_zle_0_negative
tff(fact_2247_negative__zless__0,axiom,
    ! [N: nat] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N)))),zero_zero(int))) ).

% negative_zless_0
tff(fact_2248_negD,axiom,
    ! [X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X3),zero_zero(int)))
     => ? [N2: nat] : ( X3 = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N2))) ) ) ).

% negD
tff(fact_2249_verit__less__mono__div__int2,axiom,
    ! [A2: int,B3: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A2),B3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(int,int,uminus_uminus(int),N)))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),B3),N)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),N))) ) ) ).

% verit_less_mono_div_int2
tff(fact_2250_div__eq__minus1,axiom,
    ! [B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),B2) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ).

% div_eq_minus1
tff(fact_2251_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X3)),aa(A,A,abs_abs(A),Y4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% abs_le_square_iff
tff(fact_2252_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] :
          ( ( aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(A) )
        <=> ( aa(A,A,abs_abs(A),X3) = one_one(A) ) ) ) ).

% abs_square_eq_1
tff(fact_2253_power__even__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => ( aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A3)),N) = aa(nat,A,power_power(A,A3),N) ) ) ) ).

% power_even_abs
tff(fact_2254_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% pos_minus_divide_le_eq
tff(fact_2255_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% pos_le_minus_divide_eq
tff(fact_2256_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% neg_minus_divide_le_eq
tff(fact_2257_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% neg_le_minus_divide_eq
tff(fact_2258_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A3))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ) ) ) ) ).

% minus_divide_le_eq
tff(fact_2259_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ) ) ) ) ).

% le_minus_divide_eq
tff(fact_2260_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
tff(fact_2261_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
tff(fact_2262_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A3: A] :
          ( ( aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(A) )
        <=> ( ( A3 = one_one(A) )
            | ( A3 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% power2_eq_1_iff
tff(fact_2263_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat,A3: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
           => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),N) = aa(nat,A,power_power(A,A3),N) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
           => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),N) = aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,A3),N)) ) ) ) ) ).

% uminus_power_if
tff(fact_2264_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)) = aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
tff(fact_2265_realpow__square__minus__le,axiom,
    ! [U: real,X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(nat,real,power_power(real,U),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ).

% realpow_square_minus_le
tff(fact_2266_neg__int__cases,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
     => ~ ! [N2: nat] :
            ( ( K = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) )
           => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2)) ) ) ).

% neg_int_cases
tff(fact_2267_ln__one__minus__pos__upper__bound,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),X3))),aa(real,real,uminus_uminus(real),X3))) ) ) ).

% ln_one_minus_pos_upper_bound
tff(fact_2268_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),L))
     => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),K),L) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),L),one_one(int))),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)),L)) ) ) ).

% minus_mod_int_eq
tff(fact_2269_zmod__minus1,axiom,
    ! [B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),one_one(int)),B2) = aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),one_one(int)) ) ) ).

% zmod_minus1
tff(fact_2270_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A3: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( ( modulo_modulo(int,A3,B2) = zero_zero(int) )
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),A3)),B2) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)) ) )
        & ( ( modulo_modulo(int,A3,B2) != zero_zero(int) )
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),A3)),B2) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2))),one_one(int)) ) ) ) ) ).

% zdiv_zminus1_eq_if
tff(fact_2271_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A3: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( ( modulo_modulo(int,A3,B2) = zero_zero(int) )
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),aa(int,int,uminus_uminus(int),B2)) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)) ) )
        & ( ( modulo_modulo(int,A3,B2) != zero_zero(int) )
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),aa(int,int,uminus_uminus(int),B2)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2))),one_one(int)) ) ) ) ) ).

% zdiv_zminus2_eq_if
tff(fact_2272_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X3)),Y4)) ) ) ) ).

% power2_le_iff_abs_le
tff(fact_2273_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X3)),one_one(A))) ) ) ).

% abs_square_le_1
tff(fact_2274_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),X3)),one_one(A))) ) ) ).

% abs_square_less_1
tff(fact_2275_power__mono__even,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A3: A,B2: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N))) ) ) ) ).

% power_mono_even
tff(fact_2276_zminus1__lemma,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2))
     => ( ( B2 != zero_zero(int) )
       => eucl_rel_int(aa(int,int,uminus_uminus(int),A3),B2,aa(int,product_prod(int,int),product_Pair(int,int,if(int,aa(int,bool,aa(int,fun(int,bool),fequal(int),R2),zero_zero(int)),aa(int,int,uminus_uminus(int),Q2),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),Q2)),one_one(int)))),if(int,aa(int,bool,aa(int,fun(int,bool),fequal(int),R2),zero_zero(int)),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),R2)))) ) ) ).

% zminus1_lemma
tff(fact_2277_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
tff(fact_2278_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
tff(fact_2279_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3))),X3))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
tff(fact_2280_square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A))) ) ) ) ).

% square_le_1
tff(fact_2281_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),N)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A3)),N)) = aa(nat,A,power_power(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ) ).

% minus_power_mult_self
tff(fact_2282_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
           => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
           => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% minus_one_power_iff
tff(fact_2283_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [R2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),R2),aa(nat,A,semiring_1_of_nat(A),K))),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),R2),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),R2),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),R2)),one_one(A)),K)) ) ) ).

% pochhammer_absorb_comp
tff(fact_2284_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_ring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N)),semiring_char_0_fact(A,N)) ) ) ).

% pochhammer_same
tff(fact_2285_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)) = aa(int,int,uminus_uminus(int),one_one(int)) ) ).

% minus_1_div_exp_eq_int
tff(fact_2286_Bernoulli__inequality,axiom,
    ! [X3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),X3))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3)),N))) ) ).

% Bernoulli_inequality
tff(fact_2287_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)),zero_zero(int)))
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ).

% div_pos_neg_trivial
tff(fact_2288_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K))) ).

% signed_take_bit_int_greater_eq_minus_exp
tff(fact_2289_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),K))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))),K)) ) ).

% signed_take_bit_int_less_eq_self_iff
tff(fact_2290_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))) ) ).

% signed_take_bit_int_greater_self_iff
tff(fact_2291_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% power_minus1_odd
tff(fact_2292_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K)) ) ) ).

% pochhammer_minus'
tff(fact_2293_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)) ) ) ).

% pochhammer_minus
tff(fact_2294_int__bit__induct,axiom,
    ! [P: fun(int,bool),K: int] :
      ( pp(aa(int,bool,P,zero_zero(int)))
     => ( pp(aa(int,bool,P,aa(int,int,uminus_uminus(int),one_one(int))))
       => ( ! [K2: int] :
              ( pp(aa(int,bool,P,K2))
             => ( ( K2 != zero_zero(int) )
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),times_times(int),K2),aa(num,int,numeral_numeral(int),bit0(one2))))) ) )
         => ( ! [K2: int] :
                ( pp(aa(int,bool,P,K2))
               => ( ( K2 != aa(int,int,uminus_uminus(int),one_one(int)) )
                 => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),K2),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) )
           => pp(aa(int,bool,P,K)) ) ) ) ) ).

% int_bit_induct
tff(fact_2295_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = K )
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))),K))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ) ).

% signed_take_bit_int_eq_self_iff
tff(fact_2296_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))
       => ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = K ) ) ) ).

% signed_take_bit_int_eq_self
tff(fact_2297_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X3: fun(A,nat)] : ( size_option(A,X3,none(A)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size_gen(1)
tff(fact_2298_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3))),X3))),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
tff(fact_2299_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),aa(nat,nat,suc,N)))),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K))) ) ).

% signed_take_bit_int_greater_eq
tff(fact_2300_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: fun(A,fun(A,bool)),X3: A] :
          ( ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2))
             => pp(aa(A,bool,aa(A,fun(A,bool),P,X2),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),P,aa(A,A,abs_abs(A),X3)),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% abs_sqrt_wlog
tff(fact_2301_sin__coeff__def,axiom,
    ! [X: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),X))
       => ( sin_coeff(X) = zero_zero(real) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),X))
       => ( sin_coeff(X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),semiring_char_0_fact(real,X)) ) ) ) ).

% sin_coeff_def
tff(fact_2302_cos__coeff__def,axiom,
    ! [X: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),X))
       => ( cos_coeff(X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),aa(num,nat,numeral_numeral(nat),bit0(one2))))),semiring_char_0_fact(real,X)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),X))
       => ( cos_coeff(X) = zero_zero(real) ) ) ) ).

% cos_coeff_def
tff(fact_2303_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),X3)),aa(A,A,uminus_uminus(A),Y4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3)) ) ) ).

% compl_less_compl_iff
tff(fact_2304_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X3)),aa(A,A,uminus_uminus(A),Y4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ).

% compl_le_compl_iff
tff(fact_2305_arctan__double,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,arctan,X3)) = aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),X3)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% arctan_double
tff(fact_2306_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% signed_take_bit_Suc_minus_bit1
tff(fact_2307_semiring__norm_I90_J,axiom,
    ! [M: num,N: num] :
      ( ( bit1(M) = bit1(N) )
    <=> ( M = N ) ) ).

% semiring_norm(90)
tff(fact_2308_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( bit1(X32) = bit1(Y32) )
    <=> ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
tff(fact_2309_semiring__norm_I89_J,axiom,
    ! [M: num,N: num] : ( bit1(M) != bit0(N) ) ).

% semiring_norm(89)
tff(fact_2310_semiring__norm_I88_J,axiom,
    ! [M: num,N: num] : ( bit0(M) != bit1(N) ) ).

% semiring_norm(88)
tff(fact_2311_semiring__norm_I86_J,axiom,
    ! [M: num] : ( bit1(M) != one2 ) ).

% semiring_norm(86)
tff(fact_2312_semiring__norm_I84_J,axiom,
    ! [N: num] : ( one2 != bit1(N) ) ).

% semiring_norm(84)
tff(fact_2313_zdvd1__eq,axiom,
    ! [X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),X3),one_one(int)))
    <=> ( aa(int,int,abs_abs(int),X3) = one_one(int) ) ) ).

% zdvd1_eq
tff(fact_2314_arctan__zero__zero,axiom,
    aa(real,real,arctan,zero_zero(real)) = zero_zero(real) ).

% arctan_zero_zero
tff(fact_2315_arctan__eq__zero__iff,axiom,
    ! [X3: real] :
      ( ( aa(real,real,arctan,X3) = zero_zero(real) )
    <=> ( X3 = zero_zero(real) ) ) ).

% arctan_eq_zero_iff
tff(fact_2316_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),bit1(M)),bit1(N)))
    <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N)) ) ).

% semiring_norm(80)
tff(fact_2317_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),bit1(M)),bit1(N)))
    <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M),N)) ) ).

% semiring_norm(73)
tff(fact_2318_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,abs_abs(int),Z)),one_one(int)))
    <=> ( Z = zero_zero(int) ) ) ).

% zabs_less_one_iff
tff(fact_2319_semiring__norm_I7_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit0(M)),bit1(N)) = bit1(aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ).

% semiring_norm(7)
tff(fact_2320_semiring__norm_I9_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit1(M)),bit0(N)) = bit1(aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ).

% semiring_norm(9)
tff(fact_2321_arctan__less__zero__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arctan,X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real))) ) ).

% arctan_less_zero_iff
tff(fact_2322_zero__less__arctan__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,arctan,X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3)) ) ).

% zero_less_arctan_iff
tff(fact_2323_arctan__le__zero__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arctan,X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real))) ) ).

% arctan_le_zero_iff
tff(fact_2324_zero__le__arctan__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,arctan,X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3)) ) ).

% zero_le_arctan_iff
tff(fact_2325_semiring__norm_I14_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),bit0(M)),bit1(N)) = bit0(aa(num,num,aa(num,fun(num,num),times_times(num),M),bit1(N))) ) ).

% semiring_norm(14)
tff(fact_2326_semiring__norm_I15_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),bit1(M)),bit0(N)) = bit0(aa(num,num,aa(num,fun(num,num),times_times(num),bit1(M)),N)) ) ).

% semiring_norm(15)
tff(fact_2327_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),bit1(M)),bit0(N)))
    <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N)) ) ).

% semiring_norm(81)
tff(fact_2328_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),bit0(M)),bit1(N)))
    <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M),N)) ) ).

% semiring_norm(72)
tff(fact_2329_semiring__norm_I77_J,axiom,
    ! [N: num] : pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),one2),bit1(N))) ).

% semiring_norm(77)
tff(fact_2330_semiring__norm_I70_J,axiom,
    ! [M: num] : ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),bit1(M)),one2)) ).

% semiring_norm(70)
tff(fact_2331_sin__coeff__0,axiom,
    sin_coeff(zero_zero(nat)) = zero_zero(real) ).

% sin_coeff_0
tff(fact_2332_cos__coeff__0,axiom,
    cos_coeff(zero_zero(nat)) = one_one(real) ).

% cos_coeff_0
tff(fact_2333_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),bit1(V))),aa(num,int,numeral_numeral(int),bit0(W))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),W)) ) ).

% zdiv_numeral_Bit1
tff(fact_2334_semiring__norm_I10_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit1(M)),bit1(N)) = bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)),one2)) ) ).

% semiring_norm(10)
tff(fact_2335_semiring__norm_I8_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit1(M)),one2) = bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),M),one2)) ) ).

% semiring_norm(8)
tff(fact_2336_semiring__norm_I5_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit0(M)),one2) = bit1(M) ) ).

% semiring_norm(5)
tff(fact_2337_semiring__norm_I4_J,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),bit1(N)) = bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ).

% semiring_norm(4)
tff(fact_2338_semiring__norm_I3_J,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),bit0(N)) = bit1(N) ) ).

% semiring_norm(3)
tff(fact_2339_semiring__norm_I16_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),bit1(M)),bit1(N)) = bit1(aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)),bit0(aa(num,num,aa(num,fun(num,num),times_times(num),M),N)))) ) ).

% semiring_norm(16)
tff(fact_2340_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),bit1(M)),bit0(N)))
    <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N)) ) ).

% semiring_norm(74)
tff(fact_2341_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),bit0(M)),bit1(N)))
    <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M),N)) ) ).

% semiring_norm(79)
tff(fact_2342_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M)))),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit1(one2))),M)),aa(num,nat,numeral_numeral(nat),V)) ) ).

% Suc_div_eq_add3_div_numeral
tff(fact_2343_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,N)))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit1(one2))),N)) ) ).

% div_Suc_eq_div_add3
tff(fact_2344_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M))),aa(num,nat,numeral_numeral(nat),V)) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit1(one2))),M),aa(num,nat,numeral_numeral(nat),V)) ) ).

% Suc_mod_eq_add3_mod_numeral
tff(fact_2345_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,M,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,N)))) = modulo_modulo(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit1(one2))),N)) ) ).

% mod_Suc_eq_mod_add3
tff(fact_2346_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),bit1(V)),aa(num,int,numeral_numeral(int),bit0(W))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),modulo_modulo(int,aa(num,int,numeral_numeral(int),V),aa(num,int,numeral_numeral(int),W)))),one_one(int)) ) ).

% zmod_numeral_Bit1
tff(fact_2347_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,N)),aa(num,int,numeral_numeral(int),bit1(K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% signed_take_bit_Suc_bit1
tff(fact_2348_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] : ( bit0(X22) != bit1(X32) ) ).

% verit_eq_simplify(14)
tff(fact_2349_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] : ( one2 != bit1(X32) ) ).

% verit_eq_simplify(12)
tff(fact_2350_zdvd__antisym__abs,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),A3),B2))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),B2),A3))
       => ( aa(int,int,abs_abs(int),A3) = aa(int,int,abs_abs(int),B2) ) ) ) ).

% zdvd_antisym_abs
tff(fact_2351_arctan__monotone,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arctan,X3)),aa(real,real,arctan,Y4))) ) ).

% arctan_monotone
tff(fact_2352_arctan__less__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arctan,X3)),aa(real,real,arctan,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ).

% arctan_less_iff
tff(fact_2353_arctan__le__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arctan,X3)),aa(real,real,arctan,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ).

% arctan_le_iff
tff(fact_2354_arctan__monotone_H,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arctan,X3)),aa(real,real,arctan,Y4))) ) ).

% arctan_monotone'
tff(fact_2355_xor__num_Ocases,axiom,
    ! [X3: product_prod(num,num)] :
      ( ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,one2),one2) )
     => ( ! [N2: num] : ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,one2),bit0(N2)) )
       => ( ! [N2: num] : ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,one2),bit1(N2)) )
         => ( ! [M3: num] : ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,bit0(M3)),one2) )
           => ( ! [M3: num,N2: num] : ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,bit0(M3)),bit0(N2)) )
             => ( ! [M3: num,N2: num] : ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,bit0(M3)),bit1(N2)) )
               => ( ! [M3: num] : ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,bit1(M3)),one2) )
                 => ( ! [M3: num,N2: num] : ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,bit1(M3)),bit0(N2)) )
                   => ~ ! [M3: num,N2: num] : ( X3 != aa(num,product_prod(num,num),product_Pair(num,num,bit1(M3)),bit1(N2)) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
tff(fact_2356_num_Oexhaust,axiom,
    ! [Y4: num] :
      ( ( Y4 != one2 )
     => ( ! [X23: num] : ( Y4 != bit0(X23) )
       => ~ ! [X33: num] : ( Y4 != bit1(X33) ) ) ) ).

% num.exhaust
tff(fact_2357_zabs__def,axiom,
    ! [I: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I),zero_zero(int)))
       => ( aa(int,int,abs_abs(int),I) = aa(int,int,uminus_uminus(int),I) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I),zero_zero(int)))
       => ( aa(int,int,abs_abs(int),I) = I ) ) ) ).

% zabs_def
tff(fact_2358_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),times_times(int),M),N)) = one_one(int) )
     => ( aa(int,int,abs_abs(int),M) = one_one(int) ) ) ).

% abs_zmult_eq_1
tff(fact_2359_abs__div,axiom,
    ! [Y4: int,X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),Y4),X3))
     => ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X3),Y4)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),X3)),aa(int,int,abs_abs(int),Y4)) ) ) ).

% abs_div
tff(fact_2360_sin__coeff__Suc,axiom,
    ! [N: nat] : ( sin_coeff(aa(nat,nat,suc,N)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),cos_coeff(N)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))) ) ).

% sin_coeff_Suc
tff(fact_2361_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bit1(N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N))),one_one(A)) ) ) ).

% numeral_Bit1
tff(fact_2362_eval__nat__numeral_I3_J,axiom,
    ! [N: num] : ( aa(num,nat,numeral_numeral(nat),bit1(N)) = aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),bit0(N))) ) ).

% eval_nat_numeral(3)
tff(fact_2363_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q2: num,N: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit1(M)),aa(num,A,numeral_numeral(A),bit0(Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),bit1(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Q2)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),Q2)) ) ) ) ).

% cong_exp_iff_simps(13)
tff(fact_2364_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q2: num,N: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit1(M)),aa(num,A,numeral_numeral(A),bit0(Q2))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),bit0(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) ) ) ).

% cong_exp_iff_simps(12)
tff(fact_2365_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q2: num,N: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit0(M)),aa(num,A,numeral_numeral(A),bit0(Q2))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),bit1(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) ) ) ).

% cong_exp_iff_simps(10)
tff(fact_2366_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: A,K: num] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),X3)),aa(num,nat,numeral_numeral(nat),bit1(K))) = aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit1(K)))) ) ) ).

% power_minus_Bit1
tff(fact_2367_dvd__imp__le__int,axiom,
    ! [I: int,D2: int] :
      ( ( I != zero_zero(int) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),D2),I))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,abs_abs(int),D2)),aa(int,int,abs_abs(int),I))) ) ) ).

% dvd_imp_le_int
tff(fact_2368_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,abs_abs(int),modulo_modulo(int,K,L))),aa(int,int,abs_abs(int),L))) ) ).

% abs_mod_less
tff(fact_2369_cos__coeff__Suc,axiom,
    ! [N: nat] : ( cos_coeff(aa(nat,nat,suc,N)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),sin_coeff(N))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))) ) ).

% cos_coeff_Suc
tff(fact_2370_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),bit1(N))),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(num,A,numeral_numeral(A),N) ) ) ).

% numeral_Bit1_div_2
tff(fact_2371_odd__numeral,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(num,A,numeral_numeral(A),bit1(N)))) ) ).

% odd_numeral
tff(fact_2372_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num,Q2: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit1(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) != zero_zero(A) ) ) ).

% cong_exp_iff_simps(3)
tff(fact_2373_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(nat,A,power_power(A,A3),aa(num,nat,numeral_numeral(nat),bit1(one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3)),A3) ) ) ).

% power3_eq_cube
tff(fact_2374_numeral__3__eq__3,axiom,
    aa(num,nat,numeral_numeral(nat),bit1(one2)) = aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))) ).

% numeral_3_eq_3
tff(fact_2375_Suc3__eq__add__3,axiom,
    ! [N: nat] : ( aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,N))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit1(one2))),N) ) ).

% Suc3_eq_add_3
tff(fact_2376_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M != zero_zero(int) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),M),N)),M))
      <=> ( aa(int,int,abs_abs(int),N) = one_one(int) ) ) ) ).

% zdvd_mult_cancel1
tff(fact_2377_num_Osize_I6_J,axiom,
    ! [X32: num] : ( aa(num,nat,size_size(num),bit1(X32)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,size_size(num),X32)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size(6)
tff(fact_2378_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q2: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit1(M)),aa(num,A,numeral_numeral(A),bit0(Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),bit0(Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(11)
tff(fact_2379_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q2: num,N: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),bit0(Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),bit1(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(7)
tff(fact_2380_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(int,int,abs_abs(int),L))))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L))) ) ).

% even_add_abs_iff
tff(fact_2381_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),K)),L)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L))) ) ).

% even_abs_add_iff
tff(fact_2382_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M)))),N) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit1(one2))),M)),N) ) ).

% Suc_div_eq_add3_div
tff(fact_2383_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M))),N) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit1(one2))),M),N) ) ).

% Suc_mod_eq_add3_mod
tff(fact_2384_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F2: fun(nat,int),K: int] :
      ( ! [I3: nat] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),I3))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),N)) )
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F2,aa(nat,nat,suc,I3))),aa(nat,int,F2,I3)))),one_one(int))) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,F2,M)),K))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),aa(nat,int,F2,N)))
           => ? [I3: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),I3))
                & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I3),N))
                & ( aa(nat,int,F2,I3) = K ) ) ) ) ) ) ).

% nat_intermed_int_val
tff(fact_2385_incr__lemma,axiom,
    ! [D2: int,Z: int,X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D2))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),Z))),one_one(int))),D2)))) ) ).

% incr_lemma
tff(fact_2386_decr__lemma,axiom,
    ! [D2: int,X3: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D2))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),Z))),one_one(int))),D2))),Z)) ) ).

% decr_lemma
tff(fact_2387_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = zero_zero(nat) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = one_one(nat) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(num,nat,numeral_numeral(nat),bit0(one2)) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(num,nat,numeral_numeral(nat),bit1(one2)) ) ) ).

% mod_exhaust_less_4
tff(fact_2388_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),Y4)),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X3)),Y4)) ) ) ).

% compl_le_swap2
tff(fact_2389_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),aa(A,A,uminus_uminus(A),X3)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,uminus_uminus(A),Y4))) ) ) ).

% compl_le_swap1
tff(fact_2390_compl__mono,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),Y4)),aa(A,A,uminus_uminus(A),X3))) ) ) ).

% compl_mono
tff(fact_2391_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),aa(A,A,uminus_uminus(A),X3)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,uminus_uminus(A),Y4))) ) ) ).

% compl_less_swap1
tff(fact_2392_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),Y4)),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),X3)),Y4)) ) ) ).

% compl_less_swap2
tff(fact_2393_nat__ivt__aux,axiom,
    ! [N: nat,F2: fun(nat,int),K: int] :
      ( ! [I3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),N))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F2,aa(nat,nat,suc,I3))),aa(nat,int,F2,I3)))),one_one(int))) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,F2,zero_zero(nat))),K))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),aa(nat,int,F2,N)))
         => ? [I3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I3),N))
              & ( aa(nat,int,F2,I3) = K ) ) ) ) ) ).

% nat_ivt_aux
tff(fact_2394_complex__mod__minus__le__complex__mod,axiom,
    ! [X3: complex] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),real_V7770717601297561774m_norm(complex,X3))),real_V7770717601297561774m_norm(complex,X3))) ).

% complex_mod_minus_le_complex_mod
tff(fact_2395_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A3: complex] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),B2),A3))),real_V7770717601297561774m_norm(complex,B2))),real_V7770717601297561774m_norm(complex,A3))) ).

% complex_mod_triangle_ineq2
tff(fact_2396_nat0__intermed__int__val,axiom,
    ! [N: nat,F2: fun(nat,int),K: int] :
      ( ! [I3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),N))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),one_one(nat)))),aa(nat,int,F2,I3)))),one_one(int))) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,F2,zero_zero(nat))),K))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),aa(nat,int,F2,N)))
         => ? [I3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I3),N))
              & ( aa(nat,int,F2,I3) = K ) ) ) ) ) ).

% nat0_intermed_int_val
tff(fact_2397_arctan__add,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),Y4)),one_one(real)))
       => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,arctan,X3)),aa(real,real,arctan,Y4)) = aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),X3),Y4)))) ) ) ) ).

% arctan_add
tff(fact_2398_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(num,nat,numeral_numeral(nat),bit1(one2)) )
     => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% odd_mod_4_div_2
tff(fact_2399_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% signed_take_bit_numeral_minus_bit1
tff(fact_2400_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit1(one2))) ) ) ).

% dbl_dec_simps(4)
tff(fact_2401_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] :
          ( ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N))
           => ( unique8689654367752047608divmod(A,bit1(M),bit1(N)) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),bit1(M))) ) )
          & ( ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N))
           => ( unique8689654367752047608divmod(A,bit1(M),bit1(N)) = unique1321980374590559556d_step(A,bit1(N),unique8689654367752047608divmod(A,bit1(M),bit0(bit1(N)))) ) ) ) ) ).

% divmod_algorithm_code(8)
tff(fact_2402_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] :
          ( ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M),N))
           => ( unique8689654367752047608divmod(A,bit0(M),bit1(N)) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),bit0(M))) ) )
          & ( ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M),N))
           => ( unique8689654367752047608divmod(A,bit0(M),bit1(N)) = unique1321980374590559556d_step(A,bit1(N),unique8689654367752047608divmod(A,bit0(M),bit0(bit1(N)))) ) ) ) ) ).

% divmod_algorithm_code(7)
tff(fact_2403_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(num,int,numeral_numeral(int),bit1(K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% signed_take_bit_numeral_bit1
tff(fact_2404_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,one_one(A)) = aa(num,A,numeral_numeral(A),bit1(one2)) ) ) ).

% dbl_inc_simps(3)
tff(fact_2405_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,one_one(A)) = one_one(A) ) ) ).

% dbl_dec_simps(3)
tff(fact_2406_pred__numeral__simps_I1_J,axiom,
    pred_numeral(one2) = zero_zero(nat) ).

% pred_numeral_simps(1)
tff(fact_2407_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( aa(nat,nat,suc,N) = aa(num,nat,numeral_numeral(nat),K) )
    <=> ( N = pred_numeral(K) ) ) ).

% Suc_eq_numeral
tff(fact_2408_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( aa(num,nat,numeral_numeral(nat),K) = aa(nat,nat,suc,N) )
    <=> ( pred_numeral(K) = N ) ) ).

% eq_numeral_Suc
tff(fact_2409_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,zero_zero(A)) = one_one(A) ) ) ).

% dbl_inc_simps(2)
tff(fact_2410_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_inc_simps(4)
tff(fact_2411_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_inc(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),bit1(K)) ) ) ).

% dbl_inc_simps(5)
tff(fact_2412_pred__numeral__simps_I3_J,axiom,
    ! [K: num] : ( pred_numeral(bit1(K)) = aa(num,nat,numeral_numeral(nat),bit0(K)) ) ).

% pred_numeral_simps(3)
tff(fact_2413_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),pred_numeral(K)),N)) ) ).

% less_numeral_Suc
tff(fact_2414_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),pred_numeral(K))) ) ).

% less_Suc_numeral
tff(fact_2415_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),pred_numeral(K))) ) ).

% le_Suc_numeral
tff(fact_2416_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),pred_numeral(K)),N)) ) ).

% le_numeral_Suc
tff(fact_2417_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),pred_numeral(K)),N) ) ).

% diff_numeral_Suc
tff(fact_2418_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),pred_numeral(K)) ) ).

% diff_Suc_numeral
tff(fact_2419_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_dec_simps(2)
tff(fact_2420_numeral__div__minus__numeral,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,M,N))) ) ).

% numeral_div_minus_numeral
tff(fact_2421_minus__numeral__div__numeral,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),N)) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,M,N))) ) ).

% minus_numeral_div_numeral
tff(fact_2422_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl_dec(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_inc_simps(1)
tff(fact_2423_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl_inc(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_dec_simps(1)
tff(fact_2424_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)))
        <=> unique5940410009612947441es_aux(A,unique8689654367752047608divmod(A,N,M)) ) ) ).

% dvd_numeral_simp
tff(fact_2425_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num] : ( unique8689654367752047608divmod(A,M,one2) = aa(A,product_prod(A,A),product_Pair(A,A,aa(num,A,numeral_numeral(A),M)),zero_zero(A)) ) ) ).

% divmod_algorithm_code(2)
tff(fact_2426_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( unique8689654367752047608divmod(A,one2,bit0(N)) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(3)
tff(fact_2427_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( unique8689654367752047608divmod(A,one2,bit1(N)) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(4)
tff(fact_2428_one__div__minus__numeral,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,one2,N))) ) ).

% one_div_minus_numeral
tff(fact_2429_minus__one__div__numeral,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(num,int,numeral_numeral(int),N)) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,one2,N))) ) ).

% minus_one_div_numeral
tff(fact_2430_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(num,int,numeral_numeral(int),bit0(K))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% signed_take_bit_numeral_bit0
tff(fact_2431_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% signed_take_bit_numeral_minus_bit0
tff(fact_2432_numeral__eq__Suc,axiom,
    ! [K: num] : ( aa(num,nat,numeral_numeral(nat),K) = aa(nat,nat,suc,pred_numeral(K)) ) ).

% numeral_eq_Suc
tff(fact_2433_pred__numeral__def,axiom,
    ! [K: num] : ( pred_numeral(K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),K)),one_one(nat)) ) ).

% pred_numeral_def
tff(fact_2434_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X3: A] : ( neg_numeral_dbl_inc(A,X3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),X3)),one_one(A)) ) ) ).

% dbl_inc_def
tff(fact_2435_fact__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: num] : ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),semiring_char_0_fact(A,pred_numeral(K))) ) ) ).

% fact_numeral
tff(fact_2436_divmod__int__def,axiom,
    ! [M: num,N: num] : ( unique8689654367752047608divmod(int,M,N) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N))),modulo_modulo(int,aa(num,int,numeral_numeral(int),M),aa(num,int,numeral_numeral(int),N))) ) ).

% divmod_int_def
tff(fact_2437_divmod__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] : ( unique8689654367752047608divmod(A,M,N) = aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N))),modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),N))) ) ) ).

% divmod_def
tff(fact_2438_divmod_H__nat__def,axiom,
    ! [M: num,N: num] : ( unique8689654367752047608divmod(nat,M,N) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N))),modulo_modulo(nat,aa(num,nat,numeral_numeral(nat),M),aa(num,nat,numeral_numeral(nat),N))) ) ).

% divmod'_nat_def
tff(fact_2439_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X3: A] : ( neg_numeral_dbl_dec(A,X3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),X3)),one_one(A)) ) ) ).

% dbl_dec_def
tff(fact_2440_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] :
          ( ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N))
           => ( unique8689654367752047608divmod(A,M,N) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),M)) ) )
          & ( ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N))
           => ( unique8689654367752047608divmod(A,M,N) = unique1321980374590559556d_step(A,N,unique8689654367752047608divmod(A,M,bit0(N))) ) ) ) ) ).

% divmod_divmod_step
tff(fact_2441_modulo__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
          | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
          | ( N = zero_zero(nat) ) )
       => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),N))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)) ) )
      & ( ~ ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
            | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
            | ( N = zero_zero(nat) ) )
       => ( ( ( aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L) )
           => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),N))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,M,N))) ) )
          & ( ( aa(int,int,sgn_sgn(int),K) != aa(int,int,sgn_sgn(int),L) )
           => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),N))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(bool,nat,zero_neq_one_of_bool(nat),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),N),M)))))),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,M,N)))) ) ) ) ) ) ).

% modulo_int_unfold
tff(fact_2442_mask__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: num] : ( bit_se2239418461657761734s_mask(A,aa(num,nat,numeral_numeral(nat),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se2239418461657761734s_mask(A,pred_numeral(N)))) ) ) ).

% mask_numeral
tff(fact_2443_num_Osize__gen_I3_J,axiom,
    ! [X32: num] : ( size_num(bit1(X32)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_num(X32)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size_gen(3)
tff(fact_2444_take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = zero_zero(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))))),aa(num,A,numeral_numeral(A),bit0(one2)))),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ) ) ).

% take_bit_rec
tff(fact_2445_divide__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
          | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
          | ( N = zero_zero(nat) ) )
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),N))) = zero_zero(int) ) )
      & ( ~ ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
            | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
            | ( N = zero_zero(nat) ) )
       => ( ( ( aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L) )
           => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),N))) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)) ) )
          & ( ( aa(int,int,sgn_sgn(int),K) != aa(int,int,sgn_sgn(int),L) )
           => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),N))) = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),aa(bool,nat,zero_neq_one_of_bool(nat),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),N),M)))))) ) ) ) ) ) ).

% divide_int_unfold
tff(fact_2446_sgn__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,sgn_sgn(A),A3)) = aa(A,A,sgn_sgn(A),A3) ) ) ).

% sgn_sgn
tff(fact_2447_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),bit_se2239418461657761734s_mask(nat,N)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ).

% mask_nat_positive_iff
tff(fact_2448_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),zero_zero(A)) = zero_zero(A) ) ) ).

% take_bit_of_0
tff(fact_2449_sgn__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_0
tff(fact_2450_sgn__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_zero
tff(fact_2451_sgn__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),one_one(A)) = one_one(A) ) ) ).

% sgn_1
tff(fact_2452_sgn__divide,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A3: A,B2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,sgn_sgn(A),A3)),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% sgn_divide
tff(fact_2453_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),A3)) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),A3)) ) ) ).

% idom_abs_sgn_class.sgn_minus
tff(fact_2454_power__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,N: nat] : ( aa(A,A,sgn_sgn(A),aa(nat,A,power_power(A,A3),N)) = aa(nat,A,power_power(A,aa(A,A,sgn_sgn(A),A3)),N) ) ) ).

% power_sgn
tff(fact_2455_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_concat_bit(N,K),zero_zero(int)) = aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) ) ).

% concat_bit_of_zero_2
tff(fact_2456_sgn__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,sgn_sgn(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% sgn_less
tff(fact_2457_sgn__greater,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,sgn_sgn(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% sgn_greater
tff(fact_2458_take__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,zero_zero(nat)),A3) = zero_zero(A) ) ) ).

% take_bit_0
tff(fact_2459_divide__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,sgn_sgn(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% divide_sgn
tff(fact_2460_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),one_one(A)) = one_one(A) ) ) ).

% take_bit_Suc_1
tff(fact_2461_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),one_one(A)) = one_one(A) ) ) ).

% take_bit_numeral_1
tff(fact_2462_mask__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,zero_zero(nat)) = zero_zero(A) ) ) ).

% mask_0
tff(fact_2463_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask(A,N) = zero_zero(A) )
        <=> ( N = zero_zero(nat) ) ) ) ).

% mask_eq_0_iff
tff(fact_2464_sgn__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( aa(A,A,sgn_sgn(A),A3) = one_one(A) ) ) ) ).

% sgn_pos
tff(fact_2465_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),one_one(A)) = zero_zero(A) )
        <=> ( N = zero_zero(nat) ) ) ) ).

% take_bit_of_1_eq_0_iff
tff(fact_2466_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A3)) = one_one(A) ) ) ) ).

% abs_sgn_eq_1
tff(fact_2467_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A3)),aa(A,A,sgn_sgn(A),A3)) = aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),A3),zero_zero(A)))) ) ) ).

% sgn_mult_self_eq
tff(fact_2468_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% mask_Suc_0
tff(fact_2469_sgn__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A3)) = aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),A3),zero_zero(A)))) ) ) ).

% sgn_abs
tff(fact_2470_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,abs_abs(A),A3)) = aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),A3),zero_zero(A)))) ) ) ).

% idom_abs_sgn_class.abs_sgn
tff(fact_2471_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,uminus_uminus(A),one_one(A))) = bit_se2239418461657761734s_mask(A,N) ) ) ).

% take_bit_minus_one_eq_mask
tff(fact_2472_take__bit__of__Suc__0,axiom,
    ! [N: nat] : ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(nat,nat,suc,zero_zero(nat))) = aa(bool,nat,zero_neq_one_of_bool(nat),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ).

% take_bit_of_Suc_0
tff(fact_2473_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),K),aa(int,int,sgn_sgn(int),R2))))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K))
        | ( R2 = zero_zero(int) ) ) ) ).

% dvd_mult_sgn_iff
tff(fact_2474_dvd__sgn__mult__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),R2)),K)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K))
        | ( R2 = zero_zero(int) ) ) ) ).

% dvd_sgn_mult_iff
tff(fact_2475_mult__sgn__dvd__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),aa(int,int,sgn_sgn(int),R2))),K))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K))
        & ( ( R2 = zero_zero(int) )
         => ( K = zero_zero(int) ) ) ) ) ).

% mult_sgn_dvd_iff
tff(fact_2476_sgn__mult__dvd__iff,axiom,
    ! [R2: int,L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),R2)),L)),K))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K))
        & ( ( R2 = zero_zero(int) )
         => ( K = zero_zero(int) ) ) ) ) ).

% sgn_mult_dvd_iff
tff(fact_2477_sgn__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( aa(A,A,sgn_sgn(A),A3) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% sgn_neg
tff(fact_2478_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),one_one(A)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% take_bit_of_1
tff(fact_2479_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat] : ( aa(A,A,sgn_sgn(A),aa(nat,A,semiring_1_of_nat(A),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% sgn_of_nat
tff(fact_2480_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)))
        <=> ( ( N = zero_zero(nat) )
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ) ).

% even_take_bit_eq
tff(fact_2481_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,zero_zero(nat))),A3) = modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% take_bit_Suc_0
tff(fact_2482_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ).

% take_bit_of_exp
tff(fact_2483_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% take_bit_of_2
tff(fact_2484_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),bit_se2239418461657761734s_mask(nat,N)) = bit_se2239418461657761734s_mask(A,N) ) ) ).

% of_nat_mask_eq
tff(fact_2485_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M)) ) ) ).

% take_bit_of_nat
tff(fact_2486_take__bit__add,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)),aa(A,A,bit_se2584673776208193580ke_bit(A,N),B2))) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) ) ) ).

% take_bit_add
tff(fact_2487_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A,M: nat] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),B2) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),A3) = aa(A,A,bit_se2584673776208193580ke_bit(A,M),B2) ) ) ) ) ).

% take_bit_tightened
tff(fact_2488_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M)),M)) ).

% take_bit_nat_less_eq_self
tff(fact_2489_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,M),Q2)),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),Q2))) ) ).

% take_bit_tightened_less_eq_nat
tff(fact_2490_sgn__0__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( aa(A,A,sgn_sgn(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% sgn_0_0
tff(fact_2491_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] :
          ( ( aa(A,A,sgn_sgn(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% sgn_eq_0_iff
tff(fact_2492_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] :
          ( ( aa(A,A,sgn_sgn(A),X3) = zero_zero(A) )
        <=> ( X3 = zero_zero(A) ) ) ) ).

% sgn_zero_iff
tff(fact_2493_sgn__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A,B2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A3)),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% sgn_mult
tff(fact_2494_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),X3)),aa(A,A,sgn_sgn(A),Y4)) ) ) ).

% Real_Vector_Spaces.sgn_mult
tff(fact_2495_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A3: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) = aa(A,A,sgn_sgn(A),A3) )
         => ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,sgn_sgn(A),A3) ) ) ) ).

% same_sgn_sgn_add
tff(fact_2496_take__bit__minus,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,uminus_uminus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K))) = aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,uminus_uminus(int),K)) ) ).

% take_bit_minus
tff(fact_2497_take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),L))) = aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),times_times(int),K),L)) ) ).

% take_bit_mult
tff(fact_2498_take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),L))) = aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)) ) ).

% take_bit_diff
tff(fact_2499_concat__bit__take__bit__eq,axiom,
    ! [N: nat,B2: int] : ( bit_concat_bit(N,aa(int,int,bit_se2584673776208193580ke_bit(int,N),B2)) = bit_concat_bit(N,B2) ) ).

% concat_bit_take_bit_eq
tff(fact_2500_concat__bit__eq__iff,axiom,
    ! [N: nat,K: int,L: int,R2: int,S: int] :
      ( ( aa(int,int,bit_concat_bit(N,K),L) = aa(int,int,bit_concat_bit(N,R2),S) )
    <=> ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = aa(int,int,bit_se2584673776208193580ke_bit(int,N),R2) )
        & ( L = S ) ) ) ).

% concat_bit_eq_iff
tff(fact_2501_less__eq__mask,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),bit_se2239418461657761734s_mask(nat,N))) ).

% less_eq_mask
tff(fact_2502_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = bit_se2239418461657761734s_mask(int,N) )
    <=> ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) = zero_zero(int) ) ) ).

% take_bit_eq_mask_iff
tff(fact_2503_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A3: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) != aa(A,A,sgn_sgn(A),A3) )
         => ( ( aa(A,A,sgn_sgn(A),A3) != zero_zero(A) )
           => ( ( aa(A,A,sgn_sgn(A),B2) != zero_zero(A) )
             => ( aa(A,A,sgn_sgn(A),A3) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),B2)) ) ) ) ) ) ).

% sgn_not_eq_imp
tff(fact_2504_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% sgn_minus_1
tff(fact_2505_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,M),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K))) ) ).

% take_bit_tightened_less_eq_int
tff(fact_2506_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K))) ).

% take_bit_nonnegative
tff(fact_2507_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),K))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) ) ).

% take_bit_int_less_eq_self_iff
tff(fact_2508_not__take__bit__negative,axiom,
    ! [N: nat,K: int] : ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),zero_zero(int))) ).

% not_take_bit_negative
tff(fact_2509_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int))) ) ).

% take_bit_int_greater_self_iff
tff(fact_2510_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A,B2: A] :
          ( ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3) = aa(A,A,bit_ri4674362597316999326ke_bit(A,N),B2) )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),A3) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),B2) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
tff(fact_2511_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [K: A] : ( aa(A,A,abs_abs(A),K) = aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,sgn_sgn(A),K)) ) ) ).

% linordered_idom_class.abs_sgn
tff(fact_2512_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,sgn_sgn(A),A3)) = A3 ) ) ).

% abs_mult_sgn
tff(fact_2513_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A3)),aa(A,A,abs_abs(A),A3)) = A3 ) ) ).

% sgn_mult_abs
tff(fact_2514_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),X3)),aa(A,A,abs_abs(A),X3)) = X3 ) ) ).

% mult_sgn_abs
tff(fact_2515_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N2: nat,L2: int] : ( K != aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L2)),aa(nat,int,semiring_1_of_nat(int),N2)) ) ).

% int_sgnE
tff(fact_2516_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A3: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) = aa(A,A,sgn_sgn(A),A3) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% same_sgn_abs_add
tff(fact_2517_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) = aa(A,A,if(fun(A,A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M),bit_se2584673776208193580ke_bit(A,N),bit_ri4674362597316999326ke_bit(A,M)),A3) ) ) ).

% signed_take_bit_take_bit
tff(fact_2518_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat,A3: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),A3)) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),A3)) = aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) ) ) ) ) ).

% take_bit_unset_bit_eq
tff(fact_2519_div__eq__sgn__abs,axiom,
    ! [K: int,L: int] :
      ( ( aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) ) ) ).

% div_eq_sgn_abs
tff(fact_2520_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat,A3: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),M),A3)) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),M),A3)) = aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) ) ) ) ) ).

% take_bit_set_bit_eq
tff(fact_2521_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat,A3: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),bit_se8732182000553998342ip_bit(A,M,A3)) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),bit_se8732182000553998342ip_bit(A,M,A3)) = bit_se8732182000553998342ip_bit(A,M,aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) ) ) ) ) ).

% take_bit_flip_bit_eq
tff(fact_2522_mask__nonnegative__int,axiom,
    ! [N: nat] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),bit_se2239418461657761734s_mask(int,N))) ).

% mask_nonnegative_int
tff(fact_2523_not__mask__negative__int,axiom,
    ! [N: nat] : ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),bit_se2239418461657761734s_mask(int,N)),zero_zero(int))) ).

% not_mask_negative_int
tff(fact_2524_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( aa(A,A,sgn_sgn(A),A3) = one_one(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% sgn_1_pos
tff(fact_2525_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,suc,N)))
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3)) = aa(A,A,bit_se2584673776208193580ke_bit(A,M),A3) ) ) ) ).

% take_bit_signed_take_bit
tff(fact_2526_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( ( A3 = zero_zero(A) )
           => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A3)) = zero_zero(A) ) )
          & ( ( A3 != zero_zero(A) )
           => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A3)) = one_one(A) ) ) ) ) ).

% abs_sgn_eq
tff(fact_2527_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) != zero_zero(int) )
     => ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),one_one(int)) ) ) ).

% take_bit_decr_eq
tff(fact_2528_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => ( ~ pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K))
       => ( aa(int,int,sgn_sgn(int),modulo_modulo(int,K,L)) = aa(int,int,sgn_sgn(int),L) ) ) ) ).

% sgn_mod
tff(fact_2529_less__mask,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),N))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),bit_se2239418461657761734s_mask(nat,N))) ) ).

% less_mask
tff(fact_2530_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = bit_se2239418461657761734s_mask(int,N) )
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int)))) ) ).

% take_bit_eq_mask_iff_exp_dvd
tff(fact_2531_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( aa(A,A,sgn_sgn(A),A3) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% sgn_1_neg
tff(fact_2532_sgn__if,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] :
          ( ( ( X3 = zero_zero(A) )
           => ( aa(A,A,sgn_sgn(A),X3) = zero_zero(A) ) )
          & ( ( X3 != zero_zero(A) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
               => ( aa(A,A,sgn_sgn(A),X3) = one_one(A) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
               => ( aa(A,A,sgn_sgn(A),X3) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ) ) ).

% sgn_if
tff(fact_2533_zsgn__def,axiom,
    ! [I: int] :
      ( ( ( I = zero_zero(int) )
       => ( aa(int,int,sgn_sgn(int),I) = zero_zero(int) ) )
      & ( ( I != zero_zero(int) )
       => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),I))
           => ( aa(int,int,sgn_sgn(int),I) = one_one(int) ) )
          & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),I))
           => ( aa(int,int,sgn_sgn(int),I) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ) ) ).

% zsgn_def
tff(fact_2534_norm__sgn,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] :
          ( ( ( X3 = zero_zero(A) )
           => ( real_V7770717601297561774m_norm(A,aa(A,A,sgn_sgn(A),X3)) = zero_zero(real) ) )
          & ( ( X3 != zero_zero(A) )
           => ( real_V7770717601297561774m_norm(A,aa(A,A,sgn_sgn(A),X3)) = one_one(real) ) ) ) ) ).

% norm_sgn
tff(fact_2535_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),V)),aa(int,int,abs_abs(int),K))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),V)),aa(int,int,abs_abs(int),L))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) ) ) ).

% div_sgn_abs_cancel
tff(fact_2536_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(int,int,sgn_sgn(int),L))),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L))) ) ) ).

% div_dvd_sgn_abs
tff(fact_2537_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),bit0(K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% take_bit_Suc_bit0
tff(fact_2538_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = modulo_modulo(A,A3,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ).

% take_bit_eq_mod
tff(fact_2539_take__bit__nat__eq__self,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))
     => ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M) = M ) ) ).

% take_bit_nat_eq_self
tff(fact_2540_take__bit__nat__less__exp,axiom,
    ! [N: nat,M: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ).

% take_bit_nat_less_exp
tff(fact_2541_take__bit__nat__eq__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M) = M )
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ).

% take_bit_nat_eq_self_iff
tff(fact_2542_take__bit__nat__def,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M) = modulo_modulo(nat,M,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% take_bit_nat_def
tff(fact_2543_take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ).

% take_bit_int_less_exp
tff(fact_2544_take__bit__int__def,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = modulo_modulo(int,K,aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% take_bit_int_def
tff(fact_2545_num_Osize__gen_I1_J,axiom,
    size_num(one2) = zero_zero(nat) ).

% num.size_gen(1)
tff(fact_2546_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = zero_zero(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),A3)) ) ) ).

% take_bit_eq_0_iff
tff(fact_2547_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),bit0(K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% take_bit_numeral_bit0
tff(fact_2548_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M)),M))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),M)) ) ).

% take_bit_nat_less_self_iff
tff(fact_2549_Suc__mask__eq__exp,axiom,
    ! [N: nat] : ( aa(nat,nat,suc,bit_se2239418461657761734s_mask(nat,N)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% Suc_mask_eq_exp
tff(fact_2550_mask__nat__less__exp,axiom,
    ! [N: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),bit_se2239418461657761734s_mask(nat,N)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ).

% mask_nat_less_exp
tff(fact_2551_take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% take_bit_Suc_minus_bit0
tff(fact_2552_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ).

% take_bit_int_greater_eq_self_iff
tff(fact_2553_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),K))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),K)) ) ).

% take_bit_int_less_self_iff
tff(fact_2554_eucl__rel__int__remainderI,axiom,
    ! [R2: int,L: int,K: int,Q2: int] :
      ( ( aa(int,int,sgn_sgn(int),R2) = aa(int,int,sgn_sgn(int),L) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,abs_abs(int),R2)),aa(int,int,abs_abs(int),L)))
       => ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q2),L)),R2) )
         => eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R2)) ) ) ) ).

% eucl_rel_int_remainderI
tff(fact_2555_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se2239418461657761734s_mask(A,N)))
        <=> ( N = zero_zero(nat) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
tff(fact_2556_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))
       => ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = K ) ) ) ).

% take_bit_int_eq_self
tff(fact_2557_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = K )
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ) ).

% take_bit_int_eq_self_iff
tff(fact_2558_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% take_bit_numeral_minus_bit0
tff(fact_2559_mask__nat__def,axiom,
    ! [N: nat] : ( bit_se2239418461657761734s_mask(nat,N) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),one_one(nat)) ) ).

% mask_nat_def
tff(fact_2560_mask__half__int,axiom,
    ! [N: nat] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),bit_se2239418461657761734s_mask(int,N)),aa(num,int,numeral_numeral(int),bit0(one2))) = bit_se2239418461657761734s_mask(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ).

% mask_half_int
tff(fact_2561_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) != aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),one_one(int)) )
     => ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ) ).

% take_bit_incr_eq
tff(fact_2562_mask__int__def,axiom,
    ! [N: nat] : ( bit_se2239418461657761734s_mask(int,N) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),one_one(int)) ) ).

% mask_int_def
tff(fact_2563_eucl__rel__int_Osimps,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
    <=> ( ? [K3: int] :
            ( ( A1 = K3 )
            & ( A22 = zero_zero(int) )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),K3) ) )
        | ? [L3: int,K3: int,Q4: int] :
            ( ( A1 = K3 )
            & ( A22 = L3 )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q4),zero_zero(int)) )
            & ( L3 != zero_zero(int) )
            & ( K3 = aa(int,int,aa(int,fun(int,int),times_times(int),Q4),L3) ) )
        | ? [R5: int,L3: int,K3: int,Q4: int] :
            ( ( A1 = K3 )
            & ( A22 = L3 )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q4),R5) )
            & ( aa(int,int,sgn_sgn(int),R5) = aa(int,int,sgn_sgn(int),L3) )
            & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,abs_abs(int),R5)),aa(int,int,abs_abs(int),L3)))
            & ( K3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q4),L3)),R5) ) ) ) ) ).

% eucl_rel_int.simps
tff(fact_2564_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
     => ( ( ( A22 = zero_zero(int) )
         => ( A32 != aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),A1) ) )
       => ( ! [Q5: int] :
              ( ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q5),zero_zero(int)) )
             => ( ( A22 != zero_zero(int) )
               => ( A1 != aa(int,int,aa(int,fun(int,int),times_times(int),Q5),A22) ) ) )
         => ~ ! [R: int,Q5: int] :
                ( ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q5),R) )
               => ( ( aa(int,int,sgn_sgn(int),R) = aa(int,int,sgn_sgn(int),A22) )
                 => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,abs_abs(int),R)),aa(int,int,abs_abs(int),A22)))
                   => ( A1 != aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q5),A22)),R) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
tff(fact_2565_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => ( ( aa(int,int,sgn_sgn(int),K) != aa(int,int,sgn_sgn(int),L) )
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)))),aa(bool,int,zero_neq_one_of_bool(int),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K)))) ) ) ) ).

% div_noneq_sgn_abs
tff(fact_2566_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,suc,N))),one_one(A)) ) ) ).

% take_bit_Suc_minus_1_eq
tff(fact_2567_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),bit1(K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),bit0(one2)))),one_one(A)) ) ) ).

% take_bit_Suc_bit1
tff(fact_2568_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),K)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(num,nat,numeral_numeral(nat),K))),one_one(A)) ) ) ).

% take_bit_numeral_minus_1_eq
tff(fact_2569_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))))),aa(num,A,numeral_numeral(A),bit0(one2)))),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% take_bit_Suc
tff(fact_2570_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,N) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A)) ) ) ).

% mask_eq_exp_minus_1
tff(fact_2571_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))) ) ) ).

% take_bit_int_less_eq
tff(fact_2572_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K))) ) ).

% take_bit_int_greater_eq
tff(fact_2573_signed__take__bit__eq__take__bit__shift,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% signed_take_bit_eq_take_bit_shift
tff(fact_2574_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))) = A3 )
         => ( ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
             => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = zero_zero(A) ) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
             => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A)) ) ) ) ) ) ).

% stable_imp_take_bit_eq
tff(fact_2575_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),bit1(K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),bit0(one2)))),one_one(A)) ) ) ).

% take_bit_numeral_bit1
tff(fact_2576_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),K))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))
       => ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,uminus_uminus(int),K)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),K) ) ) ) ).

% take_bit_minus_small_eq
tff(fact_2577_num_Osize__gen_I2_J,axiom,
    ! [X22: num] : ( size_num(bit0(X22)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_num(X22)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size_gen(2)
tff(fact_2578_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K))))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% take_bit_numeral_minus_bit1
tff(fact_2579_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K))))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% take_bit_Suc_minus_bit1
tff(fact_2580_divmod__BitM__2__eq,axiom,
    ! [M: num] : ( unique8689654367752047608divmod(int,bitM(M),bit0(one2)) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),one_one(int)) ) ).

% divmod_BitM_2_eq
tff(fact_2581_modulo__int__def,axiom,
    ! [L: int,K: int] :
      ( ( ( L = zero_zero(int) )
       => ( modulo_modulo(int,K,L) = K ) )
      & ( ( L != zero_zero(int) )
       => ( ( ( aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L) )
           => ( modulo_modulo(int,K,L) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L))))) ) )
          & ( ( aa(int,int,sgn_sgn(int),K) != aa(int,int,sgn_sgn(int),L) )
           => ( modulo_modulo(int,K,L) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),L)),aa(bool,int,zero_neq_one_of_bool(int),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K))))),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))))) ) ) ) ) ) ).

% modulo_int_def
tff(fact_2582_divide__int__def,axiom,
    ! [L: int,K: int] :
      ( ( ( L = zero_zero(int) )
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = zero_zero(int) ) )
      & ( ( L != zero_zero(int) )
       => ( ( ( aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L) )
           => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) )
          & ( ( aa(int,int,sgn_sgn(int),K) != aa(int,int,sgn_sgn(int),L) )
           => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))),aa(bool,nat,zero_neq_one_of_bool(nat),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),L),K)))))) ) ) ) ) ) ).

% divide_int_def
tff(fact_2583_tanh__real__altdef,axiom,
    ! [X3: real] : ( aa(real,real,tanh(real),X3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),bit0(one2)))),X3)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),bit0(one2)))),X3)))) ) ).

% tanh_real_altdef
tff(fact_2584_zero__le__sgn__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,sgn_sgn(real),X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3)) ) ).

% zero_le_sgn_iff
tff(fact_2585_sgn__le__0__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sgn_sgn(real),X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real))) ) ).

% sgn_le_0_iff
tff(fact_2586_nat__int,axiom,
    ! [N: nat] : ( aa(int,nat,nat2,aa(nat,int,semiring_1_of_nat(int),N)) = N ) ).

% nat_int
tff(fact_2587_exp__less__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,exp(real),X3)),aa(real,real,exp(real),Y4))) ) ).

% exp_less_mono
tff(fact_2588_exp__less__cancel__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,exp(real),X3)),aa(real,real,exp(real),Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ).

% exp_less_cancel_iff
tff(fact_2589_exp__le__cancel__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),X3)),aa(real,real,exp(real),Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ).

% exp_le_cancel_iff
tff(fact_2590_exp__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,exp(A),zero_zero(A)) = one_one(A) ) ) ).

% exp_zero
tff(fact_2591_nat__numeral,axiom,
    ! [K: num] : ( aa(int,nat,nat2,aa(num,int,numeral_numeral(int),K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% nat_numeral
tff(fact_2592_exp__eq__one__iff,axiom,
    ! [X3: real] :
      ( ( aa(real,real,exp(real),X3) = one_one(real) )
    <=> ( X3 = zero_zero(real) ) ) ).

% exp_eq_one_iff
tff(fact_2593_pred__numeral__inc,axiom,
    ! [K: num] : ( pred_numeral(inc(K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% pred_numeral_inc
tff(fact_2594_nat__of__bool,axiom,
    ! [P: bool] : ( aa(int,nat,nat2,aa(bool,int,zero_neq_one_of_bool(int),P)) = aa(bool,nat,zero_neq_one_of_bool(nat),P) ) ).

% nat_of_bool
tff(fact_2595_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_dec(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),bitM(K)) ) ) ).

% dbl_dec_simps(5)
tff(fact_2596_nat__1,axiom,
    aa(int,nat,nat2,one_one(int)) = aa(nat,nat,suc,zero_zero(nat)) ).

% nat_1
tff(fact_2597_nat__0__iff,axiom,
    ! [I: int] :
      ( ( aa(int,nat,nat2,I) = zero_zero(nat) )
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),zero_zero(int))) ) ).

% nat_0_iff
tff(fact_2598_nat__le__0,axiom,
    ! [Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z),zero_zero(int)))
     => ( aa(int,nat,nat2,Z) = zero_zero(nat) ) ) ).

% nat_le_0
tff(fact_2599_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Z))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z)) ) ) ).

% zless_nat_conj
tff(fact_2600_nat__neg__numeral,axiom,
    ! [K: num] : ( aa(int,nat,nat2,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) = zero_zero(nat) ) ).

% nat_neg_numeral
tff(fact_2601_one__less__exp__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),aa(real,real,exp(real),X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3)) ) ).

% one_less_exp_iff
tff(fact_2602_exp__less__one__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,exp(real),X3)),one_one(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real))) ) ).

% exp_less_one_iff
tff(fact_2603_exp__le__one__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),X3)),one_one(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real))) ) ).

% exp_le_one_iff
tff(fact_2604_one__le__exp__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(real,real,exp(real),X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3)) ) ).

% one_le_exp_iff
tff(fact_2605_nat__zminus__int,axiom,
    ! [N: nat] : ( aa(int,nat,nat2,aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N))) = zero_zero(nat) ) ).

% nat_zminus_int
tff(fact_2606_int__nat__eq,axiom,
    ! [Z: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
       => ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z)) = Z ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
       => ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z)) = zero_zero(int) ) ) ) ).

% int_nat_eq
tff(fact_2607_exp__ln__iff,axiom,
    ! [X3: real] :
      ( ( aa(real,real,exp(real),aa(real,real,ln_ln(real),X3)) = X3 )
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3)) ) ).

% exp_ln_iff
tff(fact_2608_exp__ln,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(real,real,exp(real),aa(real,real,ln_ln(real),X3)) = X3 ) ) ).

% exp_ln
tff(fact_2609_pred__numeral__simps_I2_J,axiom,
    ! [K: num] : ( pred_numeral(bit0(K)) = aa(num,nat,numeral_numeral(nat),bitM(K)) ) ).

% pred_numeral_simps(2)
tff(fact_2610_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(int,nat,nat2,Z)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Z)) ) ).

% zero_less_nat_eq
tff(fact_2611_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(M))) ) ) ).

% add_neg_numeral_special(6)
tff(fact_2612_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) ) ) ).

% add_neg_numeral_special(5)
tff(fact_2613_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) ) ) ).

% diff_numeral_special(5)
tff(fact_2614_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),inc(M)) ) ) ).

% diff_numeral_special(6)
tff(fact_2615_diff__nat__numeral,axiom,
    ! [V: num,V4: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),aa(num,nat,numeral_numeral(nat),V4)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),V4))) ) ).

% diff_nat_numeral
tff(fact_2616_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X3: num,N: nat,Y4: int] :
      ( ( aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X3)),N) = aa(int,nat,nat2,Y4) )
    <=> ( aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N) = Y4 ) ) ).

% numeral_power_eq_nat_cancel_iff
tff(fact_2617_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y4: int,X3: num,N: nat] :
      ( ( aa(int,nat,nat2,Y4) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X3)),N) )
    <=> ( Y4 = aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N) ) ) ).

% nat_eq_numeral_power_cancel_iff
tff(fact_2618_nat__abs__dvd__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),N))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),K),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% nat_abs_dvd_iff
tff(fact_2619_dvd__nat__abs__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),N),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(nat,int,semiring_1_of_nat(int),N)),K)) ) ).

% dvd_nat_abs_iff
tff(fact_2620_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),aa(int,nat,nat2,Z)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),Z)) ) ).

% one_less_nat_eq
tff(fact_2621_nat__numeral__diff__1,axiom,
    ! [V: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),V)),one_one(int))) ) ).

% nat_numeral_diff_1
tff(fact_2622_numeral__power__less__nat__cancel__iff,axiom,
    ! [X3: num,N: nat,A3: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X3)),N)),aa(int,nat,nat2,A3)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N)),A3)) ) ).

% numeral_power_less_nat_cancel_iff
tff(fact_2623_nat__less__numeral__power__cancel__iff,axiom,
    ! [A3: int,X3: num,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(int,nat,nat2,A3)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X3)),N)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A3),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N))) ) ).

% nat_less_numeral_power_cancel_iff
tff(fact_2624_numeral__power__le__nat__cancel__iff,axiom,
    ! [X3: num,N: nat,A3: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X3)),N)),aa(int,nat,nat2,A3)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N)),A3)) ) ).

% numeral_power_le_nat_cancel_iff
tff(fact_2625_nat__le__numeral__power__cancel__iff,axiom,
    ! [A3: int,X3: num,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(int,nat,nat2,A3)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X3)),N)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N))) ) ).

% nat_le_numeral_power_cancel_iff
tff(fact_2626_nat__mask__eq,axiom,
    ! [N: nat] : ( aa(int,nat,nat2,bit_se2239418461657761734s_mask(int,N)) = bit_se2239418461657761734s_mask(nat,N) ) ).

% nat_mask_eq
tff(fact_2627_BitM__inc__eq,axiom,
    ! [N: num] : ( bitM(inc(N)) = bit1(N) ) ).

% BitM_inc_eq
tff(fact_2628_inc__BitM__eq,axiom,
    ! [N: num] : ( inc(bitM(N)) = bit0(N) ) ).

% inc_BitM_eq
tff(fact_2629_norm__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),X3))),aa(real,real,exp(real),real_V7770717601297561774m_norm(A,X3)))) ) ).

% norm_exp
tff(fact_2630_exp__less__cancel,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,exp(real),X3)),aa(real,real,exp(real),Y4)))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ).

% exp_less_cancel
tff(fact_2631_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,exp(A),X3) != zero_zero(A) ) ) ).

% exp_not_eq_zero
tff(fact_2632_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),A2)),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,exp(A),A2)) ) ) ).

% exp_times_arg_commute
tff(fact_2633_semiring__norm_I26_J,axiom,
    bitM(one2) = one2 ).

% semiring_norm(26)
tff(fact_2634_num__induct,axiom,
    ! [P: fun(num,bool),X3: num] :
      ( pp(aa(num,bool,P,one2))
     => ( ! [X2: num] :
            ( pp(aa(num,bool,P,X2))
           => pp(aa(num,bool,P,inc(X2))) )
       => pp(aa(num,bool,P,X3)) ) ) ).

% num_induct
tff(fact_2635_add__inc,axiom,
    ! [X3: num,Y4: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),X3),inc(Y4)) = inc(aa(num,num,aa(num,fun(num,num),plus_plus(num),X3),Y4)) ) ).

% add_inc
tff(fact_2636_not__exp__less__zero,axiom,
    ! [X3: real] : ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,exp(real),X3)),zero_zero(real))) ).

% not_exp_less_zero
tff(fact_2637_exp__gt__zero,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,exp(real),X3))) ).

% exp_gt_zero
tff(fact_2638_exp__total,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
     => ? [X2: real] : ( aa(real,real,exp(real),X2) = Y4 ) ) ).

% exp_total
tff(fact_2639_not__exp__le__zero,axiom,
    ! [X3: real] : ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),X3)),zero_zero(real))) ).

% not_exp_le_zero
tff(fact_2640_exp__ge__zero,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,exp(real),X3))) ).

% exp_ge_zero
tff(fact_2641_nat__zero__as__int,axiom,
    zero_zero(nat) = aa(int,nat,nat2,zero_zero(int)) ).

% nat_zero_as_int
tff(fact_2642_nat__numeral__as__int,axiom,
    ! [X: num] : ( aa(num,nat,numeral_numeral(nat),X) = aa(int,nat,nat2,aa(num,int,numeral_numeral(int),X)) ) ).

% nat_numeral_as_int
tff(fact_2643_real__sgn__eq,axiom,
    ! [X3: real] : ( aa(real,real,sgn_sgn(real),X3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),aa(real,real,abs_abs(real),X3)) ) ).

% real_sgn_eq
tff(fact_2644_nat__mono,axiom,
    ! [X3: int,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),Y4))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(int,nat,nat2,X3)),aa(int,nat,nat2,Y4))) ) ).

% nat_mono
tff(fact_2645_eq__nat__nat__iff,axiom,
    ! [Z: int,Z5: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z5))
       => ( ( aa(int,nat,nat2,Z) = aa(int,nat,nat2,Z5) )
        <=> ( Z = Z5 ) ) ) ) ).

% eq_nat_nat_iff
tff(fact_2646_all__nat,axiom,
    ! [P: fun(nat,bool)] :
      ( ! [X_12: nat] : pp(aa(nat,bool,P,X_12))
    <=> ! [X4: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X4))
         => pp(aa(nat,bool,P,aa(int,nat,nat2,X4))) ) ) ).

% all_nat
tff(fact_2647_ex__nat,axiom,
    ! [P: fun(nat,bool)] :
      ( ? [X_12: nat] : pp(aa(nat,bool,P,X_12))
    <=> ? [X4: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X4))
          & pp(aa(nat,bool,P,aa(int,nat,nat2,X4))) ) ) ).

% ex_nat
tff(fact_2648_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ( aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) = aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(int,nat,nat2,K)) ) ) ).

% nat_take_bit_eq
tff(fact_2649_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(int,nat,nat2,K)) = aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ) ).

% take_bit_nat_eq
tff(fact_2650_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4) = aa(A,A,aa(A,fun(A,A),times_times(A),Y4),X3) )
         => ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X3)),aa(A,A,exp(A),Y4)) ) ) ) ).

% exp_add_commuting
tff(fact_2651_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X3)),aa(A,A,exp(A),Y4)) = aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) ) ) ).

% mult_exp_exp
tff(fact_2652_exp__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,exp(A),X3)),aa(A,A,exp(A),Y4)) ) ) ).

% exp_diff
tff(fact_2653_nat__one__as__int,axiom,
    one_one(nat) = aa(int,nat,nat2,one_one(int)) ).

% nat_one_as_int
tff(fact_2654_unset__bit__nat__def,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se2638667681897837118et_bit(nat),M),N) = aa(int,nat,nat2,aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),M),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% unset_bit_nat_def
tff(fact_2655_semiring__norm_I27_J,axiom,
    ! [N: num] : ( bitM(bit0(N)) = bit1(bitM(N)) ) ).

% semiring_norm(27)
tff(fact_2656_semiring__norm_I28_J,axiom,
    ! [N: num] : ( bitM(bit1(N)) = bit1(bit0(N)) ) ).

% semiring_norm(28)
tff(fact_2657_inc_Osimps_I1_J,axiom,
    inc(one2) = bit0(one2) ).

% inc.simps(1)
tff(fact_2658_inc_Osimps_I2_J,axiom,
    ! [X3: num] : ( inc(bit0(X3)) = bit1(X3) ) ).

% inc.simps(2)
tff(fact_2659_inc_Osimps_I3_J,axiom,
    ! [X3: num] : ( inc(bit1(X3)) = bit0(inc(X3)) ) ).

% inc.simps(3)
tff(fact_2660_exp__gt__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),aa(real,real,exp(real),X3))) ) ).

% exp_gt_one
tff(fact_2661_add__One,axiom,
    ! [X3: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),X3),one2) = inc(X3) ) ).

% add_One
tff(fact_2662_exp__ge__add__one__self,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3)),aa(real,real,exp(real),X3))) ).

% exp_ge_add_one_self
tff(fact_2663_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Z))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z)) ) ) ).

% nat_mono_iff
tff(fact_2664_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X3)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X3))) = one_one(A) ) ) ).

% exp_minus_inverse
tff(fact_2665_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(int,nat,nat2,Z)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,semiring_1_of_nat(int),M)),Z)) ) ).

% zless_nat_eq_int_zless
tff(fact_2666_nat__le__iff,axiom,
    ! [X3: int,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(int,nat,nat2,X3)),N))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% nat_le_iff
tff(fact_2667_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = Z )
    <=> ( ( M = aa(int,nat,nat2,Z) )
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z)) ) ) ).

% int_eq_iff
tff(fact_2668_nat__0__le,axiom,
    ! [Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
     => ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z)) = Z ) ) ).

% nat_0_le
tff(fact_2669_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,N: nat] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),aa(nat,A,semiring_1_of_nat(A),N))) = aa(nat,A,power_power(A,aa(A,A,exp(A),X3)),N) ) ) ).

% exp_of_nat2_mult
tff(fact_2670_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [N: nat,X3: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),X3)) = aa(nat,A,power_power(A,aa(A,A,exp(A),X3)),N) ) ) ).

% exp_of_nat_mult
tff(fact_2671_nat__int__add,axiom,
    ! [A3: nat,B2: nat] : ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2) ) ).

% nat_int_add
tff(fact_2672_int__minus,axiom,
    ! [N: nat,M: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) = aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(nat,int,semiring_1_of_nat(int),M)))) ) ).

% int_minus
tff(fact_2673_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] : ( aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),W))),aa(int,nat,nat2,aa(int,int,abs_abs(int),Z))) ) ).

% nat_abs_mult_distrib
tff(fact_2674_mult__inc,axiom,
    ! [X3: num,Y4: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),X3),inc(Y4)) = aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),times_times(num),X3),Y4)),X3) ) ).

% mult_inc
tff(fact_2675_eval__nat__numeral_I2_J,axiom,
    ! [N: num] : ( aa(num,nat,numeral_numeral(nat),bit0(N)) = aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),bitM(N))) ) ).

% eval_nat_numeral(2)
tff(fact_2676_one__plus__BitM,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),bitM(N)) = bit0(N) ) ).

% one_plus_BitM
tff(fact_2677_BitM__plus__one,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bitM(N)),one2) = bit0(N) ) ).

% BitM_plus_one
tff(fact_2678_sgn__real__def,axiom,
    ! [A3: real] :
      ( ( ( A3 = zero_zero(real) )
       => ( aa(real,real,sgn_sgn(real),A3) = zero_zero(real) ) )
      & ( ( A3 != zero_zero(real) )
       => ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
           => ( aa(real,real,sgn_sgn(real),A3) = one_one(real) ) )
          & ( ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
           => ( aa(real,real,sgn_sgn(real),A3) = aa(real,real,uminus_uminus(real),one_one(real)) ) ) ) ) ) ).

% sgn_real_def
tff(fact_2679_exp__ge__add__one__self__aux,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3)),aa(real,real,exp(real),X3))) ) ).

% exp_ge_add_one_self_aux
tff(fact_2680_lemma__exp__total,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),Y4))
     => ? [X2: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X2))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),minus_minus(real),Y4),one_one(real))))
          & ( aa(real,real,exp(real),X2) = Y4 ) ) ) ).

% lemma_exp_total
tff(fact_2681_ln__ge__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,ln_ln(real),X3)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),Y4)),X3)) ) ) ).

% ln_ge_iff
tff(fact_2682_numeral__inc,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X3: num] : ( aa(num,A,numeral_numeral(A),inc(X3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X3)),one_one(A)) ) ) ).

% numeral_inc
tff(fact_2683_ln__x__over__x__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),Y4)),Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),X3)),X3))) ) ) ).

% ln_x_over_x_mono
tff(fact_2684_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),W))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z)) ) ) ).

% nat_less_eq_zless
tff(fact_2685_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),W))
        | pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z)) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),W),Z)) ) ) ).

% nat_le_eq_zle
tff(fact_2686_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M = aa(int,nat,nat2,W) )
    <=> ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),W))
         => ( W = aa(nat,int,semiring_1_of_nat(int),M) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),W))
         => ( M = zero_zero(nat) ) ) ) ) ).

% nat_eq_iff2
tff(fact_2687_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( aa(int,nat,nat2,W) = M )
    <=> ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),W))
         => ( W = aa(nat,int,semiring_1_of_nat(int),M) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),W))
         => ( M = zero_zero(nat) ) ) ) ) ).

% nat_eq_iff
tff(fact_2688_split__nat,axiom,
    ! [P: fun(nat,bool),I: int] :
      ( pp(aa(nat,bool,P,aa(int,nat,nat2,I)))
    <=> ( ! [N3: nat] :
            ( ( I = aa(nat,int,semiring_1_of_nat(int),N3) )
           => pp(aa(nat,bool,P,N3)) )
        & ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),I),zero_zero(int)))
         => pp(aa(nat,bool,P,zero_zero(nat))) ) ) ) ).

% split_nat
tff(fact_2689_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(int,nat,nat2,K)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),N)),K)) ) ) ).

% le_nat_iff
tff(fact_2690_nat__add__distrib,axiom,
    ! [Z: int,Z5: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z5))
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),Z5)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5)) ) ) ) ).

% nat_add_distrib
tff(fact_2691_nat__mult__distrib,axiom,
    ! [Z: int,Z5: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),Z),Z5)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5)) ) ) ).

% nat_mult_distrib
tff(fact_2692_Suc__as__int,axiom,
    ! [X: nat] : ( aa(nat,nat,suc,X) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X)),one_one(int))) ) ).

% Suc_as_int
tff(fact_2693_nat__diff__distrib_H,axiom,
    ! [X3: int,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),Y4)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,X3)),aa(int,nat,nat2,Y4)) ) ) ) ).

% nat_diff_distrib'
tff(fact_2694_nat__diff__distrib,axiom,
    ! [Z5: int,Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z5))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z5),Z))
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z5)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5)) ) ) ) ).

% nat_diff_distrib
tff(fact_2695_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L))))) ).

% nat_abs_triangle_ineq
tff(fact_2696_nat__div__distrib,axiom,
    ! [X3: int,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),X3),Y4)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,X3)),aa(int,nat,nat2,Y4)) ) ) ).

% nat_div_distrib
tff(fact_2697_nat__div__distrib_H,axiom,
    ! [Y4: int,X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),X3),Y4)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,X3)),aa(int,nat,nat2,Y4)) ) ) ).

% nat_div_distrib'
tff(fact_2698_nat__power__eq,axiom,
    ! [Z: int,N: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
     => ( aa(int,nat,nat2,aa(nat,int,power_power(int,Z),N)) = aa(nat,nat,power_power(nat,aa(int,nat,nat2,Z)),N) ) ) ).

% nat_power_eq
tff(fact_2699_nat__mod__distrib,axiom,
    ! [X3: int,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
       => ( aa(int,nat,nat2,modulo_modulo(int,X3,Y4)) = modulo_modulo(nat,aa(int,nat,nat2,X3),aa(int,nat,nat2,Y4)) ) ) ) ).

% nat_mod_distrib
tff(fact_2700_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) ).

% div_abs_eq_div_nat
tff(fact_2701_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] : ( modulo_modulo(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L)) = aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) ).

% mod_abs_eq_div_nat
tff(fact_2702_numeral__BitM,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bitM(N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),bit0(N))),one_one(A)) ) ) ).

% numeral_BitM
tff(fact_2703_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [W: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(num,A,numeral_numeral(A),bitM(W)))) ) ).

% odd_numeral_BitM
tff(fact_2704_exp__le,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),one_one(real))),aa(num,real,numeral_numeral(real),bit1(one2)))) ).

% exp_le
tff(fact_2705_nat__2,axiom,
    aa(int,nat,nat2,aa(num,int,numeral_numeral(int),bit0(one2))) = aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))) ).

% nat_2
tff(fact_2706_sgn__power__injE,axiom,
    ! [A3: real,N: nat,X3: real,B2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),A3)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),A3)),N)) = X3 )
     => ( ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),B2)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),B2)),N)) )
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( A3 = B2 ) ) ) ) ).

% sgn_power_injE
tff(fact_2707_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
     => ( aa(nat,nat,suc,aa(int,nat,nat2,Z)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)) ) ) ).

% Suc_nat_eq_nat_zadd1
tff(fact_2708_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),W))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(int,nat,nat2,W)),M))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),aa(nat,int,semiring_1_of_nat(int),M))) ) ) ).

% nat_less_iff
tff(fact_2709_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z5: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z),zero_zero(int)))
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),Z),Z5)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Z))),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Z5))) ) ) ).

% nat_mult_distrib_neg
tff(fact_2710_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [N: nat,X3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(nat,A,power_power(A,aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),aa(nat,A,semiring_1_of_nat(A),N)))),N) = aa(A,A,exp(A),X3) ) ) ) ).

% exp_divide_power_eq
tff(fact_2711_nat__abs__int__diff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),B2))
       => ( aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2)))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),B2),A3) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),B2))
       => ( aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),A3)),aa(nat,int,semiring_1_of_nat(int),B2)))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A3),B2) ) ) ) ).

% nat_abs_int_diff
tff(fact_2712_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,tanh(A),X3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),X3)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X3)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),X3)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X3)))) ) ) ).

% tanh_altdef
tff(fact_2713_exp__half__le2,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% exp_half_le2
tff(fact_2714_exp__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Z)) = aa(nat,A,power_power(A,aa(A,A,exp(A),Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% exp_double
tff(fact_2715_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(int,nat,nat2,Z)),M))
    <=> ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
         => pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),Z),aa(nat,int,semiring_1_of_nat(int),M))) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
         => ( M = zero_zero(nat) ) ) ) ) ).

% nat_dvd_iff
tff(fact_2716_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Z))),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ).

% exp_bound_half
tff(fact_2717_exp__bound,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),X3)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% exp_bound
tff(fact_2718_even__nat__iff,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(int,nat,nat2,K)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)) ) ) ).

% even_nat_iff
tff(fact_2719_real__exp__bound__lemma,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,exp(real),X3)),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),X3)))) ) ) ).

% real_exp_bound_lemma
tff(fact_2720_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(nat,real,semiring_1_of_nat(real),N))),X3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),aa(nat,real,semiring_1_of_nat(real),N)))),N)),aa(real,real,exp(real),X3))) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
tff(fact_2721_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(nat,real,semiring_1_of_nat(real),N)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),aa(nat,real,semiring_1_of_nat(real),N)))),N)),aa(real,real,exp(real),aa(real,real,uminus_uminus(real),X3)))) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
tff(fact_2722_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),real_V7770717601297561774m_norm(A,Z))))) ) ) ).

% exp_bound_lemma
tff(fact_2723_exp__lower__Taylor__quadratic,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,exp(real),X3))) ) ).

% exp_lower_Taylor_quadratic
tff(fact_2724_log__base__10__eq1,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(bit1(bit0(one2))))),X3) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),aa(real,real,exp(real),one_one(real)))),aa(real,real,ln_ln(real),aa(num,real,numeral_numeral(real),bit0(bit1(bit0(one2))))))),aa(real,real,ln_ln(real),X3)) ) ) ).

% log_base_10_eq1
tff(fact_2725_signed__take__bit__eq__take__bit__minus,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),K)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),aa(nat,nat,suc,N))),aa(bool,int,zero_neq_one_of_bool(int),aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)))) ) ).

% signed_take_bit_eq_take_bit_minus
tff(fact_2726_and__int__unfold,axiom,
    ! [K: int,L: int] :
      ( ( ( ( K = zero_zero(int) )
          | ( L = zero_zero(int) ) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = zero_zero(int) ) )
      & ( ~ ( ( K = zero_zero(int) )
            | ( L = zero_zero(int) ) )
       => ( ( ( K = aa(int,int,uminus_uminus(int),one_one(int)) )
           => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = L ) )
          & ( ( K != aa(int,int,uminus_uminus(int),one_one(int)) )
           => ( ( ( L = aa(int,int,uminus_uminus(int),one_one(int)) )
               => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = K ) )
              & ( ( L != aa(int,int,uminus_uminus(int),one_one(int)) )
               => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),bit0(one2))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ) ) ) ) ) ).

% and_int_unfold
tff(fact_2727_arctan__half,axiom,
    ! [X3: real] : ( aa(real,real,arctan,X3) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))))))) ) ).

% arctan_half
tff(fact_2728_log__base__10__eq2,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(bit1(bit0(one2))))),X3) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(bit1(bit0(one2))))),aa(real,real,exp(real),one_one(real)))),aa(real,real,ln_ln(real),X3)) ) ) ).

% log_base_10_eq2
tff(fact_2729_machin,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit1(bit0(one2))))))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit1(bit1(bit1(bit1(bit0(bit1(bit1(one2))))))))))) ).

% machin
tff(fact_2730_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2) ) ) ).

% and.right_idem
tff(fact_2731_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2) ) ) ).

% and.left_idem
tff(fact_2732_and_Oidem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),A3) = A3 ) ) ).

% and.idem
tff(fact_2733_real__sqrt__eq__iff,axiom,
    ! [X3: real,Y4: real] :
      ( ( aa(real,real,sqrt,X3) = aa(real,real,sqrt,Y4) )
    <=> ( X3 = Y4 ) ) ).

% real_sqrt_eq_iff
tff(fact_2734_and__zero__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),zero_zero(A)) = zero_zero(A) ) ) ).

% and_zero_eq
tff(fact_2735_zero__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),zero_zero(A)),A3) = zero_zero(A) ) ) ).

% zero_and_eq
tff(fact_2736_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),zero_zero(A)),X3) = zero_zero(A) ) ) ).

% bit.conj_zero_left
tff(fact_2737_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),zero_zero(A)) = zero_zero(A) ) ) ).

% bit.conj_zero_right
tff(fact_2738_real__sqrt__zero,axiom,
    aa(real,real,sqrt,zero_zero(real)) = zero_zero(real) ).

% real_sqrt_zero
tff(fact_2739_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X3: real] :
      ( ( aa(real,real,sqrt,X3) = zero_zero(real) )
    <=> ( X3 = zero_zero(real) ) ) ).

% real_sqrt_eq_zero_cancel_iff
tff(fact_2740_real__sqrt__less__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,sqrt,X3)),aa(real,real,sqrt,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ).

% real_sqrt_less_iff
tff(fact_2741_real__sqrt__le__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,X3)),aa(real,real,sqrt,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ).

% real_sqrt_le_iff
tff(fact_2742_real__sqrt__eq__1__iff,axiom,
    ! [X3: real] :
      ( ( aa(real,real,sqrt,X3) = one_one(real) )
    <=> ( X3 = one_one(real) ) ) ).

% real_sqrt_eq_1_iff
tff(fact_2743_real__sqrt__one,axiom,
    aa(real,real,sqrt,one_one(real)) = one_one(real) ).

% real_sqrt_one
tff(fact_2744_take__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)),aa(A,A,bit_se2584673776208193580ke_bit(A,N),B2)) ) ) ).

% take_bit_and
tff(fact_2745_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))),A3) = A3 ) ) ).

% and.left_neutral
tff(fact_2746_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,uminus_uminus(A),one_one(A))) = A3 ) ) ).

% and.right_neutral
tff(fact_2747_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),aa(A,A,uminus_uminus(A),one_one(A))) = X3 ) ) ).

% bit.conj_one_right
tff(fact_2748_real__sqrt__gt__0__iff,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,sqrt,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4)) ) ).

% real_sqrt_gt_0_iff
tff(fact_2749_real__sqrt__lt__0__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,sqrt,X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real))) ) ).

% real_sqrt_lt_0_iff
tff(fact_2750_real__sqrt__ge__0__iff,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4)) ) ).

% real_sqrt_ge_0_iff
tff(fact_2751_real__sqrt__le__0__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real))) ) ).

% real_sqrt_le_0_iff
tff(fact_2752_real__sqrt__gt__1__iff,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),aa(real,real,sqrt,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),Y4)) ) ).

% real_sqrt_gt_1_iff
tff(fact_2753_real__sqrt__lt__1__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,sqrt,X3)),one_one(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real))) ) ).

% real_sqrt_lt_1_iff
tff(fact_2754_real__sqrt__ge__1__iff,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(real,real,sqrt,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),Y4)) ) ).

% real_sqrt_ge_1_iff
tff(fact_2755_real__sqrt__le__1__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,X3)),one_one(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real))) ) ).

% real_sqrt_le_1_iff
tff(fact_2756_log__one,axiom,
    ! [A3: real] : ( aa(real,real,log(A3),one_one(real)) = zero_zero(real) ) ).

% log_one
tff(fact_2757_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
        | pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),L)) ) ) ).

% and_nonnegative_int_iff
tff(fact_2758_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),zero_zero(int)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int))) ) ) ).

% and_negative_int_iff
tff(fact_2759_real__sqrt__mult__self,axiom,
    ! [A3: real] : ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,A3)),aa(real,real,sqrt,A3)) = aa(real,real,abs_abs(real),A3) ) ).

% real_sqrt_mult_self
tff(fact_2760_real__sqrt__abs2,axiom,
    ! [X3: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X3),X3)) = aa(real,real,abs_abs(real),X3) ) ).

% real_sqrt_abs2
tff(fact_2761_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),bit0(M))),aa(nat,nat,suc,N)))
        <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),M)),N)) ) ) ).

% bit_numeral_Bit0_Suc_iff
tff(fact_2762_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),bit1(Y4))) = one_one(A) ) ) ).

% and_numerals(2)
tff(fact_2763_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit1(X3))),one_one(A)) = one_one(A) ) ) ).

% and_numerals(8)
tff(fact_2764_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),bit1(M))),aa(nat,nat,suc,N)))
        <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),M)),N)) ) ) ).

% bit_numeral_Bit1_Suc_iff
tff(fact_2765_real__sqrt__four,axiom,
    aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) = aa(num,real,numeral_numeral(real),bit0(one2)) ).

% real_sqrt_four
tff(fact_2766_log__eq__one,axiom,
    ! [A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( aa(real,real,log(A3),A3) = one_one(real) ) ) ) ).

% log_eq_one
tff(fact_2767_log__less__cancel__iff,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,log(A3),X3)),aa(real,real,log(A3),Y4)))
          <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ) ) ) ).

% log_less_cancel_iff
tff(fact_2768_log__less__one__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,log(A3),X3)),one_one(real)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),A3)) ) ) ) ).

% log_less_one_cancel_iff
tff(fact_2769_one__less__log__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),aa(real,real,log(A3),X3)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X3)) ) ) ) ).

% one_less_log_cancel_iff
tff(fact_2770_log__less__zero__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,log(A3),X3)),zero_zero(real)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real))) ) ) ) ).

% log_less_zero_cancel_iff
tff(fact_2771_zero__less__log__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,log(A3),X3)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3)) ) ) ) ).

% zero_less_log_cancel_iff
tff(fact_2772_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)))
    <=> ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)) ) ).

% signed_take_bit_nonnegative_iff
tff(fact_2773_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),zero_zero(int)))
    <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)) ) ).

% signed_take_bit_negative_iff
tff(fact_2774_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit0(X3))),one_one(A)) = zero_zero(A) ) ) ).

% and_numerals(5)
tff(fact_2775_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(Y4))) = zero_zero(A) ) ) ).

% and_numerals(1)
tff(fact_2776_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit0(X3))),aa(num,A,numeral_numeral(A),bit0(Y4))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4))) ) ) ).

% and_numerals(3)
tff(fact_2777_log__le__cancel__iff,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,log(A3),X3)),aa(real,real,log(A3),Y4)))
          <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ) ) ) ).

% log_le_cancel_iff
tff(fact_2778_log__le__one__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,log(A3),X3)),one_one(real)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),A3)) ) ) ) ).

% log_le_one_cancel_iff
tff(fact_2779_one__le__log__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(real,real,log(A3),X3)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X3)) ) ) ) ).

% one_le_log_cancel_iff
tff(fact_2780_log__le__zero__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,log(A3),X3)),zero_zero(real)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real))) ) ) ) ).

% log_le_zero_cancel_iff
tff(fact_2781_zero__le__log__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,log(A3),X3)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3)) ) ) ) ).

% zero_le_log_cancel_iff
tff(fact_2782_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,N: num] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),bit0(W))),aa(num,nat,numeral_numeral(nat),N)))
        <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),pred_numeral(N))) ) ) ).

% bit_numeral_simps(2)
tff(fact_2783_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(W)))),aa(nat,nat,suc,N)))
    <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),N)) ) ).

% bit_minus_numeral_Bit0_Suc_iff
tff(fact_2784_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,N: num] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),bit1(W))),aa(num,nat,numeral_numeral(nat),N)))
        <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),pred_numeral(N))) ) ) ).

% bit_numeral_simps(3)
tff(fact_2785_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(W)))),aa(nat,nat,suc,N)))
    <=> ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(num,int,numeral_numeral(int),W)),N)) ) ).

% bit_minus_numeral_Bit1_Suc_iff
tff(fact_2786_and__minus__numerals_I6_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(N)))),one_one(int)) = one_one(int) ) ).

% and_minus_numerals(6)
tff(fact_2787_and__minus__numerals_I2_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(N)))) = one_one(int) ) ).

% and_minus_numerals(2)
tff(fact_2788_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit1(X3))),aa(num,A,numeral_numeral(A),bit0(Y4))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4))) ) ) ).

% and_numerals(6)
tff(fact_2789_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit0(X3))),aa(num,A,numeral_numeral(A),bit1(Y4))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4))) ) ) ).

% and_numerals(4)
tff(fact_2790_bit__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),zero_zero(nat)))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ).

% bit_0
tff(fact_2791_real__sqrt__abs,axiom,
    ! [X3: real] : ( aa(real,real,sqrt,aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(real,real,abs_abs(real),X3) ) ).

% real_sqrt_abs
tff(fact_2792_and__minus__numerals_I5_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))),one_one(int)) = zero_zero(int) ) ).

% and_minus_numerals(5)
tff(fact_2793_and__minus__numerals_I1_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))) = zero_zero(int) ) ).

% and_minus_numerals(1)
tff(fact_2794_log__pow__cancel,axiom,
    ! [A3: real,B2: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( aa(real,real,log(A3),aa(nat,real,power_power(real,A3),B2)) = aa(nat,real,semiring_1_of_nat(real),B2) ) ) ) ).

% log_pow_cancel
tff(fact_2795_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N: num] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(W)))),aa(num,nat,numeral_numeral(nat),N)))
    <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),pred_numeral(N))) ) ).

% bit_minus_numeral_int(1)
tff(fact_2796_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N: num] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(W)))),aa(num,nat,numeral_numeral(nat),N)))
    <=> ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(num,int,numeral_numeral(int),W)),pred_numeral(N))) ) ).

% bit_minus_numeral_int(2)
tff(fact_2797_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2)))),N))
        <=> ( ( N = zero_zero(nat) )
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ) ).

% bit_mod_2_iff
tff(fact_2798_real__sqrt__pow2,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( aa(nat,real,power_power(real,aa(real,real,sqrt,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = X3 ) ) ).

% real_sqrt_pow2
tff(fact_2799_real__sqrt__pow2__iff,axiom,
    ! [X3: real] :
      ( ( aa(nat,real,power_power(real,aa(real,real,sqrt,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = X3 )
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3)) ) ).

% real_sqrt_pow2_iff
tff(fact_2800_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X3: real,Y4: real,Xa: real,Ya: real] : ( aa(nat,real,power_power(real,aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Ya),aa(num,nat,numeral_numeral(nat),bit0(one2))))))),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Ya),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% real_sqrt_sum_squares_mult_squared_eq
tff(fact_2801_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit1(X3))),aa(num,A,numeral_numeral(A),bit1(Y4))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4)))) ) ) ).

% and_numerals(7)
tff(fact_2802_bit__and__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),N))
    <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N))
        & pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,L),N)) ) ) ).

% bit_and_int_iff
tff(fact_2803_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),C2)) ) ) ).

% and.left_commute
tff(fact_2804_bit__and__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2)),N))
        <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
            & pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,B2),N)) ) ) ) ).

% bit_and_iff
tff(fact_2805_and_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),A3) ) ) ).

% and.commute
tff(fact_2806_and_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),C2)) ) ) ).

% and.assoc
tff(fact_2807_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(nat,A,semiring_1_of_nat(A),M)),N))
        <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,M),N)) ) ) ).

% bit_of_nat_iff_bit
tff(fact_2808_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_and_eq
tff(fact_2809_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),M)),N))
        <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,aa(num,nat,numeral_numeral(nat),M)),N)) ) ) ).

% bit_numeral_iff
tff(fact_2810_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,B2: A,N: nat] :
          ( ! [N2: nat] :
              ( ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N2))
              | ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,B2),N2)) )
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),N))
          <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
              | pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,B2),N)) ) ) ) ) ).

% bit_disjunctive_add_iff
tff(fact_2811_real__sqrt__less__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,sqrt,X3)),aa(real,real,sqrt,Y4))) ) ).

% real_sqrt_less_mono
tff(fact_2812_real__sqrt__le__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,X3)),aa(real,real,sqrt,Y4))) ) ).

% real_sqrt_le_mono
tff(fact_2813_real__sqrt__divide,axiom,
    ! [X3: real,Y4: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),Y4)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,X3)),aa(real,real,sqrt,Y4)) ) ).

% real_sqrt_divide
tff(fact_2814_real__sqrt__mult,axiom,
    ! [X3: real,Y4: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X3),Y4)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,X3)),aa(real,real,sqrt,Y4)) ) ).

% real_sqrt_mult
tff(fact_2815_real__sqrt__power,axiom,
    ! [X3: real,K: nat] : ( aa(real,real,sqrt,aa(nat,real,power_power(real,X3),K)) = aa(nat,real,power_power(real,aa(real,real,sqrt,X3)),K) ) ).

% real_sqrt_power
tff(fact_2816_real__sqrt__minus,axiom,
    ! [X3: real] : ( aa(real,real,sqrt,aa(real,real,uminus_uminus(real),X3)) = aa(real,real,uminus_uminus(real),aa(real,real,sqrt,X3)) ) ).

% real_sqrt_minus
tff(fact_2817_pi__neq__zero,axiom,
    pi != zero_zero(real) ).

% pi_neq_zero
tff(fact_2818_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),A3)),N))
        <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
            & ( M != N ) ) ) ) ).

% bit_unset_bit_iff
tff(fact_2819_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( A3 = aa(A,A,uminus_uminus(A),one_one(A)) )
            & ( B2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% and_eq_minus_1_iff
tff(fact_2820_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(nat,nat,suc,N))) ) ).

% not_bit_1_Suc
tff(fact_2821_bit__1__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),N))
        <=> ( N = zero_zero(nat) ) ) ) ).

% bit_1_iff
tff(fact_2822_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: num] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(num,nat,numeral_numeral(nat),N))) ) ).

% bit_numeral_simps(1)
tff(fact_2823_real__sqrt__gt__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,sqrt,X3))) ) ).

% real_sqrt_gt_zero
tff(fact_2824_real__sqrt__ge__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,X3))) ) ).

% real_sqrt_ge_zero
tff(fact_2825_real__sqrt__eq__zero__cancel,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( ( aa(real,real,sqrt,X3) = zero_zero(real) )
       => ( X3 = zero_zero(real) ) ) ) ).

% real_sqrt_eq_zero_cancel
tff(fact_2826_real__sqrt__ge__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(real,real,sqrt,X3))) ) ).

% real_sqrt_ge_one
tff(fact_2827_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se2584673776208193580ke_bit(A,M),A3)),N))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
            & pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N)) ) ) ) ).

% bit_take_bit_iff
tff(fact_2828_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [B2: bool,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(bool,A,zero_neq_one_of_bool(A),B2)),N))
        <=> ( pp(B2)
            & ( N = zero_zero(nat) ) ) ) ) ).

% bit_of_bool_iff
tff(fact_2829_AND__lower,axiom,
    ! [X3: int,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X3),Y4))) ) ).

% AND_lower
tff(fact_2830_AND__upper1,axiom,
    ! [X3: int,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X3),Y4)),X3)) ) ).

% AND_upper1
tff(fact_2831_AND__upper2,axiom,
    ! [Y4: int,X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X3),Y4)),Y4)) ) ).

% AND_upper2
tff(fact_2832_AND__upper1_H,axiom,
    ! [Y4: int,Z: int,Ya: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Y4),Z))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Y4),Ya)),Z)) ) ) ).

% AND_upper1'
tff(fact_2833_AND__upper2_H,axiom,
    ! [Y4: int,Z: int,X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Y4),Z))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X3),Y4)),Z)) ) ) ).

% AND_upper2'
tff(fact_2834_log__def,axiom,
    ! [A3: real,X3: real] : ( aa(real,real,log(A3),X3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),X3)),aa(real,real,ln_ln(real),A3)) ) ).

% log_def
tff(fact_2835_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),bit_se2239418461657761734s_mask(A,N)) ) ) ).

% take_bit_eq_mask
tff(fact_2836_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,N: nat] :
          ( ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
         => ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) ) ) ) ).

% signed_take_bit_eq_if_positive
tff(fact_2837_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = zero_zero(A) )
        <=> ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N)) ) ) ).

% and_exp_eq_0_iff_not_bit
tff(fact_2838_pi__gt__zero,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),pi)) ).

% pi_gt_zero
tff(fact_2839_pi__not__less__zero,axiom,
    ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),pi),zero_zero(real))) ).

% pi_not_less_zero
tff(fact_2840_pi__ge__zero,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),pi)) ).

% pi_ge_zero
tff(fact_2841_real__div__sqrt,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),aa(real,real,sqrt,X3)) = aa(real,real,sqrt,X3) ) ) ).

% real_div_sqrt
tff(fact_2842_sqrt__add__le__add__sqrt,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,sqrt,X3)),aa(real,real,sqrt,Y4)))) ) ) ).

% sqrt_add_le_add_sqrt
tff(fact_2843_le__real__sqrt__sumsq,axiom,
    ! [X3: real,Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),X3),X3)),aa(real,real,aa(real,fun(real,real),times_times(real),Y4),Y4))))) ).

% le_real_sqrt_sumsq
tff(fact_2844_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int)))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),K)) ) ).

% and_less_eq
tff(fact_2845_AND__upper1_H_H,axiom,
    ! [Y4: int,Z: int,Ya: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Y4),Z))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Y4),Ya)),Z)) ) ) ).

% AND_upper1''
tff(fact_2846_AND__upper2_H_H,axiom,
    ! [Y4: int,Z: int,X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Y4),Z))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X3),Y4)),Z)) ) ) ).

% AND_upper2''
tff(fact_2847_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),K)),one_one(int))),N))
    <=> ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)) ) ).

% bit_not_int_iff'
tff(fact_2848_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se8732182000553998342ip_bit(A,N,A3) = aa(A,A,aa(nat,fun(A,A),if(fun(nat,fun(A,A)),aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N),bit_se2638667681897837118et_bit(A),bit_se5668285175392031749et_bit(A)),N),A3) ) ) ).

% flip_bit_eq_if
tff(fact_2849_even__and__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) ) ) ) ).

% even_and_iff
tff(fact_2850_sqrt2__less__2,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2)))),aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% sqrt2_less_2
tff(fact_2851_log__base__change,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( aa(real,real,log(B2),X3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A3),X3)),aa(real,real,log(A3),B2)) ) ) ) ).

% log_base_change
tff(fact_2852_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K))
        | pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L)) ) ) ).

% even_and_iff_int
tff(fact_2853_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( aa(nat,real,semiring_1_of_nat(real),M) = aa(nat,real,power_power(real,B2),N) )
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
       => ( aa(nat,real,semiring_1_of_nat(real),N) = aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M)) ) ) ) ).

% log_of_power_eq
tff(fact_2854_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,power_power(real,B2),N)),M))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(B2),M))) ) ) ).

% less_log_of_power
tff(fact_2855_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
     => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,M),K))) ) ) ).

% bit_imp_take_bit_positive
tff(fact_2856_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_concat_bit(M,K),L)),N))
    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
          & pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)) )
        | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
          & pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,L),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ) ).

% bit_concat_bit_iff
tff(fact_2857_pi__less__4,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2))))) ).

% pi_less_4
tff(fact_2858_pi__ge__two,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)) ).

% pi_ge_two
tff(fact_2859_pi__half__neq__two,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))) != aa(num,real,numeral_numeral(real),bit0(one2)) ).

% pi_half_neq_two
tff(fact_2860_signed__take__bit__eq__concat__bit,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = aa(int,int,bit_concat_bit(N,K),aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)))) ) ).

% signed_take_bit_eq_concat_bit
tff(fact_2861_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat,A3: A] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) = zero_zero(A) )
         => ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N)) ) ) ).

% exp_eq_0_imp_not_bit
tff(fact_2862_bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),aa(nat,nat,suc,N)))
        <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))),N)) ) ) ).

% bit_Suc
tff(fact_2863_and__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),one_one(A)) = modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% and_one_eq
tff(fact_2864_one__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),A3) = modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% one_and_eq
tff(fact_2865_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] :
          ( ! [N2: nat] :
              ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N2))
            <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))) = A3 ) ) ) ).

% bit_iff_idd_imp_stable
tff(fact_2866_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))) = A3 )
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
          <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ) ).

% stable_imp_bit_iff_odd
tff(fact_2867_real__less__rsqrt,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),Y4))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,sqrt,Y4))) ) ).

% real_less_rsqrt
tff(fact_2868_sqrt__le__D,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,X3)),Y4))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% sqrt_le_D
tff(fact_2869_real__le__rsqrt,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),Y4))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,sqrt,Y4))) ) ).

% real_le_rsqrt
tff(fact_2870_log__mult,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
           => ( aa(real,real,log(A3),aa(real,real,aa(real,fun(real,real),times_times(real),X3),Y4)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,log(A3),X3)),aa(real,real,log(A3),Y4)) ) ) ) ) ) ).

% log_mult
tff(fact_2871_log__divide,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
           => ( aa(real,real,log(A3),aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),Y4)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,log(A3),X3)),aa(real,real,log(A3),Y4)) ) ) ) ) ) ).

% log_divide
tff(fact_2872_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N2: nat] :
          ( ! [M2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N2),M2))
             => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),M2))
              <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N2)) ) )
         => ~ ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
             => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N2),one_one(nat))))
              <=> ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N2)) ) ) ) ).

% int_bit_bound
tff(fact_2873_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,power_power(real,B2),N)),M))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(B2),M))) ) ) ).

% le_log_of_power
tff(fact_2874_log__base__pow,axiom,
    ! [A3: real,N: nat,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( aa(real,real,log(aa(nat,real,power_power(real,A3),N)),X3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A3),X3)),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ).

% log_base_pow
tff(fact_2875_log__nat__power,axiom,
    ! [X3: real,B2: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(real,real,log(B2),aa(nat,real,power_power(real,X3),N)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(B2),X3)) ) ) ).

% log_nat_power
tff(fact_2876_pi__half__neq__zero,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))) != zero_zero(real) ).

% pi_half_neq_zero
tff(fact_2877_pi__half__less__two,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% pi_half_less_two
tff(fact_2878_pi__half__le__two,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% pi_half_le_two
tff(fact_2879_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)))) ) ) ).

% bit_iff_odd
tff(fact_2880_real__le__lsqrt,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,X3)),Y4)) ) ) ) ).

% real_le_lsqrt
tff(fact_2881_real__sqrt__unique,axiom,
    ! [Y4: real,X3: real] :
      ( ( aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))) = X3 )
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( aa(real,real,sqrt,X3) = Y4 ) ) ) ).

% real_sqrt_unique
tff(fact_2882_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),U))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2))))),U)) ) ).

% lemma_real_divide_sqrt_less
tff(fact_2883_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X3: real,Y4: real] :
      ( ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))) = X3 )
     => ( Y4 = zero_zero(real) ) ) ).

% real_sqrt_sum_squares_eq_cancel
tff(fact_2884_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X3: real,Y4: real] :
      ( ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))) = Y4 )
     => ( X3 = zero_zero(real) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
tff(fact_2885_real__sqrt__sum__squares__ge1,axiom,
    ! [X3: real,Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ).

% real_sqrt_sum_squares_ge1
tff(fact_2886_real__sqrt__sum__squares__ge2,axiom,
    ! [Y4: real,X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ).

% real_sqrt_sum_squares_ge2
tff(fact_2887_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A3: real,C2: real,B2: real,D2: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),A3),C2)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),B2),D2)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,A3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,B2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,C2),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,D2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))) ).

% real_sqrt_sum_squares_triangle_ineq
tff(fact_2888_sqrt__ge__absD,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),aa(real,real,sqrt,Y4)))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),Y4)) ) ).

% sqrt_ge_absD
tff(fact_2889_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N) )
     => ( aa(nat,real,semiring_1_of_nat(real),N) = aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M)) ) ) ).

% log2_of_power_eq
tff(fact_2890_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,semiring_1_of_nat(real),M)),aa(nat,real,power_power(real,B2),N)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),N))) ) ) ) ).

% log_of_power_less
tff(fact_2891_log__eq__div__ln__mult__log,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
         => ( ( B2 != one_one(real) )
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
             => ( aa(real,real,log(A3),X3) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),B2)),aa(real,real,ln_ln(real),A3))),aa(real,real,log(B2),X3)) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
tff(fact_2892_bit__int__def,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N))
    <=> ~ pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))) ) ).

% bit_int_def
tff(fact_2893_pi__half__gt__zero,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ).

% pi_half_gt_zero
tff(fact_2894_pi__half__ge__zero,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ).

% pi_half_ge_zero
tff(fact_2895_m2pi__less__pi,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))),pi)) ).

% m2pi_less_pi
tff(fact_2896_arctan__ubound,axiom,
    ! [Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arctan,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ).

% arctan_ubound
tff(fact_2897_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3)),N))
          <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% even_bit_succ_iff
tff(fact_2898_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
          <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),N))
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
tff(fact_2899_arctan__one,axiom,
    aa(real,real,arctan,one_one(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) ).

% arctan_one
tff(fact_2900_real__less__lsqrt,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,sqrt,X3)),Y4)) ) ) ) ).

% real_less_lsqrt
tff(fact_2901_sqrt__sum__squares__le__sum,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4))) ) ) ).

% sqrt_sum_squares_le_sum
tff(fact_2902_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),M)),aa(nat,real,power_power(real,B2),N)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),N))) ) ) ) ).

% log_of_power_le
tff(fact_2903_real__sqrt__ge__abs1,axiom,
    ! [X3: real,Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ).

% real_sqrt_ge_abs1
tff(fact_2904_real__sqrt__ge__abs2,axiom,
    ! [Y4: real,X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ).

% real_sqrt_ge_abs2
tff(fact_2905_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X3: real,Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),X3)),aa(real,real,abs_abs(real),Y4)))) ).

% sqrt_sum_squares_le_sum_abs
tff(fact_2906_ln__sqrt,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(real,real,ln_ln(real),aa(real,real,sqrt,X3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),X3)),aa(num,real,numeral_numeral(real),bit0(one2))) ) ) ).

% ln_sqrt
tff(fact_2907_sqrt__even__pow2,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(real,real,sqrt,aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),bit0(one2))),N)) = aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% sqrt_even_pow2
tff(fact_2908_arsinh__real__def,axiom,
    ! [X3: real] : ( aa(real,real,arsinh(real),X3) = aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real))))) ) ).

% arsinh_real_def
tff(fact_2909_minus__pi__half__less__zero,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),zero_zero(real))) ).

% minus_pi_half_less_zero
tff(fact_2910_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A,N: nat] :
          ( ! [J2: nat] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),aa(nat,nat,suc,J2)))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))),N))
          <=> ( ( ( N = zero_zero(nat) )
               => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) )
              & ( ( N != zero_zero(nat) )
               => pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)),N)) ) ) ) ) ) ).

% bit_sum_mult_2_cases
tff(fact_2911_bit__rec,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
        <=> ( ( ( N = zero_zero(nat) )
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) )
            & ( ( N != zero_zero(nat) )
             => pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ) ) ).

% bit_rec
tff(fact_2912_arctan__lbound,axiom,
    ! [Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arctan,Y4))) ).

% arctan_lbound
tff(fact_2913_arctan__bounded,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arctan,Y4)))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arctan,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ).

% arctan_bounded
tff(fact_2914_arsinh__real__aux,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real)))))) ).

% arsinh_real_aux
tff(fact_2915_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X3: real,Y4: real,Xa: real,Ya: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Ya),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))) ).

% real_sqrt_sum_squares_mult_ge_zero
tff(fact_2916_real__sqrt__power__even,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
       => ( aa(nat,real,power_power(real,aa(real,real,sqrt,X3)),N) = aa(nat,real,power_power(real,X3),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ) ).

% real_sqrt_power_even
tff(fact_2917_arith__geo__mean__sqrt,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X3),Y4))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ).

% arith_geo_mean_sqrt
tff(fact_2918_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),M))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M)))) ) ).

% less_log2_of_power
tff(fact_2919_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),M))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M)))) ) ).

% le_log2_of_power
tff(fact_2920_and__int__rec,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ).

% and_int_rec
tff(fact_2921_set__bit__eq,axiom,
    ! [N: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),N),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(int,int,aa(int,fun(int,int),times_times(int),aa(bool,int,zero_neq_one_of_bool(int),aa(bool,bool,fNot,aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)))),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ).

% set_bit_eq
tff(fact_2922_unset__bit__eq,axiom,
    ! [N: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),N),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(int,int,aa(int,fun(int,int),times_times(int),aa(bool,int,zero_neq_one_of_bool(int),aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N))),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ).

% unset_bit_eq
tff(fact_2923_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),N))) ) ) ).

% log2_of_power_less
tff(fact_2924_cos__x__y__le__one,axiom,
    ! [X3: real,Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))),one_one(real))) ).

% cos_x_y_le_one
tff(fact_2925_real__sqrt__sum__squares__less,axiom,
    ! [X3: real,U: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2))))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2))))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),U)) ) ) ).

% real_sqrt_sum_squares_less
tff(fact_2926_arcosh__real__def,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3))
     => ( aa(real,real,arcosh(real),X3) = aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real))))) ) ) ).

% arcosh_real_def
tff(fact_2927_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)),aa(bool,int,zero_neq_one_of_bool(int),aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)))),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ).

% take_bit_Suc_from_most
tff(fact_2928_sqrt__sum__squares__half__less,axiom,
    ! [X3: real,U: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(num,real,numeral_numeral(real),bit0(one2)))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),U)) ) ) ) ) ).

% sqrt_sum_squares_half_less
tff(fact_2929_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),N))) ) ) ).

% log2_of_power_le
tff(fact_2930_machin__Euler,axiom,
    aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit1(bit0(one2)))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit1(bit1(one2))))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),bit1(one2))),aa(num,real,numeral_numeral(real),bit1(bit1(bit1(bit1(bit0(bit0(one2))))))))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) ).

% machin_Euler
tff(fact_2931_arctan__inverse,axiom,
    ! [X3: real] :
      ( ( X3 != zero_zero(real) )
     => ( aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X3)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),X3)),pi)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(real,real,arctan,X3)) ) ) ).

% arctan_inverse
tff(fact_2932_sin__cos__npi,axiom,
    ! [N: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),pi)),aa(num,real,numeral_numeral(real),bit0(one2)))) = aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),N) ) ).

% sin_cos_npi
tff(fact_2933_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => ( ( archimedean_ceiling(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),one_one(int)) )
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,power_power(nat,B2),N)),K))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))))) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
tff(fact_2934_cos__pi__eq__zero,axiom,
    ! [M: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M))))),aa(num,real,numeral_numeral(real),bit0(one2)))) = zero_zero(real) ) ).

% cos_pi_eq_zero
tff(fact_2935_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( archimedean_ceiling(real,aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(real,aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat)))))),one_one(int)) ) ) ).

% ceiling_log2_div2
tff(fact_2936_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,power_power(nat,B2),N)),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2))
         => ( archimedean_ceiling(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),one_one(int)) ) ) ) ) ).

% ceiling_log_nat_eq_if
tff(fact_2937_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => ( ( archim6421214686448440834_floor(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(nat,int,semiring_1_of_nat(int),N) )
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,B2),N)),K))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))))) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
tff(fact_2938_sin__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,zero_zero(A)) = zero_zero(A) ) ) ).

% sin_zero
tff(fact_2939_cos__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cos(A,zero_zero(A)) = one_one(A) ) ) ).

% cos_zero
tff(fact_2940_floor__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archim6421214686448440834_floor(A,zero_zero(A)) = zero_zero(int) ) ) ).

% floor_zero
tff(fact_2941_floor__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archim6421214686448440834_floor(A,aa(num,A,numeral_numeral(A),V)) = aa(num,int,numeral_numeral(int),V) ) ) ).

% floor_numeral
tff(fact_2942_ceiling__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_ceiling(A,zero_zero(A)) = zero_zero(int) ) ) ).

% ceiling_zero
tff(fact_2943_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archimedean_ceiling(A,aa(num,A,numeral_numeral(A),V)) = aa(num,int,numeral_numeral(int),V) ) ) ).

% ceiling_numeral
tff(fact_2944_sin__pi,axiom,
    sin(real,pi) = zero_zero(real) ).

% sin_pi
tff(fact_2945_zero__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3)) ) ) ).

% zero_le_floor
tff(fact_2946_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X3)),cos(A,X3))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X3)),sin(A,X3))) = one_one(A) ) ) ).

% sin_cos_squared_add3
tff(fact_2947_floor__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archim6421214686448440834_floor(A,X3)),zero_zero(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),zero_zero(A))) ) ) ).

% floor_less_zero
tff(fact_2948_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),V)),X3)) ) ) ).

% numeral_le_floor
tff(fact_2949_zero__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X3)) ) ) ).

% zero_less_floor
tff(fact_2950_floor__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X3)),zero_zero(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),one_one(A))) ) ) ).

% floor_le_zero
tff(fact_2951_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,X3)),zero_zero(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A))) ) ) ).

% ceiling_le_zero
tff(fact_2952_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archim6421214686448440834_floor(A,X3)),aa(num,int,numeral_numeral(int),V)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(num,A,numeral_numeral(A),V))) ) ) ).

% floor_less_numeral
tff(fact_2953_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3)) ) ) ).

% zero_less_ceiling
tff(fact_2954_one__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),one_one(int)),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X3)) ) ) ).

% one_le_floor
tff(fact_2955_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,X3)),aa(num,int,numeral_numeral(int),V)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(num,A,numeral_numeral(A),V))) ) ) ).

% ceiling_le_numeral
tff(fact_2956_floor__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archim6421214686448440834_floor(A,X3)),one_one(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),one_one(A))) ) ) ).

% floor_less_one
tff(fact_2957_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X3)),one_one(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A))) ) ) ).

% ceiling_less_one
tff(fact_2958_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),one_one(int)),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3)) ) ) ).

% one_le_ceiling
tff(fact_2959_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),V)),X3)) ) ) ).

% numeral_less_ceiling
tff(fact_2960_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archim6421214686448440834_floor(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)) ) ) ).

% floor_neg_numeral
tff(fact_2961_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,X3)),one_one(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),one_one(A))) ) ) ).

% ceiling_le_one
tff(fact_2962_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X3)) ) ) ).

% one_less_ceiling
tff(fact_2963_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X3)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_add_numeral
tff(fact_2964_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,X3)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% floor_diff_numeral
tff(fact_2965_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archimedean_ceiling(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_neg_numeral
tff(fact_2966_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),one_one(A))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X3)),one_one(int)) ) ) ).

% ceiling_add_one
tff(fact_2967_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X3)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_diff_numeral
tff(fact_2968_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: num,N: nat] : ( archim6421214686448440834_floor(A,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N)) = aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N) ) ) ).

% floor_numeral_power
tff(fact_2969_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: num,N: nat] : ( archimedean_ceiling(A,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N)) = aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N) ) ) ).

% ceiling_numeral_power
tff(fact_2970_sin__npi,axiom,
    ! [N: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi)) = zero_zero(real) ) ).

% sin_npi
tff(fact_2971_sin__npi2,axiom,
    ! [N: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),N))) = zero_zero(real) ) ).

% sin_npi2
tff(fact_2972_and__nat__numerals_I1_J,axiom,
    ! [Y4: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(Y4))) = zero_zero(nat) ) ).

% and_nat_numerals(1)
tff(fact_2973_and__nat__numerals_I3_J,axiom,
    ! [X3: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(num,nat,numeral_numeral(nat),bit0(X3))),aa(nat,nat,suc,zero_zero(nat))) = zero_zero(nat) ) ).

% and_nat_numerals(3)
tff(fact_2974_floor__divide__eq__div__numeral,axiom,
    ! [A3: num,B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A3)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),A3)),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_divide_eq_div_numeral
tff(fact_2975_nat__ceiling__le__eq,axiom,
    ! [X3: real,A3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(int,nat,nat2,archimedean_ceiling(real,X3))),A3))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(nat,real,semiring_1_of_nat(real),A3))) ) ).

% nat_ceiling_le_eq
tff(fact_2976_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X3)),zero_zero(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,uminus_uminus(A),one_one(A)))) ) ) ).

% ceiling_less_zero
tff(fact_2977_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),X3)) ) ) ).

% zero_le_ceiling
tff(fact_2978_and__nat__numerals_I2_J,axiom,
    ! [Y4: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit1(Y4))) = one_one(nat) ) ).

% and_nat_numerals(2)
tff(fact_2979_and__nat__numerals_I4_J,axiom,
    ! [X3: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(num,nat,numeral_numeral(nat),bit1(X3))),aa(nat,nat,suc,zero_zero(nat))) = one_one(nat) ) ).

% and_nat_numerals(4)
tff(fact_2980_ceiling__divide__eq__div__numeral,axiom,
    ! [A3: num,B2: num] : ( archimedean_ceiling(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A3)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),A3))),aa(num,int,numeral_numeral(int),B2))) ) ).

% ceiling_divide_eq_div_numeral
tff(fact_2981_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X3)) ) ) ).

% numeral_less_floor
tff(fact_2982_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X3)),aa(num,int,numeral_numeral(int),V)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A)))) ) ) ).

% floor_le_numeral
tff(fact_2983_one__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)) ) ) ).

% one_less_floor
tff(fact_2984_floor__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X3)),one_one(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% floor_le_one
tff(fact_2985_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X3)),aa(num,int,numeral_numeral(int),V)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A)))) ) ) ).

% ceiling_less_numeral
tff(fact_2986_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X3)) ) ) ).

% numeral_le_ceiling
tff(fact_2987_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),X3)) ) ) ).

% neg_numeral_le_floor
tff(fact_2988_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archim6421214686448440834_floor(A,X3)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))) ) ) ).

% floor_less_neg_numeral
tff(fact_2989_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,X3)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))) ) ) ).

% ceiling_le_neg_numeral
tff(fact_2990_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),X3)) ) ) ).

% neg_numeral_less_ceiling
tff(fact_2991_cos__pi__half,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) = zero_zero(real) ).

% cos_pi_half
tff(fact_2992_sin__two__pi,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)) = zero_zero(real) ).

% sin_two_pi
tff(fact_2993_sin__pi__half,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) = one_one(real) ).

% sin_pi_half
tff(fact_2994_cos__two__pi,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)) = one_one(real) ).

% cos_two_pi
tff(fact_2995_cos__periodic,axiom,
    ! [X3: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) = cos(real,X3) ) ).

% cos_periodic
tff(fact_2996_sin__periodic,axiom,
    ! [X3: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) = sin(real,X3) ) ).

% sin_periodic
tff(fact_2997_cos__2pi__minus,axiom,
    ! [X3: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),X3)) = cos(real,X3) ) ).

% cos_2pi_minus
tff(fact_2998_and__Suc__0__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),N),aa(nat,nat,suc,zero_zero(nat))) = modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% and_Suc_0_eq
tff(fact_2999_Suc__0__and__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),N) = modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% Suc_0_and_eq
tff(fact_3000_cos__npi,axiom,
    ! [N: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi)) = aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),N) ) ).

% cos_npi
tff(fact_3001_cos__npi2,axiom,
    ! [N: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),N))) = aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),N) ) ).

% cos_npi2
tff(fact_3002_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),one_one(int)),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_one_divide_eq_div_numeral
tff(fact_3003_floor__minus__divide__eq__div__numeral,axiom,
    ! [A3: num,B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A3)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),A3))),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_minus_divide_eq_div_numeral
tff(fact_3004_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A3: num,B2: num] : ( archimedean_ceiling(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A3)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),A3)),aa(num,int,numeral_numeral(int),B2))) ) ).

% ceiling_minus_divide_eq_div_numeral
tff(fact_3005_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,cos(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,sin(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(A) ) ) ).

% sin_cos_squared_add2
tff(fact_3006_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,sin(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,cos(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(A) ) ) ).

% sin_cos_squared_add
tff(fact_3007_sin__2npi,axiom,
    ! [N: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N))),pi)) = zero_zero(real) ) ).

% sin_2npi
tff(fact_3008_cos__2npi,axiom,
    ! [N: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N))),pi)) = one_one(real) ) ).

% cos_2npi
tff(fact_3009_sin__2pi__minus,axiom,
    ! [X3: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),X3)) = aa(real,real,uminus_uminus(real),sin(real,X3)) ) ).

% sin_2pi_minus
tff(fact_3010_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X3)) ) ) ).

% neg_numeral_less_floor
tff(fact_3011_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X3)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A)))) ) ) ).

% floor_le_neg_numeral
tff(fact_3012_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X3)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A)))) ) ) ).

% ceiling_less_neg_numeral
tff(fact_3013_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X3)) ) ) ).

% neg_numeral_le_ceiling
tff(fact_3014_cos__3over2__pi,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),bit1(one2))),aa(num,real,numeral_numeral(real),bit0(one2)))),pi)) = zero_zero(real) ).

% cos_3over2_pi
tff(fact_3015_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_minus_one_divide_eq_div_numeral
tff(fact_3016_sin__3over2__pi,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),bit1(one2))),aa(num,real,numeral_numeral(real),bit0(one2)))),pi)) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% sin_3over2_pi
tff(fact_3017_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X3)),archimedean_ceiling(A,X3))) ) ).

% floor_le_ceiling
tff(fact_3018_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( cos(A,X3) = one_one(A) )
         => ( sin(A,X3) = zero_zero(A) ) ) ) ).

% cos_one_sin_zero
tff(fact_3019_sin__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X3)),cos(A,Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X3)),sin(A,Y4))) ) ) ).

% sin_diff
tff(fact_3020_polar__Ex,axiom,
    ! [X3: real,Y4: real] :
    ? [R: real,A5: real] :
      ( ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),R),cos(real,A5)) )
      & ( Y4 = aa(real,real,aa(real,fun(real,real),times_times(real),R),sin(real,A5)) ) ) ).

% polar_Ex
tff(fact_3021_sin__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X3)),cos(A,Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X3)),sin(A,Y4))) ) ) ).

% sin_add
tff(fact_3022_cos__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X3)),cos(A,Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X3)),sin(A,Y4))) ) ) ).

% cos_add
tff(fact_3023_cos__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X3)),cos(A,Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X3)),sin(A,Y4))) ) ) ).

% cos_diff
tff(fact_3024_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( sin(A,X3) = zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,cos(A,X3)) = one_one(real) ) ) ) ).

% sin_zero_norm_cos_one
tff(fact_3025_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X3)),archim6421214686448440834_floor(A,X3))),one_one(int))) ) ).

% ceiling_diff_floor_le_1
tff(fact_3026_sin__zero__abs__cos__one,axiom,
    ! [X3: real] :
      ( ( sin(real,X3) = zero_zero(real) )
     => ( aa(real,real,abs_abs(real),cos(real,X3)) = one_one(real) ) ) ).

% sin_zero_abs_cos_one
tff(fact_3027_sin__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),sin(A,X3))),cos(A,X3)) ) ) ).

% sin_double
tff(fact_3028_sincos__principal__value,axiom,
    ! [X3: real] :
    ? [Y2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Y2))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y2),pi))
      & ( sin(real,Y2) = sin(real,X3) )
      & ( cos(real,Y2) = cos(real,X3) ) ) ).

% sincos_principal_value
tff(fact_3029_floor__mono,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X3)),archim6421214686448440834_floor(A,Y4))) ) ) ).

% floor_mono
tff(fact_3030_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archim6421214686448440834_floor(A,X3)),archim6421214686448440834_floor(A,Y4)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) ) ) ).

% floor_less_cancel
tff(fact_3031_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),N))
    <=> ( N = zero_zero(nat) ) ) ).

% bit_Suc_0_iff
tff(fact_3032_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,suc,N))) ).

% not_bit_Suc_0_Suc
tff(fact_3033_ceiling__mono,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,Y4)),archimedean_ceiling(A,X3))) ) ) ).

% ceiling_mono
tff(fact_3034_sin__x__le__x,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sin(real,X3)),X3)) ) ).

% sin_x_le_x
tff(fact_3035_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X3)),archimedean_ceiling(A,Y4)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) ) ) ).

% ceiling_less_cancel
tff(fact_3036_sin__le__one,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sin(real,X3)),one_one(real))) ).

% sin_le_one
tff(fact_3037_cos__le__one,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),cos(real,X3)),one_one(real))) ).

% cos_le_one
tff(fact_3038_abs__sin__x__le__abs__x,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),sin(real,X3))),aa(real,real,abs_abs(real),X3))) ).

% abs_sin_x_le_abs_x
tff(fact_3039_cos__arctan__not__zero,axiom,
    ! [X3: real] : ( cos(real,aa(real,real,arctan,X3)) != zero_zero(real) ) ).

% cos_arctan_not_zero
tff(fact_3040_sin__cos__le1,axiom,
    ! [X3: real,Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),sin(real,X3)),sin(real,Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),cos(real,X3)),cos(real,Y4))))),one_one(real))) ).

% sin_cos_le1
tff(fact_3041_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(nat,A,power_power(A,sin(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,cos(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% sin_squared_eq
tff(fact_3042_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(nat,A,power_power(A,cos(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,sin(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% cos_squared_eq
tff(fact_3043_not__bit__Suc__0__numeral,axiom,
    ! [N: num] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),N))) ).

% not_bit_Suc_0_numeral
tff(fact_3044_le__floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X3)),archim6421214686448440834_floor(A,Y4))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)))) ) ).

% le_floor_add
tff(fact_3045_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),R2),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,archimedean_ceiling(A,R2))))) ) ).

% of_nat_ceiling
tff(fact_3046_sin__gt__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),pi))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),sin(real,X3))) ) ) ).

% sin_gt_zero
tff(fact_3047_sin__x__ge__neg__x,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),X3)),sin(real,X3))) ) ).

% sin_x_ge_neg_x
tff(fact_3048_sin__ge__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),pi))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),sin(real,X3))) ) ) ).

% sin_ge_zero
tff(fact_3049_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4))),aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X3)),archimedean_ceiling(A,Y4)))) ) ).

% ceiling_add_le
tff(fact_3050_real__nat__ceiling__ge,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(nat,real,semiring_1_of_nat(real),aa(int,nat,nat2,archimedean_ceiling(real,X3))))) ).

% real_nat_ceiling_ge
tff(fact_3051_sin__ge__minus__one,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),sin(real,X3))) ).

% sin_ge_minus_one
tff(fact_3052_cos__inj__pi,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),pi))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),pi))
           => ( ( cos(real,X3) = cos(real,Y4) )
             => ( X3 = Y4 ) ) ) ) ) ) ).

% cos_inj_pi
tff(fact_3053_cos__mono__le__eq,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),pi))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),pi))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),cos(real,X3)),cos(real,Y4)))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),X3)) ) ) ) ) ) ).

% cos_mono_le_eq
tff(fact_3054_cos__monotone__0__pi__le,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),pi))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),cos(real,X3)),cos(real,Y4))) ) ) ) ).

% cos_monotone_0_pi_le
tff(fact_3055_cos__ge__minus__one,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),cos(real,X3))) ).

% cos_ge_minus_one
tff(fact_3056_abs__sin__le__one,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),sin(real,X3))),one_one(real))) ).

% abs_sin_le_one
tff(fact_3057_abs__cos__le__one,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),cos(real,X3))),one_one(real))) ).

% abs_cos_le_one
tff(fact_3058_and__nat__def,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% and_nat_def
tff(fact_3059_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),bit0(one2)))))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),W)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% cos_diff_cos
tff(fact_3060_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),bit0(one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% sin_diff_sin
tff(fact_3061_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),bit0(one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% sin_plus_sin
tff(fact_3062_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% cos_times_sin
tff(fact_3063_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% sin_times_cos
tff(fact_3064_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% sin_times_sin
tff(fact_3065_cos__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,cos(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,sin(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% cos_double
tff(fact_3066_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),W)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,power_power(A,sin(A,W)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% cos_double_sin
tff(fact_3067_of__nat__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),R2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,archim6421214686448440834_floor(A,R2)))),R2)) ) ) ).

% of_nat_floor
tff(fact_3068_one__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X3)),one_one(int)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),one_one(A))) ) ) ).

% one_add_floor
tff(fact_3069_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A3: A,B2: A] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,archim6421214686448440834_floor(A,A3))),aa(int,nat,nat2,archim6421214686448440834_floor(A,B2)))),aa(int,nat,nat2,archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))))) ) ).

% le_mult_nat_floor
tff(fact_3070_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [M: nat,N: nat] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)) ) ) ).

% floor_divide_of_nat_eq
tff(fact_3071_nat__floor__neg,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real)))
     => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X3)) = zero_zero(nat) ) ) ).

% nat_floor_neg
tff(fact_3072_cos__two__neq__zero,axiom,
    cos(real,aa(num,real,numeral_numeral(real),bit0(one2))) != zero_zero(real) ).

% cos_two_neq_zero
tff(fact_3073_floor__eq3,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))))
       => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X3)) = N ) ) ) ).

% floor_eq3
tff(fact_3074_le__nat__floor,axiom,
    ! [X3: nat,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),X3)),A3))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X3),aa(int,nat,nat2,archim6421214686448440834_floor(real,A3)))) ) ).

% le_nat_floor
tff(fact_3075_cos__monotone__0__pi,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),pi))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),cos(real,X3)),cos(real,Y4))) ) ) ) ).

% cos_monotone_0_pi
tff(fact_3076_cos__mono__less__eq,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),pi))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),pi))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),cos(real,X3)),cos(real,Y4)))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),X3)) ) ) ) ) ) ).

% cos_mono_less_eq
tff(fact_3077_sin__eq__0__pi,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),pi)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),pi))
       => ( ( sin(real,X3) = zero_zero(real) )
         => ( X3 = zero_zero(real) ) ) ) ) ).

% sin_eq_0_pi
tff(fact_3078_sin__zero__pi__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),pi))
     => ( ( sin(real,X3) = zero_zero(real) )
      <=> ( X3 = zero_zero(real) ) ) ) ).

% sin_zero_pi_iff
tff(fact_3079_cos__monotone__minus__pi__0_H,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),cos(real,Y4)),cos(real,X3))) ) ) ) ).

% cos_monotone_minus_pi_0'
tff(fact_3080_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,aa(int,nat,nat2,K)),N))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
        & pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)) ) ) ).

% bit_nat_iff
tff(fact_3081_sincos__total__pi,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
     => ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) )
       => ? [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T3))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),pi))
            & ( X3 = cos(real,T3) )
            & ( Y4 = sin(real,T3) ) ) ) ) ).

% sincos_total_pi
tff(fact_3082_sin__cos__sqrt,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),sin(real,X3)))
     => ( sin(real,X3) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,cos(real,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% sin_cos_sqrt
tff(fact_3083_sin__expansion__lemma,axiom,
    ! [X3: real,M: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,M))),pi)),aa(num,real,numeral_numeral(real),bit0(one2))))) = cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),pi)),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ).

% sin_expansion_lemma
tff(fact_3084_le__mult__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A3)),archim6421214686448440834_floor(A,B2))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))) ) ) ) ).

% le_mult_floor
tff(fact_3085_cos__expansion__lemma,axiom,
    ! [X3: real,M: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,M))),pi)),aa(num,real,numeral_numeral(real),bit0(one2))))) = aa(real,real,uminus_uminus(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),pi)),aa(num,real,numeral_numeral(real),bit0(one2)))))) ) ).

% cos_expansion_lemma
tff(fact_3086_sin__gt__zero__02,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(num,real,numeral_numeral(real),bit0(one2))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),sin(real,X3))) ) ) ).

% sin_gt_zero_02
tff(fact_3087_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A3)),archimedean_ceiling(A,B2)))) ) ) ) ).

% mult_ceiling_le
tff(fact_3088_floor__eq4,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),N)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))))
       => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X3)) = N ) ) ) ).

% floor_eq4
tff(fact_3089_cos__two__less__zero,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),cos(real,aa(num,real,numeral_numeral(real),bit0(one2)))),zero_zero(real))) ).

% cos_two_less_zero
tff(fact_3090_cos__is__zero,axiom,
    ? [X2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X2))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),aa(num,real,numeral_numeral(real),bit0(one2))))
      & ( cos(real,X2) = zero_zero(real) )
      & ! [Y5: real] :
          ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y5))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y5),aa(num,real,numeral_numeral(real),bit0(one2))))
            & ( cos(real,Y5) = zero_zero(real) ) )
         => ( Y5 = X2 ) ) ) ).

% cos_is_zero
tff(fact_3091_cos__two__le__zero,axiom,
    pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),cos(real,aa(num,real,numeral_numeral(real),bit0(one2)))),zero_zero(real))) ).

% cos_two_le_zero
tff(fact_3092_cos__monotone__minus__pi__0,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),cos(real,Y4)),cos(real,X3))) ) ) ) ).

% cos_monotone_minus_pi_0
tff(fact_3093_cos__total,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ? [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X2))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),pi))
            & ( cos(real,X2) = Y4 )
            & ! [Y5: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y5))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y5),pi))
                  & ( cos(real,Y5) = Y4 ) )
               => ( Y5 = X2 ) ) ) ) ) ).

% cos_total
tff(fact_3094_sincos__total__pi__half,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) )
         => ? [T3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T3))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
              & ( X3 = cos(real,T3) )
              & ( Y4 = sin(real,T3) ) ) ) ) ) ).

% sincos_total_pi_half
tff(fact_3095_sincos__total__2pi__le,axiom,
    ! [X3: real,Y4: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) )
     => ? [T3: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T3))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)))
          & ( X3 = cos(real,T3) )
          & ( Y4 = sin(real,T3) ) ) ) ).

% sincos_total_2pi_le
tff(fact_3096_sincos__total__2pi,axiom,
    ! [X3: real,Y4: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) )
     => ~ ! [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T3))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)))
             => ( ( X3 = cos(real,T3) )
               => ( Y4 != sin(real,T3) ) ) ) ) ) ).

% sincos_total_2pi
tff(fact_3097_bit__nat__def,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,M),N))
    <=> ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) ) ).

% bit_nat_def
tff(fact_3098_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(nat,real,semiring_1_of_nat(real),N))))) ) ).

% sin_pi_divide_n_ge_0
tff(fact_3099_sin__45,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2)))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% sin_45
tff(fact_3100_cos__45,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2)))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% cos_45
tff(fact_3101_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),bit0(one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% cos_plus_cos
tff(fact_3102_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% cos_times_cos
tff(fact_3103_sin__gt__zero2,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),sin(real,X3))) ) ) ).

% sin_gt_zero2
tff(fact_3104_sin__lt__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),pi),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),sin(real,X3)),zero_zero(real))) ) ) ).

% sin_lt_zero
tff(fact_3105_cos__double__less__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(num,real,numeral_numeral(real),bit0(one2))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),X3))),one_one(real))) ) ) ).

% cos_double_less_one
tff(fact_3106_sin__30,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit1(one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% sin_30
tff(fact_3107_cos__gt__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),cos(real,X3))) ) ) ).

% cos_gt_zero
tff(fact_3108_sin__inj__pi,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => ( ( sin(real,X3) = sin(real,Y4) )
             => ( X3 = Y4 ) ) ) ) ) ) ).

% sin_inj_pi
tff(fact_3109_sin__mono__le__eq,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sin(real,X3)),sin(real,Y4)))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ) ) ) ) ).

% sin_mono_le_eq
tff(fact_3110_sin__monotone__2pi__le,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sin(real,Y4)),sin(real,X3))) ) ) ) ).

% sin_monotone_2pi_le
tff(fact_3111_cos__60,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit1(one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% cos_60
tff(fact_3112_sin__60,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit1(one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit1(one2)))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% sin_60
tff(fact_3113_cos__30,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit1(one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit1(one2)))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% cos_30
tff(fact_3114_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),W)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,power_power(A,cos(A,W)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),one_one(A)) ) ) ).

% cos_double_cos
tff(fact_3115_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit1(one2))),X3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(bit0(one2)))),aa(nat,A,power_power(A,cos(A,X3)),aa(num,nat,numeral_numeral(nat),bit1(one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit1(one2))),cos(A,X3))) ) ) ).

% cos_treble_cos
tff(fact_3116_and__nat__unfold,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ( M = zero_zero(nat) )
          | ( N = zero_zero(nat) ) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N) = zero_zero(nat) ) )
      & ( ~ ( ( M = zero_zero(nat) )
            | ( N = zero_zero(nat) ) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ) ).

% and_nat_unfold
tff(fact_3117_sin__le__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),pi),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sin(real,X3)),zero_zero(real))) ) ) ).

% sin_le_zero
tff(fact_3118_sin__less__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),bit0(one2)))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),sin(real,X3)),zero_zero(real))) ) ) ).

% sin_less_zero
tff(fact_3119_sin__monotone__2pi,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),sin(real,Y4)),sin(real,X3))) ) ) ) ).

% sin_monotone_2pi
tff(fact_3120_sin__mono__less__eq,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),sin(real,X3)),sin(real,Y4)))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ) ) ) ) ).

% sin_mono_less_eq
tff(fact_3121_sin__total,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ? [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X2))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
            & ( sin(real,X2) = Y4 )
            & ! [Y5: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y5))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y5),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
                  & ( sin(real,Y5) = Y4 ) )
               => ( Y5 = X2 ) ) ) ) ) ).

% sin_total
tff(fact_3122_and__nat__rec,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(bool,nat,zero_neq_one_of_bool(nat),fconj(aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% and_nat_rec
tff(fact_3123_cos__gt__zero__pi,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),cos(real,X3))) ) ) ).

% cos_gt_zero_pi
tff(fact_3124_cos__ge__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),cos(real,X3))) ) ) ).

% cos_ge_zero
tff(fact_3125_cos__one__2pi,axiom,
    ! [X3: real] :
      ( ( cos(real,X3) = one_one(real) )
    <=> ( ? [X4: nat] : ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),X4)),aa(num,real,numeral_numeral(real),bit0(one2)))),pi) )
        | ? [X4: nat] : ( X3 = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),X4)),aa(num,real,numeral_numeral(real),bit0(one2)))),pi)) ) ) ) ).

% cos_one_2pi
tff(fact_3126_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(nat,real,semiring_1_of_nat(real),N))))) ) ).

% sin_pi_divide_n_gt_0
tff(fact_3127_sin__arctan,axiom,
    ! [X3: real] : ( sin(real,aa(real,real,arctan,X3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% sin_arctan
tff(fact_3128_cos__arctan,axiom,
    ! [X3: real] : ( cos(real,aa(real,real,arctan,X3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% cos_arctan
tff(fact_3129_floor__log2__div2,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( archim6421214686448440834_floor(real,aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(real,aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))))))),one_one(int)) ) ) ).

% floor_log2_div2
tff(fact_3130_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,power_power(nat,B2),N)),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2))
         => ( archim6421214686448440834_floor(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(nat,int,semiring_1_of_nat(int),N) ) ) ) ) ).

% floor_log_nat_eq_if
tff(fact_3131_sin__zero__lemma,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( ( sin(real,X3) = zero_zero(real) )
       => ? [N2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N2))
            & ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ) ).

% sin_zero_lemma
tff(fact_3132_sin__zero__iff,axiom,
    ! [X3: real] :
      ( ( sin(real,X3) = zero_zero(real) )
    <=> ( ? [N3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3))
            & ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) ) )
        | ? [N3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3))
            & ( X3 = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ) ) ).

% sin_zero_iff
tff(fact_3133_cos__zero__lemma,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( ( cos(real,X3) = zero_zero(real) )
       => ? [N2: nat] :
            ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N2))
            & ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ) ).

% cos_zero_lemma
tff(fact_3134_cos__zero__iff,axiom,
    ! [X3: real] :
      ( ( cos(real,X3) = zero_zero(real) )
    <=> ( ? [N3: nat] :
            ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3))
            & ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) ) )
        | ? [N3: nat] :
            ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3))
            & ( X3 = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ) ) ).

% cos_zero_iff
tff(fact_3135_tan__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( cos(A,X3) != zero_zero(A) )
         => ( ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)) != zero_zero(A) )
           => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,tan(A),X3))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,aa(A,A,tan(A),X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ) ) ).

% tan_double
tff(fact_3136_sin__tan,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
     => ( sin(real,X3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,tan(real),X3)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,aa(real,real,tan(real),X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% sin_tan
tff(fact_3137_cos__tan,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
     => ( cos(real,X3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,aa(real,real,tan(real),X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% cos_tan
tff(fact_3138_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm(complex,Z) = one_one(real) )
     => ~ ! [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T3))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)))
             => ( Z != complex2(cos(real,T3),sin(real,T3)) ) ) ) ) ).

% complex_unimodular_polar
tff(fact_3139_ceiling__log__eq__powr__iff,axiom,
    ! [X3: real,B2: real,K: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
       => ( ( archimedean_ceiling(real,aa(real,real,log(B2),X3)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),K)),one_one(int)) )
        <=> ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,B2,aa(nat,real,semiring_1_of_nat(real),K))),X3))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),powr(real,B2,aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat)))))) ) ) ) ) ).

% ceiling_log_eq_powr_iff
tff(fact_3140_powr__0,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [Z: A] : ( powr(A,zero_zero(A),Z) = zero_zero(A) ) ) ).

% powr_0
tff(fact_3141_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [W: A,Z: A] :
          ( ( powr(A,W,Z) = zero_zero(A) )
        <=> ( W = zero_zero(A) ) ) ) ).

% powr_eq_0_iff
tff(fact_3142_tan__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,tan(A),zero_zero(A)) = zero_zero(A) ) ) ).

% tan_zero
tff(fact_3143_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X3: A] :
          ( ( ( X3 = zero_zero(A) )
           => ( powr(A,X3,zero_zero(A)) = zero_zero(A) ) )
          & ( ( X3 != zero_zero(A) )
           => ( powr(A,X3,zero_zero(A)) = one_one(A) ) ) ) ) ).

% powr_zero_eq_one
tff(fact_3144_powr__gt__zero,axiom,
    ! [X3: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),powr(real,X3,A3)))
    <=> ( X3 != zero_zero(real) ) ) ).

% powr_gt_zero
tff(fact_3145_powr__nonneg__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,A3,X3)),zero_zero(real)))
    <=> ( A3 = zero_zero(real) ) ) ).

% powr_nonneg_iff
tff(fact_3146_powr__less__cancel__iff,axiom,
    ! [X3: real,A3: real,B2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,X3,A3)),powr(real,X3,B2)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2)) ) ) ).

% powr_less_cancel_iff
tff(fact_3147_tan__pi,axiom,
    aa(real,real,tan(real),pi) = zero_zero(real) ).

% tan_pi
tff(fact_3148_powr__eq__one__iff,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
     => ( ( powr(real,A3,X3) = one_one(real) )
      <=> ( X3 = zero_zero(real) ) ) ) ).

% powr_eq_one_iff
tff(fact_3149_powr__one__gt__zero__iff,axiom,
    ! [X3: real] :
      ( ( powr(real,X3,one_one(real)) = X3 )
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3)) ) ).

% powr_one_gt_zero_iff
tff(fact_3150_powr__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( powr(real,X3,one_one(real)) = X3 ) ) ).

% powr_one
tff(fact_3151_powr__le__cancel__iff,axiom,
    ! [X3: real,A3: real,B2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,X3,A3)),powr(real,X3,B2)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2)) ) ) ).

% powr_le_cancel_iff
tff(fact_3152_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] : ( powr(real,aa(num,real,numeral_numeral(real),M),aa(num,real,numeral_numeral(real),N)) = aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),M)),aa(num,nat,numeral_numeral(nat),N)) ) ).

% numeral_powr_numeral_real
tff(fact_3153_log__powr__cancel,axiom,
    ! [A3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( aa(real,real,log(A3),powr(real,A3,Y4)) = Y4 ) ) ) ).

% log_powr_cancel
tff(fact_3154_powr__log__cancel,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( powr(real,A3,aa(real,real,log(A3),X3)) = X3 ) ) ) ) ).

% powr_log_cancel
tff(fact_3155_tan__npi,axiom,
    ! [N: nat] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi)) = zero_zero(real) ) ).

% tan_npi
tff(fact_3156_tan__periodic__n,axiom,
    ! [X3: real,N: num] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),N)),pi))) = aa(real,real,tan(real),X3) ) ).

% tan_periodic_n
tff(fact_3157_tan__periodic__nat,axiom,
    ! [X3: real,N: nat] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi))) = aa(real,real,tan(real),X3) ) ).

% tan_periodic_nat
tff(fact_3158_powr__numeral,axiom,
    ! [X3: real,N: num] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( powr(real,X3,aa(num,real,numeral_numeral(real),N)) = aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),N)) ) ) ).

% powr_numeral
tff(fact_3159_tan__periodic,axiom,
    ! [X3: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) = aa(real,real,tan(real),X3) ) ).

% tan_periodic
tff(fact_3160_square__powr__half,axiom,
    ! [X3: real] : ( powr(real,aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))) = aa(real,real,abs_abs(real),X3) ) ).

% square_powr_half
tff(fact_3161_powr__powr,axiom,
    ! [X3: real,A3: real,B2: real] : ( powr(real,powr(real,X3,A3),B2) = powr(real,X3,aa(real,real,aa(real,fun(real,real),times_times(real),A3),B2)) ) ).

% powr_powr
tff(fact_3162_Complex__eq__0,axiom,
    ! [A3: real,B2: real] :
      ( ( complex2(A3,B2) = zero_zero(complex) )
    <=> ( ( A3 = zero_zero(real) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_0
tff(fact_3163_zero__complex_Ocode,axiom,
    zero_zero(complex) = complex2(zero_zero(real),zero_zero(real)) ).

% zero_complex.code
tff(fact_3164_powr__non__neg,axiom,
    ! [A3: real,X3: real] : ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,A3,X3)),zero_zero(real))) ).

% powr_non_neg
tff(fact_3165_powr__less__mono2__neg,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),zero_zero(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,Y4,A3)),powr(real,X3,A3))) ) ) ) ).

% powr_less_mono2_neg
tff(fact_3166_powr__mono2,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,X3,A3)),powr(real,Y4,A3))) ) ) ) ).

% powr_mono2
tff(fact_3167_powr__ge__pzero,axiom,
    ! [X3: real,Y4: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),powr(real,X3,Y4))) ).

% powr_ge_pzero
tff(fact_3168_powr__less__mono,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,X3,A3)),powr(real,X3,B2))) ) ) ).

% powr_less_mono
tff(fact_3169_powr__less__cancel,axiom,
    ! [X3: real,A3: real,B2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,X3,A3)),powr(real,X3,B2)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2)) ) ) ).

% powr_less_cancel
tff(fact_3170_powr__mono,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,X3,A3)),powr(real,X3,B2))) ) ) ).

% powr_mono
tff(fact_3171_Complex__eq__1,axiom,
    ! [A3: real,B2: real] :
      ( ( complex2(A3,B2) = one_one(complex) )
    <=> ( ( A3 = one_one(real) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_1
tff(fact_3172_one__complex_Ocode,axiom,
    one_one(complex) = complex2(one_one(real),zero_zero(real)) ).

% one_complex.code
tff(fact_3173_Complex__eq__numeral,axiom,
    ! [A3: real,B2: real,W: num] :
      ( ( complex2(A3,B2) = aa(num,complex,numeral_numeral(complex),W) )
    <=> ( ( A3 = aa(num,real,numeral_numeral(real),W) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_numeral
tff(fact_3174_powr__mono2_H,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),zero_zero(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,Y4,A3)),powr(real,X3,A3))) ) ) ) ).

% powr_mono2'
tff(fact_3175_powr__less__mono2,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,X3,A3)),powr(real,Y4,A3))) ) ) ) ).

% powr_less_mono2
tff(fact_3176_powr__inj,axiom,
    ! [A3: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( ( powr(real,A3,X3) = powr(real,A3,Y4) )
        <=> ( X3 = Y4 ) ) ) ) ).

% powr_inj
tff(fact_3177_gr__one__powr,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),powr(real,X3,Y4))) ) ) ).

% gr_one_powr
tff(fact_3178_ge__one__powr__ge__zero,axiom,
    ! [X3: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),powr(real,X3,A3))) ) ) ).

% ge_one_powr_ge_zero
tff(fact_3179_powr__mono__both,axiom,
    ! [A3: real,B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,X3,A3)),powr(real,Y4,B2))) ) ) ) ) ).

% powr_mono_both
tff(fact_3180_powr__le1,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,X3,A3)),one_one(real))) ) ) ) ).

% powr_le1
tff(fact_3181_powr__divide,axiom,
    ! [X3: real,Y4: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( powr(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),Y4),A3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,X3,A3)),powr(real,Y4,A3)) ) ) ) ).

% powr_divide
tff(fact_3182_powr__mult,axiom,
    ! [X3: real,Y4: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( powr(real,aa(real,real,aa(real,fun(real,real),times_times(real),X3),Y4),A3) = aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,X3,A3)),powr(real,Y4,A3)) ) ) ) ).

% powr_mult
tff(fact_3183_divide__powr__uminus,axiom,
    ! [A3: real,B2: real,C2: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),A3),powr(real,B2,C2)) = aa(real,real,aa(real,fun(real,real),times_times(real),A3),powr(real,B2,aa(real,real,uminus_uminus(real),C2))) ) ).

% divide_powr_uminus
tff(fact_3184_log__base__powr,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( ( A3 != zero_zero(real) )
     => ( aa(real,real,log(powr(real,A3,B2)),X3) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A3),X3)),B2) ) ) ).

% log_base_powr
tff(fact_3185_ln__powr,axiom,
    ! [X3: real,Y4: real] :
      ( ( X3 != zero_zero(real) )
     => ( aa(real,real,ln_ln(real),powr(real,X3,Y4)) = aa(real,real,aa(real,fun(real,real),times_times(real),Y4),aa(real,real,ln_ln(real),X3)) ) ) ).

% ln_powr
tff(fact_3186_log__powr,axiom,
    ! [X3: real,B2: real,Y4: real] :
      ( ( X3 != zero_zero(real) )
     => ( aa(real,real,log(B2),powr(real,X3,Y4)) = aa(real,real,aa(real,fun(real,real),times_times(real),Y4),aa(real,real,log(B2),X3)) ) ) ).

% log_powr
tff(fact_3187_Complex__eq__neg__1,axiom,
    ! [A3: real,B2: real] :
      ( ( complex2(A3,B2) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) )
    <=> ( ( A3 = aa(real,real,uminus_uminus(real),one_one(real)) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_neg_1
tff(fact_3188_Complex__eq__neg__numeral,axiom,
    ! [A3: real,B2: real,W: num] :
      ( ( complex2(A3,B2) = aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W)) )
    <=> ( ( A3 = aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),W)) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_neg_numeral
tff(fact_3189_powr__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X3: A,A3: A,B2: A] : ( powr(A,X3,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),powr(A,X3,A3)),powr(A,X3,B2)) ) ) ).

% powr_add
tff(fact_3190_powr__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [W: A,Z1: A,Z2: A] : ( powr(A,W,aa(A,A,aa(A,fun(A,A),minus_minus(A),Z1),Z2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),powr(A,W,Z1)),powr(A,W,Z2)) ) ) ).

% powr_diff
tff(fact_3191_complex__mult,axiom,
    ! [A3: real,B2: real,C2: real,D2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(A3,B2)),complex2(C2,D2)) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),A3),C2)),aa(real,real,aa(real,fun(real,real),times_times(real),B2),D2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),A3),D2)),aa(real,real,aa(real,fun(real,real),times_times(real),B2),C2))) ) ).

% complex_mult
tff(fact_3192_tan__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,tan(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,X)),cos(A,X)) ) ) ).

% tan_def
tff(fact_3193_powr__realpow,axiom,
    ! [X3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( powr(real,X3,aa(nat,real,semiring_1_of_nat(real),N)) = aa(nat,real,power_power(real,X3),N) ) ) ).

% powr_realpow
tff(fact_3194_powr__less__iff,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,B2,Y4)),X3))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,log(B2),X3))) ) ) ) ).

% powr_less_iff
tff(fact_3195_less__powr__iff,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),powr(real,B2,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,log(B2),X3)),Y4)) ) ) ) ).

% less_powr_iff
tff(fact_3196_log__less__iff,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,log(B2),X3)),Y4))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),powr(real,B2,Y4))) ) ) ) ).

% log_less_iff
tff(fact_3197_less__log__iff,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,log(B2),X3)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),powr(real,B2,Y4)),X3)) ) ) ) ).

% less_log_iff
tff(fact_3198_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X3: A,A3: A] : ( powr(A,X3,aa(A,A,uminus_uminus(A),A3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),powr(A,X3,A3)) ) ) ).

% powr_minus_divide
tff(fact_3199_powr__neg__one,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( powr(real,X3,aa(real,real,uminus_uminus(real),one_one(real))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X3) ) ) ).

% powr_neg_one
tff(fact_3200_powr__mult__base,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),X3),powr(real,X3,Y4)) = powr(real,X3,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Y4)) ) ) ).

% powr_mult_base
tff(fact_3201_powr__le__iff,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,B2,Y4)),X3))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,log(B2),X3))) ) ) ) ).

% powr_le_iff
tff(fact_3202_le__powr__iff,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),powr(real,B2,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,log(B2),X3)),Y4)) ) ) ) ).

% le_powr_iff
tff(fact_3203_log__le__iff,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,log(B2),X3)),Y4))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),powr(real,B2,Y4))) ) ) ) ).

% log_le_iff
tff(fact_3204_le__log__iff,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,log(B2),X3)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,B2,Y4)),X3)) ) ) ) ).

% le_log_iff
tff(fact_3205_ln__powr__bound,axiom,
    ! [X3: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,ln_ln(real),X3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,X3,A3)),A3))) ) ) ).

% ln_powr_bound
tff(fact_3206_ln__powr__bound2,axiom,
    ! [X3: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,aa(real,real,ln_ln(real),X3),A3)),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,A3,A3)),X3))) ) ) ).

% ln_powr_bound2
tff(fact_3207_tan__45,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2))))) = one_one(real) ).

% tan_45
tff(fact_3208_log__add__eq__powr,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
     => ( ( B2 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,log(B2),X3)),Y4) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),X3),powr(real,B2,Y4))) ) ) ) ) ).

% log_add_eq_powr
tff(fact_3209_add__log__eq__powr,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
     => ( ( B2 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),Y4),aa(real,real,log(B2),X3)) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,B2,Y4)),X3)) ) ) ) ) ).

% add_log_eq_powr
tff(fact_3210_minus__log__eq__powr,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
     => ( ( B2 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),Y4),aa(real,real,log(B2),X3)) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,B2,Y4)),X3)) ) ) ) ) ).

% minus_log_eq_powr
tff(fact_3211_tan__60,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit1(one2)))) = aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit1(one2))) ).

% tan_60
tff(fact_3212_powr__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X3: A,A3: A] :
          ( ( ( X3 = zero_zero(A) )
           => ( powr(A,X3,A3) = zero_zero(A) ) )
          & ( ( X3 != zero_zero(A) )
           => ( powr(A,X3,A3) = aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,ln_ln(A),X3))) ) ) ) ) ).

% powr_def
tff(fact_3213_lemma__tan__total,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4))
     => ? [X2: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X2))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,tan(real),X2))) ) ) ).

% lemma_tan_total
tff(fact_3214_tan__gt__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,tan(real),X3))) ) ) ).

% tan_gt_zero
tff(fact_3215_tan__total,axiom,
    ! [Y4: real] :
    ? [X2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X2))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
      & ( aa(real,real,tan(real),X2) = Y4 )
      & ! [Y5: real] :
          ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y5))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y5),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
            & ( aa(real,real,tan(real),Y5) = Y4 ) )
         => ( Y5 = X2 ) ) ) ).

% tan_total
tff(fact_3216_tan__monotone,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,tan(real),Y4)),aa(real,real,tan(real),X3))) ) ) ) ).

% tan_monotone
tff(fact_3217_tan__monotone_H,axiom,
    ! [Y4: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),X3))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,tan(real),Y4)),aa(real,real,tan(real),X3))) ) ) ) ) ) ).

% tan_monotone'
tff(fact_3218_tan__mono__lt__eq,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,tan(real),X3)),aa(real,real,tan(real),Y4)))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ) ) ) ) ).

% tan_mono_lt_eq
tff(fact_3219_lemma__tan__total1,axiom,
    ! [Y4: real] :
    ? [X2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X2))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
      & ( aa(real,real,tan(real),X2) = Y4 ) ) ).

% lemma_tan_total1
tff(fact_3220_tan__minus__45,axiom,
    aa(real,real,tan(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))))) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% tan_minus_45
tff(fact_3221_tan__inverse,axiom,
    ! [Y4: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,tan(real),Y4)) = aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),Y4)) ) ).

% tan_inverse
tff(fact_3222_log__minus__eq__powr,axiom,
    ! [B2: real,X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
     => ( ( B2 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,log(B2),X3)),Y4) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),X3),powr(real,B2,aa(real,real,uminus_uminus(real),Y4)))) ) ) ) ) ).

% log_minus_eq_powr
tff(fact_3223_complex__norm,axiom,
    ! [X3: real,Y4: real] : ( real_V7770717601297561774m_norm(complex,complex2(X3,Y4)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% complex_norm
tff(fact_3224_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] :
          ( ( cos(A,X3) != zero_zero(A) )
         => ( ( cos(A,Y4) != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tan(A),X3)),aa(A,A,tan(A),Y4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X3)),cos(A,Y4))) ) ) ) ) ).

% add_tan_eq
tff(fact_3225_powr__half__sqrt,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( powr(real,X3,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))) = aa(real,real,sqrt,X3) ) ) ).

% powr_half_sqrt
tff(fact_3226_powr__neg__numeral,axiom,
    ! [X3: real,N: num] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( powr(real,X3,aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),N))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),N))) ) ) ).

% powr_neg_numeral
tff(fact_3227_tan__total__pos,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
     => ? [X2: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X2))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
          & ( aa(real,real,tan(real),X2) = Y4 ) ) ) ).

% tan_total_pos
tff(fact_3228_tan__pos__pi2__le,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,tan(real),X3))) ) ) ).

% tan_pos_pi2_le
tff(fact_3229_tan__less__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),bit0(one2)))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,tan(real),X3)),zero_zero(real))) ) ) ).

% tan_less_zero
tff(fact_3230_tan__mono__le,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,tan(real),X3)),aa(real,real,tan(real),Y4))) ) ) ) ).

% tan_mono_le
tff(fact_3231_tan__mono__le__eq,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,tan(real),X3)),aa(real,real,tan(real),Y4)))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ) ) ) ) ).

% tan_mono_le_eq
tff(fact_3232_tan__bound__pi2,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2))))))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,tan(real),X3))),one_one(real))) ) ).

% tan_bound_pi2
tff(fact_3233_tan__30,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit1(one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit1(one2)))) ).

% tan_30
tff(fact_3234_arctan,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arctan,Y4)))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arctan,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
      & ( aa(real,real,tan(real),aa(real,real,arctan,Y4)) = Y4 ) ) ).

% arctan
tff(fact_3235_arctan__tan,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( aa(real,real,arctan,aa(real,real,tan(real),X3)) = X3 ) ) ) ).

% arctan_tan
tff(fact_3236_arctan__unique,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( ( aa(real,real,tan(real),X3) = Y4 )
         => ( aa(real,real,arctan,Y4) = X3 ) ) ) ) ).

% arctan_unique
tff(fact_3237_tan__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] :
          ( ( cos(A,X3) != zero_zero(A) )
         => ( ( cos(A,Y4) != zero_zero(A) )
           => ( ( cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) != zero_zero(A) )
             => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tan(A),X3)),aa(A,A,tan(A),Y4))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X3)),aa(A,A,tan(A),Y4)))) ) ) ) ) ) ).

% tan_add
tff(fact_3238_tan__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] :
          ( ( cos(A,X3) != zero_zero(A) )
         => ( ( cos(A,Y4) != zero_zero(A) )
           => ( ( cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) != zero_zero(A) )
             => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,tan(A),X3)),aa(A,A,tan(A),Y4))),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X3)),aa(A,A,tan(A),Y4)))) ) ) ) ) ) ).

% tan_diff
tff(fact_3239_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] :
          ( ( cos(A,X3) != zero_zero(A) )
         => ( ( cos(A,Y4) != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X3)),aa(A,A,tan(A),Y4))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X3)),cos(A,Y4))) ) ) ) ) ).

% lemma_tan_add1
tff(fact_3240_tan__total__pi4,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ? [Z4: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))))),Z4))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Z4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2))))))
          & ( aa(real,real,tan(real),Z4) = X3 ) ) ) ).

% tan_total_pi4
tff(fact_3241_tan__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,tan(A),X3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3))),aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3))),one_one(A))) ) ) ).

% tan_half
tff(fact_3242_arcosh__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X3: A] : ( aa(A,A,arcosh(A),X3) = aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),powr(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)),real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2))))))) ) ) ).

% arcosh_def
tff(fact_3243_cos__arcsin,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => ( cos(real,aa(real,real,arcsin,X3)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ) ).

% cos_arcsin
tff(fact_3244_sin__arccos__abs,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),one_one(real)))
     => ( sin(real,aa(real,real,arccos,Y4)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,Y4),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% sin_arccos_abs
tff(fact_3245_sin__arccos,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => ( sin(real,aa(real,real,arccos,X3)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ) ).

% sin_arccos
tff(fact_3246_arsinh__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X3: A] : ( aa(A,A,arsinh(A),X3) = aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),powr(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)),real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2))))))) ) ) ).

% arsinh_def
tff(fact_3247_arcsin__0,axiom,
    aa(real,real,arcsin,zero_zero(real)) = zero_zero(real) ).

% arcsin_0
tff(fact_3248_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X3: real] :
          ( ( real_Vector_of_real(A,X3) = zero_zero(A) )
        <=> ( X3 = zero_zero(real) ) ) ) ).

% of_real_eq_0_iff
tff(fact_3249_of__real__0,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ( real_Vector_of_real(A,zero_zero(real)) = zero_zero(A) ) ) ).

% of_real_0
tff(fact_3250_of__real__mult,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X3: real,Y4: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),times_times(real),X3),Y4)) = aa(A,A,aa(A,fun(A,A),times_times(A),real_Vector_of_real(A,X3)),real_Vector_of_real(A,Y4)) ) ) ).

% of_real_mult
tff(fact_3251_of__real__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : ( real_Vector_of_real(A,aa(num,real,numeral_numeral(real),W)) = aa(num,A,numeral_numeral(A),W) ) ) ).

% of_real_numeral
tff(fact_3252_of__real__divide,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [X3: real,Y4: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),Y4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,X3)),real_Vector_of_real(A,Y4)) ) ) ).

% of_real_divide
tff(fact_3253_of__real__add,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X3: real,Y4: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,X3)),real_Vector_of_real(A,Y4)) ) ) ).

% of_real_add
tff(fact_3254_of__real__power,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X3: real,N: nat] : ( real_Vector_of_real(A,aa(nat,real,power_power(real,X3),N)) = aa(nat,A,power_power(A,real_Vector_of_real(A,X3)),N) ) ) ).

% of_real_power
tff(fact_3255_arccos__1,axiom,
    aa(real,real,arccos,one_one(real)) = zero_zero(real) ).

% arccos_1
tff(fact_3256_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,real_Vector_of_real(A,pi)) = zero_zero(A) ) ) ).

% sin_of_real_pi
tff(fact_3257_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : ( real_Vector_of_real(A,aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),W))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) ) ) ).

% of_real_neg_numeral
tff(fact_3258_cos__arccos,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ( cos(real,aa(real,real,arccos,Y4)) = Y4 ) ) ) ).

% cos_arccos
tff(fact_3259_sin__arcsin,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ( sin(real,aa(real,real,arcsin,Y4)) = Y4 ) ) ) ).

% sin_arcsin
tff(fact_3260_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X3: real] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,X3)),one_one(A))) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),one_one(real))) ) ) ).

% norm_of_real_add1
tff(fact_3261_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X3: real,B2: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,X3)),aa(num,A,numeral_numeral(A),B2))) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(num,real,numeral_numeral(real),B2))) ) ) ).

% norm_of_real_addn
tff(fact_3262_arccos__0,axiom,
    aa(real,real,arccos,zero_zero(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% arccos_0
tff(fact_3263_arcsin__1,axiom,
    aa(real,real,arcsin,one_one(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% arcsin_1
tff(fact_3264_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V7773925162809079976_field(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),bit0(one2)))) = zero_zero(A) ) ) ).

% cos_of_real_pi_half
tff(fact_3265_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V7773925162809079976_field(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),bit0(one2)))) = one_one(A) ) ) ).

% sin_of_real_pi_half
tff(fact_3266_arcsin__minus__1,axiom,
    aa(real,real,arcsin,aa(real,real,uminus_uminus(real),one_one(real))) = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% arcsin_minus_1
tff(fact_3267_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A5: complex,R: real] : ( Z = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R)),aa(complex,complex,exp(complex),A5)) ) ).

% complex_exp_exists
tff(fact_3268_sgn__eq,axiom,
    ! [Z: complex] : ( aa(complex,complex,sgn_sgn(complex),Z) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),real_Vector_of_real(complex,real_V7770717601297561774m_norm(complex,Z))) ) ).

% sgn_eq
tff(fact_3269_complex__eq__cancel__iff2,axiom,
    ! [X3: real,Y4: real,Xa: real] :
      ( ( complex2(X3,Y4) = real_Vector_of_real(complex,Xa) )
    <=> ( ( X3 = Xa )
        & ( Y4 = zero_zero(real) ) ) ) ).

% complex_eq_cancel_iff2
tff(fact_3270_complex__of__real__code,axiom,
    ! [X: real] : ( real_Vector_of_real(complex,X) = complex2(X,zero_zero(real)) ) ).

% complex_of_real_code
tff(fact_3271_complex__of__real__def,axiom,
    ! [R2: real] : ( real_Vector_of_real(complex,R2) = complex2(R2,zero_zero(real)) ) ).

% complex_of_real_def
tff(fact_3272_complex__of__real__mult__Complex,axiom,
    ! [R2: real,X3: real,Y4: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R2)),complex2(X3,Y4)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R2),X3),aa(real,real,aa(real,fun(real,real),times_times(real),R2),Y4)) ) ).

% complex_of_real_mult_Complex
tff(fact_3273_Complex__mult__complex__of__real,axiom,
    ! [X3: real,Y4: real,R2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(X3,Y4)),real_Vector_of_real(complex,R2)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),X3),R2),aa(real,real,aa(real,fun(real,real),times_times(real),Y4),R2)) ) ).

% Complex_mult_complex_of_real
tff(fact_3274_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [Y4: real,X3: real] :
          ( ( Y4 != zero_zero(real) )
         => ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),Y4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,X3)),real_Vector_of_real(A,Y4)) ) ) ) ).

% nonzero_of_real_divide
tff(fact_3275_arccos__le__arccos,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arccos,Y4)),aa(real,real,arccos,X3))) ) ) ) ).

% arccos_le_arccos
tff(fact_3276_arccos__eq__iff,axiom,
    ! [X3: real,Y4: real] :
      ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),one_one(real))) )
     => ( ( aa(real,real,arccos,X3) = aa(real,real,arccos,Y4) )
      <=> ( X3 = Y4 ) ) ) ).

% arccos_eq_iff
tff(fact_3277_arccos__le__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arccos,X3)),aa(real,real,arccos,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),X3)) ) ) ) ).

% arccos_le_mono
tff(fact_3278_arcsin__minus,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => ( aa(real,real,arcsin,aa(real,real,uminus_uminus(real),X3)) = aa(real,real,uminus_uminus(real),aa(real,real,arcsin,X3)) ) ) ) ).

% arcsin_minus
tff(fact_3279_arcsin__le__arcsin,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arcsin,X3)),aa(real,real,arcsin,Y4))) ) ) ) ).

% arcsin_le_arcsin
tff(fact_3280_arcsin__eq__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),one_one(real)))
       => ( ( aa(real,real,arcsin,X3) = aa(real,real,arcsin,Y4) )
        <=> ( X3 = Y4 ) ) ) ) ).

% arcsin_eq_iff
tff(fact_3281_arcsin__le__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arcsin,X3)),aa(real,real,arcsin,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ) ) ).

% arcsin_le_mono
tff(fact_3282_norm__less__p1,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X3: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,real_V7770717601297561774m_norm(A,X3))),one_one(A))))) ) ).

% norm_less_p1
tff(fact_3283_arccos__lbound,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y4))) ) ) ).

% arccos_lbound
tff(fact_3284_arccos__less__arccos,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arccos,Y4)),aa(real,real,arccos,X3))) ) ) ) ).

% arccos_less_arccos
tff(fact_3285_arccos__less__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arccos,X3)),aa(real,real,arccos,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),X3)) ) ) ) ).

% arccos_less_mono
tff(fact_3286_arccos__ubound,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arccos,Y4)),pi)) ) ) ).

% arccos_ubound
tff(fact_3287_arccos__cos,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),pi))
       => ( aa(real,real,arccos,cos(real,X3)) = X3 ) ) ) ).

% arccos_cos
tff(fact_3288_arcsin__less__arcsin,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arcsin,X3)),aa(real,real,arcsin,Y4))) ) ) ) ).

% arcsin_less_arcsin
tff(fact_3289_arcsin__less__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arcsin,X3)),aa(real,real,arcsin,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ) ) ).

% arcsin_less_mono
tff(fact_3290_cos__arccos__abs,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Y4)),one_one(real)))
     => ( cos(real,aa(real,real,arccos,Y4)) = Y4 ) ) ).

% cos_arccos_abs
tff(fact_3291_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [B2: real,A3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),real_Vector_of_real(A,B2)),real_Vector_of_real(A,A3)))),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)))) ) ).

% norm_of_real_diff
tff(fact_3292_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),Theta)),pi))
     => ( aa(real,real,arccos,cos(real,Theta)) = aa(real,real,abs_abs(real),Theta) ) ) ).

% arccos_cos_eq_abs
tff(fact_3293_arccos__lt__bounded,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,arccos,Y4)))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arccos,Y4)),pi)) ) ) ) ).

% arccos_lt_bounded
tff(fact_3294_arccos__bounded,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y4)))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arccos,Y4)),pi)) ) ) ) ).

% arccos_bounded
tff(fact_3295_sin__arccos__nonzero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => ( sin(real,aa(real,real,arccos,X3)) != zero_zero(real) ) ) ) ).

% sin_arccos_nonzero
tff(fact_3296_arccos__cos2,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),X3))
       => ( aa(real,real,arccos,cos(real,X3)) = aa(real,real,uminus_uminus(real),X3) ) ) ) ).

% arccos_cos2
tff(fact_3297_arccos__minus,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => ( aa(real,real,arccos,aa(real,real,uminus_uminus(real),X3)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),aa(real,real,arccos,X3)) ) ) ) ).

% arccos_minus
tff(fact_3298_cos__arcsin__nonzero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => ( cos(real,aa(real,real,arcsin,X3)) != zero_zero(real) ) ) ) ).

% cos_arcsin_nonzero
tff(fact_3299_arccos,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y4)))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arccos,Y4)),pi))
          & ( cos(real,aa(real,real,arccos,Y4)) = Y4 ) ) ) ) ).

% arccos
tff(fact_3300_arccos__minus__abs,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( aa(real,real,arccos,aa(real,real,uminus_uminus(real),X3)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),aa(real,real,arccos,X3)) ) ) ).

% arccos_minus_abs
tff(fact_3301_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( sin(A,X3) = cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),bit0(one2)))),X3)) ) ) ).

% sin_cos_eq
tff(fact_3302_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( cos(A,X3) = sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),bit0(one2)))),X3)) ) ) ).

% cos_sin_eq
tff(fact_3303_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,uminus_uminus(A),sin(A,X3)) = cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% minus_sin_cos_eq
tff(fact_3304_arccos__le__pi2,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arccos,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ).

% arccos_le_pi2
tff(fact_3305_arcsin__lt__bounded,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y4)))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,arcsin,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ) ).

% arcsin_lt_bounded
tff(fact_3306_arcsin__lbound,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y4))) ) ) ).

% arcsin_lbound
tff(fact_3307_arcsin__ubound,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arcsin,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ).

% arcsin_ubound
tff(fact_3308_arcsin__bounded,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y4)))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arcsin,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ) ).

% arcsin_bounded
tff(fact_3309_arcsin__sin,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => ( aa(real,real,arcsin,sin(real,X3)) = X3 ) ) ) ).

% arcsin_sin
tff(fact_3310_arcsin,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y4)))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arcsin,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
          & ( sin(real,aa(real,real,arcsin,Y4)) = Y4 ) ) ) ) ).

% arcsin
tff(fact_3311_arcsin__pi,axiom,
    ! [Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y4))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y4)))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arcsin,Y4)),pi))
          & ( sin(real,aa(real,real,arcsin,Y4)) = Y4 ) ) ) ) ).

% arcsin_pi
tff(fact_3312_arcsin__le__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),bit0(one2)))),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,arcsin,X3)),Y4))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),sin(real,Y4))) ) ) ) ) ) ).

% arcsin_le_iff
tff(fact_3313_le__arcsin__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),bit0(one2)))),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),aa(real,real,arcsin,X3)))
            <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sin(real,Y4)),X3)) ) ) ) ) ) ).

% le_arcsin_iff
tff(fact_3314_cos__npi__int,axiom,
    ! [N: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
       => ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(int,real,ring_1_of_int(real),N))) = one_one(real) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
       => ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(int,real,ring_1_of_int(real),N))) = aa(real,real,uminus_uminus(real),one_one(real)) ) ) ) ).

% cos_npi_int
tff(fact_3315_cot__less__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),bit0(one2)))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real)))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,cot(real),X3)),zero_zero(real))) ) ) ).

% cot_less_zero
tff(fact_3316_cot__periodic,axiom,
    ! [X3: real] : ( aa(real,real,cot(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) = aa(real,real,cot(real),X3) ) ).

% cot_periodic
tff(fact_3317_powr__int,axiom,
    ! [X3: real,I: int] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),I))
         => ( powr(real,X3,aa(int,real,ring_1_of_int(real),I)) = aa(nat,real,power_power(real,X3),aa(int,nat,nat2,I)) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),I))
         => ( powr(real,X3,aa(int,real,ring_1_of_int(real),I)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),I)))) ) ) ) ) ).

% powr_int
tff(fact_3318_sin__zero__iff__int,axiom,
    ! [X3: real] :
      ( ( sin(real,X3) = zero_zero(real) )
    <=> ? [I2: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),I2))
          & ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ).

% sin_zero_iff_int
tff(fact_3319_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [W: int,Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),W) = aa(int,A,ring_1_of_int(A),Z) )
        <=> ( W = Z ) ) ) ).

% of_int_eq_iff
tff(fact_3320_of__int__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & ring_1(A) )
     => ! [N: nat] : ( aa(int,A,ring_1_of_int(A),semiring_char_0_fact(int,N)) = semiring_char_0_fact(A,N) ) ) ).

% of_int_fact
tff(fact_3321_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( ( aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X3)) = X3 )
        <=> ? [N3: int] : ( X3 = aa(int,A,ring_1_of_int(A),N3) ) ) ) ).

% of_int_floor_cancel
tff(fact_3322_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( ( aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X3)) = X3 )
        <=> ? [N3: int] : ( X3 = aa(int,A,ring_1_of_int(A),N3) ) ) ) ).

% of_int_ceiling_cancel
tff(fact_3323_cot__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,cot(A),zero_zero(A)) = zero_zero(A) ) ) ).

% cot_zero
tff(fact_3324_of__int__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( aa(int,A,ring_1_of_int(A),zero_zero(int)) = zero_zero(A) ) ) ).

% of_int_0
tff(fact_3325_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( zero_zero(A) = aa(int,A,ring_1_of_int(A),Z) )
        <=> ( Z = zero_zero(int) ) ) ) ).

% of_int_0_eq_iff
tff(fact_3326_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = zero_zero(A) )
        <=> ( Z = zero_zero(int) ) ) ) ).

% of_int_eq_0_iff
tff(fact_3327_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: int,Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),W),Z)) ) ) ).

% of_int_le_iff
tff(fact_3328_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: num] : ( aa(int,A,ring_1_of_int(A),aa(num,int,numeral_numeral(int),K)) = aa(num,A,numeral_numeral(A),K) ) ) ).

% of_int_numeral
tff(fact_3329_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int,N: num] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = aa(num,A,numeral_numeral(A),N) )
        <=> ( Z = aa(num,int,numeral_numeral(int),N) ) ) ) ).

% of_int_eq_numeral_iff
tff(fact_3330_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: int,Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),W),Z)) ) ) ).

% of_int_less_iff
tff(fact_3331_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = one_one(A) )
        <=> ( Z = one_one(int) ) ) ) ).

% of_int_eq_1_iff
tff(fact_3332_of__int__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( aa(int,A,ring_1_of_int(A),one_one(int)) = one_one(A) ) ) ).

% of_int_1
tff(fact_3333_of__int__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_mult
tff(fact_3334_of__int__add,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_add
tff(fact_3335_of__int__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),Z)) = aa(A,A,uminus_uminus(A),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_minus
tff(fact_3336_of__int__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),minus_minus(int),W),Z)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_diff
tff(fact_3337_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(int,A,ring_1_of_int(A),aa(nat,int,semiring_1_of_nat(int),N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ).

% of_int_of_nat_eq
tff(fact_3338_of__int__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,abs_abs(int),X3)) = aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),X3)) ) ) ).

% of_int_abs
tff(fact_3339_of__int__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int,N: nat] : ( aa(int,A,ring_1_of_int(A),aa(nat,int,power_power(int,Z),N)) = aa(nat,A,power_power(A,aa(int,A,ring_1_of_int(A),Z)),N) ) ) ).

% of_int_power
tff(fact_3340_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [B2: int,W: nat,X3: int] :
          ( ( aa(nat,A,power_power(A,aa(int,A,ring_1_of_int(A),B2)),W) = aa(int,A,ring_1_of_int(A),X3) )
        <=> ( aa(nat,int,power_power(int,B2),W) = X3 ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
tff(fact_3341_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X3: int,B2: int,W: nat] :
          ( ( aa(int,A,ring_1_of_int(A),X3) = aa(nat,A,power_power(A,aa(int,A,ring_1_of_int(A),B2)),W) )
        <=> ( X3 = aa(nat,int,power_power(int,B2),W) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
tff(fact_3342_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: bool] : ( aa(int,A,ring_1_of_int(A),aa(bool,int,zero_neq_one_of_bool(int),P)) = aa(bool,A,zero_neq_one_of_bool(A),P) ) ) ).

% of_int_of_bool
tff(fact_3343_cot__pi,axiom,
    aa(real,real,cot(real),pi) = zero_zero(real) ).

% cot_pi
tff(fact_3344_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Z: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(int,A,ring_1_of_int(A),Z))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X3)),Z) ) ) ).

% ceiling_add_of_int
tff(fact_3345_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat,K: int] : ( aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,N),K))) = aa(int,A,ring_1_of_int(A),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ) ).

% of_nat_nat_take_bit_eq
tff(fact_3346_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z)) ) ) ).

% of_int_0_le_iff
tff(fact_3347_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),zero_zero(A)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z),zero_zero(int))) ) ) ).

% of_int_le_0_iff
tff(fact_3348_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Z)) ) ) ).

% of_int_0_less_iff
tff(fact_3349_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),zero_zero(A)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z),zero_zero(int))) ) ) ).

% of_int_less_0_iff
tff(fact_3350_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),N)),aa(int,A,ring_1_of_int(A),Z)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),N)),Z)) ) ) ).

% of_int_numeral_le_iff
tff(fact_3351_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int,N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),aa(num,A,numeral_numeral(A),N)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z),aa(num,int,numeral_numeral(int),N))) ) ) ).

% of_int_le_numeral_iff
tff(fact_3352_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int,N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),aa(num,A,numeral_numeral(A),N)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z),aa(num,int,numeral_numeral(int),N))) ) ) ).

% of_int_less_numeral_iff
tff(fact_3353_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),N)),aa(int,A,ring_1_of_int(A),Z)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(num,int,numeral_numeral(int),N)),Z)) ) ) ).

% of_int_numeral_less_iff
tff(fact_3354_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z),one_one(int))) ) ) ).

% of_int_le_1_iff
tff(fact_3355_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),one_one(int)),Z)) ) ) ).

% of_int_1_le_iff
tff(fact_3356_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z),one_one(int))) ) ) ).

% of_int_less_1_iff
tff(fact_3357_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),Z)) ) ) ).

% of_int_1_less_iff
tff(fact_3358_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: int,W: nat,X3: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,aa(int,A,ring_1_of_int(A),B2)),W)),aa(int,A,ring_1_of_int(A),X3)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,B2),W)),X3)) ) ) ).

% of_int_le_of_int_power_cancel_iff
tff(fact_3359_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: int,B2: int,W: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),X3)),aa(nat,A,power_power(A,aa(int,A,ring_1_of_int(A),B2)),W)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),aa(nat,int,power_power(int,B2),W))) ) ) ).

% of_int_power_le_of_int_cancel_iff
tff(fact_3360_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X3: num,N: nat,Y4: int] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N) = aa(int,A,ring_1_of_int(A),Y4) )
        <=> ( aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N) = Y4 ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
tff(fact_3361_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Y4: int,X3: num,N: nat] :
          ( ( aa(int,A,ring_1_of_int(A),Y4) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N) )
        <=> ( Y4 = aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
tff(fact_3362_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: int,W: nat,X3: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,aa(int,A,ring_1_of_int(A),B2)),W)),aa(int,A,ring_1_of_int(A),X3)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,power_power(int,B2),W)),X3)) ) ) ).

% of_int_less_of_int_power_cancel_iff
tff(fact_3363_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: int,B2: int,W: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),X3)),aa(nat,A,power_power(A,aa(int,A,ring_1_of_int(A),B2)),W)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X3),aa(nat,int,power_power(int,B2),W))) ) ) ).

% of_int_power_less_of_int_cancel_iff
tff(fact_3364_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
         => ( aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,Z)) = aa(int,A,ring_1_of_int(A),Z) ) ) ) ).

% of_nat_nat
tff(fact_3365_sin__npi__int,axiom,
    ! [N: int] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(int,real,ring_1_of_int(real),N))) = zero_zero(real) ) ).

% sin_npi_int
tff(fact_3366_tan__periodic__int,axiom,
    ! [X3: real,I: int] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I)),pi))) = aa(real,real,tan(real),X3) ) ).

% tan_periodic_int
tff(fact_3367_cot__npi,axiom,
    ! [N: nat] : ( aa(real,real,cot(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi)) = zero_zero(real) ) ).

% cot_npi
tff(fact_3368_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: num,N: nat,A3: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N)),aa(int,A,ring_1_of_int(A),A3)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N)),A3)) ) ) ).

% numeral_power_le_of_int_cancel_iff
tff(fact_3369_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: int,X3: num,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A3)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N))) ) ) ).

% of_int_le_numeral_power_cancel_iff
tff(fact_3370_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: num,N: nat,A3: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N)),aa(int,A,ring_1_of_int(A),A3)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N)),A3)) ) ) ).

% numeral_power_less_of_int_cancel_iff
tff(fact_3371_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: int,X3: num,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),A3)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X3)),N)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A3),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X3)),N))) ) ) ).

% of_int_less_numeral_power_cancel_iff
tff(fact_3372_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X3: num,N: nat,Y4: int] :
          ( ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3))),N) = aa(int,A,ring_1_of_int(A),Y4) )
        <=> ( aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X3))),N) = Y4 ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
tff(fact_3373_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Y4: int,X3: num,N: nat] :
          ( ( aa(int,A,ring_1_of_int(A),Y4) = aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3))),N) )
        <=> ( Y4 = aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X3))),N) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
tff(fact_3374_sin__int__2pin,axiom,
    ! [N: int] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),aa(int,real,ring_1_of_int(real),N))) = zero_zero(real) ) ).

% sin_int_2pin
tff(fact_3375_cos__int__2pin,axiom,
    ! [N: int] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),aa(int,real,ring_1_of_int(real),N))) = one_one(real) ) ).

% cos_int_2pin
tff(fact_3376_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: int,X3: num,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A3)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3))),N)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X3))),N))) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
tff(fact_3377_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: num,N: nat,A3: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3))),N)),aa(int,A,ring_1_of_int(A),A3)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X3))),N)),A3)) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
tff(fact_3378_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: num,N: nat,A3: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3))),N)),aa(int,A,ring_1_of_int(A),A3)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X3))),N)),A3)) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
tff(fact_3379_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: int,X3: num,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),A3)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3))),N)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A3),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X3))),N))) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
tff(fact_3380_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: int,Y4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),X3)),Y4) = aa(A,A,aa(A,fun(A,A),times_times(A),Y4),aa(int,A,ring_1_of_int(A),X3)) ) ) ).

% mult_of_int_commute
tff(fact_3381_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
        ? [Z4: int] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(int,A,ring_1_of_int(A),Z4))) ) ).

% ex_le_of_int
tff(fact_3382_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
        ? [Z4: int] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),Z4)),X3)) ) ).

% ex_of_int_less
tff(fact_3383_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
        ? [Z4: int] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(int,A,ring_1_of_int(A),Z4))) ) ).

% ex_less_of_int
tff(fact_3384_pochhammer__of__int,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X3: int,N: nat] : ( comm_s3205402744901411588hammer(A,aa(int,A,ring_1_of_int(A),X3),N) = aa(int,A,ring_1_of_int(A),comm_s3205402744901411588hammer(int,X3,N)) ) ) ).

% pochhammer_of_int
tff(fact_3385_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X3))),X3)) ) ).

% of_int_floor_le
tff(fact_3386_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X3)))) ) ).

% le_of_int_ceiling
tff(fact_3387_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,K: int] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(int,A,ring_1_of_int(A),K)) = aa(int,A,ring_1_of_int(A),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ) ).

% take_bit_of_int
tff(fact_3388_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(int,A,ring_1_of_int(A),K)),aa(int,A,ring_1_of_int(A),L)) ) ) ).

% of_int_and_eq
tff(fact_3389_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [M: int,X3: real] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),M)),real_Vector_of_real(A,X3))) = real_Vector_of_real(A,cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),M)),X3))) ) ) ).

% cos_int_times_real
tff(fact_3390_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [M: int,X3: real] : ( sin(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),M)),real_Vector_of_real(A,X3))) = real_Vector_of_real(A,sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),M)),X3))) ) ) ).

% sin_int_times_real
tff(fact_3391_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(int,A,ring_1_of_int(A),bit_se2239418461657761734s_mask(int,N)) = bit_se2239418461657761734s_mask(A,N) ) ) ).

% of_int_mask_eq
tff(fact_3392_le__floor__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),X3)) ) ) ).

% le_floor_iff
tff(fact_3393_floor__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Z: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archim6421214686448440834_floor(A,X3)),Z))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(int,A,ring_1_of_int(A),Z))) ) ) ).

% floor_less_iff
tff(fact_3394_ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,A3: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(int,A,ring_1_of_int(A),A3)))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,X3)),A3)) ) ) ).

% ceiling_le
tff(fact_3395_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Z: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,X3)),Z))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(int,A,ring_1_of_int(A),Z))) ) ) ).

% ceiling_le_iff
tff(fact_3396_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),X3)) ) ) ).

% less_ceiling_iff
tff(fact_3397_int__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X3: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),archim6421214686448440834_floor(A,X3)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),X3)) ) ) ).

% int_add_floor
tff(fact_3398_floor__add__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X3)),Z) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(int,A,ring_1_of_int(A),Z))) ) ) ).

% floor_add_int
tff(fact_3399_real__of__int__div4,axiom,
    ! [N: int,X3: int] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),N),X3))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),N)),aa(int,real,ring_1_of_int(real),X3)))) ).

% real_of_int_div4
tff(fact_3400_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [K: int,L: int] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),K)),aa(int,A,ring_1_of_int(A),L))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) ) ) ).

% floor_divide_of_int_eq
tff(fact_3401_floor__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,N: nat] :
          ( ( X3 = aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X3)) )
         => ( archim6421214686448440834_floor(A,aa(nat,A,power_power(A,X3),N)) = aa(nat,int,power_power(int,archim6421214686448440834_floor(A,X3)),N) ) ) ) ).

% floor_power
tff(fact_3402_real__of__int__div,axiom,
    ! [D2: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),D2),N))
     => ( aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),N),D2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),N)),aa(int,real,ring_1_of_int(real),D2)) ) ) ).

% real_of_int_div
tff(fact_3403_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Z))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z))) ) ) ).

% of_int_nonneg
tff(fact_3404_of__int__leD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: int,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),N))),X3))
         => ( ( N = zero_zero(int) )
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X3)) ) ) ) ).

% of_int_leD
tff(fact_3405_of__int__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Z))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z))) ) ) ).

% of_int_pos
tff(fact_3406_of__int__lessD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: int,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),N))),X3))
         => ( ( N = zero_zero(int) )
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X3)) ) ) ) ).

% of_int_lessD
tff(fact_3407_floor__exists,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
        ? [Z4: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z4)),X3))
          & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z4),one_one(int))))) ) ) ).

% floor_exists
tff(fact_3408_floor__exists1,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
        ? [X2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),X2)),X3))
          & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),one_one(int)))))
          & ! [Y5: int] :
              ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Y5)),X3))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),Y5),one_one(int))))) )
             => ( Y5 = X2 ) ) ) ) ).

% floor_exists1
tff(fact_3409_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,R2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),R2),one_one(A)))) ) ).

% of_int_ceiling_le_add_one
tff(fact_3410_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: num] : ( aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K)) ) ) ).

% of_int_neg_numeral
tff(fact_3411_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,R2))),one_one(A))),R2)) ) ).

% of_int_ceiling_diff_one_le
tff(fact_3412_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,X3: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(int,A,ring_1_of_int(A),X3)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,semiring_1_of_nat(int),N)),X3)) ) ) ).

% of_nat_less_of_int_iff
tff(fact_3413_int__le__real__less,axiom,
    ! [N: int,M: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),N),M))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(int,real,ring_1_of_int(real),N)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),M)),one_one(real)))) ) ).

% int_le_real_less
tff(fact_3414_int__less__real__le,axiom,
    ! [N: int,M: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),M))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),N)),one_one(real))),aa(int,real,ring_1_of_int(real),M))) ) ).

% int_less_real_le
tff(fact_3415_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A3: int,B2: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),A3)),aa(int,A,ring_1_of_int(A),B2))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),A3)),B2)) ) ) ).

% ceiling_divide_eq_div
tff(fact_3416_sin__zero__iff__int2,axiom,
    ! [X3: real] :
      ( ( sin(real,X3) = zero_zero(real) )
    <=> ? [I2: int] : ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I2)),pi) ) ) ).

% sin_zero_iff_int2
tff(fact_3417_real__of__int__div__aux,axiom,
    ! [X3: int,D2: int] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),X3)),aa(int,real,ring_1_of_int(real),D2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),X3),D2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),modulo_modulo(int,X3,D2))),aa(int,real,ring_1_of_int(real),D2))) ) ).

% real_of_int_div_aux
tff(fact_3418_real__of__int__floor__add__one__gt,axiom,
    ! [R2: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),R2),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R2))),one_one(real)))) ).

% real_of_int_floor_add_one_gt
tff(fact_3419_floor__eq,axiom,
    ! [N: int,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(int,real,ring_1_of_int(real),N)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),N)),one_one(real))))
       => ( archim6421214686448440834_floor(real,X3) = N ) ) ) ).

% floor_eq
tff(fact_3420_real__of__int__floor__add__one__ge,axiom,
    ! [R2: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),R2),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R2))),one_one(real)))) ).

% real_of_int_floor_add_one_ge
tff(fact_3421_real__of__int__floor__gt__diff__one,axiom,
    ! [R2: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),R2),one_one(real))),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R2)))) ).

% real_of_int_floor_gt_diff_one
tff(fact_3422_real__of__int__floor__ge__diff__one,axiom,
    ! [R2: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),R2),one_one(real))),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R2)))) ).

% real_of_int_floor_ge_diff_one
tff(fact_3423_floor__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,bool),T2: A] :
          ( pp(aa(int,bool,P,archim6421214686448440834_floor(A,T2)))
        <=> ! [I2: int] :
              ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),I2)),T2))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),T2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),I2)),one_one(A)))) )
             => pp(aa(int,bool,P,I2)) ) ) ) ).

% floor_split
tff(fact_3424_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,A3: int] :
          ( ( archim6421214686448440834_floor(A,X3) = A3 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A3)),X3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),A3)),one_one(A)))) ) ) ) ).

% floor_eq_iff
tff(fact_3425_floor__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))))
           => ( archim6421214686448440834_floor(A,X3) = Z ) ) ) ) ).

% floor_unique
tff(fact_3426_ceiling__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,bool),T2: A] :
          ( pp(aa(int,bool,P,archimedean_ceiling(A,T2)))
        <=> ! [I2: int] :
              ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),I2)),one_one(A))),T2))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),T2),aa(int,A,ring_1_of_int(A),I2))) )
             => pp(aa(int,bool,P,I2)) ) ) ) ).

% ceiling_split
tff(fact_3427_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,A3: int] :
          ( ( archimedean_ceiling(A,X3) = A3 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),A3)),one_one(A))),X3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(int,A,ring_1_of_int(A),A3))) ) ) ) ).

% ceiling_eq_iff
tff(fact_3428_ceiling__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(int,A,ring_1_of_int(A),Z)))
           => ( archimedean_ceiling(A,X3) = Z ) ) ) ) ).

% ceiling_unique
tff(fact_3429_ceiling__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X3))),one_one(A))),X3))
          & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X3)))) ) ) ).

% ceiling_correct
tff(fact_3430_less__floor__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z),archim6421214686448440834_floor(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),X3)) ) ) ).

% less_floor_iff
tff(fact_3431_floor__le__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Z: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X3)),Z))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A)))) ) ) ).

% floor_le_iff
tff(fact_3432_cot__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,cot(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),cos(A,X)),sin(A,X)) ) ) ).

% cot_def
tff(fact_3433_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Z: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X3)),Z))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A)))) ) ) ).

% ceiling_less_iff
tff(fact_3434_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z),archimedean_ceiling(A,X3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),X3)) ) ) ).

% le_ceiling_iff
tff(fact_3435_floor__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X3))),X3))
          & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X3)),one_one(int))))) ) ) ).

% floor_correct
tff(fact_3436_real__of__int__div2,axiom,
    ! [N: int,X3: int] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),N)),aa(int,real,ring_1_of_int(real),X3))),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),N),X3))))) ).

% real_of_int_div2
tff(fact_3437_real__of__int__div3,axiom,
    ! [N: int,X3: int] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),N)),aa(int,real,ring_1_of_int(real),X3))),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),N),X3)))),one_one(real))) ).

% real_of_int_div3
tff(fact_3438_floor__eq2,axiom,
    ! [N: int,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(int,real,ring_1_of_int(real),N)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),N)),one_one(real))))
       => ( archim6421214686448440834_floor(real,X3) = N ) ) ) ).

% floor_eq2
tff(fact_3439_floor__divide__real__eq__div,axiom,
    ! [B2: int,A3: real] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),B2))
     => ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),A3),aa(int,real,ring_1_of_int(real),B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),archim6421214686448440834_floor(real,A3)),B2) ) ) ).

% floor_divide_real_eq_div
tff(fact_3440_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P2),Q2)))),Q2)),P2)) ) ) ).

% floor_divide_lower
tff(fact_3441_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P2),Q2)))),Q2))) ) ) ).

% ceiling_divide_upper
tff(fact_3442_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(int,A,ring_1_of_int(A),K)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)) ) ) ).

% even_of_int_iff
tff(fact_3443_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: int] :
          ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
           => ( aa(int,A,ring_1_of_int(A),K) = aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),K)))) ) )
          & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
           => ( aa(int,A,ring_1_of_int(A),K) = aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,K)) ) ) ) ) ).

% of_int_of_nat
tff(fact_3444_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P2),Q2)))),one_one(A))),Q2))) ) ) ).

% floor_divide_upper
tff(fact_3445_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P2),Q2)))),one_one(A))),Q2)),P2)) ) ) ).

% ceiling_divide_lower
tff(fact_3446_ceiling__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: int,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),N)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),N)),one_one(A))))
           => ( archimedean_ceiling(A,X3) = aa(int,int,aa(int,fun(int,int),plus_plus(int),N),one_one(int)) ) ) ) ) ).

% ceiling_eq
tff(fact_3447_cos__one__2pi__int,axiom,
    ! [X3: real] :
      ( ( cos(real,X3) = one_one(real) )
    <=> ? [X4: int] : ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),X4)),aa(num,real,numeral_numeral(real),bit0(one2)))),pi) ) ) ).

% cos_one_2pi_int
tff(fact_3448_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] : ( aa(real,real,arccos,cos(real,Theta)) != aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Theta),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),K2)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)))) ) ).

% arccos_cos_eq_abs_2pi
tff(fact_3449_floor__log__eq__powr__iff,axiom,
    ! [X3: real,B2: real,K: int] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
       => ( ( archim6421214686448440834_floor(real,aa(real,real,log(B2),X3)) = K )
        <=> ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),powr(real,B2,aa(int,real,ring_1_of_int(real),K))),X3))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),powr(real,B2,aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int)))))) ) ) ) ) ).

% floor_log_eq_powr_iff
tff(fact_3450_cot__gt__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,cot(real),X3))) ) ) ).

% cot_gt_zero
tff(fact_3451_tan__cot_H,axiom,
    ! [X3: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),X3)) = aa(real,real,cot(real),X3) ) ).

% tan_cot'
tff(fact_3452_cos__zero__iff__int,axiom,
    ! [X3: real] :
      ( ( cos(real,X3) = zero_zero(real) )
    <=> ? [I2: int] :
          ( ~ pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),I2))
          & ( X3 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ).

% cos_zero_iff_int
tff(fact_3453_round__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))))),aa(int,A,ring_1_of_int(A),Y4)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Y4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))))))
           => ( archimedean_round(A,X3) = Y4 ) ) ) ) ).

% round_unique
tff(fact_3454_exp__two__pi__i,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(num,complex,numeral_numeral(complex),bit0(one2))),real_Vector_of_real(complex,pi))),imaginary_unit)) = one_one(complex) ).

% exp_two_pi_i
tff(fact_3455_exp__two__pi__i_H,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,pi)),aa(num,complex,numeral_numeral(complex),bit0(one2))))) = one_one(complex) ).

% exp_two_pi_i'
tff(fact_3456_round__unique_H,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(int,A,ring_1_of_int(A),N)))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2)))))
         => ( archimedean_round(A,X3) = N ) ) ) ).

% round_unique'
tff(fact_3457_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,X3))),X3))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ).

% of_int_round_abs_le
tff(fact_3458_round__0,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_round(A,zero_zero(A)) = zero_zero(int) ) ) ).

% round_0
tff(fact_3459_round__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: num] : ( archimedean_round(A,aa(num,A,numeral_numeral(A),N)) = aa(num,int,numeral_numeral(int),N) ) ) ).

% round_numeral
tff(fact_3460_complex__i__mult__minus,axiom,
    ! [X3: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),X3)) = aa(complex,complex,uminus_uminus(complex),X3) ) ).

% complex_i_mult_minus
tff(fact_3461_divide__i,axiom,
    ! [X3: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X3),imaginary_unit) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,uminus_uminus(complex),imaginary_unit)),X3) ) ).

% divide_i
tff(fact_3462_i__squared,axiom,
    aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),imaginary_unit) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% i_squared
tff(fact_3463_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: num] : ( archimedean_round(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N)) ) ) ).

% round_neg_numeral
tff(fact_3464_divide__numeral__i,axiom,
    ! [Z: complex,N: num] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(num,complex,numeral_numeral(complex),N)),imaginary_unit)) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,uminus_uminus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z))),aa(num,complex,numeral_numeral(complex),N)) ) ).

% divide_numeral_i
tff(fact_3465_power2__i,axiom,
    aa(nat,complex,power_power(complex,imaginary_unit),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% power2_i
tff(fact_3466_i__even__power,axiom,
    ! [N: nat] : ( aa(nat,complex,power_power(complex,imaginary_unit),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,complex,power_power(complex,aa(complex,complex,uminus_uminus(complex),one_one(complex))),N) ) ).

% i_even_power
tff(fact_3467_exp__pi__i,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,pi)),imaginary_unit)) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% exp_pi_i
tff(fact_3468_exp__pi__i_H,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,pi))) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% exp_pi_i'
tff(fact_3469_complex__i__not__zero,axiom,
    imaginary_unit != zero_zero(complex) ).

% complex_i_not_zero
tff(fact_3470_complex__i__not__numeral,axiom,
    ! [W: num] : ( imaginary_unit != aa(num,complex,numeral_numeral(complex),W) ) ).

% complex_i_not_numeral
tff(fact_3471_i__times__eq__iff,axiom,
    ! [W: complex,Z: complex] :
      ( ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),W) = Z )
    <=> ( W = aa(complex,complex,uminus_uminus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) ) ) ).

% i_times_eq_iff
tff(fact_3472_complex__i__not__neg__numeral,axiom,
    ! [W: num] : ( imaginary_unit != aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W)) ) ).

% complex_i_not_neg_numeral
tff(fact_3473_round__mono,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_round(A,X3)),archimedean_round(A,Y4))) ) ) ).

% round_mono
tff(fact_3474_floor__le__round,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X3)),archimedean_round(A,X3))) ) ).

% floor_le_round
tff(fact_3475_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_round(A,X3)),archimedean_ceiling(A,X3))) ) ).

% ceiling_ge_round
tff(fact_3476_imaginary__unit_Ocode,axiom,
    imaginary_unit = complex2(zero_zero(real),one_one(real)) ).

% imaginary_unit.code
tff(fact_3477_Complex__eq__i,axiom,
    ! [X3: real,Y4: real] :
      ( ( complex2(X3,Y4) = imaginary_unit )
    <=> ( ( X3 = zero_zero(real) )
        & ( Y4 = one_one(real) ) ) ) ).

% Complex_eq_i
tff(fact_3478_Complex__mult__i,axiom,
    ! [A3: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(A3,B2)),imaginary_unit) = complex2(aa(real,real,uminus_uminus(real),B2),A3) ) ).

% Complex_mult_i
tff(fact_3479_i__mult__Complex,axiom,
    ! [A3: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),complex2(A3,B2)) = complex2(aa(real,real,uminus_uminus(real),B2),A3) ) ).

% i_mult_Complex
tff(fact_3480_i__complex__of__real,axiom,
    ! [R2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,R2)) = complex2(zero_zero(real),R2) ) ).

% i_complex_of_real
tff(fact_3481_complex__of__real__i,axiom,
    ! [R2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R2)),imaginary_unit) = complex2(zero_zero(real),R2) ) ).

% complex_of_real_i
tff(fact_3482_Complex__eq,axiom,
    ! [A3: real,B2: real] : ( complex2(A3,B2) = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,A3)),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,B2))) ) ).

% Complex_eq
tff(fact_3483_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: A,M: int] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),aa(int,A,ring_1_of_int(A),archimedean_round(A,Z))))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),aa(int,A,ring_1_of_int(A),M))))) ) ).

% round_diff_minimal
tff(fact_3484_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R: real,A5: real] : ( Z = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R)),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,cos(real,A5))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,sin(real,A5))))) ) ).

% complex_split_polar
tff(fact_3485_cmod__unit__one,axiom,
    ! [A3: real] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,cos(real,A3))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,sin(real,A3))))) = one_one(real) ) ).

% cmod_unit_one
tff(fact_3486_cmod__complex__polar,axiom,
    ! [R2: real,A3: real] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R2)),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,cos(real,A3))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,sin(real,A3)))))) = aa(real,real,abs_abs(real),R2) ) ).

% cmod_complex_polar
tff(fact_3487_round__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : ( archimedean_round(A,X3) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% round_def
tff(fact_3488_of__int__round__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,X3))),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ).

% of_int_round_le
tff(fact_3489_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,X3)))) ) ).

% of_int_round_ge
tff(fact_3490_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,X3)))) ) ).

% of_int_round_gt
tff(fact_3491_csqrt__ii,axiom,
    csqrt(imaginary_unit) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),one_one(complex)),imaginary_unit)),real_Vector_of_real(complex,aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2))))) ).

% csqrt_ii
tff(fact_3492_Arg__minus__ii,axiom,
    arg(aa(complex,complex,uminus_uminus(complex),imaginary_unit)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% Arg_minus_ii
tff(fact_3493_Arg__ii,axiom,
    arg(imaginary_unit) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% Arg_ii
tff(fact_3494_cis__minus__pi__half,axiom,
    cis(aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) = aa(complex,complex,uminus_uminus(complex),imaginary_unit) ).

% cis_minus_pi_half
tff(fact_3495_round__altdef,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2)))),archimedean_frac(A,X3)))
           => ( archimedean_round(A,X3) = archimedean_ceiling(A,X3) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2)))),archimedean_frac(A,X3)))
           => ( archimedean_round(A,X3) = archim6421214686448440834_floor(A,X3) ) ) ) ) ).

% round_altdef
tff(fact_3496_csqrt__0,axiom,
    csqrt(zero_zero(complex)) = zero_zero(complex) ).

% csqrt_0
tff(fact_3497_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( csqrt(Z) = zero_zero(complex) )
    <=> ( Z = zero_zero(complex) ) ) ).

% csqrt_eq_0
tff(fact_3498_frac__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int] : ( archimedean_frac(A,aa(int,A,ring_1_of_int(A),Z)) = zero_zero(A) ) ) ).

% frac_of_int
tff(fact_3499_cis__zero,axiom,
    cis(zero_zero(real)) = one_one(complex) ).

% cis_zero
tff(fact_3500_power2__csqrt,axiom,
    ! [Z: complex] : ( aa(nat,complex,power_power(complex,csqrt(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = Z ) ).

% power2_csqrt
tff(fact_3501_cis__pi__half,axiom,
    cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) = imaginary_unit ).

% cis_pi_half
tff(fact_3502_cis__2pi,axiom,
    cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)) = one_one(complex) ).

% cis_2pi
tff(fact_3503_cis__neq__zero,axiom,
    ! [A3: real] : ( cis(A3) != zero_zero(complex) ) ).

% cis_neq_zero
tff(fact_3504_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( cis(arg(Z)) = aa(complex,complex,sgn_sgn(complex),Z) ) ) ).

% cis_Arg
tff(fact_3505_DeMoivre,axiom,
    ! [A3: real,N: nat] : ( aa(nat,complex,power_power(complex,cis(A3)),N) = cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),A3)) ) ).

% DeMoivre
tff(fact_3506_frac__ge__0,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),archimedean_frac(A,X3))) ) ).

% frac_ge_0
tff(fact_3507_frac__lt__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),archimedean_frac(A,X3)),one_one(A))) ) ).

% frac_lt_1
tff(fact_3508_cis__mult,axiom,
    ! [A3: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cis(A3)),cis(B2)) = cis(aa(real,real,aa(real,fun(real,real),plus_plus(real),A3),B2)) ) ).

% cis_mult
tff(fact_3509_frac__1__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] : ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),one_one(A))) = archimedean_frac(A,X3) ) ) ).

% frac_1_eq
tff(fact_3510_cis__divide,axiom,
    ! [A3: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),cis(A3)),cis(B2)) = cis(aa(real,real,aa(real,fun(real,real),minus_minus(real),A3),B2)) ) ).

% cis_divide
tff(fact_3511_cis__Arg__unique,axiom,
    ! [Z: complex,X3: real] :
      ( ( aa(complex,complex,sgn_sgn(complex),Z) = cis(X3) )
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),pi)),X3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),pi))
         => ( arg(Z) = X3 ) ) ) ) ).

% cis_Arg_unique
tff(fact_3512_Arg__zero,axiom,
    arg(zero_zero(complex)) = zero_zero(real) ).

% Arg_zero
tff(fact_3513_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( ( aa(complex,complex,sgn_sgn(complex),Z) = cis(arg(Z)) )
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),pi)),arg(Z)))
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),arg(Z)),pi)) ) ) ).

% Arg_correct
tff(fact_3514_frac__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( ( archimedean_frac(A,X3) = X3 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),one_one(A))) ) ) ) ).

% frac_eq
tff(fact_3515_frac__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X3)),archimedean_frac(A,Y4))),one_one(A)))
           => ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X3)),archimedean_frac(A,Y4)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X3)),archimedean_frac(A,Y4))),one_one(A)))
           => ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X3)),archimedean_frac(A,Y4))),one_one(A)) ) ) ) ) ).

% frac_add
tff(fact_3516_cis__conv__exp,axiom,
    ! [B2: real] : ( cis(B2) = aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,B2))) ) ).

% cis_conv_exp
tff(fact_3517_of__real__sqrt,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( real_Vector_of_real(complex,aa(real,real,sqrt,X3)) = csqrt(real_Vector_of_real(complex,X3)) ) ) ).

% of_real_sqrt
tff(fact_3518_Arg__bounded,axiom,
    ! [Z: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),pi)),arg(Z)))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),arg(Z)),pi)) ) ).

% Arg_bounded
tff(fact_3519_floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X3)),archimedean_frac(A,Y4))),one_one(A)))
           => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X3)),archim6421214686448440834_floor(A,Y4)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X3)),archimedean_frac(A,Y4))),one_one(A)))
           => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X3)),archim6421214686448440834_floor(A,Y4))),one_one(int)) ) ) ) ) ).

% floor_add
tff(fact_3520_cis__multiple__2pi,axiom,
    ! [N: real] :
      ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),N),ring_1_Ints(real)))
     => ( cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),N)) = one_one(complex) ) ) ).

% cis_multiple_2pi
tff(fact_3521_powr__real__of__int,axiom,
    ! [X3: real,N: int] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
         => ( powr(real,X3,aa(int,real,ring_1_of_int(real),N)) = aa(nat,real,power_power(real,X3),aa(int,nat,nat2,N)) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
         => ( powr(real,X3,aa(int,real,ring_1_of_int(real),N)) = aa(real,real,inverse_inverse(real),aa(nat,real,power_power(real,X3),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),N)))) ) ) ) ) ).

% powr_real_of_int
tff(fact_3522_xor__Suc__0__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),N),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(bool,nat,zero_neq_one_of_bool(nat),aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),aa(bool,nat,zero_neq_one_of_bool(nat),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) ) ).

% xor_Suc_0_eq
tff(fact_3523_Suc__0__xor__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),N) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(bool,nat,zero_neq_one_of_bool(nat),aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),aa(bool,nat,zero_neq_one_of_bool(nat),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) ) ).

% Suc_0_xor_eq
tff(fact_3524_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A3) = aa(A,A,inverse_inverse(A),B2) )
        <=> ( A3 = B2 ) ) ) ).

% inverse_eq_iff_eq
tff(fact_3525_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,inverse_inverse(A),A3)) = A3 ) ) ).

% inverse_inverse_eq
tff(fact_3526_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),Y4)) = Y4 ) ) ).

% bit.xor_left_self
tff(fact_3527_inverse__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),zero_zero(A)) = zero_zero(A) ) ) ).

% inverse_zero
tff(fact_3528_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( aa(A,A,inverse_inverse(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% inverse_nonzero_iff_nonzero
tff(fact_3529_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% inverse_mult_distrib
tff(fact_3530_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A] :
          ( ( aa(A,A,inverse_inverse(A),X3) = one_one(A) )
        <=> ( X3 = one_one(A) ) ) ) ).

% inverse_eq_1_iff
tff(fact_3531_inverse__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),one_one(A)) = one_one(A) ) ) ).

% inverse_1
tff(fact_3532_inverse__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3) ) ) ).

% inverse_divide
tff(fact_3533_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),A3)) = aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),A3)) ) ) ).

% inverse_minus_eq
tff(fact_3534_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),zero_zero(A)) = A3 ) ) ).

% xor.right_neutral
tff(fact_3535_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),zero_zero(A)),A3) = A3 ) ) ).

% xor.left_neutral
tff(fact_3536_xor__self__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),A3) = zero_zero(A) ) ) ).

% xor_self_eq
tff(fact_3537_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),X3) = zero_zero(A) ) ) ).

% bit.xor_self
tff(fact_3538_abs__inverse,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(A,A,inverse_inverse(A),A3)) = aa(A,A,inverse_inverse(A),aa(A,A,abs_abs(A),A3)) ) ) ).

% abs_inverse
tff(fact_3539_sgn__inverse,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,inverse_inverse(A),A3)) = aa(A,A,inverse_inverse(A),aa(A,A,sgn_sgn(A),A3)) ) ) ).

% sgn_inverse
tff(fact_3540_inverse__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,sgn_sgn(A),A3)) = aa(A,A,sgn_sgn(A),A3) ) ) ).

% inverse_sgn
tff(fact_3541_take__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)),aa(A,A,bit_se2584673776208193580ke_bit(A,N),B2)) ) ) ).

% take_bit_xor
tff(fact_3542_not__infinity__eq,axiom,
    ! [X3: extended_enat] :
      ( ( X3 != extend4730790105801354508finity(extended_enat) )
    <=> ? [I2: nat] : ( X3 = extended_enat2(I2) ) ) ).

% not_infinity_eq
tff(fact_3543_not__enat__eq,axiom,
    ! [X3: extended_enat] :
      ( ! [Y: nat] : ( X3 != extended_enat2(Y) )
    <=> ( X3 = extend4730790105801354508finity(extended_enat) ) ) ).

% not_enat_eq
tff(fact_3544_enat__ord__simps_I4_J,axiom,
    ! [Q2: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),Q2),extend4730790105801354508finity(extended_enat)))
    <=> ( Q2 != extend4730790105801354508finity(extended_enat) ) ) ).

% enat_ord_simps(4)
tff(fact_3545_enat__ord__simps_I6_J,axiom,
    ! [Q2: extended_enat] : ~ pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),extend4730790105801354508finity(extended_enat)),Q2)) ).

% enat_ord_simps(6)
tff(fact_3546_plus__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),extend4730790105801354508finity(extended_enat)),Q2) = extend4730790105801354508finity(extended_enat) ) ).

% plus_enat_simps(2)
tff(fact_3547_plus__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ).

% plus_enat_simps(3)
tff(fact_3548_enat__ord__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),Q2))
    <=> ( Q2 = extend4730790105801354508finity(extended_enat) ) ) ).

% enat_ord_simps(5)
tff(fact_3549_enat__ord__code_I3_J,axiom,
    ! [Q2: extended_enat] : pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),Q2),extend4730790105801354508finity(extended_enat))) ).

% enat_ord_code(3)
tff(fact_3550_idiff__infinity,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extend4730790105801354508finity(extended_enat)),N) = extend4730790105801354508finity(extended_enat) ) ).

% idiff_infinity
tff(fact_3551_times__enat__simps_I2_J,axiom,
    aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ).

% times_enat_simps(2)
tff(fact_3552_enat_Osimps_I5_J,axiom,
    ! [T: $tType,F1: fun(nat,T),F22: T] : ( extended_case_enat(T,F1,F22,extend4730790105801354508finity(extended_enat)) = F22 ) ).

% enat.simps(5)
tff(fact_3553_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% inverse_nonnegative_iff_nonnegative
tff(fact_3554_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% inverse_nonpositive_iff_nonpositive
tff(fact_3555_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% inverse_positive_iff_positive
tff(fact_3556_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% inverse_negative_iff_negative
tff(fact_3557_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% inverse_less_iff_less_neg
tff(fact_3558_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% inverse_less_iff_less
tff(fact_3559_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( ( archimedean_frac(A,X3) = zero_zero(A) )
        <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A))) ) ) ).

% frac_eq_0_iff
tff(fact_3560_idiff__self,axiom,
    ! [N: extended_enat] :
      ( ( N != extend4730790105801354508finity(extended_enat) )
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),N),N) = zero_zero(extended_enat) ) ) ).

% idiff_self
tff(fact_3561_add__diff__cancel__enat,axiom,
    ! [X3: extended_enat,Y4: extended_enat] :
      ( ( X3 != extend4730790105801354508finity(extended_enat) )
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X3),Y4)),X3) = Y4 ) ) ).

% add_diff_cancel_enat
tff(fact_3562_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% inverse_le_iff_le_neg
tff(fact_3563_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% inverse_le_iff_le
tff(fact_3564_left__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),A3) = one_one(A) ) ) ) ).

% left_inverse
tff(fact_3565_right__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,inverse_inverse(A),A3)) = one_one(A) ) ) ) ).

% right_inverse
tff(fact_3566_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num] : ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),W)) ) ) ).

% inverse_eq_divide_numeral
tff(fact_3567_floor__add2,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,Y4: A] :
          ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A)))
            | pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),ring_1_Ints(A))) )
         => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X3)),archim6421214686448440834_floor(A,Y4)) ) ) ) ).

% floor_add2
tff(fact_3568_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),archimedean_frac(A,X3)))
        <=> ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A))) ) ) ).

% frac_gt_0_iff
tff(fact_3569_idiff__infinity__right,axiom,
    ! [A3: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(A3)),extend4730790105801354508finity(extended_enat)) = zero_zero(extended_enat) ) ).

% idiff_infinity_right
tff(fact_3570_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) ) ).

% inverse_eq_divide_neg_numeral
tff(fact_3571_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit0(X3))),aa(num,A,numeral_numeral(A),bit0(Y4))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4))) ) ) ).

% xor_numerals(3)
tff(fact_3572_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(Y4))) = aa(num,A,numeral_numeral(A),bit1(Y4)) ) ) ).

% xor_numerals(1)
tff(fact_3573_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),bit1(Y4))) = aa(num,A,numeral_numeral(A),bit0(Y4)) ) ) ).

% xor_numerals(2)
tff(fact_3574_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit0(X3))),one_one(A)) = aa(num,A,numeral_numeral(A),bit1(X3)) ) ) ).

% xor_numerals(5)
tff(fact_3575_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit1(X3))),one_one(A)) = aa(num,A,numeral_numeral(A),bit0(X3)) ) ) ).

% xor_numerals(8)
tff(fact_3576_times__enat__simps_I3_J,axiom,
    ! [N: nat] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(N)) = zero_zero(extended_enat) ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(N)) = extend4730790105801354508finity(extended_enat) ) ) ) ).

% times_enat_simps(3)
tff(fact_3577_times__enat__simps_I4_J,axiom,
    ! [M: nat] :
      ( ( ( M = zero_zero(nat) )
       => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(M)),extend4730790105801354508finity(extended_enat)) = zero_zero(extended_enat) ) )
      & ( ( M != zero_zero(nat) )
       => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(M)),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ) ) ).

% times_enat_simps(4)
tff(fact_3578_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit1(X3))),aa(num,A,numeral_numeral(A),bit1(Y4))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4))) ) ) ).

% xor_numerals(7)
tff(fact_3579_xor__nat__numerals_I1_J,axiom,
    ! [Y4: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(Y4))) = aa(num,nat,numeral_numeral(nat),bit1(Y4)) ) ).

% xor_nat_numerals(1)
tff(fact_3580_xor__nat__numerals_I2_J,axiom,
    ! [Y4: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit1(Y4))) = aa(num,nat,numeral_numeral(nat),bit0(Y4)) ) ).

% xor_nat_numerals(2)
tff(fact_3581_xor__nat__numerals_I3_J,axiom,
    ! [X3: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(num,nat,numeral_numeral(nat),bit0(X3))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),bit1(X3)) ) ).

% xor_nat_numerals(3)
tff(fact_3582_xor__nat__numerals_I4_J,axiom,
    ! [X3: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(num,nat,numeral_numeral(nat),bit1(X3))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),bit0(X3)) ) ).

% xor_nat_numerals(4)
tff(fact_3583_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit0(X3))),aa(num,A,numeral_numeral(A),bit1(Y4))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4)))) ) ) ).

% xor_numerals(4)
tff(fact_3584_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit1(X3))),aa(num,A,numeral_numeral(A),bit0(Y4))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4)))) ) ) ).

% xor_numerals(6)
tff(fact_3585_power__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),A3)),N) = aa(A,A,inverse_inverse(A),aa(nat,A,power_power(A,A3),N)) ) ) ).

% power_inverse
tff(fact_3586_Ints__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,power_power(A,A3),N)),ring_1_Ints(A))) ) ) ).

% Ints_power
tff(fact_3587_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [X3: real] :
          ( ( X3 != zero_zero(real) )
         => ( real_Vector_of_real(A,aa(real,real,inverse_inverse(real),X3)) = aa(A,A,inverse_inverse(A),real_Vector_of_real(A,X3)) ) ) ) ).

% nonzero_of_real_inverse
tff(fact_3588_real__sqrt__inverse,axiom,
    ! [X3: real] : ( aa(real,real,sqrt,aa(real,real,inverse_inverse(real),X3)) = aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X3)) ) ).

% real_sqrt_inverse
tff(fact_3589_enat_Odistinct_I2_J,axiom,
    ! [Nat: nat] : ( extend4730790105801354508finity(extended_enat) != extended_enat2(Nat) ) ).

% enat.distinct(2)
tff(fact_3590_enat_Odistinct_I1_J,axiom,
    ! [Nat: nat] : ( extended_enat2(Nat) != extend4730790105801354508finity(extended_enat) ) ).

% enat.distinct(1)
tff(fact_3591_enat_Oexhaust,axiom,
    ! [Y4: extended_enat] :
      ( ! [Nat3: nat] : ( Y4 != extended_enat2(Nat3) )
     => ( Y4 = extend4730790105801354508finity(extended_enat) ) ) ).

% enat.exhaust
tff(fact_3592_enat2__cases,axiom,
    ! [Y4: extended_enat,Ya: extended_enat] :
      ( ( ? [Nat3: nat] : ( Y4 = extended_enat2(Nat3) )
       => ! [Nata: nat] : ( Ya != extended_enat2(Nata) ) )
     => ( ( ? [Nat3: nat] : ( Y4 = extended_enat2(Nat3) )
         => ( Ya != extend4730790105801354508finity(extended_enat) ) )
       => ( ( ( Y4 = extend4730790105801354508finity(extended_enat) )
           => ! [Nat3: nat] : ( Ya != extended_enat2(Nat3) ) )
         => ~ ( ( Y4 = extend4730790105801354508finity(extended_enat) )
             => ( Ya != extend4730790105801354508finity(extended_enat) ) ) ) ) ) ).

% enat2_cases
tff(fact_3593_enat3__cases,axiom,
    ! [Y4: extended_enat,Ya: extended_enat,Yb: extended_enat] :
      ( ( ? [Nat3: nat] : ( Y4 = extended_enat2(Nat3) )
       => ( ? [Nata: nat] : ( Ya = extended_enat2(Nata) )
         => ! [Natb: nat] : ( Yb != extended_enat2(Natb) ) ) )
     => ( ( ? [Nat3: nat] : ( Y4 = extended_enat2(Nat3) )
         => ( ? [Nata: nat] : ( Ya = extended_enat2(Nata) )
           => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
       => ( ( ? [Nat3: nat] : ( Y4 = extended_enat2(Nat3) )
           => ( ( Ya = extend4730790105801354508finity(extended_enat) )
             => ! [Nata: nat] : ( Yb != extended_enat2(Nata) ) ) )
         => ( ( ? [Nat3: nat] : ( Y4 = extended_enat2(Nat3) )
             => ( ( Ya = extend4730790105801354508finity(extended_enat) )
               => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
           => ( ( ( Y4 = extend4730790105801354508finity(extended_enat) )
               => ( ? [Nat3: nat] : ( Ya = extended_enat2(Nat3) )
                 => ! [Nata: nat] : ( Yb != extended_enat2(Nata) ) ) )
             => ( ( ( Y4 = extend4730790105801354508finity(extended_enat) )
                 => ( ? [Nat3: nat] : ( Ya = extended_enat2(Nat3) )
                   => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
               => ( ( ( Y4 = extend4730790105801354508finity(extended_enat) )
                   => ( ( Ya = extend4730790105801354508finity(extended_enat) )
                     => ! [Nat3: nat] : ( Yb != extended_enat2(Nat3) ) ) )
                 => ~ ( ( Y4 = extend4730790105801354508finity(extended_enat) )
                     => ( ( Ya = extend4730790105801354508finity(extended_enat) )
                       => ( Yb != extend4730790105801354508finity(extended_enat) ) ) ) ) ) ) ) ) ) ) ).

% enat3_cases
tff(fact_3594_enat__ex__split,axiom,
    ! [P: fun(extended_enat,bool)] :
      ( ? [X_12: extended_enat] : pp(aa(extended_enat,bool,P,X_12))
    <=> ( pp(aa(extended_enat,bool,P,extend4730790105801354508finity(extended_enat)))
        | ? [X4: nat] : pp(aa(extended_enat,bool,P,extended_enat2(X4))) ) ) ).

% enat_ex_split
tff(fact_3595_Ints__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),ring_1_Ints(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),ring_1_Ints(A))) ) ) ) ).

% Ints_diff
tff(fact_3596_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,uminus_uminus(A),X3)),ring_1_Ints(A)))
        <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A))) ) ) ).

% minus_in_Ints_iff
tff(fact_3597_Ints__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,uminus_uminus(A),A3)),ring_1_Ints(A))) ) ) ).

% Ints_minus
tff(fact_3598_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_xor_eq
tff(fact_3599_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A3) = aa(A,A,inverse_inverse(A),B2) )
         => ( A3 = B2 ) ) ) ).

% inverse_eq_imp_eq
tff(fact_3600_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),C2)) ) ) ).

% xor.assoc
tff(fact_3601_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),A3) ) ) ).

% xor.commute
tff(fact_3602_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),C2)) ) ) ).

% xor.left_commute
tff(fact_3603_Ints__add,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),ring_1_Ints(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),ring_1_Ints(A))) ) ) ) ).

% Ints_add
tff(fact_3604_Ints__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),one_one(A)),ring_1_Ints(A))) ) ).

% Ints_1
tff(fact_3605_Ints__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),ring_1_Ints(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),ring_1_Ints(A))) ) ) ) ).

% Ints_mult
tff(fact_3606_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: num] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(num,A,numeral_numeral(A),N)),ring_1_Ints(A))) ) ).

% Ints_numeral
tff(fact_3607_Ints__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),zero_zero(A)),ring_1_Ints(A))) ) ).

% Ints_0
tff(fact_3608_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A3) != zero_zero(A) ) ) ) ).

% nonzero_imp_inverse_nonzero
tff(fact_3609_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),aa(A,A,inverse_inverse(A),A3)) = A3 ) ) ) ).

% nonzero_inverse_inverse_eq
tff(fact_3610_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A3) = aa(A,A,inverse_inverse(A),B2) )
         => ( ( A3 != zero_zero(A) )
           => ( ( B2 != zero_zero(A) )
             => ( A3 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
tff(fact_3611_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( aa(A,A,inverse_inverse(A),A3) = zero_zero(A) )
         => ( A3 = zero_zero(A) ) ) ) ).

% inverse_zero_imp_zero
tff(fact_3612_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( field(A)
     => ( aa(A,A,inverse_inverse(A),zero_zero(A)) = zero_zero(A) ) ) ).

% field_class.field_inverse_zero
tff(fact_3613_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Y4: A,X3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Y4),X3) = aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Y4)),X3) = aa(A,A,aa(A,fun(A,A),times_times(A),X3),aa(A,A,inverse_inverse(A),Y4)) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
tff(fact_3614_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,aa(A,A,inverse_inverse(A),A3)) = aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,A3)) ) ) ) ).

% nonzero_norm_inverse
tff(fact_3615_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(int,A,ring_1_of_int(A),Z)),ring_1_Ints(A))) ) ).

% Ints_of_int
tff(fact_3616_Ints__induct,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Q2: A,P: fun(A,bool)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Q2),ring_1_Ints(A)))
         => ( ! [Z4: int] : pp(aa(A,bool,P,aa(int,A,ring_1_of_int(A),Z4)))
           => pp(aa(A,bool,P,Q2)) ) ) ) ).

% Ints_induct
tff(fact_3617_Ints__cases,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Q2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Q2),ring_1_Ints(A)))
         => ~ ! [Z4: int] : ( Q2 != aa(int,A,ring_1_of_int(A),Z4) ) ) ) ).

% Ints_cases
tff(fact_3618_infinity__ne__i0,axiom,
    extend4730790105801354508finity(extended_enat) != zero_zero(extended_enat) ).

% infinity_ne_i0
tff(fact_3619_Ints__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,abs_abs(A),A3)),ring_1_Ints(A))) ) ) ).

% Ints_abs
tff(fact_3620_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),B2)),N))
        <=> ~ ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
            <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,B2),N)) ) ) ) ).

% bit_xor_iff
tff(fact_3621_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y4: A,Z: A,X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Y4),Z)),X3) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y4),X3)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Z),X3)) ) ) ).

% bit.conj_xor_distrib2
tff(fact_3622_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Y4),Z)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),Z)) ) ) ).

% bit.conj_xor_distrib
tff(fact_3623_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,semiring_1_of_nat(A),N)),ring_1_Ints(A))) ) ).

% Ints_of_nat
tff(fact_3624_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(int,A,ring_1_of_int(A),K)),aa(int,A,ring_1_of_int(A),L)) ) ) ).

% of_int_xor_eq
tff(fact_3625_fact__in__Ints,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & ring_1(A) )
     => ! [N: nat] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),semiring_char_0_fact(A,N)),ring_1_Ints(A))) ) ).

% fact_in_Ints
tff(fact_3626_plus__eq__infty__iff__enat,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),N) = extend4730790105801354508finity(extended_enat) )
    <=> ( ( M = extend4730790105801354508finity(extended_enat) )
        | ( N = extend4730790105801354508finity(extended_enat) ) ) ) ).

% plus_eq_infty_iff_enat
tff(fact_3627_enat__add__left__cancel,axiom,
    ! [A3: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A3),B2) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A3),C2) )
    <=> ( ( A3 = extend4730790105801354508finity(extended_enat) )
        | ( B2 = C2 ) ) ) ).

% enat_add_left_cancel
tff(fact_3628_enat__ord__simps_I3_J,axiom,
    ! [Q2: extended_enat] : pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),Q2),extend4730790105801354508finity(extended_enat))) ).

% enat_ord_simps(3)
tff(fact_3629_infinity__ne__i1,axiom,
    extend4730790105801354508finity(extended_enat) != one_one(extended_enat) ).

% infinity_ne_i1
tff(fact_3630_numeral__ne__infinity,axiom,
    ! [K: num] : ( aa(num,extended_enat,numeral_numeral(extended_enat),K) != extend4730790105801354508finity(extended_enat) ) ).

% numeral_ne_infinity
tff(fact_3631_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [R2: real,X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),R2),real_V7770717601297561774m_norm(A,X3)))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R2))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,inverse_inverse(A),X3))),aa(real,real,inverse_inverse(real),R2))) ) ) ) ).

% norm_inverse_le_norm
tff(fact_3632_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A3))) ) ) ).

% positive_imp_inverse_positive
tff(fact_3633_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),zero_zero(A))) ) ) ).

% negative_imp_inverse_negative
tff(fact_3634_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A3)))
         => ( ( A3 != zero_zero(A) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ) ).

% inverse_positive_imp_positive
tff(fact_3635_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),zero_zero(A)))
         => ( ( A3 != zero_zero(A) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ).

% inverse_negative_imp_negative
tff(fact_3636_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A3))) ) ) ) ).

% less_imp_inverse_less_neg
tff(fact_3637_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ).

% inverse_less_imp_less_neg
tff(fact_3638_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A3))) ) ) ) ).

% less_imp_inverse_less
tff(fact_3639_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ).

% inverse_less_imp_less
tff(fact_3640_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A3)) ) ) ) ) ).

% nonzero_inverse_mult_distrib
tff(fact_3641_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),A3)) = aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),A3)) ) ) ) ).

% nonzero_inverse_minus_eq
tff(fact_3642_inverse__unique,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = one_one(A) )
         => ( aa(A,A,inverse_inverse(A),A3) = B2 ) ) ) ).

% inverse_unique
tff(fact_3643_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),one2)) = aa(num,A,numeral_numeral(A),one2) ) ) ).

% inverse_numeral_1
tff(fact_3644_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% field_class.field_divide_inverse
tff(fact_3645_divide__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% divide_inverse
tff(fact_3646_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),A3) ) ) ).

% divide_inverse_commute
tff(fact_3647_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] : ( aa(A,A,inverse_inverse(A),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3) ) ) ).

% inverse_eq_divide
tff(fact_3648_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),M)),aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X3)),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X3)),N)),aa(nat,A,power_power(A,X3),M)) ) ) ).

% power_mult_power_inverse_commute
tff(fact_3649_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),M)),aa(A,A,inverse_inverse(A),X3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),X3)),aa(nat,A,power_power(A,X3),M)) ) ) ).

% power_mult_inverse_distrib
tff(fact_3650_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: nat,X3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))),X3) = aa(A,A,aa(A,fun(A,A),times_times(A),X3),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))) ) ) ).

% mult_inverse_of_nat_commute
tff(fact_3651_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,inverse_inverse(A),A3)) = aa(A,A,inverse_inverse(A),aa(A,A,abs_abs(A),A3)) ) ) ) ).

% nonzero_abs_inverse
tff(fact_3652_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: int,X3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))),X3) = aa(A,A,aa(A,fun(A,A),times_times(A),X3),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))) ) ) ).

% mult_inverse_of_int_commute
tff(fact_3653_divide__real__def,axiom,
    ! [X3: real,Y4: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),Y4) = aa(real,real,aa(real,fun(real,real),times_times(real),X3),aa(real,real,inverse_inverse(real),Y4)) ) ).

% divide_real_def
tff(fact_3654_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3) = zero_zero(A) )
          <=> ( A3 = zero_zero(A) ) ) ) ) ).

% Ints_double_eq_0_iff
tff(fact_3655_enat__ord__code_I4_J,axiom,
    ! [M: nat] : pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),extended_enat2(M)),extend4730790105801354508finity(extended_enat))) ).

% enat_ord_code(4)
tff(fact_3656_less__infinityE,axiom,
    ! [N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),N),extend4730790105801354508finity(extended_enat)))
     => ~ ! [K2: nat] : ( N != extended_enat2(K2) ) ) ).

% less_infinityE
tff(fact_3657_infinity__ilessE,axiom,
    ! [M: nat] : ~ pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(M))) ).

% infinity_ilessE
tff(fact_3658_enat__ord__code_I5_J,axiom,
    ! [N: nat] : ~ pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(N))) ).

% enat_ord_code(5)
tff(fact_3659_infinity__ileE,axiom,
    ! [M: nat] : ~ pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(M))) ).

% infinity_ileE
tff(fact_3660_enat__add__left__cancel__less,axiom,
    ! [A3: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A3),B2)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A3),C2)))
    <=> ( ( A3 != extend4730790105801354508finity(extended_enat) )
        & pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),B2),C2)) ) ) ).

% enat_add_left_cancel_less
tff(fact_3661_enat__add__left__cancel__le,axiom,
    ! [A3: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A3),B2)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A3),C2)))
    <=> ( ( A3 = extend4730790105801354508finity(extended_enat) )
        | pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),B2),C2)) ) ) ).

% enat_add_left_cancel_le
tff(fact_3662_imult__is__infinity,axiom,
    ! [A3: extended_enat,B2: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),A3),B2) = extend4730790105801354508finity(extended_enat) )
    <=> ( ( ( A3 = extend4730790105801354508finity(extended_enat) )
          & ( B2 != zero_zero(extended_enat) ) )
        | ( ( B2 = extend4730790105801354508finity(extended_enat) )
          & ( A3 != zero_zero(extended_enat) ) ) ) ) ).

% imult_is_infinity
tff(fact_3663_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A3))) ) ) ) ).

% le_imp_inverse_le_neg
tff(fact_3664_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% inverse_le_imp_le_neg
tff(fact_3665_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A3))) ) ) ) ).

% le_imp_inverse_le
tff(fact_3666_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% inverse_le_imp_le
tff(fact_3667_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),X3)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A)))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X3)) ) ) ) ).

% inverse_le_1_iff
tff(fact_3668_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),X3)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),one_one(A))) ) ) ) ).

% one_less_inverse_iff
tff(fact_3669_one__less__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),A3))) ) ) ) ).

% one_less_inverse
tff(fact_3670_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),A3) = one_one(A) ) ) ) ).

% field_class.field_inverse
tff(fact_3671_inverse__add,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(A,A,inverse_inverse(A),A3))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% inverse_add
tff(fact_3672_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_add
tff(fact_3673_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_diff
tff(fact_3674_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A3) ) ) ) ).

% nonzero_inverse_eq_divide
tff(fact_3675_inverse__powr,axiom,
    ! [Y4: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
     => ( powr(real,aa(real,real,inverse_inverse(real),Y4),A3) = aa(real,real,inverse_inverse(real),powr(real,Y4,A3)) ) ) ).

% inverse_powr
tff(fact_3676_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3)),A3) != zero_zero(A) ) ) ) ).

% Ints_odd_nonzero
tff(fact_3677_VEBT__internal_Oelim__dead_Ocases,axiom,
    ! [X3: product_prod(vEBT_VEBT,extended_enat)] :
      ( ! [A5: bool,B5: bool,Uu2: extended_enat] : ( X3 != aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),product_Pair(vEBT_VEBT,extended_enat,vEBT_Leaf(A5,B5)),Uu2) )
     => ( ! [Info2: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] : ( X3 != aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),product_Pair(vEBT_VEBT,extended_enat,vEBT_Node(Info2,Deg2,TreeList2,Summary2)),extend4730790105801354508finity(extended_enat)) )
       => ~ ! [Info2: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT,L2: nat] : ( X3 != aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),product_Pair(vEBT_VEBT,extended_enat,vEBT_Node(Info2,Deg2,TreeList2,Summary2)),extended_enat2(L2)) ) ) ) ).

% VEBT_internal.elim_dead.cases
tff(fact_3678_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: int,A3: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),B2),A3))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),A3)),aa(int,A,ring_1_of_int(A),B2))),ring_1_Ints(A))) ) ) ).

% of_int_divide_in_Ints
tff(fact_3679_imult__infinity,axiom,
    ! [N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),zero_zero(extended_enat)),N))
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),N) = extend4730790105801354508finity(extended_enat) ) ) ).

% imult_infinity
tff(fact_3680_imult__infinity__right,axiom,
    ! [N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),zero_zero(extended_enat)),N))
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),N),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ) ).

% imult_infinity_right
tff(fact_3681_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ) ).

% inverse_le_iff
tff(fact_3682_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ) ).

% inverse_less_iff
tff(fact_3683_one__le__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),A3))) ) ) ) ).

% one_le_inverse
tff(fact_3684_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),X3)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A)))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X3)) ) ) ) ).

% inverse_less_1_iff
tff(fact_3685_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),X3)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),one_one(A))) ) ) ) ).

% one_le_inverse_iff
tff(fact_3686_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2))),aa(A,A,inverse_inverse(A),B2))) ) ) ) ) ).

% inverse_diff_inverse
tff(fact_3687_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => ? [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N2)))),X3)) ) ) ).

% reals_Archimedean
tff(fact_3688_forall__pos__mono__1,axiom,
    ! [P: fun(real,bool),E: real] :
      ( ! [D3: real,E2: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),D3),E2))
         => ( pp(aa(real,bool,P,D3))
           => pp(aa(real,bool,P,E2)) ) )
     => ( ! [N2: nat] : pp(aa(real,bool,P,aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N2)))))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
         => pp(aa(real,bool,P,E)) ) ) ) ).

% forall_pos_mono_1
tff(fact_3689_forall__pos__mono,axiom,
    ! [P: fun(real,bool),E: real] :
      ( ! [D3: real,E2: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),D3),E2))
         => ( pp(aa(real,bool,P,D3))
           => pp(aa(real,bool,P,E2)) ) )
     => ( ! [N2: nat] :
            ( ( N2 != zero_zero(nat) )
           => pp(aa(real,bool,P,aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N2)))) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
         => pp(aa(real,bool,P,E)) ) ) ) ).

% forall_pos_mono
tff(fact_3690_real__arch__inverse,axiom,
    ! [E: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
    <=> ? [N3: nat] :
          ( ( N3 != zero_zero(nat) )
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N3))))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N3))),E)) ) ) ).

% real_arch_inverse
tff(fact_3691_even__xor__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),B2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) ) ) ) ).

% even_xor_iff
tff(fact_3692_sqrt__divide__self__eq,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,X3)),X3) = aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X3)) ) ) ).

% sqrt_divide_self_eq
tff(fact_3693_ln__inverse,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(real,real,ln_ln(real),aa(real,real,inverse_inverse(real),X3)) = aa(real,real,uminus_uminus(real),aa(real,real,ln_ln(real),X3)) ) ) ).

% ln_inverse
tff(fact_3694_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),ring_1_Ints(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3)),A3)),zero_zero(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ).

% Ints_odd_less_0
tff(fact_3695_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A)))
         => ( ( X3 != zero_zero(A) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,abs_abs(A),X3))) ) ) ) ).

% Ints_nonzero_abs_ge1
tff(fact_3696_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),X3)),one_one(A)))
           => ( X3 = zero_zero(A) ) ) ) ) ).

% Ints_nonzero_abs_less1
tff(fact_3697_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),ring_1_Ints(A)))
           => ( ( X3 = Y4 )
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4))),one_one(A))) ) ) ) ) ).

% Ints_eq_abs_less1
tff(fact_3698_sin__times__pi__eq__0,axiom,
    ! [X3: real] :
      ( ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),X3),pi)) = zero_zero(real) )
    <=> pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X3),ring_1_Ints(real))) ) ).

% sin_times_pi_eq_0
tff(fact_3699_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => ? [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),N2))),X3)) ) ) ) ).

% ex_inverse_of_nat_less
tff(fact_3700_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: nat,N: nat] :
          ( ( X3 != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
           => ( aa(nat,A,power_power(A,X3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),N)),aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X3)),M)) ) ) ) ) ).

% power_diff_conv_inverse
tff(fact_3701_log__inverse,axiom,
    ! [A3: real,X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
     => ( ( A3 != one_one(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( aa(real,real,log(A3),aa(real,real,inverse_inverse(real),X3)) = aa(real,real,uminus_uminus(real),aa(real,real,log(A3),X3)) ) ) ) ) ).

% log_inverse
tff(fact_3702_frac__neg,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A] :
          ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A)))
           => ( archimedean_frac(A,aa(A,A,uminus_uminus(A),X3)) = zero_zero(A) ) )
          & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),ring_1_Ints(A)))
           => ( archimedean_frac(A,aa(A,A,uminus_uminus(A),X3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),archimedean_frac(A,X3)) ) ) ) ) ).

% frac_neg
tff(fact_3703_exp__plus__inverse__exp,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,exp(real),X3)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X3))))) ).

% exp_plus_inverse_exp
tff(fact_3704_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(A) )
     => ! [A3: B,B2: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),A3))
         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),ring_1_Ints(B)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(B,A3)),archim6421214686448440834_floor(B,B2)))),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),B2))))) ) ) ) ).

% le_mult_floor_Ints
tff(fact_3705_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X3: A,A3: A] :
          ( ( archimedean_frac(A,X3) = A3 )
        <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A3)),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A))) ) ) ) ).

% frac_unique_iff
tff(fact_3706_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(A) )
     => ! [A3: B,B2: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),A3))
         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),ring_1_Ints(B)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),B2)))),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(B,A3)),archimedean_ceiling(B,B2))))) ) ) ) ).

% mult_ceiling_le_Ints
tff(fact_3707_plus__inverse__ge__2,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,inverse_inverse(real),X3)))) ) ).

% plus_inverse_ge_2
tff(fact_3708_real__inv__sqrt__pow2,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( aa(nat,real,power_power(real,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X3))),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(real,real,inverse_inverse(real),X3) ) ) ).

% real_inv_sqrt_pow2
tff(fact_3709_tan__cot,axiom,
    ! [X3: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),X3)) = aa(real,real,inverse_inverse(real),aa(real,real,tan(real),X3)) ) ).

% tan_cot
tff(fact_3710_sin__integer__2pi,axiom,
    ! [N: real] :
      ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),N),ring_1_Ints(real)))
     => ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),N)) = zero_zero(real) ) ) ).

% sin_integer_2pi
tff(fact_3711_cos__integer__2pi,axiom,
    ! [N: real] :
      ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),N),ring_1_Ints(real)))
     => ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),N)) = one_one(real) ) ) ).

% cos_integer_2pi
tff(fact_3712_xor__nat__unfold,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M = zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N) = N ) )
      & ( ( M != zero_zero(nat) )
       => ( ( ( N = zero_zero(nat) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N) = M ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ) ) ) ).

% xor_nat_unfold
tff(fact_3713_real__le__x__sinh,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,exp(real),X3)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X3)))),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ).

% real_le_x_sinh
tff(fact_3714_xor__nat__rec,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(bool,nat,zero_neq_one_of_bool(nat),aa(bool,bool,fNot,aa(bool,bool,aa(bool,fun(bool,bool),fequal(bool),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M))),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% xor_nat_rec
tff(fact_3715_one__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)))),aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)))) ) ) ).

% one_xor_eq
tff(fact_3716_xor__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),one_one(A)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)))),aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)))) ) ) ).

% xor_one_eq
tff(fact_3717_real__le__abs__sinh,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,exp(real),X3)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X3)))),aa(num,real,numeral_numeral(real),bit0(one2)))))) ).

% real_le_abs_sinh
tff(fact_3718_tan__sec,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( cos(A,X3) != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,power_power(A,aa(A,A,tan(A),X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),cos(A,X3))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ) ).

% tan_sec
tff(fact_3719_sinh__ln__real,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( sinh(real,aa(real,real,ln_ln(real),X3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),aa(real,real,inverse_inverse(real),X3))),aa(num,real,numeral_numeral(real),bit0(one2))) ) ) ).

% sinh_ln_real
tff(fact_3720_cosh__ln__real,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( cosh(real,aa(real,real,ln_ln(real),X3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),aa(real,real,inverse_inverse(real),X3))),aa(num,real,numeral_numeral(real),bit0(one2))) ) ) ).

% cosh_ln_real
tff(fact_3721_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
         => ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ) ).

% gbinomial_absorption'
tff(fact_3722_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list(bool)] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),groups4207007520872428315er_sum(bool,int,zero_neq_one_of_bool(int),aa(num,int,numeral_numeral(int),bit0(one2)),Bs)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),aa(list(bool),nat,size_size(list(bool)),Bs)))) ).

% horner_sum_of_bool_2_less
tff(fact_3723_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( cosh(A,X3) = zero_zero(A) )
        <=> ( aa(nat,A,power_power(A,aa(A,A,exp(A),X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% cosh_zero_iff
tff(fact_3724_sinh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sinh(A,zero_zero(A)) = zero_zero(A) ) ) ).

% sinh_0
tff(fact_3725_sinh__real__zero__iff,axiom,
    ! [X3: real] :
      ( ( sinh(real,X3) = zero_zero(real) )
    <=> ( X3 = zero_zero(real) ) ) ).

% sinh_real_zero_iff
tff(fact_3726_sinh__real__less__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),sinh(real,X3)),sinh(real,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ).

% sinh_real_less_iff
tff(fact_3727_sinh__real__le__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sinh(real,X3)),sinh(real,Y4)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ).

% sinh_real_le_iff
tff(fact_3728_cosh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cosh(A,zero_zero(A)) = one_one(A) ) ) ).

% cosh_0
tff(fact_3729_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & semidom_divide(B) )
     => ! [K: nat] : ( aa(nat,B,gbinomial(B,zero_zero(B)),aa(nat,nat,suc,K)) = zero_zero(B) ) ) ).

% gbinomial_0(2)
tff(fact_3730_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A3: A] : ( aa(nat,A,gbinomial(A,A3),zero_zero(nat)) = one_one(A) ) ) ).

% gbinomial_0(1)
tff(fact_3731_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A3: A] : ( aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,zero_zero(nat))) = A3 ) ) ).

% gbinomial_Suc0
tff(fact_3732_sinh__real__neg__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),sinh(real,X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real))) ) ).

% sinh_real_neg_iff
tff(fact_3733_sinh__real__pos__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),sinh(real,X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3)) ) ).

% sinh_real_pos_iff
tff(fact_3734_sinh__real__nonneg__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),sinh(real,X3)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3)) ) ).

% sinh_real_nonneg_iff
tff(fact_3735_sinh__real__nonpos__iff,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sinh(real,X3)),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real))) ) ).

% sinh_real_nonpos_iff
tff(fact_3736_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),L)) ) ) ).

% xor_nonnegative_int_iff
tff(fact_3737_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)),zero_zero(int)))
    <=> ~ ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int))) ) ) ).

% xor_negative_int_iff
tff(fact_3738_bit__xor__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)),N))
    <=> ~ ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N))
        <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,L),N)) ) ) ).

% bit_xor_int_iff
tff(fact_3739_cosh__real__nonzero,axiom,
    ! [X3: real] : ( cosh(real,X3) != zero_zero(real) ) ).

% cosh_real_nonzero
tff(fact_3740_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X3)),cosh(A,Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X3)),sinh(A,Y4))) ) ) ).

% sinh_diff
tff(fact_3741_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X3)),cosh(A,Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X3)),sinh(A,Y4))) ) ) ).

% cosh_diff
tff(fact_3742_cosh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X3)),cosh(A,Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X3)),sinh(A,Y4))) ) ) ).

% cosh_add
tff(fact_3743_sinh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X3)),cosh(A,Y4))),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X3)),sinh(A,Y4))) ) ) ).

% sinh_add
tff(fact_3744_sinh__less__cosh__real,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),sinh(real,X3)),cosh(real,X3))) ).

% sinh_less_cosh_real
tff(fact_3745_sinh__le__cosh__real,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),sinh(real,X3)),cosh(real,X3))) ).

% sinh_le_cosh_real
tff(fact_3746_tanh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,tanh(A),X3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sinh(A,X3)),cosh(A,X3)) ) ) ).

% tanh_def
tff(fact_3747_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),cosh(A,X3)),sinh(A,X3)) = aa(A,A,exp(A),X3) ) ) ).

% cosh_plus_sinh
tff(fact_3748_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),sinh(A,X3)),cosh(A,X3)) = aa(A,A,exp(A),X3) ) ) ).

% sinh_plus_cosh
tff(fact_3749_XOR__lower,axiom,
    ! [X3: int,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),X3),Y4))) ) ) ).

% XOR_lower
tff(fact_3750_cosh__real__pos,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),cosh(real,X3))) ).

% cosh_real_pos
tff(fact_3751_cosh__real__nonneg,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),cosh(real,X3))) ).

% cosh_real_nonneg
tff(fact_3752_cosh__real__nonneg__le__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),cosh(real,X3)),cosh(real,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ) ) ).

% cosh_real_nonneg_le_iff
tff(fact_3753_cosh__real__nonpos__le__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),zero_zero(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),cosh(real,X3)),cosh(real,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),X3)) ) ) ) ).

% cosh_real_nonpos_le_iff
tff(fact_3754_cosh__real__ge__1,axiom,
    ! [X3: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),cosh(real,X3))) ).

% cosh_real_ge_1
tff(fact_3755_sinh__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),sinh(A,X3))),cosh(A,X3)) ) ) ).

% sinh_double
tff(fact_3756_divide__complex__def,axiom,
    ! [X3: complex,Y4: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X3),Y4) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X3),aa(complex,complex,inverse_inverse(complex),Y4)) ) ).

% divide_complex_def
tff(fact_3757_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,A3),K)),aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc_Suc
tff(fact_3758_cosh__real__strict__mono,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),cosh(real,X3)),cosh(real,Y4))) ) ) ).

% cosh_real_strict_mono
tff(fact_3759_cosh__real__nonneg__less__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),cosh(real,X3)),cosh(real,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ) ) ).

% cosh_real_nonneg_less_iff
tff(fact_3760_cosh__real__nonpos__less__iff,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real)))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y4),zero_zero(real)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),cosh(real,X3)),cosh(real,Y4)))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y4),X3)) ) ) ) ).

% cosh_real_nonpos_less_iff
tff(fact_3761_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),N)),K) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ) ).

% gbinomial_of_nat_symmetric
tff(fact_3762_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(nat,A,power_power(A,cosh(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,sinh(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)) ) ) ).

% cosh_square_eq
tff(fact_3763_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(nat,A,power_power(A,sinh(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,cosh(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)) ) ) ).

% sinh_square_eq
tff(fact_3764_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,cosh(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,sinh(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(A) ) ) ).

% hyperbolic_pythagoras
tff(fact_3765_xor__nat__def,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% xor_nat_def
tff(fact_3766_arcosh__cosh__real,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( aa(real,real,arcosh(real),cosh(real,X3)) = X3 ) ) ).

% arcosh_cosh_real
tff(fact_3767_cosh__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),X3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,cosh(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,power_power(A,sinh(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% cosh_double
tff(fact_3768_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),K)) ) ) ).

% gbinomial_addition_formula
tff(fact_3769_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,A3),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),K)) ) ) ).

% gbinomial_absorb_comp
tff(fact_3770_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [K: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),K)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),K)),aa(nat,A,gbinomial(A,A3),K))) ) ) ).

% gbinomial_ge_n_over_k_pow_k
tff(fact_3771_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,gbinomial(A,A3),K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A3),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1
tff(fact_3772_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),K)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A3),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1'
tff(fact_3773_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,A,gbinomial(A,A3),K)) ) ) ).

% Suc_times_gbinomial
tff(fact_3774_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),K)) ) ) ).

% gbinomial_absorption
tff(fact_3775_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,M: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),M))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),M)),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),M)),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K))) ) ) ) ).

% gbinomial_trinomial_revision
tff(fact_3776_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),K)),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_rec
tff(fact_3777_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))),aa(nat,A,gbinomial(A,A3),K)) ) ) ).

% gbinomial_factors
tff(fact_3778_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N))),one_one(A))),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),N)) ) ) ).

% gbinomial_index_swap
tff(fact_3779_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),K)),A3)),one_one(A))),K)) ) ) ).

% gbinomial_negated_upper
tff(fact_3780_tanh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] :
          ( ( cosh(A,X3) != zero_zero(A) )
         => ( ( cosh(A,Y4) != zero_zero(A) )
           => ( aa(A,A,tanh(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tanh(A),X3)),aa(A,A,tanh(A),Y4))),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tanh(A),X3)),aa(A,A,tanh(A),Y4)))) ) ) ) ) ).

% tanh_add
tff(fact_3781_XOR__upper,axiom,
    ! [X3: int,N: nat,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X3),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Y4),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),X3),Y4)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ) ) ).

% XOR_upper
tff(fact_3782_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),A3)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),K)) ) ) ).

% gbinomial_minus
tff(fact_3783_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
         => ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),K)) ) ) ) ).

% gbinomial_reduce_nat
tff(fact_3784_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),A3),K))),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer
tff(fact_3785_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer'
tff(fact_3786_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] : ( cosh(A,Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),Z)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Z)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% cosh_field_def
tff(fact_3787_complex__inverse,axiom,
    ! [A3: real,B2: real] : ( aa(complex,complex,inverse_inverse(complex),complex2(A3,B2)) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),A3),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,A3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,B2),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),B2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,A3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,B2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% complex_inverse
tff(fact_3788_xor__int__rec,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),aa(bool,bool,fNot,aa(bool,bool,aa(bool,fun(bool,bool),fequal(bool),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K))),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L)))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ).

% xor_int_rec
tff(fact_3789_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] : ( sinh(A,Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Z)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Z)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% sinh_field_def
tff(fact_3790_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Bs: list(bool),N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,groups4207007520872428315er_sum(bool,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),bit0(one2)),Bs)),N))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(bool),nat,size_size(list(bool)),Bs)))
            & pp(aa(nat,bool,nth(bool,Bs),N)) ) ) ) ).

% bit_horner_sum_bit_iff
tff(fact_3791_xor__int__unfold,axiom,
    ! [K: int,L: int] :
      ( ( ( K = aa(int,int,uminus_uminus(int),one_one(int)) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = aa(int,int,bit_ri4277139882892585799ns_not(int),L) ) )
      & ( ( K != aa(int,int,uminus_uminus(int),one_one(int)) )
       => ( ( ( L = aa(int,int,uminus_uminus(int),one_one(int)) )
           => ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = aa(int,int,bit_ri4277139882892585799ns_not(int),K) ) )
          & ( ( L != aa(int,int,uminus_uminus(int),one_one(int)) )
           => ( ( ( K = zero_zero(int) )
               => ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = L ) )
              & ( ( K != zero_zero(int) )
               => ( ( ( L = zero_zero(int) )
                   => ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = K ) )
                  & ( ( L != zero_zero(int) )
                   => ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),bit0(one2)))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
tff(fact_3792_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),N)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(num,nat,numeral_numeral(nat),N))) ) ) ).

% push_bit_numeral_minus_1
tff(fact_3793_psubsetI,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( ( A2 != B3 )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3)) ) ) ).

% psubsetI
tff(fact_3794_subset__antisym,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
       => ( A2 = B3 ) ) ) ).

% subset_antisym
tff(fact_3795_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A2)),aa(set(A),set(A),uminus_uminus(set(A)),B3)))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2)) ) ).

% Compl_subset_Compl_iff
tff(fact_3796_Compl__anti__mono,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),B3)),aa(set(A),set(A),uminus_uminus(set(A)),A2))) ) ).

% Compl_anti_mono
tff(fact_3797_subsetI,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),B3)) )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ).

% subsetI
tff(fact_3798_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)) = X3 ) ) ).

% bit.double_compl
tff(fact_3799_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,bit_ri4277139882892585799ns_not(A),X3) = aa(A,A,bit_ri4277139882892585799ns_not(A),Y4) )
        <=> ( X3 = Y4 ) ) ) ).

% bit.compl_eq_compl_iff
tff(fact_3800_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se4730199178511100633sh_bit(int,N),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) ) ).

% push_bit_nonnegative_int_iff
tff(fact_3801_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_se4730199178511100633sh_bit(int,N),K)),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int))) ) ).

% push_bit_negative_int_iff
tff(fact_3802_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,A3: A] :
          ( ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% push_bit_eq_0_iff
tff(fact_3803_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),zero_zero(A)) = zero_zero(A) ) ) ).

% push_bit_of_0
tff(fact_3804_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)) = aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),A3) ) ) ).

% push_bit_push_bit
tff(fact_3805_push__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)),aa(A,A,bit_se4730199178511100633sh_bit(A,N),B2)) ) ) ).

% push_bit_and
tff(fact_3806_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)),Y4) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),Y4)) ) ) ).

% bit.xor_compl_left
tff(fact_3807_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),aa(A,A,bit_ri4277139882892585799ns_not(A),Y4)) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),Y4)) ) ) ).

% bit.xor_compl_right
tff(fact_3808_push__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)),aa(A,A,bit_se4730199178511100633sh_bit(A,N),B2)) ) ) ).

% push_bit_xor
tff(fact_3809_concat__bit__of__zero__1,axiom,
    ! [N: nat,L: int] : ( aa(int,int,bit_concat_bit(N,zero_zero(int)),L) = aa(int,int,bit_se4730199178511100633sh_bit(int,N),L) ) ).

% concat_bit_of_zero_1
tff(fact_3810_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)) = zero_zero(A) ) ) ).

% bit.conj_cancel_right
tff(fact_3811_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)),X3) = zero_zero(A) ) ) ).

% bit.conj_cancel_left
tff(fact_3812_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% bit.compl_one
tff(fact_3813_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.compl_zero
tff(fact_3814_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),K)) = aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(num,A,numeral_numeral(A),bit0(K))) ) ) ).

% push_bit_Suc_numeral
tff(fact_3815_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_right
tff(fact_3816_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)),X3) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_left
tff(fact_3817_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),X3) ) ) ).

% bit.xor_one_right
tff(fact_3818_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,uminus_uminus(A),one_one(A))),X3) = aa(A,A,bit_ri4277139882892585799ns_not(A),X3) ) ) ).

% bit.xor_one_left
tff(fact_3819_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int))) ) ).

% not_nonnegative_int_iff
tff(fact_3820_not__negative__int__iff,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) ) ).

% not_negative_int_iff
tff(fact_3821_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( aa(A,A,uminus_uminus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),inc(N)) ) ) ).

% minus_not_numeral_eq
tff(fact_3822_even__not__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ).

% even_not_iff
tff(fact_3823_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(K)))) ) ) ).

% push_bit_Suc_minus_numeral
tff(fact_3824_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),K)) = aa(A,A,bit_se4730199178511100633sh_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),bit0(K))) ) ) ).

% push_bit_numeral
tff(fact_3825_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)) ) ) ).

% push_bit_minus_one_eq_not_mask
tff(fact_3826_not__one__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% not_one_eq
tff(fact_3827_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N)),A3) = aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% push_bit_Suc
tff(fact_3828_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A)) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) ) ) ).

% push_bit_of_1
tff(fact_3829_push__bit__of__Suc__0,axiom,
    ! [N: nat] : ( aa(nat,nat,bit_se4730199178511100633sh_bit(nat,N),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% push_bit_of_Suc_0
tff(fact_3830_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)))
        <=> ( ( N != zero_zero(nat) )
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)) ) ) ) ).

% even_push_bit_iff
tff(fact_3831_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,bit_se4730199178511100633sh_bit(A,pred_numeral(L)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(K)))) ) ) ).

% push_bit_minus_numeral
tff(fact_3832_bit__not__int__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_ri4277139882892585799ns_not(int),K)),N))
    <=> ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N)) ) ).

% bit_not_int_iff
tff(fact_3833_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),N)) = aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_push_bit
tff(fact_3834_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,N),M)) ) ) ).

% push_bit_of_nat
tff(fact_3835_psubsetD,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C2: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),C2),A2))
       => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),C2),B3)) ) ) ).

% psubsetD
tff(fact_3836_psubset__trans,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),B3),C6))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),C6)) ) ) ).

% psubset_trans
tff(fact_3837_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
     => ? [B5: A] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B5),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A2))) ) ).

% psubset_imp_ex_mem
tff(fact_3838_push__bit__nat__eq,axiom,
    ! [N: nat,K: int] : ( aa(nat,nat,bit_se4730199178511100633sh_bit(nat,N),aa(int,nat,nat2,K)) = aa(int,nat,nat2,aa(int,int,bit_se4730199178511100633sh_bit(int,N),K)) ) ).

% push_bit_nat_eq
tff(fact_3839_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3))) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)) ) ) ).

% take_bit_not_take_bit
tff(fact_3840_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A,B2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,bit_ri4277139882892585799ns_not(A),B2)) )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),B2) ) ) ) ).

% take_bit_not_iff
tff(fact_3841_push__bit__minus,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,uminus_uminus(A),A3)) = aa(A,A,uminus_uminus(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)) ) ) ).

% push_bit_minus
tff(fact_3842_push__bit__add,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)),aa(A,A,bit_se4730199178511100633sh_bit(A,N),B2)) ) ) ).

% push_bit_add
tff(fact_3843_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,bit_ri4277139882892585799ns_not(int),K)) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(int,A,ring_1_of_int(A),K)) ) ) ).

% of_int_not_eq
tff(fact_3844_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,K: int] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(int,A,ring_1_of_int(A),K)) = aa(int,A,ring_1_of_int(A),aa(int,int,bit_se4730199178511100633sh_bit(int,N),K)) ) ) ).

% push_bit_of_int
tff(fact_3845_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(int,A,ring_1_of_int(A),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),K))) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),K)) ) ) ).

% of_int_not_numeral
tff(fact_3846_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),bit_se2239418461657761734s_mask(A,N)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,M))) ) ) ).

% push_bit_mask_eq
tff(fact_3847_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),N),A3) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A)))) ) ) ).

% unset_bit_eq_and_not
tff(fact_3848_unset__bit__int__def,axiom,
    ! [N: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),N),K) = aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,bit_se4730199178511100633sh_bit(int,N),one_one(int)))) ) ).

% unset_bit_int_def
tff(fact_3849_not__add__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)),B2) ) ) ).

% not_add_distrib
tff(fact_3850_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)),B2) ) ) ).

% not_diff_distrib
tff(fact_3851_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),aa(A,A,bit_se4730199178511100633sh_bit(A,M),A3)) ) ) ).

% push_bit_take_bit
tff(fact_3852_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)) = aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),A3)) ) ) ).

% take_bit_push_bit
tff(fact_3853_flip__bit__nat__def,axiom,
    ! [M: nat,N: nat] : ( bit_se8732182000553998342ip_bit(nat,M,N) = aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),N),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),one_one(nat))) ) ).

% flip_bit_nat_def
tff(fact_3854_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)),one_one(A)) ) ) ).

% minus_eq_not_plus_1
tff(fact_3855_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))) ) ) ).

% minus_eq_not_minus_1
tff(fact_3856_not__eq__complement,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A3)),one_one(A)) ) ) ).

% not_eq_complement
tff(fact_3857_not__int__def,axiom,
    ! [K: int] : ( aa(int,int,bit_ri4277139882892585799ns_not(int),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),K)),one_one(int)) ) ).

% not_int_def
tff(fact_3858_and__not__numerals_I1_J,axiom,
    aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = zero_zero(int) ).

% and_not_numerals(1)
tff(fact_3859_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [B2: A,A3: A] :
          ( ! [N2: nat] :
              ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,B2),N2))
             => pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N2)) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,bit_ri4277139882892585799ns_not(A),B2)) ) ) ) ).

% disjunctive_diff
tff(fact_3860_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_se4730199178511100633sh_bit(int,M),K)),N))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
        & pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ).

% bit_push_bit_iff_int
tff(fact_3861_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),bit_se2239418461657761734s_mask(A,N)),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) ) ) ).

% take_bit_not_eq_mask_diff
tff(fact_3862_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% minus_numeral_inc_eq
tff(fact_3863_in__mono,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),X3: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
       => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),B3)) ) ) ).

% in_mono
tff(fact_3864_subsetD,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C2: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),C2),A2))
       => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),C2),B3)) ) ) ).

% subsetD
tff(fact_3865_equalityE,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( ( A2 = B3 )
     => ~ ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
         => ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2)) ) ) ).

% equalityE
tff(fact_3866_subset__eq,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
    <=> ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),B3)) ) ) ).

% subset_eq
tff(fact_3867_equalityD1,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( ( A2 = B3 )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ).

% equalityD1
tff(fact_3868_equalityD2,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( ( A2 = B3 )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2)) ) ).

% equalityD2
tff(fact_3869_subset__iff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
    <=> ! [T4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),T4),A2))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),T4),B3)) ) ) ).

% subset_iff
tff(fact_3870_subset__refl,axiom,
    ! [A: $tType,A2: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),A2)) ).

% subset_refl
tff(fact_3871_Collect__mono,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ! [X2: A] :
          ( pp(aa(A,bool,P,X2))
         => pp(aa(A,bool,Q,X2)) )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),collect(A,P)),collect(A,Q))) ) ).

% Collect_mono
tff(fact_3872_subset__trans,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C6))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6)) ) ) ).

% subset_trans
tff(fact_3873_set__eq__subset,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( ( A2 = B3 )
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2)) ) ) ).

% set_eq_subset
tff(fact_3874_Collect__mono__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),collect(A,P)),collect(A,Q)))
    <=> ! [X4: A] :
          ( pp(aa(A,bool,P,X4))
         => pp(aa(A,bool,Q,X4)) ) ) ).

% Collect_mono_iff
tff(fact_3875_subset__iff__psubset__eq,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
        | ( A2 = B3 ) ) ) ).

% subset_iff_psubset_eq
tff(fact_3876_subset__psubset__trans,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),B3),C6))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),C6)) ) ) ).

% subset_psubset_trans
tff(fact_3877_subset__not__subset__eq,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
        & ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2)) ) ) ).

% subset_not_subset_eq
tff(fact_3878_psubset__subset__trans,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C6))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),C6)) ) ) ).

% psubset_subset_trans
tff(fact_3879_psubset__imp__subset,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ).

% psubset_imp_subset
tff(fact_3880_psubset__eq,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
        & ( A2 != B3 ) ) ) ).

% psubset_eq
tff(fact_3881_psubsetE,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
     => ~ ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2)) ) ) ).

% psubsetE
tff(fact_3882_Diff__mono,axiom,
    ! [A: $tType,A2: set(A),C6: set(A),D4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),D4),B3))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),D4))) ) ) ).

% Diff_mono
tff(fact_3883_Diff__subset,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3)),A2)) ).

% Diff_subset
tff(fact_3884_double__diff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C6))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),A2)) = A2 ) ) ) ).

% double_diff
tff(fact_3885_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),Q2)),N))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
        & pp(aa(nat,bool,bit_se5641148757651400278ts_bit(nat,Q2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ).

% bit_push_bit_iff_nat
tff(fact_3886_concat__bit__eq,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(N,K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,bit_se4730199178511100633sh_bit(int,N),L)) ) ).

% concat_bit_eq
tff(fact_3887_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se8732182000553998342ip_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A))) ) ) ).

% flip_bit_eq_xor
tff(fact_3888_flip__bit__int__def,axiom,
    ! [N: nat,K: int] : ( bit_se8732182000553998342ip_bit(int,N,K) = aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),aa(int,int,bit_se4730199178511100633sh_bit(int,N),one_one(int))) ) ).

% flip_bit_int_def
tff(fact_3889_not__int__div__2,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),aa(num,int,numeral_numeral(int),bit0(one2))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))) ) ).

% not_int_div_2
tff(fact_3890_even__not__iff__int,axiom,
    ! [K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,bit_ri4277139882892585799ns_not(int),K)))
    <=> ~ pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)) ) ).

% even_not_iff_int
tff(fact_3891_and__not__numerals_I2_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = one_one(int) ) ).

% and_not_numerals(2)
tff(fact_3892_and__not__numerals_I4_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(num,int,numeral_numeral(int),bit0(M)) ) ).

% and_not_numerals(4)
tff(fact_3893_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),bit0(N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit1(N))) ) ) ).

% not_numeral_Bit0_eq
tff(fact_3894_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),K)),N))
    <=> pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)))),N)) ) ).

% bit_minus_int_iff
tff(fact_3895_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),bitM(N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(N))) ) ) ).

% not_numeral_BitM_eq
tff(fact_3896_push__bit__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% push_bit_double
tff(fact_3897_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N))) = zero_zero(A) ) ) ) ).

% take_bit_not_mask_eq_0
tff(fact_3898_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A))) != zero_zero(A) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
tff(fact_3899_and__not__numerals_I5_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% and_not_numerals(5)
tff(fact_3900_and__not__numerals_I7_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit1(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(num,int,numeral_numeral(int),bit0(M)) ) ).

% and_not_numerals(7)
tff(fact_3901_and__not__numerals_I3_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit1(N)))) = zero_zero(int) ) ).

% and_not_numerals(3)
tff(fact_3902_push__bit__int__def,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_se4730199178511100633sh_bit(int,N),K) = aa(int,int,aa(int,fun(int,int),times_times(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% push_bit_int_def
tff(fact_3903_push__bit__nat__def,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,bit_se4730199178511100633sh_bit(nat,N),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% push_bit_nat_def
tff(fact_3904_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ).

% push_bit_eq_mult
tff(fact_3905_exp__dvdE,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),A3))
         => ~ ! [B5: A] : ( A3 != aa(A,A,bit_se4730199178511100633sh_bit(A,N),B5) ) ) ) ).

% exp_dvdE
tff(fact_3906_and__not__numerals_I6_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit1(N)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% and_not_numerals(6)
tff(fact_3907_and__not__numerals_I9_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit1(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit1(N)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% and_not_numerals(9)
tff(fact_3908_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_ri4277139882892585799ns_not(A),A3)),N))
        <=> ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) != zero_zero(A) )
            & ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N)) ) ) ) ).

% bit_not_iff_eq
tff(fact_3909_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)) ) ) ).

% minus_exp_eq_not_mask
tff(fact_3910_push__bit__minus__one,axiom,
    ! [N: nat] : ( aa(int,int,bit_se4730199178511100633sh_bit(int,N),aa(int,int,uminus_uminus(int),one_one(int))) = aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% push_bit_minus_one
tff(fact_3911_and__not__numerals_I8_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit1(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))))) ) ).

% and_not_numerals(8)
tff(fact_3912_not__int__rec,axiom,
    ! [K: int] : ( aa(int,int,bit_ri4277139882892585799ns_not(int),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ).

% not_int_rec
tff(fact_3913_Cauchy__iff2,axiom,
    ! [X7: fun(nat,real)] :
      ( topolo3814608138187158403Cauchy(real,X7)
    <=> ! [J4: nat] :
        ? [M8: nat] :
        ! [M6: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),M6))
         => ! [N3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),N3))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,X7,M6)),aa(nat,real,X7,N3)))),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,J4))))) ) ) ) ).

% Cauchy_iff2
tff(fact_3914_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y4: bool] :
      ( ( vEBT_VEBT_membermima(X3,Xa)
      <=> pp(Y4) )
     => ( ( ? [Uu2: bool,Uv2: bool] : ( X3 = vEBT_Leaf(Uu2,Uv2) )
         => pp(Y4) )
       => ( ( ? [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] : ( X3 = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
           => pp(Y4) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
               => ( pp(Y4)
                <=> ~ ( ( Xa = Mi )
                      | ( Xa = Ma2 ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list(vEBT_VEBT)] :
                  ( ? [Vc: vEBT_VEBT] : ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc) )
                 => ( pp(Y4)
                  <=> ~ ( ( Xa = Mi )
                        | ( Xa = Ma2 )
                        | ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                           => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) )
             => ~ ! [V3: nat,TreeList2: list(vEBT_VEBT)] :
                    ( ? [Vd: vEBT_VEBT] : ( X3 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd) )
                   => ( pp(Y4)
                    <=> ~ ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                           => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
tff(fact_3915_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_VEBT_membermima(X3,Xa)
     => ( ! [Uu2: bool,Uv2: bool] : ( X3 != vEBT_Leaf(Uu2,Uv2) )
       => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] : ( X3 != vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
               => ( ( Xa = Mi )
                  | ( Xa = Ma2 ) ) )
           => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list(vEBT_VEBT)] :
                  ( ? [Vc: vEBT_VEBT] : ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc) )
                 => ( ( Xa = Mi )
                    | ( Xa = Ma2 )
                    | ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                       => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) )
             => ~ ! [V3: nat,TreeList2: list(vEBT_VEBT)] :
                    ( ? [Vd: vEBT_VEBT] : ( X3 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd) )
                   => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                       => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
tff(fact_3916_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] : ( re(csqrt(Z)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ).

% csqrt.simps(1)
tff(fact_3917_complex__Re__numeral,axiom,
    ! [V: num] : ( re(aa(num,complex,numeral_numeral(complex),V)) = aa(num,real,numeral_numeral(real),V) ) ).

% complex_Re_numeral
tff(fact_3918_Re__divide__of__nat,axiom,
    ! [Z: complex,N: nat] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(nat,complex,semiring_1_of_nat(complex),N))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),aa(nat,real,semiring_1_of_nat(real),N)) ) ).

% Re_divide_of_nat
tff(fact_3919_Re__divide__of__real,axiom,
    ! [Z: complex,R2: real] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),real_Vector_of_real(complex,R2))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),R2) ) ).

% Re_divide_of_real
tff(fact_3920_Re__sgn,axiom,
    ! [Z: complex] : ( re(aa(complex,complex,sgn_sgn(complex),Z)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),real_V7770717601297561774m_norm(complex,Z)) ) ).

% Re_sgn
tff(fact_3921_Re__divide__numeral,axiom,
    ! [Z: complex,W: num] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(num,complex,numeral_numeral(complex),W))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),aa(num,real,numeral_numeral(real),W)) ) ).

% Re_divide_numeral
tff(fact_3922_cos__Arg__i__mult__zero,axiom,
    ! [Y4: complex] :
      ( ( Y4 != zero_zero(complex) )
     => ( ( re(Y4) = zero_zero(real) )
       => ( cos(real,arg(Y4)) = zero_zero(real) ) ) ) ).

% cos_Arg_i_mult_zero
tff(fact_3923_nat__less__as__int,axiom,
    ! [X: nat,Xa2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X),Xa2))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_less_as_int
tff(fact_3924_less__eq__set__def,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
    <=> pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),aTP_Lamp_a(set(A),fun(A,bool),A2)),aTP_Lamp_a(set(A),fun(A,bool),B3))) ) ).

% less_eq_set_def
tff(fact_3925_Collect__subset,axiom,
    ! [A: $tType,A2: set(A),P: fun(A,bool)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),collect(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aa(set(A),fun(fun(A,bool),fun(A,bool)),A2),P))),A2)) ).

% Collect_subset
tff(fact_3926_less__set__def,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
    <=> pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less(fun(A,bool)),aTP_Lamp_a(set(A),fun(A,bool),A2)),aTP_Lamp_a(set(A),fun(A,bool),B3))) ) ).

% less_set_def
tff(fact_3927_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),collect(A,aTP_Lamp_ab(A,fun(A,bool),A3))),collect(A,aTP_Lamp_ab(A,fun(A,bool),B2))))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B2),A3)) ) ) ) ).

% strict_subset_divisors_dvd
tff(fact_3928_less__enat__def,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less(extended_enat),M),N))
    <=> pp(extended_case_enat(bool,aTP_Lamp_ac(extended_enat,fun(nat,bool),N),fFalse,M)) ) ).

% less_enat_def
tff(fact_3929_lambda__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ( aTP_Lamp_ad(A,A) = aa(A,fun(A,A),times_times(A),zero_zero(A)) ) ) ).

% lambda_zero
tff(fact_3930_lambda__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aTP_Lamp_ae(A,A) = aa(A,fun(A,A),times_times(A),one_one(A)) ) ) ).

% lambda_one
tff(fact_3931_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [C2: A] : ( aTP_Lamp_af(A,fun(A,A),C2) = aa(A,fun(A,A),times_times(A),C2) ) ) ).

% mult_commute_abs
tff(fact_3932_less__eq__enat__def,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),M),N))
    <=> pp(extended_case_enat(bool,aTP_Lamp_ah(extended_enat,fun(nat,bool),M),fTrue,N)) ) ).

% less_eq_enat_def
tff(fact_3933_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),collect(A,aTP_Lamp_ab(A,fun(A,bool),A3))),collect(A,aTP_Lamp_ab(A,fun(A,bool),B2))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),B2)) ) ) ).

% subset_divisors_dvd
tff(fact_3934_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bit0(N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N)) ) ) ).

% numeral_code(2)
tff(fact_3935_nat__leq__as__int,axiom,
    ! [X: nat,Xa2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X),Xa2))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_leq_as_int
tff(fact_3936_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bit1(N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N))),one_one(A)) ) ) ).

% numeral_code(3)
tff(fact_3937_power__numeral__even,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z: A,W: num] : ( aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),bit0(W))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),W))),aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),W))) ) ) ).

% power_numeral_even
tff(fact_3938_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z: A,W: num] : ( aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),bit1(W))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),W)))),aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),W))) ) ) ).

% power_numeral_odd
tff(fact_3939_nat__plus__as__int,axiom,
    ! [X: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_plus_as_int
tff(fact_3940_nat__times__as__int,axiom,
    ! [X: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),X),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_times_as_int
tff(fact_3941_nat__minus__as__int,axiom,
    ! [X: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_minus_as_int
tff(fact_3942_nat__div__as__int,axiom,
    ! [X: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_div_as_int
tff(fact_3943_nat__mod__as__int,axiom,
    ! [X: nat,Xa2: nat] : ( modulo_modulo(nat,X,Xa2) = aa(int,nat,nat2,modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),X),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_mod_as_int
tff(fact_3944_plus__enat__def,axiom,
    ! [M: extended_enat,N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),N) = extended_case_enat(extended_enat,aTP_Lamp_aj(extended_enat,fun(nat,extended_enat),N),extend4730790105801354508finity(extended_enat),M) ) ).

% plus_enat_def
tff(fact_3945_imaginary__unit_Osimps_I1_J,axiom,
    re(imaginary_unit) = zero_zero(real) ).

% imaginary_unit.simps(1)
tff(fact_3946_complex__Re__le__cmod,axiom,
    ! [X3: complex] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),re(X3)),real_V7770717601297561774m_norm(complex,X3))) ).

% complex_Re_le_cmod
tff(fact_3947_zero__complex_Osimps_I1_J,axiom,
    re(zero_zero(complex)) = zero_zero(real) ).

% zero_complex.simps(1)
tff(fact_3948_diff__enat__def,axiom,
    ! [A3: extended_enat,B2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),A3),B2) = extended_case_enat(extended_enat,aTP_Lamp_al(extended_enat,fun(nat,extended_enat),B2),extend4730790105801354508finity(extended_enat),A3) ) ).

% diff_enat_def
tff(fact_3949_diff__nat__eq__if,axiom,
    ! [Z5: int,Z: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z5),zero_zero(int)))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5)) = aa(int,nat,nat2,Z) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z5),zero_zero(int)))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5)) = if(nat,aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z5)),zero_zero(int)),zero_zero(nat),aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z5))) ) ) ) ).

% diff_nat_eq_if
tff(fact_3950_times__enat__def,axiom,
    ! [M: extended_enat,N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),N) = extended_case_enat(extended_enat,aTP_Lamp_an(extended_enat,fun(nat,extended_enat),N),if(extended_enat,aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),fequal(extended_enat),N),zero_zero(extended_enat)),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)),M) ) ).

% times_enat_def
tff(fact_3951_abs__Re__le__cmod,axiom,
    ! [X3: complex] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),re(X3))),real_V7770717601297561774m_norm(complex,X3))) ).

% abs_Re_le_cmod
tff(fact_3952_Re__csqrt,axiom,
    ! [Z: complex] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),re(csqrt(Z)))) ).

% Re_csqrt
tff(fact_3953_set__decode__def,axiom,
    ! [X3: nat] : ( nat_set_decode(X3) = collect(nat,aTP_Lamp_ao(nat,fun(nat,bool),X3)) ) ).

% set_decode_def
tff(fact_3954_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3) = if(A,aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),A3)),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),A3)),aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N)),aa(A,A,uminus_uminus(A),one_one(A)))),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),A3)) ) ) ).

% signed_take_bit_code
tff(fact_3955_pochhammer__code,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat,A3: A] :
          ( ( ( N = zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,A3,N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,A3,N) = set_fo6178422350223883121st_nat(A,aTP_Lamp_ap(A,fun(nat,fun(A,A)),A3),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),one_one(A)) ) ) ) ) ).

% pochhammer_code
tff(fact_3956_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va2: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va2))))
       => ( vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,suc,Va2))) = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va2)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va2))))
       => ( vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,suc,Va2))) = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va2)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ) ).

% vebt_buildup.simps(3)
tff(fact_3957_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),zero_zero(real)))
    <=> ( re(Z) = aa(real,real,uminus_uminus(real),real_V7770717601297561774m_norm(complex,Z)) ) ) ).

% cmod_plus_Re_le_0_iff
tff(fact_3958_gbinomial__code,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] :
          ( ( ( K = zero_zero(nat) )
           => ( aa(nat,A,gbinomial(A,A3),K) = one_one(A) ) )
          & ( ( K != zero_zero(nat) )
           => ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),set_fo6178422350223883121st_nat(A,aTP_Lamp_aq(A,fun(nat,fun(A,A)),A3),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)),one_one(A))),semiring_char_0_fact(A,K)) ) ) ) ) ).

% gbinomial_code
tff(fact_3959_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A3: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),A3)) = re(aa(nat,complex,power_power(complex,cis(A3)),N)) ) ).

% cos_n_Re_cis_pow_n
tff(fact_3960_vebt__buildup_Oelims,axiom,
    ! [X3: nat,Y4: vEBT_VEBT] :
      ( ( vEBT_vebt_buildup(X3) = Y4 )
     => ( ( ( X3 = zero_zero(nat) )
         => ( Y4 != vEBT_Leaf(fFalse,fFalse) ) )
       => ( ( ( X3 = aa(nat,nat,suc,zero_zero(nat)) )
           => ( Y4 != vEBT_Leaf(fFalse,fFalse) ) )
         => ~ ! [Va: nat] :
                ( ( X3 = aa(nat,nat,suc,aa(nat,nat,suc,Va)) )
               => ~ ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va))))
                     => ( Y4 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) )
                    & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va))))
                     => ( Y4 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
tff(fact_3961_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option(product_prod(nat,nat)),V: nat,TreeList: list(vEBT_VEBT),S: vEBT_VEBT,X3: nat] :
      ( vEBT_V5719532721284313246member(vEBT_Node(Uy,aa(nat,nat,suc,V),TreeList,S),X3)
    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)))
         => vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList))) ) ) ).

% VEBT_internal.naive_member.simps(3)
tff(fact_3962_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
             => ? [M8: nat] :
                ! [M6: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),M6))
                 => ! [N3: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),N3))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M6)),aa(nat,A,X7,N3)))),E3)) ) ) ) ) ) ).

% Cauchy_iff
tff(fact_3963_CauchyI,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E2))
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M9),M3))
                 => ! [N2: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M9),N2))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M3)),aa(nat,A,X7,N2)))),E2)) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% CauchyI
tff(fact_3964_CauchyD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),E: real] :
          ( topolo3814608138187158403Cauchy(A,X7)
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
           => ? [M10: nat] :
              ! [M2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M10),M2))
               => ! [N7: nat] :
                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M10),N7))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M2)),aa(nat,A,X7,N7)))),E)) ) ) ) ) ) ).

% CauchyD
tff(fact_3965_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList: list(vEBT_VEBT),Vd2: vEBT_VEBT,X3: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V),TreeList,Vd2),X3)
    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)))
         => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList))) ) ) ).

% VEBT_internal.membermima.simps(5)
tff(fact_3966_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi3: nat,Ma: nat,V: nat,TreeList: list(vEBT_VEBT),Vc2: vEBT_VEBT,X3: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma)),aa(nat,nat,suc,V),TreeList,Vc2),X3)
    <=> ( ( X3 = Mi3 )
        | ( X3 = Ma )
        | ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)))
           => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(X3,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList))) ) ) ) ).

% VEBT_internal.membermima.simps(4)
tff(fact_3967_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_V5719532721284313246member(X3,Xa)
     => ( ! [A5: bool,B5: bool] :
            ( ( X3 = vEBT_Leaf(A5,B5) )
           => ( ( ( Xa = zero_zero(nat) )
               => pp(A5) )
              & ( ( Xa != zero_zero(nat) )
               => ( ( ( Xa = one_one(nat) )
                   => pp(B5) )
                  & ( Xa = one_one(nat) ) ) ) ) )
       => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] : ( X3 != vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList2: list(vEBT_VEBT)] :
                ( ? [S3: vEBT_VEBT] : ( X3 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3) )
               => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                   => vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                  & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
tff(fact_3968_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( vEBT_V5719532721284313246member(X3,Xa)
     => ( ! [A5: bool,B5: bool] :
            ( ( X3 = vEBT_Leaf(A5,B5) )
           => ~ ( ( ( Xa = zero_zero(nat) )
                 => pp(A5) )
                & ( ( Xa != zero_zero(nat) )
                 => ( ( ( Xa = one_one(nat) )
                     => pp(B5) )
                    & ( Xa = one_one(nat) ) ) ) ) )
       => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList2: list(vEBT_VEBT)] :
              ( ? [S3: vEBT_VEBT] : ( X3 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3) )
             => ~ ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                   => vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                  & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
tff(fact_3969_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y4: bool] :
      ( ( vEBT_V5719532721284313246member(X3,Xa)
      <=> pp(Y4) )
     => ( ! [A5: bool,B5: bool] :
            ( ( X3 = vEBT_Leaf(A5,B5) )
           => ( pp(Y4)
            <=> ~ ( ( ( Xa = zero_zero(nat) )
                   => pp(A5) )
                  & ( ( Xa != zero_zero(nat) )
                   => ( ( ( Xa = one_one(nat) )
                       => pp(B5) )
                      & ( Xa = one_one(nat) ) ) ) ) ) )
       => ( ( ? [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] : ( X3 = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
           => pp(Y4) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList2: list(vEBT_VEBT)] :
                ( ? [S3: vEBT_VEBT] : ( X3 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3) )
               => ( pp(Y4)
                <=> ~ ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                       => vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
tff(fact_3970_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_membermima(X3,Xa)
     => ( ! [Mi: nat,Ma2: nat] :
            ( ? [Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
           => ~ ( ( Xa = Mi )
                | ( Xa = Ma2 ) ) )
       => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list(vEBT_VEBT)] :
              ( ? [Vc: vEBT_VEBT] : ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc) )
             => ~ ( ( Xa = Mi )
                  | ( Xa = Ma2 )
                  | ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                     => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                    & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) )
         => ~ ! [V3: nat,TreeList2: list(vEBT_VEBT)] :
                ( ? [Vd: vEBT_VEBT] : ( X3 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd) )
               => ~ ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                     => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                    & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
tff(fact_3971_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: int] :
          ( ( ( K = zero_zero(int) )
           => ( aa(int,A,ring_1_of_int(A),K) = zero_zero(A) ) )
          & ( ( K != zero_zero(int) )
           => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
               => ( aa(int,A,ring_1_of_int(A),K) = aa(A,A,uminus_uminus(A),aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),K))) ) )
              & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
               => ( aa(int,A,ring_1_of_int(A),K) = if(A,aa(int,bool,aa(int,fun(int,bool),fequal(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),zero_zero(int)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2))))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))))),one_one(A))) ) ) ) ) ) ) ).

% of_int_code_if
tff(fact_3972_monoseq__arctan__series,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => topological_monoseq(real,aTP_Lamp_ar(real,fun(nat,real),X3)) ) ).

% monoseq_arctan_series
tff(fact_3973_csqrt_Ocode,axiom,
    ! [Z: complex] : ( csqrt(Z) = complex2(aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(real,real,aa(real,fun(real,real),times_times(real),if(real,aa(real,bool,aa(real,fun(real,bool),fequal(real),im(Z)),zero_zero(real)),one_one(real),aa(real,real,sgn_sgn(real),im(Z)))),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),bit0(one2)))))) ) ).

% csqrt.code
tff(fact_3974_ln__series,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,real,ln_ln(real),X3) = suminf(real,aTP_Lamp_as(real,fun(nat,real),X3)) ) ) ) ).

% ln_series
tff(fact_3975_predicate1I,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ! [X2: A] :
          ( pp(aa(A,bool,P,X2))
         => pp(aa(A,bool,Q,X2)) )
     => pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q)) ) ).

% predicate1I
tff(fact_3976_complex__Im__fact,axiom,
    ! [N: nat] : ( im(semiring_char_0_fact(complex,N)) = zero_zero(real) ) ).

% complex_Im_fact
tff(fact_3977_complex__Im__of__int,axiom,
    ! [Z: int] : ( im(aa(int,complex,ring_1_of_int(complex),Z)) = zero_zero(real) ) ).

% complex_Im_of_int
tff(fact_3978_Im__complex__of__real,axiom,
    ! [Z: real] : ( im(real_Vector_of_real(complex,Z)) = zero_zero(real) ) ).

% Im_complex_of_real
tff(fact_3979_Im__power__real,axiom,
    ! [X3: complex,N: nat] :
      ( ( im(X3) = zero_zero(real) )
     => ( im(aa(nat,complex,power_power(complex,X3),N)) = zero_zero(real) ) ) ).

% Im_power_real
tff(fact_3980_complex__Im__numeral,axiom,
    ! [V: num] : ( im(aa(num,complex,numeral_numeral(complex),V)) = zero_zero(real) ) ).

% complex_Im_numeral
tff(fact_3981_complex__Im__of__nat,axiom,
    ! [N: nat] : ( im(aa(nat,complex,semiring_1_of_nat(complex),N)) = zero_zero(real) ) ).

% complex_Im_of_nat
tff(fact_3982_Im__i__times,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) = re(Z) ) ).

% Im_i_times
tff(fact_3983_Im__divide__of__real,axiom,
    ! [Z: complex,R2: real] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),real_Vector_of_real(complex,R2))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),R2) ) ).

% Im_divide_of_real
tff(fact_3984_Im__sgn,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,sgn_sgn(complex),Z)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),real_V7770717601297561774m_norm(complex,Z)) ) ).

% Im_sgn
tff(fact_3985_powser__zero,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [F2: fun(nat,A)] : ( suminf(A,aTP_Lamp_at(fun(nat,A),fun(nat,A),F2)) = aa(nat,A,F2,zero_zero(nat)) ) ) ).

% powser_zero
tff(fact_3986_Re__power__real,axiom,
    ! [X3: complex,N: nat] :
      ( ( im(X3) = zero_zero(real) )
     => ( re(aa(nat,complex,power_power(complex,X3),N)) = aa(nat,real,power_power(real,re(X3)),N) ) ) ).

% Re_power_real
tff(fact_3987_Re__i__times,axiom,
    ! [Z: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) = aa(real,real,uminus_uminus(real),im(Z)) ) ).

% Re_i_times
tff(fact_3988_Im__divide__numeral,axiom,
    ! [Z: complex,W: num] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(num,complex,numeral_numeral(complex),W))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),aa(num,real,numeral_numeral(real),W)) ) ).

% Im_divide_numeral
tff(fact_3989_Im__divide__of__nat,axiom,
    ! [Z: complex,N: nat] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(nat,complex,semiring_1_of_nat(complex),N))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),aa(nat,real,semiring_1_of_nat(real),N)) ) ).

% Im_divide_of_nat
tff(fact_3990_csqrt__of__real__nonneg,axiom,
    ! [X3: complex] :
      ( ( im(X3) = zero_zero(real) )
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),re(X3)))
       => ( csqrt(X3) = real_Vector_of_real(complex,aa(real,real,sqrt,re(X3))) ) ) ) ).

% csqrt_of_real_nonneg
tff(fact_3991_csqrt__minus,axiom,
    ! [X3: complex] :
      ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),im(X3)),zero_zero(real)))
        | ( ( im(X3) = zero_zero(real) )
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),re(X3))) ) )
     => ( csqrt(aa(complex,complex,uminus_uminus(complex),X3)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),csqrt(X3)) ) ) ).

% csqrt_minus
tff(fact_3992_csqrt__of__real__nonpos,axiom,
    ! [X3: complex] :
      ( ( im(X3) = zero_zero(real) )
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),re(X3)),zero_zero(real)))
       => ( csqrt(X3) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,aa(real,real,sqrt,aa(real,real,abs_abs(real),re(X3))))) ) ) ) ).

% csqrt_of_real_nonpos
tff(fact_3993_rev__predicate1D,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Q: fun(A,bool)] :
      ( pp(aa(A,bool,P,X3))
     => ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q))
       => pp(aa(A,bool,Q,X3)) ) ) ).

% rev_predicate1D
tff(fact_3994_predicate1D,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),X3: A] :
      ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q))
     => ( pp(aa(A,bool,P,X3))
       => pp(aa(A,bool,Q,X3)) ) ) ).

% predicate1D
tff(fact_3995_zero__complex_Osimps_I2_J,axiom,
    im(zero_zero(complex)) = zero_zero(real) ).

% zero_complex.simps(2)
tff(fact_3996_one__complex_Osimps_I2_J,axiom,
    im(one_one(complex)) = zero_zero(real) ).

% one_complex.simps(2)
tff(fact_3997_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),Z),ring_1_Ints(complex)))
    <=> ( ( im(Z) = zero_zero(real) )
        & ? [I2: int] : ( re(Z) = aa(int,real,ring_1_of_int(real),I2) ) ) ) ).

% complex_is_Int_iff
tff(fact_3998_abs__Im__le__cmod,axiom,
    ! [X3: complex] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),im(X3))),real_V7770717601297561774m_norm(complex,X3))) ).

% abs_Im_le_cmod
tff(fact_3999_times__complex_Osimps_I2_J,axiom,
    ! [X3: complex,Y4: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X3),Y4)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X3)),im(Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X3)),re(Y4))) ) ).

% times_complex.simps(2)
tff(fact_4000_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( aa(real,real,abs_abs(real),re(Z)) = real_V7770717601297561774m_norm(complex,Z) )
     => ( im(Z) = zero_zero(real) ) ) ).

% Im_eq_0
tff(fact_4001_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( re(Z) = zero_zero(real) )
     => ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,abs_abs(real),im(Z)) ) ) ).

% cmod_eq_Im
tff(fact_4002_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( im(Z) = zero_zero(real) )
     => ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,abs_abs(real),re(Z)) ) ) ).

% cmod_eq_Re
tff(fact_4003_cmod__Im__le__iff,axiom,
    ! [X3: complex,Y4: complex] :
      ( ( re(X3) = re(Y4) )
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(complex,X3)),real_V7770717601297561774m_norm(complex,Y4)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),im(X3))),aa(real,real,abs_abs(real),im(Y4)))) ) ) ).

% cmod_Im_le_iff
tff(fact_4004_cmod__Re__le__iff,axiom,
    ! [X3: complex,Y4: complex] :
      ( ( im(X3) = im(Y4) )
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(complex,X3)),real_V7770717601297561774m_norm(complex,Y4)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),re(X3))),aa(real,real,abs_abs(real),re(Y4)))) ) ) ).

% cmod_Re_le_iff
tff(fact_4005_times__complex_Osimps_I1_J,axiom,
    ! [X3: complex,Y4: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X3),Y4)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X3)),re(Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X3)),im(Y4))) ) ).

% times_complex.simps(1)
tff(fact_4006_csqrt__principal,axiom,
    ! [Z: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),re(csqrt(Z))))
      | ( ( re(csqrt(Z)) = zero_zero(real) )
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),im(csqrt(Z)))) ) ) ).

% csqrt_principal
tff(fact_4007_cmod__le,axiom,
    ! [Z: complex] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(complex,Z)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),re(Z))),aa(real,real,abs_abs(real),im(Z))))) ).

% cmod_le
tff(fact_4008_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A3: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),A3)) = im(aa(nat,complex,power_power(complex,cis(A3)),N)) ) ).

% sin_n_Im_cis_pow_n
tff(fact_4009_Re__exp,axiom,
    ! [Z: complex] : ( re(aa(complex,complex,exp(complex),Z)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,exp(real),re(Z))),cos(real,im(Z))) ) ).

% Re_exp
tff(fact_4010_Im__exp,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,exp(complex),Z)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,exp(real),re(Z))),sin(real,im(Z))) ) ).

% Im_exp
tff(fact_4011_complex__eq,axiom,
    ! [A3: complex] : ( A3 = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,re(A3))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,im(A3)))) ) ).

% complex_eq
tff(fact_4012_fun__complex__eq,axiom,
    ! [A: $tType,F2: fun(A,complex),X: A] : ( aa(A,complex,F2,X) = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,re(aa(A,complex,F2,X)))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,im(aa(A,complex,F2,X))))) ) ).

% fun_complex_eq
tff(fact_4013_monoseq__realpow,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => topological_monoseq(real,power_power(real,X3)) ) ) ).

% monoseq_realpow
tff(fact_4014_times__complex_Ocode,axiom,
    ! [X3: complex,Y4: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X3),Y4) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X3)),re(Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X3)),im(Y4))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X3)),im(Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X3)),re(Y4)))) ) ).

% times_complex.code
tff(fact_4015_exp__eq__polar,axiom,
    ! [Z: complex] : ( aa(complex,complex,exp(complex),Z) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,aa(real,real,exp(real),re(Z)))),cis(im(Z))) ) ).

% exp_eq_polar
tff(fact_4016_cmod__power2,axiom,
    ! [Z: complex] : ( aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% cmod_power2
tff(fact_4017_Im__power2,axiom,
    ! [X3: complex] : ( im(aa(nat,complex,power_power(complex,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),re(X3))),im(X3)) ) ).

% Im_power2
tff(fact_4018_Re__power2,axiom,
    ! [X3: complex] : ( re(aa(nat,complex,power_power(complex,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,power_power(real,re(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% Re_power2
tff(fact_4019_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z = zero_zero(complex) )
    <=> ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = zero_zero(real) ) ) ).

% complex_eq_0
tff(fact_4020_norm__complex__def,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% norm_complex_def
tff(fact_4021_inverse__complex_Osimps_I1_J,axiom,
    ! [X3: complex] : ( re(aa(complex,complex,inverse_inverse(complex),X3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(X3)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% inverse_complex.simps(1)
tff(fact_4022_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% complex_neq_0
tff(fact_4023_Re__divide,axiom,
    ! [X3: complex,Y4: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X3),Y4)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X3)),re(Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X3)),im(Y4)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% Re_divide
tff(fact_4024_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),re(B2)))
        | ( ( re(B2) = zero_zero(real) )
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),im(B2))) ) )
     => ( csqrt(aa(nat,complex,power_power(complex,B2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = B2 ) ) ).

% csqrt_square
tff(fact_4025_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( aa(nat,complex,power_power(complex,W),aa(num,nat,numeral_numeral(nat),bit0(one2))) = Z )
     => ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),re(W)))
          | ( ( re(W) = zero_zero(real) )
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),im(W))) ) )
       => ( csqrt(Z) = W ) ) ) ).

% csqrt_unique
tff(fact_4026_inverse__complex_Osimps_I2_J,axiom,
    ! [X3: complex] : ( im(aa(complex,complex,inverse_inverse(complex),X3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),im(X3))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% inverse_complex.simps(2)
tff(fact_4027_Im__divide,axiom,
    ! [X3: complex,Y4: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X3),Y4)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),im(X3)),re(Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),re(X3)),im(Y4)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% Im_divide
tff(fact_4028_complex__abs__le__norm,axiom,
    ! [Z: complex] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),re(Z))),aa(real,real,abs_abs(real),im(Z)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2)))),real_V7770717601297561774m_norm(complex,Z)))) ).

% complex_abs_le_norm
tff(fact_4029_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),real_V7770717601297561774m_norm(complex,Z))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),real_V7770717601297561774m_norm(complex,Z))),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) ) ) ).

% complex_unit_circle
tff(fact_4030_inverse__complex_Ocode,axiom,
    ! [X3: complex] : ( aa(complex,complex,inverse_inverse(complex),X3) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),re(X3)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),im(X3))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% inverse_complex.code
tff(fact_4031_Complex__divide,axiom,
    ! [X3: complex,Y4: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X3),Y4) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X3)),re(Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X3)),im(Y4)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),im(X3)),re(Y4))),aa(real,real,aa(real,fun(real,real),times_times(real),re(X3)),im(Y4)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Y4)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% Complex_divide
tff(fact_4032_pi__series,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) = suminf(real,aTP_Lamp_au(nat,real)) ).

% pi_series
tff(fact_4033_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] : ( im(csqrt(Z)) = aa(real,real,aa(real,fun(real,real),times_times(real),if(real,aa(real,bool,aa(real,fun(real,bool),fequal(real),im(Z)),zero_zero(real)),one_one(real),aa(real,real,sgn_sgn(real),im(Z)))),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ).

% csqrt.simps(2)
tff(fact_4034_arctan__series,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => ( aa(real,real,arctan,X3) = suminf(real,aTP_Lamp_av(real,fun(nat,real),X3)) ) ) ).

% arctan_series
tff(fact_4035_suminf__geometric,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real)))
         => ( suminf(A,power_power(A,C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),C2)) ) ) ) ).

% suminf_geometric
tff(fact_4036_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ( suminf(A,aTP_Lamp_aw(nat,A)) = zero_zero(A) ) ) ).

% suminf_zero
tff(fact_4037_summable__arctan__series,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => summable(real,aTP_Lamp_av(real,fun(nat,real),X3)) ) ).

% summable_arctan_series
tff(fact_4038_Im__Reals__divide,axiom,
    ! [R2: complex,Z: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),R2),real_Vector_Reals(complex)))
     => ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),R2),Z)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),re(R2))),im(Z))),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% Im_Reals_divide
tff(fact_4039_summable__single,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [I: nat,F2: fun(nat,A)] : summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ax(nat,fun(fun(nat,A),fun(nat,A)),I),F2)) ) ).

% summable_single
tff(fact_4040_summable__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => summable(A,aTP_Lamp_ay(nat,A)) ) ).

% summable_zero
tff(fact_4041_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( summable(A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),F2),K))
        <=> summable(A,F2) ) ) ).

% summable_iff_shift
tff(fact_4042_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F2: fun(nat,A)] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(A,fun(fun(nat,A),fun(nat,A)),C2),F2))
        <=> ( ( C2 = zero_zero(A) )
            | summable(A,F2) ) ) ) ).

% summable_cmult_iff
tff(fact_4043_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bb(fun(nat,A),fun(A,fun(nat,A)),F2),C2))
        <=> ( ( C2 = zero_zero(A) )
            | summable(A,F2) ) ) ) ).

% summable_divide_iff
tff(fact_4044_Re__divide__Reals,axiom,
    ! [R2: complex,Z: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),R2),real_Vector_Reals(complex)))
     => ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),R2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),re(R2)) ) ) ).

% Re_divide_Reals
tff(fact_4045_real__eq__imaginary__iff,axiom,
    ! [Y4: complex,X3: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),Y4),real_Vector_Reals(complex)))
     => ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),X3),real_Vector_Reals(complex)))
       => ( ( X3 = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Y4) )
        <=> ( ( X3 = zero_zero(complex) )
            & ( Y4 = zero_zero(complex) ) ) ) ) ) ).

% real_eq_imaginary_iff
tff(fact_4046_imaginary__eq__real__iff,axiom,
    ! [Y4: complex,X3: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),Y4),real_Vector_Reals(complex)))
     => ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),X3),real_Vector_Reals(complex)))
       => ( ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Y4) = X3 )
        <=> ( ( X3 = zero_zero(complex) )
            & ( Y4 = zero_zero(complex) ) ) ) ) ) ).

% imaginary_eq_real_iff
tff(fact_4047_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( summable(A,power_power(A,C2))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))) ) ) ).

% summable_geometric_iff
tff(fact_4048_Im__divide__Reals,axiom,
    ! [R2: complex,Z: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),R2),real_Vector_Reals(complex)))
     => ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),R2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),re(R2)) ) ) ).

% Im_divide_Reals
tff(fact_4049_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),G: fun(nat,A)] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,N2)),aa(nat,A,G,N2)))
         => ( summable(A,F2)
           => ( summable(A,G)
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),suminf(A,F2)),suminf(A,G))) ) ) ) ) ).

% suminf_le
tff(fact_4050_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [G: fun(nat,real),N5: nat,F2: fun(nat,A)] :
          ( summable(real,G)
         => ( ! [N2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N5),N2))
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N2))),aa(nat,real,G,N2))) )
           => summable(A,F2) ) ) ) ).

% summable_comparison_test'
tff(fact_4051_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A),G: fun(nat,real)] :
          ( ? [N8: nat] :
            ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N2))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N2))),aa(nat,real,G,N2))) )
         => ( summable(real,G)
           => summable(A,F2) ) ) ) ).

% summable_comparison_test
tff(fact_4052_Reals__mult,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),real_Vector_Reals(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),real_Vector_Reals(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),real_Vector_Reals(A))) ) ) ) ).

% Reals_mult
tff(fact_4053_Reals__add,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),real_Vector_Reals(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),real_Vector_Reals(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),real_Vector_Reals(A))) ) ) ) ).

% Reals_add
tff(fact_4054_Reals__0,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),zero_zero(A)),real_Vector_Reals(A))) ) ).

% Reals_0
tff(fact_4055_Reals__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(num,A,numeral_numeral(A),W)),real_Vector_Reals(A))) ) ).

% Reals_numeral
tff(fact_4056_Reals__power,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),real_Vector_Reals(A)))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,power_power(A,A3),N)),real_Vector_Reals(A))) ) ) ).

% Reals_power
tff(fact_4057_Reals__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),real_Vector_Reals(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),real_Vector_Reals(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),real_Vector_Reals(A))) ) ) ) ).

% Reals_divide
tff(fact_4058_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1(A)
        & topolo4958980785337419405_space(A) )
     => summable(A,power_power(A,zero_zero(A))) ) ).

% summable_zero_power
tff(fact_4059_summable__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,F2)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_bb(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) ) ) ).

% summable_divide
tff(fact_4060_summable__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F2: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F2)
         => ( summable(A,G)
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bc(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G)) ) ) ) ).

% summable_add
tff(fact_4061_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( summable(A,F2)
         => summable(A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),F2),K)) ) ) ).

% summable_ignore_initial_segment
tff(fact_4062_summable__mult__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F2: fun(nat,A)] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(A,fun(fun(nat,A),fun(nat,A)),C2),F2))
         => ( ( C2 != zero_zero(A) )
           => summable(A,F2) ) ) ) ).

% summable_mult_D
tff(fact_4063_summable__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,F2)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) ) ) ).

% summable_mult2
tff(fact_4064_summable__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,F2)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_be(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) ) ) ).

% summable_mult
tff(fact_4065_summable__const__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [C2: A] :
          ( summable(A,aTP_Lamp_bf(A,fun(nat,A),C2))
        <=> ( C2 = zero_zero(A) ) ) ) ).

% summable_const_iff
tff(fact_4066_suminf__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,F2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,F2)),C2) = suminf(A,aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) ) ) ) ).

% suminf_mult2
tff(fact_4067_suminf__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,F2)
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_be(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),suminf(A,F2)) ) ) ) ).

% suminf_mult
tff(fact_4068_suminf__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F2: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F2)
         => ( summable(A,G)
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),suminf(A,F2)),suminf(A,G)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bc(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G)) ) ) ) ) ).

% suminf_add
tff(fact_4069_suminf__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,F2)
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_bb(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),suminf(A,F2)),C2) ) ) ) ).

% suminf_divide
tff(fact_4070_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [G: fun(nat,complex),N5: nat,F2: fun(nat,A)] :
          ( summable(complex,G)
         => ( ! [N2: nat] : pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),aa(nat,complex,G,N2)),real_Vector_Reals(complex)))
           => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),re(aa(nat,complex,G,N2))))
             => ( ! [N2: nat] :
                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N5),N2))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N2))),real_V7770717601297561774m_norm(complex,aa(nat,complex,G,N2)))) )
               => summable(A,F2) ) ) ) ) ) ).

% series_comparison_complex
tff(fact_4071_powser__insidea,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(nat,A),X3: A,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bg(fun(nat,A),fun(A,fun(nat,A)),F2),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Z)),real_V7770717601297561774m_norm(A,X3)))
           => summable(real,aa(A,fun(nat,real),aTP_Lamp_bh(fun(nat,A),fun(A,fun(nat,real)),F2),Z)) ) ) ) ).

% powser_insidea
tff(fact_4072_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N2)))
           => ( ( suminf(A,F2) = zero_zero(A) )
            <=> ! [N3: nat] : ( aa(nat,A,F2,N3) = zero_zero(A) ) ) ) ) ) ).

% suminf_eq_zero_iff
tff(fact_4073_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N2)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),suminf(A,F2))) ) ) ) ).

% suminf_nonneg
tff(fact_4074_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,F2,N2)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),suminf(A,F2))) ) ) ) ).

% suminf_pos
tff(fact_4075_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [F2: fun(nat,A)] : summable(A,aTP_Lamp_bi(fun(nat,A),fun(nat,A),F2)) ) ).

% summable_zero_power'
tff(fact_4076_summable__0__powser,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(nat,A)] : summable(A,aTP_Lamp_bj(fun(nat,A),fun(nat,A),F2)) ) ).

% summable_0_powser
tff(fact_4077_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bk(fun(nat,A),fun(A,fun(nat,A)),F2),Z))
        <=> summable(A,aa(A,fun(nat,A),aTP_Lamp_bg(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) ) ) ).

% summable_powser_split_head
tff(fact_4078_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bl(fun(nat,A),fun(A,fun(nat,A)),F2),Z))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_bm(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) ) ) ).

% powser_split_head(3)
tff(fact_4079_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(nat,A),M: nat,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_bn(fun(nat,A),fun(nat,fun(A,fun(nat,A))),F2),M),Z))
        <=> summable(A,aa(A,fun(nat,A),aTP_Lamp_bg(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) ) ) ).

% summable_powser_ignore_initial_segment
tff(fact_4080_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),G: fun(nat,real)] :
          ( ? [N8: nat] :
            ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N2))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N2))),aa(nat,real,G,N2))) )
         => ( summable(real,G)
           => summable(real,aTP_Lamp_bo(fun(nat,A),fun(nat,real),F2)) ) ) ) ).

% summable_norm_comparison_test
tff(fact_4081_summable__rabs__comparison__test,axiom,
    ! [F2: fun(nat,real),G: fun(nat,real)] :
      ( ? [N8: nat] :
        ! [N2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N2))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(nat,real,F2,N2))),aa(nat,real,G,N2))) )
     => ( summable(real,G)
       => summable(real,aTP_Lamp_bp(fun(nat,real),fun(nat,real),F2)) ) ) ).

% summable_rabs_comparison_test
tff(fact_4082_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),Z),real_Vector_Reals(complex)))
    <=> ( im(Z) = zero_zero(real) ) ) ).

% complex_is_Real_iff
tff(fact_4083_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),real_Vector_Reals(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),real_Vector_Reals(A)))
           => ( ( B2 != zero_zero(A) )
             => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),real_Vector_Reals(A))) ) ) ) ) ).

% nonzero_Reals_divide
tff(fact_4084_Complex__in__Reals,axiom,
    ! [X3: real] : pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),complex2(X3,zero_zero(real))),real_Vector_Reals(complex))) ).

% Complex_in_Reals
tff(fact_4085_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [A3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),real_Vector_Reals(A)))
         => ( ( A3 != zero_zero(A) )
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,inverse_inverse(A),A3)),real_Vector_Reals(A))) ) ) ) ).

% nonzero_Reals_inverse
tff(fact_4086_summable__rabs,axiom,
    ! [F2: fun(nat,real)] :
      ( summable(real,aTP_Lamp_bp(fun(nat,real),fun(nat,real),F2))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),suminf(real,F2))),suminf(real,aTP_Lamp_bp(fun(nat,real),fun(nat,real),F2)))) ) ).

% summable_rabs
tff(fact_4087_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N2)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),suminf(A,F2)))
            <=> ? [I2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,F2,I2))) ) ) ) ) ).

% suminf_pos_iff
tff(fact_4088_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),I: nat] :
          ( summable(A,F2)
         => ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N2)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,F2,I)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),suminf(A,F2))) ) ) ) ) ).

% suminf_pos2
tff(fact_4089_summable__geometric,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real)))
         => summable(A,power_power(A,C2)) ) ) ).

% summable_geometric
tff(fact_4090_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),one_one(real)))
         => summable(A,power_power(A,X3)) ) ) ).

% complete_algebra_summable_geometric
tff(fact_4091_suminf__split__head,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( suminf(A,aTP_Lamp_bq(fun(nat,A),fun(nat,A),F2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F2)),aa(nat,A,F2,zero_zero(nat))) ) ) ) ).

% suminf_split_head
tff(fact_4092_summable__norm,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_br(fun(nat,A),fun(nat,real),F2))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,suminf(A,F2))),suminf(real,aTP_Lamp_br(fun(nat,A),fun(nat,real),F2)))) ) ) ).

% summable_norm
tff(fact_4093_powser__inside,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(nat,A),X3: A,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bl(fun(nat,A),fun(A,fun(nat,A)),F2),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Z)),real_V7770717601297561774m_norm(A,X3)))
           => summable(A,aa(A,fun(nat,A),aTP_Lamp_bl(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) ) ) ) ).

% powser_inside
tff(fact_4094_summable__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : summable(A,aTP_Lamp_bs(A,fun(nat,A),X3)) ) ).

% summable_exp
tff(fact_4095_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bl(fun(nat,A),fun(A,fun(nat,A)),F2),Z))
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_bl(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,F2,zero_zero(nat))),aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_bm(fun(nat,A),fun(A,fun(nat,A)),F2),Z))),Z)) ) ) ) ).

% powser_split_head(1)
tff(fact_4096_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bl(fun(nat,A),fun(A,fun(nat,A)),F2),Z))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_bm(fun(nat,A),fun(A,fun(nat,A)),F2),Z))),Z) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_bl(fun(nat,A),fun(A,fun(nat,A)),F2),Z))),aa(nat,A,F2,zero_zero(nat))) ) ) ) ).

% powser_split_head(2)
tff(fact_4097_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R2: real,F2: fun(nat,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R2))
         => ( summable(A,F2)
           => ? [N9: nat] :
              ! [N7: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N9),N7))
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,suminf(A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),F2),N7)))),R2)) ) ) ) ) ).

% suminf_exist_split
tff(fact_4098_summable__power__series,axiom,
    ! [F2: fun(nat,real),Z: real] :
      ( ! [I3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,F2,I3)),one_one(real)))
     => ( ! [I3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,I3)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Z))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Z),one_one(real)))
           => summable(real,aa(real,fun(nat,real),aTP_Lamp_bt(fun(nat,real),fun(real,fun(nat,real)),F2),Z)) ) ) ) ) ).

% summable_power_series
tff(fact_4099_Abel__lemma,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R2: real,R0: real,A3: fun(nat,A),M7: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),R2))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),R2),R0))
           => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,aa(nat,A,A3,N2))),aa(nat,real,power_power(real,R0),N2))),M7))
             => summable(real,aa(fun(nat,A),fun(nat,real),aTP_Lamp_bu(real,fun(fun(nat,A),fun(nat,real)),R2),A3)) ) ) ) ) ).

% Abel_lemma
tff(fact_4100_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [C2: real,N5: nat,F2: fun(nat,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),one_one(real)))
         => ( ! [N2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N5),N2))
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,aa(nat,nat,suc,N2)))),aa(real,real,aa(real,fun(real,real),times_times(real),C2),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N2))))) )
           => summable(A,F2) ) ) ) ).

% summable_ratio_test
tff(fact_4101_Re__Reals__divide,axiom,
    ! [R2: complex,Z: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),R2),real_Vector_Reals(complex)))
     => ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),R2),Z)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(R2)),re(Z))),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% Re_Reals_divide
tff(fact_4102_sin__paired,axiom,
    ! [X3: real] : sums(real,aTP_Lamp_bv(real,fun(nat,real),X3),sin(real,X3)) ).

% sin_paired
tff(fact_4103_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_VEBT_membermima(X3,Xa)
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [Uu2: bool,Uv2: bool] :
              ( ( X3 = vEBT_Leaf(Uu2,Uv2) )
             => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa))) )
         => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
               => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Xa))) )
           => ( ! [Mi: nat,Ma2: nat,Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
                  ( ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
                 => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2)),Xa)))
                   => ( ( Xa = Mi )
                      | ( Xa = Ma2 ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                    ( ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc) )
                   => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc)),Xa)))
                     => ( ( Xa = Mi )
                        | ( Xa = Ma2 )
                        | ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                           => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) )
               => ~ ! [V3: nat,TreeList2: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                      ( ( X3 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd) )
                     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd)),Xa)))
                       => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                           => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
tff(fact_4104_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y4: bool] :
      ( ( vEBT_VEBT_membermima(X3,Xa)
      <=> pp(Y4) )
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [Uu2: bool,Uv2: bool] :
              ( ( X3 = vEBT_Leaf(Uu2,Uv2) )
             => ( ~ pp(Y4)
               => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa))) ) )
         => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
               => ( ~ pp(Y4)
                 => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Xa))) ) )
           => ( ! [Mi: nat,Ma2: nat,Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
                  ( ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
                 => ( ( pp(Y4)
                    <=> ( ( Xa = Mi )
                        | ( Xa = Ma2 ) ) )
                   => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2)),Xa))) ) )
             => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                    ( ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc) )
                   => ( ( pp(Y4)
                      <=> ( ( Xa = Mi )
                          | ( Xa = Ma2 )
                          | ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                             => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) )
                     => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc)),Xa))) ) )
               => ~ ! [V3: nat,TreeList2: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                      ( ( X3 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd) )
                     => ( ( pp(Y4)
                        <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                             => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) )
                       => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd)),Xa))) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
tff(fact_4105_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Z)),one_one(real)))
         => sums(A,aTP_Lamp_bw(A,fun(nat,A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% geometric_deriv_sums
tff(fact_4106_sums__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => sums(A,aTP_Lamp_ay(nat,A),zero_zero(A)) ) ).

% sums_zero
tff(fact_4107_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A3: fun(nat,A),X3: A] :
          ( sums(A,aTP_Lamp_bj(fun(nat,A),fun(nat,A),A3),X3)
        <=> ( aa(nat,A,A3,zero_zero(nat)) = X3 ) ) ) ).

% powser_sums_zero_iff
tff(fact_4108_sums__le,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),G: fun(nat,A),S: A,T2: A] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,N2)),aa(nat,A,G,N2)))
         => ( sums(A,F2,S)
           => ( sums(A,G,T2)
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),S),T2)) ) ) ) ) ).

% sums_le
tff(fact_4109_sums__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F2: fun(nat,A)] :
          ( ! [N2: nat] : ( aa(nat,A,F2,N2) = zero_zero(A) )
         => sums(A,F2,zero_zero(A)) ) ) ).

% sums_0
tff(fact_4110_sums__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),A3: A,C2: A] :
          ( sums(A,F2,A3)
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_bb(fun(nat,A),fun(A,fun(nat,A)),F2),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)) ) ) ).

% sums_divide
tff(fact_4111_sums__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F2: fun(nat,A),A3: A,G: fun(nat,A),B2: A] :
          ( sums(A,F2,A3)
         => ( sums(A,G,B2)
           => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bc(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) ) ) ) ).

% sums_add
tff(fact_4112_sums__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(nat,A),A3: A,C2: A] :
          ( sums(A,F2,A3)
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),F2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% sums_mult2
tff(fact_4113_sums__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(nat,A),A3: A,C2: A] :
          ( sums(A,F2,A3)
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_be(fun(nat,A),fun(A,fun(nat,A)),F2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)) ) ) ).

% sums_mult
tff(fact_4114_sums__single,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [I: nat,F2: fun(nat,A)] : sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ax(nat,fun(fun(nat,A),fun(nat,A)),I),F2),aa(nat,A,F2,I)) ) ).

% sums_single
tff(fact_4115_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [C2: A,F2: fun(nat,A),D2: A] :
          ( ( C2 != zero_zero(A) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bx(A,fun(fun(nat,A),fun(nat,A)),C2),F2),aa(A,A,aa(A,fun(A,A),times_times(A),D2),C2))
          <=> sums(A,F2,D2) ) ) ) ).

% sums_mult2_iff
tff(fact_4116_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [C2: A,F2: fun(nat,A),D2: A] :
          ( ( C2 != zero_zero(A) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_by(A,fun(fun(nat,A),fun(nat,A)),C2),F2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2))
          <=> sums(A,F2,D2) ) ) ) ).

% sums_mult_iff
tff(fact_4117_sums__mult__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F2: fun(nat,A),A3: A] :
          ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(A,fun(fun(nat,A),fun(nat,A)),C2),F2),A3)
         => ( ( C2 != zero_zero(A) )
           => sums(A,F2,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),C2)) ) ) ) ).

% sums_mult_D
tff(fact_4118_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),S: A] :
          ( ( aa(nat,A,F2,zero_zero(nat)) = zero_zero(A) )
         => ( sums(A,aTP_Lamp_bq(fun(nat,A),fun(nat,A),F2),S)
           => sums(A,F2,S) ) ) ) ).

% sums_Suc_imp
tff(fact_4119_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F2: fun(nat,A),L: A] :
          ( sums(A,aTP_Lamp_bz(fun(nat,A),fun(nat,A),F2),L)
         => sums(A,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),L),aa(nat,A,F2,zero_zero(nat)))) ) ) ).

% sums_Suc
tff(fact_4120_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),S: A] :
          ( sums(A,aTP_Lamp_bq(fun(nat,A),fun(nat,A),F2),S)
        <=> sums(A,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),S),aa(nat,A,F2,zero_zero(nat)))) ) ) ).

% sums_Suc_iff
tff(fact_4121_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [N: nat,F2: fun(nat,A),S: A] :
          ( ! [I3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),N))
             => ( aa(nat,A,F2,I3) = zero_zero(A) ) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ca(nat,fun(fun(nat,A),fun(nat,A)),N),F2),S)
          <=> sums(A,F2,S) ) ) ) ).

% sums_zero_iff_shift
tff(fact_4122_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [M: nat,Z: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_cb(nat,fun(A,fun(nat,A)),M),Z),aa(nat,A,power_power(A,Z),M)) ) ).

% powser_sums_if
tff(fact_4123_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A3: fun(nat,A)] : sums(A,aTP_Lamp_bj(fun(nat,A),fun(nat,A),A3),aa(nat,A,A3,zero_zero(nat))) ) ).

% powser_sums_zero
tff(fact_4124_geometric__sums,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real)))
         => sums(A,power_power(A,C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),C2))) ) ) ).

% geometric_sums
tff(fact_4125_power__half__series,axiom,
    sums(real,aTP_Lamp_cc(nat,real),one_one(real)) ).

% power_half_series
tff(fact_4126_sums__if_H,axiom,
    ! [G: fun(nat,real),X3: real] :
      ( sums(real,G,X3)
     => sums(real,aTP_Lamp_cd(fun(nat,real),fun(nat,real),G),X3) ) ).

% sums_if'
tff(fact_4127_sums__if,axiom,
    ! [G: fun(nat,real),X3: real,F2: fun(nat,real),Y4: real] :
      ( sums(real,G,X3)
     => ( sums(real,F2,Y4)
       => sums(real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_ce(fun(nat,real),fun(fun(nat,real),fun(nat,real)),G),F2),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)) ) ) ).

% sums_if
tff(fact_4128_cos__paired,axiom,
    ! [X3: real] : sums(real,aTP_Lamp_cf(real,fun(nat,real),X3),cos(real,X3)) ).

% cos_paired
tff(fact_4129_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_membermima(X3,Xa)
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [Mi: nat,Ma2: nat,Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
              ( ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
             => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va3,Vb2)),Xa)))
               => ~ ( ( Xa = Mi )
                    | ( Xa = Ma2 ) ) ) )
         => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc) )
               => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V3),TreeList2,Vc)),Xa)))
                 => ~ ( ( Xa = Mi )
                      | ( Xa = Ma2 )
                      | ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                         => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) )
           => ~ ! [V3: nat,TreeList2: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                  ( ( X3 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd) )
                 => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList2,Vd)),Xa)))
                   => ~ ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                         => vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
tff(fact_4130_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y4: bool] :
      ( ( vEBT_V5719532721284313246member(X3,Xa)
      <=> pp(Y4) )
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [A5: bool,B5: bool] :
              ( ( X3 = vEBT_Leaf(A5,B5) )
             => ( ( pp(Y4)
                <=> ( ( ( Xa = zero_zero(nat) )
                     => pp(A5) )
                    & ( ( Xa != zero_zero(nat) )
                     => ( ( ( Xa = one_one(nat) )
                         => pp(B5) )
                        & ( Xa = one_one(nat) ) ) ) ) )
               => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A5,B5)),Xa))) ) )
         => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
               => ( ~ pp(Y4)
                 => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Xa))) ) )
           => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList2: list(vEBT_VEBT),S3: vEBT_VEBT] :
                  ( ( X3 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3) )
                 => ( ( pp(Y4)
                    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                         => vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) )
                   => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3)),Xa))) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
tff(fact_4131_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( vEBT_V5719532721284313246member(X3,Xa)
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [A5: bool,B5: bool] :
              ( ( X3 = vEBT_Leaf(A5,B5) )
             => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A5,B5)),Xa)))
               => ~ ( ( ( Xa = zero_zero(nat) )
                     => pp(A5) )
                    & ( ( Xa != zero_zero(nat) )
                     => ( ( ( Xa = one_one(nat) )
                         => pp(B5) )
                        & ( Xa = one_one(nat) ) ) ) ) ) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList2: list(vEBT_VEBT),S3: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3) )
               => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3)),Xa)))
                 => ~ ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                       => vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
tff(fact_4132_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_V5719532721284313246member(X3,Xa)
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [A5: bool,B5: bool] :
              ( ( X3 = vEBT_Leaf(A5,B5) )
             => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A5,B5)),Xa)))
               => ( ( ( Xa = zero_zero(nat) )
                   => pp(A5) )
                  & ( ( Xa != zero_zero(nat) )
                   => ( ( ( Xa = one_one(nat) )
                       => pp(B5) )
                      & ( Xa = one_one(nat) ) ) ) ) ) )
         => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
               => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Xa))) )
           => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList2: list(vEBT_VEBT),S3: vEBT_VEBT] :
                  ( ( X3 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3) )
                 => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList2,S3)),Xa)))
                   => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)))
                       => vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2))) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
tff(fact_4133_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [C2: fun(nat,A),X3: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cg(fun(nat,A),fun(A,fun(nat,A)),C2),X3))
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),C2),X3),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cg(fun(nat,A),fun(A,fun(nat,A)),C2),X3))) ) ) ).

% diffs_equiv
tff(fact_4134_diffs__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [C2: fun(nat,A),X: nat] : ( aa(nat,A,diffs(A,C2),X) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,X))),aa(nat,A,C2,aa(nat,nat,suc,X))) ) ) ).

% diffs_def
tff(fact_4135_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X3: A] :
          ( ! [X2: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),X2))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),X3)) ) ) ).

% termdiff_converges_all
tff(fact_4136_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,K5: real,C2: fun(nat,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),K5))
         => ( ! [X2: A] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X2)),K5))
               => summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),X2)) )
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ck(A,fun(fun(nat,A),fun(nat,A)),X3),C2)) ) ) ) ).

% termdiff_converges
tff(fact_4137_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,exp(A),X3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),X3)),suminf(A,aTP_Lamp_cl(A,fun(nat,A),X3))) ) ) ).

% exp_first_two_terms
tff(fact_4138_monoI1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [M3: nat,N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M3),N2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,M3)),aa(nat,A,X7,N2))) )
         => topological_monoseq(A,X7) ) ) ).

% monoI1
tff(fact_4139_monoI2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [M3: nat,N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M3),N2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N2)),aa(nat,A,X7,M3))) )
         => topological_monoseq(A,X7) ) ) ).

% monoI2
tff(fact_4140_monoseq__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( topological_monoseq(A,X7)
        <=> ( ! [M6: nat,N3: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M6),N3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,M6)),aa(nat,A,X7,N3))) )
            | ! [M6: nat,N3: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M6),N3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N3)),aa(nat,A,X7,M6))) ) ) ) ) ).

% monoseq_def
tff(fact_4141_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: real,X3: A,B2: real] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A3),X3) = aa(A,A,real_V8093663219630862766scaleR(A,B2),X3) )
        <=> ( ( A3 = B2 )
            | ( X3 = zero_zero(A) ) ) ) ) ).

% scaleR_cancel_right
tff(fact_4142_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: real] : ( aa(A,A,real_V8093663219630862766scaleR(A,A3),zero_zero(A)) = zero_zero(A) ) ) ).

% scaleR_zero_right
tff(fact_4143_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V6157519004096292374lgebra(A)
     => ! [X3: A,A3: real,Y4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),X3),aa(A,A,real_V8093663219630862766scaleR(A,A3),Y4)) = aa(A,A,real_V8093663219630862766scaleR(A,A3),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4)) ) ) ).

% mult_scaleR_right
tff(fact_4144_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( real_V6157519004096292374lgebra(A)
     => ! [A3: real,X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),Y4) = aa(A,A,real_V8093663219630862766scaleR(A,A3),aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4)) ) ) ).

% mult_scaleR_left
tff(fact_4145_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: real,X3: A,Y4: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A3),X3) = aa(A,A,real_V8093663219630862766scaleR(A,A3),Y4) )
        <=> ( ( X3 = Y4 )
            | ( A3 = zero_zero(real) ) ) ) ) ).

% scaleR_cancel_left
tff(fact_4146_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: real,B2: real,X3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A3),aa(A,A,real_V8093663219630862766scaleR(A,B2),X3)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),times_times(real),A3),B2)),X3) ) ) ).

% scaleR_scaleR
tff(fact_4147_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,zero_zero(real)),X3) = zero_zero(A) ) ) ).

% scaleR_zero_left
tff(fact_4148_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: real,X3: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A3),X3) = zero_zero(A) )
        <=> ( ( A3 = zero_zero(real) )
            | ( X3 = zero_zero(A) ) ) ) ) ).

% scaleR_eq_0_iff
tff(fact_4149_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: A,U: real,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,U),A3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,real_V8093663219630862766scaleR(A,U),B2)) )
        <=> ( ( A3 = B2 )
            | ( U = one_one(real) ) ) ) ) ).

% scaleR_eq_iff
tff(fact_4150_scaleR__power,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X3: real,Y4: A,N: nat] : ( aa(nat,A,power_power(A,aa(A,A,real_V8093663219630862766scaleR(A,X3),Y4)),N) = aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,power_power(real,X3),N)),aa(nat,A,power_power(A,Y4),N)) ) ) ).

% scaleR_power
tff(fact_4151_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [U: real,A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),U)),A3)),aa(A,A,real_V8093663219630862766scaleR(A,U),A3)) = A3 ) ) ).

% scaleR_collapse
tff(fact_4152_norm__scaleR,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: real,X3: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,abs_abs(real),A3)),real_V7770717601297561774m_norm(A,X3)) ) ) ).

% norm_scaleR
tff(fact_4153_scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [U: num,W: num,A3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(num,real,numeral_numeral(real),U)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A3)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),W))),A3) ) ) ).

% scaleR_times
tff(fact_4154_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [V: num,W: num,A3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A3)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),W)),aa(num,real,numeral_numeral(real),V))),A3) ) ) ).

% inverse_scaleR_times
tff(fact_4155_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [U: num,V: num,W: num,A3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A3)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),W))),aa(num,real,numeral_numeral(real),V))),A3) ) ) ).

% fraction_scaleR_times
tff(fact_4156_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)) = A3 ) ) ).

% scaleR_half_double
tff(fact_4157_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: real,X3: A,Y4: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,A3),Y4)) ) ) ).

% scaleR_right_distrib
tff(fact_4158_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: A,A3: real,B2: real] :
          ( ( X3 != zero_zero(A) )
         => ( ( aa(A,A,real_V8093663219630862766scaleR(A,A3),X3) = aa(A,A,real_V8093663219630862766scaleR(A,B2),X3) )
           => ( A3 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
tff(fact_4159_real__scaleR__def,axiom,
    ! [A3: real,X3: real] : ( aa(real,real,real_V8093663219630862766scaleR(real,A3),X3) = aa(real,real,aa(real,fun(real,real),times_times(real),A3),X3) ) ).

% real_scaleR_def
tff(fact_4160_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: real,X3: A,Y4: A] :
          ( ( A3 != zero_zero(real) )
         => ( ( aa(A,A,real_V8093663219630862766scaleR(A,A3),X3) = aa(A,A,real_V8093663219630862766scaleR(A,A3),Y4) )
           => ( X3 = Y4 ) ) ) ) ).

% scaleR_left_imp_eq
tff(fact_4161_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: real,B2: real,X3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),A3),B2)),X3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X3)) ) ) ).

% scaleR_left_distrib
tff(fact_4162_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: real,Y4: real,Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),Y4)),Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,X3),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,Y4),Xa)) ) ) ).

% scaleR_left.add
tff(fact_4163_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [R2: real,X3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,R2),X3) = aa(A,A,aa(A,fun(A,A),times_times(A),real_Vector_of_real(A,R2)),X3) ) ) ).

% scaleR_conv_of_real
tff(fact_4164_scaleR__complex_Osimps_I1_J,axiom,
    ! [R2: real,X3: complex] : ( re(aa(complex,complex,real_V8093663219630862766scaleR(complex,R2),X3)) = aa(real,real,aa(real,fun(real,real),times_times(real),R2),re(X3)) ) ).

% scaleR_complex.simps(1)
tff(fact_4165_scaleR__complex_Osimps_I2_J,axiom,
    ! [R2: real,X3: complex] : ( im(aa(complex,complex,real_V8093663219630862766scaleR(complex,R2),X3)) = aa(real,real,aa(real,fun(real,real),times_times(real),R2),im(X3)) ) ).

% scaleR_complex.simps(2)
tff(fact_4166_complex__scaleR,axiom,
    ! [R2: real,A3: real,B2: real] : ( aa(complex,complex,real_V8093663219630862766scaleR(complex,R2),complex2(A3,B2)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R2),A3),aa(real,real,aa(real,fun(real,real),times_times(real),R2),B2)) ) ).

% complex_scaleR
tff(fact_4167_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [B2: real,A3: real,C2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),C2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),C2))) ) ) ) ).

% scaleR_right_mono_neg
tff(fact_4168_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,B2: real,X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X3))) ) ) ) ).

% scaleR_right_mono
tff(fact_4169_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% scaleR_le_cancel_left_pos
tff(fact_4170_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% scaleR_le_cancel_left_neg
tff(fact_4171_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2)))
        <=> ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            & ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% scaleR_le_cancel_left
tff(fact_4172_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [B2: A,A3: A,C2: real] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),C2),zero_zero(real)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))) ) ) ) ).

% scaleR_left_mono_neg
tff(fact_4173_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [X3: A,Y4: A,A3: real] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,A3),Y4))) ) ) ) ).

% scaleR_left_mono
tff(fact_4174_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: A,U: real,V: real,A3: A] :
          ( ( X3 = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),U),V)),A3) )
        <=> ( ( ( V = zero_zero(real) )
             => ( X3 = zero_zero(A) ) )
            & ( ( V != zero_zero(real) )
             => ( aa(A,A,real_V8093663219630862766scaleR(A,V),X3) = aa(A,A,real_V8093663219630862766scaleR(A,U),A3) ) ) ) ) ) ).

% eq_vector_fraction_iff
tff(fact_4175_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [U: real,V: real,A3: A,X3: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),U),V)),A3) = X3 )
        <=> ( ( ( V = zero_zero(real) )
             => ( X3 = zero_zero(A) ) )
            & ( ( V != zero_zero(real) )
             => ( aa(A,A,real_V8093663219630862766scaleR(A,U),A3) = aa(A,A,real_V8093663219630862766scaleR(A,V),X3) ) ) ) ) ) ).

% vector_fraction_eq_iff
tff(fact_4176_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,E: A,C2: A,B2: real,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,B2),E)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A3),B2)),E)),C2)),D2)) ) ) ).

% Real_Vector_Spaces.le_add_iff1
tff(fact_4177_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,E: A,C2: A,B2: real,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,B2),E)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)),E)),D2))) ) ) ).

% Real_Vector_Spaces.le_add_iff2
tff(fact_4178_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A3),B2)))
        <=> ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) )
            | ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),zero_zero(real)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) )
            | ( A3 = zero_zero(real) ) ) ) ) ).

% zero_le_scaleR_iff
tff(fact_4179_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),B2)),zero_zero(A)))
        <=> ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) )
            | ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),zero_zero(real)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) )
            | ( A3 = zero_zero(real) ) ) ) ) ).

% scaleR_le_0_iff
tff(fact_4180_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A3),B2))) ) ) ) ).

% scaleR_nonpos_nonpos
tff(fact_4181_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),zero_zero(A))) ) ) ) ).

% scaleR_nonpos_nonneg
tff(fact_4182_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),zero_zero(A))) ) ) ) ).

% scaleR_nonneg_nonpos
tff(fact_4183_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3))) ) ) ) ).

% scaleR_nonneg_nonneg
tff(fact_4184_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,B2: A] :
          ( ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) )
            | ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),zero_zero(real)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A3),B2))) ) ) ).

% split_scaleR_pos_le
tff(fact_4185_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,X3: A] :
          ( ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),zero_zero(A))) )
            | ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),zero_zero(real)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),zero_zero(A))) ) ) ).

% split_scaleR_neg_le
tff(fact_4186_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,B2: real,C2: A,D2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),C2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),D2))) ) ) ) ) ) ).

% scaleR_mono'
tff(fact_4187_scaleR__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A3: real,B2: real,X3: A,Y4: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),B2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Y4))) ) ) ) ) ) ).

% scaleR_mono
tff(fact_4188_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [X3: A,A3: real] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),one_one(real)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),X3)) ) ) ) ).

% scaleR_left_le_one_le
tff(fact_4189_scaleR__2,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(num,real,numeral_numeral(real),bit0(one2))),X3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),X3) ) ) ).

% scaleR_2
tff(fact_4190_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [M: real,X3: A,C2: A,Y4: A] :
          ( ( M != zero_zero(real) )
         => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,M),X3)),C2) = Y4 )
          <=> ( X3 = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),Y4)),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),C2)) ) ) ) ) ).

% real_vector_affinity_eq
tff(fact_4191_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [M: real,Y4: A,X3: A,C2: A] :
          ( ( M != zero_zero(real) )
         => ( ( Y4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,M),X3)),C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),Y4)),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),C2)) = X3 ) ) ) ) ).

% real_vector_eq_affinity
tff(fact_4192_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3))) ) ) ) ).

% neg_le_divideR_eq
tff(fact_4193_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),B2)) ) ) ) ).

% neg_divideR_le_eq
tff(fact_4194_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),B2)) ) ) ) ).

% pos_le_divideR_eq
tff(fact_4195_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3))) ) ) ) ).

% pos_divideR_le_eq
tff(fact_4196_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3))) ) ) ) ).

% neg_less_divideR_eq
tff(fact_4197_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),B2)) ) ) ) ).

% neg_divideR_less_eq
tff(fact_4198_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),B2)) ) ) ) ).

% pos_less_divideR_eq
tff(fact_4199_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3))) ) ) ) ).

% pos_divideR_less_eq
tff(fact_4200_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [A3: real,X3: A] :
          ( ( A3 != zero_zero(real) )
         => ( ( X3 != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),A3)),aa(A,A,inverse_inverse(A),X3)) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
tff(fact_4201_scaleR__complex_Ocode,axiom,
    ! [R2: real,X3: complex] : ( aa(complex,complex,real_V8093663219630862766scaleR(complex,R2),X3) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R2),re(X3)),aa(real,real,aa(real,fun(real,real),times_times(real),R2),im(X3))) ) ).

% scaleR_complex.code
tff(fact_4202_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : summable(A,aTP_Lamp_cm(A,fun(nat,A),X3)) ) ).

% summable_exp_generic
tff(fact_4203_sin__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : sums(A,aTP_Lamp_cn(A,fun(nat,A),X3),sin(A,X3)) ) ).

% sin_converges
tff(fact_4204_sin__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( sin(A,X) = suminf(A,aTP_Lamp_cn(A,fun(nat,A),X)) ) ) ).

% sin_def
tff(fact_4205_cos__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : sums(A,aTP_Lamp_co(A,fun(nat,A),X3),cos(A,X3)) ) ).

% cos_converges
tff(fact_4206_cos__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( cos(A,X) = suminf(A,aTP_Lamp_co(A,fun(nat,A),X)) ) ) ).

% cos_def
tff(fact_4207_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : summable(real,aTP_Lamp_cp(A,fun(nat,real),X3)) ) ).

% summable_norm_sin
tff(fact_4208_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : summable(real,aTP_Lamp_cq(A,fun(nat,real),X3)) ) ).

% summable_norm_cos
tff(fact_4209_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% pos_le_minus_divideR_eq
tff(fact_4210_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3))) ) ) ) ).

% pos_minus_divideR_le_eq
tff(fact_4211_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3))) ) ) ) ).

% neg_le_minus_divideR_eq
tff(fact_4212_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% neg_minus_divideR_le_eq
tff(fact_4213_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% pos_less_minus_divideR_eq
tff(fact_4214_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3))) ) ) ) ).

% pos_minus_divideR_less_eq
tff(fact_4215_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A3: A,B2: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3))) ) ) ) ).

% neg_less_minus_divideR_eq
tff(fact_4216_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A3)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% neg_minus_divideR_less_eq
tff(fact_4217_exp__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : sums(A,aTP_Lamp_cm(A,fun(nat,A),X3),aa(A,A,exp(A),X3)) ) ).

% exp_converges
tff(fact_4218_exp__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,exp(A),X) = suminf(A,aTP_Lamp_cm(A,fun(nat,A),X)) ) ) ).

% exp_def
tff(fact_4219_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : summable(real,aTP_Lamp_cr(A,fun(nat,real),X3)) ) ).

% summable_norm_exp
tff(fact_4220_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : sums(A,aTP_Lamp_cs(A,fun(nat,A),X3),sin(A,X3)) ) ).

% sin_minus_converges
tff(fact_4221_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : sums(A,aTP_Lamp_ct(A,fun(nat,A),X3),cos(A,X3)) ) ).

% cos_minus_converges
tff(fact_4222_cosh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( cosh(A,X3) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),X3)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X3)))) ) ) ).

% cosh_def
tff(fact_4223_sinh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( sinh(A,X3) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),X3)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X3)))) ) ) ).

% sinh_def
tff(fact_4224_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,exp(A),X3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),suminf(A,aTP_Lamp_cu(A,fun(nat,A),X3))) ) ) ).

% exp_first_term
tff(fact_4225_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : sums(A,aTP_Lamp_cv(A,fun(nat,A),X3),cosh(A,X3)) ) ).

% cosh_converges
tff(fact_4226_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : sums(A,aTP_Lamp_cw(A,fun(nat,A),X3),sinh(A,X3)) ) ).

% sinh_converges
tff(fact_4227_mono__SucI1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N2)),aa(nat,A,X7,aa(nat,nat,suc,N2))))
         => topological_monoseq(A,X7) ) ) ).

% mono_SucI1
tff(fact_4228_mono__SucI2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N2))),aa(nat,A,X7,N2)))
         => topological_monoseq(A,X7) ) ) ).

% mono_SucI2
tff(fact_4229_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( topological_monoseq(A,X7)
        <=> ( ! [N3: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N3)),aa(nat,A,X7,aa(nat,nat,suc,N3))))
            | ! [N3: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N3))),aa(nat,A,X7,N3))) ) ) ) ).

% monoseq_Suc
tff(fact_4230_of__nat__code,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),N) = semiri8178284476397505188at_aux(A,aTP_Lamp_cx(A,A),N,zero_zero(A)) ) ) ).

% of_nat_code
tff(fact_4231_Arg__def,axiom,
    ! [Z: complex] :
      ( ( ( Z = zero_zero(complex) )
       => ( arg(Z) = zero_zero(real) ) )
      & ( ( Z != zero_zero(complex) )
       => ( arg(Z) = fChoice(real,aTP_Lamp_cy(complex,fun(real,bool),Z)) ) ) ) ).

% Arg_def
tff(fact_4232_set__vebt__def,axiom,
    ! [T2: vEBT_VEBT] : ( vEBT_set_vebt(T2) = collect(nat,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,T2)) ) ).

% set_vebt_def
tff(fact_4233_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_da(A,fun(A,fun(nat,A)),X3),Y4),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X3)),sin(A,Y4))) ) ).

% sin_x_sin_y
tff(fact_4234_atMost__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,K: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),set_ord_atMost(A,K)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),K)) ) ) ).

% atMost_iff
tff(fact_4235_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(B)
     => ! [A2: set(A),F2: fun(A,B)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
             => pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),aa(A,B,F2,X2)),ring_1_Ints(B))) )
         => pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A2)),ring_1_Ints(B))) ) ) ).

% Ints_sum
tff(fact_4236_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [F2: fun(B,nat),A2: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_db(fun(B,nat),fun(B,A),F2)),A2) ) ) ).

% of_nat_sum
tff(fact_4237_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [F2: fun(B,int),A2: set(B)] : ( aa(int,A,ring_1_of_int(A),aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7311177749621191930dd_sum(B,int),F2),A2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_dc(fun(B,int),fun(B,A),F2)),A2) ) ) ).

% of_int_sum
tff(fact_4238_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_atMost(A,X3)),set_ord_atMost(A,Y4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ).

% atMost_subset_iff
tff(fact_4239_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% sum.atMost_Suc
tff(fact_4240_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(B,A),A2: set(B)] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2))),aa(set(B),real,aa(fun(B,real),fun(set(B),real),groups7311177749621191930dd_sum(B,real),aTP_Lamp_dd(fun(B,A),fun(B,real),F2)),A2))) ) ).

% norm_sum
tff(fact_4241_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [S2: set(B),F2: fun(B,A),G: fun(B,real)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(B,A,F2,X2))),aa(B,real,G,X2))) )
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),S2))),aa(set(B),real,aa(fun(B,real),fun(set(B),real),groups7311177749621191930dd_sum(B,real),G),S2))) ) ) ).

% sum_norm_le
tff(fact_4242_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [F2: fun(B,A),A3: A,A2: set(B)] : ( modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_de(fun(B,A),fun(A,fun(B,A)),F2),A3)),A2),A3) = modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2),A3) ) ) ).

% mod_sum_eq
tff(fact_4243_verit__sko__ex_H,axiom,
    ! [A: $tType,P: fun(A,bool),A2: bool] :
      ( ( pp(aa(A,bool,P,fChoice(A,P)))
      <=> pp(A2) )
     => ( ? [X_12: A] : pp(aa(A,bool,P,X_12))
      <=> pp(A2) ) ) ).

% verit_sko_ex'
tff(fact_4244_verit__sko__forall,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ! [X_12: A] : pp(aa(A,bool,P,X_12))
    <=> pp(aa(A,bool,P,fChoice(A,aTP_Lamp_df(fun(A,bool),fun(A,bool),P)))) ) ).

% verit_sko_forall
tff(fact_4245_verit__sko__forall_H,axiom,
    ! [A: $tType,P: fun(A,bool),A2: bool] :
      ( ( pp(aa(A,bool,P,fChoice(A,aTP_Lamp_df(fun(A,bool),fun(A,bool),P))))
      <=> pp(A2) )
     => ( ! [X_12: A] : pp(aa(A,bool,P,X_12))
      <=> pp(A2) ) ) ).

% verit_sko_forall'
tff(fact_4246_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B3: A,A2: A,P: fun(A,bool)] :
      ( ( B3 = A2 )
     => ( ( fChoice(A,P) = A2 )
      <=> ( fChoice(A,P) = B3 ) ) ) ).

% verit_sko_forall''
tff(fact_4247_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X3: A,P: fun(A,bool)] :
      ( ( X3 = fChoice(A,P) )
     => ( ? [X_12: A] : pp(aa(A,bool,P,X_12))
      <=> pp(aa(A,bool,P,X3)) ) ) ).

% verit_sko_ex_indirect
tff(fact_4248_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X3: A,P: fun(A,bool),P3: fun(A,bool)] :
      ( ( X3 = fChoice(A,P) )
     => ( ! [X2: A] :
            ( pp(aa(A,bool,P,X2))
          <=> pp(aa(A,bool,P3,X2)) )
       => ( ? [X_12: A] : pp(aa(A,bool,P3,X_12))
        <=> pp(aa(A,bool,P,X3)) ) ) ) ).

% verit_sko_ex_indirect2
tff(fact_4249_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X3: A,P: fun(A,bool)] :
      ( ( X3 = fChoice(A,aTP_Lamp_df(fun(A,bool),fun(A,bool),P)) )
     => ( ! [X_12: A] : pp(aa(A,bool,P,X_12))
      <=> pp(aa(A,bool,P,X3)) ) ) ).

% verit_sko_forall_indirect
tff(fact_4250_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X3: A,P: fun(A,bool),P3: fun(A,bool)] :
      ( ( X3 = fChoice(A,aTP_Lamp_df(fun(A,bool),fun(A,bool),P)) )
     => ( ! [X2: A] :
            ( pp(aa(A,bool,P,X2))
          <=> pp(aa(A,bool,P3,X2)) )
       => ( ! [X_12: A] : pp(aa(A,bool,P3,X_12))
        <=> pp(aa(A,bool,P,X3)) ) ) ) ).

% verit_sko_forall_indirect2
tff(fact_4251_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dg(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,N))) ) ) ).

% sum.atMost_Suc_shift
tff(fact_4252_sum__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),I: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dh(fun(nat,A),fun(nat,A),F2)),set_ord_atMost(nat,I)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,zero_zero(nat))),aa(nat,A,F2,aa(nat,nat,suc,I))) ) ) ).

% sum_telescope
tff(fact_4253_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),N: nat,D2: fun(nat,A)] :
          ( ! [X4: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(A,fun(nat,A)),C2),X4)),set_ord_atMost(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(A,fun(nat,A)),D2),X4)),set_ord_atMost(nat,N)) )
        <=> ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I2),N))
             => ( aa(nat,A,C2,I2) = aa(nat,A,D2,I2) ) ) ) ) ).

% polyfun_eq_coeffs
tff(fact_4254_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linord2810124833399127020strict(A)
        & topolo1944317154257567458pology(A) )
     => ! [A3: fun(nat,A),B3: A] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,A3,N2)))
         => ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),A3),set_ord_atMost(nat,N2))),B3))
           => summable(A,A3) ) ) ) ).

% bounded_imp_summable
tff(fact_4255_atMost__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [U: A] : ( set_ord_atMost(A,U) = collect(A,aTP_Lamp_dj(A,fun(A,bool),U)) ) ) ).

% atMost_def
tff(fact_4256_sum__choose__lower,axiom,
    ! [R2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_dk(nat,fun(nat,nat),R2)),set_ord_atMost(nat,N)) = aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),R2),N))),N) ) ).

% sum_choose_lower
tff(fact_4257_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_dl(nat,fun(nat,nat),N)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)),one_one(nat))),M) ) ).

% choose_rising_sum(2)
tff(fact_4258_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_dl(nat,fun(nat,nat),N)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) ).

% choose_rising_sum(1)
tff(fact_4259_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [C2: fun(nat,A),N: nat,K: nat] :
          ( ! [W2: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dm(fun(nat,A),fun(A,fun(nat,A)),C2),W2)),set_ord_atMost(nat,N)) = zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
           => ( aa(nat,A,C2,K) = zero_zero(A) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
tff(fact_4260_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),N: nat] :
          ( ! [X4: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(A,fun(nat,A)),C2),X4)),set_ord_atMost(nat,N)) = zero_zero(A) )
        <=> ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I2),N))
             => ( aa(nat,A,C2,I2) = zero_zero(A) ) ) ) ) ).

% polyfun_eq_0
tff(fact_4261_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dn(A,fun(nat,A),A3)),set_ord_atMost(nat,N)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(nat,A,semiring_1_of_nat(A),N))),one_one(A))),N) ) ) ).

% gbinomial_parallel_sum
tff(fact_4262_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_do(nat,fun(nat,fun(nat,nat)),M),N)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,suc,N)),M) ) ) ).

% sum_choose_diagonal
tff(fact_4263_vandermonde,axiom,
    ! [M: nat,N: nat,R2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_dp(nat,fun(nat,fun(nat,fun(nat,nat))),M),N),R2)),set_ord_atMost(nat,R2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),R2) ) ).

% vandermonde
tff(fact_4264_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_atMost(nat,N))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X3),aa(nat,nat,suc,N))) ) ) ).

% sum_gp_basic
tff(fact_4265_choose__row__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(N)),set_ord_atMost(nat,N)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% choose_row_sum
tff(fact_4266_binomial,axiom,
    ! [A3: nat,B2: nat,N: nat] : ( aa(nat,nat,power_power(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),B2)),N) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_dq(nat,fun(nat,fun(nat,fun(nat,nat))),A3),B2),N)),set_ord_atMost(nat,N)) ) ).

% binomial
tff(fact_4267_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A3: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_dr(fun(nat,A),fun(nat,real),A3))
         => ( summable(real,aTP_Lamp_dr(fun(nat,A),fun(nat,real),B2))
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_dt(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A3),B2)) ) ) ) ).

% summable_Cauchy_product
tff(fact_4268_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A3: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_dr(fun(nat,A),fun(nat,real),A3))
         => ( summable(real,aTP_Lamp_dr(fun(nat,A),fun(nat,real),B2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,A3)),suminf(A,B2)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_dt(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A3),B2)) ) ) ) ) ).

% Cauchy_product
tff(fact_4269_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_du(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,N)) ) ) ).

% sum.in_pairs_0
tff(fact_4270_polynomial__product,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [M: nat,A3: fun(nat,A),N: nat,B2: fun(nat,A),X3: A] :
          ( ! [I3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),I3))
             => ( aa(nat,A,A3,I3) = zero_zero(A) ) )
         => ( ! [J2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),J2))
               => ( aa(nat,A,B2,J2) = zero_zero(A) ) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),A3),X3)),set_ord_atMost(nat,M))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),B2),X3)),set_ord_atMost(nat,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(fun(nat,A),fun(A,fun(nat,A)),aTP_Lamp_dx(fun(nat,A),fun(fun(nat,A),fun(A,fun(nat,A))),A3),B2),X3)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) ) ) ) ) ).

% polynomial_product
tff(fact_4271_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dy(A,fun(nat,A),A3)),set_ord_atMost(nat,M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),M)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),M)) ) ) ).

% gbinomial_sum_lower_neg
tff(fact_4272_binomial__ring,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,B2: A,N: nat] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dz(A,fun(A,fun(nat,fun(nat,A))),A3),B2),N)),set_ord_atMost(nat,N)) ) ) ).

% binomial_ring
tff(fact_4273_polynomial__product__nat,axiom,
    ! [M: nat,A3: fun(nat,nat),N: nat,B2: fun(nat,nat),X3: nat] :
      ( ! [I3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),I3))
         => ( aa(nat,nat,A3,I3) = zero_zero(nat) ) )
     => ( ! [J2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),J2))
           => ( aa(nat,nat,B2,J2) = zero_zero(nat) ) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_ea(fun(nat,nat),fun(nat,fun(nat,nat)),A3),X3)),set_ord_atMost(nat,M))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_ea(fun(nat,nat),fun(nat,fun(nat,nat)),B2),X3)),set_ord_atMost(nat,N))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_ec(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),A3),B2),X3)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) ) ) ) ).

% polynomial_product_nat
tff(fact_4274_choose__square__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ed(nat,fun(nat,nat),N)),set_ord_atMost(nat,N)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),N) ) ).

% choose_square_sum
tff(fact_4275_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A3: A,B2: A,N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ee(A,fun(A,fun(nat,fun(nat,A))),A3),B2),N)),set_ord_atMost(nat,N)) ) ) ).

% pochhammer_binomial_sum
tff(fact_4276_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A3: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_dr(fun(nat,A),fun(nat,real),A3))
         => ( summable(real,aTP_Lamp_dr(fun(nat,A),fun(nat,real),B2))
           => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_dt(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A3),B2),aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,A3)),suminf(A,B2))) ) ) ) ).

% Cauchy_product_sums
tff(fact_4277_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Inc: fun(A,A),N: nat,I: A] : ( semiri8178284476397505188at_aux(A,Inc,aa(nat,nat,suc,N),I) = semiri8178284476397505188at_aux(A,Inc,N,aa(A,A,Inc,I)) ) ) ).

% of_nat_aux.simps(2)
tff(fact_4278_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Inc: fun(A,A),I: A] : ( semiri8178284476397505188at_aux(A,Inc,zero_zero(nat),I) = I ) ) ).

% of_nat_aux.simps(1)
tff(fact_4279_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X3: A,M: nat,I5: set(nat)] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ef(A,fun(nat,fun(nat,A)),X3),M)),I5) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),I5)) ) ) ).

% sum_power_add
tff(fact_4280_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [P2: nat,K: nat,G: fun(nat,A),H: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),P2))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),P2))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_eg(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,P2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_eh(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P2),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% sum.zero_middle
tff(fact_4281_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,A3: A,X3: A,Y4: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ei(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A3),X3),Y4)),set_ord_atMost(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ej(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A3),X3),Y4)),set_ord_atMost(nat,M)) ) ) ).

% gbinomial_partial_sum_poly
tff(fact_4282_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A,Y4: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4) = aa(A,A,aa(A,fun(A,A),times_times(A),Y4),X3) )
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,N))),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ek(A,fun(A,fun(nat,fun(nat,A))),X3),Y4),N)),set_ord_atMost(nat,N)) ) ) ) ).

% exp_series_add_commuting
tff(fact_4283_root__polyfun,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [N: nat,Z: A,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),N))
         => ( ( aa(nat,A,power_power(A,Z),N) = A3 )
          <=> ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_el(nat,fun(A,fun(A,fun(nat,A))),N),Z),A3)),set_ord_atMost(nat,N)) = zero_zero(A) ) ) ) ) ).

% root_polyfun
tff(fact_4284_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X3: A,N: nat] :
          ( ( ( X3 = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_atMost(nat,N)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) )
          & ( ( X3 != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X3),aa(nat,nat,suc,N)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)) ) ) ) ) ).

% sum_gp0
tff(fact_4285_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( ( N != one_one(nat) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_em(nat,fun(nat,A),N)),set_ord_atMost(nat,N)) = zero_zero(A) ) ) ) ).

% choose_alternating_linear_sum
tff(fact_4286_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_en(nat,fun(nat,A),M)),set_ord_atMost(nat,M)) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M) ) ) ).

% gbinomial_sum_nat_pow2
tff(fact_4287_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,A3: A,X3: A,Y4: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ei(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A3),X3),Y4)),set_ord_atMost(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_eo(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A3),X3),Y4)),set_ord_atMost(nat,M)) ) ) ).

% gbinomial_partial_sum_poly_xpos
tff(fact_4288_binomial__r__part__sum,axiom,
    ! [M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)),one_one(nat)))),set_ord_atMost(nat,M)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)) ) ).

% binomial_r_part_sum
tff(fact_4289_choose__linear__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ep(nat,fun(nat,nat),N)),set_ord_atMost(nat,N)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ).

% choose_linear_sum
tff(fact_4290_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eq(nat,fun(nat,A),N)),set_ord_atMost(nat,N)) = zero_zero(A) ) ) ) ).

% choose_alternating_sum
tff(fact_4291_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [E: real,C2: fun(nat,A),N: nat] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
         => ? [M10: real] :
            ! [Z3: A] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),M10),real_V7770717601297561774m_norm(A,Z3)))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_bg(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,N)))),aa(real,real,aa(real,fun(real,real),times_times(real),E),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(A,Z3)),aa(nat,nat,suc,N))))) ) ) ) ).

% polyfun_extremal_lemma
tff(fact_4292_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,semiring_1_of_nat(A),M))),one_one(A)))),set_ord_atMost(nat,M)) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)) ) ) ).

% gbinomial_r_part_sum
tff(fact_4293_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_er(nat,fun(nat,A),N)),set_ord_atMost(nat,N))) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) ) ) ) ).

% choose_odd_sum
tff(fact_4294_choose__even__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_es(nat,fun(nat,A),N)),set_ord_atMost(nat,N))) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N) ) ) ) ).

% choose_even_sum
tff(fact_4295_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_et(A,fun(nat,A),A3)),set_ord_atMost(nat,M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),M)),one_one(A))),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,A,gbinomial(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),one_one(nat)))) ) ) ).

% gbinomial_partial_row_sum
tff(fact_4296_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,aa(num,A,numeral_numeral(A),bit0(one2)))),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),N))) ) ) ).

% mask_eq_sum_exp
tff(fact_4297_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),aa(nat,nat,suc,zero_zero(nat))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2)))),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),N))) ) ).

% mask_eq_sum_exp_nat
tff(fact_4298_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_ew(A,fun(A,fun(nat,A)),X3),Y4),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X3)),cos(A,Y4))) ) ).

% cos_x_cos_y
tff(fact_4299_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,Y4: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_ey(A,fun(A,fun(nat,A)),X3),Y4),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4))) ) ).

% sums_cos_x_plus_y
tff(fact_4300_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [F2: fun(A,B),A2: set(A)] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_ez(fun(A,B),fun(A,B),F2)),A2))) ) ).

% sum_abs_ge_zero
tff(fact_4301_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [F2: fun(A,B),A2: set(A)] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,abs_abs(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A2))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_ez(fun(A,B),fun(A,B),F2)),A2))) ) ).

% sum_abs
tff(fact_4302_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),X3: fun(A,B),A3: fun(A,B),B2: B,Delta: B] :
          ( ! [I3: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,X3,I3))) )
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),X3),I5) = one_one(B) )
           => ( ! [I3: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A3,I3)),B2))),Delta)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_fa(fun(A,B),fun(fun(A,B),fun(A,B)),X3),A3)),I5)),B2))),Delta)) ) ) ) ) ).

% convex_sum_bound_le
tff(fact_4303_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_fb(B,A)),A2) = zero_zero(A) ) ) ).

% sum.neutral_const
tff(fact_4304_of__nat__id,axiom,
    ! [N: nat] : ( aa(nat,nat,semiring_1_of_nat(nat),N) = N ) ).

% of_nat_id
tff(fact_4305_int__sum,axiom,
    ! [B: $tType,F2: fun(B,nat),A2: set(B)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A2)) = aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7311177749621191930dd_sum(B,int),aTP_Lamp_fc(fun(B,nat),fun(B,int),F2)),A2) ) ).

% int_sum
tff(fact_4306_Complex__sum_H,axiom,
    ! [A: $tType,F2: fun(A,real),S: set(A)] : ( aa(set(A),complex,aa(fun(A,complex),fun(set(A),complex),groups7311177749621191930dd_sum(A,complex),aTP_Lamp_fd(fun(A,real),fun(A,complex),F2)),S) = complex2(aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),F2),S),zero_zero(real)) ) ).

% Complex_sum'
tff(fact_4307_sum__subtractf__nat,axiom,
    ! [A: $tType,A2: set(A),G: fun(A,nat),F2: fun(A,nat)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,G,X2)),aa(A,nat,F2,X2))) )
     => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_fe(fun(A,nat),fun(fun(A,nat),fun(A,nat)),G),F2)),A2) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A2)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),G),A2)) ) ) ).

% sum_subtractf_nat
tff(fact_4308_sum__SucD,axiom,
    ! [A: $tType,F2: fun(A,nat),A2: set(A),N: nat] :
      ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A2) = aa(nat,nat,suc,N) )
     => ? [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(A,nat,F2,X2))) ) ) ).

% sum_SucD
tff(fact_4309_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),one_one(nat)),N))
     => ( aa(set(complex),complex,aa(fun(complex,complex),fun(set(complex),complex),groups7311177749621191930dd_sum(complex,complex),aTP_Lamp_ff(complex,complex)),collect(complex,aa(complex,fun(complex,bool),aTP_Lamp_fg(nat,fun(complex,fun(complex,bool)),N),C2))) = zero_zero(complex) ) ) ).

% sum_nth_roots
tff(fact_4310_sum__roots__unity,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),one_one(nat)),N))
     => ( aa(set(complex),complex,aa(fun(complex,complex),fun(set(complex),complex),groups7311177749621191930dd_sum(complex,complex),aTP_Lamp_ff(complex,complex)),collect(complex,aTP_Lamp_fh(nat,fun(complex,bool),N))) = zero_zero(complex) ) ) ).

% sum_roots_unity
tff(fact_4311_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A2: set(B)] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) != zero_zero(A) )
         => ~ ! [A5: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),A2))
               => ( aa(B,A,G,A5) = zero_zero(A) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
tff(fact_4312_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),G: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
             => ( aa(B,A,G,X2) = zero_zero(A) ) )
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) = zero_zero(A) ) ) ) ).

% sum.neutral
tff(fact_4313_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [K5: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),K5))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),aa(B,A,G,I3))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),K5)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),K5))) ) ) ).

% sum_mono
tff(fact_4314_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [R2: A,F2: fun(B,A),A2: set(B)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),R2),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_fi(A,fun(fun(B,A),fun(B,A)),R2),F2)),A2) ) ) ).

% sum_distrib_left
tff(fact_4315_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F2: fun(B,A),A2: set(B),R2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),R2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_fj(fun(B,A),fun(A,fun(B,A)),F2),R2)),A2) ) ) ).

% sum_distrib_right
tff(fact_4316_sum__product,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( semiring_0(B)
     => ! [F2: fun(A,B),A2: set(A),G: fun(C,B),B3: set(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A2)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),B3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(set(C),fun(A,B),aa(fun(C,B),fun(set(C),fun(A,B)),aTP_Lamp_fl(fun(A,B),fun(fun(C,B),fun(set(C),fun(A,B))),F2),G),B3)),A2) ) ) ).

% sum_product
tff(fact_4317_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),H: fun(B,A),A2: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_fm(fun(B,A),fun(fun(B,A),fun(B,A)),G),H)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),A2)) ) ) ).

% sum.distrib
tff(fact_4318_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F2: fun(B,A),A2: set(B),R2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),R2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_fn(fun(B,A),fun(A,fun(B,A)),F2),R2)),A2) ) ) ).

% sum_divide_distrib
tff(fact_4319_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),zero_zero(A))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),zero_zero(A))) ) ) ).

% sum_nonpos
tff(fact_4320_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,X2))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2))) ) ) ).

% sum_nonneg
tff(fact_4321_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(nat),F2: fun(nat,A),G: fun(nat,A)] :
          ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2))
         => ( ! [X2: nat] :
                ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),aa(nat,nat,suc,X2)),A2))
               => ( aa(nat,A,F2,aa(nat,nat,suc,X2)) = aa(nat,A,G,aa(nat,nat,suc,X2)) ) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),A2) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),A2) ) ) ) ) ).

% sum_cong_Suc
tff(fact_4322_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real)))
       => ? [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),T3))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),zero_zero(real)))
            & ( cos(real,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fo(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi)))),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
tff(fact_4323_Maclaurin__cos__expansion2,axiom,
    ! [X3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ? [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),T3))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),X3))
            & ( cos(real,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fo(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi)))),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ) ).

% Maclaurin_cos_expansion2
tff(fact_4324_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ? [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),T3))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),X3))
            & ( sin(real,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fp(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi)))),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ) ).

% Maclaurin_sin_expansion3
tff(fact_4325_Maclaurin__sin__expansion4,axiom,
    ! [X3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => ? [T3: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),T3))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),X3))
          & ( sin(real,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fp(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi)))),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ).

% Maclaurin_sin_expansion4
tff(fact_4326_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,K: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),set_ord_lessThan(A,K)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),K)) ) ) ).

% lessThan_iff
tff(fact_4327_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_lessThan(A,X3)),set_ord_lessThan(A,Y4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ).

% lessThan_subset_iff
tff(fact_4328_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,N))),aa(nat,A,G,N)) ) ) ).

% sum.lessThan_Suc
tff(fact_4329_sumr__cos__zero__one,axiom,
    ! [N: nat] : ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fq(nat,real)),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = one_one(real) ) ).

% sumr_cos_zero_one
tff(fact_4330_lessThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [U: A] : ( set_ord_lessThan(A,U) = collect(A,aTP_Lamp_fr(A,fun(A,bool),U)) ) ) ).

% lessThan_def
tff(fact_4331_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M: A,N: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),set_ord_lessThan(A,M)),set_ord_lessThan(A,N)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M),N)) ) ) ).

% lessThan_strict_subset_iff
tff(fact_4332_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_atMost(A,A3)),set_ord_lessThan(A,B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% Iic_subset_Iio_iff
tff(fact_4333_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Q: fun(A,nat),P: fun(A,nat),N: A] :
          ( ! [X2: A] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,Q,X2)),aa(A,nat,P,X2)))
         => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),P),set_ord_lessThan(A,N))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),Q),set_ord_lessThan(A,N))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_fs(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Q),P)),set_ord_lessThan(A,N)) ) ) ) ).

% sum_diff_distrib
tff(fact_4334_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),X3: A] :
          ( summable(A,F2)
         => ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N2))),X3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),suminf(A,F2)),X3)) ) ) ) ).

% suminf_le_const
tff(fact_4335_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [F2: fun(nat,A),N: nat,R2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),R2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ft(fun(nat,A),fun(A,fun(nat,A)),F2),R2)),set_ord_lessThan(nat,N)) ) ) ).

% sumr_diff_mult_const2
tff(fact_4336_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dg(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N))) ) ) ).

% sum.lessThan_Suc_shift
tff(fact_4337_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dh(fun(nat,A),fun(nat,A),F2)),set_ord_lessThan(nat,M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,zero_zero(nat))),aa(nat,A,F2,M)) ) ) ).

% sum_lessThan_telescope'
tff(fact_4338_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fu(fun(nat,A),fun(nat,A),F2)),set_ord_lessThan(nat,M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,M)),aa(nat,A,F2,zero_zero(nat))) ) ) ).

% sum_lessThan_telescope
tff(fact_4339_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),X3: A] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N2)))
         => ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N2))),X3))
           => summable(A,F2) ) ) ) ).

% summableI_nonneg_bounded
tff(fact_4340_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),N: nat,S: A] :
          ( sums(A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),F2),N),S)
        <=> sums(A,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N)))) ) ) ).

% sums_iff_shift
tff(fact_4341_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),N: nat,S: A] :
          ( sums(A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),F2),N),aa(A,A,aa(A,fun(A,A),minus_minus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N))))
        <=> sums(A,F2,S) ) ) ).

% sums_iff_shift'
tff(fact_4342_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),S: A,N: nat] :
          ( sums(A,F2,S)
         => sums(A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),F2),N),aa(A,A,aa(A,fun(A,A),minus_minus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N)))) ) ) ).

% sums_split_initial_segment
tff(fact_4343_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X3),N)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),one_one(A))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_lessThan(nat,N))) ) ) ).

% power_diff_1_eq
tff(fact_4344_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X3),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_lessThan(nat,N))) ) ) ).

% one_diff_power_eq
tff(fact_4345_geometric__sum,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A,N: nat] :
          ( ( X3 != one_one(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_lessThan(nat,N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X3),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),one_one(A))) ) ) ) ).

% geometric_sum
tff(fact_4346_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dg(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N))) ) ) ).

% sum.atMost_shift
tff(fact_4347_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( summable(A,F2)
         => ( suminf(A,F2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),suminf(A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),F2),K))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,K))) ) ) ) ).

% suminf_split_initial_segment
tff(fact_4348_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( summable(A,F2)
         => ( suminf(A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),F2),K)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,K))) ) ) ) ).

% suminf_minus_initial_segment
tff(fact_4349_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),N: nat] :
          ( summable(A,F2)
         => ( ! [M3: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,F2,M3))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N))),suminf(A,F2))) ) ) ) ).

% sum_less_suminf
tff(fact_4350_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X3: A,N: nat] :
          ( ( ( X3 = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_lessThan(nat,N)) = aa(nat,A,semiring_1_of_nat(A),N) ) )
          & ( ( X3 != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_lessThan(nat,N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X3),N))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)) ) ) ) ) ).

% sum_gp_strict
tff(fact_4351_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Z: A,H: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fv(A,fun(A,fun(nat,fun(nat,A))),Z),H),M)),set_ord_lessThan(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fw(A,fun(A,fun(nat,fun(nat,A))),Z),H),M)),set_ord_lessThan(nat,M)) ) ) ).

% lemma_termdiff1
tff(fact_4352_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X3: A,N: nat,Y4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X3),aa(nat,nat,suc,N))),aa(nat,A,power_power(A,Y4),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_fx(A,fun(nat,fun(A,fun(nat,A))),X3),N),Y4)),set_ord_lessThan(nat,aa(nat,nat,suc,N)))) ) ) ).

% diff_power_eq_sum
tff(fact_4353_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X3: A,N: nat,Y4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X3),N)),aa(nat,A,power_power(A,Y4),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_fy(A,fun(nat,fun(A,fun(nat,A))),X3),N),Y4)),set_ord_lessThan(nat,N))) ) ) ).

% power_diff_sumr2
tff(fact_4354_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: fun(nat,A),A3: A,N: nat] :
          ( ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),C2),A3)),set_ord_atMost(nat,N)) = zero_zero(A) )
         => ~ ! [B5: fun(nat,A)] :
                ~ ! [Z3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z3),A3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),B5),Z3)),set_ord_lessThan(nat,N))) ) ) ) ).

% polyfun_linear_factor_root
tff(fact_4355_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: fun(nat,A),N: nat,A3: A] :
        ? [B5: fun(nat,A)] :
        ! [Z3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z3),A3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),B5),Z3)),set_ord_lessThan(nat,N)))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),C2),A3)),set_ord_atMost(nat,N))) ) ) ).

% polyfun_linear_factor
tff(fact_4356_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,F2: fun(nat,A),K5: A,K: nat] :
          ( ! [P4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),P4),N))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,P4)),K5)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),K5))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),K5))) ) ) ) ).

% real_sum_nat_ivl_bounded2
tff(fact_4357_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),N: nat,I: nat] :
          ( summable(A,F2)
         => ( ! [M3: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,M3))) )
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),I))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(nat,A,F2,I)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N))),suminf(A,F2))) ) ) ) ) ) ).

% sum_less_suminf2
tff(fact_4358_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X3),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_fz(A,fun(nat,fun(nat,A)),X3),N)),set_ord_lessThan(nat,N))) ) ) ).

% one_diff_power_eq'
tff(fact_4359_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [X3: real,N: nat,Diff: fun(nat,fun(A,real))] :
          ( ( X3 = zero_zero(real) )
         => ( ( N != zero_zero(nat) )
           => ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(A,real)),fun(nat,real),aTP_Lamp_ga(real,fun(fun(nat,fun(A,real)),fun(nat,real)),X3),Diff)),set_ord_lessThan(nat,N)) = aa(A,real,aa(nat,fun(A,real),Diff,zero_zero(nat)),zero_zero(A)) ) ) ) ) ).

% Maclaurin_zero
tff(fact_4360_Maclaurin__lemma,axiom,
    ! [H: real,F2: fun(real,real),J3: fun(nat,real),N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H))
     => ? [B8: real] : ( aa(real,real,F2,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,real),fun(nat,real),aTP_Lamp_gb(real,fun(fun(nat,real),fun(nat,real)),H),J3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),B8),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,H),N)),semiring_char_0_fact(real,N)))) ) ) ).

% Maclaurin_lemma
tff(fact_4361_sum__split__even__odd,axiom,
    ! [F2: fun(nat,real),G: fun(nat,real),N: nat] : ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,real),fun(nat,real),aTP_Lamp_gc(fun(nat,real),fun(fun(nat,real),fun(nat,real)),F2),G)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gd(fun(nat,real),fun(nat,real),F2)),set_ord_lessThan(nat,N))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ge(fun(nat,real),fun(nat,real),G)),set_ord_lessThan(nat,N))) ) ).

% sum_split_even_odd
tff(fact_4362_Maclaurin__exp__le,axiom,
    ! [X3: real,N: nat] :
    ? [T3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3)))
      & ( aa(real,real,exp(real),X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gf(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,exp(real),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ).

% Maclaurin_exp_le
tff(fact_4363_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [N: nat,A3: fun(nat,A),X3: A,Y4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),A3),X3)),set_ord_atMost(nat,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),A3),Y4)),set_ord_atMost(nat,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_gh(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),N),A3),X3),Y4)),set_ord_lessThan(nat,N))) ) ) ) ).

% polyfun_diff_alt
tff(fact_4364_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A,K: nat] : ( aa(A,A,exp(A),X3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_cm(A,fun(nat,A),X3)),set_ord_lessThan(nat,K))),suminf(A,aa(nat,fun(nat,A),aTP_Lamp_gi(A,fun(nat,fun(nat,A)),X3),K))) ) ) ).

% exp_first_terms
tff(fact_4365_Maclaurin__sin__bound,axiom,
    ! [X3: real,N: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),sin(real,X3)),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fp(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),X3)),N)))) ).

% Maclaurin_sin_bound
tff(fact_4366_sum__pos__lt__pair,axiom,
    ! [F2: fun(nat,real),K: nat] :
      ( summable(real,F2)
     => ( ! [D3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))),D3)))),aa(nat,real,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))),D3)),one_one(nat)))))))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),F2),set_ord_lessThan(nat,K))),suminf(real,F2))) ) ) ).

% sum_pos_lt_pair
tff(fact_4367_Maclaurin__exp__lt,axiom,
    ! [X3: real,N: nat] :
      ( ( X3 != zero_zero(real) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ? [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,abs_abs(real),T3)))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3)))
            & ( aa(real,real,exp(real),X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gf(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,exp(real),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ) ).

% Maclaurin_exp_lt
tff(fact_4368_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [H: A,Z: A,N: nat] :
          ( ( H != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H)),N)),aa(nat,A,power_power(A,Z),N))),H)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,A,power_power(A,Z),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),times_times(A),H),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gk(A,fun(A,fun(nat,fun(nat,A))),H),Z),N)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ) ).

% lemma_termdiff2
tff(fact_4369_Maclaurin__sin__expansion,axiom,
    ! [X3: real,N: nat] :
    ? [T3: real] : ( sin(real,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fp(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi)))),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ).

% Maclaurin_sin_expansion
tff(fact_4370_Maclaurin__sin__expansion2,axiom,
    ! [X3: real,N: nat] :
    ? [T3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3)))
      & ( sin(real,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fp(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi)))),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ).

% Maclaurin_sin_expansion2
tff(fact_4371_Maclaurin__cos__expansion,axiom,
    ! [X3: real,N: nat] :
    ? [T3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3)))
      & ( cos(real,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fo(real,fun(nat,real),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi)))),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ).

% Maclaurin_cos_expansion
tff(fact_4372_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => bij_betw(nat,complex,aTP_Lamp_gl(nat,fun(nat,complex),N),set_ord_lessThan(nat,N),collect(complex,aTP_Lamp_fh(nat,fun(complex,bool),N))) ) ).

% bij_betw_roots_unity
tff(fact_4373_sum__gp,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [N: nat,M: nat,X3: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_or1337092689740270186AtMost(nat,M,N)) = zero_zero(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( ( ( X3 = one_one(A) )
               => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_or1337092689740270186AtMost(nat,M,N)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),M)) ) )
              & ( ( X3 != one_one(A) )
               => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X3),M)),aa(nat,A,power_power(A,X3),aa(nat,nat,suc,N)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)) ) ) ) ) ) ) ).

% sum_gp
tff(fact_4374_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [R2: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_et(A,fun(nat,A),R2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M))),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,A,gbinomial(A,R2),aa(nat,nat,suc,M))) ) ) ).

% gchoose_row_sum_weighted
tff(fact_4375_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% gauss_sum_from_Suc_0
tff(fact_4376_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,H: A,L4: A,H2: A] :
          ( ( set_or1337092689740270186AtMost(A,L,H) = set_or1337092689740270186AtMost(A,L4,H2) )
        <=> ( ( ( L = L4 )
              & ( H = H2 ) )
            | ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),H))
              & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L4),H2)) ) ) ) ) ).

% Icc_eq_Icc
tff(fact_4377_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,L: A,U: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),set_or1337092689740270186AtMost(A,L,U)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),I))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),U)) ) ) ) ).

% atLeastAtMost_iff
tff(fact_4378_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),set_or1337092689740270186AtMost(A,C2,D2)))
        <=> ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% atLeastatMost_subset_iff
tff(fact_4379_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [L: A,H: A,H2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,L,H)),set_ord_atMost(A,H2)))
        <=> ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),H))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),H),H2)) ) ) ) ).

% Icc_subset_Iic_iff
tff(fact_4380_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [N: nat,M: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N))) = zero_zero(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ) ) ).

% sum.cl_ivl_Suc
tff(fact_4381_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [H: A,L4: A,H2: A] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_atMost(A,H)),set_or1337092689740270186AtMost(A,L4,H2))) ) ).

% not_Iic_le_Icc
tff(fact_4382_ex__nat__less,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( ? [M6: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M6),N))
          & pp(aa(nat,bool,P,M6)) )
    <=> ? [X4: nat] :
          ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X4),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)))
          & pp(aa(nat,bool,P,X4)) ) ) ).

% ex_nat_less
tff(fact_4383_all__nat__less,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( ! [M6: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M6),N))
         => pp(aa(nat,bool,P,M6)) )
    <=> ! [X4: nat] :
          ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X4),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)))
         => pp(aa(nat,bool,P,X4)) ) ) ).

% all_nat_less
tff(fact_4384_atMost__atLeast0,axiom,
    ! [N: nat] : ( set_ord_atMost(nat,N) = set_or1337092689740270186AtMost(nat,zero_zero(nat),N) ) ).

% atMost_atLeast0
tff(fact_4385_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_gm(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.shift_bounds_cl_nat_ivl
tff(fact_4386_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),set_or1337092689740270186AtMost(A,C2,D2)))
        <=> ( ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
              | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2))
                & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3))
                  | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),D2)) ) ) )
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2)) ) ) ) ).

% atLeastatMost_psubset_iff
tff(fact_4387_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_gn(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or1337092689740270186AtMost(nat,N,M)) ) ) ).

% sum.atLeastAtMost_rev
tff(fact_4388_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( ( aa(nat,A,F2,zero_zero(nat)) = zero_zero(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,zero_zero(nat),K)) ) ) ) ).

% sum_shift_lb_Suc0_0
tff(fact_4389_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% sum.atLeast0_atMost_Suc
tff(fact_4390_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N))) ) ) ) ).

% sum.atLeast_Suc_atMost
tff(fact_4391_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,suc,N)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,aa(nat,nat,suc,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))) ) ) ) ).

% sum.nat_ivl_Suc'
tff(fact_4392_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(nat,A,G,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dg(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,N))) ) ) ) ).

% sum.Suc_reindex_ivl
tff(fact_4393_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,F2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,suc,N)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fu(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,aa(nat,nat,suc,N))),aa(nat,A,F2,M)) ) ) ) ).

% sum_Suc_diff
tff(fact_4394_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dg(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N)) ) ) ).

% sum.atLeast1_atMost_eq
tff(fact_4395_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),A3: nat,B2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,A3,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_go(fun(nat,A),fun(nat,fun(A,A)),F2),A3,B2,zero_zero(A)) ) ) ).

% sum_atLeastAtMost_code
tff(fact_4396_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A),P2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2)))) ) ) ) ).

% sum.ub_add_nat
tff(fact_4397_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_atMost(nat,M))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)))) ) ) ).

% sum_up_index_split
tff(fact_4398_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,F2: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gp(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,M)),aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gp(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,M,N)) = zero_zero(A) ) ) ) ) ).

% sum_natinterval_diff
tff(fact_4399_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,F2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gq(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,N)),aa(nat,A,F2,M)) ) ) ) ).

% sum_telescope''
tff(fact_4400_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M: nat,N: nat,X3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))) ) ) ) ).

% sum_power_shift
tff(fact_4401_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A),E: real] :
          ( summable(A,F2)
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
           => ~ ! [N9: nat] :
                  ~ ! [M2: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N9),M2))
                     => ! [N7: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,M2,N7)))),E)) ) ) ) ) ).

% summable_partial_sum_bound
tff(fact_4402_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M: nat,N: nat,X3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_or1337092689740270186AtMost(nat,M,N))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X3),M)),aa(nat,A,power_power(A,X3),aa(nat,nat,suc,N))) ) ) ) ).

% sum_gp_multiplied
tff(fact_4403_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_du(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.in_pairs
tff(fact_4404_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),N: nat,K: A] :
          ( ! [X4: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(A,fun(nat,A)),C2),X4)),set_ord_atMost(nat,N)) = K )
        <=> ( ( aa(nat,A,C2,zero_zero(nat)) = K )
            & ! [X4: nat] :
                ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X4),set_or1337092689740270186AtMost(nat,one_one(nat),N)))
               => ( aa(nat,A,C2,X4) = zero_zero(A) ) ) ) ) ) ).

% polyfun_eq_const
tff(fact_4405_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gr(nat,fun(nat,A),K)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))) ) ) ).

% gbinomial_sum_up_index
tff(fact_4406_gauss__sum__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gs(nat,nat)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,N))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% gauss_sum_nat
tff(fact_4407_double__arith__series,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,D2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gt(A,fun(A,fun(nat,A)),A3),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),D2))) ) ) ).

% double_arith_series
tff(fact_4408_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))) ) ) ).

% double_gauss_sum
tff(fact_4409_arith__series__nat,axiom,
    ! [A3: nat,D2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_gu(nat,fun(nat,fun(nat,nat)),A3),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),A3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),D2)))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% arith_series_nat
tff(fact_4410_Sum__Icc__nat,axiom,
    ! [M: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gs(nat,nat)),set_or1337092689740270186AtMost(nat,M,N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% Sum_Icc_nat
tff(fact_4411_arith__series,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A,D2: A,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gv(A,fun(A,fun(nat,A)),A3),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),D2)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% arith_series
tff(fact_4412_gauss__sum,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A)))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% gauss_sum
tff(fact_4413_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))) ) ) ).

% double_gauss_sum_from_Suc_0
tff(fact_4414_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X3: A,M: nat,N: nat] :
          ( ( ( X3 = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A)) ) )
          & ( ( X3 != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X3)),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),M)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X3),aa(nat,nat,suc,N))))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X3)) ) ) ) ) ).

% sum_gp_offset
tff(fact_4415_polyfun__diff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [N: nat,A3: fun(nat,A),X3: A,Y4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),A3),X3)),set_ord_atMost(nat,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),A3),Y4)),set_ord_atMost(nat,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_gx(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),N),A3),X3),Y4)),set_ord_lessThan(nat,N))) ) ) ) ).

% polyfun_diff
tff(fact_4416_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,aa(nat,nat,suc,N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,nat,suc,N))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_gy(A,fun(nat,A),Z),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),one_one(nat)))) ) ) ).

% pochhammer_times_pochhammer_half
tff(fact_4417_vebt__buildup_Opelims,axiom,
    ! [X3: nat,Y4: vEBT_VEBT] :
      ( ( vEBT_vebt_buildup(X3) = Y4 )
     => ( pp(aa(nat,bool,accp(nat,vEBT_v4011308405150292612up_rel),X3))
       => ( ( ( X3 = zero_zero(nat) )
           => ( ( Y4 = vEBT_Leaf(fFalse,fFalse) )
             => ~ pp(aa(nat,bool,accp(nat,vEBT_v4011308405150292612up_rel),zero_zero(nat))) ) )
         => ( ( ( X3 = aa(nat,nat,suc,zero_zero(nat)) )
             => ( ( Y4 = vEBT_Leaf(fFalse,fFalse) )
               => ~ pp(aa(nat,bool,accp(nat,vEBT_v4011308405150292612up_rel),aa(nat,nat,suc,zero_zero(nat)))) ) )
           => ~ ! [Va: nat] :
                  ( ( X3 = aa(nat,nat,suc,aa(nat,nat,suc,Va)) )
                 => ( ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va))))
                       => ( Y4 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) )
                      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va))))
                       => ( Y4 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) )
                   => ~ pp(aa(nat,bool,accp(nat,vEBT_v4011308405150292612up_rel),aa(nat,nat,suc,aa(nat,nat,suc,Va)))) ) ) ) ) ) ) ).

% vebt_buildup.pelims
tff(fact_4418_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] : ( unique8689654367752047608divmod(A,bit1(M),bit0(N)) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_gz(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M,N)) ) ) ).

% divmod_algorithm_code(6)
tff(fact_4419_arctan__def,axiom,
    ! [Y4: real] : ( aa(real,real,arctan,Y4) = the(real,aTP_Lamp_ha(real,fun(real,bool),Y4)) ) ).

% arctan_def
tff(fact_4420_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(B)
        & ring_1(B) )
     => ! [A2: set(A),F2: fun(A,B)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
             => pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),aa(A,B,F2,X2)),ring_1_Ints(B))) )
         => pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),groups7121269368397514597t_prod(A,B,F2,A2)),ring_1_Ints(B))) ) ) ).

% Ints_prod
tff(fact_4421_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,nat),A2: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(B,nat,F2,A2)) = groups7121269368397514597t_prod(B,A,aTP_Lamp_hb(fun(B,nat),fun(B,A),F2),A2) ) ) ).

% of_nat_prod
tff(fact_4422_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [F2: fun(B,int),A2: set(B)] : ( aa(int,A,ring_1_of_int(A),groups7121269368397514597t_prod(B,int,F2,A2)) = groups7121269368397514597t_prod(B,A,aTP_Lamp_hc(fun(B,int),fun(B,A),F2),A2) ) ) ).

% of_int_prod
tff(fact_4423_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_ord_lessThan(nat,N))),aa(nat,A,G,N)) ) ) ).

% prod.lessThan_Suc
tff(fact_4424_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_ord_atMost(nat,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atMost_Suc
tff(fact_4425_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M))
           => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N))) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M))
           => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ) ) ).

% prod.cl_ivl_Suc
tff(fact_4426_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] : ( unique8689654367752047608divmod(A,bit0(M),bit0(N)) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_hd(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M,N)) ) ) ).

% divmod_algorithm_code(5)
tff(fact_4427_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),H: fun(B,A),A2: set(B)] : ( groups7121269368397514597t_prod(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_he(fun(B,A),fun(fun(B,A),fun(B,A)),G),H),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,A2)),groups7121269368397514597t_prod(B,A,H,A2)) ) ) ).

% prod.distrib
tff(fact_4428_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F2: fun(B,A),G: fun(B,A),A2: set(B)] : ( groups7121269368397514597t_prod(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_hf(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),groups7121269368397514597t_prod(B,A,F2,A2)),groups7121269368397514597t_prod(B,A,G,A2)) ) ) ).

% prod_dividef
tff(fact_4429_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(B)
     => ! [F2: fun(A,B),A2: set(A),N: nat] : ( aa(nat,B,power_power(B,groups7121269368397514597t_prod(A,B,F2,A2)),N) = groups7121269368397514597t_prod(A,B,aa(nat,fun(A,B),aTP_Lamp_hg(fun(A,B),fun(nat,fun(A,B)),F2),N),A2) ) ) ).

% prod_power_distrib
tff(fact_4430_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [F2: fun(B,A),A2: set(B)] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,groups7121269368397514597t_prod(B,A,F2,A2))),groups7121269368397514597t_prod(B,real,aTP_Lamp_hh(fun(B,A),fun(B,real),F2),A2))) ) ).

% norm_prod_le
tff(fact_4431_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [F2: fun(B,A),A3: A,A2: set(B)] : ( modulo_modulo(A,groups7121269368397514597t_prod(B,A,aa(A,fun(B,A),aTP_Lamp_de(fun(B,A),fun(A,fun(B,A)),F2),A3),A2),A3) = modulo_modulo(A,groups7121269368397514597t_prod(B,A,F2,A2),A3) ) ) ).

% mod_prod_eq
tff(fact_4432_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,X2))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),groups7121269368397514597t_prod(B,A,F2,A2))) ) ) ).

% prod_nonneg
tff(fact_4433_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(A)
     => ! [A2: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3)))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),aa(B,A,G,I3))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),groups7121269368397514597t_prod(B,A,F2,A2)),groups7121269368397514597t_prod(B,A,G,A2))) ) ) ).

% prod_mono
tff(fact_4434_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(B,A,F2,X2))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),groups7121269368397514597t_prod(B,A,F2,A2))) ) ) ).

% prod_pos
tff(fact_4435_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(B,A,F2,X2))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),groups7121269368397514597t_prod(B,A,F2,A2))) ) ) ).

% prod_ge_1
tff(fact_4436_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C2: A,F2: fun(B,nat),A2: set(B)] : ( aa(nat,A,power_power(A,C2),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A2)) = groups7121269368397514597t_prod(B,A,aa(fun(B,nat),fun(B,A),aTP_Lamp_hi(A,fun(fun(B,nat),fun(B,A)),C2),F2),A2) ) ) ).

% power_sum
tff(fact_4437_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hj(fun(nat,A),fun(nat,fun(nat,A)),G),K),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.shift_bounds_cl_nat_ivl
tff(fact_4438_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,X2)))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),one_one(A))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),groups7121269368397514597t_prod(B,A,F2,A2)),one_one(A))) ) ) ).

% prod_le_1
tff(fact_4439_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,N,M)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_hk(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M),set_or1337092689740270186AtMost(nat,N,M)) ) ) ).

% prod.atLeastAtMost_rev
tff(fact_4440_ln__neg__is__const,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real)))
     => ( aa(real,real,ln_ln(real),X3) = the(real,aTP_Lamp_hl(real,bool)) ) ) ).

% ln_neg_is_const
tff(fact_4441_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,zero_zero(nat),N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atLeast0_atMost_Suc
tff(fact_4442_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,suc,N)))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,aa(nat,nat,suc,N))),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N))) ) ) ) ).

% prod.nat_ivl_Suc'
tff(fact_4443_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N))) ) ) ) ).

% prod.atLeast_Suc_atMost
tff(fact_4444_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aTP_Lamp_hm(fun(nat,A),fun(nat,A),G),set_ord_lessThan(nat,N))) ) ) ).

% prod.lessThan_Suc_shift
tff(fact_4445_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N))),aa(nat,A,G,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),groups7121269368397514597t_prod(nat,A,aTP_Lamp_hm(fun(nat,A),fun(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))) ) ) ) ).

% prod.Suc_reindex_ivl
tff(fact_4446_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aTP_Lamp_hm(fun(nat,A),fun(nat,A),G),set_ord_atMost(nat,N))) ) ) ).

% prod.atMost_Suc_shift
tff(fact_4447_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_hm(fun(nat,A),fun(nat,A),G),set_ord_lessThan(nat,N)) ) ) ).

% prod.atLeast1_atMost_eq
tff(fact_4448_fact__prod,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(nat,nat,aTP_Lamp_gs(nat,nat),set_or1337092689740270186AtMost(nat,one_one(nat),N))) ) ) ).

% fact_prod
tff(fact_4449_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [F2: fun(nat,A),A3: nat,B2: nat] : ( groups7121269368397514597t_prod(nat,A,F2,set_or1337092689740270186AtMost(nat,A3,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_hn(fun(nat,A),fun(nat,fun(A,A)),F2),A3,B2,one_one(A)) ) ) ).

% prod_atLeastAtMost_code
tff(fact_4450_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A),P2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N))),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2)))) ) ) ) ).

% prod.ub_add_nat
tff(fact_4451_periodic__finite__ex,axiom,
    ! [D2: int,P: fun(int,bool)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D2))
     => ( ! [X2: int,K2: int] :
            ( pp(aa(int,bool,P,X2))
          <=> pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2)))) )
       => ( ? [X_12: int] : pp(aa(int,bool,P,X_12))
        <=> ? [X4: int] :
              ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X4),set_or1337092689740270186AtMost(int,one_one(int),D2)))
              & pp(aa(int,bool,P,X4)) ) ) ) ) ).

% periodic_finite_ex
tff(fact_4452_bset_I3_J,axiom,
    ! [D4: int,T2: int,B3: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),T2),one_one(int))),B3))
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
               => ! [Xb2: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),B3))
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa3) ) ) )
           => ( ( X = T2 )
             => ( aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4) = T2 ) ) ) ) ) ).

% bset(3)
tff(fact_4453_bset_I4_J,axiom,
    ! [D4: int,T2: int,B3: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),T2),B3))
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
               => ! [Xb2: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),B3))
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa3) ) ) )
           => ( ( X != T2 )
             => ( aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4) != T2 ) ) ) ) ) ).

% bset(4)
tff(fact_4454_bset_I5_J,axiom,
    ! [D4: int,B3: set(int),T2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ! [X: int] :
          ( ! [Xa3: int] :
              ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
             => ! [Xb2: int] :
                  ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),B3))
                 => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa3) ) ) )
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X),T2))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4)),T2)) ) ) ) ).

% bset(5)
tff(fact_4455_bset_I7_J,axiom,
    ! [D4: int,T2: int,B3: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),T2),B3))
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
               => ! [Xb2: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),B3))
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa3) ) ) )
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),T2),X))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),T2),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4))) ) ) ) ) ).

% bset(7)
tff(fact_4456_aset_I3_J,axiom,
    ! [D4: int,T2: int,A2: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),T2),one_one(int))),A2))
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
               => ! [Xb2: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),A2))
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa3) ) ) )
           => ( ( X = T2 )
             => ( aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4) = T2 ) ) ) ) ) ).

% aset(3)
tff(fact_4457_aset_I4_J,axiom,
    ! [D4: int,T2: int,A2: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),T2),A2))
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
               => ! [Xb2: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),A2))
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa3) ) ) )
           => ( ( X != T2 )
             => ( aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4) != T2 ) ) ) ) ) ).

% aset(4)
tff(fact_4458_aset_I5_J,axiom,
    ! [D4: int,T2: int,A2: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),T2),A2))
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
               => ! [Xb2: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),A2))
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa3) ) ) )
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X),T2))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4)),T2)) ) ) ) ) ).

% aset(5)
tff(fact_4459_aset_I7_J,axiom,
    ! [D4: int,A2: set(int),T2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ! [X: int] :
          ( ! [Xa3: int] :
              ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
             => ! [Xb2: int] :
                  ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),A2))
                 => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa3) ) ) )
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),T2),X))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),T2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4))) ) ) ) ).

% aset(7)
tff(fact_4460_norm__prod__diff,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [I5: set(I6),Z: fun(I6,A),W: fun(I6,A)] :
          ( ! [I3: I6] :
              ( pp(aa(set(I6),bool,aa(I6,fun(set(I6),bool),member2(I6),I3),I5))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(I6,A,Z,I3))),one_one(real))) )
         => ( ! [I3: I6] :
                ( pp(aa(set(I6),bool,aa(I6,fun(set(I6),bool),member2(I6),I3),I5))
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(I6,A,W,I3))),one_one(real))) )
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),groups7121269368397514597t_prod(I6,A,Z,I5)),groups7121269368397514597t_prod(I6,A,W,I5)))),aa(set(I6),real,aa(fun(I6,real),fun(set(I6),real),groups7311177749621191930dd_sum(I6,real),aa(fun(I6,A),fun(I6,real),aTP_Lamp_ho(fun(I6,A),fun(fun(I6,A),fun(I6,real)),Z),W)),I5))) ) ) ) ).

% norm_prod_diff
tff(fact_4461_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aTP_Lamp_hm(fun(nat,A),fun(nat,A),G),set_ord_lessThan(nat,N))) ) ) ).

% prod.atMost_shift
tff(fact_4462_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
     => ( semiring_char_0_fact(nat,M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,N)),groups7121269368397514597t_prod(nat,nat,aTP_Lamp_gs(nat,nat),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M))) ) ) ).

% fact_eq_fact_times
tff(fact_4463_bset_I6_J,axiom,
    ! [D4: int,B3: set(int),T2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ! [X: int] :
          ( ! [Xa3: int] :
              ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
             => ! [Xb2: int] :
                  ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),B3))
                 => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa3) ) ) )
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X),T2))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4)),T2)) ) ) ) ).

% bset(6)
tff(fact_4464_bset_I8_J,axiom,
    ! [D4: int,T2: int,B3: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),T2),one_one(int))),B3))
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
               => ! [Xb2: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),B3))
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa3) ) ) )
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),T2),X))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),T2),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4))) ) ) ) ) ).

% bset(8)
tff(fact_4465_aset_I6_J,axiom,
    ! [D4: int,T2: int,A2: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),T2),one_one(int))),A2))
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
               => ! [Xb2: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),A2))
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa3) ) ) )
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X),T2))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4)),T2)) ) ) ) ) ).

% aset(6)
tff(fact_4466_aset_I8_J,axiom,
    ! [D4: int,A2: set(int),T2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ! [X: int] :
          ( ! [Xa3: int] :
              ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4)))
             => ! [Xb2: int] :
                  ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb2),A2))
                 => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa3) ) ) )
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),T2),X))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),T2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4))) ) ) ) ).

% aset(8)
tff(fact_4467_cppi,axiom,
    ! [D4: int,P: fun(int,bool),P3: fun(int,bool),A2: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( ? [Z3: int] :
          ! [X2: int] :
            ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z3),X2))
           => ( pp(aa(int,bool,P,X2))
            <=> pp(aa(int,bool,P3,X2)) ) )
       => ( ! [X2: int] :
              ( ! [Xa2: int] :
                  ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa2),set_or1337092689740270186AtMost(int,one_one(int),D4)))
                 => ! [Xb3: int] :
                      ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb3),A2))
                     => ( X2 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa2) ) ) )
             => ( pp(aa(int,bool,P,X2))
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),D4))) ) )
         => ( ! [X2: int,K2: int] :
                ( pp(aa(int,bool,P3,X2))
              <=> pp(aa(int,bool,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D4)))) )
           => ( ? [X_12: int] : pp(aa(int,bool,P,X_12))
            <=> ( ? [X4: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X4),set_or1337092689740270186AtMost(int,one_one(int),D4)))
                    & pp(aa(int,bool,P3,X4)) )
                | ? [X4: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X4),set_or1337092689740270186AtMost(int,one_one(int),D4)))
                    & ? [Xa4: int] :
                        ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa4),A2))
                        & pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa4),X4))) ) ) ) ) ) ) ) ) ).

% cppi
tff(fact_4468_cpmi,axiom,
    ! [D4: int,P: fun(int,bool),P3: fun(int,bool),B3: set(int)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),D4))
     => ( ? [Z3: int] :
          ! [X2: int] :
            ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X2),Z3))
           => ( pp(aa(int,bool,P,X2))
            <=> pp(aa(int,bool,P3,X2)) ) )
       => ( ! [X2: int] :
              ( ! [Xa2: int] :
                  ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa2),set_or1337092689740270186AtMost(int,one_one(int),D4)))
                 => ! [Xb3: int] :
                      ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xb3),B3))
                     => ( X2 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa2) ) ) )
             => ( pp(aa(int,bool,P,X2))
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),D4))) ) )
         => ( ! [X2: int,K2: int] :
                ( pp(aa(int,bool,P3,X2))
              <=> pp(aa(int,bool,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D4)))) )
           => ( ? [X_12: int] : pp(aa(int,bool,P,X_12))
            <=> ( ? [X4: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X4),set_or1337092689740270186AtMost(int,one_one(int),D4)))
                    & pp(aa(int,bool,P3,X4)) )
                | ? [X4: int] :
                    ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X4),set_or1337092689740270186AtMost(int,one_one(int),D4)))
                    & ? [Xa4: int] :
                        ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa4),B3))
                        & pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa4),X4))) ) ) ) ) ) ) ) ) ).

% cpmi
tff(fact_4469_arccos__def,axiom,
    ! [Y4: real] : ( aa(real,real,arccos,Y4) = the(real,aTP_Lamp_hp(real,fun(real,bool),Y4)) ) ).

% arccos_def
tff(fact_4470_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat] : ( comm_s3205402744901411588hammer(A,A3,aa(nat,nat,suc,N)) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_hq(A,fun(nat,A),A3),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_Suc_prod
tff(fact_4471_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat] : ( comm_s3205402744901411588hammer(A,A3,N) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hr(A,fun(nat,fun(nat,A)),A3),N),set_or1337092689740270186AtMost(nat,one_one(nat),N)) ) ) ).

% pochhammer_prod_rev
tff(fact_4472_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,M)),semiring_char_0_fact(nat,N)) = groups7121269368397514597t_prod(nat,nat,aTP_Lamp_gs(nat,nat),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),M)) ) ) ).

% fact_div_fact
tff(fact_4473_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_hs(fun(nat,A),fun(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.in_pairs
tff(fact_4474_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_ord_atMost(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_hs(fun(nat,A),fun(nat,A),G),set_ord_atMost(nat,N)) ) ) ).

% prod.in_pairs_0
tff(fact_4475_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat] : ( comm_s3205402744901411588hammer(A,A3,aa(nat,nat,suc,N)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hr(A,fun(nat,fun(nat,A)),A3),N),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_Suc_prod_rev
tff(fact_4476_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P2: nat,K: nat,G: fun(nat,A),H: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),P2))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),P2))
           => ( groups7121269368397514597t_prod(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_ht(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H),set_ord_atMost(nat,P2)) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_hu(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P2),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% prod.zero_middle
tff(fact_4477_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),groups7121269368397514597t_prod(nat,A,aTP_Lamp_hv(A,fun(nat,A),A3),set_or1337092689740270186AtMost(nat,zero_zero(nat),K))),semiring_char_0_fact(A,aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc
tff(fact_4478_divmod__step__nat__def,axiom,
    ! [L: num,Qr: product_prod(nat,nat)] : ( unique1321980374590559556d_step(nat,L,Qr) = aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_hw(num,fun(nat,fun(nat,product_prod(nat,nat))),L)),Qr) ) ).

% divmod_step_nat_def
tff(fact_4479_divmod__step__int__def,axiom,
    ! [L: num,Qr: product_prod(int,int)] : ( unique1321980374590559556d_step(int,L,Qr) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_hx(num,fun(int,fun(int,product_prod(int,int))),L)),Qr) ) ).

% divmod_step_int_def
tff(fact_4480_pi__half,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))) = the(real,aTP_Lamp_hy(real,bool)) ).

% pi_half
tff(fact_4481_pi__def,axiom,
    pi = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),the(real,aTP_Lamp_hy(real,bool))) ).

% pi_def
tff(fact_4482_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),M),N))
     => ( aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7311177749621191930dd_sum(int,int),aTP_Lamp_hz(int,int)),set_or1337092689740270186AtMost(int,M,N)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),N),aa(int,int,aa(int,fun(int,int),plus_plus(int),N),one_one(int)))),aa(int,int,aa(int,fun(int,int),times_times(int),M),aa(int,int,aa(int,fun(int,int),minus_minus(int),M),one_one(int))))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ) ).

% Sum_Icc_int
tff(fact_4483_divmod__step__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Qr: product_prod(A,A)] : ( unique1321980374590559556d_step(A,L,Qr) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_ia(num,fun(A,fun(A,product_prod(A,A))),L)),Qr) ) ) ).

% divmod_step_def
tff(fact_4484_arcsin__def,axiom,
    ! [Y4: real] : ( aa(real,real,arcsin,Y4) = the(real,aTP_Lamp_ib(real,fun(real,bool),Y4)) ) ).

% arcsin_def
tff(fact_4485_divmod__nat__if,axiom,
    ! [N: nat,M: nat] :
      ( ( ( ( N = zero_zero(nat) )
          | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) )
       => ( divmod_nat(M,N) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),M) ) )
      & ( ~ ( ( N = zero_zero(nat) )
            | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N)) )
       => ( divmod_nat(M,N) = aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_ic(nat,fun(nat,product_prod(nat,nat)))),divmod_nat(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N)) ) ) ) ).

% divmod_nat_if
tff(fact_4486_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(list(A)),set(list(A)),set2(list(A)),n_lists(A,N,Xs)) = collect(list(A),aa(list(A),fun(list(A),bool),aTP_Lamp_id(nat,fun(list(A),fun(list(A),bool)),N),Xs)) ) ).

% set_n_lists
tff(fact_4487_pred__subset__eq,axiom,
    ! [A: $tType,R4: set(A),S2: set(A)] :
      ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),aTP_Lamp_a(set(A),fun(A,bool),R4)),aTP_Lamp_a(set(A),fun(A,bool),S2)))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),R4),S2)) ) ).

% pred_subset_eq
tff(fact_4488_VEBT__internal_Oelim__dead_Osimps_I2_J,axiom,
    ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] : ( vEBT_VEBT_elim_dead(vEBT_Node(Info,Deg,TreeList,Summary),extend4730790105801354508finity(extended_enat)) = vEBT_Node(Info,Deg,aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ie(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg)),TreeList),vEBT_VEBT_elim_dead(Summary,extend4730790105801354508finity(extended_enat))) ) ).

% VEBT_internal.elim_dead.simps(2)
tff(fact_4489_map__ident,axiom,
    ! [A: $tType,X: list(A)] : ( aa(list(A),list(A),map(A,A,aTP_Lamp_if(A,A)),X) = X ) ).

% map_ident
tff(fact_4490_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B),G: fun(B,A)] :
      ( ( aa(list(B),list(A),map(B,A,F2),Xs) = aa(list(B),list(A),map(B,A,G),Xs) )
    <=> ! [X4: B] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),aa(list(B),set(B),set2(B),Xs)))
         => ( aa(B,A,F2,X4) = aa(B,A,G,X4) ) ) ) ).

% map_eq_conv
tff(fact_4491_length__map,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_size(list(A)),aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),nat,size_size(list(B)),Xs) ) ).

% length_map
tff(fact_4492_map__replicate,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),N: nat,X3: B] : ( aa(list(B),list(A),map(B,A,F2),replicate(B,N,X3)) = replicate(A,N,aa(B,A,F2,X3)) ) ).

% map_replicate
tff(fact_4493_nth__map,axiom,
    ! [B: $tType,A: $tType,N: nat,Xs: list(A),F2: fun(A,B)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,B,nth(B,aa(list(A),list(B),map(A,B,F2),Xs)),N) = aa(A,B,F2,aa(nat,A,nth(A,Xs),N)) ) ) ).

% nth_map
tff(fact_4494_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( groups7121269368397514597t_prod(product_prod(nat,nat),A,product_case_prod(nat,nat,A,G),collect(product_prod(nat,nat),product_case_prod(nat,nat,bool,aTP_Lamp_ig(nat,fun(nat,fun(nat,bool)),N)))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_ii(fun(nat,fun(nat,A)),fun(nat,A),G),set_ord_atMost(nat,N)) ) ) ).

% prod.triangle_reindex_eq
tff(fact_4495_int__prod,axiom,
    ! [B: $tType,F2: fun(B,nat),A2: set(B)] : ( aa(nat,int,semiring_1_of_nat(int),groups7121269368397514597t_prod(B,nat,F2,A2)) = groups7121269368397514597t_prod(B,int,aTP_Lamp_fc(fun(B,nat),fun(B,int),F2),A2) ) ).

% int_prod
tff(fact_4496_list_Omap__ident,axiom,
    ! [A: $tType,T2: list(A)] : ( aa(list(A),list(A),map(A,A,aTP_Lamp_if(A,A)),T2) = T2 ) ).

% list.map_ident
tff(fact_4497_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(B,A),Xs: list(B),G: fun(C,A),Ys2: list(C)] :
      ( ( aa(list(B),list(A),map(B,A,F2),Xs) = aa(list(C),list(A),map(C,A,G),Ys2) )
     => ( aa(list(B),nat,size_size(list(B)),Xs) = aa(list(C),nat,size_size(list(C)),Ys2) ) ) ).

% map_eq_imp_length_eq
tff(fact_4498_map__concat,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(list(B))] : ( aa(list(B),list(A),map(B,A,F2),concat(B,Xs)) = concat(A,aa(list(list(B)),list(list(A)),map(list(B),list(A),map(B,A,F2)),Xs)) ) ).

% map_concat
tff(fact_4499_ex__map__conv,axiom,
    ! [B: $tType,A: $tType,Ys2: list(B),F2: fun(A,B)] :
      ( ? [Xs3: list(A)] : ( Ys2 = aa(list(A),list(B),map(A,B,F2),Xs3) )
    <=> ! [X4: B] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),aa(list(B),set(B),set2(B),Ys2)))
         => ? [Xa4: A] : ( X4 = aa(A,B,F2,Xa4) ) ) ) ).

% ex_map_conv
tff(fact_4500_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(A),F2: fun(A,B),G: fun(A,B)] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Ys2)))
           => ( aa(A,B,F2,X2) = aa(A,B,G,X2) ) )
       => ( aa(list(A),list(B),map(A,B,F2),Xs) = aa(list(A),list(B),map(A,B,G),Ys2) ) ) ) ).

% map_cong
tff(fact_4501_map__idI,axiom,
    ! [A: $tType,Xs: list(A),F2: fun(A,A)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => ( aa(A,A,F2,X2) = X2 ) )
     => ( aa(list(A),list(A),map(A,A,F2),Xs) = Xs ) ) ).

% map_idI
tff(fact_4502_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F2: fun(A,B),G: fun(A,B)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => ( aa(A,B,F2,X2) = aa(A,B,G,X2) ) )
     => ( aa(list(A),list(B),map(A,B,F2),Xs) = aa(list(A),list(B),map(A,B,G),Xs) ) ) ).

% map_ext
tff(fact_4503_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X3: list(A),Xa: list(A),F2: fun(A,B),Fa: fun(A,B)] :
      ( ! [Z4: A,Za: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Z4),aa(list(A),set(A),set2(A),X3)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Za),aa(list(A),set(A),set2(A),Xa)))
           => ( ( aa(A,B,F2,Z4) = aa(A,B,Fa,Za) )
             => ( Z4 = Za ) ) ) )
     => ( ( aa(list(A),list(B),map(A,B,F2),X3) = aa(list(A),list(B),map(A,B,Fa),Xa) )
       => ( X3 = Xa ) ) ) ).

% list.inj_map_strong
tff(fact_4504_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X3: list(A),F2: fun(A,B),G: fun(A,B)] :
      ( ! [Z4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Z4),aa(list(A),set(A),set2(A),X3)))
         => ( aa(A,B,F2,Z4) = aa(A,B,G,Z4) ) )
     => ( aa(list(A),list(B),map(A,B,F2),X3) = aa(list(A),list(B),map(A,B,G),X3) ) ) ).

% list.map_cong0
tff(fact_4505_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X3: list(A),Ya: list(A),F2: fun(A,B),G: fun(A,B)] :
      ( ( X3 = Ya )
     => ( ! [Z4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Z4),aa(list(A),set(A),set2(A),Ya)))
           => ( aa(A,B,F2,Z4) = aa(A,B,G,Z4) ) )
       => ( aa(list(A),list(B),map(A,B,F2),X3) = aa(list(A),list(B),map(A,B,G),Ya) ) ) ) ).

% list.map_cong
tff(fact_4506_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( groups7121269368397514597t_prod(product_prod(nat,nat),A,product_case_prod(nat,nat,A,G),collect(product_prod(nat,nat),product_case_prod(nat,nat,bool,aTP_Lamp_ij(nat,fun(nat,fun(nat,bool)),N)))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_ii(fun(nat,fun(nat,A)),fun(nat,A),G),set_ord_lessThan(nat,N)) ) ) ).

% prod.triangle_reindex
tff(fact_4507_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list(B)] : ( aa(list(B),list(A),map(B,A,aTP_Lamp_ik(A,fun(B,A),K)),Lst) = replicate(A,aa(list(B),nat,size_size(list(B)),Lst),K) ) ).

% map_replicate_const
tff(fact_4508_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,bool,aTP_Lamp_ig(nat,fun(nat,fun(nat,bool)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_im(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_atMost(nat,N)) ) ) ).

% sum.triangle_reindex_eq
tff(fact_4509_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,bool,aTP_Lamp_ij(nat,fun(nat,fun(nat,bool)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_im(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_lessThan(nat,N)) ) ) ).

% sum.triangle_reindex
tff(fact_4510_prod__int__plus__eq,axiom,
    ! [I: nat,J3: nat] : ( groups7121269368397514597t_prod(nat,int,semiring_1_of_nat(int),set_or1337092689740270186AtMost(nat,I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J3))) = groups7121269368397514597t_prod(int,int,aTP_Lamp_hz(int,int),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J3)))) ) ).

% prod_int_plus_eq
tff(fact_4511_subrelI,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),S: set(product_prod(A,B))] :
      ( ! [X2: A,Y2: B] :
          ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X2),Y2)),R2))
         => pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X2),Y2)),S)) )
     => pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R2),S)) ) ).

% subrelI
tff(fact_4512_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R4: set(product_prod(A,B)),S2: set(product_prod(A,B))] :
      ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),aTP_Lamp_in(set(product_prod(A,B)),fun(A,fun(B,bool)),R4)),aTP_Lamp_in(set(product_prod(A,B)),fun(A,fun(B,bool)),S2)))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R4),S2)) ) ).

% pred_subset_eq2
tff(fact_4513_length__n__lists__elem,axiom,
    ! [A: $tType,Ys2: list(A),N: nat,Xs: list(A)] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Ys2),aa(list(list(A)),set(list(A)),set2(list(A)),n_lists(A,N,Xs))))
     => ( aa(list(A),nat,size_size(list(A)),Ys2) = N ) ) ).

% length_n_lists_elem
tff(fact_4514_divmod__nat__def,axiom,
    ! [M: nat,N: nat] : ( divmod_nat(M,N) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N)),modulo_modulo(nat,M,N)) ) ).

% divmod_nat_def
tff(fact_4515_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(nat,A,semiring_1_of_nat(A),N) = zero_zero(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(nat,A,semiring_1_of_nat(A),N) = aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_io(nat,fun(nat,A))),divmod_nat(N,aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ) ) ).

% of_nat_code_if
tff(fact_4516_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(list(A)),nat,size_size(list(list(A))),n_lists(A,N,Xs)) = aa(nat,nat,power_power(nat,aa(list(A),nat,size_size(list(A)),Xs)),N) ) ).

% length_n_lists
tff(fact_4517_VEBT__internal_Oelim__dead_Oelims,axiom,
    ! [X3: vEBT_VEBT,Xa: extended_enat,Y4: vEBT_VEBT] :
      ( ( vEBT_VEBT_elim_dead(X3,Xa) = Y4 )
     => ( ! [A5: bool,B5: bool] :
            ( ( X3 = vEBT_Leaf(A5,B5) )
           => ( Y4 != vEBT_Leaf(A5,B5) ) )
       => ( ! [Info2: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
              ( ( X3 = vEBT_Node(Info2,Deg2,TreeList2,Summary2) )
             => ( ( Xa = extend4730790105801354508finity(extended_enat) )
               => ( Y4 != vEBT_Node(Info2,Deg2,aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ie(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg2)),TreeList2),vEBT_VEBT_elim_dead(Summary2,extend4730790105801354508finity(extended_enat))) ) ) )
         => ~ ! [Info2: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(Info2,Deg2,TreeList2,Summary2) )
               => ! [L2: nat] :
                    ( ( Xa = extended_enat2(L2) )
                   => ( Y4 != vEBT_Node(Info2,Deg2,take(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ie(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg2)),TreeList2)),vEBT_VEBT_elim_dead(Summary2,extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.elims
tff(fact_4518_VEBT__internal_Oelim__dead_Osimps_I3_J,axiom,
    ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,L: nat] : ( vEBT_VEBT_elim_dead(vEBT_Node(Info,Deg,TreeList,Summary),extended_enat2(L)) = vEBT_Node(Info,Deg,take(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ie(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg)),TreeList)),vEBT_VEBT_elim_dead(Summary,extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))) ) ).

% VEBT_internal.elim_dead.simps(3)
tff(fact_4519_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool)),Q: fun(A,fun(B,bool))] :
      ( ! [X2: A,Y2: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),P,X2),Y2))
         => pp(aa(B,bool,aa(A,fun(B,bool),Q,X2),Y2)) )
     => pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q)) ) ).

% predicate2I
tff(fact_4520_take__all,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N))
     => ( take(A,N,Xs) = Xs ) ) ).

% take_all
tff(fact_4521_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( take(A,N,Xs) = Xs )
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N)) ) ).

% take_all_iff
tff(fact_4522_nth__take,axiom,
    ! [A: $tType,I: nat,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),N))
     => ( aa(nat,A,nth(A,take(A,N,Xs)),I) = aa(nat,A,nth(A,Xs),I) ) ) ).

% nth_take
tff(fact_4523_product__concat__map,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(B)] : ( product(A,B,Xs,Ys2) = concat(product_prod(A,B),aa(list(A),list(list(product_prod(A,B))),map(A,list(product_prod(A,B)),aTP_Lamp_ip(list(B),fun(A,list(product_prod(A,B))),Ys2)),Xs)) ) ).

% product_concat_map
tff(fact_4524_take__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: fun(B,A),Xs: list(B)] : ( take(A,N,aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),list(A),map(B,A,F2),take(B,N,Xs)) ) ).

% take_map
tff(fact_4525_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool)),X3: A,Y4: B,Q: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),P,X3),Y4))
     => ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q))
       => pp(aa(B,bool,aa(A,fun(B,bool),Q,X3),Y4)) ) ) ).

% rev_predicate2D
tff(fact_4526_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool)),Q: fun(A,fun(B,bool)),X3: A,Y4: B] :
      ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),P,X3),Y4))
       => pp(aa(B,bool,aa(A,fun(B,bool),Q,X3),Y4)) ) ) ).

% predicate2D
tff(fact_4527_in__set__takeD,axiom,
    ! [A: $tType,X3: A,N: nat,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),take(A,N,Xs))))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs))) ) ).

% in_set_takeD
tff(fact_4528_take__equalityI,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ! [I3: nat] : ( take(A,I3,Xs) = take(A,I3,Ys2) )
     => ( Xs = Ys2 ) ) ).

% take_equalityI
tff(fact_4529_set__take__subset,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),take(A,N,Xs))),aa(list(A),set(A),set2(A),Xs))) ).

% set_take_subset
tff(fact_4530_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),take(A,M,Xs))),aa(list(A),set(A),set2(A),take(A,N,Xs)))) ) ).

% set_take_subset_set_take
tff(fact_4531_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list(A),Ys2: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Ys2)))
       => ( ! [I3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),K))
             => ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,nth(A,Ys2),I3) ) )
         => ( take(A,K,Xs) = take(A,K,Ys2) ) ) ) ) ).

% nth_take_lemma
tff(fact_4532_VEBT__internal_Oelim__dead_Opelims,axiom,
    ! [X3: vEBT_VEBT,Xa: extended_enat,Y4: vEBT_VEBT] :
      ( ( vEBT_VEBT_elim_dead(X3,Xa) = Y4 )
     => ( pp(aa(product_prod(vEBT_VEBT,extended_enat),bool,accp(product_prod(vEBT_VEBT,extended_enat),vEBT_V312737461966249ad_rel),aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),product_Pair(vEBT_VEBT,extended_enat,X3),Xa)))
       => ( ! [A5: bool,B5: bool] :
              ( ( X3 = vEBT_Leaf(A5,B5) )
             => ( ( Y4 = vEBT_Leaf(A5,B5) )
               => ~ pp(aa(product_prod(vEBT_VEBT,extended_enat),bool,accp(product_prod(vEBT_VEBT,extended_enat),vEBT_V312737461966249ad_rel),aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),product_Pair(vEBT_VEBT,extended_enat,vEBT_Leaf(A5,B5)),Xa))) ) )
         => ( ! [Info2: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(Info2,Deg2,TreeList2,Summary2) )
               => ( ( Xa = extend4730790105801354508finity(extended_enat) )
                 => ( ( Y4 = vEBT_Node(Info2,Deg2,aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ie(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg2)),TreeList2),vEBT_VEBT_elim_dead(Summary2,extend4730790105801354508finity(extended_enat))) )
                   => ~ pp(aa(product_prod(vEBT_VEBT,extended_enat),bool,accp(product_prod(vEBT_VEBT,extended_enat),vEBT_V312737461966249ad_rel),aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),product_Pair(vEBT_VEBT,extended_enat,vEBT_Node(Info2,Deg2,TreeList2,Summary2)),extend4730790105801354508finity(extended_enat)))) ) ) )
           => ~ ! [Info2: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                  ( ( X3 = vEBT_Node(Info2,Deg2,TreeList2,Summary2) )
                 => ! [L2: nat] :
                      ( ( Xa = extended_enat2(L2) )
                     => ( ( Y4 = vEBT_Node(Info2,Deg2,take(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ie(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg2)),TreeList2)),vEBT_VEBT_elim_dead(Summary2,extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))) )
                       => ~ pp(aa(product_prod(vEBT_VEBT,extended_enat),bool,accp(product_prod(vEBT_VEBT,extended_enat),vEBT_V312737461966249ad_rel),aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),product_Pair(vEBT_VEBT,extended_enat,vEBT_Node(Info2,Deg2,TreeList2,Summary2)),extended_enat2(L2)))) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.pelims
tff(fact_4533_accp__subset,axiom,
    ! [A: $tType,R1: fun(A,fun(A,bool)),R22: fun(A,fun(A,bool))] :
      ( pp(aa(fun(A,fun(A,bool)),bool,aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),bool),ord_less_eq(fun(A,fun(A,bool))),R1),R22))
     => pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),accp(A,R22)),accp(A,R1))) ) ).

% accp_subset
tff(fact_4534_Collect__case__prod__mono,axiom,
    ! [B: $tType,A: $tType,A2: fun(A,fun(B,bool)),B3: fun(A,fun(B,bool))] :
      ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),A2),B3))
     => pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),collect(product_prod(A,B),product_case_prod(A,B,bool,A2))),collect(product_prod(A,B),product_case_prod(A,B,bool,B3)))) ) ).

% Collect_case_prod_mono
tff(fact_4535_complex__mult__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% complex_mult_cnj
tff(fact_4536_complex__cnj__mult,axiom,
    ! [X3: complex,Y4: complex] : ( cnj(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X3),Y4)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cnj(X3)),cnj(Y4)) ) ).

% complex_cnj_mult
tff(fact_4537_complex__cnj__divide,axiom,
    ! [X3: complex,Y4: complex] : ( cnj(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X3),Y4)) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),cnj(X3)),cnj(Y4)) ) ).

% complex_cnj_divide
tff(fact_4538_complex__cnj__zero,axiom,
    cnj(zero_zero(complex)) = zero_zero(complex) ).

% complex_cnj_zero
tff(fact_4539_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( cnj(Z) = zero_zero(complex) )
    <=> ( Z = zero_zero(complex) ) ) ).

% complex_cnj_zero_iff
tff(fact_4540_complex__cnj__power,axiom,
    ! [X3: complex,N: nat] : ( cnj(aa(nat,complex,power_power(complex,X3),N)) = aa(nat,complex,power_power(complex,cnj(X3)),N) ) ).

% complex_cnj_power
tff(fact_4541_complex__cnj__numeral,axiom,
    ! [W: num] : ( cnj(aa(num,complex,numeral_numeral(complex),W)) = aa(num,complex,numeral_numeral(complex),W) ) ).

% complex_cnj_numeral
tff(fact_4542_complex__cnj__neg__numeral,axiom,
    ! [W: num] : ( cnj(aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W))) = aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W)) ) ).

% complex_cnj_neg_numeral
tff(fact_4543_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z))) = zero_zero(real) ) ).

% complex_In_mult_cnj_zero
tff(fact_4544_Re__complex__div__eq__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2)) = zero_zero(real) )
    <=> ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))) = zero_zero(real) ) ) ).

% Re_complex_div_eq_0
tff(fact_4545_Im__complex__div__eq__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2)) = zero_zero(real) )
    <=> ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))) = zero_zero(real) ) ) ).

% Im_complex_div_eq_0
tff(fact_4546_complex__mod__sqrt__Re__mult__cnj,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,sqrt,re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)))) ) ).

% complex_mod_sqrt_Re_mult_cnj
tff(fact_4547_Re__complex__div__gt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))))) ) ).

% Re_complex_div_gt_0
tff(fact_4548_Re__complex__div__lt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2)))),zero_zero(real))) ) ).

% Re_complex_div_lt_0
tff(fact_4549_Re__complex__div__ge__0,axiom,
    ! [A3: complex,B2: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))))) ) ).

% Re_complex_div_ge_0
tff(fact_4550_Re__complex__div__le__0,axiom,
    ! [A3: complex,B2: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2)))),zero_zero(real))) ) ).

% Re_complex_div_le_0
tff(fact_4551_Im__complex__div__gt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))))) ) ).

% Im_complex_div_gt_0
tff(fact_4552_Im__complex__div__lt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2)))),zero_zero(real))) ) ).

% Im_complex_div_lt_0
tff(fact_4553_Im__complex__div__ge__0,axiom,
    ! [A3: complex,B2: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))))) ) ).

% Im_complex_div_ge_0
tff(fact_4554_Im__complex__div__le__0,axiom,
    ! [A3: complex,B2: complex] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))),zero_zero(real)))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2)))),zero_zero(real))) ) ).

% Im_complex_div_le_0
tff(fact_4555_complex__mod__mult__cnj,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z))) = aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% complex_mod_mult_cnj
tff(fact_4556_complex__div__gt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))))) )
      & ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2))))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))))) ) ) ).

% complex_div_gt_0
tff(fact_4557_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,Bs: list(bool)] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),groups4207007520872428315er_sum(bool,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),bit0(one2)),Bs)) = groups4207007520872428315er_sum(bool,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),bit0(one2)),take(bool,N,Bs)) ) ) ).

% take_bit_horner_sum_bit_eq
tff(fact_4558_complex__norm__square,axiom,
    ! [Z: complex] : ( real_Vector_of_real(complex,aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)) ) ).

% complex_norm_square
tff(fact_4559_complex__add__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),Z),cnj(Z)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),re(Z))) ) ).

% complex_add_cnj
tff(fact_4560_complex__diff__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Z),cnj(Z)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),im(Z)))),imaginary_unit) ) ).

% complex_diff_cnj
tff(fact_4561_accp__subset__induct,axiom,
    ! [A: $tType,D4: fun(A,bool),R4: fun(A,fun(A,bool)),X3: A,P: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),D4),accp(A,R4)))
     => ( ! [X2: A,Z4: A] :
            ( pp(aa(A,bool,D4,X2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),R4,Z4),X2))
             => pp(aa(A,bool,D4,Z4)) ) )
       => ( pp(aa(A,bool,D4,X3))
         => ( ! [X2: A] :
                ( pp(aa(A,bool,D4,X2))
               => ( ! [Z3: A] :
                      ( pp(aa(A,bool,aa(A,fun(A,bool),R4,Z3),X2))
                     => pp(aa(A,bool,P,Z3)) )
                 => pp(aa(A,bool,P,X2)) ) )
           => pp(aa(A,bool,P,X3)) ) ) ) ) ).

% accp_subset_induct
tff(fact_4562_complex__div__cnj,axiom,
    ! [A3: complex,B2: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A3),B2) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A3),cnj(B2))),real_Vector_of_real(complex,aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,B2)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% complex_div_cnj
tff(fact_4563_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(W))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cnj(Z)),W)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(W))))) ) ).

% cnj_add_mult_eq_Re
tff(fact_4564_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(B)] : ( product_product(A,B,aa(list(A),set(A),set2(A),Xs),aa(list(B),set(B),set2(B),Ys2)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),concat(product_prod(A,B),aa(list(A),list(list(product_prod(A,B))),map(A,list(product_prod(A,B)),aTP_Lamp_ip(list(B),fun(A,list(product_prod(A,B))),Ys2)),Xs))) ) ).

% product_code
tff(fact_4565_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F2: fun(nat,fun(A,A)),A3: nat,B2: nat,Acc: A] :
      ( pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),F2),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),A3),aa(A,product_prod(nat,A),product_Pair(nat,A,B2),Acc)))))
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),B2),A3))
         => ( set_fo6178422350223883121st_nat(A,F2,A3,B2,Acc) = Acc ) )
        & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),B2),A3))
         => ( set_fo6178422350223883121st_nat(A,F2,A3,B2,Acc) = set_fo6178422350223883121st_nat(A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),one_one(nat)),B2,aa(A,A,aa(nat,fun(A,A),F2,A3),Acc)) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
tff(fact_4566_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X3: fun(nat,fun(A,A)),Xa: nat,Xb: nat,Xc: A,Y4: A] :
      ( ( set_fo6178422350223883121st_nat(A,X3,Xa,Xb,Xc) = Y4 )
     => ( pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),X3),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),Xa),aa(A,product_prod(nat,A),product_Pair(nat,A,Xb),Xc)))))
       => ~ ( ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Xb),Xa))
               => ( Y4 = Xc ) )
              & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Xb),Xa))
               => ( Y4 = set_fo6178422350223883121st_nat(A,X3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xa),one_one(nat)),Xb,aa(A,A,aa(nat,fun(A,A),X3,Xa),Xc)) ) ) )
           => ~ pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),X3),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),Xa),aa(A,product_prod(nat,A),product_Pair(nat,A,Xb),Xc))))) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
tff(fact_4567_in__measure,axiom,
    ! [A: $tType,X3: A,Y4: A,F2: fun(A,nat)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),measure(A,F2)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F2,X3)),aa(A,nat,F2,Y4))) ) ).

% in_measure
tff(fact_4568_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: fun(nat,fun(A,A)),A1: nat,A22: nat,A32: A,P: fun(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,bool))))] :
      ( pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),A0),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),A1),aa(A,product_prod(nat,A),product_Pair(nat,A,A22),A32)))))
     => ( ! [F4: fun(nat,fun(A,A)),A5: nat,B5: nat,Acc2: A] :
            ( pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),F4),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),A5),aa(A,product_prod(nat,A),product_Pair(nat,A,B5),Acc2)))))
           => ( ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),B5),A5))
               => pp(aa(A,bool,aa(nat,fun(A,bool),aa(nat,fun(nat,fun(A,bool)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,bool))),P,F4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A5),one_one(nat))),B5),aa(A,A,aa(nat,fun(A,A),F4,A5),Acc2))) )
             => pp(aa(A,bool,aa(nat,fun(A,bool),aa(nat,fun(nat,fun(A,bool)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,bool))),P,F4),A5),B5),Acc2)) ) )
       => pp(aa(A,bool,aa(nat,fun(A,bool),aa(nat,fun(nat,fun(A,bool)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,bool))),P,A0),A1),A22),A32)) ) ) ).

% fold_atLeastAtMost_nat.pinduct
tff(fact_4569_int__ge__less__than2__def,axiom,
    ! [D2: int] : ( int_ge_less_than2(D2) = collect(product_prod(int,int),product_case_prod(int,int,bool,aTP_Lamp_iq(int,fun(int,fun(int,bool)),D2))) ) ).

% int_ge_less_than2_def
tff(fact_4570_int__ge__less__than__def,axiom,
    ! [D2: int] : ( int_ge_less_than(D2) = collect(product_prod(int,int),product_case_prod(int,int,bool,aTP_Lamp_ir(int,fun(int,fun(int,bool)),D2))) ) ).

% int_ge_less_than_def
tff(fact_4571_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,bool))] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,A0),A1)))
     => ( ! [I3: int,J2: int] :
            ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,I3),J2)))
           => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I3),J2))
               => pp(aa(int,bool,aa(int,fun(int,bool),P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int))),J2)) )
             => pp(aa(int,bool,aa(int,fun(int,bool),P,I3),J2)) ) )
       => pp(aa(int,bool,aa(int,fun(int,bool),P,A0),A1)) ) ) ).

% upto.pinduct
tff(fact_4572_set__encode__def,axiom,
    nat_set_encode = aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2)))) ).

% set_encode_def
tff(fact_4573_VEBT_Osize_I3_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),vEBT_Node(X11,X12,X13,X14)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(vEBT_VEBT),nat,size_list(vEBT_VEBT,size_size(vEBT_VEBT)),X13)),aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),X14))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% VEBT.size(3)
tff(fact_4574_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] : ( groups4207007520872428315er_sum(bool,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),bit0(one2)),aa(list(nat),list(bool),map(nat,bool,bit_se5641148757651400278ts_bit(A,A3)),upt(zero_zero(nat),N))) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) ) ) ).

% horner_sum_bit_eq_take_bit
tff(fact_4575_Sum__Ico__nat,axiom,
    ! [M: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gs(nat,nat)),set_or7035219750837199246ssThan(nat,M,N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% Sum_Ico_nat
tff(fact_4576_length__upt,axiom,
    ! [I: nat,J3: nat] : ( aa(list(nat),nat,size_size(list(nat)),upt(I,J3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),I) ) ).

% length_upt
tff(fact_4577_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,L: A,U: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),set_or7035219750837199246ssThan(A,L,U)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),I))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),U)) ) ) ) ).

% atLeastLessThan_iff
tff(fact_4578_ivl__subset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [I: A,J3: A,M: A,N: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,I,J3)),set_or7035219750837199246ssThan(A,M,N)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),J3),I))
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),I))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),J3),N)) ) ) ) ) ).

% ivl_subset
tff(fact_4579_ivl__diff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [I: A,N: A,M: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),N))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or7035219750837199246ssThan(A,I,M)),set_or7035219750837199246ssThan(A,I,N)) = set_or7035219750837199246ssThan(A,N,M) ) ) ) ).

% ivl_diff
tff(fact_4580_nth__upt,axiom,
    ! [I: nat,K: nat,J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),J3))
     => ( aa(nat,nat,nth(nat,upt(I,J3)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K) ) ) ).

% nth_upt
tff(fact_4581_take__upt,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),M)),N))
     => ( take(nat,M,upt(I,N)) = upt(I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),M)) ) ) ).

% take_upt
tff(fact_4582_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [N: nat,M: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N))) = zero_zero(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(nat,A,G,N)) ) ) ) ) ).

% sum.op_ivl_Suc
tff(fact_4583_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N))) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,N))),aa(nat,A,G,N)) ) ) ) ) ).

% prod.op_ivl_Suc
tff(fact_4584_map__Suc__upt,axiom,
    ! [M: nat,N: nat] : ( aa(list(nat),list(nat),map(nat,nat,suc),upt(M,N)) = upt(aa(nat,nat,suc,M),aa(nat,nat,suc,N)) ) ).

% map_Suc_upt
tff(fact_4585_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( set_or7035219750837199246ssThan(A,A3,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
tff(fact_4586_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( set_or7035219750837199246ssThan(A,A3,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
             => ( A3 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
tff(fact_4587_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => ( ( set_or7035219750837199246ssThan(A,A3,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
            <=> ( ( A3 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
tff(fact_4588_atLeastLessThan__upt,axiom,
    ! [I: nat,J3: nat] : ( set_or7035219750837199246ssThan(nat,I,J3) = aa(list(nat),set(nat),set2(nat),upt(I,J3)) ) ).

% atLeastLessThan_upt
tff(fact_4589_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,A3,B2)),set_or7035219750837199246ssThan(A,C2,D2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% atLeastLessThan_subset_iff
tff(fact_4590_ex__nat__less__eq,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( ? [M6: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M6),N))
          & pp(aa(nat,bool,P,M6)) )
    <=> ? [X4: nat] :
          ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X4),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))
          & pp(aa(nat,bool,P,X4)) ) ) ).

% ex_nat_less_eq
tff(fact_4591_all__nat__less__eq,axiom,
    ! [N: nat,P: fun(nat,bool)] :
      ( ! [M6: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M6),N))
         => pp(aa(nat,bool,P,M6)) )
    <=> ! [X4: nat] :
          ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X4),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))
         => pp(aa(nat,bool,P,X4)) ) ) ).

% all_nat_less_eq
tff(fact_4592_lessThan__atLeast0,axiom,
    ! [N: nat] : ( set_ord_lessThan(nat,N) = set_or7035219750837199246ssThan(nat,zero_zero(nat),N) ) ).

% lessThan_atLeast0
tff(fact_4593_atLeastAtMost__upt,axiom,
    ! [N: nat,M: nat] : ( set_or1337092689740270186AtMost(nat,N,M) = aa(list(nat),set(nat),set2(nat),upt(N,aa(nat,nat,suc,M))) ) ).

% atLeastAtMost_upt
tff(fact_4594_atLeast__upt,axiom,
    ! [N: nat] : ( set_ord_lessThan(nat,N) = aa(list(nat),set(nat),set2(nat),upt(zero_zero(nat),N)) ) ).

% atLeast_upt
tff(fact_4595_map__add__upt,axiom,
    ! [N: nat,M: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_is(nat,fun(nat,nat),N)),upt(zero_zero(nat),M)) = upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ).

% map_add_upt
tff(fact_4596_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_gm(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.shift_bounds_nat_ivl
tff(fact_4597_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hj(fun(nat,A),fun(nat,fun(nat,A)),G),K),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.shift_bounds_nat_ivl
tff(fact_4598_map__replicate__trivial,axiom,
    ! [A: $tType,X3: A,I: nat] : ( aa(list(nat),list(A),map(nat,A,aTP_Lamp_it(A,fun(nat,A),X3)),upt(zero_zero(nat),I)) = replicate(A,I,X3) ) ).

% map_replicate_trivial
tff(fact_4599_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & comm_monoid_add(A) )
     => ! [A3: B,C2: B,B2: B,D2: B,G: fun(B,A),H: fun(B,A)] :
          ( ( A3 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),C2),X2))
                 => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X2),D2))
                   => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),set_or7035219750837199246ssThan(B,A3,B2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),set_or7035219750837199246ssThan(B,C2,D2)) ) ) ) ) ) ).

% sum.ivl_cong
tff(fact_4600_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & comm_monoid_mult(A) )
     => ! [A3: B,C2: B,B2: B,D2: B,G: fun(B,A),H: fun(B,A)] :
          ( ( A3 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),C2),X2))
                 => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X2),D2))
                   => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) ) )
             => ( groups7121269368397514597t_prod(B,A,G,set_or7035219750837199246ssThan(B,A3,B2)) = groups7121269368397514597t_prod(B,A,H,set_or7035219750837199246ssThan(B,C2,D2)) ) ) ) ) ) ).

% prod.ivl_cong
tff(fact_4601_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,P2: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),P2))
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,N,P2))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,P2)) ) ) ) ) ).

% sum.atLeastLessThan_concat
tff(fact_4602_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,P2: nat,F2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),P2))
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,M,P2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,M,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,N,P2)) ) ) ) ) ).

% sum_diff_nat_ivl
tff(fact_4603_size__list__estimation,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: nat,F2: fun(A,nat)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Y4),aa(A,nat,F2,X3)))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Y4),aa(list(A),nat,size_list(A,F2),Xs))) ) ) ).

% size_list_estimation
tff(fact_4604_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list(A),F2: fun(A,nat),G: fun(A,nat)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,F2,X2)),aa(A,nat,G,X2))) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_list(A,F2),Xs)),aa(list(A),nat,size_list(A,G),Xs))) ) ).

% size_list_pointwise
tff(fact_4605_size__list__estimation_H,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: nat,F2: fun(A,nat)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y4),aa(A,nat,F2,X3)))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y4),aa(list(A),nat,size_list(A,F2),Xs))) ) ) ).

% size_list_estimation'
tff(fact_4606_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,P2: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,N))),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,N,P2))) = groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,P2)) ) ) ) ) ).

% prod.atLeastLessThan_concat
tff(fact_4607_atMost__upto,axiom,
    ! [N: nat] : ( set_ord_atMost(nat,N) = aa(list(nat),set(nat),set2(nat),upt(zero_zero(nat),aa(nat,nat,suc,N))) ) ).

% atMost_upto
tff(fact_4608_map__decr__upt,axiom,
    ! [M: nat,N: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_iu(nat,nat)),upt(aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = upt(M,N) ) ).

% map_decr_upt
tff(fact_4609_map__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(nat),list(A),map(nat,A,nth(A,Xs)),upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = Xs ) ).

% map_nth
tff(fact_4610_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),set_or7035219750837199246ssThan(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),D2)) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
tff(fact_4611_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,A3,B2)),set_or1337092689740270186AtMost(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
tff(fact_4612_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( ( aa(nat,A,F2,zero_zero(nat)) = zero_zero(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
tff(fact_4613_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(nat,A,G,N)) ) ) ).

% sum.atLeast0_lessThan_Suc
tff(fact_4614_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),N))) ) ) ) ).

% sum.atLeast_Suc_lessThan
tff(fact_4615_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: nat,B2: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),B2))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,A3,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,A3,B2))),aa(nat,A,G,B2)) ) ) ) ).

% sum.atLeastLessThan_Suc
tff(fact_4616_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(nat,A,G,N)) ) ) ).

% prod.atLeast0_lessThan_Suc
tff(fact_4617_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),N))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),N))) ) ) ) ).

% prod.atLeast_Suc_lessThan
tff(fact_4618_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: nat,B2: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),B2))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,A3,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,A3,B2))),aa(nat,A,G,B2)) ) ) ) ).

% prod.atLeastLessThan_Suc
tff(fact_4619_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,N)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))) ) ) ) ).

% sum.last_plus
tff(fact_4620_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,N)),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,N))) ) ) ) ).

% prod.last_plus
tff(fact_4621_nth__map__upt,axiom,
    ! [A: $tType,I: nat,N: nat,M: nat,F2: fun(nat,A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))
     => ( aa(nat,A,nth(A,aa(list(nat),list(A),map(nat,A,F2),upt(M,N))),I) = aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I)) ) ) ).

% nth_map_upt
tff(fact_4622_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,F2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fu(fun(nat,A),fun(nat,A),F2)),set_or7035219750837199246ssThan(nat,M,N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,N)),aa(nat,A,F2,M)) ) ) ) ).

% sum_Suc_diff'
tff(fact_4623_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_iv(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or7035219750837199246ssThan(nat,N,M)) ) ) ).

% sum.atLeastLessThan_rev
tff(fact_4624_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_iw(fun(nat,fun(nat,A)),fun(nat,A),A3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_iy(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A3),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% sum.nested_swap
tff(fact_4625_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,N,M)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_iz(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M),set_or7035219750837199246ssThan(nat,N,M)) ) ) ).

% prod.atLeastLessThan_rev
tff(fact_4626_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: fun(nat,fun(nat,A)),N: nat] : ( groups7121269368397514597t_prod(nat,A,aTP_Lamp_ja(fun(nat,fun(nat,A)),fun(nat,A),A3),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A3),N),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% prod.nested_swap
tff(fact_4627_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_jd(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_ord_lessThan(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% sum.nat_group
tff(fact_4628_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),K: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_je(fun(nat,A),fun(nat,fun(nat,A)),G),K),set_ord_lessThan(nat,N)) = groups7121269368397514597t_prod(nat,A,G,set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% prod.nat_group
tff(fact_4629_prod__Suc__Suc__fact,axiom,
    ! [N: nat] : ( groups7121269368397514597t_prod(nat,nat,suc,set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = semiring_char_0_fact(nat,N) ) ).

% prod_Suc_Suc_fact
tff(fact_4630_prod__Suc__fact,axiom,
    ! [N: nat] : ( groups7121269368397514597t_prod(nat,nat,suc,set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) = semiring_char_0_fact(nat,N) ) ).

% prod_Suc_fact
tff(fact_4631_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [N: nat,M: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = zero_zero(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(nat,A,G,N)) ) ) ) ) ).

% sum.head_if
tff(fact_4632_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N)) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
           => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,N))),aa(nat,A,G,N)) ) ) ) ) ).

% prod.head_if
tff(fact_4633_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list(A),N: nat,M: nat,F2: fun(nat,A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M) )
     => ( ! [I3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs)))
           => ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I3)) ) )
       => ( aa(list(nat),list(A),map(nat,A,F2),upt(M,N)) = Xs ) ) ) ).

% map_upt_eqI
tff(fact_4634_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(nat,nat,suc,set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% fact_prod_Suc
tff(fact_4635_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_gn(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M)) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_4636_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,N,M)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_hk(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M)) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_4637_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat] : ( comm_s3205402744901411588hammer(A,A3,N) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_hq(A,fun(nat,A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_prod
tff(fact_4638_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% fact_prod_rev
tff(fact_4639_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
        <=> ! [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
             => ? [N6: nat] :
                ! [M6: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N6),M6))
                 => ! [N3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,M6,N3)))),E3)) ) ) ) ) ).

% summable_Cauchy
tff(fact_4640_sums__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F2: fun(nat,A),S: A,K: nat] :
          ( sums(A,F2,S)
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
           => sums(A,aa(nat,fun(nat,A),aTP_Lamp_jf(fun(nat,A),fun(nat,fun(nat,A)),F2),K),S) ) ) ) ).

% sums_group
tff(fact_4641_take__bit__sum,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_jg(A,fun(nat,A),A3)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% take_bit_sum
tff(fact_4642_fact__split,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( semiring_char_0_fact(A,N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(nat,nat,suc,set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K),N)))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_split
tff(fact_4643_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jh(nat,fun(nat,fun(nat,A)),K),N),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% binomial_altdef_of_nat
tff(fact_4644_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),K) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ji(A,fun(nat,fun(nat,A)),A3),K),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_altdef_of_nat
tff(fact_4645_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,gbinomial(A,A3),K)) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_jj(A,fun(nat,A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact
tff(fact_4646_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),K)),semiring_char_0_fact(A,K)) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_jj(A,fun(nat,A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact'
tff(fact_4647_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),groups7121269368397514597t_prod(nat,A,aTP_Lamp_hv(A,fun(nat,A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),K))),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_prod_rev
tff(fact_4648_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,A),A3: A,Xs: list(B)] : ( groups4207007520872428315er_sum(B,A,F2,A3,Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_jk(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F2),A3),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum
tff(fact_4649_sum__power2,axiom,
    ! [K: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2)))),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),K)),one_one(nat)) ) ).

% sum_power2
tff(fact_4650_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A3: fun(nat,A),B2: fun(nat,A)] :
          ( ! [I3: nat,J2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I3),J2))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J2),N))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,A3,I3)),aa(nat,A,A3,J2))) ) )
         => ( ! [I3: nat,J2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I3),J2))
               => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J2),N))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,B2,J2)),aa(nat,A,B2,I3))) ) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_jl(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A3),B2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))))) ) ) ) ).

% Chebyshev_sum_upper
tff(fact_4651_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A3: fun(nat,nat),B2: fun(nat,nat)] :
      ( ! [I3: nat,J2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I3),J2))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J2),N))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,A3,I3)),aa(nat,nat,A3,J2))) ) )
     => ( ! [I3: nat,J2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I3),J2))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J2),N))
             => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,B2,J2)),aa(nat,nat,B2,I3))) ) )
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(fun(nat,nat),fun(nat,nat),aTP_Lamp_jm(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),A3),B2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))))) ) ) ).

% Chebyshev_sum_upper_nat
tff(fact_4652_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( aa(vEBT_VEBT,nat,vEBT_size_VEBT,vEBT_Node(X11,X12,X13,X14)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(vEBT_VEBT),nat,size_list(vEBT_VEBT,vEBT_size_VEBT),X13)),aa(vEBT_VEBT,nat,vEBT_size_VEBT,X14))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% VEBT.size_gen(1)
tff(fact_4653_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: bool,X222: bool] : ( aa(vEBT_VEBT,nat,vEBT_size_VEBT,vEBT_Leaf(X21,X222)) = zero_zero(nat) ) ).

% VEBT.size_gen(2)
tff(fact_4654_Code__Target__Int_Opositive__def,axiom,
    code_Target_positive = numeral_numeral(int) ).

% Code_Target_Int.positive_def
tff(fact_4655_divmod__step__integer__def,axiom,
    ! [L: num,Qr: product_prod(code_integer,code_integer)] : ( unique1321980374590559556d_step(code_integer,L,Qr) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_jn(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),Qr) ) ).

% divmod_step_integer_def
tff(fact_4656_case__nat__add__eq__if,axiom,
    ! [A: $tType,A3: A,F2: fun(nat,A),V: num,N: nat] : ( case_nat(A,A3,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N)) = aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),N)) ) ).

% case_nat_add_eq_if
tff(fact_4657_case__nat__numeral,axiom,
    ! [A: $tType,A3: A,F2: fun(nat,A),V: num] : ( case_nat(A,A3,F2,aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,F2,pred_numeral(V)) ) ).

% case_nat_numeral
tff(fact_4658_sgn__integer__code,axiom,
    ! [K: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( aa(code_integer,code_integer,sgn_sgn(code_integer),K) = zero_zero(code_integer) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)))
           => ( aa(code_integer,code_integer,sgn_sgn(code_integer),K) = aa(code_integer,code_integer,uminus_uminus(code_integer),one_one(code_integer)) ) )
          & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)))
           => ( aa(code_integer,code_integer,sgn_sgn(code_integer),K) = one_one(code_integer) ) ) ) ) ) ).

% sgn_integer_code
tff(fact_4659_times__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),K),zero_zero(code_integer)) = zero_zero(code_integer) ) ).

% times_integer_code(1)
tff(fact_4660_times__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),zero_zero(code_integer)),L) = zero_zero(code_integer) ) ).

% times_integer_code(2)
tff(fact_4661_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),K),zero_zero(code_integer)) = K ) ).

% plus_integer_code(1)
tff(fact_4662_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),zero_zero(code_integer)),L) = L ) ).

% plus_integer_code(2)
tff(fact_4663_nat_Ocase__distrib,axiom,
    ! [A: $tType,B: $tType,H: fun(A,B),F1: A,F22: fun(nat,A),Nat: nat] : ( aa(A,B,H,case_nat(A,F1,F22,Nat)) = case_nat(B,aa(A,B,H,F1),aa(fun(nat,A),fun(nat,B),aTP_Lamp_jo(fun(A,B),fun(fun(nat,A),fun(nat,B)),H),F22),Nat) ) ).

% nat.case_distrib
tff(fact_4664_less__eq__integer__code_I1_J,axiom,
    pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),zero_zero(code_integer)),zero_zero(code_integer))) ).

% less_eq_integer_code(1)
tff(fact_4665_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),zero_zero(code_integer)),L) = aa(code_integer,code_integer,uminus_uminus(code_integer),L) ) ).

% minus_integer_code(2)
tff(fact_4666_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),K),zero_zero(code_integer)) = K ) ).

% minus_integer_code(1)
tff(fact_4667_divmod__integer_H__def,axiom,
    ! [M: num,N: num] : ( unique8689654367752047608divmod(code_integer,M,N) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),aa(num,code_integer,numeral_numeral(code_integer),M)),aa(num,code_integer,numeral_numeral(code_integer),N))),modulo_modulo(code_integer,aa(num,code_integer,numeral_numeral(code_integer),M),aa(num,code_integer,numeral_numeral(code_integer),N))) ) ).

% divmod_integer'_def
tff(fact_4668_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: fun(nat,A),X22: nat] : ( case_nat(A,F1,F22,aa(nat,nat,suc,X22)) = aa(nat,A,F22,X22) ) ).

% old.nat.simps(5)
tff(fact_4669_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: fun(nat,A)] : ( case_nat(A,F1,F22,zero_zero(nat)) = F1 ) ).

% old.nat.simps(4)
tff(fact_4670_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( Nat != zero_zero(nat) )
    <=> pp(case_nat(bool,fFalse,aTP_Lamp_jp(nat,bool),Nat)) ) ).

% nat.disc_eq_case(2)
tff(fact_4671_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat = zero_zero(nat) )
    <=> pp(case_nat(bool,fTrue,aTP_Lamp_jq(nat,bool),Nat)) ) ).

% nat.disc_eq_case(1)
tff(fact_4672_zero__natural_Orsp,axiom,
    zero_zero(nat) = zero_zero(nat) ).

% zero_natural.rsp
tff(fact_4673_zero__integer_Orsp,axiom,
    zero_zero(int) = zero_zero(int) ).

% zero_integer.rsp
tff(fact_4674_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,M)),N))
    <=> pp(case_nat(bool,fFalse,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N)) ) ).

% less_eq_nat.simps(2)
tff(fact_4675_diff__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,N)) = case_nat(nat,zero_zero(nat),aTP_Lamp_gs(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) ) ).

% diff_Suc
tff(fact_4676_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),bit0(W))),N))
        <=> pp(case_nat(bool,fFalse,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),N)) ) ) ).

% bit_numeral_rec(1)
tff(fact_4677_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),bit1(W))),N))
        <=> pp(case_nat(bool,fTrue,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),N)) ) ) ).

% bit_numeral_rec(2)
tff(fact_4678_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType,N: nat,X3: A,F2: fun(nat,A)] :
      ( ( ( N = zero_zero(nat) )
       => ( case_nat(A,X3,F2,N) = X3 ) )
      & ( ( N != zero_zero(nat) )
       => ( case_nat(A,X3,F2,N) = aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ) ).

% Nitpick.case_nat_unfold
tff(fact_4679_integer__of__int__code,axiom,
    ! [K: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
       => ( code_integer_of_int(K) = aa(code_integer,code_integer,uminus_uminus(code_integer),code_integer_of_int(aa(int,int,uminus_uminus(int),K))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
       => ( ( ( K = zero_zero(int) )
           => ( code_integer_of_int(K) = zero_zero(code_integer) ) )
          & ( ( K != zero_zero(int) )
           => ( code_integer_of_int(K) = if(code_integer,aa(int,bool,aa(int,fun(int,bool),fequal(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),zero_zero(int)),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))),code_integer_of_int(aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2))))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))),code_integer_of_int(aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))))),one_one(code_integer))) ) ) ) ) ) ).

% integer_of_int_code
tff(fact_4680_Code__Numeral_Opositive__def,axiom,
    code_positive = numeral_numeral(code_integer) ).

% Code_Numeral.positive_def
tff(fact_4681_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),F1: A,F22: fun(nat,A),Nat: nat] :
      ( pp(aa(A,bool,P,case_nat(A,F1,F22,Nat)))
    <=> ~ ( ( ( Nat = zero_zero(nat) )
            & ~ pp(aa(A,bool,P,F1)) )
          | ( ( Nat = aa(nat,nat,suc,pred(Nat)) )
            & ~ pp(aa(A,bool,P,aa(nat,A,F22,pred(Nat)))) ) ) ) ).

% nat.split_sels(2)
tff(fact_4682_abs__integer__code,axiom,
    ! [K: code_integer] :
      ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)))
       => ( aa(code_integer,code_integer,abs_abs(code_integer),K) = aa(code_integer,code_integer,uminus_uminus(code_integer),K) ) )
      & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)))
       => ( aa(code_integer,code_integer,abs_abs(code_integer),K) = K ) ) ) ).

% abs_integer_code
tff(fact_4683_less__integer__code_I1_J,axiom,
    ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),zero_zero(code_integer))) ).

% less_integer_code(1)
tff(fact_4684_less__integer_Oabs__eq,axiom,
    ! [Xa: int,X3: int] :
      ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X3)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Xa),X3)) ) ).

% less_integer.abs_eq
tff(fact_4685_zero__integer__def,axiom,
    zero_zero(code_integer) = code_integer_of_int(zero_zero(int)) ).

% zero_integer_def
tff(fact_4686_unset__bit__integer_Oabs__eq,axiom,
    ! [Xa: nat,X3: int] : ( aa(code_integer,code_integer,aa(nat,fun(code_integer,code_integer),bit_se2638667681897837118et_bit(code_integer),Xa),code_integer_of_int(X3)) = code_integer_of_int(aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Xa),X3)) ) ).

% unset_bit_integer.abs_eq
tff(fact_4687_divide__integer_Oabs__eq,axiom,
    ! [Xa: int,X3: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X3)) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),X3)) ) ).

% divide_integer.abs_eq
tff(fact_4688_uminus__integer__code_I1_J,axiom,
    aa(code_integer,code_integer,uminus_uminus(code_integer),zero_zero(code_integer)) = zero_zero(code_integer) ).

% uminus_integer_code(1)
tff(fact_4689_times__integer_Oabs__eq,axiom,
    ! [Xa: int,X3: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X3)) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),times_times(int),Xa),X3)) ) ).

% times_integer.abs_eq
tff(fact_4690_less__eq__integer_Oabs__eq,axiom,
    ! [Xa: int,X3: int] :
      ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X3)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Xa),X3)) ) ).

% less_eq_integer.abs_eq
tff(fact_4691_pred__def,axiom,
    ! [Nat: nat] : ( pred(Nat) = case_nat(nat,zero_zero(nat),aTP_Lamp_gs(nat,nat),Nat) ) ).

% pred_def
tff(fact_4692_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool),F1: A,F22: fun(nat,A),Nat: nat] :
      ( pp(aa(A,bool,P,case_nat(A,F1,F22,Nat)))
    <=> ( ( ( Nat = zero_zero(nat) )
         => pp(aa(A,bool,P,F1)) )
        & ( ( Nat = aa(nat,nat,suc,pred(Nat)) )
         => pp(aa(A,bool,P,aa(nat,A,F22,pred(Nat)))) ) ) ) ).

% nat.split_sels(1)
tff(fact_4693_bit__cut__integer__def,axiom,
    ! [K: code_integer] : ( code_bit_cut_integer(K) = aa(bool,product_prod(code_integer,bool),product_Pair(code_integer,bool,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),K),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa(bool,bool,fNot,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),dvd_dvd(code_integer),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))),K))) ) ).

% bit_cut_integer_def
tff(fact_4694_divmod__integer__def,axiom,
    ! [K: code_integer,L: code_integer] : ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),K),L)),modulo_modulo(code_integer,K,L)) ) ).

% divmod_integer_def
tff(fact_4695_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A3: A,F2: fun(nat,fun(A,A)),V: num,N: nat] : ( aa(nat,A,rec_nat(A,A3,F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N)) = aa(A,A,aa(nat,fun(A,A),F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),N)),aa(nat,A,rec_nat(A,A3,F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),N))) ) ).

% rec_nat_add_eq_if
tff(fact_4696_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: fun(nat,fun(T,T)),Nat: nat] : ( aa(nat,T,rec_nat(T,F1,F22),aa(nat,nat,suc,Nat)) = aa(T,T,aa(nat,fun(T,T),F22,Nat),aa(nat,T,rec_nat(T,F1,F22),Nat)) ) ).

% old.nat.simps(7)
tff(fact_4697_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: fun(nat,fun(T,T))] : ( aa(nat,T,rec_nat(T,F1,F22),zero_zero(nat)) = F1 ) ).

% old.nat.simps(6)
tff(fact_4698_rec__nat__numeral,axiom,
    ! [A: $tType,A3: A,F2: fun(nat,fun(A,A)),V: num] : ( aa(nat,A,rec_nat(A,A3,F2),aa(num,nat,numeral_numeral(nat),V)) = aa(A,A,aa(nat,fun(A,A),F2,pred_numeral(V)),aa(nat,A,rec_nat(A,A3,F2),pred_numeral(V))) ) ).

% rec_nat_numeral
tff(fact_4699_old_Orec__nat__def,axiom,
    ! [T: $tType,X: T,Xa2: fun(nat,fun(T,T)),Xb3: nat] : ( aa(nat,T,rec_nat(T,X,Xa2),Xb3) = the(T,rec_set_nat(T,X,Xa2,Xb3)) ) ).

% old.rec_nat_def
tff(fact_4700_bit__cut__integer__code,axiom,
    ! [K: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_bit_cut_integer(K) = aa(bool,product_prod(code_integer,bool),product_Pair(code_integer,bool,zero_zero(code_integer)),fFalse) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( code_bit_cut_integer(K) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,bool),product_case_prod(code_integer,code_integer,product_prod(code_integer,bool),aTP_Lamp_jr(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,bool))),K)),code_divmod_abs(K,aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))) ) ) ) ).

% bit_cut_integer_code
tff(fact_4701_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: fun(nat,A),F1: A,F22: fun(nat,fun(A,A))] :
      ( ( F2 = rec_nat(A,F1,F22) )
     => ( aa(nat,A,F2,zero_zero(nat)) = F1 ) ) ).

% rec_nat_0_imp
tff(fact_4702_divmod__abs__code_I6_J,axiom,
    ! [J3: code_integer] : ( code_divmod_abs(zero_zero(code_integer),J3) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)) ) ).

% divmod_abs_code(6)
tff(fact_4703_subset__Collect__iff,axiom,
    ! [A: $tType,B3: set(A),A2: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),collect(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aa(set(A),fun(fun(A,bool),fun(A,bool)),A2),P))))
      <=> ! [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),B3))
           => pp(aa(A,bool,P,X4)) ) ) ) ).

% subset_Collect_iff
tff(fact_4704_subset__CollectI,axiom,
    ! [A: $tType,B3: set(A),A2: set(A),Q: fun(A,bool),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),B3))
           => ( pp(aa(A,bool,Q,X2))
             => pp(aa(A,bool,P,X2)) ) )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),collect(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aa(set(A),fun(fun(A,bool),fun(A,bool)),B3),Q))),collect(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aa(set(A),fun(fun(A,bool),fun(A,bool)),A2),P)))) ) ) ).

% subset_CollectI
tff(fact_4705_divmod__abs__code_I5_J,axiom,
    ! [J3: code_integer] : ( code_divmod_abs(J3,zero_zero(code_integer)) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),aa(code_integer,code_integer,abs_abs(code_integer),J3)) ) ).

% divmod_abs_code(5)
tff(fact_4706_floor__real__def,axiom,
    ! [X3: real] : ( archim6421214686448440834_floor(real,X3) = the(int,aTP_Lamp_js(real,fun(int,bool),X3)) ) ).

% floor_real_def
tff(fact_4707_divmod__abs__def,axiom,
    ! [K: code_integer,L: code_integer] : ( code_divmod_abs(K,L) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),K)),aa(code_integer,code_integer,abs_abs(code_integer),L))),modulo_modulo(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))) ) ).

% divmod_abs_def
tff(fact_4708_divmod__integer__code,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),L))
           => ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),K))
               => ( code_divmod_integer(K,L) = code_divmod_abs(K,L) ) )
              & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),K))
               => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_jt(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)) ) ) ) )
          & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),L))
           => ( ( ( L = zero_zero(code_integer) )
               => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),K) ) )
              & ( ( L != zero_zero(code_integer) )
               => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_apsnd(code_integer,code_integer,code_integer),uminus_uminus(code_integer)),if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_ju(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ) ) ) ).

% divmod_integer_code
tff(fact_4709_floor__rat__def,axiom,
    ! [X3: rat] : ( archim6421214686448440834_floor(rat,X3) = the(int,aTP_Lamp_jv(rat,fun(int,bool),X3)) ) ).

% floor_rat_def
tff(fact_4710_or__int__rec,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fdisj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ).

% or_int_rec
tff(fact_4711_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2) ) ) ).

% or.right_idem
tff(fact_4712_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2) ) ) ).

% or.left_idem
tff(fact_4713_or_Oidem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),A3) = A3 ) ) ).

% or.idem
tff(fact_4714_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),zero_zero(A)),A3) = A3 ) ) ).

% or.left_neutral
tff(fact_4715_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),zero_zero(A)) = A3 ) ) ).

% or.right_neutral
tff(fact_4716_take__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)),aa(A,A,bit_se2584673776208193580ke_bit(A,N),B2)) ) ) ).

% take_bit_or
tff(fact_4717_push__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A3)),aa(A,A,bit_se4730199178511100633sh_bit(A,N),B2)) ) ) ).

% push_bit_or
tff(fact_4718_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_right
tff(fact_4719_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,uminus_uminus(A),one_one(A))),X3) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_left
tff(fact_4720_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),L)) ) ) ).

% or_nonnegative_int_iff
tff(fact_4721_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)),zero_zero(int)))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
        | pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int))) ) ) ).

% or_negative_int_iff
tff(fact_4722_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y4)) ) ) ).

% bit.de_Morgan_disj
tff(fact_4723_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y4)) ) ) ).

% bit.de_Morgan_conj
tff(fact_4724_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),bit1(Y4))) = aa(num,A,numeral_numeral(A),bit1(Y4)) ) ) ).

% or_numerals(2)
tff(fact_4725_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit1(X3))),one_one(A)) = aa(num,A,numeral_numeral(A),bit1(X3)) ) ) ).

% or_numerals(8)
tff(fact_4726_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)),X3) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_left
tff(fact_4727_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_right
tff(fact_4728_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit0(X3))),aa(num,A,numeral_numeral(A),bit0(Y4))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4))) ) ) ).

% or_numerals(3)
tff(fact_4729_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit0(X3))),one_one(A)) = aa(num,A,numeral_numeral(A),bit1(X3)) ) ) ).

% or_numerals(5)
tff(fact_4730_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(Y4))) = aa(num,A,numeral_numeral(A),bit1(Y4)) ) ) ).

% or_numerals(1)
tff(fact_4731_or__minus__numerals_I6_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(N)))),one_one(int)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(N))) ) ).

% or_minus_numerals(6)
tff(fact_4732_or__minus__numerals_I2_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(N)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(N))) ) ).

% or_minus_numerals(2)
tff(fact_4733_and__minus__minus__numerals,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),N)),one_one(int)))) ) ).

% and_minus_minus_numerals
tff(fact_4734_or__minus__minus__numerals,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),N)),one_one(int)))) ) ).

% or_minus_minus_numerals
tff(fact_4735_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit0(X3))),aa(num,A,numeral_numeral(A),bit1(Y4))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4)))) ) ) ).

% or_numerals(4)
tff(fact_4736_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit1(X3))),aa(num,A,numeral_numeral(A),bit0(Y4))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4)))) ) ) ).

% or_numerals(6)
tff(fact_4737_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X3: num,Y4: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit1(X3))),aa(num,A,numeral_numeral(A),bit1(Y4))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X3)),aa(num,A,numeral_numeral(A),Y4)))) ) ) ).

% or_numerals(7)
tff(fact_4738_sgn__rat__def,axiom,
    ! [A3: rat] :
      ( ( ( A3 = zero_zero(rat) )
       => ( aa(rat,rat,sgn_sgn(rat),A3) = zero_zero(rat) ) )
      & ( ( A3 != zero_zero(rat) )
       => ( ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),zero_zero(rat)),A3))
           => ( aa(rat,rat,sgn_sgn(rat),A3) = one_one(rat) ) )
          & ( ~ pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),zero_zero(rat)),A3))
           => ( aa(rat,rat,sgn_sgn(rat),A3) = aa(rat,rat,uminus_uminus(rat),one_one(rat)) ) ) ) ) ) ).

% sgn_rat_def
tff(fact_4739_obtain__pos__sum,axiom,
    ! [R2: rat] :
      ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),zero_zero(rat)),R2))
     => ~ ! [S3: rat] :
            ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),zero_zero(rat)),S3))
           => ! [T3: rat] :
                ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),zero_zero(rat)),T3))
               => ( R2 != aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),S3),T3) ) ) ) ) ).

% obtain_pos_sum
tff(fact_4740_less__eq__rat__def,axiom,
    ! [X3: rat,Y4: rat] :
      ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),X3),Y4))
    <=> ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),X3),Y4))
        | ( X3 = Y4 ) ) ) ).

% less_eq_rat_def
tff(fact_4741_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),zero_zero(A)) = X3 ) ) ).

% bit.disj_zero_right
tff(fact_4742_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2) = zero_zero(A) )
        <=> ( ( A3 = zero_zero(A) )
            & ( B2 = zero_zero(A) ) ) ) ) ).

% or_eq_0_iff
tff(fact_4743_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_or_eq
tff(fact_4744_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),C2)) ) ) ).

% or.left_commute
tff(fact_4745_or_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),A3) ) ) ).

% or.commute
tff(fact_4746_or_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),C2)) ) ) ).

% or.assoc
tff(fact_4747_bit__or__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2)),N))
        <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
            | pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,B2),N)) ) ) ) ).

% bit_or_iff
tff(fact_4748_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y4),Z)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),Z)) ) ) ).

% bit.conj_disj_distrib
tff(fact_4749_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y4),Z)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),Z)) ) ) ).

% bit.disj_conj_distrib
tff(fact_4750_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y4: A,Z: A,X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y4),Z)),X3) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y4),X3)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Z),X3)) ) ) ).

% bit.conj_disj_distrib2
tff(fact_4751_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y4: A,Z: A,X3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y4),Z)),X3) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y4),X3)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Z),X3)) ) ) ).

% bit.disj_conj_distrib2
tff(fact_4752_bit__or__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)),N))
    <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,K),N))
        | pp(aa(nat,bool,bit_se5641148757651400278ts_bit(int,L),N)) ) ) ).

% bit_or_int_iff
tff(fact_4753_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(int,A,ring_1_of_int(A),K)),aa(int,A,ring_1_of_int(A),L)) ) ) ).

% of_int_or_eq
tff(fact_4754_abs__rat__def,axiom,
    ! [A3: rat] :
      ( ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),A3),zero_zero(rat)))
       => ( aa(rat,rat,abs_abs(rat),A3) = aa(rat,rat,uminus_uminus(rat),A3) ) )
      & ( ~ pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),A3),zero_zero(rat)))
       => ( aa(rat,rat,abs_abs(rat),A3) = A3 ) ) ) ).

% abs_rat_def
tff(fact_4755_OR__lower,axiom,
    ! [X3: int,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
       => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X3),Y4))) ) ) ).

% OR_lower
tff(fact_4756_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),L))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),K),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L))) ) ).

% or_greater_eq
tff(fact_4757_disjunctive__add,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] :
          ( ! [N2: nat] :
              ( ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N2))
              | ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,B2),N2)) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2) ) ) ) ).

% disjunctive_add
tff(fact_4758_plus__and__or,axiom,
    ! [X3: int,Y4: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X3),Y4)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X3),Y4)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),Y4) ) ).

% plus_and_or
tff(fact_4759_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)),aa(A,A,bit_ri4277139882892585799ns_not(A),B2))) ) ) ).

% or_eq_not_not_and
tff(fact_4760_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)),aa(A,A,bit_ri4277139882892585799ns_not(A),B2))) ) ) ).

% and_eq_not_not_or
tff(fact_4761_or__int__def,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),aa(int,int,bit_ri4277139882892585799ns_not(int),L))) ) ).

% or_int_def
tff(fact_4762_or__not__numerals_I1_J,axiom,
    aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),zero_zero(int)) ).

% or_not_numerals(1)
tff(fact_4763_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),Y4) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y4))) ) ) ).

% bit.xor_def2
tff(fact_4764_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X3),Y4) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),aa(A,A,bit_ri4277139882892585799ns_not(A),Y4))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X3)),Y4)) ) ) ).

% bit.xor_def
tff(fact_4765_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),N),A3) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A))) ) ) ).

% set_bit_eq_or
tff(fact_4766_xor__int__def,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),aa(int,int,bit_ri4277139882892585799ns_not(int),L))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),L)) ) ).

% xor_int_def
tff(fact_4767_concat__bit__def,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(N,K),L) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,bit_se4730199178511100633sh_bit(int,N),L)) ) ).

% concat_bit_def
tff(fact_4768_set__bit__int__def,axiom,
    ! [N: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),N),K) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),aa(int,int,bit_se4730199178511100633sh_bit(int,N),one_one(int))) ) ).

% set_bit_int_def
tff(fact_4769_even__or__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) ) ) ) ).

% even_or_iff
tff(fact_4770_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),X3) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),X3) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),Y4) = zero_zero(A) )
             => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),Y4) = aa(A,A,uminus_uminus(A),one_one(A)) )
               => ( X3 = Y4 ) ) ) ) ) ) ).

% bit.complement_unique
tff(fact_4771_or__not__numerals_I2_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N))) ) ).

% or_not_numerals(2)
tff(fact_4772_or__not__numerals_I4_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int)) ) ).

% or_not_numerals(4)
tff(fact_4773_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X3),Y4) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X3),Y4) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( aa(A,A,bit_ri4277139882892585799ns_not(A),X3) = Y4 ) ) ) ) ).

% bit.compl_unique
tff(fact_4774_or__not__numerals_I3_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit1(N)))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N))) ) ).

% or_not_numerals(3)
tff(fact_4775_or__not__numerals_I7_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit1(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),zero_zero(int)) ) ).

% or_not_numerals(7)
tff(fact_4776_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
         => ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N))) ) ) ) ).

% signed_take_bit_eq_if_negative
tff(fact_4777_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),bit_se2239418461657761734s_mask(A,N)) ) ) ).

% mask_Suc_exp
tff(fact_4778_or__not__numerals_I6_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit1(N)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% or_not_numerals(6)
tff(fact_4779_or__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),one_one(A)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))) ) ) ).

% or_one_eq
tff(fact_4780_one__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A3))) ) ) ).

% one_or_eq
tff(fact_4781_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se2239418461657761734s_mask(A,N))) ) ) ).

% mask_Suc_double
tff(fact_4782_OR__upper,axiom,
    ! [X3: int,N: nat,Y4: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X3),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Y4),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)))
         => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X3),Y4)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ) ) ).

% OR_upper
tff(fact_4783_or__not__numerals_I5_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))))) ) ).

% or_not_numerals(5)
tff(fact_4784_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)))) ) ) ).

% signed_take_bit_def
tff(fact_4785_or__not__numerals_I9_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit1(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit1(N)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))))) ) ).

% or_not_numerals(9)
tff(fact_4786_or__not__numerals_I8_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit1(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))))) ) ).

% or_not_numerals(8)
tff(fact_4787_or__minus__numerals_I5_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))),one_one(int)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(one2,bitM(N)))) ) ).

% or_minus_numerals(5)
tff(fact_4788_or__minus__numerals_I1_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(one2,bitM(N)))) ) ).

% or_minus_numerals(1)
tff(fact_4789_or__int__unfold,axiom,
    ! [K: int,L: int] :
      ( ( ( ( K = aa(int,int,uminus_uminus(int),one_one(int)) )
          | ( L = aa(int,int,uminus_uminus(int),one_one(int)) ) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L) = aa(int,int,uminus_uminus(int),one_one(int)) ) )
      & ( ~ ( ( K = aa(int,int,uminus_uminus(int),one_one(int)) )
            | ( L = aa(int,int,uminus_uminus(int),one_one(int)) ) )
       => ( ( ( K = zero_zero(int) )
           => ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L) = L ) )
          & ( ( K != zero_zero(int) )
           => ( ( ( L = zero_zero(int) )
               => ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L) = K ) )
              & ( ( L != zero_zero(int) )
               => ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),ord_max(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),bit0(one2))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ) ) ) ) ) ).

% or_int_unfold
tff(fact_4790_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool,Q: bool] : ( aa(bool,A,zero_neq_one_of_bool(A),fdisj(P,Q)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_or_iff
tff(fact_4791_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)) = aa(num,A,numeral_numeral(A),V) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)) = aa(num,A,numeral_numeral(A),U) ) ) ) ) ).

% max_number_of(1)
tff(fact_4792_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),X3)),zero_zero(A)) = aa(num,A,numeral_numeral(A),X3) ) ) ).

% max_0_1(4)
tff(fact_4793_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),aa(num,A,numeral_numeral(A),X3)) = aa(num,A,numeral_numeral(A),X3) ) ) ).

% max_0_1(3)
tff(fact_4794_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),zero_zero(A)) = one_one(A) ) ) ).

% max_0_1(2)
tff(fact_4795_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),one_one(A)) = one_one(A) ) ) ).

% max_0_1(1)
tff(fact_4796_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),X3)),one_one(A)) = aa(num,A,numeral_numeral(A),X3) ) ) ).

% max_0_1(6)
tff(fact_4797_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),aa(num,A,numeral_numeral(A),X3)) = aa(num,A,numeral_numeral(A),X3) ) ) ).

% max_0_1(5)
tff(fact_4798_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)) ) ) ) ) ).

% max_number_of(4)
tff(fact_4799_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)) = aa(num,A,numeral_numeral(A),V) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)) ) ) ) ) ).

% max_number_of(3)
tff(fact_4800_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(num,A,numeral_numeral(A),U) ) ) ) ) ).

% max_number_of(2)
tff(fact_4801_or__nat__numerals_I2_J,axiom,
    ! [Y4: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit1(Y4))) = aa(num,nat,numeral_numeral(nat),bit1(Y4)) ) ).

% or_nat_numerals(2)
tff(fact_4802_or__nat__numerals_I4_J,axiom,
    ! [X3: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(num,nat,numeral_numeral(nat),bit1(X3))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),bit1(X3)) ) ).

% or_nat_numerals(4)
tff(fact_4803_or__nat__numerals_I1_J,axiom,
    ! [Y4: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(Y4))) = aa(num,nat,numeral_numeral(nat),bit1(Y4)) ) ).

% or_nat_numerals(1)
tff(fact_4804_or__nat__numerals_I3_J,axiom,
    ! [X3: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(num,nat,numeral_numeral(nat),bit0(X3))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),bit1(X3)) ) ).

% or_nat_numerals(3)
tff(fact_4805_or__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(N)))),aa(num,int,numeral_numeral(int),M)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,bit0(N)))) ) ).

% or_minus_numerals(8)
tff(fact_4806_or__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(N)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,bit0(N)))) ) ).

% or_minus_numerals(4)
tff(fact_4807_or__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,bitM(N)))) ) ).

% or_minus_numerals(3)
tff(fact_4808_or__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))),aa(num,int,numeral_numeral(int),M)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,bitM(N)))) ) ).

% or_minus_numerals(7)
tff(fact_4809_max__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Xa2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Xa2))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X),Xa2) = Xa2 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Xa2))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X),Xa2) = X ) ) ) ) ).

% max_def_raw
tff(fact_4810_of__int__max,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: int,Y4: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),ord_max(int),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(int,A,ring_1_of_int(A),X3)),aa(int,A,ring_1_of_int(A),Y4)) ) ) ).

% of_int_max
tff(fact_4811_max__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = B2 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = A3 ) ) ) ) ).

% max_def
tff(fact_4812_max__absorb1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4) = X3 ) ) ) ).

% max_absorb1
tff(fact_4813_max__absorb2,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4) = Y4 ) ) ) ).

% max_absorb2
tff(fact_4814_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),ord_max(A),Y4),Z)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Z)) ) ) ).

% max_add_distrib_right
tff(fact_4815_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)),Z) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Z)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y4),Z)) ) ) ).

% max_add_distrib_left
tff(fact_4816_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)),Z) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Z)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),Z)) ) ) ).

% max_diff_distrib_left
tff(fact_4817_or__not__num__neg_Osimps_I1_J,axiom,
    bit_or_not_num_neg(one2,one2) = one2 ).

% or_not_num_neg.simps(1)
tff(fact_4818_of__nat__max,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: nat,Y4: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(nat,A,semiring_1_of_nat(A),X3)),aa(nat,A,semiring_1_of_nat(A),Y4)) ) ) ).

% of_nat_max
tff(fact_4819_set__bit__nat__def,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5668285175392031749et_bit(nat),M),N) = aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),N),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),one_one(nat))) ) ).

% set_bit_nat_def
tff(fact_4820_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N: num] : ( bit_or_not_num_neg(bit0(N),one2) = bit0(one2) ) ).

% or_not_num_neg.simps(4)
tff(fact_4821_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N: num,M: num] : ( bit_or_not_num_neg(bit0(N),bit1(M)) = bit0(bit_or_not_num_neg(N,M)) ) ).

% or_not_num_neg.simps(6)
tff(fact_4822_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] : ( bit_or_not_num_neg(one2,bit1(M)) = bit1(M) ) ).

% or_not_num_neg.simps(3)
tff(fact_4823_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N: num] : ( bit_or_not_num_neg(bit1(N),one2) = one2 ) ).

% or_not_num_neg.simps(7)
tff(fact_4824_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N: num,M: num] : ( bit_or_not_num_neg(bit0(N),bit0(M)) = bitM(bit_or_not_num_neg(N,M)) ) ).

% or_not_num_neg.simps(5)
tff(fact_4825_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N: num,M: num] : ( bit_or_not_num_neg(bit1(N),bit1(M)) = bitM(bit_or_not_num_neg(N,M)) ) ).

% or_not_num_neg.simps(9)
tff(fact_4826_or__nat__def,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% or_nat_def
tff(fact_4827_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] : ( bit_or_not_num_neg(one2,bit0(M)) = bit1(M) ) ).

% or_not_num_neg.simps(2)
tff(fact_4828_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N: num,M: num] : ( bit_or_not_num_neg(bit1(N),bit0(M)) = bitM(bit_or_not_num_neg(N,M)) ) ).

% or_not_num_neg.simps(8)
tff(fact_4829_or__not__num__neg_Oelims,axiom,
    ! [X3: num,Xa: num,Y4: num] :
      ( ( bit_or_not_num_neg(X3,Xa) = Y4 )
     => ( ( ( X3 = one2 )
         => ( ( Xa = one2 )
           => ( Y4 != one2 ) ) )
       => ( ( ( X3 = one2 )
           => ! [M3: num] :
                ( ( Xa = bit0(M3) )
               => ( Y4 != bit1(M3) ) ) )
         => ( ( ( X3 = one2 )
             => ! [M3: num] :
                  ( ( Xa = bit1(M3) )
                 => ( Y4 != bit1(M3) ) ) )
           => ( ( ? [N2: num] : ( X3 = bit0(N2) )
               => ( ( Xa = one2 )
                 => ( Y4 != bit0(one2) ) ) )
             => ( ! [N2: num] :
                    ( ( X3 = bit0(N2) )
                   => ! [M3: num] :
                        ( ( Xa = bit0(M3) )
                       => ( Y4 != bitM(bit_or_not_num_neg(N2,M3)) ) ) )
               => ( ! [N2: num] :
                      ( ( X3 = bit0(N2) )
                     => ! [M3: num] :
                          ( ( Xa = bit1(M3) )
                         => ( Y4 != bit0(bit_or_not_num_neg(N2,M3)) ) ) )
                 => ( ( ? [N2: num] : ( X3 = bit1(N2) )
                     => ( ( Xa = one2 )
                       => ( Y4 != one2 ) ) )
                   => ( ! [N2: num] :
                          ( ( X3 = bit1(N2) )
                         => ! [M3: num] :
                              ( ( Xa = bit0(M3) )
                             => ( Y4 != bitM(bit_or_not_num_neg(N2,M3)) ) ) )
                     => ~ ! [N2: num] :
                            ( ( X3 = bit1(N2) )
                           => ! [M3: num] :
                                ( ( Xa = bit1(M3) )
                               => ( Y4 != bitM(bit_or_not_num_neg(N2,M3)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
tff(fact_4830_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,N))) ) ).

% int_numeral_or_not_num_neg
tff(fact_4831_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),N)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(N,M))) ) ).

% int_numeral_not_or_num_neg
tff(fact_4832_numeral__or__not__num__eq,axiom,
    ! [M: num,N: num] : ( aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,N)) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% numeral_or_not_num_eq
tff(fact_4833_Suc__0__or__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(bool,nat,zero_neq_one_of_bool(nat),aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ).

% Suc_0_or_eq
tff(fact_4834_or__Suc__0__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),N),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(bool,nat,zero_neq_one_of_bool(nat),aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ).

% or_Suc_0_eq
tff(fact_4835_or__nat__rec,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(bool,nat,zero_neq_one_of_bool(nat),fdisj(aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% or_nat_rec
tff(fact_4836_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)),Z))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Z))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),Z)) ) ) ) ).

% max_less_iff_conj
tff(fact_4837_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = B2 ) ) ) ).

% max.absorb4
tff(fact_4838_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = A3 ) ) ) ).

% max.absorb3
tff(fact_4839_max__enat__simps_I4_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ).

% max_enat_simps(4)
tff(fact_4840_max__enat__simps_I5_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),extend4730790105801354508finity(extended_enat)),Q2) = extend4730790105801354508finity(extended_enat) ) ).

% max_enat_simps(5)
tff(fact_4841_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),zero_zero(extended_enat)),Q2) = Q2 ) ).

% max_enat_simps(3)
tff(fact_4842_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),Q2),zero_zero(extended_enat)) = Q2 ) ).

% max_enat_simps(2)
tff(fact_4843_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = A3 ) ) ) ).

% max.absorb1
tff(fact_4844_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = B2 ) ) ) ).

% max.absorb2
tff(fact_4845_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% max.bounded_iff
tff(fact_4846_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),N)) ) ).

% max_Suc_Suc
tff(fact_4847_max__0R,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),zero_zero(nat)) = N ) ).

% max_0R
tff(fact_4848_max__0L,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),zero_zero(nat)),N) = N ) ).

% max_0L
tff(fact_4849_max__nat_Oright__neutral,axiom,
    ! [A3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A3),zero_zero(nat)) = A3 ) ).

% max_nat.right_neutral
tff(fact_4850_max__nat_Oneutr__eq__iff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( zero_zero(nat) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A3),B2) )
    <=> ( ( A3 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% max_nat.neutr_eq_iff
tff(fact_4851_max__nat_Oleft__neutral,axiom,
    ! [A3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),zero_zero(nat)),A3) = A3 ) ).

% max_nat.left_neutral
tff(fact_4852_max__nat_Oeq__neutr__iff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A3),B2) = zero_zero(nat) )
    <=> ( ( A3 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% max_nat.eq_neutr_iff
tff(fact_4853_max__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),extended_enat2(M)),extended_enat2(N)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),N)) ) ).

% max_enat_simps(1)
tff(fact_4854_max__Suc__numeral,axiom,
    ! [N: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),pred_numeral(K))) ) ).

% max_Suc_numeral
tff(fact_4855_max__numeral__Suc,axiom,
    ! [K: num,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),pred_numeral(K)),N)) ) ).

% max_numeral_Suc
tff(fact_4856_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)) ) ).

% nat_mult_max_right
tff(fact_4857_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),N)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) ) ).

% nat_mult_max_left
tff(fact_4858_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q2)) ) ).

% nat_add_max_right
tff(fact_4859_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),N)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),Q2)) ) ).

% nat_add_max_left
tff(fact_4860_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)),M) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),M) ) ).

% nat_minus_add_max
tff(fact_4861_max__Suc1,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,N)),M) = case_nat(nat,aa(nat,nat,suc,N),aTP_Lamp_jw(nat,fun(nat,nat),N),M) ) ).

% max_Suc1
tff(fact_4862_max__Suc2,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),aa(nat,nat,suc,N)) = case_nat(nat,aa(nat,nat,suc,N),aTP_Lamp_jx(nat,fun(nat,nat),N),M) ) ).

% max_Suc2
tff(fact_4863_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ).

% max.coboundedI2
tff(fact_4864_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ).

% max.coboundedI1
tff(fact_4865_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = B2 ) ) ) ).

% max.absorb_iff2
tff(fact_4866_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = A3 ) ) ) ).

% max.absorb_iff1
tff(fact_4867_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),X3))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),Y4)) ) ) ) ).

% le_max_iff_disj
tff(fact_4868_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ).

% max.cobounded2
tff(fact_4869_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ).

% max.cobounded1
tff(fact_4870_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) ) ) ) ).

% max.order_iff
tff(fact_4871_max_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3)) ) ) ) ).

% max.boundedI
tff(fact_4872_max_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% max.boundedE
tff(fact_4873_max_OorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% max.orderI
tff(fact_4874_max_OorderE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( A3 = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) ) ) ) ).

% max.orderE
tff(fact_4875_max_Omono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A3: A,D2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),C2),D2)),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ) ).

% max.mono
tff(fact_4876_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),X3))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),Y4)) ) ) ) ).

% less_max_iff_disj
tff(fact_4877_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% max.strict_boundedE
tff(fact_4878_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
        <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) )
            & ( A3 != B2 ) ) ) ) ).

% max.strict_order_iff
tff(fact_4879_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ).

% max.strict_coboundedI1
tff(fact_4880_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ).

% max.strict_coboundedI2
tff(fact_4881_or__nat__unfold,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M = zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N) = N ) )
      & ( ( M != zero_zero(nat) )
       => ( ( ( N = zero_zero(nat) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N) = M ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ) ) ) ).

% or_nat_unfold
tff(fact_4882_or__not__num__neg_Opelims,axiom,
    ! [X3: num,Xa: num,Y4: num] :
      ( ( bit_or_not_num_neg(X3,Xa) = Y4 )
     => ( pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,X3),Xa)))
       => ( ( ( X3 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y4 = one2 )
               => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,one2),one2))) ) ) )
         => ( ( ( X3 = one2 )
             => ! [M3: num] :
                  ( ( Xa = bit0(M3) )
                 => ( ( Y4 = bit1(M3) )
                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,one2),bit0(M3)))) ) ) )
           => ( ( ( X3 = one2 )
               => ! [M3: num] :
                    ( ( Xa = bit1(M3) )
                   => ( ( Y4 = bit1(M3) )
                     => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,one2),bit1(M3)))) ) ) )
             => ( ! [N2: num] :
                    ( ( X3 = bit0(N2) )
                   => ( ( Xa = one2 )
                     => ( ( Y4 = bit0(one2) )
                       => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,bit0(N2)),one2))) ) ) )
               => ( ! [N2: num] :
                      ( ( X3 = bit0(N2) )
                     => ! [M3: num] :
                          ( ( Xa = bit0(M3) )
                         => ( ( Y4 = bitM(bit_or_not_num_neg(N2,M3)) )
                           => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,bit0(N2)),bit0(M3)))) ) ) )
                 => ( ! [N2: num] :
                        ( ( X3 = bit0(N2) )
                       => ! [M3: num] :
                            ( ( Xa = bit1(M3) )
                           => ( ( Y4 = bit0(bit_or_not_num_neg(N2,M3)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,bit0(N2)),bit1(M3)))) ) ) )
                   => ( ! [N2: num] :
                          ( ( X3 = bit1(N2) )
                         => ( ( Xa = one2 )
                           => ( ( Y4 = one2 )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,bit1(N2)),one2))) ) ) )
                     => ( ! [N2: num] :
                            ( ( X3 = bit1(N2) )
                           => ! [M3: num] :
                                ( ( Xa = bit0(M3) )
                               => ( ( Y4 = bitM(bit_or_not_num_neg(N2,M3)) )
                                 => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,bit1(N2)),bit0(M3)))) ) ) )
                       => ~ ! [N2: num] :
                              ( ( X3 = bit1(N2) )
                             => ! [M3: num] :
                                  ( ( Xa = bit1(M3) )
                                 => ( ( Y4 = bitM(bit_or_not_num_neg(N2,M3)) )
                                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),product_Pair(num,num,bit1(N2)),bit1(M3)))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
tff(fact_4883_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea3799213064322606851m_diff(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A)),bit_se5824344971392196577ns_xor(A)) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
tff(fact_4884_rat__inverse__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,inverse_inverse(rat),P2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_jy(int,fun(int,product_prod(int,int)))),quotient_of(P2)) ) ).

% rat_inverse_code
tff(fact_4885_quotient__of__number_I3_J,axiom,
    ! [K: num] : ( quotient_of(aa(num,rat,numeral_numeral(rat),K)) = aa(int,product_prod(int,int),product_Pair(int,int,aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% quotient_of_number(3)
tff(fact_4886_rat__zero__code,axiom,
    quotient_of(zero_zero(rat)) = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)) ).

% rat_zero_code
tff(fact_4887_quotient__of__number_I5_J,axiom,
    ! [K: num] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K))) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)) ) ).

% quotient_of_number(5)
tff(fact_4888_divide__rat__def,axiom,
    ! [Q2: rat,R2: rat] : ( aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),Q2),R2) = aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),Q2),aa(rat,rat,inverse_inverse(rat),R2)) ) ).

% divide_rat_def
tff(fact_4889_quotient__of__div,axiom,
    ! [R2: rat,N: int,D2: int] :
      ( ( quotient_of(R2) = aa(int,product_prod(int,int),product_Pair(int,int,N),D2) )
     => ( R2 = aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),aa(int,rat,ring_1_of_int(rat),N)),aa(int,rat,ring_1_of_int(rat),D2)) ) ) ).

% quotient_of_div
tff(fact_4890_quotient__of__denom__pos,axiom,
    ! [R2: rat,P2: int,Q2: int] :
      ( ( quotient_of(R2) = aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2) )
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Q2)) ) ).

% quotient_of_denom_pos
tff(fact_4891_rat__less__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),P2),Q2))
    <=> pp(aa(product_prod(int,int),bool,product_case_prod(int,int,bool,aTP_Lamp_ka(rat,fun(int,fun(int,bool)),Q2)),quotient_of(P2))) ) ).

% rat_less_code
tff(fact_4892_rat__less__eq__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),P2),Q2))
    <=> pp(aa(product_prod(int,int),bool,product_case_prod(int,int,bool,aTP_Lamp_kc(rat,fun(int,fun(int,bool)),Q2)),quotient_of(P2))) ) ).

% rat_less_eq_code
tff(fact_4893_rat__plus__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_ke(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_plus_code
tff(fact_4894_rat__minus__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_kg(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_minus_code
tff(fact_4895_normalize__negative,axiom,
    ! [Q2: int,P2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Q2),zero_zero(int)))
     => ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2)) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,uminus_uminus(int),P2)),aa(int,int,uminus_uminus(int),Q2))) ) ) ).

% normalize_negative
tff(fact_4896_normalize__denom__zero,axiom,
    ! [P2: int] : ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P2),zero_zero(int))) = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)) ) ).

% normalize_denom_zero
tff(fact_4897_normalize__denom__pos,axiom,
    ! [R2: product_prod(int,int),P2: int,Q2: int] :
      ( ( normalize(R2) = aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2) )
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Q2)) ) ).

% normalize_denom_pos
tff(fact_4898_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P2: int,R2: int] :
      ( ( Q2 != zero_zero(int) )
     => ( ( S != zero_zero(int) )
       => ( ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2)) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,R2),S)) )
         => ( aa(int,int,aa(int,fun(int,int),times_times(int),P2),S) = aa(int,int,aa(int,fun(int,int),times_times(int),R2),Q2) ) ) ) ) ).

% normalize_crossproduct
tff(fact_4899_rat__divide__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_ki(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_divide_code
tff(fact_4900_rat__times__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_kk(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_times_code
tff(fact_4901_Frct__code__post_I5_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),aa(num,int,numeral_numeral(int),K))) = aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),one_one(rat)),aa(num,rat,numeral_numeral(rat),K)) ) ).

% Frct_code_post(5)
tff(fact_4902_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,aa(num,int,numeral_numeral(int),K)),aa(num,int,numeral_numeral(int),L))) = aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),aa(num,rat,numeral_numeral(rat),K)),aa(num,rat,numeral_numeral(rat),L)) ) ).

% Frct_code_post(6)
tff(fact_4903_prod__decode__aux_Oelims,axiom,
    ! [X3: nat,Xa: nat,Y4: product_prod(nat,nat)] :
      ( ( nat_prod_decode_aux(X3,Xa) = Y4 )
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Xa),X3))
         => ( Y4 = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X3),Xa)) ) )
        & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Xa),X3))
         => ( Y4 = nat_prod_decode_aux(aa(nat,nat,suc,X3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),aa(nat,nat,suc,X3))) ) ) ) ) ).

% prod_decode_aux.elims
tff(fact_4904_Frct__code__post_I1_J,axiom,
    ! [A3: int] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),A3)) = zero_zero(rat) ) ).

% Frct_code_post(1)
tff(fact_4905_Frct__code__post_I2_J,axiom,
    ! [A3: int] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,A3),zero_zero(int))) = zero_zero(rat) ) ).

% Frct_code_post(2)
tff(fact_4906_Frct__code__post_I4_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,aa(num,int,numeral_numeral(int),K)),one_one(int))) = aa(num,rat,numeral_numeral(rat),K) ) ).

% Frct_code_post(4)
tff(fact_4907_prod__decode__aux_Osimps,axiom,
    ! [M: nat,K: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),K))
       => ( nat_prod_decode_aux(K,M) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),M)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),K))
       => ( nat_prod_decode_aux(K,M) = nat_prod_decode_aux(aa(nat,nat,suc,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,K))) ) ) ) ).

% prod_decode_aux.simps
tff(fact_4908_prod__decode__aux_Opelims,axiom,
    ! [X3: nat,Xa: nat,Y4: product_prod(nat,nat)] :
      ( ( nat_prod_decode_aux(X3,Xa) = Y4 )
     => ( pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),Xa)))
       => ~ ( ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Xa),X3))
               => ( Y4 = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X3),Xa)) ) )
              & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Xa),X3))
               => ( Y4 = nat_prod_decode_aux(aa(nat,nat,suc,X3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),aa(nat,nat,suc,X3))) ) ) )
           => ~ pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),Xa))) ) ) ) ).

% prod_decode_aux.pelims
tff(fact_4909_bezw__0,axiom,
    ! [X3: nat] : ( bezw(X3,zero_zero(nat)) = aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)) ) ).

% bezw_0
tff(fact_4910_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: set(nat),C2: fun(nat,A),D2: fun(nat,A)] :
          ( ( ( finite_finite(nat,A2)
              & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_kl(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D2)),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,C2,zero_zero(nat))),aa(nat,A,D2,zero_zero(nat))) ) )
          & ( ~ ( finite_finite(nat,A2)
                & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_kl(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D2)),A2) = zero_zero(A) ) ) ) ) ).

% sum_zero_power'
tff(fact_4911_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list(A)] : finite_finite(A,aa(list(A),set(A),set2(A),Xs)) ).

% List.finite_set
tff(fact_4912_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),G: fun(B,A)] :
          ( ~ finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) = zero_zero(A) ) ) ) ).

% sum.infinite
tff(fact_4913_sum__eq__0__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [F3: set(B),F2: fun(B,A)] :
          ( finite_finite(B,F3)
         => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),F3) = zero_zero(A) )
          <=> ! [X4: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),F3))
               => ( aa(B,A,F2,X4) = zero_zero(A) ) ) ) ) ) ).

% sum_eq_0_iff
tff(fact_4914_prod__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( semidom(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ( groups7121269368397514597t_prod(B,A,F2,A2) = zero_zero(A) )
          <=> ? [X4: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
                & ( aa(B,A,F2,X4) = zero_zero(A) ) ) ) ) ) ).

% prod_zero_iff
tff(fact_4915_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( ~ finite_finite(A,set_or1337092689740270186AtMost(A,A3,B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% infinite_Icc_iff
tff(fact_4916_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( ~ finite_finite(A,set_or7035219750837199246ssThan(A,A3,B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% infinite_Ico_iff
tff(fact_4917_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A)] :
          ( finite_finite(B,S2)
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_km(B,fun(fun(B,A),fun(B,A)),A3),B2)),S2) = aa(B,A,B2,A3) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_km(B,fun(fun(B,A),fun(B,A)),A3),B2)),S2) = zero_zero(A) ) ) ) ) ) ).

% sum.delta'
tff(fact_4918_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A)] :
          ( finite_finite(B,S2)
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_kn(B,fun(fun(B,A),fun(B,A)),A3),B2)),S2) = aa(B,A,B2,A3) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_kn(B,fun(fun(B,A),fun(B,A)),A3),B2)),S2) = zero_zero(A) ) ) ) ) ) ).

% sum.delta
tff(fact_4919_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [A2: set(nat),F2: fun(nat,A)] :
          ( finite_finite(nat,A2)
         => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ko(set(nat),fun(fun(nat,A),fun(nat,A)),A2),F2)) ) ) ).

% summable_If_finite_set
tff(fact_4920_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [P: fun(nat,bool),F2: fun(nat,A)] :
          ( finite_finite(nat,collect(nat,P))
         => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kp(fun(nat,bool),fun(fun(nat,A),fun(nat,A)),P),F2)) ) ) ).

% summable_If_finite
tff(fact_4921_prod__pos__nat__iff,axiom,
    ! [A: $tType,A2: set(A),F2: fun(A,nat)] :
      ( finite_finite(A,A2)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),groups7121269368397514597t_prod(A,nat,F2,A2)))
      <=> ! [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(A,nat,F2,X4))) ) ) ) ).

% prod_pos_nat_iff
tff(fact_4922_sum__zero__power,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: set(nat),C2: fun(nat,A)] :
          ( ( ( finite_finite(nat,A2)
              & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_kq(fun(nat,A),fun(nat,A),C2)),A2) = aa(nat,A,C2,zero_zero(nat)) ) )
          & ( ~ ( finite_finite(nat,A2)
                & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_kq(fun(nat,A),fun(nat,A),C2)),A2) = zero_zero(A) ) ) ) ) ).

% sum_zero_power
tff(fact_4923_finite__list,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
     => ? [Xs2: list(A)] : ( aa(list(A),set(A),set2(A),Xs2) = A2 ) ) ).

% finite_list
tff(fact_4924_finite__nat__set__iff__bounded__le,axiom,
    ! [N5: set(nat)] :
      ( finite_finite(nat,N5)
    <=> ? [M6: nat] :
        ! [X4: nat] :
          ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X4),N5))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X4),M6)) ) ) ).

% finite_nat_set_iff_bounded_le
tff(fact_4925_bounded__nat__set__is__finite,axiom,
    ! [N5: set(nat),N: nat] :
      ( ! [X2: nat] :
          ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X2),N5))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X2),N)) )
     => finite_finite(nat,N5) ) ).

% bounded_nat_set_is_finite
tff(fact_4926_finite__nat__set__iff__bounded,axiom,
    ! [N5: set(nat)] :
      ( finite_finite(nat,N5)
    <=> ? [M6: nat] :
        ! [X4: nat] :
          ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X4),N5))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X4),M6)) ) ) ).

% finite_nat_set_iff_bounded
tff(fact_4927_finite__M__bounded__by__nat,axiom,
    ! [P: fun(nat,bool),I: nat] : finite_finite(nat,collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_kr(fun(nat,bool),fun(nat,fun(nat,bool)),P),I))) ).

% finite_M_bounded_by_nat
tff(fact_4928_finite__less__ub,axiom,
    ! [F2: fun(nat,nat),U: nat] :
      ( ! [N2: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N2),aa(nat,nat,F2,N2)))
     => finite_finite(nat,collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_ks(fun(nat,nat),fun(nat,fun(nat,bool)),F2),U))) ) ).

% finite_less_ub
tff(fact_4929_finite__lists__length__eq,axiom,
    ! [A: $tType,A2: set(A),N: nat] :
      ( finite_finite(A,A2)
     => finite_finite(list(A),collect(list(A),aa(nat,fun(list(A),bool),aTP_Lamp_kt(set(A),fun(nat,fun(list(A),bool)),A2),N))) ) ).

% finite_lists_length_eq
tff(fact_4930_sum__mono__inv,axiom,
    ! [A: $tType,I6: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [F2: fun(I6,A),I5: set(I6),G: fun(I6,A),I: I6] :
          ( ( aa(set(I6),A,aa(fun(I6,A),fun(set(I6),A),groups7311177749621191930dd_sum(I6,A),F2),I5) = aa(set(I6),A,aa(fun(I6,A),fun(set(I6),A),groups7311177749621191930dd_sum(I6,A),G),I5) )
         => ( ! [I3: I6] :
                ( pp(aa(set(I6),bool,aa(I6,fun(set(I6),bool),member2(I6),I3),I5))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(I6,A,F2,I3)),aa(I6,A,G,I3))) )
           => ( pp(aa(set(I6),bool,aa(I6,fun(set(I6),bool),member2(I6),I),I5))
             => ( finite_finite(I6,I5)
               => ( aa(I6,A,F2,I) = aa(I6,A,G,I) ) ) ) ) ) ) ).

% sum_mono_inv
tff(fact_4931_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ? [X: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X),A2))
                & ( aa(B,A,F2,X) = zero_zero(A) ) )
           => ( groups7121269368397514597t_prod(B,A,F2,A2) = zero_zero(A) ) ) ) ) ).

% prod_zero
tff(fact_4932_infinite__Icc,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ finite_finite(A,set_or1337092689740270186AtMost(A,A3,B2)) ) ) ).

% infinite_Icc
tff(fact_4933_infinite__Ico,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ finite_finite(A,set_or7035219750837199246ssThan(A,A3,B2)) ) ) ).

% infinite_Ico
tff(fact_4934_finite__lists__length__le,axiom,
    ! [A: $tType,A2: set(A),N: nat] :
      ( finite_finite(A,A2)
     => finite_finite(list(A),collect(list(A),aa(nat,fun(list(A),bool),aTP_Lamp_ku(set(A),fun(nat,fun(list(A),bool)),A2),N))) ) ).

% finite_lists_length_le
tff(fact_4935_summable__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [N5: set(nat),F2: fun(nat,A)] :
          ( finite_finite(nat,N5)
         => ( ! [N2: nat] :
                ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N2),N5))
               => ( aa(nat,A,F2,N2) = zero_zero(A) ) )
           => summable(A,F2) ) ) ) ).

% summable_finite
tff(fact_4936_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I5: set(B),X3: fun(B,A),Y4: fun(B,A)] :
          ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),I5),X3)))
         => ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),I5),Y4)))
           => finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_kw(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),I5),X3),Y4))) ) ) ) ).

% sum.finite_Collect_op
tff(fact_4937_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I5: set(B),X3: fun(B,A),Y4: fun(B,A)] :
          ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kx(set(B),fun(fun(B,A),fun(B,bool)),I5),X3)))
         => ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kx(set(B),fun(fun(B,A),fun(B,bool)),I5),Y4)))
           => finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_ky(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),I5),X3),Y4))) ) ) ) ).

% prod.finite_Collect_op
tff(fact_4938_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),G: fun(B,A),P: fun(B,bool)] :
          ( finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),collect(B,aa(fun(B,bool),fun(B,bool),aTP_Lamp_kz(set(B),fun(fun(B,bool),fun(B,bool)),A2),P))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,bool),fun(B,A),aTP_Lamp_la(fun(B,A),fun(fun(B,bool),fun(B,A)),G),P)),A2) ) ) ) ).

% sum.inter_filter
tff(fact_4939_set__encode__inf,axiom,
    ! [A2: set(nat)] :
      ( ~ finite_finite(nat,A2)
     => ( aa(set(nat),nat,nat_set_encode,A2) = zero_zero(nat) ) ) ).

% set_encode_inf
tff(fact_4940_finite__int__segment,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A3: A,B2: A] : finite_finite(A,collect(A,aa(A,fun(A,bool),aTP_Lamp_lb(A,fun(A,fun(A,bool)),A3),B2))) ) ).

% finite_int_segment
tff(fact_4941_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [S: set(B),T2: set(C),G: fun(C,A),I: fun(C,B),F2: fun(B,A)] :
          ( finite_finite(B,S)
         => ( finite_finite(C,T2)
           => ( ! [X2: C] :
                  ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X2),T2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(C,A,G,X2))) )
             => ( ! [X2: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S))
                   => ? [Xa2: C] :
                        ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),Xa2),T2))
                        & ( aa(C,B,I,Xa2) = X2 )
                        & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),aa(C,A,G,Xa2))) ) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),S)),aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),T2))) ) ) ) ) ) ).

% sum_le_included
tff(fact_4942_sum__nonneg__eq__0__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,X2))) )
           => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2) = zero_zero(A) )
            <=> ! [X4: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
                 => ( aa(B,A,F2,X4) = zero_zero(A) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
tff(fact_4943_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I6: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A2: set(I6),F2: fun(I6,A),G: fun(I6,A)] :
          ( finite_finite(I6,A2)
         => ( ! [X2: I6] :
                ( pp(aa(set(I6),bool,aa(I6,fun(set(I6),bool),member2(I6),X2),A2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(I6,A,F2,X2)),aa(I6,A,G,X2))) )
           => ( ? [X: I6] :
                  ( pp(aa(set(I6),bool,aa(I6,fun(set(I6),bool),member2(I6),X),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(I6,A,F2,X)),aa(I6,A,G,X))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(I6),A,aa(fun(I6,A),fun(set(I6),A),groups7311177749621191930dd_sum(I6,A),F2),A2)),aa(set(I6),A,aa(fun(I6,A),fun(set(I6),A),groups7311177749621191930dd_sum(I6,A),G),A2))) ) ) ) ) ).

% sum_strict_mono_ex1
tff(fact_4944_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [R4: fun(A,fun(A,bool)),S2: set(B),H: fun(B,A),G: fun(B,A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),R4,zero_zero(A)),zero_zero(A)))
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( pp(aa(A,bool,aa(A,fun(A,bool),R4,X1),X23))
                  & pp(aa(A,bool,aa(A,fun(A,bool),R4,Y1),Y23)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),R4,aa(A,A,aa(A,fun(A,A),plus_plus(A),X1),Y1)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X23),Y23))) )
           => ( finite_finite(B,S2)
             => ( ! [X2: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),R4,aa(B,A,H,X2)),aa(B,A,G,X2))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),R4,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),S2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S2))) ) ) ) ) ) ).

% sum.related
tff(fact_4945_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [R4: fun(A,fun(A,bool)),S2: set(B),H: fun(B,A),G: fun(B,A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),R4,one_one(A)),one_one(A)))
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( pp(aa(A,bool,aa(A,fun(A,bool),R4,X1),X23))
                  & pp(aa(A,bool,aa(A,fun(A,bool),R4,Y1),Y23)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),R4,aa(A,A,aa(A,fun(A,A),times_times(A),X1),Y1)),aa(A,A,aa(A,fun(A,A),times_times(A),X23),Y23))) )
           => ( finite_finite(B,S2)
             => ( ! [X2: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),R4,aa(B,A,H,X2)),aa(B,A,G,X2))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),R4,groups7121269368397514597t_prod(B,A,H,S2)),groups7121269368397514597t_prod(B,A,G,S2))) ) ) ) ) ) ).

% prod.related
tff(fact_4946_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [S4: set(B),T5: set(C),S2: set(B),I: fun(C,B),J3: fun(B,C),T6: set(C),G: fun(B,A),H: fun(C,A)] :
          ( finite_finite(B,S4)
         => ( finite_finite(C,T5)
           => ( ! [A5: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4)))
                 => ( aa(C,B,I,aa(B,C,J3,A5)) = A5 ) )
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4)))
                   => pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),aa(B,C,J3,A5)),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T6),T5))) )
               => ( ! [B5: C] :
                      ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),B5),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T6),T5)))
                     => ( aa(B,C,J3,aa(C,B,I,B5)) = B5 ) )
                 => ( ! [B5: C] :
                        ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),B5),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T6),T5)))
                       => pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),aa(C,B,I,B5)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4))) )
                   => ( ! [A5: B] :
                          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),S4))
                         => ( aa(B,A,G,A5) = zero_zero(A) ) )
                     => ( ! [B5: C] :
                            ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),B5),T5))
                           => ( aa(C,A,H,B5) = zero_zero(A) ) )
                       => ( ! [A5: B] :
                              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),S2))
                             => ( aa(C,A,H,aa(B,C,J3,A5)) = aa(B,A,G,A5) ) )
                         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S2) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),H),T6) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
tff(fact_4947_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [B3: set(B),A2: set(B),F2: fun(B,A)] :
          ( finite_finite(B,B3)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),groups7121269368397514597t_prod(B,A,F2,A2)),groups7121269368397514597t_prod(B,A,F2,B3))) ) ) ) ).

% prod_dvd_prod_subset
tff(fact_4948_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [B3: set(B),A2: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( finite_finite(B,B3)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),B3))
           => ( ! [A5: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),A2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(B,A,F2,A5)),aa(B,A,G,A5))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),groups7121269368397514597t_prod(B,A,F2,A2)),groups7121269368397514597t_prod(B,A,G,B3))) ) ) ) ) ).

% prod_dvd_prod_subset2
tff(fact_4949_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A2: set(A),F2: fun(A,nat)] :
      ( finite_finite(A,A2)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A2) = aa(nat,nat,suc,zero_zero(nat)) )
      <=> ? [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
            & ( aa(A,nat,F2,X4) = aa(nat,nat,suc,zero_zero(nat)) )
            & ! [Xa4: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),A2))
               => ( ( X4 != Xa4 )
                 => ( aa(A,nat,F2,Xa4) = zero_zero(nat) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
tff(fact_4950_sum__eq__1__iff,axiom,
    ! [A: $tType,A2: set(A),F2: fun(A,nat)] :
      ( finite_finite(A,A2)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A2) = one_one(nat) )
      <=> ? [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
            & ( aa(A,nat,F2,X4) = one_one(nat) )
            & ! [Xa4: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),A2))
               => ( ( X4 != Xa4 )
                 => ( aa(A,nat,F2,Xa4) = zero_zero(nat) ) ) ) ) ) ) ).

% sum_eq_1_iff
tff(fact_4951_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [S: set(B),F2: fun(B,A),B3: A,I: B] :
          ( finite_finite(B,S)
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),S))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3))) )
           => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),S) = B3 )
             => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),S))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I)),B3)) ) ) ) ) ) ).

% sum_nonneg_leq_bound
tff(fact_4952_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [S: set(B),F2: fun(B,A),I: B] :
          ( finite_finite(B,S)
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),S))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3))) )
           => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),S) = zero_zero(A) )
             => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),S))
               => ( aa(B,A,F2,I) = zero_zero(A) ) ) ) ) ) ) ).

% sum_nonneg_0
tff(fact_4953_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),collect(B,aTP_Lamp_lc(fun(B,A),fun(B,bool),G)))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) ) ) ) ).

% sum.setdiff_irrelevant
tff(fact_4954_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => finite_finite(nat,collect(nat,aTP_Lamp_ld(nat,fun(nat,bool),M))) ) ).

% finite_divisors_nat
tff(fact_4955_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [A2: set(nat),F2: fun(nat,A)] :
          ( finite_finite(nat,A2)
         => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ko(set(nat),fun(fun(nat,A),fun(nat,A)),A2),F2),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),A2)) ) ) ).

% sums_If_finite_set
tff(fact_4956_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [P: fun(nat,bool),F2: fun(nat,A)] :
          ( finite_finite(nat,collect(nat,P))
         => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kp(fun(nat,bool),fun(fun(nat,A),fun(nat,A)),P),F2),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),collect(nat,P))) ) ) ).

% sums_If_finite
tff(fact_4957_sums__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [N5: set(nat),F2: fun(nat,A)] :
          ( finite_finite(nat,N5)
         => ( ! [N2: nat] :
                ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N2),N5))
               => ( aa(nat,A,F2,N2) = zero_zero(A) ) )
           => sums(A,F2,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),N5)) ) ) ) ).

% sums_finite
tff(fact_4958_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [N5: set(nat),F2: fun(nat,A)] :
          ( finite_finite(nat,N5)
         => ( ! [N2: nat] :
                ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N2),N5))
               => ( aa(nat,A,F2,N2) = zero_zero(A) ) )
           => ( suminf(A,F2) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),N5) ) ) ) ) ).

% suminf_finite
tff(fact_4959_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A3: A] : finite_finite(A,collect(A,aTP_Lamp_le(A,fun(A,bool),A3))) ) ).

% finite_abs_int_segment
tff(fact_4960_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N5: set(nat),N: nat] :
      ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),N5),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)))
     => finite_finite(nat,N5) ) ).

% subset_eq_atLeast0_atMost_finite
tff(fact_4961_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N5: set(nat),N: nat] :
      ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),N5),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))
     => finite_finite(nat,N5) ) ).

% subset_eq_atLeast0_lessThan_finite
tff(fact_4962_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [I5: set(B),I: B,F2: fun(B,A)] :
          ( finite_finite(B,I5)
         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),I5))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(B,A,F2,I)))
             => ( ! [I3: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),I5))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),I5))) ) ) ) ) ) ).

% sum_pos2
tff(fact_4963_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),I: A,F2: fun(A,B)] :
          ( finite_finite(A,I5)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),I5))
           => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(A,B,F2,I)))
             => ( ! [I3: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
                   => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),one_one(B)),aa(A,B,F2,I3))) )
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),groups7121269368397514597t_prod(A,B,F2,I5))) ) ) ) ) ) ).

% less_1_prod2
tff(fact_4964_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [C6: set(B),A2: set(B),B3: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,C6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),C6))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),C6))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C6),A2)))
                   => ( aa(B,A,G,A5) = zero_zero(A) ) )
               => ( ! [B5: B] :
                      ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),B5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C6),B3)))
                     => ( aa(B,A,H,B5) = zero_zero(A) ) )
                 => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),B3) )
                  <=> ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),C6) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),C6) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
tff(fact_4965_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [C6: set(B),A2: set(B),B3: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,C6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),C6))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),C6))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C6),A2)))
                   => ( aa(B,A,G,A5) = zero_zero(A) ) )
               => ( ! [B5: B] :
                      ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),B5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C6),B3)))
                     => ( aa(B,A,H,B5) = zero_zero(A) ) )
                 => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),C6) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),C6) )
                   => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),B3) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
tff(fact_4966_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [T6: set(B),S2: set(B),G: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,G,X2) = zero_zero(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),T6) ) ) ) ) ) ).

% sum.mono_neutral_left
tff(fact_4967_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [T6: set(B),S2: set(B),G: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,G,X2) = zero_zero(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),T6) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S2) ) ) ) ) ) ).

% sum.mono_neutral_right
tff(fact_4968_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [T6: set(B),S2: set(B),H: fun(B,A),G: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,H,X2) = zero_zero(A) ) )
             => ( ! [X2: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                   => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),T6) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
tff(fact_4969_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [T6: set(B),S2: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,G,X2) = zero_zero(A) ) )
             => ( ! [X2: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                   => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),T6) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),S2) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
tff(fact_4970_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [B3: set(B),A2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),A2))
         => ( finite_finite(B,A2)
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B3)) ) ) ) ) ).

% sum.subset_diff
tff(fact_4971_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [A2: set(B),B3: set(B),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),A2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),B3)) ) ) ) ) ).

% sum_diff
tff(fact_4972_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [B3: set(B),A2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),A2))
         => ( finite_finite(B,A2)
           => ( groups7121269368397514597t_prod(B,A,G,A2) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),B3))),groups7121269368397514597t_prod(B,A,G,B3)) ) ) ) ) ).

% prod.subset_diff
tff(fact_4973_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C6: set(B),A2: set(B),B3: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,C6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),C6))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),C6))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C6),A2)))
                   => ( aa(B,A,G,A5) = one_one(A) ) )
               => ( ! [B5: B] :
                      ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),B5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C6),B3)))
                     => ( aa(B,A,H,B5) = one_one(A) ) )
                 => ( ( groups7121269368397514597t_prod(B,A,G,A2) = groups7121269368397514597t_prod(B,A,H,B3) )
                  <=> ( groups7121269368397514597t_prod(B,A,G,C6) = groups7121269368397514597t_prod(B,A,H,C6) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
tff(fact_4974_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C6: set(B),A2: set(B),B3: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,C6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),C6))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),C6))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C6),A2)))
                   => ( aa(B,A,G,A5) = one_one(A) ) )
               => ( ! [B5: B] :
                      ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),B5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C6),B3)))
                     => ( aa(B,A,H,B5) = one_one(A) ) )
                 => ( ( groups7121269368397514597t_prod(B,A,G,C6) = groups7121269368397514597t_prod(B,A,H,C6) )
                   => ( groups7121269368397514597t_prod(B,A,G,A2) = groups7121269368397514597t_prod(B,A,H,B3) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
tff(fact_4975_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T6: set(B),S2: set(B),G: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,G,X2) = one_one(A) ) )
             => ( groups7121269368397514597t_prod(B,A,G,S2) = groups7121269368397514597t_prod(B,A,G,T6) ) ) ) ) ) ).

% prod.mono_neutral_left
tff(fact_4976_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T6: set(B),S2: set(B),G: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,G,X2) = one_one(A) ) )
             => ( groups7121269368397514597t_prod(B,A,G,T6) = groups7121269368397514597t_prod(B,A,G,S2) ) ) ) ) ) ).

% prod.mono_neutral_right
tff(fact_4977_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T6: set(B),S2: set(B),H: fun(B,A),G: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,H,X2) = one_one(A) ) )
             => ( ! [X2: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                   => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
               => ( groups7121269368397514597t_prod(B,A,G,S2) = groups7121269368397514597t_prod(B,A,H,T6) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
tff(fact_4978_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T6: set(B),S2: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,G,X2) = one_one(A) ) )
             => ( ! [X2: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                   => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
               => ( groups7121269368397514597t_prod(B,A,G,T6) = groups7121269368397514597t_prod(B,A,H,S2) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
tff(fact_4979_sum__diff__nat,axiom,
    ! [A: $tType,B3: set(A),A2: set(A),F2: fun(A,nat)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A2)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),B3)) ) ) ) ).

% sum_diff_nat
tff(fact_4980_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),N))
         => finite_finite(A,collect(A,aTP_Lamp_lf(nat,fun(A,bool),N))) ) ) ).

% finite_roots_unity
tff(fact_4981_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [S4: set(B),T5: set(C),H: fun(B,C),S2: set(B),T6: set(C),G: fun(C,A)] :
          ( finite_finite(B,S4)
         => ( finite_finite(C,T5)
           => ( bij_betw(B,C,H,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T6),T5))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),S4))
                   => ( aa(C,A,G,aa(B,C,H,A5)) = zero_zero(A) ) )
               => ( ! [B5: C] :
                      ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),B5),T5))
                     => ( aa(C,A,G,B5) = zero_zero(A) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_lg(fun(B,C),fun(fun(C,A),fun(B,A)),H),G)),S2) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),T6) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
tff(fact_4982_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [G: fun(nat,A),S2: A,A2: set(nat),S4: A,F2: fun(nat,A)] :
          ( sums(A,G,S2)
         => ( finite_finite(nat,A2)
           => ( ( S4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),S2),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_lh(fun(nat,A),fun(fun(nat,A),fun(nat,A)),G),F2)),A2)) )
             => sums(A,aa(fun(nat,A),fun(nat,A),aa(set(nat),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_li(fun(nat,A),fun(set(nat),fun(fun(nat,A),fun(nat,A))),G),A2),F2),S4) ) ) ) ) ).

% sums_If_finite_set'
tff(fact_4983_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [B3: set(B),A2: set(B),F2: fun(B,A)] :
          ( finite_finite(B,B3)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),B3))
           => ( ! [B5: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),B5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B3),A2)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,B5))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),B3))) ) ) ) ) ).

% sum_mono2
tff(fact_4984_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_parity(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),groups7121269368397514597t_prod(B,A,F2,A2)))
          <=> ? [X4: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
                & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(B,A,F2,X4))) ) ) ) ) ).

% even_prod_iff
tff(fact_4985_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),I5: set(nat)] :
          ( summable(A,F2)
         => ( finite_finite(nat,I5)
           => ( ! [N2: nat] :
                  ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N2),aa(set(nat),set(nat),uminus_uminus(set(nat)),I5)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),I5)),suminf(A,F2))) ) ) ) ) ).

% sum_le_suminf
tff(fact_4986_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [B3: set(A),A2: set(A),B2: A,F2: fun(A,B)] :
          ( finite_finite(A,B3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
           => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A2)))
             => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),zero_zero(B)),aa(A,B,F2,B2)))
               => ( ! [X2: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),B3))
                     => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,X2))) )
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),B3))) ) ) ) ) ) ) ).

% sum_strict_mono2
tff(fact_4987_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [B3: set(A),A2: set(A),F2: fun(A,B)] :
          ( finite_finite(A,B3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
           => ( ! [B5: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B5),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A2)))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),one_one(B)),aa(A,B,F2,B5))) )
             => ( ! [A5: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A5),A2))
                   => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,A5))) )
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),groups7121269368397514597t_prod(A,B,F2,A2)),groups7121269368397514597t_prod(A,B,F2,B3))) ) ) ) ) ) ).

% prod_mono2
tff(fact_4988_ln__prod,axiom,
    ! [A: $tType,I5: set(A),F2: fun(A,real)] :
      ( finite_finite(A,I5)
     => ( ! [I3: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,F2,I3))) )
       => ( aa(real,real,ln_ln(real),groups7121269368397514597t_prod(A,real,F2,I5)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_lj(fun(A,real),fun(A,real),F2)),I5) ) ) ) ).

% ln_prod
tff(fact_4989_even__set__encode__iff,axiom,
    ! [A2: set(nat)] :
      ( finite_finite(nat,A2)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(set(nat),nat,nat_set_encode,A2)))
      <=> ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2)) ) ) ).

% even_set_encode_iff
tff(fact_4990_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),N: nat] :
          ( finite_finite(A,collect(A,aa(nat,fun(A,bool),aTP_Lamp_lk(fun(nat,A),fun(nat,fun(A,bool)),C2),N)))
        <=> ? [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I2),N))
              & ( aa(nat,A,C2,I2) != zero_zero(A) ) ) ) ) ).

% polyfun_finite_roots
tff(fact_4991_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,N: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
           => finite_finite(A,collect(A,aa(nat,fun(A,bool),aTP_Lamp_lk(fun(nat,A),fun(nat,fun(A,bool)),C2),N))) ) ) ) ).

% polyfun_roots_finite
tff(fact_4992_finite__Collect__le__nat,axiom,
    ! [K: nat] : finite_finite(nat,collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_ag(nat,fun(nat,bool)),K))) ).

% finite_Collect_le_nat
tff(fact_4993_finite__Collect__less__nat,axiom,
    ! [K: nat] : finite_finite(nat,collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),K))) ).

% finite_Collect_less_nat
tff(fact_4994_finite__Collect__subsets,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
     => finite_finite(set(A),collect(set(A),aTP_Lamp_ll(set(A),fun(set(A),bool),A2))) ) ).

% finite_Collect_subsets
tff(fact_4995_finite__interval__int1,axiom,
    ! [A3: int,B2: int] : finite_finite(int,collect(int,aa(int,fun(int,bool),aTP_Lamp_lm(int,fun(int,fun(int,bool)),A3),B2))) ).

% finite_interval_int1
tff(fact_4996_finite__interval__int4,axiom,
    ! [A3: int,B2: int] : finite_finite(int,collect(int,aa(int,fun(int,bool),aTP_Lamp_ln(int,fun(int,fun(int,bool)),A3),B2))) ).

% finite_interval_int4
tff(fact_4997_finite__interval__int3,axiom,
    ! [A3: int,B2: int] : finite_finite(int,collect(int,aa(int,fun(int,bool),aTP_Lamp_lo(int,fun(int,fun(int,bool)),A3),B2))) ).

% finite_interval_int3
tff(fact_4998_finite__interval__int2,axiom,
    ! [A3: int,B2: int] : finite_finite(int,collect(int,aa(int,fun(int,bool),aTP_Lamp_lp(int,fun(int,fun(int,bool)),A3),B2))) ).

% finite_interval_int2
tff(fact_4999_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => finite_finite(complex,collect(complex,aa(complex,fun(complex,bool),aTP_Lamp_fg(nat,fun(complex,fun(complex,bool)),N),C2))) ) ).

% finite_nth_roots
tff(fact_5000_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : finite_finite(int,set_or7035219750837199246ssThan(int,zero_zero(int),U)) ).

% finite_atLeastZeroLessThan_int
tff(fact_5001_finite__maxlen,axiom,
    ! [A: $tType,M7: set(list(A))] :
      ( finite_finite(list(A),M7)
     => ? [N2: nat] :
        ! [X: list(A)] :
          ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),X),M7))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),X)),N2)) ) ) ).

% finite_maxlen
tff(fact_5002_finite__enat__bounded,axiom,
    ! [A2: set(extended_enat),N: nat] :
      ( ! [Y2: extended_enat] :
          ( pp(aa(set(extended_enat),bool,aa(extended_enat,fun(set(extended_enat),bool),member2(extended_enat),Y2),A2))
         => pp(aa(extended_enat,bool,aa(extended_enat,fun(extended_enat,bool),ord_less_eq(extended_enat),Y2),extended_enat2(N))) )
     => finite_finite(extended_enat,A2) ) ).

% finite_enat_bounded
tff(fact_5003_finite__divisors__int,axiom,
    ! [I: int] :
      ( ( I != zero_zero(int) )
     => finite_finite(int,collect(int,aTP_Lamp_lq(int,fun(int,bool),I))) ) ).

% finite_divisors_int
tff(fact_5004_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: set(A),A3: A] :
          ( finite_finite(A,A2)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),A2))
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A3))
                & ! [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),A2))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Xa2),X2))
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal2
tff(fact_5005_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: set(A),A3: A] :
          ( finite_finite(A,A2)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),A2))
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
                & ! [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),A2))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Xa2))
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal2
tff(fact_5006_finite__subset,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( finite_finite(A,B3)
       => finite_finite(A,A2) ) ) ).

% finite_subset
tff(fact_5007_infinite__super,axiom,
    ! [A: $tType,S2: set(A),T6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),T6))
     => ( ~ finite_finite(A,S2)
       => ~ finite_finite(A,T6) ) ) ).

% infinite_super
tff(fact_5008_rev__finite__subset,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
       => finite_finite(A,A2) ) ) ).

% rev_finite_subset
tff(fact_5009_finite__psubset__induct,axiom,
    ! [A: $tType,A2: set(A),P: fun(set(A),bool)] :
      ( finite_finite(A,A2)
     => ( ! [A7: set(A)] :
            ( finite_finite(A,A7)
           => ( ! [B9: set(A)] :
                  ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),B9),A7))
                 => pp(aa(set(A),bool,P,B9)) )
             => pp(aa(set(A),bool,P,A7)) ) )
       => pp(aa(set(A),bool,P,A2)) ) ) ).

% finite_psubset_induct
tff(fact_5010_finite__nat__iff__bounded__le,axiom,
    ! [S2: set(nat)] :
      ( finite_finite(nat,S2)
    <=> ? [K3: nat] : pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),S2),set_ord_atMost(nat,K3))) ) ).

% finite_nat_iff_bounded_le
tff(fact_5011_finite__nat__iff__bounded,axiom,
    ! [S2: set(nat)] :
      ( finite_finite(nat,S2)
    <=> ? [K3: nat] : pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),S2),set_ord_lessThan(nat,K3))) ) ).

% finite_nat_iff_bounded
tff(fact_5012_finite__nat__bounded,axiom,
    ! [S2: set(nat)] :
      ( finite_finite(nat,S2)
     => ? [K2: nat] : pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),S2),set_ord_lessThan(nat,K2))) ) ).

% finite_nat_bounded
tff(fact_5013_infinite__int__iff__unbounded__le,axiom,
    ! [S2: set(int)] :
      ( ~ finite_finite(int,S2)
    <=> ! [M6: int] :
        ? [N3: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),M6),aa(int,int,abs_abs(int),N3)))
          & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),N3),S2)) ) ) ).

% infinite_int_iff_unbounded_le
tff(fact_5014_infinite__int__iff__unbounded,axiom,
    ! [S2: set(int)] :
      ( ~ finite_finite(int,S2)
    <=> ! [M6: int] :
        ? [N3: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),M6),aa(int,int,abs_abs(int),N3)))
          & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),N3),S2)) ) ) ).

% infinite_int_iff_unbounded
tff(fact_5015_unbounded__k__infinite,axiom,
    ! [K: nat,S2: set(nat)] :
      ( ! [M3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),M3))
         => ? [N7: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N7))
              & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N7),S2)) ) )
     => ~ finite_finite(nat,S2) ) ).

% unbounded_k_infinite
tff(fact_5016_infinite__nat__iff__unbounded,axiom,
    ! [S2: set(nat)] :
      ( ~ finite_finite(nat,S2)
    <=> ! [M6: nat] :
        ? [N3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M6),N3))
          & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N3),S2)) ) ) ).

% infinite_nat_iff_unbounded
tff(fact_5017_infinite__nat__iff__unbounded__le,axiom,
    ! [S2: set(nat)] :
      ( ~ finite_finite(nat,S2)
    <=> ! [M6: nat] :
        ? [N3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M6),N3))
          & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N3),S2)) ) ) ).

% infinite_nat_iff_unbounded_le
tff(fact_5018_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2 != zero_zero(complex) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => bij_betw(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,aa(real,real,root(N),real_V7770717601297561774m_norm(complex,C2)))),cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),arg(C2)),aa(nat,real,semiring_1_of_nat(real),N))))),collect(complex,aTP_Lamp_fh(nat,fun(complex,bool),N)),collect(complex,aa(nat,fun(complex,bool),aTP_Lamp_lr(complex,fun(nat,fun(complex,bool)),C2),N))) ) ) ).

% bij_betw_nth_root_unity
tff(fact_5019_in__finite__psubset,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(product_prod(set(A),set(A))),bool,aa(product_prod(set(A),set(A)),fun(set(product_prod(set(A),set(A))),bool),member2(product_prod(set(A),set(A))),aa(set(A),product_prod(set(A),set(A)),product_Pair(set(A),set(A),A2),B3)),finite_psubset(A)))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
        & finite_finite(A,B3) ) ) ).

% in_finite_psubset
tff(fact_5020_sum__count__set,axiom,
    ! [A: $tType,Xs: list(A),X7: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),X7))
     => ( finite_finite(A,X7)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),count_list(A,Xs)),X7) = aa(list(A),nat,size_size(list(A)),Xs) ) ) ) ).

% sum_count_set
tff(fact_5021_real__root__zero,axiom,
    ! [N: nat] : ( aa(real,real,root(N),zero_zero(real)) = zero_zero(real) ) ).

% real_root_zero
tff(fact_5022_real__root__Suc__0,axiom,
    ! [X3: real] : ( aa(real,real,root(aa(nat,nat,suc,zero_zero(nat))),X3) = X3 ) ).

% real_root_Suc_0
tff(fact_5023_root__0,axiom,
    ! [X3: real] : ( aa(real,real,root(zero_zero(nat)),X3) = zero_zero(real) ) ).

% root_0
tff(fact_5024_real__root__eq__iff,axiom,
    ! [N: nat,X3: real,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( ( aa(real,real,root(N),X3) = aa(real,real,root(N),Y4) )
      <=> ( X3 = Y4 ) ) ) ).

% real_root_eq_iff
tff(fact_5025_count__notin,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( aa(A,nat,count_list(A,Xs),X3) = zero_zero(nat) ) ) ).

% count_notin
tff(fact_5026_real__root__eq__0__iff,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( ( aa(real,real,root(N),X3) = zero_zero(real) )
      <=> ( X3 = zero_zero(real) ) ) ) ).

% real_root_eq_0_iff
tff(fact_5027_real__root__less__iff,axiom,
    ! [N: nat,X3: real,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,root(N),X3)),aa(real,real,root(N),Y4)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4)) ) ) ).

% real_root_less_iff
tff(fact_5028_real__root__le__iff,axiom,
    ! [N: nat,X3: real,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,root(N),X3)),aa(real,real,root(N),Y4)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4)) ) ) ).

% real_root_le_iff
tff(fact_5029_real__root__eq__1__iff,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( ( aa(real,real,root(N),X3) = one_one(real) )
      <=> ( X3 = one_one(real) ) ) ) ).

% real_root_eq_1_iff
tff(fact_5030_real__root__one,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(real,real,root(N),one_one(real)) = one_one(real) ) ) ).

% real_root_one
tff(fact_5031_real__root__lt__0__iff,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,root(N),X3)),zero_zero(real)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real))) ) ) ).

% real_root_lt_0_iff
tff(fact_5032_real__root__gt__0__iff,axiom,
    ! [N: nat,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,root(N),Y4)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y4)) ) ) ).

% real_root_gt_0_iff
tff(fact_5033_real__root__le__0__iff,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,root(N),X3)),zero_zero(real)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),zero_zero(real))) ) ) ).

% real_root_le_0_iff
tff(fact_5034_real__root__ge__0__iff,axiom,
    ! [N: nat,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,root(N),Y4)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4)) ) ) ).

% real_root_ge_0_iff
tff(fact_5035_real__root__lt__1__iff,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,root(N),X3)),one_one(real)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real))) ) ) ).

% real_root_lt_1_iff
tff(fact_5036_real__root__gt__1__iff,axiom,
    ! [N: nat,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),aa(real,real,root(N),Y4)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),Y4)) ) ) ).

% real_root_gt_1_iff
tff(fact_5037_real__root__le__1__iff,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,root(N),X3)),one_one(real)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real))) ) ) ).

% real_root_le_1_iff
tff(fact_5038_real__root__ge__1__iff,axiom,
    ! [N: nat,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(real,real,root(N),Y4)))
      <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),Y4)) ) ) ).

% real_root_ge_1_iff
tff(fact_5039_real__root__pow__pos2,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
       => ( aa(nat,real,power_power(real,aa(real,real,root(N),X3)),N) = X3 ) ) ) ).

% real_root_pow_pos2
tff(fact_5040_real__root__divide,axiom,
    ! [N: nat,X3: real,Y4: real] : ( aa(real,real,root(N),aa(real,real,aa(real,fun(real,real),divide_divide(real),X3),Y4)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,root(N),X3)),aa(real,real,root(N),Y4)) ) ).

% real_root_divide
tff(fact_5041_real__root__mult__exp,axiom,
    ! [M: nat,N: nat,X3: real] : ( aa(real,real,root(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),X3) = aa(real,real,root(M),aa(real,real,root(N),X3)) ) ).

% real_root_mult_exp
tff(fact_5042_real__root__mult,axiom,
    ! [N: nat,X3: real,Y4: real] : ( aa(real,real,root(N),aa(real,real,aa(real,fun(real,real),times_times(real),X3),Y4)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,root(N),X3)),aa(real,real,root(N),Y4)) ) ).

% real_root_mult
tff(fact_5043_real__root__commute,axiom,
    ! [M: nat,N: nat,X3: real] : ( aa(real,real,root(M),aa(real,real,root(N),X3)) = aa(real,real,root(N),aa(real,real,root(M),X3)) ) ).

% real_root_commute
tff(fact_5044_real__root__inverse,axiom,
    ! [N: nat,X3: real] : ( aa(real,real,root(N),aa(real,real,inverse_inverse(real),X3)) = aa(real,real,inverse_inverse(real),aa(real,real,root(N),X3)) ) ).

% real_root_inverse
tff(fact_5045_real__root__minus,axiom,
    ! [N: nat,X3: real] : ( aa(real,real,root(N),aa(real,real,uminus_uminus(real),X3)) = aa(real,real,uminus_uminus(real),aa(real,real,root(N),X3)) ) ).

% real_root_minus
tff(fact_5046_real__root__pos__pos__le,axiom,
    ! [X3: real,N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,root(N),X3))) ) ).

% real_root_pos_pos_le
tff(fact_5047_real__root__less__mono,axiom,
    ! [N: nat,X3: real,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,root(N),X3)),aa(real,real,root(N),Y4))) ) ) ).

% real_root_less_mono
tff(fact_5048_real__root__le__mono,axiom,
    ! [N: nat,X3: real,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),Y4))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,root(N),X3)),aa(real,real,root(N),Y4))) ) ) ).

% real_root_le_mono
tff(fact_5049_real__root__power,axiom,
    ! [N: nat,X3: real,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(real,real,root(N),aa(nat,real,power_power(real,X3),K)) = aa(nat,real,power_power(real,aa(real,real,root(N),X3)),K) ) ) ).

% real_root_power
tff(fact_5050_real__root__abs,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(real,real,root(N),aa(real,real,abs_abs(real),X3)) = aa(real,real,abs_abs(real),aa(real,real,root(N),X3)) ) ) ).

% real_root_abs
tff(fact_5051_sgn__root,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(real,real,sgn_sgn(real),aa(real,real,root(N),X3)) = aa(real,real,sgn_sgn(real),X3) ) ) ).

% sgn_root
tff(fact_5052_real__root__gt__zero,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,root(N),X3))) ) ) ).

% real_root_gt_zero
tff(fact_5053_real__root__strict__decreasing,axiom,
    ! [N: nat,N5: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N5))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,root(N5),X3)),aa(real,real,root(N),X3))) ) ) ) ).

% real_root_strict_decreasing
tff(fact_5054_sqrt__def,axiom,
    sqrt = root(aa(num,nat,numeral_numeral(nat),bit0(one2))) ).

% sqrt_def
tff(fact_5055_root__abs__power,axiom,
    ! [N: nat,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(real,real,abs_abs(real),aa(real,real,root(N),aa(nat,real,power_power(real,Y4),N))) = aa(real,real,abs_abs(real),Y4) ) ) ).

% root_abs_power
tff(fact_5056_count__le__length,axiom,
    ! [A: $tType,Xs: list(A),X3: A] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,count_list(A,Xs),X3)),aa(list(A),nat,size_size(list(A)),Xs))) ).

% count_le_length
tff(fact_5057_real__root__pos__pos,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,root(N),X3))) ) ) ).

% real_root_pos_pos
tff(fact_5058_real__root__strict__increasing,axiom,
    ! [N: nat,N5: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N5))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,root(N),X3)),aa(real,real,root(N5),X3))) ) ) ) ) ).

% real_root_strict_increasing
tff(fact_5059_real__root__decreasing,axiom,
    ! [N: nat,N5: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N5))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),X3))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,root(N5),X3)),aa(real,real,root(N),X3))) ) ) ) ).

% real_root_decreasing
tff(fact_5060_real__root__pow__pos,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( aa(nat,real,power_power(real,aa(real,real,root(N),X3)),N) = X3 ) ) ) ).

% real_root_pow_pos
tff(fact_5061_real__root__power__cancel,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
       => ( aa(real,real,root(N),aa(nat,real,power_power(real,X3),N)) = X3 ) ) ) ).

% real_root_power_cancel
tff(fact_5062_real__root__pos__unique,axiom,
    ! [N: nat,Y4: real,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y4))
       => ( ( aa(nat,real,power_power(real,Y4),N) = X3 )
         => ( aa(real,real,root(N),X3) = Y4 ) ) ) ) ).

% real_root_pos_unique
tff(fact_5063_odd__real__root__power__cancel,axiom,
    ! [N: nat,X3: real] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(real,real,root(N),aa(nat,real,power_power(real,X3),N)) = X3 ) ) ).

% odd_real_root_power_cancel
tff(fact_5064_odd__real__root__unique,axiom,
    ! [N: nat,Y4: real,X3: real] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( ( aa(nat,real,power_power(real,Y4),N) = X3 )
       => ( aa(real,real,root(N),X3) = Y4 ) ) ) ).

% odd_real_root_unique
tff(fact_5065_odd__real__root__pow,axiom,
    ! [N: nat,X3: real] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(nat,real,power_power(real,aa(real,real,root(N),X3)),N) = X3 ) ) ).

% odd_real_root_pow
tff(fact_5066_real__root__increasing,axiom,
    ! [N: nat,N5: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N5))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,root(N),X3)),aa(real,real,root(N5),X3))) ) ) ) ) ).

% real_root_increasing
tff(fact_5067_sgn__power__root,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),aa(real,real,root(N),X3))),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),aa(real,real,root(N),X3))),N)) = X3 ) ) ).

% sgn_power_root
tff(fact_5068_root__sgn__power,axiom,
    ! [N: nat,Y4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(real,real,root(N),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Y4)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),Y4)),N))) = Y4 ) ) ).

% root_sgn_power
tff(fact_5069_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
       => ( aa(real,real,ln_ln(real),aa(real,real,root(N),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),B2)),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ) ).

% ln_root
tff(fact_5070_log__root,axiom,
    ! [N: nat,A3: real,B2: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
       => ( aa(real,real,log(B2),aa(real,real,root(N),A3)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(B2),A3)),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ) ).

% log_root
tff(fact_5071_log__base__root,axiom,
    ! [N: nat,B2: real,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
       => ( aa(real,real,log(aa(real,real,root(N),B2)),X3) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(B2),X3)) ) ) ) ).

% log_base_root
tff(fact_5072_split__root,axiom,
    ! [P: fun(real,bool),N: nat,X3: real] :
      ( pp(aa(real,bool,P,aa(real,real,root(N),X3)))
    <=> ( ( ( N = zero_zero(nat) )
         => pp(aa(real,bool,P,zero_zero(real))) )
        & ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ! [Y: real] :
              ( ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Y)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),Y)),N)) = X3 )
             => pp(aa(real,bool,P,Y)) ) ) ) ) ).

% split_root
tff(fact_5073_finite__psubset__def,axiom,
    ! [A: $tType] : ( finite_psubset(A) = collect(product_prod(set(A),set(A)),product_case_prod(set(A),set(A),bool,aTP_Lamp_ls(set(A),fun(set(A),bool)))) ) ).

% finite_psubset_def
tff(fact_5074_root__powr__inverse,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => ( aa(real,real,root(N),X3) = powr(real,X3,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),N))) ) ) ) ).

% root_powr_inverse
tff(fact_5075_set__encode__insert,axiom,
    ! [A2: set(nat),N: nat] :
      ( finite_finite(nat,A2)
     => ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N),A2))
       => ( aa(set(nat),nat,nat_set_encode,aa(set(nat),set(nat),insert2(nat,N),A2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),aa(set(nat),nat,nat_set_encode,A2)) ) ) ) ).

% set_encode_insert
tff(fact_5076_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list(A),X7: set(A),F2: fun(A,nat)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),X7))
     => ( finite_finite(A,X7)
       => ( groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F2),Xs)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_lt(list(A),fun(fun(A,nat),fun(A,nat)),Xs),F2)),X7) ) ) ) ).

% sum_list_map_eq_sum_count2
tff(fact_5077_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_parity(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(set(B),nat,finite_card(B),collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_lu(set(B),fun(fun(B,A),fun(B,bool)),A2),F2))))) ) ) ) ).

% even_sum_iff
tff(fact_5078_card__Collect__less__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),N))) = N ) ).

% card_Collect_less_nat
tff(fact_5079_insert__subset,axiom,
    ! [A: $tType,X3: A,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,X3),A2)),B3))
    <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),B3))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ) ).

% insert_subset
tff(fact_5080_card__Collect__le__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_ag(nat,fun(nat,bool)),N))) = aa(nat,nat,suc,N) ) ).

% card_Collect_le_nat
tff(fact_5081_card_Oinfinite,axiom,
    ! [A: $tType,A2: set(A)] :
      ( ~ finite_finite(A,A2)
     => ( aa(set(A),nat,finite_card(A),A2) = zero_zero(nat) ) ) ).

% card.infinite
tff(fact_5082_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Ns: list(A)] :
          ( ( groups8242544230860333062m_list(A,Ns) = zero_zero(A) )
        <=> ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Ns)))
             => ( X4 = zero_zero(A) ) ) ) ) ).

% sum_list_eq_0_iff
tff(fact_5083_List_Oset__insert,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),insert(A,X3,Xs)) = aa(set(A),set(A),insert2(A,X3),aa(list(A),set(A),set2(A),Xs)) ) ).

% List.set_insert
tff(fact_5084_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Y4: A,A2: set(B)] : ( groups7121269368397514597t_prod(B,A,aTP_Lamp_lv(A,fun(B,A),Y4),A2) = aa(nat,A,power_power(A,Y4),aa(set(B),nat,finite_card(B),A2)) ) ) ).

% prod_constant
tff(fact_5085_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aTP_Lamp_lw(B,A)),Xs)) = zero_zero(A) ) ) ).

% sum_list_0
tff(fact_5086_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),X3: B,G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),insert2(B,X3),A2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,G,X3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2)) ) ) ) ) ).

% sum.insert
tff(fact_5087_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),X3: B,G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
           => ( groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),insert2(B,X3),A2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X3)),groups7121269368397514597t_prod(B,A,G,A2)) ) ) ) ) ).

% prod.insert
tff(fact_5088_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Y4: A,A2: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_lx(A,fun(B,A),Y4)),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A2))),Y4) ) ) ).

% sum_constant
tff(fact_5089_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( groups8242544230860333062m_list(nat,upt(M,N)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gs(nat,nat)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum_list_upt
tff(fact_5090_card__insert__le,axiom,
    ! [A: $tType,A2: set(A),X3: A] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert2(A,X3),A2)))) ).

% card_insert_le
tff(fact_5091_insert__mono,axiom,
    ! [A: $tType,C6: set(A),D4: set(A),A3: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),D4))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,A3),C6)),aa(set(A),set(A),insert2(A,A3),D4))) ) ).

% insert_mono
tff(fact_5092_subset__insert,axiom,
    ! [A: $tType,X3: A,A2: set(A),B3: set(A)] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),insert2(A,X3),B3)))
      <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ) ).

% subset_insert
tff(fact_5093_subset__insertI,axiom,
    ! [A: $tType,B3: set(A),A3: A] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(set(A),set(A),insert2(A,A3),B3))) ).

% subset_insertI
tff(fact_5094_subset__insertI2,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),B2: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),insert2(A,B2),B3))) ) ).

% subset_insertI2
tff(fact_5095_n__subsets,axiom,
    ! [A: $tType,A2: set(A),K: nat] :
      ( finite_finite(A,A2)
     => ( aa(set(set(A)),nat,finite_card(set(A)),collect(set(A),aa(nat,fun(set(A),bool),aTP_Lamp_ly(set(A),fun(nat,fun(set(A),bool)),A2),K))) = aa(nat,nat,binomial(aa(set(A),nat,finite_card(A),A2)),K) ) ) ).

% n_subsets
tff(fact_5096_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A2: set(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,N)),aa(set(A),nat,finite_card(A),A2)))
    <=> ? [A6: A,B10: set(A)] :
          ( ( A2 = aa(set(A),set(A),insert2(A,A6),B10) )
          & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A6),B10))
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(set(A),nat,finite_card(A),B10)))
          & finite_finite(A,B10) ) ) ).

% card_le_Suc_iff
tff(fact_5097_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A2: set(A),N: nat] :
      ( ~ finite_finite(A,A2)
     => ? [B8: set(A)] :
          ( finite_finite(A,B8)
          & ( aa(set(A),nat,finite_card(A),B8) = N )
          & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B8),A2)) ) ) ).

% infinite_arbitrarily_large
tff(fact_5098_card__subset__eq,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
       => ( ( aa(set(A),nat,finite_card(A),A2) = aa(set(A),nat,finite_card(A),B3) )
         => ( A2 = B3 ) ) ) ) ).

% card_subset_eq
tff(fact_5099_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B3: set(A),A2: set(B),R2: fun(B,fun(A,bool))] :
      ( finite_finite(A,B3)
     => ( ! [A5: B] :
            ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A5),A2))
           => ? [B11: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B11),B3))
                & pp(aa(A,bool,aa(B,fun(A,bool),R2,A5),B11)) ) )
       => ( ! [A12: B,A23: B,B5: A] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A12),A2))
             => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A23),A2))
               => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B5),B3))
                 => ( pp(aa(A,bool,aa(B,fun(A,bool),R2,A12),B5))
                   => ( pp(aa(A,bool,aa(B,fun(A,bool),R2,A23),B5))
                     => ( A12 = A23 ) ) ) ) ) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(B),nat,finite_card(B),A2)),aa(set(A),nat,finite_card(A),B3))) ) ) ) ).

% card_le_if_inj_on_rel
tff(fact_5100_subset__Diff__insert,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),X3: A,C6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),aa(set(A),set(A),insert2(A,X3),C6))))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),C6)))
        & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2)) ) ) ).

% subset_Diff_insert
tff(fact_5101_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X3: A,Xs: list(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),groups8242544230860333062m_list(A,Xs))) ) ) ).

% member_le_sum_list
tff(fact_5102_length__concat,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( aa(list(B),nat,size_size(list(B)),concat(B,Xss)) = groups8242544230860333062m_list(nat,aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xss)) ) ).

% length_concat
tff(fact_5103_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y4: set(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),Y4)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert2(A,X3),Y4))),N)) ) ) ).

% card_insert_le_m1
tff(fact_5104_card__lists__length__eq,axiom,
    ! [A: $tType,A2: set(A),N: nat] :
      ( finite_finite(A,A2)
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),bool),aTP_Lamp_kt(set(A),fun(nat,fun(list(A),bool)),A2),N))) = aa(nat,nat,power_power(nat,aa(set(A),nat,finite_card(A),A2)),N) ) ) ).

% card_lists_length_eq
tff(fact_5105_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [F2: fun(B,A),C2: A,Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(A,fun(B,A),aTP_Lamp_fj(fun(B,A),fun(A,fun(B,A)),F2),C2)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F2),Xs))),C2) ) ) ).

% sum_list_mult_const
tff(fact_5106_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [C2: A,F2: fun(B,A),Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fi(A,fun(fun(B,A),fun(B,A)),C2),F2)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F2),Xs))) ) ) ).

% sum_list_const_mult
tff(fact_5107_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(B,A),G: fun(B,A),Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fm(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F2),Xs))),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,G),Xs))) ) ) ).

% sum_list_addf
tff(fact_5108_card__length__sum__list__rec,axiom,
    ! [M: nat,N5: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),M))
     => ( aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),bool),aTP_Lamp_lz(nat,fun(nat,fun(list(nat),bool)),M),N5))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),bool),aTP_Lamp_ma(nat,fun(nat,fun(list(nat),bool)),M),N5)))),aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),bool),aTP_Lamp_mb(nat,fun(nat,fun(list(nat),bool)),M),N5)))) ) ) ).

% card_length_sum_list_rec
tff(fact_5109_card__length__sum__list,axiom,
    ! [M: nat,N5: nat] : ( aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),bool),aTP_Lamp_lz(nat,fun(nat,fun(list(nat),bool)),M),N5))) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N5),M)),one_one(nat))),N5) ) ).

% card_length_sum_list
tff(fact_5110_card__2__iff_H,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),S2) = aa(num,nat,numeral_numeral(nat),bit0(one2)) )
    <=> ? [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),S2))
          & ? [Xa4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),S2))
              & ( X4 != Xa4 )
              & ! [Xb4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xb4),S2))
                 => ( ( Xb4 = X4 )
                    | ( Xb4 = Xa4 ) ) ) ) ) ) ).

% card_2_iff'
tff(fact_5111_card__ge__0__finite,axiom,
    ! [A: $tType,A2: set(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A2)))
     => finite_finite(A,A2) ) ).

% card_ge_0_finite
tff(fact_5112_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N: nat,S2: set(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(set(A),nat,finite_card(A),S2)))
     => ~ ! [T7: set(A)] :
            ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T7),S2))
           => ( ( aa(set(A),nat,finite_card(A),T7) = N )
             => ~ finite_finite(A,T7) ) ) ) ).

% obtain_subset_with_card_n
tff(fact_5113_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F3: set(A),C6: nat] :
      ( ! [G2: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),G2),F3))
         => ( finite_finite(A,G2)
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),G2)),C6)) ) )
     => ( finite_finite(A,F3)
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),F3)),C6)) ) ) ).

% finite_if_finite_subsets_card_bdd
tff(fact_5114_card__seteq,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),B3)),aa(set(A),nat,finite_card(A),A2)))
         => ( A2 = B3 ) ) ) ) ).

% card_seteq
tff(fact_5115_card__mono,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3))) ) ) ).

% card_mono
tff(fact_5116_card__less__sym__Diff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( finite_finite(A,A2)
     => ( finite_finite(A,B3)
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3)))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A2)))) ) ) ) ).

% card_less_sym_Diff
tff(fact_5117_card__le__sym__Diff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( finite_finite(A,A2)
     => ( finite_finite(A,B3)
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3)))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A2)))) ) ) ) ).

% card_le_sym_Diff
tff(fact_5118_card__length,axiom,
    ! [A: $tType,Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ).

% card_length
tff(fact_5119_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M7: set(A)] :
      ( finite_finite(A,M7)
     => ? [H3: fun(A,nat)] : bij_betw(A,nat,H3,M7,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(A),nat,finite_card(A),M7))) ) ).

% ex_bij_betw_finite_nat
tff(fact_5120_psubset__card__mono,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3))) ) ) ).

% psubset_card_mono
tff(fact_5121_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),X3: B,G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),insert2(B,X3),A2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),insert2(B,X3),A2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,G,X3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2)) ) ) ) ) ) ).

% sum.insert_if
tff(fact_5122_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),X3: B,G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
             => ( groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),insert2(B,X3),A2)) = groups7121269368397514597t_prod(B,A,G,A2) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
             => ( groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),insert2(B,X3),A2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X3)),groups7121269368397514597t_prod(B,A,G,A2)) ) ) ) ) ) ).

% prod.insert_if
tff(fact_5123_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),groups8242544230860333062m_list(A,Xs))) ) ) ).

% Groups_List.sum_list_nonneg
tff(fact_5124_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2)) )
         => ( ( groups8242544230860333062m_list(A,Xs) = zero_zero(A) )
          <=> ! [X4: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
               => ( X4 = zero_zero(A) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
tff(fact_5125_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),zero_zero(A))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),groups8242544230860333062m_list(A,Xs)),zero_zero(A))) ) ) ).

% sum_list_nonpos
tff(fact_5126_atLeast0__atMost__Suc,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,aa(nat,nat,suc,N)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ).

% atLeast0_atMost_Suc
tff(fact_5127_atLeast0__lessThan__Suc,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,N),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ).

% atLeast0_lessThan_Suc
tff(fact_5128_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( aa(set(nat),set(nat),insert2(nat,M),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N)) = set_or1337092689740270186AtMost(nat,M,N) ) ) ).

% atLeastAtMost_insertL
tff(fact_5129_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),aa(nat,nat,suc,N)))
     => ( set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,aa(nat,nat,suc,N)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% atLeastAtMostSuc_conv
tff(fact_5130_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( set_or1337092689740270186AtMost(nat,M,N) = aa(set(nat),set(nat),insert2(nat,M),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N)) ) ) ).

% Icc_eq_insert_lb_nat
tff(fact_5131_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [Xs: list(A)] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),groups8242544230860333062m_list(A,Xs))),groups8242544230860333062m_list(A,aa(list(A),list(A),map(A,A,abs_abs(A)),Xs)))) ) ).

% sum_list_abs
tff(fact_5132_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat,C2: A] : ( groups8242544230860333062m_list(A,replicate(A,N,C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),C2) ) ) ).

% sum_list_replicate
tff(fact_5133_lessThan__nat__numeral,axiom,
    ! [K: num] : ( set_ord_lessThan(nat,aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert2(nat,pred_numeral(K)),set_ord_lessThan(nat,pred_numeral(K))) ) ).

% lessThan_nat_numeral
tff(fact_5134_card__less,axiom,
    ! [M7: set(nat),I: nat] :
      ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),M7))
     => ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_mc(set(nat),fun(nat,fun(nat,bool)),M7),I))) != zero_zero(nat) ) ) ).

% card_less
tff(fact_5135_card__less__Suc,axiom,
    ! [M7: set(nat),I: nat] :
      ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),M7))
     => ( aa(nat,nat,suc,aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_md(set(nat),fun(nat,fun(nat,bool)),M7),I)))) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_mc(set(nat),fun(nat,fun(nat,bool)),M7),I))) ) ) ).

% card_less_Suc
tff(fact_5136_card__less__Suc2,axiom,
    ! [M7: set(nat),I: nat] :
      ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),M7))
     => ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_md(set(nat),fun(nat,fun(nat,bool)),M7),I))) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_mc(set(nat),fun(nat,fun(nat,bool)),M7),I))) ) ) ).

% card_less_Suc2
tff(fact_5137_atMost__nat__numeral,axiom,
    ! [K: num] : ( set_ord_atMost(nat,aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert2(nat,aa(num,nat,numeral_numeral(nat),K)),set_ord_atMost(nat,pred_numeral(K))) ) ).

% atMost_nat_numeral
tff(fact_5138_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( aa(set(int),nat,finite_card(int),set_or7035219750837199246ssThan(int,zero_zero(int),U)) = aa(int,nat,nat2,U) ) ).

% card_atLeastZeroLessThan_int
tff(fact_5139_sum__Suc,axiom,
    ! [A: $tType,F2: fun(A,nat),A2: set(A)] : ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_me(fun(A,nat),fun(A,nat),F2)),A2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A2)),aa(set(A),nat,finite_card(A),A2)) ) ).

% sum_Suc
tff(fact_5140_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S2: set(A),T6: set(B),R4: fun(A,fun(B,bool)),K: nat] :
      ( finite_finite(A,S2)
     => ( finite_finite(B,T6)
       => ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),T6))
             => ( aa(set(A),nat,finite_card(A),collect(A,aa(B,fun(A,bool),aa(fun(A,fun(B,bool)),fun(B,fun(A,bool)),aTP_Lamp_mf(set(A),fun(fun(A,fun(B,bool)),fun(B,fun(A,bool))),S2),R4),X2))) = K ) )
         => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,fun(B,bool)),fun(A,nat),aTP_Lamp_mh(set(B),fun(fun(A,fun(B,bool)),fun(A,nat)),T6),R4)),S2) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(set(B),nat,finite_card(B),T6)) ) ) ) ) ).

% sum_multicount
tff(fact_5141_subset__card__intvl__is__intvl,axiom,
    ! [A2: set(nat),K: nat] :
      ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),A2),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(set(nat),nat,finite_card(nat),A2)))))
     => ( A2 = set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(set(nat),nat,finite_card(nat),A2))) ) ) ).

% subset_card_intvl_is_intvl
tff(fact_5142_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add(B)
        & ordere6658533253407199908up_add(B) )
     => ! [Xs: list(A),F2: fun(A,B),G: fun(A,B)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,G,X2))) )
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F2),Xs))),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,G),Xs)))) ) ) ).

% sum_list_mono
tff(fact_5143_real__of__card,axiom,
    ! [A: $tType,A2: set(A)] : ( aa(nat,real,semiring_1_of_nat(real),aa(set(A),nat,finite_card(A),A2)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_mi(A,real)),A2) ) ).

% real_of_card
tff(fact_5144_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & semiring_1(A) )
     => ! [A2: set(B),K5: A,F2: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K5),aa(B,A,F2,I3))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A2))),K5)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2))) ) ) ).

% sum_bounded_below
tff(fact_5145_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & semiring_1(A) )
     => ! [A2: set(B),F2: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),K5)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A2))),K5))) ) ) ).

% sum_bounded_above
tff(fact_5146_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A2)),aa(nat,nat,suc,zero_zero(nat))))
      <=> ! [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
           => ! [Xa4: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),A2))
               => ( X4 = Xa4 ) ) ) ) ) ).

% card_le_Suc0_iff_eq
tff(fact_5147_card__Diff__subset,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ).

% card_Diff_subset
tff(fact_5148_card__psubset,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3)))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3)) ) ) ) ).

% card_psubset
tff(fact_5149_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( finite_finite(A,B3)
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3)))) ) ).

% diff_card_le_card_Diff
tff(fact_5150_card__lists__length__le,axiom,
    ! [A: $tType,A2: set(A),N: nat] :
      ( finite_finite(A,A2)
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),bool),aTP_Lamp_ku(set(A),fun(nat,fun(list(A),bool)),A2),N))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),power_power(nat,aa(set(A),nat,finite_card(A),A2))),set_ord_atMost(nat,N)) ) ) ).

% card_lists_length_le
tff(fact_5151_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M7: set(A)] :
      ( finite_finite(A,M7)
     => ? [H3: fun(nat,A)] : bij_betw(nat,A,H3,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(A),nat,finite_card(A),M7)),M7) ) ).

% ex_bij_betw_nat_finite
tff(fact_5152_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [K: nat,Ns: list(A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Ns)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Ns),K)),groups8242544230860333062m_list(A,Ns))) ) ) ).

% elem_le_sum_list
tff(fact_5153_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),N))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aTP_Lamp_lf(nat,fun(A,bool),N)))),N)) ) ) ).

% card_roots_unity
tff(fact_5154_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N5: set(nat),N: nat] :
      ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),N5),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(nat),nat,finite_card(nat),N5)),N)) ) ).

% subset_eq_atLeast0_lessThan_card
tff(fact_5155_size__list__conv__sum__list,axiom,
    ! [B: $tType,F2: fun(B,nat),Xs: list(B)] : ( aa(list(B),nat,size_list(B,F2),Xs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),groups8242544230860333062m_list(nat,aa(list(B),list(nat),map(B,nat,F2),Xs))),aa(list(B),nat,size_size(list(B)),Xs)) ) ).

% size_list_conv_sum_list
tff(fact_5156_card__sum__le__nat__sum,axiom,
    ! [S2: set(nat)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gs(nat,nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(nat),nat,finite_card(nat),S2)))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gs(nat,nat)),S2))) ).

% card_sum_le_nat_sum
tff(fact_5157_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [R2: B,Xs: list(C)] : ( groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,aTP_Lamp_mj(B,fun(C,B),R2)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(list(C),nat,size_size(list(C)),Xs))),R2) ) ) ).

% sum_list_triv
tff(fact_5158_sum__list__Suc,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A)] : ( groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,aTP_Lamp_me(fun(A,nat),fun(A,nat),F2)),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F2),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% sum_list_Suc
tff(fact_5159_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2 != zero_zero(complex) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( aa(set(complex),nat,finite_card(complex),collect(complex,aa(nat,fun(complex,bool),aTP_Lamp_lr(complex,fun(nat,fun(complex,bool)),C2),N))) = N ) ) ) ).

% card_nth_roots
tff(fact_5160_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(set(complex),nat,finite_card(complex),collect(complex,aTP_Lamp_fh(nat,fun(complex,bool),N))) = N ) ) ).

% card_roots_unity_eq
tff(fact_5161_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [S2: set(B),F2: fun(B,A),K5: real] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(B,A,F2,X2))),K5)) )
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),S2))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(set(B),nat,finite_card(B),S2))),K5))) ) ) ).

% sum_norm_bound
tff(fact_5162_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: set(B),F2: fun(B,A),N: A,K: nat] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3)))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),N)) ) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(B),nat,finite_card(B),A2)),K))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),N))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),groups7121269368397514597t_prod(B,A,F2,A2)),aa(nat,A,power_power(A,N),K))) ) ) ) ) ).

% prod_le_power
tff(fact_5163_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & semiring_1(A) )
     => ! [A2: set(B),F2: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,I3)),K5)) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(B),nat,finite_card(B),A2)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A2))),K5))) ) ) ) ).

% sum_bounded_above_strict
tff(fact_5164_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Xs: list(B)] : ( groups8242544230860333062m_list(B,Xs) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),nth(B,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% sum_list_sum_nth
tff(fact_5165_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A)] : ( groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F2),Xs)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(list(A),fun(A,nat),aTP_Lamp_mk(fun(A,nat),fun(list(A),fun(A,nat)),F2),Xs)),aa(list(A),set(A),set2(A),Xs)) ) ).

% sum_list_map_eq_sum_count
tff(fact_5166_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,N: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aa(nat,fun(A,bool),aTP_Lamp_lk(fun(nat,A),fun(nat,fun(A,bool)),C2),N)))),N)) ) ) ) ).

% polyfun_roots_card
tff(fact_5167_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A),C2: A] :
          ( finite_finite(B,S2)
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( groups7121269368397514597t_prod(B,A,aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_ml(B,fun(fun(B,A),fun(A,fun(B,A))),A3),B2),C2),S2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,B2,A3)),aa(nat,A,power_power(A,C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,finite_card(B),S2)),one_one(nat)))) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( groups7121269368397514597t_prod(B,A,aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_ml(B,fun(fun(B,A),fun(A,fun(B,A))),A3),B2),C2),S2) = aa(nat,A,power_power(A,C2),aa(set(B),nat,finite_card(B),S2)) ) ) ) ) ) ).

% prod_gen_delta
tff(fact_5168_set__decode__plus__power__2,axiom,
    ! [N: nat,Z: nat] :
      ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N),nat_set_decode(Z)))
     => ( nat_set_decode(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),Z)) = aa(set(nat),set(nat),insert2(nat,N),nat_set_decode(Z)) ) ) ).

% set_decode_plus_power_2
tff(fact_5169_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,N: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
           => ( finite_finite(A,collect(A,aa(nat,fun(A,bool),aTP_Lamp_lk(fun(nat,A),fun(nat,fun(A,bool)),C2),N)))
              & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aa(nat,fun(A,bool),aTP_Lamp_lk(fun(nat,A),fun(nat,fun(A,bool)),C2),N)))),N)) ) ) ) ) ).

% polyfun_rootbound
tff(fact_5170_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A2: set(A),K: nat] :
      ( finite_finite(A,A2)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),aa(set(A),nat,finite_card(A),A2)))
       => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),bool),aTP_Lamp_mm(set(A),fun(nat,fun(list(A),bool)),A2),K))) = groups7121269368397514597t_prod(nat,nat,aTP_Lamp_gs(nat,nat),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A2)),K)),one_one(nat)),aa(set(A),nat,finite_card(A),A2))) ) ) ) ).

% card_lists_distinct_length_eq
tff(fact_5171_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A2: set(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(set(A),nat,finite_card(A),A2)))
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(set(A),fun(list(A),bool),aTP_Lamp_mn(nat,fun(set(A),fun(list(A),bool)),K),A2))) = groups7121269368397514597t_prod(nat,nat,aTP_Lamp_gs(nat,nat),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A2)),K)),one_one(nat)),aa(set(A),nat,finite_card(A),A2))) ) ) ).

% card_lists_distinct_length_eq'
tff(fact_5172_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [F2: fun(nat,B),Ns: list(nat)] :
          ( ! [X2: nat,Y2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X2),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(nat,B,F2,X2)),aa(nat,B,F2,Y2))) )
         => ( sorted_wrt(nat,ord_less(nat),Ns)
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),F2),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(nat),nat,size_size(list(nat)),Ns)))),groups8242544230860333062m_list(B,aa(list(nat),list(B),map(nat,B,F2),Ns)))) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
tff(fact_5173_distinct__insert,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( distinct(A,insert(A,X3,Xs))
    <=> distinct(A,Xs) ) ).

% distinct_insert
tff(fact_5174_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A2: set(A),N: nat] :
      ( finite_finite(A,A2)
     => finite_finite(list(A),collect(list(A),aa(nat,fun(list(A),bool),aTP_Lamp_mm(set(A),fun(nat,fun(list(A),bool)),A2),N))) ) ).

% finite_lists_distinct_length_eq
tff(fact_5175_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R4: fun(A,fun(A,bool)),F2: fun(B,A),Xs: list(B)] :
      ( sorted_wrt(A,R4,aa(list(B),list(A),map(B,A,F2),Xs))
    <=> sorted_wrt(B,aa(fun(B,A),fun(B,fun(B,bool)),aTP_Lamp_mo(fun(A,fun(A,bool)),fun(fun(B,A),fun(B,fun(B,bool))),R4),F2),Xs) ) ).

% sorted_wrt_map
tff(fact_5176_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => distinct(set(A),aa(list(list(A)),list(set(A)),map(list(A),set(A),set2(A)),subseqs(A,Xs))) ) ).

% distinct_set_subseqs
tff(fact_5177_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] :
          ( finite_finite(A,A2)
         => ? [X2: list(A)] :
              ( ( aa(list(A),set(A),set2(A),X2) = A2 )
              & sorted_wrt(A,ord_less_eq(A),X2)
              & distinct(A,X2)
              & ! [Y5: list(A)] :
                  ( ( ( aa(list(A),set(A),set2(A),Y5) = A2 )
                    & sorted_wrt(A,ord_less_eq(A),Y5)
                    & distinct(A,Y5) )
                 => ( Y5 = X2 ) ) ) ) ) ).

% finite_sorted_distinct_unique
tff(fact_5178_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: list(A)] :
          ( sorted_wrt(A,ord_less(A),L)
        <=> ( sorted_wrt(A,ord_less_eq(A),L)
            & distinct(A,L) ) ) ) ).

% strict_sorted_iff
tff(fact_5179_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys2: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( distinct(A,Xs)
           => ( sorted_wrt(A,ord_less_eq(A),Ys2)
             => ( distinct(A,Ys2)
               => ( ( aa(list(A),set(A),set2(A),Xs) = aa(list(A),set(A),set2(A),Ys2) )
                 => ( Xs = Ys2 ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
tff(fact_5180_distinct__upt,axiom,
    ! [I: nat,J3: nat] : distinct(nat,upt(I,J3)) ).

% distinct_upt
tff(fact_5181_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] :
      ( distinct(A,Xs)
     => ( distinct(B,Ys2)
       => distinct(product_prod(A,B),product(A,B,Xs,Ys2)) ) ) ).

% distinct_product
tff(fact_5182_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( distinct(A,Xs)
         => distinct(A,Xs) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
tff(fact_5183_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,fun(A,bool)),Q: fun(A,fun(A,bool))] :
      ( ! [X2: A,Y2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y2),aa(list(A),set(A),set2(A),Xs)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),P,X2),Y2))
             => pp(aa(A,bool,aa(A,fun(A,bool),Q,X2),Y2)) ) ) )
     => ( sorted_wrt(A,P,Xs)
       => sorted_wrt(A,Q,Xs) ) ) ).

% sorted_wrt_mono_rel
tff(fact_5184_distinct__take,axiom,
    ! [A: $tType,Xs: list(A),I: nat] :
      ( distinct(A,Xs)
     => distinct(A,take(A,I,Xs)) ) ).

% distinct_take
tff(fact_5185_sorted__wrt__take,axiom,
    ! [A: $tType,F2: fun(A,fun(A,bool)),Xs: list(A),N: nat] :
      ( sorted_wrt(A,F2,Xs)
     => sorted_wrt(A,F2,take(A,N,Xs)) ) ).

% sorted_wrt_take
tff(fact_5186_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list(A)] : sorted_wrt(A,aTP_Lamp_mp(A,fun(A,bool)),Xs) ).

% sorted_wrt_true
tff(fact_5187_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% strict_sorted_imp_sorted
tff(fact_5188_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys2: list(A)] :
          ( sorted_wrt(A,ord_less(A),Xs)
         => ( sorted_wrt(A,ord_less(A),Ys2)
           => ( ( aa(list(A),set(A),set2(A),Ys2) = aa(list(A),set(A),set2(A),Xs) )
             => ( Ys2 = Xs ) ) ) ) ) ).

% strict_sorted_equal
tff(fact_5189_sorted__take,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),N: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),take(A,N,Xs)) ) ) ).

% sorted_take
tff(fact_5190_sorted__replicate,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [N: nat,X3: A] : sorted_wrt(A,ord_less_eq(A),replicate(A,N,X3)) ) ).

% sorted_replicate
tff(fact_5191_finite__distinct__list,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
     => ? [Xs2: list(A)] :
          ( ( aa(list(A),set(A),set2(A),Xs2) = A2 )
          & distinct(A,Xs2) ) ) ).

% finite_distinct_list
tff(fact_5192_sorted__wrt__upt,axiom,
    ! [M: nat,N: nat] : sorted_wrt(nat,ord_less(nat),upt(M,N)) ).

% sorted_wrt_upt
tff(fact_5193_sorted__upt,axiom,
    ! [M: nat,N: nat] : sorted_wrt(nat,ord_less_eq(nat),upt(M,N)) ).

% sorted_upt
tff(fact_5194_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs))
        <=> sorted_wrt(B,aTP_Lamp_mq(fun(B,A),fun(B,fun(B,bool)),F2),Xs) ) ) ).

% sorted_map
tff(fact_5195_subseqs__distinctD,axiom,
    ! [A: $tType,Ys2: list(A),Xs: list(A)] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Ys2),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs))))
     => ( distinct(A,Xs)
       => distinct(A,Ys2) ) ) ).

% subseqs_distinctD
tff(fact_5196_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,fun(A,bool))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)))
     => sorted_wrt(A,P,Xs) ) ).

% sorted_wrt01
tff(fact_5197_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),Xs: list(A)] :
      ( sorted_wrt(A,P,Xs)
    <=> ! [I2: nat,J4: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),J4))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs)))
           => pp(aa(A,bool,aa(A,fun(A,bool),P,aa(nat,A,nth(A,Xs),I2)),aa(nat,A,nth(A,Xs),J4))) ) ) ) ).

% sorted_wrt_iff_nth_less
tff(fact_5198_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),Xs: list(A),I: nat,J3: nat] :
      ( sorted_wrt(A,P,Xs)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs)))
         => pp(aa(A,bool,aa(A,fun(A,bool),P,aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J3))) ) ) ) ).

% sorted_wrt_nth_less
tff(fact_5199_distinct__card,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => ( aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ) ).

% distinct_card
tff(fact_5200_card__distinct,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) )
     => distinct(A,Xs) ) ).

% card_distinct
tff(fact_5201_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list(A),I: nat,J3: nat] :
      ( distinct(A,Xs)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs)))
         => ( ( aa(nat,A,nth(A,Xs),I) = aa(nat,A,nth(A,Xs),J3) )
          <=> ( I = J3 ) ) ) ) ) ).

% nth_eq_iff_index_eq
tff(fact_5202_distinct__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
    <=> ! [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))
         => ! [J4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs)))
             => ( ( I2 != J4 )
               => ( aa(nat,A,nth(A,Xs),I2) != aa(nat,A,nth(A,Xs),J4) ) ) ) ) ) ).

% distinct_conv_nth
tff(fact_5203_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(A)] :
          ( distinct(A,Xs)
         => ( groups8242544230860333062m_list(A,Xs) = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_mr(A,A)),aa(list(A),set(A),set2(A),Xs)) ) ) ) ).

% distinct_sum_list_conv_Sum
tff(fact_5204_sorted01,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)))
         => sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% sorted01
tff(fact_5205_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I2: nat,J4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),J4))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Xs),I2)),aa(nat,A,nth(A,Xs),J4))) ) ) ) ) ).

% sorted_iff_nth_mono_less
tff(fact_5206_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( distinct(A,Xs)
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ? [X2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X2),aa(list(A),nat,size_size(list(A)),Xs)))
            & ( aa(nat,A,nth(A,Xs),X2) = X3 )
            & ! [Y5: nat] :
                ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Y5),aa(list(A),nat,size_size(list(A)),Xs)))
                  & ( aa(nat,A,nth(A,Xs),Y5) = X3 ) )
               => ( Y5 = X2 ) ) ) ) ) ).

% distinct_Ex1
tff(fact_5207_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Xs: list(B),F2: fun(B,C)] :
          ( distinct(B,Xs)
         => ( groups8242544230860333062m_list(C,aa(list(B),list(C),map(B,C,F2),Xs)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(list(B),set(B),set2(B),Xs)) ) ) ) ).

% sum_list_distinct_conv_sum_set
tff(fact_5208_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(B),G: fun(B,A)] :
          ( distinct(B,Xs)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(list(B),set(B),set2(B),Xs)) = groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,G),Xs)) ) ) ) ).

% sum.distinct_set_conv_list
tff(fact_5209_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),M),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),N)))
     => ( set_or1337092689740270186AtMost(int,M,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),N)) = aa(set(int),set(int),insert2(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),N)),set_or1337092689740270186AtMost(int,M,N)) ) ) ).

% atLeastAtMostPlus1_int_conv
tff(fact_5210_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,I2)),aa(list(A),nat,size_size(list(A)),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Xs),I2)),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I2)))) ) ) ) ).

% sorted_iff_nth_Suc
tff(fact_5211_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] :
          ( finite_finite(A,A2)
         => ~ ! [L2: list(A)] :
                ( sorted_wrt(A,ord_less(A),L2)
               => ( ( aa(list(A),set(A),set2(A),L2) = A2 )
                 => ( aa(list(A),nat,size_size(list(A)),L2) != aa(set(A),nat,finite_card(A),A2) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
tff(fact_5212_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I2: nat,J4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I2),J4))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Xs),I2)),aa(nat,A,nth(A,Xs),J4))) ) ) ) ) ).

% sorted_iff_nth_mono
tff(fact_5213_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I: nat,J3: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J3))) ) ) ) ) ).

% sorted_nth_mono
tff(fact_5214_sorted__wrt__less__idx,axiom,
    ! [Ns: list(nat),I: nat] :
      ( sorted_wrt(nat,ord_less(nat),Ns)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(nat),nat,size_size(list(nat)),Ns)))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),aa(nat,nat,nth(nat,Ns),I))) ) ) ).

% sorted_wrt_less_idx
tff(fact_5215_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list(A),A2: set(nat),B3: set(A)] :
      ( distinct(A,Xs)
     => ( ( A2 = set_ord_lessThan(nat,aa(list(A),nat,size_size(list(A)),Xs)) )
       => ( ( B3 = aa(list(A),set(A),set2(A),Xs) )
         => bij_betw(nat,A,nth(A,Xs),A2,B3) ) ) ) ).

% bij_betw_nth
tff(fact_5216_and__int_Osimps,axiom,
    ! [K: int,L: int] :
      ( ( ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),K),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
          & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),L),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))))) ) )
      & ( ~ ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),K),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),L),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ) ).

% and_int.simps
tff(fact_5217_and__int_Oelims,axiom,
    ! [X3: int,Xa: int,Y4: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X3),Xa) = Y4 )
     => ( ( ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X3),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( Y4 = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),X3)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xa))))) ) )
        & ( ~ ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X3),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
              & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( Y4 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),X3)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xa))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X3),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ) ) ).

% and_int.elims
tff(fact_5218_and__int_Opelims,axiom,
    ! [X3: int,Xa: int,Y4: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X3),Xa) = Y4 )
     => ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,X3),Xa)))
       => ~ ( ( ( ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X3),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                  & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => ( Y4 = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),X3)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xa))))) ) )
              & ( ~ ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X3),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                    & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Xa),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => ( Y4 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),X3)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xa))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X3),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) )
           => ~ pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,X3),Xa))) ) ) ) ).

% and_int.pelims
tff(fact_5219_empty__subsetI,axiom,
    ! [A: $tType,A2: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),bot_bot(set(A))),A2)) ).

% empty_subsetI
tff(fact_5220_subset__empty,axiom,
    ! [A: $tType,A2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),bot_bot(set(A))))
    <=> ( A2 = bot_bot(set(A)) ) ) ).

% subset_empty
tff(fact_5221_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty
tff(fact_5222_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% atLeastatMost_empty_iff
tff(fact_5223_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or1337092689740270186AtMost(A,A3,B2) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% atLeastatMost_empty_iff2
tff(fact_5224_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) ) ) ) ).

% atLeastatMost_empty
tff(fact_5225_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A3: A,A2: set(A),B2: A] :
      ( ( aa(set(A),set(A),insert2(A,A3),A2) = aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))) )
    <=> ( ( A3 = B2 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))) ) ) ).

% singleton_insert_inj_eq'
tff(fact_5226_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A3: A,A2: set(A)] :
      ( ( aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))) = aa(set(A),set(A),insert2(A,A3),A2) )
    <=> ( ( A3 = B2 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))) ) ) ).

% singleton_insert_inj_eq
tff(fact_5227_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( set_or7035219750837199246ssThan(A,A3,B2) = bot_bot(set(A)) ) ) ) ).

% atLeastLessThan_empty
tff(fact_5228_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or7035219750837199246ssThan(A,A3,B2) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% atLeastLessThan_empty_iff2
tff(fact_5229_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( ( set_or7035219750837199246ssThan(A,A3,B2) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% atLeastLessThan_empty_iff
tff(fact_5230_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3) = bot_bot(set(A)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ).

% Diff_eq_empty_iff
tff(fact_5231_card_Oempty,axiom,
    ! [A: $tType] : ( aa(set(A),nat,finite_card(A),bot_bot(set(A))) = zero_zero(nat) ) ).

% card.empty
tff(fact_5232_card__0__eq,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
     => ( ( aa(set(A),nat,finite_card(A),A2) = zero_zero(nat) )
      <=> ( A2 = bot_bot(set(A)) ) ) ) ).

% card_0_eq
tff(fact_5233_subset__Compl__singleton,axiom,
    ! [A: $tType,A2: set(A),B2: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))))
    <=> ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),A2)) ) ).

% subset_Compl_singleton
tff(fact_5234_set__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( N != zero_zero(nat) )
     => ( aa(list(A),set(A),set2(A),replicate(A,N,X3)) = aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))) ) ) ).

% set_replicate
tff(fact_5235_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),bot_bot(A)))
         => ( A3 = bot_bot(A) ) ) ) ).

% bot.extremum_uniqueI
tff(fact_5236_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),bot_bot(A)))
        <=> ( A3 = bot_bot(A) ) ) ) ).

% bot.extremum_unique
tff(fact_5237_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),bot_bot(A)),A3)) ) ).

% bot.extremum
tff(fact_5238_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] :
          ( ( A3 != bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),A3)) ) ) ).

% bot.not_eq_extremum
tff(fact_5239_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),bot_bot(A))) ) ).

% bot.extremum_strict
tff(fact_5240_not__psubset__empty,axiom,
    ! [A: $tType,A2: set(A)] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),bot_bot(set(A)))) ).

% not_psubset_empty
tff(fact_5241_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4) = bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ).

% diff_shunt_var
tff(fact_5242_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: set(A)] :
          ( finite_finite(A,A2)
         => ( ( A2 != bot_bot(set(A)) )
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
                & ! [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),A2))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Xa2),X2))
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal
tff(fact_5243_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: set(A)] :
          ( finite_finite(A,A2)
         => ( ( A2 != bot_bot(set(A)) )
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
                & ! [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),A2))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Xa2))
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal
tff(fact_5244_infinite__growing,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X7: set(A)] :
          ( ( X7 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
               => ? [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),X7))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Xa2)) ) )
           => ~ finite_finite(A,X7) ) ) ) ).

% infinite_growing
tff(fact_5245_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [S2: set(A)] :
          ( finite_finite(A,S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
                & ~ ? [Xa2: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),S2))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Xa2),X2)) ) ) ) ) ) ).

% ex_min_if_finite
tff(fact_5246_subset__singleton__iff,axiom,
    ! [A: $tType,X7: set(A),A3: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X7),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))
    <=> ( ( X7 = bot_bot(set(A)) )
        | ( X7 = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) ) ) ).

% subset_singleton_iff
tff(fact_5247_subset__singletonD,axiom,
    ! [A: $tType,A2: set(A),X3: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))
     => ( ( A2 = bot_bot(set(A)) )
        | ( A2 = aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))) ) ) ) ).

% subset_singletonD
tff(fact_5248_subset__Compl__self__eq,axiom,
    ! [A: $tType,A2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),uminus_uminus(set(A)),A2)))
    <=> ( A2 = bot_bot(set(A)) ) ) ).

% subset_Compl_self_eq
tff(fact_5249_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [S2: set(B),P: fun(set(B),bool),F2: fun(B,A)] :
          ( finite_finite(B,S2)
         => ( pp(aa(set(B),bool,P,bot_bot(set(B))))
           => ( ! [X2: B,S5: set(B)] :
                  ( finite_finite(B,S5)
                 => ( ! [Y5: B] :
                        ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Y5),S5))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,Y5)),aa(B,A,F2,X2))) )
                   => ( pp(aa(set(B),bool,P,S5))
                     => pp(aa(set(B),bool,P,aa(set(B),set(B),insert2(B,X2),S5))) ) ) )
             => pp(aa(set(B),bool,P,S2)) ) ) ) ) ).

% finite_ranking_induct
tff(fact_5250_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A),P: fun(set(A),bool)] :
          ( finite_finite(A,A2)
         => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
           => ( ! [B5: A,A7: set(A)] :
                  ( finite_finite(A,A7)
                 => ( ! [X: A] :
                        ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),A7))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B5),X)) )
                   => ( pp(aa(set(A),bool,P,A7))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,B5),A7))) ) ) )
             => pp(aa(set(A),bool,P,A2)) ) ) ) ) ).

% finite_linorder_min_induct
tff(fact_5251_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A),P: fun(set(A),bool)] :
          ( finite_finite(A,A2)
         => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
           => ( ! [B5: A,A7: set(A)] :
                  ( finite_finite(A,A7)
                 => ( ! [X: A] :
                        ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),A7))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),B5)) )
                   => ( pp(aa(set(A),bool,P,A7))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,B5),A7))) ) ) )
             => pp(aa(set(A),bool,P,A2)) ) ) ) ) ).

% finite_linorder_max_induct
tff(fact_5252_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A2: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ( A2 != bot_bot(set(B)) )
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X2)),aa(B,A,G,X2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2))) ) ) ) ) ).

% sum_strict_mono
tff(fact_5253_finite__subset__induct_H,axiom,
    ! [A: $tType,F3: set(A),A2: set(A),P: fun(set(A),bool)] :
      ( finite_finite(A,F3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F3),A2))
       => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
         => ( ! [A5: A,F5: set(A)] :
                ( finite_finite(A,F5)
               => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A5),A2))
                 => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F5),A2))
                   => ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A5),F5))
                     => ( pp(aa(set(A),bool,P,F5))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,A5),F5))) ) ) ) ) )
           => pp(aa(set(A),bool,P,F3)) ) ) ) ) ).

% finite_subset_induct'
tff(fact_5254_finite__subset__induct,axiom,
    ! [A: $tType,F3: set(A),A2: set(A),P: fun(set(A),bool)] :
      ( finite_finite(A,F3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F3),A2))
       => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
         => ( ! [A5: A,F5: set(A)] :
                ( finite_finite(A,F5)
               => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A5),A2))
                 => ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A5),F5))
                   => ( pp(aa(set(A),bool,P,F5))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,A5),F5))) ) ) ) )
           => pp(aa(set(A),bool,P,F3)) ) ) ) ) ).

% finite_subset_induct
tff(fact_5255_card__eq__0__iff,axiom,
    ! [A: $tType,A2: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A2) = zero_zero(nat) )
    <=> ( ( A2 = bot_bot(set(A)) )
        | ~ finite_finite(A,A2) ) ) ).

% card_eq_0_iff
tff(fact_5256_Diff__single__insert,axiom,
    ! [A: $tType,A2: set(A),X3: A,B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))))),B3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),insert2(A,X3),B3))) ) ).

% Diff_single_insert
tff(fact_5257_subset__insert__iff,axiom,
    ! [A: $tType,A2: set(A),X3: A,B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),insert2(A,X3),B3)))
    <=> ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))))),B3)) )
        & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ) ) ).

% subset_insert_iff
tff(fact_5258_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [I5: set(B),F2: fun(B,A)] :
          ( finite_finite(B,I5)
         => ( ( I5 != bot_bot(set(B)) )
           => ( ! [I3: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),I5))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(B,A,F2,I3))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),I5))) ) ) ) ) ).

% sum_pos
tff(fact_5259_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),F2: fun(A,B)] :
          ( finite_finite(A,I5)
         => ( ( I5 != bot_bot(set(A)) )
           => ( ! [I3: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(A,B,F2,I3))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),groups7121269368397514597t_prod(A,B,F2,I5))) ) ) ) ) ).

% less_1_prod
tff(fact_5260_card__gt__0__iff,axiom,
    ! [A: $tType,A2: set(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A2)))
    <=> ( ( A2 != bot_bot(set(A)) )
        & finite_finite(A,A2) ) ) ).

% card_gt_0_iff
tff(fact_5261_finite__remove__induct,axiom,
    ! [A: $tType,B3: set(A),P: fun(set(A),bool)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [A7: set(A)] :
              ( finite_finite(A,A7)
             => ( ( A7 != bot_bot(set(A)) )
               => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A7),B3))
                 => ( ! [X: A] :
                        ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),A7))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A7),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) )
                   => pp(aa(set(A),bool,P,A7)) ) ) ) )
         => pp(aa(set(A),bool,P,B3)) ) ) ) ).

% finite_remove_induct
tff(fact_5262_remove__induct,axiom,
    ! [A: $tType,P: fun(set(A),bool),B3: set(A)] :
      ( pp(aa(set(A),bool,P,bot_bot(set(A))))
     => ( ( ~ finite_finite(A,B3)
         => pp(aa(set(A),bool,P,B3)) )
       => ( ! [A7: set(A)] :
              ( finite_finite(A,A7)
             => ( ( A7 != bot_bot(set(A)) )
               => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A7),B3))
                 => ( ! [X: A] :
                        ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),A7))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A7),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) )
                   => pp(aa(set(A),bool,P,A7)) ) ) ) )
         => pp(aa(set(A),bool,P,B3)) ) ) ) ).

% remove_induct
tff(fact_5263_card__Suc__eq,axiom,
    ! [A: $tType,A2: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A2) = aa(nat,nat,suc,K) )
    <=> ? [B7: A,B10: set(A)] :
          ( ( A2 = aa(set(A),set(A),insert2(A,B7),B10) )
          & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B7),B10))
          & ( aa(set(A),nat,finite_card(A),B10) = K )
          & ( ( K = zero_zero(nat) )
           => ( B10 = bot_bot(set(A)) ) ) ) ) ).

% card_Suc_eq
tff(fact_5264_card__eq__SucD,axiom,
    ! [A: $tType,A2: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A2) = aa(nat,nat,suc,K) )
     => ? [B5: A,B8: set(A)] :
          ( ( A2 = aa(set(A),set(A),insert2(A,B5),B8) )
          & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B5),B8))
          & ( aa(set(A),nat,finite_card(A),B8) = K )
          & ( ( K = zero_zero(nat) )
           => ( B8 = bot_bot(set(A)) ) ) ) ) ).

% card_eq_SucD
tff(fact_5265_card__1__singleton__iff,axiom,
    ! [A: $tType,A2: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A2) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ? [X4: A] : ( A2 = aa(set(A),set(A),insert2(A,X4),bot_bot(set(A))) ) ) ).

% card_1_singleton_iff
tff(fact_5266_card__Diff1__le,axiom,
    ! [A: $tType,A2: set(A),X3: A] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A2))) ).

% card_Diff1_le
tff(fact_5267_finite__induct__select,axiom,
    ! [A: $tType,S2: set(A),P: fun(set(A),bool)] :
      ( finite_finite(A,S2)
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [T7: set(A)] :
              ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),T7),S2))
             => ( pp(aa(set(A),bool,P,T7))
               => ? [X: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T7)))
                    & pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,X),T7))) ) ) )
         => pp(aa(set(A),bool,P,S2)) ) ) ) ).

% finite_induct_select
tff(fact_5268_psubset__insert__iff,axiom,
    ! [A: $tType,A2: set(A),X3: A,B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),aa(set(A),set(A),insert2(A,X3),B3)))
    <=> ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),B3))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3)) )
        & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),B3))
         => ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))))),B3)) )
            & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ) ) ) ) ).

% psubset_insert_iff
tff(fact_5269_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X3: A] : ( aa(list(A),set(A),set2(A),replicate(A,aa(nat,nat,suc,N),X3)) = aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))) ) ).

% set_replicate_Suc
tff(fact_5270_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(list(A),set(A),set2(A),replicate(A,N,X3)) = bot_bot(set(A)) ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(list(A),set(A),set2(A),replicate(A,N,X3)) = aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))) ) ) ) ).

% set_replicate_conv_if
tff(fact_5271_simp__from__to,axiom,
    ! [J3: int,I: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J3),I))
       => ( set_or1337092689740270186AtMost(int,I,J3) = bot_bot(set(int)) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J3),I))
       => ( set_or1337092689740270186AtMost(int,I,J3) = aa(set(int),set(int),insert2(int,I),set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J3)) ) ) ) ).

% simp_from_to
tff(fact_5272_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(A)
     => ! [A2: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3)))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,I3)),aa(B,A,G,I3))) ) )
           => ( ( A2 != bot_bot(set(B)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),groups7121269368397514597t_prod(B,A,F2,A2)),groups7121269368397514597t_prod(B,A,G,A2))) ) ) ) ) ).

% prod_mono_strict
tff(fact_5273_card__2__iff,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),S2) = aa(num,nat,numeral_numeral(nat),bit0(one2)) )
    <=> ? [X4: A,Y: A] :
          ( ( S2 = aa(set(A),set(A),insert2(A,X4),aa(set(A),set(A),insert2(A,Y),bot_bot(set(A)))) )
          & ( X4 != Y ) ) ) ).

% card_2_iff
tff(fact_5274_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),X3: B,G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,G,X3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B)))))) ) ) ) ) ).

% sum.remove
tff(fact_5275_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),G: fun(B,A),X3: B] :
          ( finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),insert2(B,X3),A2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,G,X3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B)))))) ) ) ) ).

% sum.insert_remove
tff(fact_5276_card__3__iff,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),S2) = aa(num,nat,numeral_numeral(nat),bit1(one2)) )
    <=> ? [X4: A,Y: A,Z6: A] :
          ( ( S2 = aa(set(A),set(A),insert2(A,X4),aa(set(A),set(A),insert2(A,Y),aa(set(A),set(A),insert2(A,Z6),bot_bot(set(A))))) )
          & ( X4 != Y )
          & ( Y != Z6 )
          & ( X4 != Z6 ) ) ) ).

% card_3_iff
tff(fact_5277_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A2: set(A)] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(set(A),nat,finite_card(A),A2)))
     => ( A2 != bot_bot(set(A)) ) ) ).

% odd_card_imp_not_empty
tff(fact_5278_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),G: fun(B,A),X3: B] :
          ( finite_finite(B,A2)
         => ( groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),insert2(B,X3),A2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X3)),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B)))))) ) ) ) ).

% prod.insert_remove
tff(fact_5279_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),X3: B,G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
           => ( groups7121269368397514597t_prod(B,A,G,A2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X3)),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B)))))) ) ) ) ) ).

% prod.remove
tff(fact_5280_card__Diff1__less__iff,axiom,
    ! [A: $tType,A2: set(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A2)))
    <=> ( finite_finite(A,A2)
        & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2)) ) ) ).

% card_Diff1_less_iff
tff(fact_5281_card__Diff2__less,axiom,
    ! [A: $tType,A2: set(A),X3: A,Y4: A] :
      ( finite_finite(A,A2)
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
       => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),A2))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))))),aa(set(A),set(A),insert2(A,Y4),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A2))) ) ) ) ).

% card_Diff2_less
tff(fact_5282_card__Diff1__less,axiom,
    ! [A: $tType,A2: set(A),X3: A] :
      ( finite_finite(A,A2)
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A2))) ) ) ).

% card_Diff1_less
tff(fact_5283_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A),C2: fun(B,A)] :
          ( finite_finite(B,S2)
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ms(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2)),S2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,B2,A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ms(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2)),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ) ) ) ) ).

% sum.delta_remove
tff(fact_5284_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A),C2: fun(B,A)] :
          ( finite_finite(B,S2)
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( groups7121269368397514597t_prod(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_mt(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2),S2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,B2,A3)),groups7121269368397514597t_prod(B,A,C2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),S2))
             => ( groups7121269368397514597t_prod(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_mt(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2),S2) = groups7121269368397514597t_prod(B,A,C2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ) ) ) ) ).

% prod.delta_remove
tff(fact_5285_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [I: C,A2: set(C),F2: fun(C,B)] :
          ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),I),A2))
         => ( ! [X2: C] :
                ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A2),aa(set(C),set(C),insert2(C,I),bot_bot(set(C))))))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(C,B,F2,X2))) )
           => ( finite_finite(C,A2)
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(C,B,F2,I)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A2))) ) ) ) ) ).

% member_le_sum
tff(fact_5286_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_field(A)
     => ! [A2: set(B),F2: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),K5),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A2))))) )
         => ( finite_finite(B,A2)
           => ( ( A2 != bot_bot(set(B)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),K5)) ) ) ) ) ).

% sum_bounded_above_divide
tff(fact_5287_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( semidom_divide(A)
     => ! [A2: set(B),F2: fun(B,A),A3: B] :
          ( finite_finite(B,A2)
         => ( ( aa(B,A,F2,A3) != zero_zero(A) )
           => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),A2))
               => ( groups7121269368397514597t_prod(B,A,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),groups7121269368397514597t_prod(B,A,F2,A2)),aa(B,A,F2,A3)) ) )
              & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),A2))
               => ( groups7121269368397514597t_prod(B,A,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = groups7121269368397514597t_prod(B,A,F2,A2) ) ) ) ) ) ) ).

% prod_diff1
tff(fact_5288_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( sinh(A,X3) = zero_zero(A) )
        <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,exp(A),X3)),aa(set(A),set(A),insert2(A,one_one(A)),aa(set(A),set(A),insert2(A,aa(A,A,uminus_uminus(A),one_one(A))),bot_bot(set(A)))))) ) ) ).

% sinh_zero_iff
tff(fact_5289_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,bool))] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,A0),A1)))
     => ( ! [K2: int,L2: int] :
            ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,K2),L2)))
           => ( ( ~ ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),K2),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                    & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),L2),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => pp(aa(int,bool,aa(int,fun(int,bool),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),K2),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L2),aa(num,int,numeral_numeral(int),bit0(one2))))) )
             => pp(aa(int,bool,aa(int,fun(int,bool),P,K2),L2)) ) )
       => pp(aa(int,bool,aa(int,fun(int,bool),P,A0),A1)) ) ) ).

% and_int.pinduct
tff(fact_5290_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,K),L)))
     => ( ( ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),K),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),L),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))))) ) )
        & ( ~ ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),K),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
              & pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),L),aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ) ) ).

% and_int.psimps
tff(fact_5291_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => ( finite_finite(B,A2)
         => ~ ! [L2: list(B)] :
                ( sorted_wrt(A,Less,aa(list(B),list(A),map(B,A,F2),L2))
               => ( ( aa(list(B),set(B),set2(B),L2) = A2 )
                 => ( aa(list(B),nat,size_size(list(B)),L2) != aa(set(B),nat,finite_card(B),A2) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
tff(fact_5292_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [F3: set(A),I5: set(A),F2: fun(A,B),I: A] :
          ( finite_finite(A,F3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),collect(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_mu(set(A),fun(fun(A,B),fun(A,bool)),I5),F2))),F3))
           => ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),I5))
               => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert2(A,I),bot_bot(set(A))))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F2,I5)),aa(A,B,F2,I)) ) )
              & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),I5))
               => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert2(A,I),bot_bot(set(A))))) = groups1027152243600224163dd_sum(A,B,F2,I5) ) ) ) ) ) ) ).

% sum_diff1'_aux
tff(fact_5293_distinct__union,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( distinct(A,union(A,Xs,Ys2))
    <=> distinct(A,Ys2) ) ).

% distinct_union
tff(fact_5294_bit__0__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( bit_se5641148757651400278ts_bit(A,zero_zero(A)) = bot_bot(fun(nat,bool)) ) ) ).

% bit_0_eq
tff(fact_5295_lessThan__0,axiom,
    set_ord_lessThan(nat,zero_zero(nat)) = bot_bot(set(nat)) ).

% lessThan_0
tff(fact_5296_set__decode__zero,axiom,
    nat_set_decode(zero_zero(nat)) = bot_bot(set(nat)) ).

% set_decode_zero
tff(fact_5297_set__encode__empty,axiom,
    aa(set(nat),nat,nat_set_encode,bot_bot(set(nat))) = zero_zero(nat) ).

% set_encode_empty
tff(fact_5298_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P2: fun(B,A)] : ( groups1027152243600224163dd_sum(B,A,P2,bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty'
tff(fact_5299_atMost__0,axiom,
    set_ord_atMost(nat,zero_zero(nat)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))) ).

% atMost_0
tff(fact_5300_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I5: set(B),P2: fun(B,A),I: B] :
          ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),I5),P2)))
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),I5))
             => ( groups1027152243600224163dd_sum(B,A,P2,aa(set(B),set(B),insert2(B,I),I5)) = groups1027152243600224163dd_sum(B,A,P2,I5) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),I5))
             => ( groups1027152243600224163dd_sum(B,A,P2,aa(set(B),set(B),insert2(B,I),I5)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,P2,I)),groups1027152243600224163dd_sum(B,A,P2,I5)) ) ) ) ) ) ).

% sum.insert'
tff(fact_5301_bot__nat__def,axiom,
    bot_bot(nat) = zero_zero(nat) ).

% bot_nat_def
tff(fact_5302_bot__enat__def,axiom,
    bot_bot(extended_enat) = zero_zero(extended_enat) ).

% bot_enat_def
tff(fact_5303_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),I5: set(B)] : ( groups1027152243600224163dd_sum(B,A,G,collect(B,aa(set(B),fun(B,bool),aTP_Lamp_mv(fun(B,A),fun(set(B),fun(B,bool)),G),I5))) = groups1027152243600224163dd_sum(B,A,G,I5) ) ) ).

% sum.non_neutral'
tff(fact_5304_atLeastLessThan0,axiom,
    ! [M: nat] : ( set_or7035219750837199246ssThan(nat,M,zero_zero(nat)) = bot_bot(set(nat)) ) ).

% atLeastLessThan0
tff(fact_5305_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan(nat,N) = bot_bot(set(nat)) )
    <=> ( N = zero_zero(nat) ) ) ).

% lessThan_empty_iff
tff(fact_5306_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I5: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,I5)
         => ( groups1027152243600224163dd_sum(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fm(fun(B,A),fun(fun(B,A),fun(B,A)),G),H),I5) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups1027152243600224163dd_sum(B,A,G,I5)),groups1027152243600224163dd_sum(B,A,H,I5)) ) ) ) ).

% sum.distrib_triv'
tff(fact_5307_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),Xs: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( distinct(A,aa(list(B),list(A),map(B,A,F2),Xs))
       => distinct(B,Xs) ) ) ).

% folding_insort_key.distinct_if_distinct_map
tff(fact_5308_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),T6: set(B),G: fun(B,A),H: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
               => ( aa(B,A,G,X2) = zero_zero(A) ) )
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                 => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
             => ( groups1027152243600224163dd_sum(B,A,G,T6) = groups1027152243600224163dd_sum(B,A,H,S2) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
tff(fact_5309_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),T6: set(B),H: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
               => ( aa(B,A,H,I3) = zero_zero(A) ) )
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                 => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
             => ( groups1027152243600224163dd_sum(B,A,G,S2) = groups1027152243600224163dd_sum(B,A,H,T6) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
tff(fact_5310_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),T6: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
               => ( aa(B,A,G,X2) = zero_zero(A) ) )
           => ( groups1027152243600224163dd_sum(B,A,G,T6) = groups1027152243600224163dd_sum(B,A,G,S2) ) ) ) ) ).

% sum.mono_neutral_right'
tff(fact_5311_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),T6: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
               => ( aa(B,A,G,X2) = zero_zero(A) ) )
           => ( groups1027152243600224163dd_sum(B,A,G,S2) = groups1027152243600224163dd_sum(B,A,G,T6) ) ) ) ) ).

% sum.mono_neutral_left'
tff(fact_5312_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I5: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),I5),G)))
         => ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),I5),H)))
           => ( groups1027152243600224163dd_sum(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fm(fun(B,A),fun(fun(B,A),fun(B,A)),G),H),I5) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups1027152243600224163dd_sum(B,A,G,I5)),groups1027152243600224163dd_sum(B,A,H,I5)) ) ) ) ) ).

% sum.distrib'
tff(fact_5313_sum_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [I5: set(B),P2: fun(B,A)] :
          ( ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),I5),P2)))
           => ( groups1027152243600224163dd_sum(B,A,P2,I5) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),P2),collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),I5),P2))) ) )
          & ( ~ finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),I5),P2)))
           => ( groups1027152243600224163dd_sum(B,A,P2,I5) = zero_zero(A) ) ) ) ) ).

% sum.G_def
tff(fact_5314_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
       => ( set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,N),set_or7035219750837199246ssThan(nat,M,N)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
       => ( set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N)) = bot_bot(set(nat)) ) ) ) ).

% atLeastLessThanSuc
tff(fact_5315_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_lessThan(nat,N)),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_lessThan_eq_remove0
tff(fact_5316_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atMost(nat,N)),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_atMost_eq_remove0
tff(fact_5317_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),pred_numeral(K)))
       => ( set_or7035219750837199246ssThan(nat,M,aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert2(nat,pred_numeral(K)),set_or7035219750837199246ssThan(nat,M,pred_numeral(K))) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),pred_numeral(K)))
       => ( set_or7035219750837199246ssThan(nat,M,aa(num,nat,numeral_numeral(nat),K)) = bot_bot(set(nat)) ) ) ) ).

% atLeastLessThan_nat_numeral
tff(fact_5318_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [I5: set(A),F2: fun(A,B),I: A] :
          ( finite_finite(A,collect(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_mu(set(A),fun(fun(A,B),fun(A,bool)),I5),F2)))
         => ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),I5))
             => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert2(A,I),bot_bot(set(A))))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F2,I5)),aa(A,B,F2,I)) ) )
            & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),I5))
             => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert2(A,I),bot_bot(set(A))))) = groups1027152243600224163dd_sum(A,B,F2,I5) ) ) ) ) ) ).

% sum_diff1'
tff(fact_5319_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B),L: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => ( finite_finite(B,A2)
         => ( ( sorted_wrt(A,Less,aa(list(B),list(A),map(B,A,F2),L))
              & ( aa(list(B),set(B),set2(B),L) = A2 )
              & ( aa(list(B),nat,size_size(list(B)),L) = aa(set(B),nat,finite_card(B),A2) ) )
          <=> ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2) = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
tff(fact_5320_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),Xs: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Xs)),S2))
       => ( sorted_wrt(A,Less_eq,aa(list(B),list(A),map(B,A,F2),Xs))
         => ( distinct(B,Xs)
           => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),aa(list(B),set(B),set2(B),Xs)) = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
tff(fact_5321_set__update__distinct,axiom,
    ! [A: $tType,Xs: list(A),N: nat,X3: A] :
      ( distinct(A,Xs)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( aa(list(A),set(A),set2(A),list_update(A,Xs,N,X3)) = aa(set(A),set(A),insert2(A,X3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,aa(nat,A,nth(A,Xs),N)),bot_bot(set(A))))) ) ) ) ).

% set_update_distinct
tff(fact_5322_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list(A),I: nat,X3: A,Y4: A] : ( list_update(A,list_update(A,Xs,I,X3),I,Y4) = list_update(A,Xs,I,Y4) ) ).

% list_update_overwrite
tff(fact_5323_length__list__update,axiom,
    ! [A: $tType,Xs: list(A),I: nat,X3: A] : ( aa(list(A),nat,size_size(list(A)),list_update(A,Xs,I,X3)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_list_update
tff(fact_5324_nth__list__update__neq,axiom,
    ! [A: $tType,I: nat,J3: nat,Xs: list(A),X3: A] :
      ( ( I != J3 )
     => ( aa(nat,A,nth(A,list_update(A,Xs,I,X3)),J3) = aa(nat,A,nth(A,Xs),J3) ) ) ).

% nth_list_update_neq
tff(fact_5325_list__update__id,axiom,
    ! [A: $tType,Xs: list(A),I: nat] : ( list_update(A,Xs,I,aa(nat,A,nth(A,Xs),I)) = Xs ) ).

% list_update_id
tff(fact_5326_list__update__beyond,axiom,
    ! [A: $tType,Xs: list(A),I: nat,X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),I))
     => ( list_update(A,Xs,I,X3) = Xs ) ) ).

% list_update_beyond
tff(fact_5327_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A),Y4: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
     => ( take(A,N,list_update(A,Xs,M,Y4)) = take(A,N,Xs) ) ) ).

% take_update_cancel
tff(fact_5328_nth__list__update__eq,axiom,
    ! [A: $tType,I: nat,Xs: list(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,A,nth(A,list_update(A,Xs,I,X3)),I) = X3 ) ) ).

% nth_list_update_eq
tff(fact_5329_set__swap,axiom,
    ! [A: $tType,I: nat,Xs: list(A),J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( aa(list(A),set(A),set2(A),list_update(A,list_update(A,Xs,I,aa(nat,A,nth(A,Xs),J3)),J3,aa(nat,A,nth(A,Xs),I))) = aa(list(A),set(A),set2(A),Xs) ) ) ) ).

% set_swap
tff(fact_5330_distinct__swap,axiom,
    ! [A: $tType,I: nat,Xs: list(A),J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( distinct(A,list_update(A,list_update(A,Xs,I,aa(nat,A,nth(A,Xs),J3)),J3,aa(nat,A,nth(A,Xs),I)))
        <=> distinct(A,Xs) ) ) ) ).

% distinct_swap
tff(fact_5331_take__update__swap,axiom,
    ! [A: $tType,M: nat,Xs: list(A),N: nat,X3: A] : ( take(A,M,list_update(A,Xs,N,X3)) = list_update(A,take(A,M,Xs),N,X3) ) ).

% take_update_swap
tff(fact_5332_list__update__swap,axiom,
    ! [A: $tType,I: nat,I7: nat,Xs: list(A),X3: A,X6: A] :
      ( ( I != I7 )
     => ( list_update(A,list_update(A,Xs,I,X3),I7,X6) = list_update(A,list_update(A,Xs,I7,X6),I,X3) ) ) ).

% list_update_swap
tff(fact_5333_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType,Less_eq: fun(A,fun(A,bool))] : ( sorted8670434370408473282of_set(A,B,Less_eq) = sorted8670434370408473282of_set(A,B,Less_eq) ) ).

% linorder.sorted_key_list_of_set.cong
tff(fact_5334_map__update,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B),K: nat,Y4: B] : ( aa(list(B),list(A),map(B,A,F2),list_update(B,Xs,K,Y4)) = list_update(A,aa(list(B),list(A),map(B,A,F2),Xs),K,aa(B,A,F2,Y4)) ) ).

% map_update
tff(fact_5335_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list(A),A2: set(A),X3: A,I: nat] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),A2))
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),list_update(A,Xs,I,X3))),A2)) ) ) ).

% set_update_subsetI
tff(fact_5336_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list(A),I: nat,X3: A] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),list_update(A,Xs,I,X3))),aa(set(A),set(A),insert2(A,X3),aa(list(A),set(A),set2(A),Xs)))) ).

% set_update_subset_insert
tff(fact_5337_set__update__memI,axiom,
    ! [A: $tType,N: nat,Xs: list(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),list_update(A,Xs,N,X3)))) ) ).

% set_update_memI
tff(fact_5338_nth__list__update,axiom,
    ! [A: $tType,I: nat,Xs: list(A),J3: nat,X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( ( ( I = J3 )
         => ( aa(nat,A,nth(A,list_update(A,Xs,I,X3)),J3) = X3 ) )
        & ( ( I != J3 )
         => ( aa(nat,A,nth(A,list_update(A,Xs,I,X3)),J3) = aa(nat,A,nth(A,Xs),J3) ) ) ) ) ).

% nth_list_update
tff(fact_5339_list__update__same__conv,axiom,
    ! [A: $tType,I: nat,Xs: list(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( ( list_update(A,Xs,I,X3) = Xs )
      <=> ( aa(nat,A,nth(A,Xs),I) = X3 ) ) ) ).

% list_update_same_conv
tff(fact_5340_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B),B3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),S2))
         => ( ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2) = aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),B3) )
           => ( finite_finite(B,A2)
             => ( finite_finite(B,B3)
               => ( A2 = B3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
tff(fact_5341_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => ( finite_finite(B,A2)
         => ( aa(list(B),set(B),set2(B),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2)) = A2 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
tff(fact_5342_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => ( aa(list(B),nat,size_size(list(B)),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2)) = aa(set(B),nat,finite_card(B),A2) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
tff(fact_5343_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => distinct(A,aa(list(B),list(A),map(B,A,F2),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2))) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
tff(fact_5344_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => sorted_wrt(A,Less_eq,aa(list(B),list(A),map(B,A,F2),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2))) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
tff(fact_5345_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => sorted_wrt(A,Less,aa(list(B),list(A),map(B,A,F2),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2))) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
tff(fact_5346_sum__list__update,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [K: nat,Xs: list(A),X3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs)))
         => ( groups8242544230860333062m_list(A,list_update(A,Xs,K,X3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),groups8242544230860333062m_list(A,Xs)),X3)),aa(nat,A,nth(A,Xs),K)) ) ) ) ).

% sum_list_update
tff(fact_5347_distinct__list__update,axiom,
    ! [A: $tType,Xs: list(A),A3: A,I: nat] :
      ( distinct(A,Xs)
     => ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,aa(nat,A,nth(A,Xs),I)),bot_bot(set(A))))))
       => distinct(A,list_update(A,Xs,I,A3)) ) ) ).

% distinct_list_update
tff(fact_5348_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),X3: B,A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X3),A2)),S2))
       => ( finite_finite(B,A2)
         => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),aa(set(B),set(B),insert2(B,X3),A2)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F2),X3),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B)))))) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
tff(fact_5349_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),X3: B,A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X3),A2)),S2))
       => ( finite_finite(B,A2)
         => ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),A2))
           => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),aa(set(B),set(B),insert2(B,X3),A2)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F2),X3),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
tff(fact_5350_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),X3: B,A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X3),A2)),S2))
       => ( finite_finite(B,A2)
         => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B))))) = remove1(B,X3,aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2)) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
tff(fact_5351_in__set__remove1,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list(A)] :
      ( ( A3 != B2 )
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),aa(list(A),set(A),set2(A),remove1(A,B2,Xs))))
      <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% in_set_remove1
tff(fact_5352_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( distinct(A,Xs)
     => ( aa(list(A),set(A),set2(A),remove1(A,X3,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))) ) ) ).

% set_remove1_eq
tff(fact_5353_distinct__remove1,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( distinct(A,Xs)
     => distinct(A,remove1(A,X3,Xs)) ) ).

% distinct_remove1
tff(fact_5354_remove1__commute,axiom,
    ! [A: $tType,X3: A,Y4: A,Zs: list(A)] : ( remove1(A,X3,remove1(A,Y4,Zs)) = remove1(A,Y4,remove1(A,X3,Zs)) ) ).

% remove1_commute
tff(fact_5355_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType,Less_eq: fun(A,fun(A,bool))] : ( insort_key(A,B,Less_eq) = insort_key(A,B,Less_eq) ) ).

% linorder.insort_key.cong
tff(fact_5356_notin__set__remove1,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: A] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),remove1(A,Y4,Xs)))) ) ).

% notin_set_remove1
tff(fact_5357_remove1__idem,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( remove1(A,X3,Xs) = Xs ) ) ).

% remove1_idem
tff(fact_5358_set__remove1__subset,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),remove1(A,X3,Xs))),aa(list(A),set(A),set2(A),Xs))) ).

% set_remove1_subset
tff(fact_5359_sorted__remove1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),A3: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),remove1(A,A3,Xs)) ) ) ).

% sorted_remove1
tff(fact_5360_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B),X3: B] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs))
         => sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),remove1(B,X3,Xs))) ) ) ).

% sorted_map_remove1
tff(fact_5361_length__remove1,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( aa(list(A),nat,size_size(list(A)),remove1(A,X3,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)) ) )
      & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( aa(list(A),nat,size_size(list(A)),remove1(A,X3,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ) ) ).

% length_remove1
tff(fact_5362_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [X3: B,Xs: list(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),aa(list(B),set(B),set2(B),Xs)))
         => ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F2),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,F2,X3)),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F2),remove1(B,X3,Xs)))) ) ) ) ).

% sum_list_map_remove1
tff(fact_5363_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A),L: list(A)] :
          ( finite_finite(A,A2)
         => ( ( sorted_wrt(A,ord_less(A),L)
              & ( aa(list(A),set(A),set2(A),L) = A2 )
              & ( aa(list(A),nat,size_size(list(A)),L) = aa(set(A),nat,finite_card(A),A2) ) )
          <=> ( aa(set(A),list(A),linord4507533701916653071of_set(A),A2) = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
tff(fact_5364_card__Pow,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
     => ( aa(set(set(A)),nat,finite_card(set(A)),pow2(A,A2)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(set(A),nat,finite_card(A),A2)) ) ) ).

% card_Pow
tff(fact_5365_Suc__0__div__numeral,axiom,
    ! [K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),K)) = aa(product_prod(nat,nat),nat,product_fst(nat,nat),unique8689654367752047608divmod(nat,one2,K)) ) ).

% Suc_0_div_numeral
tff(fact_5366_Pow__iff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),A2),pow2(A,B3)))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ).

% Pow_iff
tff(fact_5367_PowI,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),A2),pow2(A,B3))) ) ).

% PowI
tff(fact_5368_sorted__list__of__set__range,axiom,
    ! [M: nat,N: nat] : ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or7035219750837199246ssThan(nat,M,N)) = upt(M,N) ) ).

% sorted_list_of_set_range
tff(fact_5369_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] :
          ( finite_finite(A,A2)
         => ( aa(list(A),set(A),set2(A),aa(set(A),list(A),linord4507533701916653071of_set(A),A2)) = A2 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
tff(fact_5370_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] : ( aa(list(A),nat,size_size(list(A)),aa(set(A),list(A),linord4507533701916653071of_set(A),A2)) = aa(set(A),nat,finite_card(A),A2) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
tff(fact_5371_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [K: num,L: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),L)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,K,L)) ) ) ).

% numeral_div_numeral
tff(fact_5372_fst__divmod__nat,axiom,
    ! [M: nat,N: nat] : ( aa(product_prod(nat,nat),nat,product_fst(nat,nat),divmod_nat(M,N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),N) ) ).

% fst_divmod_nat
tff(fact_5373_one__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,one2,N)) ) ) ).

% one_div_numeral
tff(fact_5374_PowD,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),A2),pow2(A,B3)))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ).

% PowD
tff(fact_5375_Pow__mono,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),pow2(A,A2)),pow2(A,B3))) ) ).

% Pow_mono
tff(fact_5376_Pow__def,axiom,
    ! [A: $tType,A2: set(A)] : ( pow2(A,A2) = collect(set(A),aTP_Lamp_ll(set(A),fun(set(A),bool),A2)) ) ).

% Pow_def
tff(fact_5377_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A),B3: set(A)] :
          ( ( aa(set(A),list(A),linord4507533701916653071of_set(A),A2) = aa(set(A),list(A),linord4507533701916653071of_set(A),B3) )
         => ( finite_finite(A,A2)
           => ( finite_finite(A,B3)
             => ( A2 = B3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
tff(fact_5378_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] : distinct(A,aa(set(A),list(A),linord4507533701916653071of_set(A),A2)) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
tff(fact_5379_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] : sorted_wrt(A,ord_less_eq(A),aa(set(A),list(A),linord4507533701916653071of_set(A),A2)) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
tff(fact_5380_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] : sorted_wrt(A,ord_less(A),aa(set(A),list(A),linord4507533701916653071of_set(A),A2)) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
tff(fact_5381_fst__divmod,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] : ( aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,M,N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) ) ) ).

% fst_divmod
tff(fact_5382_binomial__def,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,binomial(N),K) = aa(set(set(nat)),nat,finite_card(set(nat)),collect(set(nat),aa(nat,fun(set(nat),bool),aTP_Lamp_mw(nat,fun(nat,fun(set(nat),bool)),N),K))) ) ).

% binomial_def
tff(fact_5383_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( distinct(A,Xs)
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(list(A),set(A),set2(A),Xs)) = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
tff(fact_5384_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A),X3: A] :
          ( finite_finite(A,A2)
         => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))))) = remove1(A,X3,aa(set(A),list(A),linord4507533701916653071of_set(A),A2)) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
tff(fact_5385_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(product_prod(nat,A)),list(nat),map(product_prod(nat,A),nat,product_fst(nat,A)),enumerate(A,N,Xs)) = upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(list(A),nat,size_size(list(A)),Xs))) ) ).

% map_fst_enumerate
tff(fact_5386_Suc__0__mod__numeral,axiom,
    ! [K: num] : ( modulo_modulo(nat,aa(nat,nat,suc,zero_zero(nat)),aa(num,nat,numeral_numeral(nat),K)) = aa(product_prod(nat,nat),nat,product_snd(nat,nat),unique8689654367752047608divmod(nat,one2,K)) ) ).

% Suc_0_mod_numeral
tff(fact_5387_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K)))) ) ).

% drop_bit_numeral_minus_bit1
tff(fact_5388_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),zero_zero(A)) = zero_zero(A) ) ) ).

% drop_bit_of_0
tff(fact_5389_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)) = aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),A3) ) ) ).

% drop_bit_drop_bit
tff(fact_5390_drop__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)),aa(A,A,bit_se4197421643247451524op_bit(A,N),B2)) ) ) ).

% drop_bit_and
tff(fact_5391_drop__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)),aa(A,A,bit_se4197421643247451524op_bit(A,N),B2)) ) ) ).

% drop_bit_or
tff(fact_5392_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A,B2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)),aa(A,A,bit_se4197421643247451524op_bit(A,N),B2)) ) ) ).

% drop_bit_xor
tff(fact_5393_length__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(product_prod(nat,A)),nat,size_size(list(product_prod(nat,A))),enumerate(A,N,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_enumerate
tff(fact_5394_fst__divmod__integer,axiom,
    ! [K: code_integer,L: code_integer] : ( aa(product_prod(code_integer,code_integer),code_integer,product_fst(code_integer,code_integer),code_divmod_integer(K,L)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),K),L) ) ).

% fst_divmod_integer
tff(fact_5395_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,B2: bool] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(bool,A,zero_neq_one_of_bool(A),B2)) = aa(bool,A,zero_neq_one_of_bool(A),fconj(aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat)),B2)) ) ) ).

% drop_bit_of_bool
tff(fact_5396_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se4197421643247451524op_bit(int,N),K)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),K)) ) ).

% drop_bit_nonnegative_int_iff
tff(fact_5397_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,bit_se4197421643247451524op_bit(int,N),K)),zero_zero(int)))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int))) ) ).

% drop_bit_negative_int_iff
tff(fact_5398_drop__bit__minus__one,axiom,
    ! [N: nat] : ( aa(int,int,bit_se4197421643247451524op_bit(int,N),aa(int,int,uminus_uminus(int),one_one(int))) = aa(int,int,uminus_uminus(int),one_one(int)) ) ).

% drop_bit_minus_one
tff(fact_5399_fst__divmod__abs,axiom,
    ! [K: code_integer,L: code_integer] : ( aa(product_prod(code_integer,code_integer),code_integer,product_fst(code_integer,code_integer),code_divmod_abs(K,L)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),K)),aa(code_integer,code_integer,abs_abs(code_integer),L)) ) ).

% fst_divmod_abs
tff(fact_5400_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),bit0(K))) = aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_Suc_bit0
tff(fact_5401_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),bit1(K))) = aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_Suc_bit1
tff(fact_5402_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),one_one(A)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% drop_bit_of_1
tff(fact_5403_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [K: num,L: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),K),aa(num,A,numeral_numeral(A),L)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,K,L)) ) ) ).

% numeral_mod_numeral
tff(fact_5404_map__snd__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(product_prod(nat,A)),list(A),map(product_prod(nat,A),A,product_snd(nat,A)),enumerate(A,N,Xs)) = Xs ) ).

% map_snd_enumerate
tff(fact_5405_snd__divmod__nat,axiom,
    ! [M: nat,N: nat] : ( aa(product_prod(nat,nat),nat,product_snd(nat,nat),divmod_nat(M,N)) = modulo_modulo(nat,M,N) ) ).

% snd_divmod_nat
tff(fact_5406_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),bit0(K))) = aa(A,A,bit_se4197421643247451524op_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_numeral_bit0
tff(fact_5407_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),bit1(K))) = aa(A,A,bit_se4197421643247451524op_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_numeral_bit1
tff(fact_5408_drop__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) ) ).

% drop_bit_Suc_minus_bit0
tff(fact_5409_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),N)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,one2,N)) ) ) ).

% one_mod_numeral
tff(fact_5410_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) ) ).

% drop_bit_numeral_minus_bit0
tff(fact_5411_drop__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit1(K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K)))) ) ).

% drop_bit_Suc_minus_bit1
tff(fact_5412_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(A,B)),Ys2: list(product_prod(A,B))] :
      ( ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs) = aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Ys2) )
     => ( ( aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),Xs) = aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),Ys2) )
       => ( Xs = Ys2 ) ) ) ).

% pair_list_eqI
tff(fact_5413_distinct__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : distinct(product_prod(nat,A),enumerate(A,N,Xs)) ).

% distinct_enumerate
tff(fact_5414_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4197421643247451524op_bit(nat,M),N)) = aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_drop_bit
tff(fact_5415_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,M: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4197421643247451524op_bit(nat,N),M)) ) ) ).

% drop_bit_of_nat
tff(fact_5416_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3) = A3 )
        <=> ( aa(A,A,bit_se4197421643247451524op_bit(A,N),A3) = zero_zero(A) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
tff(fact_5417_drop__bit__push__bit__int,axiom,
    ! [M: nat,N: nat,K: int] : ( aa(int,int,bit_se4197421643247451524op_bit(int,M),aa(int,int,bit_se4730199178511100633sh_bit(int,N),K)) = aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),aa(int,int,bit_se4730199178511100633sh_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)),K)) ) ).

% drop_bit_push_bit_int
tff(fact_5418_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)) = aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),A3)) ) ) ).

% take_bit_drop_bit
tff(fact_5419_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)),aa(A,A,bit_se4197421643247451524op_bit(A,M),A3)) ) ) ).

% drop_bit_take_bit
tff(fact_5420_divides__aux__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Qr: product_prod(A,A)] :
          ( unique5940410009612947441es_aux(A,Qr)
        <=> ( aa(product_prod(A,A),A,product_snd(A,A),Qr) = zero_zero(A) ) ) ) ).

% divides_aux_def
tff(fact_5421_snd__divmod,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] : ( aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,M,N)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),N)) ) ) ).

% snd_divmod
tff(fact_5422_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A))) = aa(A,A,bit_se4197421643247451524op_bit(A,N),A3) ) ) ).

% div_push_bit_of_1_eq_drop_bit
tff(fact_5423_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)),one_one(A)) = one_one(A) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
tff(fact_5424_bits__ident,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3))),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) = A3 ) ) ).

% bits_ident
tff(fact_5425_in__set__enumerate__eq,axiom,
    ! [A: $tType,P2: product_prod(nat,A),N: nat,Xs: list(A)] :
      ( pp(aa(set(product_prod(nat,A)),bool,aa(product_prod(nat,A),fun(set(product_prod(nat,A)),bool),member2(product_prod(nat,A)),P2),aa(list(product_prod(nat,A)),set(product_prod(nat,A)),set2(product_prod(nat,A)),enumerate(A,N,Xs))))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(product_prod(nat,A),nat,product_fst(nat,A),P2)))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(product_prod(nat,A),nat,product_fst(nat,A),P2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N)))
        & ( aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(product_prod(nat,A),nat,product_fst(nat,A),P2)),N)) = aa(product_prod(nat,A),A,product_snd(nat,A),P2) ) ) ) ).

% in_set_enumerate_eq
tff(fact_5426_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2))) = A3 )
         => ( aa(A,A,bit_se4197421643247451524op_bit(A,N),A3) = A3 ) ) ) ).

% stable_imp_drop_bit_eq
tff(fact_5427_drop__bit__half,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% drop_bit_half
tff(fact_5428_drop__bit__int__def,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_se4197421643247451524op_bit(int,N),K) = aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% drop_bit_int_def
tff(fact_5429_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ).

% drop_bit_eq_div
tff(fact_5430_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,N)),A3) = aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% drop_bit_Suc
tff(fact_5431_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)))
        <=> ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N)) ) ) ).

% even_drop_bit_iff_not_bit
tff(fact_5432_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3))) ) ) ).

% bit_iff_odd_drop_bit
tff(fact_5433_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F2: fun(nat,A),M: nat] : ( enumerate(A,N,aa(list(nat),list(A),map(nat,A,F2),upt(N,M))) = aa(list(nat),list(product_prod(nat,A)),map(nat,product_prod(nat,A),aTP_Lamp_mx(fun(nat,A),fun(nat,product_prod(nat,A)),F2)),upt(N,M)) ) ).

% enumerate_map_upt
tff(fact_5434_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : sorted_wrt(nat,ord_less_eq(nat),aa(list(product_prod(nat,A)),list(nat),map(product_prod(nat,A),nat,product_fst(nat,A)),enumerate(A,N,Xs))) ).

% sorted_enumerate
tff(fact_5435_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M: nat,A3: A] : ( enumerate(A,N,replicate(A,M,A3)) = aa(list(nat),list(product_prod(nat,A)),map(nat,product_prod(nat,A),aTP_Lamp_my(A,fun(nat,product_prod(nat,A)),A3)),upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))) ) ).

% enumerate_replicate_eq
tff(fact_5436_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,M: nat,A3: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,N),A3))) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)))) ) ) ).

% slice_eq_mask
tff(fact_5437_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list(A),N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,product_prod(nat,A),nth(product_prod(nat,A),enumerate(A,N,Xs)),M) = aa(A,product_prod(nat,A),product_Pair(nat,A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)),aa(nat,A,nth(A,Xs),M)) ) ) ).

% nth_enumerate_eq
tff(fact_5438_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(A,A,bit_se4197421643247451524op_bit(A,N),A3) = A3 ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(A,A,bit_se4197421643247451524op_bit(A,N),A3) = aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ) ) ).

% drop_bit_rec
tff(fact_5439_bezw_Oelims,axiom,
    ! [X3: nat,Xa: nat,Y4: product_prod(int,int)] :
      ( ( bezw(X3,Xa) = Y4 )
     => ( ( ( Xa = zero_zero(nat) )
         => ( Y4 = aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)) ) )
        & ( ( Xa != zero_zero(nat) )
         => ( Y4 = aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X3,Xa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,modulo_modulo(nat,X3,Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X3,Xa)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X3),Xa))))) ) ) ) ) ).

% bezw.elims
tff(fact_5440_bezw_Osimps,axiom,
    ! [Y4: nat,X3: nat] :
      ( ( ( Y4 = zero_zero(nat) )
       => ( bezw(X3,Y4) = aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)) ) )
      & ( ( Y4 != zero_zero(nat) )
       => ( bezw(X3,Y4) = aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Y4,modulo_modulo(nat,X3,Y4)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y4,modulo_modulo(nat,X3,Y4)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y4,modulo_modulo(nat,X3,Y4)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X3),Y4))))) ) ) ) ).

% bezw.simps
tff(fact_5441_bezw_Opelims,axiom,
    ! [X3: nat,Xa: nat,Y4: product_prod(int,int)] :
      ( ( bezw(X3,Xa) = Y4 )
     => ( pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),bezw_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),Xa)))
       => ~ ( ( ( ( Xa = zero_zero(nat) )
               => ( Y4 = aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)) ) )
              & ( ( Xa != zero_zero(nat) )
               => ( Y4 = aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X3,Xa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,modulo_modulo(nat,X3,Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X3,Xa)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X3),Xa))))) ) ) )
           => ~ pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),bezw_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),Xa))) ) ) ) ).

% bezw.pelims
tff(fact_5442_drop__bit__of__Suc__0,axiom,
    ! [N: nat] : ( aa(nat,nat,bit_se4197421643247451524op_bit(nat,N),aa(nat,nat,suc,zero_zero(nat))) = aa(bool,nat,zero_neq_one_of_bool(nat),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ).

% drop_bit_of_Suc_0
tff(fact_5443_drop__bit__nat__eq,axiom,
    ! [N: nat,K: int] : ( aa(nat,nat,bit_se4197421643247451524op_bit(nat,N),aa(int,nat,nat2,K)) = aa(int,nat,nat2,aa(int,int,bit_se4197421643247451524op_bit(int,N),K)) ) ).

% drop_bit_nat_eq
tff(fact_5444_quotient__of__denom__pos_H,axiom,
    ! [R2: rat] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),quotient_of(R2)))) ).

% quotient_of_denom_pos'
tff(fact_5445_drop__bit__nat__def,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,bit_se4197421643247451524op_bit(nat,N),M) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% drop_bit_nat_def
tff(fact_5446_bezw__non__0,axiom,
    ! [Y4: nat,X3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),Y4))
     => ( bezw(X3,Y4) = aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Y4,modulo_modulo(nat,X3,Y4)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y4,modulo_modulo(nat,X3,Y4)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y4,modulo_modulo(nat,X3,Y4)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X3),Y4))))) ) ) ).

% bezw_non_0
tff(fact_5447_one__mod__minus__numeral,axiom,
    ! [N: num] : ( modulo_modulo(int,one_one(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,uminus_uminus(int),adjust_mod(aa(num,int,numeral_numeral(int),N),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,one2,N)))) ) ).

% one_mod_minus_numeral
tff(fact_5448_minus__one__mod__numeral,axiom,
    ! [N: num] : ( modulo_modulo(int,aa(int,int,uminus_uminus(int),one_one(int)),aa(num,int,numeral_numeral(int),N)) = adjust_mod(aa(num,int,numeral_numeral(int),N),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,one2,N))) ) ).

% minus_one_mod_numeral
tff(fact_5449_minus__numeral__mod__numeral,axiom,
    ! [M: num,N: num] : ( modulo_modulo(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N)) = adjust_mod(aa(num,int,numeral_numeral(int),N),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,M,N))) ) ).

% minus_numeral_mod_numeral
tff(fact_5450_numeral__mod__minus__numeral,axiom,
    ! [M: num,N: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,uminus_uminus(int),adjust_mod(aa(num,int,numeral_numeral(int),N),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,M,N)))) ) ).

% numeral_mod_minus_numeral
tff(fact_5451_Divides_Oadjust__mod__def,axiom,
    ! [R2: int,L: int] :
      ( ( ( R2 = zero_zero(int) )
       => ( adjust_mod(L,R2) = zero_zero(int) ) )
      & ( ( R2 != zero_zero(int) )
       => ( adjust_mod(L,R2) = aa(int,int,aa(int,fun(int,int),minus_minus(int),L),R2) ) ) ) ).

% Divides.adjust_mod_def
tff(fact_5452_normalize__def,axiom,
    ! [P2: product_prod(int,int)] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P2)))
       => ( normalize(P2) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P2)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2)))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P2)))
       => ( ( ( aa(product_prod(int,int),int,product_snd(int,int),P2) = zero_zero(int) )
           => ( normalize(P2) = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)) ) )
          & ( ( aa(product_prod(int,int),int,product_snd(int,int),P2) != zero_zero(int) )
           => ( normalize(P2) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2))))),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P2)),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2))))) ) ) ) ) ) ).

% normalize_def
tff(fact_5453_size__prod__simp,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,nat),G: fun(B,nat),P2: product_prod(A,B)] : ( basic_BNF_size_prod(A,B,F2,G,P2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F2,aa(product_prod(A,B),A,product_fst(A,B),P2))),aa(B,nat,G,aa(product_prod(A,B),B,product_snd(A,B),P2)))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% size_prod_simp
tff(fact_5454_finite__enumerate,axiom,
    ! [S2: set(nat)] :
      ( finite_finite(nat,S2)
     => ? [R: fun(nat,nat)] :
          ( strict_mono_on(nat,nat,R,set_ord_lessThan(nat,aa(set(nat),nat,finite_card(nat),S2)))
          & ! [N7: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N7),aa(set(nat),nat,finite_card(nat),S2)))
             => pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),aa(nat,nat,R,N7)),S2)) ) ) ) ).

% finite_enumerate
tff(fact_5455_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) = zero_zero(A) )
        <=> ( ( A3 = zero_zero(A) )
            & ( B2 = zero_zero(A) ) ) ) ) ).

% gcd_eq_0_iff
tff(fact_5456_gcd__add1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),M),N)),N) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),N) ) ) ).

% gcd_add1
tff(fact_5457_gcd__add2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),aa(A,A,aa(A,fun(A,A),plus_plus(A),M),N)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),N) ) ) ).

% gcd_add2
tff(fact_5458_gcd__exp,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A3: A,N: nat,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(nat,A,power_power(A,A3),N)),aa(nat,A,power_power(A,B2),N)) = aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)),N) ) ) ).

% gcd_exp
tff(fact_5459_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [N: num,A3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))),A3) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(num,A,numeral_numeral(A),N)),A3) ) ) ).

% gcd_neg_numeral_1
tff(fact_5460_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A3: A,N: num] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),aa(num,A,numeral_numeral(A),N)) ) ) ).

% gcd_neg_numeral_2
tff(fact_5461_gcd__pos__int,axiom,
    ! [M: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),N)))
    <=> ( ( M != zero_zero(int) )
        | ( N != zero_zero(int) ) ) ) ).

% gcd_pos_int
tff(fact_5462_gcd__neg__numeral__1__int,axiom,
    ! [N: num,X3: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))),X3) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(num,int,numeral_numeral(int),N)),X3) ) ).

% gcd_neg_numeral_1_int
tff(fact_5463_gcd__neg__numeral__2__int,axiom,
    ! [X3: int,N: num] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),aa(num,int,numeral_numeral(int),N)) ) ).

% gcd_neg_numeral_2_int
tff(fact_5464_gcd__0__left__int,axiom,
    ! [X3: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),zero_zero(int)),X3) = aa(int,int,abs_abs(int),X3) ) ).

% gcd_0_left_int
tff(fact_5465_gcd__0__int,axiom,
    ! [X3: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),zero_zero(int)) = aa(int,int,abs_abs(int),X3) ) ).

% gcd_0_int
tff(fact_5466_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,K: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),M)),N)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),N) ) ) ).

% gcd_add_mult
tff(fact_5467_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,K: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B2))) ) ).

% gcd_dvd_prod
tff(fact_5468_gcd__ge__0__int,axiom,
    ! [X3: int,Y4: int] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),Y4))) ).

% gcd_ge_0_int
tff(fact_5469_bezout__int,axiom,
    ! [X3: int,Y4: int] :
    ? [U2: int,V3: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),U2),X3)),aa(int,int,aa(int,fun(int,int),times_times(int),V3),Y4)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),Y4) ) ).

% bezout_int
tff(fact_5470_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),K)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),N)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),N)) ) ).

% gcd_mult_distrib_int
tff(fact_5471_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit2
tff(fact_5472_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit1
tff(fact_5473_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A3)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit1
tff(fact_5474_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A3),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit2
tff(fact_5475_gcd__le1__int,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),A3))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A3),B2)),A3)) ) ).

% gcd_le1_int
tff(fact_5476_gcd__le2__int,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A3),B2)),B2)) ) ).

% gcd_le2_int
tff(fact_5477_gcd__cases__int,axiom,
    ! [X3: int,Y4: int,P: fun(int,bool)] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
       => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
         => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),Y4))) ) )
     => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),X3))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Y4),zero_zero(int)))
           => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),aa(int,int,uminus_uminus(int),Y4)))) ) )
       => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),zero_zero(int)))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),Y4))
             => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),X3)),Y4))) ) )
         => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),zero_zero(int)))
             => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Y4),zero_zero(int)))
               => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),X3)),aa(int,int,uminus_uminus(int),Y4)))) ) )
           => pp(aa(int,bool,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),Y4))) ) ) ) ) ).

% gcd_cases_int
tff(fact_5478_gcd__unique__int,axiom,
    ! [D2: int,A3: int,B2: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),D2))
        & pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),D2),A3))
        & pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),D2),B2))
        & ! [E3: int] :
            ( ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),E3),A3))
              & pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),E3),B2)) )
           => pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),E3),D2)) ) )
    <=> ( D2 = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A3),B2) ) ) ).

% gcd_unique_int
tff(fact_5479_gcd__non__0__int,axiom,
    ! [Y4: int,X3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Y4))
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X3),Y4) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Y4),modulo_modulo(int,X3,Y4)) ) ) ).

% gcd_non_0_int
tff(fact_5480_gcd__code__int,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),K),L) = aa(int,int,abs_abs(int),if(int,aa(int,bool,aa(int,fun(int,bool),fequal(int),L),zero_zero(int)),K,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),L),modulo_modulo(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L))))) ) ).

% gcd_code_int
tff(fact_5481_less__by__empty,axiom,
    ! [A: $tType,A2: set(product_prod(A,A)),B3: set(product_prod(A,A))] :
      ( ( A2 = bot_bot(set(product_prod(A,A))) )
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),A2),B3)) ) ).

% less_by_empty
tff(fact_5482_nat__descend__induct,axiom,
    ! [N: nat,P: fun(nat,bool),M: nat] :
      ( ! [K2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),K2))
         => pp(aa(nat,bool,P,K2)) )
     => ( ! [K2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K2),N))
           => ( ! [I4: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K2),I4))
                 => pp(aa(nat,bool,P,I4)) )
             => pp(aa(nat,bool,P,K2)) ) )
       => pp(aa(nat,bool,P,M)) ) ) ).

% nat_descend_induct
tff(fact_5483_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [F2: fun(A,B),A2: set(A)] :
          ( strict_mono_on(A,B,F2,A2)
        <=> ! [R5: A,S6: A] :
              ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),R5),A2))
                & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),S6),A2))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),R5),S6)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,R5)),aa(A,B,F2,S6))) ) ) ) ).

% strict_mono_on_def
tff(fact_5484_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [A2: set(A),F2: fun(A,B)] :
          ( ! [R: A,S3: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),R),A2))
             => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),S3),A2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),R),S3))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,R)),aa(A,B,F2,S3))) ) ) )
         => strict_mono_on(A,B,F2,A2) ) ) ).

% strict_mono_onI
tff(fact_5485_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [F2: fun(A,B),A2: set(A),R2: A,S: A] :
          ( strict_mono_on(A,B,F2,A2)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),R2),A2))
           => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),S),A2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),R2),S))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,R2)),aa(A,B,F2,S))) ) ) ) ) ) ).

% strict_mono_onD
tff(fact_5486_gcd__0__left__nat,axiom,
    ! [X3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),zero_zero(nat)),X3) = X3 ) ).

% gcd_0_left_nat
tff(fact_5487_gcd__0__nat,axiom,
    ! [X3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X3),zero_zero(nat)) = X3 ) ).

% gcd_0_nat
tff(fact_5488_gcd__nat_Oright__neutral,axiom,
    ! [A3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A3),zero_zero(nat)) = A3 ) ).

% gcd_nat.right_neutral
tff(fact_5489_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( zero_zero(nat) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A3),B2) )
    <=> ( ( A3 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% gcd_nat.neutr_eq_iff
tff(fact_5490_gcd__nat_Oleft__neutral,axiom,
    ! [A3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),zero_zero(nat)),A3) = A3 ) ).

% gcd_nat.left_neutral
tff(fact_5491_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A3),B2) = zero_zero(nat) )
    <=> ( ( A3 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% gcd_nat.eq_neutr_iff
tff(fact_5492_gcd__Suc__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% gcd_Suc_0
tff(fact_5493_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N)))
    <=> ( ( M != zero_zero(nat) )
        | ( N != zero_zero(nat) ) ) ) ).

% gcd_pos_nat
tff(fact_5494_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) ) ).

% gcd_mult_distrib_nat
tff(fact_5495_gcd__le2__nat,axiom,
    ! [B2: nat,A3: nat] :
      ( ( B2 != zero_zero(nat) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A3),B2)),B2)) ) ).

% gcd_le2_nat
tff(fact_5496_gcd__le1__nat,axiom,
    ! [A3: nat,B2: nat] :
      ( ( A3 != zero_zero(nat) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A3),B2)),A3)) ) ).

% gcd_le1_nat
tff(fact_5497_gcd__diff2__nat,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)),N) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N) ) ) ).

% gcd_diff2_nat
tff(fact_5498_gcd__diff1__nat,axiom,
    ! [N: nat,M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),N) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N) ) ) ).

% gcd_diff1_nat
tff(fact_5499_gcd__nat_Oelims,axiom,
    ! [X3: nat,Xa: nat,Y4: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X3),Xa) = Y4 )
     => ( ( ( Xa = zero_zero(nat) )
         => ( Y4 = X3 ) )
        & ( ( Xa != zero_zero(nat) )
         => ( Y4 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),modulo_modulo(nat,X3,Xa)) ) ) ) ) ).

% gcd_nat.elims
tff(fact_5500_gcd__nat_Osimps,axiom,
    ! [Y4: nat,X3: nat] :
      ( ( ( Y4 = zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X3),Y4) = X3 ) )
      & ( ( Y4 != zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X3),Y4) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y4),modulo_modulo(nat,X3,Y4)) ) ) ) ).

% gcd_nat.simps
tff(fact_5501_gcd__non__0__nat,axiom,
    ! [Y4: nat,X3: nat] :
      ( ( Y4 != zero_zero(nat) )
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X3),Y4) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y4),modulo_modulo(nat,X3,Y4)) ) ) ).

% gcd_non_0_nat
tff(fact_5502_bezout__nat,axiom,
    ! [A3: nat,B2: nat] :
      ( ( A3 != zero_zero(nat) )
     => ? [X2: nat,Y2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),X2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y2)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A3),B2)) ) ) ).

% bezout_nat
tff(fact_5503_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A3: nat] :
    ? [X2: nat,Y2: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),X2)))
        & ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),X2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y2)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A3),B2) ) )
      | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),Y2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X2)))
        & ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A3),Y2)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A3),B2) ) ) ) ).

% bezout_gcd_nat'
tff(fact_5504_gcd__code__integer,axiom,
    ! [K: code_integer,L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),K),L) = aa(code_integer,code_integer,abs_abs(code_integer),if(code_integer,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),L),zero_zero(code_integer)),K,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),L),modulo_modulo(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))))) ) ).

% gcd_code_integer
tff(fact_5505_bezw__aux,axiom,
    ! [X3: nat,Y4: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X3),Y4)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(X3,Y4))),aa(nat,int,semiring_1_of_nat(int),X3))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(X3,Y4))),aa(nat,int,semiring_1_of_nat(int),Y4))) ) ).

% bezw_aux
tff(fact_5506_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & preorder(B) )
     => ! [F2: fun(A,B),A2: set(A),X3: A,Y4: A] :
          ( strict_mono_on(A,B,F2,A2)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
           => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),A2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4))) ) ) ) ) ) ).

% strict_mono_on_leD
tff(fact_5507_gcd__nat_Opelims,axiom,
    ! [X3: nat,Xa: nat,Y4: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X3),Xa) = Y4 )
     => ( pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),gcd_nat_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),Xa)))
       => ~ ( ( ( ( Xa = zero_zero(nat) )
               => ( Y4 = X3 ) )
              & ( ( Xa != zero_zero(nat) )
               => ( Y4 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),modulo_modulo(nat,X3,Xa)) ) ) )
           => ~ pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),gcd_nat_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),Xa))) ) ) ) ).

% gcd_nat.pelims
tff(fact_5508_divmod__integer__eq__cases,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( ( ( L = zero_zero(code_integer) )
           => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),K) ) )
          & ( ( L != zero_zero(code_integer) )
           => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),aa(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,aa(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,product_apsnd(code_integer,code_integer,code_integer)),times_times(code_integer))),sgn_sgn(code_integer)),L),if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),aa(code_integer,code_integer,sgn_sgn(code_integer),K)),aa(code_integer,code_integer,sgn_sgn(code_integer),L)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_mz(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ) ).

% divmod_integer_eq_cases
tff(fact_5509_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),rotate1(A),Xs)),N) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,aa(nat,nat,suc,N),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% nth_rotate1
tff(fact_5510_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: fun(C,B),G: fun(A,C)] : ( aa(fun(list(A),list(C)),fun(list(A),list(B)),comp(list(C),list(B),list(A),map(C,B,F2)),map(A,C,G)) = map(A,B,aa(fun(A,C),fun(A,B),comp(C,B,A,F2),G)) ) ).

% map_comp_map
tff(fact_5511_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(B,A),G: fun(C,B),Xs: list(C)] : ( aa(list(B),list(A),map(B,A,F2),aa(list(C),list(B),map(C,B,G),Xs)) = aa(list(C),list(A),map(C,A,aa(fun(C,B),fun(C,A),comp(B,A,C,F2),G)),Xs) ) ).

% map_map
tff(fact_5512_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: fun(B,C),G: fun(A,B),List: list(A)] : ( aa(list(B),list(C),map(B,C,F2),aa(list(A),list(B),map(A,B,G),List)) = aa(list(A),list(C),map(A,C,aa(fun(A,B),fun(A,C),comp(B,C,A,F2),G)),List) ) ).

% List.map.compositionality
tff(fact_5513_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(B,C),F2: fun(A,B),V: list(A)] : ( aa(list(B),list(C),map(B,C,G),aa(list(A),list(B),map(A,B,F2),V)) = aa(list(A),list(C),map(A,C,aa(fun(A,B),fun(A,C),comp(B,C,A,G),F2)),V) ) ).

% list.map_comp
tff(fact_5514_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(B,C),G: fun(A,B)] : ( aa(fun(list(A),list(B)),fun(list(A),list(C)),comp(list(B),list(C),list(A),map(B,C,F2)),map(A,B,G)) = map(A,C,aa(fun(A,B),fun(A,C),comp(B,C,A,F2),G)) ) ).

% List.map.comp
tff(fact_5515_set__rotate1,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),rotate1(A),Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% set_rotate1
tff(fact_5516_length__rotate1,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),rotate1(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_rotate1
tff(fact_5517_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,aa(list(A),list(A),rotate1(A),Xs))
    <=> distinct(A,Xs) ) ).

% distinct1_rotate
tff(fact_5518_rotate1__length01,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)))
     => ( aa(list(A),list(A),rotate1(A),Xs) = Xs ) ) ).

% rotate1_length01
tff(fact_5519_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( aa(list(A),list(A),rotate1(A),aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),rotate1(B),Xs)) ) ).

% rotate1_map
tff(fact_5520_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add(B)
        & comm_monoid_add(A) )
     => ! [H: fun(B,A),G: fun(C,B),A2: set(C)] :
          ( ( aa(B,A,H,zero_zero(B)) = zero_zero(A) )
         => ( ! [X2: B,Y2: B] : ( aa(B,A,H,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,H,X2)),aa(B,A,H,Y2)) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(C,B),fun(C,A),comp(B,A,C,H),G)),A2) = aa(B,A,H,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),A2)) ) ) ) ) ).

% sum_comp_morphism
tff(fact_5521_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),aa(nat,nat,suc,I))))
     => ( aa(nat,nat,nth(nat,aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or5935395276787703475ssThan(nat,I,J3))),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),N)) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
tff(fact_5522_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),neg_numeral_sub(int,N,one2))) ) ).

% xor_minus_numerals(2)
tff(fact_5523_xor__minus__numerals_I1_J,axiom,
    ! [N: num,K: int] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))),K) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),neg_numeral_sub(int,N,one2)),K)) ) ).

% xor_minus_numerals(1)
tff(fact_5524_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,L: A,U: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),set_or5935395276787703475ssThan(A,L,U)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),I))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),U)) ) ) ) ).

% greaterThanLessThan_iff
tff(fact_5525_size__list__map,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,nat),G: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_list(A,F2),aa(list(B),list(A),map(B,A,G),Xs)) = aa(list(B),nat,size_list(B,aa(fun(B,A),fun(B,nat),comp(A,nat,B,F2),G)),Xs) ) ).

% size_list_map
tff(fact_5526_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),K))
         => ( set_or5935395276787703475ssThan(A,K,L) = bot_bot(set(A)) ) ) ) ).

% greaterThanLessThan_empty
tff(fact_5527_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( ( set_or5935395276787703475ssThan(A,A3,B2) = bot_bot(set(A)) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% greaterThanLessThan_empty_iff
tff(fact_5528_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or5935395276787703475ssThan(A,A3,B2) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% greaterThanLessThan_empty_iff2
tff(fact_5529_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( ~ finite_finite(A,set_or5935395276787703475ssThan(A,A3,B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% infinite_Ioo_iff
tff(fact_5530_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_sub(A,one2,one2) = zero_zero(A) ) ) ).

% sub_num_simps(1)
tff(fact_5531_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,M,N) ) ) ).

% diff_numeral_simps(1)
tff(fact_5532_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,bit0(K),bit0(L)) = neg_numeral_dbl(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(6)
tff(fact_5533_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,bit1(K),bit1(L)) = neg_numeral_dbl(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(9)
tff(fact_5534_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),W)),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),neg_numeral_sub(A,W,V)),Y4) ) ) ).

% semiring_norm(167)
tff(fact_5535_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),neg_numeral_sub(A,V,W)),Y4) ) ) ).

% semiring_norm(166)
tff(fact_5536_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,N,M) ) ) ).

% add_neg_numeral_simps(2)
tff(fact_5537_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,M,N) ) ) ).

% add_neg_numeral_simps(1)
tff(fact_5538_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,N,M) ) ) ).

% diff_numeral_simps(4)
tff(fact_5539_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,bit0(K),bit1(L)) = neg_numeral_dbl_dec(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(7)
tff(fact_5540_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,bit1(K),bit0(L)) = neg_numeral_dbl_inc(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(8)
tff(fact_5541_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,one2,N) ) ) ).

% diff_numeral_special(1)
tff(fact_5542_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),one_one(A)) = neg_numeral_sub(A,M,one2) ) ) ).

% diff_numeral_special(2)
tff(fact_5543_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_sub(A,bit1(K),one2) = aa(num,A,numeral_numeral(A),bit0(K)) ) ) ).

% sub_num_simps(5)
tff(fact_5544_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,N,one2) ) ) ).

% not_minus_numeral_eq
tff(fact_5545_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_sub(A,bit0(K),one2) = aa(num,A,numeral_numeral(A),bitM(K)) ) ) ).

% sub_num_simps(4)
tff(fact_5546_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,N,one2) ) ) ).

% add_neg_numeral_special(4)
tff(fact_5547_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,M,one2) ) ) ).

% add_neg_numeral_special(3)
tff(fact_5548_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) = neg_numeral_sub(A,one2,M) ) ) ).

% add_neg_numeral_special(2)
tff(fact_5549_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) = neg_numeral_sub(A,one2,M) ) ) ).

% add_neg_numeral_special(1)
tff(fact_5550_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),neg_numeral_sub(A,M,one2))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) ) ) ).

% minus_sub_one_diff_one
tff(fact_5551_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,N,one2) ) ) ).

% diff_numeral_special(7)
tff(fact_5552_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,one2,M) ) ) ).

% diff_numeral_special(8)
tff(fact_5553_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [L: num] : ( neg_numeral_sub(A,one2,bit1(L)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(L))) ) ) ).

% sub_num_simps(3)
tff(fact_5554_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [L: num] : ( neg_numeral_sub(A,one2,bit0(L)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bitM(L))) ) ) ).

% sub_num_simps(2)
tff(fact_5555_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,nat),G: fun(A,B)] : ( aa(fun(list(A),list(B)),fun(list(A),nat),comp(list(B),nat,list(A),size_list(B,F2)),map(A,B,G)) = size_list(A,aa(fun(A,B),fun(A,nat),comp(B,nat,A,F2),G)) ) ).

% list.size_gen_o_map
tff(fact_5556_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ finite_finite(A,set_or5935395276787703475ssThan(A,A3,B2)) ) ) ).

% infinite_Ioo
tff(fact_5557_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,K,L) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),L)) ) ) ).

% neg_numeral_class.sub_def
tff(fact_5558_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),X3: B,Y4: B] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),S2))
       => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Y4),S2))
         => ( aa(fun(list(B),list(B)),fun(list(B),list(B)),comp(list(B),list(B),list(B),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F2),Y4)),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F2),X3)) = aa(fun(list(B),list(B)),fun(list(B),list(B)),comp(list(B),list(B),list(B),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F2),X3)),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F2),Y4)) ) ) ) ) ).

% folding_insort_key.insort_key_commute
tff(fact_5559_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.atLeastAtMost_shift_bounds
tff(fact_5560_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.atLeastLessThan_shift_bounds
tff(fact_5561_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.atLeastAtMost_shift_bounds
tff(fact_5562_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.atLeastLessThan_shift_bounds
tff(fact_5563_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se4197421643247451524op_bit(A,N),A3)) = aa(fun(nat,nat),fun(nat,bool),comp(nat,bool,nat,bit_se5641148757651400278ts_bit(A,A3)),aa(nat,fun(nat,nat),plus_plus(nat),N)) ) ) ).

% bit_drop_bit_eq
tff(fact_5564_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A3,B2)),set_or5935395276787703475ssThan(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
tff(fact_5565_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),comp(A,A,nat,inverse_inverse(A)),F2))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_na(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) ) ) ).

% summable_inverse_divide
tff(fact_5566_sub__non__negative,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,M: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),neg_numeral_sub(A,N,M)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M),N)) ) ) ).

% sub_non_negative
tff(fact_5567_sub__non__positive,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,M: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),neg_numeral_sub(A,N,M)),zero_zero(A)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),N),M)) ) ) ).

% sub_non_positive
tff(fact_5568_sub__negative,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,M: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),neg_numeral_sub(A,N,M)),zero_zero(A)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),N),M)) ) ) ).

% sub_negative
tff(fact_5569_sub__positive,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,M: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),neg_numeral_sub(A,N,M)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M),N)) ) ) ).

% sub_positive
tff(fact_5570_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( neg_numeral_sub(A,inc(N),one2) = aa(num,A,numeral_numeral(A),N) ) ) ).

% sub_inc_One_eq
tff(fact_5571_greaterThanLessThan__upt,axiom,
    ! [N: nat,M: nat] : ( set_or5935395276787703475ssThan(nat,N,M) = aa(list(nat),set(nat),set2(nat),upt(aa(nat,nat,suc,N),M)) ) ).

% greaterThanLessThan_upt
tff(fact_5572_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A3,B2)),set_or1337092689740270186AtMost(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
tff(fact_5573_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A3,B2)),set_or7035219750837199246ssThan(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
tff(fact_5574_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) = aa(A,A,bit_ri4277139882892585799ns_not(A),neg_numeral_sub(A,N,one2)) ) ) ).

% minus_numeral_eq_not_sub_one
tff(fact_5575_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% sum.atLeast0_atMost_Suc_shift
tff(fact_5576_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
tff(fact_5577_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_atMost_Suc_shift
tff(fact_5578_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
tff(fact_5579_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ).

% sum.atLeastLessThan_shift_0
tff(fact_5580_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,N)) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ).

% prod.atLeastLessThan_shift_0
tff(fact_5581_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_iu(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.atLeast_atMost_pred_shift
tff(fact_5582_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_iu(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.atLeast_lessThan_pred_shift
tff(fact_5583_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_iu(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.atLeast_atMost_pred_shift
tff(fact_5584_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_iu(nat,nat)),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.atLeast_lessThan_pred_shift
tff(fact_5585_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ) ).

% sum.atLeastAtMost_shift_0
tff(fact_5586_sub__BitM__One__eq,axiom,
    ! [N: num] : ( neg_numeral_sub(int,bitM(N),one2) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),neg_numeral_sub(int,N,one2)) ) ).

% sub_BitM_One_eq
tff(fact_5587_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N)) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M)),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ) ).

% prod.atLeastAtMost_shift_0
tff(fact_5588_Code__Numeral_Onegative__def,axiom,
    code_negative = aa(fun(num,code_integer),fun(num,code_integer),comp(code_integer,code_integer,num,uminus_uminus(code_integer)),numeral_numeral(code_integer)) ).

% Code_Numeral.negative_def
tff(fact_5589_Code__Target__Int_Onegative__def,axiom,
    code_Target_negative = aa(fun(num,int),fun(num,int),comp(int,int,num,uminus_uminus(int)),numeral_numeral(int)) ).

% Code_Target_Int.negative_def
tff(fact_5590_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel(A)
        & field(B) )
     => ! [X3: B,B2: A,A3: A] :
          ( nO_MATCH(B,A,X3,B2)
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),one_one(A)) ) ) ) ) ).

% div_add_self1_no_field
tff(fact_5591_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel(A)
        & field(B) )
     => ! [X3: B,B2: A,A3: A] :
          ( nO_MATCH(B,A,X3,B2)
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),one_one(A)) ) ) ) ) ).

% div_add_self2_no_field
tff(fact_5592_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: A,Y4: A,A3: real] :
          ( nO_MATCH(A,real,aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4),A3)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,A3),Y4)) ) ) ) ).

% scale_right_distrib_NO_MATCH
tff(fact_5593_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: A,Y4: A,A3: real] :
          ( nO_MATCH(A,real,aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4),A3)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,A3),Y4)) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
tff(fact_5594_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring(A)
     => ! [X3: B,Y4: B,C2: A,A3: A,B2: A] :
          ( nO_MATCH(B,A,aa(B,B,aa(B,fun(B,B),divide_divide(B),X3),Y4),C2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% distrib_right_NO_MATCH
tff(fact_5595_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring(A)
     => ! [X3: B,Y4: B,A3: A,B2: A,C2: A] :
          ( nO_MATCH(B,A,aa(B,B,aa(B,fun(B,B),divide_divide(B),X3),Y4),A3)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ) ).

% distrib_left_NO_MATCH
tff(fact_5596_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ring(A)
     => ! [X3: B,Y4: B,A3: A,B2: A,C2: A] :
          ( nO_MATCH(B,A,aa(B,B,aa(B,fun(B,B),divide_divide(B),X3),Y4),A3)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ) ).

% right_diff_distrib_NO_MATCH
tff(fact_5597_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ring(A)
     => ! [X3: B,Y4: B,C2: A,A3: A,B2: A] :
          ( nO_MATCH(B,A,aa(B,B,aa(B,fun(B,B),divide_divide(B),X3),Y4),C2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% left_diff_distrib_NO_MATCH
tff(fact_5598_power__minus_H,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: A,N: nat] :
          ( nO_MATCH(A,A,one_one(A),X3)
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),X3)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,power_power(A,X3),N)) ) ) ) ).

% power_minus'
tff(fact_5599_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: A,Y4: A,C2: C,A3: real,B2: real] :
          ( nO_MATCH(A,C,aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4),C2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),A3),B2)),X3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X3)) ) ) ) ).

% scale_left_distrib_NO_MATCH
tff(fact_5600_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X3: A,Y4: A,C2: C,A3: real,B2: real] :
          ( nO_MATCH(A,C,aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4),C2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A3),B2)),X3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A3),X3)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X3)) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
tff(fact_5601_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B)] :
          ( ? [K8: real] :
            ! [X2: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X2))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X2)),K8)))
         => real_V4916620083959148203axioms(A,B,F2) ) ) ).

% bounded_linear_axioms.intro
tff(fact_5602_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B)] :
          ( real_V4916620083959148203axioms(A,B,F2)
        <=> ? [K6: real] :
            ! [X4: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X4))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X4)),K6))) ) ) ).

% bounded_linear_axioms_def
tff(fact_5603_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A3: A,Xs: list(B)] : ( groups4207007520872428315er_sum(B,A,F2,A3,Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_nb(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F2),A3),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum_funpow
tff(fact_5604_Suc__funpow,axiom,
    ! [N: nat] : ( aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),compow(fun(nat,nat)),N),suc) = aa(nat,fun(nat,nat),plus_plus(nat),N) ) ).

% Suc_funpow
tff(fact_5605_funpow__0,axiom,
    ! [A: $tType,F2: fun(A,A),X3: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),zero_zero(nat)),F2),X3) = X3 ) ).

% funpow_0
tff(fact_5606_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),F2) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2)),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2)) ) ).

% funpow_add
tff(fact_5607_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,N)),F2) = aa(fun(A,A),fun(A,A),comp(A,A,A,F2),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2)) ) ).

% funpow.simps(2)
tff(fact_5608_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,N)),F2) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2)),F2) ) ).

% funpow_Suc_right
tff(fact_5609_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F2: fun(A,A)] : ( aa(fun(fun(B,A),fun(B,A)),fun(fun(B,A),fun(B,A)),aa(nat,fun(fun(fun(B,A),fun(B,A)),fun(fun(B,A),fun(B,A))),compow(fun(fun(B,A),fun(B,A))),N),comp(A,A,B,F2)) = comp(A,A,B,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2)) ) ).

% comp_funpow
tff(fact_5610_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2)) = aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),F2) ) ).

% funpow_mult
tff(fact_5611_funpow__swap1,axiom,
    ! [A: $tType,F2: fun(A,A),N: nat,X3: A] : ( aa(A,A,F2,aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),X3)) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),aa(A,A,F2,X3)) ) ).

% funpow_swap1
tff(fact_5612_funpow__mod__eq,axiom,
    ! [A: $tType,N: nat,F2: fun(A,A),X3: A,M: nat] :
      ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),X3) = X3 )
     => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),modulo_modulo(nat,M,N)),F2),X3) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2),X3) ) ) ).

% funpow_mod_eq
tff(fact_5613_bij__betw__funpow,axiom,
    ! [A: $tType,F2: fun(A,A),S2: set(A),N: nat] :
      ( bij_betw(A,A,F2,S2,S2)
     => bij_betw(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),S2,S2) ) ).

% bij_betw_funpow
tff(fact_5614_funpow__times__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [F2: fun(A,nat),X3: A] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(A,nat,F2,X3)),aa(A,fun(A,A),times_times(A),X3)) = aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X3),aa(A,nat,F2,X3))) ) ) ).

% funpow_times_power
tff(fact_5615_of__nat__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),N) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% of_nat_def
tff(fact_5616_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),K)),A3) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(num,nat,numeral_numeral(nat),K)),aa(A,fun(A,A),plus_plus(A),one_one(A))),A3) ) ) ).

% numeral_add_unfold_funpow
tff(fact_5617_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),K) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(num,nat,numeral_numeral(nat),K)),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% numeral_unfold_funpow
tff(fact_5618_relpowp__fun__conv,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,bool)),X3: A,Y4: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),N),P),X3),Y4))
    <=> ? [F6: fun(nat,A)] :
          ( ( aa(nat,A,F6,zero_zero(nat)) = X3 )
          & ( aa(nat,A,F6,N) = Y4 )
          & ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),N))
             => pp(aa(A,bool,aa(A,fun(A,bool),P,aa(nat,A,F6,I2)),aa(nat,A,F6,aa(nat,nat,suc,I2)))) ) ) ) ).

% relpowp_fun_conv
tff(fact_5619_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] : ( funpow(A) = compow(fun(A,A)) ) ).

% Nat.funpow_code_def
tff(fact_5620_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),zero_zero(code_integer)))
     => ( code_nat_of_integer(K) = zero_zero(nat) ) ) ).

% nat_of_integer_non_positive
tff(fact_5621_of__nat__of__integer,axiom,
    ! [K: code_integer] : ( aa(nat,code_integer,semiring_1_of_nat(code_integer),code_nat_of_integer(K)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),ord_max(code_integer),zero_zero(code_integer)),K) ) ).

% of_nat_of_integer
tff(fact_5622_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R4: fun(A,fun(A,bool))] : ( aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),zero_zero(nat)),R4) = fequal(A) ) ).

% relpowp.simps(1)
tff(fact_5623_relpowp__0__E,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),X3: A,Y4: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),zero_zero(nat)),P),X3),Y4))
     => ( X3 = Y4 ) ) ).

% relpowp_0_E
tff(fact_5624_relpowp__0__I,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),zero_zero(nat)),P),X3),X3)) ).

% relpowp_0_I
tff(fact_5625_nat__of__integer__code__post_I1_J,axiom,
    code_nat_of_integer(zero_zero(code_integer)) = zero_zero(nat) ).

% nat_of_integer_code_post(1)
tff(fact_5626_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] : ( code_nat_of_integer(aa(num,code_integer,numeral_numeral(code_integer),K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% nat_of_integer_code_post(3)
tff(fact_5627_relpowp__E,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,bool)),X3: A,Z: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),N),P),X3),Z))
     => ( ( ( N = zero_zero(nat) )
         => ( X3 != Z ) )
       => ~ ! [Y2: A,M3: nat] :
              ( ( N = aa(nat,nat,suc,M3) )
             => ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),M3),P),X3),Y2))
               => ~ pp(aa(A,bool,aa(A,fun(A,bool),P,Y2),Z)) ) ) ) ) ).

% relpowp_E
tff(fact_5628_relpowp__E2,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,bool)),X3: A,Z: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),N),P),X3),Z))
     => ( ( ( N = zero_zero(nat) )
         => ( X3 != Z ) )
       => ~ ! [Y2: A,M3: nat] :
              ( ( N = aa(nat,nat,suc,M3) )
             => ( pp(aa(A,bool,aa(A,fun(A,bool),P,X3),Y2))
               => ~ pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),M3),P),Y2),Z)) ) ) ) ) ).

% relpowp_E2
tff(fact_5629_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(nat,fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),compow(fun(A,fun(A,bool))),N),bot_bot(fun(A,fun(A,bool)))) = bot_bot(fun(A,fun(A,bool))) ) ) ).

% relpowp_bot
tff(fact_5630_nat__of__integer__code,axiom,
    ! [K: code_integer] :
      ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),zero_zero(code_integer)))
       => ( code_nat_of_integer(K) = zero_zero(nat) ) )
      & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),zero_zero(code_integer)))
       => ( code_nat_of_integer(K) = aa(product_prod(code_integer,code_integer),nat,product_case_prod(code_integer,code_integer,nat,aTP_Lamp_nc(code_integer,fun(code_integer,nat))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))) ) ) ) ).

% nat_of_integer_code
tff(fact_5631_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A),X3: A] :
          ( finite_finite(A,A2)
         => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),insert2(A,X3),A2)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),X3),aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
tff(fact_5632_max__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,ord_max(nat),zero_zero(nat),aTP_Lamp_ag(nat,fun(nat,bool)),aTP_Lamp_eu(nat,fun(nat,bool))) ).

% max_nat.semilattice_neutr_order_axioms
tff(fact_5633_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [X3: B,F2: fun(B,A),Xs: list(B)] : ( remove1(B,X3,aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs)) = Xs ) ) ).

% remove1_insort_key
tff(fact_5634_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),X3: B,Xs: list(B)] : ( aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs)) = aa(nat,nat,suc,aa(list(B),nat,size_size(list(B)),Xs)) ) ) ).

% length_insort
tff(fact_5635_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A),X3: A] :
          ( finite_finite(A,A2)
         => ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),insert2(A,X3),A2)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),X3),aa(set(A),list(A),linord4507533701916653071of_set(A),A2)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
tff(fact_5636_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),X3: B,Y4: B,Xs: list(B)] :
          ( ( aa(B,A,F2,X3) != aa(B,A,F2,Y4) )
         => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),Y4),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),Y4),Xs)) ) ) ) ).

% insort_key_left_comm
tff(fact_5637_insort__left__comm,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A,Xs: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),X3),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),Y4),Xs)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),Y4),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),X3),Xs)) ) ) ).

% insort_left_comm
tff(fact_5638_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y4: A,X3: A] : ( aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),Y4)),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),X3)) = aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),X3)),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),Y4)) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
tff(fact_5639_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),X3: B,Xs: list(B)] : ( aa(list(B),set(B),set2(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs)) = aa(set(B),set(B),insert2(B,X3),aa(list(B),set(B),set2(B),Xs)) ) ) ).

% set_insort_key
tff(fact_5640_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),X3: B,Xs: list(B)] :
          ( distinct(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs))
        <=> ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),aa(list(B),set(B),set2(B),Xs)))
            & distinct(B,Xs) ) ) ) ).

% distinct_insort
tff(fact_5641_sorted__insort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),X3),Xs))
        <=> sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% sorted_insort
tff(fact_5642_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),X3: B,Xs: list(B)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs)))
        <=> sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs)) ) ) ).

% sorted_insort_key
tff(fact_5643_insort__remove1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,Xs: list(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),aa(list(A),set(A),set2(A),Xs)))
         => ( sorted_wrt(A,ord_less_eq(A),Xs)
           => ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),A3),remove1(A,A3,Xs)) = Xs ) ) ) ) ).

% insort_remove1
tff(fact_5644_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,gcd_gcd(nat),zero_zero(nat),dvd_dvd(nat),aTP_Lamp_ne(nat,fun(nat,bool))) ).

% gcd_nat.semilattice_neutr_order_axioms
tff(fact_5645_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A),X3: A] :
          ( finite_finite(A,A2)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),A2) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),X3),aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
tff(fact_5646_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J3),I)))
     => ( aa(nat,nat,nth(nat,aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or3652927894154168847AtMost(nat,I,J3))),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),N)) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
tff(fact_5647_card__UNION,axiom,
    ! [A: $tType,A2: set(set(A))] :
      ( finite_finite(set(A),A2)
     => ( ! [X2: set(A)] :
            ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X2),A2))
           => finite_finite(A,X2) )
       => ( aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A2)) = aa(int,nat,nat2,aa(set(set(set(A))),int,aa(fun(set(set(A)),int),fun(set(set(set(A))),int),groups7311177749621191930dd_sum(set(set(A)),int),aTP_Lamp_nf(set(set(A)),int)),collect(set(set(A)),aTP_Lamp_ng(set(set(A)),fun(set(set(A)),bool),A2)))) ) ) ) ).

% card_UNION
tff(fact_5648_set__removeAll,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),removeAll(A,X3),Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))) ) ).

% set_removeAll
tff(fact_5649_removeAll__id,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( aa(list(A),list(A),removeAll(A,X3),Xs) = Xs ) ) ).

% removeAll_id
tff(fact_5650_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or1337092689740270186AtMost(A,X3,Y4)) = Y4 ) ) ) ).

% Sup_atLeastAtMost
tff(fact_5651_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or1337092689740270186AtMost(A,X3,Y4)) = X3 ) ) ) ).

% Inf_atLeastAtMost
tff(fact_5652_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or7035219750837199246ssThan(A,X3,Y4)) = Y4 ) ) ) ).

% Sup_atLeastLessThan
tff(fact_5653_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or7035219750837199246ssThan(A,X3,Y4)) = X3 ) ) ) ).

% Inf_atLeastLessThan
tff(fact_5654_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,L: A,U: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),set_or3652927894154168847AtMost(A,L,U)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),I))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),U)) ) ) ) ).

% greaterThanAtMost_iff
tff(fact_5655_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),K))
         => ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) ) ) ) ).

% greaterThanAtMost_empty
tff(fact_5656_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( bot_bot(set(A)) = set_or3652927894154168847AtMost(A,K,L) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) ) ) ).

% greaterThanAtMost_empty_iff2
tff(fact_5657_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) ) ) ).

% greaterThanAtMost_empty_iff
tff(fact_5658_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( ~ finite_finite(A,set_or3652927894154168847AtMost(A,A3,B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% infinite_Ioc_iff
tff(fact_5659_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or5935395276787703475ssThan(A,X3,Y4)) = Y4 ) ) ) ).

% Sup_greaterThanLessThan
tff(fact_5660_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or3652927894154168847AtMost(A,X3,Y4)) = Y4 ) ) ) ).

% Sup_greaterThanAtMost
tff(fact_5661_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or5935395276787703475ssThan(A,X3,Y4)) = X3 ) ) ) ).

% Inf_greaterThanLessThan
tff(fact_5662_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or3652927894154168847AtMost(A,X3,Y4)) = X3 ) ) ) ).

% Inf_greaterThanAtMost
tff(fact_5663_Ioc__inj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( set_or3652927894154168847AtMost(A,A3,B2) = set_or3652927894154168847AtMost(A,C2,D2) )
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),C2)) )
            | ( ( A3 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
tff(fact_5664_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( distinct(A,Xs)
     => distinct(A,aa(list(A),list(A),removeAll(A,X3),Xs)) ) ).

% distinct_removeAll
tff(fact_5665_card__Union__le__sum__card,axiom,
    ! [A: $tType,U3: set(set(A))] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),U3))),aa(set(set(A)),nat,aa(fun(set(A),nat),fun(set(set(A)),nat),groups7311177749621191930dd_sum(set(A),nat),finite_card(A)),U3))) ).

% card_Union_le_sum_card
tff(fact_5666_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A3,B2)),set_or3652927894154168847AtMost(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% Ioc_subset_iff
tff(fact_5667_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ finite_finite(A,set_or3652927894154168847AtMost(A,A3,B2)) ) ) ).

% infinite_Ioc
tff(fact_5668_length__removeAll__less__eq,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),removeAll(A,X3),Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ).

% length_removeAll_less_eq
tff(fact_5669_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),A3: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),A3)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(A),A,complete_Inf_Inf(A),S2))),A3)) ) ) ) ).

% cInf_abs_ge
tff(fact_5670_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [B3: set(set(B)),G: fun(B,A)] :
          ( ! [X2: set(B)] :
              ( pp(aa(set(set(B)),bool,aa(set(B),fun(set(set(B)),bool),member2(set(B)),X2),B3))
             => finite_finite(B,X2) )
         => ( ! [A13: set(B)] :
                ( pp(aa(set(set(B)),bool,aa(set(B),fun(set(set(B)),bool),member2(set(B)),A13),B3))
               => ! [A24: set(B)] :
                    ( pp(aa(set(set(B)),bool,aa(set(B),fun(set(set(B)),bool),member2(set(B)),A24),B3))
                   => ( ( A13 != A24 )
                     => ! [X2: B] :
                          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A13))
                         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A24))
                           => ( aa(B,A,G,X2) = zero_zero(A) ) ) ) ) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A),groups7311177749621191930dd_sum(set(B),A)),groups7311177749621191930dd_sum(B,A)),G),B3) ) ) ) ) ).

% sum.Union_comp
tff(fact_5671_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U3: set(set(A))] :
      ( ! [X2: set(A)] :
          ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X2),U3))
         => finite_finite(A,X2) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),U3))),aa(set(set(A)),nat,aa(fun(set(A),nat),fun(set(set(A)),nat),groups7311177749621191930dd_sum(set(A),nat),finite_card(A)),U3))) ) ).

% card_Union_le_sum_card_weak
tff(fact_5672_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( distinct(A,Xs)
     => ( remove1(A,X3,Xs) = aa(list(A),list(A),removeAll(A,X3),Xs) ) ) ).

% distinct_remove1_removeAll
tff(fact_5673_greaterThanAtMost__upt,axiom,
    ! [N: nat,M: nat] : ( set_or3652927894154168847AtMost(nat,N,M) = aa(list(nat),set(nat),set2(nat),upt(aa(nat,nat,suc,N),aa(nat,nat,suc,M))) ) ).

% greaterThanAtMost_upt
tff(fact_5674_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),L: A,E: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),L))),E)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(A),A,complete_Inf_Inf(A),S2)),L))),E)) ) ) ) ).

% cInf_asclose
tff(fact_5675_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),L: A,E: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),L))),E)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(A),A,complete_Sup_Sup(A),S2)),L))),E)) ) ) ) ).

% cSup_asclose
tff(fact_5676_sum_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or3652927894154168847AtMost(nat,M,N))) ) ) ) ).

% sum.head
tff(fact_5677_prod_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),groups7121269368397514597t_prod(nat,A,G,set_or3652927894154168847AtMost(nat,M,N))) ) ) ) ).

% prod.head
tff(fact_5678_length__removeAll__less,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),removeAll(A,X3),Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ) ).

% length_removeAll_less
tff(fact_5679_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A3,B2)),set_or1337092689740270186AtMost(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
tff(fact_5680_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A3,B2)),set_or7035219750837199246ssThan(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),D2)) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
tff(fact_5681_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A3,B2)),set_or3652927894154168847AtMost(A,C2,D2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2)) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
tff(fact_5682_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or3652927894154168847AtMost(A,Y4,X3)) = Y4 ) ) ) ).

% cInf_greaterThanAtMost
tff(fact_5683_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or5935395276787703475ssThan(A,Y4,X3)) = Y4 ) ) ) ).

% cInf_greaterThanLessThan
tff(fact_5684_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or3652927894154168847AtMost(A,Y4,X3)) = X3 ) ) ) ).

% cSup_greaterThanAtMost
tff(fact_5685_Sup__nat__empty,axiom,
    aa(set(nat),nat,complete_Sup_Sup(nat),bot_bot(set(nat))) = zero_zero(nat) ).

% Sup_nat_empty
tff(fact_5686_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or1337092689740270186AtMost(A,Y4,X3)) = X3 ) ) ) ).

% cSup_atLeastAtMost
tff(fact_5687_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or1337092689740270186AtMost(A,Y4,X3)) = Y4 ) ) ) ).

% cInf_atLeastAtMost
tff(fact_5688_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or7035219750837199246ssThan(A,Y4,X3)) = X3 ) ) ) ).

% cSup_atLeastLessThan
tff(fact_5689_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or7035219750837199246ssThan(A,Y4,X3)) = Y4 ) ) ) ).

% cInf_atLeastLessThan
tff(fact_5690_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or5935395276787703475ssThan(A,Y4,X3)) = X3 ) ) ) ).

% cSup_greaterThanLessThan
tff(fact_5691_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( condit5016429287641298734tinuum(A)
     => ! [A3: A] :
        ? [B5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B5))
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B5),A3)) ) ) ).

% ex_gt_or_lt
tff(fact_5692_complete__interval,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [A3: A,B2: A,P: fun(A,bool)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,P,A3))
           => ( ~ pp(aa(A,bool,P,B2))
             => ? [C3: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C3),B2))
                  & ! [X: A] :
                      ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X))
                        & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),C3)) )
                     => pp(aa(A,bool,P,X)) )
                  & ! [D6: A] :
                      ( ! [X2: A] :
                          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
                            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),D6)) )
                         => pp(aa(A,bool,P,X2)) )
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D6),C3)) ) ) ) ) ) ) ).

% complete_interval
tff(fact_5693_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Z: A,X7: set(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Z),X7))
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),X7) = Z ) ) ) ) ).

% cSup_eq_maximum
tff(fact_5694_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & no_bot(A) )
     => ! [X7: set(A),A3: A] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A3)) )
         => ( ! [Y2: A] :
                ( ! [X: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),X7))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),Y2)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),X7) = A3 ) ) ) ) ).

% cSup_eq
tff(fact_5695_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Z: A,X7: set(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Z),X7))
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),X2)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),X7) = Z ) ) ) ) ).

% cInf_eq_minimum
tff(fact_5696_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & no_top(A) )
     => ! [X7: set(A),A3: A] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2)) )
         => ( ! [Y2: A] :
                ( ! [X: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),X7))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),A3)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),X7) = A3 ) ) ) ) ).

% cInf_eq
tff(fact_5697_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X7: set(A),A3: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A3)) )
           => ( ! [Y2: A] :
                  ( ! [X: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),X7))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2)) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),Y2)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),X7) = A3 ) ) ) ) ) ).

% cSup_eq_non_empty
tff(fact_5698_cSup__least,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X7: set(A),Z: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),X7)),Z)) ) ) ) ).

% cSup_least
tff(fact_5699_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X7: set(A),X3: A] :
          ( finite_finite(A,X7)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),X7))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(set(A),A,complete_Sup_Sup(A),X7))) ) ) ) ).

% le_cSup_finite
tff(fact_5700_less__cSupE,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [Y4: A,X7: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),aa(set(A),A,complete_Sup_Sup(A),X7)))
         => ( ( X7 != bot_bot(set(A)) )
           => ~ ! [X2: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
                 => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X2)) ) ) ) ) ).

% less_cSupE
tff(fact_5701_less__cSupD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Z: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),aa(set(A),A,complete_Sup_Sup(A),X7)))
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),X2)) ) ) ) ) ).

% less_cSupD
tff(fact_5702_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),X3: A,A3: A] :
          ( finite_finite(A,X7)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),X7))
           => ( ! [X2: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),A3)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),X7)),A3)) ) ) ) ) ).

% finite_imp_Sup_less
tff(fact_5703_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X7: set(A),A3: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2)) )
           => ( ! [Y2: A] :
                  ( ! [X: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),X7))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X)) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),A3)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),X7) = A3 ) ) ) ) ) ).

% cInf_eq_non_empty
tff(fact_5704_cInf__greatest,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X7: set(A),Z: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),X2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),aa(set(A),A,complete_Inf_Inf(A),X7))) ) ) ) ).

% cInf_greatest
tff(fact_5705_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X7: set(A),X3: A] :
          ( finite_finite(A,X7)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),X7))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),X7)),X3)) ) ) ) ).

% cInf_le_finite
tff(fact_5706_cInf__lessD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Z: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),X7)),Z))
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z)) ) ) ) ) ).

% cInf_lessD
tff(fact_5707_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),X3: A,A3: A] :
          ( finite_finite(A,X7)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),X7))
           => ( ! [X2: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X2)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(set(A),A,complete_Inf_Inf(A),X7))) ) ) ) ) ).

% finite_imp_less_Inf
tff(fact_5708_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),A3: A] :
          ( finite_finite(A,X7)
         => ( ( X7 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),X7)),A3))
            <=> ! [X4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),X7))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),A3)) ) ) ) ) ) ).

% finite_Sup_less_iff
tff(fact_5709_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),A3: A] :
          ( finite_finite(A,X7)
         => ( ( X7 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(set(A),A,complete_Inf_Inf(A),X7)))
            <=> ! [X4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),X7))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X4)) ) ) ) ) ) ).

% finite_less_Inf_iff
tff(fact_5710_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),A3: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),A3)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(A),A,complete_Sup_Sup(A),S2))),A3)) ) ) ) ).

% cSup_abs_le
tff(fact_5711_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A2: set(A)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),A2) = bot_bot(A) )
        <=> ! [X4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),X4))
             => ? [Xa4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Xa4),X4)) ) ) ) ) ).

% Inf_eq_bot_iff
tff(fact_5712_finite__subset__Union,axiom,
    ! [A: $tType,A2: set(A),B12: set(set(A))] :
      ( finite_finite(A,A2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B12)))
       => ~ ! [F7: set(set(A))] :
              ( finite_finite(set(A),F7)
             => ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),F7),B12))
               => ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),F7))) ) ) ) ) ).

% finite_subset_Union
tff(fact_5713_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A)] :
          ( ( A2 != bot_bot(set(A)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A2)),aa(set(A),A,complete_Sup_Sup(A),A2))) ) ) ).

% Inf_le_Sup
tff(fact_5714_Sup__upper2,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [U: A,A2: set(A),V: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),U),A2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),V),U))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),V),aa(set(A),A,complete_Sup_Sup(A),A2))) ) ) ) ).

% Sup_upper2
tff(fact_5715_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A2)),B2))
        <=> ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),B2)) ) ) ) ).

% Sup_le_iff
tff(fact_5716_Sup__upper,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X3: A,A2: set(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(set(A),A,complete_Sup_Sup(A),A2))) ) ) ).

% Sup_upper
tff(fact_5717_Sup__least,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),Z: A] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A2)),Z)) ) ) ).

% Sup_least
tff(fact_5718_Sup__mono,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),B3: set(A)] :
          ( ! [A5: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A5),A2))
             => ? [X: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),B3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),X)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A2)),aa(set(A),A,complete_Sup_Sup(A),B3))) ) ) ).

% Sup_mono
tff(fact_5719_Sup__eqI,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),X3: A] :
          ( ! [Y2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y2),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X3)) )
         => ( ! [Y2: A] :
                ( ! [Z3: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Z3),A2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z3),Y2)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y2)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),A2) = X3 ) ) ) ) ).

% Sup_eqI
tff(fact_5720_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: A,S2: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(set(A),A,complete_Sup_Sup(A),S2)))
        <=> ? [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),S2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X4)) ) ) ) ).

% less_Sup_iff
tff(fact_5721_Inf__greatest,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),Z: A] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),X2)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),aa(set(A),A,complete_Inf_Inf(A),A2))) ) ) ).

% Inf_greatest
tff(fact_5722_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B2: A,A2: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(set(A),A,complete_Inf_Inf(A),A2)))
        <=> ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),X4)) ) ) ) ).

% le_Inf_iff
tff(fact_5723_Inf__lower2,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [U: A,A2: set(A),V: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),U),A2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),V))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A2)),V)) ) ) ) ).

% Inf_lower2
tff(fact_5724_Inf__lower,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X3: A,A2: set(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A2)),X3)) ) ) ).

% Inf_lower
tff(fact_5725_Inf__mono,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B3: set(A),A2: set(A)] :
          ( ! [B5: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B5),B3))
             => ? [X: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),B5)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A2)),aa(set(A),A,complete_Inf_Inf(A),B3))) ) ) ).

% Inf_mono
tff(fact_5726_Inf__eqI,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),X3: A] :
          ( ! [I3: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),I3)) )
         => ( ! [Y2: A] :
                ( ! [I4: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I4),A2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),I4)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X3)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),A2) = X3 ) ) ) ) ).

% Inf_eqI
tff(fact_5727_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [S2: set(A),A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),S2)),A3))
        <=> ? [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),S2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),A3)) ) ) ) ).

% Inf_less_iff
tff(fact_5728_dependent__nat__choice,axiom,
    ! [A: $tType,P: fun(nat,fun(A,bool)),Q: fun(nat,fun(A,fun(A,bool)))] :
      ( ? [X_1: A] : pp(aa(A,bool,aa(nat,fun(A,bool),P,zero_zero(nat)),X_1))
     => ( ! [X2: A,N2: nat] :
            ( pp(aa(A,bool,aa(nat,fun(A,bool),P,N2),X2))
           => ? [Y5: A] :
                ( pp(aa(A,bool,aa(nat,fun(A,bool),P,aa(nat,nat,suc,N2)),Y5))
                & pp(aa(A,bool,aa(A,fun(A,bool),aa(nat,fun(A,fun(A,bool)),Q,N2),X2),Y5)) ) )
       => ? [F4: fun(nat,A)] :
          ! [N7: nat] :
            ( pp(aa(A,bool,aa(nat,fun(A,bool),P,N7),aa(nat,A,F4,N7)))
            & pp(aa(A,bool,aa(A,fun(A,bool),aa(nat,fun(A,fun(A,bool)),Q,N7),aa(nat,A,F4,N7)),aa(nat,A,F4,aa(nat,nat,suc,N7)))) ) ) ) ).

% dependent_nat_choice
tff(fact_5729_Union__least,axiom,
    ! [A: $tType,A2: set(set(A)),C6: set(A)] :
      ( ! [X8: set(A)] :
          ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X8),A2))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X8),C6)) )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A2)),C6)) ) ).

% Union_least
tff(fact_5730_Union__upper,axiom,
    ! [A: $tType,B3: set(A),A2: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),B3),A2))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A2))) ) ).

% Union_upper
tff(fact_5731_Union__subsetI,axiom,
    ! [A: $tType,A2: set(set(A)),B3: set(set(A))] :
      ( ! [X2: set(A)] :
          ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X2),A2))
         => ? [Y5: set(A)] :
              ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),Y5),B3))
              & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X2),Y5)) ) )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A2)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3))) ) ).

% Union_subsetI
tff(fact_5732_Inter__lower,axiom,
    ! [A: $tType,B3: set(A),A2: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),B3),A2))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A2)),B3)) ) ).

% Inter_lower
tff(fact_5733_Inter__greatest,axiom,
    ! [A: $tType,A2: set(set(A)),C6: set(A)] :
      ( ! [X8: set(A)] :
          ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X8),A2))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),X8)) )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A2))) ) ).

% Inter_greatest
tff(fact_5734_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [X3: A,A2: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(set(A),A,complete_Sup_Sup(A),A2)))
        <=> ! [Y: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X3))
             => ? [X4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X4)) ) ) ) ) ).

% le_Sup_iff
tff(fact_5735_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A2: set(A),X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A2)),X3))
        <=> ! [Y: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y))
             => ? [X4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),Y)) ) ) ) ) ).

% Inf_le_iff
tff(fact_5736_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),U: A] :
          ( ! [V3: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),V3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),V3)) )
         => ( ( A2 != bot_bot(set(A)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Sup_Sup(A),A2))) ) ) ) ).

% less_eq_Sup
tff(fact_5737_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A2)),aa(set(A),A,complete_Sup_Sup(A),B3))) ) ) ).

% Sup_subset_mono
tff(fact_5738_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),U: A] :
          ( ! [V3: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),V3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),V3),U)) )
         => ( ( A2 != bot_bot(set(A)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A2)),U)) ) ) ) ).

% Inf_less_eq
tff(fact_5739_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B3: set(A),A2: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A2)),aa(set(A),A,complete_Inf_Inf(A),B3))) ) ) ).

% Inf_superset_mono
tff(fact_5740_Union__mono,axiom,
    ! [A: $tType,A2: set(set(A)),B3: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),A2),B3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A2)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3))) ) ).

% Union_mono
tff(fact_5741_Inter__anti__mono,axiom,
    ! [A: $tType,B3: set(set(A)),A2: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),B3),A2))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A2)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B3))) ) ).

% Inter_anti_mono
tff(fact_5742_Inter__subset,axiom,
    ! [A: $tType,A2: set(set(A)),B3: set(A)] :
      ( ! [X8: set(A)] :
          ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X8),A2))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X8),B3)) )
     => ( ( A2 != bot_bot(set(set(A))) )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A2)),B3)) ) ) ).

% Inter_subset
tff(fact_5743_subset__Pow__Union,axiom,
    ! [A: $tType,A2: set(set(A))] : pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),A2),pow2(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A2)))) ).

% subset_Pow_Union
tff(fact_5744_card__partition,axiom,
    ! [A: $tType,C6: set(set(A)),K: nat] :
      ( finite_finite(set(A),C6)
     => ( finite_finite(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C6))
       => ( ! [C3: set(A)] :
              ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),C3),C6))
             => ( aa(set(A),nat,finite_card(A),C3) = K ) )
         => ( ! [C1: set(A),C22: set(A)] :
                ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),C1),C6))
               => ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),C22),C6))
                 => ( ( C1 != C22 )
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C1),C22) = bot_bot(set(A)) ) ) ) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(set(set(A)),nat,finite_card(set(A)),C6)) = aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C6)) ) ) ) ) ) ).

% card_partition
tff(fact_5745_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea2506097494486148201lgebra(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% bit.abstract_boolean_algebra_axioms
tff(fact_5746_int__of__integer__code,axiom,
    ! [K: code_integer] :
      ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)))
       => ( code_int_of_integer(K) = aa(int,int,uminus_uminus(int),code_int_of_integer(aa(code_integer,code_integer,uminus_uminus(code_integer),K))) ) )
      & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)))
       => ( ( ( K = zero_zero(code_integer) )
           => ( code_int_of_integer(K) = zero_zero(int) ) )
          & ( ( K != zero_zero(code_integer) )
           => ( code_int_of_integer(K) = aa(product_prod(code_integer,code_integer),int,product_case_prod(code_integer,code_integer,int,aTP_Lamp_nh(code_integer,fun(code_integer,int))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))) ) ) ) ) ) ).

% int_of_integer_code
tff(fact_5747_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% inf.bounded_iff
tff(fact_5748_le__inf__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y4),Z)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Z)) ) ) ) ).

% le_inf_iff
tff(fact_5749_Int__subset__iff,axiom,
    ! [A: $tType,C6: set(A),A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3)))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),A2))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),B3)) ) ) ).

% Int_subset_iff
tff(fact_5750_zero__integer_Orep__eq,axiom,
    code_int_of_integer(zero_zero(code_integer)) = zero_zero(int) ).

% zero_integer.rep_eq
tff(fact_5751_int__of__integer__numeral,axiom,
    ! [K: num] : ( code_int_of_integer(aa(num,code_integer,numeral_numeral(code_integer),K)) = aa(num,int,numeral_numeral(int),K) ) ).

% int_of_integer_numeral
tff(fact_5752_times__integer_Orep__eq,axiom,
    ! [X3: code_integer,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),X3),Xa)) = aa(int,int,aa(int,fun(int,int),times_times(int),code_int_of_integer(X3)),code_int_of_integer(Xa)) ) ).

% times_integer.rep_eq
tff(fact_5753_divide__integer_Orep__eq,axiom,
    ! [X3: code_integer,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),X3),Xa)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),code_int_of_integer(X3)),code_int_of_integer(Xa)) ) ).

% divide_integer.rep_eq
tff(fact_5754_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [A2: set(B),F2: fun(B,A),P: fun(B,bool)] :
          ( finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,bool),fun(B,A),aTP_Lamp_ni(fun(B,A),fun(fun(B,bool),fun(B,A)),F2),P)),A2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),collect(B,P))) ) ) ) ).

% sum_mult_of_bool_eq
tff(fact_5755_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [A2: set(B),P: fun(B,bool),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_nj(fun(B,bool),fun(fun(B,A),fun(B,A)),P),F2)),A2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),collect(B,P))) ) ) ) ).

% sum_of_bool_mult_eq
tff(fact_5756_Union__Int__subset,axiom,
    ! [A: $tType,A2: set(set(A)),B3: set(set(A))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),A2),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A2)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3)))) ).

% Union_Int_subset
tff(fact_5757_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),B3: set(A)] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),A2)),aa(set(A),A,complete_Sup_Sup(A),B3)))) ) ).

% Sup_inter_less_eq
tff(fact_5758_less__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,X3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),X3)) ) ) ).

% less_infI1
tff(fact_5759_less__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,X3: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),X3)) ) ) ).

% less_infI2
tff(fact_5760_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = A3 ) ) ) ).

% inf.absorb3
tff(fact_5761_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = B2 ) ) ) ).

% inf.absorb4
tff(fact_5762_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% inf.strict_boundedE
tff(fact_5763_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) )
            & ( A3 != B2 ) ) ) ) ).

% inf.strict_order_iff
tff(fact_5764_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2)) ) ) ).

% inf.strict_coboundedI1
tff(fact_5765_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2)) ) ) ).

% inf.strict_coboundedI2
tff(fact_5766_Int__mono,axiom,
    ! [A: $tType,A2: set(A),C6: set(A),B3: set(A),D4: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),D4))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C6),D4))) ) ) ).

% Int_mono
tff(fact_5767_Int__lower1,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3)),A2)) ).

% Int_lower1
tff(fact_5768_Int__lower2,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3)),B3)) ).

% Int_lower2
tff(fact_5769_Int__absorb1,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3) = B3 ) ) ).

% Int_absorb1
tff(fact_5770_Int__absorb2,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3) = A2 ) ) ).

% Int_absorb2
tff(fact_5771_Int__greatest,axiom,
    ! [A: $tType,C6: set(A),A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),A2))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),B3))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3))) ) ) ).

% Int_greatest
tff(fact_5772_Int__Collect__mono,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
           => ( pp(aa(A,bool,P,X2))
             => pp(aa(A,bool,Q,X2)) ) )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),collect(A,P))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),collect(A,Q)))) ) ) ).

% Int_Collect_mono
tff(fact_5773_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2)) ) ) ).

% inf.coboundedI2
tff(fact_5774_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2)) ) ) ).

% inf.coboundedI1
tff(fact_5775_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = B2 ) ) ) ).

% inf.absorb_iff2
tff(fact_5776_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = A3 ) ) ) ).

% inf.absorb_iff1
tff(fact_5777_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),B2)) ) ).

% inf.cobounded2
tff(fact_5778_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),A3)) ) ).

% inf.cobounded1
tff(fact_5779_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) ) ) ) ).

% inf.order_iff
tff(fact_5780_inf__greatest,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Z))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y4),Z))) ) ) ) ).

% inf_greatest
tff(fact_5781_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2))) ) ) ) ).

% inf.boundedI
tff(fact_5782_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% inf.boundedE
tff(fact_5783_inf__absorb2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4) = Y4 ) ) ) ).

% inf_absorb2
tff(fact_5784_inf__absorb1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4) = X3 ) ) ) ).

% inf_absorb1
tff(fact_5785_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = B2 ) ) ) ).

% inf.absorb2
tff(fact_5786_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = A3 ) ) ) ).

% inf.absorb1
tff(fact_5787_le__iff__inf,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4) = X3 ) ) ) ).

% le_iff_inf
tff(fact_5788_inf__unique,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [F2: fun(A,fun(A,A)),X3: A,Y4: A] :
          ( ! [X2: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F2,X2),Y2)),X2))
         => ( ! [X2: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F2,X2),Y2)),Y2))
           => ( ! [X2: A,Y2: A,Z4: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z4))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),F2,Y2),Z4))) ) )
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4) = aa(A,A,aa(A,fun(A,A),F2,X3),Y4) ) ) ) ) ) ).

% inf_unique
tff(fact_5789_inf_OorderI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% inf.orderI
tff(fact_5790_inf_OorderE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) ) ) ) ).

% inf.orderE
tff(fact_5791_le__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,X3: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),X3)) ) ) ).

% le_infI2
tff(fact_5792_le__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,X3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),X3)) ) ) ).

% le_infI1
tff(fact_5793_inf__mono,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),aa(A,A,aa(A,fun(A,A),inf_inf(A),C2),D2))) ) ) ) ).

% inf_mono
tff(fact_5794_le__infI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X3: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2))) ) ) ) ).

% le_infI
tff(fact_5795_le__infE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X3: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),B2)) ) ) ) ).

% le_infE
tff(fact_5796_inf__le2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4)),Y4)) ) ).

% inf_le2
tff(fact_5797_inf__le1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4)),X3)) ) ).

% inf_le1
tff(fact_5798_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4)),X3)) ) ).

% inf_sup_ord(1)
tff(fact_5799_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4)),Y4)) ) ).

% inf_sup_ord(2)
tff(fact_5800_integer__less__iff,axiom,
    ! [K: code_integer,L: code_integer] :
      ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),L))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),code_int_of_integer(K)),code_int_of_integer(L))) ) ).

% integer_less_iff
tff(fact_5801_less__integer_Orep__eq,axiom,
    ! [X3: code_integer,Xa: code_integer] :
      ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),X3),Xa))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),code_int_of_integer(X3)),code_int_of_integer(Xa))) ) ).

% less_integer.rep_eq
tff(fact_5802_less__eq__integer_Orep__eq,axiom,
    ! [X3: code_integer,Xa: code_integer] :
      ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),X3),Xa))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),code_int_of_integer(X3)),code_int_of_integer(Xa))) ) ).

% less_eq_integer.rep_eq
tff(fact_5803_integer__less__eq__iff,axiom,
    ! [K: code_integer,L: code_integer] :
      ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),L))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),code_int_of_integer(K)),code_int_of_integer(L))) ) ).

% integer_less_eq_iff
tff(fact_5804_inf__shunt,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4) = bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,uminus_uminus(A),Y4))) ) ) ).

% inf_shunt
tff(fact_5805_unset__bit__integer_Orep__eq,axiom,
    ! [X3: nat,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(nat,fun(code_integer,code_integer),bit_se2638667681897837118et_bit(code_integer),X3),Xa)) = aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),X3),code_int_of_integer(Xa)) ) ).

% unset_bit_integer.rep_eq
tff(fact_5806_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,A3,B2)),set_or3652927894154168847AtMost(A,C2,D2)) = bot_bot(set(A)) )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),C2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),A3)) ) ) ) ).

% Ioc_disjoint
tff(fact_5807_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3) = bot_bot(set(A)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),uminus_uminus(set(A)),B3))) ) ).

% disjoint_eq_subset_Compl
tff(fact_5808_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),G: fun(B,A),B3: set(B)] :
          ( finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(set(B),fun(B,A),aTP_Lamp_nk(fun(B,A),fun(set(B),fun(B,A)),G),B3)),A2) ) ) ) ).

% sum.inter_restrict
tff(fact_5809_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [T6: set(B),S2: set(B),H: fun(B,A),G: fun(B,A)] :
          ( finite_finite(B,T6)
         => ( finite_finite(B,S2)
           => ( ! [I3: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
                 => ( aa(B,A,H,I3) = zero_zero(A) ) )
             => ( ! [I3: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),T6)))
                   => ( aa(B,A,G,I3) = zero_zero(A) ) )
               => ( ! [X2: B] :
                      ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T6)))
                     => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),T6) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
tff(fact_5810_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,K: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),K))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,K)),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))) = aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),K))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,K)),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))) = bot_bot(set(A)) ) ) ) ) ).

% Iio_Int_singleton
tff(fact_5811_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),G: fun(B,A),B3: set(B)] :
          ( finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),B3))) ) ) ) ).

% sum.Int_Diff
tff(fact_5812_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),G: fun(B,A),B3: set(B)] :
          ( finite_finite(B,A2)
         => ( groups7121269368397514597t_prod(B,A,G,A2) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),B3))) ) ) ) ).

% prod.Int_Diff
tff(fact_5813_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),P: fun(B,bool),H: fun(B,A),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_nl(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),H),G)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),collect(B,P)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),aa(set(B),set(B),uminus_uminus(set(B)),collect(B,P))))) ) ) ) ).

% sum.If_cases
tff(fact_5814_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),P: fun(B,bool),H: fun(B,A),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( groups7121269368397514597t_prod(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_nm(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),H),G),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,H,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),collect(B,P)))),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),aa(set(B),set(B),uminus_uminus(set(B)),collect(B,P))))) ) ) ) ).

% prod.If_cases
tff(fact_5815_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: set(B),F2: fun(B,A),B2: A] :
          ( finite_finite(B,A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_nn(fun(B,A),fun(A,fun(B,A)),F2),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),collect(B,aa(A,fun(B,bool),aTP_Lamp_no(fun(B,A),fun(A,fun(B,bool)),F2),B2))))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),collect(B,aa(A,fun(B,bool),aTP_Lamp_np(fun(B,A),fun(A,fun(B,bool)),F2),B2))))),B2)) ) ) ) ).

% sum_div_partition
tff(fact_5816_distinct__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(list(A),Xs)
     => ( ! [Ys3: list(A)] :
            ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Ys3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
           => distinct(A,Ys3) )
       => ( ! [Ys3: list(A),Zs2: list(A)] :
              ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Ys3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
             => ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs2),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
               => ( ( Ys3 != Zs2 )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys3)),aa(list(A),set(A),set2(A),Zs2)) = bot_bot(set(A)) ) ) ) )
         => distinct(A,concat(A,Xs)) ) ) ) ).

% distinct_concat
tff(fact_5817_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) = bot_bot(set(A)) )
     => ( aa(set(list(A)),nat,finite_card(list(A)),shuffles(A,Xs,Ys2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys2))),aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% card_disjoint_shuffles
tff(fact_5818_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X3: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X3)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X3)) ) ).

% times_int.abs_eq
tff(fact_5819_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S2: set(A),F2: fun(A,B)] :
          ( finite_finite(A,S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ~ ? [X: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),S2))
                  & pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X)),aa(A,B,F2,lattic7623131987881927897min_on(A,B,F2,S2)))) ) ) ) ) ).

% arg_min_if_finite(2)
tff(fact_5820_finite__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : finite_finite(list(A),shuffles(A,Xs,Ys2)) ).

% finite_shuffles
tff(fact_5821_eq__Abs__Integ,axiom,
    ! [Z: int] :
      ~ ! [X2: nat,Y2: nat] : ( Z != aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X2),Y2)) ) ).

% eq_Abs_Integ
tff(fact_5822_shuffles__commutes,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : ( shuffles(A,Xs,Ys2) = shuffles(A,Ys2,Xs) ) ).

% shuffles_commutes
tff(fact_5823_int_Oabs__induct,axiom,
    ! [P: fun(int,bool),X3: int] :
      ( ! [Y2: product_prod(nat,nat)] : pp(aa(int,bool,P,aa(product_prod(nat,nat),int,abs_Integ,Y2)))
     => pp(aa(int,bool,P,X3)) ) ).

% int.abs_induct
tff(fact_5824_length__shuffles,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys2: list(A)] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
     => ( aa(list(A),nat,size_size(list(A)),Zs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys2)) ) ) ).

% length_shuffles
tff(fact_5825_nat_Oabs__eq,axiom,
    ! [X3: product_prod(nat,nat)] : ( aa(int,nat,nat2,aa(product_prod(nat,nat),int,abs_Integ,X3)) = aa(product_prod(nat,nat),nat,product_case_prod(nat,nat,nat,minus_minus(nat)),X3) ) ).

% nat.abs_eq
tff(fact_5826_zero__int__def,axiom,
    zero_zero(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))) ).

% zero_int_def
tff(fact_5827_int__def,axiom,
    ! [N: nat] : ( aa(nat,int,semiring_1_of_nat(int),N) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,N),zero_zero(nat))) ) ).

% int_def
tff(fact_5828_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( distinct(A,Xs)
     => ( distinct(A,Ys2)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) = bot_bot(set(A)) )
         => ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
           => distinct(A,Zs) ) ) ) ) ).

% distinct_disjoint_shuffles
tff(fact_5829_uminus__int_Oabs__eq,axiom,
    ! [X3: product_prod(nat,nat)] : ( aa(int,int,uminus_uminus(int),aa(product_prod(nat,nat),int,abs_Integ,X3)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_ns(nat,fun(nat,product_prod(nat,nat)))),X3)) ) ).

% uminus_int.abs_eq
tff(fact_5830_one__int__def,axiom,
    one_one(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))) ).

% one_int_def
tff(fact_5831_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: product_prod(nat,nat)] : ( aa(int,A,ring_1_of_int(A),aa(product_prod(nat,nat),int,abs_Integ,X3)) = aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_nt(nat,fun(nat,A))),X3) ) ) ).

% of_int.abs_eq
tff(fact_5832_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X3: product_prod(nat,nat)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X3)))
    <=> pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool),aTP_Lamp_nv(nat,fun(nat,fun(product_prod(nat,nat),bool)))),Xa),X3)) ) ).

% less_int.abs_eq
tff(fact_5833_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X3: product_prod(nat,nat)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X3)))
    <=> pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool),aTP_Lamp_nx(nat,fun(nat,fun(product_prod(nat,nat),bool)))),Xa),X3)) ) ).

% less_eq_int.abs_eq
tff(fact_5834_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X3: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X3)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nz(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X3)) ) ).

% plus_int.abs_eq
tff(fact_5835_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X3: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X3)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_ob(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X3)) ) ).

% minus_int.abs_eq
tff(fact_5836_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [S2: set(A),Y4: A,F2: fun(A,B)] :
          ( finite_finite(A,S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),S2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,lattic7623131987881927897min_on(A,B,F2,S2))),aa(A,B,F2,Y4))) ) ) ) ) ).

% arg_min_least
tff(fact_5837_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(A,concat(A,Xs))
    <=> ( distinct(list(A),aa(list(list(A)),list(list(A)),removeAll(list(A),nil(A)),Xs))
        & ! [Ys4: list(A)] :
            ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Ys4),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
           => distinct(A,Ys4) )
        & ! [Ys4: list(A),Zs3: list(A)] :
            ( ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Ys4),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
              & pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
              & ( Ys4 != Zs3 ) )
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys4)),aa(list(A),set(A),set2(A),Zs3)) = bot_bot(set(A)) ) ) ) ) ).

% distinct_concat_iff
tff(fact_5838_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list(list(A))] :
      ( ! [X2: list(A)] :
          ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),X2),aa(list(list(A)),set(list(A)),set2(list(A)),Xss)))
         => distinct(A,X2) )
     => distinct(list(A),product_lists(A,Xss)) ) ).

% distinct_product_lists
tff(fact_5839_Gcd__remove0__nat,axiom,
    ! [M7: set(nat)] :
      ( finite_finite(nat,M7)
     => ( gcd_Gcd(nat,M7) = gcd_Gcd(nat,aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),M7),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))))) ) ) ).

% Gcd_remove0_nat
tff(fact_5840_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: list(A)] :
      ( ( aa(list(A),list(B),map(A,B,F2),A3) = nil(B) )
    <=> ( A3 = nil(A) ) ) ).

% list.map_disc_iff
tff(fact_5841_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] :
      ( ( nil(A) = aa(list(B),list(A),map(B,A,F2),Xs) )
    <=> ( Xs = nil(B) ) ) ).

% Nil_is_map_conv
tff(fact_5842_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] :
      ( ( aa(list(B),list(A),map(B,A,F2),Xs) = nil(A) )
    <=> ( Xs = nil(B) ) ) ).

% map_is_Nil_conv
tff(fact_5843_upt__conv__Nil,axiom,
    ! [J3: nat,I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),I))
     => ( upt(I,J3) = nil(nat) ) ) ).

% upt_conv_Nil
tff(fact_5844_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list(A),K: nat,X3: A] :
      ( ( list_update(A,Xs,K,X3) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% list_update_nonempty
tff(fact_5845_concat__replicate__trivial,axiom,
    ! [A: $tType,I: nat] : ( concat(A,replicate(list(A),I,nil(A))) = nil(A) ) ).

% concat_replicate_trivial
tff(fact_5846_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),nil(A)),shuffles(A,Xs,Ys2)))
    <=> ( ( Xs = nil(A) )
        & ( Ys2 = nil(A) ) ) ) ).

% Nil_in_shuffles
tff(fact_5847_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N: nat] : ( enumerate(A,N,nil(A)) = nil(product_prod(nat,A)) ) ).

% enumerate_simps(1)
tff(fact_5848_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),list(A),rotate1(A),Xs) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% rotate1_is_Nil_conv
tff(fact_5849_list__ex1__simps_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool)] : ~ list_ex1(A,P,nil(A)) ).

% list_ex1_simps(1)
tff(fact_5850_set__empty,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),set(A),set2(A),Xs) = bot_bot(set(A)) )
    <=> ( Xs = nil(A) ) ) ).

% set_empty
tff(fact_5851_set__empty2,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( bot_bot(set(A)) = aa(list(A),set(A),set2(A),Xs) )
    <=> ( Xs = nil(A) ) ) ).

% set_empty2
tff(fact_5852_length__0__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = zero_zero(nat) )
    <=> ( Xs = nil(A) ) ) ).

% length_0_conv
tff(fact_5853_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ( groups8242544230860333062m_list(A,nil(A)) = zero_zero(A) ) ) ).

% sum_list.Nil
tff(fact_5854_take0,axiom,
    ! [A: $tType,X: list(A)] : ( take(A,zero_zero(nat),X) = nil(A) ) ).

% take0
tff(fact_5855_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( take(A,N,Xs) = nil(A) )
    <=> ( ( N = zero_zero(nat) )
        | ( Xs = nil(A) ) ) ) ).

% take_eq_Nil
tff(fact_5856_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( nil(A) = take(A,N,Xs) )
    <=> ( ( N = zero_zero(nat) )
        | ( Xs = nil(A) ) ) ) ).

% take_eq_Nil2
tff(fact_5857_Gcd__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_empty
tff(fact_5858_replicate__empty,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( replicate(A,N,X3) = nil(A) )
    <=> ( N = zero_zero(nat) ) ) ).

% replicate_empty
tff(fact_5859_empty__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( nil(A) = replicate(A,N,X3) )
    <=> ( N = zero_zero(nat) ) ) ).

% empty_replicate
tff(fact_5860_upt__eq__Nil__conv,axiom,
    ! [I: nat,J3: nat] :
      ( ( upt(I,J3) = nil(nat) )
    <=> ( ( J3 = zero_zero(nat) )
        | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),I)) ) ) ).

% upt_eq_Nil_conv
tff(fact_5861_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( aa(set(A),list(A),linord4507533701916653071of_set(A),bot_bot(set(A))) = nil(A) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
tff(fact_5862_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] :
          ( ~ finite_finite(A,A2)
         => ( aa(set(A),list(A),linord4507533701916653071of_set(A),A2) = nil(A) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
tff(fact_5863_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A3: A] : ( groups4207007520872428315er_sum(B,A,F2,A3,nil(B)) = zero_zero(A) ) ) ).

% horner_sum_simps(1)
tff(fact_5864_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list(list(A))] :
      ( ( nil(A) = concat(A,Xss) )
    <=> ! [X4: list(A)] :
          ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),X4),aa(list(list(A)),set(list(A)),set2(list(A)),Xss)))
         => ( X4 = nil(A) ) ) ) ).

% Nil_eq_concat_conv
tff(fact_5865_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list(list(A))] :
      ( ( concat(A,Xss) = nil(A) )
    <=> ! [X4: list(A)] :
          ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),X4),aa(list(list(A)),set(list(A)),set2(list(A)),Xss)))
         => ( X4 = nil(A) ) ) ) ).

% concat_eq_Nil_conv
tff(fact_5866_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(list(A),nat,size_size(list(A)),Xs)))
    <=> ( Xs != nil(A) ) ) ).

% length_greater_0_conv
tff(fact_5867_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: set(A)] :
          ( finite_finite(A,A2)
         => ( ( aa(set(A),list(A),linord4507533701916653071of_set(A),A2) = nil(A) )
          <=> ( A2 = bot_bot(set(A)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
tff(fact_5868_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: set(A)] :
          ( ( gcd_Gcd(A,A2) = zero_zero(A) )
        <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),insert2(A,zero_zero(A)),bot_bot(set(A))))) ) ) ).

% Gcd_0_iff
tff(fact_5869_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( Xs = nil(A) )
     => ( ( Ys2 = nil(A) )
       => pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),nil(A)),shuffles(A,Xs,Ys2))) ) ) ).

% Nil_in_shufflesI
tff(fact_5870_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : distinct(A,nil(A)) ).

% distinct.simps(1)
tff(fact_5871_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys2: list(A)] : ( shuffles(A,nil(A),Ys2) = aa(set(list(A)),set(list(A)),insert2(list(A),Ys2),bot_bot(set(list(A)))) ) ).

% shuffles.simps(1)
tff(fact_5872_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] : ( shuffles(A,Xs,nil(A)) = aa(set(list(A)),set(list(A)),insert2(list(A),Xs),bot_bot(set(list(A)))) ) ).

% shuffles.simps(2)
tff(fact_5873_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X3: A] : ( aa(list(A),list(A),removeAll(A,X3),nil(A)) = nil(A) ) ).

% removeAll.simps(1)
tff(fact_5874_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] : ( aa(list(A),list(A),rotate1(A),nil(A)) = nil(A) ) ).

% rotate1.simps(1)
tff(fact_5875_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B)] : ( aa(list(A),list(B),map(A,B,F2),nil(A)) = nil(B) ) ).

% list.simps(8)
tff(fact_5876_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I: nat,V: A] : ( list_update(A,nil(A),I,V) = nil(A) ) ).

% list_update.simps(1)
tff(fact_5877_list__update__code_I1_J,axiom,
    ! [A: $tType,I: nat,Y4: A] : ( list_update(A,nil(A),I,Y4) = nil(A) ) ).

% list_update_code(1)
tff(fact_5878_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool))] : sorted_wrt(A,P,nil(A)) ).

% sorted_wrt.simps(1)
tff(fact_5879_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu: list(B)] : ( product(A,B,nil(A),Uu) = nil(product_prod(A,B)) ) ).

% product.simps(1)
tff(fact_5880_concat_Osimps_I1_J,axiom,
    ! [A: $tType] : ( concat(A,nil(list(A))) = nil(A) ) ).

% concat.simps(1)
tff(fact_5881_take__Nil,axiom,
    ! [A: $tType,N: nat] : ( take(A,N,nil(A)) = nil(A) ) ).

% take_Nil
tff(fact_5882_member__rec_I2_J,axiom,
    ! [A: $tType,Y4: A] : ~ member(A,nil(A),Y4) ).

% member_rec(2)
tff(fact_5883_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X3: A] : ( remove1(A,X3,nil(A)) = nil(A) ) ).

% remove1.simps(1)
tff(fact_5884_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),A3: B,Xs: list(B)] : ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),A3),Xs) != nil(B) ) ) ).

% insort_not_Nil
tff(fact_5885_empty__set,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(list(A),set(A),set2(A),nil(A)) ) ).

% empty_set
tff(fact_5886_list_Osize_I3_J,axiom,
    ! [A: $tType] : ( aa(list(A),nat,size_size(list(A)),nil(A)) = zero_zero(nat) ) ).

% list.size(3)
tff(fact_5887_sorted0,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => sorted_wrt(A,ord_less_eq(A),nil(A)) ) ).

% sorted0
tff(fact_5888_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => sorted_wrt(A,ord_less(A),nil(A)) ) ).

% strict_sorted_simps(1)
tff(fact_5889_take__0,axiom,
    ! [A: $tType,Xs: list(A)] : ( take(A,zero_zero(nat),Xs) = nil(A) ) ).

% take_0
tff(fact_5890_replicate__0,axiom,
    ! [A: $tType,X3: A] : ( replicate(A,zero_zero(nat),X3) = nil(A) ) ).

% replicate_0
tff(fact_5891_upt__0,axiom,
    ! [I: nat] : ( upt(I,zero_zero(nat)) = nil(nat) ) ).

% upt_0
tff(fact_5892_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X3: fun(A,nat)] : ( aa(list(A),nat,size_list(A,X3),nil(A)) = zero_zero(nat) ) ).

% list.size_gen(1)
tff(fact_5893_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y4: A] : ( aa(A,nat,count_list(A,nil(A)),Y4) = zero_zero(nat) ) ).

% count_list.simps(1)
tff(fact_5894_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),bot_bot(set(B))) = nil(B) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
tff(fact_5895_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add(B)
        & strict9044650504122735259up_add(B) )
     => ! [Xs: list(A),F2: fun(A,B),G: fun(A,B)] :
          ( ( Xs != nil(A) )
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X2)),aa(A,B,G,X2))) )
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F2),Xs))),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,G),Xs)))) ) ) ) ).

% sum_list_strict_mono
tff(fact_5896_Pow__set_I1_J,axiom,
    ! [A: $tType] : ( pow2(A,aa(list(A),set(A),set2(A),nil(A))) = aa(set(set(A)),set(set(A)),insert2(set(A),bot_bot(set(A))),bot_bot(set(set(A)))) ) ).

% Pow_set(1)
tff(fact_5897_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A),A2: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),S2))
       => ( finite_finite(B,A2)
         => ( ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F2),A2) = nil(B) )
          <=> ( A2 = bot_bot(set(B)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
tff(fact_5898_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list(A),Xss: list(list(A))] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Xs),aa(list(list(A)),set(list(A)),set2(list(A)),product_lists(A,Xss))))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Xss) ) ) ).

% in_set_product_lists_length
tff(fact_5899_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list(list(A)),N: nat] :
      ( ( ( Xs = nil(list(A)) )
       => ( N = zero_zero(nat) ) )
     => ( ! [I3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(list(A)),nat,size_size(list(list(A))),Xs)))
           => ( aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I3)) = N ) )
       => ( transpose(A,Xs) = aa(list(nat),list(list(A)),map(nat,list(A),aTP_Lamp_od(list(list(A)),fun(nat,list(A)),Xs)),upt(zero_zero(nat),N)) ) ) ) ).

% transpose_rectangle
tff(fact_5900_length__product__lists,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( aa(list(list(B)),nat,size_size(list(list(B))),product_lists(B,Xss)) = aa(nat,nat,foldr(nat,nat,times_times(nat),aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xss)),one_one(nat)) ) ).

% length_product_lists
tff(fact_5901_less__eq__int_Orep__eq,axiom,
    ! [X3: int,Xa: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),Xa))
    <=> pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool),aTP_Lamp_nx(nat,fun(nat,fun(product_prod(nat,nat),bool)))),aa(int,product_prod(nat,nat),rep_Integ,X3)),aa(int,product_prod(nat,nat),rep_Integ,Xa))) ) ).

% less_eq_int.rep_eq
tff(fact_5902_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,fun(A,A)),N: nat,X3: B] : ( foldr(B,A,F2,replicate(B,N,X3)) = aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),aa(B,fun(A,A),F2,X3)) ) ).

% foldr_replicate
tff(fact_5903_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] : ( transpose(A,nil(list(A))) = nil(list(A)) ) ).

% transpose.simps(1)
tff(fact_5904_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: A,L: list(B),K: list(B),F2: fun(B,fun(A,A)),G: fun(B,fun(A,A))] :
      ( ( A3 = B2 )
     => ( ( L = K )
       => ( ! [A5: A,X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(list(B),set(B),set2(B),L)))
             => ( aa(A,A,aa(B,fun(A,A),F2,X2),A5) = aa(A,A,aa(B,fun(A,A),G,X2),A5) ) )
         => ( aa(A,A,foldr(B,A,F2,L),A3) = aa(A,A,foldr(B,A,G,K),B2) ) ) ) ) ).

% foldr_cong
tff(fact_5905_Gcd__int__greater__eq__0,axiom,
    ! [K5: set(int)] : pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),gcd_Gcd(int,K5))) ).

% Gcd_int_greater_eq_0
tff(fact_5906_transpose__empty,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( ( transpose(A,Xs) = nil(list(A)) )
    <=> ! [X4: list(A)] :
          ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),X4),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
         => ( X4 = nil(A) ) ) ) ).

% transpose_empty
tff(fact_5907_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: fun(B,fun(A,A)),F2: fun(C,B),Xs: list(C),A3: A] : ( aa(A,A,foldr(B,A,G,aa(list(C),list(B),map(C,B,F2),Xs)),A3) = aa(A,A,foldr(C,A,aa(fun(C,B),fun(C,fun(A,A)),comp(B,fun(A,A),C,G),F2),Xs),A3) ) ).

% foldr_map
tff(fact_5908_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(list(B))] : ( transpose(A,aa(list(list(B)),list(list(A)),map(list(B),list(A),map(B,A,F2)),Xs)) = aa(list(list(B)),list(list(A)),map(list(B),list(A),map(B,A,F2)),transpose(B,Xs)) ) ).

% transpose_map_map
tff(fact_5909_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A)] : ( groups8242544230860333062m_list(A,Xs) = aa(A,A,foldr(A,A,plus_plus(A),Xs),zero_zero(A)) ) ) ).

% sum_list.eq_foldr
tff(fact_5910_nat_Orep__eq,axiom,
    ! [X3: int] : ( aa(int,nat,nat2,X3) = aa(product_prod(nat,nat),nat,product_case_prod(nat,nat,nat,minus_minus(nat)),aa(int,product_prod(nat,nat),rep_Integ,X3)) ) ).

% nat.rep_eq
tff(fact_5911_horner__sum__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A3: A,Xs: list(B)] : ( groups4207007520872428315er_sum(B,A,F2,A3,Xs) = aa(A,A,foldr(B,A,aa(A,fun(B,fun(A,A)),aTP_Lamp_oe(fun(B,A),fun(A,fun(B,fun(A,A))),F2),A3),Xs),zero_zero(A)) ) ) ).

% horner_sum_foldr
tff(fact_5912_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: int] : ( aa(int,A,ring_1_of_int(A),X3) = aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_nt(nat,fun(nat,A))),aa(int,product_prod(nat,nat),rep_Integ,X3)) ) ) ).

% of_int.rep_eq
tff(fact_5913_less__int_Orep__eq,axiom,
    ! [X3: int,Xa: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X3),Xa))
    <=> pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool),aTP_Lamp_nv(nat,fun(nat,fun(product_prod(nat,nat),bool)))),aa(int,product_prod(nat,nat),rep_Integ,X3)),aa(int,product_prod(nat,nat),rep_Integ,Xa))) ) ).

% less_int.rep_eq
tff(fact_5914_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( ( ( Xs = nil(list(A)) )
         => ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)) = zero_zero(nat) ) )
        & ( ( Xs != nil(list(A)) )
         => ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)) = aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),zero_zero(nat))) ) ) ) ) ).

% length_transpose_sorted
tff(fact_5915_listset_Osimps_I1_J,axiom,
    ! [A: $tType] : ( listset(A,nil(set(A))) = aa(set(list(A)),set(list(A)),insert2(list(A),nil(A)),bot_bot(set(list(A)))) ) ).

% listset.simps(1)
tff(fact_5916_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),nil(A))))
     => ( shuffles(A,Xs,nil(A)) = aa(set(list(A)),set(list(A)),insert2(list(A),Xs),bot_bot(set(list(A)))) ) ) ).

% shuffles.psimps(2)
tff(fact_5917_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),list(A),rev(A),aa(list(A),list(A),rev(A),Xs)) = Xs ) ).

% rev_rev_ident
tff(fact_5918_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(list(A),list(A),rev(A),Xs) = aa(list(A),list(A),rev(A),Ys2) )
    <=> ( Xs = Ys2 ) ) ).

% rev_is_rev_conv
tff(fact_5919_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( nil(A) = aa(list(A),list(A),rev(A),Xs) )
    <=> ( Xs = nil(A) ) ) ).

% Nil_is_rev_conv
tff(fact_5920_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),list(A),rev(A),Xs) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% rev_is_Nil_conv
tff(fact_5921_set__rev,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% set_rev
tff(fact_5922_length__rev,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_rev
tff(fact_5923_distinct__rev,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,aa(list(A),list(A),rev(A),Xs))
    <=> distinct(A,Xs) ) ).

% distinct_rev
tff(fact_5924_rev__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] : ( aa(list(A),list(A),rev(A),replicate(A,N,X3)) = replicate(A,N,X3) ) ).

% rev_replicate
tff(fact_5925_rev_Osimps_I1_J,axiom,
    ! [A: $tType] : ( aa(list(A),list(A),rev(A),nil(A)) = nil(A) ) ).

% rev.simps(1)
tff(fact_5926_rev__map,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( aa(list(A),list(A),rev(A),aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),rev(B),Xs)) ) ).

% rev_map
tff(fact_5927_rev__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(A),list(A),rev(A),concat(A,Xs)) = concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),rev(A)),aa(list(list(A)),list(list(A)),rev(list(A)),Xs))) ) ).

% rev_concat
tff(fact_5928_sorted__wrt__rev,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),Xs: list(A)] :
      ( sorted_wrt(A,P,aa(list(A),list(A),rev(A),Xs))
    <=> sorted_wrt(A,aTP_Lamp_of(fun(A,fun(A,bool)),fun(A,fun(A,bool)),P),Xs) ) ).

% sorted_wrt_rev
tff(fact_5929_rev__swap,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(list(A),list(A),rev(A),Xs) = Ys2 )
    <=> ( Xs = aa(list(A),list(A),rev(A),Ys2) ) ) ).

% rev_swap
tff(fact_5930_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),rev(A),Xs)),N) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,nat,suc,N))) ) ) ).

% rev_nth
tff(fact_5931_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list(A),Y4: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(list(A),list(A),rev(A),list_update(A,Xs,K,Y4)) = list_update(A,aa(list(A),list(A),rev(A),Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),K)),one_one(nat)),Y4) ) ) ).

% rev_update
tff(fact_5932_sorted__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),transpose(A,Xs)))) ).

% sorted_transpose
tff(fact_5933_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),Xs))
        <=> ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,I2)),aa(list(A),nat,size_size(list(A)),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I2))),aa(nat,A,nth(A,Xs),I2))) ) ) ) ).

% sorted_rev_iff_nth_Suc
tff(fact_5934_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),Xs))
        <=> ! [I2: nat,J4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I2),J4))
             => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Xs),J4)),aa(nat,A,nth(A,Xs),I2))) ) ) ) ) ).

% sorted_rev_iff_nth_mono
tff(fact_5935_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I: nat,J3: nat] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),Xs))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Xs),J3)),aa(nat,A,nth(A,Xs),I))) ) ) ) ) ).

% sorted_rev_nth_mono
tff(fact_5936_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Y4: A] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),Xs))
         => ( ( ( Xs = nil(A) )
             => ( aa(A,A,foldr(A,A,ord_max(A),Xs),Y4) = Y4 ) )
            & ( ( Xs != nil(A) )
             => ( aa(A,A,foldr(A,A,ord_max(A),Xs),Y4) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(nat,A,nth(A,Xs),zero_zero(nat))),Y4) ) ) ) ) ) ).

% foldr_max_sorted
tff(fact_5937_length__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)) = aa(nat,nat,foldr(list(A),nat,aTP_Lamp_og(list(A),fun(nat,nat)),Xs),zero_zero(nat)) ) ).

% length_transpose
tff(fact_5938_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys2: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Ys2)))
     => ( shuffles(A,nil(A),Ys2) = aa(set(list(A)),set(list(A)),insert2(list(A),Ys2),bot_bot(set(list(A)))) ) ) ).

% shuffles.psimps(1)
tff(fact_5939_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A)),I: nat,J3: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs))))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_oh(nat,fun(list(A),bool),I)),Xs))))
         => ( aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),transpose(A,Xs)),I)),J3) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Xs),J3)),I) ) ) ) ) ).

% nth_nth_transpose_sorted
tff(fact_5940_transpose__column,axiom,
    ! [A: $tType,Xs: list(list(A)),I: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(list(A)),nat,size_size(list(list(A))),Xs)))
       => ( aa(list(list(A)),list(A),map(list(A),A,aTP_Lamp_oi(nat,fun(list(A),A),I)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_oh(nat,fun(list(A),bool),I)),transpose(A,Xs))) = aa(nat,list(A),nth(list(A),Xs),I) ) ) ) ).

% transpose_column
tff(fact_5941_transpose__column__length,axiom,
    ! [A: $tType,Xs: list(list(A)),I: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(list(A)),nat,size_size(list(list(A))),Xs)))
       => ( aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_oh(nat,fun(list(A),bool),I)),transpose(A,Xs))) = aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I)) ) ) ) ).

% transpose_column_length
tff(fact_5942_filter__filter,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),Xs: list(A)] : ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),filter2(A,Q),Xs)) = aa(list(A),list(A),filter2(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_oj(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)),Xs) ) ).

% filter_filter
tff(fact_5943_filter__True,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X2)) )
     => ( aa(list(A),list(A),filter2(A,P),Xs) = Xs ) ) ).

% filter_True
tff(fact_5944_remove1__filter__not,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A)] :
      ( ~ pp(aa(A,bool,P,X3))
     => ( remove1(A,X3,aa(list(A),list(A),filter2(A,P),Xs)) = aa(list(A),list(A),filter2(A,P),Xs) ) ) ).

% remove1_filter_not
tff(fact_5945_removeAll__filter__not,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A)] :
      ( ~ pp(aa(A,bool,P,X3))
     => ( aa(list(A),list(A),removeAll(A,X3),aa(list(A),list(A),filter2(A,P),Xs)) = aa(list(A),list(A),filter2(A,P),Xs) ) ) ).

% removeAll_filter_not
tff(fact_5946_set__filter,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,P),Xs)) = collect(A,aa(list(A),fun(A,bool),aTP_Lamp_ok(fun(A,bool),fun(list(A),fun(A,bool)),P),Xs)) ) ).

% set_filter
tff(fact_5947_filter__False,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => ~ pp(aa(A,bool,P,X2)) )
     => ( aa(list(A),list(A),filter2(A,P),Xs) = nil(A) ) ) ).

% filter_False
tff(fact_5948_length__concat__rev,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),concat(A,aa(list(list(A)),list(list(A)),rev(list(A)),Xs))) = aa(list(A),nat,size_size(list(A)),concat(A,Xs)) ) ).

% length_concat_rev
tff(fact_5949_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F2: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),aa(list(B),list(A),map(B,A,F2),Xs))) = aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,aa(fun(B,A),fun(B,bool),comp(A,bool,B,P),F2)),Xs)) ) ).

% length_filter_map
tff(fact_5950_filter__empty__conv,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( aa(list(A),list(A),filter2(A,P),Xs) = nil(A) )
    <=> ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
         => ~ pp(aa(A,bool,P,X4)) ) ) ).

% filter_empty_conv
tff(fact_5951_empty__filter__conv,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( nil(A) = aa(list(A),list(A),filter2(A,P),Xs) )
    <=> ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
         => ~ pp(aa(A,bool,P,X4)) ) ) ).

% empty_filter_conv
tff(fact_5952_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( aa(list(A),list(A),filter2(A,P),nil(A)) = nil(A) ) ).

% filter.simps(1)
tff(fact_5953_filter__replicate,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,N: nat] :
      ( ( pp(aa(A,bool,P,X3))
       => ( aa(list(A),list(A),filter2(A,P),replicate(A,N,X3)) = replicate(A,N,X3) ) )
      & ( ~ pp(aa(A,bool,P,X3))
       => ( aa(list(A),list(A),filter2(A,P),replicate(A,N,X3)) = nil(A) ) ) ) ).

% filter_replicate
tff(fact_5954_filter__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F2: fun(B,A),Xs: list(B)] : ( aa(list(A),list(A),filter2(A,P),aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,aa(fun(B,A),fun(B,bool),comp(A,bool,B,P),F2)),Xs)) ) ).

% filter_map
tff(fact_5955_rev__filter,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(list(A),list(A),rev(A),aa(list(A),list(A),filter2(A,P),Xs)) = aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),rev(A),Xs)) ) ).

% rev_filter
tff(fact_5956_removeAll__filter__not__eq,axiom,
    ! [A: $tType,X3: A] : ( removeAll(A,X3) = filter2(A,aTP_Lamp_ol(A,fun(A,bool),X3)) ) ).

% removeAll_filter_not_eq
tff(fact_5957_sum__length__filter__compl,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aTP_Lamp_df(fun(A,bool),fun(A,bool),P)),Xs))) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% sum_length_filter_compl
tff(fact_5958_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [P: fun(B,bool),X3: B,F2: fun(B,A),Xs: list(B)] :
          ( ~ pp(aa(B,bool,P,X3))
         => ( aa(list(B),list(B),filter2(B,P),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs)) = aa(list(B),list(B),filter2(B,P),Xs) ) ) ) ).

% filter_insort_triv
tff(fact_5959_filter__remove1,axiom,
    ! [A: $tType,Q: fun(A,bool),X3: A,Xs: list(A)] : ( aa(list(A),list(A),filter2(A,Q),remove1(A,X3,Xs)) = remove1(A,X3,aa(list(A),list(A),filter2(A,Q),Xs)) ) ).

% filter_remove1
tff(fact_5960_sorted__wrt__filter,axiom,
    ! [A: $tType,F2: fun(A,fun(A,bool)),Xs: list(A),P: fun(A,bool)] :
      ( sorted_wrt(A,F2,Xs)
     => sorted_wrt(A,F2,aa(list(A),list(A),filter2(A,P),Xs)) ) ).

% sorted_wrt_filter
tff(fact_5961_filter__id__conv,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( aa(list(A),list(A),filter2(A,P),Xs) = Xs )
    <=> ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X4)) ) ) ).

% filter_id_conv
tff(fact_5962_filter__cong,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Ys2)))
           => ( pp(aa(A,bool,P,X2))
            <=> pp(aa(A,bool,Q,X2)) ) )
       => ( aa(list(A),list(A),filter2(A,P),Xs) = aa(list(A),list(A),filter2(A,Q),Ys2) ) ) ) ).

% filter_cong
tff(fact_5963_filter__is__subset,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),set(A),set2(A),Xs))) ).

% filter_is_subset
tff(fact_5964_length__filter__le,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ).

% length_filter_le
tff(fact_5965_sorted__same,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [G: fun(list(A),A),Xs: list(A)] : sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),filter2(A,aa(list(A),fun(A,bool),aTP_Lamp_om(fun(list(A),A),fun(list(A),fun(A,bool)),G),Xs)),Xs)) ) ).

% sorted_same
tff(fact_5966_inter__set__filter,axiom,
    ! [A: $tType,A2: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,aTP_Lamp_a(set(A),fun(A,bool),A2)),Xs)) ) ).

% inter_set_filter
tff(fact_5967_distinct__filter,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( distinct(A,Xs)
     => distinct(A,aa(list(A),list(A),filter2(A,P),Xs)) ) ).

% distinct_filter
tff(fact_5968_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] : pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Xs),shuffles(A,aa(list(A),list(A),filter2(A,P),Xs),aa(list(A),list(A),filter2(A,aTP_Lamp_df(fun(A,bool),fun(A,bool),P)),Xs)))) ).

% partition_in_shuffles
tff(fact_5969_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B),P: fun(B,bool)] :
      ( distinct(A,aa(list(B),list(A),map(B,A,F2),Xs))
     => distinct(A,aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,P),Xs))) ) ).

% distinct_map_filter
tff(fact_5970_filter__concat,axiom,
    ! [A: $tType,P2: fun(A,bool),Xs: list(list(A))] : ( aa(list(A),list(A),filter2(A,P2),concat(A,Xs)) = concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),filter2(A,P2)),Xs)) ) ).

% filter_concat
tff(fact_5971_replicate__length__filter,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( replicate(A,aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),X3)),Xs)),X3) = aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),X3)),Xs) ) ).

% replicate_length_filter
tff(fact_5972_length__filter__less,axiom,
    ! [A: $tType,X3: A,Xs: list(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( ~ pp(aa(A,bool,P,X3))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% length_filter_less
tff(fact_5973_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B),P: fun(B,bool)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs))
         => sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,P),Xs))) ) ) ).

% sorted_filter
tff(fact_5974_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),G: fun(list(B),A),Xs: list(B)] : sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,aa(list(B),fun(B,bool),aa(fun(list(B),A),fun(list(B),fun(B,bool)),aTP_Lamp_on(fun(B,A),fun(fun(list(B),A),fun(list(B),fun(B,bool))),F2),G),Xs)),Xs))) ) ).

% sorted_map_same
tff(fact_5975_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( monoid_add(A)
     => ! [F2: fun(B,A),P: fun(B,bool),Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,P),Xs))) = groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_oo(fun(B,A),fun(fun(B,bool),fun(B,A)),F2),P)),Xs)) ) ) ).

% sum_list_map_filter'
tff(fact_5976_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: fun(A,nat),P: fun(A,bool),Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F2),aa(list(A),list(A),filter2(A,P),Xs)))),groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F2),Xs)))) ).

% sum_list_filter_le_nat
tff(fact_5977_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(B),P: fun(B,bool),F2: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(list(B),set(B),set2(B),Xs)))
             => ( ~ pp(aa(B,bool,P,X2))
               => ( aa(B,A,F2,X2) = zero_zero(A) ) ) )
         => ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,P),Xs))) = groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F2),Xs)) ) ) ) ).

% sum_list_map_filter
tff(fact_5978_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B),P: fun(B,bool),X3: B] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs))
         => ( pp(aa(B,bool,P,X3))
           => ( aa(list(B),list(B),filter2(B,P),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),aa(list(B),list(B),filter2(B,P),Xs)) ) ) ) ) ).

% filter_insort
tff(fact_5979_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list(A),Y4: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,Y4),bot_bot(set(A)))) = aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,aTP_Lamp_op(A,fun(A,bool),Y4)),Xs)) ) ).

% set_minus_filter_out
tff(fact_5980_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) = bot_bot(set(A)) )
     => ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_oq(list(A),fun(A,bool),Xs)),Zs) = Ys2 ) ) ) ).

% filter_shuffles_disjoint1(2)
tff(fact_5981_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) = bot_bot(set(A)) )
     => ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_or(list(A),fun(A,bool),Xs)),Zs) = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
tff(fact_5982_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) = bot_bot(set(A)) )
     => ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_oq(list(A),fun(A,bool),Ys2)),Zs) = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
tff(fact_5983_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) = bot_bot(set(A)) )
     => ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_or(list(A),fun(A,bool),Ys2)),Zs) = Ys2 ) ) ) ).

% filter_shuffles_disjoint2(1)
tff(fact_5984_length__filter__conv__card,axiom,
    ! [A: $tType,P2: fun(A,bool),Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P2),Xs)) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(list(A),fun(nat,bool),aTP_Lamp_os(fun(A,bool),fun(list(A),fun(nat,bool)),P2),Xs))) ) ).

% length_filter_conv_card
tff(fact_5985_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( distinct(A,Xs)
     => ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs)) = aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),collect(A,P)),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% distinct_length_filter
tff(fact_5986_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Xss: list(list(B))] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs))),aa(nat,nat,foldr(list(B),nat,aTP_Lamp_ot(list(B),fun(nat,nat)),Xss),zero_zero(nat))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,nat,foldr(list(B),nat,aTP_Lamp_ou(list(B),fun(nat,nat)),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_ov(list(B),bool)),Xss)),zero_zero(nat)))) ) ).

% transpose_aux_max
tff(fact_5987_transpose__max__length,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(nat,nat,foldr(list(A),nat,aTP_Lamp_og(list(A),fun(nat,nat)),transpose(A,Xs)),zero_zero(nat)) = aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_ow(list(A),bool)),Xs)) ) ).

% transpose_max_length
tff(fact_5988_nth__transpose,axiom,
    ! [A: $tType,I: nat,Xs: list(list(A))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs))))
     => ( aa(nat,list(A),nth(list(A),transpose(A,Xs)),I) = aa(list(list(A)),list(A),map(list(A),A,aTP_Lamp_oi(nat,fun(list(A),A),I)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_oh(nat,fun(list(A),bool),I)),Xs)) ) ) ).

% nth_transpose
tff(fact_5989_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),P: fun(B,bool),Xs: list(B)] : ( aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,P),Xs)) = map_filter(B,A,aa(fun(B,bool),fun(B,option(A)),aTP_Lamp_ox(fun(B,A),fun(fun(B,bool),fun(B,option(A))),F2),P),Xs) ) ).

% map_filter_map_filter
tff(fact_5990_transpose__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( transpose(A,transpose(A,Xs)) = takeWhile(list(A),aTP_Lamp_ow(list(A),bool),Xs) ) ) ).

% transpose_transpose
tff(fact_5991_lex__take__index,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),lex(A,R2)))
     => ~ ! [I3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs)))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Ys2)))
             => ( ( take(A,I3,Xs) = take(A,I3,Ys2) )
               => ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,nth(A,Xs),I3)),aa(nat,A,nth(A,Ys2),I3))),R2)) ) ) ) ) ).

% lex_take_index
tff(fact_5992_takeWhile__idem,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( takeWhile(A,P,takeWhile(A,P,Xs)) = takeWhile(A,P,Xs) ) ).

% takeWhile_idem
tff(fact_5993_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( takeWhile(A,P,Xs) = Xs )
    <=> ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X4)) ) ) ).

% takeWhile_eq_all_conv
tff(fact_5994_takeWhile__replicate,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,N: nat] :
      ( ( pp(aa(A,bool,P,X3))
       => ( takeWhile(A,P,replicate(A,N,X3)) = replicate(A,N,X3) ) )
      & ( ~ pp(aa(A,bool,P,X3))
       => ( takeWhile(A,P,replicate(A,N,X3)) = nil(A) ) ) ) ).

% takeWhile_replicate
tff(fact_5995_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,bool)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),takeWhile(A,P,Xs)) ) ) ).

% sorted_takeWhile
tff(fact_5996_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( distinct(A,Xs)
     => distinct(A,takeWhile(A,P,Xs)) ) ).

% distinct_takeWhile
tff(fact_5997_length__takeWhile__le,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ).

% length_takeWhile_le
tff(fact_5998_set__takeWhileD,axiom,
    ! [A: $tType,X3: A,P: fun(A,bool),Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),takeWhile(A,P,Xs))))
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
        & pp(aa(A,bool,P,X3)) ) ) ).

% set_takeWhileD
tff(fact_5999_takeWhile__cong,axiom,
    ! [A: $tType,L: list(A),K: list(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( ( L = K )
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),L)))
           => ( pp(aa(A,bool,P,X2))
            <=> pp(aa(A,bool,Q,X2)) ) )
       => ( takeWhile(A,P,L) = takeWhile(A,Q,K) ) ) ) ).

% takeWhile_cong
tff(fact_6000_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( takeWhile(A,P,nil(A)) = nil(A) ) ).

% takeWhile.simps(1)
tff(fact_6001_takeWhile__eq__take,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( takeWhile(A,P,Xs) = take(A,aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)),Xs) ) ).

% takeWhile_eq_take
tff(fact_6002_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F2: fun(B,A),Xs: list(B)] : ( takeWhile(A,P,aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),list(A),map(B,A,F2),takeWhile(B,aa(fun(B,A),fun(B,bool),comp(A,bool,B,P),F2),Xs)) ) ).

% takeWhile_map
tff(fact_6003_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,option(A))] : ( map_filter(B,A,F2,nil(B)) = nil(A) ) ).

% map_filter_simps(2)
tff(fact_6004_Nil__notin__lex,axiom,
    ! [A: $tType,Ys2: list(A),R2: set(product_prod(A,A))] : ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Ys2)),lex(A,R2))) ).

% Nil_notin_lex
tff(fact_6005_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list(A),R2: set(product_prod(A,A))] : ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),nil(A))),lex(A,R2))) ).

% Nil2_notin_lex
tff(fact_6006_nth__length__takeWhile,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)))
     => ~ pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))))) ) ).

% nth_length_takeWhile
tff(fact_6007_takeWhile__nth,axiom,
    ! [A: $tType,J3: nat,P: fun(A,bool),Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))))
     => ( aa(nat,A,nth(A,takeWhile(A,P,Xs)),J3) = aa(nat,A,nth(A,Xs),J3) ) ) ).

% takeWhile_nth
tff(fact_6008_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J3: nat,P: fun(A,bool),Xs: list(A)] :
      ( ! [I3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),J3))
         => pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),I3))) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),aa(list(A),nat,size_size(list(A)),Xs)))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J3),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))) ) ) ).

% length_takeWhile_less_P_nth
tff(fact_6009_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N: nat,Xs: list(A),P: fun(A,bool)] :
      ( ! [I3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),N))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs)))
           => pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),I3))) ) )
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
         => ~ pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),N))) )
       => ( takeWhile(A,P,Xs) = take(A,N,Xs) ) ) ) ).

% takeWhile_eq_take_P_nth
tff(fact_6010_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B),T2: A] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),aa(list(B),list(A),map(B,A,F2),Xs)))
         => ( aa(list(B),list(B),filter2(B,aa(A,fun(B,bool),aTP_Lamp_oy(fun(B,A),fun(A,fun(B,bool)),F2),T2)),Xs) = takeWhile(B,aa(A,fun(B,bool),aTP_Lamp_oy(fun(B,A),fun(A,fun(B,bool)),F2),T2),Xs) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
tff(fact_6011_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [A3: B,Xs: list(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),A3),aa(list(B),set(B),set2(B),Xs)))
         => ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs))
           => ( ( aa(list(B),B,hd(B),aa(list(B),list(B),filter2(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_oz(B,fun(fun(B,A),fun(B,bool)),A3),F2)),Xs)) = A3 )
             => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),A3),remove1(B,A3,Xs)) = Xs ) ) ) ) ) ).

% insort_key_remove1
tff(fact_6012_semiring__char__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: itself(A)] : ( semiri4206861660011772517g_char(A,Uu) = gcd_Gcd(nat,collect(nat,aTP_Lamp_pa(nat,bool))) ) ) ).

% semiring_char_def
tff(fact_6013_hd__upt,axiom,
    ! [I: nat,J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ( aa(list(nat),nat,hd(nat),upt(I,J3)) = I ) ) ).

% hd_upt
tff(fact_6014_hd__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( N != zero_zero(nat) )
     => ( aa(list(A),A,hd(A),replicate(A,N,X3)) = X3 ) ) ).

% hd_replicate
tff(fact_6015_hd__take,axiom,
    ! [A: $tType,J3: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),J3))
     => ( aa(list(A),A,hd(A),take(A,J3,Xs)) = aa(list(A),A,hd(A),Xs) ) ) ).

% hd_take
tff(fact_6016_hd__in__set,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(list(A),A,hd(A),Xs)),aa(list(A),set(A),set2(A),Xs))) ) ).

% hd_in_set
tff(fact_6017_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A3: list(A)] :
      ( ( A3 != nil(A) )
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(list(A),A,hd(A),A3)),aa(list(A),set(A),set2(A),A3))) ) ).

% list.set_sel(1)
tff(fact_6018_hd__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( ( Xs != nil(list(A)) )
     => ( ( aa(list(list(A)),list(A),hd(list(A)),Xs) != nil(A) )
       => ( aa(list(A),A,hd(A),concat(A,Xs)) = aa(list(A),A,hd(A),aa(list(list(A)),list(A),hd(list(A)),Xs)) ) ) ) ).

% hd_concat
tff(fact_6019_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F2: fun(A,B)] :
      ( ( Xs != nil(A) )
     => ( aa(list(B),B,hd(B),aa(list(A),list(B),map(A,B,F2),Xs)) = aa(A,B,F2,aa(list(A),A,hd(A),Xs)) ) ) ).

% hd_map
tff(fact_6020_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A3: list(A),F2: fun(A,B)] :
      ( ( A3 != nil(A) )
     => ( aa(list(B),B,hd(B),aa(list(A),list(B),map(A,B,F2),A3)) = aa(A,B,F2,aa(list(A),A,hd(A),A3)) ) ) ).

% list.map_sel(1)
tff(fact_6021_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( takeWhile(A,P,Xs) = nil(A) )
    <=> ( ( Xs = nil(A) )
        | ~ pp(aa(A,bool,P,aa(list(A),A,hd(A),Xs))) ) ) ).

% takeWhile_eq_Nil_iff
tff(fact_6022_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),A,hd(A),Xs) = aa(nat,A,nth(A,Xs),zero_zero(nat)) ) ) ).

% hd_conv_nth
tff(fact_6023_uminus__int__def,axiom,
    uminus_uminus(int) = aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_ns(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int_def
tff(fact_6024_prod__encode__def,axiom,
    nat_prod_encode = product_case_prod(nat,nat,nat,aTP_Lamp_pb(nat,fun(nat,nat))) ).

% prod_encode_def
tff(fact_6025_le__prod__encode__1,axiom,
    ! [A3: nat,B2: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A3),B2)))) ).

% le_prod_encode_1
tff(fact_6026_le__prod__encode__2,axiom,
    ! [B2: nat,A3: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),B2),aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A3),B2)))) ).

% le_prod_encode_2
tff(fact_6027_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M: nat] : ( aa(product_prod(nat,nat),nat,nat_prod_encode,nat_prod_decode_aux(K,M)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(K)),M) ) ).

% prod_encode_prod_decode_aux
tff(fact_6028_times__int__def,axiom,
    times_times(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int_def
tff(fact_6029_minus__int__def,axiom,
    minus_minus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_ob(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int_def
tff(fact_6030_plus__int__def,axiom,
    plus_plus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nz(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int_def
tff(fact_6031_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),L),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(set(nat),set(A),image(nat,A,nth(A,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),L)) = aa(list(A),set(A),set2(A),take(A,L,Xs)) ) ) ).

% nth_image
tff(fact_6032_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2)))
    <=> ? [Y: A,N3: nat] :
          ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,nth(A,Xs),N3)),Y)),R2))
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N3),aa(list(A),nat,size_size(list(A)),Xs)))
          & ( Ys2 = list_update(A,Xs,N3,Y) ) ) ) ).

% listrel1_iff_update
tff(fact_6033_bij__betw__Suc,axiom,
    ! [M7: set(nat),N5: set(nat)] :
      ( bij_betw(nat,nat,suc,M7,N5)
    <=> ( aa(set(nat),set(nat),image(nat,nat,suc),M7) = N5 ) ) ).

% bij_betw_Suc
tff(fact_6034_image__add__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A))),S2) = S2 ) ) ).

% image_add_0
tff(fact_6035_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A,J3: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),K)),set_or1337092689740270186AtMost(A,I,J3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),K)) ) ) ).

% image_add_atLeastAtMost
tff(fact_6036_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A,J3: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),K)),set_or7035219750837199246ssThan(A,I,J3)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),K)) ) ) ).

% image_add_atLeastLessThan
tff(fact_6037_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [C2: A,A3: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),C2)),set_ord_atMost(A,A3)) = set_ord_atMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)) ) ) ).

% image_add_atMost
tff(fact_6038_bij__betw__add,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A3: A,A2: set(A),B3: set(A)] :
          ( bij_betw(A,A,aa(A,fun(A,A),plus_plus(A),A3),A2,B3)
        <=> ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),A2) = B3 ) ) ) ).

% bij_betw_add
tff(fact_6039_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),V: list(A)] : ( aa(list(B),set(B),set2(B),aa(list(A),list(B),map(A,B,F2),V)) = aa(set(A),set(B),image(A,B,F2),aa(list(A),set(A),set2(A),V)) ) ).

% list.set_map
tff(fact_6040_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),C2)),set_or3652927894154168847AtMost(A,A3,B2)) = set_or3652927894154168847AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% image_add_greaterThanAtMost
tff(fact_6041_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A,J3: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_pc(A,fun(A,A),K)),set_or1337092689740270186AtMost(A,I,J3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),K)) ) ) ).

% image_add_atLeastAtMost'
tff(fact_6042_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A,J3: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_pc(A,fun(A,A),K)),set_or7035219750837199246ssThan(A,I,J3)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J3),K)) ) ) ).

% image_add_atLeastLessThan'
tff(fact_6043_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A2: set(B)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2)) = bot_bot(A) )
        <=> ! [X4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),X4))
             => ? [Xa4: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Xa4),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,Xa4)),X4)) ) ) ) ) ).

% INF_eq_bot_iff
tff(fact_6044_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),D2))
         => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),times_times(A),D2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),D2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),D2),B2)) ) ) ) ).

% image_mult_atLeastAtMost
tff(fact_6045_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),D2))
         => ( aa(set(A),set(A),image(A,A,aTP_Lamp_pd(A,fun(A,A),D2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),D2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),D2)) ) ) ) ).

% image_divide_atLeastAtMost
tff(fact_6046_image__set,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( aa(set(B),set(A),image(B,A,F2),aa(list(B),set(B),set2(B),Xs)) = aa(list(A),set(A),set2(A),aa(list(B),list(A),map(B,A,F2),Xs)) ) ).

% image_set
tff(fact_6047_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A2: set(B),B3: set(B)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),image(B,A,F2),A2)),aa(set(B),set(A),image(B,A,F2),B3)))) ).

% image_Int_subset
tff(fact_6048_translation__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),S)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),T2)) ) ) ).

% translation_Int
tff(fact_6049_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),B3: set(C),F2: fun(B,A),G: fun(C,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => ? [X: C] :
                  ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X),B3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),aa(C,A,G,X))) ) )
         => ( ! [J2: C] :
                ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),J2),B3))
               => ? [X: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X),A2))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(C,A,G,J2)),aa(B,A,F2,X))) ) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,G),B3)) ) ) ) ) ).

% SUP_eq
tff(fact_6050_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),B3: set(C),G: fun(C,A),F2: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => ? [X: C] :
                  ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X),B3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(C,A,G,X)),aa(B,A,F2,I3))) ) )
         => ( ! [J2: C] :
                ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),J2),B3))
               => ? [X: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X),A2))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(C,A,G,J2))) ) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,G),B3)) ) ) ) ) ).

% INF_eq
tff(fact_6051_translation__Compl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),aa(set(A),set(A),uminus_uminus(set(A)),T2)) = aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),T2)) ) ) ).

% translation_Compl
tff(fact_6052_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A2: set(A),F8: fun(B,A),F2: fun(A,B),A8: set(B)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
         => ( aa(B,A,F8,aa(A,B,F2,X2)) = X2 ) )
     => ( ! [X2: B] :
            ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A8))
           => ( aa(A,B,F2,aa(B,A,F8,X2)) = X2 ) )
       => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),A8))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F8),A8)),A2))
           => bij_betw(A,B,F2,A2,A8) ) ) ) ) ).

% bij_betw_byWitness
tff(fact_6053_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A2: set(A),A8: set(B),B3: set(A),B13: set(B)] :
      ( bij_betw(A,B,F2,A2,A8)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
       => ( ( aa(set(A),set(B),image(A,B,F2),B3) = B13 )
         => bij_betw(A,B,F2,B3,B13) ) ) ) ).

% bij_betw_subset
tff(fact_6054_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A2: set(B),B3: set(B)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(B),set(A),image(B,A,F2),A2)),aa(set(B),set(A),image(B,A,F2),B3))),aa(set(B),set(A),image(B,A,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),B3)))) ).

% image_diff_subset
tff(fact_6055_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A2: set(B),P: fun(set(A),bool)] :
      ( ! [B10: set(A)] :
          ( ( finite_finite(A,B10)
            & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B10),aa(set(B),set(A),image(B,A,F2),A2))) )
         => pp(aa(set(A),bool,P,B10)) )
    <=> ! [B10: set(B)] :
          ( ( finite_finite(B,B10)
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B10),A2)) )
         => pp(aa(set(A),bool,P,aa(set(B),set(A),image(B,A,F2),B10))) ) ) ).

% all_finite_subset_image
tff(fact_6056_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A2: set(B),P: fun(set(A),bool)] :
      ( ? [B10: set(A)] :
          ( finite_finite(A,B10)
          & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B10),aa(set(B),set(A),image(B,A,F2),A2)))
          & pp(aa(set(A),bool,P,B10)) )
    <=> ? [B10: set(B)] :
          ( finite_finite(B,B10)
          & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B10),A2))
          & pp(aa(set(A),bool,P,aa(set(B),set(A),image(B,A,F2),B10))) ) ) ).

% ex_finite_subset_image
tff(fact_6057_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B3: set(A),F2: fun(B,A),A2: set(B)] :
      ( finite_finite(A,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F2),A2)))
       => ? [C7: set(B)] :
            ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C7),A2))
            & finite_finite(B,C7)
            & ( B3 = aa(set(B),set(A),image(B,A,F2),C7) ) ) ) ) ).

% finite_subset_image
tff(fact_6058_finite__surj,axiom,
    ! [A: $tType,B: $tType,A2: set(A),B3: set(B),F2: fun(A,B)] :
      ( finite_finite(A,A2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(set(A),set(B),image(A,B,F2),A2)))
       => finite_finite(B,B3) ) ) ).

% finite_surj
tff(fact_6059_zero__notin__Suc__image,axiom,
    ! [A2: set(nat)] : ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),A2))) ).

% zero_notin_Suc_image
tff(fact_6060_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A2: set(B),P: fun(set(A),bool)] :
      ( ! [B10: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B10),aa(set(B),set(A),image(B,A,F2),A2)))
         => pp(aa(set(A),bool,P,B10)) )
    <=> ! [B10: set(B)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B10),A2))
         => pp(aa(set(A),bool,P,aa(set(B),set(A),image(B,A,F2),B10))) ) ) ).

% all_subset_image
tff(fact_6061_image__mono,axiom,
    ! [B: $tType,A: $tType,A2: set(A),B3: set(A),F2: fun(A,B)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),aa(set(A),set(B),image(A,B,F2),B3))) ) ).

% image_mono
tff(fact_6062_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A2: set(A),F2: fun(A,B),B3: set(B)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
         => pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),aa(A,B,F2,X2)),B3)) )
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),B3)) ) ).

% image_subsetI
tff(fact_6063_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B3: set(A),F2: fun(B,A),A2: set(B)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F2),A2)))
     => ~ ! [C7: set(B)] :
            ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C7),A2))
           => ( B3 != aa(set(B),set(A),image(B,A,F2),C7) ) ) ) ).

% subset_imageE
tff(fact_6064_image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),A2: set(B),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F2),A2)),B3))
    <=> ! [X4: B] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(B,A,F2,X4)),B3)) ) ) ).

% image_subset_iff
tff(fact_6065_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B3: set(A),F2: fun(B,A),A2: set(B)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F2),A2)))
    <=> ? [AA: set(B)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),AA),A2))
          & ( B3 = aa(set(B),set(A),image(B,A,F2),AA) ) ) ) ).

% subset_image_iff
tff(fact_6066_listrel1__mono,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),S))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(set(product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),bool),ord_less_eq(set(product_prod(list(A),list(A)))),listrel1(A,R2)),listrel1(A,S))) ) ).

% listrel1_mono
tff(fact_6067_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),A2: set(B),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F2),A2)),B3))
     => pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),aa(set(set(B)),set(set(A)),image(set(B),set(A),image(B,A,F2)),pow2(B,A2))),pow2(A,B3))) ) ).

% image_Pow_mono
tff(fact_6068_translation__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),S)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),T2)) ) ) ).

% translation_diff
tff(fact_6069_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),F2: fun(B,A),X3: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),X3)) )
         => ( ! [Y2: A] :
                ( ! [I4: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I4),A2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I4)),Y2)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y2)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2)) = X3 ) ) ) ) ).

% SUP_eqI
tff(fact_6070_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),B3: set(C),F2: fun(B,A),G: fun(C,A)] :
          ( ! [N2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),N2),A2))
             => ? [X: C] :
                  ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X),B3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,N2)),aa(C,A,G,X))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))),aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,G),B3)))) ) ) ).

% SUP_mono
tff(fact_6071_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),F2: fun(B,A),U: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),U)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))),U)) ) ) ).

% SUP_least
tff(fact_6072_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),G: fun(B,A),A2: set(B)] :
          ( ! [X2: B] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),aa(B,A,G,X2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,G),A2)))) ) ) ).

% SUP_mono'
tff(fact_6073_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: B,A2: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),A2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2)))) ) ) ).

% SUP_upper
tff(fact_6074_SUP__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A2: set(B),U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))),U))
        <=> ! [X4: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X4)),U)) ) ) ) ).

% SUP_le_iff
tff(fact_6075_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: B,A2: set(B),U: A,F2: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),A2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(B,A,F2,I)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2)))) ) ) ) ).

% SUP_upper2
tff(fact_6076_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A2: set(B),Y4: A,I: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))),Y4))
         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),A2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,I)),Y4)) ) ) ) ).

% SUP_lessD
tff(fact_6077_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: A,F2: fun(B,A),A2: set(B)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))))
        <=> ? [X4: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F2,X4))) ) ) ) ).

% less_SUP_iff
tff(fact_6078_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),X3: A,F2: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(B,A,F2,I3))) )
         => ( ! [Y2: A] :
                ( ! [I4: B] :
                    ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I4),A2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),aa(B,A,F2,I4))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X3)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2)) = X3 ) ) ) ) ).

% INF_eqI
tff(fact_6079_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B3: set(B),A2: set(C),F2: fun(C,A),G: fun(B,A)] :
          ( ! [M3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),M3),B3))
             => ? [X: C] :
                  ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(C,A,F2,X)),aa(B,A,G,M3))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,F2),A2))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,G),B3)))) ) ) ).

% INF_mono
tff(fact_6080_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: B,A2: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),A2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))),aa(B,A,F2,I))) ) ) ).

% INF_lower
tff(fact_6081_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),G: fun(B,A),A2: set(B)] :
          ( ! [X2: B] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),aa(B,A,G,X2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,G),A2)))) ) ) ).

% INF_mono'
tff(fact_6082_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: B,A2: set(B),F2: fun(B,A),U: A] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),A2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I)),U))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))),U)) ) ) ) ).

% INF_lower2
tff(fact_6083_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [U: A,F2: fun(B,A),A2: set(B)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))))
        <=> ! [X4: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(B,A,F2,X4))) ) ) ) ).

% le_INF_iff
tff(fact_6084_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),U: A,F2: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),A2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(B,A,F2,I3))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2)))) ) ) ).

% INF_greatest
tff(fact_6085_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Y4: A,F2: fun(B,A),A2: set(B),I: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))))
         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),A2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),aa(B,A,F2,I))) ) ) ) ).

% less_INF_D
tff(fact_6086_INF__less__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A2: set(B),A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))),A3))
        <=> ? [X4: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X4)),A3)) ) ) ) ).

% INF_less_iff
tff(fact_6087_finite__conv__nat__seg__image,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
    <=> ? [N3: nat,F6: fun(nat,A)] : ( A2 = aa(set(nat),set(A),image(nat,A,F6),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),N3))) ) ) ).

% finite_conv_nat_seg_image
tff(fact_6088_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A2: set(A),F2: fun(nat,A),N: nat] :
      ( ( A2 = aa(set(nat),set(A),image(nat,A,F2),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),N))) )
     => finite_finite(A,A2) ) ).

% nat_seg_image_imp_finite
tff(fact_6089_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list(A),R2: set(product_prod(A,A))] : ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Xs)),listrel1(A,R2))) ).

% not_Nil_listrel1
tff(fact_6090_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list(A),R2: set(product_prod(A,A))] : ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),nil(A))),listrel1(A,R2))) ).

% not_listrel1_Nil
tff(fact_6091_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2)))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys2) ) ) ).

% listrel1_eq_len
tff(fact_6092_le__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [X3: A,F2: fun(B,A),A2: set(B)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))))
        <=> ! [Y: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X3))
             => ? [X4: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(B,A,F2,X4))) ) ) ) ) ).

% le_SUP_iff
tff(fact_6093_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A2: set(B),X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))),X3))
        <=> ! [Y: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y))
             => ? [X4: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X4)),Y)) ) ) ) ) ).

% INF_le_iff
tff(fact_6094_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A2: set(B),F2: fun(B,A),M7: A] :
          ( ( A2 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),M7)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))),M7)) ) ) ) ).

% cSUP_least
tff(fact_6095_SUP__eq__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I5: set(B),C2: A,F2: fun(B,A)] :
          ( ( I5 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),I5))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(B,A,F2,I3))) )
           => ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),I5)) = C2 )
            <=> ! [X4: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),I5))
                 => ( aa(B,A,F2,X4) = C2 ) ) ) ) ) ) ).

% SUP_eq_iff
tff(fact_6096_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A2: set(B),M: A,F2: fun(B,A)] :
          ( ( A2 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),aa(B,A,F2,X2))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2)))) ) ) ) ).

% cINF_greatest
tff(fact_6097_INF__eq__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I5: set(B),F2: fun(B,A),C2: A] :
          ( ( I5 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),I5))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),C2)) )
           => ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),I5)) = C2 )
            <=> ! [X4: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),I5))
                 => ( aa(B,A,F2,X4) = C2 ) ) ) ) ) ) ).

% INF_eq_iff
tff(fact_6098_card__image__le,axiom,
    ! [B: $tType,A: $tType,A2: set(A),F2: fun(A,B)] :
      ( finite_finite(A,A2)
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(B),nat,finite_card(B),aa(set(A),set(B),image(A,B,F2),A2))),aa(set(A),nat,finite_card(A),A2))) ) ).

% card_image_le
tff(fact_6099_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F8: fun(A,B),A8: set(A),A9: set(B),F2: fun(C,A),A2: set(C)] :
      ( bij_betw(A,B,F8,A8,A9)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,F2),A2)),A8))
       => ( bij_betw(C,A,F2,A2,A8)
        <=> bij_betw(C,B,aa(fun(C,A),fun(C,B),comp(A,B,C,F8),F2),A2,A9) ) ) ) ).

% bij_betw_comp_iff2
tff(fact_6100_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),B3: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),B3))
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),aa(B,A,G,X2))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,G),B3)))) ) ) ) ).

% SUP_subset_mono
tff(fact_6101_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B3: set(B),A2: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),A2))
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),B3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X2)),aa(B,A,G,X2))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,G),B3)))) ) ) ) ).

% INF_superset_mono
tff(fact_6102_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),T6: set(C),G: fun(B,C),H: fun(B,A)] :
          ( finite_finite(B,S2)
         => ( finite_finite(C,T6)
           => ( pp(aa(set(C),bool,aa(set(C),fun(set(C),bool),ord_less_eq(set(C)),aa(set(B),set(C),image(B,C,G),S2)),T6))
             => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aTP_Lamp_pf(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),S2),G),H)),T6) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),S2) ) ) ) ) ) ).

% sum.group
tff(fact_6103_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T6: set(C),G: fun(B,C),H: fun(B,A)] :
          ( finite_finite(B,S2)
         => ( finite_finite(C,T6)
           => ( pp(aa(set(C),bool,aa(set(C),fun(set(C),bool),ord_less_eq(set(C)),aa(set(B),set(C),image(B,C,G),S2)),T6))
             => ( groups7121269368397514597t_prod(C,A,aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aTP_Lamp_pg(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),S2),G),H),T6) = groups7121269368397514597t_prod(B,A,H,S2) ) ) ) ) ) ).

% prod.group
tff(fact_6104_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),H: fun(B,C),G: fun(C,A)] :
          ( finite_finite(B,A2)
         => ( ! [X2: B,Y2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),A2))
               => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Y2),A2))
                 => ( ( X2 != Y2 )
                   => ( ( aa(B,C,H,X2) = aa(B,C,H,Y2) )
                     => ( aa(C,A,G,aa(B,C,H,X2)) = zero_zero(A) ) ) ) ) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),aa(set(B),set(C),image(B,C,H),A2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,C),fun(B,A),comp(C,A,B,G),H)),A2) ) ) ) ) ).

% sum.reindex_nontrivial
tff(fact_6105_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(B),F2: fun(B,A)] :
          ( ( A2 != bot_bot(set(B)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F2),A2))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2)))) ) ) ).

% INF_le_SUP
tff(fact_6106_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A2: set(A),B3: set(B),F2: fun(A,B)] :
      ( finite_finite(A,A2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(set(A),set(B),image(A,B,F2),A2)))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(B),nat,finite_card(B),B3)),aa(set(A),nat,finite_card(A),A2))) ) ) ).

% surj_card_le
tff(fact_6107_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,X3: A,Y4: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
         => ( aa(set(A),set(A),image(A,A,real_V8093663219630862766scaleR(A,C2)),set_or1337092689740270186AtMost(A,X3,Y4)) = set_or1337092689740270186AtMost(A,aa(A,A,real_V8093663219630862766scaleR(A,C2),X3),aa(A,A,real_V8093663219630862766scaleR(A,C2),Y4)) ) ) ) ).

% scaleR_image_atLeastAtMost
tff(fact_6108_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ).

% atLeast0_atMost_Suc_eq_insert_0
tff(fact_6109_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
tff(fact_6110_lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] : ( set_ord_lessThan(nat,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_ord_lessThan(nat,N))) ) ).

% lessThan_Suc_eq_insert_0
tff(fact_6111_atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] : ( set_ord_atMost(nat,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_ord_atMost(nat,N))) ) ).

% atMost_Suc_eq_insert_0
tff(fact_6112_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),X3: B,Xs: list(B)] :
          ( distinct(A,aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Xs)))
        <=> ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(B,A,F2,X3)),aa(set(B),set(A),image(B,A,F2),aa(list(B),set(B),set2(B),Xs))))
            & distinct(A,aa(list(B),list(A),map(B,A,F2),Xs)) ) ) ) ).

% distinct_insort_key
tff(fact_6113_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: fun(nat,set(A)),K: nat,N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_ph(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M7),K)),set_ord_lessThan(nat,N))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M7),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) ) ).

% UN_le_add_shift_strict
tff(fact_6114_UN__le__add__shift,axiom,
    ! [A: $tType,M7: fun(nat,set(A)),K: nat,N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_ph(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M7),K)),set_ord_atMost(nat,N))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M7),set_or1337092689740270186AtMost(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) ) ).

% UN_le_add_shift
tff(fact_6115_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(C),G: fun(A,B),F2: fun(C,A)] :
          ( finite_finite(C,I5)
         => ( ! [I3: C] :
                ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),I3),I5))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,G,aa(C,A,F2,I3)))) )
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(C),set(A),image(C,A,F2),I5))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(fun(C,A),fun(C,B),comp(A,B,C,G),F2)),I5))) ) ) ) ).

% sum_image_le
tff(fact_6116_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X3,Y4)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),X3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y4)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X3,Y4)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),X3)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X3,Y4)) = bot_bot(set(A)) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
tff(fact_6117_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A,C2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => ( aa(set(A),set(A),image(A,A,aTP_Lamp_pi(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X3,Y4)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),X3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => ( aa(set(A),set(A),image(A,A,aTP_Lamp_pi(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X3,Y4)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),Y4),C2),aa(A,A,aa(A,fun(A,A),times_times(A),X3),C2)) ) ) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => ( aa(set(A),set(A),image(A,A,aTP_Lamp_pi(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X3,Y4)) = bot_bot(set(A)) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
tff(fact_6118_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,M: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pj(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A3,B2) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pj(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A3)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pj(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A3)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
tff(fact_6119_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,M: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pk(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A3,B2) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pk(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A3)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pk(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A3)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
tff(fact_6120_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,M: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pl(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A3,B2) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pl(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),M)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),M)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pl(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),M)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),M)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
tff(fact_6121_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,M: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pm(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A3,B2) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pm(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),M)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),M)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M))
               => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_pm(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),M)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),M)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
tff(fact_6122_sum__fun__comp,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [S2: set(A),R4: set(B),G: fun(A,B),F2: fun(B,C)] :
          ( finite_finite(A,S2)
         => ( finite_finite(B,R4)
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,G),S2)),R4))
             => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_pn(fun(A,B),fun(fun(B,C),fun(A,C)),G),F2)),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_pp(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),S2),G),F2)),R4) ) ) ) ) ) ).

% sum_fun_comp
tff(fact_6123_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),U))
     => ( set_or7035219750837199246ssThan(int,zero_zero(int),U) = aa(set(nat),set(int),image(nat,int,semiring_1_of_nat(int)),set_ord_lessThan(nat,aa(int,nat,nat2,U))) ) ) ).

% image_atLeastZeroLessThan_int
tff(fact_6124_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y4: nat,X3: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),C2),Y4))
       => ( aa(set(nat),set(nat),image(nat,nat,aTP_Lamp_pq(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X3,Y4)) = set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X3),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Y4),C2)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),C2),Y4))
       => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),Y4))
           => ( aa(set(nat),set(nat),image(nat,nat,aTP_Lamp_pq(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X3,Y4)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),Y4))
           => ( aa(set(nat),set(nat),image(nat,nat,aTP_Lamp_pq(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X3,Y4)) = bot_bot(set(nat)) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
tff(fact_6125_listrel1p__def,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),Xs: list(A),Ys2: list(A)] :
      ( listrel1p(A,R2,Xs,Ys2)
    <=> pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,collect(product_prod(A,A),product_case_prod(A,A,bool,R2))))) ) ).

% listrel1p_def
tff(fact_6126_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A2: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),aa(set(A),A,complete_Inf_Inf(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_pr(A,fun(nat,A),B3)),collect(nat,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B3) ) ) ).

% INF_nat_binary
tff(fact_6127_set__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(A),set(A),set2(A),concat(A,Xs)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))) ) ).

% set_concat
tff(fact_6128_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B3: fun(B,set(A)),A2: set(B)] : pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),aa(set(set(set(A))),set(set(A)),complete_Sup_Sup(set(set(A))),aa(set(B),set(set(set(A))),image(B,set(set(A)),aTP_Lamp_ps(fun(B,set(A)),fun(B,set(set(A))),B3)),A2))),pow2(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B3),A2))))) ).

% UN_Pow_subset
tff(fact_6129_Inf__real__def,axiom,
    ! [X7: set(real)] : ( aa(set(real),real,complete_Inf_Inf(real),X7) = aa(real,real,uminus_uminus(real),aa(set(real),real,complete_Sup_Sup(real),aa(set(real),set(real),image(real,real,uminus_uminus(real)),X7))) ) ).

% Inf_real_def
tff(fact_6130_filter__shuffles,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Ys2: list(A)] : ( aa(set(list(A)),set(list(A)),image(list(A),list(A),filter2(A,P)),shuffles(A,Xs,Ys2)) = shuffles(A,aa(list(A),list(A),filter2(A,P),Xs),aa(list(A),list(A),filter2(A,P),Ys2)) ) ).

% filter_shuffles
tff(fact_6131_finite__int__iff__bounded__le,axiom,
    ! [S2: set(int)] :
      ( finite_finite(int,S2)
    <=> ? [K3: int] : pp(aa(set(int),bool,aa(set(int),fun(set(int),bool),ord_less_eq(set(int)),aa(set(int),set(int),image(int,int,abs_abs(int)),S2)),set_ord_atMost(int,K3))) ) ).

% finite_int_iff_bounded_le
tff(fact_6132_finite__int__iff__bounded,axiom,
    ! [S2: set(int)] :
      ( finite_finite(int,S2)
    <=> ? [K3: int] : pp(aa(set(int),bool,aa(set(int),fun(set(int),bool),ord_less_eq(set(int)),aa(set(int),set(int),image(int,int,abs_abs(int)),S2)),set_ord_lessThan(int,K3))) ) ).

% finite_int_iff_bounded
tff(fact_6133_UN__subset__iff,axiom,
    ! [B: $tType,A: $tType,A2: fun(B,set(A)),I5: set(B),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A2),I5))),B3))
    <=> ! [X4: B] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),I5))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(B,set(A),A2,X4)),B3)) ) ) ).

% UN_subset_iff
tff(fact_6134_UN__upper,axiom,
    ! [B: $tType,A: $tType,A3: A,A2: set(A),B3: fun(A,set(B))] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),A2))
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),B3,A3)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B3),A2)))) ) ).

% UN_upper
tff(fact_6135_UN__least,axiom,
    ! [A: $tType,B: $tType,A2: set(A),B3: fun(A,set(B)),C6: set(B)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
         => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),B3,X2)),C6)) )
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B3),A2))),C6)) ) ).

% UN_least
tff(fact_6136_UN__mono,axiom,
    ! [B: $tType,A: $tType,A2: set(A),B3: set(A),F2: fun(A,set(B)),G: fun(A,set(B))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
           => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F2,X2)),aa(A,set(B),G,X2))) )
       => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),F2),A2))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),G),B3)))) ) ) ).

% UN_mono
tff(fact_6137_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B3: set(A),A2: fun(B,set(A)),I5: set(B)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A2),I5))))
    <=> ! [X4: B] :
          ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),I5))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(B,set(A),A2,X4))) ) ) ).

% INT_subset_iff
tff(fact_6138_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A2: set(A),B3: set(A),F2: fun(A,set(B)),G: fun(A,set(B))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
           => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F2,X2)),aa(A,set(B),G,X2))) )
       => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),F2),B3))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),G),A2)))) ) ) ).

% INT_anti_mono
tff(fact_6139_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A2: set(A),C6: set(B),B3: fun(A,set(B))] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
         => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C6),aa(A,set(B),B3,X2))) )
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C6),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B3),A2)))) ) ).

% INT_greatest
tff(fact_6140_INT__lower,axiom,
    ! [B: $tType,A: $tType,A3: A,A2: set(A),B3: fun(A,set(B))] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),A2))
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B3),A2))),aa(A,set(B),B3,A3))) ) ).

% INT_lower
tff(fact_6141_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I5: set(A),A2: fun(A,set(B)),F2: fun(B,C),A8: fun(A,set(C))] :
      ( ! [I3: A,J2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),J2),I5))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),A2,I3)),aa(A,set(B),A2,J2)))
              | pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),A2,J2)),aa(A,set(B),A2,I3))) ) ) )
     => ( ! [I3: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
           => bij_betw(B,C,F2,aa(A,set(B),A2,I3),aa(A,set(C),A8,I3)) )
       => bij_betw(B,C,F2,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A2),I5)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image(A,set(C),A8),I5))) ) ) ).

% bij_betw_UNION_chain
tff(fact_6142_Collect__split__mono__strong,axiom,
    ! [B: $tType,A: $tType,X7: set(A),A2: set(product_prod(A,B)),Y3: set(B),P: fun(A,fun(B,bool)),Q: fun(A,fun(B,bool))] :
      ( ( X7 = aa(set(product_prod(A,B)),set(A),image(product_prod(A,B),A,product_fst(A,B)),A2) )
     => ( ( Y3 = aa(set(product_prod(A,B)),set(B),image(product_prod(A,B),B,product_snd(A,B)),A2) )
       => ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),X7))
             => ! [Xa3: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Xa3),Y3))
                 => ( pp(aa(B,bool,aa(A,fun(B,bool),P,X2),Xa3))
                   => pp(aa(B,bool,aa(A,fun(B,bool),Q,X2),Xa3)) ) ) )
         => ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),A2),collect(product_prod(A,B),product_case_prod(A,B,bool,P))))
           => pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),A2),collect(product_prod(A,B),product_case_prod(A,B,bool,Q)))) ) ) ) ) ).

% Collect_split_mono_strong
tff(fact_6143_subset__subseqs,axiom,
    ! [A: $tType,X7: set(A),Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X7),aa(list(A),set(A),set2(A),Xs)))
     => pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X7),aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs))))) ) ).

% subset_subseqs
tff(fact_6144_subseqs__powset,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs))) = pow2(A,aa(list(A),set(A),set2(A),Xs)) ) ).

% subseqs_powset
tff(fact_6145_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] : ( aa(set(int),set(int),image(int,int,aTP_Lamp_pt(int,fun(int,int),L)),set_or7035219750837199246ssThan(int,zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L))) = set_or7035219750837199246ssThan(int,L,U) ) ).

% image_add_int_atLeastLessThan
tff(fact_6146_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set(A),A2: fun(A,set(B))] :
      ( finite_finite(A,I5)
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A2),I5)))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_pu(fun(A,set(B)),fun(A,nat),A2)),I5))) ) ).

% card_UN_le
tff(fact_6147_UN__image__subset,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(B,set(A)),G: fun(C,set(B)),X3: C,X7: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F2),aa(C,set(B),G,X3)))),X7))
    <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(C,set(B),G,X3)),collect(B,aa(set(A),fun(B,bool),aTP_Lamp_pv(fun(B,set(A)),fun(set(A),fun(B,bool)),F2),X7)))) ) ).

% UN_image_subset
tff(fact_6148_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: fun(nat,set(A)),S2: set(A)] :
      ( ! [I3: nat] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(nat,set(A),F2,I3)),S2))
     => ( finite_finite(A,S2)
       => ( ? [N8: nat] :
              ( ! [N2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N2),N8))
                 => ! [M3: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M3),N8))
                     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N2))
                       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(nat,set(A),F2,M3)),aa(nat,set(A),F2,N2))) ) ) )
              & ! [N2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N2))
                 => ( aa(nat,set(A),F2,N8) = aa(nat,set(A),F2,N2) ) ) )
         => ( aa(nat,set(A),F2,aa(set(A),nat,finite_card(A),S2)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),F2),top_top(set(nat)))) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
tff(fact_6149_range__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),top_top(set(A))) = top_top(set(A)) ) ) ).

% range_add
tff(fact_6150_surj__plus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A3)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_plus
tff(fact_6151_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A2: set(A)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),A2) = top_top(A) )
        <=> ! [X4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),top_top(A)))
             => ? [Xa4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),Xa4)) ) ) ) ) ).

% Sup_eq_top_iff
tff(fact_6152_surj__fn,axiom,
    ! [A: $tType,F2: fun(A,A),N: nat] :
      ( ( aa(set(A),set(A),image(A,A,F2),top_top(set(A))) = top_top(set(A)) )
     => ( aa(set(A),set(A),image(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_fn
tff(fact_6153_SUP__eq__top__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A2: set(B)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F2),A2)) = top_top(A) )
        <=> ! [X4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),top_top(A)))
             => ? [Xa4: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Xa4),A2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),aa(B,A,F2,Xa4))) ) ) ) ) ).

% SUP_eq_top_iff
tff(fact_6154_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),top_top(A)),X3))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_ord_lessThan(A,X3)) = bot_bot(A) ) ) ) ).

% Inf_atMostLessThan
tff(fact_6155_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] : sums(A,F2,aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_pw(fun(nat,A),fun(nat,A),F2)),top_top(set(nat))))) ) ).

% sums_SUP
tff(fact_6156_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),B3: set(A),I: B] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F2),top_top(set(B)))),B3))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(B,A,F2,I)),B3)) ) ).

% range_subsetD
tff(fact_6157_top__greatest,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),top_top(A))) ) ).

% top_greatest
tff(fact_6158_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),top_top(A)),A3))
        <=> ( A3 = top_top(A) ) ) ) ).

% top.extremum_unique
tff(fact_6159_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),top_top(A)),A3))
         => ( A3 = top_top(A) ) ) ) ).

% top.extremum_uniqueI
tff(fact_6160_subset__UNIV,axiom,
    ! [A: $tType,A2: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),top_top(set(A)))) ).

% subset_UNIV
tff(fact_6161_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [L: A,H: A] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),top_top(set(A))),set_or1337092689740270186AtMost(A,L,H))) ) ).

% not_UNIV_le_Icc
tff(fact_6162_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [H: A] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),top_top(set(A))),set_ord_atMost(A,H))) ) ).

% not_UNIV_le_Iic
tff(fact_6163_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( finite_finite(fun(A,B),top_top(set(fun(A,B))))
     => ( ( aa(set(B),nat,finite_card(B),top_top(set(B))) != aa(nat,nat,suc,zero_zero(nat)) )
       => finite_finite(A,top_top(set(A))) ) ) ).

% finite_fun_UNIVD1
tff(fact_6164_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),top_top(A)),A3)) ) ).

% top.extremum_strict
tff(fact_6165_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] :
          ( ( A3 != top_top(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),top_top(A))) ) ) ).

% top.not_eq_extremum
tff(fact_6166_bij__fn,axiom,
    ! [A: $tType,F2: fun(A,A),N: nat] :
      ( bij_betw(A,A,F2,top_top(set(A)),top_top(set(A)))
     => bij_betw(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),top_top(set(A)),top_top(set(A))) ) ).

% bij_fn
tff(fact_6167_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A2: set(B)] :
      ( ( aa(set(B),set(A),image(B,A,F2),top_top(set(B))) = top_top(set(A)) )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),aa(set(B),set(A),image(B,A,F2),A2))),aa(set(B),set(A),image(B,A,F2),aa(set(B),set(B),uminus_uminus(set(B)),A2)))) ) ).

% surj_Compl_image_subset
tff(fact_6168_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => folding_insort_key(A,A,ord_less_eq(A),ord_less(A),top_top(set(A)),aTP_Lamp_nd(A,A)) ) ).

% sorted_list_of_set.folding_insort_key_axioms
tff(fact_6169_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => semila1105856199041335345_order(A,inf_inf(A),top_top(A),ord_less_eq(A),ord_less(A)) ) ).

% inf_top.semilattice_neutr_order_axioms
tff(fact_6170_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( finite_finite(A,top_top(set(A)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),top_top(set(A))))) ) ).

% finite_UNIV_card_ge_0
tff(fact_6171_conj__subset__def,axiom,
    ! [A: $tType,A2: set(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),collect(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_px(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q))))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),collect(A,P)))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),collect(A,Q))) ) ) ).

% conj_subset_def
tff(fact_6172_UN__UN__finite__eq,axiom,
    ! [A: $tType,A2: fun(nat,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aTP_Lamp_py(fun(nat,set(A)),fun(nat,set(A)),A2)),top_top(set(nat)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A2),top_top(set(nat)))) ) ).

% UN_UN_finite_eq
tff(fact_6173_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A)] :
      ( finite_finite(A,aa(set(B),set(A),image(B,A,F2),top_top(set(B))))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),aa(set(B),set(A),image(B,A,F2),top_top(set(B)))))) ) ).

% card_range_greater_zero
tff(fact_6174_UN__finite__subset,axiom,
    ! [A: $tType,A2: fun(nat,set(A)),C6: set(A)] :
      ( ! [N2: nat] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2)))),C6))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A2),top_top(set(nat))))),C6)) ) ).

% UN_finite_subset
tff(fact_6175_UN__finite2__eq,axiom,
    ! [A: $tType,A2: fun(nat,set(A)),B3: fun(nat,set(A)),K: nat] :
      ( ! [N2: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B3),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),K)))) )
     => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A2),top_top(set(nat)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B3),top_top(set(nat)))) ) ) ).

% UN_finite2_eq
tff(fact_6176_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] : ( suminf(A,F2) = aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_pw(fun(nat,A),fun(nat,A),F2)),top_top(set(nat)))) ) ) ).

% suminf_eq_SUP
tff(fact_6177_range__mod,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(set(nat),set(nat),image(nat,nat,aTP_Lamp_pz(nat,fun(nat,nat),N)),top_top(set(nat))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),N) ) ) ).

% range_mod
tff(fact_6178_UN__finite2__subset,axiom,
    ! [A: $tType,A2: fun(nat,set(A)),B3: fun(nat,set(A)),K: nat] :
      ( ! [N2: nat] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2)))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B3),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),K))))))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A2),top_top(set(nat))))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B3),top_top(set(nat)))))) ) ).

% UN_finite2_subset
tff(fact_6179_suminf__eq__SUP__real,axiom,
    ! [X7: fun(nat,real)] :
      ( summable(real,X7)
     => ( ! [I3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,X7,I3)))
       => ( suminf(real,X7) = aa(set(real),real,complete_Sup_Sup(real),aa(set(nat),set(real),image(nat,real,aTP_Lamp_qa(fun(nat,real),fun(nat,real),X7)),top_top(set(nat)))) ) ) ) ).

% suminf_eq_SUP_real
tff(fact_6180_UNIV__nat__eq,axiom,
    top_top(set(nat)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),top_top(set(nat)))) ).

% UNIV_nat_eq
tff(fact_6181_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),remdups(A,concat(A,Xss))) = aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),Xss)))) ) ).

% length_remdups_concat
tff(fact_6182_remdups__upt,axiom,
    ! [M: nat,N: nat] : ( remdups(nat,upt(M,N)) = upt(M,N) ) ).

% remdups_upt
tff(fact_6183_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X3: list(A)] :
      ( ( remdups(A,X3) = nil(A) )
    <=> ( X3 = nil(A) ) ) ).

% remdups_eq_nil_iff
tff(fact_6184_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X3: list(A)] :
      ( ( nil(A) = remdups(A,X3) )
    <=> ( X3 = nil(A) ) ) ).

% remdups_eq_nil_right_iff
tff(fact_6185_set__remdups,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),remdups(A,Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% set_remdups
tff(fact_6186_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),remdups(A,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) )
    <=> ( remdups(A,Xs) = Xs ) ) ).

% length_remdups_eq
tff(fact_6187_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( remdups(A,Xs) = Xs )
    <=> distinct(A,Xs) ) ).

% remdups_id_iff_distinct
tff(fact_6188_distinct__remdups,axiom,
    ! [A: $tType,Xs: list(A)] : distinct(A,remdups(A,Xs)) ).

% distinct_remdups
tff(fact_6189_card__UNIV__bool,axiom,
    aa(set(bool),nat,finite_card(bool),top_top(set(bool))) = aa(num,nat,numeral_numeral(nat),bit0(one2)) ).

% card_UNIV_bool
tff(fact_6190_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),remdups(A,Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ).

% length_remdups_leq
tff(fact_6191_range__mult,axiom,
    ! [A3: real] :
      ( ( ( A3 = zero_zero(real) )
       => ( aa(set(real),set(real),image(real,real,aa(real,fun(real,real),times_times(real),A3)),top_top(set(real))) = aa(set(real),set(real),insert2(real,zero_zero(real)),bot_bot(set(real))) ) )
      & ( ( A3 != zero_zero(real) )
       => ( aa(set(real),set(real),image(real,real,aa(real,fun(real,real),times_times(real),A3)),top_top(set(real))) = top_top(set(real)) ) ) ) ).

% range_mult
tff(fact_6192_infinite__UNIV__listI,axiom,
    ! [A: $tType] : ~ finite_finite(list(A),top_top(set(list(A)))) ).

% infinite_UNIV_listI
tff(fact_6193_infinite__UNIV__int,axiom,
    ~ finite_finite(int,top_top(set(int))) ).

% infinite_UNIV_int
tff(fact_6194_top__enat__def,axiom,
    top_top(extended_enat) = extend4730790105801354508finity(extended_enat) ).

% top_enat_def
tff(fact_6195_remdups__filter,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( remdups(A,aa(list(A),list(A),filter2(A,P),Xs)) = aa(list(A),list(A),filter2(A,P),remdups(A,Xs)) ) ).

% remdups_filter
tff(fact_6196_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] : ( remdups(A,nil(A)) = nil(A) ) ).

% remdups.simps(1)
tff(fact_6197_remdups__remdups,axiom,
    ! [A: $tType,Xs: list(A)] : ( remdups(A,remdups(A,Xs)) = remdups(A,Xs) ) ).

% remdups_remdups
tff(fact_6198_insert__remdups,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( insert(A,X3,remdups(A,Xs)) = remdups(A,insert(A,X3,Xs)) ) ).

% insert_remdups
tff(fact_6199_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => ( remdups(A,Xs) = Xs ) ) ).

% distinct_remdups_id
tff(fact_6200_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( remdups(A,aa(list(B),list(A),map(B,A,F2),remdups(B,Xs))) = remdups(A,aa(list(B),list(A),map(B,A,F2),Xs)) ) ).

% remdups_map_remdups
tff(fact_6201_sorted__remdups,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),remdups(A,Xs)) ) ) ).

% sorted_remdups
tff(fact_6202_remove1__remdups,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( distinct(A,Xs)
     => ( remove1(A,X3,remdups(A,Xs)) = remdups(A,remove1(A,X3,Xs)) ) ) ).

% remove1_remdups
tff(fact_6203_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),remdups(A,Xs)) = aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs)) ) ).

% length_remdups_card_conv
tff(fact_6204_Ints__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( ring_1_Ints(A) = aa(set(int),set(A),image(int,A,ring_1_of_int(A)),top_top(set(int))) ) ) ).

% Ints_def
tff(fact_6205_int__in__range__abs,axiom,
    ! [N: nat] : pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(set(int),set(int),image(int,int,abs_abs(int)),top_top(set(int))))) ).

% int_in_range_abs
tff(fact_6206_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),Xs: list(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(list(B),set(B),set2(B),Xs)) = groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,G),remdups(B,Xs))) ) ) ).

% sum_code
tff(fact_6207_root__def,axiom,
    ! [N: nat,X3: real] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(real,real,root(N),X3) = zero_zero(real) ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(real,real,root(N),X3) = the_inv_into(real,real,top_top(set(real)),aTP_Lamp_qb(nat,fun(real,real),N),X3) ) ) ) ).

% root_def
tff(fact_6208_card__UNIV__char,axiom,
    aa(set(char),nat,finite_card(char),top_top(set(char))) = aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2))))))))) ).

% card_UNIV_char
tff(fact_6209_UNIV__char__of__nat,axiom,
    top_top(set(char)) = aa(set(nat),set(char),image(nat,char,unique5772411509450598832har_of(nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2))))))))))) ).

% UNIV_char_of_nat
tff(fact_6210_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: A,N: A] :
          ( ( aa(A,char,unique5772411509450598832har_of(A),M) = aa(A,char,unique5772411509450598832har_of(A),N) )
        <=> ( modulo_modulo(A,M,aa(num,A,numeral_numeral(A),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2)))))))))) = modulo_modulo(A,N,aa(num,A,numeral_numeral(A),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2)))))))))) ) ) ) ).

% char_of_quasi_inj
tff(fact_6211_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: A] : ( aa(A,char,unique5772411509450598832har_of(A),modulo_modulo(A,N,aa(num,A,numeral_numeral(A),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2))))))))))) = aa(A,char,unique5772411509450598832har_of(A),N) ) ) ).

% char_of_mod_256
tff(fact_6212_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,M: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(one2))))),N))
         => ( aa(A,char,unique5772411509450598832har_of(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),M)) = aa(A,char,unique5772411509450598832har_of(A),M) ) ) ) ).

% char_of_take_bit_eq
tff(fact_6213_of__char__of,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [A3: A] : ( aa(char,A,comm_s6883823935334413003f_char(A),aa(A,char,unique5772411509450598832har_of(A),A3)) = modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2)))))))))) ) ) ).

% of_char_of
tff(fact_6214_char__of__def,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: A] : ( aa(A,char,unique5772411509450598832har_of(A),N) = char2(aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),aa(nat,bool,bit_se5641148757651400278ts_bit(A,N),one_one(nat)),aa(nat,bool,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,bool,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit1(one2))),aa(nat,bool,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))),aa(nat,bool,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit1(bit0(one2)))),aa(nat,bool,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit0(bit1(one2)))),aa(nat,bool,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit1(bit1(one2))))) ) ) ).

% char_of_def
tff(fact_6215_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [C2: char] : ( modulo_modulo(A,aa(char,A,comm_s6883823935334413003f_char(A),C2),aa(num,A,numeral_numeral(A),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2)))))))))) = aa(char,A,comm_s6883823935334413003f_char(A),C2) ) ) ).

% of_char_mod_256
tff(fact_6216_char_Osize_I2_J,axiom,
    ! [X15: bool,X22: bool,X32: bool,X42: bool,X52: bool,X62: bool,X72: bool,X82: bool] : ( aa(char,nat,size_size(char),char2(X15,X22,X32,X42,X52,X62,X72,X82)) = zero_zero(nat) ) ).

% char.size(2)
tff(fact_6217_nat__of__char__less__256,axiom,
    ! [C2: char] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(char,nat,comm_s6883823935334413003f_char(nat),C2)),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2))))))))))) ).

% nat_of_char_less_256
tff(fact_6218_range__nat__of__char,axiom,
    aa(set(char),set(nat),image(char,nat,comm_s6883823935334413003f_char(nat)),top_top(set(char))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2)))))))))) ).

% range_nat_of_char
tff(fact_6219_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: A,C2: char] :
          ( ( aa(A,char,unique5772411509450598832har_of(A),N) = C2 )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(one2))))),N) = aa(char,A,comm_s6883823935334413003f_char(A),C2) ) ) ) ).

% char_of_eq_iff
tff(fact_6220_integer__of__char__code,axiom,
    ! [B0: bool,B1: bool,B22: bool,B32: bool,B42: bool,B52: bool,B62: bool,B72: bool] : ( integer_of_char(char2(B0,B1,B22,B32,B42,B52,B62,B72)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(bool,code_integer,zero_neq_one_of_bool(code_integer),B72)),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa(bool,code_integer,zero_neq_one_of_bool(code_integer),B62))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa(bool,code_integer,zero_neq_one_of_bool(code_integer),B52))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa(bool,code_integer,zero_neq_one_of_bool(code_integer),B42))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa(bool,code_integer,zero_neq_one_of_bool(code_integer),B32))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa(bool,code_integer,zero_neq_one_of_bool(code_integer),B22))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa(bool,code_integer,zero_neq_one_of_bool(code_integer),B1))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa(bool,code_integer,zero_neq_one_of_bool(code_integer),B0)) ) ).

% integer_of_char_code
tff(fact_6221_char_Osize__gen,axiom,
    ! [X15: bool,X22: bool,X32: bool,X42: bool,X52: bool,X62: bool,X72: bool,X82: bool] : ( size_char(char2(X15,X22,X32,X42,X52,X62,X72,X82)) = zero_zero(nat) ) ).

% char.size_gen
tff(fact_6222_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] : ( aa(char,nat,comm_s6883823935334413003f_char(nat),ascii_of(C2)) = aa(nat,nat,bit_se2584673776208193580ke_bit(nat,aa(num,nat,numeral_numeral(nat),bit1(bit1(one2)))),aa(char,nat,comm_s6883823935334413003f_char(nat),C2)) ) ).

% String.char_of_ascii_of
tff(fact_6223_of__char__Char,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [B0: bool,B1: bool,B22: bool,B32: bool,B42: bool,B52: bool,B62: bool,B72: bool] : ( aa(char,A,comm_s6883823935334413003f_char(A),char2(B0,B1,B22,B32,B42,B52,B62,B72)) = groups4207007520872428315er_sum(bool,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),bit0(one2)),aa(list(bool),list(bool),cons(bool,B0),aa(list(bool),list(bool),cons(bool,B1),aa(list(bool),list(bool),cons(bool,B22),aa(list(bool),list(bool),cons(bool,B32),aa(list(bool),list(bool),cons(bool,B42),aa(list(bool),list(bool),cons(bool,B52),aa(list(bool),list(bool),cons(bool,B62),aa(list(bool),list(bool),cons(bool,B72),nil(bool)))))))))) ) ) ).

% of_char_Char
tff(fact_6224_list_Oinject,axiom,
    ! [A: $tType,X21: A,X222: list(A),Y21: A,Y222: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X21),X222) = aa(list(A),list(A),cons(A,Y21),Y222) )
    <=> ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% list.inject
tff(fact_6225_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X21),X222)) = aa(set(A),set(A),insert2(A,X21),aa(list(A),set(A),set2(A),X222)) ) ).

% list.simps(15)
tff(fact_6226_nth__Cons__Suc,axiom,
    ! [A: $tType,X3: A,Xs: list(A),N: nat] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),aa(nat,nat,suc,N)) = aa(nat,A,nth(A,Xs),N) ) ).

% nth_Cons_Suc
tff(fact_6227_nth__Cons__0,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),zero_zero(nat)) = X3 ) ).

% nth_Cons_0
tff(fact_6228_take__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] : ( take(A,aa(nat,nat,suc,N),aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),take(A,N,Xs)) ) ).

% take_Suc_Cons
tff(fact_6229_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [X3: A,Xs: list(A)] : ( groups8242544230860333062m_list(A,aa(list(A),list(A),cons(A,X3),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),groups8242544230860333062m_list(A,Xs)) ) ) ).

% sum_list.Cons
tff(fact_6230_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( ( aa(list(A),list(A),rev(A),Xs) = aa(list(A),list(A),cons(A,X3),nil(A)) )
    <=> ( Xs = aa(list(A),list(A),cons(A,X3),nil(A)) ) ) ).

% rev_singleton_conv
tff(fact_6231_singleton__rev__conv,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X3),nil(A)) = aa(list(A),list(A),rev(A),Xs) )
    <=> ( aa(list(A),list(A),cons(A,X3),nil(A)) = Xs ) ) ).

% singleton_rev_conv
tff(fact_6232_insert__Nil,axiom,
    ! [A: $tType,X3: A] : ( insert(A,X3,nil(A)) = aa(list(A),list(A),cons(A,X3),nil(A)) ) ).

% insert_Nil
tff(fact_6233_not__in__set__insert,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( insert(A,X3,Xs) = aa(list(A),list(A),cons(A,X3),Xs) ) ) ).

% not_in_set_insert
tff(fact_6234_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: A,Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(A),list(A),cons(A,Y4),Ys2))),listrel1(A,R2)))
    <=> ( ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),R2))
          & ( Xs = Ys2 ) )
        | ( ( X3 = Y4 )
          & pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2))) ) ) ) ).

% Cons_listrel1_Cons
tff(fact_6235_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A3: A,X3: B,Xs: list(B)] : ( groups4207007520872428315er_sum(B,A,F2,A3,aa(list(B),list(B),cons(B,X3),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,F2,X3)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),groups4207007520872428315er_sum(B,A,F2,A3,Xs))) ) ) ).

% horner_sum_simps(2)
tff(fact_6236_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X3: B,Xs: list(B)] : ( enumerate(B,N,aa(list(B),list(B),cons(B,X3),Xs)) = aa(list(product_prod(nat,B)),list(product_prod(nat,B)),cons(product_prod(nat,B),aa(B,product_prod(nat,B),product_Pair(nat,B,N),X3)),enumerate(B,aa(nat,nat,suc,N),Xs)) ) ).

% enumerate_simps(2)
tff(fact_6237_nth__Cons__numeral,axiom,
    ! [A: $tType,X3: A,Xs: list(A),V: num] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat))) ) ).

% nth_Cons_numeral
tff(fact_6238_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X3: A,Xs: list(A)] : ( take(A,aa(num,nat,numeral_numeral(nat),V),aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)),Xs)) ) ).

% take_Cons_numeral
tff(fact_6239_Cons__in__lex,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: A,Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(A),list(A),cons(A,Y4),Ys2))),lex(A,R2)))
    <=> ( ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),R2))
          & ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys2) ) )
        | ( ( X3 = Y4 )
          & pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),lex(A,R2))) ) ) ) ).

% Cons_in_lex
tff(fact_6240_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( concat(A,aa(list(B),list(list(A)),map(B,list(A),aTP_Lamp_qc(fun(B,A),fun(B,list(A)),F2)),Xs)) = aa(list(B),list(A),map(B,A,F2),Xs) ) ).

% concat_map_singleton
tff(fact_6241_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),N) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ).

% nth_Cons_pos
tff(fact_6242_impossible__Cons,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys2)))
     => ( Xs != aa(list(A),list(A),cons(A,X3),Ys2) ) ) ).

% impossible_Cons
tff(fact_6243_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list(A),Ys2: list(B),Zs: list(C),Ws: list(D),P: fun(list(A),fun(list(B),fun(list(C),fun(list(D),bool))))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( ( aa(list(B),nat,size_size(list(B)),Ys2) = aa(list(C),nat,size_size(list(C)),Zs) )
       => ( ( aa(list(C),nat,size_size(list(C)),Zs) = aa(list(D),nat,size_size(list(D)),Ws) )
         => ( pp(aa(list(D),bool,aa(list(C),fun(list(D),bool),aa(list(B),fun(list(C),fun(list(D),bool)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),bool))),P,nil(A)),nil(B)),nil(C)),nil(D)))
           => ( ! [X2: A,Xs2: list(A),Y2: B,Ys3: list(B),Z4: C,Zs2: list(C),W2: D,Ws2: list(D)] :
                  ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys3) )
                 => ( ( aa(list(B),nat,size_size(list(B)),Ys3) = aa(list(C),nat,size_size(list(C)),Zs2) )
                   => ( ( aa(list(C),nat,size_size(list(C)),Zs2) = aa(list(D),nat,size_size(list(D)),Ws2) )
                     => ( pp(aa(list(D),bool,aa(list(C),fun(list(D),bool),aa(list(B),fun(list(C),fun(list(D),bool)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),bool))),P,Xs2),Ys3),Zs2),Ws2))
                       => pp(aa(list(D),bool,aa(list(C),fun(list(D),bool),aa(list(B),fun(list(C),fun(list(D),bool)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),bool))),P,aa(list(A),list(A),cons(A,X2),Xs2)),aa(list(B),list(B),cons(B,Y2),Ys3)),aa(list(C),list(C),cons(C,Z4),Zs2)),aa(list(D),list(D),cons(D,W2),Ws2))) ) ) ) )
             => pp(aa(list(D),bool,aa(list(C),fun(list(D),bool),aa(list(B),fun(list(C),fun(list(D),bool)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),bool))),P,Xs),Ys2),Zs),Ws)) ) ) ) ) ) ).

% list_induct4
tff(fact_6244_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys2: list(B),Zs: list(C),P: fun(list(A),fun(list(B),fun(list(C),bool)))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( ( aa(list(B),nat,size_size(list(B)),Ys2) = aa(list(C),nat,size_size(list(C)),Zs) )
       => ( pp(aa(list(C),bool,aa(list(B),fun(list(C),bool),aa(list(A),fun(list(B),fun(list(C),bool)),P,nil(A)),nil(B)),nil(C)))
         => ( ! [X2: A,Xs2: list(A),Y2: B,Ys3: list(B),Z4: C,Zs2: list(C)] :
                ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys3) )
               => ( ( aa(list(B),nat,size_size(list(B)),Ys3) = aa(list(C),nat,size_size(list(C)),Zs2) )
                 => ( pp(aa(list(C),bool,aa(list(B),fun(list(C),bool),aa(list(A),fun(list(B),fun(list(C),bool)),P,Xs2),Ys3),Zs2))
                   => pp(aa(list(C),bool,aa(list(B),fun(list(C),bool),aa(list(A),fun(list(B),fun(list(C),bool)),P,aa(list(A),list(A),cons(A,X2),Xs2)),aa(list(B),list(B),cons(B,Y2),Ys3)),aa(list(C),list(C),cons(C,Z4),Zs2))) ) ) )
           => pp(aa(list(C),bool,aa(list(B),fun(list(C),bool),aa(list(A),fun(list(B),fun(list(C),bool)),P,Xs),Ys2),Zs)) ) ) ) ) ).

% list_induct3
tff(fact_6245_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B),P: fun(list(A),fun(list(B),bool))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,nil(A)),nil(B)))
       => ( ! [X2: A,Xs2: list(A),Y2: B,Ys3: list(B)] :
              ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys3) )
             => ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,Xs2),Ys3))
               => pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,aa(list(A),list(A),cons(A,X2),Xs2)),aa(list(B),list(B),cons(B,Y2),Ys3))) ) )
         => pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,Xs),Ys2)) ) ) ) ).

% list_induct2
tff(fact_6246_length__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),cons(A,X3),Xs)) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_Cons
tff(fact_6247_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,N) )
    <=> ? [Y: A,Ys4: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,Y),Ys4) )
          & ( aa(list(A),nat,size_size(list(A)),Ys4) = N ) ) ) ).

% length_Suc_conv
tff(fact_6248_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( aa(nat,nat,suc,N) = aa(list(A),nat,size_size(list(A)),Xs) )
    <=> ? [Y: A,Ys4: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,Y),Ys4) )
          & ( aa(list(A),nat,size_size(list(A)),Ys4) = N ) ) ) ).

% Suc_length_conv
tff(fact_6249_listrel1I2,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A)),X3: A] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2)))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(A),list(A),cons(A,X3),Ys2))),listrel1(A,R2))) ) ).

% listrel1I2
tff(fact_6250_foldr__Cons,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(B,B)),X3: A,Xs: list(A)] : ( foldr(A,B,F2,aa(list(A),list(A),cons(A,X3),Xs)) = aa(fun(B,B),fun(B,B),comp(B,B,B,aa(A,fun(B,B),F2,X3)),foldr(A,B,F2,Xs)) ) ).

% foldr_Cons
tff(fact_6251_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),X3: B] : ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),nil(B)) = aa(list(B),list(B),cons(B,X3),nil(B)) ) ) ).

% insort_key.simps(1)
tff(fact_6252_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A)] :
      ( ( pp(aa(A,bool,P,X3))
       => ( takeWhile(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),takeWhile(A,P,Xs)) ) )
      & ( ~ pp(aa(A,bool,P,X3))
       => ( takeWhile(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = nil(A) ) ) ) ).

% takeWhile.simps(2)
tff(fact_6253_shufflesE,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys2: list(A)] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
     => ( ( ( Zs = Xs )
         => ( Ys2 != nil(A) ) )
       => ( ( ( Zs = Ys2 )
           => ( Xs != nil(A) ) )
         => ( ! [X2: A,Xs4: list(A)] :
                ( ( Xs = aa(list(A),list(A),cons(A,X2),Xs4) )
               => ! [Z4: A,Zs4: list(A)] :
                    ( ( Zs = aa(list(A),list(A),cons(A,Z4),Zs4) )
                   => ( ( X2 = Z4 )
                     => ~ pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs4),shuffles(A,Xs4,Ys2))) ) ) )
           => ~ ! [Y2: A,Ys5: list(A)] :
                  ( ( Ys2 = aa(list(A),list(A),cons(A,Y2),Ys5) )
                 => ! [Z4: A,Zs4: list(A)] :
                      ( ( Zs = aa(list(A),list(A),cons(A,Z4),Zs4) )
                     => ( ( Y2 = Z4 )
                       => ~ pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs4),shuffles(A,Xs,Ys5))) ) ) ) ) ) ) ) ).

% shufflesE
tff(fact_6254_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),X21: A,X222: list(A)] : ( aa(list(A),list(B),map(A,B,F2),aa(list(A),list(A),cons(A,X21),X222)) = aa(list(B),list(B),cons(B,aa(A,B,F2,X21)),aa(list(A),list(B),map(A,B,F2),X222)) ) ).

% list.simps(9)
tff(fact_6255_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list(A),F2: fun(B,A),Ys2: list(B)] :
      ( ( aa(list(A),list(A),cons(A,X3),Xs) = aa(list(B),list(A),map(B,A,F2),Ys2) )
     => ? [Z4: B,Zs2: list(B)] :
          ( ( Ys2 = aa(list(B),list(B),cons(B,Z4),Zs2) )
          & ( X3 = aa(B,A,F2,Z4) )
          & ( Xs = aa(list(B),list(A),map(B,A,F2),Zs2) ) ) ) ).

% Cons_eq_map_D
tff(fact_6256_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),Xs: list(B),Y4: A,Ys2: list(A)] :
      ( ( aa(list(B),list(A),map(B,A,F2),Xs) = aa(list(A),list(A),cons(A,Y4),Ys2) )
     => ? [Z4: B,Zs2: list(B)] :
          ( ( Xs = aa(list(B),list(B),cons(B,Z4),Zs2) )
          & ( aa(B,A,F2,Z4) = Y4 )
          & ( aa(list(B),list(A),map(B,A,F2),Zs2) = Ys2 ) ) ) ).

% map_eq_Cons_D
tff(fact_6257_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list(A),F2: fun(B,A),Ys2: list(B)] :
      ( ( aa(list(A),list(A),cons(A,X3),Xs) = aa(list(B),list(A),map(B,A,F2),Ys2) )
    <=> ? [Z6: B,Zs3: list(B)] :
          ( ( Ys2 = aa(list(B),list(B),cons(B,Z6),Zs3) )
          & ( X3 = aa(B,A,F2,Z6) )
          & ( Xs = aa(list(B),list(A),map(B,A,F2),Zs3) ) ) ) ).

% Cons_eq_map_conv
tff(fact_6258_map__eq__Cons__conv,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),Xs: list(B),Y4: A,Ys2: list(A)] :
      ( ( aa(list(B),list(A),map(B,A,F2),Xs) = aa(list(A),list(A),cons(A,Y4),Ys2) )
    <=> ? [Z6: B,Zs3: list(B)] :
          ( ( Xs = aa(list(B),list(B),cons(B,Z6),Zs3) )
          & ( aa(B,A,F2,Z6) = Y4 )
          & ( aa(list(B),list(A),map(B,A,F2),Zs3) = Ys2 ) ) ) ).

% map_eq_Cons_conv
tff(fact_6259_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Xss: list(list(A))] : ( product_lists(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs),Xss)) = concat(list(A),aa(list(A),list(list(list(A))),map(A,list(list(A)),aTP_Lamp_qd(list(list(A)),fun(A,list(list(A))),Xss)),Xs)) ) ).

% product_lists.simps(2)
tff(fact_6260_list__update__code_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),I: nat,Y4: A] : ( list_update(A,aa(list(A),list(A),cons(A,X3),Xs),aa(nat,nat,suc,I),Y4) = aa(list(A),list(A),cons(A,X3),list_update(A,Xs,I,Y4)) ) ).

% list_update_code(3)
tff(fact_6261_list__update__code_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: A] : ( list_update(A,aa(list(A),list(A),cons(A,X3),Xs),zero_zero(nat),Y4) = aa(list(A),list(A),cons(A,Y4),Xs) ) ).

% list_update_code(2)
tff(fact_6262_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( distinct(A,aa(list(A),list(A),cons(A,X3),Xs))
    <=> ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
        & distinct(A,Xs) ) ) ).

% distinct.simps(2)
tff(fact_6263_replicate__Suc,axiom,
    ! [A: $tType,N: nat,X3: A] : ( replicate(A,aa(nat,nat,suc,N),X3) = aa(list(A),list(A),cons(A,X3),replicate(A,N,X3)) ) ).

% replicate_Suc
tff(fact_6264_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys2: list(A),Z: A] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
     => pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),aa(list(A),list(A),cons(A,Z),Zs)),shuffles(A,Xs,aa(list(A),list(A),cons(A,Z),Ys2)))) ) ).

% Cons_in_shuffles_rightI
tff(fact_6265_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys2: list(A),Z: A] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
     => pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),aa(list(A),list(A),cons(A,Z),Zs)),shuffles(A,aa(list(A),list(A),cons(A,Z),Xs),Ys2))) ) ).

% Cons_in_shuffles_leftI
tff(fact_6266_distinct__length__2__or__more,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list(A)] :
      ( distinct(A,aa(list(A),list(A),cons(A,A3),aa(list(A),list(A),cons(A,B2),Xs)))
    <=> ( ( A3 != B2 )
        & distinct(A,aa(list(A),list(A),cons(A,A3),Xs))
        & distinct(A,aa(list(A),list(A),cons(A,B2),Xs)) ) ) ).

% distinct_length_2_or_more
tff(fact_6267_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y4: A,X222: list(A),X21: A] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),aa(list(A),set(A),set2(A),X222)))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X21),X222)))) ) ).

% list.set_intros(2)
tff(fact_6268_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X21),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X21),X222)))) ).

% list.set_intros(1)
tff(fact_6269_list_Oset__cases,axiom,
    ! [A: $tType,E: A,A3: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),E),aa(list(A),set(A),set2(A),A3)))
     => ( ! [Z22: list(A)] : ( A3 != aa(list(A),list(A),cons(A,E),Z22) )
       => ~ ! [Z12: A,Z22: list(A)] :
              ( ( A3 = aa(list(A),list(A),cons(A,Z12),Z22) )
             => ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),E),aa(list(A),set(A),set2(A),Z22))) ) ) ) ).

% list.set_cases
tff(fact_6270_set__ConsD,axiom,
    ! [A: $tType,Y4: A,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X3),Xs))))
     => ( ( Y4 = X3 )
        | pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% set_ConsD
tff(fact_6271_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),I: nat,V: A] : ( list_update(A,aa(list(A),list(A),cons(A,X3),Xs),I,V) = case_nat(list(A),aa(list(A),list(A),cons(A,V),Xs),aa(A,fun(nat,list(A)),aa(list(A),fun(A,fun(nat,list(A))),aTP_Lamp_qe(A,fun(list(A),fun(A,fun(nat,list(A)))),X3),Xs),V),I) ) ).

% list_update.simps(2)
tff(fact_6272_not__Cons__self2,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( aa(list(A),list(A),cons(A,X3),Xs) != Xs ) ).

% not_Cons_self2
tff(fact_6273_member__rec_I1_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: A] :
      ( member(A,aa(list(A),list(A),cons(A,X3),Xs),Y4)
    <=> ( ( X3 = Y4 )
        | member(A,Xs,Y4) ) ) ).

% member_rec(1)
tff(fact_6274_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Y4: A,Xs: list(A)] :
      ( ( ( X3 = Y4 )
       => ( remove1(A,X3,aa(list(A),list(A),cons(A,Y4),Xs)) = Xs ) )
      & ( ( X3 != Y4 )
       => ( remove1(A,X3,aa(list(A),list(A),cons(A,Y4),Xs)) = aa(list(A),list(A),cons(A,Y4),remove1(A,X3,Xs)) ) ) ) ).

% remove1.simps(2)
tff(fact_6275_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Y4: A,Xs: list(A)] :
      ( ( ( X3 = Y4 )
       => ( aa(list(A),list(A),removeAll(A,X3),aa(list(A),list(A),cons(A,Y4),Xs)) = aa(list(A),list(A),removeAll(A,X3),Xs) ) )
      & ( ( X3 != Y4 )
       => ( aa(list(A),list(A),removeAll(A,X3),aa(list(A),list(A),cons(A,Y4),Xs)) = aa(list(A),list(A),cons(A,Y4),aa(list(A),list(A),removeAll(A,X3),Xs)) ) ) ) ).

% removeAll.simps(2)
tff(fact_6276_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X3: product_prod(fun(A,B),product_prod(list(A),list(B)))] :
      ( ! [F4: fun(A,B),Bs2: list(B)] : ( X3 != aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),product_Pair(fun(A,B),product_prod(list(A),list(B)),F4),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),nil(A)),Bs2)) )
     => ~ ! [F4: fun(A,B),A5: A,As: list(A),Bs2: list(B)] : ( X3 != aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),product_Pair(fun(A,B),product_prod(list(A),list(B)),F4),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),aa(list(A),list(A),cons(A,A5),As)),Bs2)) ) ) ).

% map_tailrec_rev.cases
tff(fact_6277_successively_Ocases,axiom,
    ! [A: $tType,X3: product_prod(fun(A,fun(A,bool)),list(A))] :
      ( ! [P5: fun(A,fun(A,bool))] : ( X3 != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),P5),nil(A)) )
     => ( ! [P5: fun(A,fun(A,bool)),X2: A] : ( X3 != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),P5),aa(list(A),list(A),cons(A,X2),nil(A))) )
       => ~ ! [P5: fun(A,fun(A,bool)),X2: A,Y2: A,Xs2: list(A)] : ( X3 != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),P5),aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Xs2))) ) ) ) ).

% successively.cases
tff(fact_6278_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X3: product_prod(fun(A,B),list(A))] :
          ( ! [F4: fun(A,B),X2: A] : ( X3 != aa(list(A),product_prod(fun(A,B),list(A)),product_Pair(fun(A,B),list(A),F4),aa(list(A),list(A),cons(A,X2),nil(A))) )
         => ( ! [F4: fun(A,B),X2: A,Y2: A,Zs2: list(A)] : ( X3 != aa(list(A),product_prod(fun(A,B),list(A)),product_Pair(fun(A,B),list(A),F4),aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Zs2))) )
           => ~ ! [A5: fun(A,B)] : ( X3 != aa(list(A),product_prod(fun(A,B),list(A)),product_Pair(fun(A,B),list(A),A5),nil(A)) ) ) ) ) ).

% arg_min_list.cases
tff(fact_6279_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X3: product_prod(fun(A,fun(A,bool)),list(A))] :
      ( ! [P5: fun(A,fun(A,bool))] : ( X3 != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),P5),nil(A)) )
     => ~ ! [P5: fun(A,fun(A,bool)),X2: A,Ys3: list(A)] : ( X3 != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),P5),aa(list(A),list(A),cons(A,X2),Ys3)) ) ) ).

% sorted_wrt.cases
tff(fact_6280_shuffles_Ocases,axiom,
    ! [A: $tType,X3: product_prod(list(A),list(A))] :
      ( ! [Ys3: list(A)] : ( X3 != aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Ys3) )
     => ( ! [Xs2: list(A)] : ( X3 != aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs2),nil(A)) )
       => ~ ! [X2: A,Xs2: list(A),Y2: A,Ys3: list(A)] : ( X3 != aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X2),Xs2)),aa(list(A),list(A),cons(A,Y2),Ys3)) ) ) ) ).

% shuffles.cases
tff(fact_6281_splice_Ocases,axiom,
    ! [A: $tType,X3: product_prod(list(A),list(A))] :
      ( ! [Ys3: list(A)] : ( X3 != aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Ys3) )
     => ~ ! [X2: A,Xs2: list(A),Ys3: list(A)] : ( X3 != aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Ys3) ) ) ).

% splice.cases
tff(fact_6282_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list(A),P: fun(list(A),bool)] :
      ( ( Xs != nil(A) )
     => ( ! [X2: A] : pp(aa(list(A),bool,P,aa(list(A),list(A),cons(A,X2),nil(A))))
       => ( ! [X2: A,Xs2: list(A)] :
              ( ( Xs2 != nil(A) )
             => ( pp(aa(list(A),bool,P,Xs2))
               => pp(aa(list(A),bool,P,aa(list(A),list(A),cons(A,X2),Xs2))) ) )
         => pp(aa(list(A),bool,P,Xs)) ) ) ) ).

% list_nonempty_induct
tff(fact_6283_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P: fun(list(A),fun(list(B),bool)),Xs: list(A),Ys2: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,nil(A)),nil(B)))
     => ( ! [X2: A,Xs2: list(A)] : pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,aa(list(A),list(A),cons(A,X2),Xs2)),nil(B)))
       => ( ! [Y2: B,Ys3: list(B)] : pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,nil(A)),aa(list(B),list(B),cons(B,Y2),Ys3)))
         => ( ! [X2: A,Xs2: list(A),Y2: B,Ys3: list(B)] :
                ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,Xs2),Ys3))
               => pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,aa(list(A),list(A),cons(A,X2),Xs2)),aa(list(B),list(B),cons(B,Y2),Ys3))) )
           => pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),P,Xs),Ys2)) ) ) ) ) ).

% list_induct2'
tff(fact_6284_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
    <=> ? [Y: A,Ys4: list(A)] : ( Xs = aa(list(A),list(A),cons(A,Y),Ys4) ) ) ).

% neq_Nil_conv
tff(fact_6285_remdups__adj_Ocases,axiom,
    ! [A: $tType,X3: list(A)] :
      ( ( X3 != nil(A) )
     => ( ! [X2: A] : ( X3 != aa(list(A),list(A),cons(A,X2),nil(A)) )
       => ~ ! [X2: A,Y2: A,Xs2: list(A)] : ( X3 != aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Xs2)) ) ) ) ).

% remdups_adj.cases
tff(fact_6286_transpose_Ocases,axiom,
    ! [A: $tType,X3: list(list(A))] :
      ( ( X3 != nil(list(A)) )
     => ( ! [Xss2: list(list(A))] : ( X3 != aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2) )
       => ~ ! [X2: A,Xs2: list(A),Xss2: list(list(A))] : ( X3 != aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Xss2) ) ) ) ).

% transpose.cases
tff(fact_6287_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X3: list(A)] :
          ( ! [X2: A,Xs2: list(A)] : ( X3 != aa(list(A),list(A),cons(A,X2),Xs2) )
         => ( X3 = nil(A) ) ) ) ).

% min_list.cases
tff(fact_6288_list_Oexhaust,axiom,
    ! [A: $tType,Y4: list(A)] :
      ( ( Y4 != nil(A) )
     => ~ ! [X212: A,X223: list(A)] : ( Y4 != aa(list(A),list(A),cons(A,X212),X223) ) ) ).

% list.exhaust
tff(fact_6289_list_OdiscI,axiom,
    ! [A: $tType,List: list(A),X21: A,X222: list(A)] :
      ( ( List = aa(list(A),list(A),cons(A,X21),X222) )
     => ( List != nil(A) ) ) ).

% list.discI
tff(fact_6290_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( nil(A) != aa(list(A),list(A),cons(A,X21),X222) ) ).

% list.distinct(1)
tff(fact_6291_sorted__wrt1,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),X3: A] : sorted_wrt(A,P,aa(list(A),list(A),cons(A,X3),nil(A))) ).

% sorted_wrt1
tff(fact_6292_distinct__singleton,axiom,
    ! [A: $tType,X3: A] : distinct(A,aa(list(A),list(A),cons(A,X3),nil(A))) ).

% distinct_singleton
tff(fact_6293_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A)] :
      ( ( pp(aa(A,bool,P,X3))
       => ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),filter2(A,P),Xs)) ) )
      & ( ~ pp(aa(A,bool,P,X3))
       => ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),filter2(A,P),Xs) ) ) ) ).

% filter.simps(2)
tff(fact_6294_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),A,hd(A),aa(list(A),list(A),cons(A,X21),X222)) = X21 ) ).

% list.sel(1)
tff(fact_6295_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),X3: B,Y4: B,Ys2: list(B)] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X3)),aa(B,A,F2,Y4)))
           => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),aa(list(B),list(B),cons(B,Y4),Ys2)) = aa(list(B),list(B),cons(B,X3),aa(list(B),list(B),cons(B,Y4),Ys2)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X3)),aa(B,A,F2,Y4)))
           => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),aa(list(B),list(B),cons(B,Y4),Ys2)) = aa(list(B),list(B),cons(B,Y4),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),X3),Ys2)) ) ) ) ) ).

% insort_key.simps(2)
tff(fact_6296_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list(A),X3: A] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X3),Xs)))) ).

% set_subset_Cons
tff(fact_6297_sorted2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A,Zs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),cons(A,Y4),Zs)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
            & sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,Y4),Zs)) ) ) ) ).

% sorted2
tff(fact_6298_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( remdups(A,aa(list(A),list(A),cons(A,X3),Xs)) = remdups(A,Xs) ) )
      & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( remdups(A,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),remdups(A,Xs)) ) ) ) ).

% remdups.simps(2)
tff(fact_6299_List_Oinsert__def,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( insert(A,X3,Xs) = Xs ) )
      & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( insert(A,X3,Xs) = aa(list(A),list(A),cons(A,X3),Xs) ) ) ) ).

% List.insert_def
tff(fact_6300_take__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] : ( take(A,N,aa(list(A),list(A),cons(A,X3),Xs)) = case_nat(list(A),nil(A),aa(list(A),fun(nat,list(A)),aTP_Lamp_qf(A,fun(list(A),fun(nat,list(A))),X3),Xs),N) ) ).

% take_Cons
tff(fact_6301_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A)] : pp(aa(set(list(A)),bool,aa(set(list(A)),fun(set(list(A)),bool),ord_less_eq(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,X3)),shuffles(A,Xs,Ys2))),shuffles(A,aa(list(A),list(A),cons(A,X3),Xs),Ys2))) ).

% Cons_shuffles_subset1
tff(fact_6302_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y4: A,Xs: list(A),Ys2: list(A)] : pp(aa(set(list(A)),bool,aa(set(list(A)),fun(set(list(A)),bool),ord_less_eq(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y4)),shuffles(A,Xs,Ys2))),shuffles(A,Xs,aa(list(A),list(A),cons(A,Y4),Ys2)))) ).

% Cons_shuffles_subset2
tff(fact_6303_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y4: A,Ys2: list(A),Xs: list(A)] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),aa(list(A),list(A),cons(A,Y4),Ys2)),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs))))
     => pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Ys2),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs)))) ) ).

% Cons_in_subseqsD
tff(fact_6304_nth__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list(A),N: nat] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),N) = case_nat(A,X3,nth(A,Xs),N) ) ).

% nth_Cons
tff(fact_6305_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,N)),aa(list(A),nat,size_size(list(A)),Xs)))
    <=> ? [X4: A,Ys4: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,X4),Ys4) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(list(A),nat,size_size(list(A)),Ys4))) ) ) ).

% Suc_le_length_iff
tff(fact_6306_sorted1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A] : sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,X3),nil(A))) ) ).

% sorted1
tff(fact_6307_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Ys2: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,X3),Ys2))
        <=> ( ! [X4: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Ys2)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),X4)) )
            & sorted_wrt(A,ord_less_eq(A),Ys2) ) ) ) ).

% sorted_simps(2)
tff(fact_6308_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Ys2: list(A)] :
          ( sorted_wrt(A,ord_less(A),aa(list(A),list(A),cons(A,X3),Ys2))
        <=> ( ! [X4: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Ys2)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),X4)) )
            & sorted_wrt(A,ord_less(A),Ys2) ) ) ) ).

% strict_sorted_simps(2)
tff(fact_6309_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Xs: list(B),F2: fun(B,A),A3: B] :
          ( ! [X2: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(list(B),set(B),set2(B),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,A3)),aa(B,A,F2,X2))) )
         => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),A3),Xs) = aa(list(B),list(B),cons(B,A3),Xs) ) ) ) ).

% insort_is_Cons
tff(fact_6310_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list(A),Y4: A,Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),aa(list(A),list(A),cons(A,Y4),Ys2))),listrel1(A,R2)))
     => ( ! [X2: A] :
            ( ( Xs = aa(list(A),list(A),cons(A,X2),Ys2) )
           => ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X2),Y4)),R2)) )
       => ~ ! [Zs2: list(A)] :
              ( ( Xs = aa(list(A),list(A),cons(A,Y4),Zs2) )
             => ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Zs2),Ys2)),listrel1(A,R2))) ) ) ) ).

% Cons_listrel1E2
tff(fact_6311_Cons__listrel1E1,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),Ys2)),listrel1(A,R2)))
     => ( ! [Y2: A] :
            ( ( Ys2 = aa(list(A),list(A),cons(A,Y2),Xs) )
           => ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y2)),R2)) )
       => ~ ! [Zs2: list(A)] :
              ( ( Ys2 = aa(list(A),list(A),cons(A,X3),Zs2) )
             => ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Zs2)),listrel1(A,R2))) ) ) ) ).

% Cons_listrel1E1
tff(fact_6312_listrel1I1,axiom,
    ! [A: $tType,X3: A,Y4: A,R2: set(product_prod(A,A)),Xs: list(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),R2))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(A),list(A),cons(A,Y4),Xs))),listrel1(A,R2))) ) ).

% listrel1I1
tff(fact_6313_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Y4: A,Xs: list(A)] :
      ( ( ( X3 = Y4 )
       => ( aa(A,nat,count_list(A,aa(list(A),list(A),cons(A,X3),Xs)),Y4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,count_list(A,Xs),Y4)),one_one(nat)) ) )
      & ( ( X3 != Y4 )
       => ( aa(A,nat,count_list(A,aa(list(A),list(A),cons(A,X3),Xs)),Y4) = aa(A,nat,count_list(A,Xs),Y4) ) ) ) ).

% count_list.simps(2)
tff(fact_6314_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),cons(A,X21),X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),X222)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size(4)
tff(fact_6315_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( n_lists(A,aa(nat,nat,suc,N),Xs) = concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),aTP_Lamp_qh(list(A),fun(list(A),list(list(A))),Xs)),n_lists(A,N,Xs))) ) ).

% n_lists.simps(2)
tff(fact_6316_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),N) = X3 ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),N) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ) ).

% nth_Cons'
tff(fact_6317_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X3: fun(A,nat),X21: A,X222: list(A)] : ( aa(list(A),nat,size_list(A,X3),aa(list(A),list(A),cons(A,X21),X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,X3,X21)),aa(list(A),nat,size_list(A,X3),X222))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size_gen(2)
tff(fact_6318_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list(A),A1: list(A),P: fun(list(A),fun(list(A),bool))] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),A0),A1)))
     => ( ! [Ys3: list(A)] :
            ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Ys3)))
           => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,nil(A)),Ys3)) )
       => ( ! [Xs2: list(A)] :
              ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs2),nil(A))))
             => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,Xs2),nil(A))) )
         => ( ! [X2: A,Xs2: list(A),Y2: A,Ys3: list(A)] :
                ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X2),Xs2)),aa(list(A),list(A),cons(A,Y2),Ys3))))
               => ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,Xs2),aa(list(A),list(A),cons(A,Y2),Ys3)))
                 => ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,aa(list(A),list(A),cons(A,X2),Xs2)),Ys3))
                   => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,aa(list(A),list(A),cons(A,X2),Xs2)),aa(list(A),list(A),cons(A,Y2),Ys3))) ) ) )
           => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,A0),A1)) ) ) ) ) ).

% shuffles.pinduct
tff(fact_6319_map__upt__Suc,axiom,
    ! [A: $tType,F2: fun(nat,A),N: nat] : ( aa(list(nat),list(A),map(nat,A,F2),upt(zero_zero(nat),aa(nat,nat,suc,N))) = aa(list(A),list(A),cons(A,aa(nat,A,F2,zero_zero(nat))),aa(list(nat),list(A),map(nat,A,aTP_Lamp_qi(fun(nat,A),fun(nat,A),F2)),upt(zero_zero(nat),N))) ) ).

% map_upt_Suc
tff(fact_6320_nth__equal__first__eq,axiom,
    ! [A: $tType,X3: A,Xs: list(A),N: nat] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),N) = X3 )
        <=> ( N = zero_zero(nat) ) ) ) ) ).

% nth_equal_first_eq
tff(fact_6321_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X3: A,Y4: A,Xs: list(A),N: nat] :
      ( ( X3 != Y4 )
     => ( ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X3),Xs)),N) = Y4 )
      <=> ( ( aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) = Y4 )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ) ).

% nth_non_equal_first_eq
tff(fact_6322_take__Cons_H,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] :
      ( ( ( N = zero_zero(nat) )
       => ( take(A,N,aa(list(A),list(A),cons(A,X3),Xs)) = nil(A) ) )
      & ( ( N != zero_zero(nat) )
       => ( take(A,N,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),Xs)) ) ) ) ).

% take_Cons'
tff(fact_6323_Cons__replicate__eq,axiom,
    ! [A: $tType,X3: A,Xs: list(A),N: nat,Y4: A] :
      ( ( aa(list(A),list(A),cons(A,X3),Xs) = replicate(A,N,Y4) )
    <=> ( ( X3 = Y4 )
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
        & ( Xs = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),X3) ) ) ) ).

% Cons_replicate_eq
tff(fact_6324_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A2: set(A)] : ( set_Cons(A,A2,aa(set(list(A)),set(list(A)),insert2(list(A),nil(A)),bot_bot(set(list(A))))) = aa(set(A),set(list(A)),image(A,list(A),aTP_Lamp_qj(A,list(A))),A2) ) ).

% set_Cons_sing_Nil
tff(fact_6325_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_qk(A,fun(list(A),list(A))))),Xss)) = aa(list(list(A)),list(A),map(list(A),A,hd(A)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_ow(list(A),bool)),Xss)) ) ).

% transpose_aux_filter_head
tff(fact_6326_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N)))
       => ( upt(aa(num,nat,numeral_numeral(nat),M),aa(num,nat,numeral_numeral(nat),N)) = aa(list(nat),list(nat),cons(nat,aa(num,nat,numeral_numeral(nat),M)),upt(aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N))) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N)))
       => ( upt(aa(num,nat,numeral_numeral(nat),M),aa(num,nat,numeral_numeral(nat),N)) = nil(nat) ) ) ) ).

% upt_rec_numeral
tff(fact_6327_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N = zero_zero(nat) )
       => ( n_lists(A,N,nil(A)) = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))) ) )
      & ( ( N != zero_zero(nat) )
       => ( n_lists(A,N,nil(A)) = nil(list(A)) ) ) ) ).

% n_lists_Nil
tff(fact_6328_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss)) = transpose(A,Xss) ) ).

% transpose.simps(2)
tff(fact_6329_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: fun(A,fun(list(A),B)),X21: A,X222: list(A)] : ( aa(list(A),B,case_list(B,A,F1,F22),aa(list(A),list(A),cons(A,X21),X222)) = aa(list(A),B,aa(A,fun(list(A),B),F22,X21),X222) ) ).

% list.simps(5)
tff(fact_6330_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N: nat,Ns: list(nat),Q2: nat] :
      ( ( aa(list(nat),list(nat),cons(nat,M),aa(list(nat),list(nat),cons(nat,N),Ns)) = upt(M,Q2) )
    <=> ( aa(list(nat),list(nat),cons(nat,N),Ns) = upt(aa(nat,nat,suc,M),Q2) ) ) ).

% upt_conv_Cons_Cons
tff(fact_6331_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A2: set(A),As2: list(set(A))] : ( listset(A,aa(list(set(A)),list(set(A)),cons(set(A),A2),As2)) = set_Cons(A,A2,listset(A,As2)) ) ).

% listset.simps(2)
tff(fact_6332_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: fun(A,fun(list(A),B))] : ( aa(list(A),B,case_list(B,A,F1,F22),nil(A)) = F1 ) ).

% list.simps(4)
tff(fact_6333_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H: fun(B,C),F1: B,F22: fun(A,fun(list(A),B)),List: list(A)] : ( aa(B,C,H,aa(list(A),B,case_list(B,A,F1,F22),List)) = aa(list(A),C,case_list(C,A,aa(B,C,H,F1),aa(fun(A,fun(list(A),B)),fun(A,fun(list(A),C)),aTP_Lamp_ql(fun(B,C),fun(fun(A,fun(list(A),B)),fun(A,fun(list(A),C))),H),F22)),List) ) ).

% list.case_distrib
tff(fact_6334_upt__conv__Cons,axiom,
    ! [I: nat,J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
     => ( upt(I,J3) = aa(list(nat),list(nat),cons(nat,I),upt(aa(nat,nat,suc,I),J3)) ) ) ).

% upt_conv_Cons
tff(fact_6335_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] : ( subseqs(A,nil(A)) = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))) ) ).

% subseqs.simps(1)
tff(fact_6336_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] : ( product_lists(A,nil(list(A))) = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))) ) ).

% product_lists.simps(1)
tff(fact_6337_upt__eq__Cons__conv,axiom,
    ! [I: nat,J3: nat,X3: nat,Xs: list(nat)] :
      ( ( upt(I,J3) = aa(list(nat),list(nat),cons(nat,X3),Xs) )
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
        & ( I = X3 )
        & ( upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),one_one(nat)),J3) = Xs ) ) ) ).

% upt_eq_Cons_conv
tff(fact_6338_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Xss: list(list(A))] : ( transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X3),Xs)),Xss)) = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X3),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_qk(A,fun(list(A),list(A))))),Xss)))),transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_qm(A,fun(list(A),list(list(A)))))),Xss))))) ) ).

% transpose.simps(3)
tff(fact_6339_transpose_Oelims,axiom,
    ! [A: $tType,X3: list(list(A)),Y4: list(list(A))] :
      ( ( transpose(A,X3) = Y4 )
     => ( ( ( X3 = nil(list(A)) )
         => ( Y4 != nil(list(A)) ) )
       => ( ! [Xss2: list(list(A))] :
              ( ( X3 = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2) )
             => ( Y4 != transpose(A,Xss2) ) )
         => ~ ! [X2: A,Xs2: list(A),Xss2: list(list(A))] :
                ( ( X3 = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Xss2) )
               => ( Y4 != aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_qk(A,fun(list(A),list(A))))),Xss2)))),transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_qm(A,fun(list(A),list(list(A)))))),Xss2))))) ) ) ) ) ) ).

% transpose.elims
tff(fact_6340_upt__rec,axiom,
    ! [I: nat,J3: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
       => ( upt(I,J3) = aa(list(nat),list(nat),cons(nat,I),upt(aa(nat,nat,suc,I),J3)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),J3))
       => ( upt(I,J3) = nil(nat) ) ) ) ).

% upt_rec
tff(fact_6341_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list(A)] : ( n_lists(A,zero_zero(nat),Xs) = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))) ) ).

% n_lists.simps(1)
tff(fact_6342_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I: nat,J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,I)),J3))
     => ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or3652927894154168847AtMost(nat,I,J3)) = aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,I)),aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or3652927894154168847AtMost(nat,aa(nat,nat,suc,I),J3))) ) ) ).

% sorted_list_of_set_greaterThanAtMost
tff(fact_6343_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I: nat,J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,I)),J3))
     => ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or5935395276787703475ssThan(nat,I,J3)) = aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,I)),aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or5935395276787703475ssThan(nat,aa(nat,nat,suc,I),J3))) ) ) ).

% sorted_list_of_set_greaterThanLessThan
tff(fact_6344_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Xss: list(list(A))] :
      ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X3),Xs)),Xss)))
     => ( transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X3),Xs)),Xss)) = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X3),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_qk(A,fun(list(A),list(A))))),Xss)))),transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_qm(A,fun(list(A),list(list(A)))))),Xss))))) ) ) ).

% transpose.psimps(3)
tff(fact_6345_transpose_Opelims,axiom,
    ! [A: $tType,X3: list(list(A)),Y4: list(list(A))] :
      ( ( transpose(A,X3) = Y4 )
     => ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),X3))
       => ( ( ( X3 = nil(list(A)) )
           => ( ( Y4 = nil(list(A)) )
             => ~ pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),nil(list(A)))) ) )
         => ( ! [Xss2: list(list(A))] :
                ( ( X3 = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2) )
               => ( ( Y4 = transpose(A,Xss2) )
                 => ~ pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2))) ) )
           => ~ ! [X2: A,Xs2: list(A),Xss2: list(list(A))] :
                  ( ( X3 = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Xss2) )
                 => ( ( Y4 = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_qk(A,fun(list(A),list(A))))),Xss2)))),transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_qm(A,fun(list(A),list(list(A)))))),Xss2))))) )
                   => ~ pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Xss2))) ) ) ) ) ) ) ).

% transpose.pelims
tff(fact_6346_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List = nil(A) )
    <=> pp(aa(list(A),bool,case_list(bool,A,fTrue,aTP_Lamp_qn(A,fun(list(A),bool))),List)) ) ).

% list.disc_eq_case(1)
tff(fact_6347_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List != nil(A) )
    <=> pp(aa(list(A),bool,case_list(bool,A,fFalse,aTP_Lamp_qo(A,fun(list(A),bool))),List)) ) ).

% list.disc_eq_case(2)
tff(fact_6348_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),nil(list(A))))
     => ( transpose(A,nil(list(A))) = nil(list(A)) ) ) ).

% transpose.psimps(1)
tff(fact_6349_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list(list(A))] :
      ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss)))
     => ( transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss)) = transpose(A,Xss) ) ) ).

% transpose.psimps(2)
tff(fact_6350_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list(list(A)),P: fun(list(list(A)),bool)] :
      ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),A0))
     => ( ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),nil(list(A))))
         => pp(aa(list(list(A)),bool,P,nil(list(A)))) )
       => ( ! [Xss2: list(list(A))] :
              ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2)))
             => ( pp(aa(list(list(A)),bool,P,Xss2))
               => pp(aa(list(list(A)),bool,P,aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2))) ) )
         => ( ! [X2: A,Xs2: list(A),Xss2: list(list(A))] :
                ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Xss2)))
               => ( pp(aa(list(list(A)),bool,P,aa(list(list(A)),list(list(A)),cons(list(A),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_qm(A,fun(list(A),list(list(A)))))),Xss2)))))
                 => pp(aa(list(list(A)),bool,P,aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Xss2))) ) )
           => pp(aa(list(list(A)),bool,P,A0)) ) ) ) ) ).

% transpose.pinduct
tff(fact_6351_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_qm(A,fun(list(A),list(list(A)))))),Xss)) = aa(list(list(A)),list(list(A)),map(list(A),list(A),tl(A)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_ow(list(A),bool)),Xss)) ) ).

% transpose_aux_filter_tail
tff(fact_6352_list__encode_Oelims,axiom,
    ! [X3: list(nat),Y4: nat] :
      ( ( nat_list_encode(X3) = Y4 )
     => ( ( ( X3 = nil(nat) )
         => ( Y4 != zero_zero(nat) ) )
       => ~ ! [X2: nat,Xs2: list(nat)] :
              ( ( X3 = aa(list(nat),list(nat),cons(nat,X2),Xs2) )
             => ( Y4 != aa(nat,nat,suc,aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X2),nat_list_encode(Xs2)))) ) ) ) ) ).

% list_encode.elims
tff(fact_6353_tl__upt,axiom,
    ! [M: nat,N: nat] : ( aa(list(nat),list(nat),tl(nat),upt(M,N)) = upt(aa(nat,nat,suc,M),N) ) ).

% tl_upt
tff(fact_6354_length__tl,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),tl(A),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)) ) ).

% length_tl
tff(fact_6355_list_Ocollapse,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List != nil(A) )
     => ( aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)) = List ) ) ).

% list.collapse
tff(fact_6356_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),Xs)),aa(list(A),list(A),tl(A),Xs)) = Xs ) ) ).

% hd_Cons_tl
tff(fact_6357_tl__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] : ( aa(list(A),list(A),tl(A),replicate(A,N,X3)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),X3) ) ).

% tl_replicate
tff(fact_6358_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),list(A),tl(A),aa(list(A),list(A),cons(A,X21),X222)) = X222 ) ).

% list.sel(3)
tff(fact_6359_tl__Nil,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),list(A),tl(A),Xs) = nil(A) )
    <=> ( ( Xs = nil(A) )
        | ? [X4: A] : ( Xs = aa(list(A),list(A),cons(A,X4),nil(A)) ) ) ) ).

% tl_Nil
tff(fact_6360_Nil__tl,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( nil(A) = aa(list(A),list(A),tl(A),Xs) )
    <=> ( ( Xs = nil(A) )
        | ? [X4: A] : ( Xs = aa(list(A),list(A),cons(A,X4),nil(A)) ) ) ) ).

% Nil_tl
tff(fact_6361_list_Oexpand,axiom,
    ! [A: $tType,List: list(A),List2: list(A)] :
      ( ( ( List = nil(A) )
      <=> ( List2 = nil(A) ) )
     => ( ( ( List != nil(A) )
         => ( ( List2 != nil(A) )
           => ( ( aa(list(A),A,hd(A),List) = aa(list(A),A,hd(A),List2) )
              & ( aa(list(A),list(A),tl(A),List) = aa(list(A),list(A),tl(A),List2) ) ) ) )
       => ( List = List2 ) ) ) ).

% list.expand
tff(fact_6362_list_Osel_I2_J,axiom,
    ! [A: $tType] : ( aa(list(A),list(A),tl(A),nil(A)) = nil(A) ) ).

% list.sel(2)
tff(fact_6363_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A3: list(A),X3: A] :
      ( ( A3 != nil(A) )
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),aa(list(A),list(A),tl(A),A3))))
       => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),A3))) ) ) ).

% list.set_sel(2)
tff(fact_6364_take__tl,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( take(A,N,aa(list(A),list(A),tl(A),Xs)) = aa(list(A),list(A),tl(A),take(A,aa(nat,nat,suc,N),Xs)) ) ).

% take_tl
tff(fact_6365_distinct__tl,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => distinct(A,aa(list(A),list(A),tl(A),Xs)) ) ).

% distinct_tl
tff(fact_6366_map__tl,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),tl(B),Xs)) = aa(list(A),list(A),tl(A),aa(list(B),list(A),map(B,A,F2),Xs)) ) ).

% map_tl
tff(fact_6367_sorted__tl,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),tl(A),Xs)) ) ) ).

% sorted_tl
tff(fact_6368_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A3: list(A),F2: fun(A,B)] :
      ( ( A3 != nil(A) )
     => ( aa(list(B),list(B),tl(B),aa(list(A),list(B),map(A,B,F2),A3)) = aa(list(A),list(B),map(A,B,F2),aa(list(A),list(A),tl(A),A3)) ) ) ).

% list.map_sel(2)
tff(fact_6369_tl__def,axiom,
    ! [A: $tType,List: list(A)] : ( aa(list(A),list(A),tl(A),List) = aa(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_qp(A,fun(list(A),list(A)))),List) ) ).

% tl_def
tff(fact_6370_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List != nil(A) )
     => ( List = aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)) ) ) ).

% list.exhaust_sel
tff(fact_6371_tl__take,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),tl(A),take(A,N,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),aa(list(A),list(A),tl(A),Xs)) ) ).

% tl_take
tff(fact_6372_list_Ocase__eq__if,axiom,
    ! [B: $tType,A: $tType,List: list(A),F1: B,F22: fun(A,fun(list(A),B))] :
      ( ( ( List = nil(A) )
       => ( aa(list(A),B,case_list(B,A,F1,F22),List) = F1 ) )
      & ( ( List != nil(A) )
       => ( aa(list(A),B,case_list(B,A,F1,F22),List) = aa(list(A),B,aa(A,fun(list(A),B),F22,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)) ) ) ) ).

% list.case_eq_if
tff(fact_6373_list__encode_Osimps_I1_J,axiom,
    nat_list_encode(nil(nat)) = zero_zero(nat) ).

% list_encode.simps(1)
tff(fact_6374_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( ( Xs = nil(A) )
       => ( aa(list(A),nat,size_size(list(A)),Xs) = zero_zero(nat) ) )
      & ( ( Xs != nil(A) )
       => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),tl(A),Xs))) ) ) ) ).

% Nitpick.size_list_simp(2)
tff(fact_6375_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),tl(A),Xs))))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),tl(A),Xs)),N) = aa(nat,A,nth(A,Xs),aa(nat,nat,suc,N)) ) ) ).

% nth_tl
tff(fact_6376_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z: A,Zs: list(A),Xs: list(A),Ys2: list(A)] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),aa(list(A),list(A),cons(A,Z),Zs)),shuffles(A,Xs,Ys2)))
    <=> ( ( ( Xs != nil(A) )
          & ( aa(list(A),A,hd(A),Xs) = Z )
          & pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,aa(list(A),list(A),tl(A),Xs),Ys2))) )
        | ( ( Ys2 != nil(A) )
          & ( aa(list(A),A,hd(A),Ys2) = Z )
          & pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,aa(list(A),list(A),tl(A),Ys2)))) ) ) ) ).

% Cons_in_shuffles_iff
tff(fact_6377_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: fun(B,bool),F1: B,F22: fun(A,fun(list(A),B)),List: list(A)] :
      ( pp(aa(B,bool,P,aa(list(A),B,case_list(B,A,F1,F22),List)))
    <=> ~ ( ( ( List = nil(A) )
            & ~ pp(aa(B,bool,P,F1)) )
          | ( ( List = aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)) )
            & ~ pp(aa(B,bool,P,aa(list(A),B,aa(A,fun(list(A),B),F22,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)))) ) ) ) ).

% list.split_sel_asm
tff(fact_6378_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: fun(B,bool),F1: B,F22: fun(A,fun(list(A),B)),List: list(A)] :
      ( pp(aa(B,bool,P,aa(list(A),B,case_list(B,A,F1,F22),List)))
    <=> ( ( ( List = nil(A) )
         => pp(aa(B,bool,P,F1)) )
        & ( ( List = aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)) )
         => pp(aa(B,bool,P,aa(list(A),B,aa(A,fun(list(A),B),F22,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)))) ) ) ) ).

% list.split_sel
tff(fact_6379_take__Suc,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( ( Xs != nil(A) )
     => ( take(A,aa(nat,nat,suc,N),Xs) = aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),Xs)),take(A,N,aa(list(A),list(A),tl(A),Xs))) ) ) ).

% take_Suc
tff(fact_6380_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType,Xs: list(A),F2: fun(A,nat)] :
      ( ( ( Xs = nil(A) )
       => ( aa(list(A),nat,size_list(A,F2),Xs) = zero_zero(nat) ) )
      & ( ( Xs != nil(A) )
       => ( aa(list(A),nat,size_list(A,F2),Xs) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F2,aa(list(A),A,hd(A),Xs))),aa(list(A),nat,size_list(A,F2),aa(list(A),list(A),tl(A),Xs)))) ) ) ) ).

% Nitpick.size_list_simp(1)
tff(fact_6381_list__encode_Opelims,axiom,
    ! [X3: list(nat),Y4: nat] :
      ( ( nat_list_encode(X3) = Y4 )
     => ( pp(aa(list(nat),bool,accp(list(nat),nat_list_encode_rel),X3))
       => ( ( ( X3 = nil(nat) )
           => ( ( Y4 = zero_zero(nat) )
             => ~ pp(aa(list(nat),bool,accp(list(nat),nat_list_encode_rel),nil(nat))) ) )
         => ~ ! [X2: nat,Xs2: list(nat)] :
                ( ( X3 = aa(list(nat),list(nat),cons(nat,X2),Xs2) )
               => ( ( Y4 = aa(nat,nat,suc,aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X2),nat_list_encode(Xs2)))) )
                 => ~ pp(aa(list(nat),bool,accp(list(nat),nat_list_encode_rel),aa(list(nat),list(nat),cons(nat,X2),Xs2))) ) ) ) ) ) ).

% list_encode.pelims
tff(fact_6382_shuffles_Opelims,axiom,
    ! [A: $tType,X3: list(A),Xa: list(A),Y4: set(list(A))] :
      ( ( shuffles(A,X3,Xa) = Y4 )
     => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),Xa)))
       => ( ( ( X3 = nil(A) )
           => ( ( Y4 = aa(set(list(A)),set(list(A)),insert2(list(A),Xa),bot_bot(set(list(A)))) )
             => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Xa))) ) )
         => ( ( ( Xa = nil(A) )
             => ( ( Y4 = aa(set(list(A)),set(list(A)),insert2(list(A),X3),bot_bot(set(list(A)))) )
               => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),nil(A)))) ) )
           => ~ ! [X2: A,Xs2: list(A)] :
                  ( ( X3 = aa(list(A),list(A),cons(A,X2),Xs2) )
                 => ! [Y2: A,Ys3: list(A)] :
                      ( ( Xa = aa(list(A),list(A),cons(A,Y2),Ys3) )
                     => ( ( Y4 = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,X2)),shuffles(A,Xs2,aa(list(A),list(A),cons(A,Y2),Ys3)))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y2)),shuffles(A,aa(list(A),list(A),cons(A,X2),Xs2),Ys3))) )
                       => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X2),Xs2)),aa(list(A),list(A),cons(A,Y2),Ys3)))) ) ) ) ) ) ) ) ).

% shuffles.pelims
tff(fact_6383_le__sup__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4)),Z))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Z))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z)) ) ) ) ).

% le_sup_iff
tff(fact_6384_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% sup.bounded_iff
tff(fact_6385_Un__subset__iff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)),C6))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C6)) ) ) ).

% Un_subset_iff
tff(fact_6386_set__union,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : ( aa(list(A),set(A),set2(A),union(A,Xs,Ys2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) ) ).

% set_union
tff(fact_6387_Diff__subset__conv,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3)),C6))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C6))) ) ).

% Diff_subset_conv
tff(fact_6388_Diff__partition,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A2)) = B3 ) ) ).

% Diff_partition
tff(fact_6389_Un__Pow__subset,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] : pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),pow2(A,A2)),pow2(A,B3))),pow2(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)))) ).

% Un_Pow_subset
tff(fact_6390_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Y4: A,X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4))) ) ).

% inf_sup_ord(4)
tff(fact_6391_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4))) ) ).

% inf_sup_ord(3)
tff(fact_6392_le__supE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)),X3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),X3)) ) ) ) ).

% le_supE
tff(fact_6393_le__supI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,X3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),X3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)),X3)) ) ) ) ).

% le_supI
tff(fact_6394_sup__ge1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X3: A,Y4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4))) ) ).

% sup_ge1
tff(fact_6395_sup__ge2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y4: A,X3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4))) ) ).

% sup_ge2
tff(fact_6396_le__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X3: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% le_supI1
tff(fact_6397_le__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X3: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% le_supI2
tff(fact_6398_sup_Omono,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A3: A,D2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),C2),D2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ) ).

% sup.mono
tff(fact_6399_sup__mono,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),C2),D2))) ) ) ) ).

% sup_mono
tff(fact_6400_sup__least,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y4: A,X3: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z),X3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y4),Z)),X3)) ) ) ) ).

% sup_least
tff(fact_6401_le__iff__sup,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4) = Y4 ) ) ) ).

% le_iff_sup
tff(fact_6402_sup_OorderE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) ) ) ) ).

% sup.orderE
tff(fact_6403_sup_OorderI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% sup.orderI
tff(fact_6404_sup__unique,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [F2: fun(A,fun(A,A)),X3: A,Y4: A] :
          ( ! [X2: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),F2,X2),Y2)))
         => ( ! [X2: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),aa(A,A,aa(A,fun(A,A),F2,X2),Y2)))
           => ( ! [X2: A,Y2: A,Z4: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z4),X2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F2,Y2),Z4)),X2)) ) )
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4) = aa(A,A,aa(A,fun(A,A),F2,X3),Y4) ) ) ) ) ) ).

% sup_unique
tff(fact_6405_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = A3 ) ) ) ).

% sup.absorb1
tff(fact_6406_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = B2 ) ) ) ).

% sup.absorb2
tff(fact_6407_sup__absorb1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4) = X3 ) ) ) ).

% sup_absorb1
tff(fact_6408_sup__absorb2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4) = Y4 ) ) ) ).

% sup_absorb2
tff(fact_6409_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% sup.boundedE
tff(fact_6410_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A3)) ) ) ) ).

% sup.boundedI
tff(fact_6411_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) ) ) ) ).

% sup.order_iff
tff(fact_6412_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ).

% sup.cobounded1
tff(fact_6413_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ).

% sup.cobounded2
tff(fact_6414_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = A3 ) ) ) ).

% sup.absorb_iff1
tff(fact_6415_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = B2 ) ) ) ).

% sup.absorb_iff2
tff(fact_6416_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% sup.coboundedI1
tff(fact_6417_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% sup.coboundedI2
tff(fact_6418_subset__Un__eq,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3) = B3 ) ) ).

% subset_Un_eq
tff(fact_6419_subset__UnE,axiom,
    ! [A: $tType,C6: set(A),A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)))
     => ~ ! [A10: set(A)] :
            ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A10),A2))
           => ! [B14: set(A)] :
                ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B14),B3))
               => ( C6 != aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A10),B14) ) ) ) ) ).

% subset_UnE
tff(fact_6420_Un__absorb2,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3) = A2 ) ) ).

% Un_absorb2
tff(fact_6421_Un__absorb1,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3) = B3 ) ) ).

% Un_absorb1
tff(fact_6422_Un__upper2,axiom,
    ! [A: $tType,B3: set(A),A2: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3))) ).

% Un_upper2
tff(fact_6423_Un__upper1,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3))) ).

% Un_upper1
tff(fact_6424_Un__least,axiom,
    ! [A: $tType,A2: set(A),C6: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C6))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)),C6)) ) ) ).

% Un_least
tff(fact_6425_Un__mono,axiom,
    ! [A: $tType,A2: set(A),C6: set(A),B3: set(A),D4: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),D4))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),C6),D4))) ) ) ).

% Un_mono
tff(fact_6426_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
tff(fact_6427_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(3)
tff(fact_6428_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or3652927894154168847AtMost(A,M,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(6)
tff(fact_6429_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X3: A,Y4: A,Z: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Z))),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y4),Z)))) ) ).

% distrib_inf_le
tff(fact_6430_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X3: A,Y4: A,Z: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y4),Z))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Z)))) ) ).

% distrib_sup_le
tff(fact_6431_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),C6: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3)),C6) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C6)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),A2)) ) ).

% Un_Int_assoc_eq
tff(fact_6432_less__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X3: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% less_supI1
tff(fact_6433_less__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X3: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% less_supI2
tff(fact_6434_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = A3 ) ) ) ).

% sup.absorb3
tff(fact_6435_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = B2 ) ) ) ).

% sup.absorb4
tff(fact_6436_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% sup.strict_boundedE
tff(fact_6437_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
        <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) )
            & ( A3 != B2 ) ) ) ) ).

% sup.strict_order_iff
tff(fact_6438_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% sup.strict_coboundedI1
tff(fact_6439_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% sup.strict_coboundedI2
tff(fact_6440_set__shuffles,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys2: list(A)] :
      ( pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Zs),shuffles(A,Xs,Ys2)))
     => ( aa(list(A),set(A),set2(A),Zs) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) ) ) ).

% set_shuffles
tff(fact_6441_sup__shunt,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X3: A,Y4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),Y4) = top_top(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X3)),Y4)) ) ) ).

% sup_shunt
tff(fact_6442_shunt1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),Y4)),Z))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),Y4)),Z))) ) ) ).

% shunt1
tff(fact_6443_shunt2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),aa(A,A,uminus_uminus(A),Y4))),Z))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y4),Z))) ) ) ).

% shunt2
tff(fact_6444_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [P2: A,Q2: A,R2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Q2),R2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),P2),aa(A,A,uminus_uminus(A),Q2))),R2)) ) ) ).

% sup_neg_inf
tff(fact_6445_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A),B3: set(A)] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),A2)),aa(set(A),A,complete_Inf_Inf(A),B3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3)))) ) ).

% less_eq_Inf_inter
tff(fact_6446_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(7)
tff(fact_6447_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_lessThan(A,L)),set_or7035219750837199246ssThan(A,L,U)) = set_ord_lessThan(A,U) ) ) ) ).

% ivl_disj_un_one(2)
tff(fact_6448_card__Un__le,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3)))) ).

% card_Un_le
tff(fact_6449_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or3652927894154168847AtMost(A,M,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(8)
tff(fact_6450_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_atMost(A,L)),set_or3652927894154168847AtMost(A,L,U)) = set_ord_atMost(A,U) ) ) ) ).

% ivl_disj_un_one(3)
tff(fact_6451_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: A,Ys2: list(A)] : ( shuffles(A,aa(list(A),list(A),cons(A,X3),Xs),aa(list(A),list(A),cons(A,Y4),Ys2)) = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,X3)),shuffles(A,Xs,aa(list(A),list(A),cons(A,Y4),Ys2)))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y4)),shuffles(A,aa(list(A),list(A),cons(A,X3),Xs),Ys2))) ) ).

% shuffles.simps(3)
tff(fact_6452_Inter__Un__subset,axiom,
    ! [A: $tType,A2: set(set(A)),B3: set(set(A))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A2)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B3))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),A2),B3)))) ).

% Inter_Un_subset
tff(fact_6453_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
tff(fact_6454_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),B3: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B3)) ) ) ) ) ).

% sum.union_inter
tff(fact_6455_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),B3: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3))),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,A2)),groups7121269368397514597t_prod(B,A,G,B3)) ) ) ) ) ).

% prod.union_inter
tff(fact_6456_card__Un__Int,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( finite_finite(A,A2)
     => ( finite_finite(A,B3)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3))) ) ) ) ).

% card_Un_Int
tff(fact_6457_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
tff(fact_6458_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(1)
tff(fact_6459_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_lessThan(A,L)),set_or1337092689740270186AtMost(A,L,U)) = set_ord_atMost(A,U) ) ) ) ).

% ivl_disj_un_one(4)
tff(fact_6460_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or5935395276787703475ssThan(A,M,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(2)
tff(fact_6461_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_atMost(A,L)),set_or5935395276787703475ssThan(A,L,U)) = set_ord_lessThan(A,U) ) ) ) ).

% ivl_disj_un_one(1)
tff(fact_6462_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
tff(fact_6463_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A2: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_pr(A,fun(nat,A),B3)),collect(nat,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B3) ) ) ).

% SUP_nat_binary
tff(fact_6464_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => semila1105856199041335345_order(A,sup_sup(A),bot_bot(A),aTP_Lamp_qq(A,fun(A,bool)),aTP_Lamp_qr(A,fun(A,bool))) ) ).

% sup_bot.semilattice_neutr_order_axioms
tff(fact_6465_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),B3: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3)))
                 => ( aa(B,A,G,X2) = zero_zero(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B3)) ) ) ) ) ) ).

% sum.union_inter_neutral
tff(fact_6466_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [A2: set(B),B3: set(B),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))) ) ) ) ) ).

% sum_Un
tff(fact_6467_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),B3: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3) = bot_bot(set(B)) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B3)) ) ) ) ) ) ).

% sum.union_disjoint
tff(fact_6468_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),B3: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3)))
                 => ( aa(B,A,G,X2) = one_one(A) ) )
             => ( groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,A2)),groups7121269368397514597t_prod(B,A,G,B3)) ) ) ) ) ) ).

% prod.union_inter_neutral
tff(fact_6469_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),B3: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3) = bot_bot(set(B)) )
             => ( groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,A2)),groups7121269368397514597t_prod(B,A,G,B3)) ) ) ) ) ) ).

% prod.union_disjoint
tff(fact_6470_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,U)),aa(set(A),set(A),insert2(A,U),bot_bot(set(A)))) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(6)
tff(fact_6471_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A2: set(A),B3: set(A),F2: fun(A,B)] :
          ( finite_finite(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3))
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A2)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3))) ) ) ) ).

% sum_Un2
tff(fact_6472_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: set(B),B3: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B3),A2)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))) ) ) ) ) ).

% sum.union_diff2
tff(fact_6473_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: set(B),B3: set(B),G: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A2),B3))),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B3),A2)))),groups7121269368397514597t_prod(B,A,G,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))) ) ) ) ) ).

% prod.union_diff2
tff(fact_6474_card__Un__disjoint,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( finite_finite(A,A2)
     => ( finite_finite(A,B3)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3) = bot_bot(set(A)) )
         => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ) ).

% card_Un_disjoint
tff(fact_6475_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert2(A,L),bot_bot(set(A)))),set_or3652927894154168847AtMost(A,L,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(5)
tff(fact_6476_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or5935395276787703475ssThan(A,M,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(4)
tff(fact_6477_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert2(A,L),bot_bot(set(A)))),set_or5935395276787703475ssThan(A,L,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(3)
tff(fact_6478_sum__Un__nat,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),F2: fun(A,nat)] :
      ( finite_finite(A,A2)
     => ( finite_finite(A,B3)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A2)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),B3))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3))) ) ) ) ).

% sum_Un_nat
tff(fact_6479_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),M))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),U))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(5)
tff(fact_6480_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,U)),aa(set(A),set(A),insert2(A,U),bot_bot(set(A)))) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(4)
tff(fact_6481_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [A2: set(B),B3: set(B),F2: fun(B,A)] :
          ( finite_finite(B,A2)
         => ( finite_finite(B,B3)
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3)))
                 => ( aa(B,A,F2,X2) != zero_zero(A) ) )
             => ( groups7121269368397514597t_prod(B,A,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A2),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,F2,A2)),groups7121269368397514597t_prod(B,A,F2,B3))),groups7121269368397514597t_prod(B,A,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A2),B3))) ) ) ) ) ) ).

% prod_Un
tff(fact_6482_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: fun(nat,set(A)),N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M7),set_ord_atMost(nat,N))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M7),set_or1337092689740270186AtMost(nat,one_one(nat),N)))),aa(nat,set(A),M7,zero_zero(nat))) ) ).

% UN_le_eq_Un0
tff(fact_6483_shuffles_Oelims,axiom,
    ! [A: $tType,X3: list(A),Xa: list(A),Y4: set(list(A))] :
      ( ( shuffles(A,X3,Xa) = Y4 )
     => ( ( ( X3 = nil(A) )
         => ( Y4 != aa(set(list(A)),set(list(A)),insert2(list(A),Xa),bot_bot(set(list(A)))) ) )
       => ( ( ( Xa = nil(A) )
           => ( Y4 != aa(set(list(A)),set(list(A)),insert2(list(A),X3),bot_bot(set(list(A)))) ) )
         => ~ ! [X2: A,Xs2: list(A)] :
                ( ( X3 = aa(list(A),list(A),cons(A,X2),Xs2) )
               => ! [Y2: A,Ys3: list(A)] :
                    ( ( Xa = aa(list(A),list(A),cons(A,Y2),Ys3) )
                   => ( Y4 != aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,X2)),shuffles(A,Xs2,aa(list(A),list(A),cons(A,Y2),Ys3)))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y2)),shuffles(A,aa(list(A),list(A),cons(A,X2),Xs2),Ys3))) ) ) ) ) ) ) ).

% shuffles.elims
tff(fact_6484_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Y4: A,Ys2: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(A),list(A),cons(A,Y4),Ys2))))
     => ( shuffles(A,aa(list(A),list(A),cons(A,X3),Xs),aa(list(A),list(A),cons(A,Y4),Ys2)) = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,X3)),shuffles(A,Xs,aa(list(A),list(A),cons(A,Y4),Ys2)))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y4)),shuffles(A,aa(list(A),list(A),cons(A,X3),Xs),Ys2))) ) ) ).

% shuffles.psimps(3)
tff(fact_6485_concat__inth,axiom,
    ! [A: $tType,Xs: list(A),X3: A,Ys2: list(A)] : ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,X3),nil(A))),Ys2))),aa(list(A),nat,size_size(list(A)),Xs)) = X3 ) ).

% concat_inth
tff(fact_6486_upto__aux__rec,axiom,
    ! [J3: int,I: int,Js: list(int)] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J3),I))
       => ( upto_aux(I,J3,Js) = Js ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J3),I))
       => ( upto_aux(I,J3,Js) = upto_aux(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J3),one_one(int)),aa(list(int),list(int),cons(int,J3),Js)) ) ) ) ).

% upto_aux_rec
tff(fact_6487_same__append__eq,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs) )
    <=> ( Ys2 = Zs ) ) ).

% same_append_eq
tff(fact_6488_append__same__eq,axiom,
    ! [A: $tType,Ys2: list(A),Xs: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Zs),Xs) )
    <=> ( Ys2 = Zs ) ) ).

% append_same_eq
tff(fact_6489_append__assoc,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),Zs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Zs)) ) ).

% append_assoc
tff(fact_6490_append_Oassoc,axiom,
    ! [A: $tType,A3: list(A),B2: list(A),C2: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),A3),B2)),C2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),A3),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),B2),C2)) ) ).

% append.assoc
tff(fact_6491_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = nil(A) )
    <=> ( ( Xs = nil(A) )
        & ( Ys2 = nil(A) ) ) ) ).

% append_is_Nil_conv
tff(fact_6492_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( nil(A) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) )
    <=> ( ( Xs = nil(A) )
        & ( Ys2 = nil(A) ) ) ) ).

% Nil_is_append_conv
tff(fact_6493_self__append__conv2,axiom,
    ! [A: $tType,Y4: list(A),Xs: list(A)] :
      ( ( Y4 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Y4) )
    <=> ( Xs = nil(A) ) ) ).

% self_append_conv2
tff(fact_6494_append__self__conv2,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = Ys2 )
    <=> ( Xs = nil(A) ) ) ).

% append_self_conv2
tff(fact_6495_self__append__conv,axiom,
    ! [A: $tType,Y4: list(A),Ys2: list(A)] :
      ( ( Y4 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Y4),Ys2) )
    <=> ( Ys2 = nil(A) ) ) ).

% self_append_conv
tff(fact_6496_append__self__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = Xs )
    <=> ( Ys2 = nil(A) ) ) ).

% append_self_conv
tff(fact_6497_append__Nil2,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),nil(A)) = Xs ) ).

% append_Nil2
tff(fact_6498_append_Oright__neutral,axiom,
    ! [A: $tType,A3: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),A3),nil(A)) = A3 ) ).

% append.right_neutral
tff(fact_6499_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Us: list(A),Vs: list(A)] :
      ( ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys2) )
        | ( aa(list(A),nat,size_size(list(A)),Us) = aa(list(A),nat,size_size(list(A)),Vs) ) )
     => ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Vs) )
      <=> ( ( Xs = Ys2 )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
tff(fact_6500_map__append,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B),Ys2: list(B)] : ( aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(B),list(A),map(B,A,F2),Xs)),aa(list(B),list(A),map(B,A,F2),Ys2)) ) ).

% map_append
tff(fact_6501_filter__append,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Ys2: list(A)] : ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),filter2(A,P),Xs)),aa(list(A),list(A),filter2(A,P),Ys2)) ) ).

% filter_append
tff(fact_6502_rev__append,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : ( aa(list(A),list(A),rev(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),rev(A),Ys2)),aa(list(A),list(A),rev(A),Xs)) ) ).

% rev_append
tff(fact_6503_concat__append,axiom,
    ! [A: $tType,Xs: list(list(A)),Ys2: list(list(A))] : ( concat(A,aa(list(list(A)),list(list(A)),aa(list(list(A)),fun(list(list(A)),list(list(A))),append(list(A)),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),concat(A,Xs)),concat(A,Ys2)) ) ).

% concat_append
tff(fact_6504_foldr__append,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,fun(A,A)),Xs: list(B),Ys2: list(B),A3: A] : ( aa(A,A,foldr(B,A,F2,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys2)),A3) = aa(A,A,foldr(B,A,F2,Xs),aa(A,A,foldr(B,A,F2,Ys2),A3)) ) ).

% foldr_append
tff(fact_6505_removeAll__append,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A)] : ( aa(list(A),list(A),removeAll(A,X3),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),removeAll(A,X3),Xs)),aa(list(A),list(A),removeAll(A,X3),Ys2)) ) ).

% removeAll_append
tff(fact_6506_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list(A),X3: A,Ys2: list(A),Y4: A] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),nil(A))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),aa(list(A),list(A),cons(A,Y4),nil(A))) )
    <=> ( ( Xs = Ys2 )
        & ( X3 = Y4 ) ) ) ).

% append1_eq_conv
tff(fact_6507_length__append,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys2)) ) ).

% length_append
tff(fact_6508_set__append,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) ) ).

% set_append
tff(fact_6509_sum__list__append,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A),Ys2: list(A)] : ( groups8242544230860333062m_list(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups8242544230860333062m_list(A,Xs)),groups8242544230860333062m_list(A,Ys2)) ) ) ).

% sum_list_append
tff(fact_6510_hd__append2,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),A,hd(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),A,hd(A),Xs) ) ) ).

% hd_append2
tff(fact_6511_tl__append2,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),list(A),tl(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),tl(A),Xs)),Ys2) ) ) ).

% tl_append2
tff(fact_6512_takeWhile__append1,axiom,
    ! [A: $tType,X3: A,Xs: list(A),P: fun(A,bool),Ys2: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( ~ pp(aa(A,bool,P,X3))
       => ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = takeWhile(A,P,Xs) ) ) ) ).

% takeWhile_append1
tff(fact_6513_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),Ys2: list(A)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X2)) )
     => ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),takeWhile(A,P,Ys2)) ) ) ).

% takeWhile_append2
tff(fact_6514_size__list__append,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A),Ys2: list(A)] : ( aa(list(A),nat,size_list(A,F2),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_list(A,F2),Xs)),aa(list(A),nat,size_list(A,F2),Ys2)) ) ).

% size_list_append
tff(fact_6515_nth__append__length,axiom,
    ! [A: $tType,Xs: list(A),X3: A,Ys2: list(A)] : ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),Ys2))),aa(list(A),nat,size_size(list(A)),Xs)) = X3 ) ).

% nth_append_length
tff(fact_6516_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),N: nat] : ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N)) = aa(nat,A,nth(A,Ys2),N) ) ).

% nth_append_length_plus
tff(fact_6517_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list(A),Y4: A,Ys2: list(A)] :
      ( ( aa(list(A),list(A),rev(A),Xs) = aa(list(A),list(A),cons(A,Y4),Ys2) )
    <=> ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),rev(A),Ys2)),aa(list(A),list(A),cons(A,Y4),nil(A))) ) ) ).

% rev_eq_Cons_iff
tff(fact_6518_take__append,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Ys2: list(A)] : ( take(A,N,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,N,Xs)),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),Ys2)) ) ).

% take_append
tff(fact_6519_list__update__length,axiom,
    ! [A: $tType,Xs: list(A),X3: A,Ys2: list(A),Y4: A] : ( list_update(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),Ys2)),aa(list(A),nat,size_size(list(A)),Xs),Y4) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,Y4),Ys2)) ) ).

% list_update_length
tff(fact_6520_distinct__append,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( distinct(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2))
    <=> ( distinct(A,Xs)
        & distinct(A,Ys2)
        & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)) = bot_bot(set(A)) ) ) ) ).

% distinct_append
tff(fact_6521_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] : ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_ord_lessThan(nat,aa(nat,nat,suc,K))) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_ord_lessThan(nat,K))),aa(list(nat),list(nat),cons(nat,K),nil(nat))) ) ).

% sorted_list_of_set_lessThan_Suc
tff(fact_6522_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] : ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_ord_atMost(nat,aa(nat,nat,suc,K))) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_ord_atMost(nat,K))),aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,K)),nil(nat))) ) ).

% sorted_list_of_set_atMost_Suc
tff(fact_6523_sup__nat__def,axiom,
    sup_sup(nat) = ord_max(nat) ).

% sup_nat_def
tff(fact_6524_sup__enat__def,axiom,
    sup_sup(extended_enat) = ord_max(extended_enat) ).

% sup_enat_def
tff(fact_6525_sup__int__def,axiom,
    sup_sup(int) = ord_max(int) ).

% sup_int_def
tff(fact_6526_takeWhile__tail,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A),L: list(A)] :
      ( ~ pp(aa(A,bool,P,X3))
     => ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),L))) = takeWhile(A,P,Xs) ) ) ).

% takeWhile_tail
tff(fact_6527_replicate__app__Cons__same,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,N,X3)),aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,N,X3)),Xs)) ) ).

% replicate_app_Cons_same
tff(fact_6528_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ? [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X4)) )
    <=> ? [Ys4: list(A),X4: A] :
          ( ? [Zs3: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X4),Zs3)) )
          & pp(aa(A,bool,P,X4))
          & ! [Xa4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),aa(list(A),set(A),set2(A),Ys4)))
             => ~ pp(aa(A,bool,P,Xa4)) ) ) ) ).

% split_list_first_prop_iff
tff(fact_6529_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ? [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X4)) )
    <=> ? [Ys4: list(A),X4: A,Zs3: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X4),Zs3)) )
          & pp(aa(A,bool,P,X4))
          & ! [Xa4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),aa(list(A),set(A),set2(A),Zs3)))
             => ~ pp(aa(A,bool,P,Xa4)) ) ) ) ).

% split_list_last_prop_iff
tff(fact_6530_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
    <=> ? [Ys4: list(A),Zs3: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X3),Zs3)) )
          & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Ys4))) ) ) ).

% in_set_conv_decomp_first
tff(fact_6531_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
    <=> ? [Ys4: list(A),Zs3: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X3),Zs3)) )
          & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Zs3))) ) ) ).

% in_set_conv_decomp_last
tff(fact_6532_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ? [X: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X)) )
     => ~ ! [Ys3: list(A),X2: A] :
            ( ? [Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) )
           => ( pp(aa(A,bool,P,X2))
             => ~ ! [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),aa(list(A),set(A),set2(A),Ys3)))
                   => ~ pp(aa(A,bool,P,Xa2)) ) ) ) ) ).

% split_list_first_propE
tff(fact_6533_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ? [X: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X)) )
     => ~ ! [Ys3: list(A),X2: A,Zs2: list(A)] :
            ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) )
           => ( pp(aa(A,bool,P,X2))
             => ~ ! [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),aa(list(A),set(A),set2(A),Zs2)))
                   => ~ pp(aa(A,bool,P,Xa2)) ) ) ) ) ).

% split_list_last_propE
tff(fact_6534_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ? [X: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X)) )
     => ? [Ys3: list(A),X2: A] :
          ( ? [Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) )
          & pp(aa(A,bool,P,X2))
          & ! [Xa2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),aa(list(A),set(A),set2(A),Ys3)))
             => ~ pp(aa(A,bool,P,Xa2)) ) ) ) ).

% split_list_first_prop
tff(fact_6535_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ? [X: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X)) )
     => ? [Ys3: list(A),X2: A,Zs2: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) )
          & pp(aa(A,bool,P,X2))
          & ! [Xa2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),aa(list(A),set(A),set2(A),Zs2)))
             => ~ pp(aa(A,bool,P,Xa2)) ) ) ) ).

% split_list_last_prop
tff(fact_6536_in__set__conv__decomp,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
    <=> ? [Ys4: list(A),Zs3: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X3),Zs3)) ) ) ).

% in_set_conv_decomp
tff(fact_6537_append__Cons__eq__iff,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A),Xs5: list(A),Ys6: list(A)] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Ys2)))
       => ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs5),aa(list(A),list(A),cons(A,X3),Ys6)) )
        <=> ( ( Xs = Xs5 )
            & ( Ys2 = Ys6 ) ) ) ) ) ).

% append_Cons_eq_iff
tff(fact_6538_split__list__propE,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ? [X: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X)) )
     => ~ ! [Ys3: list(A),X2: A] :
            ( ? [Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) )
           => ~ pp(aa(A,bool,P,X2)) ) ) ).

% split_list_propE
tff(fact_6539_split__list__first,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ? [Ys3: list(A),Zs2: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X3),Zs2)) )
          & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Ys3))) ) ) ).

% split_list_first
tff(fact_6540_split__list__prop,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( ? [X: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Xs)))
          & pp(aa(A,bool,P,X)) )
     => ? [Ys3: list(A),X2: A] :
          ( ? [Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) )
          & pp(aa(A,bool,P,X2)) ) ) ).

% split_list_prop
tff(fact_6541_split__list__last,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ? [Ys3: list(A),Zs2: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X3),Zs2)) )
          & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Zs2))) ) ) ).

% split_list_last
tff(fact_6542_split__list,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ? [Ys3: list(A),Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X3),Zs2)) ) ) ).

% split_list
tff(fact_6543_append__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,X3),Xs)),Ys2) = aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) ) ).

% append_Cons
tff(fact_6544_Cons__eq__appendI,axiom,
    ! [A: $tType,X3: A,Xs1: list(A),Ys2: list(A),Xs: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X3),Xs1) = Ys2 )
     => ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs1),Zs) )
       => ( aa(list(A),list(A),cons(A,X3),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Zs) ) ) ) ).

% Cons_eq_appendI
tff(fact_6545_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X3: list(A),Xs: list(list(A))] : ( concat(A,aa(list(list(A)),list(list(A)),cons(list(A),X3),Xs)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X3),concat(A,Xs)) ) ).

% concat.simps(2)
tff(fact_6546_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list(list(A)),Ys2: list(A),Zs: list(A)] :
      ( ( concat(A,Xss) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Zs) )
    <=> ( ( ( Xss = nil(list(A)) )
         => ( ( Ys2 = nil(A) )
            & ( Zs = nil(A) ) ) )
        & ( ( Xss != nil(list(A)) )
         => ? [Xss1: list(list(A)),Xs3: list(A),Xs6: list(A),Xss22: list(list(A))] :
              ( ( Xss = aa(list(list(A)),list(list(A)),aa(list(list(A)),fun(list(list(A)),list(list(A))),append(list(A)),Xss1),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs3),Xs6)),Xss22)) )
              & ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),concat(A,Xss1)),Xs3) )
              & ( Zs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs6),concat(A,Xss22)) ) ) ) ) ) ).

% concat_eq_append_conv
tff(fact_6547_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list(list(A)),Ys2: list(A),Zs: list(A)] :
      ( ( concat(A,Xss) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Zs) )
     => ( ( Xss != nil(list(A)) )
       => ? [Xss12: list(list(A)),Xs2: list(A),Xs4: list(A),Xss23: list(list(A))] :
            ( ( Xss = aa(list(list(A)),list(list(A)),aa(list(list(A)),fun(list(list(A)),list(list(A))),append(list(A)),Xss12),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs2),Xs4)),Xss23)) )
            & ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),concat(A,Xss12)),Xs2) )
            & ( Zs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs4),concat(A,Xss23)) ) ) ) ) ).

% concat_eq_appendD
tff(fact_6548_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list(A),P: fun(list(A),bool)] :
      ( ( Xs != nil(A) )
     => ( ! [X2: A] : pp(aa(list(A),bool,P,aa(list(A),list(A),cons(A,X2),nil(A))))
       => ( ! [X2: A,Xs2: list(A)] :
              ( ( Xs2 != nil(A) )
             => ( pp(aa(list(A),bool,P,Xs2))
               => pp(aa(list(A),bool,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs2),aa(list(A),list(A),cons(A,X2),nil(A))))) ) )
         => pp(aa(list(A),bool,P,Xs)) ) ) ) ).

% rev_nonempty_induct
tff(fact_6549_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys2: list(A),Zs: list(A),X3: A,Xs: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Zs) = aa(list(A),list(A),cons(A,X3),Xs) )
    <=> ( ( ( Ys2 = nil(A) )
          & ( Zs = aa(list(A),list(A),cons(A,X3),Xs) ) )
        | ? [Ys7: list(A)] :
            ( ( Ys2 = aa(list(A),list(A),cons(A,X3),Ys7) )
            & ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys7),Zs) = Xs ) ) ) ) ).

% append_eq_Cons_conv
tff(fact_6550_Cons__eq__append__conv,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X3),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Zs) )
    <=> ( ( ( Ys2 = nil(A) )
          & ( aa(list(A),list(A),cons(A,X3),Xs) = Zs ) )
        | ? [Ys7: list(A)] :
            ( ( aa(list(A),list(A),cons(A,X3),Ys7) = Ys2 )
            & ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys7),Zs) ) ) ) ) ).

% Cons_eq_append_conv
tff(fact_6551_rev__exhaust,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ~ ! [Ys3: list(A),Y2: A] : ( Xs != aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,Y2),nil(A))) ) ) ).

% rev_exhaust
tff(fact_6552_rev__induct,axiom,
    ! [A: $tType,P: fun(list(A),bool),Xs: list(A)] :
      ( pp(aa(list(A),bool,P,nil(A)))
     => ( ! [X2: A,Xs2: list(A)] :
            ( pp(aa(list(A),bool,P,Xs2))
           => pp(aa(list(A),bool,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs2),aa(list(A),list(A),cons(A,X2),nil(A))))) )
       => pp(aa(list(A),bool,P,Xs)) ) ) ).

% rev_induct
tff(fact_6553_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( Xs = Ys2 )
     => ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),nil(A)),Ys2) ) ) ).

% eq_Nil_appendI
tff(fact_6554_append_Oleft__neutral,axiom,
    ! [A: $tType,A3: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),nil(A)),A3) = A3 ) ).

% append.left_neutral
tff(fact_6555_append__Nil,axiom,
    ! [A: $tType,Ys2: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),nil(A)),Ys2) = Ys2 ) ).

% append_Nil
tff(fact_6556_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
    ? [Ps: list(A),Xs4: list(A),Ys5: list(A)] :
      ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ps),Xs4) )
      & ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ps),Ys5) )
      & ( ( Xs4 = nil(A) )
        | ( Ys5 = nil(A) )
        | ( aa(list(A),A,hd(A),Xs4) != aa(list(A),A,hd(A),Ys5) ) ) ) ).

% longest_common_prefix
tff(fact_6557_hd__append,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( ( Xs = nil(A) )
       => ( aa(list(A),A,hd(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),A,hd(A),Ys2) ) )
      & ( ( Xs != nil(A) )
       => ( aa(list(A),A,hd(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),A,hd(A),Xs) ) ) ) ).

% hd_append
tff(fact_6558_remdups__append2,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : ( remdups(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),remdups(A,Ys2))) = remdups(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) ) ).

% remdups_append2
tff(fact_6559_sorted__wrt__append,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),Xs: list(A),Ys2: list(A)] :
      ( sorted_wrt(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2))
    <=> ( sorted_wrt(A,P,Xs)
        & sorted_wrt(A,P,Ys2)
        & ! [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
           => ! [Xa4: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),aa(list(A),set(A),set2(A),Ys2)))
               => pp(aa(A,bool,aa(A,fun(A,bool),P,X4),Xa4)) ) ) ) ) ).

% sorted_wrt_append
tff(fact_6560_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A),Ts: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Zs),Ts) )
    <=> ? [Us2: list(A)] :
          ( ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Zs),Us2) )
            & ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),Ys2) = Ts ) )
          | ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us2) = Zs )
            & ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),Ts) ) ) ) ) ).

% append_eq_append_conv2
tff(fact_6561_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list(A),Xs1: list(A),Zs: list(A),Ys2: list(A),Us: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Xs1) = Zs )
     => ( ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs1),Us) )
       => ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Zs),Us) ) ) ) ).

% append_eq_appendI
tff(fact_6562_replicate__add,axiom,
    ! [A: $tType,N: nat,M: nat,X3: A] : ( replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M),X3) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,N,X3)),replicate(A,M,X3)) ) ).

% replicate_add
tff(fact_6563_append__replicate__commute,axiom,
    ! [A: $tType,N: nat,X3: A,K: nat] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,N,X3)),replicate(A,K,X3)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,K,X3)),replicate(A,N,X3)) ) ).

% append_replicate_commute
tff(fact_6564_remove1__append,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A)] :
      ( ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( remove1(A,X3,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),remove1(A,X3,Xs)),Ys2) ) )
      & ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( remove1(A,X3,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),remove1(A,X3,Ys2)) ) ) ) ).

% remove1_append
tff(fact_6565_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Ys2: list(A)] : ( enumerate(A,N,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(product_prod(nat,A)),list(product_prod(nat,A)),aa(list(product_prod(nat,A)),fun(list(product_prod(nat,A)),list(product_prod(nat,A))),append(product_prod(nat,A)),enumerate(A,N,Xs)),enumerate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),Ys2)) ) ).

% enumerate_append_eq
tff(fact_6566_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys2: list(A),Zs: list(A),F2: fun(B,A),Xs: list(B)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Zs) = aa(list(B),list(A),map(B,A,F2),Xs) )
    <=> ? [Us2: list(B),Vs2: list(B)] :
          ( ( Xs = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us2),Vs2) )
          & ( Ys2 = aa(list(B),list(A),map(B,A,F2),Us2) )
          & ( Zs = aa(list(B),list(A),map(B,A,F2),Vs2) ) ) ) ).

% append_eq_map_conv
tff(fact_6567_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B),Ys2: list(A),Zs: list(A)] :
      ( ( aa(list(B),list(A),map(B,A,F2),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Zs) )
    <=> ? [Us2: list(B),Vs2: list(B)] :
          ( ( Xs = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us2),Vs2) )
          & ( Ys2 = aa(list(B),list(A),map(B,A,F2),Us2) )
          & ( Zs = aa(list(B),list(A),map(B,A,F2),Vs2) ) ) ) ).

% map_eq_append_conv
tff(fact_6568_append__listrel1I,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A)),Us: list(A),Vs: list(A)] :
      ( ( ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2)))
          & ( Us = Vs ) )
        | ( ( Xs = Ys2 )
          & pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Us),Vs)),listrel1(A,R2))) ) )
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Vs))),listrel1(A,R2))) ) ).

% append_listrel1I
tff(fact_6569_lex__append__leftI,axiom,
    ! [A: $tType,Ys2: list(A),Zs: list(A),R2: set(product_prod(A,A)),Xs: list(A)] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ys2),Zs)),lex(A,R2)))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lex(A,R2))) ) ).

% lex_append_leftI
tff(fact_6570_concat__conv__foldr,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( concat(A,Xss) = aa(list(A),list(A),foldr(list(A),list(A),append(A),Xss),nil(A)) ) ).

% concat_conv_foldr
tff(fact_6571_tl__append,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : ( aa(list(A),list(A),tl(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),case_list(list(A),A,aa(list(A),list(A),tl(A),Ys2),aTP_Lamp_qs(list(A),fun(A,fun(list(A),list(A))),Ys2)),Xs) ) ).

% tl_append
tff(fact_6572_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Xs) )
     => ? [M3: nat,N2: nat,Zs2: list(A)] :
          ( ( concat(A,replicate(list(A),M3,Zs2)) = Xs )
          & ( concat(A,replicate(list(A),N2,Zs2)) = Ys2 ) ) ) ).

% comm_append_are_replicate
tff(fact_6573_same__length__different,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( Xs != Ys2 )
     => ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys2) )
       => ? [Pre: list(A),X2: A,Xs4: list(A),Y2: A,Ys5: list(A)] :
            ( ( X2 != Y2 )
            & ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Pre),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,X2),nil(A))),Xs4)) )
            & ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Pre),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,Y2),nil(A))),Ys5)) ) ) ) ) ).

% same_length_different
tff(fact_6574_sorted__append,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys2: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2))
        <=> ( sorted_wrt(A,ord_less_eq(A),Xs)
            & sorted_wrt(A,ord_less_eq(A),Ys2)
            & ! [X4: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
               => ! [Xa4: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),aa(list(A),set(A),set2(A),Ys2)))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Xa4)) ) ) ) ) ) ).

% sorted_append
tff(fact_6575_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list(A)] :
      ( ~ distinct(A,Ws)
     => ? [Xs2: list(A),Ys3: list(A),Zs2: list(A),Y2: A] : ( Ws = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs2),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,Y2),nil(A))),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,Y2),nil(A))),Zs2)))) ) ) ).

% not_distinct_decomp
tff(fact_6576_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As3: list(A)] :
      ( ~ distinct(A,As3)
    <=> ? [Xs3: list(A),Y: A,Ys4: list(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y),aa(list(A),set(A),set2(A),Xs3)))
          & distinct(A,Xs3)
          & ( As3 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs3),aa(list(A),list(A),cons(A,Y),Ys4)) ) ) ) ).

% not_distinct_conv_prefix
tff(fact_6577_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Ys2: list(A),X3: A,Xs: list(A)] :
      ( ( aa(list(A),list(A),filter2(A,P),Ys2) = aa(list(A),list(A),cons(A,X3),Xs) )
    <=> ? [Us2: list(A),Vs2: list(A)] :
          ( ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),cons(A,X3),Vs2)) )
          & ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Us2)))
             => ~ pp(aa(A,bool,P,X4)) )
          & pp(aa(A,bool,P,X3))
          & ( Xs = aa(list(A),list(A),filter2(A,P),Vs2) ) ) ) ).

% filter_eq_Cons_iff
tff(fact_6578_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X3: A,Xs: list(A),P: fun(A,bool),Ys2: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X3),Xs) = aa(list(A),list(A),filter2(A,P),Ys2) )
    <=> ? [Us2: list(A),Vs2: list(A)] :
          ( ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),cons(A,X3),Vs2)) )
          & ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Us2)))
             => ~ pp(aa(A,bool,P,X4)) )
          & pp(aa(A,bool,P,X3))
          & ( Xs = aa(list(A),list(A),filter2(A,P),Vs2) ) ) ) ).

% Cons_eq_filter_iff
tff(fact_6579_filter__eq__ConsD,axiom,
    ! [A: $tType,P: fun(A,bool),Ys2: list(A),X3: A,Xs: list(A)] :
      ( ( aa(list(A),list(A),filter2(A,P),Ys2) = aa(list(A),list(A),cons(A,X3),Xs) )
     => ? [Us3: list(A),Vs3: list(A)] :
          ( ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),cons(A,X3),Vs3)) )
          & ! [X: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Us3)))
             => ~ pp(aa(A,bool,P,X)) )
          & pp(aa(A,bool,P,X3))
          & ( Xs = aa(list(A),list(A),filter2(A,P),Vs3) ) ) ) ).

% filter_eq_ConsD
tff(fact_6580_Cons__eq__filterD,axiom,
    ! [A: $tType,X3: A,Xs: list(A),P: fun(A,bool),Ys2: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X3),Xs) = aa(list(A),list(A),filter2(A,P),Ys2) )
     => ? [Us3: list(A),Vs3: list(A)] :
          ( ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),cons(A,X3),Vs3)) )
          & ! [X: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Us3)))
             => ~ pp(aa(A,bool,P,X)) )
          & pp(aa(A,bool,P,X3))
          & ( Xs = aa(list(A),list(A),filter2(A,P),Vs3) ) ) ) ).

% Cons_eq_filterD
tff(fact_6581_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( aa(list(A),list(A),rev(A),aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),rev(A),Xs)),aa(list(A),list(A),cons(A,X3),nil(A))) ) ).

% rev.simps(2)
tff(fact_6582_replicate__append__same,axiom,
    ! [A: $tType,I: nat,X3: A] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,I,X3)),aa(list(A),list(A),cons(A,X3),nil(A))) = aa(list(A),list(A),cons(A,X3),replicate(A,I,X3)) ) ).

% replicate_append_same
tff(fact_6583_upt__add__eq__append,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( upt(I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),K)) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),upt(I,J3)),upt(J3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),K))) ) ) ).

% upt_add_eq_append
tff(fact_6584_list__update__append1,axiom,
    ! [A: $tType,I: nat,Xs: list(A),Ys2: list(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( list_update(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2),I,X3) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),list_update(A,Xs,I,X3)),Ys2) ) ) ).

% list_update_append1
tff(fact_6585_atLeastLessThan__add__Un,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( set_or7035219750837199246ssThan(nat,I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),set_or7035219750837199246ssThan(nat,I,J3)),set_or7035219750837199246ssThan(nat,J3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),K))) ) ) ).

% atLeastLessThan_add_Un
tff(fact_6586_remove1__split,axiom,
    ! [A: $tType,A3: A,Xs: list(A),Ys2: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),aa(list(A),set(A),set2(A),Xs)))
     => ( ( remove1(A,A3,Xs) = Ys2 )
      <=> ? [Ls: list(A),Rs: list(A)] :
            ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ls),aa(list(A),list(A),cons(A,A3),Rs)) )
            & ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),aa(list(A),set(A),set2(A),Ls)))
            & ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ls),Rs) ) ) ) ) ).

% remove1_split
tff(fact_6587_lex__append__leftD,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ! [X2: A] : ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X2),X2)),R2))
     => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lex(A,R2)))
       => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ys2),Zs)),lex(A,R2))) ) ) ).

% lex_append_leftD
tff(fact_6588_lex__append__left__iff,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ! [X2: A] : ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X2),X2)),R2))
     => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lex(A,R2)))
      <=> pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ys2),Zs)),lex(A,R2))) ) ) ).

% lex_append_left_iff
tff(fact_6589_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( aa(list(A),list(A),rotate1(A),aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),nil(A))) ) ).

% rotate1.simps(2)
tff(fact_6590_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A)),Vs: list(A),Us: list(A)] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),lex(A,R2)))
     => ( ( aa(list(A),nat,size_size(list(A)),Vs) = aa(list(A),nat,size_size(list(A)),Us) )
       => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Vs))),lex(A,R2))) ) ) ).

% lex_append_rightI
tff(fact_6591_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,N) )
    <=> ? [Y: A,Ys4: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,Y),nil(A))) )
          & ( aa(list(A),nat,size_size(list(A)),Ys4) = N ) ) ) ).

% length_Suc_conv_rev
tff(fact_6592_length__append__singleton,axiom,
    ! [A: $tType,Xs: list(A),X3: A] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),nil(A)))) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_append_singleton
tff(fact_6593_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( subseqs(A,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(list(A)),list(list(A)),aa(list(list(A)),fun(list(list(A)),list(list(A))),append(list(A)),aa(list(list(A)),list(list(A)),map(list(A),list(A),cons(A,X3)),subseqs(A,Xs))),subseqs(A,Xs)) ) ).

% subseqs.simps(2)
tff(fact_6594_nth__append,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Ys2: list(A)] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),N) = aa(nat,A,nth(A,Xs),N) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),N) = aa(nat,A,nth(A,Ys2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ) ).

% nth_append
tff(fact_6595_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Ys2: list(A),X3: A] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( list_update(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2),N,X3) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),list_update(A,Xs,N,X3)),Ys2) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( list_update(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2),N,X3) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),list_update(A,Ys2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),X3)) ) ) ) ).

% list_update_append
tff(fact_6596_listrel1I,axiom,
    ! [A: $tType,X3: A,Y4: A,R2: set(product_prod(A,A)),Xs: list(A),Us: list(A),Vs: list(A),Ys2: list(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),R2))
     => ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),aa(list(A),list(A),cons(A,X3),Vs)) )
       => ( ( Ys2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),aa(list(A),list(A),cons(A,Y4),Vs)) )
         => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2))) ) ) ) ).

% listrel1I
tff(fact_6597_listrel1E,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2)))
     => ~ ! [X2: A,Y2: A] :
            ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X2),Y2)),R2))
           => ! [Us3: list(A),Vs3: list(A)] :
                ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),cons(A,X2),Vs3)) )
               => ( Ys2 != aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),cons(A,Y2),Vs3)) ) ) ) ) ).

% listrel1E
tff(fact_6598_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list(A),Ys2: list(B)] : ( product(A,B,aa(list(A),list(A),cons(A,X3),Xs),Ys2) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),product_Pair(A,B,X3)),Ys2)),product(A,B,Xs,Ys2)) ) ).

% product.simps(2)
tff(fact_6599_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list(A),X3: A,Ys2: list(A),Y4: A,R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),nil(A)))),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),aa(list(A),list(A),cons(A,Y4),nil(A))))),listrel1(A,R2)))
    <=> ( ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2)))
          & ( X3 = Y4 ) )
        | ( ( Xs = Ys2 )
          & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),R2)) ) ) ) ).

% snoc_listrel1_snoc_iff
tff(fact_6600_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,A),A3: A,Xs: list(B),Ys2: list(B)] : ( groups4207007520872428315er_sum(B,A,F2,A3,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups4207007520872428315er_sum(B,A,F2,A3,Xs)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A3),aa(list(B),nat,size_size(list(B)),Xs))),groups4207007520872428315er_sum(B,A,F2,A3,Ys2))) ) ) ).

% horner_sum_append
tff(fact_6601_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),list(A),rotate1(A),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),tl(A),Xs)),aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),Xs)),nil(A))) ) ) ).

% rotate1_hd_tl
tff(fact_6602_upt__Suc__append,axiom,
    ! [I: nat,J3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
     => ( upt(I,aa(nat,nat,suc,J3)) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),upt(I,J3)),aa(list(nat),list(nat),cons(nat,J3),nil(nat))) ) ) ).

% upt_Suc_append
tff(fact_6603_upt__Suc,axiom,
    ! [I: nat,J3: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
       => ( upt(I,aa(nat,nat,suc,J3)) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),upt(I,J3)),aa(list(nat),list(nat),cons(nat,J3),nil(nat))) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
       => ( upt(I,aa(nat,nat,suc,J3)) = nil(nat) ) ) ) ).

% upt_Suc
tff(fact_6604_Pow__set_I2_J,axiom,
    ! [B: $tType,X3: B,Xs: list(B)] : ( pow2(B,aa(list(B),set(B),set2(B),aa(list(B),list(B),cons(B,X3),Xs))) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),pow2(B,aa(list(B),set(B),set2(B),Xs))),aa(set(set(B)),set(set(B)),image(set(B),set(B),insert2(B,X3)),pow2(B,aa(list(B),set(B),set2(B),Xs)))) ) ).

% Pow_set(2)
tff(fact_6605_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( Xs != nil(A) )
     => ( ( Ys2 != nil(A) )
       => ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Xs) )
         => ? [N2: nat,Zs2: list(A)] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),one_one(nat)),N2))
              & ( concat(A,replicate(list(A),N2,Zs2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) ) ) ) ) ) ).

% comm_append_is_replicate
tff(fact_6606_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),A3: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A3)) )
           => ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_nd(A,A)),A3),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,A3),nil(A))) ) ) ) ) ).

% sorted_insort_is_snoc
tff(fact_6607_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( take(A,aa(nat,nat,suc,I),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,I,Xs)),aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I)),nil(A))) ) ) ).

% take_Suc_conv_app_nth
tff(fact_6608_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs: list(A),N: nat,X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( ( M != N )
         => ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,N,Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,X3),nil(A))),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),Xs)))),M) = aa(nat,A,nth(A,Xs),M) ) ) ) ) ).

% nth_repl
tff(fact_6609_pos__n__replace,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Y4: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,N,Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,Y4),nil(A))),drop(A,aa(nat,nat,suc,N),Xs)))) ) ) ).

% pos_n_replace
tff(fact_6610_drop0,axiom,
    ! [A: $tType,X: list(A)] : ( drop(A,zero_zero(nat),X) = X ) ).

% drop0
tff(fact_6611_drop__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] : ( drop(A,N,drop(A,M,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M),Xs) ) ).

% drop_drop
tff(fact_6612_drop__upt,axiom,
    ! [M: nat,I: nat,J3: nat] : ( drop(nat,M,upt(I,J3)) = upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),M),J3) ) ).

% drop_upt
tff(fact_6613_drop__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] : ( drop(A,aa(nat,nat,suc,N),aa(list(A),list(A),cons(A,X3),Xs)) = drop(A,N,Xs) ) ).

% drop_Suc_Cons
tff(fact_6614_length__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),drop(A,N,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N) ) ).

% length_drop
tff(fact_6615_append__take__drop__id,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,N,Xs)),drop(A,N,Xs)) = Xs ) ).

% append_take_drop_id
tff(fact_6616_drop__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M))
     => ( drop(A,M,list_update(A,Xs,N,X3)) = drop(A,M,Xs) ) ) ).

% drop_update_cancel
tff(fact_6617_drop__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,X3: A] : ( drop(A,I,replicate(A,K,X3)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),I),X3) ) ).

% drop_replicate
tff(fact_6618_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( nil(A) = drop(A,N,Xs) )
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N)) ) ).

% drop_eq_Nil2
tff(fact_6619_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( drop(A,N,Xs) = nil(A) )
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N)) ) ).

% drop_eq_Nil
tff(fact_6620_drop__all,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N))
     => ( drop(A,N,Xs) = nil(A) ) ) ).

% drop_all
tff(fact_6621_drop__append,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Ys2: list(A)] : ( drop(A,N,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),drop(A,N,Xs)),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),Ys2)) ) ).

% drop_append
tff(fact_6622_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X3: A,Xs: list(A)] : ( drop(A,aa(num,nat,numeral_numeral(nat),V),aa(list(A),list(A),cons(A,X3),Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)),Xs) ) ).

% drop_Cons_numeral
tff(fact_6623_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A),I: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,A,nth(A,drop(A,N,Xs)),I) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),I)) ) ) ).

% nth_drop
tff(fact_6624_nth__via__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Y4: A,Ys2: list(A)] :
      ( ( drop(A,N,Xs) = aa(list(A),list(A),cons(A,Y4),Ys2) )
     => ( aa(nat,A,nth(A,Xs),N) = Y4 ) ) ).

% nth_via_drop
tff(fact_6625_sorted__drop,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),N: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),drop(A,N,Xs)) ) ) ).

% sorted_drop
tff(fact_6626_set__drop__subset,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),drop(A,N,Xs))),aa(list(A),set(A),set2(A),Xs))) ).

% set_drop_subset
tff(fact_6627_drop__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: fun(B,A),Xs: list(B)] : ( drop(A,N,aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),list(A),map(B,A,F2),drop(B,N,Xs)) ) ).

% drop_map
tff(fact_6628_distinct__drop,axiom,
    ! [A: $tType,Xs: list(A),I: nat] :
      ( distinct(A,Xs)
     => distinct(A,drop(A,I,Xs)) ) ).

% distinct_drop
tff(fact_6629_drop__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] : ( drop(A,N,take(A,M,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),drop(A,N,Xs)) ) ).

% drop_take
tff(fact_6630_in__set__dropD,axiom,
    ! [A: $tType,X3: A,N: nat,Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),drop(A,N,Xs))))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs))) ) ).

% in_set_dropD
tff(fact_6631_sorted__wrt__drop,axiom,
    ! [A: $tType,F2: fun(A,fun(A,bool)),Xs: list(A),N: nat] :
      ( sorted_wrt(A,F2,Xs)
     => sorted_wrt(A,F2,drop(A,N,Xs)) ) ).

% sorted_wrt_drop
tff(fact_6632_drop__0,axiom,
    ! [A: $tType,Xs: list(A)] : ( drop(A,zero_zero(nat),Xs) = Xs ) ).

% drop_0
tff(fact_6633_take__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] : ( take(A,N,drop(A,M,Xs)) = drop(A,M,take(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M),Xs)) ) ).

% take_drop
tff(fact_6634_drop__Nil,axiom,
    ! [A: $tType,N: nat] : ( drop(A,N,nil(A)) = nil(A) ) ).

% drop_Nil
tff(fact_6635_tl__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),tl(A),drop(A,N,Xs)) = drop(A,N,aa(list(A),list(A),tl(A),Xs)) ) ).

% tl_drop
tff(fact_6636_drop__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( drop(A,aa(nat,nat,suc,N),Xs) = drop(A,N,aa(list(A),list(A),tl(A),Xs)) ) ).

% drop_Suc
tff(fact_6637_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),drop(A,M,Xs))),aa(list(A),set(A),set2(A),drop(A,N,Xs)))) ) ).

% set_drop_subset_set_drop
tff(fact_6638_take__add,axiom,
    ! [A: $tType,I: nat,J3: nat,Xs: list(A)] : ( take(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J3),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,I,Xs)),take(A,J3,drop(A,I,Xs))) ) ).

% take_add
tff(fact_6639_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2) = Zs )
    <=> ( ( Xs = take(A,aa(list(A),nat,size_size(list(A)),Xs),Zs) )
        & ( Ys2 = drop(A,aa(list(A),nat,size_size(list(A)),Xs),Zs) ) ) ) ).

% append_eq_conv_conj
tff(fact_6640_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list(A),X3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
     => ( drop(A,M,list_update(A,Xs,N,X3)) = list_update(A,drop(A,M,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M),X3) ) ) ).

% drop_update_swap
tff(fact_6641_drop__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] : ( drop(A,N,aa(list(A),list(A),cons(A,X3),Xs)) = case_nat(list(A),aa(list(A),list(A),cons(A,X3),Xs),aTP_Lamp_qt(list(A),fun(nat,list(A)),Xs),N) ) ).

% drop_Cons
tff(fact_6642_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list(A)] :
      ( ( ( N = zero_zero(nat) )
       => ( drop(A,N,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),Xs) ) )
      & ( ( N != zero_zero(nat) )
       => ( drop(A,N,aa(list(A),list(A),cons(A,X3),Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),Xs) ) ) ) ).

% drop_Cons'
tff(fact_6643_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list(A),Xs_2: list(A),Ys_1: list(A),Ys_2: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs_1),Xs_2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys_1),Ys_2) )
    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs_1)),aa(list(A),nat,size_size(list(A)),Ys_1)))
         => ( ( Xs_1 = take(A,aa(list(A),nat,size_size(list(A)),Xs_1),Ys_1) )
            & ( Xs_2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),drop(A,aa(list(A),nat,size_size(list(A)),Xs_1),Ys_1)),Ys_2) ) ) )
        & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs_1)),aa(list(A),nat,size_size(list(A)),Ys_1)))
         => ( ( take(A,aa(list(A),nat,size_size(list(A)),Ys_1),Xs_1) = Ys_1 )
            & ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),drop(A,aa(list(A),nat,size_size(list(A)),Ys_1),Xs_1)),Xs_2) = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
tff(fact_6644_hd__drop__conv__nth,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(list(A),A,hd(A),drop(A,N,Xs)) = aa(nat,A,nth(A,Xs),N) ) ) ).

% hd_drop_conv_nth
tff(fact_6645_drop__rev,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( drop(A,N,aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N),Xs)) ) ).

% drop_rev
tff(fact_6646_rev__drop,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] : ( aa(list(A),list(A),rev(A),drop(A,I,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),I),aa(list(A),list(A),rev(A),Xs)) ) ).

% rev_drop
tff(fact_6647_rev__take,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] : ( aa(list(A),list(A),rev(A),take(A,I,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),I),aa(list(A),list(A),rev(A),Xs)) ) ).

% rev_take
tff(fact_6648_take__rev,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( take(A,N,aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N),Xs)) ) ).

% take_rev
tff(fact_6649_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I)),drop(A,aa(nat,nat,suc,I),Xs)) = drop(A,I,Xs) ) ) ).

% Cons_nth_drop_Suc
tff(fact_6650_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list(A),I: nat,J3: nat] :
      ( distinct(A,Vs)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),take(A,I,Vs))),aa(list(A),set(A),set2(A),drop(A,J3,Vs))) = bot_bot(set(A)) ) ) ) ).

% set_take_disj_set_drop_if_distinct
tff(fact_6651_id__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,I,Xs)),aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I)),drop(A,aa(nat,nat,suc,I),Xs))) ) ) ).

% id_take_nth_drop
tff(fact_6652_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list(A),A3: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( list_update(A,Xs,I,A3) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,I,Xs)),aa(list(A),list(A),cons(A,A3),drop(A,aa(nat,nat,suc,I),Xs))) ) ) ).

% upd_conv_take_nth_drop
tff(fact_6653_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,N,Xs)),aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),drop(A,N,Xs))),nil(A))) = take(A,aa(nat,nat,suc,N),Xs) ) ) ).

% take_hd_drop
tff(fact_6654_upto_Opelims,axiom,
    ! [X3: int,Xa: int,Y4: list(int)] :
      ( ( upto(X3,Xa) = Y4 )
     => ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,X3),Xa)))
       => ~ ( ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),Xa))
               => ( Y4 = aa(list(int),list(int),cons(int,X3),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),one_one(int)),Xa)) ) )
              & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),Xa))
               => ( Y4 = nil(int) ) ) )
           => ~ pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,X3),Xa))) ) ) ) ).

% upto.pelims
tff(fact_6655_upto_Opsimps,axiom,
    ! [I: int,J3: int] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,I),J3)))
     => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
         => ( upto(I,J3) = aa(list(int),list(int),cons(int,I),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J3)) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
         => ( upto(I,J3) = nil(int) ) ) ) ) ).

% upto.psimps
tff(fact_6656_upto__empty,axiom,
    ! [J3: int,I: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J3),I))
     => ( upto(I,J3) = nil(int) ) ) ).

% upto_empty
tff(fact_6657_upto__Nil2,axiom,
    ! [I: int,J3: int] :
      ( ( nil(int) = upto(I,J3) )
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J3),I)) ) ).

% upto_Nil2
tff(fact_6658_upto__Nil,axiom,
    ! [I: int,J3: int] :
      ( ( upto(I,J3) = nil(int) )
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J3),I)) ) ).

% upto_Nil
tff(fact_6659_upto__single,axiom,
    ! [I: int] : ( upto(I,I) = aa(list(int),list(int),cons(int,I),nil(int)) ) ).

% upto_single
tff(fact_6660_nth__upto,axiom,
    ! [I: int,K: nat,J3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),I),aa(nat,int,semiring_1_of_nat(int),K))),J3))
     => ( aa(nat,int,nth(int,upto(I,J3)),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),I),aa(nat,int,semiring_1_of_nat(int),K)) ) ) ).

% nth_upto
tff(fact_6661_length__upto,axiom,
    ! [I: int,J3: int] : ( aa(list(int),nat,size_size(list(int)),upto(I,J3)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),J3),I)),one_one(int))) ) ).

% length_upto
tff(fact_6662_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N)))
       => ( upto(aa(num,int,numeral_numeral(int),M),aa(num,int,numeral_numeral(int),N)) = aa(list(int),list(int),cons(int,aa(num,int,numeral_numeral(int),M)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(num,int,numeral_numeral(int),M)),one_one(int)),aa(num,int,numeral_numeral(int),N))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N)))
       => ( upto(aa(num,int,numeral_numeral(int),M),aa(num,int,numeral_numeral(int),N)) = nil(int) ) ) ) ).

% upto_rec_numeral(1)
tff(fact_6663_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))))
       => ( upto(aa(num,int,numeral_numeral(int),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(list(int),list(int),cons(int,aa(num,int,numeral_numeral(int),M)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(num,int,numeral_numeral(int),M)),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N)))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))))
       => ( upto(aa(num,int,numeral_numeral(int),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = nil(int) ) ) ) ).

% upto_rec_numeral(2)
tff(fact_6664_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),N)))
       => ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N)) = aa(list(int),list(int),cons(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),one_one(int)),aa(num,int,numeral_numeral(int),N))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),N)))
       => ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N)) = nil(int) ) ) ) ).

% upto_rec_numeral(3)
tff(fact_6665_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))))
       => ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(list(int),list(int),cons(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N)))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))))
       => ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = nil(int) ) ) ) ).

% upto_rec_numeral(4)
tff(fact_6666_upto__aux__def,axiom,
    ! [I: int,J3: int,Js: list(int)] : ( upto_aux(I,J3,Js) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I,J3)),Js) ) ).

% upto_aux_def
tff(fact_6667_sorted__wrt__upto,axiom,
    ! [I: int,J3: int] : sorted_wrt(int,ord_less(int),upto(I,J3)) ).

% sorted_wrt_upto
tff(fact_6668_atLeastAtMost__upto,axiom,
    ! [I: int,J3: int] : ( set_or1337092689740270186AtMost(int,I,J3) = aa(list(int),set(int),set2(int),upto(I,J3)) ) ).

% atLeastAtMost_upto
tff(fact_6669_distinct__upto,axiom,
    ! [I: int,J3: int] : distinct(int,upto(I,J3)) ).

% distinct_upto
tff(fact_6670_greaterThanAtMost__upto,axiom,
    ! [I: int,J3: int] : ( set_or3652927894154168847AtMost(int,I,J3) = aa(list(int),set(int),set2(int),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J3)) ) ).

% greaterThanAtMost_upto
tff(fact_6671_sorted__upto,axiom,
    ! [M: int,N: int] : sorted_wrt(int,ord_less_eq(int),upto(M,N)) ).

% sorted_upto
tff(fact_6672_upto__code,axiom,
    ! [I: int,J3: int] : ( upto(I,J3) = upto_aux(I,J3,nil(int)) ) ).

% upto_code
tff(fact_6673_upto__split2,axiom,
    ! [I: int,J3: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),J3),K))
       => ( upto(I,K) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I,J3)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),J3),one_one(int)),K)) ) ) ) ).

% upto_split2
tff(fact_6674_upto__split1,axiom,
    ! [I: int,J3: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),J3),K))
       => ( upto(I,K) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J3),one_one(int)))),upto(J3,K)) ) ) ) ).

% upto_split1
tff(fact_6675_greaterThanLessThan__upto,axiom,
    ! [I: int,J3: int] : ( set_or5935395276787703475ssThan(int,I,J3) = aa(list(int),set(int),set2(int),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),aa(int,int,aa(int,fun(int,int),minus_minus(int),J3),one_one(int)))) ) ).

% greaterThanLessThan_upto
tff(fact_6676_atLeastLessThan__upto,axiom,
    ! [I: int,J3: int] : ( set_or7035219750837199246ssThan(int,I,J3) = aa(list(int),set(int),set2(int),upto(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J3),one_one(int)))) ) ).

% atLeastLessThan_upto
tff(fact_6677_upto__rec1,axiom,
    ! [I: int,J3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
     => ( upto(I,J3) = aa(list(int),list(int),cons(int,I),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J3)) ) ) ).

% upto_rec1
tff(fact_6678_upto_Oelims,axiom,
    ! [X3: int,Xa: int,Y4: list(int)] :
      ( ( upto(X3,Xa) = Y4 )
     => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),Xa))
         => ( Y4 = aa(list(int),list(int),cons(int,X3),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),one_one(int)),Xa)) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),Xa))
         => ( Y4 = nil(int) ) ) ) ) ).

% upto.elims
tff(fact_6679_upto_Osimps,axiom,
    ! [I: int,J3: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
       => ( upto(I,J3) = aa(list(int),list(int),cons(int,I),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J3)) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
       => ( upto(I,J3) = nil(int) ) ) ) ).

% upto.simps
tff(fact_6680_upto__rec2,axiom,
    ! [I: int,J3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
     => ( upto(I,J3) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J3),one_one(int)))),aa(list(int),list(int),cons(int,J3),nil(int))) ) ) ).

% upto_rec2
tff(fact_6681_upto__split3,axiom,
    ! [I: int,J3: int,K: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J3))
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),J3),K))
       => ( upto(I,K) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J3),one_one(int)))),aa(list(int),list(int),cons(int,J3),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),J3),one_one(int)),K))) ) ) ) ).

% upto_split3
tff(fact_6682_splice_Opinduct,axiom,
    ! [A: $tType,A0: list(A),A1: list(A),P: fun(list(A),fun(list(A),bool))] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),A0),A1)))
     => ( ! [Ys3: list(A)] :
            ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Ys3)))
           => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,nil(A)),Ys3)) )
       => ( ! [X2: A,Xs2: list(A),Ys3: list(A)] :
              ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Ys3)))
             => ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,Ys3),Xs2))
               => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,aa(list(A),list(A),cons(A,X2),Xs2)),Ys3)) ) )
         => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,A0),A1)) ) ) ) ).

% splice.pinduct
tff(fact_6683_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys: list(product_prod(A,C)),Yzs: list(product_prod(C,B))] : ( relcomp(A,C,B,aa(list(product_prod(A,C)),set(product_prod(A,C)),set2(product_prod(A,C)),Xys),aa(list(product_prod(C,B)),set(product_prod(C,B)),set2(product_prod(C,B)),Yzs)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),concat(product_prod(A,B),aa(list(product_prod(A,C)),list(list(product_prod(A,B))),map(product_prod(A,C),list(product_prod(A,B)),aTP_Lamp_qv(list(product_prod(C,B)),fun(product_prod(A,C),list(product_prod(A,B))),Yzs)),Xys))) ) ).

% set_relcomp
tff(fact_6684_relcomp__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,B)),R2: set(product_prod(A,B)),S7: set(product_prod(B,C)),S: set(product_prod(B,C))] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R3),R2))
     => ( pp(aa(set(product_prod(B,C)),bool,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),bool),ord_less_eq(set(product_prod(B,C))),S7),S))
       => pp(aa(set(product_prod(A,C)),bool,aa(set(product_prod(A,C)),fun(set(product_prod(A,C)),bool),ord_less_eq(set(product_prod(A,C))),relcomp(A,B,C,R3,S7)),relcomp(A,B,C,R2,S))) ) ) ).

% relcomp_mono
tff(fact_6685_min__ext__compat,axiom,
    ! [A: $tType,R4: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,R4,S2)),R4))
     => pp(aa(set(product_prod(set(A),set(A))),bool,aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),bool),ord_less_eq(set(product_prod(set(A),set(A)))),relcomp(set(A),set(A),set(A),min_ext(A,R4),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),sup_sup(set(product_prod(set(A),set(A)))),min_ext(A,S2)),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),insert2(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),product_Pair(set(A),set(A),bot_bot(set(A))),bot_bot(set(A)))),bot_bot(set(product_prod(set(A),set(A)))))))),min_ext(A,R4))) ) ).

% min_ext_compat
tff(fact_6686_splice_Opelims,axiom,
    ! [A: $tType,X3: list(A),Xa: list(A),Y4: list(A)] :
      ( ( splice(A,X3,Xa) = Y4 )
     => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),Xa)))
       => ( ( ( X3 = nil(A) )
           => ( ( Y4 = Xa )
             => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Xa))) ) )
         => ~ ! [X2: A,Xs2: list(A)] :
                ( ( X3 = aa(list(A),list(A),cons(A,X2),Xs2) )
               => ( ( Y4 = aa(list(A),list(A),cons(A,X2),splice(A,Xa,Xs2)) )
                 => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X2),Xs2)),Xa))) ) ) ) ) ) ).

% splice.pelims
tff(fact_6687_splice__Nil2,axiom,
    ! [A: $tType,Xs: list(A)] : ( splice(A,Xs,nil(A)) = Xs ) ).

% splice_Nil2
tff(fact_6688_split__Nil__iff,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( splice(A,Xs,Ys2) = nil(A) )
    <=> ( ( Xs = nil(A) )
        & ( Ys2 = nil(A) ) ) ) ).

% split_Nil_iff
tff(fact_6689_splice__in__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),splice(A,Xs,Ys2)),shuffles(A,Xs,Ys2))) ).

% splice_in_shuffles
tff(fact_6690_length__splice,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] : ( aa(list(A),nat,size_size(list(A)),splice(A,Xs,Ys2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys2)) ) ).

% length_splice
tff(fact_6691_splice__replicate,axiom,
    ! [A: $tType,M: nat,X3: A,N: nat] : ( splice(A,replicate(A,M,X3),replicate(A,N,X3)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N),X3) ) ).

% splice_replicate
tff(fact_6692_splice_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A)] : ( splice(A,aa(list(A),list(A),cons(A,X3),Xs),Ys2) = aa(list(A),list(A),cons(A,X3),splice(A,Ys2,Xs)) ) ).

% splice.simps(2)
tff(fact_6693_splice_Osimps_I1_J,axiom,
    ! [A: $tType,Ys2: list(A)] : ( splice(A,nil(A),Ys2) = Ys2 ) ).

% splice.simps(1)
tff(fact_6694_splice_Oelims,axiom,
    ! [A: $tType,X3: list(A),Xa: list(A),Y4: list(A)] :
      ( ( splice(A,X3,Xa) = Y4 )
     => ( ( ( X3 = nil(A) )
         => ( Y4 != Xa ) )
       => ~ ! [X2: A,Xs2: list(A)] :
              ( ( X3 = aa(list(A),list(A),cons(A,X2),Xs2) )
             => ( Y4 != aa(list(A),list(A),cons(A,X2),splice(A,Xa,Xs2)) ) ) ) ) ).

% splice.elims
tff(fact_6695_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list(A),Ys2: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),Ys2)))
     => ( splice(A,aa(list(A),list(A),cons(A,X3),Xs),Ys2) = aa(list(A),list(A),cons(A,X3),splice(A,Ys2,Xs)) ) ) ).

% splice.psimps(2)
tff(fact_6696_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys2: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Ys2)))
     => ( splice(A,nil(A),Ys2) = Ys2 ) ) ).

% splice.psimps(1)
tff(fact_6697_max__ext__compat,axiom,
    ! [A: $tType,R4: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,R4,S2)),R4))
     => pp(aa(set(product_prod(set(A),set(A))),bool,aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),bool),ord_less_eq(set(product_prod(set(A),set(A)))),relcomp(set(A),set(A),set(A),max_ext(A,R4),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),sup_sup(set(product_prod(set(A),set(A)))),max_ext(A,S2)),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),insert2(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),product_Pair(set(A),set(A),bot_bot(set(A))),bot_bot(set(A)))),bot_bot(set(product_prod(set(A),set(A)))))))),max_ext(A,R4))) ) ).

% max_ext_compat
tff(fact_6698_extract__SomeE,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Ys2: list(A),Y4: A,Zs: list(A)] :
      ( ( extract(A,P,Xs) = some(product_prod(list(A),product_prod(A,list(A))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),product_Pair(list(A),product_prod(A,list(A)),Ys2),aa(list(A),product_prod(A,list(A)),product_Pair(A,list(A),Y4),Zs))) )
     => ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),aa(list(A),list(A),cons(A,Y4),Zs)) )
        & pp(aa(A,bool,P,Y4))
        & ~ ? [X: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Ys2)))
              & pp(aa(A,bool,P,X)) ) ) ) ).

% extract_SomeE
tff(fact_6699_extract__Nil__code,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( extract(A,P,nil(A)) = none(product_prod(list(A),product_prod(A,list(A)))) ) ).

% extract_Nil_code
tff(fact_6700_extract__None__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( extract(A,P,Xs) = none(product_prod(list(A),product_prod(A,list(A)))) )
    <=> ~ ? [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
            & pp(aa(A,bool,P,X4)) ) ) ).

% extract_None_iff
tff(fact_6701_extract__Some__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Ys2: list(A),Y4: A,Zs: list(A)] :
      ( ( extract(A,P,Xs) = some(product_prod(list(A),product_prod(A,list(A))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),product_Pair(list(A),product_prod(A,list(A)),Ys2),aa(list(A),product_prod(A,list(A)),product_Pair(A,list(A),Y4),Zs))) )
    <=> ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),aa(list(A),list(A),cons(A,Y4),Zs)) )
        & pp(aa(A,bool,P,Y4))
        & ~ ? [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Ys2)))
              & pp(aa(A,bool,P,X4)) ) ) ) ).

% extract_Some_iff
tff(fact_6702_INF__filter__not__bot,axiom,
    ! [I6: $tType,A: $tType,B3: set(I6),F3: fun(I6,filter(A))] :
      ( ! [X8: set(I6)] :
          ( pp(aa(set(I6),bool,aa(set(I6),fun(set(I6),bool),ord_less_eq(set(I6)),X8),B3))
         => ( finite_finite(I6,X8)
           => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(I6),set(filter(A)),image(I6,filter(A),F3),X8)) != bot_bot(filter(A)) ) ) )
     => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(I6),set(filter(A)),image(I6,filter(A),F3),B3)) != bot_bot(filter(A)) ) ) ).

% INF_filter_not_bot
tff(fact_6703_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F2: fun(A,B),B3: set(B)] :
      ( ! [X2: A] :
          ( pp(aa(A,bool,P,X2))
         => pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),aa(A,B,F2,X2)),B3)) )
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),collect(A,P))),B3)) ) ).

% image_Collect_subsetI
tff(fact_6704_Inf__filter__not__bot,axiom,
    ! [A: $tType,B3: set(filter(A))] :
      ( ! [X8: set(filter(A))] :
          ( pp(aa(set(filter(A)),bool,aa(set(filter(A)),fun(set(filter(A)),bool),ord_less_eq(set(filter(A))),X8),B3))
         => ( finite_finite(filter(A),X8)
           => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),X8) != bot_bot(filter(A)) ) ) )
     => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B3) != bot_bot(filter(A)) ) ) ).

% Inf_filter_not_bot
tff(fact_6705_INF__filter__bot__base,axiom,
    ! [A: $tType,B: $tType,I5: set(A),F3: fun(A,filter(B))] :
      ( ! [I3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
         => ! [J2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),J2),I5))
             => ? [X: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),I5))
                  & pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),aa(A,filter(B),F3,X)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F3,I3)),aa(A,filter(B),F3,J2)))) ) ) )
     => ( ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F3),I5)) = bot_bot(filter(B)) )
      <=> ? [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),I5))
            & ( aa(A,filter(B),F3,X4) = bot_bot(filter(B)) ) ) ) ) ).

% INF_filter_bot_base
tff(fact_6706_prop__restrict,axiom,
    ! [A: $tType,X3: A,Z7: set(A),X7: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),Z7))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Z7),collect(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aa(set(A),fun(fun(A,bool),fun(A,bool)),X7),P))))
       => pp(aa(A,bool,P,X3)) ) ) ).

% prop_restrict
tff(fact_6707_Collect__restrict,axiom,
    ! [A: $tType,X7: set(A),P: fun(A,bool)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),collect(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aa(set(A),fun(fun(A,bool),fun(A,bool)),X7),P))),X7)) ).

% Collect_restrict
tff(fact_6708_subset__emptyI,axiom,
    ! [A: $tType,A2: set(A)] :
      ( ! [X2: A] : ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),bot_bot(set(A)))) ) ).

% subset_emptyI
tff(fact_6709_insert__subsetI,axiom,
    ! [A: $tType,X3: A,A2: set(A),X7: set(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X7),A2))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,X3),X7)),A2)) ) ) ).

% insert_subsetI
tff(fact_6710_extract__def,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( extract(A,P,Xs) = aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),case_list(option(product_prod(list(A),product_prod(A,list(A)))),A,none(product_prod(list(A),product_prod(A,list(A)))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_qw(fun(A,bool),fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),P),Xs)),dropWhile(A,aa(fun(A,bool),fun(A,bool),comp(bool,bool,A,fNot),P),Xs)) ) ).

% extract_def
tff(fact_6711_DERIV__even__real__root,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real)))
         => has_field_derivative(real,root(N),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(nat,real,semiring_1_of_nat(real),N))),aa(nat,real,power_power(real,aa(real,real,root(N),X3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ) ).

% DERIV_even_real_root
tff(fact_6712_dropWhile__idem,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( dropWhile(A,P,dropWhile(A,P,Xs)) = dropWhile(A,P,Xs) ) ).

% dropWhile_idem
tff(fact_6713_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( dropWhile(A,P,Xs) = nil(A) )
    <=> ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X4)) ) ) ).

% dropWhile_eq_Nil_conv
tff(fact_6714_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),Ys2: list(A)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X2)) )
     => ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = dropWhile(A,P,Ys2) ) ) ).

% dropWhile_append2
tff(fact_6715_dropWhile__append1,axiom,
    ! [A: $tType,X3: A,Xs: list(A),P: fun(A,bool),Ys2: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ( ~ pp(aa(A,bool,P,X3))
       => ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),dropWhile(A,P,Xs)),Ys2) ) ) ) ).

% dropWhile_append1
tff(fact_6716_dropWhile__replicate,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,N: nat] :
      ( ( pp(aa(A,bool,P,X3))
       => ( dropWhile(A,P,replicate(A,N,X3)) = nil(A) ) )
      & ( ~ pp(aa(A,bool,P,X3))
       => ( dropWhile(A,P,replicate(A,N,X3)) = replicate(A,N,X3) ) ) ) ).

% dropWhile_replicate
tff(fact_6717_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),takeWhile(A,P,Xs)),dropWhile(A,P,Xs)) = Xs ) ).

% takeWhile_dropWhile_id
tff(fact_6718_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Y4: A,Z: A,X3: A,S2: set(A)] :
          ( has_field_derivative(A,F2,Y4,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),X3),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),Z)),S2)))
         => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F2),aa(A,fun(A,A),plus_plus(A),Z)),Y4,topolo174197925503356063within(A,X3,S2)) ) ) ).

% DERIV_at_within_shift_lemma
tff(fact_6719_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Da: A,G: fun(A,A),X3: A,S: set(A),Db: A] :
          ( has_field_derivative(A,F2,Da,topolo174197925503356063within(A,aa(A,A,G,X3),aa(set(A),set(A),image(A,A,G),S)))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X3,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F2),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_image_chain
tff(fact_6720_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Y4: A,Z: A,X3: A,S2: set(A)] :
          ( has_field_derivative(A,F2,Y4,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),X3),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),Z)),S2)))
        <=> has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_qx(fun(A,A),fun(A,fun(A,A)),F2),Z),Y4,topolo174197925503356063within(A,X3,S2)) ) ) ).

% DERIV_at_within_shift
tff(fact_6721_less__filter__def,axiom,
    ! [A: $tType,F3: filter(A),F9: filter(A)] :
      ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less(filter(A)),F3),F9))
    <=> ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F3),F9))
        & ~ pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F9),F3)) ) ) ).

% less_filter_def
tff(fact_6722_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,bool)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),dropWhile(A,P,Xs)) ) ) ).

% sorted_dropWhile
tff(fact_6723_length__dropWhile__le,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),dropWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ).

% length_dropWhile_le
tff(fact_6724_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Y4: A,X3: A,S: set(A),T2: set(A)] :
          ( has_field_derivative(A,F2,Y4,topolo174197925503356063within(A,X3,S))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T2),S))
           => has_field_derivative(A,F2,Y4,topolo174197925503356063within(A,X3,T2)) ) ) ) ).

% has_field_derivative_subset
tff(fact_6725_DERIV__subset,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),F8: A,X3: A,S: set(A),T2: set(A)] :
          ( has_field_derivative(A,F2,F8,topolo174197925503356063within(A,X3,S))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T2),S))
           => has_field_derivative(A,F2,F8,topolo174197925503356063within(A,X3,T2)) ) ) ) ).

% DERIV_subset
tff(fact_6726_at__le,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),T2: set(A),X3: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S),T2))
         => pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),topolo174197925503356063within(A,X3,S)),topolo174197925503356063within(A,X3,T2))) ) ) ).

% at_le
tff(fact_6727_DERIV__pos__imp__increasing,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ! [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
             => ? [Y5: real] :
                  ( has_field_derivative(real,F2,Y5,topolo174197925503356063within(real,X2,top_top(set(real))))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y5)) ) ) )
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,A3)),aa(real,real,F2,B2))) ) ) ).

% DERIV_pos_imp_increasing
tff(fact_6728_DERIV__neg__imp__decreasing,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ! [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
             => ? [Y5: real] :
                  ( has_field_derivative(real,F2,Y5,topolo174197925503356063within(real,X2,top_top(set(real))))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y5),zero_zero(real))) ) ) )
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,B2)),aa(real,real,F2,A3))) ) ) ).

% DERIV_neg_imp_decreasing
tff(fact_6729_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
     => ( ! [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
             => ? [Y5: real] :
                  ( has_field_derivative(real,F2,Y5,topolo174197925503356063within(real,X2,top_top(set(real))))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Y5)) ) ) )
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,F2,A3)),aa(real,real,F2,B2))) ) ) ).

% DERIV_nonneg_imp_nondecreasing
tff(fact_6730_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
     => ( ! [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
             => ? [Y5: real] :
                  ( has_field_derivative(real,F2,Y5,topolo174197925503356063within(real,X2,top_top(set(real))))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y5),zero_zero(real))) ) ) )
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,F2,B2)),aa(real,real,F2,A3))) ) ) ).

% DERIV_nonpos_imp_nonincreasing
tff(fact_6731_deriv__nonneg__imp__mono,axiom,
    ! [A3: real,B2: real,G: fun(real,real),G3: fun(real,real)] :
      ( ! [X2: real] :
          ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),set_or1337092689740270186AtMost(real,A3,B2)))
         => has_field_derivative(real,G,aa(real,real,G3,X2),topolo174197925503356063within(real,X2,top_top(set(real)))) )
     => ( ! [X2: real] :
            ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),set_or1337092689740270186AtMost(real,A3,B2)))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,G3,X2))) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,G,A3)),aa(real,real,G,B2))) ) ) ) ).

% deriv_nonneg_imp_mono
tff(fact_6732_MVT2,axiom,
    ! [A3: real,B2: real,F2: fun(real,real),F8: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ! [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
             => has_field_derivative(real,F2,aa(real,real,F8,X2),topolo174197925503356063within(real,X2,top_top(set(real)))) ) )
       => ? [Z4: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Z4))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Z4),B2))
            & ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)),aa(real,real,F8,Z4)) ) ) ) ) ).

% MVT2
tff(fact_6733_hd__dropWhile,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( dropWhile(A,P,Xs) != nil(A) )
     => ~ pp(aa(A,bool,P,aa(list(A),A,hd(A),dropWhile(A,P,Xs)))) ) ).

% hd_dropWhile
tff(fact_6734_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( dropWhile(A,P,Xs) = Xs )
    <=> ( ( Xs = nil(A) )
        | ~ pp(aa(A,bool,P,aa(list(A),A,hd(A),Xs))) ) ) ).

% dropWhile_eq_self_iff
tff(fact_6735_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( dropWhile(A,P,nil(A)) = nil(A) ) ).

% dropWhile.simps(1)
tff(fact_6736_DERIV__local__const,axiom,
    ! [F2: fun(real,real),L: real,X3: real,D2: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D2))
       => ( ! [Y2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y2))),D2))
             => ( aa(real,real,F2,X3) = aa(real,real,F2,Y2) ) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_const
tff(fact_6737_DERIV__ln,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => has_field_derivative(real,ln_ln(real),aa(real,real,inverse_inverse(real),X3),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ).

% DERIV_ln
tff(fact_6738_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),M: A,X3: A] :
          ( has_field_derivative(A,G,M,topolo174197925503356063within(A,X3,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_qy(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),sin(A,aa(A,A,G,X3)))),M),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ).

% DERIV_fun_cos
tff(fact_6739_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K: A,Xa: A] : has_field_derivative(A,aTP_Lamp_qz(A,fun(A,A),K),aa(A,A,uminus_uminus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),K))),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ).

% DERIV_cos_add
tff(fact_6740_has__real__derivative__neg__dec__left,axiom,
    ! [F2: fun(real,real),L: real,X3: real,S2: set(real)] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,S2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),L),zero_zero(real)))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [H4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H4))
               => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),H4)),S2))
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H4),D3))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,X3)),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),H4)))) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
tff(fact_6741_has__real__derivative__pos__inc__left,axiom,
    ! [F2: fun(real,real),L: real,X3: real,S2: set(real)] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,S2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),L))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [H4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H4))
               => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),H4)),S2))
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H4),D3))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),H4))),aa(real,real,F2,X3))) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
tff(fact_6742_DERIV__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,X3,S))
           => ( ( aa(A,A,G,X3) != zero_zero(A) )
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_ra(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D4),aa(A,A,G,X3))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,F2,X3)),E4))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,G,X3)),aa(A,A,G,X3))),topolo174197925503356063within(A,X3,S)) ) ) ) ) ).

% DERIV_divide
tff(fact_6743_DERIV__mult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Da: A,X3: A,S: set(A),G: fun(A,A),Db: A] :
          ( has_field_derivative(A,F2,Da,topolo174197925503356063within(A,X3,S))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X3,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_rb(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Da),aa(A,A,G,X3))),aa(A,A,aa(A,fun(A,A),times_times(A),Db),aa(A,A,F2,X3))),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_mult
tff(fact_6744_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,X3,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_rb(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,F2,X3)),E4)),aa(A,A,aa(A,fun(A,A),times_times(A),D4),aa(A,A,G,X3))),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_mult'
tff(fact_6745_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_rc(fun(A,A),fun(A,fun(A,A)),F2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D4),topolo174197925503356063within(A,X3,S)) ) ) ).

% DERIV_cmult
tff(fact_6746_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_rd(fun(A,A),fun(A,fun(A,A)),F2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),D4),C2),topolo174197925503356063within(A,X3,S)) ) ) ).

% DERIV_cmult_right
tff(fact_6747_has__field__derivative__cosh,axiom,
    ! [A11: $tType] :
      ( ( real_Vector_banach(A11)
        & real_V3459762299906320749_field(A11) )
     => ! [G: fun(A11,A11),Db: A11,X3: A11,S: set(A11)] :
          ( has_field_derivative(A11,G,Db,topolo174197925503356063within(A11,X3,S))
         => has_field_derivative(A11,aTP_Lamp_re(fun(A11,A11),fun(A11,A11),G),aa(A11,A11,aa(A11,fun(A11,A11),times_times(A11),sinh(A11,aa(A11,A11,G,X3))),Db),topolo174197925503356063within(A11,X3,S)) ) ) ).

% has_field_derivative_cosh
tff(fact_6748_has__field__derivative__sinh,axiom,
    ! [A11: $tType] :
      ( ( real_Vector_banach(A11)
        & real_V3459762299906320749_field(A11) )
     => ! [G: fun(A11,A11),Db: A11,X3: A11,S: set(A11)] :
          ( has_field_derivative(A11,G,Db,topolo174197925503356063within(A11,X3,S))
         => has_field_derivative(A11,aTP_Lamp_rf(fun(A11,A11),fun(A11,A11),G),aa(A11,A11,aa(A11,fun(A11,A11),times_times(A11),cosh(A11,aa(A11,A11,G,X3))),Db),topolo174197925503356063within(A11,X3,S)) ) ) ).

% has_field_derivative_sinh
tff(fact_6749_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_rg(fun(A,A),fun(A,fun(A,A)),F2),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),D4),C2),topolo174197925503356063within(A,X3,S)) ) ) ).

% DERIV_cdivide
tff(fact_6750_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,X3: A,S: set(A)] : has_field_derivative(A,aa(A,fun(A,A),times_times(A),C2),C2,topolo174197925503356063within(A,X3,S)) ) ).

% DERIV_cmult_Id
tff(fact_6751_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),F8: A,F3: filter(A),G: fun(A,A),G3: A] :
          ( has_field_derivative(A,F2,F8,F3)
         => ( has_field_derivative(A,G,G3,F3)
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_rh(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),F8),G3),F3) ) ) ) ).

% field_differentiable_add
tff(fact_6752_DERIV__add,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,X3,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_rh(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),D4),E4),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_add
tff(fact_6753_DERIV__const,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [K: A,F3: filter(A)] : has_field_derivative(A,aTP_Lamp_ri(A,fun(A,A),K),zero_zero(A),F3) ) ).

% DERIV_const
tff(fact_6754_has__real__derivative__pos__inc__right,axiom,
    ! [F2: fun(real,real),L: real,X3: real,S2: set(real)] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,S2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),L))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [H4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H4))
               => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),H4)),S2))
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H4),D3))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,X3)),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),H4)))) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
tff(fact_6755_has__real__derivative__neg__dec__right,axiom,
    ! [F2: fun(real,real),L: real,X3: real,S2: set(real)] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,S2))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),L),zero_zero(real)))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [H4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H4))
               => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),H4)),S2))
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H4),D3))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),H4))),aa(real,real,F2,X3))) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
tff(fact_6756_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A)] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => ( ( aa(A,A,F2,X3) != zero_zero(A) )
           => has_field_derivative(A,aTP_Lamp_rj(fun(A,A),fun(A,A),F2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(A,A,F2,X3))),D4)),aa(A,A,inverse_inverse(A),aa(A,A,F2,X3)))),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_inverse'
tff(fact_6757_DERIV__chain,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Da: A,G: fun(A,A),X3: A,Db: A,S: set(A)] :
          ( has_field_derivative(A,F2,Da,topolo174197925503356063within(A,aa(A,A,G,X3),top_top(set(A))))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X3,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F2),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_chain
tff(fact_6758_DERIV__neg__dec__right,axiom,
    ! [F2: fun(real,real),L: real,X3: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),L),zero_zero(real)))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [H4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H4))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H4),D3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),H4))),aa(real,real,F2,X3))) ) ) ) ) ) ).

% DERIV_neg_dec_right
tff(fact_6759_DERIV__pos__inc__right,axiom,
    ! [F2: fun(real,real),L: real,X3: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),L))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [H4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H4))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H4),D3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,X3)),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X3),H4)))) ) ) ) ) ) ).

% DERIV_pos_inc_right
tff(fact_6760_DERIV__isconst__all,axiom,
    ! [F2: fun(real,real),X3: real,Y4: real] :
      ( ! [X2: real] : has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,real,F2,X3) = aa(real,real,F2,Y4) ) ) ).

% DERIV_isconst_all
tff(fact_6761_DERIV__shift,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Y4: A,X3: A,Z: A] :
          ( has_field_derivative(A,F2,Y4,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Z),top_top(set(A))))
        <=> has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_rk(fun(A,A),fun(A,fun(A,A)),F2),Z),Y4,topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ).

% DERIV_shift
tff(fact_6762_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),M: A,X3: A] :
          ( has_field_derivative(A,G,M,topolo174197925503356063within(A,X3,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_rl(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,aa(A,A,G,X3))),M),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ).

% DERIV_fun_sin
tff(fact_6763_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [S: set(A),G: fun(A,A),G3: fun(A,A),F2: fun(A,A),F8: A,X3: A] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
             => has_field_derivative(A,G,aa(A,A,G3,X2),topolo174197925503356063within(A,X2,top_top(set(A)))) )
         => ( has_field_derivative(A,F2,F8,topolo174197925503356063within(A,X3,top_top(set(A))))
           => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,F2,X3)),S))
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_rm(fun(A,A),fun(fun(A,A),fun(A,A)),G),F2),aa(A,A,aa(A,fun(A,A),times_times(A),F8),aa(A,A,G3,aa(A,A,F2,X3))),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ) ) ).

% DERIV_chain_s
tff(fact_6764_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [G: fun(A,A),G3: fun(A,A),F2: fun(A,A),F8: A,X3: A] :
          ( ! [X2: A] : has_field_derivative(A,G,aa(A,A,G3,X2),topolo174197925503356063within(A,X2,top_top(set(A))))
         => ( has_field_derivative(A,F2,F8,topolo174197925503356063within(A,X3,top_top(set(A))))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_rm(fun(A,A),fun(fun(A,A),fun(A,A)),G),F2),aa(A,A,aa(A,fun(A,A),times_times(A),F8),aa(A,A,G3,aa(A,A,F2,X3))),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ) ).

% DERIV_chain3
tff(fact_6765_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Da: A,G: fun(A,A),X3: A,Db: A,S: set(A)] :
          ( has_field_derivative(A,F2,Da,topolo174197925503356063within(A,aa(A,A,G,X3),top_top(set(A))))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X3,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_rm(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_chain2
tff(fact_6766_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,aa(A,A,F2,X3),top_top(set(A))))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_rn(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),times_times(A),E4),D4),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_chain'
tff(fact_6767_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),M: A,X3: A] :
          ( has_field_derivative(A,G,M,topolo174197925503356063within(A,X3,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_ro(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),aa(A,A,G,X3))),M),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ).

% DERIV_fun_exp
tff(fact_6768_DERIV__neg__dec__left,axiom,
    ! [F2: fun(real,real),L: real,X3: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),L),zero_zero(real)))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [H4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H4))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H4),D3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,X3)),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),H4)))) ) ) ) ) ) ).

% DERIV_neg_dec_left
tff(fact_6769_DERIV__pos__inc__left,axiom,
    ! [F2: fun(real,real),L: real,X3: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),L))
       => ? [D3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D3))
            & ! [H4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H4))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H4),D3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),H4))),aa(real,real,F2,X3))) ) ) ) ) ) ).

% DERIV_pos_inc_left
tff(fact_6770_DERIV__const__ratio__const2,axiom,
    ! [A3: real,B2: real,F2: fun(real,real),K: real] :
      ( ( A3 != B2 )
     => ( ! [X2: real] : has_field_derivative(real,F2,K,topolo174197925503356063within(real,X2,top_top(set(real))))
       => ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A3))),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)) = K ) ) ) ).

% DERIV_const_ratio_const2
tff(fact_6771_DERIV__const__ratio__const,axiom,
    ! [A3: real,B2: real,F2: fun(real,real),K: real] :
      ( ( A3 != B2 )
     => ( ! [X2: real] : has_field_derivative(real,F2,K,topolo174197925503356063within(real,X2,top_top(set(real))))
       => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)),K) ) ) ) ).

% DERIV_const_ratio_const
tff(fact_6772_dropWhile__append3,axiom,
    ! [A: $tType,P: fun(A,bool),Y4: A,Xs: list(A),Ys2: list(A)] :
      ( ~ pp(aa(A,bool,P,Y4))
     => ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,Y4),Ys2))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),dropWhile(A,P,Xs)),aa(list(A),list(A),cons(A,Y4),Ys2)) ) ) ).

% dropWhile_append3
tff(fact_6773_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F2: fun(B,A),Xs: list(B)] : ( dropWhile(A,P,aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),list(A),map(B,A,F2),dropWhile(B,aa(fun(B,A),fun(B,bool),comp(A,bool,B,P),F2),Xs)) ) ).

% dropWhile_map
tff(fact_6774_DERIV__isconst3,axiom,
    ! [A3: real,B2: real,X3: real,Y4: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X3),set_or5935395276787703475ssThan(real,A3,B2)))
       => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),Y4),set_or5935395276787703475ssThan(real,A3,B2)))
         => ( ! [X2: real] :
                ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),set_or5935395276787703475ssThan(real,A3,B2)))
               => has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,X2,top_top(set(real)))) )
           => ( aa(real,real,F2,X3) = aa(real,real,F2,Y4) ) ) ) ) ) ).

% DERIV_isconst3
tff(fact_6775_set__dropWhileD,axiom,
    ! [A: $tType,X3: A,P: fun(A,bool),Xs: list(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),dropWhile(A,P,Xs))))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs))) ) ).

% set_dropWhileD
tff(fact_6776_dropWhile__cong,axiom,
    ! [A: $tType,L: list(A),K: list(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( ( L = K )
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),L)))
           => ( pp(aa(A,bool,P,X2))
            <=> pp(aa(A,bool,Q,X2)) ) )
       => ( dropWhile(A,P,L) = dropWhile(A,Q,K) ) ) ) ).

% dropWhile_cong
tff(fact_6777_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( distinct(A,Xs)
     => distinct(A,dropWhile(A,P,Xs)) ) ).

% distinct_dropWhile
tff(fact_6778_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A)] :
      ( ( pp(aa(A,bool,P,X3))
       => ( dropWhile(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = dropWhile(A,P,Xs) ) )
      & ( ~ pp(aa(A,bool,P,X3))
       => ( dropWhile(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),Xs) ) ) ) ).

% dropWhile.simps(2)
tff(fact_6779_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),N: nat] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => has_field_derivative(A,aa(nat,fun(A,A),aTP_Lamp_rp(fun(A,A),fun(nat,fun(A,A)),F2),N),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),N))),aa(A,A,aa(A,fun(A,A),times_times(A),D4),aa(nat,A,power_power(A,aa(A,A,F2,X3)),N))),topolo174197925503356063within(A,X3,S)) ) ) ).

% DERIV_power_Suc
tff(fact_6780_DERIV__const__average,axiom,
    ! [A3: real,B2: real,V: fun(real,real),K: real] :
      ( ( A3 != B2 )
     => ( ! [X2: real] : has_field_derivative(real,V,K,topolo174197925503356063within(real,X2,top_top(set(real))))
       => ( aa(real,real,V,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),A3),B2)),aa(num,real,numeral_numeral(real),bit0(one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,V,A3)),aa(real,real,V,B2))),aa(num,real,numeral_numeral(real),bit0(one2))) ) ) ) ).

% DERIV_const_average
tff(fact_6781_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [X3: A,S: set(A)] :
          ( ( X3 != zero_zero(A) )
         => has_field_derivative(A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X3)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(A,X3,S)) ) ) ).

% DERIV_inverse
tff(fact_6782_DERIV__power,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S: set(A),N: nat] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S))
         => has_field_derivative(A,aa(nat,fun(A,A),aTP_Lamp_rq(fun(A,A),fun(nat,fun(A,A)),F2),N),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),times_times(A),D4),aa(nat,A,power_power(A,aa(A,A,F2,X3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(A,X3,S)) ) ) ).

% DERIV_power
tff(fact_6783_DERIV__local__min,axiom,
    ! [F2: fun(real,real),L: real,X3: real,D2: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D2))
       => ( ! [Y2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y2))),D2))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,F2,X3)),aa(real,real,F2,Y2))) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_min
tff(fact_6784_DERIV__local__max,axiom,
    ! [F2: fun(real,real),L: real,X3: real,D2: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D2))
       => ( ! [Y2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y2))),D2))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,F2,Y2)),aa(real,real,F2,X3))) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_max
tff(fact_6785_DERIV__ln__divide,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => has_field_derivative(real,ln_ln(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X3),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ).

% DERIV_ln_divide
tff(fact_6786_DERIV__pow,axiom,
    ! [N: nat,X3: real,S: set(real)] : has_field_derivative(real,aTP_Lamp_rr(nat,fun(real,real),N),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,power_power(real,X3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(real,X3,S)) ).

% DERIV_pow
tff(fact_6787_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X3: A] :
          ( ! [Y2: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),Y2))
         => has_field_derivative(A,aTP_Lamp_rs(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),X3)),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ).

% termdiffs_strong_converges_everywhere
tff(fact_6788_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A3: A,X3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),B2))
           => ( topolo174197925503356063within(A,X3,set_or1337092689740270186AtMost(A,A3,B2)) = topolo174197925503356063within(A,X3,top_top(set(A))) ) ) ) ) ).

% at_within_Icc_at
tff(fact_6789_DERIV__fun__pow,axiom,
    ! [G: fun(real,real),M: real,X3: real,N: nat] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,X3,top_top(set(real))))
     => has_field_derivative(real,aa(nat,fun(real,real),aTP_Lamp_rt(fun(real,real),fun(nat,fun(real,real)),G),N),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,power_power(real,aa(real,real,G,X3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))))),M),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ).

% DERIV_fun_pow
tff(fact_6790_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( topolo174197925503356063within(A,B2,set_or1337092689740270186AtMost(A,A3,B2)) = topolo174197925503356063within(A,B2,set_ord_lessThan(A,B2)) ) ) ) ).

% at_within_Icc_at_left
tff(fact_6791_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D2: A,X3: A,S: set(A),G: fun(A,A),E: A] :
          ( has_field_derivative(A,F2,D2,topolo174197925503356063within(A,X3,S))
         => ( has_field_derivative(A,G,E,topolo174197925503356063within(A,X3,S))
           => ( ( aa(A,A,G,X3) != zero_zero(A) )
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_ra(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D2),aa(A,A,G,X3))),aa(A,A,aa(A,fun(A,A),times_times(A),E),aa(A,A,F2,X3)))),aa(nat,A,power_power(A,aa(A,A,G,X3)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(A,X3,S)) ) ) ) ) ).

% DERIV_quotient
tff(fact_6792_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D2: A,X3: A,S: set(A)] :
          ( has_field_derivative(A,F2,D2,topolo174197925503356063within(A,X3,S))
         => ( ( aa(A,A,F2,X3) != zero_zero(A) )
           => has_field_derivative(A,aTP_Lamp_rj(fun(A,A),fun(A,A),F2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D2),aa(A,A,inverse_inverse(A),aa(nat,A,power_power(A,aa(A,A,F2,X3)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))))),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_inverse_fun
tff(fact_6793_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Y4: A,Ys2: list(A)] :
      ( ( dropWhile(A,P,Xs) = aa(list(A),list(A),cons(A,Y4),Ys2) )
    <=> ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),takeWhile(A,P,Xs)),aa(list(A),list(A),cons(A,Y4),Ys2)) )
        & ~ pp(aa(A,bool,P,Y4)) ) ) ).

% dropWhile_eq_Cons_conv
tff(fact_6794_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K5: real,C2: fun(nat,A),F2: fun(A,A),F8: A,Z: A] :
          ( ! [Z4: A] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Z4)),K5))
             => sums(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),Z4),aa(A,A,F2,Z4)) )
         => ( has_field_derivative(A,F2,F8,topolo174197925503356063within(A,Z,top_top(set(A))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Z)),K5))
             => sums(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),Z),F8) ) ) ) ) ).

% termdiffs_sums_strong
tff(fact_6795_takeWhile__eq__filter,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ! [X2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),dropWhile(A,P,Xs))))
         => ~ pp(aa(A,bool,P,X2)) )
     => ( takeWhile(A,P,Xs) = aa(list(A),list(A),filter2(A,P),Xs) ) ) ).

% takeWhile_eq_filter
tff(fact_6796_dropWhile__eq__drop,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( dropWhile(A,P,Xs) = drop(A,aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)),Xs) ) ).

% dropWhile_eq_drop
tff(fact_6797_has__real__derivative__powr,axiom,
    ! [Z: real,R2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Z))
     => has_field_derivative(real,aTP_Lamp_ru(real,fun(real,real),R2),aa(real,real,aa(real,fun(real,real),times_times(real),R2),powr(real,Z,aa(real,real,aa(real,fun(real,real),minus_minus(real),R2),one_one(real)))),topolo174197925503356063within(real,Z,top_top(set(real)))) ) ).

% has_real_derivative_powr
tff(fact_6798_DERIV__series_H,axiom,
    ! [F2: fun(real,fun(nat,real)),F8: fun(real,fun(nat,real)),X0: real,A3: real,B2: real,L5: fun(nat,real)] :
      ( ! [N2: nat] : has_field_derivative(real,aa(nat,fun(real,real),aTP_Lamp_rv(fun(real,fun(nat,real)),fun(nat,fun(real,real)),F2),N2),aa(nat,real,aa(real,fun(nat,real),F8,X0),N2),topolo174197925503356063within(real,X0,top_top(set(real))))
     => ( ! [X2: real] :
            ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),set_or5935395276787703475ssThan(real,A3,B2)))
           => summable(real,aa(real,fun(nat,real),F2,X2)) )
       => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X0),set_or5935395276787703475ssThan(real,A3,B2)))
         => ( summable(real,aa(real,fun(nat,real),F8,X0))
           => ( summable(real,L5)
             => ( ! [N2: nat,X2: real,Y2: real] :
                    ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),set_or5935395276787703475ssThan(real,A3,B2)))
                   => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),Y2),set_or5935395276787703475ssThan(real,A3,B2)))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),F2,X2),N2)),aa(nat,real,aa(real,fun(nat,real),F2,Y2),N2)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,L5,N2)),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y2))))) ) )
               => has_field_derivative(real,aTP_Lamp_rw(fun(real,fun(nat,real)),fun(real,real),F2),suminf(real,aa(real,fun(nat,real),F8,X0)),topolo174197925503356063within(real,X0,top_top(set(real)))) ) ) ) ) ) ) ).

% DERIV_series'
tff(fact_6799_termdiffs,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X3: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
           => ( summable(A,aa(A,fun(nat,A),aTP_Lamp_rx(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,K5)))
               => has_field_derivative(A,aTP_Lamp_rs(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),X3)),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ) ) ) ).

% termdiffs
tff(fact_6800_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X3: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,K5)))
           => has_field_derivative(A,aTP_Lamp_rs(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),X3)),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ) ).

% termdiffs_strong
tff(fact_6801_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K5: real,C2: fun(nat,A),Z: A] :
          ( ! [Z4: A] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Z4)),K5))
             => summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),Z4)) )
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,Z)),K5))
           => has_field_derivative(A,aTP_Lamp_rs(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),Z)),topolo174197925503356063within(A,Z,top_top(set(A)))) ) ) ) ).

% termdiffs_strong'
tff(fact_6802_DERIV__log,axiom,
    ! [X3: real,B2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => has_field_derivative(real,log(B2),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,ln_ln(real),B2)),X3)),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ).

% DERIV_log
tff(fact_6803_DERIV__fun__powr,axiom,
    ! [G: fun(real,real),M: real,X3: real,R2: real] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,G,X3)))
       => has_field_derivative(real,aa(real,fun(real,real),aTP_Lamp_ry(fun(real,real),fun(real,fun(real,real)),G),R2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),R2),powr(real,aa(real,real,G,X3),aa(real,real,aa(real,fun(real,real),minus_minus(real),R2),aa(nat,real,semiring_1_of_nat(real),one_one(nat)))))),M),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ).

% DERIV_fun_powr
tff(fact_6804_DERIV__powr,axiom,
    ! [G: fun(real,real),M: real,X3: real,F2: fun(real,real),R2: real] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,G,X3)))
       => ( has_field_derivative(real,F2,R2,topolo174197925503356063within(real,X3,top_top(set(real))))
         => has_field_derivative(real,aa(fun(real,real),fun(real,real),aTP_Lamp_rz(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,aa(real,real,G,X3),aa(real,real,F2,X3))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),R2),aa(real,real,ln_ln(real),aa(real,real,G,X3)))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),M),aa(real,real,F2,X3))),aa(real,real,G,X3)))),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ) ).

% DERIV_powr
tff(fact_6805_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( cos(A,X3) != zero_zero(A) )
         => has_field_derivative(A,tan(A),aa(A,A,inverse_inverse(A),aa(nat,A,power_power(A,cos(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ).

% DERIV_tan
tff(fact_6806_DERIV__real__sqrt,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
     => has_field_derivative(real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X3))),aa(num,real,numeral_numeral(real),bit0(one2))),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ).

% DERIV_real_sqrt
tff(fact_6807_DERIV__arctan,axiom,
    ! [X3: real] : has_field_derivative(real,arctan,aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))),topolo174197925503356063within(real,X3,top_top(set(real)))) ).

% DERIV_arctan
tff(fact_6808_arsinh__real__has__field__derivative,axiom,
    ! [X3: real,A2: set(real)] : has_field_derivative(real,arsinh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real)))),topolo174197925503356063within(real,X3,A2)) ).

% arsinh_real_has_field_derivative
tff(fact_6809_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( sin(A,X3) != zero_zero(A) )
         => has_field_derivative(A,cot(A),aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),aa(nat,A,power_power(A,sin(A,X3)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ).

% DERIV_cot
tff(fact_6810_has__field__derivative__tanh,axiom,
    ! [A11: $tType] :
      ( ( real_Vector_banach(A11)
        & real_V3459762299906320749_field(A11) )
     => ! [G: fun(A11,A11),X3: A11,Db: A11,S: set(A11)] :
          ( ( cosh(A11,aa(A11,A11,G,X3)) != zero_zero(A11) )
         => ( has_field_derivative(A11,G,Db,topolo174197925503356063within(A11,X3,S))
           => has_field_derivative(A11,aTP_Lamp_sa(fun(A11,A11),fun(A11,A11),G),aa(A11,A11,aa(A11,fun(A11,A11),times_times(A11),aa(A11,A11,aa(A11,fun(A11,A11),minus_minus(A11),one_one(A11)),aa(nat,A11,power_power(A11,aa(A11,A11,tanh(A11),aa(A11,A11,G,X3))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),Db),topolo174197925503356063within(A11,X3,S)) ) ) ) ).

% has_field_derivative_tanh
tff(fact_6811_DERIV__real__sqrt__generic,axiom,
    ! [X3: real,D4: real] :
      ( ( X3 != zero_zero(real) )
     => ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
         => ( D4 = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X3))),aa(num,real,numeral_numeral(real),bit0(one2))) ) )
       => ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real)))
           => ( D4 = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X3)))),aa(num,real,numeral_numeral(real),bit0(one2))) ) )
         => has_field_derivative(real,sqrt,D4,topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ) ).

% DERIV_real_sqrt_generic
tff(fact_6812_arcosh__real__has__field__derivative,axiom,
    ! [X3: real,A2: set(real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => has_field_derivative(real,arcosh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real)))),topolo174197925503356063within(real,X3,A2)) ) ).

% arcosh_real_has_field_derivative
tff(fact_6813_artanh__real__has__field__derivative,axiom,
    ! [X3: real,A2: set(real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => has_field_derivative(real,artanh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))),topolo174197925503356063within(real,X3,A2)) ) ).

% artanh_real_has_field_derivative
tff(fact_6814_DERIV__power__series_H,axiom,
    ! [R4: real,F2: fun(nat,real),X0: real] :
      ( ! [X2: real] :
          ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),R4),R4)))
         => summable(real,aa(real,fun(nat,real),aTP_Lamp_sb(fun(nat,real),fun(real,fun(nat,real)),F2),X2)) )
     => ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X0),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),R4),R4)))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R4))
         => has_field_derivative(real,aTP_Lamp_sd(fun(nat,real),fun(real,real),F2),suminf(real,aa(real,fun(nat,real),aTP_Lamp_sb(fun(nat,real),fun(real,fun(nat,real)),F2),X0)),topolo174197925503356063within(real,X0,top_top(set(real)))) ) ) ) ).

% DERIV_power_series'
tff(fact_6815_dropWhile__nth,axiom,
    ! [A: $tType,J3: nat,P: fun(A,bool),Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),dropWhile(A,P,Xs))))
     => ( aa(nat,A,nth(A,dropWhile(A,P,Xs)),J3) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J3),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))) ) ) ).

% dropWhile_nth
tff(fact_6816_DERIV__real__root,axiom,
    ! [N: nat,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
       => has_field_derivative(real,root(N),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,power_power(real,aa(real,real,root(N),X3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ).

% DERIV_real_root
tff(fact_6817_DERIV__arccos,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => has_field_derivative(real,arccos,aa(real,real,inverse_inverse(real),aa(real,real,uminus_uminus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2))))))),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ).

% DERIV_arccos
tff(fact_6818_DERIV__arcsin,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => has_field_derivative(real,arcsin,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X3),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ).

% DERIV_arcsin
tff(fact_6819_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( distinct(A,Xs)
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( dropWhile(A,aTP_Lamp_op(A,fun(A,bool),X3),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),rev(A),takeWhile(A,aTP_Lamp_op(A,fun(A,bool),X3),Xs))) ) ) ) ).

% dropWhile_neq_rev
tff(fact_6820_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( distinct(A,Xs)
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ( takeWhile(A,aTP_Lamp_op(A,fun(A,bool),X3),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),aa(list(A),list(A),tl(A),dropWhile(A,aTP_Lamp_op(A,fun(A,bool),X3),Xs))) ) ) ) ).

% takeWhile_neq_rev
tff(fact_6821_Maclaurin__all__le__objl,axiom,
    ! [Diff: fun(nat,fun(real,real)),F2: fun(real,real),X3: real,N: nat] :
      ( ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
        & ! [M3: nat,X2: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),X2),topolo174197925503356063within(real,X2,top_top(set(real)))) )
     => ? [T3: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3)))
          & ( aa(real,real,F2,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_se(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ).

% Maclaurin_all_le_objl
tff(fact_6822_Maclaurin__all__le,axiom,
    ! [Diff: fun(nat,fun(real,real)),F2: fun(real,real),X3: real,N: nat] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
     => ( ! [M3: nat,X2: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),X2),topolo174197925503356063within(real,X2,top_top(set(real))))
       => ? [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3)))
            & ( aa(real,real,F2,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_se(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ) ).

% Maclaurin_all_le
tff(fact_6823_DERIV__odd__real__root,axiom,
    ! [N: nat,X3: real] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( ( X3 != zero_zero(real) )
       => has_field_derivative(real,root(N),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,power_power(real,aa(real,real,root(N),X3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ).

% DERIV_odd_real_root
tff(fact_6824_Maclaurin__minus,axiom,
    ! [H: real,N: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H),zero_zero(real)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
         => ( ! [M3: nat,T3: real] :
                ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),H),T3))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),zero_zero(real))) )
               => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
           => ? [T3: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),H),T3))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),zero_zero(real)))
                & ( aa(real,real,F2,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_sf(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,H),N))) ) ) ) ) ) ) ).

% Maclaurin_minus
tff(fact_6825_Maclaurin2,axiom,
    ! [H: real,Diff: fun(nat,fun(real,real)),F2: fun(real,real),N: nat] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H))
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
       => ( ! [M3: nat,T3: real] :
              ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T3))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),H)) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ? [T3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),T3))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),H))
              & ( aa(real,real,F2,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_sf(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,H),N))) ) ) ) ) ) ).

% Maclaurin2
tff(fact_6826_Maclaurin,axiom,
    ! [H: real,N: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),H))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
         => ( ! [M3: nat,T3: real] :
                ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T3))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),H)) )
               => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
           => ? [T3: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),T3))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),H))
                & ( aa(real,real,F2,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_sf(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,H),N))) ) ) ) ) ) ) ).

% Maclaurin
tff(fact_6827_Maclaurin__all__lt,axiom,
    ! [Diff: fun(nat,fun(real,real)),F2: fun(real,real),N: nat,X3: real] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( ( X3 != zero_zero(real) )
         => ( ! [M3: nat,X2: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),X2),topolo174197925503356063within(real,X2,top_top(set(real))))
           => ? [T3: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,abs_abs(real),T3)))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3)))
                & ( aa(real,real,F2,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_se(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ) ) ) ).

% Maclaurin_all_lt
tff(fact_6828_Maclaurin__bi__le,axiom,
    ! [Diff: fun(nat,fun(real,real)),F2: fun(real,real),N: nat,X3: real] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
     => ( ! [M3: nat,T3: real] :
            ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3))) )
           => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
       => ? [T3: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X3)))
            & ( aa(real,real,F2,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_se(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,X3),N))) ) ) ) ) ).

% Maclaurin_bi_le
tff(fact_6829_Taylor__down,axiom,
    ! [N: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real),A3: real,B2: real,C2: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
       => ( ! [M3: nat,T3: real] :
              ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),T3))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),B2)) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),C2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),C2),B2))
             => ? [T3: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),T3))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),C2))
                  & ( aa(real,real,F2,A3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_sg(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),A3),C2)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),A3),C2)),N))) ) ) ) ) ) ) ) ).

% Taylor_down
tff(fact_6830_Taylor__up,axiom,
    ! [N: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real),A3: real,B2: real,C2: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
       => ( ! [M3: nat,T3: real] :
              ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),T3))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),B2)) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),C2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),B2))
             => ? [T3: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),T3))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),B2))
                  & ( aa(real,real,F2,B2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_sg(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),B2),C2)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),C2)),N))) ) ) ) ) ) ) ) ).

% Taylor_up
tff(fact_6831_Taylor,axiom,
    ! [N: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real),A3: real,B2: real,C2: real,X3: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
       => ( ! [M3: nat,T3: real] :
              ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),T3))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),B2)) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),C2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),C2),B2))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X3))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),B2))
                 => ( ( X3 != C2 )
                   => ? [T3: real] :
                        ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),C2))
                         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),T3))
                            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),C2)) ) )
                        & ( ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),C2))
                         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),T3))
                            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),T3),X3)) ) )
                        & ( aa(real,real,F2,X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_sh(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),C2),X3)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,N),T3)),semiring_char_0_fact(real,N))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),C2)),N))) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
tff(fact_6832_Maclaurin__lemma2,axiom,
    ! [N: nat,H: real,Diff: fun(nat,fun(real,real)),K: nat,B3: real] :
      ( ! [M3: nat,T3: real] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T3))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T3),H)) )
         => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
     => ( ( N = aa(nat,nat,suc,K) )
       => ! [M2: nat,T8: real] :
            ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),T8))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),T8),H)) )
           => has_field_derivative(real,aa(nat,fun(real,real),aa(real,fun(nat,fun(real,real)),aa(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real))),aTP_Lamp_sj(nat,fun(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real)))),N),Diff),B3),M2),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T8)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_sk(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Diff),M2),T8)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,M2))))),aa(real,real,aa(real,fun(real,real),times_times(real),B3),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,T8),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,M2)))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,M2))))))),topolo174197925503356063within(real,T8,top_top(set(real)))) ) ) ) ).

% Maclaurin_lemma2
tff(fact_6833_DERIV__arctan__series,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => has_field_derivative(real,aTP_Lamp_sl(real,real),suminf(real,aTP_Lamp_sm(real,fun(nat,real),X3)),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ).

% DERIV_arctan_series
tff(fact_6834_DERIV__real__root__generic,axiom,
    ! [N: nat,X3: real,D4: real] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( ( X3 != zero_zero(real) )
       => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),X3))
             => ( D4 = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,power_power(real,aa(real,real,root(N),X3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))) ) ) )
         => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),zero_zero(real)))
               => ( D4 = aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,power_power(real,aa(real,real,root(N),X3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat))))))) ) ) )
           => ( ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
               => ( D4 = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,power_power(real,aa(real,real,root(N),X3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))) ) )
             => has_field_derivative(real,root(N),D4,topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ) ) ) ).

% DERIV_real_root_generic
tff(fact_6835_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X3: A,G3: fun(A,real),S: set(A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,G,X3)))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(A,real,G,X3)),one_one(real)))
           => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
             => has_derivative(A,real,aTP_Lamp_sn(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_so(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X3),G3),topolo174197925503356063within(A,X3,S)) ) ) ) ) ).

% has_derivative_arcsin
tff(fact_6836_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X3: A,G3: fun(A,real),S: set(A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,G,X3)))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(A,real,G,X3)),one_one(real)))
           => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
             => has_derivative(A,real,aTP_Lamp_sp(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_sq(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X3),G3),topolo174197925503356063within(A,X3,S)) ) ) ) ) ).

% has_derivative_arccos
tff(fact_6837_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),X3: A,S: set(A),T2: set(A)] :
          ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T2),S))
           => has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,T2)) ) ) ) ).

% has_derivative_subset
tff(fact_6838_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,F3: filter(A)] :
          ( has_field_derivative(A,F2,D4,F3)
        <=> has_derivative(A,A,F2,aa(A,fun(A,A),times_times(A),D4),F3) ) ) ).

% has_field_derivative_def
tff(fact_6839_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: fun(A,A),F3: filter(A),D7: A] :
          ( has_derivative(A,A,F2,D4,F3)
         => ( ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),D7) = aa(A,A,D4,X2) )
           => has_field_derivative(A,F2,D7,F3) ) ) ) ).

% has_derivative_imp_has_field_derivative
tff(fact_6840_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,F3: filter(A)] :
          ( has_field_derivative(A,F2,D4,F3)
         => has_derivative(A,A,F2,aa(A,fun(A,A),times_times(A),D4),F3) ) ) ).

% has_field_derivative_imp_has_derivative
tff(fact_6841_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(C) )
     => ! [F2: fun(D,real),F8: fun(D,real),X3: D,S: set(D),G: fun(D,C),G3: fun(D,C)] :
          ( has_derivative(D,real,F2,F8,topolo174197925503356063within(D,X3,S))
         => ( has_derivative(D,C,G,G3,topolo174197925503356063within(D,X3,S))
           => has_derivative(D,C,aa(fun(D,C),fun(D,C),aTP_Lamp_sr(fun(D,real),fun(fun(D,C),fun(D,C)),F2),G),aa(fun(D,C),fun(D,C),aa(fun(D,C),fun(fun(D,C),fun(D,C)),aa(D,fun(fun(D,C),fun(fun(D,C),fun(D,C))),aa(fun(D,real),fun(D,fun(fun(D,C),fun(fun(D,C),fun(D,C)))),aTP_Lamp_ss(fun(D,real),fun(fun(D,real),fun(D,fun(fun(D,C),fun(fun(D,C),fun(D,C))))),F2),F8),X3),G),G3),topolo174197925503356063within(D,X3,S)) ) ) ) ).

% has_derivative_scaleR
tff(fact_6842_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [C2: B,F3: filter(A)] : has_derivative(A,B,aTP_Lamp_st(B,fun(A,B),C2),aTP_Lamp_su(A,B),F3) ) ).

% has_derivative_const
tff(fact_6843_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),F3: filter(A),G: fun(A,B),G3: fun(A,B)] :
          ( has_derivative(A,B,F2,F8,F3)
         => ( has_derivative(A,B,G,G3,F3)
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sv(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),aa(fun(A,B),fun(A,B),aTP_Lamp_sv(fun(A,B),fun(fun(A,B),fun(A,B)),F8),G3),F3) ) ) ) ).

% has_derivative_add
tff(fact_6844_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V4412858255891104859lgebra(A) )
     => ! [G: fun(C,A),G3: fun(C,A),F3: filter(C),X3: A] :
          ( has_derivative(C,A,G,G3,F3)
         => has_derivative(C,A,aa(A,fun(C,A),aTP_Lamp_sw(fun(C,A),fun(A,fun(C,A)),G),X3),aa(A,fun(C,A),aTP_Lamp_sw(fun(C,A),fun(A,fun(C,A)),G3),X3),F3) ) ) ).

% has_derivative_mult_right
tff(fact_6845_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V4412858255891104859lgebra(A) )
     => ! [G: fun(C,A),G3: fun(C,A),F3: filter(C),Y4: A] :
          ( has_derivative(C,A,G,G3,F3)
         => has_derivative(C,A,aa(A,fun(C,A),aTP_Lamp_sx(fun(C,A),fun(A,fun(C,A)),G),Y4),aa(A,fun(C,A),aTP_Lamp_sx(fun(C,A),fun(A,fun(C,A)),G3),Y4),F3) ) ) ).

% has_derivative_mult_left
tff(fact_6846_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V4412858255891104859lgebra(A) )
     => ! [F2: fun(D,A),F8: fun(D,A),X3: D,S: set(D),G: fun(D,A),G3: fun(D,A)] :
          ( has_derivative(D,A,F2,F8,topolo174197925503356063within(D,X3,S))
         => ( has_derivative(D,A,G,G3,topolo174197925503356063within(D,X3,S))
           => has_derivative(D,A,aa(fun(D,A),fun(D,A),aTP_Lamp_sy(fun(D,A),fun(fun(D,A),fun(D,A)),F2),G),aa(fun(D,A),fun(D,A),aa(fun(D,A),fun(fun(D,A),fun(D,A)),aa(D,fun(fun(D,A),fun(fun(D,A),fun(D,A))),aa(fun(D,A),fun(D,fun(fun(D,A),fun(fun(D,A),fun(D,A)))),aTP_Lamp_sz(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,A),fun(fun(D,A),fun(D,A))))),F2),F8),X3),G),G3),topolo174197925503356063within(D,X3,S)) ) ) ) ).

% has_derivative_mult
tff(fact_6847_has__derivative__zero__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(A,B),X3: A] :
          ( has_derivative(A,B,aTP_Lamp_su(A,B),F3,topolo174197925503356063within(A,X3,top_top(set(A))))
         => ! [X: A] : ( aa(A,B,F3,X) = zero_zero(B) ) ) ) ).

% has_derivative_zero_unique
tff(fact_6848_has__derivative__in__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [T2: set(A),G: fun(A,B),G3: fun(A,fun(A,B)),F2: fun(C,A),S: set(C),X3: C,F8: fun(C,A)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),T2))
             => has_derivative(A,B,G,aa(A,fun(A,B),G3,X2),topolo174197925503356063within(A,X2,T2)) )
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,F2),S)),T2))
           => ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X3),S))
             => ( has_derivative(C,A,F2,F8,topolo174197925503356063within(C,X3,S))
               => has_derivative(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ta(fun(A,B),fun(fun(C,A),fun(C,B)),G),F2),aa(fun(C,A),fun(C,B),aa(C,fun(fun(C,A),fun(C,B)),aa(fun(C,A),fun(C,fun(fun(C,A),fun(C,B))),aTP_Lamp_tb(fun(A,fun(A,B)),fun(fun(C,A),fun(C,fun(fun(C,A),fun(C,B)))),G3),F2),X3),F8),topolo174197925503356063within(C,X3,S)) ) ) ) ) ) ).

% has_derivative_in_compose2
tff(fact_6849_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),X3: A,S: set(A)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
         => has_derivative(A,real,aTP_Lamp_tc(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_td(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G3),X3),topolo174197925503356063within(A,X3,S)) ) ) ).

% has_derivative_exp
tff(fact_6850_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),X3: A,S: set(A)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
         => has_derivative(A,real,aTP_Lamp_te(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_tf(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G3),X3),topolo174197925503356063within(A,X3,S)) ) ) ).

% has_derivative_sin
tff(fact_6851_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,X3: A,S: set(A)] :
          ( has_derivative(A,A,G,aa(A,fun(A,A),times_times(A),Db),topolo174197925503356063within(A,X3,S))
         => has_derivative(A,A,aTP_Lamp_tg(fun(A,A),fun(A,A),G),aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,aa(A,A,G,X3))),Db)),topolo174197925503356063within(A,X3,S)) ) ) ).

% has_derivative_sinh
tff(fact_6852_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,X3: A,S: set(A)] :
          ( has_derivative(A,A,G,aa(A,fun(A,A),times_times(A),Db),topolo174197925503356063within(A,X3,S))
         => has_derivative(A,A,aTP_Lamp_th(fun(A,A),fun(A,A),G),aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,aa(A,A,G,X3))),Db)),topolo174197925503356063within(A,X3,S)) ) ) ).

% has_derivative_cosh
tff(fact_6853_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V3459762299906320749_field(A) )
     => ! [F2: fun(C,A),F8: fun(C,A),X3: C,S2: set(C),G: fun(C,A),G3: fun(C,A)] :
          ( has_derivative(C,A,F2,F8,topolo174197925503356063within(C,X3,S2))
         => ( has_derivative(C,A,G,G3,topolo174197925503356063within(C,X3,S2))
           => ( ( aa(C,A,G,X3) != zero_zero(A) )
             => has_derivative(C,A,aa(fun(C,A),fun(C,A),aTP_Lamp_ti(fun(C,A),fun(fun(C,A),fun(C,A)),F2),G),aa(fun(C,A),fun(C,A),aa(fun(C,A),fun(fun(C,A),fun(C,A)),aa(C,fun(fun(C,A),fun(fun(C,A),fun(C,A))),aa(fun(C,A),fun(C,fun(fun(C,A),fun(fun(C,A),fun(C,A)))),aTP_Lamp_tj(fun(C,A),fun(fun(C,A),fun(C,fun(fun(C,A),fun(fun(C,A),fun(C,A))))),F2),F8),X3),G),G3),topolo174197925503356063within(C,X3,S2)) ) ) ) ) ).

% has_derivative_divide'
tff(fact_6854_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(C,A),X3: C,F8: fun(C,A),S2: set(C)] :
          ( ( aa(C,A,F2,X3) != zero_zero(A) )
         => ( has_derivative(C,A,F2,F8,topolo174197925503356063within(C,X3,S2))
           => has_derivative(C,A,aTP_Lamp_tk(fun(C,A),fun(C,A),F2),aa(fun(C,A),fun(C,A),aa(C,fun(fun(C,A),fun(C,A)),aTP_Lamp_tl(fun(C,A),fun(C,fun(fun(C,A),fun(C,A))),F2),X3),F8),topolo174197925503356063within(C,X3,S2)) ) ) ) ).

% has_derivative_inverse
tff(fact_6855_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X3: A,S2: set(A)] :
          ( ( X3 != zero_zero(A) )
         => has_derivative(A,A,inverse_inverse(A),aTP_Lamp_tm(A,fun(A,A),X3),topolo174197925503356063within(A,X3,S2)) ) ) ).

% has_derivative_inverse'
tff(fact_6856_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(real,real),F8: real,G: fun(A,real),X3: A,G3: fun(A,real),S: set(A)] :
          ( has_field_derivative(real,F2,F8,topolo174197925503356063within(real,aa(A,real,G,X3),top_top(set(real))))
         => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
           => has_derivative(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tn(fun(real,real),fun(fun(A,real),fun(A,real)),F2),G),aa(fun(A,real),fun(A,real),aTP_Lamp_to(real,fun(fun(A,real),fun(A,real)),F8),G3),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_compose_FDERIV
tff(fact_6857_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),X3: A,S: set(A)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
         => has_derivative(A,real,aTP_Lamp_tp(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_tq(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G3),X3),topolo174197925503356063within(A,X3,S)) ) ) ).

% has_derivative_cos
tff(fact_6858_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),X3: A,S2: set(A),N: nat] :
          ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S2))
         => has_derivative(A,B,aa(nat,fun(A,B),aTP_Lamp_tr(fun(A,B),fun(nat,fun(A,B)),F2),N),aa(nat,fun(A,B),aa(A,fun(nat,fun(A,B)),aa(fun(A,B),fun(A,fun(nat,fun(A,B))),aTP_Lamp_ts(fun(A,B),fun(fun(A,B),fun(A,fun(nat,fun(A,B)))),F2),F8),X3),N),topolo174197925503356063within(A,X3,S2)) ) ) ).

% has_derivative_power
tff(fact_6859_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X3: A,G3: fun(A,real),S: set(A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,G,X3)))
         => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
           => has_derivative(A,real,aTP_Lamp_tt(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_tu(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X3),G3),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% has_derivative_ln
tff(fact_6860_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(C,A),F8: fun(C,A),X3: C,S2: set(C),G: fun(C,A),G3: fun(C,A)] :
          ( has_derivative(C,A,F2,F8,topolo174197925503356063within(C,X3,S2))
         => ( has_derivative(C,A,G,G3,topolo174197925503356063within(C,X3,S2))
           => ( ( aa(C,A,G,X3) != zero_zero(A) )
             => has_derivative(C,A,aa(fun(C,A),fun(C,A),aTP_Lamp_tv(fun(C,A),fun(fun(C,A),fun(C,A)),F2),G),aa(fun(C,A),fun(C,A),aa(fun(C,A),fun(fun(C,A),fun(C,A)),aa(C,fun(fun(C,A),fun(fun(C,A),fun(C,A))),aa(fun(C,A),fun(C,fun(fun(C,A),fun(fun(C,A),fun(C,A)))),aTP_Lamp_tw(fun(C,A),fun(fun(C,A),fun(C,fun(fun(C,A),fun(fun(C,A),fun(C,A))))),F2),F8),X3),G),G3),topolo174197925503356063within(C,X3,S2)) ) ) ) ) ).

% has_derivative_divide
tff(fact_6861_has__derivative__prod,axiom,
    ! [B: $tType,I6: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [I5: set(I6),F2: fun(I6,fun(A,B)),F8: fun(I6,fun(A,B)),X3: A,S2: set(A)] :
          ( ! [I3: I6] :
              ( pp(aa(set(I6),bool,aa(I6,fun(set(I6),bool),member2(I6),I3),I5))
             => has_derivative(A,B,aa(I6,fun(A,B),F2,I3),aa(I6,fun(A,B),F8,I3),topolo174197925503356063within(A,X3,S2)) )
         => has_derivative(A,B,aa(fun(I6,fun(A,B)),fun(A,B),aTP_Lamp_ty(set(I6),fun(fun(I6,fun(A,B)),fun(A,B)),I5),F2),aa(A,fun(A,B),aa(fun(I6,fun(A,B)),fun(A,fun(A,B)),aa(fun(I6,fun(A,B)),fun(fun(I6,fun(A,B)),fun(A,fun(A,B))),aTP_Lamp_ua(set(I6),fun(fun(I6,fun(A,B)),fun(fun(I6,fun(A,B)),fun(A,fun(A,B)))),I5),F2),F8),X3),topolo174197925503356063within(A,X3,S2)) ) ) ).

% has_derivative_prod
tff(fact_6862_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),X3: A,X7: set(A),F2: fun(A,real),F8: fun(A,real)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,X7))
         => ( has_derivative(A,real,F2,F8,topolo174197925503356063within(A,X3,X7))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,G,X3)))
             => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),X7))
               => has_derivative(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ub(fun(A,real),fun(fun(A,real),fun(A,real)),G),F2),aa(fun(A,real),fun(A,real),aa(fun(A,real),fun(fun(A,real),fun(A,real)),aa(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))),aa(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real)))),aTP_Lamp_uc(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))))),G),G3),X3),F2),F8),topolo174197925503356063within(A,X3,X7)) ) ) ) ) ) ).

% has_derivative_powr
tff(fact_6863_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X3: A,G3: fun(A,real),S: set(A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,G,X3)))
         => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
           => has_derivative(A,real,aTP_Lamp_ud(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_ue(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X3),G3),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% has_derivative_real_sqrt
tff(fact_6864_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),X3: A,S: set(A)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
         => has_derivative(A,real,aTP_Lamp_uf(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_ug(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G3),X3),topolo174197925503356063within(A,X3,S)) ) ) ).

% has_derivative_arctan
tff(fact_6865_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X3: A,G3: fun(A,real),S: set(A)] :
          ( ( cos(real,aa(A,real,G,X3)) != zero_zero(real) )
         => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
           => has_derivative(A,real,aTP_Lamp_uh(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_ui(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X3),G3),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% has_derivative_tan
tff(fact_6866_find__dropWhile,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( find(A,P,Xs) = aa(list(A),option(A),case_list(option(A),A,none(A),aTP_Lamp_uj(A,fun(list(A),option(A)))),dropWhile(A,aa(fun(A,bool),fun(A,bool),comp(bool,bool,A,fNot),P),Xs)) ) ).

% find_dropWhile
tff(fact_6867_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & archim2362893244070406136eiling(Aa)
        & topolo2564578578187576103pology(Aa) )
     => ! [G: fun(A,real),X3: A,F2: fun(real,Aa),G3: fun(A,real),S: set(A)] :
          ( topolo3448309680560233919inuous(real,Aa,topolo174197925503356063within(real,aa(A,real,G,X3),top_top(set(real))),F2)
         => ( ~ pp(aa(set(Aa),bool,aa(Aa,fun(set(Aa),bool),member2(Aa),aa(real,Aa,F2,aa(A,real,G,X3))),ring_1_Ints(Aa)))
           => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,X3,S))
             => has_derivative(A,real,aa(fun(real,Aa),fun(A,real),aTP_Lamp_uk(fun(A,real),fun(fun(real,Aa),fun(A,real)),G),F2),aTP_Lamp_ul(fun(A,real),fun(A,real),G3),topolo174197925503356063within(A,X3,S)) ) ) ) ) ).

% has_derivative_floor
tff(fact_6868_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology(B)
        & topolo8458572112393995274pology(A) )
     => ! [F2: fun(A,B),A3: A,Y4: B,B2: A] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,A3)),Y4))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Y4),aa(A,B,F2,B2)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
             => ( ! [X2: A] :
                    ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B2)) )
                   => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X2,top_top(set(A))),F2) )
               => ? [X2: A] :
                    ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B2))
                    & ( aa(A,B,F2,X2) = Y4 ) ) ) ) ) ) ) ).

% IVT
tff(fact_6869_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology(B)
        & topolo8458572112393995274pology(A) )
     => ! [F2: fun(A,B),B2: A,Y4: B,A3: A] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,B2)),Y4))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Y4),aa(A,B,F2,A3)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
             => ( ! [X2: A] :
                    ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B2)) )
                   => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X2,top_top(set(A))),F2) )
               => ? [X2: A] :
                    ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B2))
                    & ( aa(A,B,F2,X2) = Y4 ) ) ) ) ) ) ) ).

% IVT2
tff(fact_6870_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( topological_t2_space(D)
        & real_V4412858255891104859lgebra(A) )
     => ! [F3: filter(D),F2: fun(D,A),G: fun(D,A)] :
          ( topolo3448309680560233919inuous(D,A,F3,F2)
         => ( topolo3448309680560233919inuous(D,A,F3,G)
           => topolo3448309680560233919inuous(D,A,F3,aa(fun(D,A),fun(D,A),aTP_Lamp_um(fun(D,A),fun(fun(D,A),fun(D,A)),F2),G)) ) ) ) ).

% continuous_mult
tff(fact_6871_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topological_t2_space(D)
        & topolo4211221413907600880p_mult(B) )
     => ! [F3: filter(D),F2: fun(D,B),G: fun(D,B)] :
          ( topolo3448309680560233919inuous(D,B,F3,F2)
         => ( topolo3448309680560233919inuous(D,B,F3,G)
           => topolo3448309680560233919inuous(D,B,F3,aa(fun(D,B),fun(D,B),aTP_Lamp_un(fun(D,B),fun(fun(D,B),fun(D,B)),F2),G)) ) ) ) ).

% continuous_mult'
tff(fact_6872_continuous__mult__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & topological_t2_space(B) )
     => ! [F3: filter(B),F2: fun(B,A),C2: A] :
          ( topolo3448309680560233919inuous(B,A,F3,F2)
         => topolo3448309680560233919inuous(B,A,F3,aa(A,fun(B,A),aTP_Lamp_uo(fun(B,A),fun(A,fun(B,A)),F2),C2)) ) ) ).

% continuous_mult_left
tff(fact_6873_continuous__mult__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & topological_t2_space(B) )
     => ! [F3: filter(B),F2: fun(B,A),C2: A] :
          ( topolo3448309680560233919inuous(B,A,F3,F2)
         => topolo3448309680560233919inuous(B,A,F3,aa(A,fun(B,A),aTP_Lamp_up(fun(B,A),fun(A,fun(B,A)),F2),C2)) ) ) ).

% continuous_mult_right
tff(fact_6874_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & topolo1898628316856586783d_mult(B) )
     => ! [F3: filter(C),F2: fun(C,B),G: fun(C,nat)] :
          ( topolo3448309680560233919inuous(C,B,F3,F2)
         => ( topolo3448309680560233919inuous(C,nat,F3,G)
           => topolo3448309680560233919inuous(C,B,F3,aa(fun(C,nat),fun(C,B),aTP_Lamp_uq(fun(C,B),fun(fun(C,nat),fun(C,B)),F2),G)) ) ) ) ).

% continuous_power'
tff(fact_6875_continuous__power,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [F3: filter(A),F2: fun(A,B),N: nat] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => topolo3448309680560233919inuous(A,B,F3,aa(nat,fun(A,B),aTP_Lamp_ur(fun(A,B),fun(nat,fun(A,B)),F2),N)) ) ) ).

% continuous_power
tff(fact_6876_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topological_t2_space(D)
        & topolo6943815403480290642id_add(B) )
     => ! [F3: filter(D),F2: fun(D,B),G: fun(D,B)] :
          ( topolo3448309680560233919inuous(D,B,F3,F2)
         => ( topolo3448309680560233919inuous(D,B,F3,G)
           => topolo3448309680560233919inuous(D,B,F3,aa(fun(D,B),fun(D,B),aTP_Lamp_us(fun(D,B),fun(fun(D,B),fun(D,B)),F2),G)) ) ) ) ).

% continuous_add
tff(fact_6877_find__cong,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Ys2)))
           => ( pp(aa(A,bool,P,X2))
            <=> pp(aa(A,bool,Q,X2)) ) )
       => ( find(A,P,Xs) = find(A,Q,Ys2) ) ) ) ).

% find_cong
tff(fact_6878_isCont__Lb__Ub,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
     => ( ! [X2: real] :
            ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2)) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),F2) )
       => ? [L6: real,M10: real] :
            ( ! [X: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X),B2)) )
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),L6),aa(real,real,F2,X)))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,F2,X)),M10)) ) )
            & ! [Y5: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),L6),Y5))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Y5),M10)) )
               => ? [X2: real] :
                    ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                    & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
                    & ( aa(real,real,F2,X2) = Y5 ) ) ) ) ) ) ).

% isCont_Lb_Ub
tff(fact_6879_isCont__real__sqrt,axiom,
    ! [X3: real] : topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),sqrt) ).

% isCont_real_sqrt
tff(fact_6880_isCont__real__root,axiom,
    ! [X3: real,N: nat] : topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),root(N)) ).

% isCont_real_root
tff(fact_6881_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [A3: A,S: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),F2)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),G)
           => ( ( aa(A,B,G,A3) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),aa(fun(A,B),fun(A,B),aTP_Lamp_ut(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ) ).

% continuous_at_within_divide
tff(fact_6882_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [A3: A,F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_uu(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% isCont_mult
tff(fact_6883_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [A3: A,F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_uv(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% isCont_add
tff(fact_6884_isCont__power,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [A3: A,F2: fun(A,B),N: nat] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),aa(nat,fun(A,B),aTP_Lamp_ur(fun(A,B),fun(nat,fun(A,B)),F2),N)) ) ) ).

% isCont_power
tff(fact_6885_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [A3: A,S: set(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),F2)
         => ( ( aa(A,B,F2,A3) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),aTP_Lamp_uw(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_at_within_inverse
tff(fact_6886_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A3: A,S: set(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),F2)
         => ( ( aa(A,B,F2,A3) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),aTP_Lamp_ux(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_at_within_sgn
tff(fact_6887_find_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A)] :
      ( ( pp(aa(A,bool,P,X3))
       => ( find(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = some(A,X3) ) )
      & ( ~ pp(aa(A,bool,P,X3))
       => ( find(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = find(A,P,Xs) ) ) ) ).

% find.simps(2)
tff(fact_6888_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: fun(A,bool)] : ( find(A,Uu,nil(A)) = none(A) ) ).

% find.simps(1)
tff(fact_6889_find__None__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( find(A,P,Xs) = none(A) )
    <=> ~ ? [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
            & pp(aa(A,bool,P,X4)) ) ) ).

% find_None_iff
tff(fact_6890_find__None__iff2,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] :
      ( ( none(A) = find(A,P,Xs) )
    <=> ~ ? [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
            & pp(aa(A,bool,P,X4)) ) ) ).

% find_None_iff2
tff(fact_6891_isCont__bounded,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A3: real,B2: real,F2: fun(real,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
         => ( ! [X2: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2)) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X2,top_top(set(real))),F2) )
           => ? [M10: A] :
              ! [X: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X),B2)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(real,A,F2,X)),M10)) ) ) ) ) ).

% isCont_bounded
tff(fact_6892_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A3: real,B2: real,F2: fun(real,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
         => ( ! [X2: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2)) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X2,top_top(set(real))),F2) )
           => ? [M10: A] :
                ( ! [X: real] :
                    ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X))
                      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X),B2)) )
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(real,A,F2,X)),M10)) )
                & ? [X2: real] :
                    ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                    & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
                    & ( aa(real,A,F2,X2) = M10 ) ) ) ) ) ) ).

% isCont_eq_Ub
tff(fact_6893_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A3: real,B2: real,F2: fun(real,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
         => ( ! [X2: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2)) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X2,top_top(set(real))),F2) )
           => ? [M10: A] :
                ( ! [X: real] :
                    ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X))
                      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X),B2)) )
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M10),aa(real,A,F2,X))) )
                & ? [X2: real] :
                    ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                    & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
                    & ( aa(real,A,F2,X2) = M10 ) ) ) ) ) ) ).

% isCont_eq_Lb
tff(fact_6894_isCont__inverse__function2,axiom,
    ! [A3: real,X3: real,B2: real,G: fun(real,real),F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),B2))
       => ( ! [Z4: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),Z4))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Z4),B2))
               => ( aa(real,real,G,aa(real,real,F2,Z4)) = Z4 ) ) )
         => ( ! [Z4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),Z4))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Z4),B2))
                 => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z4,top_top(set(real))),F2) ) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,aa(real,real,F2,X3),top_top(set(real))),G) ) ) ) ) ).

% isCont_inverse_function2
tff(fact_6895_isCont__ln,axiom,
    ! [X3: real] :
      ( ( X3 != zero_zero(real) )
     => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),ln_ln(real)) ) ).

% isCont_ln
tff(fact_6896_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [A3: A,F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),G)
           => ( ( aa(A,B,G,A3) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_ut(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ) ).

% isCont_divide
tff(fact_6897_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A3: A,F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( ( aa(A,B,F2,A3) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),aTP_Lamp_ux(fun(A,B),fun(A,B),F2)) ) ) ) ).

% isCont_sgn
tff(fact_6898_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,S: set(A),F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,S),F2)
         => ( ( cos(A,aa(A,A,F2,X3)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,S),aTP_Lamp_uy(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_within_tan
tff(fact_6899_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A,S: set(A),F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,S),F2)
         => ( ( sin(A,aa(A,A,F2,X3)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,S),aTP_Lamp_uz(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_within_cot
tff(fact_6900_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: C,A2: set(C),F2: fun(C,A)] :
          ( topolo3448309680560233919inuous(C,A,topolo174197925503356063within(C,X3,A2),F2)
         => ( ( cosh(A,aa(C,A,F2,X3)) != zero_zero(A) )
           => topolo3448309680560233919inuous(C,A,topolo174197925503356063within(C,X3,A2),aTP_Lamp_va(fun(C,A),fun(C,A),F2)) ) ) ) ).

% continuous_at_within_tanh
tff(fact_6901_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),L: A,X3: A] :
          ( has_field_derivative(A,F2,L,topolo174197925503356063within(A,X3,top_top(set(A))))
        <=> ? [G4: fun(A,A)] :
              ( ! [Z6: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,F2,Z6)),aa(A,A,F2,X3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,G4,Z6)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z6),X3)) )
              & topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,top_top(set(A))),G4)
              & ( aa(A,A,G4,X3) = L ) ) ) ) ).

% CARAT_DERIV
tff(fact_6902_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A3: real,B2: real,F2: fun(real,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
         => ( ! [X2: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2)) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X2,top_top(set(real))),F2) )
           => ? [M10: A] :
                ( ! [X: real] :
                    ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X))
                      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X),B2)) )
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(real,A,F2,X)),M10)) )
                & ! [N8: A] :
                    ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),N8),M10))
                   => ? [X2: real] :
                        ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
                        & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),N8),aa(real,A,F2,X2))) ) ) ) ) ) ) ).

% isCont_has_Ub
tff(fact_6903_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( cos(A,X3) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,top_top(set(A))),tan(A)) ) ) ).

% isCont_tan
tff(fact_6904_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( sin(A,X3) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,top_top(set(A))),cot(A)) ) ) ).

% isCont_cot
tff(fact_6905_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( ( cosh(A,X3) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,top_top(set(A))),tanh(A)) ) ) ).

% isCont_tanh
tff(fact_6906_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A3: A,F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( ( cos(A,aa(A,A,F2,A3)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A3,top_top(set(A))),aTP_Lamp_uy(fun(A,A),fun(A,A),F2)) ) ) ) ).

% isCont_tan'
tff(fact_6907_isCont__arcosh,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),arcosh(real)) ) ).

% isCont_arcosh
tff(fact_6908_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A3: A,F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( ( sin(A,aa(A,A,F2,A3)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A3,top_top(set(A))),aTP_Lamp_uz(fun(A,A),fun(A,A),F2)) ) ) ) ).

% isCont_cot'
tff(fact_6909_DERIV__inverse__function,axiom,
    ! [F2: fun(real,real),D4: real,G: fun(real,real),X3: real,A3: real,B2: real] :
      ( has_field_derivative(real,F2,D4,topolo174197925503356063within(real,aa(real,real,G,X3),top_top(set(real))))
     => ( ( D4 != zero_zero(real) )
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X3))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),B2))
           => ( ! [Y2: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Y2))
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y2),B2))
                   => ( aa(real,real,F2,aa(real,real,G,Y2)) = Y2 ) ) )
             => ( topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),G)
               => has_field_derivative(real,G,aa(real,real,inverse_inverse(real),D4),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ) ) ) ) ).

% DERIV_inverse_function
tff(fact_6910_isCont__polynom,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A3: A,C2: fun(nat,A),N: nat] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A3,top_top(set(A))),aa(nat,fun(A,A),aTP_Lamp_vb(fun(nat,A),fun(nat,fun(A,A)),C2),N)) ) ).

% isCont_polynom
tff(fact_6911_isCont__arccos,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),arccos) ) ) ).

% isCont_arccos
tff(fact_6912_isCont__arcsin,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),arcsin) ) ) ).

% isCont_arcsin
tff(fact_6913_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X3: A] :
          ( ! [Y2: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),Y2))
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,top_top(set(A))),aTP_Lamp_rs(fun(nat,A),fun(A,A),C2)) ) ) ).

% isCont_powser_converges_everywhere
tff(fact_6914_LIM__less__bound,axiom,
    ! [B2: real,X3: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),B2),X3))
     => ( ! [X2: real] :
            ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),set_or5935395276787703475ssThan(real,B2,X3)))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,F2,X2))) )
       => ( topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),F2)
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(real,real,F2,X3))) ) ) ) ).

% LIM_less_bound
tff(fact_6915_isCont__artanh,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),artanh(real)) ) ) ).

% isCont_artanh
tff(fact_6916_find__Some__iff2,axiom,
    ! [A: $tType,X3: A,P: fun(A,bool),Xs: list(A)] :
      ( ( some(A,X3) = find(A,P,Xs) )
    <=> ? [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))
          & pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),I2)))
          & ( X3 = aa(nat,A,nth(A,Xs),I2) )
          & ! [J4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),I2))
             => ~ pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),J4))) ) ) ) ).

% find_Some_iff2
tff(fact_6917_find__Some__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),X3: A] :
      ( ( find(A,P,Xs) = some(A,X3) )
    <=> ? [I2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))
          & pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),I2)))
          & ( X3 = aa(nat,A,nth(A,Xs),I2) )
          & ! [J4: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J4),I2))
             => ~ pp(aa(A,bool,P,aa(nat,A,nth(A,Xs),J4))) ) ) ) ).

% find_Some_iff
tff(fact_6918_isCont__inverse__function,axiom,
    ! [D2: real,X3: real,G: fun(real,real),F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D2))
     => ( ! [Z4: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Z4),X3))),D2))
           => ( aa(real,real,G,aa(real,real,F2,Z4)) = Z4 ) )
       => ( ! [Z4: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Z4),X3))),D2))
             => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z4,top_top(set(real))),F2) )
         => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,aa(real,real,F2,X3),top_top(set(real))),G) ) ) ) ).

% isCont_inverse_function
tff(fact_6919_GMVT_H,axiom,
    ! [A3: real,B2: real,F2: fun(real,real),G: fun(real,real),G3: fun(real,real),F8: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ! [Z4: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),Z4))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Z4),B2))
             => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z4,top_top(set(real))),F2) ) )
       => ( ! [Z4: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),Z4))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Z4),B2))
               => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z4,top_top(set(real))),G) ) )
         => ( ! [Z4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Z4))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Z4),B2))
                 => has_field_derivative(real,G,aa(real,real,G3,Z4),topolo174197925503356063within(real,Z4,top_top(set(real)))) ) )
           => ( ! [Z4: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Z4))
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Z4),B2))
                   => has_field_derivative(real,F2,aa(real,real,F8,Z4),topolo174197925503356063within(real,Z4,top_top(set(real)))) ) )
             => ? [C3: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),C3))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C3),B2))
                  & ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A3))),aa(real,real,G3,C3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,G,B2)),aa(real,real,G,A3))),aa(real,real,F8,C3)) ) ) ) ) ) ) ) ).

% GMVT'
tff(fact_6920_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [X3: real,F2: fun(real,A)] :
          ( topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X3,top_top(set(real))),F2)
         => ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(real,A,F2,X3)),ring_1_Ints(A)))
           => has_field_derivative(real,aTP_Lamp_vc(fun(real,A),fun(real,real),F2),zero_zero(real),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ) ).

% floor_has_real_derivative
tff(fact_6921_isCont__powser_H,axiom,
    ! [A: $tType,Aa: $tType] :
      ( ( real_Vector_banach(Aa)
        & real_V3459762299906320749_field(Aa)
        & topological_t2_space(A) )
     => ! [A3: A,F2: fun(A,Aa),C2: fun(nat,Aa),K5: Aa] :
          ( topolo3448309680560233919inuous(A,Aa,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( summable(Aa,aa(Aa,fun(nat,Aa),aTP_Lamp_vd(fun(nat,Aa),fun(Aa,fun(nat,Aa)),C2),K5))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(Aa,aa(A,Aa,F2,A3))),real_V7770717601297561774m_norm(Aa,K5)))
             => topolo3448309680560233919inuous(A,Aa,topolo174197925503356063within(A,A3,top_top(set(A))),aa(fun(nat,Aa),fun(A,Aa),aTP_Lamp_vf(fun(A,Aa),fun(fun(nat,Aa),fun(A,Aa)),F2),C2)) ) ) ) ) ).

% isCont_powser'
tff(fact_6922_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X3: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,K5)))
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X3,top_top(set(A))),aTP_Lamp_rs(fun(nat,A),fun(A,A),C2)) ) ) ) ).

% isCont_powser
tff(fact_6923_partition__filter__conv,axiom,
    ! [A: $tType,F2: fun(A,bool),Xs: list(A)] : ( partition(A,F2,Xs) = aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),filter2(A,F2),Xs)),aa(list(A),list(A),filter2(A,aa(fun(A,bool),fun(A,bool),comp(bool,bool,A,fNot),F2)),Xs)) ) ).

% partition_filter_conv
tff(fact_6924_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X3: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_rx(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),real_V7770717601297561774m_norm(A,K5)))
           => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_vh(fun(nat,A),fun(A,fun(A,A)),C2),X3),topolo7230453075368039082e_nhds(A,zero_zero(A)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% termdiffs_aux
tff(fact_6925_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F2: fun(B,A),L: A,F3: filter(B)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vi(A,fun(fun(B,A),fun(B,A)),C2),F2),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),L)),F3)
          <=> filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3) ) ) ) ).

% tendsto_mult_left_iff
tff(fact_6926_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F2: fun(B,A),L: A,F3: filter(B)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vj(A,fun(fun(B,A),fun(B,A)),C2),F2),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),L),C2)),F3)
          <=> filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3) ) ) ) ).

% tendsto_mult_right_iff
tff(fact_6927_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F2: fun(A,real),F3: filter(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_vk(nat,fun(fun(A,real),fun(A,real)),N),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
      <=> filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% power_tendsto_0_iff
tff(fact_6928_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [X3: A,F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X3,top_top(set(A))),F2)
        <=> filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vl(A,fun(fun(A,B),fun(A,B)),X3),F2),topolo7230453075368039082e_nhds(B,aa(A,B,F2,X3)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% isCont_iff
tff(fact_6929_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_vm(fun(A,real),fun(A,real),F2)) ) ) ).

% continuous_real_sqrt
tff(fact_6930_continuous__real__root,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real),N: nat] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => topolo3448309680560233919inuous(A,real,F3,aa(nat,fun(A,real),aTP_Lamp_vn(fun(A,real),fun(nat,fun(A,real)),F2),N)) ) ) ).

% continuous_real_root
tff(fact_6931_filterlim__mono,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),F23: filter(B),F12: filter(A),F24: filter(B),F13: filter(A)] :
      ( filterlim(A,B,F2,F23,F12)
     => ( pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),F23),F24))
       => ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F13),F12))
         => filterlim(A,B,F2,F24,F13) ) ) ) ).

% filterlim_mono
tff(fact_6932_tendsto__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: filter(B),F9: filter(B),F2: fun(B,A),L: A] :
          ( pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),F3),F9))
         => ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F9)
           => filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3) ) ) ) ).

% tendsto_mono
tff(fact_6933_partition__filter1,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),partition(A,P,Xs)) = aa(list(A),list(A),filter2(A,P),Xs) ) ).

% partition_filter1
tff(fact_6934_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [I5: set(B),F2: fun(A,fun(B,C)),F3: filter(A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),I5))
             => filterlim(A,C,aa(B,fun(A,C),aTP_Lamp_vo(fun(A,fun(B,C)),fun(B,fun(A,C)),F2),I3),topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) )
         => filterlim(A,C,aa(fun(A,fun(B,C)),fun(A,C),aTP_Lamp_vp(set(B),fun(fun(A,fun(B,C)),fun(A,C)),I5),F2),topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) ) ) ).

% tendsto_null_sum
tff(fact_6935_tendsto__real__root,axiom,
    ! [A: $tType,F2: fun(A,real),X3: real,F3: filter(A),N: nat] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,X3),F3)
     => filterlim(A,real,aa(nat,fun(A,real),aTP_Lamp_vq(fun(A,real),fun(nat,fun(A,real)),F2),N),topolo7230453075368039082e_nhds(real,aa(real,real,root(N),X3)),F3) ) ).

% tendsto_real_root
tff(fact_6936_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(B,A),A3: A,F3: filter(B)] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( ( A3 != zero_zero(A) )
           => filterlim(B,A,aTP_Lamp_vr(fun(B,A),fun(B,A),F2),topolo7230453075368039082e_nhds(A,aa(A,A,inverse_inverse(A),A3)),F3) ) ) ) ).

% tendsto_inverse
tff(fact_6937_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [F2: fun(D,B),F3: filter(D),G: fun(D,B)] :
          ( filterlim(D,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => ( filterlim(D,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
           => filterlim(D,B,aa(fun(D,B),fun(D,B),aTP_Lamp_vs(fun(D,B),fun(fun(D,B),fun(D,B)),F2),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% tendsto_add_zero
tff(fact_6938_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F2: fun(C,A),A3: A,F3: filter(C)] :
          ( filterlim(C,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( ( cosh(A,A3) != zero_zero(A) )
           => filterlim(C,A,aTP_Lamp_vt(fun(C,A),fun(C,A),F2),topolo7230453075368039082e_nhds(A,aa(A,A,tanh(A),A3)),F3) ) ) ) ).

% tendsto_tanh
tff(fact_6939_tendsto__powr,axiom,
    ! [A: $tType,F2: fun(A,real),A3: real,F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( ( A3 != zero_zero(real) )
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_vu(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,powr(real,A3,B2)),F3) ) ) ) ).

% tendsto_powr
tff(fact_6940_tendsto__ln,axiom,
    ! [A: $tType,F2: fun(A,real),A3: real,F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( ( A3 != zero_zero(real) )
       => filterlim(A,real,aTP_Lamp_lj(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,ln_ln(real),A3)),F3) ) ) ).

% tendsto_ln
tff(fact_6941_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_vv(fun(A,B),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% tendsto_norm_zero_cancel
tff(fact_6942_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_vv(fun(A,B),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
        <=> filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% tendsto_norm_zero_iff
tff(fact_6943_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => filterlim(A,real,aTP_Lamp_vv(fun(A,B),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% tendsto_norm_zero
tff(fact_6944_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(B,A),L: A,F3: filter(B)] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3)
         => ( ( L != zero_zero(A) )
           => filterlim(B,A,aTP_Lamp_vw(fun(B,A),fun(B,A),F2),topolo7230453075368039082e_nhds(A,aa(A,A,sgn_sgn(A),L)),F3) ) ) ) ).

% tendsto_sgn
tff(fact_6945_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F2: fun(A,A),A3: A,F3: filter(A)] :
          ( filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( ( cos(A,A3) != zero_zero(A) )
           => filterlim(A,A,aTP_Lamp_uy(fun(A,A),fun(A,A),F2),topolo7230453075368039082e_nhds(A,aa(A,A,tan(A),A3)),F3) ) ) ) ).

% tendsto_tan
tff(fact_6946_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F2: fun(A,A),A3: A,F3: filter(A)] :
          ( filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( ( sin(A,A3) != zero_zero(A) )
           => filterlim(A,A,aTP_Lamp_uz(fun(A,A),fun(A,A),F2),topolo7230453075368039082e_nhds(A,aa(A,A,cot(A),A3)),F3) ) ) ) ).

% tendsto_cot
tff(fact_6947_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [F2: fun(B,A),A3: A,F3: filter(B),G: fun(B,A),B2: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( filterlim(B,A,G,topolo7230453075368039082e_nhds(A,B2),F3)
           => filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vx(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),F3) ) ) ) ).

% tendsto_add
tff(fact_6948_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1633459387980952147up_add(A)
     => ! [C2: A,F2: fun(B,A),D2: A,F3: filter(B)] :
          ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vy(A,fun(fun(B,A),fun(B,A)),C2),F2),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)),F3)
        <=> filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,D2),F3) ) ) ).

% tendsto_add_const_iff
tff(fact_6949_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,aTP_Lamp_vz(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ).

% tendsto_rabs_zero_cancel
tff(fact_6950_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,aTP_Lamp_vz(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
    <=> filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ).

% tendsto_rabs_zero_iff
tff(fact_6951_tendsto__rabs__zero,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => filterlim(A,real,aTP_Lamp_vz(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ).

% tendsto_rabs_zero
tff(fact_6952_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: fun(A,real),X3: real,F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,X3),F3)
     => filterlim(A,real,aTP_Lamp_wa(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,sqrt,X3)),F3) ) ).

% tendsto_real_sqrt
tff(fact_6953_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B) )
     => ! [F2: fun(A,B),A3: B,F3: filter(A),N: nat] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A3),F3)
         => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_wb(fun(A,B),fun(nat,fun(A,B)),F2),N),topolo7230453075368039082e_nhds(B,aa(nat,B,power_power(B,A3),N)),F3) ) ) ).

% tendsto_power
tff(fact_6954_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [F2: fun(C,B),A3: B,F3: filter(C),G: fun(C,nat),B2: nat] :
          ( filterlim(C,B,F2,topolo7230453075368039082e_nhds(B,A3),F3)
         => ( filterlim(C,nat,G,topolo7230453075368039082e_nhds(nat,B2),F3)
           => filterlim(C,B,aa(fun(C,nat),fun(C,B),aTP_Lamp_wc(fun(C,B),fun(fun(C,nat),fun(C,B)),F2),G),topolo7230453075368039082e_nhds(B,aa(nat,B,power_power(B,A3),B2)),F3) ) ) ) ).

% tendsto_power_strong
tff(fact_6955_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [F2: fun(B,A),L: A,F3: filter(B),C2: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3)
         => filterlim(B,A,aa(A,fun(B,A),aTP_Lamp_wd(fun(B,A),fun(A,fun(B,A)),F2),C2),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),L),C2)),F3) ) ) ).

% tendsto_mult_right
tff(fact_6956_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [F2: fun(B,A),L: A,F3: filter(B),C2: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3)
         => filterlim(B,A,aa(A,fun(B,A),aTP_Lamp_we(fun(B,A),fun(A,fun(B,A)),F2),C2),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),L)),F3) ) ) ).

% tendsto_mult_left
tff(fact_6957_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [F2: fun(B,A),A3: A,F3: filter(B),G: fun(B,A),B2: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( filterlim(B,A,G,topolo7230453075368039082e_nhds(A,B2),F3)
           => filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wf(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),F3) ) ) ) ).

% tendsto_mult
tff(fact_6958_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [F2: fun(D,B),F3: filter(D),G: fun(D,B)] :
          ( filterlim(D,B,F2,topolo7230453075368039082e_nhds(B,one_one(B)),F3)
         => ( filterlim(D,B,G,topolo7230453075368039082e_nhds(B,one_one(B)),F3)
           => filterlim(D,B,aa(fun(D,B),fun(D,B),aTP_Lamp_wg(fun(D,B),fun(fun(D,B),fun(D,B)),F2),G),topolo7230453075368039082e_nhds(B,one_one(B)),F3) ) ) ) ).

% tendsto_mult_one
tff(fact_6959_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(B,A),A3: A,F3: filter(B),G: fun(B,A),B2: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( filterlim(B,A,G,topolo7230453075368039082e_nhds(A,B2),F3)
           => ( ( B2 != zero_zero(A) )
             => filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wh(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),F3) ) ) ) ) ).

% tendsto_divide
tff(fact_6960_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(B,A),F3: filter(B),C2: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
         => filterlim(B,A,aa(A,fun(B,A),aTP_Lamp_wi(fun(B,A),fun(A,fun(B,A)),F2),C2),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3) ) ) ).

% tendsto_divide_zero
tff(fact_6961_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(D,A),F3: filter(D),G: fun(D,A)] :
          ( filterlim(D,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
         => ( filterlim(D,A,G,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
           => filterlim(D,A,aa(fun(D,A),fun(D,A),aTP_Lamp_wj(fun(D,A),fun(fun(D,A),fun(D,A)),F2),G),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3) ) ) ) ).

% tendsto_mult_zero
tff(fact_6962_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(D,A),F3: filter(D),C2: A] :
          ( filterlim(D,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
         => filterlim(D,A,aa(A,fun(D,A),aTP_Lamp_wk(fun(D,A),fun(A,fun(D,A)),F2),C2),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3) ) ) ).

% tendsto_mult_left_zero
tff(fact_6963_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(D,A),F3: filter(D),C2: A] :
          ( filterlim(D,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
         => filterlim(D,A,aa(A,fun(D,A),aTP_Lamp_wl(fun(D,A),fun(A,fun(D,A)),F2),C2),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3) ) ) ).

% tendsto_mult_right_zero
tff(fact_6964_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_wm(fun(A,B),fun(B,fun(A,B)),F2),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% LIM_zero
tff(fact_6965_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_wm(fun(A,B),fun(B,fun(A,B)),F2),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
        <=> filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3) ) ) ).

% LIM_zero_iff
tff(fact_6966_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(B,A),A3: A,F3: filter(B),F2: fun(B,A)] :
          ( filterlim(B,A,G,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wn(fun(B,A),fun(fun(B,A),fun(B,A)),G),F2),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
           => filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3) ) ) ) ).

% Lim_transform
tff(fact_6967_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(B,A),A3: A,F3: filter(B),G: fun(B,A)] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wo(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
           => filterlim(B,A,G,topolo7230453075368039082e_nhds(A,A3),F3) ) ) ) ).

% Lim_transform2
tff(fact_6968_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_wm(fun(A,B),fun(B,fun(A,B)),F2),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3) ) ) ).

% LIM_zero_cancel
tff(fact_6969_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(B,A),G: fun(B,A),F3: filter(B),A3: A] :
          ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wo(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
         => ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
          <=> filterlim(B,A,G,topolo7230453075368039082e_nhds(A,A3),F3) ) ) ) ).

% Lim_transform_eq
tff(fact_6970_tendsto__artanh,axiom,
    ! [A: $tType,F2: fun(A,real),A3: real,F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),A3))
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),one_one(real)))
         => filterlim(A,real,aTP_Lamp_wp(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,artanh(real),A3)),F3) ) ) ) ).

% tendsto_artanh
tff(fact_6971_tendsto__log,axiom,
    ! [A: $tType,F2: fun(A,real),A3: real,F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
         => ( ( A3 != one_one(real) )
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
             => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wq(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,aa(real,real,log(A3),B2)),F3) ) ) ) ) ) ).

% tendsto_log
tff(fact_6972_tendsto__arcosh,axiom,
    ! [B: $tType,F2: fun(B,real),A3: real,F3: filter(B)] :
      ( filterlim(B,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),A3))
       => filterlim(B,real,aTP_Lamp_wr(fun(B,real),fun(B,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,arcosh(real),A3)),F3) ) ) ).

% tendsto_arcosh
tff(fact_6973_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [F2: fun(A,B),F3: filter(A),N: nat] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_ws(fun(A,B),fun(nat,fun(A,B)),F2),N),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% tendsto_null_power
tff(fact_6974_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),L5: B,A3: A,K: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A))))
         => filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_wt(fun(A,B),fun(A,fun(A,B)),F2),K),topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),K),top_top(set(A)))) ) ) ).

% LIM_offset
tff(fact_6975_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( topolo8386298272705272623_space(A)
        & zero(Aa)
        & topological_t2_space(Aa) )
     => ! [K: Aa,A3: A] :
          ( ( K != zero_zero(Aa) )
         => ~ filterlim(A,Aa,aTP_Lamp_wu(Aa,fun(A,Aa),K),topolo7230453075368039082e_nhds(Aa,zero_zero(Aa)),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ).

% LIM_not_zero
tff(fact_6976_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),A3: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,A3)),topolo174197925503356063within(A,A3,top_top(set(A))))
        <=> filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_wv(fun(A,B),fun(A,fun(A,B)),F2),A3),topolo7230453075368039082e_nhds(B,aa(A,B,F2,A3)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% LIM_isCont_iff
tff(fact_6977_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),L5: B,A3: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A))))
         => filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_wv(fun(A,B),fun(A,fun(A,B)),F2),A3),topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% LIM_offset_zero
tff(fact_6978_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),A3: A,L5: B] :
          ( filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_wv(fun(A,B),fun(A,fun(A,B)),F2),A3),topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ).

% LIM_offset_zero_cancel
tff(fact_6979_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(D)
        & zero(C) )
     => ! [A3: A,F2: fun(A,D),L5: D] :
          ( nO_MATCH(C,A,zero_zero(C),A3)
         => ( filterlim(A,D,F2,topolo7230453075368039082e_nhds(D,L5),topolo174197925503356063within(A,A3,top_top(set(A))))
          <=> filterlim(A,D,aa(fun(A,D),fun(A,D),aTP_Lamp_ww(A,fun(fun(A,D),fun(A,D)),A3),F2),topolo7230453075368039082e_nhds(D,L5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% LIM_offset_zero_iff
tff(fact_6980_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S2: set(A)] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S2))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_wx(fun(A,A),fun(A,fun(A,A)),F2),X3),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,X3,S2)) ) ) ).

% has_field_derivative_iff
tff(fact_6981_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A,S2: set(A)] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,S2))
         => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_wx(fun(A,A),fun(A,fun(A,A)),F2),X3),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,X3,S2)) ) ) ).

% has_field_derivativeD
tff(fact_6982_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),L: B,A3: A,G: fun(A,C),M: C] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A3,top_top(set(A))))
         => ( ! [X2: A] :
                ( ( X2 != A3 )
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(A,C,G,X2)),M))),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X2)),L)))) )
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,M),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ) ).

% LIM_imp_LIM
tff(fact_6983_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(A,real),A3: A,G: fun(A,real)] :
          ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,A3,top_top(set(A))))
         => ( ! [X2: A] :
                ( ( X2 != A3 )
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(A,real,G,X2))) )
           => ( ! [X2: A] :
                  ( ( X2 != A3 )
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(A,real,G,X2)),aa(A,real,F2,X2))) )
             => filterlim(A,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ) ) ).

% real_LIM_sandwich_zero
tff(fact_6984_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(A,B),L: filter(B),X3: A,S2: set(A),T6: set(A)] :
          ( filterlim(A,B,F2,L,topolo174197925503356063within(A,X3,S2))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T6),S2))
           => filterlim(A,B,F2,L,topolo174197925503356063within(A,X3,T6)) ) ) ) ).

% tendsto_within_subset
tff(fact_6985_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [R4: real,A3: A,F2: fun(A,B),G: fun(A,B),L: B] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R4))
         => ( ! [X2: A] :
                ( ( X2 != A3 )
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A3))),R4))
                 => ( aa(A,B,F2,X2) = aa(A,B,G,X2) ) ) )
           => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A3,top_top(set(A))))
             => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ) ) ).

% LIM_equal2
tff(fact_6986_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),L5: B,A3: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A))))
        <=> ! [R5: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R5))
             => ? [S6: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),S6))
                  & ! [X4: A] :
                      ( ( ( X4 != A3 )
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),A3))),S6)) )
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X4)),L5))),R5)) ) ) ) ) ) ).

% LIM_eq
tff(fact_6987_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [A3: A,F2: fun(A,B),L5: B] :
          ( ! [R: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
             => ? [S8: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),S8))
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A3))),S8)) )
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X2)),L5))),R)) ) ) )
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ).

% LIM_I
tff(fact_6988_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),L5: B,A3: A,R2: real] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A))))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R2))
           => ? [S3: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),S3))
                & ! [X: A] :
                    ( ( ( X != A3 )
                      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A3))),S3)) )
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X)),L5))),R2)) ) ) ) ) ) ).

% LIM_D
tff(fact_6989_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [F2: fun(A,A),A3: A,D4: A] :
          ( filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_wy(fun(A,A),fun(A,fun(A,A)),F2),A3),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_wz(fun(A,A),fun(A,fun(A,A)),F2),A3),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ).

% DERIV_LIM_iff
tff(fact_6990_LIM__fun__less__zero,axiom,
    ! [F2: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),L),zero_zero(real)))
       => ? [R: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
            & ! [X: real] :
                ( ( ( X != C2 )
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X))),R)) )
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,X)),zero_zero(real))) ) ) ) ) ).

% LIM_fun_less_zero
tff(fact_6991_LIM__fun__not__zero,axiom,
    ! [F2: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( ( L != zero_zero(real) )
       => ? [R: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
            & ! [X: real] :
                ( ( ( X != C2 )
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X))),R)) )
               => ( aa(real,real,F2,X) != zero_zero(real) ) ) ) ) ) ).

% LIM_fun_not_zero
tff(fact_6992_LIM__fun__gt__zero,axiom,
    ! [F2: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),L))
       => ? [R: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
            & ! [X: real] :
                ( ( ( X != C2 )
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X))),R)) )
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,F2,X))) ) ) ) ) ).

% LIM_fun_gt_zero
tff(fact_6993_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F2: fun(A,B),B2: B,A3: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A3,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( ? [D6: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D6))
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A3))),D6)) )
                     => ( aa(A,B,F2,X2) != B2 ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_xa(fun(A,B),fun(fun(B,C),fun(A,C)),F2),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ) ) ).

% LIM_compose2
tff(fact_6994_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( topological_t2_space(C)
     => ! [A3: C,S: set(C),F2: fun(C,real),G: fun(C,real)] :
          ( topolo3448309680560233919inuous(C,real,topolo174197925503356063within(C,A3,S),F2)
         => ( topolo3448309680560233919inuous(C,real,topolo174197925503356063within(C,A3,S),G)
           => ( ( aa(C,real,F2,A3) != zero_zero(real) )
             => topolo3448309680560233919inuous(C,real,topolo174197925503356063within(C,A3,S),aa(fun(C,real),fun(C,real),aTP_Lamp_xb(fun(C,real),fun(fun(C,real),fun(C,real)),F2),G)) ) ) ) ) ).

% continuous_at_within_powr
tff(fact_6995_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X3: A,S: set(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X3,S),F2)
         => ( ( aa(A,real,F2,X3) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X3,S),aTP_Lamp_xc(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_within_ln
tff(fact_6996_DERIV__def,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_xd(fun(A,A),fun(A,fun(A,A)),F2),X3),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% DERIV_def
tff(fact_6997_DERIV__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A] :
          ( has_field_derivative(A,F2,D4,topolo174197925503356063within(A,X3,top_top(set(A))))
         => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_xd(fun(A,A),fun(A,fun(A,A)),F2),X3),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% DERIV_D
tff(fact_6998_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => filterlim(A,A,aTP_Lamp_xe(A,A),topolo7230453075368039082e_nhds(A,one_one(A)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ).

% lim_exp_minus_1
tff(fact_6999_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A3: A,F2: fun(A,B),G: fun(B,C),L: C] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(B,aa(A,B,F2,A3),top_top(set(B))))
           => ( ? [D6: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D6))
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A3))),D6)) )
                     => ( aa(A,B,F2,X2) != aa(A,B,F2,A3) ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_xa(fun(A,B),fun(fun(B,C),fun(A,C)),F2),G),topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ) ) ).

% isCont_LIM_compose2
tff(fact_7000_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( partition(A,P,nil(A)) = aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),nil(A)) ) ).

% partition.simps(1)
tff(fact_7001_partition__P,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Yes: list(A),No: list(A)] :
      ( ( partition(A,P,Xs) = aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Yes),No) )
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Yes)))
           => pp(aa(A,bool,P,X)) )
        & ! [X: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),No)))
           => ~ pp(aa(A,bool,P,X)) ) ) ) ).

% partition_P
tff(fact_7002_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [K: real,F2: fun(A,B),K5: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K))
         => ( ! [H3: A] :
                ( ( H3 != zero_zero(A) )
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,H3)),K))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,H3))),aa(real,real,aa(real,fun(real,real),times_times(real),K5),real_V7770717601297561774m_norm(A,H3)))) ) )
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% lemma_termdiff4
tff(fact_7003_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D4: A,X3: A] :
          ( has_derivative(A,A,F2,aa(A,fun(A,A),times_times(A),D4),topolo174197925503356063within(A,X3,top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_xd(fun(A,A),fun(A,fun(A,A)),F2),X3),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% field_has_derivative_at
tff(fact_7004_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(A,B),F3: filter(B),A3: A] :
          ( filterlim(A,B,F2,F3,topolo174197925503356063within(A,A3,top_top(set(A))))
        <=> filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_xf(fun(A,B),fun(A,fun(A,B)),F2),A3),F3,topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% filterlim_at_to_0
tff(fact_7005_isCont__powr,axiom,
    ! [C: $tType] :
      ( topological_t2_space(C)
     => ! [A3: C,F2: fun(C,real),G: fun(C,real)] :
          ( topolo3448309680560233919inuous(C,real,topolo174197925503356063within(C,A3,top_top(set(C))),F2)
         => ( topolo3448309680560233919inuous(C,real,topolo174197925503356063within(C,A3,top_top(set(C))),G)
           => ( ( aa(C,real,F2,A3) != zero_zero(real) )
             => topolo3448309680560233919inuous(C,real,topolo174197925503356063within(C,A3,top_top(set(C))),aa(fun(C,real),fun(C,real),aTP_Lamp_xb(fun(C,real),fun(fun(C,real),fun(C,real)),F2),G)) ) ) ) ) ).

% isCont_powr
tff(fact_7006_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X3: A,F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X3,top_top(set(A))),F2)
         => ( ( aa(A,real,F2,X3) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X3,top_top(set(A))),aTP_Lamp_xc(fun(A,real),fun(A,real),F2)) ) ) ) ).

% isCont_ln'
tff(fact_7007_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A)] : ( partition(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = aa(product_prod(list(A),list(A)),product_prod(list(A),list(A)),product_case_prod(list(A),list(A),product_prod(list(A),list(A)),aa(A,fun(list(A),fun(list(A),product_prod(list(A),list(A)))),aTP_Lamp_xg(fun(A,bool),fun(A,fun(list(A),fun(list(A),product_prod(list(A),list(A))))),P),X3)),partition(A,P,Xs)) ) ).

% partition.simps(2)
tff(fact_7008_partition__filter2,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),partition(A,P,Xs)) = aa(list(A),list(A),filter2(A,aa(fun(A,bool),fun(A,bool),comp(bool,bool,A,fNot),P)),Xs) ) ).

% partition_filter2
tff(fact_7009_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(A,B),F3: filter(B),A3: A,D2: A] :
          ( filterlim(A,B,F2,F3,topolo174197925503356063within(A,A3,top_top(set(A))))
         => filterlim(A,B,aa(fun(A,A),fun(A,B),comp(A,B,A,F2),aa(A,fun(A,A),plus_plus(A),D2)),F3,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),D2),top_top(set(A)))) ) ) ).

% filterlim_shift
tff(fact_7010_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(A,B),D2: A,F3: filter(B),A3: A] :
          ( filterlim(A,B,aa(fun(A,A),fun(A,B),comp(A,B,A,F2),aa(A,fun(A,A),plus_plus(A),D2)),F3,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),D2),top_top(set(A))))
        <=> filterlim(A,B,F2,F3,topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ).

% filterlim_shift_iff
tff(fact_7011_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: real,A3: fun(nat,A),F2: fun(A,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),S))
         => ( ! [X2: A] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X2)),S))
               => sums(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),A3),X2),aa(A,A,F2,X2)) )
           => filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,aa(nat,A,A3,zero_zero(nat))),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% powser_limit_0
tff(fact_7012_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: real,A3: fun(nat,A),F2: fun(A,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),S))
         => ( ! [X2: A] :
                ( ( X2 != zero_zero(A) )
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X2)),S))
                 => sums(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),A3),X2),aa(A,A,F2,X2)) ) )
           => filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,aa(nat,A,A3,zero_zero(nat))),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% powser_limit_0_strong
tff(fact_7013_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_Vector_banach(B) )
     => ! [K: real,F2: fun(nat,real),G: fun(A,fun(nat,B))] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K))
         => ( summable(real,F2)
           => ( ! [H3: A,N2: nat] :
                  ( ( H3 != zero_zero(A) )
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,H3)),K))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(nat,B,aa(A,fun(nat,B),G,H3),N2))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,F2,N2)),real_V7770717601297561774m_norm(A,H3)))) ) )
             => filterlim(A,B,aTP_Lamp_xh(fun(A,fun(nat,B)),fun(A,B),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ).

% lemma_termdiff5
tff(fact_7014_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A3: A,S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A3,S),F2)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A3,S),G)
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,F2,A3)))
             => ( ( aa(A,real,F2,A3) != one_one(real) )
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,G,A3)))
                 => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A3,S),aa(fun(A,real),fun(A,real),aTP_Lamp_xi(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ) ) ).

% continuous_at_within_log
tff(fact_7015_LIM__cos__div__sin,axiom,
    filterlim(real,real,aTP_Lamp_xj(real,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))),top_top(set(real)))) ).

% LIM_cos_div_sin
tff(fact_7016_partition__set,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Yes: list(A),No: list(A)] :
      ( ( partition(A,P,Xs) = aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Yes),No) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Yes)),aa(list(A),set(A),set2(A),No)) = aa(list(A),set(A),set2(A),Xs) ) ) ).

% partition_set
tff(fact_7017_isCont__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A3: A,F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A3,top_top(set(A))),G)
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,F2,A3)))
             => ( ( aa(A,real,F2,A3) != one_one(real) )
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,G,A3)))
                 => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A3,top_top(set(A))),aa(fun(A,real),fun(A,real),aTP_Lamp_xi(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ) ) ).

% isCont_log
tff(fact_7018_summable__Leibniz_I3_J,axiom,
    ! [A3: fun(nat,real)] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A3)
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(nat,real,A3,zero_zero(nat))),zero_zero(real)))
         => ! [N7: nat] : pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),suminf(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3))),set_or1337092689740270186AtMost(real,aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N7)),one_one(nat)))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N7)))))) ) ) ) ).

% summable_Leibniz(3)
tff(fact_7019_summable__Leibniz_I2_J,axiom,
    ! [A3: fun(nat,real)] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A3)
       => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(nat,real,A3,zero_zero(nat))))
         => ! [N7: nat] : pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),suminf(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3))),set_or1337092689740270186AtMost(real,aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N7))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N7)),one_one(nat))))))) ) ) ) ).

% summable_Leibniz(2)
tff(fact_7020_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A3: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_xl(A,fun(fun(nat,A),fun(nat,A)),C2),A3),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A3,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_mult_right_iff
tff(fact_7021_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A3: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_xm(A,fun(fun(nat,A),fun(nat,A)),C2),A3),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A3,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_mult_left_iff
tff(fact_7022_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A3: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_xn(A,fun(fun(nat,A),fun(nat,A)),C2),A3),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A3,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_divide_iff
tff(fact_7023_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),K: nat,A3: A] :
          ( filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_xo(fun(nat,A),fun(nat,fun(nat,A)),F2),K),topolo7230453075368039082e_nhds(A,A3),at_top(nat))
         => filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,A3),at_top(nat)) ) ) ).

% LIMSEQ_offset
tff(fact_7024_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),A3: A,K: nat] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,A3),at_top(nat))
         => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_xo(fun(nat,A),fun(nat,fun(nat,A)),F2),K),topolo7230453075368039082e_nhds(A,A3),at_top(nat)) ) ) ).

% LIMSEQ_ignore_initial_segment
tff(fact_7025_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( dense_linorder(A)
        & topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ? [U2: fun(nat,A)] :
              ( ! [N7: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,U2,N7)),X3))
              & filterlim(nat,A,U2,topolo7230453075368039082e_nhds(A,X3),at_top(nat)) ) ) ) ).

% approx_from_below_dense_linorder
tff(fact_7026_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( dense_linorder(A)
        & topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ? [U2: fun(nat,A)] :
              ( ! [N7: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(nat,A,U2,N7)))
              & filterlim(nat,A,U2,topolo7230453075368039082e_nhds(A,X3),at_top(nat)) ) ) ) ).

% approx_from_above_dense_linorder
tff(fact_7027_lim__mono,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [N5: nat,X7: fun(nat,A),Y3: fun(nat,A),X3: A,Y4: A] :
          ( ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N5),N2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N2)),aa(nat,A,Y3,N2))) )
         => ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,X3),at_top(nat))
           => ( filterlim(nat,A,Y3,topolo7230453075368039082e_nhds(A,Y4),at_top(nat))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ) ) ).

% lim_mono
tff(fact_7028_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X7: fun(nat,A),X3: A,Y3: fun(nat,A),Y4: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,X3),at_top(nat))
         => ( filterlim(nat,A,Y3,topolo7230453075368039082e_nhds(A,Y4),at_top(nat))
           => ( ? [N8: nat] :
                ! [N2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N2)),aa(nat,A,Y3,N2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ) ) ).

% LIMSEQ_le
tff(fact_7029_Lim__bounded,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [F2: fun(nat,A),L: A,M7: nat,C6: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => ( ! [N2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M7),N2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,N2)),C6)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),C6)) ) ) ) ).

% Lim_bounded
tff(fact_7030_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [F2: fun(nat,A),L: A,N5: nat,C6: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => ( ! [N2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N5),N2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C6),aa(nat,A,F2,N2))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C6),L)) ) ) ) ).

% Lim_bounded2
tff(fact_7031_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X7: fun(nat,A),X3: A,A3: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,X3),at_top(nat))
         => ( ? [N8: nat] :
              ! [N2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(nat,A,X7,N2))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X3)) ) ) ) ).

% LIMSEQ_le_const
tff(fact_7032_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X7: fun(nat,A),X3: A,A3: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,X3),at_top(nat))
         => ( ? [N8: nat] :
              ! [N2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N2)),A3)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),A3)) ) ) ) ).

% LIMSEQ_le_const2
tff(fact_7033_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: fun(nat,A),S: set(A),A3: A] :
          ( ! [N2: nat] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,B2,N2)),S))
         => ( filterlim(nat,A,B2,topolo7230453075368039082e_nhds(A,A3),at_top(nat))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(set(A),A,complete_Sup_Sup(A),S))) ) ) ) ).

% Sup_lim
tff(fact_7034_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: fun(nat,A),S: set(A),A3: A] :
          ( ! [N2: nat] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,B2,N2)),S))
         => ( filterlim(nat,A,B2,topolo7230453075368039082e_nhds(A,A3),at_top(nat))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),S)),A3)) ) ) ) ).

% Inf_lim
tff(fact_7035_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% summable_LIMSEQ_zero
tff(fact_7036_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),C2))
     => filterlim(nat,nat,aa(nat,fun(nat,nat),times_times(nat),C2),at_top(nat),at_top(nat)) ) ).

% mult_nat_left_at_top
tff(fact_7037_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),C2))
     => filterlim(nat,nat,aTP_Lamp_xp(nat,fun(nat,nat),C2),at_top(nat),at_top(nat)) ) ).

% mult_nat_right_at_top
tff(fact_7038_monoseq__convergent,axiom,
    ! [X7: fun(nat,real),B3: real] :
      ( topological_monoseq(real,X7)
     => ( ! [I3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(nat,real,X7,I3))),B3))
       => ~ ! [L6: real] : ~ filterlim(nat,real,X7,topolo7230453075368039082e_nhds(real,L6),at_top(nat)) ) ) ).

% monoseq_convergent
tff(fact_7039_LIMSEQ__root,axiom,
    filterlim(nat,real,aTP_Lamp_xq(nat,real),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat)) ).

% LIMSEQ_root
tff(fact_7040_monoseq__le,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A3: fun(nat,A),X3: A] :
          ( topological_monoseq(A,A3)
         => ( filterlim(nat,A,A3,topolo7230453075368039082e_nhds(A,X3),at_top(nat))
           => ( ( ! [N7: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,A3,N7)),X3))
                & ! [M2: nat,N7: nat] :
                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N7))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,A3,M2)),aa(nat,A,A3,N7))) ) )
              | ( ! [N7: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(nat,A,A3,N7)))
                & ! [M2: nat,N7: nat] :
                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N7))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,A3,N7)),aa(nat,A,A3,M2))) ) ) ) ) ) ) ).

% monoseq_le
tff(fact_7041_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A3: A] : filterlim(nat,A,aTP_Lamp_xr(A,fun(nat,A),A3),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_const_over_n
tff(fact_7042_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_xs(nat,A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_inverse_n
tff(fact_7043_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [X7: fun(nat,A),X3: A,L: nat] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,X3),at_top(nat))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),L))
           => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_xt(fun(nat,A),fun(nat,fun(nat,A)),X7),L),topolo7230453075368039082e_nhds(A,X3),at_top(nat)) ) ) ) ).

% LIMSEQ_linear
tff(fact_7044_nested__sequence__unique,axiom,
    ! [F2: fun(nat,real),G: fun(nat,real)] :
      ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,F2,N2)),aa(nat,real,F2,aa(nat,nat,suc,N2))))
     => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,G,aa(nat,nat,suc,N2))),aa(nat,real,G,N2)))
       => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,F2,N2)),aa(nat,real,G,N2)))
         => ( filterlim(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_xu(fun(nat,real),fun(fun(nat,real),fun(nat,real)),F2),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => ? [L2: real] :
                ( ! [N7: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,F2,N7)),L2))
                & filterlim(nat,real,F2,topolo7230453075368039082e_nhds(real,L2),at_top(nat))
                & ! [N7: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),L2),aa(nat,real,G,N7)))
                & filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,L2),at_top(nat)) ) ) ) ) ) ).

% nested_sequence_unique
tff(fact_7045_LIMSEQ__inverse__zero,axiom,
    ! [X7: fun(nat,real)] :
      ( ! [R: real] :
        ? [N8: nat] :
        ! [N2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N2))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),R),aa(nat,real,X7,N2))) )
     => filterlim(nat,real,aTP_Lamp_xv(fun(nat,real),fun(nat,real),X7),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_inverse_zero
tff(fact_7046_lim__inverse__n_H,axiom,
    filterlim(nat,real,aTP_Lamp_xw(nat,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ).

% lim_inverse_n'
tff(fact_7047_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
     => filterlim(nat,real,aTP_Lamp_xx(real,fun(nat,real),C2),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat)) ) ).

% LIMSEQ_root_const
tff(fact_7048_LIMSEQ__inverse__real__of__nat,axiom,
    filterlim(nat,real,aTP_Lamp_xy(nat,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat
tff(fact_7049_increasing__LIMSEQ,axiom,
    ! [F2: fun(nat,real),L: real] :
      ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,F2,N2)),aa(nat,real,F2,aa(nat,nat,suc,N2))))
     => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,F2,N2)),L))
       => ( ! [E2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E2))
             => ? [N7: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),L),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,F2,N7)),E2))) )
         => filterlim(nat,real,F2,topolo7230453075368039082e_nhds(real,L),at_top(nat)) ) ) ) ).

% increasing_LIMSEQ
tff(fact_7050_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_xz(nat,A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_1_over_n
tff(fact_7051_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_ya(nat,A),topolo7230453075368039082e_nhds(A,one_one(A)),at_top(nat)) ) ).

% LIMSEQ_n_over_Suc_n
tff(fact_7052_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_yb(nat,A),topolo7230453075368039082e_nhds(A,one_one(A)),at_top(nat)) ) ).

% LIMSEQ_Suc_n_over_n
tff(fact_7053_LIMSEQ__realpow__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
       => filterlim(nat,real,power_power(real,X3),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ) ).

% LIMSEQ_realpow_zero
tff(fact_7054_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => sums(A,aTP_Lamp_yc(fun(nat,A),fun(nat,A),F2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,zero_zero(nat))),C2)) ) ) ).

% telescope_sums'
tff(fact_7055_telescope__sums,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => sums(A,aTP_Lamp_yd(fun(nat,A),fun(nat,A),F2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(nat,A,F2,zero_zero(nat)))) ) ) ).

% telescope_sums
tff(fact_7056_LIMSEQ__divide__realpow__zero,axiom,
    ! [X3: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => filterlim(nat,real,aa(real,fun(nat,real),aTP_Lamp_ye(real,fun(real,fun(nat,real)),X3),A3),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_divide_realpow_zero
tff(fact_7057_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),C2)),one_one(real)))
     => filterlim(nat,real,power_power(real,aa(real,real,abs_abs(real),C2)),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_abs_realpow_zero
tff(fact_7058_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,abs_abs(real),C2)),one_one(real)))
     => filterlim(nat,real,power_power(real,C2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_abs_realpow_zero2
tff(fact_7059_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),X3))
     => filterlim(nat,real,aTP_Lamp_yf(real,fun(nat,real),X3),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_inverse_realpow_zero
tff(fact_7060_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F2: fun(nat,A),S: A] :
          ( sums(A,F2,S)
        <=> filterlim(nat,A,aTP_Lamp_yg(fun(nat,A),fun(nat,A),F2),topolo7230453075368039082e_nhds(A,S),at_top(nat)) ) ) ).

% sums_def'
tff(fact_7061_root__test__convergence,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A),X3: real] :
          ( filterlim(nat,real,aTP_Lamp_yh(fun(nat,A),fun(nat,real),F2),topolo7230453075368039082e_nhds(real,X3),at_top(nat))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),one_one(real)))
           => summable(A,F2) ) ) ) ).

% root_test_convergence
tff(fact_7062_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L5: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
        <=> ! [R5: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R5))
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),No2),N3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N3)),L5))),R5)) ) ) ) ) ).

% LIMSEQ_iff
tff(fact_7063_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L5: A] :
          ( ! [R: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
             => ? [No3: nat] :
                ! [N2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),No3),N2))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N2)),L5))),R)) ) )
         => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat)) ) ) ).

% LIMSEQ_I
tff(fact_7064_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L5: A,R2: real] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R2))
           => ? [No4: nat] :
              ! [N7: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),No4),N7))
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N7)),L5))),R2)) ) ) ) ) ).

% LIMSEQ_D
tff(fact_7065_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),one_one(real)))
         => filterlim(nat,A,power_power(A,X3),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% LIMSEQ_power_zero
tff(fact_7066_tendsto__exp__limit__sequentially,axiom,
    ! [X3: real] : filterlim(nat,real,aTP_Lamp_yi(real,fun(nat,real),X3),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X3)),at_top(nat)) ).

% tendsto_exp_limit_sequentially
tff(fact_7067_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [F2: fun(B,nat),F3: filter(B),X3: A] :
          ( filterlim(B,nat,F2,at_top(nat),F3)
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),one_one(real)))
           => filterlim(B,A,aa(A,fun(B,A),aTP_Lamp_yj(fun(B,nat),fun(A,fun(B,A)),F2),X3),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3) ) ) ) ).

% tendsto_power_zero
tff(fact_7068_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R2: real] : filterlim(nat,real,aTP_Lamp_yk(real,fun(nat,real),R2),topolo7230453075368039082e_nhds(real,R2),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
tff(fact_7069_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A)] :
          ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N2)))))
         => filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% LIMSEQ_norm_0
tff(fact_7070_summable__Leibniz_I1_J,axiom,
    ! [A3: fun(nat,real)] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A3)
       => summable(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)) ) ) ).

% summable_Leibniz(1)
tff(fact_7071_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Df: A,Z: A,S: fun(nat,A),A3: A] :
          ( has_field_derivative(A,F2,Df,topolo174197925503356063within(A,Z,top_top(set(A))))
         => ( filterlim(nat,A,S,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
           => ( ! [N2: nat] : ( aa(nat,A,S,N2) != zero_zero(A) )
             => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),aTP_Lamp_yl(fun(A,A),fun(A,fun(fun(nat,A),fun(nat,A))),F2),Z),S),topolo7230453075368039082e_nhds(A,A3),at_top(nat))
               => ( Df = A3 ) ) ) ) ) ) ).

% field_derivative_lim_unique
tff(fact_7072_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,X3)),one_one(real)))
         => filterlim(nat,A,aTP_Lamp_ym(A,fun(nat,A),X3),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% powser_times_n_limit_0
tff(fact_7073_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),real_V7770717601297561774m_norm(A,X3)))
         => filterlim(nat,A,aTP_Lamp_yn(A,fun(nat,A),X3),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% lim_n_over_pown
tff(fact_7074_summable,axiom,
    ! [A3: fun(nat,real)] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,A3,N2)))
       => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,A3,aa(nat,nat,suc,N2))),aa(nat,real,A3,N2)))
         => summable(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)) ) ) ) ).

% summable
tff(fact_7075_cos__diff__limit__1,axiom,
    ! [Theta: fun(nat,real),Theta2: real] :
      ( filterlim(nat,real,aa(real,fun(nat,real),aTP_Lamp_yo(fun(nat,real),fun(real,fun(nat,real)),Theta),Theta2),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat))
     => ~ ! [K2: fun(nat,int)] : ~ filterlim(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_yp(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Theta),K2),topolo7230453075368039082e_nhds(real,Theta2),at_top(nat)) ) ).

% cos_diff_limit_1
tff(fact_7076_cos__limit__1,axiom,
    ! [Theta: fun(nat,real)] :
      ( filterlim(nat,real,aTP_Lamp_yq(fun(nat,real),fun(nat,real),Theta),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat))
     => ? [K2: fun(nat,int)] : filterlim(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_yp(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Theta),K2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% cos_limit_1
tff(fact_7077_summable__Leibniz_I4_J,axiom,
    ! [A3: fun(nat,real)] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A3)
       => filterlim(nat,real,aTP_Lamp_yr(fun(nat,real),fun(nat,real),A3),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3))),at_top(nat)) ) ) ).

% summable_Leibniz(4)
tff(fact_7078_zeroseq__arctan__series,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),X3)),one_one(real)))
     => filterlim(nat,real,aTP_Lamp_ar(real,fun(nat,real),X3),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% zeroseq_arctan_series
tff(fact_7079_summable__Leibniz_H_I2_J,axiom,
    ! [A3: fun(nat,real),N: nat] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,A3,N2)))
       => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,A3,aa(nat,nat,suc,N2))),aa(nat,real,A3,N2)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),suminf(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)))) ) ) ) ).

% summable_Leibniz'(2)
tff(fact_7080_summable__Leibniz_H_I3_J,axiom,
    ! [A3: fun(nat,real)] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,A3,N2)))
       => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,A3,aa(nat,nat,suc,N2))),aa(nat,real,A3,N2)))
         => filterlim(nat,real,aTP_Lamp_yr(fun(nat,real),fun(nat,real),A3),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3))),at_top(nat)) ) ) ) ).

% summable_Leibniz'(3)
tff(fact_7081_sums__alternating__upper__lower,axiom,
    ! [A3: fun(nat,real)] :
      ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,A3,aa(nat,nat,suc,N2))),aa(nat,real,A3,N2)))
     => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,A3,N2)))
       => ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
         => ? [L2: real] :
              ( ! [N7: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N7)))),L2))
              & filterlim(nat,real,aTP_Lamp_yr(fun(nat,real),fun(nat,real),A3),topolo7230453075368039082e_nhds(real,L2),at_top(nat))
              & ! [N7: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),L2),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N7)),one_one(nat))))))
              & filterlim(nat,real,aTP_Lamp_ys(fun(nat,real),fun(nat,real),A3),topolo7230453075368039082e_nhds(real,L2),at_top(nat)) ) ) ) ) ).

% sums_alternating_upper_lower
tff(fact_7082_summable__Leibniz_I5_J,axiom,
    ! [A3: fun(nat,real)] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A3)
       => filterlim(nat,real,aTP_Lamp_ys(fun(nat,real),fun(nat,real),A3),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3))),at_top(nat)) ) ) ).

% summable_Leibniz(5)
tff(fact_7083_summable__Leibniz_H_I4_J,axiom,
    ! [A3: fun(nat,real),N: nat] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,A3,N2)))
       => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,A3,aa(nat,nat,suc,N2))),aa(nat,real,A3,N2)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),suminf(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),one_one(nat)))))) ) ) ) ).

% summable_Leibniz'(4)
tff(fact_7084_summable__Leibniz_H_I5_J,axiom,
    ! [A3: fun(nat,real)] :
      ( filterlim(nat,real,A3,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,A3,N2)))
       => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,A3,aa(nat,nat,suc,N2))),aa(nat,real,A3,N2)))
         => filterlim(nat,real,aTP_Lamp_ys(fun(nat,real),fun(nat,real),A3),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),A3))),at_top(nat)) ) ) ) ).

% summable_Leibniz'(5)
tff(fact_7085_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),X3: A] :
          ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_yt(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F2),F8),X3),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X3,top_top(set(A)))) ) ) ) ).

% has_derivative_at2
tff(fact_7086_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),D4: fun(A,B),X3: A] :
          ( has_derivative(A,B,F2,D4,topolo174197925503356063within(A,X3,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,D4)
            & filterlim(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_yu(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),F2),D4),X3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% has_derivative_at
tff(fact_7087_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => real_V3181309239436604168linear(A,B,aTP_Lamp_su(A,B)) ) ).

% bounded_linear_zero
tff(fact_7088_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ( real_V3181309239436604168linear(A,B,G)
           => real_V3181309239436604168linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sv(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% bounded_linear_add
tff(fact_7089_real__bounded__linear,axiom,
    ! [F2: fun(real,real)] :
      ( real_V3181309239436604168linear(real,real,F2)
    <=> ? [C4: real] :
        ! [X4: real] : ( aa(real,real,F2,X4) = aa(real,real,aa(real,fun(real,real),times_times(real),X4),C4) ) ) ).

% real_bounded_linear
tff(fact_7090_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Y4: A] : real_V3181309239436604168linear(A,A,aTP_Lamp_yv(A,fun(A,A),Y4)) ) ).

% bounded_linear_divide
tff(fact_7091_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [X3: A] : real_V3181309239436604168linear(A,A,aa(A,fun(A,A),times_times(A),X3)) ) ).

% bounded_linear_mult_right
tff(fact_7092_bounded__linear__mult__const,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & real_V822414075346904944vector(C) )
     => ! [G: fun(C,A),Y4: A] :
          ( real_V3181309239436604168linear(C,A,G)
         => real_V3181309239436604168linear(C,A,aa(A,fun(C,A),aTP_Lamp_sx(fun(C,A),fun(A,fun(C,A)),G),Y4)) ) ) ).

% bounded_linear_mult_const
tff(fact_7093_bounded__linear__const__mult,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & real_V822414075346904944vector(C) )
     => ! [G: fun(C,A),X3: A] :
          ( real_V3181309239436604168linear(C,A,G)
         => real_V3181309239436604168linear(C,A,aa(A,fun(C,A),aTP_Lamp_sw(fun(C,A),fun(A,fun(C,A)),G),X3)) ) ) ).

% bounded_linear_const_mult
tff(fact_7094_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Y4: A] : real_V3181309239436604168linear(A,A,aTP_Lamp_yw(A,fun(A,A),Y4)) ) ).

% bounded_linear_mult_left
tff(fact_7095_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ? [K9: real] :
            ! [X: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X)),K9))) ) ) ).

% bounded_linear.bounded
tff(fact_7096_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),G: fun(C,A),F3: filter(C)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ( filterlim(C,A,G,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
           => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_yx(fun(A,B),fun(fun(C,A),fun(C,B)),F2),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% bounded_linear.tendsto_zero
tff(fact_7097_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ? [K9: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),K9))
              & ! [X: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X)),K9))) ) ) ) ).

% bounded_linear.nonneg_bounded
tff(fact_7098_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ? [K9: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K9))
              & ! [X: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X)),K9))) ) ) ) ).

% bounded_linear.pos_bounded
tff(fact_7099_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),K5: real] :
          ( ! [X2: A,Y2: A] : ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2)) )
         => ( ! [R: real,X2: A] : ( aa(A,B,F2,aa(A,A,real_V8093663219630862766scaleR(A,R),X2)) = aa(B,B,real_V8093663219630862766scaleR(B,R),aa(A,B,F2,X2)) )
           => ( ! [X2: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X2))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X2)),K5)))
             => real_V3181309239436604168linear(A,B,F2) ) ) ) ) ).

% bounded_linear_intro
tff(fact_7100_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),X3: A,S: set(A)] :
          ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_yy(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),F2),F8),X3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% has_derivative_iff_norm
tff(fact_7101_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),X3: A,S: set(A)] :
          ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_yz(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F2),F8),X3),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% has_derivative_at_within
tff(fact_7102_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F8: fun(A,B),X3: A,F2: fun(A,B),S: set(A)] :
          ( real_V3181309239436604168linear(A,B,F8)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aa(A,fun(fun(A,B),fun(A,B)),aTP_Lamp_za(fun(A,B),fun(A,fun(fun(A,B),fun(A,B))),F8),X3),F2),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X3,S))
           => has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S)) ) ) ) ).

% has_derivativeI
tff(fact_7103_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),X3: A] :
          ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & ? [E3: fun(A,B)] :
                ( ! [H5: A] : ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),H5)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,X3)),aa(A,B,F8,H5))),aa(A,B,E3,H5)) )
                & filterlim(A,real,aTP_Lamp_zb(fun(A,B),fun(A,real),E3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ).

% has_derivative_iff_Ex
tff(fact_7104_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),X3: A,S: set(A)] :
          ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_yt(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F2),F8),X3),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% has_derivative_within
tff(fact_7105_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),F3: filter(A)] :
          ( has_derivative(A,B,F2,F8,F3)
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,B,aa(filter(A),fun(A,B),aa(fun(A,B),fun(filter(A),fun(A,B)),aTP_Lamp_zd(fun(A,B),fun(fun(A,B),fun(filter(A),fun(A,B))),F2),F8),F3),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% has_derivative_def
tff(fact_7106_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [X3: A,S2: set(A),F2: fun(A,B),F8: fun(A,B)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),S2))
         => ( topolo1002775350975398744n_open(A,S2)
           => ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S2))
            <=> ( real_V3181309239436604168linear(A,B,F8)
                & ? [E3: fun(A,B)] :
                    ( ! [H5: A] :
                        ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),H5)),S2))
                       => ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),H5)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,X3)),aa(A,B,F8,H5))),aa(A,B,E3,H5)) ) )
                    & filterlim(A,real,aTP_Lamp_zb(fun(A,B),fun(A,real),E3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
tff(fact_7107_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [A3: A,S2: set(A),T6: set(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),S2))
         => ( topolo1002775350975398744n_open(A,S2)
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),T6))
             => ( topolo174197925503356063within(A,A3,T6) = topolo174197925503356063within(A,A3,top_top(set(A))) ) ) ) ) ) ).

% at_within_open_subset
tff(fact_7108_open__right,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A),X3: A,Y4: A] :
          ( topolo1002775350975398744n_open(A,S2)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),S2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
             => ? [B5: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),B5))
                  & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,X3,B5)),S2)) ) ) ) ) ) ).

% open_right
tff(fact_7109_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( topolo8458572112393995274pology(A)
     => ! [A2: set(A),X3: A] :
          ( topolo1002775350975398744n_open(A,A2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),X3)) )
           => ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(set(A),A,complete_Sup_Sup(A),A2)),A2)) ) ) ) ).

% Sup_notin_open
tff(fact_7110_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( topolo8458572112393995274pology(A)
     => ! [A2: set(A),X3: A] :
          ( topolo1002775350975398744n_open(A,A2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),X2)) )
           => ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(set(A),A,complete_Inf_Inf(A),A2)),A2)) ) ) ) ).

% Inf_notin_open
tff(fact_7111_first__countable__basis,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [X3: A] :
        ? [A7: fun(nat,set(A))] :
          ( ! [I4: nat] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(nat,set(A),A7,I4)))
              & topolo1002775350975398744n_open(A,aa(nat,set(A),A7,I4)) )
          & ! [S9: set(A)] :
              ( ( topolo1002775350975398744n_open(A,S9)
                & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),S9)) )
             => ? [I3: nat] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(nat,set(A),A7,I3)),S9)) ) ) ) ).

% first_countable_basis
tff(fact_7112_open__subopen,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A)] :
          ( topolo1002775350975398744n_open(A,S2)
        <=> ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),S2))
             => ? [T9: set(A)] :
                  ( topolo1002775350975398744n_open(A,T9)
                  & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),T9))
                  & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T9),S2)) ) ) ) ) ).

% open_subopen
tff(fact_7113_openI,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
             => ? [T10: set(A)] :
                  ( topolo1002775350975398744n_open(A,T10)
                  & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),T10))
                  & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T10),S2)) ) )
         => topolo1002775350975398744n_open(A,S2) ) ) ).

% openI
tff(fact_7114_open__left,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A),X3: A,Y4: A] :
          ( topolo1002775350975398744n_open(A,S2)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),S2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
             => ? [B5: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B5),X3))
                  & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,B5,X3)),S2)) ) ) ) ) ) ).

% open_left
tff(fact_7115_lim__explicit,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),F0: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,F0),at_top(nat))
        <=> ! [S10: set(A)] :
              ( topolo1002775350975398744n_open(A,S10)
             => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),F0),S10))
               => ? [N6: nat] :
                  ! [N3: nat] :
                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N6),N3))
                   => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,F2,N3)),S10)) ) ) ) ) ) ).

% lim_explicit
tff(fact_7116_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: filter(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( topolo3448309680560233919inuous(A,B,F3,G)
           => ( ( aa(A,B,G,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A))) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,F3,aa(fun(A,B),fun(A,B),aTP_Lamp_ut(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ) ).

% continuous_divide
tff(fact_7117_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [F3: filter(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( ( aa(A,B,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F3,aTP_Lamp_uw(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_inverse
tff(fact_7118_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: filter(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( ( aa(A,B,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F3,aTP_Lamp_ux(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_sgn
tff(fact_7119_continuous__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( topolo3448309680560233919inuous(A,real,F3,G)
           => ( ( aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A))) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,F3,aa(fun(A,real),fun(A,real),aTP_Lamp_zf(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ).

% continuous_powr
tff(fact_7120_continuous__ln,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( ( aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A))) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_xc(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_ln
tff(fact_7121_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: filter(A),F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,F3,F2)
         => ( ( cos(A,aa(A,A,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_zg(A,A)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,F3,aTP_Lamp_uy(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_tan
tff(fact_7122_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: filter(A),F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,F3,F2)
         => ( ( sin(A,aa(A,A,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_zg(A,A)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,F3,aTP_Lamp_uz(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_cot
tff(fact_7123_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: filter(C),F2: fun(C,A)] :
          ( topolo3448309680560233919inuous(C,A,F3,F2)
         => ( ( cosh(A,aa(C,A,F2,topolo3827282254853284352ce_Lim(C,C,F3,aTP_Lamp_zh(C,C)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(C,A,F3,aTP_Lamp_va(fun(C,A),fun(C,A),F2)) ) ) ) ).

% continuous_tanh
tff(fact_7124_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A)))))
           => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_zi(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_arcosh
tff(fact_7125_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(D)
        & zero(C) )
     => ! [A3: A,S2: set(A),F2: fun(A,D),L5: D] :
          ( nO_MATCH(C,A,zero_zero(C),A3)
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),S2))
           => ( topolo1002775350975398744n_open(A,S2)
             => ( filterlim(A,D,F2,topolo7230453075368039082e_nhds(D,L5),topolo174197925503356063within(A,A3,S2))
              <=> filterlim(A,D,aa(fun(A,D),fun(A,D),aTP_Lamp_ww(A,fun(fun(A,D),fun(A,D)),A3),F2),topolo7230453075368039082e_nhds(D,L5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ) ).

% tendsto_offset_zero_iff
tff(fact_7126_continuous__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( topolo3448309680560233919inuous(A,real,F3,G)
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A)))))
             => ( ( aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A))) != one_one(real) )
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,G,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A)))))
                 => topolo3448309680560233919inuous(A,real,F3,aa(fun(A,real),fun(A,real),aTP_Lamp_xi(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ) ) ).

% continuous_log
tff(fact_7127_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [E: real,F8: fun(A,B),S: set(A),X3: A,F2: fun(A,B),H6: fun(A,real)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
         => ( real_V3181309239436604168linear(A,B,F8)
           => ( ! [Y2: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y2),S))
                 => ( ( Y2 != X3 )
                   => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Y2,X3)),E))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,Y2)),aa(A,B,F2,X3))),aa(A,B,F8,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y2),X3))))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y2),X3)))),aa(A,real,H6,Y2))) ) ) )
             => ( filterlim(A,real,H6,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,X3,S))
               => has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S)) ) ) ) ) ) ).

% has_derivativeI_sandwich
tff(fact_7128_tendsto__exp__limit__at__right,axiom,
    ! [X3: real] : filterlim(real,real,aTP_Lamp_zj(real,fun(real,real),X3),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X3)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% tendsto_exp_limit_at_right
tff(fact_7129_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,K: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),set_ord_greaterThan(A,K)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),I)) ) ) ).

% greaterThan_iff
tff(fact_7130_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A3: A,B2: A,C2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)) = real_V557655796197034286t_dist(A,B2,C2) ) ) ).

% dist_add_cancel
tff(fact_7131_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [B2: A,A3: A,C2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)) = real_V557655796197034286t_dist(A,B2,C2) ) ) ).

% dist_add_cancel2
tff(fact_7132_dist__self,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A] : ( real_V557655796197034286t_dist(A,X3,X3) = zero_zero(real) ) ) ).

% dist_self
tff(fact_7133_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Y4: A] :
          ( ( real_V557655796197034286t_dist(A,X3,Y4) = zero_zero(real) )
        <=> ( X3 = Y4 ) ) ) ).

% dist_eq_0_iff
tff(fact_7134_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_greaterThan(A,X3)),set_ord_greaterThan(A,Y4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ).

% greaterThan_subset_iff
tff(fact_7135_dist__0__norm,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] : ( real_V557655796197034286t_dist(A,zero_zero(A),X3) = real_V7770717601297561774m_norm(A,X3) ) ) ).

% dist_0_norm
tff(fact_7136_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X3,Y4)))
        <=> ( X3 != Y4 ) ) ) ).

% zero_less_dist_iff
tff(fact_7137_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(A,X3,Y4)),zero_zero(real)))
        <=> ( X3 = Y4 ) ) ) ).

% dist_le_zero_iff
tff(fact_7138_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),top_top(A)))
         => ( aa(set(A),A,complete_Sup_Sup(A),set_ord_greaterThan(A,X3)) = top_top(A) ) ) ) ).

% Sup_greaterThanAtLeast
tff(fact_7139_dist__scaleR,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: real,A3: A,Y4: real] : ( real_V557655796197034286t_dist(A,aa(A,A,real_V8093663219630862766scaleR(A,X3),A3),aa(A,A,real_V8093663219630862766scaleR(A,Y4),A3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y4))),real_V7770717601297561774m_norm(A,A3)) ) ) ).

% dist_scaleR
tff(fact_7140_open__dist,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S2: set(A)] :
          ( topolo1002775350975398744n_open(A,S2)
        <=> ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),S2))
             => ? [E3: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
                  & ! [Y: A] :
                      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Y,X4)),E3))
                     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y),S2)) ) ) ) ) ) ).

% open_dist
tff(fact_7141_open__ball,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,D2: real] : topolo1002775350975398744n_open(A,collect(A,aa(real,fun(A,bool),aTP_Lamp_zk(A,fun(real,fun(A,bool)),X3),D2))) ) ).

% open_ball
tff(fact_7142_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Z: A,Y4: A,E: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,X3,Z)),real_V557655796197034286t_dist(A,Y4,Z))),E))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(A,X3,Y4)),E)) ) ) ).

% dist_triangle_le
tff(fact_7143_dist__triangle3,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Y4: A,A3: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(A,X3,Y4)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,A3,X3)),real_V557655796197034286t_dist(A,A3,Y4)))) ) ).

% dist_triangle3
tff(fact_7144_dist__triangle2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Y4: A,Z: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(A,X3,Y4)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,X3,Z)),real_V557655796197034286t_dist(A,Y4,Z)))) ) ).

% dist_triangle2
tff(fact_7145_dist__triangle,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Z: A,Y4: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(A,X3,Z)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,X3,Y4)),real_V557655796197034286t_dist(A,Y4,Z)))) ) ).

% dist_triangle
tff(fact_7146_zero__le__dist,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Y4: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),real_V557655796197034286t_dist(A,X3,Y4))) ) ).

% zero_le_dist
tff(fact_7147_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X3: A] : ( real_V7770717601297561774m_norm(A,X3) = real_V557655796197034286t_dist(A,X3,zero_zero(A)) ) ) ).

% norm_conv_dist
tff(fact_7148_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Z: A,Y4: A,E: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,X3,Z)),real_V557655796197034286t_dist(A,Y4,Z))),E))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X3,Y4)),E)) ) ) ).

% dist_triangle_lt
tff(fact_7149_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,Y4: A,E1: real,X22: A,E22: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X15,Y4)),E1))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X22,Y4)),E22))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X15,X22)),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22))) ) ) ) ).

% dist_triangle_less_add
tff(fact_7150_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Y4: A] :
          ( ( X3 != Y4 )
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X3,Y4))) ) ) ).

% dist_pos_lt
tff(fact_7151_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A,Y4: A] : ~ pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X3,Y4)),zero_zero(real))) ) ).

% dist_not_less_zero
tff(fact_7152_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A] : ( set_ord_greaterThan(A,L) = collect(A,aa(A,fun(A,bool),ord_less(A),L)) ) ) ).

% greaterThan_def
tff(fact_7153_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Y4: A,X3: A,E: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Y4,X3)),E))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X3,Y4)),E)) ) ) ).

% dist_commute_lessI
tff(fact_7154_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [A3: A,B2: A,C2: A] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V557655796197034286t_dist(A,A3,B2)),real_V557655796197034286t_dist(A,B2,C2)))),real_V557655796197034286t_dist(A,A3,C2))) ) ).

% abs_dist_diff_le
tff(fact_7155_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( topolo174197925503356063within(A,A3,set_or1337092689740270186AtMost(A,A3,B2)) = topolo174197925503356063within(A,A3,set_ord_greaterThan(A,A3)) ) ) ) ).

% at_within_Icc_at_right
tff(fact_7156_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,U)),set_ord_greaterThan(A,U)) = set_ord_greaterThan(A,L) ) ) ) ).

% ivl_disj_un_one(5)
tff(fact_7157_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),F8: A,A3: A,S2: set(A),D2: real,G: fun(A,A)] :
          ( has_field_derivative(A,F2,F8,topolo174197925503356063within(A,A3,S2))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D2))
           => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),S2))
             => ( ! [X2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
                   => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X2,A3)),D2))
                     => ( aa(A,A,F2,X2) = aa(A,A,G,X2) ) ) )
               => has_field_derivative(A,G,F8,topolo174197925503356063within(A,A3,S2)) ) ) ) ) ) ).

% has_field_derivative_transform_within
tff(fact_7158_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F8: fun(A,B),X3: A,S: set(A),D2: real,G: fun(A,B)] :
          ( has_derivative(A,B,F2,F8,topolo174197925503356063within(A,X3,S))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D2))
           => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),S))
             => ( ! [X9: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X9),S))
                   => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X9,X3)),D2))
                     => ( aa(A,B,F2,X9) = aa(A,B,G,X9) ) ) )
               => has_derivative(A,B,G,F8,topolo174197925503356063within(A,X3,S)) ) ) ) ) ) ).

% has_derivative_transform_within
tff(fact_7159_Cauchy__def,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
             => ? [M8: nat] :
                ! [M6: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),M6))
                 => ! [N3: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),N3))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M6),aa(nat,A,X7,N3))),E3)) ) ) ) ) ) ).

% Cauchy_def
tff(fact_7160_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,S)
        <=> ! [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
             => ? [N6: nat] :
                ! [N3: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N6),N3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,S,N3),aa(nat,A,S,N6))),E3)) ) ) ) ) ).

% Cauchy_altdef2
tff(fact_7161_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),E: real] :
          ( topolo3814608138187158403Cauchy(A,X7)
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
           => ? [M10: nat] :
              ! [M2: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M10),M2))
               => ! [N7: nat] :
                    ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M10),N7))
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M2),aa(nat,A,X7,N7))),E)) ) ) ) ) ) ).

% metric_CauchyD
tff(fact_7162_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E2))
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M9),M3))
                 => ! [N2: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M9),N2))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M3),aa(nat,A,X7,N2))),E2)) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% metric_CauchyI
tff(fact_7163_less__separate,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ? [A5: A,B5: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),set_ord_lessThan(A,A5)))
              & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),set_ord_greaterThan(A,B5)))
              & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,A5)),set_ord_greaterThan(A,B5)) = bot_bot(set(A)) ) ) ) ) ).

% less_separate
tff(fact_7164_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: fun(real,A),F3: filter(A),A3: real] :
      ( filterlim(real,A,F2,F3,topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
    <=> filterlim(real,A,aa(real,fun(real,A),aTP_Lamp_zl(fun(real,A),fun(real,fun(real,A)),F2),A3),F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% filterlim_at_right_to_0
tff(fact_7165_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(A) )
     => ! [F2: fun(C,A),L: A,A3: C,G: fun(C,B),M: B] :
          ( filterlim(C,A,F2,topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(C,A3,top_top(set(C))))
         => ( ! [X2: C] :
                ( ( X2 != A3 )
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(B,aa(C,B,G,X2),M)),real_V557655796197034286t_dist(A,aa(C,A,F2,X2),L))) )
           => filterlim(C,B,G,topolo7230453075368039082e_nhds(B,M),topolo174197925503356063within(C,A3,top_top(set(C)))) ) ) ) ).

% metric_LIM_imp_LIM
tff(fact_7166_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),L: B,X3: A,S2: set(A),D2: real,G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,X3,S2))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D2))
           => ( ! [X9: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X9),S2))
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X9,X3)))
                   => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X9,X3)),D2))
                     => ( aa(A,B,F2,X9) = aa(A,B,G,X9) ) ) ) )
             => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,X3,S2)) ) ) ) ) ).

% Lim_transform_within
tff(fact_7167_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Y4: A,X15: A,E: real,X22: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Y4,X15)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E),aa(num,real,numeral_numeral(real),bit0(one2)))))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Y4,X22)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X15,X22)),E)) ) ) ) ).

% dist_triangle_half_r
tff(fact_7168_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,Y4: A,E: real,X22: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X15,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E),aa(num,real,numeral_numeral(real),bit0(one2)))))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X22,Y4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E),aa(num,real,numeral_numeral(real),bit0(one2)))))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X15,X22)),E)) ) ) ) ).

% dist_triangle_half_l
tff(fact_7169_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,X22: A,E: real,X32: A,X42: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X15,X22)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E),aa(num,real,numeral_numeral(real),bit1(one2)))))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X22,X32)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E),aa(num,real,numeral_numeral(real),bit1(one2)))))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X32,X42)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E),aa(num,real,numeral_numeral(real),bit1(one2)))))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X15,X42)),E)) ) ) ) ) ).

% dist_triangle_third
tff(fact_7170_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [G: fun(A,B),G5: filter(B),X3: A,S2: set(A),F3: filter(B),D2: real,F2: fun(A,B)] :
          ( filterlim(A,B,G,G5,topolo174197925503356063within(A,X3,S2))
         => ( pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),G5),F3))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D2))
             => ( ! [X9: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X9),S2))
                   => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X9,X3)))
                     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X9,X3)),D2))
                       => ( aa(A,B,F2,X9) = aa(A,B,G,X9) ) ) ) )
               => filterlim(A,B,F2,F3,topolo174197925503356063within(A,X3,S2)) ) ) ) ) ) ).

% filterlim_transform_within
tff(fact_7171_CauchyI_H,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E2))
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M9),M3))
                 => ! [N2: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N2))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M3),aa(nat,A,X7,N2))),E2)) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% CauchyI'
tff(fact_7172_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [F2: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,F2)
        <=> ! [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
             => ? [M8: nat] :
                ! [M6: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),M6))
                 => ! [N3: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M6),N3))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,F2,M6),aa(nat,A,F2,N3))),E3)) ) ) ) ) ) ).

% Cauchy_altdef
tff(fact_7173_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
        <=> filterlim(A,real,aa(B,fun(A,real),aTP_Lamp_zm(fun(A,B),fun(B,fun(A,real)),F2),L),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% tendsto_dist_iff
tff(fact_7174_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(B,A),P2: A,F12: filter(B),C2: A,L: A] :
          ( filterlim(B,A,F2,topolo174197925503356063within(A,P2,set_ord_greaterThan(A,P2)),F12)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( ( L = aa(A,A,aa(A,fun(A,A),times_times(A),C2),P2) )
             => filterlim(B,A,aa(A,fun(B,A),aTP_Lamp_zn(fun(B,A),fun(A,fun(B,A)),F2),C2),topolo174197925503356063within(A,L,set_ord_greaterThan(A,L)),F12) ) ) ) ) ).

% filterlim_times_pos
tff(fact_7175_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F2: fun(A,B),L5: B,A3: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A))))
        <=> ! [R5: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R5))
             => ? [S6: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),S6))
                  & ! [X4: A] :
                      ( ( ( X4 != A3 )
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X4,A3)),S6)) )
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F2,X4),L5)),R5)) ) ) ) ) ) ).

% LIM_def
tff(fact_7176_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F2: fun(A,B),L5: B,A3: A,R2: real] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A))))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R2))
           => ? [S3: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),S3))
                & ! [X: A] :
                    ( ( ( X != A3 )
                      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X,A3)),S3)) )
                   => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F2,X),L5)),R2)) ) ) ) ) ) ).

% metric_LIM_D
tff(fact_7177_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [A3: A,F2: fun(A,B),L5: B] :
          ( ! [R: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
             => ? [S8: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),S8))
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X2,A3)),S8)) )
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F2,X2),L5)),R)) ) ) )
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ).

% metric_LIM_I
tff(fact_7178_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [G: fun(A,B),L: B,A3: A,R4: real,F2: fun(A,B)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A3,top_top(set(A))))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R4))
           => ( ! [X2: A] :
                  ( ( X2 != A3 )
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X2,A3)),R4))
                   => ( aa(A,B,F2,X2) = aa(A,B,G,X2) ) ) )
             => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ) ) ).

% metric_LIM_equal2
tff(fact_7179_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L5: A,R2: real] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R2))
           => ? [No4: nat] :
              ! [N7: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),No4),N7))
               => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N7),L5)),R2)) ) ) ) ) ).

% metric_LIMSEQ_D
tff(fact_7180_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L5: A] :
          ( ! [R: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R))
             => ? [No3: nat] :
                ! [N2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),No3),N2))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N2),L5)),R)) ) )
         => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat)) ) ) ).

% metric_LIMSEQ_I
tff(fact_7181_lim__sequentially,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L5: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
        <=> ! [R5: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R5))
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),No2),N3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N3),L5)),R5)) ) ) ) ) ).

% lim_sequentially
tff(fact_7182_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [J4: nat] :
            ? [M8: nat] :
            ! [M6: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),M6))
             => ! [N3: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M8),N3))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M6),aa(nat,A,X7,N3))),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,J4))))) ) ) ) ) ).

% metric_Cauchy_iff2
tff(fact_7183_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F2: fun(A,B),B2: B,A3: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A3,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( ? [D6: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D6))
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X2,A3)),D6)) )
                     => ( aa(A,B,F2,X2) != B2 ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_zo(fun(A,B),fun(fun(B,C),fun(A,C)),F2),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ) ) ).

% metric_LIM_compose2
tff(fact_7184_tendsto__arcosh__at__left__1,axiom,
    filterlim(real,real,arcosh(real),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,one_one(real),set_ord_greaterThan(real,one_one(real)))) ).

% tendsto_arcosh_at_left_1
tff(fact_7185_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(D) )
     => ! [A3: A,F2: fun(A,C),G: fun(C,D),L: D] :
          ( topolo3448309680560233919inuous(A,C,topolo174197925503356063within(A,A3,top_top(set(A))),F2)
         => ( filterlim(C,D,G,topolo7230453075368039082e_nhds(D,L),topolo174197925503356063within(C,aa(A,C,F2,A3),top_top(set(C))))
           => ( ? [D6: real] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D6))
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X2,A3)),D6)) )
                     => ( aa(A,C,F2,X2) != aa(A,C,F2,A3) ) ) )
             => filterlim(A,D,aa(fun(C,D),fun(A,D),aTP_Lamp_zp(fun(A,C),fun(fun(C,D),fun(A,D)),F2),G),topolo7230453075368039082e_nhds(D,L),topolo174197925503356063within(A,A3,top_top(set(A)))) ) ) ) ) ).

% metric_isCont_LIM_compose2
tff(fact_7186_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A3: A,G: fun(A,B),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,set_ord_lessThan(A,A3)),G)
         => ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,G,A3)),topolo174197925503356063within(A,A3,set_ord_greaterThan(A,A3)))
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,top_top(set(A))),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_zq(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A3),G),F2)) ) ) ) ).

% isCont_If_ge
tff(fact_7187_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L5: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
        <=> ! [R5: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),R5))
             => ? [No2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),No2))
                  & ! [N3: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),No2),N3))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N3),L5)),R5)) ) ) ) ) ) ).

% LIMSEQ_iff_nz
tff(fact_7188_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S2: set(A)] :
          ( topolo6688025880775521714ounded(A,S2)
        <=> ! [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
             => ? [K3: set(A)] :
                  ( finite_finite(A,K3)
                  & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(A),set(set(A)),image(A,set(A),aTP_Lamp_zs(real,fun(A,set(A)),E3)),K3)))) ) ) ) ) ).

% totally_bounded_metric
tff(fact_7189_filterlim__tan__at__right,axiom,
    filterlim(real,real,tan(real),at_bot(real),topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),set_ord_greaterThan(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))))) ).

% filterlim_tan_at_right
tff(fact_7190_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [S2: set(A),T6: set(A)] :
          ( topolo6688025880775521714ounded(A,S2)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T6),S2))
           => topolo6688025880775521714ounded(A,T6) ) ) ) ).

% totally_bounded_subset
tff(fact_7191_greaterThan__0,axiom,
    set_ord_greaterThan(nat,zero_zero(nat)) = aa(set(nat),set(nat),image(nat,nat,suc),top_top(set(nat))) ).

% greaterThan_0
tff(fact_7192_exp__at__bot,axiom,
    filterlim(real,real,exp(real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_bot(real)) ).

% exp_at_bot
tff(fact_7193_filterlim__inverse__at__bot__neg,axiom,
    filterlim(real,real,inverse_inverse(real),at_bot(real),topolo174197925503356063within(real,zero_zero(real),set_ord_lessThan(real,zero_zero(real)))) ).

% filterlim_inverse_at_bot_neg
tff(fact_7194_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
       => ( filterlim(A,real,G,at_bot(real),F3)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zt(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_bot(real),F3) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
tff(fact_7195_ln__at__0,axiom,
    filterlim(real,real,ln_ln(real),at_bot(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% ln_at_0
tff(fact_7196_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: fun(real,real),Flim: real] :
      ( ! [X2: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2))
         => ? [Y5: real] :
              ( has_field_derivative(real,F2,Y5,topolo174197925503356063within(real,X2,top_top(set(real))))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y5)) ) )
     => ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,Flim),at_bot(real))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Flim),aa(real,real,F2,B2))) ) ) ).

% DERIV_pos_imp_increasing_at_bot
tff(fact_7197_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F2: fun(real,real),F3: filter(real)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( filterlim(real,real,F2,at_bot(real),F3)
       => ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zu(nat,fun(fun(real,real),fun(real,real)),N),F2),at_bot(real),F3) ) ) ) ).

% filterlim_pow_at_bot_odd
tff(fact_7198_tendsto__arctan__at__bot,axiom,
    filterlim(real,real,arctan,topolo7230453075368039082e_nhds(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),at_bot(real)) ).

% tendsto_arctan_at_bot
tff(fact_7199_interval__cases,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [S2: set(A)] :
          ( ! [A5: A,B5: A,X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A5),S2))
             => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B5),S2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),X2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B5))
                   => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2)) ) ) ) )
         => ? [A5: A,B5: A] :
              ( ( S2 = bot_bot(set(A)) )
              | ( S2 = top_top(set(A)) )
              | ( S2 = set_ord_lessThan(A,B5) )
              | ( S2 = set_ord_atMost(A,B5) )
              | ( S2 = set_ord_greaterThan(A,A5) )
              | ( S2 = set_ord_atLeast(A,A5) )
              | ( S2 = set_or5935395276787703475ssThan(A,A5,B5) )
              | ( S2 = set_or3652927894154168847AtMost(A,A5,B5) )
              | ( S2 = set_or7035219750837199246ssThan(A,A5,B5) )
              | ( S2 = set_or1337092689740270186AtMost(A,A5,B5) ) ) ) ) ).

% interval_cases
tff(fact_7200_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F2: fun(real,real),F3: filter(real)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( filterlim(real,real,F2,at_bot(real),F3)
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
         => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zu(nat,fun(fun(real,real),fun(real,real)),N),F2),at_top(real),F3) ) ) ) ).

% filterlim_pow_at_bot_even
tff(fact_7201_atLeast__0,axiom,
    set_ord_atLeast(nat,zero_zero(nat)) = top_top(set(nat)) ).

% atLeast_0
tff(fact_7202_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,K: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I),set_ord_atLeast(A,K)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),I)) ) ) ).

% atLeast_iff
tff(fact_7203_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_atLeast(A,X3)),set_ord_atLeast(A,Y4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ).

% atLeast_subset_iff
tff(fact_7204_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),K)),set_ord_atLeast(A,I)) = set_ord_atLeast(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),K),I)) ) ) ).

% image_add_atLeast
tff(fact_7205_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [L: A,H: A,L4: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,L,H)),set_ord_atLeast(A,L4)))
        <=> ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),H))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L4),L)) ) ) ) ).

% Icc_subset_Ici_iff
tff(fact_7206_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_greaterThan(A,A3)),set_ord_atLeast(A,A3))) ) ).

% Ioi_le_Ico
tff(fact_7207_sqrt__at__top,axiom,
    filterlim(real,real,sqrt,at_top(real),at_top(real)) ).

% sqrt_at_top
tff(fact_7208_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,at_top(real),F3)
     => ( filterlim(A,real,G,at_top(real),F3)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zt(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_top(real),F3) ) ) ).

% filterlim_at_top_mult_at_top
tff(fact_7209_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [L: A,H2: A] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_atLeast(A,L)),set_ord_atMost(A,H2))) ) ).

% not_Ici_le_Iic
tff(fact_7210_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [H: A,L4: A] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_atMost(A,H)),set_ord_atLeast(A,L4))) ) ).

% not_Iic_le_Ici
tff(fact_7211_atLeast__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A] : ( set_ord_atLeast(A,L) = collect(A,aa(A,fun(A,bool),ord_less_eq(A),L)) ) ) ).

% atLeast_def
tff(fact_7212_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [L: A] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),top_top(set(A))),set_ord_atLeast(A,L))) ) ).

% not_UNIV_le_Ici
tff(fact_7213_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [L: A,L4: A,H2: A] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_atLeast(A,L)),set_or1337092689740270186AtMost(A,L4,H2))) ) ).

% not_Ici_le_Icc
tff(fact_7214_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,U)),set_ord_atLeast(A,U)) = set_ord_atLeast(A,L) ) ) ) ).

% ivl_disj_un_one(8)
tff(fact_7215_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ord_atLeast(A,A3)),set_ord_greaterThan(A,B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ).

% Ici_subset_Ioi_iff
tff(fact_7216_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F2: fun(A,real),F3: filter(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( filterlim(A,real,F2,at_top(real),F3)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_vk(nat,fun(fun(A,real),fun(A,real)),N),F2),at_top(real),F3) ) ) ).

% filterlim_pow_at_top
tff(fact_7217_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( filterlim(A,real,G,at_top(real),F3)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zv(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% real_tendsto_divide_at_top
tff(fact_7218_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,U)),set_ord_greaterThan(A,U)) = set_ord_atLeast(A,L) ) ) ) ).

% ivl_disj_un_one(7)
tff(fact_7219_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,at_top(real),F3)
     => filterlim(A,real,aTP_Lamp_zw(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ).

% tendsto_inverse_0_at_top
tff(fact_7220_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,U)),set_ord_atLeast(A,U)) = set_ord_greaterThan(A,L) ) ) ) ).

% ivl_disj_un_one(6)
tff(fact_7221_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
       => ( filterlim(A,real,G,at_top(real),F3)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zx(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_top(real),F3) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
tff(fact_7222_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),C2))
       => ( filterlim(A,real,G,at_top(real),F3)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zt(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_top(real),F3) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
tff(fact_7223_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F2: fun(A,real),F3: filter(A)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),S),zero_zero(real)))
     => ( filterlim(A,real,F2,at_top(real),F3)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zy(real,fun(fun(A,real),fun(A,real)),S),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% tendsto_neg_powr
tff(fact_7224_ln__x__over__x__tendsto__0,axiom,
    filterlim(real,real,aTP_Lamp_zz(real,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(real)) ).

% ln_x_over_x_tendsto_0
tff(fact_7225_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F2: fun(real,A),F3: filter(A)] :
      ( filterlim(real,A,F2,F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
    <=> filterlim(real,A,aTP_Lamp_aaa(fun(real,A),fun(real,A),F2),F3,at_top(real)) ) ).

% filterlim_at_right_to_top
tff(fact_7226_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F2: fun(real,A),F3: filter(A)] :
      ( filterlim(real,A,F2,F3,at_top(real))
    <=> filterlim(real,A,aTP_Lamp_aaa(fun(real,A),fun(real,A),F2),F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% filterlim_at_top_to_right
tff(fact_7227_filterlim__inverse__at__right__top,axiom,
    filterlim(real,real,inverse_inverse(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))),at_top(real)) ).

% filterlim_inverse_at_right_top
tff(fact_7228_filterlim__inverse__at__top__right,axiom,
    filterlim(real,real,inverse_inverse(real),at_top(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% filterlim_inverse_at_top_right
tff(fact_7229_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),zero_zero(real)))
       => ( filterlim(A,real,G,at_top(real),F3)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zt(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_bot(real),F3) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
tff(fact_7230_tendsto__power__div__exp__0,axiom,
    ! [K: nat] : filterlim(real,real,aTP_Lamp_aab(nat,fun(real,real),K),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(real)) ).

% tendsto_power_div_exp_0
tff(fact_7231_tendsto__exp__limit__at__top,axiom,
    ! [X3: real] : filterlim(real,real,aTP_Lamp_aac(real,fun(real,real),X3),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X3)),at_top(real)) ).

% tendsto_exp_limit_at_top
tff(fact_7232_filterlim__tan__at__left,axiom,
    filterlim(real,real,tan(real),at_top(real),topolo174197925503356063within(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))),set_ord_lessThan(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))) ).

% filterlim_tan_at_left
tff(fact_7233_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: fun(real,real),Flim: real] :
      ( ! [X2: real] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),B2),X2))
         => ? [Y5: real] :
              ( has_field_derivative(real,F2,Y5,topolo174197925503356063within(real,X2,top_top(set(real))))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y5),zero_zero(real))) ) )
     => ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,Flim),at_top(real))
       => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Flim),aa(real,real,F2,B2))) ) ) ).

% DERIV_neg_imp_decreasing_at_top
tff(fact_7234_tendsto__arctan__at__top,axiom,
    filterlim(real,real,arctan,topolo7230453075368039082e_nhds(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),at_top(real)) ).

% tendsto_arctan_at_top
tff(fact_7235_lhopital__left__at__top,axiom,
    ! [G: fun(real,real),X3: real,G3: fun(real,real),F2: fun(real,real),F8: fun(real,real),Y4: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
     => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),topolo7230453075368039082e_nhds(real,Y4),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,Y4),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3))) ) ) ) ) ) ).

% lhopital_left_at_top
tff(fact_7236_lhopital__right__at__top,axiom,
    ! [G: fun(real,real),X3: real,G3: fun(real,real),F2: fun(real,real),F8: fun(real,real),Y4: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
     => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),topolo7230453075368039082e_nhds(real,Y4),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,Y4),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3))) ) ) ) ) ) ).

% lhopital_right_at_top
tff(fact_7237_eventually__at__right,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X3: A,Y4: A,P: fun(A,bool)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( eventually(A,P,topolo174197925503356063within(A,X3,set_ord_greaterThan(A,X3)))
          <=> ? [B7: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),B7))
                & ! [Y: A] :
                    ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),B7))
                     => pp(aa(A,bool,P,Y)) ) ) ) ) ) ) ).

% eventually_at_right
tff(fact_7238_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [P: fun(A,bool),X3: A] :
          ( eventually(A,P,topolo174197925503356063within(A,X3,set_ord_greaterThan(A,X3)))
        <=> ? [B7: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),B7))
              & ! [Y: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),B7))
                   => pp(aa(A,bool,P,Y)) ) ) ) ) ) ).

% eventually_at_right_field
tff(fact_7239_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [Q: fun(A,bool),F2: fun(A,B),P: fun(B,bool),G: fun(B,A)] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,Q,X2))
             => ( pp(aa(A,bool,Q,Y2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2))) ) ) )
         => ( ! [X2: B] :
                ( pp(aa(B,bool,P,X2))
               => ( aa(A,B,F2,aa(B,A,G,X2)) = X2 ) )
           => ( ! [X2: B] :
                  ( pp(aa(B,bool,P,X2))
                 => pp(aa(A,bool,Q,aa(B,A,G,X2))) )
             => ( eventually(A,Q,at_top(A))
               => ( eventually(B,P,at_top(B))
                 => filterlim(A,B,F2,at_top(B),at_top(A)) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
tff(fact_7240_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [C2: A] : eventually(A,aa(A,fun(A,bool),ord_less(A),C2),at_top(A)) ) ).

% eventually_gt_at_top
tff(fact_7241_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [P: fun(A,bool)] :
          ( eventually(A,P,at_top(A))
        <=> ? [N6: A] :
            ! [N3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),N6),N3))
             => pp(aa(A,bool,P,N3)) ) ) ) ).

% eventually_at_top_dense
tff(fact_7242_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool)] :
          ( eventually(A,P,at_top(A))
        <=> ? [N6: A] :
            ! [N3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N6),N3))
             => pp(aa(A,bool,P,N3)) ) ) ) ).

% eventually_at_top_linorder
tff(fact_7243_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,P: fun(A,bool)] :
          ( ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),X2))
             => pp(aa(A,bool,P,X2)) )
         => eventually(A,P,at_top(A)) ) ) ).

% eventually_at_top_linorderI
tff(fact_7244_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : eventually(A,aa(A,fun(A,bool),ord_less_eq(A),C2),at_top(A)) ) ).

% eventually_ge_at_top
tff(fact_7245_eventually__at__left,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Y4: A,X3: A,P: fun(A,bool)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( eventually(A,P,topolo174197925503356063within(A,X3,set_ord_lessThan(A,X3)))
          <=> ? [B7: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B7),X3))
                & ! [Y: A] :
                    ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B7),Y))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X3))
                     => pp(aa(A,bool,P,Y)) ) ) ) ) ) ) ).

% eventually_at_left
tff(fact_7246_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [P: fun(A,bool),X3: A] :
          ( eventually(A,P,topolo174197925503356063within(A,X3,set_ord_lessThan(A,X3)))
        <=> ? [B7: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B7),X3))
              & ! [Y: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B7),Y))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X3))
                   => pp(aa(A,bool,P,Y)) ) ) ) ) ) ).

% eventually_at_left_field
tff(fact_7247_filter__leD,axiom,
    ! [A: $tType,F3: filter(A),F9: filter(A),P: fun(A,bool)] :
      ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F3),F9))
     => ( eventually(A,P,F9)
       => eventually(A,P,F3) ) ) ).

% filter_leD
tff(fact_7248_filter__leI,axiom,
    ! [A: $tType,F9: filter(A),F3: filter(A)] :
      ( ! [P5: fun(A,bool)] :
          ( eventually(A,P5,F9)
         => eventually(A,P5,F3) )
     => pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F3),F9)) ) ).

% filter_leI
tff(fact_7249_le__filter__def,axiom,
    ! [A: $tType,F3: filter(A),F9: filter(A)] :
      ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F3),F9))
    <=> ! [P6: fun(A,bool)] :
          ( eventually(A,P6,F9)
         => eventually(A,P6,F3) ) ) ).

% le_filter_def
tff(fact_7250_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( order_top(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: A,P: fun(A,bool)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),top_top(A)))
         => ( eventually(A,P,topolo7230453075368039082e_nhds(A,top_top(A)))
          <=> ? [B7: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B7),top_top(A)))
                & ! [Z6: A] :
                    ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B7),Z6))
                   => pp(aa(A,bool,P,Z6)) ) ) ) ) ) ).

% eventually_nhds_top
tff(fact_7251_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : eventually(A,aTP_Lamp_aag(A,fun(A,bool),C2),at_bot(A)) ) ).

% eventually_le_at_bot
tff(fact_7252_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool)] :
          ( eventually(A,P,at_bot(A))
        <=> ? [N6: A] :
            ! [N3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N3),N6))
             => pp(aa(A,bool,P,N3)) ) ) ) ).

% eventually_at_bot_linorder
tff(fact_7253_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_bot(A) )
     => ! [P: fun(A,bool)] :
          ( eventually(A,P,at_bot(A))
        <=> ? [N6: A] :
            ! [N3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),N3),N6))
             => pp(aa(A,bool,P,N3)) ) ) ) ).

% eventually_at_bot_dense
tff(fact_7254_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( unboun7993243217541854897norder(A)
     => ! [C2: A] : eventually(A,aTP_Lamp_aah(A,fun(A,bool),C2),at_bot(A)) ) ).

% eventually_gt_at_bot
tff(fact_7255_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),F3: filter(B),G5: filter(A),F9: filter(B),G6: filter(A),F8: fun(A,B)] :
      ( filterlim(A,B,F2,F3,G5)
     => ( pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),F3),F9))
       => ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),G6),G5))
         => ( eventually(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_aai(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),F8),G6)
           => filterlim(A,B,F8,F9,G6) ) ) ) ) ).

% filterlim_mono_eventually
tff(fact_7256_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [F2: fun(B,A),G: fun(B,A),Net: filter(B),H: fun(B,A),C2: A] :
          ( eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_aaj(fun(B,A),fun(fun(B,A),fun(B,bool)),F2),G),Net)
         => ( eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_aaj(fun(B,A),fun(fun(B,A),fun(B,bool)),G),H),Net)
           => ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,C2),Net)
             => ( filterlim(B,A,H,topolo7230453075368039082e_nhds(A,C2),Net)
               => filterlim(B,A,G,topolo7230453075368039082e_nhds(A,C2),Net) ) ) ) ) ) ).

% tendsto_sandwich
tff(fact_7257_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [F2: fun(B,A),Y4: A,F3: filter(B),A3: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,Y4),F3)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),A3))
           => eventually(B,aa(A,fun(B,bool),aTP_Lamp_aak(fun(B,A),fun(A,fun(B,bool)),F2),A3),F3) ) ) ) ).

% order_tendstoD(2)
tff(fact_7258_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [F2: fun(B,A),Y4: A,F3: filter(B),A3: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,Y4),F3)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),Y4))
           => eventually(B,aa(A,fun(B,bool),aTP_Lamp_aal(fun(B,A),fun(A,fun(B,bool)),F2),A3),F3) ) ) ) ).

% order_tendstoD(1)
tff(fact_7259_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Y4: A,F2: fun(B,A),F3: filter(B)] :
          ( ! [A5: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A5),Y4))
             => eventually(B,aa(A,fun(B,bool),aTP_Lamp_aal(fun(B,A),fun(A,fun(B,bool)),F2),A5),F3) )
         => ( ! [A5: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),A5))
               => eventually(B,aa(A,fun(B,bool),aTP_Lamp_aak(fun(B,A),fun(A,fun(B,bool)),F2),A5),F3) )
           => filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,Y4),F3) ) ) ) ).

% order_tendstoI
tff(fact_7260_order__tendsto__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [F2: fun(B,A),X3: A,F3: filter(B)] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,X3),F3)
        <=> ( ! [L3: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L3),X3))
               => eventually(B,aa(A,fun(B,bool),aTP_Lamp_aal(fun(B,A),fun(A,fun(B,bool)),F2),L3),F3) )
            & ! [U4: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),U4))
               => eventually(B,aa(A,fun(B,bool),aTP_Lamp_aak(fun(B,A),fun(A,fun(B,bool)),F2),U4),F3) ) ) ) ) ).

% order_tendsto_iff
tff(fact_7261_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),F3: filter(B),G: fun(B,A)] :
          ( filterlim(B,A,F2,at_top(A),F3)
         => ( eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_aam(fun(B,A),fun(fun(B,A),fun(B,bool)),F2),G),F3)
           => filterlim(B,A,G,at_top(A),F3) ) ) ) ).

% filterlim_at_top_mono
tff(fact_7262_filterlim__at__top__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_top(B),F3)
        <=> ! [Z8: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),C2),Z8))
             => eventually(A,aa(B,fun(A,bool),aTP_Lamp_aan(fun(A,B),fun(B,fun(A,bool)),F2),Z8),F3) ) ) ) ).

% filterlim_at_top_ge
tff(fact_7263_filterlim__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,F2,at_top(B),F3)
        <=> ! [Z8: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_aan(fun(A,B),fun(B,fun(A,bool)),F2),Z8),F3) ) ) ).

% filterlim_at_top
tff(fact_7264_filterlim__at__top__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,F2,at_top(B),F3)
        <=> ! [Z8: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_aao(fun(A,B),fun(B,fun(A,bool)),F2),Z8),F3) ) ) ).

% filterlim_at_top_dense
tff(fact_7265_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( no_top(A)
        & topolo1944317154257567458pology(A) )
     => ! [X3: A] : eventually(A,aa(A,fun(A,bool),ord_less(A),X3),topolo174197925503356063within(A,X3,set_ord_greaterThan(A,X3))) ) ).

% eventually_at_right_less
tff(fact_7266_filterlim__at__bot__le,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_bot(B),F3)
        <=> ! [Z8: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Z8),C2))
             => eventually(A,aa(B,fun(A,bool),aTP_Lamp_aap(fun(A,B),fun(B,fun(A,bool)),F2),Z8),F3) ) ) ) ).

% filterlim_at_bot_le
tff(fact_7267_filterlim__at__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,F2,at_bot(B),F3)
        <=> ! [Z8: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_aap(fun(A,B),fun(B,fun(A,bool)),F2),Z8),F3) ) ) ).

% filterlim_at_bot
tff(fact_7268_filterlim__at__bot__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dense_linorder(B)
        & no_bot(B) )
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,F2,at_bot(B),F3)
        <=> ! [Z8: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_aaq(fun(A,B),fun(B,fun(A,bool)),F2),Z8),F3) ) ) ).

% filterlim_at_bot_dense
tff(fact_7269_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: fun(B,real),G: fun(B,real),Net: filter(B),H: fun(B,real),C2: real] :
      ( eventually(B,aa(fun(B,real),fun(B,bool),aTP_Lamp_aar(fun(B,real),fun(fun(B,real),fun(B,bool)),F2),G),Net)
     => ( eventually(B,aa(fun(B,real),fun(B,bool),aTP_Lamp_aar(fun(B,real),fun(fun(B,real),fun(B,bool)),G),H),Net)
       => ( filterlim(B,real,F2,topolo7230453075368039082e_nhds(real,C2),Net)
         => ( filterlim(B,real,H,topolo7230453075368039082e_nhds(real,C2),Net)
           => filterlim(B,real,G,topolo7230453075368039082e_nhds(real,C2),Net) ) ) ) ) ).

% real_tendsto_sandwich
tff(fact_7270_eventually__Inf__base,axiom,
    ! [A: $tType,B3: set(filter(A)),P: fun(A,bool)] :
      ( ( B3 != bot_bot(set(filter(A))) )
     => ( ! [F5: filter(A)] :
            ( pp(aa(set(filter(A)),bool,aa(filter(A),fun(set(filter(A)),bool),member2(filter(A)),F5),B3))
           => ! [G2: filter(A)] :
                ( pp(aa(set(filter(A)),bool,aa(filter(A),fun(set(filter(A)),bool),member2(filter(A)),G2),B3))
               => ? [X: filter(A)] :
                    ( pp(aa(set(filter(A)),bool,aa(filter(A),fun(set(filter(A)),bool),member2(filter(A)),X),B3))
                    & pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),X),aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F5),G2))) ) ) )
       => ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B3))
        <=> ? [X4: filter(A)] :
              ( pp(aa(set(filter(A)),bool,aa(filter(A),fun(set(filter(A)),bool),member2(filter(A)),X4),B3))
              & eventually(A,P,X4) ) ) ) ) ).

% eventually_Inf_base
tff(fact_7271_eventually__at,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,bool),A3: A,S2: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A3,S2))
        <=> ? [D5: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D5))
              & ! [X4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),S2))
                 => ( ( ( X4 != A3 )
                      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X4,A3)),D5)) )
                   => pp(aa(A,bool,P,X4)) ) ) ) ) ) ).

% eventually_at
tff(fact_7272_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,bool),A3: A] :
          ( eventually(A,P,topolo7230453075368039082e_nhds(A,A3))
        <=> ? [D5: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D5))
              & ! [X4: A] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X4,A3)),D5))
                 => pp(aa(A,bool,P,X4)) ) ) ) ) ).

% eventually_nhds_metric
tff(fact_7273_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A3: A,B2: A,P: fun(A,bool)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),set_or5935395276787703475ssThan(A,A3,B2)))
             => pp(aa(A,bool,P,X2)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => eventually(A,P,topolo174197925503356063within(A,B2,set_ord_lessThan(A,B2))) ) ) ) ).

% eventually_at_leftI
tff(fact_7274_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A3: A,B2: A,P: fun(A,bool)] :
          ( ! [X2: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),set_or5935395276787703475ssThan(A,A3,B2)))
             => pp(aa(A,bool,P,X2)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => eventually(A,P,topolo174197925503356063within(A,A3,set_ord_greaterThan(A,A3))) ) ) ) ).

% eventually_at_rightI
tff(fact_7275_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P: fun(A,bool),A3: A] :
          ( eventually(A,P,topolo174197925503356063within(A,A3,top_top(set(A))))
        <=> eventually(A,aa(A,fun(A,bool),aTP_Lamp_aas(fun(A,bool),fun(A,fun(A,bool)),P),A3),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% eventually_at_to_0
tff(fact_7276_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [F2: fun(B,A),L: A,F3: filter(B)] :
          ( eventually(B,aa(A,fun(B,bool),aTP_Lamp_aat(fun(B,A),fun(A,fun(B,bool)),F2),L),F3)
         => ( ! [X2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),L))
               => eventually(B,aa(A,fun(B,bool),aTP_Lamp_aal(fun(B,A),fun(A,fun(B,bool)),F2),X2),F3) )
           => filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3) ) ) ) ).

% increasing_tendsto
tff(fact_7277_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [L: A,F2: fun(B,A),F3: filter(B)] :
          ( eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_aau(A,fun(fun(B,A),fun(B,bool)),L),F2),F3)
         => ( ! [X2: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),X2))
               => eventually(B,aa(A,fun(B,bool),aTP_Lamp_aak(fun(B,A),fun(A,fun(B,bool)),F2),X2),F3) )
           => filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3) ) ) ) ).

% decreasing_tendsto
tff(fact_7278_filterlim__at__top__gt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_top(B),F3)
        <=> ! [Z8: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),C2),Z8))
             => eventually(A,aa(B,fun(A,bool),aTP_Lamp_aav(fun(A,B),fun(B,fun(A,bool)),F2),Z8),F3) ) ) ) ).

% filterlim_at_top_gt
tff(fact_7279_filterlim__at__bot__lt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_bot(B),F3)
        <=> ! [Z8: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),Z8),C2))
             => eventually(A,aa(B,fun(A,bool),aTP_Lamp_aaw(fun(A,B),fun(B,fun(A,bool)),F2),Z8),F3) ) ) ) ).

% filterlim_at_bot_lt
tff(fact_7280_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [F2: fun(B,A),X3: A,F3: filter(B),A3: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,X3),F3)
         => ( eventually(B,aa(A,fun(B,bool),aTP_Lamp_aax(fun(B,A),fun(A,fun(B,bool)),F2),A3),F3)
           => ( ( F3 != bot_bot(filter(B)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),A3)) ) ) ) ) ).

% tendsto_upperbound
tff(fact_7281_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [F2: fun(B,A),X3: A,F3: filter(B),A3: A] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,X3),F3)
         => ( eventually(B,aa(A,fun(B,bool),aTP_Lamp_aay(fun(B,A),fun(A,fun(B,bool)),F2),A3),F3)
           => ( ( F3 != bot_bot(filter(B)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X3)) ) ) ) ) ).

% tendsto_lowerbound
tff(fact_7282_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [F3: filter(B),F2: fun(B,A),X3: A,G: fun(B,A),Y4: A] :
          ( ( F3 != bot_bot(filter(B)) )
         => ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,X3),F3)
           => ( filterlim(B,A,G,topolo7230453075368039082e_nhds(A,Y4),F3)
             => ( eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_aaz(fun(B,A),fun(fun(B,A),fun(B,bool)),F2),G),F3)
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3)) ) ) ) ) ) ).

% tendsto_le
tff(fact_7283_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(A) )
     => ! [F2: fun(C,A),A3: A,F3: filter(C),G: fun(C,B),B2: B] :
          ( filterlim(C,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( eventually(C,aa(B,fun(C,bool),aa(fun(C,B),fun(B,fun(C,bool)),aa(A,fun(fun(C,B),fun(B,fun(C,bool))),aTP_Lamp_aba(fun(C,A),fun(A,fun(fun(C,B),fun(B,fun(C,bool)))),F2),A3),G),B2),F3)
           => filterlim(C,B,G,topolo7230453075368039082e_nhds(B,B2),F3) ) ) ) ).

% metric_tendsto_imp_tendsto
tff(fact_7284_eventually__at__right__to__0,axiom,
    ! [P: fun(real,bool),A3: real] :
      ( eventually(real,P,topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
    <=> eventually(real,aa(real,fun(real,bool),aTP_Lamp_abb(fun(real,bool),fun(real,fun(real,bool)),P),A3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% eventually_at_right_to_0
tff(fact_7285_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F3: fun(B,filter(A)),B3: set(B)] :
      ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(B),set(filter(A)),image(B,filter(A),F3),B3)))
    <=> ? [X10: set(B)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),X10),B3))
          & finite_finite(B,X10)
          & eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(B),set(filter(A)),image(B,filter(A),F3),X10))) ) ) ).

% eventually_INF
tff(fact_7286_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( eventually(A,aTP_Lamp_abc(fun(A,real),fun(A,bool),F2),F3)
           => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_zi(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_arcosh_strong
tff(fact_7287_eventually__at__right__real,axiom,
    ! [A3: real,B2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => eventually(real,aa(real,fun(real,bool),aTP_Lamp_abd(real,fun(real,fun(real,bool)),A3),B2),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3))) ) ).

% eventually_at_right_real
tff(fact_7288_eventually__at__left__real,axiom,
    ! [B2: real,A3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),B2),A3))
     => eventually(real,aa(real,fun(real,bool),aTP_Lamp_abd(real,fun(real,fun(real,bool)),B2),A3),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3))) ) ).

% eventually_at_left_real
tff(fact_7289_eventually__at__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,bool),A3: A,S2: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A3,S2))
        <=> ? [D5: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),D5))
              & ! [X4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),S2))
                 => ( ( ( X4 != A3 )
                      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(A,X4,A3)),D5)) )
                   => pp(aa(A,bool,P,X4)) ) ) ) ) ) ).

% eventually_at_le
tff(fact_7290_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F2: fun(A,B),L5: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),F3)
         => ( eventually(A,aa(B,fun(A,bool),aTP_Lamp_abe(fun(A,B),fun(B,fun(A,bool)),F2),L5),F3)
           => filterlim(A,B,F2,topolo174197925503356063within(B,L5,set_ord_lessThan(B,L5)),F3) ) ) ) ).

% tendsto_imp_filterlim_at_left
tff(fact_7291_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F2: fun(A,B),L5: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L5),F3)
         => ( eventually(A,aa(B,fun(A,bool),aTP_Lamp_abf(fun(A,B),fun(B,fun(A,bool)),F2),L5),F3)
           => filterlim(A,B,F2,topolo174197925503356063within(B,L5,set_ord_greaterThan(B,L5)),F3) ) ) ) ).

% tendsto_imp_filterlim_at_right
tff(fact_7292_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [F2: fun(B,A),L: A,F3: filter(B),E: real] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3)
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E))
           => eventually(B,aa(real,fun(B,bool),aa(A,fun(real,fun(B,bool)),aTP_Lamp_abg(fun(B,A),fun(A,fun(real,fun(B,bool))),F2),L),E),F3) ) ) ) ).

% tendstoD
tff(fact_7293_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [F2: fun(B,A),L: A,F3: filter(B)] :
          ( ! [E2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E2))
             => eventually(B,aa(real,fun(B,bool),aa(A,fun(real,fun(B,bool)),aTP_Lamp_abg(fun(B,A),fun(A,fun(real,fun(B,bool))),F2),L),E2),F3) )
         => filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3) ) ) ).

% tendstoI
tff(fact_7294_tendsto__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [F2: fun(B,A),L: A,F3: filter(B)] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3)
        <=> ! [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
             => eventually(B,aa(real,fun(B,bool),aa(A,fun(real,fun(B,bool)),aTP_Lamp_abg(fun(B,A),fun(A,fun(real,fun(B,bool))),F2),L),E3),F3) ) ) ) ).

% tendsto_iff
tff(fact_7295_eventually__Inf,axiom,
    ! [A: $tType,P: fun(A,bool),B3: set(filter(A))] :
      ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B3))
    <=> ? [X10: set(filter(A))] :
          ( pp(aa(set(filter(A)),bool,aa(set(filter(A)),fun(set(filter(A)),bool),ord_less_eq(set(filter(A))),X10),B3))
          & finite_finite(filter(A),X10)
          & eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),X10)) ) ) ).

% eventually_Inf
tff(fact_7296_eventually__at__top__to__right,axiom,
    ! [P: fun(real,bool)] :
      ( eventually(real,P,at_top(real))
    <=> eventually(real,aTP_Lamp_abh(fun(real,bool),fun(real,bool),P),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% eventually_at_top_to_right
tff(fact_7297_eventually__at__right__to__top,axiom,
    ! [P: fun(real,bool)] :
      ( eventually(real,P,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
    <=> eventually(real,aTP_Lamp_abh(fun(real,bool),fun(real,bool),P),at_top(real)) ) ).

% eventually_at_right_to_top
tff(fact_7298_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: fun(B,real),A3: real,F3: filter(B)] :
      ( filterlim(B,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),A3))
       => ( eventually(B,aTP_Lamp_abi(fun(B,real),fun(B,bool),F2),F3)
         => filterlim(B,real,aTP_Lamp_wr(fun(B,real),fun(B,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,arcosh(real),A3)),F3) ) ) ) ).

% tendsto_arcosh_strong
tff(fact_7299_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & linorder(B) )
     => ! [Q: fun(A,bool),F2: fun(A,B),P: fun(B,bool),G: fun(B,A),A3: A] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,Q,X2))
             => ( pp(aa(A,bool,Q,Y2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2))) ) ) )
         => ( ! [X2: B] :
                ( pp(aa(B,bool,P,X2))
               => ( aa(A,B,F2,aa(B,A,G,X2)) = X2 ) )
           => ( ! [X2: B] :
                  ( pp(aa(B,bool,P,X2))
                 => pp(aa(A,bool,Q,aa(B,A,G,X2))) )
             => ( eventually(A,Q,topolo174197925503356063within(A,A3,set_ord_lessThan(A,A3)))
               => ( ! [B5: A] :
                      ( pp(aa(A,bool,Q,B5))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B5),A3)) )
                 => ( eventually(B,P,at_top(B))
                   => filterlim(A,B,F2,at_top(B),topolo174197925503356063within(A,A3,set_ord_lessThan(A,A3))) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
tff(fact_7300_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B3: set(A),F3: fun(A,filter(B)),P: fun(B,bool)] :
      ( ( B3 != bot_bot(set(A)) )
     => ( ! [A5: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A5),B3))
           => ! [B5: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B5),B3))
               => ? [X: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),B3))
                    & pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),aa(A,filter(B),F3,X)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F3,A5)),aa(A,filter(B),F3,B5)))) ) ) )
       => ( eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F3),B3)))
        <=> ? [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),B3))
              & eventually(B,P,aa(A,filter(B),F3,X4)) ) ) ) ) ).

% eventually_INF_base
tff(fact_7301_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & linorder(B) )
     => ! [Q: fun(A,bool),F2: fun(A,B),P: fun(B,bool),G: fun(B,A),A3: A] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,Q,X2))
             => ( pp(aa(A,bool,Q,Y2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2))) ) ) )
         => ( ! [X2: B] :
                ( pp(aa(B,bool,P,X2))
               => ( aa(A,B,F2,aa(B,A,G,X2)) = X2 ) )
           => ( ! [X2: B] :
                  ( pp(aa(B,bool,P,X2))
                 => pp(aa(A,bool,Q,aa(B,A,G,X2))) )
             => ( eventually(A,Q,topolo174197925503356063within(A,A3,set_ord_greaterThan(A,A3)))
               => ( ! [B5: A] :
                      ( pp(aa(A,bool,Q,B5))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B5)) )
                 => ( eventually(B,P,at_bot(B))
                   => filterlim(A,B,F2,at_bot(B),topolo174197925503356063within(A,A3,set_ord_greaterThan(A,A3))) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
tff(fact_7302_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,C),K5: real] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => ( eventually(A,aa(real,fun(A,bool),aa(fun(A,C),fun(real,fun(A,bool)),aTP_Lamp_abj(fun(A,B),fun(fun(A,C),fun(real,fun(A,bool))),F2),G),K5),F3)
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) ) ) ) ).

% tendsto_0_le
tff(fact_7303_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( eventually(A,aTP_Lamp_abk(fun(A,real),fun(A,bool),F2),F3)
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_vu(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ) ) ).

% tendsto_zero_powrI
tff(fact_7304_tendsto__powr2,axiom,
    ! [A: $tType,F2: fun(A,real),A3: real,F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( eventually(A,aTP_Lamp_abk(fun(A,real),fun(A,bool),F2),F3)
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_vu(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,powr(real,A3,B2)),F3) ) ) ) ) ).

% tendsto_powr2
tff(fact_7305_tendsto__powr_H,axiom,
    ! [A: $tType,F2: fun(A,real),A3: real,F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( ( ( A3 != zero_zero(real) )
            | ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B2))
              & eventually(A,aTP_Lamp_abk(fun(A,real),fun(A,bool),F2),F3) ) )
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_vu(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,powr(real,A3,B2)),F3) ) ) ) ).

% tendsto_powr'
tff(fact_7306_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
         => ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),L),ring_1_Ints(B)))
           => eventually(A,aa(B,fun(A,bool),aTP_Lamp_abl(fun(A,B),fun(B,fun(A,bool)),F2),L),F3) ) ) ) ).

% eventually_floor_less
tff(fact_7307_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: fun(A,real),A3: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A3),F3)
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),A3))
       => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
         => ( eventually(A,aTP_Lamp_abm(fun(A,real),fun(A,bool),G),F3)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zv(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_top(real),F3) ) ) ) ) ).

% LIM_at_top_divide
tff(fact_7308_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
         => ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),L),ring_1_Ints(B)))
           => eventually(A,aa(B,fun(A,bool),aTP_Lamp_abn(fun(A,B),fun(B,fun(A,bool)),F2),L),F3) ) ) ) ).

% eventually_less_ceiling
tff(fact_7309_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( eventually(A,aTP_Lamp_abm(fun(A,real),fun(A,bool),F2),F3)
     => ( filterlim(A,real,F2,at_top(real),F3)
      <=> filterlim(A,real,aa(fun(A,real),fun(A,real),comp(real,real,A,inverse_inverse(real)),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% filterlim_at_top_iff_inverse_0
tff(fact_7310_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( eventually(A,aTP_Lamp_abm(fun(A,real),fun(A,bool),F2),F3)
     => ( filterlim(A,real,aTP_Lamp_zw(fun(A,real),fun(A,real),F2),at_top(real),F3)
      <=> filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% filterlim_inverse_at_top_iff
tff(fact_7311_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => ( eventually(A,aTP_Lamp_abm(fun(A,real),fun(A,bool),F2),F3)
       => filterlim(A,real,aTP_Lamp_zw(fun(A,real),fun(A,real),F2),at_top(real),F3) ) ) ).

% filterlim_inverse_at_top
tff(fact_7312_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => ( eventually(A,aTP_Lamp_abo(fun(A,real),fun(A,bool),F2),F3)
       => filterlim(A,real,aTP_Lamp_zw(fun(A,real),fun(A,real),F2),at_bot(real),F3) ) ) ).

% filterlim_inverse_at_bot
tff(fact_7313_lhopital__at__top__at__top,axiom,
    ! [F2: fun(real,real),A3: real,G: fun(real,real),F8: fun(real,real),G3: fun(real,real)] :
      ( filterlim(real,real,F2,at_top(real),topolo174197925503356063within(real,A3,top_top(set(real))))
     => ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,A3,top_top(set(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,A3,top_top(set(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,A3,top_top(set(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G3),at_top(real),topolo174197925503356063within(real,A3,top_top(set(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),at_top(real),topolo174197925503356063within(real,A3,top_top(set(real)))) ) ) ) ) ) ).

% lhopital_at_top_at_top
tff(fact_7314_lhopital,axiom,
    ! [F2: fun(real,real),X3: real,G: fun(real,real),G3: fun(real,real),F8: fun(real,real),F3: filter(real)] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X3,top_top(set(real))))
       => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G),topolo174197925503356063within(real,X3,top_top(set(real))))
         => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),topolo174197925503356063within(real,X3,top_top(set(real))))
           => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,X3,top_top(set(real))))
             => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,X3,top_top(set(real))))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),F3,topolo174197925503356063within(real,X3,top_top(set(real))))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),F3,topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ) ) ) ) ) ).

% lhopital
tff(fact_7315_lhopital__right__at__top__at__top,axiom,
    ! [F2: fun(real,real),A3: real,G: fun(real,real),F8: fun(real,real),G3: fun(real,real)] :
      ( filterlim(real,real,F2,at_top(real),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
     => ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G3),at_top(real),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),at_top(real),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3))) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
tff(fact_7316_lhopital__at__top__at__bot,axiom,
    ! [F2: fun(real,real),A3: real,G: fun(real,real),F8: fun(real,real),G3: fun(real,real)] :
      ( filterlim(real,real,F2,at_top(real),topolo174197925503356063within(real,A3,top_top(set(real))))
     => ( filterlim(real,real,G,at_bot(real),topolo174197925503356063within(real,A3,top_top(set(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,A3,top_top(set(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,A3,top_top(set(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G3),at_bot(real),topolo174197925503356063within(real,A3,top_top(set(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),at_bot(real),topolo174197925503356063within(real,A3,top_top(set(real)))) ) ) ) ) ) ).

% lhopital_at_top_at_bot
tff(fact_7317_lhopital__left__at__top__at__top,axiom,
    ! [F2: fun(real,real),A3: real,G: fun(real,real),F8: fun(real,real),G3: fun(real,real)] :
      ( filterlim(real,real,F2,at_top(real),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
     => ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G3),at_top(real),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),at_top(real),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3))) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
tff(fact_7318_lhospital__at__top__at__top,axiom,
    ! [G: fun(real,real),G3: fun(real,real),F2: fun(real,real),F8: fun(real,real),X3: real] :
      ( filterlim(real,real,G,at_top(real),at_top(real))
     => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),at_top(real))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),at_top(real))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),at_top(real))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),topolo7230453075368039082e_nhds(real,X3),at_top(real))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,X3),at_top(real)) ) ) ) ) ) ).

% lhospital_at_top_at_top
tff(fact_7319_lhopital__at__top,axiom,
    ! [G: fun(real,real),X3: real,G3: fun(real,real),F2: fun(real,real),F8: fun(real,real),Y4: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),topolo174197925503356063within(real,X3,top_top(set(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,X3,top_top(set(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,X3,top_top(set(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),topolo7230453075368039082e_nhds(real,Y4),topolo174197925503356063within(real,X3,top_top(set(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,Y4),topolo174197925503356063within(real,X3,top_top(set(real)))) ) ) ) ) ) ).

% lhopital_at_top
tff(fact_7320_lhopital__right__0,axiom,
    ! [F0: fun(real,real),G0: fun(real,real),G3: fun(real,real),F8: fun(real,real),F3: filter(real)] :
      ( filterlim(real,real,F0,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
     => ( filterlim(real,real,G0,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
       => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G0),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
         => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
           => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F0),F8),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
             => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G0),G3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F0),G0),F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ) ) ) ) ) ) ).

% lhopital_right_0
tff(fact_7321_lhopital__right,axiom,
    ! [F2: fun(real,real),X3: real,G: fun(real,real),G3: fun(real,real),F8: fun(real,real),F3: filter(real)] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
       => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
         => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
           => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
             => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),F3,topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3)))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),F3,topolo174197925503356063within(real,X3,set_ord_greaterThan(real,X3))) ) ) ) ) ) ) ) ).

% lhopital_right
tff(fact_7322_lhopital__left,axiom,
    ! [F2: fun(real,real),X3: real,G: fun(real,real),G3: fun(real,real),F8: fun(real,real),F3: filter(real)] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
       => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
         => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
           => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
             => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),F3,topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3)))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),F3,topolo174197925503356063within(real,X3,set_ord_lessThan(real,X3))) ) ) ) ) ) ) ) ).

% lhopital_left
tff(fact_7323_lhopital__right__at__top__at__bot,axiom,
    ! [F2: fun(real,real),A3: real,G: fun(real,real),F8: fun(real,real),G3: fun(real,real)] :
      ( filterlim(real,real,F2,at_top(real),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
     => ( filterlim(real,real,G,at_bot(real),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G3),at_bot(real),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),at_bot(real),topolo174197925503356063within(real,A3,set_ord_greaterThan(real,A3))) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
tff(fact_7324_lhopital__left__at__top__at__bot,axiom,
    ! [F2: fun(real,real),A3: real,G: fun(real,real),F8: fun(real,real),G3: fun(real,real)] :
      ( filterlim(real,real,F2,at_top(real),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
     => ( filterlim(real,real,G,at_bot(real),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G3),at_bot(real),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),at_bot(real),topolo174197925503356063within(real,A3,set_ord_lessThan(real,A3))) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
tff(fact_7325_lhopital__right__0__at__top,axiom,
    ! [G: fun(real,real),G3: fun(real,real),F2: fun(real,real),F8: fun(real,real),X3: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
     => ( eventually(real,aTP_Lamp_aad(fun(real,real),fun(real,bool),G3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),F2),F8),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),G),G3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F8),topolo7230453075368039082e_nhds(real,X3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,X3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ) ) ) ) ).

% lhopital_right_0_at_top
tff(fact_7326_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [C2: fun(nat,A),K: nat,N: nat,B3: real] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),K))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
             => eventually(A,aa(real,fun(A,bool),aa(nat,fun(real,fun(A,bool)),aTP_Lamp_abq(fun(nat,A),fun(nat,fun(real,fun(A,bool))),C2),N),B3),at_infinity(A)) ) ) ) ) ).

% polyfun_extremal
tff(fact_7327_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( bfun(A,B,F2,F3)
        <=> ? [Y: B,K6: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K6))
              & eventually(A,aa(real,fun(A,bool),aa(B,fun(real,fun(A,bool)),aTP_Lamp_abr(fun(A,B),fun(B,fun(real,fun(A,bool))),F2),Y),K6),F3) ) ) ) ).

% Bfun_metric_def
tff(fact_7328_eventually__sequentially__seg,axiom,
    ! [P: fun(nat,bool),K: nat] :
      ( eventually(nat,aa(nat,fun(nat,bool),aTP_Lamp_abs(fun(nat,bool),fun(nat,fun(nat,bool)),P),K),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_seg
tff(fact_7329_sequentially__offset,axiom,
    ! [P: fun(nat,bool),K: nat] :
      ( eventually(nat,P,at_top(nat))
     => eventually(nat,aa(nat,fun(nat,bool),aTP_Lamp_abs(fun(nat,bool),fun(nat,fun(nat,bool)),P),K),at_top(nat)) ) ).

% sequentially_offset
tff(fact_7330_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(nat,A),G: fun(nat,B)] :
          ( eventually(nat,aa(fun(nat,B),fun(nat,bool),aTP_Lamp_abt(fun(nat,A),fun(fun(nat,B),fun(nat,bool)),F2),G),at_top(nat))
         => ( bfun(nat,B,G,at_top(nat))
           => bfun(nat,A,F2,at_top(nat)) ) ) ) ).

% Bseq_eventually_mono
tff(fact_7331_eventually__sequentially,axiom,
    ! [P: fun(nat,bool)] :
      ( eventually(nat,P,at_top(nat))
    <=> ? [N6: nat] :
        ! [N3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N6),N3))
         => pp(aa(nat,bool,P,N3)) ) ) ).

% eventually_sequentially
tff(fact_7332_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: fun(nat,bool)] :
      ( ! [X2: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),C2),X2))
         => pp(aa(nat,bool,P,X2)) )
     => eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentiallyI
tff(fact_7333_le__sequentially,axiom,
    ! [F3: filter(nat)] :
      ( pp(aa(filter(nat),bool,aa(filter(nat),fun(filter(nat),bool),ord_less_eq(filter(nat)),F3),at_top(nat)))
    <=> ! [N6: nat] : eventually(nat,aa(nat,fun(nat,bool),ord_less_eq(nat),N6),F3) ) ).

% le_sequentially
tff(fact_7334_at__bot__le__at__infinity,axiom,
    pp(aa(filter(real),bool,aa(filter(real),fun(filter(real),bool),ord_less_eq(filter(real)),at_bot(real)),at_infinity(real))) ).

% at_bot_le_at_infinity
tff(fact_7335_at__top__le__at__infinity,axiom,
    pp(aa(filter(real),bool,aa(filter(real),fun(filter(real),bool),ord_less_eq(filter(real)),at_top(real)),at_infinity(real))) ).

% at_top_le_at_infinity
tff(fact_7336_Bseq__add,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( bfun(nat,A,F2,at_top(nat))
         => bfun(nat,A,aa(A,fun(nat,A),aTP_Lamp_abu(fun(nat,A),fun(A,fun(nat,A)),F2),C2),at_top(nat)) ) ) ).

% Bseq_add
tff(fact_7337_Bseq__offset,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),K: nat] :
          ( bfun(nat,A,aa(nat,fun(nat,A),aTP_Lamp_abv(fun(nat,A),fun(nat,fun(nat,A)),X7),K),at_top(nat))
         => bfun(nat,A,X7,at_top(nat)) ) ) ).

% Bseq_offset
tff(fact_7338_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( bfun(nat,A,aa(A,fun(nat,A),aTP_Lamp_abu(fun(nat,A),fun(A,fun(nat,A)),F2),C2),at_top(nat))
        <=> bfun(nat,A,F2,at_top(nat)) ) ) ).

% Bseq_add_iff
tff(fact_7339_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),K: nat] :
          ( bfun(nat,A,X7,at_top(nat))
         => bfun(nat,A,aa(nat,fun(nat,A),aTP_Lamp_abv(fun(nat,A),fun(nat,fun(nat,A)),X7),K),at_top(nat)) ) ) ).

% Bseq_ignore_initial_segment
tff(fact_7340_Bseq__mult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),G: fun(nat,A)] :
          ( bfun(nat,A,F2,at_top(nat))
         => ( bfun(nat,A,G,at_top(nat))
           => bfun(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_abw(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G),at_top(nat)) ) ) ) ).

% Bseq_mult
tff(fact_7341_BseqI_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),K5: real] :
          ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N2))),K5))
         => bfun(nat,A,X7,at_top(nat)) ) ) ).

% BseqI'
tff(fact_7342_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [X3: A] :
          ~ ! [A7: fun(nat,set(A))] :
              ( ! [I4: nat] : topolo1002775350975398744n_open(A,aa(nat,set(A),A7,I4))
             => ( ! [I4: nat] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(nat,set(A),A7,I4)))
               => ~ ! [S9: set(A)] :
                      ( topolo1002775350975398744n_open(A,S9)
                     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),S9))
                       => eventually(nat,aa(set(A),fun(nat,bool),aTP_Lamp_abx(fun(nat,set(A)),fun(set(A),fun(nat,bool)),A7),S9),at_top(nat)) ) ) ) ) ) ).

% countable_basis_at_decseq
tff(fact_7343_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( bfun(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(A,fun(fun(nat,A),fun(nat,A)),C2),F2),at_top(nat))
          <=> bfun(nat,A,F2,at_top(nat)) ) ) ) ).

% Bseq_cmult_iff
tff(fact_7344_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P: fun(A,bool)] :
          ( eventually(A,P,at_infinity(A))
        <=> ? [B7: real] :
            ! [X4: A] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),B7),real_V7770717601297561774m_norm(A,X4)))
             => pp(aa(A,bool,P,X4)) ) ) ) ).

% eventually_at_infinity
tff(fact_7345_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),C2: B,F3: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,C2),F3)
         => ( filterlim(A,B,G,at_infinity(B),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aby(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),at_infinity(B),F3) ) ) ) ).

% tendsto_add_filterlim_at_infinity
tff(fact_7346_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B),C2: B] :
          ( filterlim(A,B,F2,at_infinity(B),F3)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,C2),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aby(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),at_infinity(B),F3) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
tff(fact_7347_Bseq__eq__bounded,axiom,
    ! [F2: fun(nat,real),A3: real,B2: real] :
      ( pp(aa(set(real),bool,aa(set(real),fun(set(real),bool),ord_less_eq(set(real)),aa(set(nat),set(real),image(nat,real,F2),top_top(set(nat)))),set_or1337092689740270186AtMost(real,A3,B2)))
     => bfun(nat,real,F2,at_top(nat)) ) ).

% Bseq_eq_bounded
tff(fact_7348_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => filterlim(A,A,inverse_inverse(A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_infinity(A)) ) ).

% tendsto_inverse_0
tff(fact_7349_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,bool),aTP_Lamp_abz(fun(nat,A),fun(fun(nat,real),fun(nat,bool)),F2),G),at_top(nat))
         => ( summable(real,G)
           => summable(A,F2) ) ) ) ).

% summable_comparison_test_ev
tff(fact_7350_BseqD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
         => ? [K9: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K9))
              & ! [N7: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N7))),K9)) ) ) ) ).

% BseqD
tff(fact_7351_BseqE,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
         => ~ ! [K9: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K9))
               => ~ ! [N7: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N7))),K9)) ) ) ) ).

% BseqE
tff(fact_7352_BseqI,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [K5: real,X7: fun(nat,A)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K5))
         => ( ! [N2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N2))),K5))
           => bfun(nat,A,X7,at_top(nat)) ) ) ) ).

% BseqI
tff(fact_7353_Bseq__def,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K6: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K6))
              & ! [N3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N3))),K6)) ) ) ) ).

% Bseq_def
tff(fact_7354_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [N6: nat] :
            ! [N3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N3))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N6)))) ) ) ).

% Bseq_iff1a
tff(fact_7355_Bseq__realpow,axiom,
    ! [X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),one_one(real)))
       => bfun(nat,real,power_power(real,X3),at_top(nat)) ) ) ).

% Bseq_realpow
tff(fact_7356_Bseq__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [N6: nat] :
            ! [N3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N3))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N6)))) ) ) ).

% Bseq_iff
tff(fact_7357_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(B,A),C2: A,F3: filter(B),G: fun(B,A)] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,C2),F3)
         => ( ( C2 != zero_zero(A) )
           => ( filterlim(B,A,G,at_infinity(A),F3)
             => filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_aca(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),at_infinity(A),F3) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
tff(fact_7358_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(C,A),C2: A,F3: filter(C),G: fun(C,A)] :
          ( filterlim(C,A,F2,topolo7230453075368039082e_nhds(A,C2),F3)
         => ( filterlim(C,A,G,at_infinity(A),F3)
           => filterlim(C,A,aa(fun(C,A),fun(C,A),aTP_Lamp_acb(fun(C,A),fun(fun(C,A),fun(C,A)),F2),G),topolo7230453075368039082e_nhds(A,zero_zero(A)),F3) ) ) ) ).

% tendsto_divide_0
tff(fact_7359_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F2: fun(A,B),F3: filter(A),N: nat] :
          ( filterlim(A,B,F2,at_infinity(B),F3)
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_acc(fun(A,B),fun(nat,fun(A,B)),F2),N),at_infinity(B),F3) ) ) ) ).

% filterlim_power_at_infinity
tff(fact_7360_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => filterlim(A,A,inverse_inverse(A),at_infinity(A),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ).

% filterlim_inverse_at_infinity
tff(fact_7361_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P2: fun(A,bool)] :
          ( eventually(A,P2,at_infinity(A))
        <=> ? [B7: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B7))
              & ! [X4: A] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),B7),real_V7770717601297561774m_norm(A,X4)))
                 => pp(aa(A,bool,P2,X4)) ) ) ) ) ).

% eventually_at_infinity_pos
tff(fact_7362_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),K5: real,F3: filter(A)] :
          ( eventually(A,aa(real,fun(A,bool),aTP_Lamp_acd(fun(A,B),fun(real,fun(A,bool)),F2),K5),F3)
         => bfun(A,B,F2,F3) ) ) ).

% BfunI
tff(fact_7363_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,at_infinity(real),F3)
     => ( eventually(A,aTP_Lamp_abm(fun(A,real),fun(A,bool),F2),F3)
       => filterlim(A,real,F2,at_top(real),F3) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
tff(fact_7364_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,at_infinity(real),F3)
     => ( eventually(A,aTP_Lamp_abo(fun(A,real),fun(A,bool),F2),F3)
       => filterlim(A,real,F2,at_bot(real),F3) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
tff(fact_7365_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [G: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,aTP_Lamp_ace(fun(A,B),fun(A,B),G),topolo174197925503356063within(B,zero_zero(B),top_top(set(B))),F3)
        <=> filterlim(A,B,G,at_infinity(B),F3) ) ) ).

% filterlim_inverse_at_iff
tff(fact_7366_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K3))
              & ? [X4: A] :
                ! [N3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,X7,N3)),aa(A,A,uminus_uminus(A),X4)))),K3)) ) ) ) ).

% Bseq_iff2
tff(fact_7367_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K3))
              & ? [N6: nat] :
                ! [N3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,X7,N3)),aa(A,A,uminus_uminus(A),aa(nat,A,X7,N6))))),K3)) ) ) ) ).

% Bseq_iff3
tff(fact_7368_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),C2: A,F3: filter(A),G: fun(A,A)] :
          ( filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,C2),F3)
         => ( filterlim(A,A,G,topolo174197925503356063within(A,zero_zero(A),top_top(set(A))),F3)
           => ( ( C2 != zero_zero(A) )
             => filterlim(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_ra(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),at_infinity(A),F3) ) ) ) ) ).

% filterlim_divide_at_infinity
tff(fact_7369_filterlim__at__infinity,axiom,
    ! [A: $tType,C: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [C2: real,F2: fun(C,A),F3: filter(C)] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),C2))
         => ( filterlim(C,A,F2,at_infinity(A),F3)
          <=> ! [R5: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C2),R5))
               => eventually(C,aa(real,fun(C,bool),aTP_Lamp_acf(fun(C,A),fun(real,fun(C,bool)),F2),R5),F3) ) ) ) ) ).

% filterlim_at_infinity
tff(fact_7370_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(B,A),A3: A,F3: filter(B)] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( ( A3 != zero_zero(A) )
           => bfun(B,A,aTP_Lamp_vr(fun(B,A),fun(B,A),F2),F3) ) ) ) ).

% Bfun_inverse
tff(fact_7371_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X3: A] :
          ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),real_V7770717601297561774m_norm(A,X3)))
         => filterlim(nat,A,power_power(A,X3),at_infinity(A),at_top(nat)) ) ) ).

% filterlim_realpow_sequentially_gt1
tff(fact_7372_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),L: A] :
          ( filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,L),at_infinity(A))
        <=> filterlim(A,A,aa(fun(A,A),fun(A,A),comp(A,A,A,F2),inverse_inverse(A)),topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% lim_at_infinity_0
tff(fact_7373_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),L: A] :
          ( filterlim(A,A,aTP_Lamp_acg(fun(A,A),fun(A,A),F2),topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
         => filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,L),at_infinity(A)) ) ) ).

% lim_zero_infinity
tff(fact_7374_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( bfun(A,B,F2,F3)
         => ~ ! [B8: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),B8))
               => ~ eventually(A,aa(real,fun(A,bool),aTP_Lamp_acd(fun(A,B),fun(real,fun(A,bool)),F2),B8),F3) ) ) ) ).

% BfunE
tff(fact_7375_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( bfun(A,B,F2,F3)
        <=> ? [K6: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),K6))
              & eventually(A,aa(real,fun(A,bool),aTP_Lamp_acd(fun(A,B),fun(real,fun(A,bool)),F2),K6),F3) ) ) ) ).

% Bfun_def
tff(fact_7376_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( real_V8037385150606011577_space(A)
        & real_V822414075346904944vector(A) )
     => ! [F2: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,bool),aTP_Lamp_ach(fun(nat,A),fun(fun(nat,real),fun(nat,bool)),F2),G),at_top(nat))
         => ( filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => summable(A,F2) ) ) ) ).

% summable_bounded_partials
tff(fact_7377_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,bool),aTP_Lamp_aci(fun(nat,A),fun(fun(nat,real),fun(nat,bool)),F2),G),at_top(nat))
         => ( filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => summable(A,F2) ) ) ) ).

% summable_Cauchy'
tff(fact_7378_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool)] :
          ( eventually(A,P,at_top(A))
         => eventually(A,aTP_Lamp_acj(fun(A,bool),fun(A,bool),P),at_top(A)) ) ) ).

% eventually_all_ge_at_top
tff(fact_7379_Greatest__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool)] : ( order_Greatest(A,P) = the(A,aTP_Lamp_ack(fun(A,bool),fun(A,bool),P)) ) ) ).

% Greatest_def
tff(fact_7380_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [A3: A,B2: A,P: fun(A,bool)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( ! [F4: fun(nat,A)] :
                ( ! [N7: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(nat,A,F4,N7)))
               => ( ! [N7: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,F4,N7)),B2))
                 => ( order_antimono(nat,A,F4)
                   => ( filterlim(nat,A,F4,topolo7230453075368039082e_nhds(A,A3),at_top(nat))
                     => eventually(nat,aa(fun(nat,A),fun(nat,bool),aTP_Lamp_acl(fun(A,bool),fun(fun(nat,A),fun(nat,bool)),P),F4),at_top(nat)) ) ) ) )
           => eventually(A,P,topolo174197925503356063within(A,A3,set_ord_greaterThan(A,A3))) ) ) ) ).

% sequentially_imp_eventually_at_right
tff(fact_7381_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_antimono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Y4)),aa(A,B,F2,X3))) ) ) ) ).

% antimonoD
tff(fact_7382_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_antimono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Y4)),aa(A,B,F2,X3))) ) ) ) ).

% antimonoE
tff(fact_7383_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Y2)),aa(A,B,F2,X2))) )
         => order_antimono(A,B,F2) ) ) ).

% antimonoI
tff(fact_7384_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( order_antimono(A,B,F2)
        <=> ! [X4: A,Y: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Y))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Y)),aa(A,B,F2,X4))) ) ) ) ).

% antimono_def
tff(fact_7385_decseq__SucD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: fun(nat,A),I: nat] :
          ( order_antimono(nat,A,A2)
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,A2,aa(nat,nat,suc,I))),aa(nat,A,A2,I))) ) ) ).

% decseq_SucD
tff(fact_7386_decseq__SucI,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N2))),aa(nat,A,X7,N2)))
         => order_antimono(nat,A,X7) ) ) ).

% decseq_SucI
tff(fact_7387_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A)] :
          ( order_antimono(nat,A,F2)
        <=> ! [N3: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,aa(nat,nat,suc,N3))),aa(nat,A,F2,N3))) ) ) ).

% decseq_Suc_iff
tff(fact_7388_decseq__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( order_antimono(nat,A,X7)
        <=> ! [M6: nat,N3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M6),N3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N3)),aa(nat,A,X7,M6))) ) ) ) ).

% decseq_def
tff(fact_7389_decseqD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),I: nat,J3: nat] :
          ( order_antimono(nat,A,F2)
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,J3)),aa(nat,A,F2,I))) ) ) ) ).

% decseqD
tff(fact_7390_GreatestI__ex__nat,axiom,
    ! [P: fun(nat,bool),B2: nat] :
      ( ? [X_1: nat] : pp(aa(nat,bool,P,X_1))
     => ( ! [Y2: nat] :
            ( pp(aa(nat,bool,P,Y2))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y2),B2)) )
       => pp(aa(nat,bool,P,order_Greatest(nat,P))) ) ) ).

% GreatestI_ex_nat
tff(fact_7391_Greatest__le__nat,axiom,
    ! [P: fun(nat,bool),K: nat,B2: nat] :
      ( pp(aa(nat,bool,P,K))
     => ( ! [Y2: nat] :
            ( pp(aa(nat,bool,P,Y2))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y2),B2)) )
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),order_Greatest(nat,P))) ) ) ).

% Greatest_le_nat
tff(fact_7392_GreatestI__nat,axiom,
    ! [P: fun(nat,bool),K: nat,B2: nat] :
      ( pp(aa(nat,bool,P,K))
     => ( ! [Y2: nat] :
            ( pp(aa(nat,bool,P,Y2))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Y2),B2)) )
       => pp(aa(nat,bool,P,order_Greatest(nat,P))) ) ) ).

% GreatestI_nat
tff(fact_7393_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X3: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,X3))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X3)) )
           => ( ! [X2: A] :
                  ( pp(aa(A,bool,P,X2))
                 => ( ! [Y5: A] :
                        ( pp(aa(A,bool,P,Y5))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y5),X2)) )
                   => pp(aa(A,bool,Q,X2)) ) )
             => pp(aa(A,bool,Q,order_Greatest(A,P))) ) ) ) ) ).

% GreatestI2_order
tff(fact_7394_Greatest__equality,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X3: A] :
          ( pp(aa(A,bool,P,X3))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X3)) )
           => ( order_Greatest(A,P) = X3 ) ) ) ) ).

% Greatest_equality
tff(fact_7395_decseq__bounded,axiom,
    ! [X7: fun(nat,real),B3: real] :
      ( order_antimono(nat,real,X7)
     => ( ! [I3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),B3),aa(nat,real,X7,I3)))
       => bfun(nat,real,X7,at_top(nat)) ) ) ).

% decseq_bounded
tff(fact_7396_decseq__ge,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X7: fun(nat,A),L5: A,N: nat] :
          ( order_antimono(nat,A,X7)
         => ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L5),aa(nat,A,X7,N))) ) ) ) ).

% decseq_ge
tff(fact_7397_decseq__convergent,axiom,
    ! [X7: fun(nat,real),B3: real] :
      ( order_antimono(nat,real,X7)
     => ( ! [I3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),B3),aa(nat,real,X7,I3)))
       => ~ ! [L6: real] :
              ( filterlim(nat,real,X7,topolo7230453075368039082e_nhds(real,L6),at_top(nat))
             => ~ ! [I4: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),L6),aa(nat,real,X7,I4))) ) ) ) ).

% decseq_convergent
tff(fact_7398_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( topolo3112930676232923870pology(B)
        & topolo1944317154257567458pology(B)
        & topolo4958980785337419405_space(C) )
     => ! [A3: B,B2: B,X7: fun(B,C),L5: C] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),A3),B2))
         => ( ! [S5: fun(nat,B)] :
                ( ! [N7: nat] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),A3),aa(nat,B,S5,N7)))
               => ( ! [N7: nat] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(nat,B,S5,N7)),B2))
                 => ( order_antimono(nat,B,S5)
                   => ( filterlim(nat,B,S5,topolo7230453075368039082e_nhds(B,A3),at_top(nat))
                     => filterlim(nat,C,aa(fun(nat,B),fun(nat,C),aTP_Lamp_acm(fun(B,C),fun(fun(nat,B),fun(nat,C)),X7),S5),topolo7230453075368039082e_nhds(C,L5),at_top(nat)) ) ) ) )
           => filterlim(B,C,X7,topolo7230453075368039082e_nhds(C,L5),topolo174197925503356063within(B,A3,set_ord_greaterThan(B,A3))) ) ) ) ).

% tendsto_at_right_sequentially
tff(fact_7399_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: fun(B,A),Y3: set(B),X7: set(A),F3: filter(B),F2: fun(A,C)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G),Y3)),X7))
     => ( eventually(B,aTP_Lamp_acn(set(B),fun(B,bool),Y3),F3)
       => ( map_filter_on(A,C,X7,F2,map_filter_on(B,A,Y3,G,F3)) = map_filter_on(B,C,Y3,aa(fun(B,A),fun(B,C),comp(A,C,B,F2),G),F3) ) ) ) ).

% map_filter_on_comp
tff(fact_7400_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist(A)
        & topolo7287701948861334536_space(A) )
     => ! [F3: filter(A)] :
          ( topolo6773858410816713723filter(A,F3)
        <=> ! [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
             => ? [P6: fun(A,bool)] :
                  ( eventually(A,P6,F3)
                  & ! [X4: A,Y: A] :
                      ( ( pp(aa(A,bool,P6,X4))
                        & pp(aa(A,bool,P6,Y)) )
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X4,Y)),E3)) ) ) ) ) ) ).

% cauchy_filter_metric
tff(fact_7401_nhds__imp__cauchy__filter,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [F3: filter(A),X3: A] :
          ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F3),topolo7230453075368039082e_nhds(A,X3)))
         => topolo6773858410816713723filter(A,F3) ) ) ).

% nhds_imp_cauchy_filter
tff(fact_7402_GMVT,axiom,
    ! [A3: real,B2: real,F2: fun(real,real),G: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ! [X2: real] :
            ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2)) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),F2) )
       => ( ! [X2: real] :
              ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2)) )
             => differentiable(real,real,F2,topolo174197925503356063within(real,X2,top_top(set(real)))) )
         => ( ! [X2: real] :
                ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X2))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X2),B2)) )
               => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),G) )
           => ( ! [X2: real] :
                  ( ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
                    & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2)) )
                 => differentiable(real,real,G,topolo174197925503356063within(real,X2,top_top(set(real)))) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( has_field_derivative(real,G,G_c,topolo174197925503356063within(real,C3,top_top(set(real))))
                  & has_field_derivative(real,F2,F_c,topolo174197925503356063within(real,C3,top_top(set(real))))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),C3))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),C3),B2))
                  & ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A3))),G_c) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,G,B2)),aa(real,real,G,A3))),F_c) ) ) ) ) ) ) ) ).

% GMVT
tff(fact_7403_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),A2: set(B),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F2),A2)),B3))
     => pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),aa(set(set(B)),set(set(A)),image(set(B),set(A),image(B,A,F2)),finite_Fpow(B,A2))),finite_Fpow(A,B3))) ) ).

% image_Fpow_mono
tff(fact_7404_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(A) )
     => ! [Q2: fun(B,A),C2: A,T2: B] :
          ( differentiable(B,A,aa(A,fun(B,A),aTP_Lamp_aco(fun(B,A),fun(A,fun(B,A)),Q2),C2),topolo174197925503356063within(B,T2,top_top(set(B))))
        <=> ( ( C2 = zero_zero(A) )
            | differentiable(B,A,Q2,topolo174197925503356063within(B,T2,top_top(set(B)))) ) ) ) ).

% differentiable_cmult_right_iff
tff(fact_7405_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(A) )
     => ! [C2: A,Q2: fun(B,A),T2: B] :
          ( differentiable(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_acp(A,fun(fun(B,A),fun(B,A)),C2),Q2),topolo174197925503356063within(B,T2,top_top(set(B))))
        <=> ( ( C2 = zero_zero(A) )
            | differentiable(B,A,Q2,topolo174197925503356063within(B,T2,top_top(set(B)))) ) ) ) ).

% differentiable_cmult_left_iff
tff(fact_7406_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),X3: A,S: set(A),T2: set(A)] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X3,S))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T2),S))
           => differentiable(A,B,F2,topolo174197925503356063within(A,X3,T2)) ) ) ) ).

% differentiable_within_subset
tff(fact_7407_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B)] :
          ( differentiable(A,B,F2,F3)
         => ( differentiable(A,B,G,F3)
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sv(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),F3) ) ) ) ).

% differentiable_add
tff(fact_7408_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),X3: A,S: set(A),N: nat] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X3,S))
         => differentiable(A,B,aa(nat,fun(A,B),aTP_Lamp_tr(fun(A,B),fun(nat,fun(A,B)),F2),N),topolo174197925503356063within(A,X3,S)) ) ) ).

% differentiable_power
tff(fact_7409_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [F2: fun(A,B),X3: A,S: set(A),G: fun(A,B)] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X3,S))
         => ( differentiable(A,B,G,topolo174197925503356063within(A,X3,S))
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acq(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% differentiable_mult
tff(fact_7410_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),X3: A,S: set(A),G: fun(A,B)] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X3,S))
         => ( differentiable(A,B,G,topolo174197925503356063within(A,X3,S))
           => ( ( aa(A,B,G,X3) != zero_zero(B) )
             => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acr(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo174197925503356063within(A,X3,S)) ) ) ) ) ).

% differentiable_divide
tff(fact_7411_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),X3: A,S: set(A)] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X3,S))
         => ( ( aa(A,B,F2,X3) != zero_zero(B) )
           => differentiable(A,B,aTP_Lamp_acs(fun(A,B),fun(A,B),F2),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% differentiable_inverse
tff(fact_7412_Fpow__mono,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),finite_Fpow(A,A2)),finite_Fpow(A,B3))) ) ).

% Fpow_mono
tff(fact_7413_Fpow__subset__Pow,axiom,
    ! [A: $tType,A2: set(A)] : pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),finite_Fpow(A,A2)),pow2(A,A2))) ).

% Fpow_subset_Pow
tff(fact_7414_Fpow__def,axiom,
    ! [A: $tType,A2: set(A)] : ( finite_Fpow(A,A2) = collect(set(A),aTP_Lamp_act(set(A),fun(set(A),bool),A2)) ) ).

% Fpow_def
tff(fact_7415_MVT,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
       => ( ! [X2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2))
               => differentiable(real,real,F2,topolo174197925503356063within(real,X2,top_top(set(real)))) ) )
         => ? [L2: real,Z4: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Z4))
              & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Z4),B2))
              & has_field_derivative(real,F2,L2,topolo174197925503356063within(real,Z4,top_top(set(real))))
              & ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)),L2) ) ) ) ) ) ).

% MVT
tff(fact_7416_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),C6: set(B),F2: fun(B,set(A))] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( ! [T7: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),T7),C6))
               => topolo1002775350975398744n_open(A,aa(B,set(A),F2,T7)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F2),C6))))
             => ~ ! [C8: set(B)] :
                    ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C8),C6))
                   => ( finite_finite(B,C8)
                     => ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F2),C8)))) ) ) ) ) ) ) ).

% compactE_image
tff(fact_7417_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( topolo4958980785337419405_space(C)
     => ! [S: set(C),F2: fun(C,real),G: fun(C,real)] :
          ( topolo81223032696312382ous_on(C,real,S,F2)
         => ( topolo81223032696312382ous_on(C,real,S,G)
           => ( ! [X2: C] :
                  ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X2),S))
                 => ( aa(C,real,F2,X2) != zero_zero(real) ) )
             => topolo81223032696312382ous_on(C,real,S,aa(fun(C,real),fun(C,real),aTP_Lamp_acu(fun(C,real),fun(fun(C,real),fun(C,real)),F2),G)) ) ) ) ) ).

% continuous_on_powr
tff(fact_7418_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
               => ( aa(A,real,F2,X2) != zero_zero(real) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_acv(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_on_ln
tff(fact_7419_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [S: set(A),F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
               => ( aa(A,B,F2,X2) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_acw(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_on_sgn
tff(fact_7420_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [S: set(A),F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
               => ( aa(A,B,F2,X2) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_acx(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_on_inverse
tff(fact_7421_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => ( ! [X2: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
                 => ( aa(A,B,G,X2) != zero_zero(B) ) )
             => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_acy(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ) ).

% continuous_on_divide
tff(fact_7422_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( topolo4958980785337419405_space(D)
        & real_V4412858255891104859lgebra(A) )
     => ! [S: set(D),F2: fun(D,A),G: fun(D,A)] :
          ( topolo81223032696312382ous_on(D,A,S,F2)
         => ( topolo81223032696312382ous_on(D,A,S,G)
           => topolo81223032696312382ous_on(D,A,S,aa(fun(D,A),fun(D,A),aTP_Lamp_acz(fun(D,A),fun(fun(D,A),fun(D,A)),F2),G)) ) ) ) ).

% continuous_on_mult
tff(fact_7423_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo4958980785337419405_space(D)
        & topolo4211221413907600880p_mult(B) )
     => ! [A2: set(D),F2: fun(D,B),G: fun(D,B)] :
          ( topolo81223032696312382ous_on(D,B,A2,F2)
         => ( topolo81223032696312382ous_on(D,B,A2,G)
           => topolo81223032696312382ous_on(D,B,A2,aa(fun(D,B),fun(D,B),aTP_Lamp_ada(fun(D,B),fun(fun(D,B),fun(D,B)),F2),G)) ) ) ) ).

% continuous_on_mult'
tff(fact_7424_continuous__on__mult__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & topolo4958980785337419405_space(B) )
     => ! [S: set(B),F2: fun(B,A),C2: A] :
          ( topolo81223032696312382ous_on(B,A,S,F2)
         => topolo81223032696312382ous_on(B,A,S,aa(A,fun(B,A),aTP_Lamp_adb(fun(B,A),fun(A,fun(B,A)),F2),C2)) ) ) ).

% continuous_on_mult_left
tff(fact_7425_continuous__on__mult__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & topolo4958980785337419405_space(B) )
     => ! [S: set(B),F2: fun(B,A),C2: A] :
          ( topolo81223032696312382ous_on(B,A,S,F2)
         => topolo81223032696312382ous_on(B,A,S,aa(A,fun(B,A),aTP_Lamp_adc(fun(B,A),fun(A,fun(B,A)),F2),C2)) ) ) ).

% continuous_on_mult_right
tff(fact_7426_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [S: set(A),C2: A] : topolo81223032696312382ous_on(A,A,S,aa(A,fun(A,A),times_times(A),C2)) ) ).

% continuous_on_mult_const
tff(fact_7427_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_add(fun(A,real),fun(A,real),F2)) ) ) ).

% continuous_on_real_sqrt
tff(fact_7428_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo1898628316856586783d_mult(B) )
     => ! [A2: set(C),F2: fun(C,B),G: fun(C,nat)] :
          ( topolo81223032696312382ous_on(C,B,A2,F2)
         => ( topolo81223032696312382ous_on(C,nat,A2,G)
           => topolo81223032696312382ous_on(C,B,A2,aa(fun(C,nat),fun(C,B),aTP_Lamp_ade(fun(C,B),fun(fun(C,nat),fun(C,B)),F2),G)) ) ) ) ).

% continuous_on_power'
tff(fact_7429_continuous__on__power,axiom,
    ! [C: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(C) )
     => ! [S: set(C),F2: fun(C,B),N: nat] :
          ( topolo81223032696312382ous_on(C,B,S,F2)
         => topolo81223032696312382ous_on(C,B,S,aa(nat,fun(C,B),aTP_Lamp_adf(fun(C,B),fun(nat,fun(C,B)),F2),N)) ) ) ).

% continuous_on_power
tff(fact_7430_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo4958980785337419405_space(D)
        & topolo6943815403480290642id_add(B) )
     => ! [S: set(D),F2: fun(D,B),G: fun(D,B)] :
          ( topolo81223032696312382ous_on(D,B,S,F2)
         => ( topolo81223032696312382ous_on(D,B,S,G)
           => topolo81223032696312382ous_on(D,B,S,aa(fun(D,B),fun(D,B),aTP_Lamp_adg(fun(D,B),fun(fun(D,B),fun(D,B)),F2),G)) ) ) ) ).

% continuous_on_add
tff(fact_7431_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real),N: nat] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => topolo81223032696312382ous_on(A,real,S,aa(nat,fun(A,real),aTP_Lamp_adh(fun(A,real),fun(nat,fun(A,real)),F2),N)) ) ) ).

% continuous_on_real_root
tff(fact_7432_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & dense_order(B)
        & topolo1944317154257567458pology(B) )
     => ! [F2: fun(A,B),A2: set(A)] :
          ( topolo1002775350975398744n_open(B,aa(set(A),set(B),image(A,B,F2),A2))
         => ( ! [X2: A,Y2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
               => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y2),A2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                   => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2))) ) ) )
           => topolo81223032696312382ous_on(A,B,A2,F2) ) ) ) ).

% continuous_onI_mono
tff(fact_7433_continuous__on__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [T2: set(A),G: fun(A,B),S: set(C),F2: fun(C,A)] :
          ( topolo81223032696312382ous_on(A,B,T2,G)
         => ( topolo81223032696312382ous_on(C,A,S,F2)
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,F2),S)),T2))
             => topolo81223032696312382ous_on(C,B,S,aa(fun(C,A),fun(C,B),aTP_Lamp_adi(fun(A,B),fun(fun(C,A),fun(C,B)),G),F2)) ) ) ) ) ).

% continuous_on_compose2
tff(fact_7434_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S: set(A),F2: fun(A,B),T2: set(A)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T2),S))
           => topolo81223032696312382ous_on(A,B,T2,F2) ) ) ) ).

% continuous_on_subset
tff(fact_7435_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology(B)
        & topolo8458572112393995274pology(A) )
     => ! [F2: fun(A,B),A3: A,Y4: B,B2: A] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,A3)),Y4))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Y4),aa(A,B,F2,B2)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
             => ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A3,B2),F2)
               => ? [X2: A] :
                    ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B2))
                    & ( aa(A,B,F2,X2) = Y4 ) ) ) ) ) ) ) ).

% IVT'
tff(fact_7436_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology(B)
        & topolo8458572112393995274pology(A) )
     => ! [F2: fun(A,B),B2: A,Y4: B,A3: A] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,B2)),Y4))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Y4),aa(A,B,F2,A3)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
             => ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A3,B2),F2)
               => ? [X2: A] :
                    ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B2))
                    & ( aa(A,B,F2,X2) = Y4 ) ) ) ) ) ) ) ).

% IVT2'
tff(fact_7437_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A)] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
                & ! [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),S2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Xa2),X2)) ) ) ) ) ) ).

% compact_attains_sup
tff(fact_7438_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A)] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ? [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S2))
                & ! [Xa2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),S2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Xa2)) ) ) ) ) ) ).

% compact_attains_inf
tff(fact_7439_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [S: set(A),F2: fun(A,B)] :
          ( topolo2193935891317330818ompact(A,S)
         => ( ( S != bot_bot(set(A)) )
           => ( topolo81223032696312382ous_on(A,B,S,F2)
             => ? [X2: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
                  & ! [Xa2: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),S))
                     => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Xa2)),aa(A,B,F2,X2))) ) ) ) ) ) ) ).

% continuous_attains_sup
tff(fact_7440_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [S: set(A),F2: fun(A,B)] :
          ( topolo2193935891317330818ompact(A,S)
         => ( ( S != bot_bot(set(A)) )
           => ( topolo81223032696312382ous_on(A,B,S,F2)
             => ? [X2: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
                  & ! [Xa2: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),S))
                     => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Xa2))) ) ) ) ) ) ) ).

% continuous_attains_inf
tff(fact_7441_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,top_top(set(A)),F2)
         => ( topolo81223032696312382ous_on(A,B,top_top(set(A)),G)
           => topolo1002775350975398744n_open(A,collect(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_adj(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),G))) ) ) ) ).

% open_Collect_less
tff(fact_7442_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: set(A),F2: fun(A,A)] :
          ( topolo81223032696312382ous_on(A,A,S,F2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
               => ( cos(A,aa(A,A,F2,X2)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(A,A,S,aTP_Lamp_uy(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_on_tan
tff(fact_7443_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ? [A7: set(A)] :
                ( topolo1002775350975398744n_open(A,A7)
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A7),S) = collect(A,aa(fun(A,real),fun(A,bool),aa(fun(A,real),fun(fun(A,real),fun(A,bool)),aTP_Lamp_adk(set(A),fun(fun(A,real),fun(fun(A,real),fun(A,bool))),S),F2),G)) ) ) ) ) ) ).

% open_Collect_less_Int
tff(fact_7444_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: set(A),F2: fun(A,A)] :
          ( topolo81223032696312382ous_on(A,A,S,F2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
               => ( sin(A,aa(A,A,F2,X2)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(A,A,S,aTP_Lamp_uz(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_on_cot
tff(fact_7445_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A2: set(C),F2: fun(C,A)] :
          ( topolo81223032696312382ous_on(C,A,A2,F2)
         => ( ! [X2: C] :
                ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X2),A2))
               => ( cosh(A,aa(C,A,F2,X2)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(C,A,A2,aTP_Lamp_adl(fun(C,A),fun(C,A),F2)) ) ) ) ).

% continuous_on_tanh
tff(fact_7446_continuous__on__arcosh_H,axiom,
    ! [A2: set(real),F2: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A2,F2)
     => ( ! [X2: real] :
            ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),A2))
           => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(real,real,F2,X2))) )
       => topolo81223032696312382ous_on(real,real,A2,aTP_Lamp_adm(fun(real,real),fun(real,real),F2)) ) ) ).

% continuous_on_arcosh'
tff(fact_7447_continuous__image__closed__interval,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),B2))
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
       => ? [C3: real,D3: real] :
            ( ( aa(set(real),set(real),image(real,real,F2),set_or1337092689740270186AtMost(real,A3,B2)) = set_or1337092689740270186AtMost(real,C3,D3) )
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),C3),D3)) ) ) ) ).

% continuous_image_closed_interval
tff(fact_7448_continuous__on__arcosh,axiom,
    ! [A2: set(real)] :
      ( pp(aa(set(real),bool,aa(set(real),fun(set(real),bool),ord_less_eq(set(real)),A2),set_ord_atLeast(real,one_one(real))))
     => topolo81223032696312382ous_on(real,real,A2,arcosh(real)) ) ).

% continuous_on_arcosh
tff(fact_7449_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ? [A7: set(A)] :
              ( topolo1002775350975398744n_open(A,A7)
              & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A7),S) = collect(A,aa(fun(A,real),fun(A,bool),aTP_Lamp_adn(set(A),fun(fun(A,real),fun(A,bool)),S),F2)) ) ) ) ) ).

% open_Collect_positive
tff(fact_7450_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( topolo4958980785337419405_space(C)
     => ! [S: set(C),F2: fun(C,real),G: fun(C,real)] :
          ( topolo81223032696312382ous_on(C,real,S,F2)
         => ( topolo81223032696312382ous_on(C,real,S,G)
           => ( ! [X2: C] :
                  ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X2),S))
                 => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(C,real,F2,X2)))
                    & ( ( aa(C,real,F2,X2) = zero_zero(real) )
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(C,real,G,X2))) ) ) )
             => topolo81223032696312382ous_on(C,real,S,aa(fun(C,real),fun(C,real),aTP_Lamp_acu(fun(C,real),fun(fun(C,real),fun(C,real)),F2),G)) ) ) ) ) ).

% continuous_on_powr'
tff(fact_7451_continuous__on__log,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X2: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,F2,X2))) )
             => ( ! [X2: A] :
                    ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
                   => ( aa(A,real,F2,X2) != one_one(real) ) )
               => ( ! [X2: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
                     => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,G,X2))) )
                 => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_ado(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ) ) ).

% continuous_on_log
tff(fact_7452_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,F2,X2)))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(A,real,F2,X2)),one_one(real))) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_adp(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_on_arccos
tff(fact_7453_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,F2,X2)))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(A,real,F2,X2)),one_one(real))) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_adq(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_on_arcsin
tff(fact_7454_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ord(A)
        & real_V3459762299906320749_field(A) )
     => ! [A3: A,B2: A,F2: fun(A,A)] :
          ( ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B2))
               => ? [Y5: A] : has_field_derivative(A,F2,Y5,topolo174197925503356063within(A,X2,top_top(set(A)))) ) )
         => topolo81223032696312382ous_on(A,A,set_or1337092689740270186AtMost(A,A3,B2),F2) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
tff(fact_7455_Rolle__deriv,axiom,
    ! [A3: real,B2: real,F2: fun(real,real),F8: fun(real,fun(real,real))] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ( aa(real,real,F2,A3) = aa(real,real,F2,B2) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
         => ( ! [X2: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2))
                 => has_derivative(real,real,F2,aa(real,fun(real,real),F8,X2),topolo174197925503356063within(real,X2,top_top(set(real)))) ) )
           => ? [Z4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Z4))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Z4),B2))
                & ! [X: real] : ( aa(real,real,aa(real,fun(real,real),F8,Z4),X) = zero_zero(real) ) ) ) ) ) ) ).

% Rolle_deriv
tff(fact_7456_mvt,axiom,
    ! [A3: real,B2: real,F2: fun(real,real),F8: fun(real,fun(real,real))] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
       => ( ! [X2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2))
               => has_derivative(real,real,F2,aa(real,fun(real,real),F8,X2),topolo174197925503356063within(real,X2,top_top(set(real)))) ) )
         => ~ ! [Xi: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Xi))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Xi),B2))
                 => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A3)) != aa(real,real,aa(real,fun(real,real),F8,Xi),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A3)) ) ) ) ) ) ) ).

% mvt
tff(fact_7457_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A3: A,B2: A,F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A3,B2),F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,B2)),topolo174197925503356063within(A,B2,set_ord_lessThan(A,B2))) ) ) ) ).

% continuous_on_Icc_at_leftD
tff(fact_7458_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A3: A,B2: A,F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A3,B2),F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,A3)),topolo174197925503356063within(A,A3,set_ord_greaterThan(A,A3))) ) ) ) ).

% continuous_on_Icc_at_rightD
tff(fact_7459_DERIV__isconst__end,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
       => ( ! [X2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2))
               => has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,X2,top_top(set(real)))) ) )
         => ( aa(real,real,F2,B2) = aa(real,real,F2,A3) ) ) ) ) ).

% DERIV_isconst_end
tff(fact_7460_DERIV__neg__imp__decreasing__open,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ! [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2))
             => ? [Y5: real] :
                  ( has_field_derivative(real,F2,Y5,topolo174197925503356063within(real,X2,top_top(set(real))))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Y5),zero_zero(real))) ) ) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,B2)),aa(real,real,F2,A3))) ) ) ) ).

% DERIV_neg_imp_decreasing_open
tff(fact_7461_DERIV__pos__imp__increasing__open,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ! [X2: real] :
            ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2))
             => ? [Y5: real] :
                  ( has_field_derivative(real,F2,Y5,topolo174197925503356063within(real,X2,top_top(set(real))))
                  & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),Y5)) ) ) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,F2,A3)),aa(real,real,F2,B2))) ) ) ) ).

% DERIV_pos_imp_increasing_open
tff(fact_7462_continuous__on__artanh,axiom,
    ! [A2: set(real)] :
      ( pp(aa(set(real),bool,aa(set(real),fun(set(real),bool),ord_less_eq(set(real)),A2),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real))))
     => topolo81223032696312382ous_on(real,real,A2,artanh(real)) ) ).

% continuous_on_artanh
tff(fact_7463_DERIV__isconst2,axiom,
    ! [A3: real,B2: real,F2: fun(real,real),X3: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
       => ( ! [X2: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
             => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2))
               => has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,X2,top_top(set(real)))) ) )
         => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),A3),X3))
           => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),B2))
             => ( aa(real,real,F2,X3) = aa(real,real,F2,A3) ) ) ) ) ) ) ).

% DERIV_isconst2
tff(fact_7464_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),A3: A,B2: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,A3)),topolo174197925503356063within(A,A3,set_ord_greaterThan(A,A3)))
         => ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,B2)),topolo174197925503356063within(A,B2,set_ord_lessThan(A,B2)))
           => ( ! [X2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),B2))
                   => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,X2)),topolo174197925503356063within(A,X2,top_top(set(A)))) ) )
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
               => topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A3,B2),F2) ) ) ) ) ) ).

% continuous_on_IccI
tff(fact_7465_Rolle,axiom,
    ! [A3: real,B2: real,F2: fun(real,real)] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),B2))
     => ( ( aa(real,real,F2,A3) = aa(real,real,F2,B2) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A3,B2),F2)
         => ( ! [X2: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),X2))
               => ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),B2))
                 => differentiable(real,real,F2,topolo174197925503356063within(real,X2,top_top(set(real)))) ) )
           => ? [Z4: real] :
                ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),A3),Z4))
                & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Z4),B2))
                & has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,Z4,top_top(set(real)))) ) ) ) ) ) ).

% Rolle
tff(fact_7466_compactE,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),T11: set(set(A))] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),T11)))
           => ( ! [B8: set(A)] :
                  ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),B8),T11))
                 => topolo1002775350975398744n_open(A,B8) )
             => ~ ! [T12: set(set(A))] :
                    ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),T12),T11))
                   => ( finite_finite(set(A),T12)
                     => ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),T12))) ) ) ) ) ) ) ).

% compactE
tff(fact_7467_compactI,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A)] :
          ( ! [C7: set(set(A))] :
              ( ! [X: set(A)] :
                  ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X),C7))
                 => topolo1002775350975398744n_open(A,X) )
             => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C7)))
               => ? [C9: set(set(A))] :
                    ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),C9),C7))
                    & finite_finite(set(A),C9)
                    & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C9))) ) ) )
         => topolo2193935891317330818ompact(A,S) ) ) ).

% compactI
tff(fact_7468_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A)] :
          ( topolo2193935891317330818ompact(A,S2)
        <=> ! [C10: set(set(A))] :
              ( ( ! [X4: set(A)] :
                    ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X4),C10))
                   => topolo1002775350975398744n_open(A,X4) )
                & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C10))) )
             => ? [D8: set(set(A))] :
                  ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),D8),C10))
                  & finite_finite(set(A),D8)
                  & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),D8))) ) ) ) ) ).

% compact_eq_Heine_Borel
tff(fact_7469_the__elem__set,axiom,
    ! [A: $tType,X3: A] : ( the_elem(A,aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X3),nil(A)))) = X3 ) ).

% the_elem_set
tff(fact_7470_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: A,A3: A,P: fun(A,bool)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( ! [F4: fun(nat,A)] :
                ( ! [N7: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(nat,A,F4,N7)))
               => ( ! [N7: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,F4,N7)),A3))
                 => ( order_mono(nat,A,F4)
                   => ( filterlim(nat,A,F4,topolo7230453075368039082e_nhds(A,A3),at_top(nat))
                     => eventually(nat,aa(fun(nat,A),fun(nat,bool),aTP_Lamp_acl(fun(A,bool),fun(fun(nat,A),fun(nat,bool)),P),F4),at_top(nat)) ) ) ) )
           => eventually(A,P,topolo174197925503356063within(A,A3,set_ord_lessThan(A,A3))) ) ) ) ).

% sequentially_imp_eventually_at_left
tff(fact_7471_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [F2: fun(A,A),P2: A,K: nat] :
          ( order_mono(A,A,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,F2,P2)),P2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F2),bot_bot(A))),P2)) ) ) ) ).

% Kleene_iter_lpfp
tff(fact_7472_incseq__bounded,axiom,
    ! [X7: fun(nat,real),B3: real] :
      ( order_mono(nat,real,X7)
     => ( ! [I3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,X7,I3)),B3))
       => bfun(nat,real,X7,at_top(nat)) ) ) ).

% incseq_bounded
tff(fact_7473_funpow__mono2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(A,A),I: nat,J3: nat,X3: A,Y4: A] :
          ( order_mono(A,A,F2)
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),aa(A,A,F2,X3)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),I),F2),X3)),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),J3),F2),Y4))) ) ) ) ) ) ).

% funpow_mono2
tff(fact_7474_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_mono(A,B,F2)
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ) ).

% mono_invE
tff(fact_7475_mono__mult,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => order_mono(A,A,aa(A,fun(A,A),times_times(A),A3)) ) ) ).

% mono_mult
tff(fact_7476_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A)] :
          ( order_mono(nat,A,F2)
        <=> ! [N3: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,N3)),aa(nat,A,F2,aa(nat,nat,suc,N3)))) ) ) ).

% incseq_Suc_iff
tff(fact_7477_incseq__SucI,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N2)),aa(nat,A,X7,aa(nat,nat,suc,N2))))
         => order_mono(nat,A,X7) ) ) ).

% incseq_SucI
tff(fact_7478_incseq__SucD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: fun(nat,A),I: nat] :
          ( order_mono(nat,A,A2)
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,A2,I)),aa(nat,A,A2,aa(nat,nat,suc,I)))) ) ) ).

% incseq_SucD
tff(fact_7479_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_mono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4))) ) ) ) ).

% monoD
tff(fact_7480_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_mono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4))) ) ) ) ).

% monoE
tff(fact_7481_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2))) )
         => order_mono(A,B,F2) ) ) ).

% monoI
tff(fact_7482_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( order_mono(A,B,F2)
        <=> ! [X4: A,Y: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Y))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X4)),aa(A,B,F2,Y))) ) ) ) ).

% mono_def
tff(fact_7483_incseqD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),I: nat,J3: nat] :
          ( order_mono(nat,A,F2)
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,F2,I)),aa(nat,A,F2,J3))) ) ) ) ).

% incseqD
tff(fact_7484_incseq__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( order_mono(nat,A,X7)
        <=> ! [M6: nat,N3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M6),N3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,M6)),aa(nat,A,X7,N3))) ) ) ) ).

% incseq_def
tff(fact_7485_funpow__mono,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(A,A),A2: A,B3: A,N: nat] :
          ( order_mono(A,A,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),A2)),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),B3))) ) ) ) ).

% funpow_mono
tff(fact_7486_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf(A)
        & semilattice_inf(B) )
     => ! [F2: fun(A,B),A2: A,B3: A] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B3))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,F2,A2)),aa(A,B,F2,B3)))) ) ) ).

% mono_inf
tff(fact_7487_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup(A)
        & semilattice_sup(B) )
     => ! [F2: fun(A,B),A2: A,B3: A] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,F2,A2)),aa(A,B,F2,B3))),aa(A,B,F2,aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B3)))) ) ) ).

% mono_sup
tff(fact_7488_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [F2: fun(A,A),P2: A,K: nat] :
          ( order_mono(A,A,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P2),aa(A,A,F2,P2)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P2),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F2),top_top(A)))) ) ) ) ).

% Kleene_iter_gpfp
tff(fact_7489_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [F2: fun(A,B),M: A,N: A,M4: B,N4: B] :
          ( order_mono(A,B,F2)
         => ( ( aa(set(A),set(B),image(A,B,F2),set_or7035219750837199246ssThan(A,M,N)) = set_or7035219750837199246ssThan(B,M4,N4) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M),N))
             => ( aa(A,B,F2,M) = M4 ) ) ) ) ) ).

% mono_image_least
tff(fact_7490_mono__add,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A3: A] : order_mono(A,A,aa(A,fun(A,A),plus_plus(A),A3)) ) ).

% mono_add
tff(fact_7491_mono__Suc,axiom,
    order_mono(nat,nat,suc) ).

% mono_Suc
tff(fact_7492_mono__pow,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),N: nat] :
          ( order_mono(A,A,F2)
         => order_mono(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2)) ) ) ).

% mono_pow
tff(fact_7493_mono__times__nat,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => order_mono(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N)) ) ).

% mono_times_nat
tff(fact_7494_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_mono(A,B,F2)
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) ) ) ) ).

% mono_strict_invE
tff(fact_7495_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_mono(nat,A,aTP_Lamp_adr(fun(A,A),fun(nat,A),Q)) ) ) ).

% mono_funpow
tff(fact_7496_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F2: fun(A,B),A2: fun(C,A),I5: set(C)] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ads(fun(A,B),fun(fun(C,A),fun(C,B)),F2),A2)),I5))),aa(A,B,F2,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,A2),I5))))) ) ) ).

% mono_SUP
tff(fact_7497_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F2: fun(A,B),A2: set(A)] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F2),A2))),aa(A,B,F2,aa(set(A),A,complete_Sup_Sup(A),A2)))) ) ) ).

% mono_Sup
tff(fact_7498_mono__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(A) )
     => ! [F2: fun(A,B),A2: fun(C,A),I5: set(C)] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,A2),I5)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ads(fun(A,B),fun(fun(C,A),fun(C,B)),F2),A2)),I5)))) ) ) ).

% mono_INF
tff(fact_7499_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F2: fun(A,B),A2: set(A)] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,aa(set(A),A,complete_Inf_Inf(A),A2))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F2),A2)))) ) ) ).

% mono_Inf
tff(fact_7500_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_antimono(nat,A,aTP_Lamp_adt(fun(A,A),fun(nat,A),Q)) ) ) ).

% antimono_funpow
tff(fact_7501_incseq__le,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X7: fun(nat,A),L5: A,N: nat] :
          ( order_mono(nat,A,X7)
         => ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,X7,N)),L5)) ) ) ) ).

% incseq_le
tff(fact_7502_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [M: nat,N: nat,F2: fun(A,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( order_mono(A,A,F2)
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),top_top(A))),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2),top_top(A)))) ) ) ) ).

% funpow_increasing
tff(fact_7503_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [M: nat,N: nat,F2: fun(A,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M),N))
         => ( order_mono(A,A,F2)
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2),bot_bot(A))),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),bot_bot(A)))) ) ) ) ).

% funpow_decreasing
tff(fact_7504_incseq__convergent,axiom,
    ! [X7: fun(nat,real),B3: real] :
      ( order_mono(nat,real,X7)
     => ( ! [I3: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,X7,I3)),B3))
       => ~ ! [L6: real] :
              ( filterlim(nat,real,X7,topolo7230453075368039082e_nhds(real,L6),at_top(nat))
             => ~ ! [I4: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(nat,real,X7,I4)),L6)) ) ) ) ).

% incseq_convergent
tff(fact_7505_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K))
     => order_mono(nat,nat,aTP_Lamp_adu(nat,fun(nat,nat),K)) ) ).

% mono_ge2_power_minus_self
tff(fact_7506_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A)] :
          ( finite_finite(A,aa(set(nat),set(A),image(nat,A,F2),top_top(set(nat))))
         => ( order_mono(nat,A,F2)
           => ( ! [N2: nat] :
                  ( ( aa(nat,A,F2,N2) = aa(nat,A,F2,aa(nat,nat,suc,N2)) )
                 => ( aa(nat,A,F2,aa(nat,nat,suc,N2)) = aa(nat,A,F2,aa(nat,nat,suc,aa(nat,nat,suc,N2))) ) )
             => ? [N9: nat] :
                  ( ! [N7: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N7),N9))
                     => ! [M2: nat] :
                          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N9))
                         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N7))
                           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,F2,M2)),aa(nat,A,F2,N7))) ) ) )
                  & ! [N7: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N9),N7))
                     => ( aa(nat,A,F2,N9) = aa(nat,A,F2,N7) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
tff(fact_7507_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo3112930676232923870pology(B)
        & topolo1944317154257567458pology(B)
        & topolo4958980785337419405_space(A) )
     => ! [B2: B,A3: B,X7: fun(B,A),L5: A] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B2),A3))
         => ( ! [S5: fun(nat,B)] :
                ( ! [N7: nat] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(nat,B,S5,N7)),A3))
               => ( ! [N7: nat] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B2),aa(nat,B,S5,N7)))
                 => ( order_mono(nat,B,S5)
                   => ( filterlim(nat,B,S5,topolo7230453075368039082e_nhds(B,A3),at_top(nat))
                     => filterlim(nat,A,aa(fun(nat,B),fun(nat,A),aTP_Lamp_adv(fun(B,A),fun(fun(nat,B),fun(nat,A)),X7),S5),topolo7230453075368039082e_nhds(A,L5),at_top(nat)) ) ) ) )
           => filterlim(B,A,X7,topolo7230453075368039082e_nhds(A,L5),topolo174197925503356063within(B,A3,set_ord_lessThan(B,A3))) ) ) ) ).

% tendsto_at_left_sequentially
tff(fact_7508_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( remdups_adj(A,Xs) = Ys2 )
    <=> ? [F6: fun(nat,nat)] :
          ( order_mono(nat,nat,F6)
          & ( aa(set(nat),set(nat),image(nat,nat,F6),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Ys2)) )
          & ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))
             => ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,nth(A,Ys2),aa(nat,nat,F6,I2)) ) )
          & ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),one_one(nat))),aa(list(A),nat,size_size(list(A)),Xs)))
             => ( ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),one_one(nat))) )
              <=> ( aa(nat,nat,F6,I2) = aa(nat,nat,F6,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),one_one(nat))) ) ) ) ) ) ).

% remdups_adj_altdef
tff(fact_7509_range__abs__Nats,axiom,
    aa(set(int),set(int),image(int,int,abs_abs(int)),top_top(set(int))) = semiring_1_Nats(int) ).

% range_abs_Nats
tff(fact_7510_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( remdups_adj(A,Xs) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% remdups_adj_Nil_iff
tff(fact_7511_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),remdups_adj(A,Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% remdups_adj_set
tff(fact_7512_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list(A)] : ( remdups_adj(A,aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),remdups_adj(A,Xs)) ) ).

% remdups_adj_rev
tff(fact_7513_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),A,hd(A),remdups_adj(A,Xs)) = aa(list(A),A,hd(A),Xs) ) ).

% hd_remdups_adj
tff(fact_7514_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),tl(A),remdups_adj(A,aa(list(A),list(A),cons(A,X3),Xs)))) = remdups_adj(A,aa(list(A),list(A),cons(A,X3),Xs)) ) ).

% remdups_adj_Cons_alt
tff(fact_7515_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: fun(set(A),set(B)),A2: set(A),B3: set(A)] :
      ( order_mono(set(A),set(B),F2)
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),F2,A2)),aa(set(A),set(B),F2,B3)))) ) ).

% mono_Int
tff(fact_7516_mono__Un,axiom,
    ! [B: $tType,A: $tType,F2: fun(set(A),set(B)),A2: set(A),B3: set(A)] :
      ( order_mono(set(A),set(B),F2)
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(A),set(B),F2,A2)),aa(set(A),set(B),F2,B3))),aa(set(A),set(B),F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A2),B3)))) ) ).

% mono_Un
tff(fact_7517_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] : ( remdups_adj(A,nil(A)) = nil(A) ) ).

% remdups_adj.simps(1)
tff(fact_7518_Nats__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),semiring_1_Nats(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),semiring_1_Nats(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),semiring_1_Nats(A))) ) ) ) ).

% Nats_mult
tff(fact_7519_Nats__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [W: num] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(num,A,numeral_numeral(A),W)),semiring_1_Nats(A))) ) ).

% Nats_numeral
tff(fact_7520_Nats__0,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),zero_zero(A)),semiring_1_Nats(A))) ) ).

% Nats_0
tff(fact_7521_Nats__add,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),semiring_1_Nats(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),semiring_1_Nats(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),semiring_1_Nats(A))) ) ) ) ).

% Nats_add
tff(fact_7522_Nats__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),one_one(A)),semiring_1_Nats(A))) ) ).

% Nats_1
tff(fact_7523_fact__in__Nats,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),semiring_char_0_fact(A,N)),semiring_1_Nats(A))) ) ).

% fact_in_Nats
tff(fact_7524_Nats__cases,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X3: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),semiring_1_Nats(A)))
         => ~ ! [N2: nat] : ( X3 != aa(nat,A,semiring_1_of_nat(A),N2) ) ) ) ).

% Nats_cases
tff(fact_7525_Nats__induct,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X3: A,P: fun(A,bool)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),semiring_1_Nats(A)))
         => ( ! [N2: nat] : pp(aa(A,bool,P,aa(nat,A,semiring_1_of_nat(A),N2)))
           => pp(aa(A,bool,P,X3)) ) ) ) ).

% Nats_induct
tff(fact_7526_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,semiring_1_of_nat(A),N)),semiring_1_Nats(A))) ) ).

% of_nat_in_Nats
tff(fact_7527_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => ( remdups_adj(A,Xs) = Xs ) ) ).

% remdups_adj_distinct
tff(fact_7528_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X3: A,Y4: A,Xs: list(A)] :
      ( ( ( X3 = Y4 )
       => ( remdups_adj(A,aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),cons(A,Y4),Xs))) = remdups_adj(A,aa(list(A),list(A),cons(A,X3),Xs)) ) )
      & ( ( X3 != Y4 )
       => ( remdups_adj(A,aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),cons(A,Y4),Xs))) = aa(list(A),list(A),cons(A,X3),remdups_adj(A,aa(list(A),list(A),cons(A,Y4),Xs))) ) ) ) ).

% remdups_adj.simps(3)
tff(fact_7529_remdups__adj_Oelims,axiom,
    ! [A: $tType,X3: list(A),Y4: list(A)] :
      ( ( remdups_adj(A,X3) = Y4 )
     => ( ( ( X3 = nil(A) )
         => ( Y4 != nil(A) ) )
       => ( ! [X2: A] :
              ( ( X3 = aa(list(A),list(A),cons(A,X2),nil(A)) )
             => ( Y4 != aa(list(A),list(A),cons(A,X2),nil(A)) ) )
         => ~ ! [X2: A,Y2: A,Xs2: list(A)] :
                ( ( X3 = aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Xs2)) )
               => ~ ( ( ( X2 = Y2 )
                     => ( Y4 = remdups_adj(A,aa(list(A),list(A),cons(A,X2),Xs2)) ) )
                    & ( ( X2 != Y2 )
                     => ( Y4 = aa(list(A),list(A),cons(A,X2),remdups_adj(A,aa(list(A),list(A),cons(A,Y2),Xs2))) ) ) ) ) ) ) ) ).

% remdups_adj.elims
tff(fact_7530_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A] : ( remdups_adj(A,aa(list(A),list(A),cons(A,X3),nil(A))) = aa(list(A),list(A),cons(A,X3),nil(A)) ) ).

% remdups_adj.simps(2)
tff(fact_7531_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( remdups_adj(A,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),cons(A,X3),remdups_adj(A,dropWhile(A,aTP_Lamp_adw(A,fun(A,bool),X3),Xs))) ) ).

% remdups_adj_Cons'
tff(fact_7532_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),remdups_adj(A,Xs)) ) ) ).

% sorted_remdups_adj
tff(fact_7533_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs))),aa(list(A),nat,size_size(list(A)),Xs))) ).

% remdups_adj_length
tff(fact_7534_Nats__diff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),semiring_1_Nats(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),semiring_1_Nats(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
             => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),semiring_1_Nats(A))) ) ) ) ) ).

% Nats_diff
tff(fact_7535_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list(A),X3: A,Y4: A] : ( remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),cons(A,Y4),nil(A))))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X3),nil(A))))),if(list(A),aa(A,bool,aa(A,fun(A,bool),fequal(A),X3),Y4),nil(A),aa(list(A),list(A),cons(A,Y4),nil(A)))) ) ).

% remdups_adj_append_two
tff(fact_7536_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),semiring_1_Nats(A)),ring_1_Ints(A))) ) ).

% Nats_subset_Ints
tff(fact_7537_remdups__adj__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list(A)] : ( remdups_adj(A,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),list(A),case_list(list(A),A,aa(list(A),list(A),cons(A,X3),nil(A)),aTP_Lamp_adx(A,fun(A,fun(list(A),list(A))),X3)),remdups_adj(A,Xs)) ) ).

% remdups_adj_Cons
tff(fact_7538_remdups__adj__adjacent,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,I)),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs))))
     => ( aa(nat,A,nth(A,remdups_adj(A,Xs)),I) != aa(nat,A,nth(A,remdups_adj(A,Xs)),aa(nat,nat,suc,I)) ) ) ).

% remdups_adj_adjacent
tff(fact_7539_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( N = zero_zero(nat) )
       => ( remdups_adj(A,replicate(A,N,X3)) = nil(A) ) )
      & ( ( N != zero_zero(nat) )
       => ( remdups_adj(A,replicate(A,N,X3)) = aa(list(A),list(A),cons(A,X3),nil(A)) ) ) ) ).

% remdups_adj_replicate
tff(fact_7540_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list(A),X3: A] :
      ( ( remdups_adj(A,Xs) = aa(list(A),list(A),cons(A,X3),nil(A)) )
     => ( Xs = replicate(A,aa(list(A),nat,size_size(list(A)),Xs),X3) ) ) ).

% remdups_adj_singleton
tff(fact_7541_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list(A),X3: A,Xs_2: list(A)] : ( remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs_1),aa(list(A),list(A),cons(A,X3),Xs_2))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs_1),aa(list(A),list(A),cons(A,X3),nil(A))))),aa(list(A),list(A),tl(A),remdups_adj(A,aa(list(A),list(A),cons(A,X3),Xs_2)))) ) ).

% remdups_adj_append
tff(fact_7542_Nats__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( semiring_1_Nats(A) = aa(set(nat),set(A),image(nat,A,semiring_1_of_nat(A)),top_top(set(nat))) ) ) ).

% Nats_def
tff(fact_7543_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list(A),Y4: A,Ys2: list(A)] : ( remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,Y4),Ys2))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,Y4),nil(A))))),remdups_adj(A,dropWhile(A,aTP_Lamp_adw(A,fun(A,bool),Y4),Ys2))) ) ).

% remdups_adj_append_dropWhile
tff(fact_7544_tl__remdups__adj,axiom,
    ! [A: $tType,Ys2: list(A)] :
      ( ( Ys2 != nil(A) )
     => ( aa(list(A),list(A),tl(A),remdups_adj(A,Ys2)) = remdups_adj(A,dropWhile(A,aTP_Lamp_ady(list(A),fun(A,bool),Ys2),aa(list(A),list(A),tl(A),Ys2))) ) ) ).

% tl_remdups_adj
tff(fact_7545_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( semiring_1_Nats(A) = collect(A,aTP_Lamp_adz(A,bool)) ) ) ).

% Nats_altdef2
tff(fact_7546_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs)))) ) ).

% remdups_adj_length_ge1
tff(fact_7547_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs)) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( Xs != nil(A) )
        & ( Xs = replicate(A,aa(list(A),nat,size_size(list(A)),Xs),aa(list(A),A,hd(A),Xs)) ) ) ) ).

% remdups_adj_singleton_iff
tff(fact_7548_remdups__adj_Opelims,axiom,
    ! [A: $tType,X3: list(A),Y4: list(A)] :
      ( ( remdups_adj(A,X3) = Y4 )
     => ( pp(aa(list(A),bool,accp(list(A),remdups_adj_rel(A)),X3))
       => ( ( ( X3 = nil(A) )
           => ( ( Y4 = nil(A) )
             => ~ pp(aa(list(A),bool,accp(list(A),remdups_adj_rel(A)),nil(A))) ) )
         => ( ! [X2: A] :
                ( ( X3 = aa(list(A),list(A),cons(A,X2),nil(A)) )
               => ( ( Y4 = aa(list(A),list(A),cons(A,X2),nil(A)) )
                 => ~ pp(aa(list(A),bool,accp(list(A),remdups_adj_rel(A)),aa(list(A),list(A),cons(A,X2),nil(A)))) ) )
           => ~ ! [X2: A,Y2: A,Xs2: list(A)] :
                  ( ( X3 = aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Xs2)) )
                 => ( ( ( ( X2 = Y2 )
                       => ( Y4 = remdups_adj(A,aa(list(A),list(A),cons(A,X2),Xs2)) ) )
                      & ( ( X2 != Y2 )
                       => ( Y4 = aa(list(A),list(A),cons(A,X2),remdups_adj(A,aa(list(A),list(A),cons(A,Y2),Xs2))) ) ) )
                   => ~ pp(aa(list(A),bool,accp(list(A),remdups_adj_rel(A)),aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Xs2)))) ) ) ) ) ) ) ).

% remdups_adj.pelims
tff(fact_7549_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: fun(nat,real),G: fun(nat,nat)] :
      ( ! [X2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,X2)))
     => ( order_mono(nat,real,F2)
       => ( order_strict_mono(nat,nat,G)
         => ( bfun(nat,real,aa(fun(nat,nat),fun(nat,real),aTP_Lamp_aea(fun(nat,real),fun(fun(nat,nat),fun(nat,real)),F2),G),at_top(nat))
          <=> bfun(nat,real,F2,at_top(nat)) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
tff(fact_7550_strict__mono__imp__increasing,axiom,
    ! [F2: fun(nat,nat),N: nat] :
      ( order_strict_mono(nat,nat,F2)
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),aa(nat,nat,F2,N))) ) ).

% strict_mono_imp_increasing
tff(fact_7551_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [R2: fun(A,B),M: A,N: A] :
          ( order_strict_mono(A,B,R2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M),N))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,R2,M)),aa(A,B,R2,N))) ) ) ) ).

% strict_mono_leD
tff(fact_7552_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_strict_mono(A,B,F2)
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4)) ) ) ) ).

% strict_mono_less_eq
tff(fact_7553_strict__mono__add,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A] : order_strict_mono(A,A,aTP_Lamp_pc(A,fun(A,A),K)) ) ).

% strict_mono_add
tff(fact_7554_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A)] :
          ( order_strict_mono(nat,A,F2)
        <=> ! [N3: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,F2,N3)),aa(nat,A,F2,aa(nat,nat,suc,N3)))) ) ) ).

% strict_mono_Suc_iff
tff(fact_7555_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_strict_mono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4))) ) ) ) ).

% strict_monoD
tff(fact_7556_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X2)),aa(A,B,F2,Y2))) )
         => order_strict_mono(A,B,F2) ) ) ).

% strict_monoI
tff(fact_7557_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( order_strict_mono(A,B,F2)
        <=> ! [X4: A,Y: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),Y))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X4)),aa(A,B,F2,Y))) ) ) ) ).

% strict_mono_def
tff(fact_7558_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X3: A,Y4: A] :
          ( order_strict_mono(A,B,F2)
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) ) ) ) ).

% strict_mono_less
tff(fact_7559_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [G: fun(nat,nat),F2: fun(nat,A)] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N2: nat] :
                ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N2),aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat)))))
               => ( aa(nat,A,F2,N2) = zero_zero(A) ) )
           => ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aeb(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F2))
            <=> summable(A,F2) ) ) ) ) ).

% summable_mono_reindex
tff(fact_7560_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [G: fun(nat,nat),F2: fun(nat,A),C2: A] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N2: nat] :
                ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N2),aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat)))))
               => ( aa(nat,A,F2,N2) = zero_zero(A) ) )
           => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aeb(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F2),C2)
            <=> sums(A,F2,C2) ) ) ) ) ).

% sums_mono_reindex
tff(fact_7561_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [G: fun(nat,nat),F2: fun(nat,A)] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N2: nat] :
                ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N2),aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat)))))
               => ( aa(nat,A,F2,N2) = zero_zero(A) ) )
           => ( suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aec(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F2)) = suminf(A,F2) ) ) ) ) ).

% suminf_mono_reindex
tff(fact_7562_complex__is__Nat__iff,axiom,
    ! [Z: complex] :
      ( pp(aa(set(complex),bool,aa(complex,fun(set(complex),bool),member2(complex),Z),semiring_1_Nats(complex)))
    <=> ( ( im(Z) = zero_zero(real) )
        & ? [I2: nat] : ( re(Z) = aa(nat,real,semiring_1_of_nat(real),I2) ) ) ) ).

% complex_is_Nat_iff
tff(fact_7563_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),G: fun(nat,nat)] :
          ( ! [X2: nat,Y2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X2),Y2))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,X2))),real_V7770717601297561774m_norm(A,aa(nat,A,F2,Y2)))) )
         => ( order_strict_mono(nat,nat,G)
           => ( bfun(nat,A,aa(fun(nat,nat),fun(nat,A),aTP_Lamp_aed(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),F2),G),at_top(nat))
            <=> bfun(nat,A,F2,at_top(nat)) ) ) ) ) ).

% increasing_Bseq_subseq_iff
tff(fact_7564_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),I5: set(B),F2: fun(B,set(A))] :
          ( topolo2193935891317330818ompact(A,S)
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),I5))
               => topolo7761053866217962861closed(A,aa(B,set(A),F2,I3)) )
           => ( ! [I8: set(B)] :
                  ( finite_finite(B,I8)
                 => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),I8),I5))
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),F2),I8))) != bot_bot(set(A)) ) ) )
             => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),F2),I5))) != bot_bot(set(A)) ) ) ) ) ) ).

% compact_imp_fip_image
tff(fact_7565_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list(A),N: A,Ns: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,M),Ms)),aa(list(A),list(A),cons(A,N),Ns))),lenlex(A,R2)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),Ms)),aa(list(A),nat,size_size(list(A)),Ns)))
        | ( ( aa(list(A),nat,size_size(list(A)),Ms) = aa(list(A),nat,size_size(list(A)),Ns) )
          & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,M),N)),R2)) )
        | ( ( M = N )
          & pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ms),Ns)),lenlex(A,R2))) ) ) ) ).

% Cons_lenlex_iff
tff(fact_7566_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Ns)),lenlex(A,R2)))
    <=> ( Ns != nil(A) ) ) ).

% Nil_lenlex_iff1
tff(fact_7567_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list(A),R2: set(product_prod(A,A))] : ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ns),nil(A))),lenlex(A,R2))) ).

% Nil_lenlex_iff2
tff(fact_7568_lenlex__irreflexive,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),Xs: list(A)] :
      ( ! [X2: A] : ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X2),X2)),R2))
     => ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Xs)),lenlex(A,R2))) ) ).

% lenlex_irreflexive
tff(fact_7569_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,top_top(set(A)),F2)
         => ( topolo81223032696312382ous_on(A,B,top_top(set(A)),G)
           => topolo7761053866217962861closed(A,collect(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_aee(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),G))) ) ) ) ).

% closed_Collect_le
tff(fact_7570_t4__space,axiom,
    ! [A: $tType] :
      ( topological_t4_space(A)
     => ! [S2: set(A),T6: set(A)] :
          ( topolo7761053866217962861closed(A,S2)
         => ( topolo7761053866217962861closed(A,T6)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T6) = bot_bot(set(A)) )
             => ? [U5: set(A),V5: set(A)] :
                  ( topolo1002775350975398744n_open(A,U5)
                  & topolo1002775350975398744n_open(A,V5)
                  & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),U5))
                  & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T6),V5))
                  & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U5),V5) = bot_bot(set(A)) ) ) ) ) ) ) ).

% t4_space
tff(fact_7571_t3__space,axiom,
    ! [A: $tType] :
      ( topological_t3_space(A)
     => ! [S2: set(A),Y4: A] :
          ( topolo7761053866217962861closed(A,S2)
         => ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),S2))
           => ? [U5: set(A),V5: set(A)] :
                ( topolo1002775350975398744n_open(A,U5)
                & topolo1002775350975398744n_open(A,V5)
                & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y4),U5))
                & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),V5))
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U5),V5) = bot_bot(set(A)) ) ) ) ) ) ).

% t3_space
tff(fact_7572_nhds__closed,axiom,
    ! [A: $tType] :
      ( topological_t3_space(A)
     => ! [X3: A,A2: set(A)] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
         => ( topolo1002775350975398744n_open(A,A2)
           => ? [A10: set(A)] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A10))
                & topolo7761053866217962861closed(A,A10)
                & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A10),A2))
                & eventually(A,aTP_Lamp_aef(set(A),fun(A,bool),A10),topolo7230453075368039082e_nhds(A,X3)) ) ) ) ) ).

% nhds_closed
tff(fact_7573_lenlex__length,axiom,
    ! [A: $tType,Ms: list(A),Ns: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ms),Ns)),lenlex(A,R2)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Ms)),aa(list(A),nat,size_size(list(A)),Ns))) ) ).

% lenlex_length
tff(fact_7574_lenlex__append1,axiom,
    ! [A: $tType,Us: list(A),Xs: list(A),R4: set(product_prod(A,A)),Vs: list(A),Ys2: list(A)] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Us),Xs)),lenlex(A,R4)))
     => ( ( aa(list(A),nat,size_size(list(A)),Vs) = aa(list(A),nat,size_size(list(A)),Ys2) )
       => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Vs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2))),lenlex(A,R4))) ) ) ).

% lenlex_append1
tff(fact_7575_compact__imp__fip,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),F3: set(set(A))] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( ! [T7: set(A)] :
                ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),T7),F3))
               => topolo7761053866217962861closed(A,T7) )
           => ( ! [F10: set(set(A))] :
                  ( finite_finite(set(A),F10)
                 => ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),F10),F3))
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),F10)) != bot_bot(set(A)) ) ) )
             => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),F3)) != bot_bot(set(A)) ) ) ) ) ) ).

% compact_imp_fip
tff(fact_7576_compact__fip,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [U3: set(A)] :
          ( topolo2193935891317330818ompact(A,U3)
        <=> ! [A14: set(set(A))] :
              ( ! [X4: set(A)] :
                  ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X4),A14))
                 => topolo7761053866217962861closed(A,X4) )
             => ( ! [B10: set(set(A))] :
                    ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),B10),A14))
                   => ( finite_finite(set(A),B10)
                     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B10)) != bot_bot(set(A)) ) ) )
               => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A14)) != bot_bot(set(A)) ) ) ) ) ) ).

% compact_fip
tff(fact_7577_pos__deriv__imp__strict__mono,axiom,
    ! [F2: fun(real,real),F8: fun(real,real)] :
      ( ! [X2: real] : has_field_derivative(real,F2,aa(real,real,F8,X2),topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( ! [X2: real] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(real,real,F8,X2)))
       => order_strict_mono(real,real,F2) ) ) ).

% pos_deriv_imp_strict_mono
tff(fact_7578_lenlex__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lenlex(A,R2) = collect(product_prod(list(A),list(A)),product_case_prod(list(A),list(A),bool,aTP_Lamp_aeg(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R2))) ) ).

% lenlex_conv
tff(fact_7579_lenlex__append2,axiom,
    ! [A: $tType,R4: set(product_prod(A,A)),Us: list(A),Xs: list(A),Ys2: list(A)] :
      ( irrefl(A,R4)
     => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Ys2))),lenlex(A,R4)))
      <=> pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),lenlex(A,R4))) ) ) ).

% lenlex_append2
tff(fact_7580_inj__sgn__power,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => inj_on(real,real,aTP_Lamp_qb(nat,fun(real,real),N),top_top(set(real))) ) ).

% inj_sgn_power
tff(fact_7581_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),Xs: list(A),Ys2: list(A)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => ( ( aa(list(A),list(B),map(A,B,F2),Xs) = aa(list(A),list(B),map(A,B,F2),Ys2) )
      <=> ( Xs = Ys2 ) ) ) ).

% inj_map_eq_map
tff(fact_7582_inj__mult__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A3: A] :
          ( inj_on(A,A,aa(A,fun(A,A),times_times(A),A3),top_top(set(A)))
        <=> ( A3 != zero_zero(A) ) ) ) ).

% inj_mult_left
tff(fact_7583_inj__divide__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A] :
          ( inj_on(A,A,aTP_Lamp_aeh(A,fun(A,A),A3),top_top(set(A)))
        <=> ( A3 != zero_zero(A) ) ) ) ).

% inj_divide_right
tff(fact_7584_inj__map,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B)] :
      ( inj_on(list(A),list(B),map(A,B,F2),top_top(set(list(A))))
    <=> inj_on(A,B,F2,top_top(set(A))) ) ).

% inj_map
tff(fact_7585_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => inj_on(list(A),list(B),map(A,B,F2),top_top(set(list(A)))) ) ).

% inj_mapI
tff(fact_7586_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),Xs: list(A)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => ( remdups_adj(B,aa(list(A),list(B),map(A,B,F2),Xs)) = aa(list(A),list(B),map(A,B,F2),remdups_adj(A,Xs)) ) ) ).

% remdups_adj_map_injective
tff(fact_7587_inj__on__iff__surj,axiom,
    ! [B: $tType,A: $tType,A2: set(A),A8: set(B)] :
      ( ( A2 != bot_bot(set(A)) )
     => ( ? [F6: fun(A,B)] :
            ( inj_on(A,B,F6,A2)
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F6),A2)),A8)) )
      <=> ? [G4: fun(B,A)] : ( aa(set(B),set(A),image(B,A,G4),A8) = A2 ) ) ) ).

% inj_on_iff_surj
tff(fact_7588_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( order(A)
     => ! [A2: set(A),F2: fun(A,B)] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
             => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
               => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y2),A2))
                 => ( aa(A,B,F2,X2) != aa(A,B,F2,Y2) ) ) ) )
         => ( ! [X2: A,Y2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
               => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Y2),A2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                    | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X2)) ) ) )
           => inj_on(A,B,F2,A2) ) ) ) ).

% linorder_inj_onI
tff(fact_7589_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),B3: set(A),A2: set(A)] :
      ( inj_on(A,B,F2,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
       => inj_on(A,B,F2,A2) ) ) ).

% subset_inj_on
tff(fact_7590_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A2: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,A2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A2))
       => inj_on(A,B,F2,B3) ) ) ).

% inj_on_subset
tff(fact_7591_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),C6: set(A),A2: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,C6)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C6))
         => ( ( aa(set(A),set(B),image(A,B,F2),A2) = aa(set(A),set(B),image(A,B,F2),B3) )
          <=> ( A2 = B3 ) ) ) ) ) ).

% inj_on_image_eq_iff
tff(fact_7592_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),B3: set(A),A3: A,A2: set(A)] :
      ( inj_on(A,B,F2,B3)
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),B3))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
         => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),aa(A,B,F2,A3)),aa(set(A),set(B),image(A,B,F2),A2)))
          <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),A2)) ) ) ) ) ).

% inj_on_image_mem_iff
tff(fact_7593_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F2: fun(B,A),T6: set(B)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),aa(set(B),set(A),image(B,A,F2),T6)))
    <=> ? [U6: set(B)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),U6),T6))
          & inj_on(B,A,F2,U6)
          & ( S2 = aa(set(B),set(A),image(B,A,F2),U6) ) ) ) ).

% subset_image_inj
tff(fact_7594_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),C6: set(A),A2: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,C6)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3)),C6))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C6))
         => ( aa(set(A),set(B),image(A,B,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A2),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),aa(set(A),set(B),image(A,B,F2),B3)) ) ) ) ) ).

% inj_on_image_set_diff
tff(fact_7595_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),C6: set(A),A2: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,C6)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C6))
         => ( aa(set(A),set(B),image(A,B,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A2),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),aa(set(A),set(B),image(A,B,F2),B3)) ) ) ) ) ).

% inj_on_image_Int
tff(fact_7596_endo__inj__surj,axiom,
    ! [A: $tType,A2: set(A),F2: fun(A,A)] :
      ( finite_finite(A,A2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),image(A,A,F2),A2)),A2))
       => ( inj_on(A,A,F2,A2)
         => ( aa(set(A),set(A),image(A,A,F2),A2) = A2 ) ) ) ) ).

% endo_inj_surj
tff(fact_7597_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A2: set(A),B3: set(B)] :
      ( inj_on(A,B,F2,A2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),B3))
       => ( finite_finite(B,B3)
         => finite_finite(A,A2) ) ) ) ).

% inj_on_finite
tff(fact_7598_finite__surj__inj,axiom,
    ! [A: $tType,A2: set(A),F2: fun(A,A)] :
      ( finite_finite(A,A2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(A),set(A),image(A,A,F2),A2)))
       => inj_on(A,A,F2,A2) ) ) ).

% finite_surj_inj
tff(fact_7599_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A2: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),aa(set(A),set(B),image(A,B,F2),B3)))
      <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ) ).

% inj_image_subset_iff
tff(fact_7600_distinct__map,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] :
      ( distinct(A,aa(list(B),list(A),map(B,A,F2),Xs))
    <=> ( distinct(B,Xs)
        & inj_on(B,A,F2,aa(list(B),set(B),set2(B),Xs)) ) ) ).

% distinct_map
tff(fact_7601_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),Xs: list(A),Ys2: list(A)] :
      ( inj_on(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys2)))
     => ( ( aa(list(A),list(B),map(A,B,F2),Xs) = aa(list(A),list(B),map(A,B,F2),Ys2) )
      <=> ( Xs = Ys2 ) ) ) ).

% inj_on_map_eq_map
tff(fact_7602_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B),Ys2: list(B)] :
      ( ( aa(list(B),list(A),map(B,A,F2),Xs) = aa(list(B),list(A),map(B,A,F2),Ys2) )
     => ( inj_on(B,A,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys2)))
       => ( Xs = Ys2 ) ) ) ).

% map_inj_on
tff(fact_7603_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A2: set(B)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(B),set(A),image(B,A,F2),A2))),aa(set(B),nat,finite_card(B),A2)))
     => ~ inj_on(B,A,F2,A2) ) ).

% pigeonhole
tff(fact_7604_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B)] :
      ( inj_on(list(A),list(B),map(A,B,F2),top_top(set(list(A))))
     => inj_on(A,B,F2,top_top(set(A))) ) ).

% inj_mapD
tff(fact_7605_map__injective,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B),Ys2: list(B)] :
      ( ( aa(list(B),list(A),map(B,A,F2),Xs) = aa(list(B),list(A),map(B,A,F2),Ys2) )
     => ( inj_on(B,A,F2,top_top(set(B)))
       => ( Xs = Ys2 ) ) ) ).

% map_injective
tff(fact_7606_inj__fn,axiom,
    ! [A: $tType,F2: fun(A,A),N: nat] :
      ( inj_on(A,A,F2,top_top(set(A)))
     => inj_on(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),top_top(set(A))) ) ).

% inj_fn
tff(fact_7607_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => inj_on(A,A,aTP_Lamp_nd(A,A),top_top(set(A))) ) ).

% sorted_list_of_set.inj_on
tff(fact_7608_inj__add__left,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A3: A] : inj_on(A,A,aa(A,fun(A,A),plus_plus(A),A3),top_top(set(A))) ) ).

% inj_add_left
tff(fact_7609_irrefl__lex,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( irrefl(A,R2)
     => irrefl(list(A),lex(A,R2)) ) ).

% irrefl_lex
tff(fact_7610_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A3: A,A2: set(A)] : inj_on(A,A,aTP_Lamp_aei(A,fun(A,A),A3),A2) ) ).

% inj_on_add'
tff(fact_7611_inj__on__add,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A3: A,A2: set(A)] : inj_on(A,A,aa(A,fun(A,A),plus_plus(A),A3),A2) ) ).

% inj_on_add
tff(fact_7612_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F2: fun(B,A)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F2)
     => inj_on(B,A,F2,S2) ) ).

% folding_insort_key.inj_on
tff(fact_7613_inj__on__mult,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A,A2: set(A)] :
          ( ( A3 != zero_zero(A) )
         => inj_on(A,A,aa(A,fun(A,A),times_times(A),A3),A2) ) ) ).

% inj_on_mult
tff(fact_7614_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A2: set(list(A))] :
      ( inj_on(A,B,F2,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),A2)))
     => inj_on(list(A),list(B),map(A,B,F2),A2) ) ).

% inj_on_mapI
tff(fact_7615_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),B3: set(A),A2: set(A)] :
      ( inj_on(A,B,F2,B3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A2),B3))
       => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),aa(set(A),set(B),image(A,B,F2),B3))) ) ) ).

% inj_on_strict_subset
tff(fact_7616_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [F2: fun(A,B)] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
             => ( aa(A,B,F2,X2) != aa(A,B,F2,Y2) ) )
         => inj_on(A,B,F2,top_top(set(A))) ) ) ).

% linorder_injI
tff(fact_7617_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A2: set(A),X3: B,B3: set(A)] :
      ( inj_on(A,B,F2,A2)
     => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X3),aa(set(A),set(B),image(A,B,F2),A2)))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),the_inv_into(A,B,A2,F2,X3)),B3)) ) ) ) ).

% the_inv_into_into
tff(fact_7618_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),X3: A,Xs: list(A)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => ( aa(list(A),list(B),map(A,B,F2),aa(list(A),list(A),removeAll(A,X3),Xs)) = aa(list(B),list(B),removeAll(B,aa(A,B,F2,X3)),aa(list(A),list(B),map(A,B,F2),Xs)) ) ) ).

% map_removeAll_inj
tff(fact_7619_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo8458572112393995274pology(A)
        & topolo1944317154257567458pology(B) )
     => ! [A3: A,X3: A,B2: A,F2: fun(A,B)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),B2))
           => ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A3,B2),F2)
             => ( inj_on(A,B,F2,set_or1337092689740270186AtMost(A,A3,B2))
               => ( ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,A3)),aa(A,B,F2,X3)))
                    & pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,B2))) )
                  | ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,B2)),aa(A,B,F2,X3)))
                    & pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,A3))) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
tff(fact_7620_injective__scaleR,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [C2: real] :
          ( ( C2 != zero_zero(real) )
         => inj_on(A,A,real_V8093663219630862766scaleR(A,C2),top_top(set(A))) ) ) ).

% injective_scaleR
tff(fact_7621_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set(A),A2: fun(A,set(B)),F2: fun(B,C)] :
      ( ! [I3: A,J2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),J2),I5))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),A2,I3)),aa(A,set(B),A2,J2)))
              | pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),A2,J2)),aa(A,set(B),A2,I3))) ) ) )
     => ( ! [I3: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
           => inj_on(B,C,F2,aa(A,set(B),A2,I3)) )
       => inj_on(B,C,F2,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A2),I5))) ) ) ).

% inj_on_UNION_chain
tff(fact_7622_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),Y4: A,Xs: list(A)] :
      ( inj_on(A,B,F2,aa(set(A),set(A),insert2(A,Y4),aa(list(A),set(A),set2(A),Xs)))
     => ( aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),aTP_Lamp_aej(fun(A,B),fun(A,fun(A,bool)),F2),Y4)),Xs) = aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),Y4)),Xs) ) ) ).

% inj_on_filter_key_eq
tff(fact_7623_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A2: set(A),B3: set(B),G: fun(B,A)] :
      ( inj_on(A,B,F2,A2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),B3))
       => ( inj_on(B,A,G,B3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G),B3)),A2))
           => ( finite_finite(A,A2)
             => ( finite_finite(B,B3)
               => ( aa(set(A),nat,finite_card(A),A2) = aa(set(B),nat,finite_card(B),B3) ) ) ) ) ) ) ) ).

% card_bij_eq
tff(fact_7624_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S2: set(A),T6: set(B),F2: fun(A,B)] :
      ( finite_finite(A,S2)
     => ( finite_finite(B,T6)
       => ( ( aa(set(A),nat,finite_card(A),S2) = aa(set(B),nat,finite_card(B),T6) )
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),S2)),T6))
           => ( ! [X4: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X4),T6))
                 => ? [Xa4: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),S2))
                      & ( aa(A,B,F2,Xa4) = X4 ) ) )
            <=> inj_on(A,B,F2,S2) ) ) ) ) ) ).

% surjective_iff_injective_gen
tff(fact_7625_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A2: set(A)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),aa(set(A),set(A),uminus_uminus(set(A)),A2))),aa(set(B),set(B),uminus_uminus(set(B)),aa(set(A),set(B),image(A,B,F2),A2)))) ) ).

% inj_image_Compl_subset
tff(fact_7626_lexl__not__refl,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),X3: list(A)] :
      ( irrefl(A,R2)
     => ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),X3)),lex(A,R2))) ) ).

% lexl_not_refl
tff(fact_7627_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),X3: A,Xs: list(A)] :
      ( inj_on(A,B,F2,aa(set(A),set(A),insert2(A,X3),aa(list(A),set(A),set2(A),Xs)))
     => ( aa(list(A),list(B),map(A,B,F2),aa(list(A),list(A),removeAll(A,X3),Xs)) = aa(list(B),list(B),removeAll(B,aa(A,B,F2,X3)),aa(list(A),list(B),map(A,B,F2),Xs)) ) ) ).

% map_removeAll_inj_on
tff(fact_7628_image__INT,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(A,B),C6: set(A),A2: set(C),B3: fun(C,set(A)),J3: C] :
      ( inj_on(A,B,F2,C6)
     => ( ! [X2: C] :
            ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),X2),A2))
           => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(C,set(A),B3,X2)),C6)) )
       => ( pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),J3),A2))
         => ( aa(set(A),set(B),image(A,B,F2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),B3),A2))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_aek(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),F2),B3)),A2)) ) ) ) ) ).

% image_INT
tff(fact_7629_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A2: set(A),B3: set(B)] :
      ( finite_finite(A,A2)
     => ( finite_finite(B,B3)
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(B),nat,finite_card(B),B3)))
         => ? [F4: fun(A,B)] :
              ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F4),A2)),B3))
              & inj_on(A,B,F4,A2) ) ) ) ) ).

% card_le_inj
tff(fact_7630_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A2: set(A),B3: set(B)] :
      ( inj_on(A,B,F2,A2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),B3))
       => ( finite_finite(B,B3)
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(B),nat,finite_card(B),B3))) ) ) ) ).

% card_inj_on_le
tff(fact_7631_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A2: set(A),B3: set(B)] :
      ( finite_finite(A,A2)
     => ( finite_finite(B,B3)
       => ( ? [F6: fun(A,B)] :
              ( inj_on(A,B,F6,A2)
              & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F6),A2)),B3)) )
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(B),nat,finite_card(B),B3))) ) ) ) ).

% inj_on_iff_card_le
tff(fact_7632_log__inj,axiom,
    ! [B2: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),one_one(real)),B2))
     => inj_on(real,real,log(B2),set_ord_greaterThan(real,zero_zero(real))) ) ).

% log_inj
tff(fact_7633_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B),Ys2: list(B)] :
          ( inj_on(B,A,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys2)))
         => ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs))
           => ( distinct(A,aa(list(B),list(A),map(B,A,F2),Xs))
             => ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Ys2))
               => ( distinct(A,aa(list(B),list(A),map(B,A,F2),Ys2))
                 => ( ( aa(list(B),set(B),set2(B),Xs) = aa(list(B),set(B),set2(B),Ys2) )
                   => ( Xs = Ys2 ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
tff(fact_7634_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A2: set(A),B3: set(B),G: fun(B,A)] :
      ( inj_on(A,B,F2,A2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),B3))
       => ( inj_on(B,A,G,B3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G),B3)),A2))
           => ? [H3: fun(A,B)] : bij_betw(A,B,H3,A2,B3) ) ) ) ) ).

% Schroeder_Bernstein
tff(fact_7635_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),S2: set(B),P: fun(set(A),bool)] :
      ( ! [T9: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T9),aa(set(B),set(A),image(B,A,F2),S2)))
         => pp(aa(set(A),bool,P,T9)) )
    <=> ! [T9: set(B)] :
          ( ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),T9),S2))
            & inj_on(B,A,F2,T9) )
         => pp(aa(set(A),bool,P,aa(set(B),set(A),image(B,A,F2),T9))) ) ) ).

% all_subset_image_inj
tff(fact_7636_inj__on__rev,axiom,
    ! [A: $tType,A2: set(list(A))] : inj_on(list(A),list(A),rev(A),A2) ).

% inj_on_rev
tff(fact_7637_inj__on__diff__nat,axiom,
    ! [N5: set(nat),K: nat] :
      ( ! [N2: nat] :
          ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),N2),N5))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N2)) )
     => inj_on(nat,nat,aTP_Lamp_pq(nat,fun(nat,nat),K),N5) ) ).

% inj_on_diff_nat
tff(fact_7638_inj__on__Cons1,axiom,
    ! [A: $tType,X3: A,A2: set(list(A))] : inj_on(list(A),list(A),cons(A,X3),A2) ).

% inj_on_Cons1
tff(fact_7639_inj__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => inj_on(nat,A,semiring_1_of_nat(A),top_top(set(nat))) ) ).

% inj_of_nat
tff(fact_7640_inj__Suc,axiom,
    ! [N5: set(nat)] : inj_on(nat,nat,suc,N5) ).

% inj_Suc
tff(fact_7641_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X7: fun(bool,A),Y3: fun(bool,A)] :
          ( pp(aa(fun(bool,A),bool,aa(fun(bool,A),fun(fun(bool,A),bool),ord_less_eq(fun(bool,A)),X7),Y3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(bool,A,X7,fFalse)),aa(bool,A,Y3,fFalse)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(bool,A,X7,fTrue)),aa(bool,A,Y3,fTrue))) ) ) ) ).

% le_rel_bool_arg_iff
tff(fact_7642_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
     => ? [N2: nat,F4: fun(nat,A)] :
          ( ( A2 = aa(set(nat),set(A),image(nat,A,F4),collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),N2))) )
          & inj_on(nat,A,F4,collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),N2))) ) ) ).

% finite_imp_nat_seg_image_inj_on
tff(fact_7643_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A2: set(A)] :
      ( finite_finite(A,A2)
     => ? [F4: fun(A,nat),N2: nat] :
          ( ( aa(set(A),set(nat),image(A,nat,F4),A2) = collect(nat,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),N2)) )
          & inj_on(A,nat,F4,A2) ) ) ).

% finite_imp_inj_to_nat_seg
tff(fact_7644_inj__on__nth,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] :
      ( distinct(A,Xs)
     => ( ! [X2: nat] :
            ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X2),I5))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X2),aa(list(A),nat,size_size(list(A)),Xs))) )
       => inj_on(nat,A,nth(A,Xs),I5) ) ) ).

% inj_on_nth
tff(fact_7645_infinite__countable__subset,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ~ finite_finite(A,S2)
     => ? [F4: fun(nat,A)] :
          ( inj_on(nat,A,F4,top_top(set(nat)))
          & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(nat),set(A),image(nat,A,F4),top_top(set(nat)))),S2)) ) ) ).

% infinite_countable_subset
tff(fact_7646_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ~ finite_finite(A,S2)
    <=> ? [F6: fun(nat,A)] :
          ( inj_on(nat,A,F6,top_top(set(nat)))
          & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(nat),set(A),image(nat,A,F6),top_top(set(nat)))),S2)) ) ) ).

% infinite_iff_countable_subset
tff(fact_7647_summable__reindex,axiom,
    ! [F2: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F2)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,X2)))
         => summable(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F2),G)) ) ) ) ).

% summable_reindex
tff(fact_7648_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F2: fun(A,A),S: A] :
      ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F2),S) = S )
     => ( ! [M3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M3))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
             => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M3),F2),S) != S ) ) )
       => inj_on(nat,A,aa(A,fun(nat,A),aTP_Lamp_ael(fun(A,A),fun(A,fun(nat,A)),F2),S),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% inj_on_funpow_least
tff(fact_7649_suminf__reindex__mono,axiom,
    ! [F2: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F2)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,X2)))
         => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),suminf(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F2),G))),suminf(real,F2))) ) ) ) ).

% suminf_reindex_mono
tff(fact_7650_inj__on__char__of__nat,axiom,
    inj_on(nat,char,unique5772411509450598832har_of(nat),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2))))))))))) ).

% inj_on_char_of_nat
tff(fact_7651_suminf__reindex,axiom,
    ! [F2: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F2)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X2: nat] : pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,X2)))
         => ( ! [X2: nat] :
                ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),X2),aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat)))))
               => ( aa(nat,real,F2,X2) = zero_zero(real) ) )
           => ( suminf(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F2),G)) = suminf(real,F2) ) ) ) ) ) ).

% suminf_reindex
tff(fact_7652_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),S2: set(B),P: fun(set(A),bool)] :
      ( ? [T9: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),T9),aa(set(B),set(A),image(B,A,F2),S2)))
          & pp(aa(set(A),bool,P,T9)) )
    <=> ? [T9: set(B)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),T9),S2))
          & inj_on(B,A,F2,T9)
          & pp(aa(set(A),bool,P,aa(set(B),set(A),image(B,A,F2),T9))) ) ) ).

% ex_subset_image_inj
tff(fact_7653_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: fun(A,B),C6: set(A),B3: set(A),X3: A] :
      ( inj_on(A,B,G,C6)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C6),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))))))
       => pp(aa(set(fun(B,A)),bool,aa(fun(B,A),fun(set(fun(B,A)),bool),member2(fun(B,A)),aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_aem(fun(A,B),fun(set(A),fun(A,fun(B,A))),G),C6),X3)),bNF_Wellorder_Func(B,A,top_top(set(B)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))))))) ) ) ).

% If_the_inv_into_in_Func
tff(fact_7654_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list(B),F2: fun(B,list(A))] : ( aa(list(A),set(A),set2(A),bind(B,A,Xs,F2)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_aen(fun(B,list(A)),fun(B,set(A)),F2)),aa(list(B),set(B),set2(B),Xs))) ) ).

% set_list_bind
tff(fact_7655_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,list(A))] : ( bind(B,A,nil(B),F2) = nil(A) ) ).

% bind_simps(1)
tff(fact_7656_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X3: B,Xs: list(B),F2: fun(B,list(A))] : ( bind(B,A,aa(list(B),list(B),cons(B,X3),Xs),F2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(B,list(A),F2,X3)),bind(B,A,Xs,F2)) ) ).

% bind_simps(2)
tff(fact_7657_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(A),F2: fun(A,list(B)),G: fun(A,list(B))] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
           => ( aa(A,list(B),F2,X2) = aa(A,list(B),G,X2) ) )
       => ( bind(A,B,Xs,F2) = bind(A,B,Ys2,G) ) ) ) ).

% list_bind_cong
tff(fact_7658_refl__ge__eq,axiom,
    ! [A: $tType,R4: fun(A,fun(A,bool))] :
      ( ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),R4,X2),X2))
     => pp(aa(fun(A,fun(A,bool)),bool,aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),bool),ord_less_eq(fun(A,fun(A,bool))),fequal(A)),R4)) ) ).

% refl_ge_eq
tff(fact_7659_ge__eq__refl,axiom,
    ! [A: $tType,R4: fun(A,fun(A,bool)),X3: A] :
      ( pp(aa(fun(A,fun(A,bool)),bool,aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),bool),ord_less_eq(fun(A,fun(A,bool))),fequal(A)),R4))
     => pp(aa(A,bool,aa(A,fun(A,bool),R4,X3),X3)) ) ).

% ge_eq_refl
tff(fact_7660_List_Obind__def,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F2: fun(A,list(B))] : ( bind(A,B,Xs,F2) = concat(B,aa(list(A),list(list(B)),map(A,list(B),F2),Xs)) ) ).

% List.bind_def
tff(fact_7661_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: fun(B,A),A15: set(B),B15: set(A),F22: fun(C,D),B23: set(C),A25: set(D)] :
      ( ( aa(set(B),set(A),image(B,A,F1),A15) = B15 )
     => ( inj_on(C,D,F22,B23)
       => ( pp(aa(set(D),bool,aa(set(D),fun(set(D),bool),ord_less_eq(set(D)),aa(set(C),set(D),image(C,D,F22),B23)),A25))
         => ( ( ( B23 = bot_bot(set(C)) )
             => ( A25 = bot_bot(set(D)) ) )
           => ( bNF_Wellorder_Func(C,A,B23,B15) = aa(set(fun(D,B)),set(fun(C,A)),image(fun(D,B),fun(C,A),bNF_We4925052301507509544nc_map(C,B,A,D,B23,F1,F22)),bNF_Wellorder_Func(D,B,A25,A15)) ) ) ) ) ) ).

% Func_map_surj
tff(fact_7662_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [X3: A,N: int,S2: set(A)] :
          ( ( X3 != zero_zero(A) )
         => has_derivative(A,A,aTP_Lamp_aeo(int,fun(A,A),N),aa(int,fun(A,A),aTP_Lamp_aep(A,fun(int,fun(A,A)),X3),N),topolo174197925503356063within(A,X3,S2)) ) ) ).

% has_derivative_power_int'
tff(fact_7663_power__int__1__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int] : ( power_int(A,one_one(A),N) = one_one(A) ) ) ).

% power_int_1_left
tff(fact_7664_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & monoid_mult(A) )
     => ! [Y4: A] : ( power_int(A,Y4,one_one(int)) = Y4 ) ) ).

% power_int_1_right
tff(fact_7665_power__int__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,N: int] : ( aa(A,A,sgn_sgn(A),power_int(A,A3,N)) = power_int(A,aa(A,A,sgn_sgn(A),A3),N) ) ) ).

% power_int_sgn
tff(fact_7666_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A,W: num,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),X3),aa(num,A,numeral_numeral(A),W)),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,M)),power_int(A,aa(num,A,numeral_numeral(A),W),M)) ) ) ).

% power_int_mult_distrib_numeral2
tff(fact_7667_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [W: num,Y4: A,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Y4),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(num,A,numeral_numeral(A),W),M)),power_int(A,Y4,M)) ) ) ).

% power_int_mult_distrib_numeral1
tff(fact_7668_power__int__0__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] :
          ( ( M != zero_zero(int) )
         => ( power_int(A,zero_zero(A),M) = zero_zero(A) ) ) ) ).

% power_int_0_left
tff(fact_7669_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,N: int] :
          ( ( power_int(A,X3,N) = zero_zero(A) )
        <=> ( ( X3 = zero_zero(A) )
            & ( N != zero_zero(int) ) ) ) ) ).

% power_int_eq_0_iff
tff(fact_7670_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( inverse(B)
        & power(B) )
     => ! [X3: B] : ( power_int(B,X3,zero_zero(int)) = one_one(B) ) ) ).

% power_int_0_right
tff(fact_7671_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,N: int] : ( aa(A,A,abs_abs(A),power_int(A,aa(A,A,uminus_uminus(A),A3),N)) = aa(A,A,abs_abs(A),power_int(A,A3,N)) ) ) ).

% abs_power_int_minus
tff(fact_7672_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [X3: A,N: nat] : ( power_int(A,X3,aa(nat,int,semiring_1_of_nat(int),N)) = aa(nat,A,power_power(A,X3),N) ) ) ).

% power_int_of_nat
tff(fact_7673_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: num,N: num] : ( power_int(A,power_int(A,X3,aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N)) = power_int(A,X3,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ) ).

% power_int_mult_numeral
tff(fact_7674_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),B2)) = B2 ) ) ).

% power_int_minus_one_mult_self'
tff(fact_7675_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)) = one_one(A) ) ) ).

% power_int_minus_one_mult_self
tff(fact_7676_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [X3: A,N: num] : ( power_int(A,X3,aa(num,int,numeral_numeral(int),N)) = aa(nat,A,power_power(A,X3),aa(num,nat,numeral_numeral(nat),N)) ) ) ).

% power_int_numeral
tff(fact_7677_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [X3: num,N: int,Y4: real] :
          ( ( power_int(A,aa(num,A,numeral_numeral(A),X3),N) = real_Vector_of_real(A,Y4) )
        <=> ( power_int(real,aa(num,real,numeral_numeral(real),X3),N) = Y4 ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
tff(fact_7678_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [Y4: real,X3: num,N: int] :
          ( ( real_Vector_of_real(A,Y4) = power_int(A,aa(num,A,numeral_numeral(A),X3),N) )
        <=> ( Y4 = power_int(real,aa(num,real,numeral_numeral(real),X3),N) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
tff(fact_7679_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & monoid_mult(A) )
     => ! [Y4: A] : ( power_int(A,Y4,aa(int,int,uminus_uminus(int),one_one(int))) = aa(A,A,inverse_inverse(A),Y4) ) ) ).

% power_int_minus1_right
tff(fact_7680_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,aa(num,int,numeral_numeral(int),M))),power_int(A,X3,aa(num,int,numeral_numeral(int),N))) = power_int(A,X3,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N))) ) ) ).

% power_int_add_numeral
tff(fact_7681_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: num,N: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,aa(num,int,numeral_numeral(int),M))),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,aa(num,int,numeral_numeral(int),N))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)))),B2) ) ) ).

% power_int_add_numeral2
tff(fact_7682_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,A3,N)),power_int(A,B2,N)))
              <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ) ) ).

% power_int_mono_iff
tff(fact_7683_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
         => ( power_int(A,aa(A,A,uminus_uminus(A),A3),N) = power_int(A,A3,N) ) ) ) ).

% power_int_minus_left_even
tff(fact_7684_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int,A3: A] :
          ( ~ pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
         => ( power_int(A,aa(A,A,uminus_uminus(A),A3),N) = aa(A,A,uminus_uminus(A),power_int(A,A3,N)) ) ) ) ).

% power_int_minus_left_odd
tff(fact_7685_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: num,N: num] : ( power_int(A,aa(num,A,numeral_numeral(A),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),pow(M,N))) ) ) ).

% power_int_numeral_neg_numeral
tff(fact_7686_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),power_int(A,X3,N))) ) ) ).

% zero_le_power_int
tff(fact_7687_power__int__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N5: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),N),N5))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,A3,N)),power_int(A,A3,N5))) ) ) ) ).

% power_int_increasing
tff(fact_7688_continuous__at__within__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [A3: A,S: set(A),F2: fun(A,B),N: int] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),F2)
         => ( ( aa(A,B,F2,A3) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A3,S),aa(int,fun(A,B),aTP_Lamp_aeq(fun(A,B),fun(int,fun(A,B)),F2),N)) ) ) ) ).

% continuous_at_within_power_int
tff(fact_7689_tendsto__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(B,A),A3: A,F3: filter(B),N: int] :
          ( filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,A3),F3)
         => ( ( A3 != zero_zero(A) )
           => filterlim(B,A,aa(int,fun(B,A),aTP_Lamp_aer(fun(B,A),fun(int,fun(B,A)),F2),N),topolo7230453075368039082e_nhds(A,power_int(A,A3,N)),F3) ) ) ) ).

% tendsto_power_int
tff(fact_7690_continuous__on__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F2: fun(A,B),N: int] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( ! [X2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),S))
               => ( aa(A,B,F2,X2) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aa(int,fun(A,B),aTP_Lamp_aes(fun(A,B),fun(int,fun(A,B)),F2),N)) ) ) ) ).

% continuous_on_power_int
tff(fact_7691_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] :
          ( ( ( M = zero_zero(int) )
           => ( power_int(A,zero_zero(A),M) = one_one(A) ) )
          & ( ( M != zero_zero(int) )
           => ( power_int(A,zero_zero(A),M) = zero_zero(A) ) ) ) ) ).

% power_int_0_left_If
tff(fact_7692_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),power_int(A,X3,N))) ) ) ).

% zero_less_power_int
tff(fact_7693_power__int__minus,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,N: int] : ( power_int(A,X3,aa(int,int,uminus_uminus(int),N)) = aa(A,A,inverse_inverse(A),power_int(A,X3,N)) ) ) ).

% power_int_minus
tff(fact_7694_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,N: int] :
          ( ( ( X3 != zero_zero(A) )
            | ( N = zero_zero(int) ) )
         => ( power_int(A,X3,N) != zero_zero(A) ) ) ) ).

% power_int_not_zero
tff(fact_7695_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A,Y4: A,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),Y4),M) = aa(A,A,aa(A,fun(A,A),divide_divide(A),power_int(A,X3,M)),power_int(A,Y4,M)) ) ) ).

% power_int_divide_distrib
tff(fact_7696_power__int__mult,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: int,N: int] : ( power_int(A,X3,aa(int,int,aa(int,fun(int,int),times_times(int),M),N)) = power_int(A,power_int(A,X3,M),N) ) ) ).

% power_int_mult
tff(fact_7697_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A,Y4: A,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,M)),power_int(A,Y4,M)) ) ) ).

% power_int_mult_distrib
tff(fact_7698_power__int__commutes,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,N: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,N)),X3) = aa(A,A,aa(A,fun(A,A),times_times(A),X3),power_int(A,X3,N)) ) ) ).

% power_int_commutes
tff(fact_7699_power__int__abs,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,N: int] : ( aa(A,A,abs_abs(A),power_int(A,A3,N)) = power_int(A,aa(A,A,abs_abs(A),A3),N) ) ) ).

% power_int_abs
tff(fact_7700_power__int__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,N: int] : ( power_int(A,aa(A,A,inverse_inverse(A),X3),N) = aa(A,A,inverse_inverse(A),power_int(A,X3,N)) ) ) ).

% power_int_inverse
tff(fact_7701_power__int__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,N: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),X3),N) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),power_int(A,X3,N)) ) ) ).

% power_int_one_over
tff(fact_7702_power__int__diff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A,M: int,N: int] :
          ( ( ( X3 != zero_zero(A) )
            | ( M != N ) )
         => ( power_int(A,X3,aa(int,int,aa(int,fun(int,int),minus_minus(int),M),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),power_int(A,X3,M)),power_int(A,X3,N)) ) ) ) ).

% power_int_diff
tff(fact_7703_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N5: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),N5))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,A3,N)),power_int(A,A3,N5))) ) ) ) ).

% power_int_strict_increasing
tff(fact_7704_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),X3: A,S: set(A),N: int] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X3,S))
         => ( ( aa(A,B,F2,X3) != zero_zero(B) )
           => differentiable(A,B,aa(int,fun(A,B),aTP_Lamp_aet(fun(A,B),fun(int,fun(A,B)),F2),N),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% differentiable_power_int
tff(fact_7705_continuous__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [F3: filter(A),F2: fun(A,B),N: int] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( ( aa(A,B,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_ze(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F3,aa(int,fun(A,B),aTP_Lamp_aeq(fun(A,B),fun(int,fun(A,B)),F2),N)) ) ) ) ).

% continuous_power_int
tff(fact_7706_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N5: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),N5))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,A3,N5)),power_int(A,A3,N))) ) ) ) ) ).

% power_int_strict_decreasing
tff(fact_7707_power__int__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,Y4: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,X3,N)),power_int(A,Y4,N))) ) ) ) ) ).

% power_int_mono
tff(fact_7708_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),zero_zero(int)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,B2,N)),power_int(A,A3,N))) ) ) ) ) ).

% power_int_strict_antimono
tff(fact_7709_one__le__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X3))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),power_int(A,X3,N))) ) ) ) ).

% one_le_power_int
tff(fact_7710_one__less__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),power_int(A,A3,N))) ) ) ) ).

% one_less_power_int
tff(fact_7711_power__int__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: int,N: int] :
          ( ( ( X3 != zero_zero(A) )
            | ( aa(int,int,aa(int,fun(int,int),plus_plus(int),M),N) != zero_zero(int) ) )
         => ( power_int(A,X3,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,M)),power_int(A,X3,N)) ) ) ) ).

% power_int_add
tff(fact_7712_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( division_ring(A)
        & one(B)
        & uminus(B) )
     => ! [X3: C,A3: A,N: int] :
          ( nO_MATCH(B,C,aa(B,B,uminus_uminus(B),one_one(B)),X3)
         => ( power_int(A,aa(A,A,uminus_uminus(A),A3),N) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),N)),power_int(A,A3,N)) ) ) ) ).

% power_int_minus_left_distrib
tff(fact_7713_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,A3,N)),power_int(A,B2,N))) ) ) ) ) ).

% power_int_strict_mono
tff(fact_7714_power__int__antimono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),zero_zero(int)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,B2,N)),power_int(A,A3,N))) ) ) ) ) ).

% power_int_antimono
tff(fact_7715_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N5: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),N),N5))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
             => ( ( ( A3 != zero_zero(A) )
                  | ( N5 != zero_zero(int) )
                  | ( N = zero_zero(int) ) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,A3,N5)),power_int(A,A3,N))) ) ) ) ) ) ).

% power_int_decreasing
tff(fact_7716_power__int__le__one,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X3))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,X3,N)),one_one(A))) ) ) ) ) ).

% power_int_le_one
tff(fact_7717_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,M: int,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,X3,M)),power_int(A,X3,N)))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),M),N)) ) ) ) ) ).

% power_int_le_imp_le_exp
tff(fact_7718_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X3: A,M: int,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,X3,M)),power_int(A,X3,N)))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),M),N)) ) ) ) ) ).

% power_int_le_imp_less_exp
tff(fact_7719_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X3: A,N: int] :
          ( ( ( X3 != zero_zero(A) )
            | ( N != zero_zero(int) ) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,aa(int,int,aa(int,fun(int,int),minus_minus(int),N),one_one(int)))),X3) = power_int(A,X3,N) ) ) ) ).

% power_int_minus_mult
tff(fact_7720_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int,A3: A] :
          ( ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
           => ( power_int(A,aa(A,A,uminus_uminus(A),A3),N) = power_int(A,A3,N) ) )
          & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
           => ( power_int(A,aa(A,A,uminus_uminus(A),A3),N) = aa(A,A,uminus_uminus(A),power_int(A,A3,N)) ) ) ) ) ).

% power_int_minus_left
tff(fact_7721_power__int__add__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: int] :
          ( ( ( X3 != zero_zero(A) )
            | ( M != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,X3,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X3,M)),X3) ) ) ) ).

% power_int_add_1
tff(fact_7722_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X3: A,M: int] :
          ( ( ( X3 != zero_zero(A) )
            | ( M != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,X3,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),X3),power_int(A,X3,M)) ) ) ) ).

% power_int_add_1'
tff(fact_7723_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: fun(A,B),A25: set(A),A15: set(B),F1: fun(B,C),B15: set(C),F22: fun(D,A),B23: set(D)] :
      ( pp(aa(set(fun(A,B)),bool,aa(fun(A,B),fun(set(fun(A,B)),bool),member2(fun(A,B)),G),bNF_Wellorder_Func(A,B,A25,A15)))
     => ( pp(aa(set(C),bool,aa(set(C),fun(set(C),bool),ord_less_eq(set(C)),aa(set(B),set(C),image(B,C,F1),A15)),B15))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(D),set(A),image(D,A,F22),B23)),A25))
         => pp(aa(set(fun(D,C)),bool,aa(fun(D,C),fun(set(fun(D,C)),bool),member2(fun(D,C)),aa(fun(A,B),fun(D,C),bNF_We4925052301507509544nc_map(D,B,C,A,B23,F1,F22),G)),bNF_Wellorder_Func(D,C,B23,B15))) ) ) ) ).

% Func_map
tff(fact_7724_power__int__def,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [N: int,X3: A] :
          ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => ( power_int(A,X3,N) = aa(nat,A,power_power(A,X3),aa(int,nat,nat2,N)) ) )
          & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => ( power_int(A,X3,N) = aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X3)),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),N))) ) ) ) ) ).

% power_int_def
tff(fact_7725_powr__real__of__int_H,axiom,
    ! [X3: real,N: int] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),X3))
     => ( ( ( X3 != zero_zero(real) )
          | pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N)) )
       => ( powr(real,X3,aa(int,real,ring_1_of_int(real),N)) = power_int(real,X3,N) ) ) ) ).

% powr_real_of_int'
tff(fact_7726_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D2: A,X3: A,S: set(A),N: int] :
          ( has_field_derivative(A,F2,D2,topolo174197925503356063within(A,X3,S))
         => ( ( aa(A,A,F2,X3) != zero_zero(A) )
           => has_field_derivative(A,aa(int,fun(A,A),aTP_Lamp_aeu(fun(A,A),fun(int,fun(A,A)),F2),N),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),N)),power_int(A,aa(A,A,F2,X3),aa(int,int,aa(int,fun(int,int),minus_minus(int),N),one_one(int))))),D2),topolo174197925503356063within(A,X3,S)) ) ) ) ).

% DERIV_power_int
tff(fact_7727_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V3459762299906320749_field(A) )
     => ! [F2: fun(C,A),X3: C,F8: fun(C,A),S2: set(C),N: int] :
          ( ( aa(C,A,F2,X3) != zero_zero(A) )
         => ( has_derivative(C,A,F2,F8,topolo174197925503356063within(C,X3,S2))
           => has_derivative(C,A,aa(int,fun(C,A),aTP_Lamp_aev(fun(C,A),fun(int,fun(C,A)),F2),N),aa(int,fun(C,A),aa(fun(C,A),fun(int,fun(C,A)),aa(C,fun(fun(C,A),fun(int,fun(C,A))),aTP_Lamp_aew(fun(C,A),fun(C,fun(fun(C,A),fun(int,fun(C,A)))),F2),X3),F8),N),topolo174197925503356063within(C,X3,S2)) ) ) ) ).

% has_derivative_power_int
tff(fact_7728_at__right__eq,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
         => ( topolo174197925503356063within(A,X3,set_ord_greaterThan(A,X3)) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aTP_Lamp_aex(A,fun(A,filter(A)),X3)),set_ord_greaterThan(A,X3))) ) ) ) ).

% at_right_eq
tff(fact_7729_at__left__eq,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
         => ( topolo174197925503356063within(A,X3,set_ord_lessThan(A,X3)) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aTP_Lamp_aey(A,fun(A,filter(A)),X3)),set_ord_lessThan(A,X3))) ) ) ) ).

% at_left_eq
tff(fact_7730_principal__le__iff,axiom,
    ! [A: $tType,A2: set(A),B3: set(A)] :
      ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),principal(A,A2)),principal(A,B3)))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3)) ) ).

% principal_le_iff
tff(fact_7731_le__principal,axiom,
    ! [A: $tType,F3: filter(A),A2: set(A)] :
      ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F3),principal(A,A2)))
    <=> eventually(A,aTP_Lamp_a(set(A),fun(A,bool),A2),F3) ) ).

% le_principal
tff(fact_7732_filterlim__base__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,I5: set(A),F3: fun(A,set(B)),F2: fun(B,C),G5: fun(D,set(C)),J5: set(D)] :
      ( ( I5 != bot_bot(set(A)) )
     => ( ! [I3: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),I3),I5))
           => ! [J2: A] :
                ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),J2),I5))
               => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F3,I3)),aa(A,set(B),F3,J2)))
                  | pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F3,J2)),aa(A,set(B),F3,I3))) ) ) )
       => ( filterlim(B,C,F2,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(D),set(filter(C)),image(D,filter(C),aTP_Lamp_aez(fun(D,set(C)),fun(D,filter(C)),G5)),J5)),aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),aTP_Lamp_afa(fun(A,set(B)),fun(A,filter(B)),F3)),I5)))
        <=> ! [X4: D] :
              ( pp(aa(set(D),bool,aa(D,fun(set(D),bool),member2(D),X4),J5))
             => ? [Xa4: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),I5))
                  & ! [Xb4: B] :
                      ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Xb4),aa(A,set(B),F3,Xa4)))
                     => pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),aa(B,C,F2,Xb4)),aa(D,set(C),G5,X4))) ) ) ) ) ) ) ).

% filterlim_base_iff
tff(fact_7733_at__infinity__def,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( at_infinity(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(real),set(filter(A)),image(real,filter(A),aTP_Lamp_afc(real,filter(A))),top_top(set(real)))) ) ) ).

% at_infinity_def
tff(fact_7734_nhds__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X3: A] : ( topolo7230453075368039082e_nhds(A,X3) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(real),set(filter(A)),image(real,filter(A),aTP_Lamp_afe(A,fun(real,filter(A)),X3)),set_ord_greaterThan(real,zero_zero(real)))) ) ) ).

% nhds_metric
tff(fact_7735_complete__uniform,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [S2: set(A)] :
          ( topolo2479028161051973599mplete(A,S2)
        <=> ! [F11: filter(A)] :
              ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F11),principal(A,S2)))
             => ( ( F11 != bot_bot(filter(A)) )
               => ( topolo6773858410816713723filter(A,F11)
                 => ? [X4: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),S2))
                      & pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F11),topolo7230453075368039082e_nhds(A,X4))) ) ) ) ) ) ) ).

% complete_uniform
tff(fact_7736_uniformity__dist,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ( topolo7806501430040627800ormity(A) = aa(set(filter(product_prod(A,A))),filter(product_prod(A,A)),complete_Inf_Inf(filter(product_prod(A,A))),aa(set(real),set(filter(product_prod(A,A))),image(real,filter(product_prod(A,A)),aTP_Lamp_afg(real,filter(product_prod(A,A)))),set_ord_greaterThan(real,zero_zero(real)))) ) ) ).

% uniformity_dist
tff(fact_7737_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [P6: fun(product_prod(A,A),bool)] :
              ( eventually(product_prod(A,A),P6,topolo7806501430040627800ormity(A))
             => ? [N6: nat] :
                ! [N3: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N6),N3))
                 => ! [M6: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N6),M6))
                     => pp(aa(product_prod(A,A),bool,P6,aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,X7,N3)),aa(nat,A,X7,M6)))) ) ) ) ) ) ).

% Cauchy_uniform_iff
tff(fact_7738_uniformity__complex__def,axiom,
    topolo7806501430040627800ormity(complex) = aa(set(filter(product_prod(complex,complex))),filter(product_prod(complex,complex)),complete_Inf_Inf(filter(product_prod(complex,complex))),aa(set(real),set(filter(product_prod(complex,complex))),image(real,filter(product_prod(complex,complex)),aTP_Lamp_afi(real,filter(product_prod(complex,complex)))),set_ord_greaterThan(real,zero_zero(real)))) ).

% uniformity_complex_def
tff(fact_7739_uniformity__real__def,axiom,
    topolo7806501430040627800ormity(real) = aa(set(filter(product_prod(real,real))),filter(product_prod(real,real)),complete_Inf_Inf(filter(product_prod(real,real))),aa(set(real),set(filter(product_prod(real,real))),image(real,filter(product_prod(real,real)),aTP_Lamp_afk(real,filter(product_prod(real,real)))),set_ord_greaterThan(real,zero_zero(real)))) ).

% uniformity_real_def
tff(fact_7740_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [P: fun(product_prod(A,A),bool)] :
          ( eventually(product_prod(A,A),P,topolo7806501430040627800ormity(A))
        <=> ? [E3: real] :
              ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),E3))
              & ! [X4: A,Y: A] :
                  ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,X4,Y)),E3))
                 => pp(aa(product_prod(A,A),bool,P,aa(A,product_prod(A,A),product_Pair(A,A,X4),Y))) ) ) ) ) ).

% eventually_uniformity_metric
tff(fact_7741_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( num_of_nat(aa(nat,nat,suc,N)) = inc(num_of_nat(N)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( num_of_nat(aa(nat,nat,suc,N)) = one2 ) ) ) ).

% num_of_nat.simps(2)
tff(fact_7742_nths__shift__lemma,axiom,
    ! [A: $tType,A2: set(nat),Xs: list(A),I: nat] : ( aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aTP_Lamp_afl(set(nat),fun(product_prod(A,nat),bool),A2)),zip(A,nat,Xs,upt(I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))))) = aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aa(nat,fun(product_prod(A,nat),bool),aTP_Lamp_afm(set(nat),fun(nat,fun(product_prod(A,nat),bool)),A2),I)),zip(A,nat,Xs,upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))))) ) ).

% nths_shift_lemma
tff(fact_7743_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] : ( num_of_nat(aa(num,nat,numeral_numeral(nat),Q2)) = Q2 ) ).

% num_of_nat_numeral_eq
tff(fact_7744_zip__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] :
      ( ( zip(A,B,Xs,Ys2) = nil(product_prod(A,B)) )
    <=> ( ( Xs = nil(A) )
        | ( Ys2 = nil(B) ) ) ) ).

% zip_eq_Nil_iff
tff(fact_7745_Nil__eq__zip__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] :
      ( ( nil(product_prod(A,B)) = zip(A,B,Xs,Ys2) )
    <=> ( ( Xs = nil(A) )
        | ( Ys2 = nil(B) ) ) ) ).

% Nil_eq_zip_iff
tff(fact_7746_zip__Nil,axiom,
    ! [B: $tType,A: $tType,Ys2: list(B)] : ( zip(A,B,nil(A),Ys2) = nil(product_prod(A,B)) ) ).

% zip_Nil
tff(fact_7747_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),zip(A,B,Xs,Ys2)) = Xs ) ) ).

% map_fst_zip
tff(fact_7748_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),zip(A,B,Xs,Ys2)) = Ys2 ) ) ).

% map_snd_zip
tff(fact_7749_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list(A),Y4: B,Ys2: list(B)] : ( zip(A,B,aa(list(A),list(A),cons(A,X3),Xs),aa(list(B),list(B),cons(B,Y4),Ys2)) = aa(list(product_prod(A,B)),list(product_prod(A,B)),cons(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,X3),Y4)),zip(A,B,Xs,Ys2)) ) ).

% zip_Cons_Cons
tff(fact_7750_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Us: list(B),Ys2: list(A),Vs: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Us) )
     => ( zip(A,B,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us),Vs)) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),zip(A,B,Xs,Us)),zip(A,B,Ys2,Vs)) ) ) ).

% zip_append
tff(fact_7751_nth__zip,axiom,
    ! [A: $tType,B: $tType,I: nat,Xs: list(A),Ys2: list(B)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),aa(list(B),nat,size_size(list(B)),Ys2)))
       => ( aa(nat,product_prod(A,B),nth(product_prod(A,B),zip(A,B,Xs,Ys2)),I) = aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Xs),I)),aa(nat,B,nth(B,Ys2),I)) ) ) ) ).

% nth_zip
tff(fact_7752_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B),Xy: product_prod(A,B),Xys: list(product_prod(A,B))] :
      ( ( zip(A,B,Xs,Ys2) = aa(list(product_prod(A,B)),list(product_prod(A,B)),cons(product_prod(A,B),Xy),Xys) )
     => ~ ! [X2: A,Xs4: list(A)] :
            ( ( Xs = aa(list(A),list(A),cons(A,X2),Xs4) )
           => ! [Y2: B,Ys5: list(B)] :
                ( ( Ys2 = aa(list(B),list(B),cons(B,Y2),Ys5) )
               => ( ( Xy = aa(B,product_prod(A,B),product_Pair(A,B,X2),Y2) )
                 => ( Xys != zip(A,B,Xs4,Ys5) ) ) ) ) ) ).

% zip_eq_ConsE
tff(fact_7753_zip__same,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,A3),B2)),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),zip(A,A,Xs,Xs))))
    <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),aa(list(A),set(A),set2(A),Xs)))
        & ( A3 = B2 ) ) ) ).

% zip_same
tff(fact_7754_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X3: A,Y4: B,Xs: list(A),Ys2: list(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X3),Y4)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys2))))
     => ~ ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
         => ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Y4),aa(list(B),set(B),set2(B),Ys2))) ) ) ).

% in_set_zipE
tff(fact_7755_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X3: A,Y4: B,Xs: list(A),Ys2: list(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X3),Y4)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys2))))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs))) ) ).

% set_zip_leftD
tff(fact_7756_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X3: A,Y4: B,Xs: list(A),Ys2: list(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X3),Y4)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys2))))
     => pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Y4),aa(list(B),set(B),set2(B),Ys2))) ) ).

% set_zip_rightD
tff(fact_7757_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),I: nat,X3: A,Ys2: list(B),Y4: B] : ( zip(A,B,list_update(A,Xs,I,X3),list_update(B,Ys2,I,Y4)) = list_update(product_prod(A,B),zip(A,B,Xs,Ys2),I,aa(B,product_prod(A,B),product_Pair(A,B,X3),Y4)) ) ).

% zip_update
tff(fact_7758_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list(A)] : ( zip(A,A,Xs,Xs) = aa(list(A),list(product_prod(A,A)),map(A,product_prod(A,A),aTP_Lamp_afn(A,product_prod(A,A))),Xs) ) ).

% zip_same_conv_map
tff(fact_7759_distinct__zipI1,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] :
      ( distinct(A,Xs)
     => distinct(product_prod(A,B),zip(A,B,Xs,Ys2)) ) ).

% distinct_zipI1
tff(fact_7760_distinct__zipI2,axiom,
    ! [B: $tType,A: $tType,Ys2: list(A),Xs: list(B)] :
      ( distinct(A,Ys2)
     => distinct(product_prod(B,A),zip(B,A,Xs,Ys2)) ) ).

% distinct_zipI2
tff(fact_7761_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( zip(A,B,aa(list(A),list(A),rev(A),Xs),aa(list(B),list(B),rev(B),Ys2)) = aa(list(product_prod(A,B)),list(product_prod(A,B)),rev(product_prod(A,B)),zip(A,B,Xs,Ys2)) ) ) ).

% zip_rev
tff(fact_7762_take__zip,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list(A),Ys2: list(B)] : ( take(product_prod(A,B),N,zip(A,B,Xs,Ys2)) = zip(A,B,take(A,N,Xs),take(B,N,Ys2)) ) ).

% take_zip
tff(fact_7763_zip_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Xs: list(A)] : ( zip(A,B,Xs,nil(B)) = nil(product_prod(A,B)) ) ).

% zip.simps(1)
tff(fact_7764_drop__zip,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list(A),Ys2: list(B)] : ( drop(product_prod(A,B),N,zip(A,B,Xs,Ys2)) = zip(A,B,drop(A,N,Xs),drop(B,N,Ys2)) ) ).

% drop_zip
tff(fact_7765_num__of__nat_Osimps_I1_J,axiom,
    num_of_nat(zero_zero(nat)) = one2 ).

% num_of_nat.simps(1)
tff(fact_7766_hd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] :
      ( ( Xs != nil(A) )
     => ( ( Ys2 != nil(B) )
       => ( aa(list(product_prod(A,B)),product_prod(A,B),hd(product_prod(A,B)),zip(A,B,Xs,Ys2)) = aa(B,product_prod(A,B),product_Pair(A,B,aa(list(A),A,hd(A),Xs)),aa(list(B),B,hd(B),Ys2)) ) ) ) ).

% hd_zip
tff(fact_7767_zip__map__fst__snd,axiom,
    ! [B: $tType,A: $tType,Zs: list(product_prod(A,B))] : ( zip(A,B,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Zs),aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),Zs)) = Zs ) ).

% zip_map_fst_snd
tff(fact_7768_update__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(B),I: nat,Xy: product_prod(A,B)] : ( list_update(product_prod(A,B),zip(A,B,Xs,Ys2),I,Xy) = zip(A,B,list_update(A,Xs,I,aa(product_prod(A,B),A,product_fst(A,B),Xy)),list_update(B,Ys2,I,aa(product_prod(A,B),B,product_snd(A,B),Xy))) ) ).

% update_zip
tff(fact_7769_zip__commute,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(B)] : ( zip(A,B,Xs,Ys2) = aa(list(product_prod(B,A)),list(product_prod(A,B)),map(product_prod(B,A),product_prod(A,B),product_case_prod(B,A,product_prod(A,B),aTP_Lamp_afo(B,fun(A,product_prod(A,B))))),zip(B,A,Ys2,Xs)) ) ).

% zip_commute
tff(fact_7770_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys2: list(B),Zs: list(C)] : ( zip(A,product_prod(B,C),Xs,zip(B,C,Ys2,Zs)) = aa(list(product_prod(B,product_prod(A,C))),list(product_prod(A,product_prod(B,C))),map(product_prod(B,product_prod(A,C)),product_prod(A,product_prod(B,C)),product_case_prod(B,product_prod(A,C),product_prod(A,product_prod(B,C)),aTP_Lamp_afq(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C)))))),zip(B,product_prod(A,C),Ys2,zip(A,C,Xs,Zs))) ) ).

% zip_left_commute
tff(fact_7771_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),Xs: list(A),Ys2: list(B)] : ( zip(A,B,takeWhile(A,P,Xs),Ys2) = takeWhile(product_prod(A,B),aa(fun(product_prod(A,B),A),fun(product_prod(A,B),bool),comp(A,bool,product_prod(A,B),P),product_fst(A,B)),zip(A,B,Xs,Ys2)) ) ).

% zip_takeWhile_fst
tff(fact_7772_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),P: fun(B,bool),Ys2: list(B)] : ( zip(A,B,Xs,takeWhile(B,P,Ys2)) = takeWhile(product_prod(A,B),aa(fun(product_prod(A,B),B),fun(product_prod(A,B),bool),comp(B,bool,product_prod(A,B),P),product_snd(A,B)),zip(A,B,Xs,Ys2)) ) ).

% zip_takeWhile_snd
tff(fact_7773_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(C,A),Xs: list(C),Ys2: list(B)] : ( zip(A,B,aa(list(C),list(A),map(C,A,F2),Xs),Ys2) = aa(list(product_prod(C,B)),list(product_prod(A,B)),map(product_prod(C,B),product_prod(A,B),product_case_prod(C,B,product_prod(A,B),aTP_Lamp_afr(fun(C,A),fun(C,fun(B,product_prod(A,B))),F2))),zip(C,B,Xs,Ys2)) ) ).

% zip_map1
tff(fact_7774_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),F2: fun(C,B),Ys2: list(C)] : ( zip(A,B,Xs,aa(list(C),list(B),map(C,B,F2),Ys2)) = aa(list(product_prod(A,C)),list(product_prod(A,B)),map(product_prod(A,C),product_prod(A,B),product_case_prod(A,C,product_prod(A,B),aTP_Lamp_afs(fun(C,B),fun(A,fun(C,product_prod(A,B))),F2))),zip(A,C,Xs,Ys2)) ) ).

% zip_map2
tff(fact_7775_zip__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,F2: fun(C,A),Xs: list(C),G: fun(D,B),Ys2: list(D)] : ( zip(A,B,aa(list(C),list(A),map(C,A,F2),Xs),aa(list(D),list(B),map(D,B,G),Ys2)) = aa(list(product_prod(C,D)),list(product_prod(A,B)),map(product_prod(C,D),product_prod(A,B),product_case_prod(C,D,product_prod(A,B),aa(fun(D,B),fun(C,fun(D,product_prod(A,B))),aTP_Lamp_aft(fun(C,A),fun(fun(D,B),fun(C,fun(D,product_prod(A,B)))),F2),G))),zip(C,D,Xs,Ys2)) ) ).

% zip_map_map
tff(fact_7776_map2__map__map,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,H: fun(B,fun(C,A)),F2: fun(D,B),Xs: list(D),G: fun(D,C)] : ( aa(list(product_prod(B,C)),list(A),map(product_prod(B,C),A,product_case_prod(B,C,A,H)),zip(B,C,aa(list(D),list(B),map(D,B,F2),Xs),aa(list(D),list(C),map(D,C,G),Xs))) = aa(list(D),list(A),map(D,A,aa(fun(D,C),fun(D,A),aa(fun(D,B),fun(fun(D,C),fun(D,A)),aTP_Lamp_afu(fun(B,fun(C,A)),fun(fun(D,B),fun(fun(D,C),fun(D,A))),H),F2),G)),Xs) ) ).

% map2_map_map
tff(fact_7777_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B),X3: A] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
       => ~ ! [Y2: B] : ~ pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X3),Y2)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys2)))) ) ) ).

% in_set_impl_in_set_zip1
tff(fact_7778_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B),Y4: B] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Y4),aa(list(B),set(B),set2(B),Ys2)))
       => ~ ! [X2: A] : ~ pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X2),Y4)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys2)))) ) ) ).

% in_set_impl_in_set_zip2
tff(fact_7779_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B),Zs: list(product_prod(A,B))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
     => ( ( zip(A,B,Xs,Ys2) = Zs )
      <=> ( ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Zs) = Xs )
          & ( aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),Zs) = Ys2 ) ) ) ) ).

% zip_eq_conv
tff(fact_7780_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(num,nat,numeral_numeral(nat),num_of_nat(N)) = N ) ) ).

% numeral_num_of_nat
tff(fact_7781_zip__replicate1,axiom,
    ! [A: $tType,B: $tType,N: nat,X3: A,Ys2: list(B)] : ( zip(A,B,replicate(A,N,X3),Ys2) = aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),product_Pair(A,B,X3)),take(B,N,Ys2)) ) ).

% zip_replicate1
tff(fact_7782_num__of__nat__One,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),one_one(nat)))
     => ( num_of_nat(N) = one2 ) ) ).

% num_of_nat_One
tff(fact_7783_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: fun(product_prod(B,C),A),Xs: list(B),G: fun(D,C),Ys2: list(D)] : ( aa(list(product_prod(B,C)),list(A),map(product_prod(B,C),A,F2),zip(B,C,Xs,aa(list(D),list(C),map(D,C,G),Ys2))) = aa(list(product_prod(B,D)),list(A),map(product_prod(B,D),A,product_case_prod(B,D,A,aa(fun(D,C),fun(B,fun(D,A)),aTP_Lamp_afv(fun(product_prod(B,C),A),fun(fun(D,C),fun(B,fun(D,A))),F2),G))),zip(B,D,Xs,Ys2)) ) ).

% map_zip_map2
tff(fact_7784_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: fun(product_prod(B,C),A),G: fun(D,B),Xs: list(D),Ys2: list(C)] : ( aa(list(product_prod(B,C)),list(A),map(product_prod(B,C),A,F2),zip(B,C,aa(list(D),list(B),map(D,B,G),Xs),Ys2)) = aa(list(product_prod(D,C)),list(A),map(product_prod(D,C),A,product_case_prod(D,C,A,aa(fun(D,B),fun(D,fun(C,A)),aTP_Lamp_afw(fun(product_prod(B,C),A),fun(fun(D,B),fun(D,fun(C,A))),F2),G))),zip(D,C,Xs,Ys2)) ) ).

% map_zip_map
tff(fact_7785_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),N: nat,Y4: B] : ( zip(A,B,Xs,replicate(B,N,Y4)) = aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_afo(B,fun(A,product_prod(A,B))),Y4)),take(A,N,Xs)) ) ).

% zip_replicate2
tff(fact_7786_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list(A),Ys2: list(B)] : ( zip(A,B,aa(list(A),list(A),cons(A,X3),Xs),Ys2) = aa(list(B),list(product_prod(A,B)),case_list(list(product_prod(A,B)),B,nil(product_prod(A,B)),aa(list(A),fun(B,fun(list(B),list(product_prod(A,B)))),aTP_Lamp_afx(A,fun(list(A),fun(B,fun(list(B),list(product_prod(A,B))))),X3),Xs)),Ys2) ) ).

% zip_Cons1
tff(fact_7787_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Y4: B,Ys2: list(B)] : ( zip(A,B,Xs,aa(list(B),list(B),cons(B,Y4),Ys2)) = aa(list(A),list(product_prod(A,B)),case_list(list(product_prod(A,B)),A,nil(product_prod(A,B)),aa(list(B),fun(A,fun(list(A),list(product_prod(A,B)))),aTP_Lamp_afy(B,fun(list(B),fun(A,fun(list(A),list(product_prod(A,B))))),Y4),Ys2)),Xs) ) ).

% zip_Cons
tff(fact_7788_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(num,A,numeral_numeral(A),num_of_nat(N)) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(num,A,numeral_numeral(A),num_of_nat(N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ) ) ).

% numeral_num_of_nat_unfold
tff(fact_7789_zip__append1,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(A),Zs: list(B)] : ( zip(A,B,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2),Zs) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),zip(A,B,Xs,take(B,aa(list(A),nat,size_size(list(A)),Xs),Zs))),zip(A,B,Ys2,drop(B,aa(list(A),nat,size_size(list(A)),Xs),Zs))) ) ).

% zip_append1
tff(fact_7790_zip__append2,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B),Zs: list(B)] : ( zip(A,B,Xs,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Ys2),Zs)) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),zip(A,B,take(A,aa(list(B),nat,size_size(list(B)),Ys2),Xs),Ys2)),zip(A,B,drop(A,aa(list(B),nat,size_size(list(B)),Ys2),Xs),Zs)) ) ).

% zip_append2
tff(fact_7791_num__of__nat__double,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( num_of_nat(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N)) = bit0(num_of_nat(N)) ) ) ).

% num_of_nat_double
tff(fact_7792_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => ( num_of_nat(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(num,num,aa(num,fun(num,num),plus_plus(num),num_of_nat(M)),num_of_nat(N)) ) ) ) ).

% num_of_nat_plus_distrib
tff(fact_7793_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: fun(nat,bool),Xs: list(A),Is: list(nat)] : ( aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aTP_Lamp_afz(fun(nat,bool),fun(product_prod(A,nat),bool),P)),zip(A,nat,Xs,Is))) = aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aTP_Lamp_aga(fun(nat,bool),fun(product_prod(A,nat),bool),P)),zip(A,nat,Xs,aa(list(nat),list(nat),map(nat,nat,suc),Is)))) ) ).

% nths_shift_lemma_Suc
tff(fact_7794_in__set__zip,axiom,
    ! [A: $tType,B: $tType,P2: product_prod(A,B),Xs: list(A),Ys2: list(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),P2),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys2))))
    <=> ? [N3: nat] :
          ( ( aa(nat,A,nth(A,Xs),N3) = aa(product_prod(A,B),A,product_fst(A,B),P2) )
          & ( aa(nat,B,nth(B,Ys2),N3) = aa(product_prod(A,B),B,product_snd(A,B),P2) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N3),aa(list(A),nat,size_size(list(A)),Xs)))
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N3),aa(list(B),nat,size_size(list(B)),Ys2))) ) ) ).

% in_set_zip
tff(fact_7795_nths__def,axiom,
    ! [A: $tType,Xs: list(A),A2: set(nat)] : ( nths(A,Xs,A2) = aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aTP_Lamp_afl(set(nat),fun(product_prod(A,nat),bool),A2)),zip(A,nat,Xs,upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))))) ) ).

% nths_def
tff(fact_7796_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3)) = one_one(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X3),one2))) ) ) ).

% eq_numeral_iff_iszero(7)
tff(fact_7797_nths__nil,axiom,
    ! [A: $tType,A2: set(nat)] : ( nths(A,nil(A),A2) = nil(A) ) ).

% nths_nil
tff(fact_7798_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: num] :
          ( ring_1_iszero(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),W)) ) ) ).

% iszero_neg_numeral
tff(fact_7799_nths__upt__eq__take,axiom,
    ! [A: $tType,L: list(A),N: nat] : ( nths(A,L,set_ord_lessThan(nat,N)) = take(A,N,L) ) ).

% nths_upt_eq_take
tff(fact_7800_nths__empty,axiom,
    ! [A: $tType,Xs: list(A)] : ( nths(A,Xs,bot_bot(set(nat))) = nil(A) ) ).

% nths_empty
tff(fact_7801_nths__singleton,axiom,
    ! [A: $tType,A2: set(nat),X3: A] :
      ( ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2))
       => ( nths(A,aa(list(A),list(A),cons(A,X3),nil(A)),A2) = aa(list(A),list(A),cons(A,X3),nil(A)) ) )
      & ( ~ pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2))
       => ( nths(A,aa(list(A),list(A),cons(A,X3),nil(A)),A2) = nil(A) ) ) ) ).

% nths_singleton
tff(fact_7802_nths__map,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B),I5: set(nat)] : ( nths(A,aa(list(B),list(A),map(B,A,F2),Xs),I5) = aa(list(B),list(A),map(B,A,F2),nths(B,Xs,I5)) ) ).

% nths_map
tff(fact_7803_inj__split__Cons,axiom,
    ! [A: $tType,X7: set(product_prod(list(A),A))] : inj_on(product_prod(list(A),A),list(A),product_case_prod(list(A),A,list(A),aTP_Lamp_qg(list(A),fun(A,list(A)))),X7) ).

% inj_split_Cons
tff(fact_7804_drop__eq__nths,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( drop(A,N,Xs) = nths(A,Xs,collect(nat,aa(nat,fun(nat,bool),ord_less_eq(nat),N))) ) ).

% drop_eq_nths
tff(fact_7805_sorted__nths,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I5: set(nat)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),nths(A,Xs,I5)) ) ) ).

% sorted_nths
tff(fact_7806_set__nths__subset,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),nths(A,Xs,I5))),aa(list(A),set(A),set2(A),Xs))) ).

% set_nths_subset
tff(fact_7807_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: num,Y4: num] :
          ( ( aa(num,A,numeral_numeral(A),X3) = aa(num,A,numeral_numeral(A),Y4) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,X3,Y4)) ) ) ).

% eq_numeral_iff_iszero(1)
tff(fact_7808_nths__all,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] :
      ( ! [I3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs)))
         => pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),I3),I5)) )
     => ( nths(A,Xs,I5) = Xs ) ) ).

% nths_all
tff(fact_7809_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: A,Y4: A] :
          ( ( X3 = Y4 )
        <=> ring_1_iszero(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Y4)) ) ) ).

% eq_iff_iszero_diff
tff(fact_7810_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [W: num] : ~ ring_1_iszero(A,aa(num,A,numeral_numeral(A),W)) ) ).

% not_iszero_numeral
tff(fact_7811_iszero__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] :
          ( ring_1_iszero(A,Z)
        <=> ( Z = zero_zero(A) ) ) ) ).

% iszero_def
tff(fact_7812_iszero__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ring_1_iszero(A,zero_zero(A)) ) ).

% iszero_0
tff(fact_7813_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,one_one(A)) ) ).

% not_iszero_1
tff(fact_7814_notin__set__nthsI,axiom,
    ! [A: $tType,X3: A,Xs: list(A),I5: set(nat)] :
      ( ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs)))
     => ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),nths(A,Xs,I5)))) ) ).

% notin_set_nthsI
tff(fact_7815_in__set__nthsD,axiom,
    ! [A: $tType,X3: A,Xs: list(A),I5: set(nat)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),nths(A,Xs,I5))))
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),aa(list(A),set(A),set2(A),Xs))) ) ).

% in_set_nthsD
tff(fact_7816_distinct__nthsI,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] :
      ( distinct(A,Xs)
     => distinct(A,nths(A,Xs,I5)) ) ).

% distinct_nthsI
tff(fact_7817_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_iszero_neg_1
tff(fact_7818_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(num,A,numeral_numeral(A),one2)) ) ).

% not_iszero_Numeral1
tff(fact_7819_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: num] :
          ( ( aa(num,A,numeral_numeral(A),X3) = zero_zero(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),X3)) ) ) ).

% eq_numeral_iff_iszero(9)
tff(fact_7820_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y4: num] :
          ( ( zero_zero(A) = aa(num,A,numeral_numeral(A),Y4) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Y4)) ) ) ).

% eq_numeral_iff_iszero(10)
tff(fact_7821_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys2: list(B),Zs: list(C)] : ( zip(A,product_prod(B,C),Xs,zip(B,C,Ys2,Zs)) = aa(list(product_prod(product_prod(A,B),C)),list(product_prod(A,product_prod(B,C))),map(product_prod(product_prod(A,B),C),product_prod(A,product_prod(B,C)),product_case_prod(product_prod(A,B),C,product_prod(A,product_prod(B,C)),product_case_prod(A,B,fun(C,product_prod(A,product_prod(B,C))),aTP_Lamp_agb(A,fun(B,fun(C,product_prod(A,product_prod(B,C)))))))),zip(product_prod(A,B),C,zip(A,B,Xs,Ys2),Zs)) ) ).

% zip_assoc
tff(fact_7822_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3)) = zero_zero(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),X3)) ) ) ).

% eq_numeral_iff_iszero(11)
tff(fact_7823_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y4: num] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y4)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Y4)) ) ) ).

% eq_numeral_iff_iszero(12)
tff(fact_7824_enumerate__eq__zip,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( enumerate(A,N,Xs) = zip(nat,A,upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(list(A),nat,size_size(list(A)),Xs))),Xs) ) ).

% enumerate_eq_zip
tff(fact_7825_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) ) ).

% not_iszero_neg_Numeral1
tff(fact_7826_nths__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A),I5: set(nat)] : ( nths(A,drop(A,N,Xs),I5) = nths(A,Xs,aa(set(nat),set(nat),image(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N)),I5)) ) ).

% nths_drop
tff(fact_7827_nths__append,axiom,
    ! [A: $tType,L: list(A),L4: list(A),A2: set(nat)] : ( nths(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),L),L4),A2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),nths(A,L,A2)),nths(A,L4,collect(nat,aa(set(nat),fun(nat,bool),aTP_Lamp_agc(list(A),fun(set(nat),fun(nat,bool)),L),A2)))) ) ).

% nths_append
tff(fact_7828_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: num,Y4: num] :
          ( ( aa(num,A,numeral_numeral(A),X3) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y4)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X3),Y4))) ) ) ).

% eq_numeral_iff_iszero(2)
tff(fact_7829_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: num,Y4: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3)) = aa(num,A,numeral_numeral(A),Y4) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X3),Y4))) ) ) ).

% eq_numeral_iff_iszero(3)
tff(fact_7830_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: num,Y4: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X3)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y4)) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,Y4,X3)) ) ) ).

% eq_numeral_iff_iszero(4)
tff(fact_7831_rat__floor__code,axiom,
    ! [P2: rat] : ( archim6421214686448440834_floor(rat,P2) = aa(product_prod(int,int),int,product_case_prod(int,int,int,divide_divide(int)),quotient_of(P2)) ) ).

% rat_floor_code
tff(fact_7832_filter__in__nths,axiom,
    ! [A: $tType,Xs: list(A),S: set(nat)] :
      ( distinct(A,Xs)
     => ( aa(list(A),list(A),filter2(A,aa(set(nat),fun(A,bool),aTP_Lamp_agd(list(A),fun(set(nat),fun(A,bool)),Xs),S)),Xs) = nths(A,Xs,S) ) ) ).

% filter_in_nths
tff(fact_7833_length__nths,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] : ( aa(list(A),nat,size_size(list(A)),nths(A,Xs,I5)) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(set(nat),fun(nat,bool),aTP_Lamp_age(list(A),fun(set(nat),fun(nat,bool)),Xs),I5))) ) ).

% length_nths
tff(fact_7834_Divides_Oadjust__div__def,axiom,
    ! [Qr: product_prod(int,int)] : ( adjust_div(Qr) = aa(product_prod(int,int),int,product_case_prod(int,int,int,aTP_Lamp_agf(int,fun(int,int))),Qr) ) ).

% Divides.adjust_div_def
tff(fact_7835_filter__eq__nths,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(list(A),list(A),filter2(A,P),Xs) = nths(A,Xs,collect(nat,aa(list(A),fun(nat,bool),aTP_Lamp_os(fun(A,bool),fun(list(A),fun(nat,bool)),P),Xs))) ) ).

% filter_eq_nths
tff(fact_7836_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X3: num] :
          ( ( aa(num,A,numeral_numeral(A),X3) = one_one(A) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,X3,one2)) ) ) ).

% eq_numeral_iff_iszero(5)
tff(fact_7837_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y4: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),Y4) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,one2,Y4)) ) ) ).

% eq_numeral_iff_iszero(6)
tff(fact_7838_nths__Cons,axiom,
    ! [A: $tType,X3: A,L: list(A),A2: set(nat)] : ( nths(A,aa(list(A),list(A),cons(A,X3),L),A2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),if(list(A),aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),zero_zero(nat)),A2),aa(list(A),list(A),cons(A,X3),nil(A)),nil(A))),nths(A,L,collect(nat,aTP_Lamp_agg(set(nat),fun(nat,bool),A2)))) ) ).

% nths_Cons
tff(fact_7839_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y4: num] :
          ( ( one_one(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y4)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Y4))) ) ) ).

% eq_numeral_iff_iszero(8)
tff(fact_7840_num__of__integer__code,axiom,
    ! [K: code_integer] :
      ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),one_one(code_integer)))
       => ( code_num_of_integer(K) = one2 ) )
      & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),one_one(code_integer)))
       => ( code_num_of_integer(K) = aa(product_prod(code_integer,code_integer),num,product_case_prod(code_integer,code_integer,num,aTP_Lamp_agh(code_integer,fun(code_integer,num))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))) ) ) ) ).

% num_of_integer_code
tff(fact_7841_extract__Cons__code,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A,Xs: list(A)] :
      ( ( pp(aa(A,bool,P,X3))
       => ( extract(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = some(product_prod(list(A),product_prod(A,list(A))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),product_Pair(list(A),product_prod(A,list(A)),nil(A)),aa(list(A),product_prod(A,list(A)),product_Pair(A,list(A),X3),Xs))) ) )
      & ( ~ pp(aa(A,bool,P,X3))
       => ( extract(A,P,aa(list(A),list(A),cons(A,X3),Xs)) = case_option(option(product_prod(list(A),product_prod(A,list(A)))),product_prod(list(A),product_prod(A,list(A))),none(product_prod(list(A),product_prod(A,list(A)))),product_case_prod(list(A),product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))),aTP_Lamp_agj(A,fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),X3)),extract(A,P,Xs)) ) ) ) ).

% extract_Cons_code
tff(fact_7842_lists__length__Suc__eq,axiom,
    ! [A: $tType,A2: set(A),N: nat] : ( collect(list(A),aa(nat,fun(list(A),bool),aTP_Lamp_agk(set(A),fun(nat,fun(list(A),bool)),A2),N)) = aa(set(product_prod(list(A),A)),set(list(A)),image(product_prod(list(A),A),list(A),product_case_prod(list(A),A,list(A),aTP_Lamp_qg(list(A),fun(A,list(A))))),product_Sigma(list(A),A,collect(list(A),aa(nat,fun(list(A),bool),aTP_Lamp_kt(set(A),fun(nat,fun(list(A),bool)),A2),N)),aTP_Lamp_agl(set(A),fun(list(A),set(A)),A2))) ) ).

% lists_length_Suc_eq
tff(fact_7843_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I5: set(B),P2: fun(B,A),I: B] :
          ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kx(set(B),fun(fun(B,A),fun(B,bool)),I5),P2)))
         => ( ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),I5))
             => ( groups1962203154675924110t_prod(B,A,P2,aa(set(B),set(B),insert2(B,I),I5)) = groups1962203154675924110t_prod(B,A,P2,I5) ) )
            & ( ~ pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I),I5))
             => ( groups1962203154675924110t_prod(B,A,P2,aa(set(B),set(B),insert2(B,I),I5)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,P2,I)),groups1962203154675924110t_prod(B,A,P2,I5)) ) ) ) ) ) ).

% prod.insert'
tff(fact_7844_set__product,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] : ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),product(A,B,Xs,Ys2)) = product_Sigma(A,B,aa(list(A),set(A),set2(A),Xs),aTP_Lamp_agm(list(B),fun(A,set(B)),Ys2)) ) ).

% set_product
tff(fact_7845_Ex__inj__on__UNION__Sigma,axiom,
    ! [A: $tType,B: $tType,A2: fun(B,set(A)),I5: set(B)] :
    ? [F4: fun(A,product_prod(B,A))] :
      ( inj_on(A,product_prod(B,A),F4,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A2),I5)))
      & pp(aa(set(product_prod(B,A)),bool,aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),bool),ord_less_eq(set(product_prod(B,A))),aa(set(A),set(product_prod(B,A)),image(A,product_prod(B,A),F4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A2),I5)))),product_Sigma(B,A,I5,A2))) ) ).

% Ex_inj_on_UNION_Sigma
tff(fact_7846_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A2: set(A),C6: set(B),B3: set(A),D4: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A2,aTP_Lamp_agn(set(B),fun(A,set(B)),C6))),product_Sigma(A,B,B3,aTP_Lamp_agn(set(B),fun(A,set(B)),D4))))
    <=> ( ( A2 = bot_bot(set(A)) )
        | ( C6 = bot_bot(set(B)) )
        | ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
          & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C6),D4)) ) ) ) ).

% times_subset_iff
tff(fact_7847_Sigma__mono,axiom,
    ! [B: $tType,A: $tType,A2: set(A),C6: set(A),B3: fun(A,set(B)),D4: fun(A,set(B))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),C6))
     => ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),A2))
           => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),B3,X2)),aa(A,set(B),D4,X2))) )
       => pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A2,B3)),product_Sigma(A,B,C6,D4))) ) ) ).

% Sigma_mono
tff(fact_7848_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,X3: A,C6: set(A),A2: set(B),B3: set(B)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),C6))
     => ( pp(aa(set(product_prod(B,A)),bool,aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),bool),ord_less_eq(set(product_prod(B,A))),product_Sigma(B,A,A2,aTP_Lamp_ago(set(A),fun(B,set(A)),C6))),product_Sigma(B,A,B3,aTP_Lamp_ago(set(A),fun(B,set(A)),C6))))
      <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A2),B3)) ) ) ).

% Times_subset_cancel2
tff(fact_7849_relcomp__subset__Sigma,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: set(product_prod(A,B)),A2: set(A),B3: set(B),S: set(product_prod(B,C)),C6: set(C)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R2),product_Sigma(A,B,A2,aTP_Lamp_agn(set(B),fun(A,set(B)),B3))))
     => ( pp(aa(set(product_prod(B,C)),bool,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),bool),ord_less_eq(set(product_prod(B,C))),S),product_Sigma(B,C,B3,aTP_Lamp_agp(set(C),fun(B,set(C)),C6))))
       => pp(aa(set(product_prod(A,C)),bool,aa(set(product_prod(A,C)),fun(set(product_prod(A,C)),bool),ord_less_eq(set(product_prod(A,C))),relcomp(A,B,C,R2,S)),product_Sigma(A,C,A2,aTP_Lamp_agq(set(C),fun(A,set(C)),C6)))) ) ) ).

% relcomp_subset_Sigma
tff(fact_7850_open__prod__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S2: set(product_prod(A,B))] :
          ( ! [X2: product_prod(A,B)] :
              ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),X2),S2))
             => ? [A16: set(A),B9: set(B)] :
                  ( topolo1002775350975398744n_open(A,A16)
                  & topolo1002775350975398744n_open(B,B9)
                  & pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),X2),product_Sigma(A,B,A16,aTP_Lamp_agr(set(B),fun(A,set(B)),B9))))
                  & pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A16,aTP_Lamp_agr(set(B),fun(A,set(B)),B9))),S2)) ) )
         => topolo1002775350975398744n_open(product_prod(A,B),S2) ) ) ).

% open_prod_intro
tff(fact_7851_open__prod__elim,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S2: set(product_prod(A,B)),X3: product_prod(A,B)] :
          ( topolo1002775350975398744n_open(product_prod(A,B),S2)
         => ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),X3),S2))
           => ~ ! [A7: set(A)] :
                  ( topolo1002775350975398744n_open(A,A7)
                 => ! [B8: set(B)] :
                      ( topolo1002775350975398744n_open(B,B8)
                     => ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),X3),product_Sigma(A,B,A7,aTP_Lamp_agr(set(B),fun(A,set(B)),B8))))
                       => ~ pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A7,aTP_Lamp_agr(set(B),fun(A,set(B)),B8))),S2)) ) ) ) ) ) ) ).

% open_prod_elim
tff(fact_7852_open__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S2: set(product_prod(A,B))] :
          ( topolo1002775350975398744n_open(product_prod(A,B),S2)
        <=> ! [X4: product_prod(A,B)] :
              ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),X4),S2))
             => ? [A14: set(A)] :
                  ( topolo1002775350975398744n_open(A,A14)
                  & ? [B10: set(B)] :
                      ( topolo1002775350975398744n_open(B,B10)
                      & pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),X4),product_Sigma(A,B,A14,aTP_Lamp_agr(set(B),fun(A,set(B)),B10))))
                      & pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A14,aTP_Lamp_agr(set(B),fun(A,set(B)),B10))),S2)) ) ) ) ) ) ).

% open_prod_def
tff(fact_7853_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A2: set(A),B3: set(B)] : ( aa(set(product_prod(A,B)),nat,finite_card(product_prod(A,B)),product_Sigma(A,B,A2,aTP_Lamp_agn(set(B),fun(A,set(B)),B3))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(A),nat,finite_card(A),A2)),aa(set(B),nat,finite_card(B),B3)) ) ).

% card_cartesian_product
tff(fact_7854_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I5: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,I5)
         => ( groups1962203154675924110t_prod(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_he(fun(B,A),fun(fun(B,A),fun(B,A)),G),H),I5) = aa(A,A,aa(A,fun(A,A),times_times(A),groups1962203154675924110t_prod(B,A,G,I5)),groups1962203154675924110t_prod(B,A,H,I5)) ) ) ) ).

% prod.distrib_triv'
tff(fact_7855_Restr__subset,axiom,
    ! [A: $tType,A2: set(A),B3: set(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),B3))
     => ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B3,aTP_Lamp_ags(set(A),fun(A,set(A)),B3)))),product_Sigma(A,A,A2,aTP_Lamp_ags(set(A),fun(A,set(A)),A2))) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A2,aTP_Lamp_ags(set(A),fun(A,set(A)),A2))) ) ) ).

% Restr_subset
tff(fact_7856_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T6: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
               => ( aa(B,A,G,X2) = one_one(A) ) )
           => ( groups1962203154675924110t_prod(B,A,G,S2) = groups1962203154675924110t_prod(B,A,G,T6) ) ) ) ) ).

% prod.mono_neutral_left'
tff(fact_7857_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T6: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
               => ( aa(B,A,G,X2) = one_one(A) ) )
           => ( groups1962203154675924110t_prod(B,A,G,T6) = groups1962203154675924110t_prod(B,A,G,S2) ) ) ) ) ).

% prod.mono_neutral_right'
tff(fact_7858_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T6: set(B),H: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
               => ( aa(B,A,H,I3) = one_one(A) ) )
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                 => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
             => ( groups1962203154675924110t_prod(B,A,G,S2) = groups1962203154675924110t_prod(B,A,H,T6) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
tff(fact_7859_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T6: set(B),G: fun(B,A),H: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T6))
         => ( ! [X2: B] :
                ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T6),S2)))
               => ( aa(B,A,G,X2) = one_one(A) ) )
           => ( ! [X2: B] :
                  ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),X2),S2))
                 => ( aa(B,A,G,X2) = aa(B,A,H,X2) ) )
             => ( groups1962203154675924110t_prod(B,A,G,T6) = groups1962203154675924110t_prod(B,A,H,S2) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
tff(fact_7860_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I5: set(B),G: fun(B,A),H: fun(B,A)] :
          ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kx(set(B),fun(fun(B,A),fun(B,bool)),I5),G)))
         => ( finite_finite(B,collect(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_kx(set(B),fun(fun(B,A),fun(B,bool)),I5),H)))
           => ( groups1962203154675924110t_prod(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_he(fun(B,A),fun(fun(B,A),fun(B,A)),G),H),I5) = aa(A,A,aa(A,fun(A,A),times_times(A),groups1962203154675924110t_prod(B,A,G,I5)),groups1962203154675924110t_prod(B,A,H,I5)) ) ) ) ) ).

% prod.distrib'
tff(fact_7861_subset__fst__imageI,axiom,
    ! [B: $tType,A: $tType,A2: set(A),B3: set(B),S2: set(product_prod(A,B)),Y4: B] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A2,aTP_Lamp_agn(set(B),fun(A,set(B)),B3))),S2))
     => ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Y4),B3))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),aa(set(product_prod(A,B)),set(A),image(product_prod(A,B),A,product_fst(A,B)),S2))) ) ) ).

% subset_fst_imageI
tff(fact_7862_subset__snd__imageI,axiom,
    ! [B: $tType,A: $tType,A2: set(A),B3: set(B),S2: set(product_prod(A,B)),X3: A] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A2,aTP_Lamp_agn(set(B),fun(A,set(B)),B3))),S2))
     => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X3),A2))
       => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(set(product_prod(A,B)),set(B),image(product_prod(A,B),B,product_snd(A,B)),S2))) ) ) ).

% subset_snd_imageI
tff(fact_7863_subset__fst__snd,axiom,
    ! [B: $tType,A: $tType,A2: set(product_prod(A,B))] : pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),A2),product_Sigma(A,B,aa(set(product_prod(A,B)),set(A),image(product_prod(A,B),A,product_fst(A,B)),A2),aTP_Lamp_agt(set(product_prod(A,B)),fun(A,set(B)),A2)))) ).

% subset_fst_snd
tff(fact_7864_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A2: set(A),F2: fun(A,B),B3: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),bNF_Gr(A,B,A2,F2)),product_Sigma(A,B,A2,aTP_Lamp_agn(set(B),fun(A,set(B)),B3))))
    <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F2),A2)),B3)) ) ).

% Gr_incl
tff(fact_7865_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y4: bool] :
      ( ( vEBT_VEBT_valid(X3,Xa)
      <=> pp(Y4) )
     => ( ( ? [Uu2: bool,Uv2: bool] : ( X3 = vEBT_Leaf(Uu2,Uv2) )
         => ( pp(Y4)
          <=> ( Xa != one_one(nat) ) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
              ( ( X3 = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
             => ( pp(Y4)
              <=> ~ ( ( Deg2 = Xa )
                    & ! [X4: vEBT_VEBT] :
                        ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                       => vEBT_VEBT_valid(X4,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
                    & vEBT_VEBT_valid(Summary2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
                    & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                    & pp(case_option(bool,product_prod(nat,nat),fconj(aa(bool,bool,fNot,aa(fun(nat,bool),bool,fEx(nat),aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2))),fAll(vEBT_VEBT,combs(vEBT_VEBT,bool,bool,combb(bool,fun(bool,bool),vEBT_VEBT,fimplies,combc(vEBT_VEBT,set(vEBT_VEBT),bool,member2(vEBT_VEBT),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))),combb(bool,bool,vEBT_VEBT,fNot,combb(fun(nat,bool),bool,vEBT_VEBT,fEx(nat),vEBT_V8194947554948674370ptions))))),product_case_prod(nat,nat,bool,aa(vEBT_VEBT,fun(nat,fun(nat,bool)),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool))),aTP_Lamp_agu(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool)))),Deg2),TreeList2),Summary2)),Mima)) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
tff(fact_7866_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo7761053866217962861closed(product_prod(A,A),collect(product_prod(A,A),aTP_Lamp_agv(product_prod(A,A),bool))) ) ).

% closed_subdiagonal
tff(fact_7867_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo7761053866217962861closed(product_prod(A,A),collect(product_prod(A,A),aTP_Lamp_agw(product_prod(A,A),bool))) ) ).

% closed_superdiagonal
tff(fact_7868_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo1002775350975398744n_open(product_prod(A,A),collect(product_prod(A,A),aTP_Lamp_agx(product_prod(A,A),bool))) ) ).

% open_subdiagonal
tff(fact_7869_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo1002775350975398744n_open(product_prod(A,A),collect(product_prod(A,A),aTP_Lamp_agy(product_prod(A,A),bool))) ) ).

% open_superdiagonal
tff(fact_7870_set__Cons__def,axiom,
    ! [A: $tType,A2: set(A),XS: set(list(A))] : ( set_Cons(A,A2,XS) = collect(list(A),aa(set(list(A)),fun(list(A),bool),aTP_Lamp_agz(set(A),fun(set(list(A)),fun(list(A),bool)),A2),XS)) ) ).

% set_Cons_def
tff(fact_7871_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X3: fun(A,fun(A,bool)),Xa: list(A)] :
      ( ~ sorted_wrt(A,X3,Xa)
     => ~ ! [X2: A,Ys3: list(A)] :
            ( ( Xa = aa(list(A),list(A),cons(A,X2),Ys3) )
           => ( ! [Xa3: A] :
                  ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa3),aa(list(A),set(A),set2(A),Ys3)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),X3,X2),Xa3)) )
              & sorted_wrt(A,X3,Ys3) ) ) ) ).

% sorted_wrt.elims(3)
tff(fact_7872_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),X3: A,Ys2: list(A)] :
      ( sorted_wrt(A,P,aa(list(A),list(A),cons(A,X3),Ys2))
    <=> ( ! [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Ys2)))
           => pp(aa(A,bool,aa(A,fun(A,bool),P,X3),X4)) )
        & sorted_wrt(A,P,Ys2) ) ) ).

% sorted_wrt.simps(2)
tff(fact_7873_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ord(A)
     => order_mono(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)),aTP_Lamp_aha(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)))) ) ).

% lexordp.mono
tff(fact_7874_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool))] : order_mono(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)),aTP_Lamp_ahb(fun(A,fun(A,bool)),fun(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool))),Less)) ).

% ord.lexordp.mono
tff(fact_7875_Ball__Collect,axiom,
    ! [A: $tType,A2: set(A),P: fun(A,bool)] :
      ( ! [X4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),A2))
         => pp(aa(A,bool,P,X4)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A2),collect(A,P))) ) ).

% Ball_Collect
tff(fact_7876_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),A2) = aa(set(A),A,complete_Sup_Sup(A),collect(A,aTP_Lamp_ahc(set(A),fun(A,bool),A2))) ) ) ).

% Inf_eq_Sup
tff(fact_7877_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),A2) = aa(set(A),A,complete_Inf_Inf(A),collect(A,aTP_Lamp_ahd(set(A),fun(A,bool),A2))) ) ) ).

% Sup_eq_Inf
tff(fact_7878_listrel1__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( listrel1(A,R2) = collect(product_prod(list(A),list(A)),product_case_prod(list(A),list(A),bool,aTP_Lamp_ahe(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R2))) ) ).

% listrel1_def
tff(fact_7879_lex__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lex(A,R2) = collect(product_prod(list(A),list(A)),product_case_prod(list(A),list(A),bool,aTP_Lamp_ahf(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R2))) ) ).

% lex_conv
tff(fact_7880_takeWhile__append,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),Ys2: list(A)] :
      ( ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
           => pp(aa(A,bool,P,X2)) )
       => ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),takeWhile(A,P,Ys2)) ) )
      & ( ~ ! [X: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,P,X)) )
       => ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = takeWhile(A,P,Xs) ) ) ) ).

% takeWhile_append
tff(fact_7881_dropWhile__append,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),Ys2: list(A)] :
      ( ( ! [X2: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
           => pp(aa(A,bool,P,X2)) )
       => ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = dropWhile(A,P,Ys2) ) )
      & ( ~ ! [X: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,P,X)) )
       => ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),dropWhile(A,P,Xs)),Ys2) ) ) ) ).

% dropWhile_append
tff(fact_7882_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X3: fun(A,fun(A,bool)),Xa: list(A)] :
      ( sorted_wrt(A,X3,Xa)
     => ( ( Xa != nil(A) )
       => ~ ! [X2: A,Ys3: list(A)] :
              ( ( Xa = aa(list(A),list(A),cons(A,X2),Ys3) )
             => ~ ( ! [Xa2: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),aa(list(A),set(A),set2(A),Ys3)))
                     => pp(aa(A,bool,aa(A,fun(A,bool),X3,X2),Xa2)) )
                  & sorted_wrt(A,X3,Ys3) ) ) ) ) ).

% sorted_wrt.elims(2)
tff(fact_7883_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X3: fun(A,fun(A,bool)),Xa: list(A),Y4: bool] :
      ( ( sorted_wrt(A,X3,Xa)
      <=> pp(Y4) )
     => ( ( ( Xa = nil(A) )
         => ~ pp(Y4) )
       => ~ ! [X2: A,Ys3: list(A)] :
              ( ( Xa = aa(list(A),list(A),cons(A,X2),Ys3) )
             => ( pp(Y4)
              <=> ~ ( ! [Xa4: A] :
                        ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),aa(list(A),set(A),set2(A),Ys3)))
                       => pp(aa(A,bool,aa(A,fun(A,bool),X3,X2),Xa4)) )
                    & sorted_wrt(A,X3,Ys3) ) ) ) ) ) ).

% sorted_wrt.elims(1)
tff(fact_7884_set__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),Xs) = collect(A,aTP_Lamp_ahg(list(A),fun(A,bool),Xs)) ) ).

% set_conv_nth
tff(fact_7885_pairs__le__eq__Sigma,axiom,
    ! [M: nat] : ( collect(product_prod(nat,nat),product_case_prod(nat,nat,bool,aTP_Lamp_ig(nat,fun(nat,fun(nat,bool)),M))) = product_Sigma(nat,nat,set_ord_atMost(nat,M),aTP_Lamp_ahh(nat,fun(nat,set(nat)),M)) ) ).

% pairs_le_eq_Sigma
tff(fact_7886_set__nths,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] : ( aa(list(A),set(A),set2(A),nths(A,Xs,I5)) = collect(A,aa(set(nat),fun(A,bool),aTP_Lamp_ahi(list(A),fun(set(nat),fun(A,bool)),Xs),I5)) ) ).

% set_nths
tff(fact_7887_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,Deg4: nat] :
      ( vEBT_VEBT_valid(vEBT_Node(Mima2,Deg,TreeList,Summary),Deg4)
    <=> ( ( Deg = Deg4 )
        & ! [X4: vEBT_VEBT] :
            ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList)))
           => vEBT_VEBT_valid(X4,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
        & vEBT_VEBT_valid(Summary,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
        & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
        & pp(case_option(bool,product_prod(nat,nat),fconj(aa(bool,bool,fNot,aa(fun(nat,bool),bool,fEx(nat),aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary))),fAll(vEBT_VEBT,combs(vEBT_VEBT,bool,bool,combb(bool,fun(bool,bool),vEBT_VEBT,fimplies,combc(vEBT_VEBT,set(vEBT_VEBT),bool,member2(vEBT_VEBT),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))),combb(bool,bool,vEBT_VEBT,fNot,combb(fun(nat,bool),bool,vEBT_VEBT,fEx(nat),vEBT_V8194947554948674370ptions))))),product_case_prod(nat,nat,bool,aa(vEBT_VEBT,fun(nat,fun(nat,bool)),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool))),aTP_Lamp_agu(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool)))),Deg),TreeList),Summary)),Mima2)) ) ) ).

% VEBT_internal.valid'.simps(2)
tff(fact_7888_funpow__inj__finite,axiom,
    ! [A: $tType,P2: fun(A,A),X3: A] :
      ( inj_on(A,A,P2,top_top(set(A)))
     => ( finite_finite(A,collect(A,aa(A,fun(A,bool),aTP_Lamp_ahj(fun(A,A),fun(A,fun(A,bool)),P2),X3)))
       => ~ ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
             => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N2),P2),X3) != X3 ) ) ) ) ).

% funpow_inj_finite
tff(fact_7889_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_VEBT_valid(X3,Xa)
     => ( ( ? [Uu2: bool,Uv2: bool] : ( X3 = vEBT_Leaf(Uu2,Uv2) )
         => ( Xa = one_one(nat) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
              ( ( X3 = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
             => ( ( Deg2 = Xa )
                & ! [X2: vEBT_VEBT] :
                    ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                   => vEBT_VEBT_valid(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
                & vEBT_VEBT_valid(Summary2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
                & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                & pp(case_option(bool,product_prod(nat,nat),fconj(aa(bool,bool,fNot,aa(fun(nat,bool),bool,fEx(nat),aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2))),fAll(vEBT_VEBT,combs(vEBT_VEBT,bool,bool,combb(bool,fun(bool,bool),vEBT_VEBT,fimplies,combc(vEBT_VEBT,set(vEBT_VEBT),bool,member2(vEBT_VEBT),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))),combb(bool,bool,vEBT_VEBT,fNot,combb(fun(nat,bool),bool,vEBT_VEBT,fEx(nat),vEBT_V8194947554948674370ptions))))),product_case_prod(nat,nat,bool,aa(vEBT_VEBT,fun(nat,fun(nat,bool)),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool))),aTP_Lamp_agu(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool)))),Deg2),TreeList2),Summary2)),Mima)) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
tff(fact_7890_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_valid(X3,Xa)
     => ( ( ? [Uu2: bool,Uv2: bool] : ( X3 = vEBT_Leaf(Uu2,Uv2) )
         => ( Xa != one_one(nat) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
              ( ( X3 = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
             => ~ ( ( Deg2 = Xa )
                  & ! [X: vEBT_VEBT] :
                      ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                     => vEBT_VEBT_valid(X,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
                  & vEBT_VEBT_valid(Summary2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
                  & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                  & pp(case_option(bool,product_prod(nat,nat),fconj(aa(bool,bool,fNot,aa(fun(nat,bool),bool,fEx(nat),aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2))),fAll(vEBT_VEBT,combs(vEBT_VEBT,bool,bool,combb(bool,fun(bool,bool),vEBT_VEBT,fimplies,combc(vEBT_VEBT,set(vEBT_VEBT),bool,member2(vEBT_VEBT),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))),combb(bool,bool,vEBT_VEBT,fNot,combb(fun(nat,bool),bool,vEBT_VEBT,fEx(nat),vEBT_V8194947554948674370ptions))))),product_case_prod(nat,nat,bool,aa(vEBT_VEBT,fun(nat,fun(nat,bool)),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool))),aTP_Lamp_agu(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool)))),Deg2),TreeList2),Summary2)),Mima)) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
tff(fact_7891_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y4: bool] :
      ( ( vEBT_VEBT_valid(X3,Xa)
      <=> pp(Y4) )
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [Uu2: bool,Uv2: bool] :
              ( ( X3 = vEBT_Leaf(Uu2,Uv2) )
             => ( ( pp(Y4)
                <=> ( Xa = one_one(nat) ) )
               => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa))) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
               => ( ( pp(Y4)
                  <=> ( ( Deg2 = Xa )
                      & ! [X4: vEBT_VEBT] :
                          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                         => vEBT_VEBT_valid(X4,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
                      & vEBT_VEBT_valid(Summary2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
                      & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                      & pp(case_option(bool,product_prod(nat,nat),fconj(aa(bool,bool,fNot,aa(fun(nat,bool),bool,fEx(nat),aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2))),fAll(vEBT_VEBT,combs(vEBT_VEBT,bool,bool,combb(bool,fun(bool,bool),vEBT_VEBT,fimplies,combc(vEBT_VEBT,set(vEBT_VEBT),bool,member2(vEBT_VEBT),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))),combb(bool,bool,vEBT_VEBT,fNot,combb(fun(nat,bool),bool,vEBT_VEBT,fEx(nat),vEBT_V8194947554948674370ptions))))),product_case_prod(nat,nat,bool,aa(vEBT_VEBT,fun(nat,fun(nat,bool)),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool))),aTP_Lamp_agu(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool)))),Deg2),TreeList2),Summary2)),Mima)) ) )
                 => ~ pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg2,TreeList2,Summary2)),Xa))) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
tff(fact_7892_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_valid(X3,Xa)
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [Uu2: bool,Uv2: bool] :
              ( ( X3 = vEBT_Leaf(Uu2,Uv2) )
             => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa)))
               => ( Xa != one_one(nat) ) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
               => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg2,TreeList2,Summary2)),Xa)))
                 => ~ ( ( Deg2 = Xa )
                      & ! [X: vEBT_VEBT] :
                          ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                         => vEBT_VEBT_valid(X,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
                      & vEBT_VEBT_valid(Summary2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
                      & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                      & pp(case_option(bool,product_prod(nat,nat),fconj(aa(bool,bool,fNot,aa(fun(nat,bool),bool,fEx(nat),aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2))),fAll(vEBT_VEBT,combs(vEBT_VEBT,bool,bool,combb(bool,fun(bool,bool),vEBT_VEBT,fimplies,combc(vEBT_VEBT,set(vEBT_VEBT),bool,member2(vEBT_VEBT),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))),combb(bool,bool,vEBT_VEBT,fNot,combb(fun(nat,bool),bool,vEBT_VEBT,fEx(nat),vEBT_V8194947554948674370ptions))))),product_case_prod(nat,nat,bool,aa(vEBT_VEBT,fun(nat,fun(nat,bool)),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool))),aTP_Lamp_agu(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool)))),Deg2),TreeList2),Summary2)),Mima)) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
tff(fact_7893_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A2: set(set(A))] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A2))),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),collect(set(A),aTP_Lamp_ahk(set(set(A)),fun(set(A),bool),A2)))))) ) ).

% Inf_Sup_le
tff(fact_7894_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A2: set(set(A))] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),collect(set(A),aTP_Lamp_ahl(set(set(A)),fun(set(A),bool),A2))))),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A2)))) ) ).

% Sup_Inf_le
tff(fact_7895_Sup__int__def,axiom,
    ! [X7: set(int)] : ( aa(set(int),int,complete_Sup_Sup(int),X7) = the(int,aTP_Lamp_ahm(set(int),fun(int,bool),X7)) ) ).

% Sup_int_def
tff(fact_7896_Inf__filter__def,axiom,
    ! [A: $tType,S2: set(filter(A))] : ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),S2) = aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),collect(filter(A),aTP_Lamp_ahn(set(filter(A)),fun(filter(A),bool),S2))) ) ).

% Inf_filter_def
tff(fact_7897_Union__maximal__sets,axiom,
    ! [A: $tType,F14: set(set(A))] :
      ( finite_finite(set(A),F14)
     => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),collect(set(A),aTP_Lamp_aho(set(set(A)),fun(set(A),bool),F14))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),F14) ) ) ).

% Union_maximal_sets
tff(fact_7898_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( semiring_1_Nats(A) = collect(A,aTP_Lamp_ahp(A,bool)) ) ) ).

% Nats_altdef1
tff(fact_7899_list__eq__iff__zip__eq,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A)] :
      ( ( Xs = Ys2 )
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys2) )
        & ! [X4: product_prod(A,A)] :
            ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),X4),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),zip(A,A,Xs,Ys2))))
           => pp(aa(product_prod(A,A),bool,product_case_prod(A,A,bool,fequal(A)),X4)) ) ) ) ).

% list_eq_iff_zip_eq
tff(fact_7900_concat__injective,axiom,
    ! [A: $tType,Xs: list(list(A)),Ys2: list(list(A))] :
      ( ( concat(A,Xs) = concat(A,Ys2) )
     => ( ( aa(list(list(A)),nat,size_size(list(list(A))),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Ys2) )
       => ( ! [X2: product_prod(list(A),list(A))] :
              ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),X2),aa(list(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),set2(product_prod(list(A),list(A))),zip(list(A),list(A),Xs,Ys2))))
             => pp(aa(product_prod(list(A),list(A)),bool,product_case_prod(list(A),list(A),bool,aTP_Lamp_ahq(list(A),fun(list(A),bool))),X2)) )
         => ( Xs = Ys2 ) ) ) ) ).

% concat_injective
tff(fact_7901_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list(list(A)),Ys2: list(list(A))] :
      ( ! [X2: product_prod(list(A),list(A))] :
          ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),X2),aa(list(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),set2(product_prod(list(A),list(A))),zip(list(A),list(A),Xs,Ys2))))
         => pp(aa(product_prod(list(A),list(A)),bool,product_case_prod(list(A),list(A),bool,aTP_Lamp_ahq(list(A),fun(list(A),bool))),X2)) )
     => ( ( aa(list(list(A)),nat,size_size(list(list(A))),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Ys2) )
       => ( ( concat(A,Xs) = concat(A,Ys2) )
        <=> ( Xs = Ys2 ) ) ) ) ).

% concat_eq_concat_iff
tff(fact_7902_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_VEBT_valid(X3,Xa)
     => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X3),Xa)))
       => ( ! [Uu2: bool,Uv2: bool] :
              ( ( X3 = vEBT_Leaf(Uu2,Uv2) )
             => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa)))
               => ( Xa = one_one(nat) ) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                ( ( X3 = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
               => ( pp(aa(product_prod(vEBT_VEBT,nat),bool,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg2,TreeList2,Summary2)),Xa)))
                 => ( ( Deg2 = Xa )
                    & ! [X2: vEBT_VEBT] :
                        ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X2),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2)))
                       => vEBT_VEBT_valid(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
                    & vEBT_VEBT_valid(Summary2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
                    & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),bit0(one2))))) )
                    & pp(case_option(bool,product_prod(nat,nat),fconj(aa(bool,bool,fNot,aa(fun(nat,bool),bool,fEx(nat),aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Summary2))),fAll(vEBT_VEBT,combs(vEBT_VEBT,bool,bool,combb(bool,fun(bool,bool),vEBT_VEBT,fimplies,combc(vEBT_VEBT,set(vEBT_VEBT),bool,member2(vEBT_VEBT),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))),combb(bool,bool,vEBT_VEBT,fNot,combb(fun(nat,bool),bool,vEBT_VEBT,fEx(nat),vEBT_V8194947554948674370ptions))))),product_case_prod(nat,nat,bool,aa(vEBT_VEBT,fun(nat,fun(nat,bool)),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool))),aTP_Lamp_agu(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool)))),Deg2),TreeList2),Summary2)),Mima)) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
tff(fact_7903_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [A2: set(set(A))] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A2))),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),collect(set(A),aTP_Lamp_ahr(set(set(A)),fun(set(A),bool),A2)))))) ) ).

% finite_Inf_Sup
tff(fact_7904_lexn__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),N: nat] : ( aa(nat,set(product_prod(list(A),list(A))),lexn(A,R2),N) = collect(product_prod(list(A),list(A)),product_case_prod(list(A),list(A),bool,aa(nat,fun(list(A),fun(list(A),bool)),aTP_Lamp_ahs(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),bool))),R2),N))) ) ).

% lexn_conv
tff(fact_7905_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( aa(nat,set(product_prod(list(A),list(A))),lexn(A,R2),zero_zero(nat)) = bot_bot(set(product_prod(list(A),list(A)))) ) ).

% lexn.simps(1)
tff(fact_7906_lexn__length,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A)),N: nat] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),aa(nat,set(product_prod(list(A),list(A))),lexn(A,R2),N)))
     => ( ( aa(list(A),nat,size_size(list(A)),Xs) = N )
        & ( aa(list(A),nat,size_size(list(A)),Ys2) = N ) ) ) ).

% lexn_length
tff(fact_7907_lex__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lex(A,R2) = aa(set(set(product_prod(list(A),list(A)))),set(product_prod(list(A),list(A))),complete_Sup_Sup(set(product_prod(list(A),list(A)))),aa(set(nat),set(set(product_prod(list(A),list(A)))),image(nat,set(product_prod(list(A),list(A))),lexn(A,R2)),top_top(set(nat)))) ) ).

% lex_def
tff(fact_7908_sorted__wrt_Opelims_I1_J,axiom,
    ! [A: $tType,X3: fun(A,fun(A,bool)),Xa: list(A),Y4: bool] :
      ( ( sorted_wrt(A,X3,Xa)
      <=> pp(Y4) )
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),X3),Xa)))
       => ( ( ( Xa = nil(A) )
           => ( pp(Y4)
             => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),X3),nil(A)))) ) )
         => ~ ! [X2: A,Ys3: list(A)] :
                ( ( Xa = aa(list(A),list(A),cons(A,X2),Ys3) )
               => ( ( pp(Y4)
                  <=> ( ! [Xa4: A] :
                          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa4),aa(list(A),set(A),set2(A),Ys3)))
                         => pp(aa(A,bool,aa(A,fun(A,bool),X3,X2),Xa4)) )
                      & sorted_wrt(A,X3,Ys3) ) )
                 => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),X3),aa(list(A),list(A),cons(A,X2),Ys3)))) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
tff(fact_7909_sorted__wrt_Opelims_I2_J,axiom,
    ! [A: $tType,X3: fun(A,fun(A,bool)),Xa: list(A)] :
      ( sorted_wrt(A,X3,Xa)
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),X3),Xa)))
       => ( ( ( Xa = nil(A) )
           => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),X3),nil(A)))) )
         => ~ ! [X2: A,Ys3: list(A)] :
                ( ( Xa = aa(list(A),list(A),cons(A,X2),Ys3) )
               => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),X3),aa(list(A),list(A),cons(A,X2),Ys3))))
                 => ~ ( ! [Xa2: A] :
                          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa2),aa(list(A),set(A),set2(A),Ys3)))
                         => pp(aa(A,bool,aa(A,fun(A,bool),X3,X2),Xa2)) )
                      & sorted_wrt(A,X3,Ys3) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
tff(fact_7910_sorted__wrt_Opelims_I3_J,axiom,
    ! [A: $tType,X3: fun(A,fun(A,bool)),Xa: list(A)] :
      ( ~ sorted_wrt(A,X3,Xa)
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),X3),Xa)))
       => ~ ! [X2: A,Ys3: list(A)] :
              ( ( Xa = aa(list(A),list(A),cons(A,X2),Ys3) )
             => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),product_Pair(fun(A,fun(A,bool)),list(A),X3),aa(list(A),list(A),cons(A,X2),Ys3))))
               => ( ! [Xa3: A] :
                      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Xa3),aa(list(A),set(A),set2(A),Ys3)))
                     => pp(aa(A,bool,aa(A,fun(A,bool),X3,X2),Xa3)) )
                  & sorted_wrt(A,X3,Ys3) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
tff(fact_7911_mlex__eq,axiom,
    ! [A: $tType,F2: fun(A,nat),R4: set(product_prod(A,A))] : ( mlex_prod(A,F2,R4) = collect(product_prod(A,A),product_case_prod(A,A,bool,aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aTP_Lamp_aht(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,bool))),F2),R4))) ) ).

% mlex_eq
tff(fact_7912_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),Ys2)),listrel(A,B,R2)))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
        & ! [X4: product_prod(A,B)] :
            ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),X4),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys2))))
           => pp(aa(product_prod(A,B),bool,product_case_prod(A,B,bool,aTP_Lamp_in(set(product_prod(A,B)),fun(A,fun(B,bool)),R2)),X4)) ) ) ) ).

% listrel_iff_zip
tff(fact_7913_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),Ys2)),listrel(A,B,R2)))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) ) ) ).

% listrel_eq_len
tff(fact_7914_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),nil(B))),listrel(A,B,R2)))
     => ( Xs = nil(A) ) ) ).

% listrel_Nil2
tff(fact_7915_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),nil(A)),Xs)),listrel(A,B,R2)))
     => ( Xs = nil(B) ) ) ).

% listrel_Nil1
tff(fact_7916_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B))] : pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),nil(A)),nil(B))),listrel(A,B,R2))) ).

% listrel.Nil
tff(fact_7917_listrel__mono,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),S: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R2),S))
     => pp(aa(set(product_prod(list(A),list(B))),bool,aa(set(product_prod(list(A),list(B))),fun(set(product_prod(list(A),list(B))),bool),ord_less_eq(set(product_prod(list(A),list(B)))),listrel(A,B,R2)),listrel(A,B,S))) ) ).

% listrel_mono
tff(fact_7918_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X3: A,Y4: B,R2: set(product_prod(A,B)),Xs: list(A),Ys2: list(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X3),Y4)),R2))
     => ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),Ys2)),listrel(A,B,R2)))
       => pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(B),list(B),cons(B,Y4),Ys2))),listrel(A,B,R2))) ) ) ).

% listrel.Cons
tff(fact_7919_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y4: A,Ys2: list(A),Xs: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),aa(list(A),list(A),cons(A,Y4),Ys2)),Xs)),listrel(A,B,R2)))
     => ~ ! [Y2: B,Ys3: list(B)] :
            ( ( Xs = aa(list(B),list(B),cons(B,Y2),Ys3) )
           => ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,Y4),Y2)),R2))
             => ~ pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Ys2),Ys3)),listrel(A,B,R2))) ) ) ) ).

% listrel_Cons1
tff(fact_7920_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Y4: B,Ys2: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),aa(list(B),list(B),cons(B,Y4),Ys2))),listrel(A,B,R2)))
     => ~ ! [X2: A,Xs2: list(A)] :
            ( ( Xs = aa(list(A),list(A),cons(A,X2),Xs2) )
           => ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X2),Y4)),R2))
             => ~ pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs2),Ys2)),listrel(A,B,R2))) ) ) ) ).

% listrel_Cons2
tff(fact_7921_mlex__less,axiom,
    ! [A: $tType,F2: fun(A,nat),X3: A,Y4: A,R4: set(product_prod(A,A))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F2,X3)),aa(A,nat,F2,Y4)))
     => pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),mlex_prod(A,F2,R4))) ) ).

% mlex_less
tff(fact_7922_mlex__iff,axiom,
    ! [A: $tType,X3: A,Y4: A,F2: fun(A,nat),R4: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),mlex_prod(A,F2,R4)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F2,X3)),aa(A,nat,F2,Y4)))
        | ( ( aa(A,nat,F2,X3) = aa(A,nat,F2,Y4) )
          & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),R4)) ) ) ) ).

% mlex_iff
tff(fact_7923_mlex__leq,axiom,
    ! [A: $tType,F2: fun(A,nat),X3: A,Y4: A,R4: set(product_prod(A,A))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,F2,X3)),aa(A,nat,F2,Y4)))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),R4))
       => pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),mlex_prod(A,F2,R4))) ) ) ).

% mlex_leq
tff(fact_7924_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: list(A),A22: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),A1),A22)),listrel(A,B,R2)))
     => ( ( ( A1 = nil(A) )
         => ( A22 != nil(B) ) )
       => ~ ! [X2: A,Y2: B,Xs2: list(A)] :
              ( ( A1 = aa(list(A),list(A),cons(A,X2),Xs2) )
             => ! [Ys3: list(B)] :
                  ( ( A22 = aa(list(B),list(B),cons(B,Y2),Ys3) )
                 => ( pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X2),Y2)),R2))
                   => ~ pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs2),Ys3)),listrel(A,B,R2))) ) ) ) ) ) ).

% listrel.cases
tff(fact_7925_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: list(A),A22: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),A1),A22)),listrel(A,B,R2)))
    <=> ( ( ( A1 = nil(A) )
          & ( A22 = nil(B) ) )
        | ? [X4: A,Y: B,Xs3: list(A),Ys4: list(B)] :
            ( ( A1 = aa(list(A),list(A),cons(A,X4),Xs3) )
            & ( A22 = aa(list(B),list(B),cons(B,Y),Ys4) )
            & pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,X4),Y)),R2))
            & pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs3),Ys4)),listrel(A,B,R2))) ) ) ) ).

% listrel.simps
tff(fact_7926_listrel__iff__nth,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),Ys2)),listrel(A,B,R2)))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys2) )
        & ! [N3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N3),aa(list(A),nat,size_size(list(A)),Xs)))
           => pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Xs),N3)),aa(nat,B,nth(B,Ys2),N3))),R2)) ) ) ) ).

% listrel_iff_nth
tff(fact_7927_relpow__finite__bounded1,axiom,
    ! [A: $tType,R4: set(product_prod(A,A)),K: nat] :
      ( finite_finite(product_prod(A,A),R4)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),K),R4)),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_ahu(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R4)),collect(nat,aTP_Lamp_ahv(set(product_prod(A,A)),fun(nat,bool),R4)))))) ) ) ).

% relpow_finite_bounded1
tff(fact_7928_Rats__eq__int__div__nat,axiom,
    field_char_0_Rats(real) = collect(real,aTP_Lamp_ahw(real,bool)) ).

% Rats_eq_int_div_nat
tff(fact_7929_Rats__abs__iff,axiom,
    ! [X3: real] :
      ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),aa(real,real,abs_abs(real),X3)),field_char_0_Rats(real)))
    <=> pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X3),field_char_0_Rats(real))) ) ).

% Rats_abs_iff
tff(fact_7930_finite__relpow,axiom,
    ! [A: $tType,R4: set(product_prod(A,A)),N: nat] :
      ( finite_finite(product_prod(A,A),R4)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
       => finite_finite(product_prod(A,A),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R4)) ) ) ).

% finite_relpow
tff(fact_7931_Nats__subset__Rats,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),semiring_1_Nats(A)),field_char_0_Rats(A))) ) ).

% Nats_subset_Rats
tff(fact_7932_Rats__no__top__le,axiom,
    ! [X3: real] :
    ? [X2: real] :
      ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),field_char_0_Rats(real)))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),X3),X2)) ) ).

% Rats_no_top_le
tff(fact_7933_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),ring_1_Ints(A)),field_char_0_Rats(A))) ) ).

% Ints_subset_Rats
tff(fact_7934_Rats__no__bot__less,axiom,
    ! [X3: real] :
    ? [X2: real] :
      ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),field_char_0_Rats(real)))
      & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),X3)) ) ).

% Rats_no_bot_less
tff(fact_7935_Rats__dense__in__real,axiom,
    ! [X3: real,Y4: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),Y4))
     => ? [X2: real] :
          ( pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),X2),field_char_0_Rats(real)))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X3),X2))
          & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),X2),Y4)) ) ) ).

% Rats_dense_in_real
tff(fact_7936_relpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,R4: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),R4) = relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M),R4),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R4)) ) ).

% relpow_add
tff(fact_7937_Rats__mult,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),field_char_0_Rats(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),field_char_0_Rats(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),field_char_0_Rats(A))) ) ) ) ).

% Rats_mult
tff(fact_7938_Rats__number__of,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [W: num] : pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(num,A,numeral_numeral(A),W)),field_char_0_Rats(A))) ) ).

% Rats_number_of
tff(fact_7939_Rats__divide,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),field_char_0_Rats(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),field_char_0_Rats(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A3),B2)),field_char_0_Rats(A))) ) ) ) ).

% Rats_divide
tff(fact_7940_Rats__power,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),field_char_0_Rats(A)))
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(nat,A,power_power(A,A3),N)),field_char_0_Rats(A))) ) ) ).

% Rats_power
tff(fact_7941_Rats__add,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),field_char_0_Rats(A)))
         => ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),B2),field_char_0_Rats(A)))
           => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),field_char_0_Rats(A))) ) ) ) ).

% Rats_add
tff(fact_7942_Rats__0,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),zero_zero(A)),field_char_0_Rats(A))) ) ).

% Rats_0
tff(fact_7943_relpow__E2,axiom,
    ! [A: $tType,X3: A,Z: A,N: nat,R4: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R4)))
     => ( ( ( N = zero_zero(nat) )
         => ( X3 != Z ) )
       => ~ ! [Y2: A,M3: nat] :
              ( ( N = aa(nat,nat,suc,M3) )
             => ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y2)),R4))
               => ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,Y2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M3),R4))) ) ) ) ) ).

% relpow_E2
tff(fact_7944_relpow__E,axiom,
    ! [A: $tType,X3: A,Z: A,N: nat,R4: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R4)))
     => ( ( ( N = zero_zero(nat) )
         => ( X3 != Z ) )
       => ~ ! [Y2: A,M3: nat] :
              ( ( N = aa(nat,nat,suc,M3) )
             => ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y2)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M3),R4)))
               => ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,Y2),Z)),R4)) ) ) ) ) ).

% relpow_E
tff(fact_7945_relpow__0__E,axiom,
    ! [A: $tType,X3: A,Y4: A,R4: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),zero_zero(nat)),R4)))
     => ( X3 = Y4 ) ) ).

% relpow_0_E
tff(fact_7946_relpow__0__I,axiom,
    ! [A: $tType,X3: A,R4: set(product_prod(A,A))] : pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),X3)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),zero_zero(nat)),R4))) ).

% relpow_0_I
tff(fact_7947_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ) ).

% relpow_empty
tff(fact_7948_relpow__fun__conv,axiom,
    ! [A: $tType,A3: A,B2: A,N: nat,R4: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,A3),B2)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R4)))
    <=> ? [F6: fun(nat,A)] :
          ( ( aa(nat,A,F6,zero_zero(nat)) = A3 )
          & ( aa(nat,A,F6,N) = B2 )
          & ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),N))
             => pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,F6,I2)),aa(nat,A,F6,aa(nat,nat,suc,I2)))),R4)) ) ) ) ).

% relpow_fun_conv
tff(fact_7949_Rats__eq__int__div__int,axiom,
    field_char_0_Rats(real) = collect(real,aTP_Lamp_ahx(real,bool)) ).

% Rats_eq_int_div_int
tff(fact_7950_relpow__finite__bounded,axiom,
    ! [A: $tType,R4: set(product_prod(A,A)),K: nat] :
      ( finite_finite(product_prod(A,A),R4)
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),K),R4)),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_ahu(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R4)),collect(nat,aTP_Lamp_ahy(set(product_prod(A,A)),fun(nat,bool),R4)))))) ) ).

% relpow_finite_bounded
tff(fact_7951_ntrancl__def,axiom,
    ! [A: $tType,N: nat,R4: set(product_prod(A,A))] : ( transitive_ntrancl(A,N,R4) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_ahu(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R4)),collect(nat,aTP_Lamp_ahz(nat,fun(nat,bool),N)))) ) ).

% ntrancl_def
tff(fact_7952_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R4: set(product_prod(A,A))] :
      ( finite_finite(product_prod(A,A),R4)
     => ( transitive_trancl(A,R4) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_ahu(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R4)),collect(nat,aTP_Lamp_ahv(set(product_prod(A,A)),fun(nat,bool),R4)))) ) ) ).

% trancl_finite_eq_relpow
tff(fact_7953_ntrancl__Zero,axiom,
    ! [A: $tType,R4: set(product_prod(A,A))] : ( transitive_ntrancl(A,zero_zero(nat),R4) = R4 ) ).

% ntrancl_Zero
tff(fact_7954_trancl__power,axiom,
    ! [A: $tType,P2: product_prod(A,A),R4: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),P2),transitive_trancl(A,R4)))
    <=> ? [N3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N3))
          & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),P2),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N3),R4))) ) ) ).

% trancl_power
tff(fact_7955_trancl__subset__Sigma,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A2: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A2,aTP_Lamp_ags(set(A),fun(A,set(A)),A2))))
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_trancl(A,R2)),product_Sigma(A,A,A2,aTP_Lamp_ags(set(A),fun(A,set(A)),A2)))) ) ).

% trancl_subset_Sigma
tff(fact_7956_trancl__mono,axiom,
    ! [A: $tType,P2: product_prod(A,A),R2: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),P2),transitive_trancl(A,R2)))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),S))
       => pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),P2),transitive_trancl(A,S))) ) ) ).

% trancl_mono
tff(fact_7957_trancl__Int__subset,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),S))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),transitive_trancl(A,R2)),S),R2)),S))
       => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_trancl(A,R2)),S)) ) ) ).

% trancl_Int_subset
tff(fact_7958_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list(product_prod(A,A))] : ( transitive_trancl(A,aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs)) = transitive_ntrancl(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs))),one_one(nat)),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs)) ) ).

% trancl_set_ntrancl
tff(fact_7959_lexord__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lexord(A,R2) = collect(product_prod(list(A),list(A)),product_case_prod(list(A),list(A),bool,aTP_Lamp_aia(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R2))) ) ).

% lexord_def
tff(fact_7960_set__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] : ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys2)) = collect(product_prod(A,B),aa(list(B),fun(product_prod(A,B),bool),aTP_Lamp_aib(list(A),fun(list(B),fun(product_prod(A,B),bool)),Xs),Ys2)) ) ).

% set_zip
tff(fact_7961_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = A3 ) ) ) ).

% min.absorb1
tff(fact_7962_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = B2 ) ) ) ).

% min.absorb2
tff(fact_7963_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% min.bounded_iff
tff(fact_7964_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z: A,X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),X3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z),Y4)) ) ) ) ).

% min_less_iff_conj
tff(fact_7965_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = B2 ) ) ) ).

% min.absorb4
tff(fact_7966_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = A3 ) ) ) ).

% min.absorb3
tff(fact_7967_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)) ) ).

% min_Suc_Suc
tff(fact_7968_min__0L,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),zero_zero(nat)),N) = zero_zero(nat) ) ).

% min_0L
tff(fact_7969_min__0R,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),N),zero_zero(nat)) = zero_zero(nat) ) ).

% min_0R
tff(fact_7970_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A3)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)),A3) ) ) ).

% take_bit_take_bit
tff(fact_7971_take__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] : ( take(A,N,take(A,M,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),N),M),Xs) ) ).

% take_take
tff(fact_7972_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat,A3: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,M),aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A3)) = aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)),A3) ) ) ).

% signed_take_bit_signed_take_bit
tff(fact_7973_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)) = aa(num,A,numeral_numeral(A),U) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)) = aa(num,A,numeral_numeral(A),V) ) ) ) ) ).

% min_number_of(1)
tff(fact_7974_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),aa(num,A,numeral_numeral(A),X3)) = zero_zero(A) ) ) ).

% min_0_1(3)
tff(fact_7975_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),X3)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(4)
tff(fact_7976_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),one_one(A)) = zero_zero(A) ) ) ).

% min_0_1(1)
tff(fact_7977_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(2)
tff(fact_7978_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),aa(num,A,numeral_numeral(A),X3)) = one_one(A) ) ) ).

% min_0_1(5)
tff(fact_7979_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),X3)),one_one(A)) = one_one(A) ) ) ).

% min_0_1(6)
tff(fact_7980_length__take,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),take(A,N,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),N) ) ).

% length_take
tff(fact_7981_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),bit_se2239418461657761734s_mask(A,N)) = bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)) ) ) ).

% take_bit_of_mask
tff(fact_7982_take__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,X3: A] : ( take(A,I,replicate(A,K,X3)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),I),K),X3) ) ).

% take_replicate
tff(fact_7983_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(num,A,numeral_numeral(A),U) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)) ) ) ) ) ).

% min_number_of(2)
tff(fact_7984_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)) = aa(num,A,numeral_numeral(A),V) ) ) ) ) ).

% min_number_of(3)
tff(fact_7985_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)) ) ) ) ) ).

% min_number_of(4)
tff(fact_7986_lexord__cons__cons,axiom,
    ! [A: $tType,A3: A,X3: list(A),B2: A,Y4: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,A3),X3)),aa(list(A),list(A),cons(A,B2),Y4))),lexord(A,R2)))
    <=> ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,A3),B2)),R2))
        | ( ( A3 = B2 )
          & pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),Y4)),lexord(A,R2))) ) ) ) ).

% lexord_cons_cons
tff(fact_7987_lexord__Nil__left,axiom,
    ! [A: $tType,Y4: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),nil(A)),Y4)),lexord(A,R2)))
    <=> ? [A6: A,X4: list(A)] : ( Y4 = aa(list(A),list(A),cons(A,A6),X4) ) ) ).

% lexord_Nil_left
tff(fact_7988_min__numeral__Suc,axiom,
    ! [K: num,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),pred_numeral(K)),N)) ) ).

% min_numeral_Suc
tff(fact_7989_min__Suc__numeral,axiom,
    ! [N: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),N),pred_numeral(K))) ) ).

% min_Suc_numeral
tff(fact_7990_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I: nat,X3: A,J3: nat,Y4: B] : ( zip(A,B,replicate(A,I,X3),replicate(B,J3,Y4)) = replicate(product_prod(A,B),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),I),J3),aa(B,product_prod(A,B),product_Pair(A,B,X3),Y4)) ) ).

% zip_replicate
tff(fact_7991_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),Xs: list(A),Ys2: list(A),Zs: list(A)] :
      ( irrefl(A,R2)
     => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lexord(A,R2)))
      <=> pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ys2),Zs)),lexord(A,R2))) ) ) ).

% lexord_same_pref_if_irrefl
tff(fact_7992_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B)] : ( aa(list(product_prod(A,B)),nat,size_size(list(product_prod(A,B))),zip(A,B,Xs,Ys2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys2)) ) ).

% length_zip
tff(fact_7993_zip__obtain__same__length,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys2: list(B),P: fun(list(product_prod(A,B)),bool)] :
      ( ! [Zs2: list(A),Ws2: list(B),N2: nat] :
          ( ( aa(list(A),nat,size_size(list(A)),Zs2) = aa(list(B),nat,size_size(list(B)),Ws2) )
         => ( ( N2 = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys2)) )
           => ( ( Zs2 = take(A,N2,Xs) )
             => ( ( Ws2 = take(B,N2,Ys2) )
               => pp(aa(list(product_prod(A,B)),bool,P,zip(A,B,Zs2,Ws2))) ) ) ) )
     => pp(aa(list(product_prod(A,B)),bool,P,zip(A,B,Xs,Ys2))) ) ).

% zip_obtain_same_length
tff(fact_7994_inf__nat__def,axiom,
    inf_inf(nat) = ord_min(nat) ).

% inf_nat_def
tff(fact_7995_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,M),aa(int,int,bit_concat_bit(N,K),L)) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N),K),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),L)) ) ).

% take_bit_concat_bit_eq
tff(fact_7996_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)),Z))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Z))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Z)) ) ) ) ).

% min_le_iff_disj
tff(fact_7997_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2)) ) ) ).

% min.coboundedI2
tff(fact_7998_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2)) ) ) ).

% min.coboundedI1
tff(fact_7999_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = B2 ) ) ) ).

% min.absorb_iff2
tff(fact_8000_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = A3 ) ) ) ).

% min.absorb_iff1
tff(fact_8001_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),B2)) ) ).

% min.cobounded2
tff(fact_8002_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),A3)) ) ).

% min.cobounded1
tff(fact_8003_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) ) ) ) ).

% min.order_iff
tff(fact_8004_min_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2))) ) ) ) ).

% min.boundedI
tff(fact_8005_min_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% min.boundedE
tff(fact_8006_min_OorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% min.orderI
tff(fact_8007_min_OorderE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( A3 = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) ) ) ) ).

% min.orderE
tff(fact_8008_min_Omono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),aa(A,A,aa(A,fun(A,A),ord_min(A),C2),D2))) ) ) ) ).

% min.mono
tff(fact_8009_min__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Xa2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Xa2))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X),Xa2) = X ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Xa2))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X),Xa2) = Xa2 ) ) ) ) ).

% min_def_raw
tff(fact_8010_min__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = A3 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = B2 ) ) ) ) ).

% min_def
tff(fact_8011_min__absorb1,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X3: A,Y4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4) = X3 ) ) ) ).

% min_absorb1
tff(fact_8012_min__absorb2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y4: A,X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X3))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4) = Y4 ) ) ) ).

% min_absorb2
tff(fact_8013_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2)) ) ) ).

% min.strict_coboundedI2
tff(fact_8014_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2)) ) ) ).

% min.strict_coboundedI1
tff(fact_8015_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) )
            & ( A3 != B2 ) ) ) ) ).

% min.strict_order_iff
tff(fact_8016_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% min.strict_boundedE
tff(fact_8017_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X3: A,Y4: A,Z: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)),Z))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Z))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),Z)) ) ) ) ).

% min_less_iff_disj
tff(fact_8018_concat__bit__assoc__sym,axiom,
    ! [M: nat,N: nat,K: int,L: int,R2: int] : ( aa(int,int,bit_concat_bit(M,aa(int,int,bit_concat_bit(N,K),L)),R2) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N),K),aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),L),R2)) ) ).

% concat_bit_assoc_sym
tff(fact_8019_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)),Z) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),Z)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),Z)) ) ) ).

% min_diff_distrib_left
tff(fact_8020_min__diff,axiom,
    ! [M: nat,I: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),I)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),I)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)),I) ) ).

% min_diff
tff(fact_8021_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) ) ).

% nat_mult_min_left
tff(fact_8022_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)) ) ).

% nat_mult_min_right
tff(fact_8023_of__int__min,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X3: int,Y4: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),ord_min(int),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(int,A,ring_1_of_int(A),X3)),aa(int,A,ring_1_of_int(A),Y4)) ) ) ).

% of_int_min
tff(fact_8024_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)),Z) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Z)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y4),Z)) ) ) ).

% min_add_distrib_left
tff(fact_8025_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X3: A,Y4: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),aa(A,A,aa(A,fun(A,A),ord_min(A),Y4),Z)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Z)) ) ) ).

% min_add_distrib_right
tff(fact_8026_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),X3)),aa(A,A,uminus_uminus(A),Y4)) ) ) ).

% minus_min_eq_max
tff(fact_8027_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X3: A,Y4: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),X3)),aa(A,A,uminus_uminus(A),Y4)) ) ) ).

% minus_max_eq_min
tff(fact_8028_of__nat__min,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X3: nat,Y4: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(nat,A,semiring_1_of_nat(A),X3)),aa(nat,A,semiring_1_of_nat(A),Y4)) ) ) ).

% of_nat_min
tff(fact_8029_lexord__take__index__conv,axiom,
    ! [A: $tType,X3: list(A),Y4: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),Y4)),lexord(A,R2)))
    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),X3)),aa(list(A),nat,size_size(list(A)),Y4)))
          & ( take(A,aa(list(A),nat,size_size(list(A)),X3),Y4) = X3 ) )
        | ? [I2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),X3)),aa(list(A),nat,size_size(list(A)),Y4))))
            & ( take(A,I2,X3) = take(A,I2,Y4) )
            & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,nth(A,X3),I2)),aa(nat,A,nth(A,Y4),I2))),R2)) ) ) ) ).

% lexord_take_index_conv
tff(fact_8030_lexord__Nil__right,axiom,
    ! [A: $tType,X3: list(A),R2: set(product_prod(A,A))] : ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),nil(A))),lexord(A,R2))) ).

% lexord_Nil_right
tff(fact_8031_lexord__linear,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),X3: list(A),Y4: list(A)] :
      ( ! [A5: A,B5: A] :
          ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,A5),B5)),R2))
          | ( A5 = B5 )
          | pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,B5),A5)),R2)) )
     => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),Y4)),lexord(A,R2)))
        | ( X3 = Y4 )
        | pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Y4),X3)),lexord(A,R2))) ) ) ).

% lexord_linear
tff(fact_8032_lexord__irreflexive,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),Xs: list(A)] :
      ( ! [X2: A] : ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X2),X2)),R2))
     => ~ pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Xs)),lexord(A,R2))) ) ).

% lexord_irreflexive
tff(fact_8033_lexord__append__leftI,axiom,
    ! [A: $tType,U: list(A),V: list(A),R2: set(product_prod(A,A)),X3: list(A)] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),U),V)),lexord(A,R2)))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X3),U)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X3),V))),lexord(A,R2))) ) ).

% lexord_append_leftI
tff(fact_8034_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list(A),R2: set(product_prod(A,A)),Ys2: list(A),Zs: list(A)] :
      ( ! [X2: A,Y2: A,Z4: A] :
          ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X2),aa(list(A),set(A),set2(A),Xs)))
         => ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X2),Y2)),R2))
           => ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,Y2),Z4)),R2))
             => pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X2),Z4)),R2)) ) ) )
     => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),lexord(A,R2)))
       => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ys2),Zs)),lexord(A,R2)))
         => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Zs)),lexord(A,R2))) ) ) ) ).

% lexord_partial_trans
tff(fact_8035_lexord__append__leftD,axiom,
    ! [A: $tType,X3: list(A),U: list(A),V: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X3),U)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X3),V))),lexord(A,R2)))
     => ( ! [A5: A] : ~ pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,A5),A5)),R2))
       => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),U),V)),lexord(A,R2))) ) ) ).

% lexord_append_leftD
tff(fact_8036_lexord__append__rightI,axiom,
    ! [A: $tType,Y4: list(A),X3: list(A),R2: set(product_prod(A,A))] :
      ( ? [B11: A,Z3: list(A)] : ( Y4 = aa(list(A),list(A),cons(A,B11),Z3) )
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X3),Y4))),lexord(A,R2))) ) ).

% lexord_append_rightI
tff(fact_8037_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P2: A,X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y4)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y4)) ) ) ) ) ).

% max_mult_distrib_left
tff(fact_8038_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P2: A,X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y4)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),X3)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y4)) ) ) ) ) ).

% min_mult_distrib_left
tff(fact_8039_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P2: A,X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)),P2) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),P2)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)),P2) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),P2)) ) ) ) ) ).

% max_mult_distrib_right
tff(fact_8040_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P2: A,X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)),P2) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),P2)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)),P2) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X3),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y4),P2)) ) ) ) ) ).

% min_mult_distrib_right
tff(fact_8041_lexord__sufE,axiom,
    ! [A: $tType,Xs: list(A),Zs: list(A),Ys2: list(A),Qs: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys2),Qs))),lexord(A,R2)))
     => ( ( Xs != Ys2 )
       => ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys2) )
         => ( ( aa(list(A),nat,size_size(list(A)),Zs) = aa(list(A),nat,size_size(list(A)),Qs) )
           => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),lexord(A,R2))) ) ) ) ) ).

% lexord_sufE
tff(fact_8042_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [P2: A,X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)),P2) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),P2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),P2)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Y4)),P2) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),P2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),P2)) ) ) ) ) ).

% max_divide_distrib_right
tff(fact_8043_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [P2: A,X3: A,Y4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)),P2) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),P2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),P2)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P2))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Y4)),P2) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X3),P2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y4),P2)) ) ) ) ) ).

% min_divide_distrib_right
tff(fact_8044_min__Suc2,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),aa(nat,nat,suc,N)) = case_nat(nat,zero_zero(nat),aTP_Lamp_aic(nat,fun(nat,nat),N),M) ) ).

% min_Suc2
tff(fact_8045_min__Suc1,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,N)),M) = case_nat(nat,zero_zero(nat),aTP_Lamp_aid(nat,fun(nat,nat),N),M) ) ).

% min_Suc1
tff(fact_8046_lexord__lex,axiom,
    ! [A: $tType,X3: list(A),Y4: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),Y4)),lex(A,R2)))
    <=> ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),Y4)),lexord(A,R2)))
        & ( aa(list(A),nat,size_size(list(A)),X3) = aa(list(A),nat,size_size(list(A)),Y4) ) ) ) ).

% lexord_lex
tff(fact_8047_lexord__irrefl,axiom,
    ! [A: $tType,R4: set(product_prod(A,A))] :
      ( irrefl(A,R4)
     => irrefl(list(A),lexord(A,R4)) ) ).

% lexord_irrefl
tff(fact_8048_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,M: nat,N: nat] : ( modulo_modulo(A,modulo_modulo(A,A3,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)) = modulo_modulo(A,A3,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N))) ) ) ).

% mod_exp_eq
tff(fact_8049_lexord__append__left__rightI,axiom,
    ! [A: $tType,A3: A,B2: A,R2: set(product_prod(A,A)),U: list(A),X3: list(A),Y4: list(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,A3),B2)),R2))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),aa(list(A),list(A),cons(A,A3),X3))),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),aa(list(A),list(A),cons(A,B2),Y4)))),lexord(A,R2))) ) ).

% lexord_append_left_rightI
tff(fact_8050_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),Zs: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys2)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lexord(A,R2)))
    <=> ( ? [X4: A] :
            ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),aa(list(A),set(A),set2(A),Xs)))
            & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X4),X4)),R2)) )
        | pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ys2),Zs)),lexord(A,R2))) ) ) ).

% lexord_same_pref_iff
tff(fact_8051_lexord__sufI,axiom,
    ! [A: $tType,U: list(A),W: list(A),R2: set(product_prod(A,A)),V: list(A),Z: list(A)] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),U),W)),lexord(A,R2)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),W)),aa(list(A),nat,size_size(list(A)),U)))
       => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),V)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),W),Z))),lexord(A,R2))) ) ) ).

% lexord_sufI
tff(fact_8052_map__fst__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys2: list(B)] : ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),zip(A,B,Xs,Ys2)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys2)),Xs) ) ).

% map_fst_zip_take
tff(fact_8053_map__snd__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list(B),Ys2: list(A)] : ( aa(list(product_prod(B,A)),list(A),map(product_prod(B,A),A,product_snd(B,A)),zip(B,A,Xs,Ys2)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(B),nat,size_size(list(B)),Xs)),aa(list(A),nat,size_size(list(A)),Ys2)),Ys2) ) ).

% map_snd_zip_take
tff(fact_8054_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat,M: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N))),one_one(A)) ) ) ).

% mask_mod_exp
tff(fact_8055_List_Olexordp__def,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),Xs: list(A),Ys2: list(A)] :
      ( lexordp(A,R2,Xs,Ys2)
    <=> pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),lexord(A,collect(product_prod(A,A),product_case_prod(A,A,bool,R2))))) ) ).

% List.lexordp_def
tff(fact_8056_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X3: A,Xs: list(A)] : ( min_list(A,aa(list(A),list(A),cons(A,X3),Xs)) = aa(list(A),A,case_list(A,A,X3,aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_aie(A,fun(list(A),fun(A,fun(list(A),A))),X3),Xs)),Xs) ) ) ).

% min_list.simps
tff(fact_8057_min__enat__simps_I4_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) = Q2 ) ).

% min_enat_simps(4)
tff(fact_8058_min__enat__simps_I5_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),extend4730790105801354508finity(extended_enat)),Q2) = Q2 ) ).

% min_enat_simps(5)
tff(fact_8059_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),Q2),zero_zero(extended_enat)) = zero_zero(extended_enat) ) ).

% min_enat_simps(2)
tff(fact_8060_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),zero_zero(extended_enat)),Q2) = zero_zero(extended_enat) ) ).

% min_enat_simps(3)
tff(fact_8061_min__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),extended_enat2(M)),extended_enat2(N)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)) ) ).

% min_enat_simps(1)
tff(fact_8062_inf__int__def,axiom,
    inf_inf(int) = ord_min(int) ).

% inf_int_def
tff(fact_8063_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R4: set(product_prod(A,A))] :
      ( finite_finite(product_prod(A,A),R4)
     => ( transitive_rtrancl(A,R4) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_ahu(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R4)),collect(nat,aTP_Lamp_ahy(set(product_prod(A,A)),fun(nat,bool),R4)))) ) ) ).

% rtrancl_finite_eq_relpow
tff(fact_8064_min__list_Oelims,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X3: list(A),Y4: A] :
          ( ( min_list(A,X3) = Y4 )
         => ( ! [X2: A,Xs2: list(A)] :
                ( ( X3 = aa(list(A),list(A),cons(A,X2),Xs2) )
               => ( Y4 != aa(list(A),A,case_list(A,A,X2,aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_aie(A,fun(list(A),fun(A,fun(list(A),A))),X2),Xs2)),Xs2) ) )
           => ~ ( ( X3 = nil(A) )
               => ( Y4 != undefined(A) ) ) ) ) ) ).

% min_list.elims
tff(fact_8065_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs: list(A),R2: set(product_prod(A,A))] : pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Xs)),listrel(A,A,transitive_rtrancl(A,R2)))) ).

% listrel_rtrancl_refl
tff(fact_8066_inf__enat__def,axiom,
    inf_inf(extended_enat) = ord_min(extended_enat) ).

% inf_enat_def
tff(fact_8067_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A)),Zs: list(A)] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel(A,A,transitive_rtrancl(A,R2))))
     => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ys2),Zs)),listrel(A,A,transitive_rtrancl(A,R2))))
       => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Zs)),listrel(A,A,transitive_rtrancl(A,R2)))) ) ) ).

% listrel_rtrancl_trans
tff(fact_8068_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel1(A,R2)))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel(A,A,transitive_rtrancl(A,R2)))) ) ).

% listrel_reflcl_if_listrel1
tff(fact_8069_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),listrel(A,A,R2)))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),transitive_rtrancl(list(A),listrel1(A,R2)))) ) ).

% rtrancl_listrel1_if_listrel
tff(fact_8070_listrel__rtrancl__eq__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( listrel(A,A,transitive_rtrancl(A,R2)) = transitive_rtrancl(list(A),listrel1(A,R2)) ) ).

% listrel_rtrancl_eq_rtrancl_listrel1
tff(fact_8071_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : pp(aa(set(product_prod(list(A),list(A))),bool,aa(set(product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),bool),ord_less_eq(set(product_prod(list(A),list(A)))),listrel1(A,transitive_rtrancl(A,R2))),transitive_rtrancl(list(A),listrel1(A,R2)))) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
tff(fact_8072_rtrancl__mono,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),S))
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_rtrancl(A,R2)),transitive_rtrancl(A,S))) ) ).

% rtrancl_mono
tff(fact_8073_rtrancl__subset,axiom,
    ! [A: $tType,R4: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R4),S2))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),S2),transitive_rtrancl(A,R4)))
       => ( transitive_rtrancl(A,S2) = transitive_rtrancl(A,R4) ) ) ) ).

% rtrancl_subset
tff(fact_8074_rtrancl__subset__rtrancl,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),transitive_rtrancl(A,S)))
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_rtrancl(A,R2)),transitive_rtrancl(A,S))) ) ).

% rtrancl_subset_rtrancl
tff(fact_8075_rtrancl__Un__subset,axiom,
    ! [A: $tType,R4: set(product_prod(A,A)),S2: set(product_prod(A,A))] : pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_rtrancl(A,R4)),transitive_rtrancl(A,S2))),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R4),S2)))) ).

% rtrancl_Un_subset
tff(fact_8076_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X3: list(A),Y4: list(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X3),Y4)),transitive_rtrancl(list(A),listrel1(A,R2))))
     => ( aa(list(A),nat,size_size(list(A)),X3) = aa(list(A),nat,size_size(list(A)),Y4) ) ) ).

% rtrancl_listrel1_eq_len
tff(fact_8077_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X3: A,Y4: A,R2: set(product_prod(A,A)),Xs: list(A),Ys2: list(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4)),transitive_rtrancl(A,R2)))
     => ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),transitive_rtrancl(list(A),listrel1(A,R2))))
       => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(A),list(A),cons(A,Y4),Ys2))),transitive_rtrancl(list(A),listrel1(A,R2)))) ) ) ).

% rtrancl_listrel1_ConsI2
tff(fact_8078_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list(A),Ys2: list(A),R2: set(product_prod(A,A)),X3: A] :
      ( pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys2)),transitive_rtrancl(list(A),listrel1(A,R2))))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(A),list(A),cons(A,X3),Ys2))),transitive_rtrancl(list(A),listrel1(A,R2)))) ) ).

% rtrancl_listrel1_ConsI1
tff(fact_8079_hd__def,axiom,
    ! [A: $tType,List: list(A)] : ( aa(list(A),A,hd(A),List) = aa(list(A),A,case_list(A,A,undefined(A),aTP_Lamp_aif(A,fun(list(A),A))),List) ) ).

% hd_def
tff(fact_8080_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A3: A,B2: A,R2: set(product_prod(A,A)),A2: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,A3),B2)),transitive_rtrancl(A,R2)))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A2,aTP_Lamp_ags(set(A),fun(A,set(A)),A2))))
       => ( ( A3 = B2 )
          | pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A3),A2)) ) ) ) ).

% trancl_subset_Sigma_aux
tff(fact_8081_listrel__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : pp(aa(set(product_prod(list(A),list(A))),bool,aa(set(product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),bool),ord_less_eq(set(product_prod(list(A),list(A)))),listrel(A,A,R2)),transitive_rtrancl(list(A),listrel1(A,R2)))) ).

% listrel_subset_rtrancl_listrel1
tff(fact_8082_min__list_Opelims,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X3: list(A),Y4: A] :
          ( ( min_list(A,X3) = Y4 )
         => ( pp(aa(list(A),bool,accp(list(A),min_list_rel(A)),X3))
           => ( ! [X2: A,Xs2: list(A)] :
                  ( ( X3 = aa(list(A),list(A),cons(A,X2),Xs2) )
                 => ( ( Y4 = aa(list(A),A,case_list(A,A,X2,aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_aie(A,fun(list(A),fun(A,fun(list(A),A))),X2),Xs2)),Xs2) )
                   => ~ pp(aa(list(A),bool,accp(list(A),min_list_rel(A)),aa(list(A),list(A),cons(A,X2),Xs2))) ) )
             => ~ ( ( X3 = nil(A) )
                 => ( ( Y4 = undefined(A) )
                   => ~ pp(aa(list(A),bool,accp(list(A),min_list_rel(A)),nil(A))) ) ) ) ) ) ) ).

% min_list.pelims
tff(fact_8083_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X3: fun(A,B),Xa: list(A),Y4: A] :
          ( ( arg_min_list(A,B,X3,Xa) = Y4 )
         => ( ! [X2: A] :
                ( ( Xa = aa(list(A),list(A),cons(A,X2),nil(A)) )
               => ( Y4 != X2 ) )
           => ( ! [X2: A,Y2: A,Zs2: list(A)] :
                  ( ( Xa = aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Zs2)) )
                 => ( Y4 != if(A,aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,X3,X2)),aa(A,B,X3,arg_min_list(A,B,X3,aa(list(A),list(A),cons(A,Y2),Zs2)))),X2,arg_min_list(A,B,X3,aa(list(A),list(A),cons(A,Y2),Zs2))) ) )
             => ~ ( ( Xa = nil(A) )
                 => ( Y4 != undefined(A) ) ) ) ) ) ) ).

% arg_min_list.elims
tff(fact_8084_arg__min__list_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),X3: A] : ( arg_min_list(A,B,F2,aa(list(A),list(A),cons(A,X3),nil(A))) = X3 ) ) ).

% arg_min_list.simps(1)
tff(fact_8085_arg__min__list__in,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Xs: list(A),F2: fun(A,B)] :
          ( ( Xs != nil(A) )
         => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),arg_min_list(A,B,F2,Xs)),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% arg_min_list_in
tff(fact_8086_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),X3: A,Y4: A,Zs: list(A)] : ( arg_min_list(A,B,F2,aa(list(A),list(A),cons(A,X3),aa(list(A),list(A),cons(A,Y4),Zs))) = if(A,aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,arg_min_list(A,B,F2,aa(list(A),list(A),cons(A,Y4),Zs)))),X3,arg_min_list(A,B,F2,aa(list(A),list(A),cons(A,Y4),Zs))) ) ) ).

% arg_min_list.simps(2)
tff(fact_8087_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X3: fun(A,B),Xa: list(A),Y4: A] :
          ( ( arg_min_list(A,B,X3,Xa) = Y4 )
         => ( pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),product_Pair(fun(A,B),list(A),X3),Xa)))
           => ( ! [X2: A] :
                  ( ( Xa = aa(list(A),list(A),cons(A,X2),nil(A)) )
                 => ( ( Y4 = X2 )
                   => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),product_Pair(fun(A,B),list(A),X3),aa(list(A),list(A),cons(A,X2),nil(A))))) ) )
             => ( ! [X2: A,Y2: A,Zs2: list(A)] :
                    ( ( Xa = aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Zs2)) )
                   => ( ( Y4 = if(A,aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,X3,X2)),aa(A,B,X3,arg_min_list(A,B,X3,aa(list(A),list(A),cons(A,Y2),Zs2)))),X2,arg_min_list(A,B,X3,aa(list(A),list(A),cons(A,Y2),Zs2))) )
                     => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),product_Pair(fun(A,B),list(A),X3),aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Zs2))))) ) )
               => ~ ( ( Xa = nil(A) )
                   => ( ( Y4 = undefined(A) )
                     => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),product_Pair(fun(A,B),list(A),X3),nil(A)))) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
tff(fact_8088_pow_Osimps_I3_J,axiom,
    ! [X3: num,Y4: num] : ( pow(X3,bit1(Y4)) = aa(num,num,aa(num,fun(num,num),times_times(num),sqr(pow(X3,Y4))),X3) ) ).

% pow.simps(3)
tff(fact_8089_sqr__conv__mult,axiom,
    ! [X3: num] : ( sqr(X3) = aa(num,num,aa(num,fun(num,num),times_times(num),X3),X3) ) ).

% sqr_conv_mult
tff(fact_8090_sqr_Osimps_I2_J,axiom,
    ! [N: num] : ( sqr(bit0(N)) = bit0(bit0(sqr(N))) ) ).

% sqr.simps(2)
tff(fact_8091_sqr_Osimps_I1_J,axiom,
    sqr(one2) = one2 ).

% sqr.simps(1)
tff(fact_8092_numeral__sqr,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),sqr(K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% numeral_sqr
tff(fact_8093_pow_Osimps_I2_J,axiom,
    ! [X3: num,Y4: num] : ( pow(X3,bit0(Y4)) = sqr(pow(X3,Y4)) ) ).

% pow.simps(2)
tff(fact_8094_sqr_Osimps_I3_J,axiom,
    ! [N: num] : ( sqr(bit1(N)) = bit1(bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),sqr(N)),N))) ) ).

% sqr.simps(3)
tff(fact_8095_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( linord4507533701916653071of_set(A) = linord144544945434240204of_set(A,A,aTP_Lamp_nd(A,A)) ) ) ).

% sorted_list_of_set_def
tff(fact_8096_integer__of__num__triv_I2_J,axiom,
    aa(num,code_integer,code_integer_of_num,bit0(one2)) = aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)) ).

% integer_of_num_triv(2)
tff(fact_8097_integer__of__num__def,axiom,
    code_integer_of_num = numeral_numeral(code_integer) ).

% integer_of_num_def
tff(fact_8098_integer__of__num__triv_I1_J,axiom,
    aa(num,code_integer,code_integer_of_num,one2) = one_one(code_integer) ).

% integer_of_num_triv(1)
tff(fact_8099_integer__of__num_I2_J,axiom,
    ! [N: num] : ( aa(num,code_integer,code_integer_of_num,bit0(N)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(num,code_integer,code_integer_of_num,N)),aa(num,code_integer,code_integer_of_num,N)) ) ).

% integer_of_num(2)
tff(fact_8100_rat__floor__lemma,axiom,
    ! [A3: int,B2: int] :
      ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2))),fract(A3,B2)))
      & pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),fract(A3,B2)),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2)),one_one(int))))) ) ).

% rat_floor_lemma
tff(fact_8101_listrel__def,axiom,
    ! [B: $tType,A: $tType,X: set(product_prod(A,B))] : ( listrel(A,B,X) = collect(product_prod(list(A),list(B)),product_case_prod(list(A),list(B),bool,listrelp(A,B,aTP_Lamp_in(set(product_prod(A,B)),fun(A,fun(B,bool)),X)))) ) ).

% listrel_def
tff(fact_8102_mult__rat,axiom,
    ! [A3: int,B2: int,C2: int,D2: int] : ( aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),fract(A3,B2)),fract(C2,D2)) = fract(aa(int,int,aa(int,fun(int,int),times_times(int),A3),C2),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)) ) ).

% mult_rat
tff(fact_8103_divide__rat,axiom,
    ! [A3: int,B2: int,C2: int,D2: int] : ( aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),fract(A3,B2)),fract(C2,D2)) = fract(aa(int,int,aa(int,fun(int,int),times_times(int),A3),D2),aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) ) ).

% divide_rat
tff(fact_8104_floor__Fract,axiom,
    ! [A3: int,B2: int] : ( archim6421214686448440834_floor(rat,fract(A3,B2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),B2) ) ).

% floor_Fract
tff(fact_8105_less__rat,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),fract(A3,B2)),fract(C2,D2)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),A3),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)))) ) ) ) ).

% less_rat
tff(fact_8106_add__rat,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),fract(A3,B2)),fract(C2,D2)) = fract(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),A3),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)) ) ) ) ).

% add_rat
tff(fact_8107_le__rat,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),fract(A3,B2)),fract(C2,D2)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),A3),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)))) ) ) ) ).

% le_rat
tff(fact_8108_diff__rat,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),fract(A3,B2)),fract(C2,D2)) = fract(aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),A3),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)) ) ) ) ).

% diff_rat
tff(fact_8109_sgn__rat,axiom,
    ! [A3: int,B2: int] : ( aa(rat,rat,sgn_sgn(rat),fract(A3,B2)) = aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),A3)),aa(int,int,sgn_sgn(int),B2))) ) ).

% sgn_rat
tff(fact_8110_rat__number__expand_I3_J,axiom,
    ! [K: num] : ( aa(num,rat,numeral_numeral(rat),K) = fract(aa(num,int,numeral_numeral(int),K),one_one(int)) ) ).

% rat_number_expand(3)
tff(fact_8111_rat__number__collapse_I3_J,axiom,
    ! [W: num] : ( fract(aa(num,int,numeral_numeral(int),W),one_one(int)) = aa(num,rat,numeral_numeral(rat),W) ) ).

% rat_number_collapse(3)
tff(fact_8112_Rat__induct__pos,axiom,
    ! [P: fun(rat,bool),Q2: rat] :
      ( ! [A5: int,B5: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B5))
         => pp(aa(rat,bool,P,fract(A5,B5))) )
     => pp(aa(rat,bool,P,Q2)) ) ).

% Rat_induct_pos
tff(fact_8113_listrelp_ONil,axiom,
    ! [A: $tType,B: $tType,R2: fun(A,fun(B,bool))] : pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,R2),nil(A)),nil(B))) ).

% listrelp.Nil
tff(fact_8114_Fract__coprime,axiom,
    ! [A3: int,B2: int] : ( fract(aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A3),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),B2),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A3),B2))) = fract(A3,B2) ) ).

% Fract_coprime
tff(fact_8115_mult__rat__cancel,axiom,
    ! [C2: int,A3: int,B2: int] :
      ( ( C2 != zero_zero(int) )
     => ( fract(aa(int,int,aa(int,fun(int,int),times_times(int),C2),A3),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)) = fract(A3,B2) ) ) ).

% mult_rat_cancel
tff(fact_8116_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( ( fract(A3,B2) = fract(C2,D2) )
        <=> ( aa(int,int,aa(int,fun(int,int),times_times(int),A3),D2) = aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2) ) ) ) ) ).

% eq_rat(1)
tff(fact_8117_eq__rat_I3_J,axiom,
    ! [A3: int,C2: int] : ( fract(zero_zero(int),A3) = fract(zero_zero(int),C2) ) ).

% eq_rat(3)
tff(fact_8118_eq__rat_I2_J,axiom,
    ! [A3: int] : ( fract(A3,zero_zero(int)) = fract(zero_zero(int),one_one(int)) ) ).

% eq_rat(2)
tff(fact_8119_rat__number__collapse_I6_J,axiom,
    ! [K: int] : ( fract(K,zero_zero(int)) = zero_zero(rat) ) ).

% rat_number_collapse(6)
tff(fact_8120_rat__number__collapse_I1_J,axiom,
    ! [K: int] : ( fract(zero_zero(int),K) = zero_zero(rat) ) ).

% rat_number_collapse(1)
tff(fact_8121_listrelp_OCons,axiom,
    ! [A: $tType,B: $tType,R2: fun(A,fun(B,bool)),X3: A,Y4: B,Xs: list(A),Ys2: list(B)] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),R2,X3),Y4))
     => ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,R2),Xs),Ys2))
       => pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,R2),aa(list(A),list(A),cons(A,X3),Xs)),aa(list(B),list(B),cons(B,Y4),Ys2))) ) ) ).

% listrelp.Cons
tff(fact_8122_Fract__of__int__quotient,axiom,
    ! [K: int,L: int] : ( fract(K,L) = aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),aa(int,rat,ring_1_of_int(rat),K)),aa(int,rat,ring_1_of_int(rat),L)) ) ).

% Fract_of_int_quotient
tff(fact_8123_Zero__rat__def,axiom,
    zero_zero(rat) = fract(zero_zero(int),one_one(int)) ).

% Zero_rat_def
tff(fact_8124_listrelp_Osimps,axiom,
    ! [A: $tType,B: $tType,R2: fun(A,fun(B,bool)),A1: list(A),A22: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,R2),A1),A22))
    <=> ( ( ( A1 = nil(A) )
          & ( A22 = nil(B) ) )
        | ? [X4: A,Y: B,Xs3: list(A),Ys4: list(B)] :
            ( ( A1 = aa(list(A),list(A),cons(A,X4),Xs3) )
            & ( A22 = aa(list(B),list(B),cons(B,Y),Ys4) )
            & pp(aa(B,bool,aa(A,fun(B,bool),R2,X4),Y))
            & pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,R2),Xs3),Ys4)) ) ) ) ).

% listrelp.simps
tff(fact_8125_listrelp_Ocases,axiom,
    ! [A: $tType,B: $tType,R2: fun(A,fun(B,bool)),A1: list(A),A22: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,R2),A1),A22))
     => ( ( ( A1 = nil(A) )
         => ( A22 != nil(B) ) )
       => ~ ! [X2: A,Y2: B,Xs2: list(A)] :
              ( ( A1 = aa(list(A),list(A),cons(A,X2),Xs2) )
             => ! [Ys3: list(B)] :
                  ( ( A22 = aa(list(B),list(B),cons(B,Y2),Ys3) )
                 => ( pp(aa(B,bool,aa(A,fun(B,bool),R2,X2),Y2))
                   => ~ pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,R2),Xs2),Ys3)) ) ) ) ) ) ).

% listrelp.cases
tff(fact_8126_zero__less__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),zero_zero(rat)),fract(A3,B2)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),A3)) ) ) ).

% zero_less_Fract_iff
tff(fact_8127_Fract__less__zero__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),fract(A3,B2)),zero_zero(rat)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A3),zero_zero(int))) ) ) ).

% Fract_less_zero_iff
tff(fact_8128_Fract__less__one__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),fract(A3,B2)),one_one(rat)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),A3),B2)) ) ) ).

% Fract_less_one_iff
tff(fact_8129_one__less__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),one_one(rat)),fract(A3,B2)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),B2),A3)) ) ) ).

% one_less_Fract_iff
tff(fact_8130_Fract__add__one,axiom,
    ! [N: int,M: int] :
      ( ( N != zero_zero(int) )
     => ( fract(aa(int,int,aa(int,fun(int,int),plus_plus(int),M),N),N) = aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),fract(M,N)),one_one(rat)) ) ) ).

% Fract_add_one
tff(fact_8131_zero__le__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),zero_zero(rat)),fract(A3,B2)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),A3)) ) ) ).

% zero_le_Fract_iff
tff(fact_8132_Fract__le__zero__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),fract(A3,B2)),zero_zero(rat)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),zero_zero(int))) ) ) ).

% Fract_le_zero_iff
tff(fact_8133_one__le__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),one_one(rat)),fract(A3,B2)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),B2),A3)) ) ) ).

% one_le_Fract_iff
tff(fact_8134_Fract__le__one__iff,axiom,
    ! [B2: int,A3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),B2))
     => ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),fract(A3,B2)),one_one(rat)))
      <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),A3),B2)) ) ) ).

% Fract_le_one_iff
tff(fact_8135_rat__number__expand_I5_J,axiom,
    ! [K: num] : ( aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K)) = fract(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% rat_number_expand(5)
tff(fact_8136_rat__number__collapse_I4_J,axiom,
    ! [W: num] : ( fract(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W)),one_one(int)) = aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),W)) ) ).

% rat_number_collapse(4)
tff(fact_8137_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),X: list(A),Xa2: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,aTP_Lamp_in(set(product_prod(A,B)),fun(A,fun(B,bool)),R2)),X),Xa2))
    <=> pp(aa(set(product_prod(list(A),list(B))),bool,aa(product_prod(list(A),list(B)),fun(set(product_prod(list(A),list(B))),bool),member2(product_prod(list(A),list(B))),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),X),Xa2)),listrel(A,B,R2))) ) ).

% listrelp_listrel_eq
tff(fact_8138_rotate__drop__take,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,N),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),drop(A,modulo_modulo(nat,N,aa(list(A),nat,size_size(list(A)),Xs)),Xs)),take(A,modulo_modulo(nat,N,aa(list(A),nat,size_size(list(A)),Xs)),Xs)) ) ).

% rotate_drop_take
tff(fact_8139_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( ring_1_of_int(A) = aa(fun(product_prod(nat,nat),A),fun(int,A),map_fun(int,product_prod(nat,nat),A,A,rep_Integ,id(A)),product_case_prod(nat,nat,A,aTP_Lamp_nt(nat,fun(nat,A)))) ) ) ).

% ring_1_class.of_int_def
tff(fact_8140_of__nat__eq__id,axiom,
    semiring_1_of_nat(nat) = id(nat) ).

% of_nat_eq_id
tff(fact_8141_list_Omap__id0,axiom,
    ! [A: $tType] : ( map(A,A,id(A)) = id(list(A)) ) ).

% list.map_id0
tff(fact_8142_id__funpow,axiom,
    ! [A: $tType,N: nat] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),id(A)) = id(A) ) ).

% id_funpow
tff(fact_8143_rotate0,axiom,
    ! [A: $tType] : ( rotate(A,zero_zero(nat)) = id(list(A)) ) ).

% rotate0
tff(fact_8144_rotate__is__Nil__conv,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( aa(list(A),list(A),rotate(A,N),Xs) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% rotate_is_Nil_conv
tff(fact_8145_set__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),rotate(A,N),Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% set_rotate
tff(fact_8146_length__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),rotate(A,N),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_rotate
tff(fact_8147_distinct__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( distinct(A,aa(list(A),list(A),rotate(A,N),Xs))
    <=> distinct(A,Xs) ) ).

% distinct_rotate
tff(fact_8148_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se4730199178511100633sh_bit(A,zero_zero(nat)) = id(A) ) ) ).

% push_bit_0_id
tff(fact_8149_drop__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se4197421643247451524op_bit(A,zero_zero(nat)) = id(A) ) ) ).

% drop_bit_0
tff(fact_8150_rotate__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,aa(nat,nat,suc,N)),Xs) = aa(list(A),list(A),rotate1(A),aa(list(A),list(A),rotate(A,N),Xs)) ) ).

% rotate_Suc
tff(fact_8151_rotate__length01,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)))
     => ( aa(list(A),list(A),rotate(A,N),Xs) = Xs ) ) ).

% rotate_length01
tff(fact_8152_rotate__id,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( modulo_modulo(nat,N,aa(list(A),nat,size_size(list(A)),Xs)) = zero_zero(nat) )
     => ( aa(list(A),list(A),rotate(A,N),Xs) = Xs ) ) ).

% rotate_id
tff(fact_8153_rotate__def,axiom,
    ! [A: $tType,N: nat] : ( rotate(A,N) = aa(fun(list(A),list(A)),fun(list(A),list(A)),aa(nat,fun(fun(list(A),list(A)),fun(list(A),list(A))),compow(fun(list(A),list(A))),N),rotate1(A)) ) ).

% rotate_def
tff(fact_8154_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),zero_zero(nat)),F2) = id(A) ) ).

% funpow_simps_right(1)
tff(fact_8155_rotate__add,axiom,
    ! [A: $tType,M: nat,N: nat] : ( rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),rotate(A,M)),rotate(A,N)) ) ).

% rotate_add
tff(fact_8156_rotate__conv__mod,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,N),Xs) = aa(list(A),list(A),rotate(A,modulo_modulo(nat,N,aa(list(A),nat,size_size(list(A)),Xs))),Xs) ) ).

% rotate_conv_mod
tff(fact_8157_rotate__rotate,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,M),aa(list(A),list(A),rotate(A,N),Xs)) = aa(list(A),list(A),rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),Xs) ) ).

% rotate_rotate
tff(fact_8158_rotate1__rotate__swap,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate1(A),aa(list(A),list(A),rotate(A,N),Xs)) = aa(list(A),list(A),rotate(A,N),aa(list(A),list(A),rotate1(A),Xs)) ) ).

% rotate1_rotate_swap
tff(fact_8159_foldr__Nil,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(B,B))] : ( foldr(A,B,F2,nil(A)) = id(B) ) ).

% foldr_Nil
tff(fact_8160_rotate__append,axiom,
    ! [A: $tType,L: list(A),Q2: list(A)] : ( aa(list(A),list(A),rotate(A,aa(list(A),nat,size_size(list(A)),L)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),L),Q2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Q2),L) ) ).

% rotate_append
tff(fact_8161_foldr__filter,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,fun(A,A)),P: fun(B,bool),Xs: list(B)] : ( foldr(B,A,F2,aa(list(B),list(B),filter2(B,P),Xs)) = foldr(B,A,aa(fun(B,bool),fun(B,fun(A,A)),aTP_Lamp_aig(fun(B,fun(A,A)),fun(fun(B,bool),fun(B,fun(A,A))),F2),P),Xs) ) ).

% foldr_filter
tff(fact_8162_less__eq__int__def,axiom,
    ord_less_eq(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),fun(int,fun(int,bool)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),bool),fun(int,bool),rep_Integ,map_fun(int,product_prod(nat,nat),bool,bool,rep_Integ,id(bool))),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool),aTP_Lamp_nx(nat,fun(nat,fun(product_prod(nat,nat),bool))))) ).

% less_eq_int_def
tff(fact_8163_less__int__def,axiom,
    ord_less(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),fun(int,fun(int,bool)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),bool),fun(int,bool),rep_Integ,map_fun(int,product_prod(nat,nat),bool,bool,rep_Integ,id(bool))),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool),aTP_Lamp_nv(nat,fun(nat,fun(product_prod(nat,nat),bool))))) ).

% less_int_def
tff(fact_8164_nat__def,axiom,
    nat2 = aa(fun(product_prod(nat,nat),nat),fun(int,nat),map_fun(int,product_prod(nat,nat),nat,nat,rep_Integ,id(nat)),product_case_prod(nat,nat,nat,minus_minus(nat))) ).

% nat_def
tff(fact_8165_List_Omap_Oidentity,axiom,
    ! [A: $tType] : ( map(A,A,aTP_Lamp_if(A,A)) = id(list(A)) ) ).

% List.map.identity
tff(fact_8166_list_Omap__id,axiom,
    ! [A: $tType,T2: list(A)] : ( aa(list(A),list(A),map(A,A,id(A)),T2) = T2 ) ).

% list.map_id
tff(fact_8167_rotate__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: fun(B,A),Xs: list(B)] : ( aa(list(A),list(A),rotate(A,N),aa(list(B),list(A),map(B,A,F2),Xs)) = aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),rotate(B,N),Xs)) ) ).

% rotate_map
tff(fact_8168_rotate__rev,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,N),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),aa(list(A),list(A),rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),modulo_modulo(nat,N,aa(list(A),nat,size_size(list(A)),Xs)))),Xs)) ) ).

% rotate_rev
tff(fact_8169_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [F2: fun(A,B),G: fun(C,B),A2: set(A),B3: set(C)] :
          ( inj_on(product_prod(A,C),B,product_case_prod(A,C,B,aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_fk(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),F2),G)),product_Sigma(A,C,A2,aTP_Lamp_agq(set(C),fun(A,set(C)),B3)))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A2)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),B3)) = aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7311177749621191930dd_sum(B,B),id(B)),collect(B,aa(set(C),fun(B,bool),aa(set(A),fun(set(C),fun(B,bool)),aa(fun(C,B),fun(set(A),fun(set(C),fun(B,bool))),aTP_Lamp_aih(fun(A,B),fun(fun(C,B),fun(set(A),fun(set(C),fun(B,bool)))),F2),G),A2),B3))) ) ) ) ).

% sum_mult_sum_if_inj
tff(fact_8170_nth__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list(A),M: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),rotate(A,M),Xs)),N) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% nth_rotate
tff(fact_8171_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),A,hd(A),aa(list(A),list(A),rotate(A,N),Xs)) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,N,aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% hd_rotate_conv_nth
tff(fact_8172_sorted__key__list__of__set__def,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A)] : ( linord144544945434240204of_set(B,A,F2) = finite_folding_F(B,list(B),linorder_insort_key(B,A,F2),nil(B)) ) ) ).

% sorted_key_list_of_set_def
tff(fact_8173_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = case_option(int,num,zero_zero(int),aTP_Lamp_aii(num,fun(num,int),M),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M),N)) ) ).

% take_bit_numeral_minus_numeral_int
tff(fact_8174_take__bit__num__simps_I1_J,axiom,
    ! [M: num] : ( bit_take_bit_num(zero_zero(nat),M) = none(num) ) ).

% take_bit_num_simps(1)
tff(fact_8175_take__bit__num__simps_I2_J,axiom,
    ! [N: nat] : ( bit_take_bit_num(aa(nat,nat,suc,N),one2) = some(num,one2) ) ).

% take_bit_num_simps(2)
tff(fact_8176_take__bit__num__simps_I5_J,axiom,
    ! [R2: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R2),one2) = some(num,one2) ) ).

% take_bit_num_simps(5)
tff(fact_8177_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: num,N: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),M)),aa(num,A,numeral_numeral(A),N)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M),N)) ) ) ).

% take_bit_numeral_numeral
tff(fact_8178_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: num,Q2: num] :
          ( ( bit_take_bit_num(M,N) = some(num,Q2) )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),Q2) ) ) ) ).

% take_bit_num_eq_Some_imp
tff(fact_8179_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N: nat] : ( bit_take_bit_num(N,one2) = case_nat(option(num),none(num),aTP_Lamp_aij(nat,option(num)),N) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
tff(fact_8180_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: num] :
          ( ( bit_take_bit_num(M,N) = none(num) )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(num,A,numeral_numeral(A),N)) = zero_zero(A) ) ) ) ).

% take_bit_num_eq_None_imp
tff(fact_8181_take__bit__num__def,axiom,
    ! [N: nat,M: num] :
      ( ( ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(num,nat,numeral_numeral(nat),M)) = zero_zero(nat) )
       => ( bit_take_bit_num(N,M) = none(num) ) )
      & ( ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(num,nat,numeral_numeral(nat),M)) != zero_zero(nat) )
       => ( bit_take_bit_num(N,M) = some(num,num_of_nat(aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(num,nat,numeral_numeral(nat),M)))) ) ) ) ).

% take_bit_num_def
tff(fact_8182_ATP_Olambda__1,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_au(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uu)),one_one(real))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat)))) ) ).

% ATP.lambda_1
tff(fact_8183_ATP_Olambda__2,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_xe(A,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Uu)),one_one(A))),Uu) ) ) ).

% ATP.lambda_2
tff(fact_8184_ATP_Olambda__3,axiom,
    ! [A: $tType,Uu: set(set(A))] : ( aa(set(set(A)),int,aTP_Lamp_nf(set(set(A)),int),Uu) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(set(A)),nat,finite_card(set(A)),Uu)),one_one(nat)))),aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),Uu)))) ) ).

% ATP.lambda_3
tff(fact_8185_ATP_Olambda__4,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: A] :
          ( pp(aa(A,bool,aTP_Lamp_adz(A,bool),Uu))
        <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uu),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Uu)) ) ) ) ).

% ATP.lambda_4
tff(fact_8186_ATP_Olambda__5,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_cc(nat,real),Uu) = aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_5
tff(fact_8187_ATP_Olambda__6,axiom,
    ! [Uu: real] :
      ( pp(aa(real,bool,aTP_Lamp_hy(real,bool),Uu))
    <=> ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Uu))
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Uu),aa(num,real,numeral_numeral(real),bit0(one2))))
        & ( cos(real,Uu) = zero_zero(real) ) ) ) ).

% ATP.lambda_6
tff(fact_8188_ATP_Olambda__7,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_yb(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uu))),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_7
tff(fact_8189_ATP_Olambda__8,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_fq(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),times_times(real),cos_coeff(Uu)),aa(nat,real,power_power(real,zero_zero(real)),Uu)) ) ).

% ATP.lambda_8
tff(fact_8190_ATP_Olambda__9,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ya(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uu))) ) ) ).

% ATP.lambda_9
tff(fact_8191_ATP_Olambda__10,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_xj(real,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,Uu)),sin(real,Uu)) ) ).

% ATP.lambda_10
tff(fact_8192_ATP_Olambda__11,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_zz(real,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),Uu)),Uu) ) ).

% ATP.lambda_11
tff(fact_8193_ATP_Olambda__12,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: nat] :
          ( pp(aa(nat,bool,aTP_Lamp_pa(nat,bool),Uu))
        <=> ( aa(nat,A,semiring_1_of_nat(A),Uu) = zero_zero(A) ) ) ) ).

% ATP.lambda_12
tff(fact_8194_ATP_Olambda__13,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_xq(nat,real),Uu) = aa(real,real,root(Uu),aa(nat,real,semiring_1_of_nat(real),Uu)) ) ).

% ATP.lambda_13
tff(fact_8195_ATP_Olambda__14,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_iu(nat,nat),Uu) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,suc,zero_zero(nat))) ) ).

% ATP.lambda_14
tff(fact_8196_ATP_Olambda__15,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,product_prod(A,A),aTP_Lamp_afn(A,product_prod(A,A)),Uu) = aa(A,product_prod(A,A),product_Pair(A,A,Uu),Uu) ) ).

% ATP.lambda_15
tff(fact_8197_ATP_Olambda__16,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_cx(A,A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),one_one(A)) ) ) ).

% ATP.lambda_16
tff(fact_8198_ATP_Olambda__17,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,list(A),aTP_Lamp_qj(A,list(A)),Uu) = aa(list(A),list(A),cons(A,Uu),nil(A)) ) ).

% ATP.lambda_17
tff(fact_8199_ATP_Olambda__18,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_xw(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),Uu)) ) ).

% ATP.lambda_18
tff(fact_8200_ATP_Olambda__19,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_xz(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_19
tff(fact_8201_ATP_Olambda__20,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_ou(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(B),nat,size_size(list(B)),Uu)),aa(nat,nat,suc,zero_zero(nat)))) ) ).

% ATP.lambda_20
tff(fact_8202_ATP_Olambda__21,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( pp(aa(list(B),bool,aTP_Lamp_ov(list(B),bool),Uu))
    <=> ( Uu != nil(B) ) ) ).

% ATP.lambda_21
tff(fact_8203_ATP_Olambda__22,axiom,
    ! [A: $tType,Uu: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_ow(list(A),bool),Uu))
    <=> ( Uu != nil(A) ) ) ).

% ATP.lambda_22
tff(fact_8204_ATP_Olambda__23,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: B] : ( aa(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C))),aTP_Lamp_afq(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C)))),Uu) = product_case_prod(A,C,product_prod(A,product_prod(B,C)),aTP_Lamp_afp(B,fun(A,fun(C,product_prod(A,product_prod(B,C)))),Uu)) ) ).

% ATP.lambda_23
tff(fact_8205_ATP_Olambda__24,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_sl(real,real),Uu) = suminf(real,aTP_Lamp_av(real,fun(nat,real),Uu)) ) ).

% ATP.lambda_24
tff(fact_8206_ATP_Olambda__25,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real] : ( aa(real,filter(A),aTP_Lamp_afc(real,filter(A)),Uu) = principal(A,collect(A,aTP_Lamp_afb(real,fun(A,bool),Uu))) ) ) ).

% ATP.lambda_25
tff(fact_8207_ATP_Olambda__26,axiom,
    ! [Uu: real] : ( aa(real,filter(product_prod(real,real)),aTP_Lamp_afk(real,filter(product_prod(real,real))),Uu) = principal(product_prod(real,real),collect(product_prod(real,real),product_case_prod(real,real,bool,aTP_Lamp_afj(real,fun(real,fun(real,bool)),Uu)))) ) ).

% ATP.lambda_26
tff(fact_8208_ATP_Olambda__27,axiom,
    ! [Uu: real] : ( aa(real,filter(product_prod(complex,complex)),aTP_Lamp_afi(real,filter(product_prod(complex,complex))),Uu) = principal(product_prod(complex,complex),collect(product_prod(complex,complex),product_case_prod(complex,complex,bool,aTP_Lamp_afh(real,fun(complex,fun(complex,bool)),Uu)))) ) ).

% ATP.lambda_27
tff(fact_8209_ATP_Olambda__28,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [Uu: real] : ( aa(real,filter(product_prod(A,A)),aTP_Lamp_afg(real,filter(product_prod(A,A))),Uu) = principal(product_prod(A,A),collect(product_prod(A,A),product_case_prod(A,A,bool,aTP_Lamp_aff(real,fun(A,fun(A,bool)),Uu)))) ) ) ).

% ATP.lambda_28
tff(fact_8210_ATP_Olambda__29,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_xy(nat,real),Uu) = aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uu))) ) ).

% ATP.lambda_29
tff(fact_8211_ATP_Olambda__30,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_xs(nat,A),Uu) = aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_30
tff(fact_8212_ATP_Olambda__31,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_ot(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(B),nat,size_size(list(B)),Uu)) ) ).

% ATP.lambda_31
tff(fact_8213_ATP_Olambda__32,axiom,
    ! [A: $tType,Uu: list(A)] : ( aa(list(A),fun(nat,nat),aTP_Lamp_og(list(A),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Uu)) ) ).

% ATP.lambda_32
tff(fact_8214_ATP_Olambda__33,axiom,
    ! [Uu: nat] : ( aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_ic(nat,fun(nat,product_prod(nat,nat))),Uu) = product_Pair(nat,nat,aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_33
tff(fact_8215_ATP_Olambda__34,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: A] :
          ( pp(aa(A,bool,aTP_Lamp_ahp(A,bool),Uu))
        <=> ? [N3: int] :
              ( ( Uu = aa(int,A,ring_1_of_int(A),N3) )
              & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N3)) ) ) ) ).

% ATP.lambda_34
tff(fact_8216_ATP_Olambda__35,axiom,
    ! [Uu: real] :
      ( pp(aa(real,bool,aTP_Lamp_ahw(real,bool),Uu))
    <=> ? [I2: int,N3: nat] :
          ( ( Uu = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),I2)),aa(nat,real,semiring_1_of_nat(real),N3)) )
          & ( N3 != zero_zero(nat) ) ) ) ).

% ATP.lambda_35
tff(fact_8217_ATP_Olambda__36,axiom,
    ! [Uu: real] :
      ( pp(aa(real,bool,aTP_Lamp_ahx(real,bool),Uu))
    <=> ? [I2: int,J4: int] :
          ( ( Uu = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),I2)),aa(int,real,ring_1_of_int(real),J4)) )
          & ( J4 != zero_zero(int) ) ) ) ).

% ATP.lambda_36
tff(fact_8218_ATP_Olambda__37,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( pp(aa(product_prod(A,A),bool,aTP_Lamp_agv(product_prod(A,A),bool),Uu))
        <=> ? [X4: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),product_Pair(A,A,X4),Y) )
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Y)) ) ) ) ).

% ATP.lambda_37
tff(fact_8219_ATP_Olambda__38,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( pp(aa(product_prod(A,A),bool,aTP_Lamp_agw(product_prod(A,A),bool),Uu))
        <=> ? [X4: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),product_Pair(A,A,X4),Y) )
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X4)) ) ) ) ).

% ATP.lambda_38
tff(fact_8220_ATP_Olambda__39,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( pp(aa(product_prod(A,A),bool,aTP_Lamp_agx(product_prod(A,A),bool),Uu))
        <=> ? [X4: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),product_Pair(A,A,X4),Y) )
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),Y)) ) ) ) ).

% ATP.lambda_39
tff(fact_8221_ATP_Olambda__40,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( pp(aa(product_prod(A,A),bool,aTP_Lamp_agy(product_prod(A,A),bool),Uu))
        <=> ? [X4: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),product_Pair(A,A,X4),Y) )
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X4)) ) ) ) ).

% ATP.lambda_40
tff(fact_8222_ATP_Olambda__41,axiom,
    ! [Uu: nat] : ( aa(nat,option(num),aTP_Lamp_aij(nat,option(num)),Uu) = some(num,one2) ) ).

% ATP.lambda_41
tff(fact_8223_ATP_Olambda__42,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cv(A,fun(nat,A),Uu),Uua) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,power_power(A,Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_42
tff(fact_8224_ATP_Olambda__43,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_es(nat,fun(nat,A),Uu),Uua) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_43
tff(fact_8225_ATP_Olambda__44,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cw(A,fun(nat,A),Uu),Uua) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,power_power(A,Uu),Uua))) ) ) ).

% ATP.lambda_44
tff(fact_8226_ATP_Olambda__45,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_cd(fun(nat,real),fun(nat,real),Uu),Uua) = if(real,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),zero_zero(real),aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% ATP.lambda_45
tff(fact_8227_ATP_Olambda__46,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: product_prod(A,C),Uua: product_prod(C,B)] : ( aa(product_prod(C,B),list(product_prod(A,B)),aTP_Lamp_qu(product_prod(A,C),fun(product_prod(C,B),list(product_prod(A,B))),Uu),Uua) = if(list(product_prod(A,B)),aa(C,bool,aa(C,fun(C,bool),fequal(C),aa(product_prod(A,C),C,product_snd(A,C),Uu)),aa(product_prod(C,B),C,product_fst(C,B),Uua)),aa(list(product_prod(A,B)),list(product_prod(A,B)),cons(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,aa(product_prod(A,C),A,product_fst(A,C),Uu)),aa(product_prod(C,B),B,product_snd(C,B),Uua))),nil(product_prod(A,B))),nil(product_prod(A,B))) ) ).

% ATP.lambda_46
tff(fact_8228_ATP_Olambda__47,axiom,
    ! [Uu: code_integer,Uua: code_integer] : ( aa(code_integer,int,aa(code_integer,fun(code_integer,int),aTP_Lamp_nh(code_integer,fun(code_integer,int)),Uu),Uua) = if(int,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uua),zero_zero(code_integer)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),code_int_of_integer(Uu)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),code_int_of_integer(Uu))),one_one(int))) ) ).

% ATP.lambda_47
tff(fact_8229_ATP_Olambda__48,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_io(nat,fun(nat,A)),Uu),Uua) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uua),zero_zero(nat)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,semiring_1_of_nat(A),Uu))),one_one(A))) ) ) ).

% ATP.lambda_48
tff(fact_8230_ATP_Olambda__49,axiom,
    ! [Uu: code_integer,Uua: code_integer] : ( aa(code_integer,num,aa(code_integer,fun(code_integer,num),aTP_Lamp_agh(code_integer,fun(code_integer,num)),Uu),Uua) = if(num,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uua),zero_zero(code_integer)),aa(num,num,aa(num,fun(num,num),plus_plus(num),code_num_of_integer(Uu)),code_num_of_integer(Uu)),aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),code_num_of_integer(Uu)),code_num_of_integer(Uu))),one2)) ) ).

% ATP.lambda_49
tff(fact_8231_ATP_Olambda__50,axiom,
    ! [Uu: code_integer,Uua: code_integer] : ( aa(code_integer,nat,aa(code_integer,fun(code_integer,nat),aTP_Lamp_nc(code_integer,fun(code_integer,nat)),Uu),Uua) = if(nat,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uua),zero_zero(code_integer)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),code_nat_of_integer(Uu)),code_nat_of_integer(Uu)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),code_nat_of_integer(Uu)),code_nat_of_integer(Uu))),one_one(nat))) ) ).

% ATP.lambda_50
tff(fact_8232_ATP_Olambda__51,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_jy(int,fun(int,product_prod(int,int))),Uu),Uua) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),Uu),zero_zero(int)),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),Uu)),Uua)),aa(int,int,abs_abs(int),Uu))) ) ).

% ATP.lambda_51
tff(fact_8233_ATP_Olambda__52,axiom,
    ! [Uu: extended_enat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_an(extended_enat,fun(nat,extended_enat),Uu),Uua) = extended_case_enat(extended_enat,aTP_Lamp_am(nat,fun(nat,extended_enat),Uua),if(extended_enat,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uua),zero_zero(nat)),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)),Uu) ) ).

% ATP.lambda_52
tff(fact_8234_ATP_Olambda__53,axiom,
    ! [Uu: extended_enat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_al(extended_enat,fun(nat,extended_enat),Uu),Uua) = extended_case_enat(extended_enat,aTP_Lamp_ak(nat,fun(nat,extended_enat),Uua),zero_zero(extended_enat),Uu) ) ).

% ATP.lambda_53
tff(fact_8235_ATP_Olambda__54,axiom,
    ! [Uu: extended_enat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_aj(extended_enat,fun(nat,extended_enat),Uu),Uua) = extended_case_enat(extended_enat,aTP_Lamp_ai(nat,fun(nat,extended_enat),Uua),extend4730790105801354508finity(extended_enat),Uu) ) ).

% ATP.lambda_54
tff(fact_8236_ATP_Olambda__55,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ah(extended_enat,fun(nat,bool),Uu),Uua))
    <=> pp(extended_case_enat(bool,aa(nat,fun(nat,bool),aTP_Lamp_ag(nat,fun(nat,bool)),Uua),fFalse,Uu)) ) ).

% ATP.lambda_55
tff(fact_8237_ATP_Olambda__56,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_er(nat,fun(nat,A),Uu),Uua) = if(A,aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_56
tff(fact_8238_ATP_Olambda__57,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ac(extended_enat,fun(nat,bool),Uu),Uua))
    <=> pp(extended_case_enat(bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),fTrue,Uu)) ) ).

% ATP.lambda_57
tff(fact_8239_ATP_Olambda__58,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_adt(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),top_top(A)) ) ) ).

% ATP.lambda_58
tff(fact_8240_ATP_Olambda__59,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_adr(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),bot_bot(A)) ) ) ).

% ATP.lambda_59
tff(fact_8241_ATP_Olambda__60,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat] : ( aa(nat,list(A),aTP_Lamp_od(list(list(A)),fun(nat,list(A)),Uu),Uua) = aa(list(nat),list(A),map(nat,A,aa(nat,fun(nat,A),aTP_Lamp_oc(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua)),upt(zero_zero(nat),aa(list(list(A)),nat,size_size(list(list(A))),Uu))) ) ).

% ATP.lambda_60
tff(fact_8242_ATP_Olambda__61,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_ii(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ih(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_61
tff(fact_8243_ATP_Olambda__62,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_im(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_il(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua)),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_62
tff(fact_8244_ATP_Olambda__63,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_as(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Uu),one_one(real))),aa(nat,nat,suc,Uua))) ) ).

% ATP.lambda_63
tff(fact_8245_ATP_Olambda__64,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_bv(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat))))),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat)))) ) ).

% ATP.lambda_64
tff(fact_8246_ATP_Olambda__65,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_cf(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)))),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))) ) ).

% ATP.lambda_65
tff(fact_8247_ATP_Olambda__66,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_em(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),Uua))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_66
tff(fact_8248_ATP_Olambda__67,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_en(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uua)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),bit0(one2))),Uua)) ) ) ).

% ATP.lambda_67
tff(fact_8249_ATP_Olambda__68,axiom,
    ! [Uu: real,Uua: real] :
      ( pp(aa(real,bool,aTP_Lamp_ib(real,fun(real,bool),Uu),Uua))
    <=> ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Uua))
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Uua),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
        & ( sin(real,Uua) = Uu ) ) ) ).

% ATP.lambda_68
tff(fact_8250_ATP_Olambda__69,axiom,
    ! [Uu: real,Uua: real] :
      ( pp(aa(real,bool,aTP_Lamp_ha(real,fun(real,bool),Uu),Uua))
    <=> ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2))))),Uua))
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Uua),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))
        & ( aa(real,real,tan(real),Uua) = Uu ) ) ) ).

% ATP.lambda_69
tff(fact_8251_ATP_Olambda__70,axiom,
    ! [Uu: complex,Uua: real] :
      ( pp(aa(real,bool,aTP_Lamp_cy(complex,fun(real,bool),Uu),Uua))
    <=> ( ( aa(complex,complex,sgn_sgn(complex),Uu) = cis(Uua) )
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Uua))
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Uua),pi)) ) ) ).

% ATP.lambda_70
tff(fact_8252_ATP_Olambda__71,axiom,
    ! [Uu: real,Uua: int] :
      ( pp(aa(int,bool,aTP_Lamp_js(real,fun(int,bool),Uu),Uua))
    <=> ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(int,real,ring_1_of_int(real),Uua)),Uu))
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),Uu),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int))))) ) ) ).

% ATP.lambda_71
tff(fact_8253_ATP_Olambda__72,axiom,
    ! [Uu: rat,Uua: int] :
      ( pp(aa(int,bool,aTP_Lamp_jv(rat,fun(int,bool),Uu),Uua))
    <=> ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),aa(int,rat,ring_1_of_int(rat),Uua)),Uu))
        & pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),Uu),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int))))) ) ) ).

% ATP.lambda_72
tff(fact_8254_ATP_Olambda__73,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_av(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat))))),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat))))) ) ).

% ATP.lambda_73
tff(fact_8255_ATP_Olambda__74,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_sm(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% ATP.lambda_74
tff(fact_8256_ATP_Olambda__75,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_xk(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_75
tff(fact_8257_ATP_Olambda__76,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_eq(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_76
tff(fact_8258_ATP_Olambda__77,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dn(A,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))),Uua) ) ) ).

% ATP.lambda_77
tff(fact_8259_ATP_Olambda__78,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_et(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uu),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_78
tff(fact_8260_ATP_Olambda__79,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dy(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Uua)) ) ) ).

% ATP.lambda_79
tff(fact_8261_ATP_Olambda__80,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_ne(nat,fun(nat,bool)),Uu),Uua))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),Uu),Uua))
        & ( Uu != Uua ) ) ) ).

% ATP.lambda_80
tff(fact_8262_ATP_Olambda__81,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aTP_Lamp_ng(set(set(A)),fun(set(set(A)),bool),Uu),Uua))
    <=> ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),Uua),Uu))
        & ( Uua != bot_bot(set(set(A))) ) ) ) ).

% ATP.lambda_81
tff(fact_8263_ATP_Olambda__82,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ed(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,power_power(nat,aa(nat,nat,binomial(Uu),Uua)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% ATP.lambda_82
tff(fact_8264_ATP_Olambda__83,axiom,
    ! [Uu: set(int),Uua: int] :
      ( pp(aa(int,bool,aTP_Lamp_ahm(set(int),fun(int,bool),Uu),Uua))
    <=> ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),Uua),Uu))
        & ! [X4: int] :
            ( pp(aa(set(int),bool,aa(int,fun(set(int),bool),member2(int),X4),Uu))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X4),Uua)) ) ) ) ).

% ATP.lambda_83
tff(fact_8265_ATP_Olambda__84,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_aho(set(set(A)),fun(set(A),bool),Uu),Uua))
    <=> ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),Uua),Uu))
        & ! [X4: set(A)] :
            ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X4),Uu))
           => ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),Uua),X4)) ) ) ) ).

% ATP.lambda_84
tff(fact_8266_ATP_Olambda__85,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_gf(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,Uu),Uua)),semiring_char_0_fact(real,Uua)) ) ).

% ATP.lambda_85
tff(fact_8267_ATP_Olambda__86,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_aab(nat,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,Uua),Uu)),aa(real,real,exp(real),Uua)) ) ).

% ATP.lambda_86
tff(fact_8268_ATP_Olambda__87,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_act(set(A),fun(set(A),bool),Uu),Uua))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uua),Uu))
        & finite_finite(A,Uua) ) ) ).

% ATP.lambda_87
tff(fact_8269_ATP_Olambda__88,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_ls(set(A),fun(set(A),bool)),Uu),Uua))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),Uu),Uua))
        & finite_finite(A,Uua) ) ) ).

% ATP.lambda_88
tff(fact_8270_ATP_Olambda__89,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_adu(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,Uu),Uua)),Uua) ) ).

% ATP.lambda_89
tff(fact_8271_ATP_Olambda__90,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_dl(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uu) ) ).

% ATP.lambda_90
tff(fact_8272_ATP_Olambda__91,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_dk(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_91
tff(fact_8273_ATP_Olambda__92,axiom,
    ! [Uu: nat,Uua: complex] :
      ( pp(aa(complex,bool,aTP_Lamp_fh(nat,fun(complex,bool),Uu),Uua))
    <=> ( aa(nat,complex,power_power(complex,Uua),Uu) = one_one(complex) ) ) ).

% ATP.lambda_92
tff(fact_8274_ATP_Olambda__93,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: nat,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_lf(nat,fun(A,bool),Uu),Uua))
        <=> ( aa(nat,A,power_power(A,Uua),Uu) = one_one(A) ) ) ) ).

% ATP.lambda_93
tff(fact_8275_ATP_Olambda__94,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_le(A,fun(A,bool),Uu),Uua))
        <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uua),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),Uua)),Uu)) ) ) ) ).

% ATP.lambda_94
tff(fact_8276_ATP_Olambda__95,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_yi(real,fun(nat,real),Uu),Uua) = aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),Uu),aa(nat,real,semiring_1_of_nat(real),Uua)))),Uua) ) ).

% ATP.lambda_95
tff(fact_8277_ATP_Olambda__96,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_zj(real,fun(real,real),Uu),Uua) = powr(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),Uu),Uua)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),Uua)) ) ).

% ATP.lambda_96
tff(fact_8278_ATP_Olambda__97,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_aac(real,fun(real,real),Uu),Uua) = powr(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),Uu),Uua)),Uua) ) ).

% ATP.lambda_97
tff(fact_8279_ATP_Olambda__98,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ar(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat))))),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat)))) ) ).

% ATP.lambda_98
tff(fact_8280_ATP_Olambda__99,axiom,
    ! [Uu: real,Uua: real] :
      ( pp(aa(real,bool,aTP_Lamp_hp(real,fun(real,bool),Uu),Uua))
    <=> ( pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),Uua))
        & pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Uua),pi))
        & ( cos(real,Uua) = Uu ) ) ) ).

% ATP.lambda_99
tff(fact_8281_ATP_Olambda__100,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ahv(set(product_prod(A,A)),fun(nat,bool),Uu),Uua))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),Uua))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),Uu))) ) ) ).

% ATP.lambda_100
tff(fact_8282_ATP_Olambda__101,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ahz(nat,fun(nat,bool),Uu),Uua))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),Uua))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),aa(nat,nat,suc,Uu))) ) ) ).

% ATP.lambda_101
tff(fact_8283_ATP_Olambda__102,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_hs(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)))) ) ) ).

% ATP.lambda_102
tff(fact_8284_ATP_Olambda__103,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_du(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)))) ) ) ).

% ATP.lambda_103
tff(fact_8285_ATP_Olambda__104,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_yd(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_104
tff(fact_8286_ATP_Olambda__105,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_fu(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_105
tff(fact_8287_ATP_Olambda__106,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_ja(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),Uu,Uua),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_106
tff(fact_8288_ATP_Olambda__107,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_iw(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_107
tff(fact_8289_ATP_Olambda__108,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bj(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,power_power(A,zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_108
tff(fact_8290_ATP_Olambda__109,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_at(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,power_power(A,zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_109
tff(fact_8291_ATP_Olambda__110,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_kq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,power_power(A,zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_110
tff(fact_8292_ATP_Olambda__111,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bi(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,power_power(A,zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_111
tff(fact_8293_ATP_Olambda__112,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_gq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_112
tff(fact_8294_ATP_Olambda__113,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_gp(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_113
tff(fact_8295_ATP_Olambda__114,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_yc(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_114
tff(fact_8296_ATP_Olambda__115,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_dh(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_115
tff(fact_8297_ATP_Olambda__116,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: fun(A,bool),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ack(fun(A,bool),fun(A,bool),Uu),Uua))
        <=> ( pp(aa(A,bool,Uu,Uua))
            & ! [Y: A] :
                ( pp(aa(A,bool,Uu,Y))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Uua)) ) ) ) ) ).

% ATP.lambda_116
tff(fact_8298_ATP_Olambda__117,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_abo(fun(A,real),fun(A,bool),Uu),Uua))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(A,real,Uu,Uua)),zero_zero(real))) ) ).

% ATP.lambda_117
tff(fact_8299_ATP_Olambda__118,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ul(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uu,Uua)),zero_zero(real)) ) ) ).

% ATP.lambda_118
tff(fact_8300_ATP_Olambda__119,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,complex,aTP_Lamp_fd(fun(A,real),fun(A,complex),Uu),Uua) = complex2(aa(A,real,Uu,Uua),zero_zero(real)) ) ).

% ATP.lambda_119
tff(fact_8301_ATP_Olambda__120,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,list(A),aTP_Lamp_qc(fun(B,A),fun(B,list(A)),Uu),Uua) = aa(list(A),list(A),cons(A,aa(B,A,Uu,Uua)),nil(A)) ) ).

% ATP.lambda_120
tff(fact_8302_ATP_Olambda__121,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: B] :
          ( pp(aa(B,bool,aTP_Lamp_lc(fun(B,A),fun(B,bool),Uu),Uua))
        <=> ( aa(B,A,Uu,Uua) = zero_zero(A) ) ) ) ).

% ATP.lambda_121
tff(fact_8303_ATP_Olambda__122,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_ys(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),Uu)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat)))) ) ).

% ATP.lambda_122
tff(fact_8304_ATP_Olambda__123,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_yr(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_xk(fun(nat,real),fun(nat,real),Uu)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))) ) ).

% ATP.lambda_123
tff(fact_8305_ATP_Olambda__124,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] : ( aa(list(A),list(list(A)),aTP_Lamp_qh(list(A),fun(list(A),list(list(A))),Uu),Uua) = aa(list(A),list(list(A)),map(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_qg(list(A),fun(A,list(A))),Uua)),Uu) ) ).

% ATP.lambda_124
tff(fact_8306_ATP_Olambda__125,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_pb(nat,fun(nat,nat)),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uu) ) ).

% ATP.lambda_125
tff(fact_8307_ATP_Olambda__126,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_zb(fun(A,B),fun(A,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua))),real_V7770717601297561774m_norm(A,Uua)) ) ) ).

% ATP.lambda_126
tff(fact_8308_ATP_Olambda__127,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cl(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% ATP.lambda_127
tff(fact_8309_ATP_Olambda__128,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cu(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,suc,Uua)))),aa(nat,A,power_power(A,Uu),aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_128
tff(fact_8310_ATP_Olambda__129,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cm(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_129
tff(fact_8311_ATP_Olambda__130,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bs(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),semiring_char_0_fact(A,Uua))),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_130
tff(fact_8312_ATP_Olambda__131,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bw(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uua))),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_131
tff(fact_8313_ATP_Olambda__132,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aTP_Lamp_aii(num,fun(num,int),Uu),Uua) = aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),Uu)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),bit0(one2))),aa(num,nat,numeral_numeral(nat),Uu))),aa(num,int,numeral_numeral(int),Uua))) ) ).

% ATP.lambda_132
tff(fact_8314_ATP_Olambda__133,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ct(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),Uu)),Uua)) ) ) ).

% ATP.lambda_133
tff(fact_8315_ATP_Olambda__134,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_qb(nat,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Uua)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),Uua)),Uu)) ) ).

% ATP.lambda_134
tff(fact_8316_ATP_Olambda__135,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cn(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_135
tff(fact_8317_ATP_Olambda__136,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_co(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_136
tff(fact_8318_ATP_Olambda__137,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_yn(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_137
tff(fact_8319_ATP_Olambda__138,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ym(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_138
tff(fact_8320_ATP_Olambda__139,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_fp(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),sin_coeff(Uua)),aa(nat,real,power_power(real,Uu),Uua)) ) ).

% ATP.lambda_139
tff(fact_8321_ATP_Olambda__140,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_fo(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),cos_coeff(Uua)),aa(nat,real,power_power(real,Uu),Uua)) ) ).

% ATP.lambda_140
tff(fact_8322_ATP_Olambda__141,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_nt(nat,fun(nat,A)),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_141
tff(fact_8323_ATP_Olambda__142,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: A] : ( aa(A,list(list(A)),aTP_Lamp_qd(list(list(A)),fun(A,list(list(A))),Uu),Uua) = aa(list(list(A)),list(list(A)),map(list(A),list(A),cons(A,Uua)),product_lists(A,Uu)) ) ).

% ATP.lambda_142
tff(fact_8324_ATP_Olambda__143,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_ahq(list(A),fun(list(A),bool)),Uu),Uua))
    <=> ( aa(list(A),nat,size_size(list(A)),Uu) = aa(list(A),nat,size_size(list(A)),Uua) ) ) ).

% ATP.lambda_143
tff(fact_8325_ATP_Olambda__144,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_gr(nat,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Uua)),Uu) ) ) ).

% ATP.lambda_144
tff(fact_8326_ATP_Olambda__145,axiom,
    ! [A: $tType,B: $tType,Uu: list(B),Uua: A] : ( aa(A,list(product_prod(A,B)),aTP_Lamp_ip(list(B),fun(A,list(product_prod(A,B))),Uu),Uua) = aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),product_Pair(A,B,Uua)),Uu) ) ).

% ATP.lambda_145
tff(fact_8327_ATP_Olambda__146,axiom,
    ! [A: $tType,Uu: set(nat),Uua: product_prod(A,nat)] :
      ( pp(aa(product_prod(A,nat),bool,aTP_Lamp_afl(set(nat),fun(product_prod(A,nat),bool),Uu),Uua))
    <=> pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),aa(product_prod(A,nat),nat,product_snd(A,nat),Uua)),Uu)) ) ).

% ATP.lambda_146
tff(fact_8328_ATP_Olambda__147,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_agg(set(nat),fun(nat,bool),Uu),Uua))
    <=> pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),aa(nat,nat,suc,Uua)),Uu)) ) ).

% ATP.lambda_147
tff(fact_8329_ATP_Olambda__148,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_gz(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),product_Pair(A,A,Uu),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)),one_one(A))) ) ) ).

% ATP.lambda_148
tff(fact_8330_ATP_Olambda__149,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_hd(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),product_Pair(A,A,Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)) ) ) ).

% ATP.lambda_149
tff(fact_8331_ATP_Olambda__150,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_gy(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% ATP.lambda_150
tff(fact_8332_ATP_Olambda__151,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ep(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(nat,nat,binomial(Uu),Uua)) ) ).

% ATP.lambda_151
tff(fact_8333_ATP_Olambda__152,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_yk(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),Uu),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua)))))) ) ).

% ATP.lambda_152
tff(fact_8334_ATP_Olambda__153,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_yg(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or1337092689740270186AtMost(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_153
tff(fact_8335_ATP_Olambda__154,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_mx(fun(nat,A),fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),product_Pair(nat,A,Uua),aa(nat,A,Uu,Uua)) ) ).

% ATP.lambda_154
tff(fact_8336_ATP_Olambda__155,axiom,
    ! [Uu: nat,Uua: vEBT_VEBT] : ( aa(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ie(nat,fun(vEBT_VEBT,vEBT_VEBT),Uu),Uua) = vEBT_VEBT_elim_dead(Uua,extended_enat2(aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% ATP.lambda_155
tff(fact_8337_ATP_Olambda__156,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_jg(A,fun(nat,A),Uu),Uua) = aa(A,A,bit_se4730199178511100633sh_bit(A,Uua),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,bit_se5641148757651400278ts_bit(A,Uu),Uua))) ) ) ).

% ATP.lambda_156
tff(fact_8338_ATP_Olambda__157,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_yh(fun(nat,A),fun(nat,real),Uu),Uua) = aa(real,real,root(Uua),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua))) ) ) ).

% ATP.lambda_157
tff(fact_8339_ATP_Olambda__158,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aa(int,fun(int,int),aTP_Lamp_agf(int,fun(int,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),aa(bool,int,zero_neq_one_of_bool(int),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),fequal(int),Uua),zero_zero(int))))) ) ).

% ATP.lambda_158
tff(fact_8340_ATP_Olambda__159,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_qa(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),Uu),set_ord_lessThan(nat,Uua)) ) ).

% ATP.lambda_159
tff(fact_8341_ATP_Olambda__160,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_pw(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_ord_lessThan(nat,Uua)) ) ) ).

% ATP.lambda_160
tff(fact_8342_ATP_Olambda__161,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_afb(real,fun(A,bool),Uu),Uua))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Uu),real_V7770717601297561774m_norm(A,Uua))) ) ) ).

% ATP.lambda_161
tff(fact_8343_ATP_Olambda__162,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ahy(set(product_prod(A,A)),fun(nat,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),Uu))) ) ).

% ATP.lambda_162
tff(fact_8344_ATP_Olambda__163,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_xr(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_163
tff(fact_8345_ATP_Olambda__164,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_oh(nat,fun(list(A),bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uu),aa(list(A),nat,size_size(list(A)),Uua))) ) ).

% ATP.lambda_164
tff(fact_8346_ATP_Olambda__165,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_hv(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_165
tff(fact_8347_ATP_Olambda__166,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_jj(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_166
tff(fact_8348_ATP_Olambda__167,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_hq(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_167
tff(fact_8349_ATP_Olambda__168,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_or(list(A),fun(A,bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uua),aa(list(A),set(A),set2(A),Uu))) ) ).

% ATP.lambda_168
tff(fact_8350_ATP_Olambda__169,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ady(list(A),fun(A,bool),Uu),Uua))
    <=> ( Uua = aa(list(A),A,hd(A),Uu) ) ) ).

% ATP.lambda_169
tff(fact_8351_ATP_Olambda__170,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_ll(set(A),fun(set(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uua),Uu)) ) ).

% ATP.lambda_170
tff(fact_8352_ATP_Olambda__171,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_ag(nat,fun(nat,bool)),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),Uu)) ) ).

% ATP.lambda_171
tff(fact_8353_ATP_Olambda__172,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_qq(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_172
tff(fact_8354_ATP_Olambda__173,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_aag(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_173
tff(fact_8355_ATP_Olambda__174,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_dj(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_174
tff(fact_8356_ATP_Olambda__175,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_pz(nat,fun(nat,nat),Uu),Uua) = modulo_modulo(nat,Uua,Uu) ) ).

% ATP.lambda_175
tff(fact_8357_ATP_Olambda__176,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_yv(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_176
tff(fact_8358_ATP_Olambda__177,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_pd(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_177
tff(fact_8359_ATP_Olambda__178,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_aeh(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_178
tff(fact_8360_ATP_Olambda__179,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_eu(nat,fun(nat,bool)),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),Uu)) ) ).

% ATP.lambda_179
tff(fact_8361_ATP_Olambda__180,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_qr(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_180
tff(fact_8362_ATP_Olambda__181,axiom,
    ! [A: $tType] :
      ( unboun7993243217541854897norder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_aah(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_181
tff(fact_8363_ATP_Olambda__182,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_fr(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_182
tff(fact_8364_ATP_Olambda__183,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_xp(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uu) ) ).

% ATP.lambda_183
tff(fact_8365_ATP_Olambda__184,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_yw(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_184
tff(fact_8366_ATP_Olambda__185,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_af(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_185
tff(fact_8367_ATP_Olambda__186,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_pi(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_186
tff(fact_8368_ATP_Olambda__187,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_pq(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uu) ) ).

% ATP.lambda_187
tff(fact_8369_ATP_Olambda__188,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_rr(nat,fun(real,real),Uu),Uua) = aa(nat,real,power_power(real,Uua),Uu) ) ).

% ATP.lambda_188
tff(fact_8370_ATP_Olambda__189,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_is(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uu) ) ).

% ATP.lambda_189
tff(fact_8371_ATP_Olambda__190,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aTP_Lamp_pt(int,fun(int,int),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),Uu) ) ).

% ATP.lambda_190
tff(fact_8372_ATP_Olambda__191,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_aei(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_191
tff(fact_8373_ATP_Olambda__192,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_pc(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_192
tff(fact_8374_ATP_Olambda__193,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_ru(real,fun(real,real),Uu),Uua) = powr(real,Uua,Uu) ) ).

% ATP.lambda_193
tff(fact_8375_ATP_Olambda__194,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ld(nat,fun(nat,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),Uua),Uu)) ) ).

% ATP.lambda_194
tff(fact_8376_ATP_Olambda__195,axiom,
    ! [Uu: int,Uua: int] :
      ( pp(aa(int,bool,aTP_Lamp_lq(int,fun(int,bool),Uu),Uua))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),Uua),Uu)) ) ).

% ATP.lambda_195
tff(fact_8377_ATP_Olambda__196,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ab(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Uua),Uu)) ) ) ).

% ATP.lambda_196
tff(fact_8378_ATP_Olambda__197,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_ns(nat,fun(nat,product_prod(nat,nat))),Uu),Uua) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Uua),Uu) ) ).

% ATP.lambda_197
tff(fact_8379_ATP_Olambda__198,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_afo(B,fun(A,product_prod(A,B))),Uu),Uua) = aa(B,product_prod(A,B),product_Pair(A,B,Uua),Uu) ) ).

% ATP.lambda_198
tff(fact_8380_ATP_Olambda__199,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_my(A,fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),product_Pair(nat,A,Uua),Uu) ) ).

% ATP.lambda_199
tff(fact_8381_ATP_Olambda__200,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] : ( aa(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_qg(list(A),fun(A,list(A))),Uu),Uua) = aa(list(A),list(A),cons(A,Uua),Uu) ) ).

% ATP.lambda_200
tff(fact_8382_ATP_Olambda__201,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: int,Uua: A] : ( aa(A,A,aTP_Lamp_aeo(int,fun(A,A),Uu),Uua) = power_int(A,Uua,Uu) ) ) ).

% ATP.lambda_201
tff(fact_8383_ATP_Olambda__202,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_xx(real,fun(nat,real),Uu),Uua) = aa(real,real,root(Uua),Uu) ) ).

% ATP.lambda_202
tff(fact_8384_ATP_Olambda__203,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_acn(set(B),fun(B,bool),Uu),Uua))
    <=> pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uua),Uu)) ) ).

% ATP.lambda_203
tff(fact_8385_ATP_Olambda__204,axiom,
    ! [A: $tType] :
      ( topological_t3_space(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_aef(set(A),fun(A,bool),Uu),Uua))
        <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uua),Uu)) ) ) ).

% ATP.lambda_204
tff(fact_8386_ATP_Olambda__205,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_a(set(A),fun(A,bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uua),Uu)) ) ).

% ATP.lambda_205
tff(fact_8387_ATP_Olambda__206,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] : ( aa(nat,set(product_prod(A,A)),aTP_Lamp_ahu(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),Uu),Uua) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Uua),Uu) ) ).

% ATP.lambda_206
tff(fact_8388_ATP_Olambda__207,axiom,
    ! [A: $tType,Uu: list(A),Uua: nat] : ( aa(nat,list(A),aTP_Lamp_qt(list(A),fun(nat,list(A)),Uu),Uua) = drop(A,Uua,Uu) ) ).

% ATP.lambda_207
tff(fact_8389_ATP_Olambda__208,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] : ( aa(list(A),A,aTP_Lamp_oi(nat,fun(list(A),A),Uu),Uua) = aa(nat,A,nth(A,Uua),Uu) ) ).

% ATP.lambda_208
tff(fact_8390_ATP_Olambda__209,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_adw(A,fun(A,bool),Uu),Uua))
    <=> ( Uua = Uu ) ) ).

% ATP.lambda_209
tff(fact_8391_ATP_Olambda__210,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_qk(A,fun(list(A),list(A))),Uu),Uua) = aa(list(A),list(A),cons(A,Uu),nil(A)) ) ).

% ATP.lambda_210
tff(fact_8392_ATP_Olambda__211,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(list(A)),aa(A,fun(list(A),list(list(A))),aTP_Lamp_qm(A,fun(list(A),list(list(A)))),Uu),Uua) = aa(list(list(A)),list(list(A)),cons(list(A),Uua),nil(list(A))) ) ).

% ATP.lambda_211
tff(fact_8393_ATP_Olambda__212,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_abk(fun(A,real),fun(A,bool),Uu),Uua))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),zero_zero(real)),aa(A,real,Uu,Uua))) ) ).

% ATP.lambda_212
tff(fact_8394_ATP_Olambda__213,axiom,
    ! [B: $tType,Uu: fun(B,real),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_abi(fun(B,real),fun(B,bool),Uu),Uua))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(B,real,Uu,Uua))) ) ).

% ATP.lambda_213
tff(fact_8395_ATP_Olambda__214,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_abc(fun(A,real),fun(A,bool),Uu),Uua))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),one_one(real)),aa(A,real,Uu,Uua))) ) ) ).

% ATP.lambda_214
tff(fact_8396_ATP_Olambda__215,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_abm(fun(A,real),fun(A,bool),Uu),Uua))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,Uu,Uua))) ) ).

% ATP.lambda_215
tff(fact_8397_ATP_Olambda__216,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A] : ( aa(A,set(B),aTP_Lamp_agt(set(product_prod(A,B)),fun(A,set(B)),Uu),Uua) = aa(set(product_prod(A,B)),set(B),image(product_prod(A,B),B,product_snd(A,B)),Uu) ) ).

% ATP.lambda_216
tff(fact_8398_ATP_Olambda__217,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_ge(fun(nat,real),fun(nat,real),Uu),Uua) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat))) ) ).

% ATP.lambda_217
tff(fact_8399_ATP_Olambda__218,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_gd(fun(nat,real),fun(nat,real),Uu),Uua) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)) ) ).

% ATP.lambda_218
tff(fact_8400_ATP_Olambda__219,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_acg(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),Uua)) ) ) ).

% ATP.lambda_219
tff(fact_8401_ATP_Olambda__220,axiom,
    ! [A: $tType,Uu: fun(nat,bool),Uua: product_prod(A,nat)] :
      ( pp(aa(product_prod(A,nat),bool,aTP_Lamp_afz(fun(nat,bool),fun(product_prod(A,nat),bool),Uu),Uua))
    <=> pp(aa(nat,bool,Uu,aa(nat,nat,suc,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua)))) ) ).

% ATP.lambda_220
tff(fact_8402_ATP_Olambda__221,axiom,
    ! [Uu: fun(real,bool),Uua: real] :
      ( pp(aa(real,bool,aTP_Lamp_abh(fun(real,bool),fun(real,bool),Uu),Uua))
    <=> pp(aa(real,bool,Uu,aa(real,real,inverse_inverse(real),Uua))) ) ).

% ATP.lambda_221
tff(fact_8403_ATP_Olambda__222,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real] : ( aa(real,A,aTP_Lamp_aaa(fun(real,A),fun(real,A),Uu),Uua) = aa(real,A,Uu,aa(real,real,inverse_inverse(real),Uua)) ) ).

% ATP.lambda_222
tff(fact_8404_ATP_Olambda__223,axiom,
    ! [A: $tType,Uu: fun(nat,bool),Uua: product_prod(A,nat)] :
      ( pp(aa(product_prod(A,nat),bool,aTP_Lamp_aga(fun(nat,bool),fun(product_prod(A,nat),bool),Uu),Uua))
    <=> pp(aa(nat,bool,Uu,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua))) ) ).

% ATP.lambda_223
tff(fact_8405_ATP_Olambda__224,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_224
tff(fact_8406_ATP_Olambda__225,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bz(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_225
tff(fact_8407_ATP_Olambda__226,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_hm(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_226
tff(fact_8408_ATP_Olambda__227,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_dg(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_227
tff(fact_8409_ATP_Olambda__228,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_qi(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_228
tff(fact_8410_ATP_Olambda__229,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),aTP_Lamp_agj(A,fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),Uu),Uua) = product_case_prod(A,list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_agi(A,fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua)) ) ).

% ATP.lambda_229
tff(fact_8411_ATP_Olambda__230,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ob(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_oa(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_230
tff(fact_8412_ATP_Olambda__231,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_nz(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_ny(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_231
tff(fact_8413_ATP_Olambda__232,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),bool),aa(nat,fun(nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_nx(nat,fun(nat,fun(product_prod(nat,nat),bool))),Uu),Uua) = product_case_prod(nat,nat,bool,aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_nw(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua)) ) ).

% ATP.lambda_232
tff(fact_8414_ATP_Olambda__233,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),bool),aa(nat,fun(nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_nv(nat,fun(nat,fun(product_prod(nat,nat),bool))),Uu),Uua) = product_case_prod(nat,nat,bool,aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_nu(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua)) ) ).

% ATP.lambda_233
tff(fact_8415_ATP_Olambda__234,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_nr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_nq(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_234
tff(fact_8416_ATP_Olambda__235,axiom,
    ! [Uu: fun(nat,real),Uua: real] : ( aa(real,real,aTP_Lamp_sd(fun(nat,real),fun(real,real),Uu),Uua) = suminf(real,aa(real,fun(nat,real),aTP_Lamp_sc(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua)) ) ).

% ATP.lambda_235
tff(fact_8417_ATP_Olambda__236,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A] : ( aa(A,A,aTP_Lamp_rs(fun(nat,A),fun(A,A),Uu),Uua) = suminf(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua)) ) ) ).

% ATP.lambda_236
tff(fact_8418_ATP_Olambda__237,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: real,Uua: A] : ( aa(A,set(A),aTP_Lamp_zs(real,fun(A,set(A)),Uu),Uua) = collect(A,aa(A,fun(A,bool),aTP_Lamp_zr(real,fun(A,fun(A,bool)),Uu),Uua)) ) ) ).

% ATP.lambda_237
tff(fact_8419_ATP_Olambda__238,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,complex,aTP_Lamp_gl(nat,fun(nat,complex),Uu),Uua) = cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),aa(nat,real,semiring_1_of_nat(real),Uua))),aa(nat,real,semiring_1_of_nat(real),Uu))) ) ).

% ATP.lambda_238
tff(fact_8420_ATP_Olambda__239,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_tm(A,fun(A,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Uu)),Uua)),aa(A,A,inverse_inverse(A),Uu))) ) ) ).

% ATP.lambda_239
tff(fact_8421_ATP_Olambda__240,axiom,
    ! [Uu: fun(real,real),Uua: real] :
      ( pp(aa(real,bool,aTP_Lamp_aad(fun(real,real),fun(real,bool),Uu),Uua))
    <=> ( aa(real,real,Uu,Uua) != zero_zero(real) ) ) ).

% ATP.lambda_240
tff(fact_8422_ATP_Olambda__241,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: list(product_prod(C,B)),Uua: product_prod(A,C)] : ( aa(product_prod(A,C),list(product_prod(A,B)),aTP_Lamp_qv(list(product_prod(C,B)),fun(product_prod(A,C),list(product_prod(A,B))),Uu),Uua) = concat(product_prod(A,B),aa(list(product_prod(C,B)),list(list(product_prod(A,B))),map(product_prod(C,B),list(product_prod(A,B)),aTP_Lamp_qu(product_prod(A,C),fun(product_prod(C,B),list(product_prod(A,B))),Uua)),Uu)) ) ).

% ATP.lambda_241
tff(fact_8423_ATP_Olambda__242,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_cr(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,power_power(A,Uu),Uua))) ) ) ).

% ATP.lambda_242
tff(fact_8424_ATP_Olambda__243,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ao(nat,fun(nat,bool),Uu),Uua))
    <=> ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)))) ) ).

% ATP.lambda_243
tff(fact_8425_ATP_Olambda__244,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cs(A,fun(nat,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),Uu)),Uua))) ) ) ).

% ATP.lambda_244
tff(fact_8426_ATP_Olambda__245,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_cp(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,power_power(A,Uu),Uua))) ) ) ).

% ATP.lambda_245
tff(fact_8427_ATP_Olambda__246,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_cq(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,power_power(A,Uu),Uua))) ) ) ).

% ATP.lambda_246
tff(fact_8428_ATP_Olambda__247,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat] : ( aa(nat,set(A),aTP_Lamp_py(fun(nat,set(A)),fun(nat,set(A)),Uu),Uua) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),Uu),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua))) ) ).

% ATP.lambda_247
tff(fact_8429_ATP_Olambda__248,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_aq(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_248
tff(fact_8430_ATP_Olambda__249,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_ap(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_249
tff(fact_8431_ATP_Olambda__250,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_oq(list(A),fun(A,bool),Uu),Uua))
    <=> ~ pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uua),aa(list(A),set(A),set2(A),Uu))) ) ).

% ATP.lambda_250
tff(fact_8432_ATP_Olambda__251,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_ahh(nat,fun(nat,set(nat)),Uu),Uua) = set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uua)) ) ).

% ATP.lambda_251
tff(fact_8433_ATP_Olambda__252,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_yf(real,fun(nat,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(nat,real,power_power(real,Uu),Uua)) ) ).

% ATP.lambda_252
tff(fact_8434_ATP_Olambda__253,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_qz(A,fun(A,A),Uu),Uua) = cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu)) ) ) ).

% ATP.lambda_253
tff(fact_8435_ATP_Olambda__254,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_am(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uua)) ) ).

% ATP.lambda_254
tff(fact_8436_ATP_Olambda__255,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_ak(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uua)) ) ).

% ATP.lambda_255
tff(fact_8437_ATP_Olambda__256,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_ai(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)) ) ).

% ATP.lambda_256
tff(fact_8438_ATP_Olambda__257,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: A] : ( aa(A,filter(A),aTP_Lamp_aex(A,fun(A,filter(A)),Uu),Uua) = principal(A,set_or5935395276787703475ssThan(A,Uu,Uua)) ) ) ).

% ATP.lambda_257
tff(fact_8439_ATP_Olambda__258,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: A] : ( aa(A,filter(A),aTP_Lamp_aey(A,fun(A,filter(A)),Uu),Uua) = principal(A,set_or5935395276787703475ssThan(A,Uua,Uu)) ) ) ).

% ATP.lambda_258
tff(fact_8440_ATP_Olambda__259,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_aid(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uu),Uua)) ) ).

% ATP.lambda_259
tff(fact_8441_ATP_Olambda__260,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_aic(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uua),Uu)) ) ).

% ATP.lambda_260
tff(fact_8442_ATP_Olambda__261,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_jw(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uu),Uua)) ) ).

% ATP.lambda_261
tff(fact_8443_ATP_Olambda__262,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_jx(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uua),Uu)) ) ).

% ATP.lambda_262
tff(fact_8444_ATP_Olambda__263,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ol(A,fun(A,bool),Uu),Uua))
    <=> ( Uu != Uua ) ) ).

% ATP.lambda_263
tff(fact_8445_ATP_Olambda__264,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_op(A,fun(A,bool),Uu),Uua))
    <=> ( Uua != Uu ) ) ).

% ATP.lambda_264
tff(fact_8446_ATP_Olambda__265,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_bo(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_265
tff(fact_8447_ATP_Olambda__266,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_dr(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_266
tff(fact_8448_ATP_Olambda__267,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_br(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_267
tff(fact_8449_ATP_Olambda__268,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,real,aTP_Lamp_dd(fun(B,A),fun(B,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_268
tff(fact_8450_ATP_Olambda__269,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,real,aTP_Lamp_hh(fun(B,A),fun(B,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_269
tff(fact_8451_ATP_Olambda__270,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_vv(fun(A,B),fun(A,real),Uu),Uua) = real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_270
tff(fact_8452_ATP_Olambda__271,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_xv(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_271
tff(fact_8453_ATP_Olambda__272,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(C,A),Uua: C] : ( aa(C,A,aTP_Lamp_tk(fun(C,A),fun(C,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(C,A,Uu,Uua)) ) ) ).

% ATP.lambda_272
tff(fact_8454_ATP_Olambda__273,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_vr(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_273
tff(fact_8455_ATP_Olambda__274,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_acs(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_274
tff(fact_8456_ATP_Olambda__275,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_acx(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_275
tff(fact_8457_ATP_Olambda__276,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_rj(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_276
tff(fact_8458_ATP_Olambda__277,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_uw(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_277
tff(fact_8459_ATP_Olambda__278,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_zw(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_278
tff(fact_8460_ATP_Olambda__279,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ace(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_279
tff(fact_8461_ATP_Olambda__280,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] : ( aa(B,int,aTP_Lamp_fc(fun(B,nat),fun(B,int),Uu),Uua) = aa(nat,int,semiring_1_of_nat(int),aa(B,nat,Uu,Uua)) ) ).

% ATP.lambda_280
tff(fact_8462_ATP_Olambda__281,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_hb(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_281
tff(fact_8463_ATP_Olambda__282,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_db(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_282
tff(fact_8464_ATP_Olambda__283,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_tt(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_283
tff(fact_8465_ATP_Olambda__284,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_acv(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_284
tff(fact_8466_ATP_Olambda__285,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_xc(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_285
tff(fact_8467_ATP_Olambda__286,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_lj(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_286
tff(fact_8468_ATP_Olambda__287,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_hn(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_287
tff(fact_8469_ATP_Olambda__288,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_hc(fun(B,int),fun(B,A),Uu),Uua) = aa(int,A,ring_1_of_int(A),aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_288
tff(fact_8470_ATP_Olambda__289,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_dc(fun(B,int),fun(B,A),Uu),Uua) = aa(int,A,ring_1_of_int(A),aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_289
tff(fact_8471_ATP_Olambda__290,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_go(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_290
tff(fact_8472_ATP_Olambda__291,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_wp(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,artanh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_291
tff(fact_8473_ATP_Olambda__292,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_uf(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_292
tff(fact_8474_ATP_Olambda__293,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_sn(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcsin,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_293
tff(fact_8475_ATP_Olambda__294,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_adq(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcsin,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_294
tff(fact_8476_ATP_Olambda__295,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_adm(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,arcosh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_295
tff(fact_8477_ATP_Olambda__296,axiom,
    ! [B: $tType,Uu: fun(B,real),Uua: B] : ( aa(B,real,aTP_Lamp_wr(fun(B,real),fun(B,real),Uu),Uua) = aa(real,real,arcosh(real),aa(B,real,Uu,Uua)) ) ).

% ATP.lambda_296
tff(fact_8478_ATP_Olambda__297,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_zi(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcosh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_297
tff(fact_8479_ATP_Olambda__298,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_sp(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arccos,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_298
tff(fact_8480_ATP_Olambda__299,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_adp(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arccos,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_299
tff(fact_8481_ATP_Olambda__300,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_vw(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,sgn_sgn(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_300
tff(fact_8482_ATP_Olambda__301,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_acw(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_301
tff(fact_8483_ATP_Olambda__302,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ux(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_302
tff(fact_8484_ATP_Olambda__303,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_bp(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_303
tff(fact_8485_ATP_Olambda__304,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_vz(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_304
tff(fact_8486_ATP_Olambda__305,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ez(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,abs_abs(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_305
tff(fact_8487_ATP_Olambda__306,axiom,
    ! [A11: $tType] :
      ( ( real_Vector_banach(A11)
        & real_V3459762299906320749_field(A11) )
     => ! [Uu: fun(A11,A11),Uua: A11] : ( aa(A11,A11,aTP_Lamp_sa(fun(A11,A11),fun(A11,A11),Uu),Uua) = aa(A11,A11,tanh(A11),aa(A11,A11,Uu,Uua)) ) ) ).

% ATP.lambda_306
tff(fact_8488_ATP_Olambda__307,axiom,
    ! [A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(C,A),Uua: C] : ( aa(C,A,aTP_Lamp_adl(fun(C,A),fun(C,A),Uu),Uua) = aa(A,A,tanh(A),aa(C,A,Uu,Uua)) ) ) ).

% ATP.lambda_307
tff(fact_8489_ATP_Olambda__308,axiom,
    ! [A: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(C,A),Uua: C] : ( aa(C,A,aTP_Lamp_va(fun(C,A),fun(C,A),Uu),Uua) = aa(A,A,tanh(A),aa(C,A,Uu,Uua)) ) ) ).

% ATP.lambda_308
tff(fact_8490_ATP_Olambda__309,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(C,A),Uua: C] : ( aa(C,A,aTP_Lamp_vt(fun(C,A),fun(C,A),Uu),Uua) = aa(A,A,tanh(A),aa(C,A,Uu,Uua)) ) ) ).

% ATP.lambda_309
tff(fact_8491_ATP_Olambda__310,axiom,
    ! [A11: $tType] :
      ( ( real_Vector_banach(A11)
        & real_V3459762299906320749_field(A11) )
     => ! [Uu: fun(A11,A11),Uua: A11] : ( aa(A11,A11,aTP_Lamp_rf(fun(A11,A11),fun(A11,A11),Uu),Uua) = sinh(A11,aa(A11,A11,Uu,Uua)) ) ) ).

% ATP.lambda_310
tff(fact_8492_ATP_Olambda__311,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_tg(fun(A,A),fun(A,A),Uu),Uua) = sinh(A,aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_311
tff(fact_8493_ATP_Olambda__312,axiom,
    ! [A11: $tType] :
      ( ( real_Vector_banach(A11)
        & real_V3459762299906320749_field(A11) )
     => ! [Uu: fun(A11,A11),Uua: A11] : ( aa(A11,A11,aTP_Lamp_re(fun(A11,A11),fun(A11,A11),Uu),Uua) = cosh(A11,aa(A11,A11,Uu,Uua)) ) ) ).

% ATP.lambda_312
tff(fact_8494_ATP_Olambda__313,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_th(fun(A,A),fun(A,A),Uu),Uua) = cosh(A,aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_313
tff(fact_8495_ATP_Olambda__314,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_uh(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,tan(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_314
tff(fact_8496_ATP_Olambda__315,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_uy(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,tan(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_315
tff(fact_8497_ATP_Olambda__316,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_te(fun(A,real),fun(A,real),Uu),Uua) = sin(real,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_316
tff(fact_8498_ATP_Olambda__317,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_rl(fun(A,A),fun(A,A),Uu),Uua) = sin(A,aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_317
tff(fact_8499_ATP_Olambda__318,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_tc(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,exp(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_318
tff(fact_8500_ATP_Olambda__319,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_ro(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,exp(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_319
tff(fact_8501_ATP_Olambda__320,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_uz(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,cot(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_320
tff(fact_8502_ATP_Olambda__321,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_yq(fun(nat,real),fun(nat,real),Uu),Uua) = cos(real,aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_321
tff(fact_8503_ATP_Olambda__322,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_tp(fun(A,real),fun(A,real),Uu),Uua) = cos(real,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_322
tff(fact_8504_ATP_Olambda__323,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_qy(fun(A,A),fun(A,A),Uu),Uua) = cos(A,aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_323
tff(fact_8505_ATP_Olambda__324,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(C,A),Uua: C] : ( aa(C,fun(B,product_prod(A,B)),aTP_Lamp_afr(fun(C,A),fun(C,fun(B,product_prod(A,B))),Uu),Uua) = product_Pair(A,B,aa(C,A,Uu,Uua)) ) ).

% ATP.lambda_324
tff(fact_8506_ATP_Olambda__325,axiom,
    ! [C: $tType,D: $tType,Uu: fun(D,set(C)),Uua: D] : ( aa(D,filter(C),aTP_Lamp_aez(fun(D,set(C)),fun(D,filter(C)),Uu),Uua) = principal(C,aa(D,set(C),Uu,Uua)) ) ).

% ATP.lambda_325
tff(fact_8507_ATP_Olambda__326,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,filter(B),aTP_Lamp_afa(fun(A,set(B)),fun(A,filter(B)),Uu),Uua) = principal(B,aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_326
tff(fact_8508_ATP_Olambda__327,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,nat,aTP_Lamp_pu(fun(A,set(B)),fun(A,nat),Uu),Uua) = aa(set(B),nat,finite_card(B),aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_327
tff(fact_8509_ATP_Olambda__328,axiom,
    ! [Uu: fun(real,fun(nat,real)),Uua: real] : ( aa(real,real,aTP_Lamp_rw(fun(real,fun(nat,real)),fun(real,real),Uu),Uua) = suminf(real,aa(real,fun(nat,real),Uu,Uua)) ) ).

% ATP.lambda_328
tff(fact_8510_ATP_Olambda__329,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_Vector_banach(B) )
     => ! [Uu: fun(A,fun(nat,B)),Uua: A] : ( aa(A,B,aTP_Lamp_xh(fun(A,fun(nat,B)),fun(A,B),Uu),Uua) = suminf(B,aa(A,fun(nat,B),Uu,Uua)) ) ) ).

% ATP.lambda_329
tff(fact_8511_ATP_Olambda__330,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,list(A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_aen(fun(B,list(A)),fun(B,set(A)),Uu),Uua) = aa(list(A),set(A),set2(A),aa(B,list(A),Uu,Uua)) ) ).

% ATP.lambda_330
tff(fact_8512_ATP_Olambda__331,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ud(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_331
tff(fact_8513_ATP_Olambda__332,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_add(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_332
tff(fact_8514_ATP_Olambda__333,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_vm(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_333
tff(fact_8515_ATP_Olambda__334,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_wa(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_334
tff(fact_8516_ATP_Olambda__335,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B] : ( aa(B,set(set(A)),aTP_Lamp_ps(fun(B,set(A)),fun(B,set(set(A))),Uu),Uua) = pow2(A,aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_335
tff(fact_8517_ATP_Olambda__336,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,nat,aTP_Lamp_me(fun(A,nat),fun(A,nat),Uu),Uua) = aa(nat,nat,suc,aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_336
tff(fact_8518_ATP_Olambda__337,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_df(fun(A,bool),fun(A,bool),Uu),Uua))
    <=> ~ pp(aa(A,bool,Uu,Uua)) ) ).

% ATP.lambda_337
tff(fact_8519_ATP_Olambda__338,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real] : ( aa(real,filter(A),aTP_Lamp_afe(A,fun(real,filter(A)),Uu),Uua) = principal(A,collect(A,aa(real,fun(A,bool),aTP_Lamp_afd(A,fun(real,fun(A,bool)),Uu),Uua))) ) ) ).

% ATP.lambda_338
tff(fact_8520_ATP_Olambda__339,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [Uu: fun(real,A),Uua: real] : ( aa(real,real,aTP_Lamp_vc(fun(real,A),fun(real,real),Uu),Uua) = aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(A,aa(real,A,Uu,Uua))) ) ) ).

% ATP.lambda_339
tff(fact_8521_ATP_Olambda__340,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ahg(list(A),fun(A,bool),Uu),Uua))
    <=> ? [I2: nat] :
          ( ( Uua = aa(nat,A,nth(A,Uu),I2) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Uu))) ) ) ).

% ATP.lambda_340
tff(fact_8522_ATP_Olambda__341,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( pp(aa(set(A),bool,aTP_Lamp_ahk(set(set(A)),fun(set(A),bool),Uu),Uua))
        <=> ? [F6: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F6),Uu) )
              & ! [X4: set(A)] :
                  ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X4),Uu))
                 => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(set(A),A,F6,X4)),X4)) ) ) ) ) ).

% ATP.lambda_341
tff(fact_8523_ATP_Olambda__342,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( pp(aa(set(A),bool,aTP_Lamp_ahl(set(set(A)),fun(set(A),bool),Uu),Uua))
        <=> ? [F6: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F6),Uu) )
              & ! [X4: set(A)] :
                  ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X4),Uu))
                 => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(set(A),A,F6,X4)),X4)) ) ) ) ) ).

% ATP.lambda_342
tff(fact_8524_ATP_Olambda__343,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( pp(aa(set(A),bool,aTP_Lamp_ahr(set(set(A)),fun(set(A),bool),Uu),Uua))
        <=> ? [F6: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F6),Uu) )
              & ! [X4: set(A)] :
                  ( pp(aa(set(set(A)),bool,aa(set(A),fun(set(set(A)),bool),member2(set(A)),X4),Uu))
                 => pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),aa(set(A),A,F6,X4)),X4)) ) ) ) ) ).

% ATP.lambda_343
tff(fact_8525_ATP_Olambda__344,axiom,
    ! [A: $tType,Uu: set(filter(A)),Uua: filter(A)] :
      ( pp(aa(filter(A),bool,aTP_Lamp_ahn(set(filter(A)),fun(filter(A),bool),Uu),Uua))
    <=> ! [X4: filter(A)] :
          ( pp(aa(set(filter(A)),bool,aa(filter(A),fun(set(filter(A)),bool),member2(filter(A)),X4),Uu))
         => pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),Uua),X4)) ) ) ).

% ATP.lambda_344
tff(fact_8526_ATP_Olambda__345,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ahc(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),X4)) ) ) ) ).

% ATP.lambda_345
tff(fact_8527_ATP_Olambda__346,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ahd(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X4: A] :
              ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Uua)) ) ) ) ).

% ATP.lambda_346
tff(fact_8528_ATP_Olambda__347,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(A,bool),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_acj(fun(A,bool),fun(A,bool),Uu),Uua))
        <=> ! [Y: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Y))
             => pp(aa(A,bool,Uu,Y)) ) ) ) ).

% ATP.lambda_347
tff(fact_8529_ATP_Olambda__348,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),option(A),aa(A,fun(list(A),option(A)),aTP_Lamp_uj(A,fun(list(A),option(A))),Uu),Uua) = some(A,Uu) ) ).

% ATP.lambda_348
tff(fact_8530_ATP_Olambda__349,axiom,
    ! [A: $tType,B: $tType,Uu: list(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_agm(list(B),fun(A,set(B)),Uu),Uua) = aa(list(B),set(B),set2(B),Uu) ) ).

% ATP.lambda_349
tff(fact_8531_ATP_Olambda__350,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_ce(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = if(real,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub),aa(nat,real,Uua,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),one_one(nat))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% ATP.lambda_350
tff(fact_8532_ATP_Olambda__351,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_gc(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = if(real,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub),aa(nat,real,Uu,Uub),aa(nat,real,Uua,Uub)) ) ).

% ATP.lambda_351
tff(fact_8533_ATP_Olambda__352,axiom,
    ! [Uu: num,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_jn(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),aa(num,code_integer,numeral_numeral(code_integer),Uu)),Uub),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uub),aa(num,code_integer,numeral_numeral(code_integer),Uu))),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))),Uua)),Uub)) ) ).

% ATP.lambda_352
tff(fact_8534_ATP_Olambda__353,axiom,
    ! [Uu: num,Uua: nat,Uub: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_hw(num,fun(nat,fun(nat,product_prod(nat,nat))),Uu),Uua),Uub) = if(product_prod(nat,nat),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Uu)),Uub),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),Uu))),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),Uub)) ) ).

% ATP.lambda_353
tff(fact_8535_ATP_Olambda__354,axiom,
    ! [Uu: num,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_hx(num,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),Uu)),Uub),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),Uua)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uub),aa(num,int,numeral_numeral(int),Uu))),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),Uua)),Uub)) ) ).

% ATP.lambda_354
tff(fact_8536_ATP_Olambda__355,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: num,Uua: A,Uub: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_ia(num,fun(A,fun(A,product_prod(A,A))),Uu),Uua),Uub) = if(product_prod(A,A),aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),Uu)),Uub),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),aa(num,A,numeral_numeral(A),Uu))),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)),Uub)) ) ) ).

% ATP.lambda_355
tff(fact_8537_ATP_Olambda__356,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_adx(A,fun(A,fun(list(A),list(A))),Uu),Uua),Uub) = if(list(A),aa(A,bool,aa(A,fun(A,bool),fequal(A),Uu),Uua),aa(list(A),list(A),cons(A,Uua),Uub),aa(list(A),list(A),cons(A,Uu),aa(list(A),list(A),cons(A,Uua),Uub))) ) ).

% ATP.lambda_356
tff(fact_8538_ATP_Olambda__357,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: set(nat),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ko(set(nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = if(A,aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),Uub),Uu),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_357
tff(fact_8539_ATP_Olambda__358,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] : ( aa(B,A,aa(set(B),fun(B,A),aTP_Lamp_nk(fun(B,A),fun(set(B),fun(B,A)),Uu),Uua),Uub) = if(A,aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uub),Uua),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_358
tff(fact_8540_ATP_Olambda__359,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_km(B,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uu),Uub),aa(B,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_359
tff(fact_8541_ATP_Olambda__360,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ax(nat,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uub),Uu),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_360
tff(fact_8542_ATP_Olambda__361,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kn(B,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uub),Uu),aa(B,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_361
tff(fact_8543_ATP_Olambda__362,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_ju(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_362
tff(fact_8544_ATP_Olambda__363,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_mz(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_363
tff(fact_8545_ATP_Olambda__364,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_jt(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uu),Uub))) ) ).

% ATP.lambda_364
tff(fact_8546_ATP_Olambda__365,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,bool),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kp(fun(nat,bool),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = if(A,aa(nat,bool,Uu,Uub),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_365
tff(fact_8547_ATP_Olambda__366,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_la(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,Uua,Uub),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_366
tff(fact_8548_ATP_Olambda__367,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_oo(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,Uua,Uub),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_367
tff(fact_8549_ATP_Olambda__368,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,fun(A,A)),Uua: fun(B,bool),Uub: B] : ( aa(B,fun(A,A),aa(fun(B,bool),fun(B,fun(A,A)),aTP_Lamp_aig(fun(B,fun(A,A)),fun(fun(B,bool),fun(B,fun(A,A))),Uu),Uua),Uub) = if(fun(A,A),aa(B,bool,Uua,Uub),aa(B,fun(A,A),Uu,Uub),id(A)) ) ).

% ATP.lambda_368
tff(fact_8550_ATP_Olambda__369,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,option(A),aa(fun(B,bool),fun(B,option(A)),aTP_Lamp_ox(fun(B,A),fun(fun(B,bool),fun(B,option(A))),Uu),Uua),Uub) = if(option(A),aa(B,bool,Uua,Uub),some(A,aa(B,A,Uu,Uub)),none(A)) ) ).

% ATP.lambda_369
tff(fact_8551_ATP_Olambda__370,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] :
      ( pp(aa(real,bool,aa(fun(real,real),fun(real,bool),aTP_Lamp_aae(fun(real,real),fun(fun(real,real),fun(real,bool)),Uu),Uua),Uub))
    <=> has_field_derivative(real,Uu,aa(real,real,Uua,Uub),topolo174197925503356063within(real,Uub,top_top(set(real)))) ) ).

% ATP.lambda_370
tff(fact_8552_ATP_Olambda__371,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ael(fun(A,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uub),Uu),Uua) ) ).

% ATP.lambda_371
tff(fact_8553_ATP_Olambda__372,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ih(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_372
tff(fact_8554_ATP_Olambda__373,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_il(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_373
tff(fact_8555_ATP_Olambda__374,axiom,
    ! [Uu: fun(real,fun(nat,real)),Uua: nat,Uub: real] : ( aa(real,real,aa(nat,fun(real,real),aTP_Lamp_rv(fun(real,fun(nat,real)),fun(nat,fun(real,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),Uu,Uub),Uua) ) ).

% ATP.lambda_374
tff(fact_8556_ATP_Olambda__375,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jb(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_375
tff(fact_8557_ATP_Olambda__376,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ix(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_376
tff(fact_8558_ATP_Olambda__377,axiom,
    ! [I6: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(I6,fun(A,B)),Uua: A,Uub: I6] : ( aa(I6,B,aa(A,fun(I6,B),aTP_Lamp_tx(fun(I6,fun(A,B)),fun(A,fun(I6,B)),Uu),Uua),Uub) = aa(A,B,aa(I6,fun(A,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_377
tff(fact_8559_ATP_Olambda__378,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_vo(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_378
tff(fact_8560_ATP_Olambda__379,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_of(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uub),Uua)) ) ).

% ATP.lambda_379
tff(fact_8561_ATP_Olambda__380,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ey(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ex(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_380
tff(fact_8562_ATP_Olambda__381,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ew(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ev(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_381
tff(fact_8563_ATP_Olambda__382,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_dt(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_ds(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_382
tff(fact_8564_ATP_Olambda__383,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_da(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_cz(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_383
tff(fact_8565_ATP_Olambda__384,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cb(nat,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uub),Uu),one_one(A),zero_zero(A))),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_384
tff(fact_8566_ATP_Olambda__385,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,bool),aa(code_integer,fun(code_integer,product_prod(code_integer,bool)),aTP_Lamp_jr(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,bool))),Uu),Uua),Uub) = aa(bool,product_prod(code_integer,bool),product_Pair(code_integer,bool,if(code_integer,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),Uu),Uua,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),Uub))),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),one_one(code_integer))) ) ).

% ATP.lambda_385
tff(fact_8567_ATP_Olambda__386,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jb(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_386
tff(fact_8568_ATP_Olambda__387,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_iy(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ix(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_387
tff(fact_8569_ATP_Olambda__388,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_vb(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_bg(fun(nat,A),fun(A,fun(nat,A)),Uu),Uub)),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_388
tff(fact_8570_ATP_Olambda__389,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_kk(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kj(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_389
tff(fact_8571_ATP_Olambda__390,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ki(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kh(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_390
tff(fact_8572_ATP_Olambda__391,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_kg(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kf(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_391
tff(fact_8573_ATP_Olambda__392,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ke(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kd(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_392
tff(fact_8574_ATP_Olambda__393,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_kc(rat,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> pp(aa(product_prod(int,int),bool,product_case_prod(int,int,bool,aa(int,fun(int,fun(int,bool)),aTP_Lamp_kb(int,fun(int,fun(int,fun(int,bool))),Uua),Uub)),quotient_of(Uu))) ) ).

% ATP.lambda_393
tff(fact_8575_ATP_Olambda__394,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_ka(rat,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> pp(aa(product_prod(int,int),bool,product_case_prod(int,int,bool,aa(int,fun(int,fun(int,bool)),aTP_Lamp_jz(int,fun(int,fun(int,fun(int,bool))),Uua),Uub)),quotient_of(Uu))) ) ).

% ATP.lambda_394
tff(fact_8576_ATP_Olambda__395,axiom,
    ! [A: $tType,B: $tType,I6: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: set(I6),Uua: fun(I6,fun(A,B)),Uub: A] : ( aa(A,B,aa(fun(I6,fun(A,B)),fun(A,B),aTP_Lamp_ty(set(I6),fun(fun(I6,fun(A,B)),fun(A,B)),Uu),Uua),Uub) = groups7121269368397514597t_prod(I6,B,aa(A,fun(I6,B),aTP_Lamp_tx(fun(I6,fun(A,B)),fun(A,fun(I6,B)),Uua),Uub),Uu) ) ) ).

% ATP.lambda_395
tff(fact_8577_ATP_Olambda__396,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_se(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uub),zero_zero(real))),semiring_char_0_fact(real,Uub))),aa(nat,real,power_power(real,Uua),Uub)) ) ).

% ATP.lambda_396
tff(fact_8578_ATP_Olambda__397,axiom,
    ! [Uu: real,Uua: fun(nat,fun(real,real)),Uub: nat] : ( aa(nat,real,aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_sf(real,fun(fun(nat,fun(real,real)),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uua,Uub),zero_zero(real))),semiring_char_0_fact(real,Uub))),aa(nat,real,power_power(real,Uu),Uub)) ) ).

% ATP.lambda_397
tff(fact_8579_ATP_Olambda__398,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [Uu: real,Uua: fun(nat,fun(A,real)),Uub: nat] : ( aa(nat,real,aa(fun(nat,fun(A,real)),fun(nat,real),aTP_Lamp_ga(real,fun(fun(nat,fun(A,real)),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(A,real,aa(nat,fun(A,real),Uua,Uub),zero_zero(A))),semiring_char_0_fact(real,Uub))),aa(nat,real,power_power(real,Uu),Uub)) ) ) ).

% ATP.lambda_398
tff(fact_8580_ATP_Olambda__399,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A] :
          ( pp(aa(A,bool,aa(nat,fun(A,bool),aTP_Lamp_lk(fun(nat,A),fun(nat,fun(A,bool)),Uu),Uua),Uub))
        <=> ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(A,fun(nat,A)),Uu),Uub)),set_ord_atMost(nat,Uua)) = zero_zero(A) ) ) ) ).

% ATP.lambda_399
tff(fact_8581_ATP_Olambda__400,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_xd(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub))),aa(A,A,Uu,Uua))),Uub) ) ) ).

% ATP.lambda_400
tff(fact_8582_ATP_Olambda__401,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_wy(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub))),aa(A,A,Uu,Uua))),Uub) ) ) ).

% ATP.lambda_401
tff(fact_8583_ATP_Olambda__402,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kl(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,zero_zero(A)),Uub))),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_402
tff(fact_8584_ATP_Olambda__403,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_wx(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uu,Uua))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),Uua)) ) ) ).

% ATP.lambda_403
tff(fact_8585_ATP_Olambda__404,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_wz(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uu,Uua))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),Uua)) ) ) ).

% ATP.lambda_404
tff(fact_8586_ATP_Olambda__405,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_sb(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uub)))),aa(nat,real,power_power(real,Uua),Uub)) ) ).

% ATP.lambda_405
tff(fact_8587_ATP_Olambda__406,axiom,
    ! [Uu: real,Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_gb(real,fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,Uua,Uub)),semiring_char_0_fact(real,Uub))),aa(nat,real,power_power(real,Uu),Uub)) ) ).

% ATP.lambda_406
tff(fact_8588_ATP_Olambda__407,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( pp(aa(list(nat),bool,aa(nat,fun(list(nat),bool),aTP_Lamp_ma(nat,fun(nat,fun(list(nat),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),one_one(nat)) )
        & ( groups8242544230860333062m_list(nat,Uub) = Uua ) ) ) ).

% ATP.lambda_407
tff(fact_8589_ATP_Olambda__408,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),aa(nat,A,Uu,Uub))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(nat,nat,suc,zero_zero(nat))))) ) ) ).

% ATP.lambda_408
tff(fact_8590_ATP_Olambda__409,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_aeg(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),Uua)),aa(list(A),nat,size_size(list(A)),Uub)))
        | ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(list(A),nat,size_size(list(A)),Uub) )
          & pp(aa(set(product_prod(list(A),list(A))),bool,aa(product_prod(list(A),list(A)),fun(set(product_prod(list(A),list(A))),bool),member2(product_prod(list(A),list(A))),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Uua),Uub)),lex(A,Uu))) ) ) ) ).

% ATP.lambda_409
tff(fact_8591_ATP_Olambda__410,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_ahf(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(list(A),nat,size_size(list(A)),Uub) )
        & ? [Xys2: list(A),X4: A,Y: A,Xs6: list(A),Ys7: list(A)] :
            ( ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),cons(A,X4),Xs6)) )
            & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),cons(A,Y),Ys7)) )
            & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X4),Y)),Uu)) ) ) ) ).

% ATP.lambda_410
tff(fact_8592_ATP_Olambda__411,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( pp(aa(list(nat),bool,aa(nat,fun(list(nat),bool),aTP_Lamp_mb(nat,fun(nat,fun(list(nat),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),groups8242544230860333062m_list(nat,Uub)),one_one(nat)) = Uua ) ) ) ).

% ATP.lambda_411
tff(fact_8593_ATP_Olambda__412,axiom,
    ! [A: $tType,Uu: nat,Uua: set(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(set(A),fun(list(A),bool),aTP_Lamp_mn(nat,fun(set(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & distinct(A,Uub)
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uua)) ) ) ).

% ATP.lambda_412
tff(fact_8594_ATP_Olambda__413,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(nat,fun(list(A),bool),aTP_Lamp_mm(set(A),fun(nat,fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & distinct(A,Uub)
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)) ) ) ).

% ATP.lambda_413
tff(fact_8595_ATP_Olambda__414,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(nat,fun(list(A),bool),aTP_Lamp_agk(set(A),fun(nat,fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu))
        & ( aa(list(A),nat,size_size(list(A)),Uub) = aa(nat,nat,suc,Uua) ) ) ) ).

% ATP.lambda_414
tff(fact_8596_ATP_Olambda__415,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_id(nat,fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),aa(list(A),set(A),set2(A),Uua))) ) ) ).

% ATP.lambda_415
tff(fact_8597_ATP_Olambda__416,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(nat,fun(list(A),bool),aTP_Lamp_ku(set(A),fun(nat,fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Uub)),Uua)) ) ) ).

% ATP.lambda_416
tff(fact_8598_ATP_Olambda__417,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(nat,fun(list(A),bool),aTP_Lamp_kt(set(A),fun(nat,fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu))
        & ( aa(list(A),nat,size_size(list(A)),Uub) = Uua ) ) ) ).

% ATP.lambda_417
tff(fact_8599_ATP_Olambda__418,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( pp(aa(list(nat),bool,aa(nat,fun(list(nat),bool),aTP_Lamp_lz(nat,fun(nat,fun(list(nat),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( groups8242544230860333062m_list(nat,Uub) = Uua ) ) ) ).

% ATP.lambda_418
tff(fact_8600_ATP_Olambda__419,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_rx(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,diffs(A,Uu)),Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_419
tff(fact_8601_ATP_Olambda__420,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_md(set(nat),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),aa(nat,nat,suc,Uub)),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),Uua)) ) ) ).

% ATP.lambda_420
tff(fact_8602_ATP_Olambda__421,axiom,
    ! [A: $tType,Uu: set(nat),Uua: nat,Uub: product_prod(A,nat)] :
      ( pp(aa(product_prod(A,nat),bool,aa(nat,fun(product_prod(A,nat),bool),aTP_Lamp_afm(set(nat),fun(nat,fun(product_prod(A,nat),bool)),Uu),Uua),Uub))
    <=> pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(product_prod(A,nat),nat,product_snd(A,nat),Uub)),Uua)),Uu)) ) ).

% ATP.lambda_421
tff(fact_8603_ATP_Olambda__422,axiom,
    ! [Uu: nat,Uua: nat,Uub: set(nat)] :
      ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),aTP_Lamp_mw(nat,fun(nat,fun(set(nat),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(set(nat)),bool,aa(set(nat),fun(set(set(nat)),bool),member2(set(nat)),Uub),pow2(nat,set_or7035219750837199246ssThan(nat,zero_zero(nat),Uu))))
        & ( aa(set(nat),nat,finite_card(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_422
tff(fact_8604_ATP_Olambda__423,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: nat] :
      ( pp(aa(nat,bool,aa(set(nat),fun(nat,bool),aTP_Lamp_age(list(A),fun(set(nat),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),aa(list(A),nat,size_size(list(A)),Uu)))
        & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),Uub),Uua)) ) ) ).

% ATP.lambda_423
tff(fact_8605_ATP_Olambda__424,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: list(A),Uub: nat] :
      ( pp(aa(nat,bool,aa(list(A),fun(nat,bool),aTP_Lamp_os(fun(A,bool),fun(list(A),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),aa(list(A),nat,size_size(list(A)),Uua)))
        & pp(aa(A,bool,Uu,aa(nat,A,nth(A,Uua),Uub))) ) ) ).

% ATP.lambda_424
tff(fact_8606_ATP_Olambda__425,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: list(A),Uub: A] :
      ( pp(aa(A,bool,aa(list(A),fun(A,bool),aTP_Lamp_ok(fun(A,bool),fun(list(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uub),aa(list(A),set(A),set2(A),Uua)))
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_425
tff(fact_8607_ATP_Olambda__426,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ji(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uub))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_426
tff(fact_8608_ATP_Olambda__427,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: nat] :
      ( pp(aa(nat,bool,aa(set(nat),fun(nat,bool),aTP_Lamp_agc(list(A),fun(set(nat),fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),aa(list(A),nat,size_size(list(A)),Uu))),Uua)) ) ).

% ATP.lambda_427
tff(fact_8609_ATP_Olambda__428,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(nat,fun(set(A),bool),aTP_Lamp_ly(set(A),fun(nat,fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uub),Uu))
        & ( aa(set(A),nat,finite_card(A),Uub) = Uua ) ) ) ).

% ATP.lambda_428
tff(fact_8610_ATP_Olambda__429,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_mc(set(nat),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),Uub),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_429
tff(fact_8611_ATP_Olambda__430,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cg(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uu),Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_430
tff(fact_8612_ATP_Olambda__431,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uu),Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_431
tff(fact_8613_ATP_Olambda__432,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ck(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uua),Uub)),aa(nat,A,power_power(A,Uu),Uub)) ) ) ).

% ATP.lambda_432
tff(fact_8614_ATP_Olambda__433,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_do(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub)) ) ).

% ATP.lambda_433
tff(fact_8615_ATP_Olambda__434,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_ir(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uu),Uua))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uua),Uub)) ) ) ).

% ATP.lambda_434
tff(fact_8616_ATP_Olambda__435,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_lm(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uub),Uua)) ) ) ).

% ATP.lambda_435
tff(fact_8617_ATP_Olambda__436,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_iq(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uua),Uub)) ) ) ).

% ATP.lambda_436
tff(fact_8618_ATP_Olambda__437,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_lp(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uub),Uua)) ) ) ).

% ATP.lambda_437
tff(fact_8619_ATP_Olambda__438,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_lo(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uub),Uua)) ) ) ).

% ATP.lambda_438
tff(fact_8620_ATP_Olambda__439,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_ln(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uub),Uua)) ) ) ).

% ATP.lambda_439
tff(fact_8621_ATP_Olambda__440,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(A,real),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,real),fun(A,bool),aTP_Lamp_adn(set(A),fun(fun(A,real),fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uub),Uu))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),zero_zero(real)),aa(A,real,Uua,Uub))) ) ) ) ).

% ATP.lambda_440
tff(fact_8622_ATP_Olambda__441,axiom,
    ! [A: $tType,Uu: list(A),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_lt(list(A),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,count_list(A,Uu),Uub)),aa(A,nat,Uua,Uub)) ) ).

% ATP.lambda_441
tff(fact_8623_ATP_Olambda__442,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: list(A),Uub: A] : ( aa(A,nat,aa(list(A),fun(A,nat),aTP_Lamp_mk(fun(A,nat),fun(list(A),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,count_list(A,Uua),Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_442
tff(fact_8624_ATP_Olambda__443,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(B,bool),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,bool),fun(B,bool),aTP_Lamp_kz(set(B),fun(fun(B,bool),fun(B,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uub),Uu))
        & pp(aa(B,bool,Uua,Uub)) ) ) ).

% ATP.lambda_443
tff(fact_8625_ATP_Olambda__444,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aa(set(A),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uub),Uu))
        & pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_444
tff(fact_8626_ATP_Olambda__445,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_kv(set(B),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uub),Uu))
            & ( aa(B,A,Uua,Uub) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_445
tff(fact_8627_ATP_Olambda__446,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_mu(set(A),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uub),Uu))
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_446
tff(fact_8628_ATP_Olambda__447,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_kx(set(B),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uub),Uu))
            & ( aa(B,A,Uua,Uub) != one_one(A) ) ) ) ) ).

% ATP.lambda_447
tff(fact_8629_ATP_Olambda__448,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( pp(aa(B,bool,aa(set(B),fun(B,bool),aTP_Lamp_mv(fun(B,A),fun(set(B),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uub),Uua))
            & ( aa(B,A,Uu,Uub) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_448
tff(fact_8630_ATP_Olambda__449,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_parity(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_lu(set(B),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uub),Uu))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(B,A,Uua,Uub))) ) ) ) ).

% ATP.lambda_449
tff(fact_8631_ATP_Olambda__450,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_ig(nat,fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu)) ) ).

% ATP.lambda_450
tff(fact_8632_ATP_Olambda__451,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real,Uub: A] :
          ( pp(aa(A,bool,aa(real,fun(A,bool),aTP_Lamp_zk(A,fun(real,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_451
tff(fact_8633_ATP_Olambda__452,axiom,
    ! [Uu: real,Uua: complex,Uub: complex] :
      ( pp(aa(complex,bool,aa(complex,fun(complex,bool),aTP_Lamp_afh(real,fun(complex,fun(complex,bool)),Uu),Uua),Uub))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(complex,Uua,Uub)),Uu)) ) ).

% ATP.lambda_452
tff(fact_8634_ATP_Olambda__453,axiom,
    ! [Uu: real,Uua: real,Uub: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),aTP_Lamp_afj(real,fun(real,fun(real,bool)),Uu),Uua),Uub))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(real,Uua,Uub)),Uu)) ) ).

% ATP.lambda_453
tff(fact_8635_ATP_Olambda__454,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [Uu: real,Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_aff(real,fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Uua,Uub)),Uu)) ) ) ).

% ATP.lambda_454
tff(fact_8636_ATP_Olambda__455,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: real,Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_zr(real,fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Uua,Uub)),Uu)) ) ) ).

% ATP.lambda_455
tff(fact_8637_ATP_Olambda__456,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real,Uub: A] :
          ( pp(aa(A,bool,aa(real,fun(A,bool),aTP_Lamp_afd(A,fun(real,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,Uub,Uu)),Uua)) ) ) ).

% ATP.lambda_456
tff(fact_8638_ATP_Olambda__457,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_ij(nat,fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu)) ) ).

% ATP.lambda_457
tff(fact_8639_ATP_Olambda__458,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_pm(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_458
tff(fact_8640_ATP_Olambda__459,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_pk(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_459
tff(fact_8641_ATP_Olambda__460,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_pl(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_460
tff(fact_8642_ATP_Olambda__461,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_pj(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_461
tff(fact_8643_ATP_Olambda__462,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_in(set(product_prod(A,B)),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(product_prod(A,B),fun(set(product_prod(A,B)),bool),member2(product_prod(A,B)),aa(B,product_prod(A,B),product_Pair(A,B,Uua),Uub)),Uu)) ) ).

% ATP.lambda_462
tff(fact_8644_ATP_Olambda__463,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_oc(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Uu),Uub)),Uua) ) ).

% ATP.lambda_463
tff(fact_8645_ATP_Olambda__464,axiom,
    ! [Uu: nat,Uua: complex,Uub: complex] :
      ( pp(aa(complex,bool,aa(complex,fun(complex,bool),aTP_Lamp_fg(nat,fun(complex,fun(complex,bool)),Uu),Uua),Uub))
    <=> ( aa(nat,complex,power_power(complex,Uub),Uu) = Uua ) ) ).

% ATP.lambda_464
tff(fact_8646_ATP_Olambda__465,axiom,
    ! [Uu: complex,Uua: nat,Uub: complex] :
      ( pp(aa(complex,bool,aa(nat,fun(complex,bool),aTP_Lamp_lr(complex,fun(nat,fun(complex,bool)),Uu),Uua),Uub))
    <=> ( aa(nat,complex,power_power(complex,Uub),Uua) = Uu ) ) ).

% ATP.lambda_465
tff(fact_8647_ATP_Olambda__466,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Uu: A,Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_lb(A,fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uub),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uu),Uub))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uub),Uua)) ) ) ) ).

% ATP.lambda_466
tff(fact_8648_ATP_Olambda__467,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bk(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,suc,Uub))),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_467
tff(fact_8649_ATP_Olambda__468,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bm(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,suc,Uub))),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_468
tff(fact_8650_ATP_Olambda__469,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,int),Uub: nat] : ( aa(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_yp(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),aa(nat,int,Uua,Uub))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) ) ).

% ATP.lambda_469
tff(fact_8651_ATP_Olambda__470,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_sc(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,power_power(real,Uua),aa(nat,nat,suc,Uub))) ) ).

% ATP.lambda_470
tff(fact_8652_ATP_Olambda__471,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_bt(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,power_power(real,Uua),Uub)) ) ).

% ATP.lambda_471
tff(fact_8653_ATP_Olambda__472,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_ea(fun(nat,nat),fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uub)),aa(nat,nat,power_power(nat,Uua),Uub)) ) ).

% ATP.lambda_472
tff(fact_8654_ATP_Olambda__473,axiom,
    ! [Aa: $tType] :
      ( ( real_Vector_banach(Aa)
        & real_V3459762299906320749_field(Aa) )
     => ! [Uu: fun(nat,Aa),Uua: Aa,Uub: nat] : ( aa(nat,Aa,aa(Aa,fun(nat,Aa),aTP_Lamp_vd(fun(nat,Aa),fun(Aa,fun(nat,Aa)),Uu),Uua),Uub) = aa(Aa,Aa,aa(Aa,fun(Aa,Aa),times_times(Aa),aa(nat,Aa,Uu,Uub)),aa(nat,Aa,power_power(Aa,Uua),Uub)) ) ) ).

% ATP.lambda_473
tff(fact_8655_ATP_Olambda__474,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_474
tff(fact_8656_ATP_Olambda__475,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bg(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_475
tff(fact_8657_ATP_Olambda__476,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bl(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_476
tff(fact_8658_ATP_Olambda__477,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_477
tff(fact_8659_ATP_Olambda__478,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_dm(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_478
tff(fact_8660_ATP_Olambda__479,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_dv(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_479
tff(fact_8661_ATP_Olambda__480,axiom,
    ! [Uu: fun(nat,bool),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_kr(fun(nat,bool),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,Uu,Uub))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),Uua)) ) ) ).

% ATP.lambda_480
tff(fact_8662_ATP_Olambda__481,axiom,
    ! [C: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(D,real),Uua: fun(D,C),Uub: D] : ( aa(D,C,aa(fun(D,C),fun(D,C),aTP_Lamp_sr(fun(D,real),fun(fun(D,C),fun(D,C)),Uu),Uua),Uub) = aa(C,C,real_V8093663219630862766scaleR(C,aa(D,real,Uu,Uub)),aa(D,C,Uua,Uub)) ) ) ).

% ATP.lambda_481
tff(fact_8663_ATP_Olambda__482,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: B,Uub: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),aTP_Lamp_mq(fun(B,A),fun(B,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uu,Uua)),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_482
tff(fact_8664_ATP_Olambda__483,axiom,
    ! [B: $tType,Uu: fun(B,real),Uua: fun(B,real),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,real),fun(B,bool),aTP_Lamp_aar(fun(B,real),fun(fun(B,real),fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),aa(B,real,Uu,Uub)),aa(B,real,Uua,Uub))) ) ).

% ATP.lambda_483
tff(fact_8665_ATP_Olambda__484,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_aaj(fun(B,A),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub))) ) ) ).

% ATP.lambda_484
tff(fact_8666_ATP_Olambda__485,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_aam(fun(B,A),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub))) ) ) ).

% ATP.lambda_485
tff(fact_8667_ATP_Olambda__486,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_aee(fun(A,B),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub))) ) ) ).

% ATP.lambda_486
tff(fact_8668_ATP_Olambda__487,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_aaz(fun(B,A),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uua,Uub)),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_487
tff(fact_8669_ATP_Olambda__488,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_abp(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,Uu,Uub)),aa(real,real,Uua,Uub)) ) ).

% ATP.lambda_488
tff(fact_8670_ATP_Olambda__489,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(C,A),Uua: fun(C,A),Uub: C] : ( aa(C,A,aa(fun(C,A),fun(C,A),aTP_Lamp_tv(fun(C,A),fun(fun(C,A),fun(C,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(C,A,Uu,Uub)),aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_489
tff(fact_8671_ATP_Olambda__490,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(C,A),Uua: fun(C,A),Uub: C] : ( aa(C,A,aa(fun(C,A),fun(C,A),aTP_Lamp_ti(fun(C,A),fun(fun(C,A),fun(C,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(C,A,Uu,Uub)),aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_490
tff(fact_8672_ATP_Olambda__491,axiom,
    ! [A: $tType,C: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(C,A),Uua: fun(C,A),Uub: C] : ( aa(C,A,aa(fun(C,A),fun(C,A),aTP_Lamp_acb(fun(C,A),fun(fun(C,A),fun(C,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(C,A,Uu,Uub)),aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_491
tff(fact_8673_ATP_Olambda__492,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wh(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_492
tff(fact_8674_ATP_Olambda__493,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_hf(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_493
tff(fact_8675_ATP_Olambda__494,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acr(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_494
tff(fact_8676_ATP_Olambda__495,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acy(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_495
tff(fact_8677_ATP_Olambda__496,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_ra(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_496
tff(fact_8678_ATP_Olambda__497,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ut(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_497
tff(fact_8679_ATP_Olambda__498,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zv(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_498
tff(fact_8680_ATP_Olambda__499,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaf(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,Uua,Uub)),aa(real,real,Uu,Uub)) ) ).

% ATP.lambda_499
tff(fact_8681_ATP_Olambda__500,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_adj(fun(A,B),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub))) ) ) ).

% ATP.lambda_500
tff(fact_8682_ATP_Olambda__501,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aTP_Lamp_jm(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uub)),aa(nat,nat,Uua,Uub)) ) ).

% ATP.lambda_501
tff(fact_8683_ATP_Olambda__502,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_abw(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_502
tff(fact_8684_ATP_Olambda__503,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_jl(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_503
tff(fact_8685_ATP_Olambda__504,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(D,A),Uua: fun(D,A),Uub: D] : ( aa(D,A,aa(fun(D,A),fun(D,A),aTP_Lamp_sy(fun(D,A),fun(fun(D,A),fun(D,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(D,A,Uu,Uub)),aa(D,A,Uua,Uub)) ) ) ).

% ATP.lambda_504
tff(fact_8686_ATP_Olambda__505,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo4958980785337419405_space(D)
        & topolo4211221413907600880p_mult(B) )
     => ! [Uu: fun(D,B),Uua: fun(D,B),Uub: D] : ( aa(D,B,aa(fun(D,B),fun(D,B),aTP_Lamp_ada(fun(D,B),fun(fun(D,B),fun(D,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(D,B,Uu,Uub)),aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_505
tff(fact_8687_ATP_Olambda__506,axiom,
    ! [A: $tType,D: $tType] :
      ( ( topolo4958980785337419405_space(D)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(D,A),Uua: fun(D,A),Uub: D] : ( aa(D,A,aa(fun(D,A),fun(D,A),aTP_Lamp_acz(fun(D,A),fun(fun(D,A),fun(D,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(D,A,Uu,Uub)),aa(D,A,Uua,Uub)) ) ) ).

% ATP.lambda_506
tff(fact_8688_ATP_Olambda__507,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topological_t2_space(D)
        & topolo4211221413907600880p_mult(B) )
     => ! [Uu: fun(D,B),Uua: fun(D,B),Uub: D] : ( aa(D,B,aa(fun(D,B),fun(D,B),aTP_Lamp_un(fun(D,B),fun(fun(D,B),fun(D,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(D,B,Uu,Uub)),aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_507
tff(fact_8689_ATP_Olambda__508,axiom,
    ! [A: $tType,D: $tType] :
      ( ( topological_t2_space(D)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(D,A),Uua: fun(D,A),Uub: D] : ( aa(D,A,aa(fun(D,A),fun(D,A),aTP_Lamp_um(fun(D,A),fun(fun(D,A),fun(D,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(D,A,Uu,Uub)),aa(D,A,Uua,Uub)) ) ) ).

% ATP.lambda_508
tff(fact_8690_ATP_Olambda__509,axiom,
    ! [B: $tType,D: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [Uu: fun(D,B),Uua: fun(D,B),Uub: D] : ( aa(D,B,aa(fun(D,B),fun(D,B),aTP_Lamp_wg(fun(D,B),fun(fun(D,B),fun(D,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(D,B,Uu,Uub)),aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_509
tff(fact_8691_ATP_Olambda__510,axiom,
    ! [A: $tType,D: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(D,A),Uua: fun(D,A),Uub: D] : ( aa(D,A,aa(fun(D,A),fun(D,A),aTP_Lamp_wj(fun(D,A),fun(fun(D,A),fun(D,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(D,A,Uu,Uub)),aa(D,A,Uua,Uub)) ) ) ).

% ATP.lambda_510
tff(fact_8692_ATP_Olambda__511,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_aca(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_511
tff(fact_8693_ATP_Olambda__512,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wf(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_512
tff(fact_8694_ATP_Olambda__513,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_he(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_513
tff(fact_8695_ATP_Olambda__514,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acq(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_514
tff(fact_8696_ATP_Olambda__515,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_rb(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_515
tff(fact_8697_ATP_Olambda__516,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_uu(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_516
tff(fact_8698_ATP_Olambda__517,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zt(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_517
tff(fact_8699_ATP_Olambda__518,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zx(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uub)),aa(A,real,Uu,Uub)) ) ).

% ATP.lambda_518
tff(fact_8700_ATP_Olambda__519,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_fa(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_519
tff(fact_8701_ATP_Olambda__520,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_xu(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),aa(nat,real,Uua,Uub)) ) ).

% ATP.lambda_520
tff(fact_8702_ATP_Olambda__521,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wo(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_521
tff(fact_8703_ATP_Olambda__522,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_lh(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uua,Uub)),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_522
tff(fact_8704_ATP_Olambda__523,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_wn(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(B,A,Uua,Uub)),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_523
tff(fact_8705_ATP_Olambda__524,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_fs(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ) ).

% ATP.lambda_524
tff(fact_8706_ATP_Olambda__525,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_fe(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_525
tff(fact_8707_ATP_Olambda__526,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo1898628316856586783d_mult(B) )
     => ! [Uu: fun(C,B),Uua: fun(C,nat),Uub: C] : ( aa(C,B,aa(fun(C,nat),fun(C,B),aTP_Lamp_ade(fun(C,B),fun(fun(C,nat),fun(C,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(C,B,Uu,Uub)),aa(C,nat,Uua,Uub)) ) ) ).

% ATP.lambda_526
tff(fact_8708_ATP_Olambda__527,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & topolo1898628316856586783d_mult(B) )
     => ! [Uu: fun(C,B),Uua: fun(C,nat),Uub: C] : ( aa(C,B,aa(fun(C,nat),fun(C,B),aTP_Lamp_uq(fun(C,B),fun(fun(C,nat),fun(C,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(C,B,Uu,Uub)),aa(C,nat,Uua,Uub)) ) ) ).

% ATP.lambda_527
tff(fact_8709_ATP_Olambda__528,axiom,
    ! [B: $tType,C: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [Uu: fun(C,B),Uua: fun(C,nat),Uub: C] : ( aa(C,B,aa(fun(C,nat),fun(C,B),aTP_Lamp_wc(fun(C,B),fun(fun(C,nat),fun(C,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(C,B,Uu,Uub)),aa(C,nat,Uua,Uub)) ) ) ).

% ATP.lambda_528
tff(fact_8710_ATP_Olambda__529,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bc(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_529
tff(fact_8711_ATP_Olambda__530,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo4958980785337419405_space(D)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(D,B),Uua: fun(D,B),Uub: D] : ( aa(D,B,aa(fun(D,B),fun(D,B),aTP_Lamp_adg(fun(D,B),fun(fun(D,B),fun(D,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(D,B,Uu,Uub)),aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_530
tff(fact_8712_ATP_Olambda__531,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topological_t2_space(D)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(D,B),Uua: fun(D,B),Uub: D] : ( aa(D,B,aa(fun(D,B),fun(D,B),aTP_Lamp_us(fun(D,B),fun(fun(D,B),fun(D,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(D,B,Uu,Uub)),aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_531
tff(fact_8713_ATP_Olambda__532,axiom,
    ! [B: $tType,D: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [Uu: fun(D,B),Uua: fun(D,B),Uub: D] : ( aa(D,B,aa(fun(D,B),fun(D,B),aTP_Lamp_vs(fun(D,B),fun(fun(D,B),fun(D,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(D,B,Uu,Uub)),aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_532
tff(fact_8714_ATP_Olambda__533,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vx(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_533
tff(fact_8715_ATP_Olambda__534,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fm(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_534
tff(fact_8716_ATP_Olambda__535,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sv(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_535
tff(fact_8717_ATP_Olambda__536,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_rh(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_536
tff(fact_8718_ATP_Olambda__537,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_uv(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_537
tff(fact_8719_ATP_Olambda__538,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aby(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_538
tff(fact_8720_ATP_Olambda__539,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_rz(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = powr(real,aa(real,real,Uu,Uub),aa(real,real,Uua,Uub)) ) ).

% ATP.lambda_539
tff(fact_8721_ATP_Olambda__540,axiom,
    ! [C: $tType] :
      ( topolo4958980785337419405_space(C)
     => ! [Uu: fun(C,real),Uua: fun(C,real),Uub: C] : ( aa(C,real,aa(fun(C,real),fun(C,real),aTP_Lamp_acu(fun(C,real),fun(fun(C,real),fun(C,real)),Uu),Uua),Uub) = powr(real,aa(C,real,Uu,Uub),aa(C,real,Uua,Uub)) ) ) ).

% ATP.lambda_540
tff(fact_8722_ATP_Olambda__541,axiom,
    ! [C: $tType] :
      ( topological_t2_space(C)
     => ! [Uu: fun(C,real),Uua: fun(C,real),Uub: C] : ( aa(C,real,aa(fun(C,real),fun(C,real),aTP_Lamp_xb(fun(C,real),fun(fun(C,real),fun(C,real)),Uu),Uua),Uub) = powr(real,aa(C,real,Uu,Uub),aa(C,real,Uua,Uub)) ) ) ).

% ATP.lambda_541
tff(fact_8723_ATP_Olambda__542,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ub(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_542
tff(fact_8724_ATP_Olambda__543,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zf(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_543
tff(fact_8725_ATP_Olambda__544,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_vu(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_544
tff(fact_8726_ATP_Olambda__545,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ado(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_545
tff(fact_8727_ATP_Olambda__546,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_xi(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_546
tff(fact_8728_ATP_Olambda__547,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wq(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_547
tff(fact_8729_ATP_Olambda__548,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_px(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
        & pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_548
tff(fact_8730_ATP_Olambda__549,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_oj(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uua,Uub))
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_549
tff(fact_8731_ATP_Olambda__550,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_aej(fun(A,B),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uu,Uua) = aa(A,B,Uu,Uub) ) ) ).

% ATP.lambda_550
tff(fact_8732_ATP_Olambda__551,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_aai(fun(A,B),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ).

% ATP.lambda_551
tff(fact_8733_ATP_Olambda__552,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_oz(B,fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( aa(B,A,Uua,Uu) = aa(B,A,Uua,Uub) ) ) ) ).

% ATP.lambda_552
tff(fact_8734_ATP_Olambda__553,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_ni(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(bool,A,zero_neq_one_of_bool(A),aa(B,bool,Uua,Uub))) ) ) ).

% ATP.lambda_553
tff(fact_8735_ATP_Olambda__554,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_abn(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,Uu,Uub)),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,Uua)))) ) ) ).

% ATP.lambda_554
tff(fact_8736_ATP_Olambda__555,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_rp(fun(A,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,aa(A,A,Uu,Uub)),aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_555
tff(fact_8737_ATP_Olambda__556,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: set(B),Uua: fun(A,fun(B,C)),Uub: A] : ( aa(A,C,aa(fun(A,fun(B,C)),fun(A,C),aTP_Lamp_vp(set(B),fun(fun(A,fun(B,C)),fun(A,C)),Uu),Uua),Uub) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(A,fun(B,C),Uua,Uub)),Uu) ) ) ).

% ATP.lambda_556
tff(fact_8738_ATP_Olambda__557,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,real,aa(B,fun(A,real),aTP_Lamp_zm(fun(A,B),fun(B,fun(A,real)),Uu),Uua),Uub) = real_V557655796197034286t_dist(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_557
tff(fact_8739_ATP_Olambda__558,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [Uu: fun(nat,set(A)),Uua: set(A),Uub: nat] :
          ( pp(aa(nat,bool,aa(set(A),fun(nat,bool),aTP_Lamp_abx(fun(nat,set(A)),fun(set(A),fun(nat,bool)),Uu),Uua),Uub))
        <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(nat,set(A),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_558
tff(fact_8740_ATP_Olambda__559,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_ks(fun(nat,nat),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,Uu,Uub)),Uua)) ) ).

% ATP.lambda_559
tff(fact_8741_ATP_Olambda__560,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] :
      ( pp(aa(B,bool,aa(set(A),fun(B,bool),aTP_Lamp_pv(fun(B,set(A)),fun(set(A),fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(B,set(A),Uu,Uub)),Uua)) ) ).

% ATP.lambda_560
tff(fact_8742_ATP_Olambda__561,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_aax(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_561
tff(fact_8743_ATP_Olambda__562,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_aat(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_562
tff(fact_8744_ATP_Olambda__563,axiom,
    ! [A: $tType,B: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_aaw(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_563
tff(fact_8745_ATP_Olambda__564,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_aap(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_564
tff(fact_8746_ATP_Olambda__565,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_de(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = modulo_modulo(A,aa(B,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_565
tff(fact_8747_ATP_Olambda__566,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bb(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_566
tff(fact_8748_ATP_Olambda__567,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_nn(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_567
tff(fact_8749_ATP_Olambda__568,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_wi(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_568
tff(fact_8750_ATP_Olambda__569,axiom,
    ! [B: $tType,A: $tType] :
      ( field(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_fn(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_569
tff(fact_8751_ATP_Olambda__570,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_rg(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_570
tff(fact_8752_ATP_Olambda__571,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_xn(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_571
tff(fact_8753_ATP_Olambda__572,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_aak(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_572
tff(fact_8754_ATP_Olambda__573,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_abe(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_573
tff(fact_8755_ATP_Olambda__574,axiom,
    ! [A: $tType,B: $tType] :
      ( ( dense_linorder(B)
        & no_bot(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_aaq(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_574
tff(fact_8756_ATP_Olambda__575,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_575
tff(fact_8757_ATP_Olambda__576,axiom,
    ! [D: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(D,A),Uua: A,Uub: D] : ( aa(D,A,aa(A,fun(D,A),aTP_Lamp_wk(fun(D,A),fun(A,fun(D,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(D,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_576
tff(fact_8758_ATP_Olambda__577,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(C,A),Uua: A,Uub: C] : ( aa(C,A,aa(A,fun(C,A),aTP_Lamp_sx(fun(C,A),fun(A,fun(C,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(C,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_577
tff(fact_8759_ATP_Olambda__578,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_aco(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_578
tff(fact_8760_ATP_Olambda__579,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_adc(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_579
tff(fact_8761_ATP_Olambda__580,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(A)
        & topological_t2_space(B) )
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_up(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_580
tff(fact_8762_ATP_Olambda__581,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_wd(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_581
tff(fact_8763_ATP_Olambda__582,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_fj(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_582
tff(fact_8764_ATP_Olambda__583,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_rd(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_583
tff(fact_8765_ATP_Olambda__584,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_to(real,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_584
tff(fact_8766_ATP_Olambda__585,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bx(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_585
tff(fact_8767_ATP_Olambda__586,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_xl(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_586
tff(fact_8768_ATP_Olambda__587,axiom,
    ! [B: $tType,A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vj(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_587
tff(fact_8769_ATP_Olambda__588,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ft(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_588
tff(fact_8770_ATP_Olambda__589,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_wm(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_589
tff(fact_8771_ATP_Olambda__590,axiom,
    ! [Uu: fun(real,real),Uua: nat,Uub: real] : ( aa(real,real,aa(nat,fun(real,real),aTP_Lamp_rt(fun(real,real),fun(nat,fun(real,real)),Uu),Uua),Uub) = aa(nat,real,power_power(real,aa(real,real,Uu,Uub)),Uua) ) ).

% ATP.lambda_590
tff(fact_8772_ATP_Olambda__591,axiom,
    ! [C: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(C,B),Uua: nat,Uub: C] : ( aa(C,B,aa(nat,fun(C,B),aTP_Lamp_adf(fun(C,B),fun(nat,fun(C,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_591
tff(fact_8773_ATP_Olambda__592,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_tr(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_592
tff(fact_8774_ATP_Olambda__593,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_rq(fun(A,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_593
tff(fact_8775_ATP_Olambda__594,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_ur(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_594
tff(fact_8776_ATP_Olambda__595,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_acc(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_595
tff(fact_8777_ATP_Olambda__596,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_ws(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_596
tff(fact_8778_ATP_Olambda__597,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_hg(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_597
tff(fact_8779_ATP_Olambda__598,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_wb(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_598
tff(fact_8780_ATP_Olambda__599,axiom,
    ! [Uu: nat,Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zu(nat,fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(nat,real,power_power(real,aa(real,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_599
tff(fact_8781_ATP_Olambda__600,axiom,
    ! [A: $tType,Uu: nat,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_vk(nat,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(nat,real,power_power(real,aa(A,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_600
tff(fact_8782_ATP_Olambda__601,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_abu(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_601
tff(fact_8783_ATP_Olambda__602,axiom,
    ! [Uu: fun(real,real),Uua: real,Uub: real] : ( aa(real,real,aa(real,fun(real,real),aTP_Lamp_ry(fun(real,real),fun(real,fun(real,real)),Uu),Uua),Uub) = powr(real,aa(real,real,Uu,Uub),Uua) ) ).

% ATP.lambda_602
tff(fact_8784_ATP_Olambda__603,axiom,
    ! [A: $tType,Uu: real,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zy(real,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uua,Uub),Uu) ) ).

% ATP.lambda_603
tff(fact_8785_ATP_Olambda__604,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(C,A),Uua: int,Uub: C] : ( aa(C,A,aa(int,fun(C,A),aTP_Lamp_aev(fun(C,A),fun(int,fun(C,A)),Uu),Uua),Uub) = power_int(A,aa(C,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_604
tff(fact_8786_ATP_Olambda__605,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(B,A),Uua: int,Uub: B] : ( aa(B,A,aa(int,fun(B,A),aTP_Lamp_aer(fun(B,A),fun(int,fun(B,A)),Uu),Uua),Uub) = power_int(A,aa(B,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_605
tff(fact_8787_ATP_Olambda__606,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_aet(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_606
tff(fact_8788_ATP_Olambda__607,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_aes(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_607
tff(fact_8789_ATP_Olambda__608,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: int,Uub: A] : ( aa(A,A,aa(int,fun(A,A),aTP_Lamp_aeu(fun(A,A),fun(int,fun(A,A)),Uu),Uua),Uub) = power_int(A,aa(A,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_608
tff(fact_8790_ATP_Olambda__609,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_aeq(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_609
tff(fact_8791_ATP_Olambda__610,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jh(nat,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub))) ) ) ).

% ATP.lambda_610
tff(fact_8792_ATP_Olambda__611,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: fun(nat,A),Uub: nat] : ( aa(nat,real,aa(fun(nat,A),fun(nat,real),aTP_Lamp_bu(real,fun(fun(nat,A),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uua,Uub))),aa(nat,real,power_power(real,Uu),Uub)) ) ) ).

% ATP.lambda_611
tff(fact_8793_ATP_Olambda__612,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( pp(aa(nat,bool,aa(fun(nat,real),fun(nat,bool),aTP_Lamp_abz(fun(nat,A),fun(fun(nat,real),fun(nat,bool)),Uu),Uua),Uub))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uub))),aa(nat,real,Uua,Uub))) ) ) ).

% ATP.lambda_612
tff(fact_8794_ATP_Olambda__613,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_nj(fun(B,bool),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(B,bool,Uu,Uub))),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_613
tff(fact_8795_ATP_Olambda__614,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,B),Uub: nat] :
          ( pp(aa(nat,bool,aa(fun(nat,B),fun(nat,bool),aTP_Lamp_abt(fun(nat,A),fun(fun(nat,B),fun(nat,bool)),Uu),Uua),Uub))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uub))),real_V7770717601297561774m_norm(B,aa(nat,B,Uua,Uub)))) ) ) ).

% ATP.lambda_614
tff(fact_8796_ATP_Olambda__615,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: real,Uub: A] :
          ( pp(aa(A,bool,aa(real,fun(A,bool),aTP_Lamp_acd(fun(A,B),fun(real,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uub))),Uua)) ) ) ).

% ATP.lambda_615
tff(fact_8797_ATP_Olambda__616,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_gi(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)))),aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ) ).

% ATP.lambda_616
tff(fact_8798_ATP_Olambda__617,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_abl(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(B,Uua))),aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_617
tff(fact_8799_ATP_Olambda__618,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(list(A),fun(list(A),bool)),Uua: list(A),Uub: list(A)] :
          ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)),aTP_Lamp_aha(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool))),Uu),Uua),Uub))
        <=> ( ? [Y: A,Ys4: list(A)] :
                ( ( Uua = nil(A) )
                & ( Uub = aa(list(A),list(A),cons(A,Y),Ys4) ) )
            | ? [X4: A,Y: A,Xs3: list(A),Ys4: list(A)] :
                ( ( Uua = aa(list(A),list(A),cons(A,X4),Xs3) )
                & ( Uub = aa(list(A),list(A),cons(A,Y),Ys4) )
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),Y)) )
            | ? [X4: A,Y: A,Xs3: list(A),Ys4: list(A)] :
                ( ( Uua = aa(list(A),list(A),cons(A,X4),Xs3) )
                & ( Uub = aa(list(A),list(A),cons(A,Y),Ys4) )
                & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),Y))
                & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X4))
                & pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),Uu,Xs3),Ys4)) ) ) ) ) ).

% ATP.lambda_618
tff(fact_8800_ATP_Olambda__619,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_je(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = groups7121269368397514597t_prod(nat,A,Uu,set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_619
tff(fact_8801_ATP_Olambda__620,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jf(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_620
tff(fact_8802_ATP_Olambda__621,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jd(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_621
tff(fact_8803_ATP_Olambda__622,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: int,Uub: A] : ( aa(A,A,aa(int,fun(A,A),aTP_Lamp_aep(A,fun(int,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uub),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),Uua)),power_int(A,Uu,aa(int,int,aa(int,fun(int,int),minus_minus(int),Uua),one_one(int))))) ) ) ).

% ATP.lambda_622
tff(fact_8804_ATP_Olambda__623,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_gv(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_623
tff(fact_8805_ATP_Olambda__624,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_gt(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_624
tff(fact_8806_ATP_Olambda__625,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_fz(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_625
tff(fact_8807_ATP_Olambda__626,axiom,
    ! [Uu: real,Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_ye(real,fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),Uua),aa(nat,real,power_power(real,Uu),Uub)) ) ).

% ATP.lambda_626
tff(fact_8808_ATP_Olambda__627,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ef(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_627
tff(fact_8809_ATP_Olambda__628,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_gu(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ).

% ATP.lambda_628
tff(fact_8810_ATP_Olambda__629,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: A,Uua: B,Uub: C] : ( aa(C,product_prod(A,product_prod(B,C)),aa(B,fun(C,product_prod(A,product_prod(B,C))),aa(A,fun(B,fun(C,product_prod(A,product_prod(B,C)))),aTP_Lamp_agb(A,fun(B,fun(C,product_prod(A,product_prod(B,C))))),Uu),Uua),Uub) = aa(product_prod(B,C),product_prod(A,product_prod(B,C)),product_Pair(A,product_prod(B,C),Uu),aa(C,product_prod(B,C),product_Pair(B,C,Uua),Uub)) ) ).

% ATP.lambda_629
tff(fact_8811_ATP_Olambda__630,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: B,Uua: A,Uub: C] : ( aa(C,product_prod(A,product_prod(B,C)),aa(A,fun(C,product_prod(A,product_prod(B,C))),aTP_Lamp_afp(B,fun(A,fun(C,product_prod(A,product_prod(B,C)))),Uu),Uua),Uub) = aa(product_prod(B,C),product_prod(A,product_prod(B,C)),product_Pair(A,product_prod(B,C),Uua),aa(C,product_prod(B,C),product_Pair(B,C,Uu),Uub)) ) ).

% ATP.lambda_630
tff(fact_8812_ATP_Olambda__631,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: nat] : ( aa(nat,list(A),aa(list(A),fun(nat,list(A)),aTP_Lamp_qf(A,fun(list(A),fun(nat,list(A))),Uu),Uua),Uub) = aa(list(A),list(A),cons(A,Uu),take(A,Uub,Uua)) ) ).

% ATP.lambda_631
tff(fact_8813_ATP_Olambda__632,axiom,
    ! [Uu: real,Uua: real,Uub: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),aTP_Lamp_abd(real,fun(real,fun(real,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(real),bool,aa(real,fun(set(real),bool),member2(real),Uub),set_or5935395276787703475ssThan(real,Uu,Uua))) ) ).

% ATP.lambda_632
tff(fact_8814_ATP_Olambda__633,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_aau(A,fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uu),aa(B,A,Uua,Uub))) ) ) ).

% ATP.lambda_633
tff(fact_8815_ATP_Olambda__634,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_aay(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_634
tff(fact_8816_ATP_Olambda__635,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_aav(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Uua),aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_635
tff(fact_8817_ATP_Olambda__636,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_aan(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Uua),aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_636
tff(fact_8818_ATP_Olambda__637,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_na(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_637
tff(fact_8819_ATP_Olambda__638,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_aal(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_638
tff(fact_8820_ATP_Olambda__639,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_oy(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_639
tff(fact_8821_ATP_Olambda__640,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_aao(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),Uua),aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_640
tff(fact_8822_ATP_Olambda__641,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_abf(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),Uua),aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_641
tff(fact_8823_ATP_Olambda__642,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_642
tff(fact_8824_ATP_Olambda__643,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_acp(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_643
tff(fact_8825_ATP_Olambda__644,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fi(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_644
tff(fact_8826_ATP_Olambda__645,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_by(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_645
tff(fact_8827_ATP_Olambda__646,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_xm(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_646
tff(fact_8828_ATP_Olambda__647,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vi(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_647
tff(fact_8829_ATP_Olambda__648,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_be(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_648
tff(fact_8830_ATP_Olambda__649,axiom,
    ! [A: $tType,D: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(D,A),Uua: A,Uub: D] : ( aa(D,A,aa(A,fun(D,A),aTP_Lamp_wl(fun(D,A),fun(A,fun(D,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(D,A,Uu,Uub)) ) ) ).

% ATP.lambda_649
tff(fact_8831_ATP_Olambda__650,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(C,A),Uua: A,Uub: C] : ( aa(C,A,aa(A,fun(C,A),aTP_Lamp_sw(fun(C,A),fun(A,fun(C,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(C,A,Uu,Uub)) ) ) ).

% ATP.lambda_650
tff(fact_8832_ATP_Olambda__651,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_adb(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_651
tff(fact_8833_ATP_Olambda__652,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topological_t2_space(B)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_uo(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_652
tff(fact_8834_ATP_Olambda__653,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_we(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_653
tff(fact_8835_ATP_Olambda__654,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_zn(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_654
tff(fact_8836_ATP_Olambda__655,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_rc(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(A,A,Uu,Uub)) ) ) ).

% ATP.lambda_655
tff(fact_8837_ATP_Olambda__656,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: fun(B,nat),Uub: B] : ( aa(B,A,aa(fun(B,nat),fun(B,A),aTP_Lamp_hi(A,fun(fun(B,nat),fun(B,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,Uu),aa(B,nat,Uua,Uub)) ) ) ).

% ATP.lambda_656
tff(fact_8838_ATP_Olambda__657,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [Uu: fun(B,nat),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_yj(fun(B,nat),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,Uua),aa(B,nat,Uu,Uub)) ) ) ).

% ATP.lambda_657
tff(fact_8839_ATP_Olambda__658,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1633459387980952147up_add(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vy(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_658
tff(fact_8840_ATP_Olambda__659,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_no(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_659
tff(fact_8841_ATP_Olambda__660,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,B),Uua: A,Uub: C] : ( aa(C,product_prod(A,B),aa(A,fun(C,product_prod(A,B)),aTP_Lamp_afs(fun(C,B),fun(A,fun(C,product_prod(A,B))),Uu),Uua),Uub) = aa(B,product_prod(A,B),product_Pair(A,B,Uua),aa(C,B,Uu,Uub)) ) ).

% ATP.lambda_660
tff(fact_8842_ATP_Olambda__661,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_adh(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ) ).

% ATP.lambda_661
tff(fact_8843_ATP_Olambda__662,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_vn(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ) ).

% ATP.lambda_662
tff(fact_8844_ATP_Olambda__663,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_vq(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ).

% ATP.lambda_663
tff(fact_8845_ATP_Olambda__664,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,B),Uua: fun(C,set(A)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_aek(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(A),set(B),image(A,B,Uu),aa(C,set(A),Uua,Uub)) ) ).

% ATP.lambda_664
tff(fact_8846_ATP_Olambda__665,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(list(A),A),Uua: list(A),Uub: A] :
          ( pp(aa(A,bool,aa(list(A),fun(A,bool),aTP_Lamp_om(fun(list(A),A),fun(list(A),fun(A,bool)),Uu),Uua),Uub))
        <=> ( Uub = aa(list(A),A,Uu,Uua) ) ) ) ).

% ATP.lambda_665
tff(fact_8847_ATP_Olambda__666,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hr(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_666
tff(fact_8848_ATP_Olambda__667,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: A] :
      ( pp(aa(A,bool,aa(set(nat),fun(A,bool),aTP_Lamp_agd(list(A),fun(set(nat),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uub),aa(list(A),set(A),set2(A),nths(A,Uu,Uua)))) ) ).

% ATP.lambda_667
tff(fact_8849_ATP_Olambda__668,axiom,
    ! [A: $tType,C: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(C,A),Uua: real,Uub: C] :
          ( pp(aa(C,bool,aa(real,fun(C,bool),aTP_Lamp_acf(fun(C,A),fun(real,fun(C,bool)),Uu),Uua),Uub))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Uua),real_V7770717601297561774m_norm(A,aa(C,A,Uu,Uub)))) ) ) ).

% ATP.lambda_668
tff(fact_8850_ATP_Olambda__669,axiom,
    ! [A: $tType,Uu: list(A),Uua: A,Uub: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_qs(list(A),fun(A,fun(list(A),list(A))),Uu),Uua),Uub) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Uub),Uu) ) ).

% ATP.lambda_669
tff(fact_8851_ATP_Olambda__670,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_xt(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ) ).

% ATP.lambda_670
tff(fact_8852_ATP_Olambda__671,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_wv(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)) ) ) ).

% ATP.lambda_671
tff(fact_8853_ATP_Olambda__672,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_qx(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)) ) ) ).

% ATP.lambda_672
tff(fact_8854_ATP_Olambda__673,axiom,
    ! [Uu: fun(real,bool),Uua: real,Uub: real] :
      ( pp(aa(real,bool,aa(real,fun(real,bool),aTP_Lamp_abb(fun(real,bool),fun(real,fun(real,bool)),Uu),Uua),Uub))
    <=> pp(aa(real,bool,Uu,aa(real,real,aa(real,fun(real,real),plus_plus(real),Uub),Uua))) ) ).

% ATP.lambda_673
tff(fact_8855_ATP_Olambda__674,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real,Uub: real] : ( aa(real,A,aa(real,fun(real,A),aTP_Lamp_zl(fun(real,A),fun(real,fun(real,A)),Uu),Uua),Uub) = aa(real,A,Uu,aa(real,real,aa(real,fun(real,real),plus_plus(real),Uub),Uua)) ) ).

% ATP.lambda_674
tff(fact_8856_ATP_Olambda__675,axiom,
    ! [Uu: fun(nat,bool),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_abs(fun(nat,bool),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ).

% ATP.lambda_675
tff(fact_8857_ATP_Olambda__676,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat,Uub: nat] : ( aa(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_ph(fun(nat,set(A)),fun(nat,fun(nat,set(A))),Uu),Uua),Uub) = aa(nat,set(A),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_676
tff(fact_8858_ATP_Olambda__677,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_677
tff(fact_8859_ATP_Olambda__678,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_xo(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_678
tff(fact_8860_ATP_Olambda__679,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_abv(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_679
tff(fact_8861_ATP_Olambda__680,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hj(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_680
tff(fact_8862_ATP_Olambda__681,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_gm(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_681
tff(fact_8863_ATP_Olambda__682,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,bool),Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_aas(fun(A,bool),fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua))) ) ) ).

% ATP.lambda_682
tff(fact_8864_ATP_Olambda__683,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_wt(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_683
tff(fact_8865_ATP_Olambda__684,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_xf(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_684
tff(fact_8866_ATP_Olambda__685,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_rk(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_685
tff(fact_8867_ATP_Olambda__686,axiom,
    ! [D: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(D) )
     => ! [Uu: A,Uua: fun(A,D),Uub: A] : ( aa(A,D,aa(fun(A,D),fun(A,D),aTP_Lamp_ww(A,fun(fun(A,D),fun(A,D)),Uu),Uua),Uub) = aa(A,D,Uua,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uub)) ) ) ).

% ATP.lambda_686
tff(fact_8868_ATP_Olambda__687,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vl(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uub)) ) ) ).

% ATP.lambda_687
tff(fact_8869_ATP_Olambda__688,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ca(nat,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uu)) ) ) ).

% ATP.lambda_688
tff(fact_8870_ATP_Olambda__689,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(real,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tn(fun(real,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,Uu,aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_689
tff(fact_8871_ATP_Olambda__690,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,real,aa(fun(nat,nat),fun(nat,real),aTP_Lamp_aea(fun(nat,real),fun(fun(nat,nat),fun(nat,real)),Uu),Uua),Uub) = aa(nat,real,Uu,aa(nat,nat,Uua,Uub)) ) ).

% ATP.lambda_690
tff(fact_8872_ATP_Olambda__691,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,A,aa(fun(nat,nat),fun(nat,A),aTP_Lamp_aed(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,Uua,Uub)) ) ) ).

% ATP.lambda_691
tff(fact_8873_ATP_Olambda__692,axiom,
    ! [C: $tType,B: $tType] :
      ( ( topolo3112930676232923870pology(B)
        & topolo1944317154257567458pology(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(B,C),Uua: fun(nat,B),Uub: nat] : ( aa(nat,C,aa(fun(nat,B),fun(nat,C),aTP_Lamp_acm(fun(B,C),fun(fun(nat,B),fun(nat,C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(nat,B,Uua,Uub)) ) ) ).

% ATP.lambda_692
tff(fact_8874_ATP_Olambda__693,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo3112930676232923870pology(B)
        & topolo1944317154257567458pology(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(B,A),Uua: fun(nat,B),Uub: nat] : ( aa(nat,A,aa(fun(nat,B),fun(nat,A),aTP_Lamp_adv(fun(B,A),fun(fun(nat,B),fun(nat,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(nat,B,Uua,Uub)) ) ) ).

% ATP.lambda_693
tff(fact_8875_ATP_Olambda__694,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [Uu: fun(A,bool),Uua: fun(nat,A),Uub: nat] :
          ( pp(aa(nat,bool,aa(fun(nat,A),fun(nat,bool),aTP_Lamp_acl(fun(A,bool),fun(fun(nat,A),fun(nat,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,Uu,aa(nat,A,Uua,Uub))) ) ) ).

% ATP.lambda_694
tff(fact_8876_ATP_Olambda__695,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ta(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_695
tff(fact_8877_ATP_Olambda__696,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_yx(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_696
tff(fact_8878_ATP_Olambda__697,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_adi(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_697
tff(fact_8879_ATP_Olambda__698,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_rm(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_698
tff(fact_8880_ATP_Olambda__699,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ads(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_699
tff(fact_8881_ATP_Olambda__700,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(nat,A),Uub: nat] : ( aa(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_jo(fun(A,B),fun(fun(nat,A),fun(nat,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(nat,A,Uua,Uub)) ) ).

% ATP.lambda_700
tff(fact_8882_ATP_Olambda__701,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,nat),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aeb(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,Uu,Uub)) ) ) ).

% ATP.lambda_701
tff(fact_8883_ATP_Olambda__702,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,nat),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aec(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,Uu,Uub)) ) ) ).

% ATP.lambda_702
tff(fact_8884_ATP_Olambda__703,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,C),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_lg(fun(B,C),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(C,A,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_703
tff(fact_8885_ATP_Olambda__704,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_xa(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_704
tff(fact_8886_ATP_Olambda__705,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_rn(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uua,aa(A,A,Uu,Uub)) ) ) ).

% ATP.lambda_705
tff(fact_8887_ATP_Olambda__706,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(D) )
     => ! [Uu: fun(A,C),Uua: fun(C,D),Uub: A] : ( aa(A,D,aa(fun(C,D),fun(A,D),aTP_Lamp_zp(fun(A,C),fun(fun(C,D),fun(A,D)),Uu),Uua),Uub) = aa(C,D,Uua,aa(A,C,Uu,Uub)) ) ) ).

% ATP.lambda_706
tff(fact_8888_ATP_Olambda__707,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_zo(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_707
tff(fact_8889_ATP_Olambda__708,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_pn(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_708
tff(fact_8890_ATP_Olambda__709,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_vh(fun(nat,A),fun(A,fun(A,A)),Uu),Uua),Uub) = suminf(A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_vg(fun(nat,A),fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_709
tff(fact_8891_ATP_Olambda__710,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(Aa)
        & real_V3459762299906320749_field(Aa) )
     => ! [Uu: fun(A,Aa),Uua: fun(nat,Aa),Uub: A] : ( aa(A,Aa,aa(fun(nat,Aa),fun(A,Aa),aTP_Lamp_vf(fun(A,Aa),fun(fun(nat,Aa),fun(A,Aa)),Uu),Uua),Uub) = suminf(Aa,aa(A,fun(nat,Aa),aa(fun(nat,Aa),fun(A,fun(nat,Aa)),aTP_Lamp_ve(fun(A,Aa),fun(fun(nat,Aa),fun(A,fun(nat,Aa))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_710
tff(fact_8892_ATP_Olambda__711,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,real,aa(A,fun(nat,real),aTP_Lamp_bh(fun(nat,A),fun(A,fun(nat,real)),Uu),Uua),Uub) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub))) ) ) ).

% ATP.lambda_711
tff(fact_8893_ATP_Olambda__712,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: fun(I6,A),Uua: fun(I6,A),Uub: I6] : ( aa(I6,real,aa(fun(I6,A),fun(I6,real),aTP_Lamp_ho(fun(I6,A),fun(fun(I6,A),fun(I6,real)),Uu),Uua),Uub) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(I6,A,Uu,Uub)),aa(I6,A,Uua,Uub))) ) ) ).

% ATP.lambda_712
tff(fact_8894_ATP_Olambda__713,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_yo(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = cos(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),Uua)) ) ).

% ATP.lambda_713
tff(fact_8895_ATP_Olambda__714,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_np(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_714
tff(fact_8896_ATP_Olambda__715,axiom,
    ! [B: $tType,A: $tType,Uu: set(B),Uua: fun(A,fun(B,bool)),Uub: A] : ( aa(A,nat,aa(fun(A,fun(B,bool)),fun(A,nat),aTP_Lamp_mh(set(B),fun(fun(A,fun(B,bool)),fun(A,nat)),Uu),Uua),Uub) = aa(set(B),nat,finite_card(B),collect(B,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_mg(set(B),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),Uu),Uua),Uub))) ) ).

% ATP.lambda_715
tff(fact_8897_ATP_Olambda__716,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & archim2362893244070406136eiling(Aa)
        & topolo2564578578187576103pology(Aa) )
     => ! [Uu: fun(A,real),Uua: fun(real,Aa),Uub: A] : ( aa(A,real,aa(fun(real,Aa),fun(A,real),aTP_Lamp_uk(fun(A,real),fun(fun(real,Aa),fun(A,real)),Uu),Uua),Uub) = aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(Aa,aa(real,Aa,Uua,aa(A,real,Uu,Uub)))) ) ) ).

% ATP.lambda_716
tff(fact_8898_ATP_Olambda__717,axiom,
    ! [A: $tType,B: $tType,Uu: list(A),Uua: list(B),Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(list(B),fun(product_prod(A,B),bool),aTP_Lamp_aib(list(A),fun(list(B),fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ? [I2: nat] :
          ( ( Uub = aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Uu),I2)),aa(nat,B,nth(B,Uua),I2)) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Uu)),aa(list(B),nat,size_size(list(B)),Uua)))) ) ) ).

% ATP.lambda_717
tff(fact_8899_ATP_Olambda__718,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: A] :
      ( pp(aa(A,bool,aa(set(nat),fun(A,bool),aTP_Lamp_ahi(list(A),fun(set(nat),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [I2: nat] :
          ( ( Uub = aa(nat,A,nth(A,Uu),I2) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Uu)))
          & pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),I2),Uua)) ) ) ).

% ATP.lambda_718
tff(fact_8900_ATP_Olambda__719,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( pp(aa(nat,bool,aa(fun(nat,real),fun(nat,bool),aTP_Lamp_aci(fun(nat,A),fun(fun(nat,real),fun(nat,bool)),Uu),Uua),Uub))
        <=> ! [N3: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uub),N3))
             => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,Uub,N3)))),aa(nat,real,Uua,Uub))) ) ) ) ).

% ATP.lambda_719
tff(fact_8901_ATP_Olambda__720,axiom,
    ! [A: $tType] :
      ( ( real_V8037385150606011577_space(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( pp(aa(nat,bool,aa(fun(nat,real),fun(nat,bool),aTP_Lamp_ach(fun(nat,A),fun(fun(nat,real),fun(nat,bool)),Uu),Uua),Uub))
        <=> ! [A6: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uub),A6))
             => ! [B7: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A6),B7))
                 => pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or3652927894154168847AtMost(nat,A6,B7)))),aa(nat,real,Uua,A6))) ) ) ) ) ).

% ATP.lambda_720
tff(fact_8902_ATP_Olambda__721,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ahj(fun(A,A),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ? [N3: nat] : ( Uub = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N3),Uu),Uua) ) ) ).

% ATP.lambda_721
tff(fact_8903_ATP_Olambda__722,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_aia(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: A,V6: list(A)] :
          ( ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Uua),aa(list(A),list(A),cons(A,A6),V6)) )
          | ? [U4: list(A),Aa2: A,B7: A,Va4: list(A),W3: list(A)] :
              ( pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,Aa2),B7)),Uu))
              & ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U4),aa(list(A),list(A),cons(A,Aa2),Va4)) )
              & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U4),aa(list(A),list(A),cons(A,B7),W3)) ) ) ) ) ).

% ATP.lambda_722
tff(fact_8904_ATP_Olambda__723,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(list(A)),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(set(list(A)),fun(list(A),bool),aTP_Lamp_agz(set(A),fun(set(list(A)),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ? [X4: A,Xs3: list(A)] :
          ( ( Uub = aa(list(A),list(A),cons(A,X4),Xs3) )
          & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),X4),Uu))
          & pp(aa(set(list(A)),bool,aa(list(A),fun(set(list(A)),bool),member2(list(A)),Xs3),Uua)) ) ) ).

% ATP.lambda_723
tff(fact_8905_ATP_Olambda__724,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_ahe(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ? [Us2: list(A),Z6: A,Z9: A,Vs2: list(A)] :
          ( ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),cons(A,Z6),Vs2)) )
          & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,Z6),Z9)),Uu))
          & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),cons(A,Z9),Vs2)) ) ) ) ).

% ATP.lambda_724
tff(fact_8906_ATP_Olambda__725,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ev(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,fconj(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub),aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uuc)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),zero_zero(A)) ) ) ).

% ATP.lambda_725
tff(fact_8907_ATP_Olambda__726,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_cz(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,fconj(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub),aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uuc))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub)))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),zero_zero(A)) ) ) ).

% ATP.lambda_726
tff(fact_8908_ATP_Olambda__727,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ex(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),zero_zero(A)) ) ) ).

% ATP.lambda_727
tff(fact_8909_ATP_Olambda__728,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: A,Uuc: B] : ( aa(B,A,aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_aem(fun(A,B),fun(set(A),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uuc),aa(set(A),set(B),image(A,B,Uu),Uua)),the_inv_into(A,B,Uua,Uu,Uuc),Uub) ) ).

% ATP.lambda_728
tff(fact_8910_ATP_Olambda__729,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_eg(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uuc),Uu),zero_zero(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ).

% ATP.lambda_729
tff(fact_8911_ATP_Olambda__730,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_ht(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uuc),Uu),one_one(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ).

% ATP.lambda_730
tff(fact_8912_ATP_Olambda__731,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_zq(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = if(B,aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uuc),Uu),aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_731
tff(fact_8913_ATP_Olambda__732,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_hu(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_732
tff(fact_8914_ATP_Olambda__733,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_eh(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_733
tff(fact_8915_ATP_Olambda__734,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: set(nat),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(set(nat),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_li(fun(nat,A),fun(set(nat),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(set(nat),bool,aa(nat,fun(set(nat),bool),member2(nat),Uuc),Uua),aa(nat,A,Uub,Uuc),aa(nat,A,Uu,Uuc)) ) ) ).

% ATP.lambda_734
tff(fact_8916_ATP_Olambda__735,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_mt(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_735
tff(fact_8917_ATP_Olambda__736,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ms(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_736
tff(fact_8918_ATP_Olambda__737,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: A,Uuc: B] : ( aa(B,A,aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_ml(B,fun(fun(B,A),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),Uub) ) ) ).

% ATP.lambda_737
tff(fact_8919_ATP_Olambda__738,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: list(A),Uuc: list(A)] : ( aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),aa(A,fun(list(A),fun(list(A),product_prod(list(A),list(A)))),aTP_Lamp_xg(fun(A,bool),fun(A,fun(list(A),fun(list(A),product_prod(list(A),list(A))))),Uu),Uua),Uub),Uuc) = if(product_prod(list(A),list(A)),aa(A,bool,Uu,Uua),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),aa(list(A),list(A),cons(A,Uua),Uub)),Uuc),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Uub),aa(list(A),list(A),cons(A,Uua),Uuc))) ) ).

% ATP.lambda_738
tff(fact_8920_ATP_Olambda__739,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_nm(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_739
tff(fact_8921_ATP_Olambda__740,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_nl(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_740
tff(fact_8922_ATP_Olambda__741,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_nb(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uuc),aa(A,fun(A,A),times_times(A),Uua)),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))) ) ) ).

% ATP.lambda_741
tff(fact_8923_ATP_Olambda__742,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(B,A),Uub: B,Uuc: B] :
      ( pp(aa(B,bool,aa(B,fun(B,bool),aa(fun(B,A),fun(B,fun(B,bool)),aTP_Lamp_mo(fun(A,fun(A,bool)),fun(fun(B,A),fun(B,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(A,bool,aa(A,fun(A,bool),Uu,aa(B,A,Uua,Uub)),aa(B,A,Uua,Uuc))) ) ).

% ATP.lambda_742
tff(fact_8924_ATP_Olambda__743,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,Uu: fun(B,fun(C,A)),Uua: fun(D,B),Uub: fun(D,C),Uuc: D] : ( aa(D,A,aa(fun(D,C),fun(D,A),aa(fun(D,B),fun(fun(D,C),fun(D,A)),aTP_Lamp_afu(fun(B,fun(C,A)),fun(fun(D,B),fun(fun(D,C),fun(D,A))),Uu),Uua),Uub),Uuc) = aa(C,A,aa(B,fun(C,A),Uu,aa(D,B,Uua,Uuc)),aa(D,C,Uub,Uuc)) ) ).

% ATP.lambda_743
tff(fact_8925_ATP_Olambda__744,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gk(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gj(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(nat,nat,suc,zero_zero(nat)))),Uuc))) ) ) ).

% ATP.lambda_744
tff(fact_8926_ATP_Olambda__745,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: set(C),Uuc: A] : ( aa(A,B,aa(set(C),fun(A,B),aa(fun(C,B),fun(set(C),fun(A,B)),aTP_Lamp_fl(fun(A,B),fun(fun(C,B),fun(set(C),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_fk(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uuc)),Uub) ) ) ).

% ATP.lambda_745
tff(fact_8927_ATP_Olambda__746,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_el(nat,fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uuc),zero_zero(nat)),aa(A,A,uminus_uminus(A),Uub),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uuc),Uu),one_one(A),zero_zero(A)))),aa(nat,A,power_power(A,Uua),Uuc)) ) ) ).

% ATP.lambda_746
tff(fact_8928_ATP_Olambda__747,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_ec(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_eb(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uuc)),set_ord_atMost(nat,Uuc))),aa(nat,nat,power_power(nat,Uub),Uuc)) ) ).

% ATP.lambda_747
tff(fact_8929_ATP_Olambda__748,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(fun(nat,A),fun(A,fun(nat,A)),aTP_Lamp_dx(fun(nat,A),fun(fun(nat,A),fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_dw(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uuc)),set_ord_atMost(nat,Uuc))),aa(nat,A,power_power(A,Uub),Uuc)) ) ) ).

% ATP.lambda_748
tff(fact_8930_ATP_Olambda__749,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: nat,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_sk(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,Uua)),Uuc)),zero_zero(real))),semiring_char_0_fact(real,Uuc))),aa(nat,real,power_power(real,Uub),Uuc)) ) ).

% ATP.lambda_749
tff(fact_8931_ATP_Olambda__750,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: nat,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_si(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)),zero_zero(real))),semiring_char_0_fact(real,Uuc))),aa(nat,real,power_power(real,Uub),Uuc)) ) ).

% ATP.lambda_750
tff(fact_8932_ATP_Olambda__751,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_sh(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uuc),Uua)),semiring_char_0_fact(real,Uuc))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Uub),Uua)),Uuc)) ) ).

% ATP.lambda_751
tff(fact_8933_ATP_Olambda__752,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_sg(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uuc),Uub)),semiring_char_0_fact(real,Uuc))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Uua),Uub)),Uuc)) ) ).

% ATP.lambda_752
tff(fact_8934_ATP_Olambda__753,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fv(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uua)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uu),Uub)) ) ) ).

% ATP.lambda_753
tff(fact_8935_ATP_Olambda__754,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_nq(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uub))) ) ).

% ATP.lambda_754
tff(fact_8936_ATP_Olambda__755,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gj(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu)),Uuc)),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),bit0(one2)))),Uuc))) ) ) ).

% ATP.lambda_755
tff(fact_8937_ATP_Olambda__756,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),aTP_Lamp_yl(fun(A,A),fun(A,fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),aa(nat,A,Uub,Uuc)))),aa(A,A,Uu,Uua))),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_756
tff(fact_8938_ATP_Olambda__757,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: set(product_prod(A,A)),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aTP_Lamp_aht(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc)))
        | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc)))
          & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,Uub),Uuc)),Uua)) ) ) ) ).

% ATP.lambda_757
tff(fact_8939_ATP_Olambda__758,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: real,Uuc: A] :
          ( pp(aa(A,bool,aa(real,fun(A,bool),aa(B,fun(real,fun(A,bool)),aTP_Lamp_abr(fun(A,B),fun(B,fun(real,fun(A,bool))),Uu),Uua),Uub),Uuc))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uuc),Uua)),Uub)) ) ) ).

% ATP.lambda_758
tff(fact_8940_ATP_Olambda__759,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: real,Uuc: B] :
          ( pp(aa(B,bool,aa(real,fun(B,bool),aa(A,fun(real,fun(B,bool)),aTP_Lamp_abg(fun(B,A),fun(A,fun(real,fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),real_V557655796197034286t_dist(A,aa(B,A,Uu,Uuc),Uua)),Uub)) ) ) ).

% ATP.lambda_759
tff(fact_8941_ATP_Olambda__760,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ee(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),comm_s3205402744901411588hammer(A,Uu,Uuc))),comm_s3205402744901411588hammer(A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_760
tff(fact_8942_ATP_Olambda__761,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_dq(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,semiring_1_of_nat(nat),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,nat,power_power(nat,Uu),Uuc))),aa(nat,nat,power_power(nat,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_761
tff(fact_8943_ATP_Olambda__762,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dz(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_762
tff(fact_8944_ATP_Olambda__763,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ek(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uuc))),aa(nat,A,power_power(A,Uu),Uuc))),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))) ) ) ).

% ATP.lambda_763
tff(fact_8945_ATP_Olambda__764,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat,Uub: list(A),Uuc: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(nat,fun(list(A),fun(list(A),bool)),aTP_Lamp_ahs(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & ( aa(list(A),nat,size_size(list(A)),Uuc) = Uua )
        & ? [Xys2: list(A),X4: A,Y: A,Xs6: list(A),Ys7: list(A)] :
            ( ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),cons(A,X4),Xs6)) )
            & ( Uuc = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),cons(A,Y),Ys7)) )
            & pp(aa(set(product_prod(A,A)),bool,aa(product_prod(A,A),fun(set(product_prod(A,A)),bool),member2(product_prod(A,A)),aa(A,product_prod(A,A),product_Pair(A,A,X4),Y)),Uu)) ) ) ) ).

% ATP.lambda_764
tff(fact_8946_ATP_Olambda__765,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_fy(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uuc)))),aa(nat,A,power_power(A,Uu),Uuc)) ) ) ).

% ATP.lambda_765
tff(fact_8947_ATP_Olambda__766,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,fun(B,bool)),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_mg(set(B),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uuc),Uu))
        & pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uub),Uuc)) ) ) ).

% ATP.lambda_766
tff(fact_8948_ATP_Olambda__767,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,fun(B,bool)),Uub: B,Uuc: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aa(fun(A,fun(B,bool)),fun(B,fun(A,bool)),aTP_Lamp_mf(set(A),fun(fun(A,fun(B,bool)),fun(B,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uuc),Uu))
        & pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uuc),Uub)) ) ) ).

% ATP.lambda_767
tff(fact_8949_ATP_Olambda__768,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fw(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,Uu),Uuc)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uua)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))) ) ) ).

% ATP.lambda_768
tff(fact_8950_ATP_Olambda__769,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(A,real),Uub: fun(A,real),Uuc: A] :
          ( pp(aa(A,bool,aa(fun(A,real),fun(A,bool),aa(fun(A,real),fun(fun(A,real),fun(A,bool)),aTP_Lamp_adk(set(A),fun(fun(A,real),fun(fun(A,real),fun(A,bool))),Uu),Uua),Uub),Uuc))
        <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uuc),Uu))
            & pp(aa(real,bool,aa(real,fun(real,bool),ord_less(real),aa(A,real,Uua,Uuc)),aa(A,real,Uub,Uuc))) ) ) ) ).

% ATP.lambda_769
tff(fact_8951_ATP_Olambda__770,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,C),Uub: C,Uuc: B] :
      ( pp(aa(B,bool,aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_pe(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uuc),Uu))
        & ( aa(B,C,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_770
tff(fact_8952_ATP_Olambda__771,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,B),Uub: B,Uuc: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_po(set(A),fun(fun(A,B),fun(B,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),Uuc),Uu))
        & ( aa(A,B,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_771
tff(fact_8953_ATP_Olambda__772,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_fx(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,Uu),Uuc)),aa(nat,A,power_power(A,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uuc))) ) ) ).

% ATP.lambda_772
tff(fact_8954_ATP_Olambda__773,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_dp(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Uu),Uuc)),aa(nat,nat,binomial(Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_773
tff(fact_8955_ATP_Olambda__774,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aa(int,fun(int,fun(int,bool)),aTP_Lamp_kb(int,fun(int,fun(int,fun(int,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_774
tff(fact_8956_ATP_Olambda__775,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_nw(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ).

% ATP.lambda_775
tff(fact_8957_ATP_Olambda__776,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aa(int,fun(int,fun(int,bool)),aTP_Lamp_jz(int,fun(int,fun(int,fun(int,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_776
tff(fact_8958_ATP_Olambda__777,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_nu(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ).

% ATP.lambda_777
tff(fact_8959_ATP_Olambda__778,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_ny(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)) ) ).

% ATP.lambda_778
tff(fact_8960_ATP_Olambda__779,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_oa(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ).

% ATP.lambda_779
tff(fact_8961_ATP_Olambda__780,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: list(A),Uub: B,Uuc: list(B)] : ( aa(list(B),list(product_prod(A,B)),aa(B,fun(list(B),list(product_prod(A,B))),aa(list(A),fun(B,fun(list(B),list(product_prod(A,B)))),aTP_Lamp_afx(A,fun(list(A),fun(B,fun(list(B),list(product_prod(A,B))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(A,B)),list(product_prod(A,B)),cons(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Uu),Uub)),zip(A,B,Uua,Uuc)) ) ).

% ATP.lambda_780
tff(fact_8962_ATP_Olambda__781,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: list(B),Uub: A,Uuc: list(A)] : ( aa(list(A),list(product_prod(A,B)),aa(A,fun(list(A),list(product_prod(A,B))),aa(list(B),fun(A,fun(list(A),list(product_prod(A,B)))),aTP_Lamp_afy(B,fun(list(B),fun(A,fun(list(A),list(product_prod(A,B))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(A,B)),list(product_prod(A,B)),cons(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Uub),Uu)),zip(A,B,Uuc,Uua)) ) ).

% ATP.lambda_781
tff(fact_8963_ATP_Olambda__782,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_ky(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uuc),Uu))
            & ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uua,Uuc)),aa(B,A,Uub,Uuc)) != one_one(A) ) ) ) ) ).

% ATP.lambda_782
tff(fact_8964_ATP_Olambda__783,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_kw(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> ( pp(aa(set(B),bool,aa(B,fun(set(B),bool),member2(B),Uuc),Uu))
            & ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uua,Uuc)),aa(B,A,Uub,Uuc)) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_783
tff(fact_8965_ATP_Olambda__784,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_yt(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))))) ) ) ).

% ATP.lambda_784
tff(fact_8966_ATP_Olambda__785,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_bn(fun(nat,A),fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uuc),Uua))),aa(nat,A,power_power(A,Uub),Uuc)) ) ) ).

% ATP.lambda_785
tff(fact_8967_ATP_Olambda__786,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_jk(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))),aa(nat,A,power_power(A,Uua),Uuc)) ) ) ).

% ATP.lambda_786
tff(fact_8968_ATP_Olambda__787,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_vg(fun(nat,A),fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)),Uuc)),aa(nat,A,power_power(A,Uua),Uuc))),Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uuc)),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))))) ) ) ).

% ATP.lambda_787
tff(fact_8969_ATP_Olambda__788,axiom,
    ! [A: $tType,Aa: $tType] :
      ( ( real_Vector_banach(Aa)
        & real_V3459762299906320749_field(Aa)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,Aa),Uua: fun(nat,Aa),Uub: A,Uuc: nat] : ( aa(nat,Aa,aa(A,fun(nat,Aa),aa(fun(nat,Aa),fun(A,fun(nat,Aa)),aTP_Lamp_ve(fun(A,Aa),fun(fun(nat,Aa),fun(A,fun(nat,Aa))),Uu),Uua),Uub),Uuc) = aa(Aa,Aa,aa(Aa,fun(Aa,Aa),times_times(Aa),aa(nat,Aa,Uua,Uuc)),aa(nat,Aa,power_power(Aa,aa(A,Aa,Uu,Uub)),Uuc)) ) ) ).

% ATP.lambda_788
tff(fact_8970_ATP_Olambda__789,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_ue(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(A,real,Uu,Uua)))),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ).

% ATP.lambda_789
tff(fact_8971_ATP_Olambda__790,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gw(fun(nat,A),fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),Uub)),one_one(nat)))) ) ) ).

% ATP.lambda_790
tff(fact_8972_ATP_Olambda__791,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: A] : ( aa(A,A,aa(B,fun(A,A),aa(A,fun(B,fun(A,A)),aTP_Lamp_oe(fun(B,A),fun(A,fun(B,fun(A,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uuc)) ) ) ).

% ATP.lambda_791
tff(fact_8973_ATP_Olambda__792,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_eb(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uuc)),aa(nat,nat,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_792
tff(fact_8974_ATP_Olambda__793,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_ds(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_793
tff(fact_8975_ATP_Olambda__794,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_dw(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_794
tff(fact_8976_ATP_Olambda__795,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: A,Uuc: C] : ( aa(C,B,aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_fk(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(C,B,Uua,Uuc)) ) ) ).

% ATP.lambda_795
tff(fact_8977_ATP_Olambda__796,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Uu: fun(C,A),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,product_prod(A,B),aa(C,fun(D,product_prod(A,B)),aa(fun(D,B),fun(C,fun(D,product_prod(A,B))),aTP_Lamp_aft(fun(C,A),fun(fun(D,B),fun(C,fun(D,product_prod(A,B)))),Uu),Uua),Uub),Uuc) = aa(B,product_prod(A,B),product_Pair(A,B,aa(C,A,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ).

% ATP.lambda_796
tff(fact_8978_ATP_Olambda__797,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: fun(list(B),A),Uub: list(B),Uuc: B] :
          ( pp(aa(B,bool,aa(list(B),fun(B,bool),aa(fun(list(B),A),fun(list(B),fun(B,bool)),aTP_Lamp_on(fun(B,A),fun(fun(list(B),A),fun(list(B),fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> ( aa(B,A,Uu,Uuc) = aa(list(B),A,Uua,Uub) ) ) ) ).

% ATP.lambda_797
tff(fact_8979_ATP_Olambda__798,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_ui(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(nat,real,power_power(real,cos(real,aa(A,real,Uu,Uua))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% ATP.lambda_798
tff(fact_8980_ATP_Olambda__799,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_ug(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,aa(A,real,Uu,Uub)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% ATP.lambda_799
tff(fact_8981_ATP_Olambda__800,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_td(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,exp(real),aa(A,real,Uu,Uub))) ) ) ).

% ATP.lambda_800
tff(fact_8982_ATP_Olambda__801,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_tf(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),cos(real,aa(A,real,Uu,Uub))) ) ) ).

% ATP.lambda_801
tff(fact_8983_ATP_Olambda__802,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_tu(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(A,real,Uu,Uua))) ) ) ).

% ATP.lambda_802
tff(fact_8984_ATP_Olambda__803,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_so(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,aa(A,real,Uu,Uua)),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ) ) ).

% ATP.lambda_803
tff(fact_8985_ATP_Olambda__804,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_tq(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,uminus_uminus(real),sin(real,aa(A,real,Uu,Uub)))) ) ) ).

% ATP.lambda_804
tff(fact_8986_ATP_Olambda__805,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_sq(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,uminus_uminus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,aa(A,real,Uu,Uua)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))) ) ) ).

% ATP.lambda_805
tff(fact_8987_ATP_Olambda__806,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_yu(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc))),aa(A,B,Uu,Uub))),aa(A,B,Uua,Uuc)))),real_V7770717601297561774m_norm(A,Uuc)) ) ) ).

% ATP.lambda_806
tff(fact_8988_ATP_Olambda__807,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_yy(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,Uub))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))) ) ) ).

% ATP.lambda_807
tff(fact_8989_ATP_Olambda__808,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(A,B),Uua: fun(A,C),Uub: real,Uuc: A] :
          ( pp(aa(A,bool,aa(real,fun(A,bool),aa(fun(A,C),fun(real,fun(A,bool)),aTP_Lamp_abj(fun(A,B),fun(fun(A,C),fun(real,fun(A,bool))),Uu),Uua),Uub),Uuc))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(A,C,Uua,Uuc))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uuc))),Uub))) ) ) ).

% ATP.lambda_808
tff(fact_8990_ATP_Olambda__809,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: filter(A),Uuc: A] : ( aa(A,B,aa(filter(A),fun(A,B),aa(fun(A,B),fun(filter(A),fun(A,B)),aTP_Lamp_zd(fun(A,B),fun(fun(A,B),fun(filter(A),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_zc(A,A)))))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_zc(A,A))))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_zc(A,A)))))) ) ) ).

% ATP.lambda_809
tff(fact_8991_ATP_Olambda__810,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(A,fun(fun(A,B),fun(A,B)),aTP_Lamp_za(fun(A,B),fun(A,fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uua)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uub,Uuc)),aa(A,B,Uub,Uua))),aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uua)))) ) ) ).

% ATP.lambda_810
tff(fact_8992_ATP_Olambda__811,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_yz(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,Uub))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))) ) ) ).

% ATP.lambda_811
tff(fact_8993_ATP_Olambda__812,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(B,C),Uuc: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_pp(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),aa(set(A),nat,finite_card(A),collect(A,aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_po(set(A),fun(fun(A,B),fun(B,fun(A,bool))),Uu),Uua),Uuc))))),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_812
tff(fact_8994_ATP_Olambda__813,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(list(A),fun(list(A),bool)),Uub: list(A),Uuc: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)),aTP_Lamp_ahb(fun(A,fun(A,bool)),fun(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool))),Uu),Uua),Uub),Uuc))
    <=> ( ? [Y: A,Ys4: list(A)] :
            ( ( Uub = nil(A) )
            & ( Uuc = aa(list(A),list(A),cons(A,Y),Ys4) ) )
        | ? [X4: A,Y: A,Xs3: list(A),Ys4: list(A)] :
            ( ( Uub = aa(list(A),list(A),cons(A,X4),Xs3) )
            & ( Uuc = aa(list(A),list(A),cons(A,Y),Ys4) )
            & pp(aa(A,bool,aa(A,fun(A,bool),Uu,X4),Y)) )
        | ? [X4: A,Y: A,Xs3: list(A),Ys4: list(A)] :
            ( ( Uub = aa(list(A),list(A),cons(A,X4),Xs3) )
            & ( Uuc = aa(list(A),list(A),cons(A,Y),Ys4) )
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),Uu,X4),Y))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),Uu,Y),X4))
            & pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),Uua,Xs3),Ys4)) ) ) ) ).

% ATP.lambda_813
tff(fact_8995_ATP_Olambda__814,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: A,Uuc: nat] : ( aa(nat,list(A),aa(A,fun(nat,list(A)),aa(list(A),fun(A,fun(nat,list(A))),aTP_Lamp_qe(A,fun(list(A),fun(A,fun(nat,list(A)))),Uu),Uua),Uub),Uuc) = aa(list(A),list(A),cons(A,Uu),list_update(A,Uua,Uuc,Uub)) ) ).

% ATP.lambda_814
tff(fact_8996_ATP_Olambda__815,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,A),Uuc: C] : ( aa(C,A,aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aTP_Lamp_pg(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),Uu),Uua),Uub),Uuc) = groups7121269368397514597t_prod(B,A,Uub,collect(B,aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_pe(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_815
tff(fact_8997_ATP_Olambda__816,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,A),Uuc: C] : ( aa(C,A,aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aTP_Lamp_pf(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),Uu),Uua),Uub),Uuc) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),Uub),collect(B,aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_pe(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_816
tff(fact_8998_ATP_Olambda__817,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: real,Uuc: A] :
          ( pp(aa(A,bool,aa(real,fun(A,bool),aa(nat,fun(real,fun(A,bool)),aTP_Lamp_abq(fun(nat,A),fun(nat,fun(real,fun(A,bool))),Uu),Uua),Uub),Uuc))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),Uub),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_bg(fun(nat,A),fun(A,fun(nat,A)),Uu),Uuc)),set_ord_atMost(nat,Uua))))) ) ) ).

% ATP.lambda_817
tff(fact_8999_ATP_Olambda__818,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),A,aa(A,fun(list(A),A),aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_aie(A,fun(list(A),fun(A,fun(list(A),A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),ord_min(A),Uu),min_list(A,Uua)) ) ) ).

% ATP.lambda_818
tff(fact_9000_ATP_Olambda__819,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(B,C),Uua: fun(A,fun(list(A),B)),Uub: A,Uuc: list(A)] : ( aa(list(A),C,aa(A,fun(list(A),C),aa(fun(A,fun(list(A),B)),fun(A,fun(list(A),C)),aTP_Lamp_ql(fun(B,C),fun(fun(A,fun(list(A),B)),fun(A,fun(list(A),C))),Uu),Uua),Uub),Uuc) = aa(B,C,Uu,aa(list(A),B,aa(A,fun(list(A),B),Uua,Uub),Uuc)) ) ).

% ATP.lambda_819
tff(fact_9001_ATP_Olambda__820,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_iz(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_820
tff(fact_9002_ATP_Olambda__821,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_iv(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_821
tff(fact_9003_ATP_Olambda__822,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_hk(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_822
tff(fact_9004_ATP_Olambda__823,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_gn(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_823
tff(fact_9005_ATP_Olambda__824,axiom,
    ! [A: $tType,D: $tType,B: $tType,C: $tType,Uu: fun(product_prod(B,C),A),Uua: fun(D,B),Uub: D,Uuc: C] : ( aa(C,A,aa(D,fun(C,A),aa(fun(D,B),fun(D,fun(C,A)),aTP_Lamp_afw(fun(product_prod(B,C),A),fun(fun(D,B),fun(D,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(product_prod(B,C),A,Uu,aa(C,product_prod(B,C),product_Pair(B,C,aa(D,B,Uua,Uub)),Uuc)) ) ).

% ATP.lambda_824
tff(fact_9006_ATP_Olambda__825,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Uu: fun(product_prod(B,C),A),Uua: fun(D,C),Uub: B,Uuc: D] : ( aa(D,A,aa(B,fun(D,A),aa(fun(D,C),fun(B,fun(D,A)),aTP_Lamp_afv(fun(product_prod(B,C),A),fun(fun(D,C),fun(B,fun(D,A))),Uu),Uua),Uub),Uuc) = aa(product_prod(B,C),A,Uu,aa(C,product_prod(B,C),product_Pair(B,C,Uub),aa(D,C,Uua,Uuc))) ) ).

% ATP.lambda_825
tff(fact_9007_ATP_Olambda__826,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kf(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_826
tff(fact_9008_ATP_Olambda__827,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kd(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_827
tff(fact_9009_ATP_Olambda__828,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_qw(fun(A,bool),fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua),Uub),Uuc) = some(product_prod(list(A),product_prod(A,list(A))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),product_Pair(list(A),product_prod(A,list(A)),takeWhile(A,aa(fun(A,bool),fun(A,bool),comp(bool,bool,A,fNot),Uu),Uua)),aa(list(A),product_prod(A,list(A)),product_Pair(A,list(A),Uub),Uuc))) ) ).

% ATP.lambda_828
tff(fact_9010_ATP_Olambda__829,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(C,A),Uua: C,Uub: fun(C,A),Uuc: C] : ( aa(C,A,aa(fun(C,A),fun(C,A),aa(C,fun(fun(C,A),fun(C,A)),aTP_Lamp_tl(fun(C,A),fun(C,fun(fun(C,A),fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(C,A,Uu,Uua))),aa(C,A,Uub,Uuc))),aa(A,A,inverse_inverse(A),aa(C,A,Uu,Uua)))) ) ) ).

% ATP.lambda_829
tff(fact_9011_ATP_Olambda__830,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_agi(A,fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua),Uub),Uuc) = some(product_prod(list(A),product_prod(A,list(A))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),product_Pair(list(A),product_prod(A,list(A)),aa(list(A),list(A),cons(A,Uu),Uua)),aa(list(A),product_prod(A,list(A)),product_Pair(A,list(A),Uub),Uuc))) ) ).

% ATP.lambda_830
tff(fact_9012_ATP_Olambda__831,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kj(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uub)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_831
tff(fact_9013_ATP_Olambda__832,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kh(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_832
tff(fact_9014_ATP_Olambda__833,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,fun(A,B)),Uua: fun(C,A),Uub: C,Uuc: fun(C,A),Uud: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aa(C,fun(fun(C,A),fun(C,B)),aa(fun(C,A),fun(C,fun(fun(C,A),fun(C,B))),aTP_Lamp_tb(fun(A,fun(A,B)),fun(fun(C,A),fun(C,fun(fun(C,A),fun(C,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,B,aa(A,fun(A,B),Uu,aa(C,A,Uua,Uub)),aa(C,A,Uuc,Uud)) ) ) ).

% ATP.lambda_833
tff(fact_9015_ATP_Olambda__834,axiom,
    ! [A: $tType,B: $tType,I6: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: set(I6),Uua: fun(I6,fun(A,B)),Uub: fun(I6,fun(A,B)),Uuc: A,Uud: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(I6,fun(A,B)),fun(A,fun(A,B)),aa(fun(I6,fun(A,B)),fun(fun(I6,fun(A,B)),fun(A,fun(A,B))),aTP_Lamp_ua(set(I6),fun(fun(I6,fun(A,B)),fun(fun(I6,fun(A,B)),fun(A,fun(A,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(I6),B,aa(fun(I6,B),fun(set(I6),B),groups7311177749621191930dd_sum(I6,B),aa(A,fun(I6,B),aa(A,fun(A,fun(I6,B)),aa(fun(I6,fun(A,B)),fun(A,fun(A,fun(I6,B))),aa(fun(I6,fun(A,B)),fun(fun(I6,fun(A,B)),fun(A,fun(A,fun(I6,B)))),aTP_Lamp_tz(set(I6),fun(fun(I6,fun(A,B)),fun(fun(I6,fun(A,B)),fun(A,fun(A,fun(I6,B))))),Uu),Uua),Uub),Uuc),Uud)),Uu) ) ) ).

% ATP.lambda_834
tff(fact_9016_ATP_Olambda__835,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_gh(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aa(A,fun(A,fun(nat,fun(nat,A))),aTP_Lamp_gg(fun(nat,A),fun(A,fun(A,fun(nat,fun(nat,A)))),Uua),Uub),Uuc),Uud)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_835
tff(fact_9017_ATP_Olambda__836,axiom,
    ! [Uu: nat,Uua: fun(nat,fun(real,real)),Uub: real,Uuc: nat,Uud: real] : ( aa(real,real,aa(nat,fun(real,real),aa(real,fun(nat,fun(real,real)),aa(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real))),aTP_Lamp_sj(nat,fun(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real)))),Uu),Uua),Uub),Uuc),Uud) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(nat,fun(real,real),Uua,Uuc),Uud)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_si(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uua),Uuc),Uud)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)))),aa(real,real,aa(real,fun(real,real),times_times(real),Uub),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,Uud),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)))))) ) ).

% ATP.lambda_836
tff(fact_9018_ATP_Olambda__837,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_gx(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gw(fun(nat,A),fun(A,fun(nat,fun(nat,A))),Uua),Uuc),Uud)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uud),Uu))),aa(nat,A,power_power(A,Uub),Uud)) ) ) ).

% ATP.lambda_837
tff(fact_9019_ATP_Olambda__838,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_eo(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uud)),Uua)),one_one(A))),Uud)),aa(nat,A,power_power(A,Uub),Uud))),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_838
tff(fact_9020_ATP_Olambda__839,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ei(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),Uua)),Uud)),aa(nat,A,power_power(A,Uub),Uud))),aa(nat,A,power_power(A,Uuc),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_839
tff(fact_9021_ATP_Olambda__840,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ej(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),Uua)),Uud)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),Uub)),Uud))),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_840
tff(fact_9022_ATP_Olambda__841,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: A,Uuc: nat,Uud: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aa(A,fun(A,fun(nat,fun(nat,A))),aTP_Lamp_gg(fun(nat,A),fun(A,fun(A,fun(nat,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uuc),Uud)),one_one(nat)))),aa(nat,A,power_power(A,Uub),Uud))),aa(nat,A,power_power(A,Uua),Uuc)) ) ) ).

% ATP.lambda_841
tff(fact_9023_ATP_Olambda__842,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [Uu: fun(C,A),Uua: A,Uub: fun(C,B),Uuc: B,Uud: C] :
          ( pp(aa(C,bool,aa(B,fun(C,bool),aa(fun(C,B),fun(B,fun(C,bool)),aa(A,fun(fun(C,B),fun(B,fun(C,bool))),aTP_Lamp_aba(fun(C,A),fun(A,fun(fun(C,B),fun(B,fun(C,bool)))),Uu),Uua),Uub),Uuc),Uud))
        <=> pp(aa(real,bool,aa(real,fun(real,bool),ord_less_eq(real),real_V557655796197034286t_dist(B,aa(C,B,Uub,Uud),Uuc)),real_V557655796197034286t_dist(A,aa(C,A,Uu,Uud),Uua))) ) ) ).

% ATP.lambda_842
tff(fact_9024_ATP_Olambda__843,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: nat,Uud: A] : ( aa(A,B,aa(nat,fun(A,B),aa(A,fun(nat,fun(A,B)),aa(fun(A,B),fun(A,fun(nat,fun(A,B))),aTP_Lamp_ts(fun(A,B),fun(fun(A,B),fun(A,fun(nat,fun(A,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),Uuc)),aa(A,B,Uua,Uud))),aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),one_one(nat)))) ) ) ).

% ATP.lambda_843
tff(fact_9025_ATP_Olambda__844,axiom,
    ! [Uu: nat,Uua: list(vEBT_VEBT),Uub: vEBT_VEBT,Uuc: nat,Uud: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aa(vEBT_VEBT,fun(nat,fun(nat,bool)),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool))),aTP_Lamp_agu(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uuc),Uud))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uud),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Uu)))
        & ! [I2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))
           => ( ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,aa(nat,vEBT_VEBT,nth(vEBT_VEBT,Uua),I2)),X_12))
            <=> pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,Uub),I2)) ) )
        & ( ( Uuc = Uud )
         => ! [X4: vEBT_VEBT] :
              ( pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),Uua)))
             => ~ ? [X_12: nat] : pp(aa(nat,bool,aa(vEBT_VEBT,fun(nat,bool),vEBT_V8194947554948674370ptions,X4),X_12)) ) )
        & ( ( Uuc != Uud )
         => ( vEBT_V5917875025757280293ildren(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua,Uud)
            & ! [X4: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),bit0(one2))),Uu)))
               => ( vEBT_V5917875025757280293ildren(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua,X4)
                 => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),X4))
                    & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X4),Uud)) ) ) ) ) ) ) ) ).

% ATP.lambda_844
tff(fact_9026_ATP_Olambda__845,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(C,A),Uua: C,Uub: fun(C,A),Uuc: int,Uud: C] : ( aa(C,A,aa(int,fun(C,A),aa(fun(C,A),fun(int,fun(C,A)),aa(C,fun(fun(C,A),fun(int,fun(C,A))),aTP_Lamp_aew(fun(C,A),fun(C,fun(fun(C,A),fun(int,fun(C,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(C,A,Uub,Uud)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),Uuc)),power_int(A,aa(C,A,Uu,Uua),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uuc),one_one(int))))) ) ) ).

% ATP.lambda_845
tff(fact_9027_ATP_Olambda__846,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: set(A),Uuc: set(C),Uud: B] :
          ( pp(aa(B,bool,aa(set(C),fun(B,bool),aa(set(A),fun(set(C),fun(B,bool)),aa(fun(C,B),fun(set(A),fun(set(C),fun(B,bool))),aTP_Lamp_aih(fun(A,B),fun(fun(C,B),fun(set(A),fun(set(C),fun(B,bool)))),Uu),Uua),Uub),Uuc),Uud))
        <=> ? [A6: A,B7: C] :
              ( ( Uud = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,A6)),aa(C,B,Uua,B7)) )
              & pp(aa(set(A),bool,aa(A,fun(set(A),bool),member2(A),A6),Uub))
              & pp(aa(set(C),bool,aa(C,fun(set(C),bool),member2(C),B7),Uuc)) ) ) ) ).

% ATP.lambda_846
tff(fact_9028_ATP_Olambda__847,axiom,
    ! [A: $tType,B: $tType,I6: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: set(I6),Uua: fun(I6,fun(A,B)),Uub: fun(I6,fun(A,B)),Uuc: A,Uud: A,Uue: I6] : ( aa(I6,B,aa(A,fun(I6,B),aa(A,fun(A,fun(I6,B)),aa(fun(I6,fun(A,B)),fun(A,fun(A,fun(I6,B))),aa(fun(I6,fun(A,B)),fun(fun(I6,fun(A,B)),fun(A,fun(A,fun(I6,B)))),aTP_Lamp_tz(set(I6),fun(fun(I6,fun(A,B)),fun(fun(I6,fun(A,B)),fun(A,fun(A,fun(I6,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,aa(I6,fun(A,B),Uub,Uue),Uud)),groups7121269368397514597t_prod(I6,B,aa(A,fun(I6,B),aTP_Lamp_tx(fun(I6,fun(A,B)),fun(A,fun(I6,B)),Uua),Uuc),aa(set(I6),set(I6),aa(set(I6),fun(set(I6),set(I6)),minus_minus(set(I6)),Uu),aa(set(I6),set(I6),insert2(I6,Uue),bot_bot(set(I6)))))) ) ) ).

% ATP.lambda_847
tff(fact_9029_ATP_Olambda__848,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(C,A),Uua: fun(C,A),Uub: C,Uuc: fun(C,A),Uud: fun(C,A),Uue: C] : ( aa(C,A,aa(fun(C,A),fun(C,A),aa(fun(C,A),fun(fun(C,A),fun(C,A)),aa(C,fun(fun(C,A),fun(fun(C,A),fun(C,A))),aa(fun(C,A),fun(C,fun(fun(C,A),fun(fun(C,A),fun(C,A)))),aTP_Lamp_tj(fun(C,A),fun(fun(C,A),fun(C,fun(fun(C,A),fun(fun(C,A),fun(C,A))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(C,A,Uua,Uue)),aa(C,A,Uuc,Uub))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(C,A,Uu,Uub)),aa(C,A,Uud,Uue)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(C,A,Uuc,Uub)),aa(C,A,Uuc,Uub))) ) ) ).

% ATP.lambda_848
tff(fact_9030_ATP_Olambda__849,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: fun(A,real),Uud: fun(A,real),Uue: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(fun(A,real),fun(fun(A,real),fun(A,real)),aa(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))),aa(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real)))),aTP_Lamp_uc(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,aa(A,real,Uu,Uub),aa(A,real,Uuc,Uub))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uud,Uue)),aa(real,real,ln_ln(real),aa(A,real,Uu,Uub)))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uue)),aa(A,real,Uuc,Uub))),aa(A,real,Uu,Uub)))) ) ) ).

% ATP.lambda_849
tff(fact_9031_ATP_Olambda__850,axiom,
    ! [C: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(D,real),Uua: fun(D,real),Uub: D,Uuc: fun(D,C),Uud: fun(D,C),Uue: D] : ( aa(D,C,aa(fun(D,C),fun(D,C),aa(fun(D,C),fun(fun(D,C),fun(D,C)),aa(D,fun(fun(D,C),fun(fun(D,C),fun(D,C))),aa(fun(D,real),fun(D,fun(fun(D,C),fun(fun(D,C),fun(D,C)))),aTP_Lamp_ss(fun(D,real),fun(fun(D,real),fun(D,fun(fun(D,C),fun(fun(D,C),fun(D,C))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,real_V8093663219630862766scaleR(C,aa(D,real,Uu,Uub)),aa(D,C,Uud,Uue))),aa(C,C,real_V8093663219630862766scaleR(C,aa(D,real,Uua,Uue)),aa(D,C,Uuc,Uub))) ) ) ).

% ATP.lambda_850
tff(fact_9032_ATP_Olambda__851,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(D,A),Uua: fun(D,A),Uub: D,Uuc: fun(D,A),Uud: fun(D,A),Uue: D] : ( aa(D,A,aa(fun(D,A),fun(D,A),aa(fun(D,A),fun(fun(D,A),fun(D,A)),aa(D,fun(fun(D,A),fun(fun(D,A),fun(D,A))),aa(fun(D,A),fun(D,fun(fun(D,A),fun(fun(D,A),fun(D,A)))),aTP_Lamp_sz(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,A),fun(fun(D,A),fun(D,A))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(D,A,Uu,Uub)),aa(D,A,Uud,Uue))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(D,A,Uua,Uue)),aa(D,A,Uuc,Uub))) ) ) ).

% ATP.lambda_851
tff(fact_9033_ATP_Olambda__852,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(C,A),Uua: fun(C,A),Uub: C,Uuc: fun(C,A),Uud: fun(C,A),Uue: C] : ( aa(C,A,aa(fun(C,A),fun(C,A),aa(fun(C,A),fun(fun(C,A),fun(C,A)),aa(C,fun(fun(C,A),fun(fun(C,A),fun(C,A))),aa(fun(C,A),fun(C,fun(fun(C,A),fun(fun(C,A),fun(C,A)))),aTP_Lamp_tw(fun(C,A),fun(fun(C,A),fun(C,fun(fun(C,A),fun(fun(C,A),fun(C,A))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(C,A,Uu,Uub))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(C,A,Uuc,Uub))),aa(C,A,Uud,Uue))),aa(A,A,inverse_inverse(A),aa(C,A,Uuc,Uub))))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(C,A,Uua,Uue)),aa(C,A,Uuc,Uub))) ) ) ).

% ATP.lambda_852
tff(fact_9034_ATP_Olambda__853,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: B] : ( aa(B,set(C),aTP_Lamp_agp(set(C),fun(B,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_853
tff(fact_9035_ATP_Olambda__854,axiom,
    ! [A: $tType,C: $tType,Uu: set(C),Uua: A] : ( aa(A,set(C),aTP_Lamp_agq(set(C),fun(A,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_854
tff(fact_9036_ATP_Olambda__855,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: set(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_agr(set(B),fun(A,set(B)),Uu),Uua) = Uu ) ) ).

% ATP.lambda_855
tff(fact_9037_ATP_Olambda__856,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_agn(set(B),fun(A,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_856
tff(fact_9038_ATP_Olambda__857,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] : ( aa(list(A),set(A),aTP_Lamp_agl(set(A),fun(list(A),set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_857
tff(fact_9039_ATP_Olambda__858,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: B] : ( aa(B,set(A),aTP_Lamp_ago(set(A),fun(B,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_858
tff(fact_9040_ATP_Olambda__859,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] : ( aa(A,set(A),aTP_Lamp_ags(set(A),fun(A,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_859
tff(fact_9041_ATP_Olambda__860,axiom,
    ! [A: $tType,Aa: $tType] :
      ( ( zero(Aa)
        & topological_t2_space(Aa)
        & topolo8386298272705272623_space(A) )
     => ! [Uu: Aa,Uua: A] : ( aa(A,Aa,aTP_Lamp_wu(Aa,fun(A,Aa),Uu),Uua) = Uu ) ) ).

% ATP.lambda_860
tff(fact_9042_ATP_Olambda__861,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_st(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_861
tff(fact_9043_ATP_Olambda__862,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_mj(B,fun(C,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_862
tff(fact_9044_ATP_Olambda__863,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_pr(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_863
tff(fact_9045_ATP_Olambda__864,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bf(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_864
tff(fact_9046_ATP_Olambda__865,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ri(A,fun(A,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_865
tff(fact_9047_ATP_Olambda__866,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_lv(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_866
tff(fact_9048_ATP_Olambda__867,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_lx(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_867
tff(fact_9049_ATP_Olambda__868,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),A,aa(A,fun(list(A),A),aTP_Lamp_aif(A,fun(list(A),A)),Uu),Uua) = Uu ) ).

% ATP.lambda_868
tff(fact_9050_ATP_Olambda__869,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_it(A,fun(nat,A),Uu),Uua) = Uu ) ).

% ATP.lambda_869
tff(fact_9051_ATP_Olambda__870,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_ik(A,fun(B,A),Uu),Uua) = Uu ) ).

% ATP.lambda_870
tff(fact_9052_ATP_Olambda__871,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_qp(A,fun(list(A),list(A))),Uu),Uua) = Uua ) ).

% ATP.lambda_871
tff(fact_9053_ATP_Olambda__872,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] :
      ( pp(aa(list(A),bool,aa(A,fun(list(A),bool),aTP_Lamp_qn(A,fun(list(A),bool)),Uu),Uua))
    <=> $false ) ).

% ATP.lambda_872
tff(fact_9054_ATP_Olambda__873,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] :
      ( pp(aa(list(A),bool,aa(A,fun(list(A),bool),aTP_Lamp_qo(A,fun(list(A),bool)),Uu),Uua))
    <=> $true ) ).

% ATP.lambda_873
tff(fact_9055_ATP_Olambda__874,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_mp(A,fun(A,bool)),Uu),Uua))
    <=> $true ) ).

% ATP.lambda_874
tff(fact_9056_ATP_Olambda__875,axiom,
    ! [Uu: complex] : ( aa(complex,complex,aTP_Lamp_ff(complex,complex),Uu) = Uu ) ).

% ATP.lambda_875
tff(fact_9057_ATP_Olambda__876,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_gs(nat,nat),Uu) = Uu ) ).

% ATP.lambda_876
tff(fact_9058_ATP_Olambda__877,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_hz(int,int),Uu) = Uu ) ).

% ATP.lambda_877
tff(fact_9059_ATP_Olambda__878,axiom,
    ! [C: $tType] :
      ( topological_t2_space(C)
     => ! [Uu: C] : ( aa(C,C,aTP_Lamp_zh(C,C),Uu) = Uu ) ) ).

% ATP.lambda_878
tff(fact_9060_ATP_Olambda__879,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_zc(A,A),Uu) = Uu ) ) ).

% ATP.lambda_879
tff(fact_9061_ATP_Olambda__880,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ze(A,A),Uu) = Uu ) ) ).

% ATP.lambda_880
tff(fact_9062_ATP_Olambda__881,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_zg(A,A),Uu) = Uu ) ) ).

% ATP.lambda_881
tff(fact_9063_ATP_Olambda__882,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_mr(A,A),Uu) = Uu ) ) ).

% ATP.lambda_882
tff(fact_9064_ATP_Olambda__883,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_nd(A,A),Uu) = Uu ) ) ).

% ATP.lambda_883
tff(fact_9065_ATP_Olambda__884,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ae(A,A),Uu) = Uu ) ) ).

% ATP.lambda_884
tff(fact_9066_ATP_Olambda__885,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,A,aTP_Lamp_if(A,A),Uu) = Uu ) ).

% ATP.lambda_885
tff(fact_9067_ATP_Olambda__886,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ay(nat,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_886
tff(fact_9068_ATP_Olambda__887,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_aw(nat,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_887
tff(fact_9069_ATP_Olambda__888,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_fb(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_888
tff(fact_9070_ATP_Olambda__889,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_lw(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_889
tff(fact_9071_ATP_Olambda__890,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_su(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_890
tff(fact_9072_ATP_Olambda__891,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ad(A,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_891
tff(fact_9073_ATP_Olambda__892,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,real,aTP_Lamp_mi(A,real),Uu) = one_one(real) ) ).

% ATP.lambda_892
tff(fact_9074_ATP_Olambda__893,axiom,
    ! [Uu: real] :
      ( pp(aa(real,bool,aTP_Lamp_hl(real,bool),Uu))
    <=> $false ) ).

% ATP.lambda_893
tff(fact_9075_ATP_Olambda__894,axiom,
    ! [Uu: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_jq(nat,bool),Uu))
    <=> $false ) ).

% ATP.lambda_894
tff(fact_9076_ATP_Olambda__895,axiom,
    ! [Uu: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_jp(nat,bool),Uu))
    <=> $true ) ).

% ATP.lambda_895

% Type constructors (743)
tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    bounded_lattice(extended_enat) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice_1,axiom,
    ! [A11: $tType] : bounded_lattice(filter(A11)) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice_2,axiom,
    bounded_lattice(bool) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice_3,axiom,
    ! [A11: $tType] : bounded_lattice(set(A11)) ).

tff(tcon_fun___Lattices_Obounded__lattice_4,axiom,
    ! [A11: $tType,A17: $tType] :
      ( bounded_lattice(A17)
     => bounded_lattice(fun(A11,A17)) ) ).

tff(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A11: $tType,A17: $tType] :
      ( comple6319245703460814977attice(A17)
     => condit1219197933456340205attice(fun(A11,A17)) ) ).

tff(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A11: $tType,A17: $tType] :
      ( counta3822494911875563373attice(A17)
     => counta3822494911875563373attice(fun(A11,A17)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A11: $tType,A17: $tType] :
      ( comple592849572758109894attice(A17)
     => comple592849572758109894attice(fun(A11,A17)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A11: $tType,A17: $tType] :
      ( bounded_lattice(A17)
     => bounde4967611905675639751up_bot(fun(A11,A17)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A11: $tType,A17: $tType] :
      ( bounded_lattice(A17)
     => bounde4346867609351753570nf_top(fun(A11,A17)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A11: $tType,A17: $tType] :
      ( comple6319245703460814977attice(A17)
     => comple6319245703460814977attice(fun(A11,A17)) ) ).

tff(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A11: $tType,A17: $tType] :
      ( boolea8198339166811842893lgebra(A17)
     => boolea8198339166811842893lgebra(fun(A11,A17)) ) ).

tff(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A11: $tType,A17: $tType] :
      ( semilattice_sup(A17)
     => semilattice_sup(fun(A11,A17)) ) ).

tff(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A11: $tType,A17: $tType] :
      ( semilattice_inf(A17)
     => semilattice_inf(fun(A11,A17)) ) ).

tff(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A11: $tType,A17: $tType] :
      ( order_top(A17)
     => order_top(fun(A11,A17)) ) ).

tff(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A11: $tType,A17: $tType] :
      ( order_bot(A17)
     => order_bot(fun(A11,A17)) ) ).

tff(tcon_fun___Orderings_Opreorder,axiom,
    ! [A11: $tType,A17: $tType] :
      ( preorder(A17)
     => preorder(fun(A11,A17)) ) ).

tff(tcon_fun___Lattices_Olattice,axiom,
    ! [A11: $tType,A17: $tType] :
      ( lattice(A17)
     => lattice(fun(A11,A17)) ) ).

tff(tcon_fun___Orderings_Oorder,axiom,
    ! [A11: $tType,A17: $tType] :
      ( order(A17)
     => order(fun(A11,A17)) ) ).

tff(tcon_fun___Orderings_Oord,axiom,
    ! [A11: $tType,A17: $tType] :
      ( ord(A17)
     => ord(fun(A11,A17)) ) ).

tff(tcon_fun___Groups_Ouminus,axiom,
    ! [A11: $tType,A17: $tType] :
      ( uminus(A17)
     => uminus(fun(A11,A17)) ) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder(int) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_5,axiom,
    condit1219197933456340205attice(int) ).

tff(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations(int) ).

tff(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel(int) ).

tff(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict(int) ).

tff(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add(int) ).

tff(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring(int) ).

tff(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize(int) ).

tff(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult(int) ).

tff(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add(int) ).

tff(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors(int) ).

tff(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space(int) ).

tff(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__sup_6,axiom,
    semilattice_sup(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__inf_7,axiom,
    semilattice_inf(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel(int) ).

tff(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs(int) ).

tff(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide(int) ).

tff(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring(int) ).

tff(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0(int) ).

tff(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn(int) ).

tff(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity(int) ).

tff(tcon_Int_Oint___Orderings_Opreorder_8,axiom,
    preorder(int) ).

tff(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult(int) ).

tff(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0(int) ).

tff(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top(int) ).

tff(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot(int) ).

tff(tcon_Int_Oint___Lattices_Olattice_9,axiom,
    lattice(int) ).

tff(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd(int) ).

tff(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring(int) ).

tff(tcon_Int_Oint___Orderings_Oorder_10,axiom,
    order(int) ).

tff(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral(int) ).

tff(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0(int) ).

tff(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom(int) ).

tff(tcon_Int_Oint___Orderings_Oord_11,axiom,
    ord(int) ).

tff(tcon_Int_Oint___Groups_Ouminus_12,axiom,
    uminus(int) ).

tff(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1(int) ).

tff(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if(int) ).

tff(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd(int) ).

tff(tcon_Int_Oint___Power_Opower,axiom,
    power(int) ).

tff(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral(int) ).

tff(tcon_Int_Oint___Groups_Ozero,axiom,
    zero(int) ).

tff(tcon_Int_Oint___Groups_Oplus,axiom,
    plus(int) ).

tff(tcon_Int_Oint___Rings_Oring,axiom,
    ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom,axiom,
    idom(int) ).

tff(tcon_Int_Oint___Groups_Oone,axiom,
    one(int) ).

tff(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd(int) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_13,axiom,
    condit6923001295902523014norder(nat) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_14,axiom,
    condit1219197933456340205attice(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_15,axiom,
    bit_un5681908812861735899ations(nat) ).

tff(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_16,axiom,
    semiri1453513574482234551roduct(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_17,axiom,
    euclid5411537665997757685th_nat(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_18,axiom,
    ordere1937475149494474687imp_le(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_19,axiom,
    euclid3128863361964157862miring(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_20,axiom,
    euclid4440199948858584721cancel(nat) ).

tff(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_21,axiom,
    unique1627219031080169319umeral(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_22,axiom,
    semiri6575147826004484403cancel(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_23,axiom,
    strict9044650504122735259up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_24,axiom,
    ordere580206878836729694up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_25,axiom,
    ordere2412721322843649153imp_le(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_26,axiom,
    bit_se359711467146920520ations(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_27,axiom,
    linord2810124833399127020strict(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_28,axiom,
    strict7427464778891057005id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_29,axiom,
    ordere8940638589300402666id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_30,axiom,
    euclid3725896446679973847miring(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Otopological__space_31,axiom,
    topolo4958980785337419405_space(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_32,axiom,
    topolo1944317154257567458pology(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_33,axiom,
    topolo5987344860129210374id_add(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_34,axiom,
    topolo2564578578187576103pology(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_35,axiom,
    semiri2026040879449505780visors(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_36,axiom,
    linord181362715937106298miring(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_37,axiom,
    topolo4211221413907600880p_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_38,axiom,
    linord8928482502909563296strict(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_39,axiom,
    semiri3467727345109120633visors(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_40,axiom,
    ordere6658533253407199908up_add(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_41,axiom,
    semiri6843258321239162965malize(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__monoid__mult_42,axiom,
    topolo1898628316856586783d_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_43,axiom,
    ordere6911136660526730532id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_44,axiom,
    cancel2418104881723323429up_add(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__monoid__add_45,axiom,
    topolo6943815403480290642id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_46,axiom,
    cancel1802427076303600483id_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_47,axiom,
    comm_s4317794764714335236cancel(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_48,axiom,
    bit_semiring_bits(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Ot2__space_49,axiom,
    topological_t2_space(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__comm__semiring_50,axiom,
    ordere2520102378445227354miring(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_51,axiom,
    cancel_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring_52,axiom,
    linordered_semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring__0_53,axiom,
    ordered_semiring_0(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semidom_54,axiom,
    linordered_semidom(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__sup_55,axiom,
    semilattice_sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__inf_56,axiom,
    semilattice_inf(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__mult_57,axiom,
    ab_semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1__cancel_58,axiom,
    semiring_1_cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Oalgebraic__semidom_59,axiom,
    algebraic_semidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_60,axiom,
    comm_monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__add_61,axiom,
    ab_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring_62,axiom,
    ordered_semiring(nat) ).

tff(tcon_Nat_Onat___Parity_Osemiring__parity_63,axiom,
    semiring_parity(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__add_64,axiom,
    comm_monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__modulo_65,axiom,
    semiring_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1_66,axiom,
    comm_semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__0_67,axiom,
    comm_semiring_0(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__mult_68,axiom,
    semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__modulo_69,axiom,
    semidom_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide_70,axiom,
    semidom_divide(nat) ).

tff(tcon_Nat_Onat___Num_Osemiring__numeral_71,axiom,
    semiring_numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__add_72,axiom,
    semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__less__one_73,axiom,
    zero_less_one(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring_74,axiom,
    comm_semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder__bot_75,axiom,
    order_bot(nat) ).

tff(tcon_Nat_Onat___Nat_Osemiring__char__0_76,axiom,
    semiring_char_0(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__neq__one_77,axiom,
    zero_neq_one(nat) ).

tff(tcon_Nat_Onat___Orderings_Opreorder_78,axiom,
    preorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Olinorder_79,axiom,
    linorder(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__mult_80,axiom,
    monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__add_81,axiom,
    monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1_82,axiom,
    semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__0_83,axiom,
    semiring_0(nat) ).

tff(tcon_Nat_Onat___Orderings_Ono__top_84,axiom,
    no_top(nat) ).

tff(tcon_Nat_Onat___Lattices_Olattice_85,axiom,
    lattice(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd_86,axiom,
    semiring_gcd(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__Gcd_87,axiom,
    semiring_Gcd(nat) ).

tff(tcon_Nat_Onat___Rings_Omult__zero_88,axiom,
    mult_zero(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder_89,axiom,
    order(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring_90,axiom,
    semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom_91,axiom,
    semidom(nat) ).

tff(tcon_Nat_Onat___Orderings_Oord_92,axiom,
    ord(nat) ).

tff(tcon_Nat_Onat___Power_Opower_93,axiom,
    power(nat) ).

tff(tcon_Nat_Onat___Num_Onumeral_94,axiom,
    numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Ozero_95,axiom,
    zero(nat) ).

tff(tcon_Nat_Onat___Groups_Oplus_96,axiom,
    plus(nat) ).

tff(tcon_Nat_Onat___Groups_Oone_97,axiom,
    one(nat) ).

tff(tcon_Nat_Onat___Rings_Odvd_98,axiom,
    dvd(nat) ).

tff(tcon_Nat_Onat___Nat_Osize,axiom,
    size(nat) ).

tff(tcon_Num_Onum___Orderings_Opreorder_99,axiom,
    preorder(num) ).

tff(tcon_Num_Onum___Orderings_Olinorder_100,axiom,
    linorder(num) ).

tff(tcon_Num_Onum___Orderings_Oorder_101,axiom,
    order(num) ).

tff(tcon_Num_Onum___Orderings_Oord_102,axiom,
    ord(num) ).

tff(tcon_Num_Onum___Groups_Oplus_103,axiom,
    plus(num) ).

tff(tcon_Num_Onum___Nat_Osize_104,axiom,
    size(num) ).

tff(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_105,axiom,
    semiri1453513574482234551roduct(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_106,axiom,
    ordere1937475149494474687imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_107,axiom,
    semiri6575147826004484403cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_108,axiom,
    strict9044650504122735259up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_109,axiom,
    ordere580206878836729694up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_110,axiom,
    ordere2412721322843649153imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_111,axiom,
    linord2810124833399127020strict(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_112,axiom,
    strict7427464778891057005id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_113,axiom,
    ordere8940638589300402666id_add(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_114,axiom,
    linord715952674999750819strict(rat) ).

tff(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_115,axiom,
    semiri2026040879449505780visors(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_116,axiom,
    linord181362715937106298miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_117,axiom,
    linord8928482502909563296strict(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_118,axiom,
    semiri3467727345109120633visors(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_119,axiom,
    ordere6658533253407199908up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_120,axiom,
    ordere166539214618696060dd_abs(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_121,axiom,
    ordere6911136660526730532id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_122,axiom,
    linord5086331880401160121up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_123,axiom,
    cancel2418104881723323429up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_124,axiom,
    ring_15535105094025558882visors(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_125,axiom,
    cancel1802427076303600483id_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring__strict_126,axiom,
    linord4710134922213307826strict(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_127,axiom,
    comm_s4317794764714335236cancel(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__comm__semiring_128,axiom,
    ordere2520102378445227354miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1_129,axiom,
    linord6961819062388156250ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add_130,axiom,
    ordered_ab_group_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_131,axiom,
    cancel_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring_132,axiom,
    linordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring__0_133,axiom,
    ordered_semiring_0(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semidom_134,axiom,
    linordered_semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__sup_135,axiom,
    semilattice_sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__inf_136,axiom,
    semilattice_inf(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__mult_137,axiom,
    ab_semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1__cancel_138,axiom,
    semiring_1_cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_139,axiom,
    comm_monoid_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__add_140,axiom,
    ab_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring_141,axiom,
    ordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring__abs_142,axiom,
    ordered_ring_abs(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__add_143,axiom,
    comm_monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring_144,axiom,
    linordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__idom_145,axiom,
    linordered_idom(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1_146,axiom,
    comm_semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__0_147,axiom,
    comm_semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__mult_148,axiom,
    semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom__divide_149,axiom,
    semidom_divide(rat) ).

tff(tcon_Rat_Orat___Num_Osemiring__numeral_150,axiom,
    semiring_numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__add_151,axiom,
    semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__less__one_152,axiom,
    zero_less_one(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring_153,axiom,
    comm_semiring(rat) ).

tff(tcon_Rat_Orat___Nat_Osemiring__char__0_154,axiom,
    semiring_char_0(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__group__add_155,axiom,
    ab_group_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__neq__one_156,axiom,
    zero_neq_one(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring_157,axiom,
    ordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__abs__sgn_158,axiom,
    idom_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Orderings_Opreorder_159,axiom,
    preorder(rat) ).

tff(tcon_Rat_Orat___Orderings_Olinorder_160,axiom,
    linorder(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__mult_161,axiom,
    monoid_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__divide_162,axiom,
    idom_divide(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring__1_163,axiom,
    comm_ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__add_164,axiom,
    monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1_165,axiom,
    semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__0_166,axiom,
    semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__top_167,axiom,
    no_top(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__bot_168,axiom,
    no_bot(rat) ).

tff(tcon_Rat_Orat___Lattices_Olattice_169,axiom,
    lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Ogroup__add_170,axiom,
    group_add(rat) ).

tff(tcon_Rat_Orat___Rings_Omult__zero_171,axiom,
    mult_zero(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring_172,axiom,
    comm_ring(rat) ).

tff(tcon_Rat_Orat___Orderings_Oorder_173,axiom,
    order(rat) ).

tff(tcon_Rat_Orat___Num_Oneg__numeral_174,axiom,
    neg_numeral(rat) ).

tff(tcon_Rat_Orat___Nat_Oring__char__0_175,axiom,
    ring_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring_176,axiom,
    semiring(rat) ).

tff(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom_177,axiom,
    semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Oord_178,axiom,
    ord(rat) ).

tff(tcon_Rat_Orat___Groups_Ouminus_179,axiom,
    uminus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1_180,axiom,
    ring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Oabs__if_181,axiom,
    abs_if(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield,axiom,
    field(rat) ).

tff(tcon_Rat_Orat___Power_Opower_182,axiom,
    power(rat) ).

tff(tcon_Rat_Orat___Num_Onumeral_183,axiom,
    numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Ozero_184,axiom,
    zero(rat) ).

tff(tcon_Rat_Orat___Groups_Oplus_185,axiom,
    plus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring_186,axiom,
    ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom_187,axiom,
    idom(rat) ).

tff(tcon_Rat_Orat___Groups_Oone_188,axiom,
    one(rat) ).

tff(tcon_Rat_Orat___Rings_Odvd_189,axiom,
    dvd(rat) ).

tff(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_190,axiom,
    ! [A11: $tType] : condit1219197933456340205attice(set(A11)) ).

tff(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_191,axiom,
    ! [A11: $tType] : counta3822494911875563373attice(set(A11)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_192,axiom,
    ! [A11: $tType] : comple592849572758109894attice(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_193,axiom,
    ! [A11: $tType] : bounde4967611905675639751up_bot(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_194,axiom,
    ! [A11: $tType] : bounde4346867609351753570nf_top(set(A11)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_195,axiom,
    ! [A11: $tType] : comple6319245703460814977attice(set(A11)) ).

tff(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_196,axiom,
    ! [A11: $tType] : boolea8198339166811842893lgebra(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__sup_197,axiom,
    ! [A11: $tType] : semilattice_sup(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__inf_198,axiom,
    ! [A11: $tType] : semilattice_inf(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder__top_199,axiom,
    ! [A11: $tType] : order_top(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder__bot_200,axiom,
    ! [A11: $tType] : order_bot(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Opreorder_201,axiom,
    ! [A11: $tType] : preorder(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Olattice_202,axiom,
    ! [A11: $tType] : lattice(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder_203,axiom,
    ! [A11: $tType] : order(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oord_204,axiom,
    ! [A11: $tType] : ord(set(A11)) ).

tff(tcon_Set_Oset___Groups_Ouminus_205,axiom,
    ! [A11: $tType] : uminus(set(A11)) ).

tff(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_206,axiom,
    condit1219197933456340205attice(bool) ).

tff(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_207,axiom,
    counta3822494911875563373attice(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_208,axiom,
    comple592849572758109894attice(bool) ).

tff(tcon_HOL_Obool___Topological__Spaces_Otopological__space_209,axiom,
    topolo4958980785337419405_space(bool) ).

tff(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_210,axiom,
    topolo1944317154257567458pology(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_211,axiom,
    bounde4967611905675639751up_bot(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_212,axiom,
    bounde4346867609351753570nf_top(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_213,axiom,
    comple6319245703460814977attice(bool) ).

tff(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_214,axiom,
    topolo2564578578187576103pology(bool) ).

tff(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_215,axiom,
    boolea8198339166811842893lgebra(bool) ).

tff(tcon_HOL_Obool___Topological__Spaces_Ot2__space_216,axiom,
    topological_t2_space(bool) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__sup_217,axiom,
    semilattice_sup(bool) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__inf_218,axiom,
    semilattice_inf(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder__top_219,axiom,
    order_top(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder__bot_220,axiom,
    order_bot(bool) ).

tff(tcon_HOL_Obool___Orderings_Opreorder_221,axiom,
    preorder(bool) ).

tff(tcon_HOL_Obool___Orderings_Olinorder_222,axiom,
    linorder(bool) ).

tff(tcon_HOL_Obool___Lattices_Olattice_223,axiom,
    lattice(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder_224,axiom,
    order(bool) ).

tff(tcon_HOL_Obool___Orderings_Oord_225,axiom,
    ord(bool) ).

tff(tcon_HOL_Obool___Groups_Ouminus_226,axiom,
    uminus(bool) ).

tff(tcon_List_Olist___Nat_Osize_227,axiom,
    ! [A11: $tType] : size(list(A11)) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_228,axiom,
    condit6923001295902523014norder(real) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_229,axiom,
    condit1219197933456340205attice(real) ).

tff(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_230,axiom,
    semiri1453513574482234551roduct(real) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_231,axiom,
    ordere1937475149494474687imp_le(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_232,axiom,
    semiri6575147826004484403cancel(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector(real) ).

tff(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_233,axiom,
    strict9044650504122735259up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_234,axiom,
    ordere580206878836729694up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_235,axiom,
    ordere2412721322843649153imp_le(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_236,axiom,
    linord2810124833399127020strict(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector(real) ).

tff(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_237,axiom,
    strict7427464778891057005id_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_238,axiom,
    ordere8940638589300402666id_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Otopological__space_239,axiom,
    topolo4958980785337419405_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_240,axiom,
    topolo1944317154257567458pology(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra(real) ).

tff(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_241,axiom,
    archim462609752435547400_field(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_242,axiom,
    linord715952674999750819strict(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist(real) ).

tff(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_243,axiom,
    unboun7993243217541854897norder(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_244,axiom,
    topolo5987344860129210374id_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_245,axiom,
    topolo2564578578187576103pology(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_246,axiom,
    semiri2026040879449505780visors(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_247,axiom,
    linord181362715937106298miring(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_248,axiom,
    topolo4211221413907600880p_mult(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_249,axiom,
    linord8928482502909563296strict(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_250,axiom,
    semiri3467727345109120633visors(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_251,axiom,
    ordere6658533253407199908up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_252,axiom,
    ordere166539214618696060dd_abs(real) ).

tff(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_253,axiom,
    archim2362893244070406136eiling(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_254,axiom,
    ordere6911136660526730532id_add(real) ).

tff(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_255,axiom,
    linord5086331880401160121up_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_256,axiom,
    cancel2418104881723323429up_add(real) ).

tff(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_257,axiom,
    ring_15535105094025558882visors(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__monoid__add_258,axiom,
    topolo6943815403480290642id_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_259,axiom,
    cancel1802427076303600483id_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__ring__strict_260,axiom,
    linord4710134922213307826strict(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_261,axiom,
    comm_s4317794764714335236cancel(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ot2__space_262,axiom,
    topological_t2_space(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__comm__semiring_263,axiom,
    ordere2520102378445227354miring(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__1_264,axiom,
    linord6961819062388156250ring_1(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__group__add_265,axiom,
    ordered_ab_group_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_266,axiom,
    cancel_semigroup_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring_267,axiom,
    linordered_semiring(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__semiring__0_268,axiom,
    ordered_semiring_0(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semidom_269,axiom,
    linordered_semidom(real) ).

tff(tcon_Real_Oreal___Orderings_Odense__linorder_270,axiom,
    dense_linorder(real) ).

tff(tcon_Real_Oreal___Lattices_Osemilattice__sup_271,axiom,
    semilattice_sup(real) ).

tff(tcon_Real_Oreal___Lattices_Osemilattice__inf_272,axiom,
    semilattice_inf(real) ).

tff(tcon_Real_Oreal___Groups_Oab__semigroup__mult_273,axiom,
    ab_semigroup_mult(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1__cancel_274,axiom,
    semiring_1_cancel(real) ).

tff(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_275,axiom,
    comm_monoid_mult(real) ).

tff(tcon_Real_Oreal___Groups_Oab__semigroup__add_276,axiom,
    ab_semigroup_add(real) ).

tff(tcon_Real_Oreal___Fields_Olinordered__field_277,axiom,
    linordered_field(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__semiring_278,axiom,
    ordered_semiring(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__ring__abs_279,axiom,
    ordered_ring_abs(real) ).

tff(tcon_Real_Oreal___Groups_Ocomm__monoid__add_280,axiom,
    comm_monoid_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__ring_281,axiom,
    linordered_ring(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__idom_282,axiom,
    linordered_idom(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__1_283,axiom,
    comm_semiring_1(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__0_284,axiom,
    comm_semiring_0(real) ).

tff(tcon_Real_Oreal___Orderings_Odense__order_285,axiom,
    dense_order(real) ).

tff(tcon_Real_Oreal___Groups_Osemigroup__mult_286,axiom,
    semigroup_mult(real) ).

tff(tcon_Real_Oreal___Rings_Osemidom__divide_287,axiom,
    semidom_divide(real) ).

tff(tcon_Real_Oreal___Num_Osemiring__numeral_288,axiom,
    semiring_numeral(real) ).

tff(tcon_Real_Oreal___Groups_Osemigroup__add_289,axiom,
    semigroup_add(real) ).

tff(tcon_Real_Oreal___Fields_Ofield__abs__sgn_290,axiom,
    field_abs_sgn(real) ).

tff(tcon_Real_Oreal___Fields_Odivision__ring_291,axiom,
    division_ring(real) ).

tff(tcon_Real_Oreal___Rings_Ozero__less__one_292,axiom,
    zero_less_one(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring_293,axiom,
    comm_semiring(real) ).

tff(tcon_Real_Oreal___Nat_Osemiring__char__0_294,axiom,
    semiring_char_0(real) ).

tff(tcon_Real_Oreal___Groups_Oab__group__add_295,axiom,
    ab_group_add(real) ).

tff(tcon_Real_Oreal___Fields_Ofield__char__0_296,axiom,
    field_char_0(real) ).

tff(tcon_Real_Oreal___Rings_Ozero__neq__one_297,axiom,
    zero_neq_one(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__ring_298,axiom,
    ordered_ring(real) ).

tff(tcon_Real_Oreal___Rings_Oidom__abs__sgn_299,axiom,
    idom_abs_sgn(real) ).

tff(tcon_Real_Oreal___Orderings_Opreorder_300,axiom,
    preorder(real) ).

tff(tcon_Real_Oreal___Orderings_Olinorder_301,axiom,
    linorder(real) ).

tff(tcon_Real_Oreal___Groups_Omonoid__mult_302,axiom,
    monoid_mult(real) ).

tff(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln(real) ).

tff(tcon_Real_Oreal___Rings_Oidom__divide_303,axiom,
    idom_divide(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__ring__1_304,axiom,
    comm_ring_1(real) ).

tff(tcon_Real_Oreal___Groups_Omonoid__add_305,axiom,
    monoid_add(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1_306,axiom,
    semiring_1(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__0_307,axiom,
    semiring_0(real) ).

tff(tcon_Real_Oreal___Orderings_Ono__top_308,axiom,
    no_top(real) ).

tff(tcon_Real_Oreal___Orderings_Ono__bot_309,axiom,
    no_bot(real) ).

tff(tcon_Real_Oreal___Lattices_Olattice_310,axiom,
    lattice(real) ).

tff(tcon_Real_Oreal___Groups_Ogroup__add_311,axiom,
    group_add(real) ).

tff(tcon_Real_Oreal___Rings_Omult__zero_312,axiom,
    mult_zero(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__ring_313,axiom,
    comm_ring(real) ).

tff(tcon_Real_Oreal___Orderings_Oorder_314,axiom,
    order(real) ).

tff(tcon_Real_Oreal___Num_Oneg__numeral_315,axiom,
    neg_numeral(real) ).

tff(tcon_Real_Oreal___Nat_Oring__char__0_316,axiom,
    ring_char_0(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring_317,axiom,
    semiring(real) ).

tff(tcon_Real_Oreal___Fields_Oinverse_318,axiom,
    inverse(real) ).

tff(tcon_Real_Oreal___Rings_Osemidom_319,axiom,
    semidom(real) ).

tff(tcon_Real_Oreal___Orderings_Oord_320,axiom,
    ord(real) ).

tff(tcon_Real_Oreal___Groups_Ouminus_321,axiom,
    uminus(real) ).

tff(tcon_Real_Oreal___Rings_Oring__1_322,axiom,
    ring_1(real) ).

tff(tcon_Real_Oreal___Rings_Oabs__if_323,axiom,
    abs_if(real) ).

tff(tcon_Real_Oreal___Fields_Ofield_324,axiom,
    field(real) ).

tff(tcon_Real_Oreal___Power_Opower_325,axiom,
    power(real) ).

tff(tcon_Real_Oreal___Num_Onumeral_326,axiom,
    numeral(real) ).

tff(tcon_Real_Oreal___Groups_Ozero_327,axiom,
    zero(real) ).

tff(tcon_Real_Oreal___Groups_Oplus_328,axiom,
    plus(real) ).

tff(tcon_Real_Oreal___Rings_Oring_329,axiom,
    ring(real) ).

tff(tcon_Real_Oreal___Rings_Oidom_330,axiom,
    idom(real) ).

tff(tcon_Real_Oreal___Groups_Oone_331,axiom,
    one(real) ).

tff(tcon_Real_Oreal___Rings_Odvd_332,axiom,
    dvd(real) ).

tff(tcon_String_Ochar___Nat_Osize_333,axiom,
    size(char) ).

tff(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_334,axiom,
    ! [A11: $tType] : condit1219197933456340205attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_335,axiom,
    ! [A11: $tType] : counta3822494911875563373attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_336,axiom,
    ! [A11: $tType] : bounde4967611905675639751up_bot(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_337,axiom,
    ! [A11: $tType] : bounde4346867609351753570nf_top(filter(A11)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_338,axiom,
    ! [A11: $tType] : comple6319245703460814977attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_339,axiom,
    ! [A11: $tType] : semilattice_sup(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_340,axiom,
    ! [A11: $tType] : semilattice_inf(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__top_341,axiom,
    ! [A11: $tType] : order_top(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__bot_342,axiom,
    ! [A11: $tType] : order_bot(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Opreorder_343,axiom,
    ! [A11: $tType] : preorder(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Olattice_344,axiom,
    ! [A11: $tType] : lattice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder_345,axiom,
    ! [A11: $tType] : order(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oord_346,axiom,
    ! [A11: $tType] : ord(filter(A11)) ).

tff(tcon_Option_Ooption___Nat_Osize_347,axiom,
    ! [A11: $tType] : size(option(A11)) ).

tff(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_348,axiom,
    semiri1453513574482234551roduct(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_349,axiom,
    topolo3112930676232923870pology(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_350,axiom,
    real_V8999393235501362500lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_351,axiom,
    real_V2822296259951069270ebra_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_352,axiom,
    semiri6575147826004484403cancel(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_353,axiom,
    real_V4412858255891104859lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_354,axiom,
    real_V822414075346904944vector(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_355,axiom,
    topolo4958980785337419405_space(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_356,axiom,
    real_V3459762299906320749_field(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_357,axiom,
    real_V5047593784448816457lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_358,axiom,
    real_V768167426530841204y_dist(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_359,axiom,
    topolo5987344860129210374id_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_360,axiom,
    semiri2026040879449505780visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_361,axiom,
    real_V2191834092415804123ebra_1(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_362,axiom,
    real_V8037385150606011577_space(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_363,axiom,
    topolo4211221413907600880p_mult(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_364,axiom,
    topolo7287701948861334536_space(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_365,axiom,
    topolo8386298272705272623_space(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_366,axiom,
    semiri3467727345109120633visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_367,axiom,
    real_V6157519004096292374lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_368,axiom,
    real_V7819770556892013058_space(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_369,axiom,
    topolo1287966508704411220up_add(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_370,axiom,
    real_V4867850818363320053vector(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_371,axiom,
    cancel2418104881723323429up_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_372,axiom,
    ring_15535105094025558882visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_373,axiom,
    real_V7773925162809079976_field(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_374,axiom,
    topolo6943815403480290642id_add(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_375,axiom,
    cancel1802427076303600483id_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_376,axiom,
    comm_s4317794764714335236cancel(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__group__add_377,axiom,
    topolo1633459387980952147up_add(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_378,axiom,
    topological_t2_space(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_379,axiom,
    cancel_semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_380,axiom,
    real_Vector_banach(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_381,axiom,
    ab_semigroup_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_382,axiom,
    semiring_1_cancel(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_383,axiom,
    comm_monoid_mult(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_384,axiom,
    ab_semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_385,axiom,
    comm_monoid_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_386,axiom,
    comm_semiring_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_387,axiom,
    comm_semiring_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_388,axiom,
    semigroup_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemidom__divide_389,axiom,
    semidom_divide(complex) ).

tff(tcon_Complex_Ocomplex___Num_Osemiring__numeral_390,axiom,
    semiring_numeral(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Osemigroup__add_391,axiom,
    semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_392,axiom,
    field_abs_sgn(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Odivision__ring_393,axiom,
    division_ring(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_394,axiom,
    comm_semiring(complex) ).

tff(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_395,axiom,
    semiring_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__group__add_396,axiom,
    ab_group_add(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield__char__0_397,axiom,
    field_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_398,axiom,
    zero_neq_one(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_399,axiom,
    idom_abs_sgn(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Omonoid__mult_400,axiom,
    monoid_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom__divide_401,axiom,
    idom_divide(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_402,axiom,
    comm_ring_1(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Omonoid__add_403,axiom,
    monoid_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1_404,axiom,
    semiring_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__0_405,axiom,
    semiring_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ogroup__add_406,axiom,
    group_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Omult__zero_407,axiom,
    mult_zero(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__ring_408,axiom,
    comm_ring(complex) ).

tff(tcon_Complex_Ocomplex___Num_Oneg__numeral_409,axiom,
    neg_numeral(complex) ).

tff(tcon_Complex_Ocomplex___Nat_Oring__char__0_410,axiom,
    ring_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring_411,axiom,
    semiring(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Oinverse_412,axiom,
    inverse(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemidom_413,axiom,
    semidom(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ouminus_414,axiom,
    uminus(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring__1_415,axiom,
    ring_1(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield_416,axiom,
    field(complex) ).

tff(tcon_Complex_Ocomplex___Power_Opower_417,axiom,
    power(complex) ).

tff(tcon_Complex_Ocomplex___Num_Onumeral_418,axiom,
    numeral(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ozero_419,axiom,
    zero(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oplus_420,axiom,
    plus(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring_421,axiom,
    ring(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom_422,axiom,
    idom(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oone_423,axiom,
    one(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Odvd_424,axiom,
    dvd(complex) ).

tff(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_425,axiom,
    condit6923001295902523014norder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_426,axiom,
    condit1219197933456340205attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_427,axiom,
    counta3822494911875563373attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_428,axiom,
    comple592849572758109894attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_429,axiom,
    strict9044650504122735259up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_430,axiom,
    strict7427464778891057005id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_431,axiom,
    canoni5634975068530333245id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_432,axiom,
    bounde4967611905675639751up_bot(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_433,axiom,
    bounde4346867609351753570nf_top(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_434,axiom,
    comple6319245703460814977attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_435,axiom,
    linord181362715937106298miring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_436,axiom,
    semiri3467727345109120633visors(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_437,axiom,
    ordere6658533253407199908up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_438,axiom,
    ordere6911136660526730532id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_439,axiom,
    ordere2520102378445227354miring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_440,axiom,
    semilattice_sup(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_441,axiom,
    semilattice_inf(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_442,axiom,
    ab_semigroup_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_443,axiom,
    comm_monoid_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_444,axiom,
    ab_semigroup_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_445,axiom,
    ordered_semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_446,axiom,
    comm_monoid_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_447,axiom,
    comm_semiring_1(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_448,axiom,
    comm_semiring_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_449,axiom,
    semigroup_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_450,axiom,
    semiring_numeral(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_451,axiom,
    semigroup_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_452,axiom,
    zero_less_one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_453,axiom,
    comm_semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Owellorder_454,axiom,
    wellorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_455,axiom,
    order_top(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_456,axiom,
    order_bot(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_457,axiom,
    semiring_char_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_458,axiom,
    zero_neq_one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Opreorder_459,axiom,
    preorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Olinorder_460,axiom,
    linorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_461,axiom,
    monoid_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_462,axiom,
    monoid_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_463,axiom,
    semiring_1(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_464,axiom,
    semiring_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Olattice_465,axiom,
    lattice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Omult__zero_466,axiom,
    mult_zero(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder_467,axiom,
    order(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring_468,axiom,
    semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oord_469,axiom,
    ord(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Power_Opower_470,axiom,
    power(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Num_Onumeral_471,axiom,
    numeral(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ozero_472,axiom,
    zero(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oplus_473,axiom,
    plus(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oone_474,axiom,
    one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Odvd_475,axiom,
    dvd(extended_enat) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_476,axiom,
    ! [A11: $tType,A17: $tType] :
      ( ( topolo4958980785337419405_space(A11)
        & topolo4958980785337419405_space(A17) )
     => topolo4958980785337419405_space(product_prod(A11,A17)) ) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_477,axiom,
    ! [A11: $tType,A17: $tType] :
      ( ( topological_t2_space(A11)
        & topological_t2_space(A17) )
     => topological_t2_space(product_prod(A11,A17)) ) ).

tff(tcon_Product__Type_Oprod___Nat_Osize_478,axiom,
    ! [A11: $tType,A17: $tType] : size(product_prod(A11,A17)) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_479,axiom,
    bit_un5681908812861735899ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_480,axiom,
    semiri1453513574482234551roduct(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_481,axiom,
    euclid5411537665997757685th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_482,axiom,
    euclid8789492081693882211th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_483,axiom,
    ordere1937475149494474687imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_484,axiom,
    euclid3128863361964157862miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_485,axiom,
    euclid4440199948858584721cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_486,axiom,
    unique1627219031080169319umeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_487,axiom,
    euclid8851590272496341667cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_488,axiom,
    semiri6575147826004484403cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_489,axiom,
    strict9044650504122735259up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_490,axiom,
    ordere580206878836729694up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_491,axiom,
    ordere2412721322843649153imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_492,axiom,
    bit_se359711467146920520ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_493,axiom,
    linord2810124833399127020strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_494,axiom,
    strict7427464778891057005id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_495,axiom,
    ordere8940638589300402666id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_496,axiom,
    euclid3725896446679973847miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_497,axiom,
    linord715952674999750819strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_498,axiom,
    bit_ri3973907225187159222ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_499,axiom,
    semiri2026040879449505780visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_500,axiom,
    linord181362715937106298miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_501,axiom,
    euclid5891614535332579305n_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_502,axiom,
    linord8928482502909563296strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_503,axiom,
    semiri3467727345109120633visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_504,axiom,
    ordere6658533253407199908up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_505,axiom,
    ordere166539214618696060dd_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_506,axiom,
    ordere6911136660526730532id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_507,axiom,
    linord5086331880401160121up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_508,axiom,
    cancel2418104881723323429up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_509,axiom,
    ring_15535105094025558882visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_510,axiom,
    cancel1802427076303600483id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_511,axiom,
    linord4710134922213307826strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_512,axiom,
    comm_s4317794764714335236cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_513,axiom,
    bit_semiring_bits(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_514,axiom,
    ordere2520102378445227354miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_515,axiom,
    linord6961819062388156250ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_516,axiom,
    ordered_ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_517,axiom,
    cancel_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_518,axiom,
    linordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_519,axiom,
    ordered_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_520,axiom,
    linordered_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_521,axiom,
    ab_semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_522,axiom,
    semiring_1_cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_523,axiom,
    algebraic_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_524,axiom,
    comm_monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_525,axiom,
    ab_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_526,axiom,
    ordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_527,axiom,
    ordered_ring_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_528,axiom,
    semiring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_529,axiom,
    comm_monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_530,axiom,
    semiring_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_531,axiom,
    linordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_532,axiom,
    linordered_idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_533,axiom,
    comm_semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_534,axiom,
    comm_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_535,axiom,
    semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_536,axiom,
    semidom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_537,axiom,
    semidom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_538,axiom,
    semiring_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_539,axiom,
    semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_540,axiom,
    zero_less_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_541,axiom,
    comm_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_542,axiom,
    semiring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_543,axiom,
    ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_544,axiom,
    zero_neq_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_545,axiom,
    ordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_546,axiom,
    idom_abs_sgn(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_547,axiom,
    ring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_548,axiom,
    preorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_549,axiom,
    linorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_550,axiom,
    monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_551,axiom,
    idom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_552,axiom,
    idom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_553,axiom,
    comm_ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_554,axiom,
    monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_555,axiom,
    semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_556,axiom,
    semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_557,axiom,
    group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_558,axiom,
    mult_zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_559,axiom,
    comm_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oorder_560,axiom,
    order(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_561,axiom,
    neg_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_562,axiom,
    ring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring_563,axiom,
    semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom_564,axiom,
    semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oord_565,axiom,
    ord(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ouminus_566,axiom,
    uminus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1_567,axiom,
    ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_568,axiom,
    abs_if(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Power_Opower_569,axiom,
    power(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Onumeral_570,axiom,
    numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ozero_571,axiom,
    zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oplus_572,axiom,
    plus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring_573,axiom,
    ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom_574,axiom,
    idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oone_575,axiom,
    one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Odvd_576,axiom,
    dvd(code_integer) ).

tff(tcon_VEBT__Definitions_OVEBT___Nat_Osize_577,axiom,
    size(vEBT_VEBT) ).

% Helper facts (24)
tff(help_If_2_1_T,axiom,
    ! [A: $tType,X3: A,Y4: A] : ( if(A,fFalse,X3,Y4) = Y4 ) ).

tff(help_If_1_1_T,axiom,
    ! [A: $tType,X3: A,Y4: A] : ( if(A,fTrue,X3,Y4) = X3 ) ).

tff(help_fEx_1_1_U,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A] :
      ( ~ pp(aa(A,bool,P,X3))
      | pp(aa(fun(A,bool),bool,fEx(A),P)) ) ).

tff(help_fAll_1_1_U,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A] :
      ( ~ pp(fAll(A,P))
      | pp(aa(A,bool,P,X3)) ) ).

tff(help_fNot_2_1_U,axiom,
    ! [P: bool] :
      ( pp(P)
      | pp(aa(bool,bool,fNot,P)) ) ).

tff(help_fNot_1_1_U,axiom,
    ! [P: bool] :
      ( ~ pp(aa(bool,bool,fNot,P))
      | ~ pp(P) ) ).

tff(help_COMBB_1_1_U,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: fun(B,C),Q: fun(A,B),R4: A] : ( aa(A,C,combb(B,C,A,P,Q),R4) = aa(B,C,P,aa(A,B,Q,R4)) ) ).

tff(help_COMBC_1_1_U,axiom,
    ! [A: $tType,C: $tType,B: $tType,P: fun(A,fun(B,C)),Q: B,R4: A] : ( aa(A,C,combc(A,B,C,P,Q),R4) = aa(B,C,aa(A,fun(B,C),P,R4),Q) ) ).

tff(help_COMBS_1_1_U,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: fun(A,fun(B,C)),Q: fun(A,B),R4: A] : ( aa(A,C,combs(A,B,C,P,Q),R4) = aa(B,C,aa(A,fun(B,C),P,R4),aa(A,B,Q,R4)) ) ).

tff(help_fTrue_1_1_U,axiom,
    pp(fTrue) ).

tff(help_fconj_3_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fconj(P,Q))
      | pp(Q) ) ).

tff(help_fconj_2_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fconj(P,Q))
      | pp(P) ) ).

tff(help_fconj_1_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(P)
      | ~ pp(Q)
      | pp(fconj(P,Q)) ) ).

tff(help_fdisj_3_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fdisj(P,Q))
      | pp(P)
      | pp(Q) ) ).

tff(help_fdisj_2_1_U,axiom,
    ! [Q: bool,P: bool] :
      ( ~ pp(Q)
      | pp(fdisj(P,Q)) ) ).

tff(help_fdisj_1_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(P)
      | pp(fdisj(P,Q)) ) ).

tff(help_fFalse_1_1_T,axiom,
    ! [P: bool] :
      ( ( P = fTrue )
      | ( P = fFalse ) ) ).

tff(help_fFalse_1_1_U,axiom,
    ~ pp(fFalse) ).

tff(help_fequal_2_1_T,axiom,
    ! [A: $tType,X3: A,Y4: A] :
      ( ( X3 != Y4 )
      | pp(aa(A,bool,aa(A,fun(A,bool),fequal(A),X3),Y4)) ) ).

tff(help_fequal_1_1_T,axiom,
    ! [A: $tType,X3: A,Y4: A] :
      ( ~ pp(aa(A,bool,aa(A,fun(A,bool),fequal(A),X3),Y4))
      | ( X3 = Y4 ) ) ).

tff(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( aa(A,bool,P,fChoice(A,P)) = aa(fun(A,bool),bool,fEx(A),P) ) ).

tff(help_fimplies_3_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(aa(bool,bool,aa(bool,fun(bool,bool),fimplies,P),Q))
      | ~ pp(P)
      | pp(Q) ) ).

tff(help_fimplies_2_1_U,axiom,
    ! [Q: bool,P: bool] :
      ( ~ pp(Q)
      | pp(aa(bool,bool,aa(bool,fun(bool,bool),fimplies,P),Q)) ) ).

tff(help_fimplies_1_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( pp(P)
      | pp(aa(bool,bool,aa(bool,fun(bool,bool),fimplies,P),Q)) ) ).

% Conjectures (1)
tff(conj_0,conjecture,
    pp(aa(set(vEBT_VEBT),bool,aa(vEBT_VEBT,fun(set(vEBT_VEBT),bool),member2(vEBT_VEBT),aa(nat,vEBT_VEBT,nth(vEBT_VEBT,treeLista),i)),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),treeLista))) ).

%------------------------------------------------------------------------------
