%------------------------------------------------------------------------------
% File     : VBT00019^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Definitions 00707_032605
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0063_VEBT_Definitions_00707_032605 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9544 (3169 unt; 570 typ;   0 def)
%            Number of atoms       : 27285 (9507 equ;   5 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 169747 (2003   ~; 313   |;2313   &;153039   @)
%                                         (   0 <=>;12079  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   11 (  10 usr)
%            Number of type conns  : 4271 (4271   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  564 ( 560 usr;  11 con; 0-8 aty)
%            Number of variables   : 29793 (3394   ^25088   !; 795   ?;29793   :)
%                                         ( 516  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 18:00:34.614
%------------------------------------------------------------------------------
% Could-be-implicit typings (16)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (554)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_OInf,type,
    complete_Inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_OSup,type,
    complete_Sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot1__space,type,
    topological_t1_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oopen__uniformity,type,
    topolo569519726778239578ormity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Odiscrete__topology,type,
    topolo8865339358273720382pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__boolean__algebra,type,
    comple489889107523837845lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OSucc,type,
    bNF_Greatest_Succ: 
      !>[A: $tType] : ( ( set @ ( list @ A ) ) > ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: num > int ).

thf(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: num > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Extended__Nat_Oenat,type,
    extended_enat2: nat > extended_enat ).

thf(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : ( ( nat > T ) > T > extended_enat > T ) ).

thf(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,
    extend4730790105801354508finity: 
      !>[A: $tType] : A ).

thf(sy_c_Extended__Nat_Othe__enat,type,
    extended_the_enat: extended_enat > nat ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( filter @ B ) > ( filter @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite2: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > A > ( option @ B ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Orec__option,type,
    rec_option: 
      !>[C: $tType,A: $tType] : ( C > ( A > C ) > ( option @ A ) > C ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( ( set @ ( option @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Order__Continuity_Ocountable__complete__lattice__class_Occlfp,type,
    order_532582986084564980_cclfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Ofilter,type,
    filter3: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

thf(sy_c_String_Ochar__of__integer,type,
    char_of_integer: code_integer > char ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ogenerate__topology,type,
    topolo8378437560675496660pology: 
      !>[A: $tType] : ( ( set @ ( set @ A ) ) > ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : ( filter @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Ocase__VEBT,type,
    vEBT_case_VEBT: 
      !>[A: $tType] : ( ( ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > A ) > ( $o > $o > A ) > vEBT_VEBT > A ) ).

thf(sy_c_VEBT__Definitions_OVEBT_Odeg,type,
    vEBT_deg: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT_Osummary,type,
    vEBT_summary: vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_OtreeList,type,
    vEBT_treeList: vEBT_VEBT > ( list @ vEBT_VEBT ) ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead,type,
    vEBT_VEBT_elim_dead: vEBT_VEBT > extended_enat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead__rel,type,
    vEBT_V312737461966249ad_rel: ( product_prod @ vEBT_VEBT @ extended_enat ) > ( product_prod @ vEBT_VEBT @ extended_enat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_dega____,type,
    dega: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_summarya____,type,
    summarya: vEBT_VEBT ).

thf(sy_v_treeLista____,type,
    treeLista: list @ vEBT_VEBT ).

% Relevant facts (8182)
thf(fact_0__C3_OIH_C_I2_J,axiom,
    ( ( vEBT_VEBT_elim_dead @ summarya @ ( extend4730790105801354508finity @ extended_enat ) )
    = summarya ) ).

% "3.IH"(2)
thf(fact_1__092_060open_062deg_Adiv_A2_A_061_An_092_060close_062,axiom,
    ( ( divide_divide @ nat @ dega @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = na ) ).

% \<open>deg div 2 = n\<close>
thf(fact_2_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_3__C3_Ohyps_C_I5_J,axiom,
    ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ summarya @ X_1 ) ).

% "3.hyps"(5)
thf(fact_4__C3_Ohyps_C_I1_J,axiom,
    vEBT_invar_vebt @ summarya @ m ).

% "3.hyps"(1)
thf(fact_5__092_060open_062elim__dead_A_INode_ANone_Adeg_AtreeList_Asummary_J_A_092_060infinity_062_A_061_ANode_ANone_Adeg_A_Imap_A_I_092_060lambda_062t_O_Aelim__dead_At_A_Ienat_A_I2_A_094_A_Ideg_Adiv_A2_J_J_J_J_AtreeList_J_A_Ielim__dead_Asummary_A_092_060infinity_062_J_092_060close_062,axiom,
    ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ dega @ treeLista @ summarya ) @ ( extend4730790105801354508finity @ extended_enat ) )
    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ dega
      @ ( map @ vEBT_VEBT @ vEBT_VEBT
        @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ dega @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ treeLista )
      @ ( vEBT_VEBT_elim_dead @ summarya @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% \<open>elim_dead (Node None deg treeList summary) \<infinity> = Node None deg (map (\<lambda>t. elim_dead t (enat (2 ^ (deg div 2)))) treeList) (elim_dead summary \<infinity>)\<close>
thf(fact_6__C3_OIH_C_I1_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeLista ) )
     => ( ( vEBT_invar_vebt @ X @ na )
        & ( ( vEBT_VEBT_elim_dead @ X @ ( extend4730790105801354508finity @ extended_enat ) )
          = X ) ) ) ).

% "3.IH"(1)
thf(fact_7__C3_Ohyps_C_I4_J,axiom,
    ( dega
    = ( plus_plus @ nat @ na @ m ) ) ).

% "3.hyps"(4)
thf(fact_8_not__enat__eq,axiom,
    ! [X2: extended_enat] :
      ( ( ! [Y: nat] :
            ( X2
           != ( extended_enat2 @ Y ) ) )
      = ( X2
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% not_enat_eq
thf(fact_9_not__infinity__eq,axiom,
    ! [X2: extended_enat] :
      ( ( ( X2
         != ( extend4730790105801354508finity @ extended_enat ) ) )
      = ( ? [I: nat] :
            ( X2
            = ( extended_enat2 @ I ) ) ) ) ).

% not_infinity_eq
thf(fact_10__C3_Ohyps_C_I6_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeLista ) )
     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ).

% "3.hyps"(6)
thf(fact_11_VEBT_Osimps_I5_J,axiom,
    ! [A: $tType,F1: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > A,F2: $o > $o > A,X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_case_VEBT @ A @ F1 @ F2 @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( F1 @ X11 @ X12 @ X13 @ X14 ) ) ).

% VEBT.simps(5)
thf(fact_12_VEBT_Osel_I4_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_summary @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = X14 ) ).

% VEBT.sel(4)
thf(fact_13_VEBT_Osel_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_treeList @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = X13 ) ).

% VEBT.sel(3)
thf(fact_14_VEBT_Osel_I2_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_deg @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = X12 ) ).

% VEBT.sel(2)
thf(fact_15_b,axiom,
    ( ( map @ vEBT_VEBT @ vEBT_VEBT
      @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) )
      @ treeLista )
    = treeLista ) ).

% b
thf(fact_16_enat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( extended_enat2 @ Nat )
        = ( extended_enat2 @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% enat.inject
thf(fact_17_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_18__092_060open_062take_A_I2_A_094_Adeg_Adiv_A2_A_094_A_Ideg_Adiv_A2_J_J_A_Imap_A_I_092_060lambda_062t_O_Aelim__dead_At_A_Ienat_A_I2_A_094_An_J_J_J_AtreeList_J_A_061_AtreeList_092_060close_062,axiom,
    ( ( take @ vEBT_VEBT @ ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ dega ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ dega @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
      @ ( map @ vEBT_VEBT @ vEBT_VEBT
        @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) )
        @ treeLista ) )
    = treeLista ) ).

% \<open>take (2 ^ deg div 2 ^ (deg div 2)) (map (\<lambda>t. elim_dead t (enat (2 ^ n))) treeList) = treeList\<close>
thf(fact_19_elimnum,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ N )
     => ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        = ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) ) ) ).

% elimnum
thf(fact_20__092_060open_0622_A_094_Am_A_061_A2_A_094_Adeg_Adiv_A2_A_094_A_Ideg_Adiv_A2_J_092_060close_062,axiom,
    ( ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m )
    = ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ dega ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ dega @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% \<open>2 ^ m = 2 ^ deg div 2 ^ (deg div 2)\<close>
thf(fact_21__C3_Ohyps_C_I3_J,axiom,
    ( m
    = ( suc @ na ) ) ).

% "3.hyps"(3)
thf(fact_22__C3_Ohyps_C_I2_J,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeLista )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "3.hyps"(2)
thf(fact_23_VEBT_Ocase__distrib,axiom,
    ! [A: $tType,B: $tType,H: A > B,F1: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > A,F2: $o > $o > A,VEBT: vEBT_VEBT] :
      ( ( H @ ( vEBT_case_VEBT @ A @ F1 @ F2 @ VEBT ) )
      = ( vEBT_case_VEBT @ B
        @ ^ [X1: option @ ( product_prod @ nat @ nat ),X22: nat,X3: list @ vEBT_VEBT,X4: vEBT_VEBT] : ( H @ ( F1 @ X1 @ X22 @ X3 @ X4 ) )
        @ ^ [X1: $o,X22: $o] : ( H @ ( F2 @ X1 @ X22 ) )
        @ VEBT ) ) ).

% VEBT.case_distrib
thf(fact_24_VEBT__internal_Oelim__dead_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( vEBT_Node @ Info @ Deg
        @ ( map @ vEBT_VEBT @ vEBT_VEBT
          @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          @ TreeList )
        @ ( vEBT_VEBT_elim_dead @ Summary @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% VEBT_internal.elim_dead.simps(2)
thf(fact_25_enat__ex__split,axiom,
    ( ( ^ [P: extended_enat > $o] :
        ? [X5: extended_enat] : ( P @ X5 ) )
    = ( ^ [P2: extended_enat > $o] :
          ( ( P2 @ ( extend4730790105801354508finity @ extended_enat ) )
          | ? [X6: nat] : ( P2 @ ( extended_enat2 @ X6 ) ) ) ) ) ).

% enat_ex_split
thf(fact_26_enat3__cases,axiom,
    ! [Y2: extended_enat,Ya: extended_enat,Yb: extended_enat] :
      ( ( ? [Nat3: nat] :
            ( Y2
            = ( extended_enat2 @ Nat3 ) )
       => ( ? [Nata: nat] :
              ( Ya
              = ( extended_enat2 @ Nata ) )
         => ! [Natb: nat] :
              ( Yb
             != ( extended_enat2 @ Natb ) ) ) )
     => ( ( ? [Nat3: nat] :
              ( Y2
              = ( extended_enat2 @ Nat3 ) )
         => ( ? [Nata: nat] :
                ( Ya
                = ( extended_enat2 @ Nata ) )
           => ( Yb
             != ( extend4730790105801354508finity @ extended_enat ) ) ) )
       => ( ( ? [Nat3: nat] :
                ( Y2
                = ( extended_enat2 @ Nat3 ) )
           => ( ( Ya
                = ( extend4730790105801354508finity @ extended_enat ) )
             => ! [Nata: nat] :
                  ( Yb
                 != ( extended_enat2 @ Nata ) ) ) )
         => ( ( ? [Nat3: nat] :
                  ( Y2
                  = ( extended_enat2 @ Nat3 ) )
             => ( ( Ya
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( Yb
                 != ( extend4730790105801354508finity @ extended_enat ) ) ) )
           => ( ( ( Y2
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( ? [Nat3: nat] :
                      ( Ya
                      = ( extended_enat2 @ Nat3 ) )
                 => ! [Nata: nat] :
                      ( Yb
                     != ( extended_enat2 @ Nata ) ) ) )
             => ( ( ( Y2
                    = ( extend4730790105801354508finity @ extended_enat ) )
                 => ( ? [Nat3: nat] :
                        ( Ya
                        = ( extended_enat2 @ Nat3 ) )
                   => ( Yb
                     != ( extend4730790105801354508finity @ extended_enat ) ) ) )
               => ( ( ( Y2
                      = ( extend4730790105801354508finity @ extended_enat ) )
                   => ( ( Ya
                        = ( extend4730790105801354508finity @ extended_enat ) )
                     => ! [Nat3: nat] :
                          ( Yb
                         != ( extended_enat2 @ Nat3 ) ) ) )
                 => ~ ( ( Y2
                        = ( extend4730790105801354508finity @ extended_enat ) )
                     => ( ( Ya
                          = ( extend4730790105801354508finity @ extended_enat ) )
                       => ( Yb
                         != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) ) ) ) ) ) ) ).

% enat3_cases
thf(fact_27_enat2__cases,axiom,
    ! [Y2: extended_enat,Ya: extended_enat] :
      ( ( ? [Nat3: nat] :
            ( Y2
            = ( extended_enat2 @ Nat3 ) )
       => ! [Nata: nat] :
            ( Ya
           != ( extended_enat2 @ Nata ) ) )
     => ( ( ? [Nat3: nat] :
              ( Y2
              = ( extended_enat2 @ Nat3 ) )
         => ( Ya
           != ( extend4730790105801354508finity @ extended_enat ) ) )
       => ( ( ( Y2
              = ( extend4730790105801354508finity @ extended_enat ) )
           => ! [Nat3: nat] :
                ( Ya
               != ( extended_enat2 @ Nat3 ) ) )
         => ~ ( ( Y2
                = ( extend4730790105801354508finity @ extended_enat ) )
             => ( Ya
               != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) ) ).

% enat2_cases
thf(fact_28_enat_Oexhaust,axiom,
    ! [Y2: extended_enat] :
      ( ! [Nat3: nat] :
          ( Y2
         != ( extended_enat2 @ Nat3 ) )
     => ( Y2
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% enat.exhaust
thf(fact_29_enat_Odistinct_I1_J,axiom,
    ! [Nat: nat] :
      ( ( extended_enat2 @ Nat )
     != ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat.distinct(1)
thf(fact_30_enat_Odistinct_I2_J,axiom,
    ! [Nat4: nat] :
      ( ( extend4730790105801354508finity @ extended_enat )
     != ( extended_enat2 @ Nat4 ) ) ).

% enat.distinct(2)
thf(fact_31_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_32_VEBT__internal_Oelim__dead_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,L: nat] :
      ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ ( extended_enat2 @ L ) )
      = ( vEBT_Node @ Info @ Deg
        @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( map @ vEBT_VEBT @ vEBT_VEBT
            @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ TreeList ) )
        @ ( vEBT_VEBT_elim_dead @ Summary @ ( extended_enat2 @ ( divide_divide @ nat @ L @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.simps(3)
thf(fact_33_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ).

% div_exp_eq
thf(fact_34_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B,G: B > A] :
      ( ( ( map @ B @ A @ F3 @ Xs )
        = ( map @ B @ A @ G @ Xs ) )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ ( set2 @ B @ Xs ) )
           => ( ( F3 @ X6 )
              = ( G @ X6 ) ) ) ) ) ).

% map_eq_conv
thf(fact_35_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_36_semiring__norm_I83_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit0 @ N ) ) ).

% semiring_norm(83)
thf(fact_37_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X2 ) ) ).

% field_sum_of_halves
thf(fact_38_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% numeral_plus_numeral
thf(fact_39_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) ).

% add_numeral_left
thf(fact_40_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X6: nat,N2: nat] : ( divide_divide @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% high_def
thf(fact_41_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit0_div_2
thf(fact_42_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X6: A] : X6 )
      = ( ^ [Xs2: list @ A] : Xs2 ) ) ).

% map_ident
thf(fact_43_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P3: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P3 ) )
      = ( P3 @ A2 ) ) ).

% mem_Collect_eq
thf(fact_44_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( collect @ A
        @ ^ [X6: A] : ( member @ A @ X6 @ A3 ) )
      = A3 ) ).

% Collect_mem_eq
thf(fact_45_Collect__cong,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o] :
      ( ! [X7: A] :
          ( ( P3 @ X7 )
          = ( Q @ X7 ) )
     => ( ( collect @ A @ P3 )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_46_ext,axiom,
    ! [B: $tType,A: $tType,F3: A > B,G: A > B] :
      ( ! [X7: A] :
          ( ( F3 @ X7 )
          = ( G @ X7 ) )
     => ( F3 = G ) ) ).

% ext
thf(fact_47_even__odd__cases,axiom,
    ! [X2: nat] :
      ( ! [N3: nat] :
          ( X2
         != ( plus_plus @ nat @ N3 @ N3 ) )
     => ~ ! [N3: nat] :
            ( X2
           != ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) ) ) ).

% even_odd_cases
thf(fact_48_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) ).

% numeral_eq_iff
thf(fact_49_semiring__norm_I87_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(87)
thf(fact_50_plus__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( plus_plus @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% plus_enat_simps(3)
thf(fact_51_plus__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( plus_plus @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% plus_enat_simps(2)
thf(fact_52_length__map,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F3 @ Xs ) )
      = ( size_size @ ( list @ B ) @ Xs ) ) ).

% length_map
thf(fact_53_plus__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( plus_plus @ nat @ M @ N ) ) ) ).

% plus_enat_simps(1)
thf(fact_54_semiring__norm_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(6)
thf(fact_55_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_56_Suc__numeral,axiom,
    ! [N: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% Suc_numeral
thf(fact_57_add__2__eq__Suc_H,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc'
thf(fact_58_add__2__eq__Suc,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc
thf(fact_59_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_60_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs != Ys ) ) ).

% neq_if_length_neq
thf(fact_61_Ex__list__of__length,axiom,
    ! [A: $tType,N: nat] :
    ? [Xs3: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs3 )
      = N ) ).

% Ex_list_of_length
thf(fact_62_take__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ! [I2: nat] :
          ( ( take @ A @ I2 @ Xs )
          = ( take @ A @ I2 @ Ys ) )
     => ( Xs = Ys ) ) ).

% take_equalityI
thf(fact_63_add__One__commute,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) ).

% add_One_commute
thf(fact_64_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: B > A,Xs: list @ B,G: C > A,Ys: list @ C] :
      ( ( ( map @ B @ A @ F3 @ Xs )
        = ( map @ C @ A @ G @ Ys ) )
     => ( ( size_size @ ( list @ B ) @ Xs )
        = ( size_size @ ( list @ C ) @ Ys ) ) ) ).

% map_eq_imp_length_eq
thf(fact_65_Suc__nat__number__of__add,axiom,
    ! [V: num,N: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N ) ) ).

% Suc_nat_number_of_add
thf(fact_66_enat__add__left__cancel,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ A2 @ B2 )
        = ( plus_plus @ extended_enat @ A2 @ C2 ) )
      = ( ( A2
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( B2 = C2 ) ) ) ).

% enat_add_left_cancel
thf(fact_67_plus__eq__infty__iff__enat,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( M
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( N
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% plus_eq_infty_iff_enat
thf(fact_68_numeral__ne__infinity,axiom,
    ! [K: num] :
      ( ( numeral_numeral @ extended_enat @ K )
     != ( extend4730790105801354508finity @ extended_enat ) ) ).

% numeral_ne_infinity
thf(fact_69_in__set__takeD,axiom,
    ! [A: $tType,X2: A,N: nat,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) )
     => ( member @ A @ X2 @ ( set2 @ A @ Xs ) ) ) ).

% in_set_takeD
thf(fact_70_take__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F3: B > A,Xs: list @ B] :
      ( ( take @ A @ N @ ( map @ B @ A @ F3 @ Xs ) )
      = ( map @ B @ A @ F3 @ ( take @ B @ N @ Xs ) ) ) ).

% take_map
thf(fact_71_numeral__eq__enat,axiom,
    ( ( numeral_numeral @ extended_enat )
    = ( ^ [K2: num] : ( extended_enat2 @ ( numeral_numeral @ nat @ K2 ) ) ) ) ).

% numeral_eq_enat
thf(fact_72_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_73_list_Omap__ident,axiom,
    ! [A: $tType,T3: list @ A] :
      ( ( map @ A @ A
        @ ^ [X6: A] : X6
        @ T3 )
      = T3 ) ).

% list.map_ident
thf(fact_74_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X7: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X7 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 )
               => ( ! [X7: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X7 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_75_ex__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,F3: A > B] :
      ( ( ? [Xs2: list @ A] :
            ( Ys
            = ( map @ A @ B @ F3 @ Xs2 ) ) )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ ( set2 @ B @ Ys ) )
           => ? [Y: A] :
                ( X6
                = ( F3 @ Y ) ) ) ) ) ).

% ex_map_conv
thf(fact_76_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F3: A > B,G: A > B] :
      ( ( Xs = Ys )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ Ys ) )
           => ( ( F3 @ X7 )
              = ( G @ X7 ) ) )
       => ( ( map @ A @ B @ F3 @ Xs )
          = ( map @ A @ B @ G @ Ys ) ) ) ) ).

% map_cong
thf(fact_77_map__idI,axiom,
    ! [A: $tType,Xs: list @ A,F3: A > A] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( ( F3 @ X7 )
            = X7 ) )
     => ( ( map @ A @ A @ F3 @ Xs )
        = Xs ) ) ).

% map_idI
thf(fact_78_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F3: A > B,G: A > B] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( ( F3 @ X7 )
            = ( G @ X7 ) ) )
     => ( ( map @ A @ B @ F3 @ Xs )
        = ( map @ A @ B @ G @ Xs ) ) ) ).

% map_ext
thf(fact_79_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X2: list @ A,Xa: list @ A,F3: A > B,Fa: A > B] :
      ( ! [Z2: A,Za: A] :
          ( ( member @ A @ Z2 @ ( set2 @ A @ X2 ) )
         => ( ( member @ A @ Za @ ( set2 @ A @ Xa ) )
           => ( ( ( F3 @ Z2 )
                = ( Fa @ Za ) )
             => ( Z2 = Za ) ) ) )
     => ( ( ( map @ A @ B @ F3 @ X2 )
          = ( map @ A @ B @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) ).

% list.inj_map_strong
thf(fact_80_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X2: list @ A,F3: A > B,G: A > B] :
      ( ! [Z2: A] :
          ( ( member @ A @ Z2 @ ( set2 @ A @ X2 ) )
         => ( ( F3 @ Z2 )
            = ( G @ Z2 ) ) )
     => ( ( map @ A @ B @ F3 @ X2 )
        = ( map @ A @ B @ G @ X2 ) ) ) ).

% list.map_cong0
thf(fact_81_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X2: list @ A,Ya: list @ A,F3: A > B,G: A > B] :
      ( ( X2 = Ya )
     => ( ! [Z2: A] :
            ( ( member @ A @ Z2 @ ( set2 @ A @ Ya ) )
           => ( ( F3 @ Z2 )
              = ( G @ Z2 ) ) )
       => ( ( map @ A @ B @ F3 @ X2 )
          = ( map @ A @ B @ G @ Ya ) ) ) ) ).

% list.map_cong
thf(fact_82_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_Bit0
thf(fact_83_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_84_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X7: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X7 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 )
               => ( ! [X7: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X7 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_85_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_code(2)
thf(fact_86_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_87_add__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc_right
thf(fact_88_VEBT__internal_Oelim__dead_Oelims,axiom,
    ! [X2: vEBT_VEBT,Xa: extended_enat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_VEBT_elim_dead @ X2 @ Xa )
        = Y2 )
     => ( ! [A4: $o,B3: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A4 @ B3 ) )
           => ( Y2
             != ( vEBT_Leaf @ A4 @ B3 ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Info2 @ Deg2 @ TreeList2 @ Summary2 ) )
             => ( ( Xa
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( Y2
                 != ( vEBT_Node @ Info2 @ Deg2
                    @ ( map @ vEBT_VEBT @ vEBT_VEBT
                      @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      @ TreeList2 )
                    @ ( vEBT_VEBT_elim_dead @ Summary2 @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) )
         => ~ ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Info2 @ Deg2 @ TreeList2 @ Summary2 ) )
               => ! [L2: nat] :
                    ( ( Xa
                      = ( extended_enat2 @ L2 ) )
                   => ( Y2
                     != ( vEBT_Node @ Info2 @ Deg2
                        @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                          @ ( map @ vEBT_VEBT @ vEBT_VEBT
                            @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            @ TreeList2 ) )
                        @ ( vEBT_VEBT_elim_dead @ Summary2 @ ( extended_enat2 @ ( divide_divide @ nat @ L2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.elims
thf(fact_89_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T2: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T2 ) ) ) ) ).

% set_vebt_def
thf(fact_90_a,axiom,
    ! [I3: nat] :
      ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( vEBT_VEBT_elim_dead @ ( nth @ vEBT_VEBT @ treeLista @ I3 ) @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) )
        = ( nth @ vEBT_VEBT @ treeLista @ I3 ) ) ) ).

% a
thf(fact_91_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_92_nat_Oinject,axiom,
    ! [X23: nat,Y22: nat] :
      ( ( ( suc @ X23 )
        = ( suc @ Y22 ) )
      = ( X23 = Y22 ) ) ).

% nat.inject
thf(fact_93_the__enat_Osimps,axiom,
    ! [N: nat] :
      ( ( extended_the_enat @ ( extended_enat2 @ N ) )
      = N ) ).

% the_enat.simps
thf(fact_94_valid__eq2,axiom,
    ! [T3: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T3 @ D2 )
     => ( vEBT_invar_vebt @ T3 @ D2 ) ) ).

% valid_eq2
thf(fact_95_valid__eq1,axiom,
    ! [T3: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T3 @ D2 )
     => ( vEBT_VEBT_valid @ T3 @ D2 ) ) ).

% valid_eq1
thf(fact_96_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_97_inthall,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o,N: nat] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( P3 @ X7 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P3 @ ( nth @ A @ Xs @ N ) ) ) ) ).

% inthall
thf(fact_98_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X222 )
        = ( vEBT_Leaf @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% VEBT.inject(2)
thf(fact_99_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% numeral_less_iff
thf(fact_100_lessI,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( suc @ N ) ) ).

% lessI
thf(fact_101_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% Suc_mono
thf(fact_102_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_eq
thf(fact_103_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% nat_add_left_cancel_less
thf(fact_104_nth__take,axiom,
    ! [A: $tType,I3: nat,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I3 @ N )
     => ( ( nth @ A @ ( take @ A @ N @ Xs ) @ I3 )
        = ( nth @ A @ Xs @ I3 ) ) ) ).

% nth_take
thf(fact_105_nth__map,axiom,
    ! [B: $tType,A: $tType,N: nat,Xs: list @ A,F3: A > B] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ B @ ( map @ A @ B @ F3 @ Xs ) @ N )
        = ( F3 @ ( nth @ A @ Xs @ N ) ) ) ) ).

% nth_map
thf(fact_106_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,N: nat,M: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F3 @ N ) @ ( F3 @ M ) )
            = ( ord_less @ nat @ N @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_107_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N @ N4 )
           => ( ord_less @ A @ ( F3 @ N ) @ ( F3 @ N4 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_108_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M != N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) ).

% nat_neq_iff
thf(fact_109_less__not__refl,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_not_refl
thf(fact_110_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) ).

% less_not_refl2
thf(fact_111_less__not__refl3,axiom,
    ! [S: nat,T3: nat] :
      ( ( ord_less @ nat @ S @ T3 )
     => ( S != T3 ) ) ).

% less_not_refl3
thf(fact_112_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F3: A > B,P3: A > $o,A2: A] :
          ( ! [X7: A] :
              ( ! [Y3: A] :
                  ( ( ord_less @ B @ ( F3 @ Y3 ) @ ( F3 @ X7 ) )
                 => ( P3 @ Y3 ) )
             => ( P3 @ X7 ) )
         => ( P3 @ A2 ) ) ) ).

% measure_induct
thf(fact_113_less__irrefl__nat,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_irrefl_nat
thf(fact_114_nat__less__induct,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
             => ( P3 @ M2 ) )
         => ( P3 @ N3 ) )
     => ( P3 @ N ) ) ).

% nat_less_induct
thf(fact_115_infinite__descent,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P3 @ N3 )
         => ? [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
              & ~ ( P3 @ M2 ) ) )
     => ( P3 @ N ) ) ).

% infinite_descent
thf(fact_116_linorder__neqE__nat,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( X2 != Y2 )
     => ( ~ ( ord_less @ nat @ X2 @ Y2 )
       => ( ord_less @ nat @ Y2 @ X2 ) ) ) ).

% linorder_neqE_nat
thf(fact_117_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F3: A > B,P3: A > $o,A2: A] :
          ( ! [X7: A] :
              ( ! [Y3: A] :
                  ( ( ord_less @ B @ ( F3 @ Y3 ) @ ( F3 @ X7 ) )
                 => ( P3 @ Y3 ) )
             => ( P3 @ X7 ) )
         => ( P3 @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_118_infinite__descent__measure,axiom,
    ! [A: $tType,P3: A > $o,V2: A > nat,X2: A] :
      ( ! [X7: A] :
          ( ~ ( P3 @ X7 )
         => ? [Y3: A] :
              ( ( ord_less @ nat @ ( V2 @ Y3 ) @ ( V2 @ X7 ) )
              & ~ ( P3 @ Y3 ) ) )
     => ( P3 @ X2 ) ) ).

% infinite_descent_measure
thf(fact_119_nth__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I2 )
              = ( nth @ A @ Ys @ I2 ) ) )
       => ( Xs = Ys ) ) ) ).

% nth_equalityI
thf(fact_120_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P3: nat > A > $o] :
      ( ( ! [I: nat] :
            ( ( ord_less @ nat @ I @ K )
           => ? [X8: A] : ( P3 @ I @ X8 ) ) )
      = ( ? [Xs2: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs2 )
              = K )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ K )
               => ( P3 @ I @ ( nth @ A @ Xs2 @ I ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_121_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y4: list @ A,Z3: list @ A] : ( Y4 = Z3 ) )
      = ( ^ [Xs2: list @ A,Ys2: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs2 )
              = ( size_size @ ( list @ A ) @ Ys2 ) )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( nth @ A @ Xs2 @ I )
                  = ( nth @ A @ Ys2 @ I ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_122_Nat_OlessE,axiom,
    ! [I3: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ K )
     => ( ( K
         != ( suc @ I3 ) )
       => ~ ! [J: nat] :
              ( ( ord_less @ nat @ I3 @ J )
             => ( K
               != ( suc @ J ) ) ) ) ) ).

% Nat.lessE
thf(fact_123_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_lessD
thf(fact_124_Suc__lessE,axiom,
    ! [I3: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I3 ) @ K )
     => ~ ! [J: nat] :
            ( ( ord_less @ nat @ I3 @ J )
           => ( K
             != ( suc @ J ) ) ) ) ).

% Suc_lessE
thf(fact_125_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less @ nat @ ( suc @ M ) @ N ) ) ) ).

% Suc_lessI
thf(fact_126_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( M = N ) ) ) ).

% less_SucE
thf(fact_127_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% less_SucI
thf(fact_128_Ex__less__Suc,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( suc @ N ) )
            & ( P3 @ I ) ) )
      = ( ( P3 @ N )
        | ? [I: nat] :
            ( ( ord_less @ nat @ I @ N )
            & ( P3 @ I ) ) ) ) ).

% Ex_less_Suc
thf(fact_129_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( M = N ) ) ) ).

% less_Suc_eq
thf(fact_130_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N ) )
      = ( ord_less @ nat @ N @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_131_All__less__Suc,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ! [I: nat] :
            ( ( ord_less @ nat @ I @ ( suc @ N ) )
           => ( P3 @ I ) ) )
      = ( ( P3 @ N )
        & ! [I: nat] :
            ( ( ord_less @ nat @ I @ N )
           => ( P3 @ I ) ) ) ) ).

% All_less_Suc
thf(fact_132_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N ) @ M )
      = ( ? [M3: nat] :
            ( ( M
              = ( suc @ M3 ) )
            & ( ord_less @ nat @ N @ M3 ) ) ) ) ).

% Suc_less_eq2
thf(fact_133_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) ).

% less_antisym
thf(fact_134_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_SucD
thf(fact_135_less__trans__Suc,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ( ord_less @ nat @ J2 @ K )
       => ( ord_less @ nat @ ( suc @ I3 ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_136_less__Suc__induct,axiom,
    ! [I3: nat,J2: nat,P3: nat > nat > $o] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ! [I2: nat] : ( P3 @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J: nat,K3: nat] :
              ( ( ord_less @ nat @ I2 @ J )
             => ( ( ord_less @ nat @ J @ K3 )
               => ( ( P3 @ I2 @ J )
                 => ( ( P3 @ J @ K3 )
                   => ( P3 @ I2 @ K3 ) ) ) ) )
         => ( P3 @ I3 @ J2 ) ) ) ) ).

% less_Suc_induct
thf(fact_137_strict__inc__induct,axiom,
    ! [I3: nat,J2: nat,P3: nat > $o] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ! [I2: nat] :
            ( ( J2
              = ( suc @ I2 ) )
           => ( P3 @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( ( P3 @ ( suc @ I2 ) )
               => ( P3 @ I2 ) ) )
         => ( P3 @ I3 ) ) ) ) ).

% strict_inc_induct
thf(fact_138_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_139_add__lessD1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ K )
     => ( ord_less @ nat @ I3 @ K ) ) ).

% add_lessD1
thf(fact_140_add__less__mono,axiom,
    ! [I3: nat,J2: nat,K: nat,L: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ( ord_less @ nat @ K @ L )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( plus_plus @ nat @ J2 @ L ) ) ) ) ).

% add_less_mono
thf(fact_141_not__add__less1,axiom,
    ! [I3: nat,J2: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ I3 ) ).

% not_add_less1
thf(fact_142_not__add__less2,axiom,
    ! [J2: nat,I3: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J2 @ I3 ) @ I3 ) ).

% not_add_less2
thf(fact_143_add__less__mono1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( plus_plus @ nat @ J2 @ K ) ) ) ).

% add_less_mono1
thf(fact_144_trans__less__add1,axiom,
    ! [I3: nat,J2: nat,M: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ord_less @ nat @ I3 @ ( plus_plus @ nat @ J2 @ M ) ) ) ).

% trans_less_add1
thf(fact_145_trans__less__add2,axiom,
    ! [I3: nat,J2: nat,M: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ord_less @ nat @ I3 @ ( plus_plus @ nat @ M @ J2 ) ) ) ).

% trans_less_add2
thf(fact_146_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ K @ L )
     => ( ( ( plus_plus @ nat @ M @ L )
          = ( plus_plus @ nat @ K @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% less_add_eq_less
thf(fact_147_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
           => ( P3 @ X6 ) ) )
      = ( ! [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P3 @ ( nth @ A @ Xs @ I ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_148_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o,X2: A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P3 @ ( nth @ A @ Xs @ I2 ) ) )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( P3 @ X2 ) ) ) ).

% all_nth_imp_all_set
thf(fact_149_in__set__conv__nth,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ I )
              = X2 ) ) ) ) ).

% in_set_conv_nth
thf(fact_150_list__ball__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P3: A > $o] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
           => ( P3 @ X7 ) )
       => ( P3 @ ( nth @ A @ Xs @ N ) ) ) ) ).

% list_ball_nth
thf(fact_151_nth__mem,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ ( nth @ A @ Xs @ N ) @ ( set2 @ A @ Xs ) ) ) ).

% nth_mem
thf(fact_152_VEBT_Oexhaust,axiom,
    ! [Y2: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y2
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X212: $o,X223: $o] :
            ( Y2
           != ( vEBT_Leaf @ X212 @ X223 ) ) ) ).

% VEBT.exhaust
thf(fact_153_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X222: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X21 @ X222 ) ) ).

% VEBT.distinct(1)
thf(fact_154_length__induct,axiom,
    ! [A: $tType,P3: ( list @ A ) > $o,Xs: list @ A] :
      ( ! [Xs3: list @ A] :
          ( ! [Ys3: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys3 ) @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P3 @ Ys3 ) )
         => ( P3 @ Xs3 ) )
     => ( P3 @ Xs ) ) ).

% length_induct
thf(fact_155_VEBT__internal_Oelim__dead_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,Uu: extended_enat] :
      ( ( vEBT_VEBT_elim_dead @ ( vEBT_Leaf @ A2 @ B2 ) @ Uu )
      = ( vEBT_Leaf @ A2 @ B2 ) ) ).

% VEBT_internal.elim_dead.simps(1)
thf(fact_156_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ? [K3: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M @ K3 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_157_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M4: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M4 @ K2 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_158_less__add__Suc2,axiom,
    ! [I3: nat,M: nat] : ( ord_less @ nat @ I3 @ ( suc @ ( plus_plus @ nat @ M @ I3 ) ) ) ).

% less_add_Suc2
thf(fact_159_less__add__Suc1,axiom,
    ! [I3: nat,M: nat] : ( ord_less @ nat @ I3 @ ( suc @ ( plus_plus @ nat @ I3 @ M ) ) ) ).

% less_add_Suc1
thf(fact_160_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ~ ! [Q3: nat] :
            ( N
           != ( suc @ ( plus_plus @ nat @ M @ Q3 ) ) ) ) ).

% less_natE
thf(fact_161_VEBT_Osimps_I6_J,axiom,
    ! [A: $tType,F1: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > A,F2: $o > $o > A,X21: $o,X222: $o] :
      ( ( vEBT_case_VEBT @ A @ F1 @ F2 @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( F2 @ X21 @ X222 ) ) ).

% VEBT.simps(6)
thf(fact_162_Suc__inject,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y2 ) )
     => ( X2 = Y2 ) ) ).

% Suc_inject
thf(fact_163_n__not__Suc__n,axiom,
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) ).

% n_not_Suc_n
thf(fact_164_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( size_size @ A @ X2 )
           != ( size_size @ A @ Y2 ) )
         => ( X2 != Y2 ) ) ) ).

% size_neq_size_imp_neq
thf(fact_165_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less @ A @ X2 @ ( divide_divide @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_166_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A3 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_167_add__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc
thf(fact_168_add__Suc__shift,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ M @ ( suc @ N ) ) ) ).

% add_Suc_shift
thf(fact_169_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ N )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ X2 ) ) ) ) ).

% both_member_options_ding
thf(fact_170_high__inv,axiom,
    ! [X2: nat,N: nat,Y2: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X2 ) @ N )
        = Y2 ) ) ).

% high_inv
thf(fact_171_less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% less_exp
thf(fact_172_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_173_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_174_verit__eq__simplify_I8_J,axiom,
    ! [X23: num,Y22: num] :
      ( ( ( bit0 @ X23 )
        = ( bit0 @ Y22 ) )
      = ( X23 = Y22 ) ) ).

% verit_eq_simplify(8)
thf(fact_175_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_176_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_177_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_178_plus__enat__def,axiom,
    ( ( plus_plus @ extended_enat )
    = ( ^ [M4: extended_enat,N2: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [O: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [P4: nat] : ( extended_enat2 @ ( plus_plus @ nat @ O @ P4 ) )
              @ ( extend4730790105801354508finity @ extended_enat )
              @ N2 )
          @ ( extend4730790105801354508finity @ extended_enat )
          @ M4 ) ) ) ).

% plus_enat_def
thf(fact_179_length__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_subseqs
thf(fact_180_deg__not__0,axiom,
    ! [T3: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T3 @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% deg_not_0
thf(fact_181_enat__ord__simps_I6_J,axiom,
    ! [Q2: extended_enat] :
      ~ ( ord_less @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 ) ).

% enat_ord_simps(6)
thf(fact_182_enat__ord__simps_I4_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_less @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( Q2
         != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% enat_ord_simps(4)
thf(fact_183_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_184_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_185_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X2 @ Y2 ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_186_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ X2 @ Y2 )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_187_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_188_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_189_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_190_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_191_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_192_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_193_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_194_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_195_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_196_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_197_low__inv,axiom,
    ! [X2: nat,N: nat,Y2: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X2 ) @ N )
        = X2 ) ) ).

% low_inv
thf(fact_198_less__nat__zero__code,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_199_neq0__conv,axiom,
    ! [N: nat] :
      ( ( ( N
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% neq0_conv
thf(fact_200_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_201_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_202_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_203_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_204_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_205_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_206_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N @ K ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_207_enat__ord__simps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% enat_ord_simps(2)
thf(fact_208_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(78)
thf(fact_209_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_210_enat_Osimps_I4_J,axiom,
    ! [T: $tType,F1: nat > T,F2: T,Nat: nat] :
      ( ( extended_case_enat @ T @ F1 @ F2 @ ( extended_enat2 @ Nat ) )
      = ( F1 @ Nat ) ) ).

% enat.simps(4)
thf(fact_211_enat_Osimps_I5_J,axiom,
    ! [T: $tType,F1: nat > T,F2: T] :
      ( ( extended_case_enat @ T @ F1 @ F2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = F2 ) ).

% enat.simps(5)
thf(fact_212_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_213_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_214_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_215_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_216_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_217_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_218_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_219_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_220_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_221_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_222_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_223_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_224_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_225_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_226_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_227_less__Suc0,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_228_zero__less__Suc,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) ).

% zero_less_Suc
thf(fact_229_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% add_gr_0
thf(fact_230_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_231_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_232_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% nat_0_less_mult_iff
thf(fact_233_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% mult_less_cancel2
thf(fact_234_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_235_mult__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc_right
thf(fact_236_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_237_power__Suc__0,axiom,
    ! [N: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_238_nat__power__eq__Suc__0__iff,axiom,
    ! [X2: nat,M: nat] :
      ( ( ( power_power @ nat @ X2 @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_239_div__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_240_nat__zero__less__power__iff,axiom,
    ! [X2: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X2 @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X2 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_241_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( divide_divide @ nat @ M @ N ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_242_semiring__norm_I76_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit0 @ N ) ) ).

% semiring_norm(76)
thf(fact_243_enat__ord__number_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(2)
thf(fact_244_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_245_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_246_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_247_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_248_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_249_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_250_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_251_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_252_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% power_eq_0_iff
thf(fact_253_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N @ M ) @ N )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_254_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N ) @ N )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_255_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_256_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_257_numeral__less__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ).

% numeral_less_enat_iff
thf(fact_258_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_259_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_260_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_261_option_Osize__neq,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( size_size @ ( option @ A ) @ X2 )
     != ( zero_zero @ nat ) ) ).

% option.size_neq
thf(fact_262_mult__0,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_263_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X2: A] :
          ( ( ( zero_zero @ A )
            = X2 )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_264_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_265_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ B4 @ A5 ) ) ) ) ).

% mult.commute
thf(fact_266_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_267_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_268_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_269_subseqs__refl,axiom,
    ! [A: $tType,Xs: list @ A] : ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs_refl
thf(fact_270_mult__less__mono2,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I3 ) @ ( times_times @ nat @ K @ J2 ) ) ) ) ).

% mult_less_mono2
thf(fact_271_mult__less__mono1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I3 @ K ) @ ( times_times @ nat @ J2 @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_272_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N ) )
        = ( M = N ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_273_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel1
thf(fact_274_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A,Y2: A,N: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( times_times @ A @ ( power_power @ A @ X2 @ N ) @ Y2 )
            = ( times_times @ A @ Y2 @ ( power_power @ A @ X2 @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_275_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_276_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_commutes
thf(fact_277_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N ) ) ) ).

% power_mult
thf(fact_278_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_279_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ M @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_280_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_281_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_282_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_283_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_284_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_285_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_286_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_287_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) )
          = ( ( X2
             != ( zero_zero @ A ) )
            | ( Y2
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_288_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_289_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_290_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_291_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_292_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_293_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) ) ) ) ).

% one_less_mult
thf(fact_294_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ) ).

% n_less_m_mult_n
thf(fact_295_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ N @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_296_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q2 ) @ N )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N @ Q2 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_297_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( divide_divide @ nat @ M @ N ) ) ) ).

% nat_mult_div_cancel1
thf(fact_298_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( M = N ) ) ).

% Suc_mult_cancel1
thf(fact_299_left__add__mult__distrib,axiom,
    ! [I3: nat,U: nat,J2: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_300_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% add_mult_distrib2
thf(fact_301_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% add_mult_distrib
thf(fact_302_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_303_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
                & ( ord_less @ A @ E @ D1 )
                & ( ord_less @ A @ E @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_304_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) ).

% zero_neq_numeral
thf(fact_305_div__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( divide_divide @ nat @ M @ ( times_times @ nat @ N @ Q2 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M @ N ) @ Q2 ) ) ).

% div_mult2_eq
thf(fact_306_vebt__buildup_Ocases,axiom,
    ! [X2: nat] :
      ( ( X2
       != ( zero_zero @ nat ) )
     => ( ( X2
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va: nat] :
              ( X2
             != ( suc @ ( suc @ Va ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_307_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M5: nat] :
          ( N
          = ( suc @ M5 ) ) ) ).

% not0_implies_Suc
thf(fact_308_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_309_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_310_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_311_zero__induct,axiom,
    ! [P3: nat > $o,K: nat] :
      ( ( P3 @ K )
     => ( ! [N3: nat] :
            ( ( P3 @ ( suc @ N3 ) )
           => ( P3 @ N3 ) )
       => ( P3 @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_312_diff__induct,axiom,
    ! [P3: nat > nat > $o,M: nat,N: nat] :
      ( ! [X7: nat] : ( P3 @ X7 @ ( zero_zero @ nat ) )
     => ( ! [Y5: nat] : ( P3 @ ( zero_zero @ nat ) @ ( suc @ Y5 ) )
       => ( ! [X7: nat,Y5: nat] :
              ( ( P3 @ X7 @ Y5 )
             => ( P3 @ ( suc @ X7 ) @ ( suc @ Y5 ) ) )
         => ( P3 @ M @ N ) ) ) ) ).

% diff_induct
thf(fact_313_nat__induct,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ( P3 @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P3 @ N3 )
           => ( P3 @ ( suc @ N3 ) ) )
       => ( P3 @ N ) ) ) ).

% nat_induct
thf(fact_314_old_Onat_Oexhaust,axiom,
    ! [Y2: nat] :
      ( ( Y2
       != ( zero_zero @ nat ) )
     => ~ ! [Nat3: nat] :
            ( Y2
           != ( suc @ Nat3 ) ) ) ).

% old.nat.exhaust
thf(fact_315_nat_OdiscI,axiom,
    ! [Nat: nat,X23: nat] :
      ( ( Nat
        = ( suc @ X23 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_316_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_317_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat5: nat] :
      ( ( suc @ Nat5 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_318_nat_Odistinct_I1_J,axiom,
    ! [X23: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X23 ) ) ).

% nat.distinct(1)
thf(fact_319_enat__iless,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K3: nat] :
          ( N
          = ( extended_enat2 @ K3 ) ) ) ).

% enat_iless
thf(fact_320_chain__incr,axiom,
    ! [A: $tType,Y6: A > extended_enat,K: nat] :
      ( ! [I2: A] :
        ? [J3: A] : ( ord_less @ extended_enat @ ( Y6 @ I2 ) @ ( Y6 @ J3 ) )
     => ? [J: A] : ( ord_less @ extended_enat @ ( extended_enat2 @ K ) @ ( Y6 @ J ) ) ) ).

% chain_incr
thf(fact_321_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: A > nat,P3: A > $o,X2: A] :
      ( ! [X7: A] :
          ( ( ( V2 @ X7 )
            = ( zero_zero @ nat ) )
         => ( P3 @ X7 ) )
     => ( ! [X7: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V2 @ X7 ) )
           => ( ~ ( P3 @ X7 )
             => ? [Y3: A] :
                  ( ( ord_less @ nat @ ( V2 @ Y3 ) @ ( V2 @ X7 ) )
                  & ~ ( P3 @ Y3 ) ) ) )
       => ( P3 @ X2 ) ) ) ).

% infinite_descent0_measure
thf(fact_322_infinite__descent0,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ( P3 @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P3 @ N3 )
             => ? [M2: nat] :
                  ( ( ord_less @ nat @ M2 @ N3 )
                  & ~ ( P3 @ M2 ) ) ) )
       => ( P3 @ N ) ) ) ).

% infinite_descent0
thf(fact_323_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( N
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_324_less__zeroE,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_325_not__less0,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_326_not__gr0,axiom,
    ! [N: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_327_gr0I,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% gr0I
thf(fact_328_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_329_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_330_plus__nat_Oadd__0,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% plus_nat.add_0
thf(fact_331_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_Suc
thf(fact_332_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_333_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_add
thf(fact_334_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_335_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C3 ) )
               => ( C3
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_336_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_337_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_338_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_less_power
thf(fact_339_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_340_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_341_nat__power__less__imp__less,axiom,
    ! [I3: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I3 )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I3 @ M ) @ ( power_power @ nat @ I3 @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% nat_power_less_imp_less
thf(fact_342_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_343_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_344_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) ) ) ) ).

% dividend_less_div_times
thf(fact_345_split__div,axiom,
    ! [P3: nat > $o,M: nat,N: nat] :
      ( ( P3 @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P3 @ ( zero_zero @ nat ) ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I: nat,J4: nat] :
              ( ( ord_less @ nat @ J4 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I ) @ J4 ) )
               => ( P3 @ I ) ) ) ) ) ) ).

% split_div
thf(fact_346_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_347_num_Osize_I5_J,axiom,
    ! [X23: num] :
      ( ( size_size @ num @ ( bit0 @ X23 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X23 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_348_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_349_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_350_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_mult_less_cancel1
thf(fact_351_mult__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc
thf(fact_352_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_less_numeral
thf(fact_353_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_354_less__mult__imp__div__less,axiom,
    ! [M: nat,I3: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I3 @ N ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ I3 ) ) ).

% less_mult_imp_div_less
thf(fact_355_less__enatE,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ~ ! [K3: nat] :
            ( ( N
              = ( extended_enat2 @ K3 ) )
           => ~ ( ord_less @ nat @ K3 @ M ) ) ) ).

% less_enatE
thf(fact_356_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N @ K ) ) ) ).

% power_gt_expt
thf(fact_357_Ex__less__Suc2,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( suc @ N ) )
            & ( P3 @ I ) ) )
      = ( ( P3 @ ( zero_zero @ nat ) )
        | ? [I: nat] :
            ( ( ord_less @ nat @ I @ N )
            & ( P3 @ ( suc @ I ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_358_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
      = ( ? [M4: nat] :
            ( N
            = ( suc @ M4 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_359_All__less__Suc2,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ! [I: nat] :
            ( ( ord_less @ nat @ I @ ( suc @ N ) )
           => ( P3 @ I ) ) )
      = ( ( P3 @ ( zero_zero @ nat ) )
        & ! [I: nat] :
            ( ( ord_less @ nat @ I @ N )
           => ( P3 @ ( suc @ I ) ) ) ) ) ).

% All_less_Suc2
thf(fact_360_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ? [M5: nat] :
          ( N
          = ( suc @ M5 ) ) ) ).

% gr0_implies_Suc
thf(fact_361_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J4: nat] :
            ( ( M
              = ( suc @ J4 ) )
            & ( ord_less @ nat @ J4 @ N ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_362_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_363_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_364_less__imp__add__positive,axiom,
    ! [I3: nat,J2: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ? [K3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K3 )
          & ( ( plus_plus @ nat @ I3 @ K3 )
            = J2 ) ) ) ).

% less_imp_add_positive
thf(fact_365_enat__ord__code_I4_J,axiom,
    ! [M: nat] : ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_code(4)
thf(fact_366_less__infinityE,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ N @ ( extend4730790105801354508finity @ extended_enat ) )
     => ~ ! [K3: nat] :
            ( N
           != ( extended_enat2 @ K3 ) ) ) ).

% less_infinityE
thf(fact_367_infinity__ilessE,axiom,
    ! [M: nat] :
      ~ ( ord_less @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ M ) ) ).

% infinity_ilessE
thf(fact_368_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_369_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_370_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_371_enat__add__left__cancel__less,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( plus_plus @ extended_enat @ A2 @ B2 ) @ ( plus_plus @ extended_enat @ A2 @ C2 ) )
      = ( ( A2
         != ( extend4730790105801354508finity @ extended_enat ) )
        & ( ord_less @ extended_enat @ B2 @ C2 ) ) ) ).

% enat_add_left_cancel_less
thf(fact_372_nat__bit__induct,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ( P3 @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P3 @ N3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( P3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
       => ( ! [N3: nat] :
              ( ( P3 @ N3 )
             => ( P3 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
         => ( P3 @ N ) ) ) ) ).

% nat_bit_induct
thf(fact_373_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_374_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A] :
          ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X2 @ X2 ) @ X2 ) @ X2 ) ) ) ).

% power4_eq_xxxx
thf(fact_375_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_376_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_377_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X2: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X2 @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_378_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_379_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_380_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_381_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_382_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ B4 @ A5 ) ) ) ) ).

% add.commute
thf(fact_383_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_384_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_385_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_386_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B5: A,K: A,B2: A,A2: A] :
          ( ( B5
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B5 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_387_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_388_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I3 @ K )
            = ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_389_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_390_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_391_length__pos__if__in__set,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_pos_if_in_set
thf(fact_392_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_393_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_394_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_395_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2_right
thf(fact_396_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2
thf(fact_397_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) ) ) ) ).

% power2_sum
thf(fact_398_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_399_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X2
             != ( zero_zero @ A ) )
            | ( Y2
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_400_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_401_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_402_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_403_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_404_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_405_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_406_less__2__cases,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_407_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_408_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_409_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_410_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_411_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_412_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_413_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_414_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J2 )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_415_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_416_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_417_verit__eq__simplify_I10_J,axiom,
    ! [X23: num] :
      ( one2
     != ( bit0 @ X23 ) ) ).

% verit_eq_simplify(10)
thf(fact_418_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_divide
thf(fact_419_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X2: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_420_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N2: nat,TreeList3: list @ vEBT_VEBT,X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ X6 @ N2 ) ) @ ( vEBT_VEBT_low @ X6 @ N2 ) ) ) ) ).

% in_children_def
thf(fact_421_buildup__gives__valid,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N ) @ N ) ) ).

% buildup_gives_valid
thf(fact_422_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_423_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_424_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_425_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_426_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_427_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_428_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_429_double__not__eq__Suc__double,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% double_not_eq_Suc_double
thf(fact_430_Suc__double__not__eq__double,axiom,
    ! [M: nat,N: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_double_not_eq_double
thf(fact_431_times__enat__simps_I2_J,axiom,
    ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extend4730790105801354508finity @ extended_enat ) )
    = ( extend4730790105801354508finity @ extended_enat ) ) ).

% times_enat_simps(2)
thf(fact_432_i0__less,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( ( N
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_433_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_434_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_435_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_436_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_437_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_438_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_439_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_440_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_441_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_442_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_443_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_444_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_445_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_446_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_447_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_448_times__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( times_times @ nat @ M @ N ) ) ) ).

% times_enat_simps(1)
thf(fact_449_semiring__norm_I13_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ).

% semiring_norm(13)
thf(fact_450_semiring__norm_I12_J,axiom,
    ! [N: num] :
      ( ( times_times @ num @ one2 @ N )
      = N ) ).

% semiring_norm(12)
thf(fact_451_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_452_num__double,axiom,
    ! [N: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N )
      = ( bit0 @ N ) ) ).

% num_double
thf(fact_453_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_mult_numeral
thf(fact_454_times__enat__simps_I4_J,axiom,
    ! [M: nat] :
      ( ( ( M
          = ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) )
          = ( zero_zero @ extended_enat ) ) )
      & ( ( M
         != ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) )
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% times_enat_simps(4)
thf(fact_455_times__enat__simps_I3_J,axiom,
    ! [N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) )
          = ( zero_zero @ extended_enat ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) )
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% times_enat_simps(3)
thf(fact_456_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_457_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ) ) ).

% enat_0_less_mult_iff
thf(fact_458_enat__less__induct,axiom,
    ! [P3: extended_enat > $o,N: extended_enat] :
      ( ! [N3: extended_enat] :
          ( ! [M2: extended_enat] :
              ( ( ord_less @ extended_enat @ M2 @ N3 )
             => ( P3 @ M2 ) )
         => ( P3 @ N3 ) )
     => ( P3 @ N ) ) ).

% enat_less_induct
thf(fact_459_not__iless0,axiom,
    ! [N: extended_enat] :
      ~ ( ord_less @ extended_enat @ N @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_460_imult__is__infinity,axiom,
    ! [A2: extended_enat,B2: extended_enat] :
      ( ( ( times_times @ extended_enat @ A2 @ B2 )
        = ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( ( A2
            = ( extend4730790105801354508finity @ extended_enat ) )
          & ( B2
           != ( zero_zero @ extended_enat ) ) )
        | ( ( B2
            = ( extend4730790105801354508finity @ extended_enat ) )
          & ( A2
           != ( zero_zero @ extended_enat ) ) ) ) ) ).

% imult_is_infinity
thf(fact_461_imult__infinity,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
     => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ N )
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% imult_infinity
thf(fact_462_imult__infinity__right,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
     => ( ( times_times @ extended_enat @ N @ ( extend4730790105801354508finity @ extended_enat ) )
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% imult_infinity_right
thf(fact_463_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_464_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_465_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_466_infinity__ne__i0,axiom,
    ( extend4730790105801354508finity @ extended_enat )
 != ( zero_zero @ extended_enat ) ).

% infinity_ne_i0
thf(fact_467_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_468_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_469_enat__0__iff_I2_J,axiom,
    ! [X2: nat] :
      ( ( ( zero_zero @ extended_enat )
        = ( extended_enat2 @ X2 ) )
      = ( X2
        = ( zero_zero @ nat ) ) ) ).

% enat_0_iff(2)
thf(fact_470_enat__0__iff_I1_J,axiom,
    ! [X2: nat] :
      ( ( ( extended_enat2 @ X2 )
        = ( zero_zero @ extended_enat ) )
      = ( X2
        = ( zero_zero @ nat ) ) ) ).

% enat_0_iff(1)
thf(fact_471_zero__enat__def,axiom,
    ( ( zero_zero @ extended_enat )
    = ( extended_enat2 @ ( zero_zero @ nat ) ) ) ).

% zero_enat_def
thf(fact_472_less__enat__def,axiom,
    ( ( ord_less @ extended_enat )
    = ( ^ [M4: extended_enat,N2: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [M1: nat] : ( extended_case_enat @ $o @ ( ord_less @ nat @ M1 ) @ $true @ N2 )
          @ $false
          @ M4 ) ) ) ).

% less_enat_def
thf(fact_473_times__enat__def,axiom,
    ( ( times_times @ extended_enat )
    = ( ^ [M4: extended_enat,N2: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [O: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [P4: nat] : ( extended_enat2 @ ( times_times @ nat @ O @ P4 ) )
              @ ( if @ extended_enat
                @ ( O
                  = ( zero_zero @ nat ) )
                @ ( zero_zero @ extended_enat )
                @ ( extend4730790105801354508finity @ extended_enat ) )
              @ N2 )
          @ ( if @ extended_enat
            @ ( N2
              = ( zero_zero @ extended_enat ) )
            @ ( zero_zero @ extended_enat )
            @ ( extend4730790105801354508finity @ extended_enat ) )
          @ M4 ) ) ) ).

% times_enat_def
thf(fact_474_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_475_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
        ? [Y5: A] : ( ord_less @ A @ Y5 @ X ) ) ).

% linordered_field_no_lb
thf(fact_476_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
        ? [X_12: A] : ( ord_less @ A @ X @ X_12 ) ) ).

% linordered_field_no_ub
thf(fact_477_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ~ ( ord_less @ A @ X2 @ Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_478_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_479_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_480_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_481_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_482_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_483_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_484_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_485_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_486_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_487_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_488_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_489_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,E2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_490_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,Z: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_491_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,Z: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X2 @ W ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ).

% divide_divide_times_eq
thf(fact_492_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_493_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_494_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H2: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_495_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_496_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_497_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_498_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_499_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_500_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_501_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_502_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_503_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_504_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_505_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_506_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_507_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_508_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_509_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_510_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_511_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_512_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_513_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_514_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y2 @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_515_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_neg_neg
thf(fact_516_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_517_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_518_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_pos_pos
thf(fact_519_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_520_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_521_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_522_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_523_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_524_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X2 @ Y2 )
                = ( divide_divide @ A @ W @ Z ) )
              = ( ( times_times @ A @ X2 @ Z )
                = ( times_times @ A @ W @ Y2 ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_525_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_526_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_527_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_528_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_529_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_530_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_531_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_532_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_533_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_534_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_535_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_536_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_537_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_538_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_539_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less @ A @ ( times_times @ A @ Z @ Y2 ) @ X2 )
           => ( ord_less @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_540_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_541_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_542_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_543_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_544_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_545_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) ) @ Y2 ) ) ) ) ).

% add_frac_num
thf(fact_546_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) ) @ Y2 ) ) ) ) ).

% add_num_frac
thf(fact_547_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X2 @ ( divide_divide @ A @ Y2 @ Z ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ Z ) @ Y2 ) @ Z ) ) ) ) ).

% add_divide_eq_iff
thf(fact_548_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Z ) @ Y2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% divide_add_eq_iff
thf(fact_549_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_550_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V: nat,TreeList: list @ vEBT_VEBT,S: vEBT_VEBT,X2: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V ) @ TreeList @ S ) @ X2 )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_551_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_552_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList: list @ vEBT_VEBT,Vd: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V ) @ TreeList @ Vd ) @ X2 )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_553_buildup__nothing__in__leaf,axiom,
    ! [N: nat,X2: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N ) @ X2 ) ).

% buildup_nothing_in_leaf
thf(fact_554_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_555_length__mul__elem,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ! [X7: list @ A] :
          ( ( member @ ( list @ A ) @ X7 @ ( set2 @ ( list @ A ) @ Xs ) )
         => ( ( size_size @ ( list @ A ) @ X7 )
            = N ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) @ N ) ) ) ).

% length_mul_elem
thf(fact_556_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X6: nat,N2: nat] : ( modulo_modulo @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% low_def
thf(fact_557_four__x__squared,axiom,
    ! [X2: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_558_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_559_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ Z ) )
            = ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% mult_less_iff1
thf(fact_560_buildup__nothing__in__min__max,axiom,
    ! [N: nat,X2: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N ) @ X2 ) ).

% buildup_nothing_in_min_max
thf(fact_561_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T2: vEBT_VEBT,X6: nat] :
          ( ( vEBT_V5719532721284313246member @ T2 @ X6 )
          | ( vEBT_VEBT_membermima @ T2 @ X6 ) ) ) ) ).

% both_member_options_def
thf(fact_562_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mod_trivial
thf(fact_563_not__real__square__gt__zero,axiom,
    ! [X2: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X2 @ X2 ) ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_564_real__divide__square__eq,axiom,
    ! [R: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ R ) )
      = ( divide_divide @ real @ A2 @ R ) ) ).

% real_divide_square_eq
thf(fact_565_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_566_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_567_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_568_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_569_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_570_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_571_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_572_mod__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = M ) ) ).

% mod_less
thf(fact_573_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_574_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_575_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_576_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_577_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_578_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_579_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_580_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_581_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_582_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ K @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self1
thf(fact_583_Suc__mod__mult__self2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ N @ K ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self2
thf(fact_584_Suc__mod__mult__self3,axiom,
    ! [K: nat,N: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self3
thf(fact_585_Suc__mod__mult__self4,axiom,
    ! [N: nat,K: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N @ K ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self4
thf(fact_586_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_587_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_588_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_589_plus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) ).

% plus_int_code(2)
thf(fact_590_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_591_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_592_zmult__zless__mono2,axiom,
    ! [I3: int,J2: int,K: int] :
      ( ( ord_less @ int @ I3 @ J2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I3 ) @ ( times_times @ int @ K @ J2 ) ) ) ) ).

% zmult_zless_mono2
thf(fact_593_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_594_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_595_times__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_596_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_597_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_598_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_599_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_600_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_601_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_602_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_603_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_604_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_605_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_606_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N ) @ B2 ) ) ) ).

% power_mod
thf(fact_607_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ N ) ) ).

% mod_Suc_Suc_eq
thf(fact_608_mod__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% mod_Suc_eq
thf(fact_609_map__concat,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ ( list @ B )] :
      ( ( map @ B @ A @ F3 @ ( concat @ B @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F3 ) @ Xs ) ) ) ).

% map_concat
thf(fact_610_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_611_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_612_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_613_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_614_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_615_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D3: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ D3 ) ) ) ) ) ).

% mod_eqE
thf(fact_616_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_617_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
          = N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
         != N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ).

% mod_Suc
thf(fact_618_mod__induct,axiom,
    ! [P3: nat > $o,N: nat,P5: nat,M: nat] :
      ( ( P3 @ N )
     => ( ( ord_less @ nat @ N @ P5 )
       => ( ( ord_less @ nat @ M @ P5 )
         => ( ! [N3: nat] :
                ( ( ord_less @ nat @ N3 @ P5 )
               => ( ( P3 @ N3 )
                 => ( P3 @ ( modulo_modulo @ nat @ ( suc @ N3 ) @ P5 ) ) ) )
           => ( P3 @ M ) ) ) ) ) ).

% mod_induct
thf(fact_619_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_less_divisor
thf(fact_620_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q3: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q3 ) ) ) ).

% mod_eq_0D
thf(fact_621_nat__mod__eq__iff,axiom,
    ! [X2: nat,N: nat,Y2: nat] :
      ( ( ( modulo_modulo @ nat @ X2 @ N )
        = ( modulo_modulo @ nat @ Y2 @ N ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X2 @ ( times_times @ nat @ N @ Q1 ) )
            = ( plus_plus @ nat @ Y2 @ ( times_times @ nat @ N @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_622_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_623_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_624_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_625_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_626_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_627_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% mult_div_mod_eq
thf(fact_628_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = A2 ) ) ).

% mod_mult_div_eq
thf(fact_629_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = A2 ) ) ).

% mod_div_mult_eq
thf(fact_630_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% div_mult_mod_eq
thf(fact_631_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( A2
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_632_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_633_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_634_div__less__mono,axiom,
    ! [A3: nat,B5: nat,N: nat] :
      ( ( ord_less @ nat @ A3 @ B5 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( modulo_modulo @ nat @ A3 @ N )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B5 @ N )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A3 @ N ) @ ( divide_divide @ nat @ B5 @ N ) ) ) ) ) ) ).

% div_less_mono
thf(fact_635_div__mod__decomp,axiom,
    ! [A3: nat,N: nat] :
      ( A3
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A3 @ N ) @ N ) @ ( modulo_modulo @ nat @ A3 @ N ) ) ) ).

% div_mod_decomp
thf(fact_636_mod__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( times_times @ nat @ N @ Q2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M @ N ) @ Q2 ) ) @ ( modulo_modulo @ nat @ M @ N ) ) ) ).

% mod_mult2_eq
thf(fact_637_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_638_realpow__pos__nth2,axiom,
    ! [A2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R2: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
          & ( ( power_power @ real @ R2 @ ( suc @ N ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_639_split__mod,axiom,
    ! [P3: nat > $o,M: nat,N: nat] :
      ( ( P3 @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P3 @ M ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I: nat,J4: nat] :
              ( ( ord_less @ nat @ J4 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I ) @ J4 ) )
               => ( P3 @ J4 ) ) ) ) ) ) ).

% split_mod
thf(fact_640_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_641_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_642_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_643_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_644_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_645_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_646_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_647_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A2 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_648_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y2: A,X2: A,Z: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y2 ) @ ( times_times @ A @ X2 @ Z ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z ) @ ( times_times @ A @ X2 @ Y2 ) ) )
          = ( ( W = X2 )
            | ( Y2 = Z ) ) ) ) ).

% crossproduct_eq
thf(fact_649_realpow__pos__nth,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ( ( power_power @ real @ R2 @ N )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_650_realpow__pos__nth__unique,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X7: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X7 )
            & ( ( power_power @ real @ X7 @ N )
              = A2 )
            & ! [Y3: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
                  & ( ( power_power @ real @ Y3 @ N )
                    = A2 ) )
               => ( Y3 = X7 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_651_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X2 @ Xa )
        = Y2 )
     => ( ! [A4: $o,B3: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A4 @ B3 ) )
           => ( Y2
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
           => Y2 )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT] :
                ( ? [S2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) )
               => ( Y2
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_652_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X2 @ Xa )
     => ( ! [A4: $o,B3: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A4 @ B3 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A4 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B3 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT] :
              ( ? [S2: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_653_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X2 @ Xa )
     => ( ! [A4: $o,B3: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A4 @ B3 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A4 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B3 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT] :
                ( ? [S2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_654_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_655_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_656_gcd__nat__induct,axiom,
    ! [P3: nat > nat > $o,M: nat,N: nat] :
      ( ! [M5: nat] : ( P3 @ M5 @ ( zero_zero @ nat ) )
     => ( ! [M5: nat,N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ( P3 @ N3 @ ( modulo_modulo @ nat @ M5 @ N3 ) )
             => ( P3 @ M5 @ N3 ) ) )
       => ( P3 @ M @ N ) ) ) ).

% gcd_nat_induct
thf(fact_657_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_658_num_Osize__gen_I2_J,axiom,
    ! [X23: num] :
      ( ( size_num @ ( bit0 @ X23 ) )
      = ( plus_plus @ nat @ ( size_num @ X23 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_659_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L ) ) ) ) ).

% power_numeral
thf(fact_660_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X2: A,Y2: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X2 @ Y2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_661_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(71)
thf(fact_662_semiring__norm_I68_J,axiom,
    ! [N: num] : ( ord_less_eq @ num @ one2 @ N ) ).

% semiring_norm(68)
thf(fact_663_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N @ M ) ) ).

% Suc_le_mono
thf(fact_664_le0,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% le0
thf(fact_665_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_666_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_667_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_668_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% nat_add_left_cancel_le
thf(fact_669_enat__ord__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% enat_ord_simps(1)
thf(fact_670_enat__ord__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = ( Q2
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% enat_ord_simps(5)
thf(fact_671_enat__ord__code_I3_J,axiom,
    ! [Q2: extended_enat] : ( ord_less_eq @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_code(3)
thf(fact_672_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_673_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% numeral_le_iff
thf(fact_674_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_675_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_676_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_677_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_678_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_679_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% div_by_1
thf(fact_680_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_681_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_682_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_683_set__n__deg__not__0,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,M: nat] :
      ( ! [X7: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X7 @ N ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N ) ) ) ).

% set_n_deg_not_0
thf(fact_684_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_685_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_686_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_687_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_688_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_689_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_690_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_691_take__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( take @ A @ N @ Xs )
        = Xs ) ) ).

% take_all
thf(fact_692_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = Xs )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% take_all_iff
thf(fact_693_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_694_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(1)
thf(fact_695_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_696_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_697_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_698_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_699_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_700_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_701_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_702_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_703_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_704_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_705_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_706_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_707_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_708_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_709_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_710_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_711_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_712_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_713_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_714_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_715_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_716_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N ) )
            = ( M = N ) ) ) ) ).

% power_inject_exp
thf(fact_717_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_718_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_719_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) ) ).

% one_le_mult_iff
thf(fact_720_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% mult_le_cancel2
thf(fact_721_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_722_less__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_723_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_724_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_725_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_726_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_727_numeral__le__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ).

% numeral_le_enat_iff
thf(fact_728_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_729_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_730_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_731_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_732_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_733_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_734_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_735_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_736_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_737_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_738_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_739_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X2: nat,Y2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X2 ) @ ( power_power @ A @ B2 @ Y2 ) )
            = ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ).

% power_increasing_iff
thf(fact_740_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_741_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_742_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X2: nat,Y2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X2 ) @ ( power_power @ A @ B2 @ Y2 ) )
            = ( ord_less @ nat @ X2 @ Y2 ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_743_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_744_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_745_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_746_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_747_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_748_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_749_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_750_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_751_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_752_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_753_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_754_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_755_signed__take__bit__Suc__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_756_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_757_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_758_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_759_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_760_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_761_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_762_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_763_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_764_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X2 = Y2 ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_765_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_766_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_767_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_768_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_769_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z22 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(2)
thf(fact_770_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z22 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(1)
thf(fact_771_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X6: real,Y: real] :
          ( ( ord_less @ real @ X6 @ Y )
          | ( X6 = Y ) ) ) ) ).

% less_eq_real_def
thf(fact_772_signed__take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% signed_take_bit_mult
thf(fact_773_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_774_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N5 ) ) ) ) ) ).

% power_increasing
thf(fact_775_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_776_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X2: A] :
          ( ( ( one_one @ A )
            = X2 )
          = ( X2
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_777_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_778_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_779_signed__take__bit__add,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ K @ L ) ) ) ).

% signed_take_bit_add
thf(fact_780_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_781_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_782_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_783_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_784_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_785_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ ( suc @ N3 ) ) @ ( F3 @ N3 ) )
         => ( ( ord_less_eq @ nat @ N @ N4 )
           => ( ord_less_eq @ A @ ( F3 @ N4 ) @ ( F3 @ N ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_786_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
         => ( ( ord_less_eq @ nat @ N @ N4 )
           => ( ord_less_eq @ A @ ( F3 @ N ) @ ( F3 @ N4 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_787_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% one_le_power
thf(fact_788_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N5 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_789_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_790_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ord_less_eq @ A @ Y2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y2 @ X2 ) @ X2 ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_791_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ord_less_eq @ A @ Y2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X2 @ Y2 ) @ X2 ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_792_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_793_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_794_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_795_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_796_zmod__trivial__iff,axiom,
    ! [I3: int,K: int] :
      ( ( ( modulo_modulo @ int @ I3 @ K )
        = I3 )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I3 )
          & ( ord_less @ int @ I3 @ K ) )
        | ( ( ord_less_eq @ int @ I3 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I3 ) ) ) ) ).

% zmod_trivial_iff
thf(fact_797_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_798_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_799_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_800_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_801_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( plus_plus @ int @ K @ L ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_802_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_pos_eq
thf(fact_803_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_neg_eq
thf(fact_804_split__zmod,axiom,
    ! [P3: int > $o,N: int,K: int] :
      ( ( P3 @ ( modulo_modulo @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P3 @ N ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I: int,J4: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J4 )
                & ( ord_less @ int @ J4 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J4 ) ) )
             => ( P3 @ J4 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I: int,J4: int] :
              ( ( ( ord_less @ int @ K @ J4 )
                & ( ord_less_eq @ int @ J4 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J4 ) ) )
             => ( P3 @ J4 ) ) ) ) ) ).

% split_zmod
thf(fact_805_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_806_less__eq__enat__def,axiom,
    ( ( ord_less_eq @ extended_enat )
    = ( ^ [M4: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [N1: nat] :
              ( extended_case_enat @ $o
              @ ^ [M1: nat] : ( ord_less_eq @ nat @ M1 @ N1 )
              @ $false
              @ M4 )
          @ $true ) ) ) ).

% less_eq_enat_def
thf(fact_807_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M @ Xs ) ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) ) ) ).

% set_take_subset_set_take
thf(fact_808_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q3: int] :
          ( M
          = ( times_times @ int @ D2 @ Q3 ) ) ) ).

% zmod_eq_0D
thf(fact_809_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M
            = ( times_times @ int @ D2 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_810_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_811_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) ).

% zero_le
thf(fact_812_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B6: B,A6: B] :
          ( ( ~ ( ord_less_eq @ B @ B6 @ A6 ) )
          = ( ord_less @ B @ A6 @ B6 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_813_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J2 )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_814_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_815_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_816_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_817_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_818_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C3 ) ) ) ) ).

% less_eqE
thf(fact_819_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_820_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
            ? [C4: A] :
              ( B4
              = ( plus_plus @ A @ A5 @ C4 ) ) ) ) ) ).

% le_iff_add
thf(fact_821_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_822_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_823_le__num__One__iff,axiom,
    ! [X2: num] :
      ( ( ord_less_eq @ num @ X2 @ one2 )
      = ( X2 = one2 ) ) ).

% le_num_One_iff
thf(fact_824_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_825_div__mod__decomp__int,axiom,
    ! [A3: int,N: int] :
      ( A3
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A3 @ N ) @ N ) @ ( modulo_modulo @ int @ A3 @ N ) ) ) ).

% div_mod_decomp_int
thf(fact_826_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_827_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_leD
thf(fact_828_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) ).

% le_SucE
thf(fact_829_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ ( suc @ N ) ) ) ).

% le_SucI
thf(fact_830_Suc__le__D,axiom,
    ! [N: nat,M6: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ M6 )
     => ? [M5: nat] :
          ( M6
          = ( suc @ M5 ) ) ) ).

% Suc_le_D
thf(fact_831_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq @ nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) ).

% le_Suc_eq
thf(fact_832_Suc__n__not__le__n,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N ) @ N ) ).

% Suc_n_not_le_n
thf(fact_833_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N ) )
      = ( ord_less_eq @ nat @ ( suc @ N ) @ M ) ) ).

% not_less_eq_eq
thf(fact_834_full__nat__induct,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N3 )
             => ( P3 @ M2 ) )
         => ( P3 @ N3 ) )
     => ( P3 @ N ) ) ).

% full_nat_induct
thf(fact_835_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P3: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( P3 @ M )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M @ N3 )
             => ( ( P3 @ N3 )
               => ( P3 @ ( suc @ N3 ) ) ) )
         => ( P3 @ N ) ) ) ) ).

% nat_induct_at_least
thf(fact_836_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R3: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ! [X7: nat] : ( R3 @ X7 @ X7 )
       => ( ! [X7: nat,Y5: nat,Z2: nat] :
              ( ( R3 @ X7 @ Y5 )
             => ( ( R3 @ Y5 @ Z2 )
               => ( R3 @ X7 @ Z2 ) ) )
         => ( ! [N3: nat] : ( R3 @ N3 @ ( suc @ N3 ) )
           => ( R3 @ M @ N ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_837_le__0__eq,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( zero_zero @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_838_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_839_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_840_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% less_eq_nat.simps(1)
thf(fact_841_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_842_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_843_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M4 @ N2 )
          & ( M4 != N2 ) ) ) ) ).

% nat_less_le
thf(fact_844_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_imp_le_nat
thf(fact_845_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( ( ord_less @ nat @ M4 @ N2 )
          | ( M4 = N2 ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_846_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less @ nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_or_eq_imp_le
thf(fact_847_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( M != N )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% le_neq_implies_less
thf(fact_848_less__mono__imp__le__mono,axiom,
    ! [F3: nat > nat,I3: nat,J2: nat] :
      ( ! [I2: nat,J: nat] :
          ( ( ord_less @ nat @ I2 @ J )
         => ( ord_less @ nat @ ( F3 @ I2 ) @ ( F3 @ J ) ) )
     => ( ( ord_less_eq @ nat @ I3 @ J2 )
       => ( ord_less_eq @ nat @ ( F3 @ I3 ) @ ( F3 @ J2 ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_849_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_850_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B5 )
      = ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
           => ( member @ A @ X6 @ B5 ) ) ) ) ).

% subset_code(1)
thf(fact_851_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) ).

% add_leE
thf(fact_852_le__add1,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) ).

% le_add1
thf(fact_853_le__add2,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) ).

% le_add2
thf(fact_854_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% add_leD1
thf(fact_855_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) ).

% add_leD2
thf(fact_856_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N3: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N3 ) ) ) ).

% le_Suc_ex
thf(fact_857_add__le__mono,axiom,
    ! [I3: nat,J2: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( plus_plus @ nat @ J2 @ L ) ) ) ) ).

% add_le_mono
thf(fact_858_add__le__mono1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( plus_plus @ nat @ J2 @ K ) ) ) ).

% add_le_mono1
thf(fact_859_trans__le__add1,axiom,
    ! [I3: nat,J2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ord_less_eq @ nat @ I3 @ ( plus_plus @ nat @ J2 @ M ) ) ) ).

% trans_le_add1
thf(fact_860_trans__le__add2,axiom,
    ! [I3: nat,J2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ord_less_eq @ nat @ I3 @ ( plus_plus @ nat @ M @ J2 ) ) ) ).

% trans_le_add2
thf(fact_861_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M4: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( plus_plus @ nat @ M4 @ K2 ) ) ) ) ).

% nat_le_iff_add
thf(fact_862_mult__le__mono2,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I3 ) @ ( times_times @ nat @ K @ J2 ) ) ) ).

% mult_le_mono2
thf(fact_863_mult__le__mono1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I3 @ K ) @ ( times_times @ nat @ J2 @ K ) ) ) ).

% mult_le_mono1
thf(fact_864_mult__le__mono,axiom,
    ! [I3: nat,J2: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I3 @ K ) @ ( times_times @ nat @ J2 @ L ) ) ) ) ).

% mult_le_mono
thf(fact_865_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_866_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_867_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N @ K ) ) ) ).

% div_le_mono
thf(fact_868_div__le__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ).

% div_le_dividend
thf(fact_869_nat__mult__1__right,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) ).

% nat_mult_1_right
thf(fact_870_nat__mult__1,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) ).

% nat_mult_1
thf(fact_871_enat__ile,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K3: nat] :
          ( N
          = ( extended_enat2 @ K3 ) ) ) ).

% enat_ile
thf(fact_872_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ M ) ).

% mod_less_eq_dividend
thf(fact_873_enat__ord__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( ord_less_eq @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_simps(3)
thf(fact_874_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = ( N
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_875_i0__lb,axiom,
    ! [N: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ).

% i0_lb
thf(fact_876_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ! [Z2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
             => ( ( ord_less @ A @ Z2 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X2 ) @ Y2 ) ) )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% field_le_mult_one_interval
thf(fact_877_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_878_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_879_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_880_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_881_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_882_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_883_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_884_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_885_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X2: A,A2: A,Y2: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X2 @ A2 )
         => ( ( ord_less_eq @ A @ Y2 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X2 ) @ ( times_times @ A @ V @ Y2 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_886_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_887_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_888_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_889_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_890_split__neg__lemma,axiom,
    ! [K: int,P3: int > int > $o,N: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P3 @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I: int,J4: int] :
              ( ( ( ord_less @ int @ K @ J4 )
                & ( ord_less_eq @ int @ J4 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J4 ) ) )
             => ( P3 @ I @ J4 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_891_split__pos__lemma,axiom,
    ! [K: int,P3: int > int > $o,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P3 @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I: int,J4: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J4 )
                & ( ord_less @ int @ J4 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J4 ) ) )
             => ( P3 @ I @ J4 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_892_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X6: A] : X6 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_893_iadd__le__enat__iff,axiom,
    ! [X2: extended_enat,Y2: extended_enat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( plus_plus @ extended_enat @ X2 @ Y2 ) @ ( extended_enat2 @ N ) )
      = ( ? [Y7: nat,X9: nat] :
            ( ( X2
              = ( extended_enat2 @ X9 ) )
            & ( Y2
              = ( extended_enat2 @ Y7 ) )
            & ( ord_less_eq @ nat @ ( plus_plus @ nat @ X9 @ Y7 ) @ N ) ) ) ) ).

% iadd_le_enat_iff
thf(fact_894_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_895_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_896_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X2: A,A2: A,Y2: A,U: A,V: A] :
          ( ( ord_less @ A @ X2 @ A2 )
         => ( ( ord_less @ A @ Y2 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X2 ) @ ( times_times @ A @ V @ Y2 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_897_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% neg_mod_bound
thf(fact_898_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L ) @ L ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_899_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_900_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_le_numeral
thf(fact_901_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_902_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_903_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_904_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_905_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_906_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_907_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_908_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_909_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_910_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_911_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_912_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_913_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_914_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_915_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_916_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_917_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_918_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X2 @ Y2 )
                = ( zero_zero @ A ) )
              = ( ( X2
                  = ( zero_zero @ A ) )
                & ( Y2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_919_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ( plus_plus @ A @ X2 @ Y2 )
                = ( zero_zero @ A ) )
              = ( ( X2
                  = ( zero_zero @ A ) )
                & ( Y2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_920_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_921_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_922_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_923_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_924_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_925_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_926_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_927_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_928_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_929_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_930_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_931_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_932_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_933_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_934_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_935_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_936_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_937_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_938_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono
thf(fact_939_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_power
thf(fact_940_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_941_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_942_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_943_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_944_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_945_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_946_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_947_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_948_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_949_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_950_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% le_imp_less_Suc
thf(fact_951_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat] : ( ord_less_eq @ nat @ ( suc @ N2 ) ) ) ) ).

% less_eq_Suc_le
thf(fact_952_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% less_Suc_eq_le
thf(fact_953_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% le_less_Suc_eq
thf(fact_954_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_lessD
thf(fact_955_inc__induct,axiom,
    ! [I3: nat,J2: nat,P3: nat > $o] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( P3 @ J2 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J2 )
               => ( ( P3 @ ( suc @ N3 ) )
                 => ( P3 @ N3 ) ) ) )
         => ( P3 @ I3 ) ) ) ) ).

% inc_induct
thf(fact_956_dec__induct,axiom,
    ! [I3: nat,J2: nat,P3: nat > $o] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( P3 @ I3 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J2 )
               => ( ( P3 @ N3 )
                 => ( P3 @ ( suc @ N3 ) ) ) ) )
         => ( P3 @ J2 ) ) ) ) ).

% dec_induct
thf(fact_957_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_eq
thf(fact_958_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_leI
thf(fact_959_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_960_ex__least__nat__le,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ( P3 @ N )
     => ( ~ ( P3 @ ( zero_zero @ nat ) )
       => ? [K3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K3 )
               => ~ ( P3 @ I4 ) )
            & ( P3 @ K3 ) ) ) ) ).

% ex_least_nat_le
thf(fact_961_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A,Y2: A,N: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X2 @ N ) @ ( power_power @ A @ Y2 @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_962_mono__nat__linear__lb,axiom,
    ! [F3: nat > nat,M: nat,K: nat] :
      ( ! [M5: nat,N3: nat] :
          ( ( ord_less @ nat @ M5 @ N3 )
         => ( ord_less @ nat @ ( F3 @ M5 ) @ ( F3 @ N3 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F3 @ M ) @ K ) @ ( F3 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_963_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_mult_le_cancel1
thf(fact_964_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_one_over
thf(fact_965_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_966_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R4: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R4 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( ord_less @ int @ B2 @ R4 )
           => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_967_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R4: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R4 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
       => ( ( ord_less @ int @ R4 @ B2 )
         => ( ( ord_less @ int @ R @ B2 )
           => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_968_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B6: int,Q5: int,R4: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
             => ( ( ord_less_eq @ int @ B6 @ B2 )
               => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_969_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B6: int,Q5: int,R4: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) )
       => ( ( ord_less @ int @ R4 @ B6 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
             => ( ( ord_less_eq @ int @ B6 @ B2 )
               => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_970_q__pos__lemma,axiom,
    ! [B6: int,Q5: int,R4: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) )
     => ( ( ord_less @ int @ R4 @ B6 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q5 ) ) ) ) ).

% q_pos_lemma
thf(fact_971_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_972_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ ( divide_divide @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_div_le_mono
thf(fact_973_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_974_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_975_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_976_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N2: nat] : ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_977_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N ) ) @ N ) ).

% mod_Suc_le_divisor
thf(fact_978_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_979_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_980_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_981_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_982_set__take__subset,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_take_subset
thf(fact_983_infinity__ileE,axiom,
    ! [M: nat] :
      ~ ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ M ) ) ).

% infinity_ileE
thf(fact_984_enat__ord__code_I5_J,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) ) ).

% enat_ord_code(5)
thf(fact_985_pow_Osimps_I1_J,axiom,
    ! [X2: num] :
      ( ( pow @ X2 @ one2 )
      = X2 ) ).

% pow.simps(1)
thf(fact_986_enat__add__left__cancel__le,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( plus_plus @ extended_enat @ A2 @ B2 ) @ ( plus_plus @ extended_enat @ A2 @ C2 ) )
      = ( ( A2
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( ord_less_eq @ extended_enat @ B2 @ C2 ) ) ) ).

% enat_add_left_cancel_le
thf(fact_987_verit__le__mono__div,axiom,
    ! [A3: nat,B5: nat,N: nat] :
      ( ( ord_less @ nat @ A3 @ B5 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A3 @ N )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B5 @ N )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B5 @ N ) ) ) ) ).

% verit_le_mono_div
thf(fact_988_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu @ Uv ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_989_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_990_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_991_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_992_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_993_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_994_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_995_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_996_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_997_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_998_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_999_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_1000_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_1001_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_1002_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_1003_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ X2 ) @ ( times_times @ A @ Z @ Y2 ) )
            = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_1004_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ Z ) )
            = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_1005_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ Y2 @ E ) ) )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% field_le_epsilon
thf(fact_1006_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_1007_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_1008_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_1009_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_1010_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_1011_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_1012_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N3: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_1013_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N3: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_1014_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_1015_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) @ ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_1016_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_1017_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_1018_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,W: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_1019_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_1020_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_1021_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_1022_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_1023_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_1024_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_1025_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_1026_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_1027_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_1028_zdiv__mono__strict,axiom,
    ! [A3: int,B5: int,N: int] :
      ( ( ord_less @ int @ A3 @ B5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ( ( modulo_modulo @ int @ A3 @ N )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B5 @ N )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A3 @ N ) @ ( divide_divide @ int @ B5 @ N ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1029_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_1030_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N ) )
            = ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_1031_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_1032_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_1033_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_1034_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1035_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1036_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1037_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1038_ex__least__nat__less,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ( P3 @ N )
     => ( ~ ( P3 @ ( zero_zero @ nat ) )
       => ? [K3: nat] :
            ( ( ord_less @ nat @ K3 @ N )
            & ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ K3 )
               => ~ ( P3 @ I4 ) )
            & ( P3 @ ( suc @ K3 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_1039_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_1040_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_1041_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_1042_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_1043_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_1044_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_1045_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less @ nat @ M @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_1046_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N5 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N5 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_1047_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel1
thf(fact_1048_nat__one__le__power,axiom,
    ! [I3: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I3 )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I3 @ N ) ) ) ).

% nat_one_le_power
thf(fact_1049_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_1050_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ N @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% div_greater_zero_iff
thf(fact_1051_nat__induct__non__zero,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( P3 @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( P3 @ N3 )
               => ( P3 @ ( suc @ N3 ) ) ) )
         => ( P3 @ N ) ) ) ) ).

% nat_induct_non_zero
thf(fact_1052_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_le_divisor
thf(fact_1053_split__zdiv,axiom,
    ! [P3: int > $o,N: int,K: int] :
      ( ( P3 @ ( divide_divide @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P3 @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I: int,J4: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J4 )
                & ( ord_less @ int @ J4 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J4 ) ) )
             => ( P3 @ I ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I: int,J4: int] :
              ( ( ( ord_less @ int @ K @ J4 )
                & ( ord_less_eq @ int @ J4 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J4 ) ) )
             => ( P3 @ I ) ) ) ) ) ).

% split_zdiv
thf(fact_1054_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_neg_eq
thf(fact_1055_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_pos_eq
thf(fact_1056_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_1057_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_1058_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_1059_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I3 @ K ) )
        = ( ord_less_eq @ int @ K @ I3 ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_1060_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_1061_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_1062_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ L @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) ) ) ) ).

% div_positive_int
thf(fact_1063_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_1064_zdiv__mono2__neg,axiom,
    ! [A2: int,B6: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
       => ( ( ord_less_eq @ int @ B6 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B6 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_1065_zdiv__mono1__neg,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A6 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_1066_zdiv__eq__0__iff,axiom,
    ! [I3: int,K: int] :
      ( ( ( divide_divide @ int @ I3 @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I3 )
          & ( ord_less @ int @ I3 @ K ) )
        | ( ( ord_less_eq @ int @ I3 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I3 ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_1067_zdiv__mono2,axiom,
    ! [A2: int,B6: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
       => ( ( ord_less_eq @ int @ B6 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B6 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_1068_zdiv__mono1,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A6 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_1069_nat__mod__eq__lemma,axiom,
    ! [X2: nat,N: nat,Y2: nat] :
      ( ( ( modulo_modulo @ nat @ X2 @ N )
        = ( modulo_modulo @ nat @ Y2 @ N ) )
     => ( ( ord_less_eq @ nat @ Y2 @ X2 )
       => ? [Q3: nat] :
            ( X2
            = ( plus_plus @ nat @ Y2 @ ( times_times @ nat @ N @ Q3 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_1070_mod__eq__nat2E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N @ Q2 ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ~ ! [S2: nat] :
              ( N
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q2 @ S2 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_1071_mod__eq__nat1E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N @ Q2 ) )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ~ ! [S2: nat] :
              ( M
             != ( plus_plus @ nat @ N @ ( times_times @ nat @ Q2 @ S2 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_1072_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ) ) ).

% div_less_dividend
thf(fact_1073_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N )
          = M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1074_Suc__ile__eq,axiom,
    ! [M: nat,N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ ( suc @ M ) ) @ N )
      = ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ N ) ) ).

% Suc_ile_eq
thf(fact_1075_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X2: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
      = ( ( ( X2
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X2
           != ( zero_zero @ nat ) )
         => ( ( ( X2
                = ( one_one @ nat ) )
             => B2 )
            & ( X2
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_1076_signed__take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% signed_take_bit_int_less_exp
thf(fact_1077_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_1078_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_1079_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_1080_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_1081_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_1082_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_1083_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_1084_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_1085_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ Y2 ) @ X2 )
           => ( ord_less_eq @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_1086_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_1087_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N )
                  = ( power_power @ A @ B2 @ N ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_1088_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_1089_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_1090_not__exp__less__eq__0__int,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_1091_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_1092_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N5 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N5 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_1093_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_1094_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_eq_le
thf(fact_1095_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_imp_le
thf(fact_1096_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_1097_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_1098_div__nat__eqI,axiom,
    ! [N: nat,Q2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q2 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q2 ) ) )
       => ( ( divide_divide @ nat @ M @ N )
          = Q2 ) ) ) ).

% div_nat_eqI
thf(fact_1099_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N @ Q2 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q2 ) @ N ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_1100_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_1101_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ K )
             => ( ( nth @ A @ Xs @ I2 )
                = ( nth @ A @ Ys @ I2 ) ) )
         => ( ( take @ A @ K @ Xs )
            = ( take @ A @ K @ Ys ) ) ) ) ) ).

% nth_take_lemma
thf(fact_1102_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1103_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_1104_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_1105_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_1106_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
             => ( X2 = Y2 ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_1107_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% power2_le_imp_le
thf(fact_1108_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_1109_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1110_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_1111_split__div_H,axiom,
    ! [P3: nat > $o,M: nat,N: nat] :
      ( ( P3 @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
          & ( P3 @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q4 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q4 ) ) )
            & ( P3 @ Q4 ) ) ) ) ).

% split_div'
thf(fact_1112_nat__induct2,axiom,
    ! [P3: nat > $o,N: nat] :
      ( ( P3 @ ( zero_zero @ nat ) )
     => ( ( P3 @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( P3 @ N3 )
             => ( P3 @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P3 @ N ) ) ) ) ).

% nat_induct2
thf(fact_1113_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_1114_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% power2_less_imp_less
thf(fact_1115_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_1116_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_1117_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% zero_le_even_power'
thf(fact_1118_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_1119_Euclid__induct,axiom,
    ! [P3: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( P3 @ A4 @ B3 )
          = ( P3 @ B3 @ A4 ) )
     => ( ! [A4: nat] : ( P3 @ A4 @ ( zero_zero @ nat ) )
       => ( ! [A4: nat,B3: nat] :
              ( ( P3 @ A4 @ B3 )
             => ( P3 @ A4 @ ( plus_plus @ nat @ A4 @ B3 ) ) )
         => ( P3 @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1120_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_1121_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_1122_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ( modulo_modulo @ A @ X2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X2 @ M ) )
              | ( ( modulo_modulo @ A @ X2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X2 @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_1123_incr__mult__lemma,axiom,
    ! [D2: int,P3: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X7: int] :
            ( ( P3 @ X7 )
           => ( P3 @ ( plus_plus @ int @ X7 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X: int] :
              ( ( P3 @ X )
             => ( P3 @ ( plus_plus @ int @ X @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_1124_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1125_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1126_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1127_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_1128_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( ( vEBT_invar_vebt @ A1 @ A22 )
     => ( ( ? [A4: $o,B3: $o] :
              ( A1
              = ( vEBT_Leaf @ A4 @ B3 ) )
         => ( A22
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList2: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M5: nat,Deg2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList2 @ Summary2 ) )
             => ( ( A22 = Deg2 )
               => ( ! [X: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ( vEBT_invar_vebt @ X @ N3 ) )
                 => ( ( vEBT_invar_vebt @ Summary2 @ M5 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M5 ) )
                     => ( ( M5 = N3 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N3 @ M5 ) )
                         => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_1 )
                           => ~ ! [X: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                 => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList2: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M5: nat,Deg2: nat] :
                ( ( A1
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( A22 = Deg2 )
                 => ( ! [X: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ( vEBT_invar_vebt @ X @ N3 ) )
                   => ( ( vEBT_invar_vebt @ Summary2 @ M5 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M5 ) )
                       => ( ( M5
                            = ( suc @ N3 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N3 @ M5 ) )
                           => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_1 )
                             => ~ ! [X: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                   => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList2: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M5: nat,Deg2: nat,Mi: nat,Ma2: nat] :
                  ( ( A1
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ Deg2 @ TreeList2 @ Summary2 ) )
                 => ( ( A22 = Deg2 )
                   => ( ! [X: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ( vEBT_invar_vebt @ X @ N3 ) )
                     => ( ( vEBT_invar_vebt @ Summary2 @ M5 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M5 ) )
                         => ( ( M5 = N3 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N3 @ M5 ) )
                             => ( ! [I4: nat] :
                                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M5 ) )
                                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X8 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                               => ( ( ( Mi = Ma2 )
                                   => ! [X: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                                   => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi != Ma2 )
                                         => ! [I4: nat] :
                                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M5 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                    = I4 )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                & ! [X: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X @ N3 )
                                                        = I4 )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ X @ N3 ) ) )
                                                   => ( ( ord_less @ nat @ Mi @ X )
                                                      & ( ord_less_eq @ nat @ X @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList2: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M5: nat,Deg2: nat,Mi: nat,Ma2: nat] :
                    ( ( A1
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ Deg2 @ TreeList2 @ Summary2 ) )
                   => ( ( A22 = Deg2 )
                     => ( ! [X: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                           => ( vEBT_invar_vebt @ X @ N3 ) )
                       => ( ( vEBT_invar_vebt @ Summary2 @ M5 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M5 ) )
                           => ( ( M5
                                = ( suc @ N3 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N3 @ M5 ) )
                               => ( ! [I4: nat] :
                                      ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M5 ) )
                                     => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X8 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                                 => ( ( ( Mi = Ma2 )
                                     => ! [X: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                         => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                                     => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi != Ma2 )
                                           => ! [I4: nat] :
                                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M5 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                      = I4 )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                  & ! [X: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X @ N3 )
                                                          = I4 )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ X @ N3 ) ) )
                                                     => ( ( ord_less @ nat @ Mi @ X )
                                                        & ( ord_less_eq @ nat @ X @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_1129_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A12: vEBT_VEBT,A23: nat] :
          ( ( ? [A5: $o,B4: $o] :
                ( A12
                = ( vEBT_Leaf @ A5 @ B4 ) )
            & ( A23
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X6: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X6 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
              & ! [X6: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X6: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X6 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
              & ! [X6: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,Mi2: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma3 ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X6: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X6 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ! [I: nat] :
                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X8 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
              & ( ( Mi2 = Ma3 )
               => ! [X6: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
              & ( ord_less_eq @ nat @ Mi2 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi2 != Ma3 )
               => ! [I: nat] :
                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                          = I )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                      & ! [X6: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X6 @ N2 )
                              = I )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ X6 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi2 @ X6 )
                            & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,Mi2: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma3 ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X6: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X6 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ! [I: nat] :
                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X8 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
              & ( ( Mi2 = Ma3 )
               => ! [X6: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
              & ( ord_less_eq @ nat @ Mi2 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi2 != Ma3 )
               => ! [I: nat] :
                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                          = I )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                      & ! [X6: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X6 @ N2 )
                              = I )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ X6 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi2 @ X6 )
                            & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_1130_concat__bit__Suc,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_concat_bit @ ( suc @ N ) @ K @ L )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L ) ) ) ) ).

% concat_bit_Suc
thf(fact_1131_option_Oinject,axiom,
    ! [A: $tType,X23: A,Y22: A] :
      ( ( ( some @ A @ X23 )
        = ( some @ A @ Y22 ) )
      = ( X23 = Y22 ) ) ).

% option.inject
thf(fact_1132_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_1133_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_1134_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_1135_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_1136_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( divide_divide @ A @ C2 @ A2 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_1137_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1138_not__None__eq,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( ( X2
         != ( none @ A ) ) )
      = ( ? [Y: A] :
            ( X2
            = ( some @ A @ Y ) ) ) ) ).

% not_None_eq
thf(fact_1139_not__Some__eq,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( ! [Y: A] :
            ( X2
           != ( some @ A @ Y ) ) )
      = ( X2
        = ( none @ A ) ) ) ).

% not_Some_eq
thf(fact_1140_concat__bit__0,axiom,
    ! [K: int,L: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L )
      = L ) ).

% concat_bit_0
thf(fact_1141_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_1142_mi__ma__2__deg,axiom,
    ! [Mi3: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ N )
     => ( ( ord_less_eq @ nat @ Mi3 @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_1143_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1144_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1145_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1146_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1147_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1148_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1149_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1150_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1151_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1152_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1153_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1154_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = A2 ) ) ) ).

% unit_div_1_div_1
thf(fact_1155_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_1156_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_1157_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_1158_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_1159_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_1160_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z ) ) ).

% zle_add1_eq_le
thf(fact_1161_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N @ K @ L ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ).

% concat_bit_nonnegative_iff
thf(fact_1162_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N @ K @ L ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_1163_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_1164_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi3: nat,Ma: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X2 )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X2 = Mi3 )
          | ( X2 = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_1165_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1166_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = ( divide_divide @ A @ B2 @ A2 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1167_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_1168_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X2: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Mi3: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X2 ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_1169_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1170_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_1171_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_1172_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_mod_2_iff
thf(fact_1173_even__Suc__Suc__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% even_Suc_Suc_iff
thf(fact_1174_even__Suc,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_Suc
thf(fact_1175_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1176_even__Suc__div__two,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_1177_odd__Suc__div__two,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_1178_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1179_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1180_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1181_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_1182_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% even_power
thf(fact_1183_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_1184_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_1185_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1186_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_1187_verit__la__generic,axiom,
    ! [A2: int,X2: int] :
      ( ( ord_less_eq @ int @ A2 @ X2 )
      | ( A2 = X2 )
      | ( ord_less_eq @ int @ X2 @ A2 ) ) ).

% verit_la_generic
thf(fact_1188_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) ) ).

% set_bit_greater_eq
thf(fact_1189_complete__real,axiom,
    ! [S3: set @ real] :
      ( ? [X: real] : ( member @ real @ X @ S3 )
     => ( ? [Z4: real] :
          ! [X7: real] :
            ( ( member @ real @ X7 @ S3 )
           => ( ord_less_eq @ real @ X7 @ Z4 ) )
       => ? [Y5: real] :
            ( ! [X: real] :
                ( ( member @ real @ X @ S3 )
               => ( ord_less_eq @ real @ X @ Y5 ) )
            & ! [Z4: real] :
                ( ! [X7: real] :
                    ( ( member @ real @ X7 @ S3 )
                   => ( ord_less_eq @ real @ X7 @ Z4 ) )
               => ( ord_less_eq @ real @ Y5 @ Z4 ) ) ) ) ) ).

% complete_real
thf(fact_1190_Nat_Oex__has__greatest__nat,axiom,
    ! [P3: nat > $o,K: nat,B2: nat] :
      ( ( P3 @ K )
     => ( ! [Y5: nat] :
            ( ( P3 @ Y5 )
           => ( ord_less_eq @ nat @ Y5 @ B2 ) )
       => ? [X7: nat] :
            ( ( P3 @ X7 )
            & ! [Y3: nat] :
                ( ( P3 @ Y3 )
               => ( ord_less_eq @ nat @ Y3 @ X7 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_1191_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) ).

% nat_le_linear
thf(fact_1192_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) ).

% le_antisym
thf(fact_1193_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% eq_imp_le
thf(fact_1194_le__trans,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( ord_less_eq @ nat @ J2 @ K )
       => ( ord_less_eq @ nat @ I3 @ K ) ) ) ).

% le_trans
thf(fact_1195_le__refl,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ N ) ).

% le_refl
thf(fact_1196_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ A2 ) ) ).

% dvd_refl
thf(fact_1197_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_1198_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ N @ M )
       => ( M = N ) ) ) ).

% dvd_antisym
thf(fact_1199_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A2 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_1200_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_1201_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_1202_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( zero_zero @ A ) )
             => ( B4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_1203_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) ) ) ).

% dvd_triv_right
thf(fact_1204_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1205_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1206_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1207_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1208_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1209_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1210_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B4: A,A5: A] :
            ? [K2: A] :
              ( A5
              = ( times_times @ A @ B4 @ K2 ) ) ) ) ) ).

% dvd_def
thf(fact_1211_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A2: A,B2: A,K: A] :
          ( ( A2
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% dvdI
thf(fact_1212_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ~ ! [K3: A] :
                ( A2
               != ( times_times @ A @ B2 @ K3 ) ) ) ) ).

% dvdE
thf(fact_1213_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B7: A,C5: A] :
              ( ( A2
                = ( times_times @ A @ B7 @ C5 ) )
              & ( dvd_dvd @ A @ B7 @ B2 )
              & ( dvd_dvd @ A @ C5 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1214_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P5: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ P5 @ ( times_times @ A @ A2 @ B2 ) )
         => ~ ! [X7: A,Y5: A] :
                ( ( P5
                  = ( times_times @ A @ X7 @ Y5 ) )
               => ( ( dvd_dvd @ A @ X7 @ A2 )
                 => ~ ( dvd_dvd @ A @ Y5 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1215_option_Odistinct_I1_J,axiom,
    ! [A: $tType,X23: A] :
      ( ( none @ A )
     != ( some @ A @ X23 ) ) ).

% option.distinct(1)
thf(fact_1216_option_OdiscI,axiom,
    ! [A: $tType,Option: option @ A,X23: A] :
      ( ( Option
        = ( some @ A @ X23 ) )
     => ( Option
       != ( none @ A ) ) ) ).

% option.discI
thf(fact_1217_option_Oexhaust,axiom,
    ! [A: $tType,Y2: option @ A] :
      ( ( Y2
       != ( none @ A ) )
     => ~ ! [X24: A] :
            ( Y2
           != ( some @ A @ X24 ) ) ) ).

% option.exhaust
thf(fact_1218_split__option__ex,axiom,
    ! [A: $tType] :
      ( ( ^ [P: ( option @ A ) > $o] :
          ? [X5: option @ A] : ( P @ X5 ) )
      = ( ^ [P2: ( option @ A ) > $o] :
            ( ( P2 @ ( none @ A ) )
            | ? [X6: A] : ( P2 @ ( some @ A @ X6 ) ) ) ) ) ).

% split_option_ex
thf(fact_1219_split__option__all,axiom,
    ! [A: $tType] :
      ( ( ^ [P: ( option @ A ) > $o] :
          ! [X5: option @ A] : ( P @ X5 ) )
      = ( ^ [P2: ( option @ A ) > $o] :
            ( ( P2 @ ( none @ A ) )
            & ! [X6: A] : ( P2 @ ( some @ A @ X6 ) ) ) ) ) ).

% split_option_all
thf(fact_1220_combine__options__cases,axiom,
    ! [A: $tType,B: $tType,X2: option @ A,P3: ( option @ A ) > ( option @ B ) > $o,Y2: option @ B] :
      ( ( ( X2
          = ( none @ A ) )
       => ( P3 @ X2 @ Y2 ) )
     => ( ( ( Y2
            = ( none @ B ) )
         => ( P3 @ X2 @ Y2 ) )
       => ( ! [A4: A,B3: B] :
              ( ( X2
                = ( some @ A @ A4 ) )
             => ( ( Y2
                  = ( some @ B @ B3 ) )
               => ( P3 @ X2 @ Y2 ) ) )
         => ( P3 @ X2 @ Y2 ) ) ) ) ).

% combine_options_cases
thf(fact_1221_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A2 ) ) ).

% one_dvd
thf(fact_1222_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% unit_imp_dvd
thf(fact_1223_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1224_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_1225_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_1226_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_1227_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ D2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_1228_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_1229_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A2 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_1230_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A,N: nat] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( dvd_dvd @ A @ ( power_power @ A @ X2 @ N ) @ ( power_power @ A @ Y2 @ N ) ) ) ) ).

% dvd_power_same
thf(fact_1231_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% le_imp_power_dvd
thf(fact_1232_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_1233_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A,N: nat,M: nat] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X2 @ N ) @ ( power_power @ A @ Y2 @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_1234_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_uniqueI
thf(fact_1235_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) )
        & ( A2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.not_eq_extremum
thf(fact_1236_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_unique
thf(fact_1237_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
        & ( ( zero_zero @ nat )
         != A2 ) ) ).

% gcd_nat.extremum_strict
thf(fact_1238_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% gcd_nat.extremum
thf(fact_1239_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
            = ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_iff
thf(fact_1240_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_1241_dvd__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [K: A,M: A,N: A] :
          ( ( dvd_dvd @ A @ K @ M )
         => ( ( dvd_dvd @ A @ K @ N )
           => ( dvd_dvd @ A @ K @ ( modulo_modulo @ A @ M @ N ) ) ) ) ) ).

% dvd_mod
thf(fact_1242_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 )
            = ( modulo_modulo @ A @ A2 @ C2 ) ) ) ) ).

% mod_mod_cancel
thf(fact_1243_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
       => ( ( dvd_dvd @ int @ M @ N )
         => ( ( dvd_dvd @ int @ N @ M )
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_1244_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z2: B] :
        ! [X: B] :
          ( ( ord_less @ B @ Z2 @ X )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) ) ) ) ).

% pinf(9)
thf(fact_1245_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z2: B] :
        ! [X: B] :
          ( ( ord_less @ B @ Z2 @ X )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) ) ) ) ) ).

% pinf(10)
thf(fact_1246_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z2: B] :
        ! [X: B] :
          ( ( ord_less @ B @ X @ Z2 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) ) ) ) ).

% minf(9)
thf(fact_1247_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z2: B] :
        ! [X: B] :
          ( ( ord_less @ B @ X @ Z2 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) ) ) ) ) ).

% minf(10)
thf(fact_1248_infinity__ne__i1,axiom,
    ( extend4730790105801354508finity @ extended_enat )
 != ( one_one @ extended_enat ) ).

% infinity_ne_i1
thf(fact_1249_zdvd__mono,axiom,
    ! [K: int,M: int,T3: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T3 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T3 ) ) ) ) ).

% zdvd_mono
thf(fact_1250_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_1251_concat__bit__assoc,axiom,
    ! [N: nat,K: int,M: nat,L: int,R: int] :
      ( ( bit_concat_bit @ N @ K @ ( bit_concat_bit @ M @ L @ R ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N ) @ ( bit_concat_bit @ N @ K @ L ) @ R ) ) ).

% concat_bit_assoc
thf(fact_1252_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi3: nat,Ma: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ X2 )
      = ( ( X2 = Mi3 )
        | ( X2 = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_1253_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P3: A > $o,L: A] :
          ( ( ? [X6: A] : ( P3 @ ( times_times @ A @ L @ X6 ) ) )
          = ( ? [X6: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X6 @ ( zero_zero @ A ) ) )
                & ( P3 @ X6 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1254_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1255_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1256_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1257_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1258_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1259_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1260_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1261_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A2 @ B2 )
              = ( times_times @ A @ A2 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1262_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A2 )
              = ( times_times @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1263_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1264_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1265_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1266_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1267_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1268_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1269_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A2 )
              = ( divide_divide @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1270_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1271_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1272_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_1273_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_1274_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% div_power
thf(fact_1275_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_1276_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( modulo_modulo @ A @ B4 @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_1277_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_1278_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_1279_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_1280_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat @ K @ N ) ) ) ).

% dvd_imp_le
thf(fact_1281_zdvd__not__zless,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N )
       => ~ ( dvd_dvd @ int @ N @ M ) ) ) ).

% zdvd_not_zless
thf(fact_1282_zdvd__imp__le,axiom,
    ! [Z: int,N: int] :
      ( ( dvd_dvd @ int @ Z @ N )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int @ Z @ N ) ) ) ).

% zdvd_imp_le
thf(fact_1283_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( ( L
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% mod_int_pos_iff
thf(fact_1284_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N ) ) ) ).

% zdvd_mult_cancel
thf(fact_1285_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D3: nat,X7: nat,Y5: nat] :
      ( ( dvd_dvd @ nat @ D3 @ A2 )
      & ( dvd_dvd @ nat @ D3 @ B2 )
      & ( ( ( times_times @ nat @ A2 @ X7 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y5 ) @ D3 ) )
        | ( ( times_times @ nat @ B2 @ X7 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y5 ) @ D3 ) ) ) ) ).

% bezout_add_nat
thf(fact_1286_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X2: nat,Y2: nat] :
      ( ( dvd_dvd @ nat @ D2 @ A2 )
     => ( ( dvd_dvd @ nat @ D2 @ B2 )
       => ( ( ( ( times_times @ nat @ A2 @ X2 )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D2 ) )
            | ( ( times_times @ nat @ B2 @ X2 )
              = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y2 ) @ D2 ) ) )
         => ? [X7: nat,Y5: nat] :
              ( ( dvd_dvd @ nat @ D2 @ A2 )
              & ( dvd_dvd @ nat @ D2 @ ( plus_plus @ nat @ A2 @ B2 ) )
              & ( ( ( times_times @ nat @ A2 @ X7 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ Y5 ) @ D2 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ X7 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y5 ) @ D2 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_1287_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X6: A] : ( plus_plus @ A @ X6 @ X6 ) ) ) ) ).

% dbl_def
thf(fact_1288_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N ) ) ).

% zdvd_reduce
thf(fact_1289_zdvd__period,axiom,
    ! [A2: int,D2: int,X2: int,T3: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D2 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X2 @ T3 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X2 @ ( times_times @ int @ C2 @ D2 ) ) @ T3 ) ) ) ) ).

% zdvd_period
thf(fact_1290_real__arch__pow,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ? [N3: nat] : ( ord_less @ real @ Y2 @ ( power_power @ real @ X2 @ N3 ) ) ) ).

% real_arch_pow
thf(fact_1291_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% int_one_le_iff_zero_less
thf(fact_1292_odd__nonzero,axiom,
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1293_int__gr__induct,axiom,
    ! [K: int,I3: int,P3: int > $o] :
      ( ( ord_less @ int @ K @ I3 )
     => ( ( P3 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ K @ I2 )
             => ( ( P3 @ I2 )
               => ( P3 @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P3 @ I3 ) ) ) ) ).

% int_gr_induct
thf(fact_1294_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z )
        | ( W = Z ) ) ) ).

% zless_add1_eq
thf(fact_1295_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z )
      = ( ord_less @ int @ W @ Z ) ) ).

% add1_zle_eq
thf(fact_1296_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ Z )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z ) ) ).

% zless_imp_add1_zle
thf(fact_1297_one__enat__def,axiom,
    ( ( one_one @ extended_enat )
    = ( extended_enat2 @ ( one_one @ nat ) ) ) ).

% one_enat_def
thf(fact_1298_enat__1__iff_I1_J,axiom,
    ! [X2: nat] :
      ( ( ( extended_enat2 @ X2 )
        = ( one_one @ extended_enat ) )
      = ( X2
        = ( one_one @ nat ) ) ) ).

% enat_1_iff(1)
thf(fact_1299_enat__1__iff_I2_J,axiom,
    ! [X2: nat] :
      ( ( ( one_one @ extended_enat )
        = ( extended_enat2 @ X2 ) )
      = ( X2
        = ( one_one @ nat ) ) ) ).

% enat_1_iff(2)
thf(fact_1300_even__even__mod__4__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_1301_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C3: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C3 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1302_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1303_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1304_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1305_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1306_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1307_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ).

% even_numeral
thf(fact_1308_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X2: A,M: nat,N: nat] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ N ) )
            = ( ( dvd_dvd @ A @ X2 @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1309_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1310_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1311_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1312_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1313_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A2 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1314_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = C2 )
            = ( A2
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1315_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1316_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1317_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1318_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_mult_cancel
thf(fact_1319_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D3: nat,X7: nat,Y5: nat] :
          ( ( dvd_dvd @ nat @ D3 @ A2 )
          & ( dvd_dvd @ nat @ D3 @ B2 )
          & ( ( times_times @ nat @ A2 @ X7 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y5 ) @ D3 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1320_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_1321_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P3: A > $o,P6: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X7: A] :
              ( ( ord_less @ A @ Z4 @ X7 )
             => ( ( P3 @ X7 )
                = ( P6 @ X7 ) ) )
         => ( ? [Z4: A] :
              ! [X7: A] :
                ( ( ord_less @ A @ Z4 @ X7 )
               => ( ( Q @ X7 )
                  = ( Q6 @ X7 ) ) )
           => ? [Z2: A] :
              ! [X: A] :
                ( ( ord_less @ A @ Z2 @ X )
               => ( ( ( P3 @ X )
                    & ( Q @ X ) )
                  = ( ( P6 @ X )
                    & ( Q6 @ X ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_1322_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P3: A > $o,P6: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X7: A] :
              ( ( ord_less @ A @ Z4 @ X7 )
             => ( ( P3 @ X7 )
                = ( P6 @ X7 ) ) )
         => ( ? [Z4: A] :
              ! [X7: A] :
                ( ( ord_less @ A @ Z4 @ X7 )
               => ( ( Q @ X7 )
                  = ( Q6 @ X7 ) ) )
           => ? [Z2: A] :
              ! [X: A] :
                ( ( ord_less @ A @ Z2 @ X )
               => ( ( ( P3 @ X )
                    | ( Q @ X ) )
                  = ( ( P6 @ X )
                    | ( Q6 @ X ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_1323_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( X != T3 ) ) ) ).

% pinf(3)
thf(fact_1324_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( X != T3 ) ) ) ).

% pinf(4)
thf(fact_1325_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ~ ( ord_less @ A @ X @ T3 ) ) ) ).

% pinf(5)
thf(fact_1326_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( ord_less @ A @ T3 @ X ) ) ) ).

% pinf(7)
thf(fact_1327_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z2: C] :
        ! [X: C] :
          ( ( ord_less @ C @ Z2 @ X )
         => ( F4 = F4 ) ) ) ).

% pinf(11)
thf(fact_1328_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P3: A > $o,P6: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X7: A] :
              ( ( ord_less @ A @ X7 @ Z4 )
             => ( ( P3 @ X7 )
                = ( P6 @ X7 ) ) )
         => ( ? [Z4: A] :
              ! [X7: A] :
                ( ( ord_less @ A @ X7 @ Z4 )
               => ( ( Q @ X7 )
                  = ( Q6 @ X7 ) ) )
           => ? [Z2: A] :
              ! [X: A] :
                ( ( ord_less @ A @ X @ Z2 )
               => ( ( ( P3 @ X )
                    & ( Q @ X ) )
                  = ( ( P6 @ X )
                    & ( Q6 @ X ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_1329_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P3: A > $o,P6: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X7: A] :
              ( ( ord_less @ A @ X7 @ Z4 )
             => ( ( P3 @ X7 )
                = ( P6 @ X7 ) ) )
         => ( ? [Z4: A] :
              ! [X7: A] :
                ( ( ord_less @ A @ X7 @ Z4 )
               => ( ( Q @ X7 )
                  = ( Q6 @ X7 ) ) )
           => ? [Z2: A] :
              ! [X: A] :
                ( ( ord_less @ A @ X @ Z2 )
               => ( ( ( P3 @ X )
                    | ( Q @ X ) )
                  = ( ( P6 @ X )
                    | ( Q6 @ X ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_1330_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z2 )
         => ( X != T3 ) ) ) ).

% minf(3)
thf(fact_1331_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z2 )
         => ( X != T3 ) ) ) ).

% minf(4)
thf(fact_1332_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z2 )
         => ( ord_less @ A @ X @ T3 ) ) ) ).

% minf(5)
thf(fact_1333_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z2 )
         => ~ ( ord_less @ A @ T3 @ X ) ) ) ).

% minf(7)
thf(fact_1334_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z2: C] :
        ! [X: C] :
          ( ( ord_less @ C @ X @ Z2 )
         => ( F4 = F4 ) ) ) ).

% minf(11)
thf(fact_1335_power__dvd__imp__le,axiom,
    ! [I3: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I3 @ M ) @ ( power_power @ nat @ I3 @ N ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I3 )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% power_dvd_imp_le
thf(fact_1336_real__arch__pow__inv,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ? [N3: nat] : ( ord_less @ real @ ( power_power @ real @ X2 @ N3 ) @ Y2 ) ) ) ).

% real_arch_pow_inv
thf(fact_1337_conj__le__cong,axiom,
    ! [X2: int,X10: int,P3: $o,P6: $o] :
      ( ( X2 = X10 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X10 )
         => ( P3 = P6 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
            & P3 )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X10 )
            & P6 ) ) ) ) ).

% conj_le_cong
thf(fact_1338_imp__le__cong,axiom,
    ! [X2: int,X10: int,P3: $o,P6: $o] :
      ( ( X2 = X10 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X10 )
         => ( P3 = P6 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
           => P3 )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X10 )
           => P6 ) ) ) ) ).

% imp_le_cong
thf(fact_1339_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1340_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1341_le__imp__0__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ).

% le_imp_0_less
thf(fact_1342_int__div__less__self,axiom,
    ! [X2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X2 @ K ) @ X2 ) ) ) ).

% int_div_less_self
thf(fact_1343_option_Osize_I4_J,axiom,
    ! [A: $tType,X23: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X23 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_1344_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_1345_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1346_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1347_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B3: A] :
                  ( ( B3
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B3 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B3 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B3 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B3 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1348_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B3: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) ) ) ).

% evenE
thf(fact_1349_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1350_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_1351_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B4 ) )
              & ( ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1352_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X2: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X2
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X2 @ ( power_power @ A @ X2 @ N ) ) ) ) ).

% dvd_power
thf(fact_1353_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_1354_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% dvd_power_iff_le
thf(fact_1355_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1356_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N @ M ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1357_two__realpow__ge__one,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) ) ).

% two_realpow_ge_one
thf(fact_1358_verit__le__mono__div__int,axiom,
    ! [A3: int,B5: int,N: int] :
      ( ( ord_less @ int @ A3 @ B5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A3 @ N )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B5 @ N )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B5 @ N ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1359_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_1360_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_1361_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1362_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_odd
thf(fact_1363_odd__pos,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% odd_pos
thf(fact_1364_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1365_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1366_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_1367_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B3: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1368_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1369_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1370_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_even_power
thf(fact_1371_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_1372_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_1373_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi3: nat,Ma: nat,V: nat,TreeList: list @ vEBT_VEBT,Vc: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ ( suc @ V ) @ TreeList @ Vc ) @ X2 )
      = ( ( X2 = Mi3 )
        | ( X2 = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_1374_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1375_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ~ ( ord_less_eq @ A @ X @ T3 ) ) ) ).

% pinf(6)
thf(fact_1376_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( ord_less_eq @ A @ T3 @ X ) ) ) ).

% pinf(8)
thf(fact_1377_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z2 )
         => ( ord_less_eq @ A @ X @ T3 ) ) ) ).

% minf(6)
thf(fact_1378_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T3: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z2 )
         => ~ ( ord_less_eq @ A @ T3 @ X ) ) ) ).

% minf(8)
thf(fact_1379_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_1380_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi3: nat,Ma: nat] :
      ( ! [X7: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X7 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
               => ( ( ( Mi3 = Ma )
                   => ! [X7: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X7 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi3 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi3 != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X7: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X7 @ N )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ X7 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi3 @ X7 )
                                      & ( ord_less_eq @ nat @ X7 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_1381_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X2 @ Xa )
     => ( ! [Mi: nat,Ma2: nat] :
            ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
           => ~ ( ( Xa = Mi )
                | ( Xa = Ma2 ) ) )
       => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT] :
              ( ? [Vc2: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
             => ~ ( ( Xa = Mi )
                  | ( Xa = Ma2 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) )
         => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT] :
                ( ? [Vd2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_1382_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_1383_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_1384_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi3: nat,Ma: nat] :
      ( ! [X7: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X7 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
               => ( ( ( Mi3 = Ma )
                   => ! [X7: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X7 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi3 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi3 != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X7: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X7 @ N )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ X7 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi3 @ X7 )
                                      & ( ord_less_eq @ nat @ X7 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_1385_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_1386_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_membermima @ X2 @ Xa )
        = Y2 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => Y2 )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
           => Y2 )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( Y2
                  = ( ~ ( ( Xa = Mi )
                        | ( Xa = Ma2 ) ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
                 => ( Y2
                    = ( ~ ( ( Xa = Mi )
                          | ( Xa = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) )
             => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT] :
                    ( ? [Vd2: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) )
                   => ( Y2
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_1387_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X2 @ Xa )
     => ( ! [Uu2: $o,Uv2: $o] :
            ( X2
           != ( vEBT_Leaf @ Uu2 @ Uv2 ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( ( Xa = Mi )
                  | ( Xa = Ma2 ) ) )
           => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
                 => ( ( Xa = Mi )
                    | ( Xa = Ma2 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) )
             => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT] :
                    ( ? [Vd2: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_1388_div2__even__ext__nat,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( divide_divide @ nat @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X2 )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y2 ) )
       => ( X2 = Y2 ) ) ) ).

% div2_even_ext_nat
thf(fact_1389_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: A,R: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q2 @ R ) )
          = ( R
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_1390_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_1391_vebt__buildup_Oelims,axiom,
    ! [X2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( zero_zero @ nat ) )
         => ( Y2
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X2
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y2
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va: nat] :
                ( ( X2
                  = ( suc @ ( suc @ Va ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_1392_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va2: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_1393_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P3: A > $o,K: A,F3: A > nat,N: nat] :
      ( ( P3 @ K )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
           => ? [Y3: A] :
                ( ( P3 @ Y3 )
                & ~ ( ord_less_eq @ nat @ ( F3 @ Y3 ) @ ( F3 @ X7 ) ) ) )
       => ? [Y5: A] :
            ( ( P3 @ Y5 )
            & ~ ( ord_less @ nat @ ( F3 @ Y5 ) @ ( plus_plus @ nat @ ( F3 @ K ) @ N ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_1394_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: A > nat,X23: A] :
      ( ( size_option @ A @ X2 @ ( some @ A @ X23 ) )
      = ( plus_plus @ nat @ ( X2 @ X23 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_1395_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1396_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1397_intind,axiom,
    ! [A: $tType,I3: nat,N: nat,P3: A > $o,X2: A] :
      ( ( ord_less @ nat @ I3 @ N )
     => ( ( P3 @ X2 )
       => ( P3 @ ( nth @ A @ ( replicate @ A @ N @ X2 ) @ I3 ) ) ) ) ).

% intind
thf(fact_1398_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_1399_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_1400_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_1401_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_1402_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_1403_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_1404_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_1405_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_1406_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_1407_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_1408_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_1409_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_1410_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_Suc_Suc
thf(fact_1411_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N ) @ K ) ) ).

% Suc_diff_diff
thf(fact_1412_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_1413_diff__0__eq__0,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_1414_diff__diff__cancel,axiom,
    ! [I3: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I3 @ N )
     => ( ( minus_minus @ nat @ N @ ( minus_minus @ nat @ N @ I3 ) )
        = I3 ) ) ).

% diff_diff_cancel
thf(fact_1415_diff__diff__left,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ J2 ) @ K )
      = ( minus_minus @ nat @ I3 @ ( plus_plus @ nat @ J2 @ K ) ) ) ).

% diff_diff_left
thf(fact_1416_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P3: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P3 ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P3
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_1417_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_1418_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P3: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P3 )
            = ( zero_zero @ A ) )
          = ( ~ P3 ) ) ) ).

% of_bool_eq_0_iff
thf(fact_1419_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P3: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P3 ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P3
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_1420_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P3: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P3 )
            = ( one_one @ A ) )
          = P3 ) ) ).

% of_bool_eq_1_iff
thf(fact_1421_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1422_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X2: A,N: nat,Y2: A] :
      ( ( ( replicate @ A @ M @ X2 )
        = ( replicate @ A @ N @ Y2 ) )
      = ( ( M = N )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X2 = Y2 ) ) ) ) ).

% replicate_eq_replicate
thf(fact_1423_length__replicate,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N @ X2 ) )
      = N ) ).

% length_replicate
thf(fact_1424_map__replicate,axiom,
    ! [A: $tType,B: $tType,F3: B > A,N: nat,X2: B] :
      ( ( map @ B @ A @ F3 @ ( replicate @ B @ N @ X2 ) )
      = ( replicate @ A @ N @ ( F3 @ X2 ) ) ) ).

% map_replicate
thf(fact_1425_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_1426_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_1427_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_1428_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_1429_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_1430_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_1431_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1432_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1433_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_1434_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P3: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P3 ) )
          = P3 ) ) ).

% zero_less_of_bool_iff
thf(fact_1435_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% zero_less_diff
thf(fact_1436_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_1437_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% diff_is_0_eq
thf(fact_1438_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P3: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P3 ) @ ( one_one @ A ) )
          = ( ~ P3 ) ) ) ).

% of_bool_less_one_iff
thf(fact_1439_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P3: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P3 )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P3 ) ) ) ) ).

% of_bool_not_iff
thf(fact_1440_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( plus_plus @ nat @ I3 @ ( minus_minus @ nat @ J2 @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_1441_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J2 @ K ) @ I3 )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J2 @ I3 ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_1442_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ I3 @ ( minus_minus @ nat @ J2 @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I3 @ K ) @ J2 ) ) ) ).

% Nat.diff_diff_right
thf(fact_1443_diff__Suc__1,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( one_one @ nat ) )
      = N ) ).

% diff_Suc_1
thf(fact_1444_Suc__0__mod__eq,axiom,
    ! [N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_1445_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P3: A > $o] :
      ( ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
           => ( P3 @ X6 ) ) )
      = ( ( P3 @ A2 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_1446_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P3: A > $o] :
      ( ( ? [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
            & ( P3 @ X6 ) ) )
      = ( ( P3 @ A2 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_1447_in__set__replicate,axiom,
    ! [A: $tType,X2: A,N: nat,Y2: A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N @ Y2 ) ) )
      = ( ( X2 = Y2 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_1448_nth__replicate,axiom,
    ! [A: $tType,I3: nat,N: nat,X2: A] :
      ( ( ord_less @ nat @ I3 @ N )
     => ( ( nth @ A @ ( replicate @ A @ N @ X2 ) @ I3 )
        = X2 ) ) ).

% nth_replicate
thf(fact_1449_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_product
thf(fact_1450_Suc__pred,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% Suc_pred
thf(fact_1451_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J2 @ K ) ) @ I3 )
        = ( minus_minus @ nat @ ( suc @ J2 ) @ ( plus_plus @ nat @ K @ I3 ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_1452_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ I3 @ ( suc @ ( minus_minus @ nat @ J2 @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( suc @ J2 ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_1453_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P5: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P5 ) ) )
          = P5 ) ) ).

% odd_of_bool_self
thf(fact_1454_Suc__diff__1,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
        = N ) ) ).

% Suc_diff_1
thf(fact_1455_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_1456_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_1457_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% odd_Suc_minus_one
thf(fact_1458_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ).

% even_diff_nat
thf(fact_1459_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1460_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1461_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1462_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1463_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1464_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_1465_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_1466_diff__commute,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ J2 ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ K ) @ J2 ) ) ).

% diff_commute
thf(fact_1467_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P5: $o,Q2: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P5 )
            = ( zero_neq_one_of_bool @ A @ Q2 ) )
          = ( P5 = Q2 ) ) ) ).

% of_bool_eq_iff
thf(fact_1468_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P3: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P3
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P3 ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_1469_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_1470_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_1471_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_1472_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_1473_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( minus_minus @ A @ A5 @ B4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_1474_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_1475_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_1476_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_1477_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_1478_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_1479_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_1480_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A2 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% left_diff_distrib'
thf(fact_1481_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_1482_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P3: A > $o,D4: A,Q: A > $o] :
          ( ! [X7: A,K3: A] :
              ( ( P3 @ X7 )
              = ( P3 @ ( minus_minus @ A @ X7 @ ( times_times @ A @ K3 @ D4 ) ) ) )
         => ( ! [X7: A,K3: A] :
                ( ( Q @ X7 )
                = ( Q @ ( minus_minus @ A @ X7 @ ( times_times @ A @ K3 @ D4 ) ) ) )
           => ! [X: A,K4: A] :
                ( ( ( P3 @ X )
                  | ( Q @ X ) )
                = ( ( P3 @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) )
                  | ( Q @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1483_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P3: A > $o,D4: A,Q: A > $o] :
          ( ! [X7: A,K3: A] :
              ( ( P3 @ X7 )
              = ( P3 @ ( minus_minus @ A @ X7 @ ( times_times @ A @ K3 @ D4 ) ) ) )
         => ( ! [X7: A,K3: A] :
                ( ( Q @ X7 )
                = ( Q @ ( minus_minus @ A @ X7 @ ( times_times @ A @ K3 @ D4 ) ) ) )
           => ! [X: A,K4: A] :
                ( ( ( P3 @ X )
                  & ( Q @ X ) )
                = ( ( P3 @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) )
                  & ( Q @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1484_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_1485_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_1486_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_1487_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_1488_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_1489_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_1490_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_1491_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_1492_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_1493_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_1494_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_1495_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_1496_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( ( dvd_dvd @ A @ X2 @ Z )
           => ( dvd_dvd @ A @ X2 @ ( minus_minus @ A @ Y2 @ Z ) ) ) ) ) ).

% dvd_diff
thf(fact_1497_zero__induct__lemma,axiom,
    ! [P3: nat > $o,K: nat,I3: nat] :
      ( ( P3 @ K )
     => ( ! [N3: nat] :
            ( ( P3 @ ( suc @ N3 ) )
           => ( P3 @ N3 ) )
       => ( P3 @ ( minus_minus @ nat @ K @ I3 ) ) ) ) ).

% zero_induct_lemma
thf(fact_1498_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N @ M )
          = ( zero_zero @ nat ) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
thf(fact_1499_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_1500_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_1501_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_1502_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_1503_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_1504_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ord_less @ nat @ M @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_1505_less__imp__diff__less,axiom,
    ! [J2: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ J2 @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J2 @ N ) @ K ) ) ).

% less_imp_diff_less
thf(fact_1506_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N @ K ) )
          = ( M = N ) ) ) ) ).

% eq_diff_iff
thf(fact_1507_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% le_diff_iff
thf(fact_1508_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_1509_diff__le__mono,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L ) @ ( minus_minus @ nat @ N @ L ) ) ) ).

% diff_le_mono
thf(fact_1510_diff__le__self,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ).

% diff_le_self
thf(fact_1511_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_1512_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ).

% diff_le_mono2
thf(fact_1513_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% Nat.diff_cancel
thf(fact_1514_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_cancel2
thf(fact_1515_diff__add__inverse,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N @ M ) @ N )
      = M ) ).

% diff_add_inverse
thf(fact_1516_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ N )
      = M ) ).

% diff_add_inverse2
thf(fact_1517_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% diff_mult_distrib2
thf(fact_1518_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% diff_mult_distrib
thf(fact_1519_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% dvd_diff_nat
thf(fact_1520_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P3: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P3 ) ) ) ).

% zero_less_eq_of_bool
thf(fact_1521_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P3: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P3 ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1522_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P4: $o] : ( if @ A @ P4 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1523_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P3: A > $o,P5: $o] :
          ( ( P3 @ ( zero_neq_one_of_bool @ A @ P5 ) )
          = ( ( P5
             => ( P3 @ ( one_one @ A ) ) )
            & ( ~ P5
             => ( P3 @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1524_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P3: A > $o,P5: $o] :
          ( ( P3 @ ( zero_neq_one_of_bool @ A @ P5 ) )
          = ( ~ ( ( P5
                  & ~ ( P3 @ ( one_one @ A ) ) )
                | ( ~ P5
                  & ~ ( P3 @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1525_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1526_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_1527_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_1528_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1529_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_1530_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_1531_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1532_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1533_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1534_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1535_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1536_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1537_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1538_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1539_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: A,K: A,N: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N )
         => ( ord_less_eq @ A @ I3 @ ( minus_minus @ A @ N @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_1540_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: A,K: A,N: A,J2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N )
         => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J2 @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N )
             => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J2 @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N @ K ) @ J2 ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_1541_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_1542_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_1543_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_1544_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X2: A,Y2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) )
          = ( times_times @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ A @ X2 @ Y2 ) ) ) ) ).

% square_diff_square_factored
thf(fact_1545_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_1546_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_1547_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X2: A,Y2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ Y2 ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X2 @ ( minus_minus @ A @ Y2 @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X2 @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_1548_replicate__length__same,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( X7 = X2 ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X2 )
        = Xs ) ) ).

% replicate_length_same
thf(fact_1549_replicate__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X2: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = N )
     => ( ! [Y5: A] :
            ( ( member @ A @ Y5 @ ( set2 @ A @ Xs ) )
           => ( Y5 = X2 ) )
       => ( Xs
          = ( replicate @ A @ N @ X2 ) ) ) ) ).

% replicate_eqI
thf(fact_1550_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A] : ( dvd_dvd @ A @ B2 @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% dvd_minus_mod
thf(fact_1551_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_1552_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_1553_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N ) ) )
        = ( minus_minus @ nat @ M @ N ) ) ) ).

% Suc_diff_Suc
thf(fact_1554_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ) ) ).

% diff_less
thf(fact_1555_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( suc @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Suc_diff_le
thf(fact_1556_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less @ nat @ M @ N ) ) ) ) ).

% less_diff_iff
thf(fact_1557_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_1558_diff__add__0,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ N @ ( plus_plus @ nat @ N @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_1559_less__diff__conv,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ ( minus_minus @ nat @ J2 @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ K ) @ J2 ) ) ).

% less_diff_conv
thf(fact_1560_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( plus_plus @ nat @ N @ ( minus_minus @ nat @ M @ N ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_1561_le__diff__conv,axiom,
    ! [J2: nat,K: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J2 @ K ) @ I3 )
      = ( ord_less_eq @ nat @ J2 @ ( plus_plus @ nat @ I3 @ K ) ) ) ).

% le_diff_conv
thf(fact_1562_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( ord_less_eq @ nat @ I3 @ ( minus_minus @ nat @ J2 @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ K ) @ J2 ) ) ) ).

% Nat.le_diff_conv2
thf(fact_1563_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ K )
        = ( plus_plus @ nat @ I3 @ ( minus_minus @ nat @ J2 @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_1564_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J2 @ I3 ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J2 @ K ) @ I3 ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_1565_Nat_Ole__imp__diff__is__add,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( ( minus_minus @ nat @ J2 @ I3 )
          = K )
        = ( J2
          = ( plus_plus @ nat @ K @ I3 ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_1566_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1567_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) )
      = ( ( ord_less @ nat @ N @ M )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_minus_self
thf(fact_1568_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_1569_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ N ) ) ) ) ).

% dvd_diffD1
thf(fact_1570_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_1571_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D3: nat,X7: nat,Y5: nat] :
      ( ( dvd_dvd @ nat @ D3 @ A2 )
      & ( dvd_dvd @ nat @ D3 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X7 ) @ ( times_times @ nat @ B2 @ Y5 ) )
          = D3 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X7 ) @ ( times_times @ nat @ A2 @ Y5 ) )
          = D3 ) ) ) ).

% bezout1_nat
thf(fact_1572_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M4: nat,N2: nat] : ( if @ nat @ ( ord_less @ nat @ M4 @ N2 ) @ M4 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M4 @ N2 ) @ N2 ) ) ) ) ).

% mod_if
thf(fact_1573_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% mod_geq
thf(fact_1574_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% le_mod_geq
thf(fact_1575_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,D3: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ D3 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT,Deg3: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_1576_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X6: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_1577_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs2: list @ A,Ys2: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X6: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 ) @ Ys2 )
              @ Xs2 ) ) ) ) ).

% product_concat_map
thf(fact_1578_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_1579_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_1580_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_1581_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_1582_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1583_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1584_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X2 @ ( divide_divide @ A @ Y2 @ Z ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ Y2 ) @ Z ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1585_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X2 @ Z ) @ Y2 )
            = ( divide_divide @ A @ ( minus_minus @ A @ X2 @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1586_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1587_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D4: A,T3: A] :
          ( ( dvd_dvd @ A @ D2 @ D4 )
         => ! [X: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X @ T3 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) @ T3 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1588_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D4: A,T3: A] :
          ( ( dvd_dvd @ A @ D2 @ D4 )
         => ! [X: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X @ T3 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) @ T3 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1589_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1590_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1591_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1592_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1593_diff__Suc__less,axiom,
    ! [N: nat,I3: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N @ ( suc @ I3 ) ) @ N ) ) ).

% diff_Suc_less
thf(fact_1594_nat__diff__split,axiom,
    ! [P3: nat > $o,A2: nat,B2: nat] :
      ( ( P3 @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P3 @ ( zero_zero @ nat ) ) )
        & ! [D5: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D5 ) )
           => ( P3 @ D5 ) ) ) ) ).

% nat_diff_split
thf(fact_1595_nat__diff__split__asm,axiom,
    ! [P3: nat > $o,A2: nat,B2: nat] :
      ( ( P3 @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P3 @ ( zero_zero @ nat ) ) )
            | ? [D5: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D5 ) )
                & ~ ( P3 @ D5 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_1596_less__diff__conv2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J2 @ K ) @ I3 )
        = ( ord_less @ nat @ J2 @ ( plus_plus @ nat @ I3 @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_1597_nat__diff__add__eq2,axiom,
    ! [I3: nat,J2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J2 @ I3 ) @ U ) @ N ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_1598_nat__diff__add__eq1,axiom,
    ! [J2: nat,I3: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I3 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I3 @ J2 ) @ U ) @ M ) @ N ) ) ) ).

% nat_diff_add_eq1
thf(fact_1599_nat__le__add__iff2,axiom,
    ! [I3: nat,J2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J2 @ I3 ) @ U ) @ N ) ) ) ) ).

% nat_le_add_iff2
thf(fact_1600_nat__le__add__iff1,axiom,
    ! [J2: nat,I3: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I3 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I3 @ J2 ) @ U ) @ M ) @ N ) ) ) ).

% nat_le_add_iff1
thf(fact_1601_nat__eq__add__iff2,axiom,
    ! [I3: nat,J2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J2 @ I3 ) @ U ) @ N ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_1602_nat__eq__add__iff1,axiom,
    ! [J2: nat,I3: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I3 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I3 @ J2 ) @ U ) @ M )
          = N ) ) ) ).

% nat_eq_add_iff1
thf(fact_1603_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q2 )
          = ( modulo_modulo @ nat @ N @ Q2 ) )
        = ( dvd_dvd @ nat @ Q2 @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_1604_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M4: nat,N2: nat] : ( minus_minus @ nat @ M4 @ ( times_times @ nat @ ( divide_divide @ nat @ M4 @ N2 ) @ N2 ) ) ) ) ).

% modulo_nat_def
thf(fact_1605_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_1606_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1607_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1608_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y2 @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_1609_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_diff
thf(fact_1610_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1611_Suc__pred_H,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( N
        = ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1612_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M4 @ N2 )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M4 @ N2 ) @ N2 ) ) ) ) ) ).

% div_if
thf(fact_1613_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% div_geq
thf(fact_1614_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( if @ nat
          @ ( M4
            = ( zero_zero @ nat ) )
          @ N2
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M4 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% add_eq_if
thf(fact_1615_nat__less__add__iff1,axiom,
    ! [J2: nat,I3: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I3 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I3 @ J2 ) @ U ) @ M ) @ N ) ) ) ).

% nat_less_add_iff1
thf(fact_1616_nat__less__add__iff2,axiom,
    ! [I3: nat,J2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J2 @ I3 ) @ U ) @ N ) ) ) ) ).

% nat_less_add_iff2
thf(fact_1617_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( if @ nat
          @ ( M4
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( minus_minus @ nat @ M4 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% mult_eq_if
thf(fact_1618_dvd__minus__add,axiom,
    ! [Q2: nat,N: nat,R: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q2 @ N )
     => ( ( ord_less_eq @ nat @ Q2 @ ( times_times @ nat @ R @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ Q2 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N @ ( minus_minus @ nat @ ( times_times @ nat @ R @ M ) @ Q2 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1619_mod__nat__eqI,axiom,
    ! [R: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ R @ N )
     => ( ( ord_less_eq @ nat @ R @ M )
       => ( ( dvd_dvd @ nat @ N @ ( minus_minus @ nat @ M @ R ) )
         => ( ( modulo_modulo @ nat @ M @ N )
            = R ) ) ) ) ).

% mod_nat_eqI
thf(fact_1620_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A4: $o,B3: $o,X7: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B3 ) @ X7 ) )
     => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT,S2: vEBT_VEBT,X7: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) @ X7 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_1621_VEBT__internal_Oelim__dead_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ extended_enat] :
      ( ! [A4: $o,B3: $o,Uu2: extended_enat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Leaf @ A4 @ B3 ) @ Uu2 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList2 @ Summary2 ) @ ( extend4730790105801354508finity @ extended_enat ) ) )
       => ~ ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT,L2: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList2 @ Summary2 ) @ ( extended_enat2 @ L2 ) ) ) ) ) ).

% VEBT_internal.elim_dead.cases
thf(fact_1622_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_1623_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V: A,R: A,S: A] :
          ( ( ord_less_eq @ A @ U @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
           => ( ( ord_less_eq @ A @ R @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R @ ( minus_minus @ A @ V @ U ) ) @ S ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_1624_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_1625_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1626_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P4: A,M4: nat] :
              ( if @ A
              @ ( M4
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P4 @ ( power_power @ A @ P4 @ ( minus_minus @ nat @ M4 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1627_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_1628_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) ) ) ) ).

% diff_le_diff_pow
thf(fact_1629_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% le_div_geq
thf(fact_1630_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P3: A > $o,A2: A] :
          ( ! [A4: A] :
              ( ( ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A4 )
             => ( P3 @ A4 ) )
         => ( ! [A4: A,B3: $o] :
                ( ( P3 @ A4 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B3 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A4 )
                 => ( P3 @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B3 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) ) ) )
           => ( P3 @ A2 ) ) ) ) ).

% bits_induct
thf(fact_1631_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_1632_list__decode_Ocases,axiom,
    ! [X2: nat] :
      ( ( X2
       != ( zero_zero @ nat ) )
     => ~ ! [N3: nat] :
            ( X2
           != ( suc @ N3 ) ) ) ).

% list_decode.cases
thf(fact_1633_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) ) ) ) ).

% power2_diff
thf(fact_1634_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P3: A > $o,K: A,F3: A > nat,B2: nat] :
      ( ( P3 @ K )
     => ( ! [Y5: A] :
            ( ( P3 @ Y5 )
           => ( ord_less @ nat @ ( F3 @ Y5 ) @ B2 ) )
       => ? [X7: A] :
            ( ( P3 @ X7 )
            & ! [Y3: A] :
                ( ( P3 @ Y3 )
               => ( ord_less_eq @ nat @ ( F3 @ Y3 ) @ ( F3 @ X7 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_1635_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_1636_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1637_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1638_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Uw2 ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X7: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ X7 ) )
         => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X7: nat] :
                ( X2
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) @ X7 ) )
           => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X7: nat] :
                  ( X2
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) @ X7 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_1639_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_1640_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X2: A > nat] :
      ( ( size_option @ A @ X2 @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_1641_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_1642_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_1643_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R: A,Q2: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ R ) ) ) ) ) ).

% divmod_step_eq
thf(fact_1644_psubsetI,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B5 )
     => ( ( A3 != B5 )
       => ( ord_less @ ( set @ A ) @ A3 @ B5 ) ) ) ).

% psubsetI
thf(fact_1645_Suc__if__eq,axiom,
    ! [A: $tType,F3: nat > A,H: nat > A,G: A,N: nat] :
      ( ! [N3: nat] :
          ( ( F3 @ ( suc @ N3 ) )
          = ( H @ N3 ) )
     => ( ( ( F3 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( F3 @ N )
              = G ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( F3 @ N )
              = ( H @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1646_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N2: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_1647_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_1648_VEBT__internal_Oelim__dead_Opelims,axiom,
    ! [X2: vEBT_VEBT,Xa: extended_enat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_VEBT_elim_dead @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ X2 @ Xa ) )
       => ( ! [A4: $o,B3: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A4 @ B3 ) )
             => ( ( Y2
                  = ( vEBT_Leaf @ A4 @ B3 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Leaf @ A4 @ B3 ) @ Xa ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Info2 @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( Xa
                    = ( extend4730790105801354508finity @ extended_enat ) )
                 => ( ( Y2
                      = ( vEBT_Node @ Info2 @ Deg2
                        @ ( map @ vEBT_VEBT @ vEBT_VEBT
                          @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          @ TreeList2 )
                        @ ( vEBT_VEBT_elim_dead @ Summary2 @ ( extend4730790105801354508finity @ extended_enat ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList2 @ Summary2 ) @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) )
           => ~ ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Info2 @ Deg2 @ TreeList2 @ Summary2 ) )
                 => ! [L2: nat] :
                      ( ( Xa
                        = ( extended_enat2 @ L2 ) )
                     => ( ( Y2
                          = ( vEBT_Node @ Info2 @ Deg2
                            @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                              @ ( map @ vEBT_VEBT @ vEBT_VEBT
                                @ ^ [T2: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T2 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                @ TreeList2 ) )
                            @ ( vEBT_VEBT_elim_dead @ Summary2 @ ( extended_enat2 @ ( divide_divide @ nat @ L2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList2 @ Summary2 ) @ ( extended_enat2 @ L2 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.pelims
thf(fact_1649_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1650_verit__minus__simplify_I4_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( uminus_uminus @ B @ ( uminus_uminus @ B @ B2 ) )
          = B2 ) ) ).

% verit_minus_simplify(4)
thf(fact_1651_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_1652_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_1653_idiff__infinity,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ N )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% idiff_infinity
thf(fact_1654_idiff__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_1655_idiff__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = N ) ).

% idiff_0_right
thf(fact_1656_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1657_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_1658_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_1659_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_1660_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_1661_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_1662_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1663_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( M = N ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1664_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_1665_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_1666_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_1667_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1668_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1669_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1670_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_1671_div__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% div_minus_minus
thf(fact_1672_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( dvd_dvd @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) )
          = ( dvd_dvd @ A @ X2 @ Y2 ) ) ) ).

% dvd_minus_iff
thf(fact_1673_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 )
          = ( dvd_dvd @ A @ X2 @ Y2 ) ) ) ).

% minus_dvd_iff
thf(fact_1674_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_minus_minus
thf(fact_1675_real__add__minus__iff,axiom,
    ! [X2: real,A2: real] :
      ( ( ( plus_plus @ real @ X2 @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X2 = A2 ) ) ).

% real_add_minus_iff
thf(fact_1676_idiff__enat__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( extended_enat2 @ ( zero_zero @ nat ) ) )
      = N ) ).

% idiff_enat_0_right
thf(fact_1677_idiff__enat__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ ( zero_zero @ nat ) ) @ N )
      = ( extended_enat2 @ ( zero_zero @ nat ) ) ) ).

% idiff_enat_0
thf(fact_1678_idiff__enat__enat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ A2 ) @ ( extended_enat2 @ B2 ) )
      = ( extended_enat2 @ ( minus_minus @ nat @ A2 @ B2 ) ) ) ).

% idiff_enat_enat
thf(fact_1679_idiff__self,axiom,
    ! [N: extended_enat] :
      ( ( N
       != ( extend4730790105801354508finity @ extended_enat ) )
     => ( ( minus_minus @ extended_enat @ N @ N )
        = ( zero_zero @ extended_enat ) ) ) ).

% idiff_self
thf(fact_1680_add__diff__cancel__enat,axiom,
    ! [X2: extended_enat,Y2: extended_enat] :
      ( ( X2
       != ( extend4730790105801354508finity @ extended_enat ) )
     => ( ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X2 @ Y2 ) @ X2 )
        = Y2 ) ) ).

% add_diff_cancel_enat
thf(fact_1681_triangle__0,axiom,
    ( ( nat_triangle @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) ) ).

% triangle_0
thf(fact_1682_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1683_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1684_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1685_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1686_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1687_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_1688_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1689_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1690_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1691_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1692_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_1693_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_1694_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_1695_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1
thf(fact_1696_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1_right
thf(fact_1697_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1698_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1699_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% div_minus1_right
thf(fact_1700_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A] :
          ( ( divide_divide @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X2 ) ) ) ).

% divide_minus1
thf(fact_1701_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_1702_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_1703_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z ) ) ).

% zle_diff1_eq
thf(fact_1704_idiff__infinity__right,axiom,
    ! [A2: nat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ A2 ) @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_infinity_right
thf(fact_1705_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_1706_triangle__Suc,axiom,
    ! [N: nat] :
      ( ( nat_triangle @ ( suc @ N ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N ) @ ( suc @ N ) ) ) ).

% triangle_Suc
thf(fact_1707_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1708_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1709_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1710_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1711_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1712_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_1713_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1714_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1715_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(168)
thf(fact_1716_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_1717_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_1718_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Y2 ) ) ) ).

% semiring_norm(172)
thf(fact_1719_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(171)
thf(fact_1720_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(170)
thf(fact_1721_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1722_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1723_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1724_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_1725_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_1726_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1727_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1728_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1729_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1730_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1731_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1732_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1733_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1734_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_1735_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1736_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1737_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1738_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1739_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1740_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1741_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_1742_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_1743_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_minus_odd
thf(fact_1744_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1745_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1746_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_1747_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1748_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1749_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1750_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1751_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_1752_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X6: real,Y: real] : ( plus_plus @ real @ X6 @ ( uminus_uminus @ real @ Y ) ) ) ) ).

% minus_real_def
thf(fact_1753_unique__quotient,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R4: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R4 ) )
       => ( Q2 = Q5 ) ) ) ).

% unique_quotient
thf(fact_1754_unique__remainder,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R4: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R4 ) )
       => ( R = R4 ) ) ) ).

% unique_remainder
thf(fact_1755_minus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L )
      = ( uminus_uminus @ int @ L ) ) ).

% minus_int_code(2)
thf(fact_1756_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
     => ? [B3: A] : ( member @ A @ B3 @ ( minus_minus @ ( set @ A ) @ B5 @ A3 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_1757_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
         => ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) ) ) ) ).

% verit_negate_coefficient(3)
thf(fact_1758_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_1759_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_1760_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q2 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q2 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_1761_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_1762_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_1763_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_1764_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_1765_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_1766_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_1767_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_1768_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_1769_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_1770_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_1771_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_1772_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_1773_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_1774_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1775_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1776_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_1777_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_1778_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_1779_div__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% div_minus_right
thf(fact_1780_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_1781_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_1782_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_1783_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_1784_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% mod_minus_eq
thf(fact_1785_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,A6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( modulo_modulo @ A @ A6 @ B2 ) )
         => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A6 ) @ B2 ) ) ) ) ).

% mod_minus_cong
thf(fact_1786_mod__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% mod_minus_right
thf(fact_1787_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% uminus_int_code(1)
thf(fact_1788_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( minus_minus @ int @ Z1 @ Z22 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(4)
thf(fact_1789_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z22 ) @ W )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(3)
thf(fact_1790_signed__take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% signed_take_bit_diff
thf(fact_1791_signed__take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_1792_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_1793_div__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( divide_divide @ int @ K @ L )
        = Q2 ) ) ).

% div_int_unique
thf(fact_1794_mod__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( modulo_modulo @ int @ K @ L )
        = R ) ) ).

% mod_int_unique
thf(fact_1795_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_1796_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_1797_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_1798_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_le_numeral
thf(fact_1799_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_1800_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_less_numeral
thf(fact_1801_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_1802_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1803_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1804_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_1805_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1806_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1807_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1808_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1809_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1810_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_1811_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_1812_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X2 ) )
          = ( times_times @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1813_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1814_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1815_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1816_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1817_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X2: A] :
          ( ( ( times_times @ A @ X2 @ X2 )
            = ( one_one @ A ) )
          = ( ( X2
              = ( one_one @ A ) )
            | ( X2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_1818_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_1819_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_1820_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1821_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1822_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B5: A,K: A,B2: A,A2: A] :
          ( ( B5
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B5 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1823_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_1824_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_1825_real__minus__mult__self__le,axiom,
    ! [U: real,X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X2 @ X2 ) ) ).

% real_minus_mult_self_le
thf(fact_1826_int__less__induct,axiom,
    ! [I3: int,K: int,P3: int > $o] :
      ( ( ord_less @ int @ I3 @ K )
     => ( ( P3 @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ I2 @ K )
             => ( ( P3 @ I2 )
               => ( P3 @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P3 @ I3 ) ) ) ) ).

% int_less_induct
thf(fact_1827_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_1828_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_1829_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_1830_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_1831_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y2: extended_enat,X2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z @ Y2 )
     => ( ( plus_plus @ extended_enat @ X2 @ ( minus_minus @ extended_enat @ Y2 @ Z ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X2 @ Y2 ) @ Z ) ) ) ).

% add_diff_assoc_enat
thf(fact_1832_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_1833_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_1834_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_1835_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_1836_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_1837_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_1838_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_1839_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_1840_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_1841_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_1842_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_1843_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_1844_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_1845_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_1846_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_1847_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_1848_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_1849_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_1850_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_1851_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1852_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1853_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1854_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_1855_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_1856_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_1857_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_1858_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus
thf(fact_1859_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_1860_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q2: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q2 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_1861_real__add__less__0__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y2 @ ( uminus_uminus @ real @ X2 ) ) ) ).

% real_add_less_0_iff
thf(fact_1862_real__0__less__add__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ Y2 ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X2 ) @ Y2 ) ) ).

% real_0_less_add_iff
thf(fact_1863_real__add__le__0__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y2 @ ( uminus_uminus @ real @ X2 ) ) ) ).

% real_add_le_0_iff
thf(fact_1864_real__0__le__add__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ Y2 ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X2 ) @ Y2 ) ) ).

% real_0_le_add_iff
thf(fact_1865_plusinfinity,axiom,
    ! [D2: int,P6: int > $o,P3: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X7: int,K3: int] :
            ( ( P6 @ X7 )
            = ( P6 @ ( minus_minus @ int @ X7 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X7: int] :
              ( ( ord_less @ int @ Z4 @ X7 )
             => ( ( P3 @ X7 )
                = ( P6 @ X7 ) ) )
         => ( ? [X_1: int] : ( P6 @ X_1 )
           => ? [X_12: int] : ( P3 @ X_12 ) ) ) ) ) ).

% plusinfinity
thf(fact_1866_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P3: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X7: int,K3: int] :
            ( ( P1 @ X7 )
            = ( P1 @ ( minus_minus @ int @ X7 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X7: int] :
              ( ( ord_less @ int @ X7 @ Z4 )
             => ( ( P3 @ X7 )
                = ( P1 @ X7 ) ) )
         => ( ? [X_1: int] : ( P1 @ X_1 )
           => ? [X_12: int] : ( P3 @ X_12 ) ) ) ) ) ).

% minusinfinity
thf(fact_1867_eucl__rel__int,axiom,
    ! [K: int,L: int] : ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% eucl_rel_int
thf(fact_1868_psubsetD,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A,C2: A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B5 ) ) ) ).

% psubsetD
thf(fact_1869_psubset__trans,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
     => ( ( ord_less @ ( set @ A ) @ B5 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% psubset_trans
thf(fact_1870_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1871_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1872_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1873_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1874_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1875_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1876_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_1877_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_1878_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X2 @ Z ) ) @ Y2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X2 ) @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1879_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1880_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X2 @ Z ) ) @ Y2 )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X2 ) @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1881_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1882_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1883_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_minus
thf(fact_1884_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X2 = Y2 )
            | ( X2
              = ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% power2_eq_iff
thf(fact_1885_decr__mult__lemma,axiom,
    ! [D2: int,P3: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X7: int] :
            ( ( P3 @ X7 )
           => ( P3 @ ( minus_minus @ int @ X7 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X: int] :
              ( ( P3 @ X )
             => ( P3 @ ( minus_minus @ int @ X @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1886_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L ) @ L ) ) ) ) ).

% mod_pos_geq
thf(fact_1887_verit__less__mono__div__int2,axiom,
    ! [A3: int,B5: int,N: int] :
      ( ( ord_less_eq @ int @ A3 @ B5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B5 @ N ) @ ( divide_divide @ int @ A3 @ N ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_1888_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_1889_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_1890_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X6: A] : ( member @ A @ X6 @ A7 )
            @ ^ [X6: A] : ( member @ A @ X6 @ B8 ) ) ) ) ).

% less_eq_set_def
thf(fact_1891_Collect__subset,axiom,
    ! [A: $tType,A3: set @ A,P3: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X6: A] :
            ( ( member @ A @ X6 @ A3 )
            & ( P3 @ X6 ) ) )
      @ A3 ) ).

% Collect_subset
thf(fact_1892_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_1893_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_1894_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_1895_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1896_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1897_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1898_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_1899_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_1900_less__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less @ ( A > $o )
            @ ^ [X6: A] : ( member @ A @ X6 @ A7 )
            @ ^ [X6: A] : ( member @ A @ X6 @ B8 ) ) ) ) ).

% less_set_def
thf(fact_1901_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_1902_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( power_power @ A @ A2 @ N ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_1903_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1904_realpow__square__minus__le,axiom,
    ! [U: real,X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_1905_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_diff_iff
thf(fact_1906_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_1907_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_1908_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_1909_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_1910_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_1911_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1912_diff__enat__def,axiom,
    ( ( minus_minus @ extended_enat )
    = ( ^ [A5: extended_enat,B4: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [X6: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [Y: nat] : ( extended_enat2 @ ( minus_minus @ nat @ X6 @ Y ) )
              @ ( zero_zero @ extended_enat )
              @ B4 )
          @ ( extend4730790105801354508finity @ extended_enat )
          @ A5 ) ) ) ).

% diff_enat_def
thf(fact_1913_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_1914_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_1915_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_1916_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_1917_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_1918_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_1919_psubsetE,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B5 )
         => ( ord_less_eq @ ( set @ A ) @ B5 @ A3 ) ) ) ).

% psubsetE
thf(fact_1920_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( A7 != B8 ) ) ) ) ).

% psubset_eq
thf(fact_1921_psubset__imp__subset,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B5 ) ) ).

% psubset_imp_subset
thf(fact_1922_psubset__subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% psubset_subset_trans
thf(fact_1923_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_1924_subset__psubset__trans,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B5 )
     => ( ( ord_less @ ( set @ A ) @ B5 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% subset_psubset_trans
thf(fact_1925_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
            | ( A7 = B8 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_1926_int__bit__induct,axiom,
    ! [P3: int > $o,K: int] :
      ( ( P3 @ ( zero_zero @ int ) )
     => ( ( P3 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K3: int] :
              ( ( P3 @ K3 )
             => ( ( K3
                 != ( zero_zero @ int ) )
               => ( P3 @ ( times_times @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K3: int] :
                ( ( P3 @ K3 )
               => ( ( K3
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P3 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P3 @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_1927_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q2 ) @ R ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
            & ( ord_less @ int @ R @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R )
                & ( ord_less_eq @ int @ R @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q2
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_1928_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_1929_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_1930_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_1931_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1932_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_1933_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_1934_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_1935_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X6: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 ) @ Ys )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_1936_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% compl_less_compl_iff
thf(fact_1937_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) )
           => ( ! [Mi: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
                   => ( ( Xa = Mi )
                      | ( Xa = Ma2 ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) @ Xa ) )
                     => ( ( Xa = Mi )
                        | ( Xa = Ma2 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) )
               => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) @ Xa ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_1938_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_membermima @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ~ Y2
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( Y2
                      = ( ( Xa = Mi )
                        | ( Xa = Ma2 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
                   => ( ( Y2
                        = ( ( Xa = Mi )
                          | ( Xa = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) @ Xa ) ) ) )
               => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) )
                     => ( ( Y2
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_1939_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( plus_plus @ int @ Q2
        @ ( zero_neq_one_of_bool @ int
          @ ( R
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_1940_minus__set__def,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( collect @ A
            @ ( minus_minus @ ( A > $o )
              @ ^ [X6: A] : ( member @ A @ X6 @ A7 )
              @ ^ [X6: A] : ( member @ A @ X6 @ B8 ) ) ) ) ) ).

% minus_set_def
thf(fact_1941_set__diff__eq,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( collect @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ A7 )
                & ~ ( member @ A @ X6 @ B8 ) ) ) ) ) ).

% set_diff_eq
thf(fact_1942_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X6: A] : ( times_times @ A @ X6 @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_1943_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ ( uminus_uminus @ A @ X2 ) )
         => ( ord_less @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% compl_less_swap1
thf(fact_1944_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y2 ) @ X2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) ) ) ).

% compl_less_swap2
thf(fact_1945_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Mi: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
               => ~ ( ( Xa = Mi )
                    | ( Xa = Ma2 ) ) ) )
         => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) @ Xa ) )
                 => ~ ( ( Xa = Mi )
                      | ( Xa = Ma2 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) )
           => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd2 ) @ Xa ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_1946_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A4: $o,B3: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A4 @ B3 ) )
             => ( ( Y2
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B3 ) @ Xa ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) )
                 => ( ( Y2
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) @ Xa ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_1947_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A4: $o,B3: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A4 @ B3 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B3 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) @ Xa ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_1948_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A4: $o,B3: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A4 @ B3 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B3 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A4 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B3 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList2 @ S2 ) @ Xa ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_1949_Bolzano,axiom,
    ! [A2: real,B2: real,P3: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A4: real,B3: real,C3: real] :
            ( ( P3 @ A4 @ B3 )
           => ( ( P3 @ B3 @ C3 )
             => ( ( ord_less_eq @ real @ A4 @ B3 )
               => ( ( ord_less_eq @ real @ B3 @ C3 )
                 => ( P3 @ A4 @ C3 ) ) ) ) )
       => ( ! [X7: real] :
              ( ( ord_less_eq @ real @ A2 @ X7 )
             => ( ( ord_less_eq @ real @ X7 @ B2 )
               => ? [D6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                    & ! [A4: real,B3: real] :
                        ( ( ( ord_less_eq @ real @ A4 @ X7 )
                          & ( ord_less_eq @ real @ X7 @ B3 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B3 @ A4 ) @ D6 ) )
                       => ( P3 @ A4 @ B3 ) ) ) ) )
         => ( P3 @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_1950_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_1951_semiring__norm_I90_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(90)
thf(fact_1952_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( ( bit1 @ X32 )
        = ( bit1 @ Y32 ) )
      = ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
thf(fact_1953_semiring__norm_I88_J,axiom,
    ! [M: num,N: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N ) ) ).

% semiring_norm(88)
thf(fact_1954_semiring__norm_I89_J,axiom,
    ! [M: num,N: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N ) ) ).

% semiring_norm(89)
thf(fact_1955_semiring__norm_I84_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit1 @ N ) ) ).

% semiring_norm(84)
thf(fact_1956_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_1957_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(73)
thf(fact_1958_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(80)
thf(fact_1959_semiring__norm_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(9)
thf(fact_1960_semiring__norm_I7_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(7)
thf(fact_1961_semiring__norm_I15_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N ) ) ) ).

% semiring_norm(15)
thf(fact_1962_semiring__norm_I14_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N ) ) ) ) ).

% semiring_norm(14)
thf(fact_1963_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(72)
thf(fact_1964_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(81)
thf(fact_1965_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_1966_semiring__norm_I77_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit1 @ N ) ) ).

% semiring_norm(77)
thf(fact_1967_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_1968_semiring__norm_I3_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) ).

% semiring_norm(3)
thf(fact_1969_semiring__norm_I4_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_1970_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_1971_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_1972_semiring__norm_I10_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_1973_semiring__norm_I16_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_1974_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(79)
thf(fact_1975_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(74)
thf(fact_1976_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_1977_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_1978_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_1979_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_1980_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_1981_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_1982_verit__eq__simplify_I14_J,axiom,
    ! [X23: num,X32: num] :
      ( ( bit0 @ X23 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_1983_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_1984_num_Oexhaust,axiom,
    ! [Y2: num] :
      ( ( Y2 != one2 )
     => ( ! [X24: num] :
            ( Y2
           != ( bit0 @ X24 ) )
       => ~ ! [X33: num] :
              ( Y2
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_1985_xor__num_Ocases,axiom,
    ! [X2: product_prod @ num @ num] :
      ( ( X2
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N3: num] :
            ( X2
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) )
       => ( ! [N3: num] :
              ( X2
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) )
         => ( ! [M5: num] :
                ( X2
               != ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ one2 ) )
           => ( ! [M5: num,N3: num] :
                  ( X2
                 != ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit0 @ N3 ) ) )
             => ( ! [M5: num,N3: num] :
                    ( X2
                   != ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit1 @ N3 ) ) )
               => ( ! [M5: num] :
                      ( X2
                     != ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ one2 ) )
                 => ( ! [M5: num,N3: num] :
                        ( X2
                       != ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit0 @ N3 ) ) )
                   => ~ ! [M5: num,N3: num] :
                          ( X2
                         != ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_1986_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_1987_eval__nat__numeral_I3_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_1988_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_1989_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_1990_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_1991_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_1992_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_1993_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_1994_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit1_div_2
thf(fact_1995_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ).

% odd_numeral
thf(fact_1996_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_1997_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_1998_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_1999_Suc3__eq__add__3,axiom,
    ! [N: nat] :
      ( ( suc @ ( suc @ ( suc @ N ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ).

% Suc3_eq_add_3
thf(fact_2000_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_2001_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_2002_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2003_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2004_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_div_eq_add3_div
thf(fact_2005_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2006_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2007_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2008_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2009_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2010_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_2011_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_2012_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2013_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2014_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_2015_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2016_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N ) )
      = ( ( pred_numeral @ K )
        = N ) ) ).

% eq_numeral_Suc
thf(fact_2017_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ( suc @ N )
        = ( numeral_numeral @ nat @ K ) )
      = ( N
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2018_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_2019_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_2020_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2021_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2022_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% less_numeral_Suc
thf(fact_2023_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2024_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% le_numeral_Suc
thf(fact_2025_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2026_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% diff_numeral_Suc
thf(fact_2027_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2028_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_2029_numeral__div__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_2030_minus__numeral__div__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_2031_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2032_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2033_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N @ M ) ) ) ) ).

% dvd_numeral_simp
thf(fact_2034_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_2035_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_2036_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_2037_one__div__minus__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% one_div_minus_numeral
thf(fact_2038_minus__one__div__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_div_numeral
thf(fact_2039_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2040_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2041_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K2: num] : ( suc @ ( pred_numeral @ K2 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2042_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K2: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K2 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2043_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X6: A] : ( plus_plus @ A @ ( plus_plus @ A @ X6 @ X6 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_2044_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M4: num,N2: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M4 ) @ ( numeral_numeral @ int @ N2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M4 ) @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% divmod_int_def
thf(fact_2045_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M4: num,N2: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M4 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M4 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ) ) ).

% divmod_def
thf(fact_2046_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M4: num,N2: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M4 ) @ ( numeral_numeral @ nat @ N2 ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M4 ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_2047_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X6: A] : ( minus_minus @ A @ ( plus_plus @ A @ X6 @ X6 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_2048_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M4: num,N2: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M4 @ N2 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M4 ) ) @ ( unique1321980374590559556d_step @ A @ N2 @ ( unique8689654367752047608divmod @ A @ M4 @ ( bit0 @ N2 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_2049_vebt__buildup_Opelims,axiom,
    ! [X2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X2 )
        = Y2 )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X2 )
       => ( ( ( X2
              = ( zero_zero @ nat ) )
           => ( ( Y2
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X2
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y2
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va: nat] :
                  ( ( X2
                    = ( suc @ ( suc @ Va ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y2
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y2
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_2050_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K2: int] :
              ( if @ A
              @ ( K2
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K2 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_2051_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_2052_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F5: A > B,G2: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F5 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F5 ) ) ) ) ) ).

% less_fun_def
thf(fact_2053_set__decode__Suc,axiom,
    ! [N: nat,X2: nat] :
      ( ( member @ nat @ ( suc @ N ) @ ( nat_set_decode @ X2 ) )
      = ( member @ nat @ N @ ( nat_set_decode @ ( divide_divide @ nat @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_2054_set__decode__0,axiom,
    ! [X2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X2 ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X2 ) ) ) ).

% set_decode_0
thf(fact_2055_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X6: nat] :
          ( collect @ nat
          @ ^ [N2: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_2056_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( zero_zero @ A ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_eq_0_iff
thf(fact_2057_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( zero_zero @ A )
            = ( ring_1_of_int @ A @ Z ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_0_eq_iff
thf(fact_2058_of__int__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( zero_zero @ int ) )
        = ( zero_zero @ A ) ) ) ).

% of_int_0
thf(fact_2059_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int,N: num] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( numeral_numeral @ A @ N ) )
          = ( Z
            = ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_2060_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_2061_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ W @ Z ) ) ) ).

% of_int_less_iff
thf(fact_2062_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_mult
thf(fact_2063_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_add
thf(fact_2064_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X2 )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X2
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_2065_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X2 ) )
          = ( ( power_power @ int @ B2 @ W )
            = X2 ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_2066_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int,N: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z @ N ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z ) @ N ) ) ) ).

% of_int_power
thf(fact_2067_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_2068_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_le_iff
thf(fact_2069_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_less_iff
thf(fact_2070_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_2071_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N ) @ Z ) ) ) ).

% of_int_numeral_le_iff
thf(fact_2072_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ int @ Z @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_2073_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N ) @ Z ) ) ) ).

% of_int_numeral_less_iff
thf(fact_2074_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ int @ Z @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_2075_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_less_iff
thf(fact_2076_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_2077_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X2 ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_2078_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X2 ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X2 @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_2079_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y2: int,X2: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y2 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N ) )
          = ( Y2
            = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_2080_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: num,N: nat,Y2: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N )
            = ( ring_1_of_int @ A @ Y2 ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N )
            = Y2 ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_2081_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X2 ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X2 @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_2082_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X2 ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_2083_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_2084_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_2085_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_2086_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_2087_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y2: int,X2: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y2 )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N ) )
          = ( Y2
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_2088_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: num,N: nat,Y2: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N )
            = ( ring_1_of_int @ A @ Y2 ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N )
            = Y2 ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_2089_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_2090_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_2091_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_2092_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_2093_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_2094_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: int,Y2: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X2 ) @ Y2 )
          = ( times_times @ A @ Y2 @ ( ring_1_of_int @ A @ X2 ) ) ) ) ).

% mult_of_int_commute
thf(fact_2095_real__of__int__div4,axiom,
    ! [N: int,X2: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X2 ) ) ) ).

% real_of_int_div4
thf(fact_2096_real__of__int__div,axiom,
    ! [D2: int,N: int] :
      ( ( dvd_dvd @ int @ D2 @ N )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_2097_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_imp_not_less
thf(fact_2098_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( Y2 != X2 ) ) ) ).

% order_less_imp_not_eq2
thf(fact_2099_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( X2 != Y2 ) ) ) ).

% order_less_imp_not_eq
thf(fact_2100_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
          | ( X2 = Y2 )
          | ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_less_linear
thf(fact_2101_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,P3: $o] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ X2 )
           => P3 ) ) ) ).

% order_less_imp_triv
thf(fact_2102_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_not_sym
thf(fact_2103_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F3: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F3 @ B2 ) @ C2 )
           => ( ! [X7: A,Y5: A] :
                  ( ( ord_less @ A @ X7 @ Y5 )
                 => ( ord_less @ C @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
             => ( ord_less @ C @ ( F3 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_2104_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F3: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F3 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X7: B,Y5: B] :
                  ( ( ord_less @ B @ X7 @ Y5 )
                 => ( ord_less @ A @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_2105_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A] :
          ~ ( ord_less @ A @ X2 @ X2 ) ) ).

% order_less_irrefl
thf(fact_2106_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F3: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F3 @ B2 )
              = C2 )
           => ( ! [X7: A,Y5: A] :
                  ( ( ord_less @ A @ X7 @ Y5 )
                 => ( ord_less @ B @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
             => ( ord_less @ B @ ( F3 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_2107_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F3: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F3 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X7: B,Y5: B] :
                  ( ( ord_less @ B @ X7 @ Y5 )
                 => ( ord_less @ A @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_2108_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_less_trans
thf(fact_2109_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_2110_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( X2 != Y2 ) )
          = ( ( ord_less @ A @ X2 @ Y2 )
            | ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neq_iff
thf(fact_2111_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_asym
thf(fact_2112_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ~ ( ord_less @ A @ X2 @ Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neqE
thf(fact_2113_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_2114_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_2115_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_2116_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
          = ( ( ord_less @ A @ Y2 @ X2 )
            | ( X2 = Y2 ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_2117_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_2118_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P3: A > A > $o,A2: A,B2: A] :
          ( ! [A4: A,B3: A] :
              ( ( ord_less @ A @ A4 @ B3 )
             => ( P3 @ A4 @ B3 ) )
         => ( ! [A4: A] : ( P3 @ A4 @ A4 )
           => ( ! [A4: A,B3: A] :
                  ( ( P3 @ B3 @ A4 )
                 => ( P3 @ A4 @ B3 ) )
             => ( P3 @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_2119_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P: A > $o] :
            ? [X5: A] : ( P @ X5 ) )
        = ( ^ [P2: A > $o] :
            ? [N2: A] :
              ( ( P2 @ N2 )
              & ! [M4: A] :
                  ( ( ord_less @ A @ M4 @ N2 )
                 => ~ ( P2 @ M4 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_2120_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_2121_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_2122_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ( X2 != Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_cases
thf(fact_2123_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X2: A] :
          ( ~ ( ord_less @ A @ Y2 @ X2 )
         => ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv3
thf(fact_2124_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P3: A > $o,A2: A] :
          ( ! [X7: A] :
              ( ! [Y3: A] :
                  ( ( ord_less @ A @ Y3 @ X7 )
                 => ( P3 @ Y3 ) )
             => ( P3 @ X7 ) )
         => ( P3 @ A2 ) ) ) ).

% less_induct
thf(fact_2125_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_2126_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_2127_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_2128_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( X2 != Y2 ) ) ) ).

% less_imp_neq
thf(fact_2129_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [Z2: A] :
              ( ( ord_less @ A @ X2 @ Z2 )
              & ( ord_less @ A @ Z2 @ Y2 ) ) ) ) ).

% dense
thf(fact_2130_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X2: A] :
        ? [X_12: A] : ( ord_less @ A @ X2 @ X_12 ) ) ).

% gt_ex
thf(fact_2131_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X2: A] :
        ? [Y5: A] : ( ord_less @ A @ Y5 @ X2 ) ) ).

% lt_ex
thf(fact_2132_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_nonneg
thf(fact_2133_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_pos
thf(fact_2134_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_2135_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N2: int,M4: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M4 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_2136_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N2: int,M4: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M4 ) ) ) ) ).

% int_less_real_le
thf(fact_2137_real__of__int__div__aux,axiom,
    ! [X2: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X2 ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X2 @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X2 @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_2138_real__of__int__div2,axiom,
    ! [N: int,X2: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X2 ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X2 ) ) ) ) ).

% real_of_int_div2
thf(fact_2139_real__of__int__div3,axiom,
    ! [N: int,X2: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X2 ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X2 ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_2140_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_2141_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ X2 @ Y2 )
            | ( X2 = Y2 ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_2142_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
          | ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_le_less_linear
thf(fact_2143_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F3: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F3 @ B2 ) @ C2 )
           => ( ! [X7: A,Y5: A] :
                  ( ( ord_less @ A @ X7 @ Y5 )
                 => ( ord_less @ C @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
             => ( ord_less @ C @ ( F3 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_2144_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F3: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F3 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X7: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X7 @ Y5 )
                 => ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_2145_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F3: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F3 @ B2 ) @ C2 )
           => ( ! [X7: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X7 @ Y5 )
                 => ( ord_less_eq @ C @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
             => ( ord_less @ C @ ( F3 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_2146_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F3: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F3 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X7: B,Y5: B] :
                  ( ( ord_less @ B @ X7 @ Y5 )
                 => ( ord_less @ A @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_2147_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_less_le_trans
thf(fact_2148_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_le_less_trans
thf(fact_2149_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_2150_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_2151_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% order_less_imp_le
thf(fact_2152_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% linorder_not_less
thf(fact_2153_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less_eq @ A @ X2 @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_not_le
thf(fact_2154_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X6: A,Y: A] :
              ( ( ord_less_eq @ A @ X6 @ Y )
              & ( X6 != Y ) ) ) ) ) ).

% order_less_le
thf(fact_2155_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X6: A,Y: A] :
              ( ( ord_less @ A @ X6 @ Y )
              | ( X6 = Y ) ) ) ) ) ).

% order_le_less
thf(fact_2156_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_2157_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_2158_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ~ ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_2159_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_2160_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_2161_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( A5 != B4 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_2162_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less @ A @ B4 @ A5 )
              | ( A5 = B4 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_2163_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ X2 @ W2 )
               => ( ( ord_less @ A @ W2 @ Y2 )
                 => ( ord_less_eq @ A @ W2 @ Z ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% dense_le_bounded
thf(fact_2164_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ Z @ X2 )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ Z @ W2 )
               => ( ( ord_less @ A @ W2 @ X2 )
                 => ( ord_less_eq @ A @ Y2 @ W2 ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% dense_ge_bounded
thf(fact_2165_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ~ ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_2166_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_2167_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_2168_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( A5 != B4 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_2169_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less @ A @ A5 @ B4 )
              | ( A5 = B4 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_2170_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X2: A] :
          ( ~ ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% not_le_imp_less
thf(fact_2171_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X6: A,Y: A] :
              ( ( ord_less_eq @ A @ X6 @ Y )
              & ~ ( ord_less_eq @ A @ Y @ X6 ) ) ) ) ) ).

% less_le_not_le
thf(fact_2172_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y2: A,Z: A] :
          ( ! [X7: A] :
              ( ( ord_less @ A @ X7 @ Y2 )
             => ( ord_less_eq @ A @ X7 @ Z ) )
         => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ).

% dense_le
thf(fact_2173_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,Y2: A] :
          ( ! [X7: A] :
              ( ( ord_less @ A @ Z @ X7 )
             => ( ord_less_eq @ A @ Y2 @ X7 ) )
         => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ).

% dense_ge
thf(fact_2174_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv2
thf(fact_2175_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv1
thf(fact_2176_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_2177_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% leI
thf(fact_2178_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ~ ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% leD
thf(fact_2179_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L3: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L3 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L3 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_2180_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L3: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L3 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L3 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_2181_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L3: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L3 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L3 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_2182_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: B > C > A,A2: B,B2: C] :
      ( ( product_case_prod @ B @ C @ A @ F3 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( F3 @ A2 @ B2 ) ) ).

% case_prod_conv
thf(fact_2183_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [X7: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X7 ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X7 @ ( one_one @ int ) ) ) )
          & ! [Y3: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y3 ) @ X2 )
                & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y3 @ ( one_one @ int ) ) ) ) )
             => ( Y3 = X7 ) ) ) ) ).

% floor_exists1
thf(fact_2184_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_2185_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M4: nat,N2: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N2
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M4 @ N2 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M4 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M4 @ N2 ) @ N2 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_2186_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_2187_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_2188_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_2189_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P5: product_prod @ A @ B,C2: A > B > $o] :
      ( ! [A4: A,B3: B] :
          ( ( P5
            = ( product_Pair @ A @ B @ A4 @ B3 ) )
         => ( C2 @ A4 @ B3 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P5 ) ) ).

% case_prodI2
thf(fact_2190_case__prodI,axiom,
    ! [A: $tType,B: $tType,F3: A > B > $o,A2: A,B2: B] :
      ( ( F3 @ A2 @ B2 )
     => ( product_case_prod @ A @ B @ $o @ F3 @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) ).

% case_prodI
thf(fact_2191_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P5: product_prod @ A @ B,Z: C,C2: A > B > ( set @ C )] :
      ( ! [A4: A,B3: B] :
          ( ( P5
            = ( product_Pair @ A @ B @ A4 @ B3 ) )
         => ( member @ C @ Z @ ( C2 @ A4 @ B3 ) ) )
     => ( member @ C @ Z @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P5 ) ) ) ).

% mem_case_prodI2
thf(fact_2192_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z: A,C2: B > C > ( set @ A ),A2: B,B2: C] :
      ( ( member @ A @ Z @ ( C2 @ A2 @ B2 ) )
     => ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) ).

% mem_case_prodI
thf(fact_2193_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P5: product_prod @ A @ B,C2: A > B > C > $o,X2: C] :
      ( ! [A4: A,B3: B] :
          ( ( ( product_Pair @ A @ B @ A4 @ B3 )
            = P5 )
         => ( C2 @ A4 @ B3 @ X2 ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P5 @ X2 ) ) ).

% case_prodI2'
thf(fact_2194_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% mask_nat_positive_iff
thf(fact_2195_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_2196_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] :
      ( ( bit_concat_bit @ N @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_2197_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_2198_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_2199_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_2200_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_2201_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_2202_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_2203_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_2204_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_2205_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_2206_take__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% take_bit_of_Suc_0
thf(fact_2207_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_2208_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_2209_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_2210_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_2211_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_2212_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_2213_case__prodD,axiom,
    ! [A: $tType,B: $tType,F3: A > B > $o,A2: A,B2: B] :
      ( ( product_case_prod @ A @ B @ $o @ F3 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( F3 @ A2 @ B2 ) ) ).

% case_prodD
thf(fact_2214_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: A > B > $o,P5: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P5 )
     => ~ ! [X7: A,Y5: B] :
            ( ( P5
              = ( product_Pair @ A @ B @ X7 @ Y5 ) )
           => ~ ( C2 @ X7 @ Y5 ) ) ) ).

% case_prodE
thf(fact_2215_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_int_mask_eq
thf(fact_2216_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_2217_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: A > B > C > $o,P5: product_prod @ A @ B,Z: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P5 @ Z )
     => ~ ! [X7: A,Y5: B] :
            ( ( P5
              = ( product_Pair @ A @ B @ X7 @ Y5 ) )
           => ~ ( C2 @ X7 @ Y5 @ Z ) ) ) ).

% case_prodE'
thf(fact_2218_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R3: A > B > C > $o,A2: A,B2: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R3 @ ( product_Pair @ A @ B @ A2 @ B2 ) @ C2 )
     => ( R3 @ A2 @ B2 @ C2 ) ) ).

% case_prodD'
thf(fact_2219_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_2220_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_2221_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_2222_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q2 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N @ Q2 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_2223_take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_2224_take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% take_bit_mult
thf(fact_2225_take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% take_bit_diff
thf(fact_2226_concat__bit__take__bit__eq,axiom,
    ! [N: nat,B2: int] :
      ( ( bit_concat_bit @ N @ ( bit_se2584673776208193580ke_bit @ int @ N @ B2 ) )
      = ( bit_concat_bit @ N @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_2227_concat__bit__eq__iff,axiom,
    ! [N: nat,K: int,L: int,R: int,S: int] :
      ( ( ( bit_concat_bit @ N @ K @ L )
        = ( bit_concat_bit @ N @ R @ S ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N @ R ) )
        & ( L = S ) ) ) ).

% concat_bit_eq_iff
thf(fact_2228_less__eq__mask,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% less_eq_mask
thf(fact_2229_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_2230_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_2231_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_2232_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% take_bit_nonnegative
thf(fact_2233_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_2234_not__take__bit__negative,axiom,
    ! [N: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_2235_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_2236_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_2237_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_2238_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_2239_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_2240_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_2241_mask__nonnegative__int,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N ) ) ).

% mask_nonnegative_int
thf(fact_2242_not__mask__negative__int,axiom,
    ! [N: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_2243_semiring__norm_I28_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ N ) ) ) ).

% semiring_norm(28)
thf(fact_2244_semiring__norm_I27_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit0 @ N ) )
      = ( bit1 @ ( bitM @ N ) ) ) ).

% semiring_norm(27)
thf(fact_2245_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_2246_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_2247_less__mask,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ) ).

% less_mask
thf(fact_2248_eval__nat__numeral_I2_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_2249_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_2250_BitM__plus__one,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ ( bitM @ N ) @ one2 )
      = ( bit0 @ N ) ) ).

% BitM_plus_one
thf(fact_2251_one__plus__BitM,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% one_plus_BitM
thf(fact_2252_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_2253_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( modulo_modulo @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_2254_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_2255_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W ) ) ) ) ).

% odd_numeral_BitM
thf(fact_2256_take__bit__nat__eq__self,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_2257_take__bit__nat__less__exp,axiom,
    ! [N: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_nat_less_exp
thf(fact_2258_take__bit__nat__eq__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_2259_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N2: nat,M4: nat] : ( modulo_modulo @ nat @ M4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_nat_def
thf(fact_2260_prod_Ocase__distrib,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H: C > D,F3: A > B > C,Prod: product_prod @ A @ B] :
      ( ( H @ ( product_case_prod @ A @ B @ C @ F3 @ Prod ) )
      = ( product_case_prod @ A @ B @ D
        @ ^ [X1: A,X22: B] : ( H @ ( F3 @ X1 @ X22 ) )
        @ Prod ) ) ).

% prod.case_distrib
thf(fact_2261_take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_int_less_exp
thf(fact_2262_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( modulo_modulo @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_int_def
thf(fact_2263_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_2264_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q4: int,R5: int] :
          ( plus_plus @ int @ Q4
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_2265_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_2266_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_2267_Suc__mask__eq__exp,axiom,
    ! [N: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_mask_eq_exp
thf(fact_2268_mask__nat__less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% mask_nat_less_exp
thf(fact_2269_take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_2270_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_2271_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_2272_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_2273_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_2274_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_2275_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_2276_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N2: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_2277_mask__half__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_2278_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_2279_exists__least__lemma,axiom,
    ! [P3: nat > $o] :
      ( ~ ( P3 @ ( zero_zero @ nat ) )
     => ( ? [X_1: nat] : ( P3 @ X_1 )
       => ? [N3: nat] :
            ( ~ ( P3 @ N3 )
            & ( P3 @ ( suc @ N3 ) ) ) ) ) ).

% exists_least_lemma
thf(fact_2280_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N2: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_2281_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z2: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ X2 ) ) ).

% ex_of_int_less
thf(fact_2282_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z2: int] : ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ Z2 ) ) ) ).

% ex_less_of_int
thf(fact_2283_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M4: nat,N2: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M4 @ N2 ) @ ( modulo_modulo @ nat @ M4 @ N2 ) ) ) ) ).

% divmod_nat_def
thf(fact_2284_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_2285_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_2286_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_2287_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_2288_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N2: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_2289_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_2290_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_2291_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( plus_plus @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_2292_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_2293_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_2294_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: A > B > C,G: ( product_prod @ A @ B ) > C] :
      ( ! [X7: A,Y5: B] :
          ( ( F3 @ X7 @ Y5 )
          = ( G @ ( product_Pair @ A @ B @ X7 @ Y5 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F3 )
        = G ) ) ).

% cond_case_prod_eta
thf(fact_2295_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: ( product_prod @ A @ B ) > C] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X6: A,Y: B] : ( F3 @ ( product_Pair @ A @ B @ X6 @ Y ) ) )
      = F3 ) ).

% case_prod_eta
thf(fact_2296_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: A > $o,P3: B > C > A,Z: product_prod @ B @ C] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P3 @ Z ) )
     => ~ ! [X7: B,Y5: C] :
            ( ( Z
              = ( product_Pair @ B @ C @ X7 @ Y5 ) )
           => ~ ( Q @ ( P3 @ X7 @ Y5 ) ) ) ) ).

% case_prodE2
thf(fact_2297_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_2298_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y2 ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y2 ) @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X2 )
              = Y2 ) ) ) ) ).

% round_unique
thf(fact_2299_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_2300_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_2301_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) ) ) ).

% of_int_round_gt
thf(fact_2302_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) ) ) ).

% of_int_round_ge
thf(fact_2303_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2304_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D5: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z5: int,Z6: int] :
                ( ( ord_less_eq @ int @ D5 @ Z5 )
                & ( ord_less @ int @ Z5 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_2305_split__part,axiom,
    ! [B: $tType,A: $tType,P3: $o,Q: A > B > $o] :
      ( ( product_case_prod @ A @ B @ $o
        @ ^ [A5: A,B4: B] :
            ( P3
            & ( Q @ A5 @ B4 ) ) )
      = ( ^ [Ab: product_prod @ A @ B] :
            ( P3
            & ( product_case_prod @ A @ B @ $o @ Q @ Ab ) ) ) ) ).

% split_part
thf(fact_2306_round__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% round_0
thf(fact_2307_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ int @ N ) ) ) ).

% round_numeral
thf(fact_2308_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_2309_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_2310_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_2311_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_2312_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_2313_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ).

% round_neg_numeral
thf(fact_2314_prod_Odisc__eq__case,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( product_case_prod @ A @ B @ $o
      @ ^ [Uu3: A,Uv3: B] : $true
      @ Prod ) ).

% prod.disc_eq_case
thf(fact_2315_num__induct,axiom,
    ! [P3: num > $o,X2: num] :
      ( ( P3 @ one2 )
     => ( ! [X7: num] :
            ( ( P3 @ X7 )
           => ( P3 @ ( inc @ X7 ) ) )
       => ( P3 @ X2 ) ) ) ).

% num_induct
thf(fact_2316_add__inc,axiom,
    ! [X2: num,Y2: num] :
      ( ( plus_plus @ num @ X2 @ ( inc @ Y2 ) )
      = ( inc @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ).

% add_inc
thf(fact_2317_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_2318_inc_Osimps_I2_J,axiom,
    ! [X2: num] :
      ( ( inc @ ( bit0 @ X2 ) )
      = ( bit1 @ X2 ) ) ).

% inc.simps(2)
thf(fact_2319_inc_Osimps_I3_J,axiom,
    ! [X2: num] :
      ( ( inc @ ( bit1 @ X2 ) )
      = ( bit0 @ ( inc @ X2 ) ) ) ).

% inc.simps(3)
thf(fact_2320_add__One,axiom,
    ! [X2: num] :
      ( ( plus_plus @ num @ X2 @ one2 )
      = ( inc @ X2 ) ) ).

% add_One
thf(fact_2321_inc__BitM__eq,axiom,
    ! [N: num] :
      ( ( inc @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% inc_BitM_eq
thf(fact_2322_BitM__inc__eq,axiom,
    ! [N: num] :
      ( ( bitM @ ( inc @ N ) )
      = ( bit1 @ N ) ) ).

% BitM_inc_eq
thf(fact_2323_mult__inc,axiom,
    ! [X2: num,Y2: num] :
      ( ( times_times @ num @ X2 @ ( inc @ Y2 ) )
      = ( plus_plus @ num @ ( times_times @ num @ X2 @ Y2 ) @ X2 ) ) ).

% mult_inc
thf(fact_2324_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X2: num] :
          ( ( numeral_numeral @ A @ ( inc @ X2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_2325_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D5: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z5: int,Z6: int] :
                ( ( ord_less_eq @ int @ D5 @ Z6 )
                & ( ord_less @ int @ Z5 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_2326_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K2 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_2327_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L3: int] :
          ( if @ int
          @ ( ( K2
              = ( zero_zero @ int ) )
            | ( L3
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L3
            @ ( if @ int
              @ ( L3
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K2
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_2328_exp__lower__Taylor__quadratic,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( divide_divide @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X2 ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_2329_sqrt__sum__squares__half__less,axiom,
    ! [X2: real,U: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_2330_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys2: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys2 )
              = N )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys2 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% set_n_lists
thf(fact_2331_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.right_idem
thf(fact_2332_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.left_idem
thf(fact_2333_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ A2 )
          = A2 ) ) ).

% and.idem
thf(fact_2334_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_2335_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_2336_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_2337_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_2338_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X2: real] :
      ( ( ( sqrt @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_2339_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_2340_real__sqrt__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% real_sqrt_less_iff
thf(fact_2341_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_2342_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_2343_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_2344_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X2 ) ) ).

% bit.conj_one_right
thf(fact_2345_real__sqrt__gt__0__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y2 ) ) ).

% real_sqrt_gt_0_iff
thf(fact_2346_real__sqrt__lt__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_2347_real__sqrt__le__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_2348_real__sqrt__ge__0__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 ) ) ).

% real_sqrt_ge_0_iff
thf(fact_2349_real__sqrt__gt__1__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y2 ) ) ).

% real_sqrt_gt_1_iff
thf(fact_2350_real__sqrt__lt__1__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_2351_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% and_nonnegative_int_iff
thf(fact_2352_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_2353_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_2354_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_2355_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_2356_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_2357_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_2358_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_2359_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ).

% signed_take_bit_negative_iff
thf(fact_2360_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_2361_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_2362_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(3)
thf(fact_2363_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_2364_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_2365_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_2366_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_2367_and__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_2368_and__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_2369_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(6)
thf(fact_2370_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(4)
thf(fact_2371_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_2372_and__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_2373_and__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_2374_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( pred_numeral @ N ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_2375_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_2376_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( N
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_2377_real__sqrt__pow2,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( power_power @ real @ ( sqrt @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 ) ) ).

% real_sqrt_pow2
thf(fact_2378_real__sqrt__pow2__iff,axiom,
    ! [X2: real] :
      ( ( ( power_power @ real @ ( sqrt @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% real_sqrt_pow2_iff
thf(fact_2379_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X2: real,Y2: real,Xa: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_2380_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_2381_bit__and__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ).

% bit_and_int_iff
thf(fact_2382_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_2383_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_and_iff
thf(fact_2384_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se5824344872417868541ns_and @ A @ B4 @ A5 ) ) ) ) ).

% and.commute
thf(fact_2385_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_2386_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% bit_numeral_iff
thf(fact_2387_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_and_eq
thf(fact_2388_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_2389_real__sqrt__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_less_mono
thf(fact_2390_real__sqrt__mult,axiom,
    ! [X2: real,Y2: real] :
      ( ( sqrt @ ( times_times @ real @ X2 @ Y2 ) )
      = ( times_times @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_mult
thf(fact_2391_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            & ( M != N ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_2392_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_2393_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_2394_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_2395_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_2396_real__sqrt__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_gt_zero
thf(fact_2397_real__sqrt__eq__zero__cancel,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( sqrt @ X2 )
          = ( zero_zero @ real ) )
       => ( X2
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_2398_real__sqrt__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_ge_zero
thf(fact_2399_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less @ nat @ N @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_take_bit_iff
thf(fact_2400_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N )
          = ( B2
            & ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_2401_AND__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) ) ) ).

% AND_lower
thf(fact_2402_AND__upper1,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ X2 ) ) ).

% AND_upper1
thf(fact_2403_AND__upper2,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Y2 ) ) ).

% AND_upper2
thf(fact_2404_AND__upper1_H,axiom,
    ! [Y2: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less_eq @ int @ Y2 @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y2 @ Ya ) @ Z ) ) ) ).

% AND_upper1'
thf(fact_2405_AND__upper2_H,axiom,
    ! [Y2: int,Z: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less_eq @ int @ Y2 @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Z ) ) ) ).

% AND_upper2'
thf(fact_2406_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_2407_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_2408_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_2409_real__div__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( divide_divide @ real @ X2 @ ( sqrt @ X2 ) )
        = ( sqrt @ X2 ) ) ) ).

% real_div_sqrt
thf(fact_2410_sqrt__add__le__add__sqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X2 @ Y2 ) ) @ ( plus_plus @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_2411_le__real__sqrt__sumsq,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X2 @ X2 ) @ ( times_times @ real @ Y2 @ Y2 ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_2412_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ K ) ) ).

% and_less_eq
thf(fact_2413_AND__upper1_H_H,axiom,
    ! [Y2: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less @ int @ Y2 @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y2 @ Ya ) @ Z ) ) ) ).

% AND_upper1''
thf(fact_2414_AND__upper2_H_H,axiom,
    ! [Y2: int,Z: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less @ int @ Y2 @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Z ) ) ) ).

% AND_upper2''
thf(fact_2415_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff'
thf(fact_2416_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ N2 ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N2 @ A5 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_2417_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_2418_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_2419_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ).

% even_and_iff_int
thf(fact_2420_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_2421_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L ) @ N )
      = ( ( ( ord_less @ nat @ N @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) )
        | ( ( ord_less_eq @ nat @ M @ N )
          & ( bit_se5641148757651400278ts_bit @ int @ L @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_2422_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_concat_bit @ N2 @ K2 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_2423_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_2424_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) ) ).

% bit_Suc
thf(fact_2425_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_2426_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_2427_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
         => ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_2428_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_2429_real__less__rsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 )
     => ( ord_less @ real @ X2 @ ( sqrt @ Y2 ) ) ) ).

% real_less_rsqrt
thf(fact_2430_sqrt__le__D,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ Y2 )
     => ( ord_less_eq @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_2431_real__le__rsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 )
     => ( ord_less_eq @ real @ X2 @ ( sqrt @ Y2 ) ) ) ).

% real_le_rsqrt
thf(fact_2432_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list @ A,N: nat,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys )
        = N ) ) ).

% length_n_lists_elem
thf(fact_2433_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ N3 @ M2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M2 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) ) ) ) ).

% int_bit_bound
thf(fact_2434_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_2435_real__le__lsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X2 ) @ Y2 ) ) ) ) ).

% real_le_lsqrt
thf(fact_2436_real__sqrt__unique,axiom,
    ! [Y2: real,X2: real] :
      ( ( ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( sqrt @ X2 )
          = Y2 ) ) ) ).

% real_sqrt_unique
thf(fact_2437_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_2438_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X2 )
     => ( Y2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_2439_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y2 )
     => ( X2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_2440_real__sqrt__sum__squares__ge1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_2441_real__sqrt__sum__squares__ge2,axiom,
    ! [Y2: real,X2: real] : ( ord_less_eq @ real @ Y2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_2442_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_2443_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K2: int,N2: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% bit_int_def
thf(fact_2444_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_2445_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_2446_real__less__lsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X2 ) @ Y2 ) ) ) ) ).

% real_less_lsqrt
thf(fact_2447_sqrt__sum__squares__le__sum,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X2 @ Y2 ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_2448_sqrt__even__pow2,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_2449_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [J: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_2450_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_2451_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X2: real,Y2: real,Xa: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_2452_real__sqrt__power__even,axiom,
    ! [N: nat,X2: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( sqrt @ X2 ) @ N )
          = ( power_power @ real @ X2 @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_2453_arith__geo__mean__sqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X2 @ Y2 ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_2454_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L3: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_2455_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K2: int] :
          ( plus_plus @ int @ K2
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% set_bit_eq
thf(fact_2456_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ K2 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% unset_bit_eq
thf(fact_2457_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_2458_exp__le__one__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_2459_one__le__exp__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% one_le_exp_iff
thf(fact_2460_exp__less__one__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_2461_one__less__exp__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% one_less_exp_iff
thf(fact_2462_real__exp__bound__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_2463_exp__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_2464_exp__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) ) ) ).

% exp_less_mono
thf(fact_2465_exp__less__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% exp_less_cancel_iff
thf(fact_2466_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_2467_exp__eq__one__iff,axiom,
    ! [X2: real] :
      ( ( ( exp @ real @ X2 )
        = ( one_one @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_2468_and__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_2469_and__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_2470_and__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_2471_and__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_2472_and__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_2473_Suc__0__and__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_2474_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N ) ) ).

% not_bit_Suc_0_Suc
thf(fact_2475_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_2476_not__bit__Suc__0__numeral,axiom,
    ! [N: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N ) ) ).

% not_bit_Suc_0_numeral
thf(fact_2477_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% bit_nat_def
thf(fact_2478_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( exp @ A @ X2 )
         != ( zero_zero @ A ) ) ) ).

% exp_not_eq_zero
thf(fact_2479_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A3: A] :
          ( ( times_times @ A @ ( exp @ A @ A3 ) @ A3 )
          = ( times_times @ A @ A3 @ ( exp @ A @ A3 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_2480_exp__less__cancel,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) )
     => ( ord_less @ real @ X2 @ Y2 ) ) ).

% exp_less_cancel
thf(fact_2481_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( if @ nat
          @ ( ( M4
              = ( zero_zero @ nat ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_2482_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_2483_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) )
          = ( exp @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% mult_exp_exp
thf(fact_2484_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) ) ) ) ) ).

% exp_add_commuting
thf(fact_2485_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( divide_divide @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) ) ) ) ).

% exp_diff
thf(fact_2486_not__exp__less__zero,axiom,
    ! [X2: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X2 ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_2487_exp__gt__zero,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X2 ) ) ).

% exp_gt_zero
thf(fact_2488_exp__total,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X7: real] :
          ( ( exp @ real @ X7 )
          = Y2 ) ) ).

% exp_total
thf(fact_2489_exp__ge__zero,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X2 ) ) ).

% exp_ge_zero
thf(fact_2490_not__exp__le__zero,axiom,
    ! [X2: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_2491_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_2492_exp__gt__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) ) ) ).

% exp_gt_one
thf(fact_2493_exp__ge__add__one__self__aux,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( exp @ real @ X2 ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_2494_lemma__exp__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 )
     => ? [X7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X7 )
          & ( ord_less_eq @ real @ X7 @ ( minus_minus @ real @ Y2 @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X7 )
            = Y2 ) ) ) ).

% lemma_exp_total
thf(fact_2495_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_2496_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) )
          = ( power_power @ A @ ( exp @ A @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_2497_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_2498_arsinh__real__aux,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_2499_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_2500_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N @ Xs ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_n_lists
thf(fact_2501_artanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% artanh_0
thf(fact_2502_arsinh__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arsinh_0
thf(fact_2503_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X6: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X6 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X6 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_2504_ln__one__minus__pos__lower__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X2 ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2505_tanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tanh_0
thf(fact_2506_tanh__real__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( tanh @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% tanh_real_zero_iff
thf(fact_2507_tanh__real__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( tanh @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% tanh_real_less_iff
thf(fact_2508_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_2509_ln__inj__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( ln_ln @ real @ X2 )
            = ( ln_ln @ real @ Y2 ) )
          = ( X2 = Y2 ) ) ) ) ).

% ln_inj_iff
thf(fact_2510_ln__less__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_2511_tanh__real__neg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_2512_tanh__real__pos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% tanh_real_pos_iff
thf(fact_2513_tanh__real__nonpos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_2514_tanh__real__nonneg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% tanh_real_nonneg_iff
thf(fact_2515_ln__le__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) )
          = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_2516_ln__eq__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ln_ln @ real @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_2517_ln__gt__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_gt_zero_iff
thf(fact_2518_ln__less__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_2519_exp__ln__iff,axiom,
    ! [X2: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X2 ) )
        = X2 )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% exp_ln_iff
thf(fact_2520_exp__ln,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( exp @ real @ ( ln_ln @ real @ X2 ) )
        = X2 ) ) ).

% exp_ln
thf(fact_2521_ln__ge__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_ge_zero_iff
thf(fact_2522_ln__le__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_2523_ln__less__self,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ X2 ) ) ).

% ln_less_self
thf(fact_2524_tanh__real__lt__1,axiom,
    ! [X2: real] : ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_2525_ln__bound,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ X2 ) ) ).

% ln_bound
thf(fact_2526_ln__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) ) ) ).

% ln_gt_zero
thf(fact_2527_ln__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_2528_ln__gt__zero__imp__gt__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_2529_ln__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) ) ) ).

% ln_ge_zero
thf(fact_2530_tanh__real__gt__neg1,axiom,
    ! [X2: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X2 ) ) ).

% tanh_real_gt_neg1
thf(fact_2531_ln__ge__zero__imp__ge__one,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_2532_ln__add__one__self__le__self,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) ).

% ln_add_one_self_le_self
thf(fact_2533_ln__mult,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ln_ln @ real @ ( times_times @ real @ X2 @ Y2 ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) ) ) ) ).

% ln_mult
thf(fact_2534_ln__eq__minus__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ln_ln @ real @ X2 )
          = ( minus_minus @ real @ X2 @ ( one_one @ real ) ) )
       => ( X2
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_2535_ln__div,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X2 @ Y2 ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) ) ) ) ).

% ln_div
thf(fact_2536_ln__ge__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( ln_ln @ real @ X2 ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y2 ) @ X2 ) ) ) ).

% ln_ge_iff
thf(fact_2537_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X6: real] : ( ln_ln @ real @ ( plus_plus @ real @ X6 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_2538_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2539_ln__le__minus__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( minus_minus @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_2540_ln__diff__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X2 @ Y2 ) @ Y2 ) ) ) ) ).

% ln_diff_le
thf(fact_2541_ln__add__one__self__le__self2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) ).

% ln_add_one_self_le_self2
thf(fact_2542_tanh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( tanh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2543_arcosh__real__def,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( arcosh @ real @ X2 )
        = ( ln_ln @ real @ ( plus_plus @ real @ X2 @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_2544_ln__one__minus__pos__upper__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X2 ) ) @ ( uminus_uminus @ real @ X2 ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_2545_ln__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( sqrt @ X2 ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_2546_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X6 ) @ ( exp @ A @ ( uminus_uminus @ A @ X6 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X6 ) @ ( exp @ A @ ( uminus_uminus @ A @ X6 ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_2547_ln__one__plus__pos__lower__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X2 @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2548_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X6: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X6 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_2549_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2550_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_2551_arctan__half,axiom,
    ( arctan
    = ( ^ [X6: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X6 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_2552_log__base__10__eq1,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X2 )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% log_base_10_eq1
thf(fact_2553_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_2554_log__base__10__eq2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X2 )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% log_base_10_eq2
thf(fact_2555_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_abs
thf(fact_2556_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_2557_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_2558_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_2559_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_2560_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_2561_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_numeral
thf(fact_2562_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% abs_mult_self_eq
thf(fact_2563_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_2564_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_2565_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_2566_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus
thf(fact_2567_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_2568_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M ) @ K )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% abs_dvd_iff
thf(fact_2569_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ M @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% dvd_abs_iff
thf(fact_2570_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P3: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P3 ) )
          = ( zero_neq_one_of_bool @ A @ P3 ) ) ) ).

% abs_bool_eq
thf(fact_2571_arctan__eq__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( arctan @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% arctan_eq_zero_iff
thf(fact_2572_arctan__zero__zero,axiom,
    ( ( arctan @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arctan_zero_zero
thf(fact_2573_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_2574_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_2575_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_2576_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2577_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_neg_numeral
thf(fact_2578_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2579_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% abs_power_minus
thf(fact_2580_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_2581_zero__less__arctan__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_less_arctan_iff
thf(fact_2582_arctan__less__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( arctan @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_2583_arctan__le__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_2584_zero__le__arctan__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_le_arctan_iff
thf(fact_2585_real__sqrt__abs2,axiom,
    ! [X2: real] :
      ( ( sqrt @ ( times_times @ real @ X2 @ X2 ) )
      = ( abs_abs @ real @ X2 ) ) ).

% real_sqrt_abs2
thf(fact_2586_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_2587_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_2588_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_2589_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2590_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_2591_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_2592_one__less__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less @ real @ A2 @ X2 ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_2593_log__less__one__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X2 @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_2594_log__less__cancel__iff,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) )
            = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_2595_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_2596_artanh__minus__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X2 ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X2 ) ) ) ) ).

% artanh_minus_real
thf(fact_2597_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_2598_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_2599_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_2600_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_2601_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_2602_one__le__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less_eq @ real @ A2 @ X2 ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_2603_log__le__one__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X2 @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_2604_log__le__cancel__iff,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) )
            = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_2605_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_2606_real__sqrt__abs,axiom,
    ! [X2: real] :
      ( ( sqrt @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X2 ) ) ).

% real_sqrt_abs
thf(fact_2607_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_2608_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_2609_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_2610_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_2611_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_2612_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_2613_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( abs_abs @ A @ X2 )
            = ( abs_abs @ A @ Y2 ) )
          = ( ( X2 = Y2 )
            | ( X2
              = ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% abs_eq_iff
thf(fact_2614_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_abs
thf(fact_2615_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L: A,K: A] :
          ( ( ( abs_abs @ A @ L )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_2616_arctan__monotone,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) ) ) ).

% arctan_monotone
thf(fact_2617_arctan__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% arctan_less_iff
thf(fact_2618_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_2619_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_2620_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_2621_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_2622_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_2623_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_2624_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_2625_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_2626_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_2627_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_2628_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_2629_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_2630_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_2631_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_2632_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ E ) )
         => ( X2
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_2633_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_2634_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y2 ) @ X2 )
            = ( abs_abs @ A @ ( times_times @ A @ Y2 @ X2 ) ) ) ) ) ).

% abs_mult_pos
thf(fact_2635_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_2636_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_2637_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_2638_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% zero_le_power_abs
thf(fact_2639_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X2 ) @ Y2 )
            = ( abs_abs @ A @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% abs_div_pos
thf(fact_2640_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_2641_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A5: A] : ( if @ A @ ( ord_less @ A @ A5 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A5 ) @ A5 ) ) ) ) ).

% abs_if_raw
thf(fact_2642_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A5: A] : ( if @ A @ ( ord_less @ A @ A5 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A5 ) @ A5 ) ) ) ) ).

% abs_if
thf(fact_2643_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,A2: A,R: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ R )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_2644_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_2645_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_2646_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,A2: A,R: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ R )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R ) @ X2 )
            & ( ord_less @ A @ X2 @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_2647_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A5: real] : ( if @ real @ ( ord_less @ real @ A5 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A5 ) @ A5 ) ) ) ).

% abs_real_def
thf(fact_2648_lemma__interval__lt,axiom,
    ! [A2: real,X2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [Y3: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y3 ) ) @ D3 )
               => ( ( ord_less @ real @ A2 @ Y3 )
                  & ( ord_less @ real @ Y3 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_2649_arctan__add,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X2 @ Y2 ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_2650_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X2 ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_2651_log__base__change,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X2 )
          = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_2652_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X2 )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% of_int_leD
thf(fact_2653_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X2 )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% of_int_lessD
thf(fact_2654_lemma__interval,axiom,
    ! [A2: real,X2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [Y3: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y3 ) ) @ D3 )
               => ( ( ord_less_eq @ real @ A2 @ Y3 )
                  & ( ord_less_eq @ real @ Y3 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_2655_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ ( abs_abs @ A @ Y2 ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_2656_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X2 )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2657_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_even_abs
thf(fact_2658_log__mult,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ( log @ A2 @ ( times_times @ real @ X2 @ Y2 ) )
              = ( plus_plus @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) ) ) ) ) ) ) ).

% log_mult
thf(fact_2659_log__divide,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ( log @ A2 @ ( divide_divide @ real @ X2 @ Y2 ) )
              = ( minus_minus @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) ) ) ) ) ) ) ).

% log_divide
thf(fact_2660_arctan__double,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X2 ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_2661_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ Y2 ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_2662_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2663_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2664_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_even
thf(fact_2665_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
             => ( ( log @ A2 @ X2 )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X2 ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_2666_sqrt__ge__absD,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( sqrt @ Y2 ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 ) ) ).

% sqrt_ge_absD
thf(fact_2667_real__sqrt__ge__abs1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_2668_real__sqrt__ge__abs2,axiom,
    ! [Y2: real,X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_2669_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X2 ) @ ( abs_abs @ real @ Y2 ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_2670_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) @ X2 ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_2671_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X2 )
            = N ) ) ) ).

% round_unique'
thf(fact_2672_cos__x__y__le__one,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_2673_real__sqrt__sum__squares__less,axiom,
    ! [X2: real,U: real,Y2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y2 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_2674_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P3: A > A > $o,X2: A] :
          ( ! [X7: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X7 )
             => ( P3 @ X7 @ ( power_power @ A @ X7 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P3 @ ( abs_abs @ A @ X2 ) @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2675_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_le
thf(fact_2676_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_2677_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_2678_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X2: real,N: nat] :
      ( ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ ( uminus_uminus @ real @ X2 ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_2679_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ X2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ X2 ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_2680_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) ).

% of_nat_eq_iff
thf(fact_2681_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% abs_of_nat
thf(fact_2682_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_2683_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( ( zero_zero @ nat )
            = N ) ) ) ).

% of_nat_0_eq_iff
thf(fact_2684_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_2685_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_iff
thf(fact_2686_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% of_nat_le_iff
thf(fact_2687_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% of_nat_numeral
thf(fact_2688_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_add
thf(fact_2689_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_2690_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2691_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2692_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2693_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N ) ) ) ).

% of_nat_power
thf(fact_2694_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X2 ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X2 ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_2695_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X2 )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X2
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_2696_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z ) @ ( one_one @ int ) )
      = ( Z
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_2697_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P3: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P3 ) )
          = ( zero_neq_one_of_bool @ A @ P3 ) ) ) ).

% of_nat_of_bool
thf(fact_2698_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_2699_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_2700_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% of_nat_0_less_iff
thf(fact_2701_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X2 ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_2702_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X2 @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_2703_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X2 ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_2704_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X2 @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_2705_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X2: num,N: nat,Y2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N )
            = ( semiring_1_of_nat @ A @ Y2 ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N )
            = Y2 ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2706_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y2: nat,X2: num,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y2 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N ) )
          = ( Y2
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2707_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W ) @ ( semiring_1_of_nat @ real @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W ) @ N ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_2708_real__of__nat__less__numeral__iff,axiom,
    ! [N: nat,W: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( numeral_numeral @ real @ W ) )
      = ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ W ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_2709_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2710_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X2 ) @ N ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_2711_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_2712_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_of_nat
thf(fact_2713_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: num,N: nat,X2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I3 ) @ N ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I3 ) @ N ) @ X2 ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2714_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,I3: num,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ I3 ) @ N ) )
          = ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ I3 ) @ N ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2715_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: num,N: nat,X2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I3 ) @ N ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I3 ) @ N ) @ X2 ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2716_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,I3: num,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ I3 ) @ N ) )
          = ( ord_less_eq @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ I3 ) @ N ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2717_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [N3: nat] : ( ord_less @ A @ X2 @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% reals_Archimedean2
thf(fact_2718_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X2: nat,Y2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X2 ) @ Y2 )
          = ( times_times @ A @ Y2 @ ( semiring_1_of_nat @ A @ X2 ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2719_pi__neq__zero,axiom,
    pi
 != ( zero_zero @ real ) ).

% pi_neq_zero
thf(fact_2720_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,X2: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ X2 ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_2721_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_nat_0_le_iff
thf(fact_2722_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_2723_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_2724_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_2725_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ M @ N )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_2726_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
         => ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_imp_less
thf(fact_2727_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I3: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I3 @ J2 )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J2 ) ) ) ) ).

% of_nat_mono
thf(fact_2728_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_2729_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% of_nat_dvd_iff
thf(fact_2730_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_2731_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_2732_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_2733_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_2734_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mod
thf(fact_2735_abs__div,axiom,
    ! [Y2: int,X2: int] :
      ( ( dvd_dvd @ int @ Y2 @ X2 )
     => ( ( abs_abs @ int @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ X2 ) @ ( abs_abs @ int @ Y2 ) ) ) ) ).

% abs_div
thf(fact_2736_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_2737_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_and_eq
thf(fact_2738_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_2739_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_nat_mask_eq
thf(fact_2740_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N3: nat] : ( ord_less @ A @ Y2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X2 ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2741_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% of_nat_diff
thf(fact_2742_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,N: nat] :
          ( ( exp @ A @ ( times_times @ A @ X2 @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( power_power @ A @ ( exp @ A @ X2 ) @ N ) ) ) ).

% exp_of_nat2_mult
thf(fact_2743_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X2: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ X2 ) )
          = ( power_power @ A @ ( exp @ A @ X2 ) @ N ) ) ) ).

% exp_of_nat_mult
thf(fact_2744_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I: int] : ( if @ int @ ( ord_less @ int @ I @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I ) @ I ) ) ) ).

% zabs_def
thf(fact_2745_reals__Archimedean3,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ! [Y3: real] :
        ? [N3: nat] : ( ord_less @ real @ Y3 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ X2 ) ) ) ).

% reals_Archimedean3
thf(fact_2746_dvd__imp__le__int,axiom,
    ! [I3: int,D2: int] :
      ( ( I3
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D2 @ I3 )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D2 ) @ ( abs_abs @ int @ I3 ) ) ) ) ).

% dvd_imp_le_int
thf(fact_2747_real__of__nat__div4,axiom,
    ! [N: nat,X2: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X2 ) ) ) ).

% real_of_nat_div4
thf(fact_2748_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L ) ) @ ( abs_abs @ int @ L ) ) ) ).

% abs_mod_less
thf(fact_2749_real__of__nat__div,axiom,
    ! [D2: nat,N: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_2750_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2751_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2752_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_2753_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat,M4: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M4 ) ) ) ) ).

% nat_less_real_le
thf(fact_2754_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N2: nat,M4: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M4 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_2755_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_2756_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N ) @ M )
        = ( ( abs_abs @ int @ N )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2757_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_2758_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_2759_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_2760_real__of__nat__div__aux,axiom,
    ! [X2: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X2 @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X2 @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2761_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_2762_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% of_nat_less_two_power
thf(fact_2763_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_2764_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X2 @ ( semiring_1_of_nat @ A @ N ) ) ) @ N )
            = ( exp @ A @ X2 ) ) ) ) ).

% exp_divide_power_eq
thf(fact_2765_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_add_abs_iff
thf(fact_2766_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_abs_add_iff
thf(fact_2767_real__archimedian__rdiv__eq__0,axiom,
    ! [X2: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M5: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M5 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M5 ) @ X2 ) @ C2 ) )
         => ( X2
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_2768_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_2769_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_2770_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_2771_real__of__nat__div2,axiom,
    ! [N: nat,X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X2 ) ) ) ) ).

% real_of_nat_div2
thf(fact_2772_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_2773_log__base__pow,axiom,
    ! [A2: real,N: nat,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N ) @ X2 )
        = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log_base_pow
thf(fact_2774_ln__realpow,axiom,
    ! [X2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( power_power @ real @ X2 @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_realpow
thf(fact_2775_log__nat__power,axiom,
    ! [X2: real,B2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ B2 @ ( power_power @ real @ X2 @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X2 ) ) ) ) ).

% log_nat_power
thf(fact_2776_real__of__nat__div3,axiom,
    ! [N: nat,X2: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X2 ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_2777_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F3: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I2 )
            & ( ord_less @ nat @ I2 @ N ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F3 @ ( suc @ I2 ) ) @ ( F3 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( ord_less_eq @ int @ ( F3 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F3 @ N ) )
           => ? [I2: nat] :
                ( ( ord_less_eq @ nat @ M @ I2 )
                & ( ord_less_eq @ nat @ I2 @ N )
                & ( ( F3 @ I2 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_2778_decr__lemma,axiom,
    ! [D2: int,X2: int,Z: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X2 @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X2 @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z ) ) ).

% decr_lemma
thf(fact_2779_incr__lemma,axiom,
    ! [D2: int,Z: int,X2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z @ ( plus_plus @ int @ X2 @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X2 @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_2780_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_2781_linear__plus__1__le__power,axiom,
    ! [X2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X2 ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X2 @ ( one_one @ real ) ) @ N ) ) ) ).

% linear_plus_1_le_power
thf(fact_2782_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_2783_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( semiring_1_of_nat @ real @ N )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_2784_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_less
thf(fact_2785_Bernoulli__inequality,axiom,
    ! [X2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X2 ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ N ) ) ) ).

% Bernoulli_inequality
thf(fact_2786_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_2787_arctan__ubound,axiom,
    ! [Y2: real] : ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_2788_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_2789_nat__ivt__aux,axiom,
    ! [N: nat,F3: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F3 @ ( suc @ I2 ) ) @ ( F3 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F3 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F3 @ N ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N )
              & ( ( F3 @ I2 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_2790_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_le
thf(fact_2791_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_2792_arctan__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) )
      & ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_2793_arctan__lbound,axiom,
    ! [Y2: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) ) ).

% arctan_lbound
thf(fact_2794_nat0__intermed__int__val,axiom,
    ! [N: nat,F3: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F3 @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) ) @ ( F3 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F3 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F3 @ N ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N )
              & ( ( F3 @ I2 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_2795_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_2796_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_2797_Bernoulli__inequality__even,axiom,
    ! [N: nat,X2: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X2 ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ N ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2798_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_less
thf(fact_2799_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M4: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M4 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M4 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_2800_monoseq__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_2801_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H: A,Z: A,K5: real,N: nat] :
          ( ( H
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z @ H ) ) @ K5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ N ) @ ( power_power @ A @ Z @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K5 @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2802_sin__cos__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% sin_cos_npi
thf(fact_2803_ln__series,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X2 )
          = ( suminf @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ ( one_one @ real ) ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% ln_series
thf(fact_2804_arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( arctan @ X2 )
        = ( suminf @ real
          @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_2805_sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sin_zero
thf(fact_2806_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V ) )
      = ( M
        = ( numeral_numeral @ nat @ V ) ) ) ).

% int_eq_iff_numeral
thf(fact_2807_negative__eq__positive,axiom,
    ! [N: nat,M: nat] :
      ( ( ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) )
        = ( semiring_1_of_nat @ int @ M ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% negative_eq_positive
thf(fact_2808_sin__pi,axiom,
    ( ( sin @ real @ pi )
    = ( zero_zero @ real ) ) ).

% sin_pi
thf(fact_2809_negative__zless,axiom,
    ! [N: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_2810_sin__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_2811_sin__npi2,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_2812_sin__npi__int,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_2813_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F3: nat > A] :
          ( ( suminf @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) )
          = ( F3 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_2814_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_2815_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_2816_sin__periodic,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X2 ) ) ).

% sin_periodic
thf(fact_2817_sin__2npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_2818_sin__2pi__minus,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X2 ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X2 ) ) ) ).

% sin_2pi_minus
thf(fact_2819_sin__int__2pin,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_2820_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_2821_int__if,axiom,
    ! [P3: $o,A2: nat,B2: nat] :
      ( ( P3
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P3 @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ A2 ) ) )
      & ( ~ P3
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P3 @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ B2 ) ) ) ) ).

% int_if
thf(fact_2822_nat__int__comparison_I1_J,axiom,
    ( ( ^ [Y4: nat,Z3: nat] : ( Y4 = Z3 ) )
    = ( ^ [A5: nat,B4: nat] :
          ( ( semiring_1_of_nat @ int @ A5 )
          = ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(1)
thf(fact_2823_of__nat__eq__enat,axiom,
    ( ( semiring_1_of_nat @ extended_enat )
    = extended_enat2 ) ).

% of_nat_eq_enat
thf(fact_2824_sin__x__le__x,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ X2 ) ) ).

% sin_x_le_x
thf(fact_2825_int__ops_I1_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) )
    = ( zero_zero @ int ) ) ).

% int_ops(1)
thf(fact_2826_int__ops_I3_J,axiom,
    ! [N: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ int @ N ) ) ).

% int_ops(3)
thf(fact_2827_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_2828_int__of__nat__induct,axiom,
    ! [P3: int > $o,Z: int] :
      ( ! [N3: nat] : ( P3 @ ( semiring_1_of_nat @ int @ N3 ) )
     => ( ! [N3: nat] : ( P3 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) )
       => ( P3 @ Z ) ) ) ).

% int_of_nat_induct
thf(fact_2829_int__cases,axiom,
    ! [Z: int] :
      ( ! [N3: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% int_cases
thf(fact_2830_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_2831_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% zero_le_imp_eq_int
thf(fact_2832_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% nonneg_int_cases
thf(fact_2833_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z ) ) ).

% zadd_int_left
thf(fact_2834_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_2835_int__plus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_2836_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_2837_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_2838_not__int__zless__negative,axiom,
    ! [N: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_2839_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_2840_zmod__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A2 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_2841_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_less_as_int
thf(fact_2842_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_leq_as_int
thf(fact_2843_sin__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero
thf(fact_2844_sin__x__ge__neg__x,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X2 ) @ ( sin @ real @ X2 ) ) ) ).

% sin_x_ge_neg_x
thf(fact_2845_sin__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_ge_zero
thf(fact_2846_int__cases4,axiom,
    ! [M: int] :
      ( ! [N3: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% int_cases4
thf(fact_2847_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_2848_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2849_int__Suc,axiom,
    ! [N: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2850_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W3: int,Z6: int] :
        ? [N2: nat] :
          ( Z6
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_2851_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% nonpos_int_cases
thf(fact_2852_negative__zle__0,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_2853_sin__eq__0__pi,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
     => ( ( ord_less @ real @ X2 @ pi )
       => ( ( ( sin @ real @ X2 )
            = ( zero_zero @ real ) )
         => ( X2
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_2854_sin__zero__pi__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ pi )
     => ( ( ( sin @ real @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_2855_sin__zero__iff__int2,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I: int] :
            ( X2
            = ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_2856_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% pos_int_cases
thf(fact_2857_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
          & ( K
            = ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_2858_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) )
       => ~ ! [N3: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% int_cases3
thf(fact_2859_zmult__zless__mono2__lemma,axiom,
    ! [I3: int,J2: int,K: nat] :
      ( ( ord_less @ int @ I3 @ J2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I3 ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J2 ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_2860_not__zle__0__negative,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ).

% not_zle_0_negative
thf(fact_2861_negative__zless__0,axiom,
    ! [N: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_2862_negD,axiom,
    ! [X2: int] :
      ( ( ord_less @ int @ X2 @ ( zero_zero @ int ) )
     => ? [N3: nat] :
          ( X2
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% negD
thf(fact_2863_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_2864_sin__gt__zero__02,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero_02
thf(fact_2865_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X15: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X15 @ N2 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X15 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2866_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X15: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X15 @ N2 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X15 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2867_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% neg_int_cases
thf(fact_2868_zdiff__int__split,axiom,
    ! [P3: int > $o,X2: nat,Y2: nat] :
      ( ( P3 @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X2 @ Y2 ) ) )
      = ( ( ( ord_less_eq @ nat @ Y2 @ X2 )
         => ( P3 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X2 ) @ ( semiring_1_of_nat @ int @ Y2 ) ) ) )
        & ( ( ord_less @ nat @ X2 @ Y2 )
         => ( P3 @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_2869_monoseq__realpow,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X2 ) ) ) ) ).

% monoseq_realpow
thf(fact_2870_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_2871_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_2872_sin__gt__zero2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero2
thf(fact_2873_sin__lt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ pi @ X2 )
     => ( ( ord_less @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_2874_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_2875_sin__monotone__2pi__le,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y2 ) @ ( sin @ real @ X2 ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_2876_sin__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) )
              = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_2877_sin__inj__pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X2 )
                = ( sin @ real @ Y2 ) )
             => ( X2 = Y2 ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_2878_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_2879_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_2880_sin__le__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ pi @ X2 )
     => ( ( ord_less @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_2881_sin__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_2882_sin__mono__less__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) )
              = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_2883_sin__monotone__2pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y2 ) @ ( sin @ real @ X2 ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_2884_sin__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ? [X7: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X7 )
            & ( ord_less_eq @ real @ X7 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X7 )
              = Y2 )
            & ! [Y3: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
                  & ( ord_less_eq @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y3 )
                    = Y2 ) )
               => ( Y3 = X7 ) ) ) ) ) ).

% sin_total
thf(fact_2885_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_2886_sin__arctan,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( arctan @ X2 ) )
      = ( divide_divide @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_2887_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_2888_sin__zero__iff__int,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I )
            & ( X2
              = ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_2889_sin__zero__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( sin @ real @ X2 )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_2890_sin__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X2
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_2891_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K2: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_2892_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_divide_numeral
thf(fact_2893_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2894_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2895_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_neg_numeral
thf(fact_2896_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( zero_zero @ real ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2897_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
          = ( ( X2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_2898_norm__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) ).

% norm_zero
thf(fact_2899_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( real_V7770717601297561774m_norm @ A @ X2 )
            = ( zero_zero @ real ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% norm_eq_zero
thf(fact_2900_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_numeral
thf(fact_2901_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_2902_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ).

% norm_ge_zero
thf(fact_2903_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_mult
thf(fact_2904_norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_divide
thf(fact_2905_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X2 @ N ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ N ) ) ) ).

% norm_power
thf(fact_2906_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% norm_uminus_minus
thf(fact_2907_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2908_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat,Z: A] :
          ( ( ( power_power @ A @ W @ N )
            = ( power_power @ A @ Z @ N ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2909_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A,R: real,Y2: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) ) @ ( times_times @ real @ R @ S ) ) ) ) ) ).

% norm_mult_less
thf(fact_2910_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_mult_ineq
thf(fact_2911_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E2 )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ E2 ) ) ) ).

% norm_triangle_lt
thf(fact_2912_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,R: real,Y2: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_add_less
thf(fact_2913_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R: real,B2: A,S: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2914_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2915_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ E2 ) ) ) ).

% norm_triangle_le
thf(fact_2916_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2917_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A,N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X2 @ N ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ N ) ) ) ).

% norm_power_ineq
thf(fact_2918_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E1: real,Z: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ Z ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2919_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2920_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat] :
          ( ( ( power_power @ A @ W @ N )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2921_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2922_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X2 )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2923_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2924_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_2925_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A
          @ ^ [N2: nat] : ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% suminf_zero
thf(fact_2926_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_2927_summable__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_2928_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_2929_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) )
            = X2 )
          = ( ? [N2: int] :
                ( X2
                = ( ring_1_of_int @ A @ N2 ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_2930_summable__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I3: nat,F3: nat > A] :
          ( summable @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I3 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) ) ) ) ).

% summable_single
thf(fact_2931_summable__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A
        @ ^ [N2: nat] : ( zero_zero @ A ) ) ) ).

% summable_zero
thf(fact_2932_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( summable @ A @ F3 ) ) ) ).

% summable_iff_shift
thf(fact_2933_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_2934_ceiling__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% ceiling_zero
thf(fact_2935_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% ceiling_numeral
thf(fact_2936_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F3: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F3 ) ) ) ) ).

% summable_cmult_iff
thf(fact_2937_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F3 @ N2 ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F3 ) ) ) ) ).

% summable_divide_iff
thf(fact_2938_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z ) ) ) ).

% ceiling_add_of_int
thf(fact_2939_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ X2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ X2 ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_2940_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_2941_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% zero_less_ceiling
thf(fact_2942_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X2 @ ( numeral_numeral @ A @ V ) ) ) ) ).

% ceiling_le_numeral
thf(fact_2943_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_2944_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% one_le_ceiling
thf(fact_2945_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V ) @ X2 ) ) ) ).

% numeral_less_ceiling
thf(fact_2946_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ).

% one_less_ceiling
thf(fact_2947_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_add_numeral
thf(fact_2948_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_2949_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_2950_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_2951_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: num,N: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) ) ) ).

% ceiling_numeral_power
thf(fact_2952_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_2953_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_2954_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 ) ) ) ).

% zero_le_ceiling
thf(fact_2955_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_2956_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_2957_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% numeral_le_ceiling
thf(fact_2958_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_2959_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X2 ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_2960_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_2961_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_2962_cos__periodic,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X2 ) ) ).

% cos_periodic
thf(fact_2963_cos__2pi__minus,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X2 ) )
      = ( cos @ real @ X2 ) ) ).

% cos_2pi_minus
thf(fact_2964_cos__npi2,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi2
thf(fact_2965_cos__npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi
thf(fact_2966_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_2967_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_2968_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_2969_cos__2npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_2970_cos__int__2pin,axiom,
    ! [N: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_2971_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_2972_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_2973_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_2974_cos__npi__int,axiom,
    ! [N: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_2975_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_2976_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) ) ) ) ).

% summable_mult
thf(fact_2977_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A,G: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ).

% summable_add
thf(fact_2978_summable__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F3 @ N2 ) @ C2 ) ) ) ) ).

% summable_divide
thf(fact_2979_summable__minus__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( uminus_uminus @ A @ ( F3 @ N2 ) ) )
          = ( summable @ A @ F3 ) ) ) ).

% summable_minus_iff
thf(fact_2980_summable__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( summable @ A
            @ ^ [N2: nat] : ( uminus_uminus @ A @ ( F3 @ N2 ) ) ) ) ) ).

% summable_minus
thf(fact_2981_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) ) )
          = ( summable @ A @ F3 ) ) ) ).

% summable_Suc_iff
thf(fact_2982_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( summable @ A @ F3 )
         => ( summable @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_2983_summable__const__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A] :
          ( ( summable @ A
            @ ^ [Uu3: nat] : C2 )
          = ( C2
            = ( zero_zero @ A ) ) ) ) ).

% summable_const_iff
thf(fact_2984_summable__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ).

% summable_diff
thf(fact_2985_summable__norm__cancel,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A] :
          ( ( summable @ real
            @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) )
         => ( summable @ A @ F3 ) ) ) ).

% summable_norm_cancel
thf(fact_2986_summable__rabs__cancel,axiom,
    ! [F3: nat > real] :
      ( ( summable @ real
        @ ^ [N2: nat] : ( abs_abs @ real @ ( F3 @ N2 ) ) )
     => ( summable @ real @ F3 ) ) ).

% summable_rabs_cancel
thf(fact_2987_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F3: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_mult_D
thf(fact_2988_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_2989_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F3 ) ) ) ) ) ).

% suminf_mult
thf(fact_2990_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( ( times_times @ A @ ( suminf @ A @ F3 ) @ C2 )
            = ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_2991_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A,G: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( summable @ A @ G )
           => ( ( plus_plus @ A @ ( suminf @ A @ F3 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N2: nat] : ( plus_plus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_2992_suminf__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( summable @ A @ G )
           => ( ( minus_minus @ A @ ( suminf @ A @ F3 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ) ).

% suminf_diff
thf(fact_2993_suminf__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( F3 @ N2 ) @ C2 ) )
            = ( divide_divide @ A @ ( suminf @ A @ F3 ) @ C2 ) ) ) ) ).

% suminf_divide
thf(fact_2994_suminf__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( uminus_uminus @ A @ ( F3 @ N2 ) ) )
            = ( uminus_uminus @ A @ ( suminf @ A @ F3 ) ) ) ) ) ).

% suminf_minus
thf(fact_2995_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > A,X2: A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_2996_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ( ( suminf @ A @ F3 )
                = ( zero_zero @ A ) )
              = ( ! [N2: nat] :
                    ( ( F3 @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_2997_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F3 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_2998_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F3 ) ) ) ) ) ).

% suminf_pos
thf(fact_2999_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( archimedean_ceiling @ A @ Y2 ) )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% ceiling_less_cancel
thf(fact_3000_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F3: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_zero_power'
thf(fact_3001_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_0_powser
thf(fact_3002_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_3003_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_3004_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > A,M: nat,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( plus_plus @ nat @ N2 @ M ) ) @ ( power_power @ A @ Z @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_3005_polar__Ex,axiom,
    ! [X2: real,Y2: real] :
    ? [R2: real,A4: real] :
      ( ( X2
        = ( times_times @ real @ R2 @ ( cos @ real @ A4 ) ) )
      & ( Y2
        = ( times_times @ real @ R2 @ ( sin @ real @ A4 ) ) ) ) ).

% polar_Ex
thf(fact_3006_cos__arctan__not__zero,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( arctan @ X2 ) )
     != ( zero_zero @ real ) ) ).

% cos_arctan_not_zero
thf(fact_3007_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > real] :
          ( ? [N7: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N7 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_3008_summable__rabs__comparison__test,axiom,
    ! [F3: nat > real,G: nat > real] :
      ( ? [N7: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N7 @ N3 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F3 @ N3 ) ) @ ( G @ N3 ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F3 @ N2 ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_3009_summable__rabs,axiom,
    ! [F3: nat > real] :
      ( ( summable @ real
        @ ^ [N2: nat] : ( abs_abs @ real @ ( F3 @ N2 ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F3 ) )
        @ ( suminf @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F3 @ N2 ) ) ) ) ) ).

% summable_rabs
thf(fact_3010_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,I3: nat] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I3 ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F3 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_3011_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F3 ) )
              = ( ? [I: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_3012_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X2 )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_3013_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% sin_add
thf(fact_3014_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% sin_diff
thf(fact_3015_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_3016_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X2 ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_3017_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F3 ) @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_3018_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_3019_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ int @ Z @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ X2 ) ) ) ).

% less_ceiling_iff
thf(fact_3020_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( archimedean_ceiling @ A @ Y2 ) ) ) ) ).

% ceiling_add_le
thf(fact_3021_cos__monotone__0__pi__le,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_3022_cos__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) )
              = ( ord_less_eq @ real @ Y2 @ X2 ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_3023_cos__inj__pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ( cos @ real @ X2 )
                = ( cos @ real @ Y2 ) )
             => ( X2 = Y2 ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_3024_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A] :
          ( ( summable @ real
            @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F3 ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) ) ) ) ) ).

% summable_norm
thf(fact_3025_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% cos_diff
thf(fact_3026_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% cos_add
thf(fact_3027_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X2 ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_3028_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( plus_plus @ A @ R @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_3029_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( one_one @ A ) ) @ R ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_3030_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_3031_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: nat > A,X2: A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ) ).

% powser_inside
thf(fact_3032_cos__monotone__0__pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ord_less @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_3033_cos__mono__less__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) )
              = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_3034_cos__monotone__minus__pi__0_H,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y2 ) @ ( cos @ real @ X2 ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_3035_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_3036_sin__zero__abs__cos__one,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X2 ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_3037_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
            = ( plus_plus @ A @ ( F3 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
                @ Z ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_3038_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ Z )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_3039_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,F3: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( ( summable @ A @ F3 )
           => ? [N8: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N9 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I: nat] : ( F3 @ ( plus_plus @ nat @ I @ N9 ) ) ) )
                  @ R ) ) ) ) ) ).

% suminf_exist_split
thf(fact_3040_summable__power__series,axiom,
    ! [F3: nat > real,Z: real] :
      ( ! [I2: nat] : ( ord_less_eq @ real @ ( F3 @ I2 ) @ ( one_one @ real ) )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ I2 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z )
         => ( ( ord_less @ real @ Z @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I: nat] : ( times_times @ real @ ( F3 @ I ) @ ( power_power @ real @ Z @ I ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_3041_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,R0: real,A2: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R )
         => ( ( ord_less @ real @ R @ R0 )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R0 @ N3 ) ) @ M7 )
             => ( summable @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N2 ) ) @ ( power_power @ real @ R @ N2 ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_3042_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X2 ) ) @ ( cos @ A @ X2 ) ) ) ) ).

% sin_double
thf(fact_3043_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) ) @ ( one_one @ A ) ) @ X2 )
          & ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) ) ) ) ) ).

% ceiling_correct
thf(fact_3044_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ Z ) )
           => ( ( archimedean_ceiling @ A @ X2 )
              = Z ) ) ) ) ).

% ceiling_unique
thf(fact_3045_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X2 )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_3046_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P3: int > $o,T3: A] :
          ( ( P3 @ ( archimedean_ceiling @ A @ T3 ) )
          = ( ! [I: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I ) @ ( one_one @ A ) ) @ T3 )
                  & ( ord_less_eq @ A @ T3 @ ( ring_1_of_int @ A @ I ) ) )
               => ( P3 @ I ) ) ) ) ) ).

% ceiling_split
thf(fact_3047_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N5: nat,F3: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ ( suc @ N3 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) ) ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_ratio_test
thf(fact_3048_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_3049_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_3050_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less_eq @ int @ Z @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% le_ceiling_iff
thf(fact_3051_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_3052_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_3053_cos__is__zero,axiom,
    ? [X7: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X7 )
      & ( ord_less_eq @ real @ X7 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X7 )
        = ( zero_zero @ real ) )
      & ! [Y3: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
            & ( ord_less_eq @ real @ Y3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y3 )
              = ( zero_zero @ real ) ) )
         => ( Y3 = X7 ) ) ) ).

% cos_is_zero
thf(fact_3054_cos__monotone__minus__pi__0,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y2 ) @ ( cos @ real @ X2 ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_3055_cos__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ? [X7: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X7 )
            & ( ord_less_eq @ real @ X7 @ pi )
            & ( ( cos @ real @ X7 )
              = Y2 )
            & ! [Y3: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
                  & ( ord_less_eq @ real @ Y3 @ pi )
                  & ( ( cos @ real @ Y3 )
                    = Y2 ) )
               => ( Y3 = X7 ) ) ) ) ) ).

% cos_total
thf(fact_3056_sincos__principal__value,axiom,
    ! [X2: real] :
    ? [Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y5 )
      & ( ord_less_eq @ real @ Y5 @ pi )
      & ( ( sin @ real @ Y5 )
        = ( sin @ real @ X2 ) )
      & ( ( cos @ real @ Y5 )
        = ( cos @ real @ X2 ) ) ) ).

% sincos_principal_value
thf(fact_3057_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ P5 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P5 @ Q2 ) ) ) @ Q2 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_3058_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_3059_sin__cos__le1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) ) @ ( times_times @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_3060_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_3061_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_3062_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_3063_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_3064_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P5 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) @ P5 ) ) ) ).

% ceiling_divide_lower
thf(fact_3065_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int,X2: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X2 )
              = ( plus_plus @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_3066_cos__double__less__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_3067_cos__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_gt_zero
thf(fact_3068_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_3069_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_3070_cos__one__2pi__int,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( one_one @ real ) )
      = ( ? [X6: int] :
            ( X2
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X6 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3071_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_3072_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X2 ) ) ) ) ) ).

% cos_treble_cos
thf(fact_3073_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_3074_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_3075_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_3076_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_3077_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_3078_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_3079_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_3080_cos__gt__zero__pi,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_3081_cos__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_ge_zero
thf(fact_3082_cos__one__2pi,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( one_one @ real ) )
      = ( ? [X6: nat] :
            ( X2
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X6 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X6: nat] :
            ( X2
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X6 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_3083_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_3084_cos__arctan,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( arctan @ X2 ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3085_sincos__total__pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ pi )
            & ( X2
              = ( cos @ real @ T4 ) )
            & ( Y2
              = ( sin @ real @ T4 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_3086_sin__cos__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) )
     => ( ( sin @ real @ X2 )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3087_sin__expansion__lemma,axiom,
    ! [X2: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_3088_cos__zero__iff__int,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I )
            & ( X2
              = ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3089_cos__zero__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( cos @ real @ X2 )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_3090_cos__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X2
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_3091_cos__expansion__lemma,axiom,
    ! [X2: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_3092_sincos__total__pi__half,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X2
                = ( cos @ real @ T4 ) )
              & ( Y2
                = ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_3093_sincos__total__2pi__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X2
            = ( cos @ real @ T4 ) )
          & ( Y2
            = ( sin @ real @ T4 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_3094_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_3095_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_3096_sincos__total__2pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X2
                  = ( cos @ real @ T4 ) )
               => ( Y2
                 != ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_3097_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_3098_sin__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X2 )
        = ( divide_divide @ real @ ( tan @ real @ X2 ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_3099_cos__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X2 )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_3100_ceiling__log__eq__powr__iff,axiom,
    ! [X2: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X2 ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_3101_cos__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X2 ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3102_powr__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [Z: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z )
          = ( zero_zero @ A ) ) ) ).

% powr_0
thf(fact_3103_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [W: A,Z: A] :
          ( ( ( powr @ A @ W @ Z )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) ).

% powr_eq_0_iff
thf(fact_3104_tan__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tan_zero
thf(fact_3105_arcsin__0,axiom,
    ( ( arcsin @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arcsin_0
thf(fact_3106_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X2: A] :
          ( ( ( X2
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X2 @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X2
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X2 @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_3107_powr__gt__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X2 @ A2 ) )
      = ( ( X2
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_3108_powr__nonneg__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X2 ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_3109_powr__less__cancel__iff,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_3110_tan__pi,axiom,
    ( ( tan @ real @ pi )
    = ( zero_zero @ real ) ) ).

% tan_pi
thf(fact_3111_powr__eq__one__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X2 )
          = ( one_one @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_3112_powr__one,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( one_one @ real ) )
        = X2 ) ) ).

% powr_one
thf(fact_3113_powr__one__gt__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( powr @ real @ X2 @ ( one_one @ real ) )
        = X2 )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% powr_one_gt_zero_iff
thf(fact_3114_powr__le__cancel__iff,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_3115_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% numeral_powr_numeral_real
thf(fact_3116_powr__log__cancel,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X2 ) )
            = X2 ) ) ) ) ).

% powr_log_cancel
thf(fact_3117_log__powr__cancel,axiom,
    ! [A2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y2 ) )
          = Y2 ) ) ) ).

% log_powr_cancel
thf(fact_3118_tan__npi,axiom,
    ! [N: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_3119_tan__periodic__n,axiom,
    ! [X2: real,N: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_n
thf(fact_3120_tan__periodic__nat,axiom,
    ! [X2: real,N: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_nat
thf(fact_3121_tan__periodic__int,axiom,
    ! [X2: real,I3: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_int
thf(fact_3122_powr__numeral,axiom,
    ! [X2: real,N: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( numeral_numeral @ real @ N ) )
        = ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% powr_numeral
thf(fact_3123_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_3124_tan__periodic,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic
thf(fact_3125_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_3126_square__powr__half,axiom,
    ! [X2: real] :
      ( ( powr @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X2 ) ) ).

% square_powr_half
thf(fact_3127_powr__powr,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X2 @ A2 ) @ B2 )
      = ( powr @ real @ X2 @ ( times_times @ real @ A2 @ B2 ) ) ) ).

% powr_powr
thf(fact_3128_powr__non__neg,axiom,
    ! [A2: real,X2: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A2 @ X2 ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_3129_powr__less__mono2__neg,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ Y2 )
         => ( ord_less @ real @ ( powr @ real @ Y2 @ A2 ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_3130_powr__ge__pzero,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X2 @ Y2 ) ) ).

% powr_ge_pzero
thf(fact_3131_powr__mono2,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ Y2 )
         => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_3132_powr__less__mono,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
       => ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_3133_powr__less__cancel,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_3134_powr__mono2_H,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ Y2 )
         => ( ord_less_eq @ real @ ( powr @ real @ Y2 @ A2 ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_3135_powr__less__mono2,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ Y2 )
         => ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_3136_powr__inj,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X2 )
            = ( powr @ real @ A2 @ Y2 ) )
          = ( X2 = Y2 ) ) ) ) ).

% powr_inj
thf(fact_3137_gr__one__powr,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X2 @ Y2 ) ) ) ) ).

% gr_one_powr
thf(fact_3138_powr__le1,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_3139_powr__mono__both,axiom,
    ! [A2: real,B2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ X2 @ Y2 )
           => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_3140_ge__one__powr__ge__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_3141_powr__divide,axiom,
    ! [X2: real,Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( powr @ real @ ( divide_divide @ real @ X2 @ Y2 ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_3142_powr__mult,axiom,
    ! [X2: real,Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( powr @ real @ ( times_times @ real @ X2 @ Y2 ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_3143_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A2 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_3144_log__base__powr,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A2 @ B2 ) @ X2 )
        = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_3145_ln__powr,axiom,
    ! [X2: real,Y2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X2 @ Y2 ) )
        = ( times_times @ real @ Y2 @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_powr
thf(fact_3146_log__powr,axiom,
    ! [X2: real,B2: real,Y2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X2 @ Y2 ) )
        = ( times_times @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ).

% log_powr
thf(fact_3147_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X2: A,A2: A,B2: A] :
          ( ( powr @ A @ X2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X2 @ A2 ) @ ( powr @ A @ X2 @ B2 ) ) ) ) ).

% powr_add
thf(fact_3148_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W: A,Z1: A,Z22: A] :
          ( ( powr @ A @ W @ ( minus_minus @ A @ Z1 @ Z22 ) )
          = ( divide_divide @ A @ ( powr @ A @ W @ Z1 ) @ ( powr @ A @ W @ Z22 ) ) ) ) ).

% powr_diff
thf(fact_3149_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X6: A] : ( divide_divide @ A @ ( sin @ A @ X6 ) @ ( cos @ A @ X6 ) ) ) ) ) ).

% tan_def
thf(fact_3150_powr__realpow,axiom,
    ! [X2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( semiring_1_of_nat @ real @ N ) )
        = ( power_power @ real @ X2 @ N ) ) ) ).

% powr_realpow
thf(fact_3151_less__log__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ Y2 @ ( log @ B2 @ X2 ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ).

% less_log_iff
thf(fact_3152_log__less__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ B2 @ X2 ) @ Y2 )
          = ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ).

% log_less_iff
thf(fact_3153_less__powr__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) )
          = ( ord_less @ real @ ( log @ B2 @ X2 ) @ Y2 ) ) ) ) ).

% less_powr_iff
thf(fact_3154_powr__less__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 )
          = ( ord_less @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ) ).

% powr_less_iff
thf(fact_3155_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X2: A,A2: A] :
          ( ( powr @ A @ X2 @ ( uminus_uminus @ A @ A2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X2 @ A2 ) ) ) ) ).

% powr_minus_divide
thf(fact_3156_powr__neg__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% powr_neg_one
thf(fact_3157_arcsin__less__arcsin,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_3158_powr__mult__base,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( times_times @ real @ X2 @ ( powr @ real @ X2 @ Y2 ) )
        = ( powr @ real @ X2 @ ( plus_plus @ real @ ( one_one @ real ) @ Y2 ) ) ) ) ).

% powr_mult_base
thf(fact_3159_arcsin__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% arcsin_less_mono
thf(fact_3160_powr__le__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 )
          = ( ord_less_eq @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ) ).

% powr_le_iff
thf(fact_3161_le__powr__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X2 ) @ Y2 ) ) ) ) ).

% le_powr_iff
thf(fact_3162_log__le__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X2 ) @ Y2 )
          = ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ).

% log_le_iff
thf(fact_3163_le__log__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( log @ B2 @ X2 ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ).

% le_log_iff
thf(fact_3164_ln__powr__bound,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( divide_divide @ real @ ( powr @ real @ X2 @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_3165_ln__powr__bound2,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X2 ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X2 ) ) ) ) ).

% ln_powr_bound2
thf(fact_3166_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_3167_add__log__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( plus_plus @ real @ Y2 @ ( log @ B2 @ X2 ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_3168_log__add__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( plus_plus @ real @ ( log @ B2 @ X2 ) @ Y2 )
            = ( log @ B2 @ ( times_times @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_3169_minus__log__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( minus_minus @ real @ Y2 @ ( log @ B2 @ X2 ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_3170_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_3171_cos__arcsin__nonzero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X2 ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3172_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X6: A,A5: A] :
              ( if @ A
              @ ( X6
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A5 @ ( ln_ln @ A @ X6 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_3173_tan__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X2 ) ) ) ) ).

% tan_gt_zero
thf(fact_3174_lemma__tan__total,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X7: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X7 )
          & ( ord_less @ real @ X7 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y2 @ ( tan @ real @ X7 ) ) ) ) ).

% lemma_tan_total
thf(fact_3175_lemma__tan__total1,axiom,
    ! [Y2: real] :
    ? [X7: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X7 )
      & ( ord_less @ real @ X7 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X7 )
        = Y2 ) ) ).

% lemma_tan_total1
thf(fact_3176_tan__mono__lt__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) )
              = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_3177_tan__monotone_H,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
         => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y2 @ X2 )
              = ( ord_less @ real @ ( tan @ real @ Y2 ) @ ( tan @ real @ X2 ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_3178_tan__monotone,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y2 ) @ ( tan @ real @ X2 ) ) ) ) ) ).

% tan_monotone
thf(fact_3179_tan__total,axiom,
    ! [Y2: real] :
    ? [X7: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X7 )
      & ( ord_less @ real @ X7 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X7 )
        = Y2 )
      & ! [Y3: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
            & ( ord_less @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y3 )
              = Y2 ) )
         => ( Y3 = X7 ) ) ) ).

% tan_total
thf(fact_3180_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_3181_tan__inverse,axiom,
    ! [Y2: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y2 ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 ) ) ) ).

% tan_inverse
thf(fact_3182_log__minus__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( minus_minus @ real @ ( log @ B2 @ X2 ) @ Y2 )
            = ( log @ B2 @ ( times_times @ real @ X2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y2 ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_3183_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_3184_powr__half__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X2 ) ) ) ).

% powr_half_sqrt
thf(fact_3185_powr__neg__numeral,axiom,
    ! [X2: real,N: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_3186_tan__pos__pi2__le,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X2 ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_3187_tan__total__pos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X7 )
          & ( ord_less @ real @ X7 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X7 )
            = Y2 ) ) ) ).

% tan_total_pos
thf(fact_3188_tan__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_3189_tan__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) )
              = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_3190_tan__mono__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) ) ) ) ) ).

% tan_mono_le
thf(fact_3191_tan__bound__pi2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X2 ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_3192_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_3193_arctan__unique,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X2 )
            = Y2 )
         => ( ( arctan @ Y2 )
            = X2 ) ) ) ) ).

% arctan_unique
thf(fact_3194_arctan__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X2 ) )
          = X2 ) ) ) ).

% arctan_tan
thf(fact_3195_arctan,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) )
      & ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y2 ) )
        = Y2 ) ) ).

% arctan
thf(fact_3196_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_3197_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_3198_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_3199_tan__total__pi4,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ? [Z2: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z2 )
          & ( ord_less @ real @ Z2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z2 )
            = X2 ) ) ) ).

% tan_total_pi4
thf(fact_3200_arcsin__lt__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3201_arcsin__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3202_arcsin__ubound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3203_arcsin__lbound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) ) ) ) ).

% arcsin_lbound
thf(fact_3204_arcsin__sin,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X2 ) )
          = X2 ) ) ) ).

% arcsin_sin
thf(fact_3205_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X6: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X6 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X6 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_3206_le__arcsin__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y2 @ ( arcsin @ X2 ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y2 ) @ X2 ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3207_arcsin__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X2 ) @ Y2 )
              = ( ord_less_eq @ real @ X2 @ ( sin @ real @ Y2 ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3208_arcsin__pi,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y2 ) )
            = Y2 ) ) ) ) ).

% arcsin_pi
thf(fact_3209_arcsin,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y2 ) )
            = Y2 ) ) ) ) ).

% arcsin
thf(fact_3210_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X6: A] : ( ln_ln @ A @ ( plus_plus @ A @ X6 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_3211_sin__arccos__abs,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y2 ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3212_sin__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X2 ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3213_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_3214_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X6: A] : ( ln_ln @ A @ ( plus_plus @ A @ X6 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_3215_summable__complex__of__real,axiom,
    ! [F3: nat > real] :
      ( ( summable @ complex
        @ ^ [N2: nat] : ( real_Vector_of_real @ complex @ ( F3 @ N2 ) ) )
      = ( summable @ real @ F3 ) ) ).

% summable_complex_of_real
thf(fact_3216_sums__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( sums @ A
        @ ^ [N2: nat] : ( zero_zero @ A )
        @ ( zero_zero @ A ) ) ) ).

% sums_zero
thf(fact_3217_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real] :
          ( ( ( real_Vector_of_real @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( X2
            = ( zero_zero @ real ) ) ) ) ).

% of_real_eq_0_iff
thf(fact_3218_of__real__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) ).

% of_real_0
thf(fact_3219_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X2 @ Y2 ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_mult
thf(fact_3220_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_real_numeral
thf(fact_3221_of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X2 @ Y2 ) )
          = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_divide
thf(fact_3222_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_add
thf(fact_3223_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,N: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X2 @ N ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X2 ) @ N ) ) ) ).

% of_real_power
thf(fact_3224_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3225_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( zero_zero @ A ) ) ) ).

% sin_of_real_pi
thf(fact_3226_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_real_neg_numeral
thf(fact_3227_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X2: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
            @ X2 )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X2 ) ) ) ).

% powser_sums_zero_iff
thf(fact_3228_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_3229_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X2 @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_3230_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3231_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_3232_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_3233_sums__of__real__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > real,C2: real] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( real_Vector_of_real @ A @ ( F3 @ N2 ) )
            @ ( real_Vector_of_real @ A @ C2 ) )
          = ( sums @ real @ F3 @ C2 ) ) ) ).

% sums_of_real_iff
thf(fact_3234_sums__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [X15: nat > real,A2: real] :
          ( ( sums @ real @ X15 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( real_Vector_of_real @ A @ ( X15 @ N2 ) )
            @ ( real_Vector_of_real @ A @ A2 ) ) ) ) ).

% sums_of_real
thf(fact_3235_sums__0,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F3: nat > A] :
          ( ! [N3: nat] :
              ( ( F3 @ N3 )
              = ( zero_zero @ A ) )
         => ( sums @ A @ F3 @ ( zero_zero @ A ) ) ) ) ).

% sums_0
thf(fact_3236_sums__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I3: nat,F3: nat > A] :
          ( sums @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I3 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) )
          @ ( F3 @ I3 ) ) ) ).

% sums_single
thf(fact_3237_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 )
            @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_3238_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) )
            @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% sums_mult
thf(fact_3239_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) )
              @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_3240_sums__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) )
              @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_diff
thf(fact_3241_sums__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F3 @ N2 ) @ C2 )
            @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ).

% sums_divide
thf(fact_3242_sums__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,A2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( uminus_uminus @ A @ ( F3 @ N2 ) )
            @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% sums_minus
thf(fact_3243_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F3: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F3 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_3244_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F3: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F3 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_3245_summable__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [X15: nat > real] :
          ( ( summable @ real @ X15 )
         => ( summable @ A
            @ ^ [N2: nat] : ( real_Vector_of_real @ A @ ( X15 @ N2 ) ) ) ) ) ).

% summable_of_real
thf(fact_3246_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y2: real,X2: real] :
          ( ( Y2
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X2 @ Y2 ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_3247_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F3: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F3 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_3248_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,S: A] :
          ( ( ( F3 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
              @ S )
           => ( sums @ A @ F3 @ S ) ) ) ) ).

% sums_Suc_imp
thf(fact_3249_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A,L: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ L )
         => ( sums @ A @ F3 @ ( plus_plus @ A @ L @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_3250_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,S: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ S )
          = ( sums @ A @ F3 @ ( plus_plus @ A @ S @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_3251_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N: nat,F3: nat > A,S: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ N )
             => ( ( F3 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I: nat] : ( F3 @ ( plus_plus @ nat @ I @ N ) )
              @ S )
            = ( sums @ A @ F3 @ S ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_3252_suminf__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [X15: nat > real] :
          ( ( summable @ real @ X15 )
         => ( ( real_Vector_of_real @ A @ ( suminf @ real @ X15 ) )
            = ( suminf @ A
              @ ^ [N2: nat] : ( real_Vector_of_real @ A @ ( X15 @ N2 ) ) ) ) ) ) ).

% suminf_of_real
thf(fact_3253_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_3254_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( if @ A @ ( N2 = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z @ N2 ) )
          @ ( power_power @ A @ Z @ M ) ) ) ).

% powser_sums_if
thf(fact_3255_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_3256_arccos__lbound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) ) ) ) ).

% arccos_lbound
thf(fact_3257_arccos__less__arccos,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y2 ) @ ( arccos @ X2 ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3258_arccos__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X2 ) @ ( arccos @ Y2 ) )
          = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ).

% arccos_less_mono
thf(fact_3259_arccos__cos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( arccos @ ( cos @ real @ X2 ) )
          = X2 ) ) ) ).

% arccos_cos
thf(fact_3260_arccos__lt__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less @ real @ ( arccos @ Y2 ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3261_arccos__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3262_sin__arccos__nonzero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X2 ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3263_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X2: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X2 ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X2 ) ) ) ) ) ).

% cos_int_times_real
thf(fact_3264_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X2: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X2 ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X2 ) ) ) ) ) ).

% sin_int_times_real
thf(fact_3265_arccos__cos2,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
       => ( ( arccos @ ( cos @ real @ X2 ) )
          = ( uminus_uminus @ real @ X2 ) ) ) ) ).

% arccos_cos2
thf(fact_3266_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_3267_power__half__series,axiom,
    ( sums @ real
    @ ^ [N2: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N2 ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_3268_arccos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y2 ) )
            = Y2 ) ) ) ) ).

% arccos
thf(fact_3269_sums__if_H,axiom,
    ! [G: nat > real,X2: real] :
      ( ( sums @ real @ G @ X2 )
     => ( sums @ real
        @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X2 ) ) ).

% sums_if'
thf(fact_3270_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X6: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X6 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_3271_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X6: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X6 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_3272_sums__if,axiom,
    ! [G: nat > real,X2: real,F3: nat > real,Y2: real] :
      ( ( sums @ real @ G @ X2 )
     => ( ( sums @ real @ F3 @ Y2 )
       => ( sums @ real
          @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( F3 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X2 @ Y2 ) ) ) ) ).

% sums_if
thf(fact_3273_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X2 ) )
          = ( cos @ A @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_3274_arccos__le__pi2,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3275_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K3: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K3 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3276_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( C2 @ N2 ) ) @ ( power_power @ A @ X2 @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_3277_sin__paired,axiom,
    ! [X2: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X2 ) ) ).

% sin_paired
thf(fact_3278_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_3279_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_3280_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X15: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X15 @ N3 ) @ ( X15 @ ( suc @ N3 ) ) )
         => ( topological_monoseq @ A @ X15 ) ) ) ).

% mono_SucI1
thf(fact_3281_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) )
            = X2 )
          = ( ? [N2: int] :
                ( X2
                = ( ring_1_of_int @ A @ N2 ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_3282_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_3283_floor__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% floor_zero
thf(fact_3284_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% floor_numeral
thf(fact_3285_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_3286_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% pochhammer_Suc0
thf(fact_3287_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_3288_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_3289_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_3290_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% zero_le_floor
thf(fact_3291_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_3292_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V ) @ X2 ) ) ) ).

% numeral_le_floor
thf(fact_3293_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ).

% zero_less_floor
thf(fact_3294_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_3295_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X2 @ ( numeral_numeral @ A @ V ) ) ) ) ).

% floor_less_numeral
thf(fact_3296_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_3297_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_neg_numeral
thf(fact_3298_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_diff_numeral
thf(fact_3299_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: num,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) ) ) ).

% floor_numeral_power
thf(fact_3300_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_3301_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% numeral_less_floor
thf(fact_3302_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_3303_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) ) ).

% one_less_floor
thf(fact_3304_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_3305_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X2 ) ) ) ).

% neg_numeral_le_floor
thf(fact_3306_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_3307_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_3308_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_3309_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% neg_numeral_less_floor
thf(fact_3310_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_3311_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_3312_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A4: complex,R2: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( exp @ complex @ A4 ) ) ) ).

% complex_exp_exists
thf(fact_3313_diffs__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [F3: nat > real] :
          ( ( diffs @ A
            @ ^ [N2: nat] : ( real_Vector_of_real @ A @ ( F3 @ N2 ) ) )
          = ( ^ [N2: nat] : ( real_Vector_of_real @ A @ ( diffs @ real @ F3 @ N2 ) ) ) ) ) ).

% diffs_of_real
thf(fact_3314_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ N )
         != ( zero_zero @ A ) ) ) ).

% fact_nonzero
thf(fact_3315_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% floor_less_cancel
thf(fact_3316_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_zero
thf(fact_3317_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_3318_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_gt_zero
thf(fact_3319_diffs__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [C2: nat > A] :
          ( ( diffs @ A
            @ ^ [N2: nat] : ( uminus_uminus @ A @ ( C2 @ N2 ) ) )
          = ( ^ [N2: nat] : ( uminus_uminus @ A @ ( diffs @ A @ C2 @ N2 ) ) ) ) ) ).

% diffs_minus
thf(fact_3320_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X2 @ N ) ) ) ) ).

% pochhammer_pos
thf(fact_3321_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_3322_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_3323_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_3324_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% floor_less_iff
thf(fact_3325_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% le_floor_add
thf(fact_3326_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) ) ) ) ).

% floor_add_int
thf(fact_3327_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( plus_plus @ int @ Z @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ X2 ) ) ) ) ).

% int_add_floor
thf(fact_3328_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) )
          = ( divide_divide @ int @ K @ L ) ) ) ).

% floor_divide_of_int_eq
thf(fact_3329_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,N: nat] :
          ( ( X2
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X2 @ N ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ N ) ) ) ) ).

% floor_power
thf(fact_3330_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ) ).

% fact_less_mono
thf(fact_3331_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_3332_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X2 @ N ) ) ) ) ).

% pochhammer_nonneg
thf(fact_3333_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N @ N ) ) ) ) ).

% fact_le_power
thf(fact_3334_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_3335_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_3336_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_3337_real__of__int__floor__add__one__gt,axiom,
    ! [R: real] : ( ord_less @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_3338_floor__eq,axiom,
    ! [N: int,X2: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X2 )
          = N ) ) ) ).

% floor_eq
thf(fact_3339_real__of__int__floor__add__one__ge,axiom,
    ! [R: real] : ( ord_less_eq @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_3340_real__of__int__floor__gt__diff__one,axiom,
    ! [R: real] : ( ord_less @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_3341_real__of__int__floor__ge__diff__one,axiom,
    ! [R: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_3342_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% pochhammer_rec
thf(fact_3343_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C4: nat > A,N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( C4 @ ( suc @ N2 ) ) ) ) ) ) ).

% diffs_def
thf(fact_3344_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_3345_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_3346_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,K: nat] :
          ( ( ord_less @ nat @ N @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_3347_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_3348_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ? [K2: nat] :
                ( ( ord_less @ nat @ K2 @ N )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K2 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_3349_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_3350_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_3351_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( plus_plus @ nat @ N @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_3352_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_3353_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P3: int > $o,T3: A] :
          ( ( P3 @ ( archim6421214686448440834_floor @ A @ T3 ) )
          = ( ! [I: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I ) @ T3 )
                  & ( ord_less @ A @ T3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I ) @ ( one_one @ A ) ) ) )
               => ( P3 @ I ) ) ) ) ) ).

% floor_split
thf(fact_3354_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X2 )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X2 )
            & ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_3355_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X2 )
         => ( ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X2 )
              = Z ) ) ) ) ).

% floor_unique
thf(fact_3356_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_3357_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ int @ Z @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% less_floor_iff
thf(fact_3358_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_3359_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_3360_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [X7: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X7 @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_3361_floor__eq2,axiom,
    ! [N: int,X2: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X2 )
          = N ) ) ) ).

% floor_eq2
thf(fact_3362_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_3363_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,Z: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_3364_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P5 @ Q2 ) ) ) @ Q2 ) @ P5 ) ) ) ).

% floor_divide_lower
thf(fact_3365_square__fact__le__2__fact,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% square_fact_le_2_fact
thf(fact_3366_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M4: nat] :
              ( if @ A
              @ ( M4
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M4 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M4 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_3367_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_3368_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R ) @ K ) )
          = ( times_times @ A @ R @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_3369_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ P5 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P5 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) ) ) ) ).

% floor_divide_upper
thf(fact_3370_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X6: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X6 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_3371_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_3372_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_3373_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,K5: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K5 )
         => ( ! [X7: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X7 ) @ K5 )
               => ( summable @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X7 @ N2 ) ) ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_3374_floor__log__eq__powr__iff,axiom,
    ! [X2: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X2 ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X2 )
            & ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_3375_monoseq__minus,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: nat > A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( topological_monoseq @ A
            @ ^ [N2: nat] : ( uminus_uminus @ A @ ( A2 @ N2 ) ) ) ) ) ).

% monoseq_minus
thf(fact_3376_floor__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_3377_cos__paired,axiom,
    ! [X2: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ real @ X2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      @ ( cos @ real @ X2 ) ) ).

% cos_paired
thf(fact_3378_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_3379_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X8: nat > A] :
              ( ! [N2: nat] : ( ord_less_eq @ A @ ( X8 @ N2 ) @ ( X8 @ ( suc @ N2 ) ) )
              | ! [N2: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N2 ) ) @ ( X8 @ N2 ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_3380_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X15: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X15 @ ( suc @ N3 ) ) @ ( X15 @ N3 ) )
         => ( topological_monoseq @ A @ X15 ) ) ) ).

% mono_SucI2
thf(fact_3381_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ).

% sin_coeff_def
thf(fact_3382_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_3383_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_3384_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_3385_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_3386_sin__coeff__0,axiom,
    ( ( sin_coeff @ ( zero_zero @ nat ) )
    = ( zero_zero @ real ) ) ).

% sin_coeff_0
thf(fact_3387_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_3388_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% fact_less_mono_nat
thf(fact_3389_sin__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( sin_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( cos_coeff @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% sin_coeff_Suc
thf(fact_3390_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_Suc_0_nat
thf(fact_3391_cos__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( cos_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% cos_coeff_Suc
thf(fact_3392_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_3393_fact__div__fact__le__pow,axiom,
    ! [R: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ R ) ) ) @ ( power_power @ nat @ N @ R ) ) ) ).

% fact_div_fact_le_pow
thf(fact_3394_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F5: nat > A > A,A5: nat,B4: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B4 @ A5 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F5 @ ( plus_plus @ nat @ A5 @ ( one_one @ nat ) ) @ B4 @ ( F5 @ A5 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_3395_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X2: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y2: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X2 @ Xa @ Xb @ Xc )
        = Y2 )
     => ( ( ( ord_less @ nat @ Xb @ Xa )
         => ( Y2 = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb @ Xa )
         => ( Y2
            = ( set_fo6178422350223883121st_nat @ A @ X2 @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X2 @ Xa @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_3396_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_3397_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X6: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X6 ) ) @ ( archimedean_ceiling @ A @ X6 ) @ ( archim6421214686448440834_floor @ A @ X6 ) ) ) ) ) ).

% round_altdef
thf(fact_3398_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I: A] : ( plus_plus @ A @ I @ ( one_one @ A ) )
              @ N2
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_3399_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_3400_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z
               != ( complex2 @ ( cos @ real @ T4 ) @ ( sin @ real @ T4 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_3401_cot__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_3402_binomial__Suc__n,axiom,
    ! [N: nat] :
      ( ( binomial @ ( suc @ N ) @ N )
      = ( suc @ N ) ) ).

% binomial_Suc_n
thf(fact_3403_cot__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% cot_zero
thf(fact_3404_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_3405_binomial__1,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = N ) ).

% binomial_1
thf(fact_3406_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N @ K ) ) ).

% binomial_eq_0_iff
thf(fact_3407_binomial__Suc__Suc,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_3408_binomial__n__0,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_3409_frac__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archimedean_frac @ A @ ( ring_1_of_int @ A @ Z ) )
          = ( zero_zero @ A ) ) ) ).

% frac_of_int
thf(fact_3410_cot__pi,axiom,
    ( ( cot @ real @ pi )
    = ( zero_zero @ real ) ) ).

% cot_pi
thf(fact_3411_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) )
      = ( ord_less_eq @ nat @ K @ N ) ) ).

% zero_less_binomial_iff
thf(fact_3412_cot__npi,axiom,
    ! [N: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3413_cot__periodic,axiom,
    ! [X2: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X2 ) ) ).

% cot_periodic
thf(fact_3414_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( zero_zero @ complex ) )
      = ( ( A2
          = ( zero_zero @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_0
thf(fact_3415_zero__complex_Ocode,axiom,
    ( ( zero_zero @ complex )
    = ( complex2 @ ( zero_zero @ real ) @ ( zero_zero @ real ) ) ) ).

% zero_complex.code
thf(fact_3416_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ N @ K )
     => ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_3417_Suc__times__binomial__eq,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_3418_Suc__times__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) ) ).

% Suc_times_binomial
thf(fact_3419_choose__mult__lemma,axiom,
    ! [M: nat,R: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ ( plus_plus @ nat @ M @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M @ R ) @ M ) ) ) ).

% choose_mult_lemma
thf(fact_3420_binomial__le__pow,axiom,
    ! [R: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R @ N )
     => ( ord_less_eq @ nat @ ( binomial @ N @ R ) @ ( power_power @ nat @ N @ R ) ) ) ).

% binomial_le_pow
thf(fact_3421_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_3422_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_3423_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_3424_complex__of__real__def,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [R5: real] : ( complex2 @ R5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_def
thf(fact_3425_complex__of__real__code,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [X6: real] : ( complex2 @ X6 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_code
thf(fact_3426_complex__eq__cancel__iff2,axiom,
    ! [X2: real,Y2: real,Xa: real] :
      ( ( ( complex2 @ X2 @ Y2 )
        = ( real_Vector_of_real @ complex @ Xa ) )
      = ( ( X2 = Xa )
        & ( Y2
          = ( zero_zero @ real ) ) ) ) ).

% complex_eq_cancel_iff2
thf(fact_3427_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X2 ) ) ) ).

% frac_ge_0
thf(fact_3428_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X2 ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_3429_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X2 ) ) ) ).

% frac_1_eq
thf(fact_3430_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) ) ) ).

% zero_less_binomial
thf(fact_3431_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( suc @ A2 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ A2 ) ) ) ).

% Suc_times_binomial_add
thf(fact_3432_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( times_times @ nat @ ( binomial @ N @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N @ K ) @ ( binomial @ ( minus_minus @ nat @ N @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_3433_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( binomial @ N @ K ) )
        = ( semiring_char_0_fact @ nat @ N ) ) ) ).

% binomial_fact_lemma
thf(fact_3434_binomial__Suc__Suc__eq__times,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_3435_binomial__absorb__comp,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N @ K ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_3436_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_3437_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_3438_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N: nat,I3: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N ) @ I3 )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N @ ( Inc @ I3 ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_3439_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I3: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I3 )
          = I3 ) ) ).

% of_nat_aux.simps(1)
thf(fact_3440_Complex__mult__complex__of__real,axiom,
    ! [X2: real,Y2: real,R: real] :
      ( ( times_times @ complex @ ( complex2 @ X2 @ Y2 ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( times_times @ real @ X2 @ R ) @ ( times_times @ real @ Y2 @ R ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_3441_complex__of__real__mult__Complex,axiom,
    ! [R: real,X2: real,Y2: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X2 @ Y2 ) )
      = ( complex2 @ ( times_times @ real @ R @ X2 ) @ ( times_times @ real @ R @ Y2 ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_3442_binomial__absorption,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N @ ( suc @ K ) ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_3443_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_3444_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A2 @ C2 ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A2 @ D2 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_3445_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_3446_binomial__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N )
       => ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K7 ) ) ) ) ).

% binomial_mono
thf(fact_3447_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% binomial_maximum'
thf(fact_3448_binomial__maximum,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_3449_binomial__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K7 @ N )
         => ( ord_less_eq @ nat @ ( binomial @ N @ K7 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_3450_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% binomial_le_pow2
thf(fact_3451_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_3452_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N @ K ) )
        = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_3453_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X6: A] : ( divide_divide @ A @ ( cos @ A @ X6 ) @ ( sin @ A @ X6 ) ) ) ) ) ).

% cot_def
thf(fact_3454_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = X2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_3455_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_3456_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N )
       => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K7 ) ) ) ) ).

% binomial_strict_mono
thf(fact_3457_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K7 @ N )
         => ( ord_less @ nat @ ( binomial @ N @ K7 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_3458_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_3459_central__binomial__odd,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( binomial @ N @ ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_3460_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( binomial @ N @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_3461_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_3462_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_3463_complex__norm,axiom,
    ! [X2: real,Y2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X2 @ Y2 ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_3464_choose__two,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_3465_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_3466_binomial__code,axiom,
    ( binomial
    = ( ^ [N2: nat,K2: nat] : ( if @ nat @ ( ord_less @ nat @ N2 @ K2 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K2 ) ) @ ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K2 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ K2 ) @ ( one_one @ nat ) ) @ N2 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K2 ) ) ) ) ) ) ).

% binomial_code
thf(fact_3467_cot__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X2 ) ) ) ) ).

% cot_gt_zero
thf(fact_3468_tan__cot_H,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) )
      = ( cot @ real @ X2 ) ) ).

% tan_cot'
thf(fact_3469_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K2: nat] :
              ( if @ A
              @ ( K2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L3: nat] : ( times_times @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ L3 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K2 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_3470_arctan__def,axiom,
    ( arctan
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X6: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X6 )
              & ( ord_less @ real @ X6 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X6 )
                = Y ) ) ) ) ) ).

% arctan_def
thf(fact_3471_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X6: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X6 )
              & ( ord_less_eq @ real @ X6 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X6 )
                = Y ) ) ) ) ) ).

% arcsin_def
thf(fact_3472_modulo__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_3473_powr__int,axiom,
    ! [X2: real,I3: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I3 )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ I3 ) )
            = ( power_power @ real @ X2 @ ( nat2 @ I3 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I3 )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ I3 ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( nat2 @ ( uminus_uminus @ int @ I3 ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_3474_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% sgn_sgn
thf(fact_3475_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_3476_sgn__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_zero
thf(fact_3477_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_3478_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_3479_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% idom_abs_sgn_class.sgn_minus
thf(fact_3480_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_sgn
thf(fact_3481_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_3482_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_3483_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_3484_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_3485_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_3486_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_3487_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% gbinomial_Suc0
thf(fact_3488_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_3489_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_3490_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_3491_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_3492_nat__0__iff,axiom,
    ! [I3: int] :
      ( ( ( nat2 @ I3 )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I3 @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_3493_nat__le__0,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_3494_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
        & ( ord_less @ int @ W @ Z ) ) ) ).

% zless_nat_conj
thf(fact_3495_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_3496_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_3497_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_3498_nat__zminus__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_zminus_int
thf(fact_3499_int__nat__eq,axiom,
    ! [Z: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = Z ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_3500_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_3501_sgn__mult__dvd__iff,axiom,
    ! [R: int,L: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ L ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_3502_mult__sgn__dvd__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L @ ( sgn_sgn @ int @ R ) ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_3503_dvd__sgn__mult__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ K ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_3504_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R ) ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_3505_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_3506_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% zero_less_nat_eq
thf(fact_3507_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z ) )
            = ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_nat_nat
thf(fact_3508_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sgn_of_nat
thf(fact_3509_diff__nat__numeral,axiom,
    ! [V: num,V4: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( numeral_numeral @ nat @ V4 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ V4 ) ) ) ) ).

% diff_nat_numeral
thf(fact_3510_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X2: num,N: nat,Y2: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N )
        = ( nat2 @ Y2 ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N )
        = Y2 ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_3511_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y2: int,X2: num,N: nat] :
      ( ( ( nat2 @ Y2 )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N ) )
      = ( Y2
        = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_3512_nat__ceiling__le__eq,axiom,
    ! [X2: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X2 ) ) @ A2 )
      = ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_3513_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ).

% one_less_nat_eq
thf(fact_3514_nat__numeral__diff__1,axiom,
    ! [V: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_3515_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X2: num,N: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_3516_numeral__power__less__nat__cancel__iff,axiom,
    ! [X2: num,N: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_3517_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X2: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_3518_numeral__power__le__nat__cancel__iff,axiom,
    ! [X2: num,N: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_3519_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( sgn_sgn @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_zero_iff
thf(fact_3520_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_3521_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_3522_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( sgn_sgn @ A @ A2 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_3523_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_3524_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X2 @ Y2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X2 ) @ ( sgn_sgn @ A @ Y2 ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_3525_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_3526_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_3527_nat__zero__as__int,axiom,
    ( ( zero_zero @ nat )
    = ( nat2 @ ( zero_zero @ int ) ) ) ).

% nat_zero_as_int
thf(fact_3528_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I: num] : ( nat2 @ ( numeral_numeral @ int @ I ) ) ) ) ).

% nat_numeral_as_int
thf(fact_3529_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X2 ) @ ( abs_abs @ A @ X2 ) )
          = X2 ) ) ).

% mult_sgn_abs
thf(fact_3530_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = A2 ) ) ).

% sgn_mult_abs
thf(fact_3531_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = A2 ) ) ).

% abs_mult_sgn
thf(fact_3532_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K2: A] : ( times_times @ A @ K2 @ ( sgn_sgn @ A @ K2 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_3533_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N3: nat,L2: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_sgnE
thf(fact_3534_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_3535_ex__nat,axiom,
    ( ( ^ [P: nat > $o] :
        ? [X5: nat] : ( P @ X5 ) )
    = ( ^ [P2: nat > $o] :
        ? [X6: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
          & ( P2 @ ( nat2 @ X6 ) ) ) ) ) ).

% ex_nat
thf(fact_3536_all__nat,axiom,
    ( ( ^ [P: nat > $o] :
        ! [X5: nat] : ( P @ X5 ) )
    = ( ^ [P2: nat > $o] :
        ! [X6: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
         => ( P2 @ ( nat2 @ X6 ) ) ) ) ) ).

% all_nat
thf(fact_3537_eq__nat__nat__iff,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( ( nat2 @ Z )
            = ( nat2 @ Z7 ) )
          = ( Z = Z7 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_3538_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_3539_div__eq__sgn__abs,axiom,
    ! [K: int,L: int] :
      ( ( ( sgn_sgn @ int @ K )
        = ( sgn_sgn @ int @ L ) )
     => ( ( divide_divide @ int @ K @ L )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_eq_sgn_abs
thf(fact_3540_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M4: nat,N2: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M4 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_3541_nat__mask__eq,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% nat_mask_eq
thf(fact_3542_ln__real__def,axiom,
    ( ( ln_ln @ real )
    = ( ^ [X6: real] :
          ( the @ real
          @ ^ [U2: real] :
              ( ( exp @ real @ U2 )
              = X6 ) ) ) ) ).

% ln_real_def
thf(fact_3543_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_3544_suminf__def,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F5: nat > A] : ( the @ A @ ( sums @ A @ F5 ) ) ) ) ) ).

% suminf_def
thf(fact_3545_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_3546_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_mono_iff
thf(fact_3547_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_3548_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z ) ) ).

% zless_nat_eq_int_zless
thf(fact_3549_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z )
      = ( ( M
          = ( nat2 @ Z ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% int_eq_iff
thf(fact_3550_nat__0__le,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
        = Z ) ) ).

% nat_0_le
thf(fact_3551_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_3552_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L ) )
          = ( sgn_sgn @ int @ L ) ) ) ) ).

% sgn_mod
thf(fact_3553_int__minus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ N @ M ) )
      = ( semiring_1_of_nat @ int @ ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ) ) ).

% int_minus
thf(fact_3554_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_3555_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M4: nat,N2: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% and_nat_def
thf(fact_3556_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_3557_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_3558_real__nat__ceiling__ge,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X2 ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_3559_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_3560_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_3561_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_3562_ln__neg__is__const,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X2 )
        = ( the @ real
          @ ^ [X6: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_3563_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_3564_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X6: A] :
              ( if @ A
              @ ( X6
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X6 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_3565_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R ) ) ) @ R ) ) ) ).

% of_nat_floor
thf(fact_3566_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I: int] :
          ( if @ int
          @ ( I
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_3567_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_3568_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_3569_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_less_eq_zless
thf(fact_3570_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_3571_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( X2
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X2 ) )
              = ( zero_zero @ real ) ) )
          & ( ( X2
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X2 ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_3572_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% nat_le_eq_zle
thf(fact_3573_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_3574_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_3575_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M
        = ( nat2 @ W ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_3576_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ( nat2 @ W )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_3577_split__nat,axiom,
    ! [P3: nat > $o,I3: int] :
      ( ( P3 @ ( nat2 @ I3 ) )
      = ( ! [N2: nat] :
            ( ( I3
              = ( semiring_1_of_nat @ int @ N2 ) )
           => ( P3 @ N2 ) )
        & ( ( ord_less @ int @ I3 @ ( zero_zero @ int ) )
         => ( P3 @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_3578_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_3579_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% le_nat_iff
thf(fact_3580_nat__add__distrib,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( nat2 @ ( plus_plus @ int @ Z @ Z7 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_3581_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ L ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_3582_nat__mult__distrib,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ).

% nat_mult_distrib
thf(fact_3583_Suc__as__int,axiom,
    ( suc
    = ( ^ [A5: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_3584_nat__diff__distrib,axiom,
    ! [Z7: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
     => ( ( ord_less_eq @ int @ Z7 @ Z )
       => ( ( nat2 @ ( minus_minus @ int @ Z @ Z7 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_3585_nat__diff__distrib_H,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ( nat2 @ ( minus_minus @ int @ X2 @ Y2 ) )
          = ( minus_minus @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_3586_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_3587_nat__div__distrib_H,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( nat2 @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ).

% nat_div_distrib'
thf(fact_3588_nat__div__distrib,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( nat2 @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ).

% nat_div_distrib
thf(fact_3589_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( dvd_dvd @ int @ L @ K )
     => ( ( divide_divide @ int @ K @ L )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_3590_nat__floor__neg,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_3591_nat__power__eq,axiom,
    ! [Z: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( power_power @ int @ Z @ N ) )
        = ( power_power @ nat @ ( nat2 @ Z ) @ N ) ) ) ).

% nat_power_eq
thf(fact_3592_nat__mod__distrib,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ( nat2 @ ( modulo_modulo @ int @ X2 @ Y2 ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_3593_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_3594_floor__eq3,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
          = N ) ) ) ).

% floor_eq3
thf(fact_3595_le__nat__floor,axiom,
    ! [X2: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X2 ) @ A2 )
     => ( ord_less_eq @ nat @ X2 @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_3596_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_3597_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_3598_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_3599_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_nat_iff
thf(fact_3600_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K2: int,L3: int] :
          ( if @ int
          @ ( L3
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K2 )
              = ( sgn_sgn @ int @ L3 ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L3 ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L3 ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L3 @ K2 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_3601_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K2: int,L3: int] :
          ( if @ int
          @ ( L3
            = ( zero_zero @ int ) )
          @ K2
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K2 )
              = ( sgn_sgn @ int @ L3 ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L3 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L3 ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L3 )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L3 )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L3 @ K2 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L3 ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_3602_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_3603_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_3604_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_3605_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( suc @ ( nat2 @ Z ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_3606_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_3607_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z7 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_3608_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_3609_floor__eq4,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
          = N ) ) ) ).

% floor_eq4
thf(fact_3610_diff__nat__eq__if,axiom,
    ! [Z7: int,Z: int] :
      ( ( ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) )
          = ( nat2 @ Z ) ) )
      & ( ~ ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z @ Z7 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z @ Z7 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_3611_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_3612_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_3613_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_3614_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K2: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K2 ) @ A5 ) @ ( one_one @ A ) ) @ K2 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_3615_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K2: int] : ( if @ A @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K2 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K2 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_3616_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( dvd_dvd @ int @ Z @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_3617_arccos__def,axiom,
    ( arccos
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X6: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X6 )
              & ( ord_less_eq @ real @ X6 @ pi )
              & ( ( cos @ real @ X6 )
                = Y ) ) ) ) ) ).

% arccos_def
thf(fact_3618_eucl__rel__int__remainderI,axiom,
    ! [R: int,L: int,K: int,Q2: int] :
      ( ( ( sgn_sgn @ int @ R )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q2 @ L ) @ R ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_3619_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_3620_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_3621_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A5 ) @ K2 ) ) @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_3622_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A12: int,A23: int,A32: product_prod @ int @ int] :
          ( ? [K2: int] :
              ( ( A12 = K2 )
              & ( A23
                = ( zero_zero @ int ) )
              & ( A32
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K2 ) ) )
          | ? [L3: int,K2: int,Q4: int] :
              ( ( A12 = K2 )
              & ( A23 = L3 )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L3
               != ( zero_zero @ int ) )
              & ( K2
                = ( times_times @ int @ Q4 @ L3 ) ) )
          | ? [R5: int,L3: int,K2: int,Q4: int] :
              ( ( A12 = K2 )
              & ( A23 = L3 )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L3 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L3 ) )
              & ( K2
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L3 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_3623_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A33: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A1 @ A22 @ A33 )
     => ( ( ( A22
            = ( zero_zero @ int ) )
         => ( A33
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A1 ) ) )
       => ( ! [Q3: int] :
              ( ( A33
                = ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) )
             => ( ( A22
                 != ( zero_zero @ int ) )
               => ( A1
                 != ( times_times @ int @ Q3 @ A22 ) ) ) )
         => ~ ! [R2: int,Q3: int] :
                ( ( A33
                  = ( product_Pair @ int @ int @ Q3 @ R2 ) )
               => ( ( ( sgn_sgn @ int @ R2 )
                    = ( sgn_sgn @ int @ A22 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R2 ) @ ( abs_abs @ int @ A22 ) )
                   => ( A1
                     != ( plus_plus @ int @ ( times_times @ int @ Q3 @ A22 ) @ R2 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_3624_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K2: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ K2 ) ) @ ( one_one @ A ) ) @ K2 ) @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_3625_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_3626_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_3627_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_3628_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X6: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X6 )
          & ( ord_less_eq @ real @ X6 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X6 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_3629_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X6: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X6 )
            & ( ord_less_eq @ real @ X6 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X6 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_3630_divide__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_3631_the__equality,axiom,
    ! [A: $tType,P3: A > $o,A2: A] :
      ( ( P3 @ A2 )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
           => ( X7 = A2 ) )
       => ( ( the @ A @ P3 )
          = A2 ) ) ) ).

% the_equality
thf(fact_3632_the__eq__trivial,axiom,
    ! [A: $tType,A2: A] :
      ( ( the @ A
        @ ^ [X6: A] : ( X6 = A2 ) )
      = A2 ) ).

% the_eq_trivial
thf(fact_3633_the__sym__eq__trivial,axiom,
    ! [A: $tType,X2: A] :
      ( ( the @ A
        @ ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 )
          @ X2 ) )
      = X2 ) ).

% the_sym_eq_trivial
thf(fact_3634_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_3635_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_3636_zero__le__sgn__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_le_sgn_iff
thf(fact_3637_sgn__le__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_3638_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X2: A,Y2: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X9: A,Y7: B] :
              ( ( X2 = X9 )
              & ( Y2 = Y7 ) ) ) )
      = ( product_Pair @ A @ B @ X2 @ Y2 ) ) ).

% The_split_eq
thf(fact_3639_complex__i__mult__minus,axiom,
    ! [X2: complex] :
      ( ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ imaginary_unit @ X2 ) )
      = ( uminus_uminus @ complex @ X2 ) ) ).

% complex_i_mult_minus
thf(fact_3640_divide__i,axiom,
    ! [X2: complex] :
      ( ( divide_divide @ complex @ X2 @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X2 ) ) ).

% divide_i
thf(fact_3641_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3642_divide__numeral__i,axiom,
    ! [Z: complex,N: num] :
      ( ( divide_divide @ complex @ Z @ ( times_times @ complex @ ( numeral_numeral @ complex @ N ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) @ ( numeral_numeral @ complex @ N ) ) ) ).

% divide_numeral_i
thf(fact_3643_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3644_i__even__power,axiom,
    ! [N: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N ) ) ).

% i_even_power
thf(fact_3645_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_3646_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_3647_complex__i__not__zero,axiom,
    imaginary_unit
 != ( zero_zero @ complex ) ).

% complex_i_not_zero
thf(fact_3648_i__times__eq__iff,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( times_times @ complex @ imaginary_unit @ W )
        = Z )
      = ( W
        = ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) ) ) ).

% i_times_eq_iff
thf(fact_3649_Complex__eq__i,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( complex2 @ X2 @ Y2 )
        = imaginary_unit )
      = ( ( X2
          = ( zero_zero @ real ) )
        & ( Y2
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3650_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3651_Complex__mult__i,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ imaginary_unit )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% Complex_mult_i
thf(fact_3652_i__mult__Complex,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% i_mult_Complex
thf(fact_3653_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A5: real] :
          ( if @ real
          @ ( A5
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A5 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_3654_Complex__eq,axiom,
    ( complex2
    = ( ^ [A5: real,B4: real] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ A5 ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B4 ) ) ) ) ) ).

% Complex_eq
thf(fact_3655_sgn__power__injE,axiom,
    ! [A2: real,N: nat,X2: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N ) )
        = X2 )
     => ( ( X2
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_3656_i__complex__of__real,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% i_complex_of_real
thf(fact_3657_complex__of__real__i,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% complex_of_real_i
thf(fact_3658_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R2: real,A4: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A4 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A4 ) ) ) ) ) ) ).

% complex_split_polar
thf(fact_3659_the1__equality,axiom,
    ! [A: $tType,P3: A > $o,A2: A] :
      ( ? [X: A] :
          ( ( P3 @ X )
          & ! [Y5: A] :
              ( ( P3 @ Y5 )
             => ( Y5 = X ) ) )
     => ( ( P3 @ A2 )
       => ( ( the @ A @ P3 )
          = A2 ) ) ) ).

% the1_equality
thf(fact_3660_the1I2,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o] :
      ( ? [X: A] :
          ( ( P3 @ X )
          & ! [Y5: A] :
              ( ( P3 @ Y5 )
             => ( Y5 = X ) ) )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
           => ( Q @ X7 ) )
       => ( Q @ ( the @ A @ P3 ) ) ) ) ).

% the1I2
thf(fact_3661_If__def,axiom,
    ! [A: $tType] :
      ( ( if @ A )
      = ( ^ [P2: $o,X6: A,Y: A] :
            ( the @ A
            @ ^ [Z6: A] :
                ( ( P2
                 => ( Z6 = X6 ) )
                & ( ~ P2
                 => ( Z6 = Y ) ) ) ) ) ) ).

% If_def
thf(fact_3662_theI2,axiom,
    ! [A: $tType,P3: A > $o,A2: A,Q: A > $o] :
      ( ( P3 @ A2 )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
           => ( X7 = A2 ) )
       => ( ! [X7: A] :
              ( ( P3 @ X7 )
             => ( Q @ X7 ) )
         => ( Q @ ( the @ A @ P3 ) ) ) ) ) ).

% theI2
thf(fact_3663_theI_H,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ? [X: A] :
          ( ( P3 @ X )
          & ! [Y5: A] :
              ( ( P3 @ Y5 )
             => ( Y5 = X ) ) )
     => ( P3 @ ( the @ A @ P3 ) ) ) ).

% theI'
thf(fact_3664_theI,axiom,
    ! [A: $tType,P3: A > $o,A2: A] :
      ( ( P3 @ A2 )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
           => ( X7 = A2 ) )
       => ( P3 @ ( the @ A @ P3 ) ) ) ) ).

% theI
thf(fact_3665_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X6: real] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z6 ) @ X6 )
              & ( ord_less @ real @ X6 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_3666_cmod__unit__one,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_3667_cmod__complex__polar,axiom,
    ! [R: real,A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) ) )
      = ( abs_abs @ real @ R ) ) ).

% cmod_complex_polar
thf(fact_3668_arctan__inverse,axiom,
    ! [X2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X2 ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X2 ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X2 ) ) ) ) ).

% arctan_inverse
thf(fact_3669_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3670_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_3671_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3672_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3673_csqrt__0,axiom,
    ( ( csqrt @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% csqrt_0
thf(fact_3674_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( csqrt @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% csqrt_eq_0
thf(fact_3675_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3676_power2__csqrt,axiom,
    ! [Z: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z ) ).

% power2_csqrt
thf(fact_3677_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3678_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3679_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( cis @ ( arg @ Z ) )
        = ( sgn_sgn @ complex @ Z ) ) ) ).

% cis_Arg
thf(fact_3680_cis__neq__zero,axiom,
    ! [A2: real] :
      ( ( cis @ A2 )
     != ( zero_zero @ complex ) ) ).

% cis_neq_zero
thf(fact_3681_DeMoivre,axiom,
    ! [A2: real,N: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_3682_cis__Arg__unique,axiom,
    ! [Z: complex,X2: real] :
      ( ( ( sgn_sgn @ complex @ Z )
        = ( cis @ X2 ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ( arg @ Z )
            = X2 ) ) ) ) ).

% cis_Arg_unique
thf(fact_3683_cis__mult,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% cis_mult
thf(fact_3684_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z )
          = ( cis @ ( arg @ Z ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
        & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ) ).

% Arg_correct
thf(fact_3685_Arg__zero,axiom,
    ( ( arg @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% Arg_zero
thf(fact_3686_cis__conv__exp,axiom,
    ( cis
    = ( ^ [B4: real] : ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B4 ) ) ) ) ) ).

% cis_conv_exp
thf(fact_3687_of__real__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X2 ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X2 ) ) ) ) ).

% of_real_sqrt
thf(fact_3688_Arg__bounded,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
      & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ).

% Arg_bounded
thf(fact_3689_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X6: rat] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z6 ) @ X6 )
              & ( ord_less @ rat @ X6 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_3690_Arg__def,axiom,
    ( arg
    = ( ^ [Z6: complex] :
          ( if @ real
          @ ( Z6
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A5: real] :
                ( ( ( sgn_sgn @ complex @ Z6 )
                  = ( cis @ A5 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A5 )
                & ( ord_less_eq @ real @ A5 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_3691_cis__multiple__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_3692_pred__subset__eq,axiom,
    ! [A: $tType,R3: set @ A,S3: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X6: A] : ( member @ A @ X6 @ R3 )
        @ ^ [X6: A] : ( member @ A @ X6 @ S3 ) )
      = ( ord_less_eq @ ( set @ A ) @ R3 @ S3 ) ) ).

% pred_subset_eq
thf(fact_3693_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( member @ A @ X2 @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_eq_0_iff
thf(fact_3694_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y2 @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) ) ) ).

% floor_add2
thf(fact_3695_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X2 ) )
          = ( ~ ( member @ A @ X2 @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_3696_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A5: rat] :
          ( if @ rat
          @ ( A5
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A5 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_3697_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_3698_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_3699_obtain__pos__sum,axiom,
    ! [R: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
     => ~ ! [S2: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S2 )
           => ! [T4: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T4 )
               => ( R
                 != ( plus_plus @ rat @ S2 @ T4 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_3700_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: num] : ( member @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_3701_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A5: rat] : ( if @ rat @ ( ord_less @ rat @ A5 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A5 ) @ A5 ) ) ) ).

% abs_rat_def
thf(fact_3702_Ints__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_0
thf(fact_3703_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_3704_less__eq__rat__def,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [X6: rat,Y: rat] :
          ( ( ord_less @ rat @ X6 @ Y )
          | ( X6 = Y ) ) ) ) ).

% less_eq_rat_def
thf(fact_3705_verit__sko__ex_H,axiom,
    ! [A: $tType,P3: A > $o,A3: $o] :
      ( ( ( P3 @ ( fChoice @ A @ P3 ) )
        = A3 )
     => ( ( ? [X8: A] : ( P3 @ X8 ) )
        = A3 ) ) ).

% verit_sko_ex'
thf(fact_3706_verit__sko__forall,axiom,
    ! [A: $tType] :
      ( ( ^ [P: A > $o] :
          ! [X5: A] : ( P @ X5 ) )
      = ( ^ [P2: A > $o] :
            ( P2
            @ ( fChoice @ A
              @ ^ [X6: A] :
                  ~ ( P2 @ X6 ) ) ) ) ) ).

% verit_sko_forall
thf(fact_3707_verit__sko__forall_H,axiom,
    ! [A: $tType,P3: A > $o,A3: $o] :
      ( ( ( P3
          @ ( fChoice @ A
            @ ^ [X6: A] :
                ~ ( P3 @ X6 ) ) )
        = A3 )
     => ( ( ! [X8: A] : ( P3 @ X8 ) )
        = A3 ) ) ).

% verit_sko_forall'
thf(fact_3708_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B5: A,A3: A,P3: A > $o] :
      ( ( B5 = A3 )
     => ( ( ( fChoice @ A @ P3 )
          = A3 )
        = ( ( fChoice @ A @ P3 )
          = B5 ) ) ) ).

% verit_sko_forall''
thf(fact_3709_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X2: A,P3: A > $o] :
      ( ( X2
        = ( fChoice @ A @ P3 ) )
     => ( ( ? [X8: A] : ( P3 @ X8 ) )
        = ( P3 @ X2 ) ) ) ).

% verit_sko_ex_indirect
thf(fact_3710_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X2: A,P3: A > $o,P6: A > $o] :
      ( ( X2
        = ( fChoice @ A @ P3 ) )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
            = ( P6 @ X7 ) )
       => ( ( ? [X8: A] : ( P6 @ X8 ) )
          = ( P3 @ X2 ) ) ) ) ).

% verit_sko_ex_indirect2
thf(fact_3711_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X2: A,P3: A > $o] :
      ( ( X2
        = ( fChoice @ A
          @ ^ [X6: A] :
              ~ ( P3 @ X6 ) ) )
     => ( ( ! [X8: A] : ( P3 @ X8 ) )
        = ( P3 @ X2 ) ) ) ).

% verit_sko_forall_indirect
thf(fact_3712_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X2: A,P3: A > $o,P6: A > $o] :
      ( ( X2
        = ( fChoice @ A
          @ ^ [X6: A] :
              ~ ( P3 @ X6 ) ) )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
            = ( P6 @ X7 ) )
       => ( ( ! [X8: A] : ( P6 @ X8 ) )
          = ( P3 @ X2 ) ) ) ) ).

% verit_sko_forall_indirect2
thf(fact_3713_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_3714_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_3715_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_3716_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_3717_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( X2
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X2 ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_3718_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) )
           => ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_3719_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y2 @ ( ring_1_Ints @ A ) )
           => ( ( X2 = Y2 )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_3720_sin__times__pi__eq__0,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X2 @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X2 @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_3721_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ R3 ) )
        = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ S3 ) ) )
      = ( R3 = S3 ) ) ).

% pred_equals_eq2
thf(fact_3722_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ R3 )
        @ ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ S3 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S3 ) ) ).

% pred_subset_eq2
thf(fact_3723_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X2 ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X2 ) ) ) ) ) ) ).

% frac_neg
thf(fact_3724_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_3725_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X2 @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_3726_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_3727_sin__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_3728_cos__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_3729_some__sym__eq__trivial,axiom,
    ! [A: $tType,X2: A] :
      ( ( fChoice @ A
        @ ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 )
          @ X2 ) )
      = X2 ) ).

% some_sym_eq_trivial
thf(fact_3730_some__eq__trivial,axiom,
    ! [A: $tType,X2: A] :
      ( ( fChoice @ A
        @ ^ [Y: A] : ( Y = X2 ) )
      = X2 ) ).

% some_eq_trivial
thf(fact_3731_some__equality,axiom,
    ! [A: $tType,P3: A > $o,A2: A] :
      ( ( P3 @ A2 )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
           => ( X7 = A2 ) )
       => ( ( fChoice @ A @ P3 )
          = A2 ) ) ) ).

% some_equality
thf(fact_3732_powr__real__of__int,axiom,
    ! [X2: real,N: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ N ) )
            = ( power_power @ real @ X2 @ ( nat2 @ N ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ N ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X2 @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_3733_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
thf(fact_3734_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
          = A2 ) ) ).

% inverse_inverse_eq
thf(fact_3735_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_3736_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_3737_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3738_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3739_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A] :
          ( ( ( inverse_inverse @ A @ X2 )
            = ( one_one @ A ) )
          = ( X2
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3740_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A2 ) ) ) ).

% inverse_divide
thf(fact_3741_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% inverse_minus_eq
thf(fact_3742_abs__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ).

% abs_inverse
thf(fact_3743_sgn__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% sgn_inverse
thf(fact_3744_inverse__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% inverse_sgn
thf(fact_3745_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,X2: A,Y2: B] :
      ( ( fChoice @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X9: A,Y7: B] :
              ( ( X2 = X9 )
              & ( Y2 = Y7 ) ) ) )
      = ( product_Pair @ A @ B @ X2 @ Y2 ) ) ).

% Eps_case_prod_eq
thf(fact_3746_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3747_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3748_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3749_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3750_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3751_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3752_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3753_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3754_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3755_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3756_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3757_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3758_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
thf(fact_3759_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y2: A,X2: A] :
          ( ( ( times_times @ A @ Y2 @ X2 )
            = ( times_times @ A @ X2 @ Y2 ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y2 ) @ X2 )
            = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ Y2 ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3760_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_3761_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_3762_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_3763_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_3764_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_3765_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X2: real] :
          ( ( X2
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X2 ) )
            = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X2 ) ) ) ) ) ).

% nonzero_of_real_inverse
thf(fact_3766_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ) ).

% nonzero_norm_inverse
thf(fact_3767_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_inverse
thf(fact_3768_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fChoice @ ( product_prod @ A @ B ) )
      = ( ^ [P2: ( product_prod @ A @ B ) > $o] :
            ( fChoice @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : ( P2 @ ( product_Pair @ A @ B @ A5 @ B4 ) ) ) ) ) ) ).

% split_paired_Eps
thf(fact_3769_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R: real,X2: A] :
          ( ( ord_less_eq @ real @ R @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X2 ) ) @ ( inverse_inverse @ real @ R ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_3770_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3771_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3772_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3773_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3774_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3775_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3776_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3777_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3778_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3779_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_3780_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3781_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3782_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ ( inverse_inverse @ A @ B4 ) @ A5 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3783_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% divide_inverse
thf(fact_3784_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3785_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3786_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ N ) @ ( power_power @ A @ X2 @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3787_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( inverse_inverse @ A @ X2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X2 ) @ ( power_power @ A @ X2 @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3788_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X2: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X2 )
          = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3789_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_3790_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X2: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X2 )
          = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3791_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X6: real,Y: real] : ( times_times @ real @ X6 @ ( inverse_inverse @ real @ Y ) ) ) ) ).

% divide_real_def
thf(fact_3792_exp__fdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( diffs @ A
          @ ^ [N2: nat] : ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) )
        = ( ^ [N2: nat] : ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ) ).

% exp_fdiffs
thf(fact_3793_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3794_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3795_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3796_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3797_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X2 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3798_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3799_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X2 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3800_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3801_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3802_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3803_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3804_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3805_inverse__powr,axiom,
    ! [Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y2 ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y2 @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_3806_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3807_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3808_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X2 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3809_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X2 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3810_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3811_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3812_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N3: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ X2 ) ) ) ).

% reals_Archimedean
thf(fact_3813_forall__pos__mono__1,axiom,
    ! [P3: real > $o,E2: real] :
      ( ! [D3: real,E: real] :
          ( ( ord_less @ real @ D3 @ E )
         => ( ( P3 @ D3 )
           => ( P3 @ E ) ) )
     => ( ! [N3: nat] : ( P3 @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P3 @ E2 ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3814_real__arch__inverse,axiom,
    ! [E2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
      = ( ? [N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ E2 ) ) ) ) ).

% real_arch_inverse
thf(fact_3815_forall__pos__mono,axiom,
    ! [P3: real > $o,E2: real] :
      ( ! [D3: real,E: real] :
          ( ( ord_less @ real @ D3 @ E )
         => ( ( P3 @ D3 )
           => ( P3 @ E ) ) )
     => ( ! [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( P3 @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P3 @ E2 ) ) ) ) ).

% forall_pos_mono
thf(fact_3816_sqrt__divide__self__eq,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( divide_divide @ real @ ( sqrt @ X2 ) @ X2 )
        = ( inverse_inverse @ real @ ( sqrt @ X2 ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3817_ln__inverse,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X2 ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_inverse
thf(fact_3818_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ).

% summable_exp
thf(fact_3819_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) ) @ X2 ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3820_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat,N: nat] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( power_power @ A @ X2 @ ( minus_minus @ nat @ N @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X2 @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3821_log__inverse,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X2 ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X2 ) ) ) ) ) ) ).

% log_inverse
thf(fact_3822_someI2,axiom,
    ! [A: $tType,P3: A > $o,A2: A,Q: A > $o] :
      ( ( P3 @ A2 )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
           => ( Q @ X7 ) )
       => ( Q @ ( fChoice @ A @ P3 ) ) ) ) ).

% someI2
thf(fact_3823_someI__ex,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ? [X_1: A] : ( P3 @ X_1 )
     => ( P3 @ ( fChoice @ A @ P3 ) ) ) ).

% someI_ex
thf(fact_3824_someI2__ex,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o] :
      ( ? [X_1: A] : ( P3 @ X_1 )
     => ( ! [X7: A] :
            ( ( P3 @ X7 )
           => ( Q @ X7 ) )
       => ( Q @ ( fChoice @ A @ P3 ) ) ) ) ).

% someI2_ex
thf(fact_3825_someI2__bex,axiom,
    ! [A: $tType,A3: set @ A,P3: A > $o,Q: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ A3 )
          & ( P3 @ X ) )
     => ( ! [X7: A] :
            ( ( ( member @ A @ X7 @ A3 )
              & ( P3 @ X7 ) )
           => ( Q @ X7 ) )
       => ( Q
          @ ( fChoice @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ A3 )
                & ( P3 @ X6 ) ) ) ) ) ) ).

% someI2_bex
thf(fact_3826_some__eq__ex,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( P3 @ ( fChoice @ A @ P3 ) )
      = ( ? [X8: A] : ( P3 @ X8 ) ) ) ).

% some_eq_ex
thf(fact_3827_some1__equality,axiom,
    ! [A: $tType,P3: A > $o,A2: A] :
      ( ? [X: A] :
          ( ( P3 @ X )
          & ! [Y5: A] :
              ( ( P3 @ Y5 )
             => ( Y5 = X ) ) )
     => ( ( P3 @ A2 )
       => ( ( fChoice @ A @ P3 )
          = A2 ) ) ) ).

% some1_equality
thf(fact_3828_exp__plus__inverse__exp,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3829_plus__inverse__ge__2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3830_real__inv__sqrt__pow2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X2 ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3831_dependent__nat__choice,axiom,
    ! [A: $tType,P3: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_1: A] : ( P3 @ ( zero_zero @ nat ) @ X_1 )
     => ( ! [X7: A,N3: nat] :
            ( ( P3 @ N3 @ X7 )
           => ? [Y3: A] :
                ( ( P3 @ ( suc @ N3 ) @ Y3 )
                & ( Q @ N3 @ X7 @ Y3 ) ) )
       => ? [F6: nat > A] :
          ! [N9: nat] :
            ( ( P3 @ N9 @ ( F6 @ N9 ) )
            & ( Q @ N9 @ ( F6 @ N9 ) @ ( F6 @ ( suc @ N9 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_3832_tan__cot,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X2 ) ) ) ).

% tan_cot
thf(fact_3833_real__le__x__sinh,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3834_real__le__abs__sinh,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3835_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3836_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X6: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X6 )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X6 @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_3837_sinh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( sinh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3838_cosh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( cosh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3839_case__prod__app,axiom,
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F5: B > C > D > A,X6: product_prod @ B @ C,Y: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [L3: B,R5: C] : ( F5 @ L3 @ R5 @ Y )
            @ X6 ) ) ) ).

% case_prod_app
thf(fact_3840_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,B2: real] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
          = ( ( A2 = B2 )
            | ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_cancel_right
thf(fact_3841_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_right
thf(fact_3842_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ Y2 )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X2 @ Y2 ) ) ) ) ).

% mult_scaleR_left
thf(fact_3843_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X2: A,A2: real,Y2: A] :
          ( ( times_times @ A @ X2 @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X2 @ Y2 ) ) ) ) ).

% mult_scaleR_right
thf(fact_3844_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
          = ( ( X2 = Y2 )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_cancel_left
thf(fact_3845_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X2 ) ) ) ).

% scaleR_scaleR
thf(fact_3846_sinh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sinh_0
thf(fact_3847_sinh__real__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( sinh @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% sinh_real_zero_iff
thf(fact_3848_sinh__real__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( sinh @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% sinh_real_less_iff
thf(fact_3849_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ real ) )
            | ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_eq_0_iff
thf(fact_3850_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( zero_zero @ real ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_left
thf(fact_3851_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ U @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_3852_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3853_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: real,Y2: A,N: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ Y2 ) @ N )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X2 @ N ) @ ( power_power @ A @ Y2 @ N ) ) ) ) ).

% scaleR_power
thf(fact_3854_sinh__real__neg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3855_sinh__real__pos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% sinh_real_pos_iff
thf(fact_3856_sinh__real__nonpos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3857_sinh__real__nonneg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% sinh_real_nonneg_iff
thf(fact_3858_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,A2: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U ) @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
          = A2 ) ) ).

% scaleR_collapse
thf(fact_3859_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: real,X2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ) ).

% norm_scaleR
thf(fact_3860_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_3861_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_3862_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_3863_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_3864_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,A2: real,B2: real] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
              = ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
thf(fact_3865_cosh__real__nonzero,axiom,
    ! [X2: real] :
      ( ( cosh @ real @ X2 )
     != ( zero_zero @ real ) ) ).

% cosh_real_nonzero
thf(fact_3866_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
              = ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
           => ( X2 = Y2 ) ) ) ) ).

% scaleR_left_imp_eq
thf(fact_3867_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ X2 ) )
          = ( exp @ A @ X2 ) ) ) ).

% cosh_plus_sinh
thf(fact_3868_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ X2 ) )
          = ( exp @ A @ X2 ) ) ) ).

% sinh_plus_cosh
thf(fact_3869_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% cosh_add
thf(fact_3870_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% sinh_add
thf(fact_3871_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ).

% scaleR_right_distrib
thf(fact_3872_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X6: A] : ( divide_divide @ A @ ( sinh @ A @ X6 ) @ ( cosh @ A @ X6 ) ) ) ) ) ).

% tanh_def
thf(fact_3873_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_3874_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% sinh_diff
thf(fact_3875_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% cosh_diff
thf(fact_3876_sinh__less__cosh__real,axiom,
    ! [X2: real] : ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( cosh @ real @ X2 ) ) ).

% sinh_less_cosh_real
thf(fact_3877_summable__scaleR__right,axiom,
    ! [B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X15: nat > B,R: real] :
          ( ( summable @ B @ X15 )
         => ( summable @ B
            @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ B @ R @ ( X15 @ N2 ) ) ) ) ) ).

% summable_scaleR_right
thf(fact_3878_sums__scaleR__right,axiom,
    ! [B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X15: nat > B,A2: B,R: real] :
          ( ( sums @ B @ X15 @ A2 )
         => ( sums @ B
            @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ B @ R @ ( X15 @ N2 ) )
            @ ( real_V8093663219630862766scaleR @ B @ R @ A2 ) ) ) ) ).

% sums_scaleR_right
thf(fact_3879_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: real,Y2: real,Xa: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X2 @ Y2 ) @ Xa )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ Xa ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ Xa ) ) ) ) ).

% scaleR_left.add
thf(fact_3880_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X2 )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ).

% scaleR_left_distrib
thf(fact_3881_cosh__real__pos,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X2 ) ) ).

% cosh_real_pos
thf(fact_3882_cosh__real__nonpos__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y2 @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less_eq @ real @ Y2 @ X2 ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3883_cosh__real__nonneg__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3884_cosh__real__nonneg,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X2 ) ) ).

% cosh_real_nonneg
thf(fact_3885_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_3886_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X2 ) ) @ ( cosh @ A @ X2 ) ) ) ) ).

% sinh_double
thf(fact_3887_complex__scaleR,axiom,
    ! [R: real,A2: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ B2 ) ) ) ).

% complex_scaleR
thf(fact_3888_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X6: complex,Y: complex] : ( times_times @ complex @ X6 @ ( inverse_inverse @ complex @ Y ) ) ) ) ).

% divide_complex_def
thf(fact_3889_suminf__scaleR__right,axiom,
    ! [B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X15: nat > B,R: real] :
          ( ( summable @ B @ X15 )
         => ( ( real_V8093663219630862766scaleR @ B @ R @ ( suminf @ B @ X15 ) )
            = ( suminf @ B
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ B @ R @ ( X15 @ N2 ) ) ) ) ) ) ).

% suminf_scaleR_right
thf(fact_3890_summable__scaleR__left,axiom,
    ! [B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X15: nat > real,X2: B] :
          ( ( summable @ real @ X15 )
         => ( summable @ B
            @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ B @ ( X15 @ N2 ) @ X2 ) ) ) ) ).

% summable_scaleR_left
thf(fact_3891_sums__scaleR__left,axiom,
    ! [B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X15: nat > real,A2: real,X2: B] :
          ( ( sums @ real @ X15 @ A2 )
         => ( sums @ B
            @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ B @ ( X15 @ N2 ) @ X2 )
            @ ( real_V8093663219630862766scaleR @ B @ A2 @ X2 ) ) ) ) ).

% sums_scaleR_left
thf(fact_3892_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3893_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3894_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3895_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3896_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3897_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3898_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3899_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,U: real,V: real,A2: A] :
          ( ( X2
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 ) )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X2
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V @ X2 )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_3900_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V: real,A2: A,X2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 )
            = X2 )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X2
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V @ X2 ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_3901_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3902_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3903_cosh__real__strict__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3904_cosh__real__nonneg__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3905_cosh__real__nonpos__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y2 @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3906_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3907_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3908_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3909_arcosh__cosh__real,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( arcosh @ real @ ( cosh @ real @ X2 ) )
        = X2 ) ) ).

% arcosh_cosh_real
thf(fact_3910_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X6: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X6 ) @ ( exp @ A @ ( uminus_uminus @ A @ X6 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3911_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X6: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X6 ) @ ( exp @ A @ ( uminus_uminus @ A @ X6 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3912_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3913_suminf__scaleR__left,axiom,
    ! [B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X15: nat > real,X2: B] :
          ( ( summable @ real @ X15 )
         => ( ( real_V8093663219630862766scaleR @ B @ ( suminf @ real @ X15 ) @ X2 )
            = ( suminf @ B
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ B @ ( X15 @ N2 ) @ X2 ) ) ) ) ) ).

% suminf_scaleR_left
thf(fact_3914_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3915_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3916_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3917_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3918_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3919_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3920_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3921_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3922_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3923_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X2: A,Y2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y2 ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3924_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X2: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ X2 ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3925_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 )
          = ( plus_plus @ A @ X2 @ X2 ) ) ) ).

% scaleR_2
thf(fact_3926_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y2: A,X2: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y2
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X2 ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X2 ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3927_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X2: A,C2: A,Y2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X2 ) @ C2 )
              = Y2 )
            = ( X2
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3928_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3929_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3930_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3931_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3932_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3933_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3934_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3935_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3936_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: real,X2: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( X2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) )
              = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A2 ) @ ( inverse_inverse @ A @ X2 ) ) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
thf(fact_3937_fun__cong__unused__0,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( zero @ B )
     => ! [F3: ( A > B ) > C,G: C] :
          ( ( F3
            = ( ^ [X6: A > B] : G ) )
         => ( ( F3
              @ ^ [X6: A] : ( zero_zero @ B ) )
            = G ) ) ) ).

% fun_cong_unused_0
thf(fact_3938_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ).

% summable_exp_generic
thf(fact_3939_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X2 @ N2 ) )
          @ ( sin @ A @ X2 ) ) ) ).

% sin_converges
thf(fact_3940_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X6: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X6 @ N2 ) ) ) ) ) ) ).

% sin_def
thf(fact_3941_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X2 @ N2 ) )
          @ ( cos @ A @ X2 ) ) ) ).

% cos_converges
thf(fact_3942_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X6: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X6 @ N2 ) ) ) ) ) ) ).

% cos_def
thf(fact_3943_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ).

% summable_norm_sin
thf(fact_3944_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ).

% summable_norm_cos
thf(fact_3945_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X2 @ N2 ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X2 ) ) ) ).

% cosh_converges
thf(fact_3946_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3947_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3948_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3949_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3950_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3951_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3952_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3953_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3954_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X2 @ N2 ) ) )
          @ ( sinh @ A @ X2 ) ) ) ).

% sinh_converges
thf(fact_3955_eq__subset,axiom,
    ! [A: $tType,P3: A > A > $o] :
      ( ord_less_eq @ ( A > A > $o )
      @ ^ [Y4: A,Z3: A] : ( Y4 = Z3 )
      @ ^ [A5: A,B4: A] :
          ( ( P3 @ A5 @ B4 )
          | ( A5 = B4 ) ) ) ).

% eq_subset
thf(fact_3956_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X2 @ N2 ) )
          @ ( exp @ A @ X2 ) ) ) ).

% exp_converges
thf(fact_3957_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X6: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X6 @ N2 ) ) ) ) ) ) ).

% exp_def
thf(fact_3958_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ).

% summable_norm_exp
thf(fact_3959_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N2 ) ) )
          @ ( sin @ A @ X2 ) ) ) ).

% sin_minus_converges
thf(fact_3960_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N2 ) )
          @ ( cos @ A @ X2 ) ) ) ).

% cos_minus_converges
thf(fact_3961_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cosh @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X2 ) @ ( tanh @ A @ Y2 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X2 ) @ ( tanh @ A @ Y2 ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3962_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3963_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3964_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3965_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X6: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N2 ) ) ) @ ( power_power @ A @ X6 @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_3966_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P5: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P5 )
      = P5 ) ).

% case_prod_Pair_iden
thf(fact_3967_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cosh @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3968_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P4: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P4 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P4 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) ) @ ( power_power @ A @ X2 @ N2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P4 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P4 ) )
          @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ).

% sin_x_sin_y
thf(fact_3969_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P4: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P4 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P4 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) @ ( power_power @ A @ X2 @ N2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P4 @ N2 ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P4 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_3970_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P4: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P4 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P4 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) @ ( power_power @ A @ X2 @ N2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P4 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P4 ) )
          @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ).

% cos_x_cos_y
thf(fact_3971_rat__inverse__code,axiom,
    ! [P5: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P5 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,B4: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A5
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A5 ) @ B4 ) @ ( abs_abs @ int @ A5 ) ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_inverse_code
thf(fact_3972_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [F3: B > nat,A3: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7311177749621191930dd_sum @ B @ nat @ F3 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X6: B] : ( semiring_1_of_nat @ A @ ( F3 @ X6 ) )
            @ A3 ) ) ) ).

% of_nat_sum
thf(fact_3973_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ A )
     => ! [F3: B > int,A3: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7311177749621191930dd_sum @ B @ int @ F3 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X6: B] : ( ring_1_of_int @ A @ ( F3 @ X6 ) )
            @ A3 ) ) ) ).

% of_int_sum
thf(fact_3974_of__real__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [F3: B > real,S: set @ B] :
          ( ( real_Vector_of_real @ A @ ( groups7311177749621191930dd_sum @ B @ real @ F3 @ S ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X6: B] : ( real_Vector_of_real @ A @ ( F3 @ X6 ) )
            @ S ) ) ) ).

% of_real_sum
thf(fact_3975_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_3976_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_3977_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_3978_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_3979_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_3980_scaleR__left_Osum,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [G: C > real,A3: set @ C,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( groups7311177749621191930dd_sum @ C @ real @ G @ A3 ) @ X2 )
          = ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ A @ ( G @ X6 ) @ X2 )
            @ A3 ) ) ) ).

% scaleR_left.sum
thf(fact_3981_scaleR__sum__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [F3: C > real,A3: set @ C,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( groups7311177749621191930dd_sum @ C @ real @ F3 @ A3 ) @ X2 )
          = ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [A5: C] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ A5 ) @ X2 )
            @ A3 ) ) ) ).

% scaleR_sum_left
thf(fact_3982_sum__choose__upper,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( binomial @ K2 @ M )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ N ) @ ( suc @ M ) ) ) ).

% sum_choose_upper
thf(fact_3983_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I: B] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ I ) )
            @ A3 ) ) ) ).

% norm_sum
thf(fact_3984_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F3: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I: B] : ( modulo_modulo @ A @ ( F3 @ I ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ A2 ) ) ) ).

% mod_sum_eq
thf(fact_3985_scaleR__sum__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,F3: C > A,A3: set @ C] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( groups7311177749621191930dd_sum @ C @ A @ F3 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ A @ A2 @ ( F3 @ X6 ) )
            @ A3 ) ) ) ).

% scaleR_sum_right
thf(fact_3986_scaleR__right_Osum,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,G: C > A,A3: set @ C] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( groups7311177749621191930dd_sum @ C @ A @ G @ A3 ) )
          = ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ A @ A2 @ ( G @ X6 ) )
            @ A3 ) ) ) ).

% scaleR_right.sum
thf(fact_3987_summable__sum,axiom,
    ! [I5: $tType,A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [I6: set @ I5,F3: I5 > nat > A] :
          ( ! [I2: I5] :
              ( ( member @ I5 @ I2 @ I6 )
             => ( summable @ A @ ( F3 @ I2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ I5 @ A
                @ ^ [I: I5] : ( F3 @ I @ N2 )
                @ I6 ) ) ) ) ).

% summable_sum
thf(fact_3988_sums__sum,axiom,
    ! [A: $tType,I5: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [I6: set @ I5,F3: I5 > nat > A,X2: I5 > A] :
          ( ! [I2: I5] :
              ( ( member @ I5 @ I2 @ I6 )
             => ( sums @ A @ ( F3 @ I2 ) @ ( X2 @ I2 ) ) )
         => ( sums @ A
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ I5 @ A
                @ ^ [I: I5] : ( F3 @ I @ N2 )
                @ I6 )
            @ ( groups7311177749621191930dd_sum @ I5 @ A @ X2 @ I6 ) ) ) ) ).

% sums_sum
thf(fact_3989_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_3990_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: nat > A,I3: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( minus_minus @ A @ ( F3 @ I ) @ ( F3 @ ( suc @ I ) ) )
            @ ( set_ord_atMost @ nat @ I3 ) )
          = ( minus_minus @ A @ ( F3 @ ( zero_zero @ nat ) ) @ ( F3 @ ( suc @ I3 ) ) ) ) ) ).

% sum_telescope
thf(fact_3991_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,D2: nat > A] :
          ( ( ! [X6: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ X6 @ I ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( D2 @ I ) @ ( power_power @ A @ X6 @ I ) )
                  @ ( set_ord_atMost @ nat @ N ) ) ) )
          = ( ! [I: nat] :
                ( ( ord_less_eq @ nat @ I @ N )
               => ( ( C2 @ I )
                  = ( D2 @ I ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_3992_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B5: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N3 ) ) @ B5 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_3993_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X6: A] : ( ord_less_eq @ A @ X6 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_3994_sum__choose__lower,axiom,
    ! [R: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( binomial @ ( plus_plus @ nat @ R @ K2 ) @ K2 )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R @ N ) ) @ N ) ) ).

% sum_choose_lower
thf(fact_3995_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J4: nat] : ( binomial @ ( plus_plus @ nat @ N @ J4 ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ M ) ) ).

% choose_rising_sum(2)
thf(fact_3996_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J4: nat] : ( binomial @ ( plus_plus @ nat @ N @ J4 ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_3997_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N: nat,K: nat] :
          ( ! [W2: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ W2 @ I ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_3998_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( ! [X6: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ X6 @ I ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I: nat] :
                ( ( ord_less_eq @ nat @ I @ N )
               => ( ( C2 @ I )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_3999_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K2 ) ) @ K2 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_4000_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K2: nat] : ( binomial @ ( minus_minus @ nat @ N @ K2 ) @ ( minus_minus @ nat @ M @ K2 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_4001_vandermonde,axiom,
    ! [M: nat,N: nat,R: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( times_times @ nat @ ( binomial @ M @ K2 ) @ ( binomial @ N @ ( minus_minus @ nat @ R @ K2 ) ) )
        @ ( set_ord_atMost @ nat @ R ) )
      = ( binomial @ ( plus_plus @ nat @ M @ N ) @ R ) ) ).

% vandermonde
thf(fact_4002_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_4003_suminf__sum,axiom,
    ! [A: $tType,I5: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [I6: set @ I5,F3: I5 > nat > A] :
          ( ! [I2: I5] :
              ( ( member @ I5 @ I2 @ I6 )
             => ( summable @ A @ ( F3 @ I2 ) ) )
         => ( ( suminf @ A
              @ ^ [N2: nat] :
                  ( groups7311177749621191930dd_sum @ I5 @ A
                  @ ^ [I: I5] : ( F3 @ I @ N2 )
                  @ I6 ) )
            = ( groups7311177749621191930dd_sum @ I5 @ A
              @ ^ [I: I5] : ( suminf @ A @ ( F3 @ I ) )
              @ I6 ) ) ) ) ).

% suminf_sum
thf(fact_4004_choose__row__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N ) @ ( set_ord_atMost @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% choose_row_sum
thf(fact_4005_binomial,axiom,
    ! [A2: nat,B2: nat,N: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N @ K2 ) ) @ ( power_power @ nat @ A2 @ K2 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) ) ) ).

% binomial
thf(fact_4006_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( summable @ A
              @ ^ [K2: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I ) ) )
                  @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_4007_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I ) ) )
                    @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_4008_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.in_pairs_0
thf(fact_4009_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N: nat,B2: nat > A,X2: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ M @ I2 )
             => ( ( A2 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ! [J: nat] :
                ( ( ord_less @ nat @ N @ J )
               => ( ( B2 @ J )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ X2 @ I ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J4: nat] : ( times_times @ A @ ( B2 @ J4 ) @ ( power_power @ A @ X2 @ J4 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K2: nat] : ( times_times @ A @ ( A2 @ K2 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K2 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X2 @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_4010_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_4011_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K2 ) ) @ ( power_power @ A @ A2 @ K2 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_4012_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N: nat,B2: nat > nat,X2: nat] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ M @ I2 )
         => ( ( A2 @ I2 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J: nat] :
            ( ( ord_less @ nat @ N @ J )
           => ( ( B2 @ J )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I: nat] : ( times_times @ nat @ ( A2 @ I ) @ ( power_power @ nat @ X2 @ I ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J4: nat] : ( times_times @ nat @ ( B2 @ J4 ) @ ( power_power @ nat @ X2 @ J4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K2: nat] : ( times_times @ nat @ ( A2 @ K2 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K2 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X2 @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_4013_choose__square__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( power_power @ nat @ ( binomial @ N @ K2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% choose_square_sum
thf(fact_4014_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K2 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K2 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_4015_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( sums @ A
              @ ^ [K2: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I ) ) )
                  @ ( set_ord_atMost @ nat @ K2 ) )
              @ ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_4016_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,M: nat,I6: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( power_power @ A @ X2 @ ( plus_plus @ nat @ M @ I ) )
            @ I6 )
          = ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ I6 ) ) ) ) ).

% sum_power_add
thf(fact_4017_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P5: nat,K: nat,G: nat > A,H: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P5 )
         => ( ( ord_less_eq @ nat @ K @ P5 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J4: nat] : ( if @ A @ ( ord_less @ nat @ J4 @ K ) @ ( G @ J4 ) @ ( if @ A @ ( J4 = K ) @ ( zero_zero @ A ) @ ( H @ ( minus_minus @ nat @ J4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P5 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J4: nat] : ( if @ A @ ( ord_less @ nat @ J4 @ K ) @ ( G @ J4 ) @ ( H @ J4 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P5 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_4018_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X2: A,Y2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K2 ) @ ( power_power @ A @ X2 @ K2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ K2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_4019_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A,Y2: A,N: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I ) ) @ ( power_power @ A @ X2 @ I ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ I ) ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N @ I ) ) ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_4020_quotient__of__denom__pos,axiom,
    ! [R: rat,P5: int,Q2: int] :
      ( ( ( quotient_of @ R )
        = ( product_Pair @ int @ int @ P5 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% quotient_of_denom_pos
thf(fact_4021_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,Z: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( ( power_power @ A @ Z @ N )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I = N ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z @ I ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_4022_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp0
thf(fact_4023_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I ) @ ( semiring_1_of_nat @ A @ I ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_4024_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K2 ) ) @ K2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K2 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_4025_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X2: A,Y2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K2 ) @ ( power_power @ A @ X2 @ K2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K2 ) @ A2 ) @ ( one_one @ A ) ) @ K2 ) @ ( power_power @ A @ X2 @ K2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_4026_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_4027_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I: nat] : ( times_times @ nat @ I @ ( binomial @ N @ I ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_4028_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_4029_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E2: real,C2: nat > A,N: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ? [M8: real] :
            ! [Z4: A] :
              ( ( ord_less_eq @ real @ M8 @ ( real_V7770717601297561774m_norm @ A @ Z4 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z4 @ I ) )
                    @ ( set_ord_atMost @ nat @ N ) ) )
                @ ( times_times @ real @ E2 @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ ( suc @ N ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_4030_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_4031_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_4032_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_4033_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_4034_rat__uminus__code,axiom,
    ! [P5: rat] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ P5 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ A5 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_uminus_code
thf(fact_4035_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P4: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A5: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D5: int] : ( ord_less @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ C4 @ B4 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P4 ) ) ) ) ).

% rat_less_code
thf(fact_4036_rat__floor__code,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [P4: rat] : ( product_case_prod @ int @ int @ int @ ( divide_divide @ int ) @ ( quotient_of @ P4 ) ) ) ) ).

% rat_floor_code
thf(fact_4037_rat__abs__code,axiom,
    ! [P5: rat] :
      ( ( quotient_of @ ( abs_abs @ rat @ P5 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int] : ( product_Pair @ int @ int @ ( abs_abs @ int @ A5 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_abs_code
thf(fact_4038_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P4: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A5: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D5: int] : ( ord_less_eq @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ C4 @ B4 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P4 ) ) ) ) ).

% rat_less_eq_code
thf(fact_4039_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_4040_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_4041_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F3: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I: A] : ( abs_abs @ B @ ( F3 @ I ) )
            @ A3 ) ) ) ).

% sum_abs_ge_zero
thf(fact_4042_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F3: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I: A] : ( abs_abs @ B @ ( F3 @ I ) )
            @ A3 ) ) ) ).

% sum_abs
thf(fact_4043_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,X2: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X2 @ I2 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X2 @ I6 )
              = ( one_one @ B ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I6 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I2 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I: A] : ( times_times @ B @ ( A2 @ I ) @ ( X2 @ I ) )
                      @ I6 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_4044_abs__sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F3: A > B,A3: set @ A] :
          ( ( abs_abs @ B
            @ ( groups7311177749621191930dd_sum @ A @ B
              @ ^ [A5: A] : ( abs_abs @ B @ ( F3 @ A5 ) )
              @ A3 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [A5: A] : ( abs_abs @ B @ ( F3 @ A5 ) )
            @ A3 ) ) ) ).

% abs_sum_abs
thf(fact_4045_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N2: nat] : N2 ) ) ).

% of_nat_id
thf(fact_4046_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu3: B] : ( zero_zero @ A )
            @ A3 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_4047_int__sum,axiom,
    ! [B: $tType,F3: B > nat,A3: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7311177749621191930dd_sum @ B @ nat @ F3 @ A3 ) )
      = ( groups7311177749621191930dd_sum @ B @ int
        @ ^ [X6: B] : ( semiring_1_of_nat @ int @ ( F3 @ X6 ) )
        @ A3 ) ) ).

% int_sum
thf(fact_4048_Complex__sum_H,axiom,
    ! [A: $tType,F3: A > real,S: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X6: A] : ( complex2 @ ( F3 @ X6 ) @ ( zero_zero @ real ) )
        @ S )
      = ( complex2 @ ( groups7311177749621191930dd_sum @ A @ real @ F3 @ S ) @ ( zero_zero @ real ) ) ) ).

% Complex_sum'
thf(fact_4049_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set @ A,G: A > nat,F3: A > nat] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ A3 )
         => ( ord_less_eq @ nat @ ( G @ X7 ) @ ( F3 @ X7 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X6: A] : ( minus_minus @ nat @ ( F3 @ X6 ) @ ( G @ X6 ) )
          @ A3 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A3 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_4050_sum__SucD,axiom,
    ! [A: $tType,F3: A > nat,A3: set @ A,N: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 )
        = ( suc @ N ) )
     => ? [X7: A] :
          ( ( member @ A @ X7 @ A3 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X7 ) ) ) ) ).

% sum_SucD
thf(fact_4051_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X6: complex] : X6
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_4052_sum_Oswap,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > C > A,B5: set @ C,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [I: B] : ( groups7311177749621191930dd_sum @ C @ A @ ( G @ I ) @ B5 )
            @ A3 )
          = ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [J4: C] :
                ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [I: B] : ( G @ I @ J4 )
                @ A3 )
            @ B5 ) ) ) ).

% sum.swap
thf(fact_4053_sum__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X6: complex] : X6
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_4054_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I: nat,J4: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ J4 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( G @ I @ ( minus_minus @ nat @ K2 @ I ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_4055_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
           != ( zero_zero @ A ) )
         => ~ ! [A4: B] :
                ( ( member @ B @ A4 @ A3 )
               => ( ( G @ A4 )
                  = ( zero_zero @ A ) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
thf(fact_4056_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( ( G @ X7 )
                = ( zero_zero @ A ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.neutral
thf(fact_4057_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F3: B > A,G: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ K5 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ ( G @ I2 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K5 ) ) ) ) ).

% sum_mono
thf(fact_4058_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F3: A > B,A3: set @ A,G: C > B,B5: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B5 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J4: C] : ( times_times @ B @ ( F3 @ I ) @ ( G @ J4 ) )
                @ B5 )
            @ A3 ) ) ) ).

% sum_product
thf(fact_4059_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F3: B > A,A3: set @ B,R: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ ( F3 @ N2 ) @ R )
            @ A3 ) ) ) ).

% sum_distrib_right
thf(fact_4060_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R: A,F3: B > A,A3: set @ B] :
          ( ( times_times @ A @ R @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ R @ ( F3 @ N2 ) )
            @ A3 ) ) ) ).

% sum_distrib_left
thf(fact_4061_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X6: B] : ( plus_plus @ A @ ( G @ X6 ) @ ( H @ X6 ) )
            @ A3 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H @ A3 ) ) ) ) ).

% sum.distrib
thf(fact_4062_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X6: B] : ( minus_minus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ A3 )
          = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum_subtractf
thf(fact_4063_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F3: B > A,A3: set @ B,R: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( divide_divide @ A @ ( F3 @ N2 ) @ R )
            @ A3 ) ) ) ).

% sum_divide_distrib
thf(fact_4064_sum__negf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X6: B] : ( uminus_uminus @ A @ ( F3 @ X6 ) )
            @ A3 )
          = ( uminus_uminus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) ) ) ) ).

% sum_negf
thf(fact_4065_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_4066_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ X7 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) ) ) ) ).

% sum_nonneg
thf(fact_4067_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ nat,F3: nat > A,G: nat > A] :
          ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
         => ( ! [X7: nat] :
                ( ( member @ nat @ ( suc @ X7 ) @ A3 )
               => ( ( F3 @ ( suc @ X7 ) )
                  = ( G @ ( suc @ X7 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ A3 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ A3 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_4068_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ? [T4: real] :
            ( ( ord_less @ real @ X2 @ T4 )
            & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M4: nat] : ( times_times @ real @ ( cos_coeff @ M4 ) @ ( power_power @ real @ X2 @ M4 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_4069_Maclaurin__cos__expansion2,axiom,
    ! [X2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X2 )
            & ( ( cos @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M4: nat] : ( times_times @ real @ ( cos_coeff @ M4 ) @ ( power_power @ real @ X2 @ M4 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_4070_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X2 )
            & ( ( sin @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M4: nat] : ( times_times @ real @ ( sin_coeff @ M4 ) @ ( power_power @ real @ X2 @ M4 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_4071_Maclaurin__sin__expansion4,axiom,
    ! [X2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ? [T4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ X2 )
          & ( ( sin @ real @ X2 )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M4: nat] : ( times_times @ real @ ( sin_coeff @ M4 ) @ ( power_power @ real @ X2 @ M4 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_4072_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,K: A] :
          ( ( member @ A @ I3 @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I3 @ K ) ) ) ).

% lessThan_iff
thf(fact_4073_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_4074_sumr__cos__zero__one,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M4: nat] : ( times_times @ real @ ( cos_coeff @ M4 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M4 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_4075_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X6: A] : ( ord_less @ A @ X6 @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_4076_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N ) )
          = ( ord_less @ A @ M @ N ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_4077_lessThan__Suc__atMost,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( set_ord_atMost @ nat @ K ) ) ).

% lessThan_Suc_atMost
thf(fact_4078_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_4079_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nat_diff_reindex
thf(fact_4080_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P3: A > nat,N: A] :
          ( ! [X7: A] : ( ord_less_eq @ nat @ ( Q @ X7 ) @ ( P3 @ X7 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P3 @ ( set_ord_lessThan @ A @ N ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X6: A] : ( minus_minus @ nat @ ( P3 @ X6 ) @ ( Q @ X6 ) )
              @ ( set_ord_lessThan @ A @ N ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_4081_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F3: nat > A,N: nat,R: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ R ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( minus_minus @ A @ ( F3 @ I ) @ R )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_4082_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_4083_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ N2 ) ) @ ( F3 @ N2 ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F3 @ M ) @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_4084_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F3 @ ( zero_zero @ nat ) ) @ ( F3 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_4085_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,X2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X2 )
           => ( summable @ A @ F3 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_4086_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I: nat] : ( F3 @ ( plus_plus @ nat @ I @ N ) )
            @ S )
          = ( sums @ A @ F3 @ ( plus_plus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_4087_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,S: A,N: nat] :
          ( ( sums @ A @ F3 @ S )
         => ( sums @ A
            @ ^ [I: nat] : ( F3 @ ( plus_plus @ nat @ I @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_4088_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I: nat] : ( F3 @ ( plus_plus @ nat @ I @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) ) )
          = ( sums @ A @ F3 @ S ) ) ) ).

% sums_iff_shift'
thf(fact_4089_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_4090_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_4091_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,N: nat] :
          ( ( X2
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_4092_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_4093_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A @ F3 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_4094_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F3 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_4095_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,N: nat] :
          ( ( summable @ A @ F3 )
         => ( ! [M5: nat] :
                ( ( ord_less_eq @ nat @ N @ M5 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ M5 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F3 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_4096_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_4097_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z: A,H: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P4: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ ( minus_minus @ nat @ M @ P4 ) ) @ ( power_power @ A @ Z @ P4 ) ) @ ( power_power @ A @ Z @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P4: nat] : ( times_times @ A @ ( power_power @ A @ Z @ P4 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ ( minus_minus @ nat @ M @ P4 ) ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ M @ P4 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_4098_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N: nat,Y2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ ( suc @ N ) ) @ ( power_power @ A @ Y2 @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P4: nat] : ( times_times @ A @ ( power_power @ A @ X2 @ P4 ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N @ P4 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_4099_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N: nat,Y2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ N ) @ ( power_power @ A @ Y2 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N @ ( suc @ I ) ) ) @ ( power_power @ A @ X2 @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_4100_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ A2 @ I ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) )
         => ~ ! [B3: nat > A] :
                ~ ! [Z4: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z4 @ I ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I: nat] : ( times_times @ A @ ( B3 @ I ) @ ( power_power @ A @ Z4 @ I ) )
                        @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_4101_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N: nat,A2: A] :
        ? [B3: nat > A] :
        ! [Z4: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z4 @ I ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( B3 @ I ) @ ( power_power @ A @ Z4 @ I ) )
                @ ( set_ord_lessThan @ nat @ N ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ A2 @ I ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_4102_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I: nat,J4: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I @ J4 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( G @ I @ ( minus_minus @ nat @ K2 @ I ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.triangle_reindex
thf(fact_4103_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,F3: nat > A,K5: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N )
             => ( ord_less_eq @ A @ ( F3 @ P7 ) @ K5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K5 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ K5 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_4104_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,N: nat,I3: nat] :
          ( ( summable @ A @ F3 )
         => ( ! [M5: nat] :
                ( ( ord_less_eq @ nat @ N @ M5 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ M5 ) ) )
           => ( ( ord_less_eq @ nat @ N @ I3 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I3 ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F3 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_4105_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( power_power @ A @ X2 @ ( minus_minus @ nat @ N @ ( suc @ I ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_4106_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X2: real,N: nat,Diff: nat > A > real] :
          ( ( X2
            = ( zero_zero @ real ) )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ X2 @ M4 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_4107_Maclaurin__lemma,axiom,
    ! [H: real,F3: real > real,J2: nat > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ? [B9: real] :
          ( ( F3 @ H )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J2 @ M4 ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ H @ M4 ) )
              @ ( set_ord_lessThan @ nat @ N ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H @ N ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_4108_sum__split__even__odd,axiom,
    ! [F3: nat > real,G: nat > real,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) @ ( F3 @ I ) @ ( G @ I ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I: nat] : ( F3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum_split_even_odd
thf(fact_4109_Maclaurin__exp__le,axiom,
    ! [X2: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( exp @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M4: nat] : ( divide_divide @ real @ ( power_power @ real @ X2 @ M4 ) @ ( semiring_char_0_fact @ real @ M4 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_4110_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X2: A,Y2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ X2 @ I ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ Y2 @ I ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J4: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J4 @ K2 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y2 @ K2 ) ) @ ( power_power @ A @ X2 @ J4 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ J4 ) ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_4111_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X6: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X6 @ N2 ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ K ) ) ) @ ( power_power @ A @ X6 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_4112_Maclaurin__sin__bound,axiom,
    ! [X2: real,N: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X2 )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M4: nat] : ( times_times @ real @ ( sin_coeff @ M4 ) @ ( power_power @ real @ X2 @ M4 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( abs_abs @ real @ X2 ) @ N ) ) ) ).

% Maclaurin_sin_bound
thf(fact_4113_sum__pos__lt__pair,axiom,
    ! [F3: nat > real,K: nat] :
      ( ( summable @ real @ F3 )
     => ( ! [D3: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F3 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D3 ) ) ) @ ( F3 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D3 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F3 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F3 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_4114_Maclaurin__exp__lt,axiom,
    ! [X2: real,N: nat] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( exp @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M4: nat] : ( divide_divide @ real @ ( power_power @ real @ X2 @ M4 ) @ ( semiring_char_0_fact @ real @ M4 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_4115_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H: A,Z: A,N: nat] :
          ( ( H
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ N ) @ ( power_power @ A @ Z @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P4: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ Q4 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ P4 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_4116_Maclaurin__sin__expansion,axiom,
    ! [X2: real,N: nat] :
    ? [T4: real] :
      ( ( sin @ real @ X2 )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M4: nat] : ( times_times @ real @ ( sin_coeff @ M4 ) @ ( power_power @ real @ X2 @ M4 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_4117_Maclaurin__sin__expansion2,axiom,
    ! [X2: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( sin @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M4: nat] : ( times_times @ real @ ( sin_coeff @ M4 ) @ ( power_power @ real @ X2 @ M4 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_4118_Maclaurin__cos__expansion,axiom,
    ! [X2: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( cos @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M4: nat] : ( times_times @ real @ ( cos_coeff @ M4 ) @ ( power_power @ real @ X2 @ M4 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_4119_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( bij_betw @ nat @ complex
        @ ^ [K2: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        @ ( set_ord_lessThan @ nat @ N )
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_4120_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M: nat,X2: A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( ( X2
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X2
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_4121_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_4122_rat__plus__code,axiom,
    ! [P5: rat,Q2: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P5 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ B4 @ C4 ) ) @ ( times_times @ int @ C4 @ D5 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_plus_code
thf(fact_4123_normalize__denom__zero,axiom,
    ! [P5: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P5 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_4124_normalize__negative,axiom,
    ! [Q2: int,P5: int] :
      ( ( ord_less @ int @ Q2 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P5 @ Q2 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P5 ) @ ( uminus_uminus @ int @ Q2 ) ) ) ) ) ).

% normalize_negative
thf(fact_4125_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_4126_sum_Oreindex__bij__betw,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [H: B > C,S3: set @ B,T5: set @ C,G: C > A] :
          ( ( bij_betw @ B @ C @ H @ S3 @ T5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X6: B] : ( G @ ( H @ X6 ) )
              @ S3 )
            = ( groups7311177749621191930dd_sum @ C @ A @ G @ T5 ) ) ) ) ).

% sum.reindex_bij_betw
thf(fact_4127_ex__nat__less,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ? [M4: nat] :
            ( ( ord_less_eq @ nat @ M4 @ N )
            & ( P3 @ M4 ) ) )
      = ( ? [X6: nat] :
            ( ( member @ nat @ X6 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P3 @ X6 ) ) ) ) ).

% ex_nat_less
thf(fact_4128_all__nat__less,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ! [M4: nat] :
            ( ( ord_less_eq @ nat @ M4 @ N )
           => ( P3 @ M4 ) ) )
      = ( ! [X6: nat] :
            ( ( member @ nat @ X6 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P3 @ X6 ) ) ) ) ).

% all_nat_less
thf(fact_4129_atMost__atLeast0,axiom,
    ( ( set_ord_atMost @ nat )
    = ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) ) ) ).

% atMost_atLeast0
thf(fact_4130_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( suc @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
thf(fact_4131_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ I @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_4132_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_4133_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_4134_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( ( F3 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_4135_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_4136_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_4137_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_4138_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( G @ ( suc @ I ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_4139_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F3: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ I ) ) @ ( F3 @ I ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F3 @ ( suc @ N ) ) @ ( F3 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_4140_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( G @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_4141_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( F3 @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_4142_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I ) @ ( set_ord_lessThan @ nat @ I ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J4: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( A2 @ I @ J4 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J4 ) @ N ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nested_swap'
thf(fact_4143_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( plus_plus @ A @ ( F3 @ A5 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_4144_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A,P5: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P5 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P5 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_4145_normalize__denom__pos,axiom,
    ! [R: product_prod @ int @ int,P5: int,Q2: int] :
      ( ( ( normalize @ R )
        = ( product_Pair @ int @ int @ P5 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% normalize_denom_pos
thf(fact_4146_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P5: int,R: int] :
      ( ( Q2
       != ( zero_zero @ int ) )
     => ( ( S
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P5 @ Q2 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R @ S ) ) )
         => ( ( times_times @ int @ P5 @ S )
            = ( times_times @ int @ R @ Q2 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_4147_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_atMost @ nat @ M ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_4148_Frct__code__post_I1_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A2 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_4149_Frct__code__post_I2_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_4150_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F3: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K2: nat] : ( minus_minus @ A @ ( F3 @ K2 ) @ ( F3 @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( minus_minus @ A @ ( F3 @ M ) @ ( F3 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K2: nat] : ( minus_minus @ A @ ( F3 @ K2 ) @ ( F3 @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_4151_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F3: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K2: nat] : ( minus_minus @ A @ ( F3 @ K2 ) @ ( F3 @ ( minus_minus @ nat @ K2 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
            = ( minus_minus @ A @ ( F3 @ N ) @ ( F3 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_4152_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_4153_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,E2: real] :
          ( ( summable @ A @ F3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ~ ! [N8: nat] :
                  ~ ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ M2 )
                     => ! [N9: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N9 ) ) ) @ E2 ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_4154_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_4155_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.in_pairs
thf(fact_4156_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,K: A] :
          ( ( ! [X6: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ X6 @ I ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X6: nat] :
                ( ( member @ nat @ X6 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) )
               => ( ( C2 @ X6 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_4157_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_4158_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L ) ) ) ).

% Frct_code_post(6)
thf(fact_4159_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J4: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J4 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_4160_gauss__sum__nat,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X6: nat] : X6
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_4161_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_4162_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_4163_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_4164_Sum__Icc__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X6: nat] : X6
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_4165_rat__minus__code,axiom,
    ! [P5: rat,Q2: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P5 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ B4 @ C4 ) ) @ ( times_times @ int @ C4 @ D5 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_minus_code
thf(fact_4166_rat__times__code,axiom,
    ! [P5: rat,Q2: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P5 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ B4 ) @ ( times_times @ int @ C4 @ D5 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_times_code
thf(fact_4167_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_4168_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_4169_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_4170_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,M: nat,N: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_4171_rat__divide__code,axiom,
    ! [P5: rat,Q2: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P5 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ C4 @ B4 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_divide_code
thf(fact_4172_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X2: A,Y2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ X2 @ I ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ Y2 @ I ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J4: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J4 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J4 ) @ N ) )
                    @ ( power_power @ A @ X2 @ J4 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_4173_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_4174_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ R @ K2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K2 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_4175_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] : ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_4176_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X6: int] : X6
          @ ( set_or1337092689740270186AtMost @ int @ M @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_4177_Suc__0__xor__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_4178_xor__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_4179_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) )
          = Y2 ) ) ).

% bit.xor_left_self
thf(fact_4180_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_4181_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_4182_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_4183_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_4184_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_4185_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu3: B] : ( one_one @ A )
            @ A3 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_4186_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F3: B > nat,A3: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ B @ nat @ F3 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X6: B] : ( semiring_1_of_nat @ A @ ( F3 @ X6 ) )
            @ A3 ) ) ) ).

% of_nat_prod
thf(fact_4187_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [F3: B > int,A3: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7121269368397514597t_prod @ B @ int @ F3 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X6: B] : ( ring_1_of_int @ A @ ( F3 @ X6 ) )
            @ A3 ) ) ) ).

% of_int_prod
thf(fact_4188_of__real__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2191834092415804123ebra_1 @ A ) )
     => ! [F3: B > real,S: set @ B] :
          ( ( real_Vector_of_real @ A @ ( groups7121269368397514597t_prod @ B @ real @ F3 @ S ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X6: B] : ( real_Vector_of_real @ A @ ( F3 @ X6 ) )
            @ S ) ) ) ).

% of_real_prod
thf(fact_4189_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_4190_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_4191_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_4192_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% xor_numerals(1)
thf(fact_4193_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) ) ) ).

% xor_numerals(2)
thf(fact_4194_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% xor_numerals(5)
thf(fact_4195_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X2 ) ) ) ) ).

% xor_numerals(8)
thf(fact_4196_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_4197_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_4198_xor__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) ) ).

% xor_nat_numerals(4)
thf(fact_4199_xor__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% xor_nat_numerals(3)
thf(fact_4200_xor__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) ) ).

% xor_nat_numerals(2)
thf(fact_4201_xor__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% xor_nat_numerals(1)
thf(fact_4202_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_4203_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_4204_prod_Oreindex__bij__betw,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [H: B > C,S3: set @ B,T5: set @ C,G: C > A] :
          ( ( bij_betw @ B @ C @ H @ S3 @ T5 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X6: B] : ( G @ ( H @ X6 ) )
              @ S3 )
            = ( groups7121269368397514597t_prod @ C @ A @ G @ T5 ) ) ) ) ).

% prod.reindex_bij_betw
thf(fact_4205_abs__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_field @ A )
     => ! [F3: B > A,A3: set @ B] :
          ( ( abs_abs @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X6: B] : ( abs_abs @ A @ ( F3 @ X6 ) )
            @ A3 ) ) ) ).

% abs_prod
thf(fact_4206_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X6: B] : ( divide_divide @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ A3 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_dividef
thf(fact_4207_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F3: A > B,A3: set @ A,N: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ A3 ) @ N )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X6: A] : ( power_power @ B @ ( F3 @ X6 ) @ N )
            @ A3 ) ) ) ).

% prod_power_distrib
thf(fact_4208_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X6: B] : ( times_times @ A @ ( G @ X6 ) @ ( H @ X6 ) )
            @ A3 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ H @ A3 ) ) ) ) ).

% prod.distrib
thf(fact_4209_prod_Oswap,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > C > A,B5: set @ C,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [I: B] : ( groups7121269368397514597t_prod @ C @ A @ ( G @ I ) @ B5 )
            @ A3 )
          = ( groups7121269368397514597t_prod @ C @ A
            @ ^ [J4: C] :
                ( groups7121269368397514597t_prod @ B @ A
                @ ^ [I: B] : ( G @ I @ J4 )
                @ A3 )
            @ B5 ) ) ) ).

% prod.swap
thf(fact_4210_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_xor_eq
thf(fact_4211_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F3: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I: B] : ( modulo_modulo @ A @ ( F3 @ I ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ A2 ) ) ) ).

% mod_prod_eq
thf(fact_4212_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_xor_eq
thf(fact_4213_prod__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ B )
        & ( comm_semiring_1 @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( groups7121269368397514597t_prod @ A @ real
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) )
            @ A3 )
          = ( real_V7770717601297561774m_norm @ B @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ A3 ) ) ) ) ).

% prod_norm
thf(fact_4214_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_4215_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se5824344971392196577ns_xor @ A @ B4 @ A5 ) ) ) ) ).

% xor.commute
thf(fact_4216_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_4217_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ N )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_xor_iff
thf(fact_4218_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ X2 ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X2 ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_4219_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_se5824344971392196577ns_xor @ A @ Y2 @ Z ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Z ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_4220_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F3: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A5: B] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ A5 ) )
            @ A3 ) ) ) ).

% norm_prod_le
thf(fact_4221_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) )
                & ( ord_less_eq @ A @ ( F3 @ I2 ) @ ( G @ I2 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_mono
thf(fact_4222_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ X7 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) ) ) ) ).

% prod_nonneg
thf(fact_4223_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ X7 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) ) ) ) ).

% prod_pos
thf(fact_4224_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( suc @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
thf(fact_4225_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F3: B > nat,A3: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F3 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A5: B] : ( power_power @ A @ C2 @ ( F3 @ A5 ) )
            @ A3 ) ) ) ).

% power_sum
thf(fact_4226_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ I @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_4227_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ X7 ) )
                & ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_4228_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nat_diff_reindex
thf(fact_4229_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_4230_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_4231_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_4232_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_4233_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_4234_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_4235_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( G @ ( suc @ I ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_4236_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_4237_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] : ( G @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_4238_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X6: nat] : X6
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod
thf(fact_4239_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I ) @ ( set_ord_lessThan @ nat @ I ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J4: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( A2 @ I @ J4 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J4 ) @ N ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nested_swap'
thf(fact_4240_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F3: nat > A,A2: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( times_times @ A @ ( F3 @ A5 ) )
            @ A2
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_4241_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A,P5: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P5 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P5 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_4242_periodic__finite__ex,axiom,
    ! [D2: int,P3: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X7: int,K3: int] :
            ( ( P3 @ X7 )
            = ( P3 @ ( minus_minus @ int @ X7 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ( ? [X8: int] : ( P3 @ X8 ) )
          = ( ? [X6: int] :
                ( ( member @ int @ X6 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P3 @ X6 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_4243_bset_I3_J,axiom,
    ! [D4: int,T3: int,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member @ int @ ( minus_minus @ int @ T3 @ ( one_one @ int ) ) @ B5 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( X = T3 )
             => ( ( minus_minus @ int @ X @ D4 )
                = T3 ) ) ) ) ) ).

% bset(3)
thf(fact_4244_bset_I4_J,axiom,
    ! [D4: int,T3: int,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member @ int @ T3 @ B5 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( X != T3 )
             => ( ( minus_minus @ int @ X @ D4 )
               != T3 ) ) ) ) ) ).

% bset(4)
thf(fact_4245_bset_I5_J,axiom,
    ! [D4: int,B5: set @ int,T3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ! [X: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B5 )
                 => ( X
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( ord_less @ int @ X @ T3 )
           => ( ord_less @ int @ ( minus_minus @ int @ X @ D4 ) @ T3 ) ) ) ) ).

% bset(5)
thf(fact_4246_bset_I7_J,axiom,
    ! [D4: int,T3: int,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member @ int @ T3 @ B5 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( ord_less @ int @ T3 @ X )
             => ( ord_less @ int @ T3 @ ( minus_minus @ int @ X @ D4 ) ) ) ) ) ) ).

% bset(7)
thf(fact_4247_aset_I3_J,axiom,
    ! [D4: int,T3: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member @ int @ ( plus_plus @ int @ T3 @ ( one_one @ int ) ) @ A3 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( X = T3 )
             => ( ( plus_plus @ int @ X @ D4 )
                = T3 ) ) ) ) ) ).

% aset(3)
thf(fact_4248_aset_I4_J,axiom,
    ! [D4: int,T3: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member @ int @ T3 @ A3 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( X != T3 )
             => ( ( plus_plus @ int @ X @ D4 )
               != T3 ) ) ) ) ) ).

% aset(4)
thf(fact_4249_aset_I5_J,axiom,
    ! [D4: int,T3: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member @ int @ T3 @ A3 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( ord_less @ int @ X @ T3 )
             => ( ord_less @ int @ ( plus_plus @ int @ X @ D4 ) @ T3 ) ) ) ) ) ).

% aset(5)
thf(fact_4250_aset_I7_J,axiom,
    ! [D4: int,A3: set @ int,T3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ! [X: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( ord_less @ int @ T3 @ X )
           => ( ord_less @ int @ T3 @ ( plus_plus @ int @ X @ D4 ) ) ) ) ) ).

% aset(7)
thf(fact_4251_norm__prod__diff,axiom,
    ! [A: $tType,I5: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I6: set @ I5,Z: I5 > A,W: I5 > A] :
          ( ! [I2: I5] :
              ( ( member @ I5 @ I2 @ I6 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z @ I2 ) ) @ ( one_one @ real ) ) )
         => ( ! [I2: I5] :
                ( ( member @ I5 @ I2 @ I6 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I2 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I5 @ A @ Z @ I6 ) @ ( groups7121269368397514597t_prod @ I5 @ A @ W @ I6 ) ) )
              @ ( groups7311177749621191930dd_sum @ I5 @ real
                @ ^ [I: I5] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z @ I ) @ ( W @ I ) ) )
                @ I6 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_4252_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_4253_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X6: nat] : X6
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_4254_bset_I6_J,axiom,
    ! [D4: int,B5: set @ int,T3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ! [X: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B5 )
                 => ( X
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( ord_less_eq @ int @ X @ T3 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X @ D4 ) @ T3 ) ) ) ) ).

% bset(6)
thf(fact_4255_bset_I8_J,axiom,
    ! [D4: int,T3: int,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member @ int @ ( minus_minus @ int @ T3 @ ( one_one @ int ) ) @ B5 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( ord_less_eq @ int @ T3 @ X )
             => ( ord_less_eq @ int @ T3 @ ( minus_minus @ int @ X @ D4 ) ) ) ) ) ) ).

% bset(8)
thf(fact_4256_aset_I6_J,axiom,
    ! [D4: int,T3: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member @ int @ ( plus_plus @ int @ T3 @ ( one_one @ int ) ) @ A3 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( ord_less_eq @ int @ X @ T3 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X @ D4 ) @ T3 ) ) ) ) ) ).

% aset(6)
thf(fact_4257_aset_I8_J,axiom,
    ! [D4: int,A3: set @ int,T3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ! [X: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( ord_less_eq @ int @ T3 @ X )
           => ( ord_less_eq @ int @ T3 @ ( plus_plus @ int @ X @ D4 ) ) ) ) ) ).

% aset(8)
thf(fact_4258_cppi,axiom,
    ! [D4: int,P3: int > $o,P6: int > $o,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ? [Z4: int] :
          ! [X7: int] :
            ( ( ord_less @ int @ Z4 @ X7 )
           => ( ( P3 @ X7 )
              = ( P6 @ X7 ) ) )
       => ( ! [X7: int] :
              ( ! [Xa3: int] :
                  ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                 => ! [Xb3: int] :
                      ( ( member @ int @ Xb3 @ A3 )
                     => ( X7
                       != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
             => ( ( P3 @ X7 )
               => ( P3 @ ( plus_plus @ int @ X7 @ D4 ) ) ) )
         => ( ! [X7: int,K3: int] :
                ( ( P6 @ X7 )
                = ( P6 @ ( minus_minus @ int @ X7 @ ( times_times @ int @ K3 @ D4 ) ) ) )
           => ( ( ? [X8: int] : ( P3 @ X8 ) )
              = ( ? [X6: int] :
                    ( ( member @ int @ X6 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                    & ( P6 @ X6 ) )
                | ? [X6: int] :
                    ( ( member @ int @ X6 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                    & ? [Y: int] :
                        ( ( member @ int @ Y @ A3 )
                        & ( P3 @ ( minus_minus @ int @ Y @ X6 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_4259_cpmi,axiom,
    ! [D4: int,P3: int > $o,P6: int > $o,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ? [Z4: int] :
          ! [X7: int] :
            ( ( ord_less @ int @ X7 @ Z4 )
           => ( ( P3 @ X7 )
              = ( P6 @ X7 ) ) )
       => ( ! [X7: int] :
              ( ! [Xa3: int] :
                  ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                 => ! [Xb3: int] :
                      ( ( member @ int @ Xb3 @ B5 )
                     => ( X7
                       != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
             => ( ( P3 @ X7 )
               => ( P3 @ ( minus_minus @ int @ X7 @ D4 ) ) ) )
         => ( ! [X7: int,K3: int] :
                ( ( P6 @ X7 )
                = ( P6 @ ( minus_minus @ int @ X7 @ ( times_times @ int @ K3 @ D4 ) ) ) )
           => ( ( ? [X8: int] : ( P3 @ X8 ) )
              = ( ? [X6: int] :
                    ( ( member @ int @ X6 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                    & ( P6 @ X6 ) )
                | ? [X6: int] :
                    ( ( member @ int @ X6 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                    & ? [Y: int] :
                        ( ( member @ int @ Y @ B5 )
                        & ( P3 @ ( plus_plus @ int @ Y @ X6 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_4260_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_4261_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_4262_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X6: nat] : X6
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_4263_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_4264_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_4265_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_4266_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( if @ nat
          @ ( M4
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M4
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_4267_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P5: nat,K: nat,G: nat > A,H: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P5 )
         => ( ( ord_less_eq @ nat @ K @ P5 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J4: nat] : ( if @ A @ ( ord_less @ nat @ J4 @ K ) @ ( G @ J4 ) @ ( if @ A @ ( J4 = K ) @ ( one_one @ A ) @ ( H @ ( minus_minus @ nat @ J4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P5 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J4: nat] : ( if @ A @ ( ord_less @ nat @ J4 @ K ) @ ( G @ J4 ) @ ( H @ J4 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P5 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_4268_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_4269_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_4270_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_4271_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_4272_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4273_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_4274_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_4275_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4276_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_4277_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_4278_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_4279_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_4280_real__root__zero,axiom,
    ! [N: nat] :
      ( ( root @ N @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_4281_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_4282_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_4283_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_4284_concat__bit__of__zero__1,axiom,
    ! [N: nat,L: int] :
      ( ( bit_concat_bit @ N @ ( zero_zero @ int ) @ L )
      = ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ).

% concat_bit_of_zero_1
thf(fact_4285_real__root__Suc__0,axiom,
    ! [X2: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X2 )
      = X2 ) ).

% real_root_Suc_0
thf(fact_4286_root__0,axiom,
    ! [X2: real] :
      ( ( root @ ( zero_zero @ nat ) @ X2 )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_4287_real__root__eq__iff,axiom,
    ! [N: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X2 )
          = ( root @ N @ Y2 ) )
        = ( X2 = Y2 ) ) ) ).

% real_root_eq_iff
thf(fact_4288_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_4289_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_4290_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_4291_real__root__eq__0__iff,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_4292_real__root__less__iff,axiom,
    ! [N: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X2 ) @ ( root @ N @ Y2 ) )
        = ( ord_less @ real @ X2 @ Y2 ) ) ) ).

% real_root_less_iff
thf(fact_4293_real__root__le__iff,axiom,
    ! [N: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X2 ) @ ( root @ N @ Y2 ) )
        = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ).

% real_root_le_iff
thf(fact_4294_real__root__eq__1__iff,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X2 )
          = ( one_one @ real ) )
        = ( X2
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_4295_real__root__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_4296_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_4297_real__root__lt__0__iff,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_4298_real__root__gt__0__iff,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ Y2 ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y2 ) ) ) ).

% real_root_gt_0_iff
thf(fact_4299_real__root__le__0__iff,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_4300_real__root__ge__0__iff,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ Y2 ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 ) ) ) ).

% real_root_ge_0_iff
thf(fact_4301_real__root__lt__1__iff,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X2 ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_4302_real__root__gt__1__iff,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N @ Y2 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y2 ) ) ) ).

% real_root_gt_1_iff
thf(fact_4303_real__root__ge__1__iff,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N @ Y2 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 ) ) ) ).

% real_root_ge_1_iff
thf(fact_4304_real__root__le__1__iff,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X2 ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_4305_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_4306_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_4307_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_4308_push__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% push_bit_of_Suc_0
thf(fact_4309_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( ( N
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_4310_real__root__pow__pos2,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( root @ N @ X2 ) @ N )
          = X2 ) ) ) ).

% real_root_pow_pos2
thf(fact_4311_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_4312_int__prod,axiom,
    ! [B: $tType,F3: B > nat,A3: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7121269368397514597t_prod @ B @ nat @ F3 @ A3 ) )
      = ( groups7121269368397514597t_prod @ B @ int
        @ ^ [X6: B] : ( semiring_1_of_nat @ int @ ( F3 @ X6 ) )
        @ A3 ) ) ).

% int_prod
thf(fact_4313_bit__xor__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ N )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
         != ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ) ).

% bit_xor_int_iff
thf(fact_4314_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se5824344971392196577ns_xor @ int @ K2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_4315_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) ) ) ) ).

% push_bit_minus
thf(fact_4316_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_4317_push__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_4318_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_4319_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_4320_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_push_bit
thf(fact_4321_real__root__mult,axiom,
    ! [N: nat,X2: real,Y2: real] :
      ( ( root @ N @ ( times_times @ real @ X2 @ Y2 ) )
      = ( times_times @ real @ ( root @ N @ X2 ) @ ( root @ N @ Y2 ) ) ) ).

% real_root_mult
thf(fact_4322_real__root__mult__exp,axiom,
    ! [M: nat,N: nat,X2: real] :
      ( ( root @ ( times_times @ nat @ M @ N ) @ X2 )
      = ( root @ M @ ( root @ N @ X2 ) ) ) ).

% real_root_mult_exp
thf(fact_4323_real__root__pos__pos__le,axiom,
    ! [X2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X2 ) ) ) ).

% real_root_pos_pos_le
thf(fact_4324_XOR__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X2 @ Y2 ) ) ) ) ).

% XOR_lower
thf(fact_4325_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_4326_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_4327_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M4: nat,N2: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M4 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_4328_real__root__less__mono,axiom,
    ! [N: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ord_less @ real @ ( root @ N @ X2 ) @ ( root @ N @ Y2 ) ) ) ) ).

% real_root_less_mono
thf(fact_4329_real__root__le__mono,axiom,
    ! [N: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ord_less_eq @ real @ ( root @ N @ X2 ) @ ( root @ N @ Y2 ) ) ) ) ).

% real_root_le_mono
thf(fact_4330_real__root__power,axiom,
    ! [N: nat,X2: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X2 @ K ) )
        = ( power_power @ real @ ( root @ N @ X2 ) @ K ) ) ) ).

% real_root_power
thf(fact_4331_real__root__abs,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( abs_abs @ real @ X2 ) )
        = ( abs_abs @ real @ ( root @ N @ X2 ) ) ) ) ).

% real_root_abs
thf(fact_4332_sgn__root,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( sgn_sgn @ real @ ( root @ N @ X2 ) )
        = ( sgn_sgn @ real @ X2 ) ) ) ).

% sgn_root
thf(fact_4333_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_4334_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M4: nat,N2: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% xor_nat_def
thf(fact_4335_prod__int__eq,axiom,
    ! [I3: nat,J2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I3 @ J2 ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X6: int] : X6
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I3 ) @ ( semiring_1_of_nat @ int @ J2 ) ) ) ) ).

% prod_int_eq
thf(fact_4336_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q2 ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_4337_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K2: int,L3: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K2 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L3 ) ) ) ) ).

% concat_bit_eq
thf(fact_4338_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344971392196577ns_xor @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_4339_real__root__gt__zero,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ X2 ) ) ) ) ).

% real_root_gt_zero
thf(fact_4340_real__root__strict__decreasing,axiom,
    ! [N: nat,N5: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N5 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
         => ( ord_less @ real @ ( root @ N5 @ X2 ) @ ( root @ N @ X2 ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_4341_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_4342_root__abs__power,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( abs_abs @ real @ ( root @ N @ ( power_power @ real @ Y2 @ N ) ) )
        = ( abs_abs @ real @ Y2 ) ) ) ).

% root_abs_power
thf(fact_4343_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_4344_prod__int__plus__eq,axiom,
    ! [I3: nat,J2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I3 @ ( plus_plus @ nat @ I3 @ J2 ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X6: int] : X6
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I3 ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I3 @ J2 ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_4345_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_4346_real__root__pos__pos,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X2 ) ) ) ) ).

% real_root_pos_pos
thf(fact_4347_real__root__strict__increasing,axiom,
    ! [N: nat,N5: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N5 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N @ X2 ) @ ( root @ N5 @ X2 ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_4348_real__root__decreasing,axiom,
    ! [N: nat,N5: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N5 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
         => ( ord_less_eq @ real @ ( root @ N5 @ X2 ) @ ( root @ N @ X2 ) ) ) ) ) ).

% real_root_decreasing
thf(fact_4349_real__root__pow__pos,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( root @ N @ X2 ) @ N )
          = X2 ) ) ) ).

% real_root_pow_pos
thf(fact_4350_real__root__power__cancel,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( root @ N @ ( power_power @ real @ X2 @ N ) )
          = X2 ) ) ) ).

% real_root_power_cancel
thf(fact_4351_real__root__pos__unique,axiom,
    ! [N: nat,Y2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( power_power @ real @ Y2 @ N )
            = X2 )
         => ( ( root @ N @ X2 )
            = Y2 ) ) ) ) ).

% real_root_pos_unique
thf(fact_4352_odd__real__root__pow,axiom,
    ! [N: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( power_power @ real @ ( root @ N @ X2 ) @ N )
        = X2 ) ) ).

% odd_real_root_pow
thf(fact_4353_odd__real__root__unique,axiom,
    ! [N: nat,Y2: real,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ( power_power @ real @ Y2 @ N )
          = X2 )
       => ( ( root @ N @ X2 )
          = Y2 ) ) ) ).

% odd_real_root_unique
thf(fact_4354_odd__real__root__power__cancel,axiom,
    ! [N: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X2 @ N ) )
        = X2 ) ) ).

% odd_real_root_power_cancel
thf(fact_4355_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( times_times @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_int_def
thf(fact_4356_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N2: nat,M4: nat] : ( times_times @ nat @ M4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_nat_def
thf(fact_4357_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( times_times @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_4358_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 )
         => ~ ! [B3: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N @ B3 ) ) ) ) ).

% exp_dvdE
thf(fact_4359_real__root__increasing,axiom,
    ! [N: nat,N5: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N5 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N @ X2 ) @ ( root @ N5 @ X2 ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_4360_sgn__power__root,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N @ X2 ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N @ X2 ) ) @ N ) )
        = X2 ) ) ).

% sgn_power_root
thf(fact_4361_root__sgn__power,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( times_times @ real @ ( sgn_sgn @ real @ Y2 ) @ ( power_power @ real @ ( abs_abs @ real @ Y2 ) @ N ) ) )
        = Y2 ) ) ).

% root_sgn_power
thf(fact_4362_push__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_minus_one
thf(fact_4363_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% ln_root
thf(fact_4364_log__root,axiom,
    ! [N: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_root
thf(fact_4365_log__base__root,axiom,
    ! [N: nat,B2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N @ B2 ) @ X2 )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X2 ) ) ) ) ) ).

% log_base_root
thf(fact_4366_XOR__upper,axiom,
    ! [X2: int,N: nat,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ X2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X2 @ Y2 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% XOR_upper
thf(fact_4367_split__root,axiom,
    ! [P3: real > $o,N: nat,X2: real] :
      ( ( P3 @ ( root @ N @ X2 ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P3 @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ! [Y: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) )
                = X2 )
             => ( P3 @ Y ) ) ) ) ) ).

% split_root
thf(fact_4368_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I: nat,J4: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ J4 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( G @ I @ ( minus_minus @ nat @ K2 @ I ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_4369_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,Bs: list @ $o] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( take @ $o @ N @ Bs ) ) ) ) ).

% take_bit_horner_sum_bit_eq
thf(fact_4370_root__powr__inverse,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( root @ N @ X2 )
          = ( powr @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_4371_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) @ N2 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4372_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L3: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_4373_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I: nat,J4: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I @ J4 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( G @ I @ ( minus_minus @ nat @ K2 @ I ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.triangle_reindex
thf(fact_4374_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N )
          = ( ( ord_less @ nat @ N @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_4375_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L3: int] :
          ( if @ int
          @ ( K2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L3 )
          @ ( if @ int
            @ ( L3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K2 )
            @ ( if @ int
              @ ( K2
                = ( zero_zero @ int ) )
              @ L3
              @ ( if @ int
                @ ( L3
                  = ( zero_zero @ int ) )
                @ K2
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_4376_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_4377_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_4378_Sum__Ico__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X6: nat] : X6
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4379_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = X2 ) ) ).

% bit.double_compl
thf(fact_4380_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X2 )
            = ( bit_ri4277139882892585799ns_not @ A @ Y2 ) )
          = ( X2 = Y2 ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_4381_length__upt,axiom,
    ! [I3: nat,J2: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I3 @ J2 ) )
      = ( minus_minus @ nat @ J2 @ I3 ) ) ).

% length_upt
thf(fact_4382_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ Y2 )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) ) ) ) ).

% bit.xor_compl_left
thf(fact_4383_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) ) ) ) ).

% bit.xor_compl_right
thf(fact_4384_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,L: A,U: A] :
          ( ( member @ A @ I3 @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I3 )
            & ( ord_less @ A @ I3 @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4385_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_4386_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_4387_nth__upt,axiom,
    ! [I3: nat,K: nat,J2: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ K ) @ J2 )
     => ( ( nth @ nat @ ( upt @ I3 @ J2 ) @ K )
        = ( plus_plus @ nat @ I3 @ K ) ) ) ).

% nth_upt
thf(fact_4388_take__upt,axiom,
    ! [I3: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ M ) @ N )
     => ( ( take @ nat @ M @ ( upt @ I3 @ N ) )
        = ( upt @ I3 @ ( plus_plus @ nat @ I3 @ M ) ) ) ) ).

% take_upt
thf(fact_4389_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_4390_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_4391_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
          = ( bit_ri4277139882892585799ns_not @ A @ X2 ) ) ) ).

% bit.xor_one_left
thf(fact_4392_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X2 ) ) ) ).

% bit.xor_one_right
thf(fact_4393_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_4394_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_4395_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_4396_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_4397_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_4398_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_not_iff
thf(fact_4399_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_4400_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_4401_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4402_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4403_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_4404_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_4405_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_4406_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_4407_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_4408_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_4409_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_4410_map__Suc__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% map_Suc_upt
thf(fact_4411_atLeastLessThan__upt,axiom,
    ( ( set_or7035219750837199246ssThan @ nat )
    = ( ^ [I: nat,J4: nat] : ( set2 @ nat @ ( upt @ I @ J4 ) ) ) ) ).

% atLeastLessThan_upt
thf(fact_4412_bit__not__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff
thf(fact_4413_ex__nat__less__eq,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ? [M4: nat] :
            ( ( ord_less @ nat @ M4 @ N )
            & ( P3 @ M4 ) ) )
      = ( ? [X6: nat] :
            ( ( member @ nat @ X6 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P3 @ X6 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4414_all__nat__less__eq,axiom,
    ! [N: nat,P3: nat > $o] :
      ( ( ! [M4: nat] :
            ( ( ord_less @ nat @ M4 @ N )
           => ( P3 @ M4 ) ) )
      = ( ! [X6: nat] :
            ( ( member @ nat @ X6 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P3 @ X6 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4415_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_4416_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_4417_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ L @ ( suc @ U ) )
      = ( set_or1337092689740270186AtMost @ nat @ L @ U ) ) ).

% atLeastLessThanSuc_atLeastAtMost
thf(fact_4418_lessThan__atLeast0,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) ) ) ).

% lessThan_atLeast0
thf(fact_4419_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N2: nat,M4: nat] : ( set2 @ nat @ ( upt @ N2 @ ( suc @ M4 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_4420_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast_upt
thf(fact_4421_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( suc @ I ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_Suc_ivl
thf(fact_4422_map__add__upt,axiom,
    ! [N: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I: nat] : ( plus_plus @ nat @ I @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N @ ( plus_plus @ nat @ M @ N ) ) ) ).

% map_add_upt
thf(fact_4423_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ I @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_4424_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( suc @ I ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_Suc_ivl
thf(fact_4425_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ I @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_4426_map__replicate__trivial,axiom,
    ! [A: $tType,X2: A,I3: nat] :
      ( ( map @ nat @ A
        @ ^ [I: nat] : X2
        @ ( upt @ ( zero_zero @ nat ) @ I3 ) )
      = ( replicate @ A @ I3 @ X2 ) ) ).

% map_replicate_trivial
thf(fact_4427_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X7: B] :
                  ( ( ord_less_eq @ B @ C2 @ X7 )
                 => ( ( ord_less @ B @ X7 @ D2 )
                   => ( ( G @ X7 )
                      = ( H @ X7 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4428_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X7: B] :
                  ( ( ord_less_eq @ B @ C2 @ X7 )
                 => ( ( ord_less @ B @ X7 @ D2 )
                   => ( ( G @ X7 )
                      = ( H @ X7 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4429_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_4430_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A5: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_4431_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_4432_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,P5: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P5 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P5 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P5 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4433_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K2: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K2 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_4434_size__list__estimation,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: nat,F3: A > nat] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less @ nat @ Y2 @ ( F3 @ X2 ) )
       => ( ord_less @ nat @ Y2 @ ( size_list @ A @ F3 @ Xs ) ) ) ) ).

% size_list_estimation
thf(fact_4435_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list @ A,F3: A > nat,G: A > nat] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ nat @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F3 @ Xs ) @ ( size_list @ A @ G @ Xs ) ) ) ).

% size_list_pointwise
thf(fact_4436_size__list__estimation_H,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: nat,F3: A > nat] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ Y2 @ ( F3 @ X2 ) )
       => ( ord_less_eq @ nat @ Y2 @ ( size_list @ A @ F3 @ Xs ) ) ) ) ).

% size_list_estimation'
thf(fact_4437_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,P5: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P5 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P5 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P5 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4438_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_4439_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ) ) ) ).

% atMost_upto
thf(fact_4440_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_4441_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_4442_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_4443_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se5824344872417868541ns_and @ int @ K2 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_4444_map__decr__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N ) ) )
      = ( upt @ M @ N ) ) ).

% map_decr_upt
thf(fact_4445_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_4446_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_4447_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_4448_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_4449_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_4450_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( ( F3 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_4451_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_4452_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_4453_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_4454_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_4455_and__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_4456_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_4457_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_4458_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_4459_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_4460_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ N ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_4461_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_4462_nth__map__upt,axiom,
    ! [A: $tType,I3: nat,N: nat,M: nat,F3: nat > A] :
      ( ( ord_less @ nat @ I3 @ ( minus_minus @ nat @ N @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F3 @ ( upt @ M @ N ) ) @ I3 )
        = ( F3 @ ( plus_plus @ nat @ M @ I3 ) ) ) ) ).

% nth_map_upt
thf(fact_4463_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N ) ) ).

% bit_minus_int_iff
thf(fact_4464_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_4465_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_4466_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F3: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ I ) ) @ ( F3 @ I ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F3 @ N ) @ ( F3 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_4467_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_4468_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_4469_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_4470_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J4: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( A2 @ I @ J4 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J4 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sum.nested_swap
thf(fact_4471_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_4472_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J4: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( A2 @ I @ J4 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J4 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% prod.nested_swap
thf(fact_4473_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M4: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M4 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M4 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_4474_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M4: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M4 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M4 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_4475_prod__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_fact
thf(fact_4476_prod__Suc__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_Suc_fact
thf(fact_4477_and__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_4478_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_4479_and__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_4480_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.head_if
thf(fact_4481_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_4482_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,M: nat,F3: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( minus_minus @ nat @ N @ M ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I2 )
              = ( F3 @ ( plus_plus @ nat @ M @ I2 ) ) ) )
       => ( ( map @ nat @ A @ F3 @ ( upt @ M @ N ) )
          = Xs ) ) ) ).

% map_upt_eqI
thf(fact_4483_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_4484_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4485_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4486_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ I ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_4487_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_4488_and__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_4489_and__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_4490_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_not_iff_eq
thf(fact_4491_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F5: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ M4 )
                 => ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N2 ) ) ) @ E3 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_4492_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_4493_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F3: nat > A,S: A,K: nat] :
          ( ( sums @ A @ F3 @ S )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N2 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ K ) ) )
              @ S ) ) ) ) ).

% sums_group
thf(fact_4494_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K2: nat] : ( bit_se4730199178511100633sh_bit @ A @ K2 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ K2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% take_bit_sum
thf(fact_4495_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_4496_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_4497_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ I ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K2 @ I ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K2 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_4498_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_4499_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_4500_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K2: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ I ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K2 ) )
              @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_4501_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A5: A,Xs2: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F5 @ ( nth @ B @ Xs2 @ N2 ) ) @ ( power_power @ A @ A5 @ N2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4502_and__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_4503_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K2: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_4504_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4505_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: nat > A,B2: nat > A] :
          ( ! [I2: nat,J: nat] :
              ( ( ord_less_eq @ nat @ I2 @ J )
             => ( ( ord_less @ nat @ J @ N )
               => ( ord_less_eq @ A @ ( A2 @ I2 ) @ ( A2 @ J ) ) ) )
         => ( ! [I2: nat,J: nat] :
                ( ( ord_less_eq @ nat @ I2 @ J )
               => ( ( ord_less @ nat @ J @ N )
                 => ( ord_less_eq @ A @ ( B2 @ J ) @ ( B2 @ I2 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K2: nat] : ( times_times @ A @ ( A2 @ K2 ) @ ( B2 @ K2 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_4506_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I2: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J )
         => ( ( ord_less @ nat @ J @ N )
           => ( ord_less_eq @ nat @ ( A2 @ I2 ) @ ( A2 @ J ) ) ) )
     => ( ! [I2: nat,J: nat] :
            ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ N )
             => ( ord_less_eq @ nat @ ( B2 @ J ) @ ( B2 @ I2 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I: nat] : ( times_times @ nat @ ( A2 @ I ) @ ( B2 @ I ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_4507_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_4508_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X8: nat > real] :
        ! [J4: nat] :
        ? [M9: nat] :
        ! [M4: nat] :
          ( ( ord_less_eq @ nat @ M9 @ M4 )
         => ! [N2: nat] :
              ( ( ord_less_eq @ nat @ M9 @ N2 )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J4 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_4509_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N2 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_4510_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M5: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M5 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X15 @ M5 ) @ ( X15 @ N3 ) ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X15 ) ) ) ).

% CauchyI
thf(fact_4511_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X15 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M8: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M2 )
               => ! [N9: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N9 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X15 @ M2 ) @ ( X15 @ N9 ) ) ) @ E2 ) ) ) ) ) ) ).

% CauchyD
thf(fact_4512_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_4513_Code__Target__Int_Opositive__def,axiom,
    ( code_Target_positive
    = ( numeral_numeral @ int ) ) ).

% Code_Target_Int.positive_def
thf(fact_4514_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L3: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L3 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L3 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_4515_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] :
      ( ( re @ ( csqrt @ Z ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_4516_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A5: complex,B4: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A5 @ ( cnj @ B4 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_4517_cnj__prod,axiom,
    ! [A: $tType,F3: A > complex,S: set @ A] :
      ( ( cnj @ ( groups7121269368397514597t_prod @ A @ complex @ F3 @ S ) )
      = ( groups7121269368397514597t_prod @ A @ complex
        @ ^ [X6: A] : ( cnj @ ( F3 @ X6 ) )
        @ S ) ) ).

% cnj_prod
thf(fact_4518_complex__cnj__mult,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( cnj @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( times_times @ complex @ ( cnj @ X2 ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_mult
thf(fact_4519_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( ( cnj @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% complex_cnj_zero_iff
thf(fact_4520_complex__cnj__zero,axiom,
    ( ( cnj @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% complex_cnj_zero
thf(fact_4521_cnj__sum,axiom,
    ! [A: $tType,F3: A > complex,S: set @ A] :
      ( ( cnj @ ( groups7311177749621191930dd_sum @ A @ complex @ F3 @ S ) )
      = ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X6: A] : ( cnj @ ( F3 @ X6 ) )
        @ S ) ) ).

% cnj_sum
thf(fact_4522_Re__sum,axiom,
    ! [A: $tType,F3: A > complex,S: set @ A] :
      ( ( re @ ( groups7311177749621191930dd_sum @ A @ complex @ F3 @ S ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X6: A] : ( re @ ( F3 @ X6 ) )
        @ S ) ) ).

% Re_sum
thf(fact_4523_cos__Arg__i__mult__zero,axiom,
    ! [Y2: complex] :
      ( ( Y2
       != ( zero_zero @ complex ) )
     => ( ( ( re @ Y2 )
          = ( zero_zero @ real ) )
       => ( ( cos @ real @ ( arg @ Y2 ) )
          = ( zero_zero @ real ) ) ) ) ).

% cos_Arg_i_mult_zero
thf(fact_4524_Cauchy__Re,axiom,
    ! [X15: nat > complex] :
      ( ( topolo3814608138187158403Cauchy @ complex @ X15 )
     => ( topolo3814608138187158403Cauchy @ real
        @ ^ [N2: nat] : ( re @ ( X15 @ N2 ) ) ) ) ).

% Cauchy_Re
thf(fact_4525_complex__mod__sqrt__Re__mult__cnj,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z6: complex] : ( sqrt @ ( re @ ( times_times @ complex @ Z6 @ ( cnj @ Z6 ) ) ) ) ) ) ).

% complex_mod_sqrt_Re_mult_cnj
thf(fact_4526_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_4527_times__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_4528_sums__cnj,axiom,
    ! [F3: nat > complex,L: complex] :
      ( ( sums @ complex
        @ ^ [X6: nat] : ( cnj @ ( F3 @ X6 ) )
        @ ( cnj @ L ) )
      = ( sums @ complex @ F3 @ L ) ) ).

% sums_cnj
thf(fact_4529_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = L ) ).

% plus_integer_code(2)
thf(fact_4530_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_4531_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_4532_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K2: code_integer] :
          ( if @ code_integer
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_4533_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_4534_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( minus_minus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( uminus_uminus @ code_integer @ L ) ) ).

% minus_integer_code(2)
thf(fact_4535_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( minus_minus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% minus_integer_code(1)
thf(fact_4536_sums__Re,axiom,
    ! [X15: nat > complex,A2: complex] :
      ( ( sums @ complex @ X15 @ A2 )
     => ( sums @ real
        @ ^ [N2: nat] : ( re @ ( X15 @ N2 ) )
        @ ( re @ A2 ) ) ) ).

% sums_Re
thf(fact_4537_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_4538_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_4539_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_4540_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_4541_imaginary__unit_Osimps_I1_J,axiom,
    ( ( re @ imaginary_unit )
    = ( zero_zero @ real ) ) ).

% imaginary_unit.simps(1)
thf(fact_4542_zero__complex_Osimps_I1_J,axiom,
    ( ( re @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(1)
thf(fact_4543_scaleR__complex_Osimps_I1_J,axiom,
    ! [R: real,X2: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R @ X2 ) )
      = ( times_times @ real @ R @ ( re @ X2 ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_4544_complex__add__cnj,axiom,
    ! [Z: complex] :
      ( ( plus_plus @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z ) ) ) ) ).

% complex_add_cnj
thf(fact_4545_summable__Re,axiom,
    ! [F3: nat > complex] :
      ( ( summable @ complex @ F3 )
     => ( summable @ real
        @ ^ [X6: nat] : ( re @ ( F3 @ X6 ) ) ) ) ).

% summable_Re
thf(fact_4546_Re__csqrt,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) ) ).

% Re_csqrt
thf(fact_4547_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rsp
thf(fact_4548_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) ) ).

% zero_integer.rsp
thf(fact_4549_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_4550_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_4551_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_4552_complex__mod__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_4553_complex__norm__square,axiom,
    ! [Z: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z @ ( cnj @ Z ) ) ) ).

% complex_norm_square
thf(fact_4554_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z6: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z6 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z6 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_4555_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( ( im @ ( csqrt @ Z ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_4556_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K2: int] :
          ( if @ code_integer @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K2 ) ) )
          @ ( if @ code_integer
            @ ( K2
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_4557_csqrt__of__real__nonpos,axiom,
    ! [X2: complex] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X2 ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X2 )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X2 ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_4558_complex__Im__of__int,axiom,
    ! [Z: int] :
      ( ( im @ ( ring_1_of_int @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_int
thf(fact_4559_complex__Im__fact,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_char_0_fact @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_fact
thf(fact_4560_complex__Im__of__nat,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_1_of_nat @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_nat
thf(fact_4561_Im__complex__of__real,axiom,
    ! [Z: real] :
      ( ( im @ ( real_Vector_of_real @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% Im_complex_of_real
thf(fact_4562_Im__power__real,axiom,
    ! [X2: complex,N: nat] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X2 @ N ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_4563_complex__Im__numeral,axiom,
    ! [V: num] :
      ( ( im @ ( numeral_numeral @ complex @ V ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_4564_Im__sum,axiom,
    ! [A: $tType,F3: A > complex,S: set @ A] :
      ( ( im @ ( groups7311177749621191930dd_sum @ A @ complex @ F3 @ S ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X6: A] : ( im @ ( F3 @ X6 ) )
        @ S ) ) ).

% Im_sum
thf(fact_4565_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_4566_Im__i__times,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( re @ Z ) ) ).

% Im_i_times
thf(fact_4567_Re__power__real,axiom,
    ! [X2: complex,N: nat] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X2 @ N ) )
        = ( power_power @ real @ ( re @ X2 ) @ N ) ) ) ).

% Re_power_real
thf(fact_4568_Re__i__times,axiom,
    ! [Z: complex] :
      ( ( re @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( uminus_uminus @ real @ ( im @ Z ) ) ) ).

% Re_i_times
thf(fact_4569_csqrt__of__real__nonneg,axiom,
    ! [X2: complex] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X2 ) )
       => ( ( csqrt @ X2 )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X2 ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_4570_csqrt__minus,axiom,
    ! [X2: complex] :
      ( ( ( ord_less @ real @ ( im @ X2 ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X2 ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X2 ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X2 ) ) ) ) ).

% csqrt_minus
thf(fact_4571_divide__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( divide_divide @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( divide_divide @ int @ Xa @ X2 ) ) ) ).

% divide_integer.abs_eq
thf(fact_4572_less__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( ord_less @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( ord_less @ int @ Xa @ X2 ) ) ).

% less_integer.abs_eq
thf(fact_4573_uminus__integer__code_I1_J,axiom,
    ( ( uminus_uminus @ code_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ code_integer ) ) ).

% uminus_integer_code(1)
thf(fact_4574_zero__integer__def,axiom,
    ( ( zero_zero @ code_integer )
    = ( code_integer_of_int @ ( zero_zero @ int ) ) ) ).

% zero_integer_def
thf(fact_4575_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K2: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K2 ) @ K2 ) ) ) ).

% abs_integer_code
thf(fact_4576_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_4577_sums__Im,axiom,
    ! [X15: nat > complex,A2: complex] :
      ( ( sums @ complex @ X15 @ A2 )
     => ( sums @ real
        @ ^ [N2: nat] : ( im @ ( X15 @ N2 ) )
        @ ( im @ A2 ) ) ) ).

% sums_Im
thf(fact_4578_Cauchy__Im,axiom,
    ! [X15: nat > complex] :
      ( ( topolo3814608138187158403Cauchy @ complex @ X15 )
     => ( topolo3814608138187158403Cauchy @ real
        @ ^ [N2: nat] : ( im @ ( X15 @ N2 ) ) ) ) ).

% Cauchy_Im
thf(fact_4579_zero__complex_Osimps_I2_J,axiom,
    ( ( im @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(2)
thf(fact_4580_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_4581_times__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( times_times @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( times_times @ int @ Xa @ X2 ) ) ) ).

% times_integer.abs_eq
thf(fact_4582_scaleR__complex_Osimps_I2_J,axiom,
    ! [R: real,X2: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R @ X2 ) )
      = ( times_times @ real @ R @ ( im @ X2 ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_4583_sums__complex__iff,axiom,
    ( ( sums @ complex )
    = ( ^ [F5: nat > complex,X6: complex] :
          ( ( sums @ real
            @ ^ [Y: nat] : ( re @ ( F5 @ Y ) )
            @ ( re @ X6 ) )
          & ( sums @ real
            @ ^ [Y: nat] : ( im @ ( F5 @ Y ) )
            @ ( im @ X6 ) ) ) ) ) ).

% sums_complex_iff
thf(fact_4584_summable__Im,axiom,
    ! [F3: nat > complex] :
      ( ( summable @ complex @ F3 )
     => ( summable @ real
        @ ^ [X6: nat] : ( im @ ( F3 @ X6 ) ) ) ) ).

% summable_Im
thf(fact_4585_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( ring_1_Ints @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I: int] :
            ( ( re @ Z )
            = ( ring_1_of_int @ real @ I ) ) ) ) ).

% complex_is_Int_iff
thf(fact_4586_summable__complex__iff,axiom,
    ( ( summable @ complex )
    = ( ^ [F5: nat > complex] :
          ( ( summable @ real
            @ ^ [X6: nat] : ( re @ ( F5 @ X6 ) ) )
          & ( summable @ real
            @ ^ [X6: nat] : ( im @ ( F5 @ X6 ) ) ) ) ) ) ).

% summable_complex_iff
thf(fact_4587_times__complex_Osimps_I2_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( im @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y2 ) ) ) ) ).

% times_complex.simps(2)
thf(fact_4588_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( abs_abs @ real @ ( re @ Z ) )
        = ( real_V7770717601297561774m_norm @ complex @ Z ) )
     => ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% Im_eq_0
thf(fact_4589_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( ( re @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_eq_Im
thf(fact_4590_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( ( im @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( re @ Z ) ) ) ) ).

% cmod_eq_Re
thf(fact_4591_times__complex_Osimps_I1_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( re @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y2 ) ) ) ) ).

% times_complex.simps(1)
thf(fact_4592_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_4593_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X6: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X6 ) ) @ ( times_times @ real @ R5 @ ( im @ X6 ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_4594_csqrt__principal,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) )
      | ( ( ( re @ ( csqrt @ Z ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z ) ) ) ) ) ).

% csqrt_principal
thf(fact_4595_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_4596_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_4597_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_4598_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_4599_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_4600_Re__exp,axiom,
    ! [Z: complex] :
      ( ( re @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( cos @ real @ ( im @ Z ) ) ) ) ).

% Re_exp
thf(fact_4601_Im__exp,axiom,
    ! [Z: complex] :
      ( ( im @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( sin @ real @ ( im @ Z ) ) ) ) ).

% Im_exp
thf(fact_4602_complex__eq,axiom,
    ! [A2: complex] :
      ( A2
      = ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ A2 ) ) ) ) ) ).

% complex_eq
thf(fact_4603_fun__complex__eq,axiom,
    ! [A: $tType,F3: A > complex] :
      ( F3
      = ( ^ [X6: A] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ ( F3 @ X6 ) ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ ( F3 @ X6 ) ) ) ) ) ) ) ).

% fun_complex_eq
thf(fact_4604_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X6: complex,Y: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X6 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X6 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X6 ) @ ( im @ Y ) ) @ ( times_times @ real @ ( im @ X6 ) @ ( re @ Y ) ) ) ) ) ) ).

% times_complex.code
thf(fact_4605_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_4606_exp__eq__polar,axiom,
    ( ( exp @ complex )
    = ( ^ [Z6: complex] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( exp @ real @ ( re @ Z6 ) ) ) @ ( cis @ ( im @ Z6 ) ) ) ) ) ).

% exp_eq_polar
thf(fact_4607_cmod__power2,axiom,
    ! [Z: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_4608_Im__power2,axiom,
    ! [X2: complex] :
      ( ( im @ ( power_power @ complex @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X2 ) ) @ ( im @ X2 ) ) ) ).

% Im_power2
thf(fact_4609_Re__power2,axiom,
    ! [X2: complex] :
      ( ( re @ ( power_power @ complex @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_4610_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_4611_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z6: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_4612_inverse__complex_Osimps_I1_J,axiom,
    ! [X2: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X2 ) )
      = ( divide_divide @ real @ ( re @ X2 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_4613_complex__diff__cnj,axiom,
    ! [Z: complex] :
      ( ( minus_minus @ complex @ Z @ ( cnj @ Z ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_4614_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( ( Z
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_4615_Re__divide,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( re @ ( divide_divide @ complex @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y2 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_4616_complex__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( times_times @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_4617_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_4618_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z )
          = W ) ) ) ).

% csqrt_unique
thf(fact_4619_inverse__complex_Osimps_I2_J,axiom,
    ! [X2: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X2 ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X2 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_4620_Im__divide,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( im @ ( divide_divide @ complex @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y2 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_4621_complex__abs__le__norm,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% complex_abs_le_norm
thf(fact_4622_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_4623_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X6: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X6 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X6 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_4624_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X6: complex,Y: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X6 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X6 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X6 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X6 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_4625_Im__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R ) ) @ ( im @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_4626_Re__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R ) @ ( re @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_4627_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N5: nat,F3: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N3: nat] : ( member @ complex @ ( G @ N3 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N3 ) ) )
             => ( ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ N5 @ N3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N3 ) ) ) )
               => ( summable @ A @ F3 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4628_integer__of__num_I3_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit1 @ N ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_4629_real__eq__imaginary__iff,axiom,
    ! [Y2: complex,X2: complex] :
      ( ( member @ complex @ Y2 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X2 @ ( real_Vector_Reals @ complex ) )
       => ( ( X2
            = ( times_times @ complex @ imaginary_unit @ Y2 ) )
          = ( ( X2
              = ( zero_zero @ complex ) )
            & ( Y2
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_4630_imaginary__eq__real__iff,axiom,
    ! [Y2: complex,X2: complex] :
      ( ( member @ complex @ Y2 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X2 @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y2 )
            = X2 )
          = ( ( X2
              = ( zero_zero @ complex ) )
            & ( Y2
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_4631_Reals__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_0
thf(fact_4632_Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_divide
thf(fact_4633_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_4634_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_4635_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_4636_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_4637_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( real_Vector_Reals @ complex ) )
      = ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% complex_is_Real_iff
thf(fact_4638_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_4639_Complex__in__Reals,axiom,
    ! [X2: real] : ( member @ complex @ ( complex2 @ X2 @ ( zero_zero @ real ) ) @ ( real_Vector_Reals @ complex ) ) ).

% Complex_in_Reals
thf(fact_4640_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% nonzero_Reals_inverse
thf(fact_4641_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_4642_Re__prod__Reals,axiom,
    ! [A: $tType,A3: set @ A,F3: A > complex] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ A3 )
         => ( member @ complex @ ( F3 @ X7 ) @ ( real_Vector_Reals @ complex ) ) )
     => ( ( re @ ( groups7121269368397514597t_prod @ A @ complex @ F3 @ A3 ) )
        = ( groups7121269368397514597t_prod @ A @ real
          @ ^ [X6: A] : ( re @ ( F3 @ X6 ) )
          @ A3 ) ) ) ).

% Re_prod_Reals
thf(fact_4643_integer__of__num_I2_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) ) ).

% integer_of_num(2)
thf(fact_4644_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_4645_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K2 ) ) )
          @ ( if @ int
            @ ( K2
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L3: code_integer,J4: code_integer] :
                  ( if @ int
                  @ ( J4
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L3 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L3 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_4646_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K2: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K2 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_4647_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K2 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L3: code_integer,J4: code_integer] :
                ( if @ num
                @ ( J4
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L3 ) @ ( code_num_of_integer @ L3 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L3 ) @ ( code_num_of_integer @ L3 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_4648_zero__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ int ) ) ).

% zero_integer.rep_eq
thf(fact_4649_int__of__integer__numeral,axiom,
    ! [K: num] :
      ( ( code_int_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ int @ K ) ) ).

% int_of_integer_numeral
thf(fact_4650_times__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( times_times @ code_integer @ X2 @ Xa ) )
      = ( times_times @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% times_integer.rep_eq
thf(fact_4651_divide__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( divide_divide @ code_integer @ X2 @ Xa ) )
      = ( divide_divide @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% divide_integer.rep_eq
thf(fact_4652_integer__less__iff,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [K2: code_integer,L3: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ K2 ) @ ( code_int_of_integer @ L3 ) ) ) ) ).

% integer_less_iff
thf(fact_4653_less__integer_Orep__eq,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [X6: code_integer,Xa4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ X6 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_integer.rep_eq
thf(fact_4654_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K2: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S4: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K2 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S4 ) )
                @ ( S4
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_4655_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L3: code_integer,J4: code_integer] :
                ( if @ nat
                @ ( J4
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L3 ) @ ( code_nat_of_integer @ L3 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L3 ) @ ( code_nat_of_integer @ L3 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_4656_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F3: nat > A > A,V: num,N: nat] :
      ( ( rec_nat @ A @ A2 @ F3 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F3 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) @ ( rec_nat @ A @ A2 @ F3 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_4657_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F2: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F2 @ ( suc @ Nat ) )
      = ( F2 @ Nat @ ( rec_nat @ T @ F1 @ F2 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_4658_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F2: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F2 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_4659_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F3: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A2 @ F3 @ ( numeral_numeral @ nat @ V ) )
      = ( F3 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A2 @ F3 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_4660_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_4661_nat__of__integer__code__post_I1_J,axiom,
    ( ( code_nat_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ nat ) ) ).

% nat_of_integer_code_post(1)
thf(fact_4662_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_4663_divmod__abs__code_I6_J,axiom,
    ! [J2: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J2 )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_4664_divmod__abs__code_I5_J,axiom,
    ! [J2: code_integer] :
      ( ( code_divmod_abs @ J2 @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J2 ) ) ) ).

% divmod_abs_code(5)
thf(fact_4665_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F22: nat > T > T,X6: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F22 @ X6 ) ) ) ) ).

% old.rec_nat_def
thf(fact_4666_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L3: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L3 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K2 ) @ ( code_divmod_abs @ K2 @ L3 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S4: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S4
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L3 @ S4 ) ) )
                @ ( code_divmod_abs @ K2 @ L3 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L3
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K2 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K2 @ L3 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S4: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S4
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L3 ) @ S4 ) ) )
                    @ ( code_divmod_abs @ K2 @ L3 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_4667_rec__nat__0__imp,axiom,
    ! [A: $tType,F3: nat > A,F1: A,F2: nat > A > A] :
      ( ( F3
        = ( rec_nat @ A @ F1 @ F2 ) )
     => ( ( F3 @ ( zero_zero @ nat ) )
        = F1 ) ) ).

% rec_nat_0_imp
thf(fact_4668_subset__CollectI,axiom,
    ! [A: $tType,B5: set @ A,A3: set @ A,Q: A > $o,P3: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ A3 )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ B5 )
           => ( ( Q @ X7 )
             => ( P3 @ X7 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ B5 )
                & ( Q @ X6 ) ) )
          @ ( collect @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ A3 )
                & ( P3 @ X6 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_4669_subset__Collect__iff,axiom,
    ! [A: $tType,B5: set @ A,A3: set @ A,P3: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5
          @ ( collect @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ A3 )
                & ( P3 @ X6 ) ) ) )
        = ( ! [X6: A] :
              ( ( member @ A @ X6 @ B5 )
             => ( P3 @ X6 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_4670_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F3: nat > A,F1: A,F2: nat > A > A,N: nat] :
      ( ( F3
        = ( rec_nat @ A @ F1 @ F2 ) )
     => ( ( F3 @ ( suc @ N ) )
        = ( F2 @ N @ ( F3 @ N ) ) ) ) ).

% rec_nat_Suc_imp
thf(fact_4671_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F3: nat > A,V: num,N: nat] :
      ( ( case_nat @ A @ A2 @ F3 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F3 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ).

% case_nat_add_eq_if
thf(fact_4672_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L3: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_4673_prod__decode__aux_Oelims,axiom,
    ! [X2: nat,Xa: nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X2 @ Xa )
        = Y2 )
     => ( ( ( ord_less_eq @ nat @ Xa @ X2 )
         => ( Y2
            = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X2 @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa @ X2 )
         => ( Y2
            = ( nat_prod_decode_aux @ ( suc @ X2 ) @ ( minus_minus @ nat @ Xa @ ( suc @ X2 ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_4674_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ A2 )
          = A2 ) ) ).

% or.idem
thf(fact_4675_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.left_idem
thf(fact_4676_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.right_idem
thf(fact_4677_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_4678_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_4679_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_4680_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_4681_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_4682_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_4683_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% or_nonnegative_int_iff
thf(fact_4684_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_4685_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_4686_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_4687_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F3: nat > A,V: num] :
      ( ( case_nat @ A @ A2 @ F3 @ ( numeral_numeral @ nat @ V ) )
      = ( F3 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_4688_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% or_numerals(8)
thf(fact_4689_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% or_numerals(2)
thf(fact_4690_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_4691_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_4692_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% or_numerals(3)
thf(fact_4693_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% or_numerals(1)
thf(fact_4694_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% or_numerals(5)
thf(fact_4695_or__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_4696_or__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_4697_or__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_4698_and__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_4699_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_4700_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_4701_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_4702_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: A > B,F1: A,F2: nat > A,Nat: nat] :
      ( ( H @ ( case_nat @ A @ F1 @ F2 @ Nat ) )
      = ( case_nat @ B @ ( H @ F1 )
        @ ^ [X6: nat] : ( H @ ( F2 @ X6 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_4703_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_4704_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( zero_zero @ A ) )
          = X2 ) ) ).

% bit.disj_zero_right
thf(fact_4705_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ X2 ) @ ( bit_se1065995026697491101ons_or @ A @ Z @ X2 ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_4706_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ X2 ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X2 ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_4707_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ Z ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 ) @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Z ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_4708_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ Z ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Z ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_4709_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_or_iff
thf(fact_4710_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_4711_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se1065995026697491101ons_or @ A @ B4 @ A5 ) ) ) ) ).

% or.commute
thf(fact_4712_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_4713_bit__or__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        | ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ).

% bit_or_int_iff
thf(fact_4714_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_or_eq
thf(fact_4715_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_or_eq
thf(fact_4716_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F2: nat > A,X23: nat] :
      ( ( case_nat @ A @ F1 @ F2 @ ( suc @ X23 ) )
      = ( F2 @ X23 ) ) ).

% old.nat.simps(5)
thf(fact_4717_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F2: nat > A] :
      ( ( case_nat @ A @ F1 @ F2 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_4718_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) ) ) ).

% or_greater_eq
thf(fact_4719_OR__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) ) ) ) ).

% OR_lower
thf(fact_4720_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_4721_plus__and__or,axiom,
    ! [X2: int,Y2: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) )
      = ( plus_plus @ int @ X2 @ Y2 ) ) ).

% plus_and_or
thf(fact_4722_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A5: A,B4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( bit_ri4277139882892585799ns_not @ A @ B4 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_4723_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A5: A,B4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( bit_ri4277139882892585799ns_not @ A @ B4 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_4724_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_4725_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_4726_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L3: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K2 ) @ ( bit_ri4277139882892585799ns_not @ int @ L3 ) ) ) ) ) ).

% or_int_def
thf(fact_4727_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4728_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X6: A,Y: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X6 @ Y ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X6 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_4729_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X6: A,Y: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X6 @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X6 ) @ Y ) ) ) ) ) ).

% bit.xor_def
thf(fact_4730_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_4731_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L3: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K2 @ ( bit_ri4277139882892585799ns_not @ int @ L3 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K2 ) @ L3 ) ) ) ) ).

% xor_int_def
thf(fact_4732_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K2: int,L3: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K2 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L3 ) ) ) ) ).

% concat_bit_def
thf(fact_4733_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se1065995026697491101ons_or @ int @ K2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_4734_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N ) ) ).

% less_eq_nat.simps(2)
thf(fact_4735_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_4736_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X2: A,Y2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X2 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y2 )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y2 )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X2 = Y2 ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_4737_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_4738_or__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(2)
thf(fact_4739_diff__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K2: nat] : K2
        @ ( minus_minus @ nat @ M @ N ) ) ) ).

% diff_Suc
thf(fact_4740_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X2 )
              = Y2 ) ) ) ) ).

% bit.compl_unique
thf(fact_4741_or__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(3)
thf(fact_4742_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4743_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ N )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(1)
thf(fact_4744_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ N )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(2)
thf(fact_4745_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X6: A,F5: nat > A,N2: nat] :
            ( if @ A
            @ ( N2
              = ( zero_zero @ nat ) )
            @ X6
            @ ( F5 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_4746_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_4747_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% mask_Suc_exp
thf(fact_4748_or__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_4749_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_4750_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_4751_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_4752_OR__upper,axiom,
    ! [X2: int,N: nat,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ X2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% OR_upper
thf(fact_4753_or__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_4754_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A5 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_4755_or__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_4756_or__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_4757_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K2: nat,M4: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M4 @ K2 ) @ ( product_Pair @ nat @ nat @ M4 @ ( minus_minus @ nat @ K2 @ M4 ) ) @ ( nat_prod_decode_aux @ ( suc @ K2 ) @ ( minus_minus @ nat @ M4 @ ( suc @ K2 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_4758_or__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_4759_or__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_4760_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L3: int] :
          ( if @ int
          @ ( ( K2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K2
              = ( zero_zero @ int ) )
            @ L3
            @ ( if @ int
              @ ( L3
                = ( zero_zero @ int ) )
              @ K2
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_4761_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P3: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P3
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P3 ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_4762_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_4763_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(3)
thf(fact_4764_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X2 ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(4)
thf(fact_4765_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_4766_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_4767_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(5)
thf(fact_4768_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(6)
thf(fact_4769_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_4770_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_4771_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_4772_or__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% or_nat_numerals(2)
thf(fact_4773_or__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% or_nat_numerals(4)
thf(fact_4774_or__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% or_nat_numerals(1)
thf(fact_4775_or__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% or_nat_numerals(3)
thf(fact_4776_or__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_4777_or__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_4778_or__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_4779_or__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_4780_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: nat,Y2: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X2 @ Y2 ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( semiring_1_of_nat @ A @ Y2 ) ) ) ) ).

% of_nat_max
thf(fact_4781_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ord_max @ A @ ( minus_minus @ A @ X2 @ Z ) @ ( minus_minus @ A @ Y2 @ Z ) ) ) ) ).

% max_diff_distrib_left
thf(fact_4782_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ord_max @ A @ ( plus_plus @ A @ X2 @ Z ) @ ( plus_plus @ A @ Y2 @ Z ) ) ) ) ).

% max_add_distrib_left
thf(fact_4783_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ X2 @ ( ord_max @ A @ Y2 @ Z ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( plus_plus @ A @ X2 @ Z ) ) ) ) ).

% max_add_distrib_right
thf(fact_4784_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_4785_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ B4 @ A5 ) ) ) ) ).

% max_def_raw
thf(fact_4786_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M4: nat,N2: nat] : ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M4 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_4787_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_4788_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit1 @ M ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_4789_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_4790_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(3)
thf(fact_4791_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_4792_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit1 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_4793_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M4: nat,N2: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% or_nat_def
thf(fact_4794_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(2)
thf(fact_4795_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_4796_or__not__num__neg_Oelims,axiom,
    ! [X2: num,Xa: num,Y2: num] :
      ( ( ( bit_or_not_num_neg @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y2 != one2 ) ) )
       => ( ( ( X2 = one2 )
           => ! [M5: num] :
                ( ( Xa
                  = ( bit0 @ M5 ) )
               => ( Y2
                 != ( bit1 @ M5 ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [M5: num] :
                  ( ( Xa
                    = ( bit1 @ M5 ) )
                 => ( Y2
                   != ( bit1 @ M5 ) ) ) )
           => ( ( ? [N3: num] :
                    ( X2
                    = ( bit0 @ N3 ) )
               => ( ( Xa = one2 )
                 => ( Y2
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N3: num] :
                    ( ( X2
                      = ( bit0 @ N3 ) )
                   => ! [M5: num] :
                        ( ( Xa
                          = ( bit0 @ M5 ) )
                       => ( Y2
                         != ( bitM @ ( bit_or_not_num_neg @ N3 @ M5 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X2
                        = ( bit0 @ N3 ) )
                     => ! [M5: num] :
                          ( ( Xa
                            = ( bit1 @ M5 ) )
                         => ( Y2
                           != ( bit0 @ ( bit_or_not_num_neg @ N3 @ M5 ) ) ) ) )
                 => ( ( ? [N3: num] :
                          ( X2
                          = ( bit1 @ N3 ) )
                     => ( ( Xa = one2 )
                       => ( Y2 != one2 ) ) )
                   => ( ! [N3: num] :
                          ( ( X2
                            = ( bit1 @ N3 ) )
                         => ! [M5: num] :
                              ( ( Xa
                                = ( bit0 @ M5 ) )
                             => ( Y2
                               != ( bitM @ ( bit_or_not_num_neg @ N3 @ M5 ) ) ) ) )
                     => ~ ! [N3: num] :
                            ( ( X2
                              = ( bit1 @ N3 ) )
                           => ! [M5: num] :
                                ( ( Xa
                                  = ( bit1 @ M5 ) )
                               => ( Y2
                                 != ( bitM @ ( bit_or_not_num_neg @ N3 @ M5 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_4797_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_4798_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N @ M ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_4799_numeral__or__not__num__eq,axiom,
    ! [M: num,N: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_4800_Suc__0__or__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_or_eq
thf(fact_4801_or__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% or_Suc_0_eq
thf(fact_4802_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_4803_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_4804_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_4805_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ( ord_less @ A @ X2 @ Z )
            & ( ord_less @ A @ Y2 @ Z ) ) ) ) ).

% max_less_iff_conj
thf(fact_4806_max__enat__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% max_enat_simps(5)
thf(fact_4807_max__enat__simps_I4_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% max_enat_simps(4)
thf(fact_4808_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = Q2 ) ).

% max_enat_simps(2)
thf(fact_4809_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = Q2 ) ).

% max_enat_simps(3)
thf(fact_4810_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_Suc_Suc
thf(fact_4811_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_4812_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_4813_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_4814_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_4815_max__0L,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% max_0L
thf(fact_4816_max__0R,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ N @ ( zero_zero @ nat ) )
      = N ) ).

% max_0R
thf(fact_4817_max__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_enat_simps(1)
thf(fact_4818_of__nat__of__integer,axiom,
    ! [K: code_integer] :
      ( ( semiring_1_of_nat @ code_integer @ ( code_nat_of_integer @ K ) )
      = ( ord_max @ code_integer @ ( zero_zero @ code_integer ) @ K ) ) ).

% of_nat_of_integer
thf(fact_4819_max__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_4820_max__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% max_numeral_Suc
thf(fact_4821_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N @ Q2 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_max_right
thf(fact_4822_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N ) @ Q2 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N @ Q2 ) ) ) ).

% nat_mult_max_left
thf(fact_4823_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N ) @ Q2 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q2 ) @ ( plus_plus @ nat @ N @ Q2 ) ) ) ).

% nat_add_max_left
thf(fact_4824_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N @ Q2 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N ) @ ( plus_plus @ nat @ M @ Q2 ) ) ) ).

% nat_add_max_right
thf(fact_4825_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N @ M ) @ M )
      = ( ord_max @ nat @ N @ M ) ) ).

% nat_minus_add_max
thf(fact_4826_max__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M3: nat] : ( suc @ ( ord_max @ nat @ M3 @ N ) )
        @ M ) ) ).

% max_Suc2
thf(fact_4827_max__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M3: nat] : ( suc @ ( ord_max @ nat @ N @ M3 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_4828_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_4829_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_4830_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( ord_max @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_4831_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_4832_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ Z @ ( ord_max @ A @ X2 @ Y2 ) )
          = ( ( ord_less @ A @ Z @ X2 )
            | ( ord_less @ A @ Z @ Y2 ) ) ) ) ).

% less_max_iff_disj
thf(fact_4833_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( if @ nat
          @ ( M4
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M4
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_4834_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4835_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P3: A > $o,F1: A,F2: nat > A,Nat: nat] :
      ( ( P3 @ ( case_nat @ A @ F1 @ F2 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P3 @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P3 @ ( F2 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_4836_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P3: A > $o,F1: A,F2: nat > A,Nat: nat] :
      ( ( P3 @ ( case_nat @ A @ F1 @ F2 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P3 @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P3 @ ( F2 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_4837_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X22: nat] : X22 ) ) ).

% pred_def
thf(fact_4838_bezw__0,axiom,
    ! [X2: nat] :
      ( ( bezw @ X2 @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_4839_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite2 @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ ( zero_zero @ A ) @ I ) ) @ ( D2 @ I ) )
                @ A3 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite2 @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ ( zero_zero @ A ) @ I ) ) @ ( D2 @ I ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_4840_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_4841_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list @ A] : ( finite_finite2 @ A @ ( set2 @ A @ Xs ) ) ).

% List.finite_set
thf(fact_4842_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [F4: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ F4 )
         => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ F4 )
              = ( zero_zero @ A ) )
            = ( ! [X6: B] :
                  ( ( member @ B @ X6 @ F4 )
                 => ( ( F3 @ X6 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_eq_0_iff
thf(fact_4843_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.infinite
thf(fact_4844_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 )
              = ( zero_zero @ A ) )
            = ( ? [X6: B] :
                  ( ( member @ B @ X6 @ A3 )
                  & ( ( F3 @ X6 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% prod_zero_iff
thf(fact_4845_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite2 @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_4846_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite2 @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_4847_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( zero_zero @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( zero_zero @ A ) )
                  @ S3 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_4848_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( zero_zero @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( zero_zero @ A ) )
                  @ S3 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_4849_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_4850_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_4851_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P3: nat > $o,F3: nat > A] :
          ( ( finite_finite2 @ nat @ ( collect @ nat @ P3 ) )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( P3 @ R5 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite
thf(fact_4852_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A3: set @ nat,F3: nat > A] :
          ( ( finite_finite2 @ nat @ A3 )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A3 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite_set
thf(fact_4853_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_div_numeral
thf(fact_4854_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F3 @ A3 ) )
        = ( ! [X6: A] :
              ( ( member @ A @ X6 @ A3 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X6 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_4855_fst__divmod__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( product_fst @ nat @ nat @ ( divmod_nat @ M @ N ) )
      = ( divide_divide @ nat @ M @ N ) ) ).

% fst_divmod_nat
thf(fact_4856_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_4857_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite2 @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ ( zero_zero @ A ) @ I ) )
                @ A3 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite2 @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ ( zero_zero @ A ) @ I ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_4858_fst__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( product_case_prod @ A @ B @ A
        @ ^ [X1: A,X22: B] : X1 ) ) ).

% fst_def
thf(fact_4859_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
              & ( ( size_size @ ( list @ A ) @ Xs2 )
                = N ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_4860_finite__less__ub,axiom,
    ! [F3: nat > nat,U: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( F3 @ N3 ) )
     => ( finite_finite2 @ nat
        @ ( collect @ nat
          @ ^ [N2: nat] : ( ord_less_eq @ nat @ ( F3 @ N2 ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_4861_sum_Oswap__restrict,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B5: set @ C,G: B > C > A,R3: B > C > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ C @ B5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X6: B] :
                    ( groups7311177749621191930dd_sum @ C @ A @ ( G @ X6 )
                    @ ( collect @ C
                      @ ^ [Y: C] :
                          ( ( member @ C @ Y @ B5 )
                          & ( R3 @ X6 @ Y ) ) ) )
                @ A3 )
              = ( groups7311177749621191930dd_sum @ C @ A
                @ ^ [Y: C] :
                    ( groups7311177749621191930dd_sum @ B @ A
                    @ ^ [X6: B] : ( G @ X6 @ Y )
                    @ ( collect @ B
                      @ ^ [X6: B] :
                          ( ( member @ B @ X6 @ A3 )
                          & ( R3 @ X6 @ Y ) ) ) )
                @ B5 ) ) ) ) ) ).

% sum.swap_restrict
thf(fact_4862_prod_Oswap__restrict,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B5: set @ C,G: B > C > A,R3: B > C > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ C @ B5 )
           => ( ( groups7121269368397514597t_prod @ B @ A
                @ ^ [X6: B] :
                    ( groups7121269368397514597t_prod @ C @ A @ ( G @ X6 )
                    @ ( collect @ C
                      @ ^ [Y: C] :
                          ( ( member @ C @ Y @ B5 )
                          & ( R3 @ X6 @ Y ) ) ) )
                @ A3 )
              = ( groups7121269368397514597t_prod @ C @ A
                @ ^ [Y: C] :
                    ( groups7121269368397514597t_prod @ B @ A
                    @ ^ [X6: B] : ( G @ X6 @ Y )
                    @ ( collect @ B
                      @ ^ [X6: B] :
                          ( ( member @ B @ X6 @ A3 )
                          & ( R3 @ X6 @ Y ) ) ) )
                @ B5 ) ) ) ) ) ).

% prod.swap_restrict
thf(fact_4863_finite__M__bounded__by__nat,axiom,
    ! [P3: nat > $o,I3: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [K2: nat] :
            ( ( P3 @ K2 )
            & ( ord_less @ nat @ K2 @ I3 ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_4864_bounded__nat__set__is__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ! [X7: nat] :
          ( ( member @ nat @ X7 @ N5 )
         => ( ord_less @ nat @ X7 @ N ) )
     => ( finite_finite2 @ nat @ N5 ) ) ).

% bounded_nat_set_is_finite
thf(fact_4865_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite2 @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M4: nat] :
        ! [X6: nat] :
          ( ( member @ nat @ X6 @ N6 )
         => ( ord_less @ nat @ X6 @ M4 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_4866_finite__list,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ? [Xs3: list @ A] :
          ( ( set2 @ A @ Xs3 )
          = A3 ) ) ).

% finite_list
thf(fact_4867_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ? [X: B] :
                ( ( member @ B @ X @ A3 )
                & ( ( F3 @ X )
                  = ( zero_zero @ A ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% prod_zero
thf(fact_4868_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite2 @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_4869_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite2 @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_4870_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4871_summable__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N5: set @ nat,F3: nat > A] :
          ( ( finite_finite2 @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_finite
thf(fact_4872_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite2 @ nat @ N5 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_4873_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite2 @ nat @ N5 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_4874_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,X2: B > A,Y2: B > A] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [I: B] :
                  ( ( member @ B @ I @ I6 )
                  & ( ( X2 @ I )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [I: B] :
                    ( ( member @ B @ I @ I6 )
                    & ( ( Y2 @ I )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [I: B] :
                    ( ( member @ B @ I @ I6 )
                    & ( ( plus_plus @ A @ ( X2 @ I ) @ ( Y2 @ I ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_4875_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,X2: B > A,Y2: B > A] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [I: B] :
                  ( ( member @ B @ I @ I6 )
                  & ( ( X2 @ I )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [I: B] :
                    ( ( member @ B @ I @ I6 )
                    & ( ( Y2 @ I )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [I: B] :
                    ( ( member @ B @ I @ I6 )
                    & ( ( times_times @ A @ ( X2 @ I ) @ ( Y2 @ I ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_4876_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,P3: B > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( collect @ B
                @ ^ [X6: B] :
                    ( ( member @ B @ X6 @ A3 )
                    & ( P3 @ X6 ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X6: B] : ( if @ A @ ( P3 @ X6 ) @ ( G @ X6 ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_filter
thf(fact_4877_set__encode__inf,axiom,
    ! [A3: set @ nat] :
      ( ~ ( finite_finite2 @ nat @ A3 )
     => ( ( nat_set_encode @ A3 )
        = ( zero_zero @ nat ) ) ) ).

% set_encode_inf
thf(fact_4878_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,P3: B > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( collect @ B
                @ ^ [X6: B] :
                    ( ( member @ B @ X6 @ A3 )
                    & ( P3 @ X6 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X6: B] : ( if @ A @ ( P3 @ X6 ) @ ( G @ X6 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_filter
thf(fact_4879_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X6 )
                & ( ord_less_eq @ A @ X6 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4880_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% fst_divmod
thf(fact_4881_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,T3: set @ C,G: C > A,I3: C > B,F3: B > A] :
          ( ( finite_finite2 @ B @ S )
         => ( ( finite_finite2 @ C @ T3 )
           => ( ! [X7: C] :
                  ( ( member @ C @ X7 @ T3 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X7 ) ) )
             => ( ! [X7: B] :
                    ( ( member @ B @ X7 @ S )
                   => ? [Xa3: C] :
                        ( ( member @ C @ Xa3 @ T3 )
                        & ( ( I3 @ Xa3 )
                          = X7 )
                        & ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( G @ Xa3 ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T3 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_4882_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ A3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ X7 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 )
                = ( zero_zero @ A ) )
              = ( ! [X6: B] :
                    ( ( member @ B @ X6 @ A3 )
                   => ( ( F3 @ X6 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_4883_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I5: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: set @ I5,F3: I5 > A,G: I5 > A] :
          ( ( finite_finite2 @ I5 @ A3 )
         => ( ! [X7: I5] :
                ( ( member @ I5 @ X7 @ A3 )
               => ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
           => ( ? [X: I5] :
                  ( ( member @ I5 @ X @ A3 )
                  & ( ord_less @ A @ ( F3 @ X ) @ ( G @ X ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I5 @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ I5 @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_4884_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R3: A > A > $o,S3: set @ B,H: B > A,G: B > A] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X16: A,Y1: A,X24: A,Y23: A] :
                ( ( ( R3 @ X16 @ X24 )
                  & ( R3 @ Y1 @ Y23 ) )
               => ( R3 @ ( plus_plus @ A @ X16 @ Y1 ) @ ( plus_plus @ A @ X24 @ Y23 ) ) )
           => ( ( finite_finite2 @ B @ S3 )
             => ( ! [X7: B] :
                    ( ( member @ B @ X7 @ S3 )
                   => ( R3 @ ( H @ X7 ) @ ( G @ X7 ) ) )
               => ( R3 @ ( groups7311177749621191930dd_sum @ B @ A @ H @ S3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_4885_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R3: A > A > $o,S3: set @ B,H: B > A,G: B > A] :
          ( ( R3 @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X16: A,Y1: A,X24: A,Y23: A] :
                ( ( ( R3 @ X16 @ X24 )
                  & ( R3 @ Y1 @ Y23 ) )
               => ( R3 @ ( times_times @ A @ X16 @ Y1 ) @ ( times_times @ A @ X24 @ Y23 ) ) )
           => ( ( finite_finite2 @ B @ S3 )
             => ( ! [X7: B] :
                    ( ( member @ B @ X7 @ S3 )
                   => ( R3 @ ( H @ X7 ) @ ( G @ X7 ) ) )
               => ( R3 @ ( groups7121269368397514597t_prod @ B @ A @ H @ S3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S3 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_4886_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T6: set @ C,S3: set @ B,I3: C > B,J2: B > C,T5: set @ C,G: B > A,H: C > A] :
          ( ( finite_finite2 @ B @ S5 )
         => ( ( finite_finite2 @ C @ T6 )
           => ( ! [A4: B] :
                  ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) )
                 => ( ( I3 @ ( J2 @ A4 ) )
                    = A4 ) )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) )
                   => ( member @ C @ ( J2 @ A4 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) ) )
               => ( ! [B3: C] :
                      ( ( member @ C @ B3 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                     => ( ( J2 @ ( I3 @ B3 ) )
                        = B3 ) )
                 => ( ! [B3: C] :
                        ( ( member @ C @ B3 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                       => ( member @ B @ ( I3 @ B3 ) @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) ) )
                   => ( ! [A4: B] :
                          ( ( member @ B @ A4 @ S5 )
                         => ( ( G @ A4 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B3: C] :
                            ( ( member @ C @ B3 @ T6 )
                           => ( ( H @ B3 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A4: B] :
                              ( ( member @ B @ A4 @ S3 )
                             => ( ( H @ ( J2 @ A4 ) )
                                = ( G @ A4 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H @ T5 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_4887_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X6: A] :
              ( ( member @ A @ X6 @ A3 )
              & ( ( F3 @ X6 )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y: A] :
                  ( ( member @ A @ Y @ A3 )
                 => ( ( X6 != Y )
                   => ( ( F3 @ Y )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_4888_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 )
          = ( one_one @ nat ) )
        = ( ? [X6: A] :
              ( ( member @ A @ X6 @ A3 )
              & ( ( F3 @ X6 )
                = ( one_one @ nat ) )
              & ! [Y: A] :
                  ( ( member @ A @ Y @ A3 )
                 => ( ( X6 != Y )
                   => ( ( F3 @ Y )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_4889_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F3: B > A,I3: B] :
          ( ( finite_finite2 @ B @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I3 @ S )
               => ( ( F3 @ I3 )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_4890_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F3: B > A,B5: A,I3: B] :
          ( ( finite_finite2 @ B @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S )
                = B5 )
             => ( ( member @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( F3 @ I3 ) @ B5 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_4891_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X6: B] :
                      ( ( G @ X6 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_4892_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X6: B] :
                      ( ( G @ X6 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_4893_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite2 @ nat
        @ ( collect @ nat
          @ ^ [D5: nat] : ( dvd_dvd @ nat @ D5 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_4894_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A3: set @ nat,F3: nat > A] :
          ( ( finite_finite2 @ nat @ A3 )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A3 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ A3 ) ) ) ) ).

% sums_If_finite_set
thf(fact_4895_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P3: nat > $o,F3: nat > A] :
          ( ( finite_finite2 @ nat @ ( collect @ nat @ P3 ) )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( P3 @ R5 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( collect @ nat @ P3 ) ) ) ) ) ).

% sums_If_finite
thf(fact_4896_sums__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N5: set @ nat,F3: nat > A] :
          ( ( finite_finite2 @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( sums @ A @ F3 @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ N5 ) ) ) ) ) ).

% sums_finite
thf(fact_4897_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [N5: set @ nat,F3: nat > A] :
          ( ( finite_finite2 @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A @ F3 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ N5 ) ) ) ) ) ).

% suminf_finite
thf(fact_4898_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [K2: A] :
                ( ( member @ A @ K2 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K2 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4899_exp__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comm_monoid_mult @ B )
        & ( real_Vector_banach @ B )
        & ( real_V2822296259951069270ebra_1 @ B ) )
     => ! [I6: set @ A,F3: A > B] :
          ( ( finite_finite2 @ A @ I6 )
         => ( ( exp @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ I6 ) )
            = ( groups7121269368397514597t_prod @ A @ B
              @ ^ [X6: A] : ( exp @ B @ ( F3 @ X6 ) )
              @ I6 ) ) ) ) ).

% exp_sum
thf(fact_4900_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,I3: B,F3: B > A] :
          ( ( finite_finite2 @ B @ I6 )
         => ( ( member @ B @ I3 @ I6 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I3 ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ I6 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ I6 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_4901_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,I3: A,F3: A > B] :
          ( ( finite_finite2 @ A @ I6 )
         => ( ( member @ A @ I3 @ I6 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F3 @ I3 ) )
             => ( ! [I2: A] :
                    ( ( member @ A @ I2 @ I6 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F3 @ I2 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ I6 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_4902_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A3: set @ B,B5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite2 @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B5 @ C6 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A4 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B3: B] :
                      ( ( member @ B @ B3 @ ( minus_minus @ ( set @ B ) @ C6 @ B5 ) )
                     => ( ( H @ B3 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ B5 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ C6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_4903_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A3: set @ B,B5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite2 @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B5 @ C6 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A4 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B3: B] :
                      ( ( member @ B @ B3 @ ( minus_minus @ ( set @ B ) @ C6 @ B5 ) )
                     => ( ( H @ B3 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ C6 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ B5 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_4904_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T5 )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
                 => ( ( G @ X7 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_4905_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T5 )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
                 => ( ( G @ X7 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_4906_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S3: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T5 )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
                 => ( ( H @ X7 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X7: B] :
                    ( ( member @ B @ X7 @ S3 )
                   => ( ( G @ X7 )
                      = ( H @ X7 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H @ T5 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_4907_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S3: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite2 @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T5 )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
                 => ( ( G @ X7 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X7: B] :
                    ( ( member @ B @ X7 @ S3 )
                   => ( ( G @ X7 )
                      = ( H @ X7 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H @ S3 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_4908_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B5: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B5 @ A3 )
         => ( ( finite_finite2 @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B5 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_4909_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B5: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B5 @ A3 )
         => ( ( finite_finite2 @ B @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B5 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_4910_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [Z6: A] :
                  ( ( power_power @ A @ Z6 @ N )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_4911_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T6: set @ C,H: B > C,S3: set @ B,T5: set @ C,G: C > A] :
          ( ( finite_finite2 @ B @ S5 )
         => ( ( finite_finite2 @ C @ T6 )
           => ( ( bij_betw @ B @ C @ H @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ S5 )
                   => ( ( G @ ( H @ A4 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B3: C] :
                      ( ( member @ C @ B3 @ T6 )
                     => ( ( G @ B3 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X6: B] : ( G @ ( H @ X6 ) )
                      @ S3 )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T5 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_4912_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > A,S3: A,A3: set @ nat,S5: A,F3: nat > A] :
          ( ( sums @ A @ G @ S3 )
         => ( ( finite_finite2 @ nat @ A3 )
           => ( ( S5
                = ( plus_plus @ A @ S3
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) )
                    @ A3 ) ) )
             => ( sums @ A
                @ ^ [N2: nat] : ( if @ A @ ( member @ nat @ N2 @ A3 ) @ ( F3 @ N2 ) @ ( G @ N2 ) )
                @ S5 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_4913_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S5: set @ B,T6: set @ C,H: B > C,S3: set @ B,T5: set @ C,G: C > A] :
          ( ( finite_finite2 @ B @ S5 )
         => ( ( finite_finite2 @ C @ T6 )
           => ( ( bij_betw @ B @ C @ H @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ S5 )
                   => ( ( G @ ( H @ A4 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B3: C] :
                      ( ( member @ C @ B3 @ T6 )
                     => ( ( G @ B3 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X6: B] : ( G @ ( H @ X6 ) )
                      @ S3 )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T5 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_4914_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B5: set @ B,A3: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ B5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B5 )
           => ( ! [B3: B] :
                  ( ( member @ B @ B3 @ ( minus_minus @ ( set @ B ) @ B5 @ A3 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ B3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ B5 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_4915_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) )
            = ( ? [X6: B] :
                  ( ( member @ B @ X6 @ A3 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F3 @ X6 ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_4916_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,I6: set @ nat] :
          ( ( summable @ A @ F3 )
         => ( ( finite_finite2 @ nat @ I6 )
           => ( ! [N3: nat] :
                  ( ( member @ nat @ N3 @ ( uminus_uminus @ ( set @ nat ) @ I6 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ I6 ) @ ( suminf @ A @ F3 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_4917_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B5: set @ A,A3: set @ A,B2: A,F3: A > B] :
          ( ( finite_finite2 @ A @ B5 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B5 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B5 @ A3 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F3 @ B2 ) )
               => ( ! [X7: A] :
                      ( ( member @ A @ X7 @ B5 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F3 @ X7 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ B5 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_4918_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B5: set @ A,A3: set @ A,F3: A > B] :
          ( ( finite_finite2 @ A @ B5 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B5 )
           => ( ! [B3: A] :
                  ( ( member @ A @ B3 @ ( minus_minus @ ( set @ A ) @ B5 @ A3 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F3 @ B3 ) ) )
             => ( ! [A4: A] :
                    ( ( member @ A @ A4 @ A3 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F3 @ A4 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ B5 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_4919_ln__prod,axiom,
    ! [A: $tType,I6: set @ A,F3: A > real] :
      ( ( finite_finite2 @ A @ I6 )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ I2 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F3 @ I6 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X6: A] : ( ln_ln @ real @ ( F3 @ X6 ) )
            @ I6 ) ) ) ) ).

% ln_prod
thf(fact_4920_even__set__encode__iff,axiom,
    ! [A3: set @ nat] :
      ( ( finite_finite2 @ nat @ A3 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A3 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4921_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z6 @ I ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_4922_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X6: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ X6 @ I ) )
                    @ ( set_ord_atMost @ nat @ N ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I: nat] :
                ( ( ord_less_eq @ nat @ I @ N )
                & ( ( C2 @ I )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_4923_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4924_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less @ nat @ N2 @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_4925_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A3 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_4926_finite__Collect__conjI,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o] :
      ( ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
        | ( finite_finite2 @ A @ ( collect @ A @ Q ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X6: A] :
              ( ( P3 @ X6 )
              & ( Q @ X6 ) ) ) ) ) ).

% finite_Collect_conjI
thf(fact_4927_finite__Collect__disjI,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X6: A] :
              ( ( P3 @ X6 )
              | ( Q @ X6 ) ) ) )
      = ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
        & ( finite_finite2 @ A @ ( collect @ A @ Q ) ) ) ) ).

% finite_Collect_disjI
thf(fact_4928_finite__interval__int1,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite2 @ int
      @ ( collect @ int
        @ ^ [I: int] :
            ( ( ord_less_eq @ int @ A2 @ I )
            & ( ord_less_eq @ int @ I @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_4929_finite__interval__int4,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite2 @ int
      @ ( collect @ int
        @ ^ [I: int] :
            ( ( ord_less @ int @ A2 @ I )
            & ( ord_less @ int @ I @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_4930_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite2 @ int
      @ ( collect @ int
        @ ^ [I: int] :
            ( ( ord_less_eq @ int @ A2 @ I )
            & ( ord_less @ int @ I @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_4931_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite2 @ int
      @ ( collect @ int
        @ ^ [I: int] :
            ( ( ord_less @ int @ A2 @ I )
            & ( ord_less_eq @ int @ I @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_4932_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( finite_finite2 @ complex
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_4933_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_finite2 @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) ) ).

% finite_atLeastZeroLessThan_int
thf(fact_4934_uminus__set__def,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( ^ [A7: set @ A] :
            ( collect @ A
            @ ( uminus_uminus @ ( A > $o )
              @ ^ [X6: A] : ( member @ A @ X6 @ A7 ) ) ) ) ) ).

% uminus_set_def
thf(fact_4935_Collect__neg__eq,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( collect @ A
        @ ^ [X6: A] :
            ~ ( P3 @ X6 ) )
      = ( uminus_uminus @ ( set @ A ) @ ( collect @ A @ P3 ) ) ) ).

% Collect_neg_eq
thf(fact_4936_Compl__eq,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( ^ [A7: set @ A] :
            ( collect @ A
            @ ^ [X6: A] :
                ~ ( member @ A @ X6 @ A7 ) ) ) ) ).

% Compl_eq
thf(fact_4937_finite__maxlen,axiom,
    ! [A: $tType,M7: set @ ( list @ A )] :
      ( ( finite_finite2 @ ( list @ A ) @ M7 )
     => ? [N3: nat] :
        ! [X: list @ A] :
          ( ( member @ ( list @ A ) @ X @ M7 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ N3 ) ) ) ).

% finite_maxlen
thf(fact_4938_finite__enat__bounded,axiom,
    ! [A3: set @ extended_enat,N: nat] :
      ( ! [Y5: extended_enat] :
          ( ( member @ extended_enat @ Y5 @ A3 )
         => ( ord_less_eq @ extended_enat @ Y5 @ ( extended_enat2 @ N ) ) )
     => ( finite_finite2 @ extended_enat @ A3 ) ) ).

% finite_enat_bounded
thf(fact_4939_finite__divisors__int,axiom,
    ! [I3: int] :
      ( ( I3
       != ( zero_zero @ int ) )
     => ( finite_finite2 @ int
        @ ( collect @ int
          @ ^ [D5: int] : ( dvd_dvd @ int @ D5 @ I3 ) ) ) ) ).

% finite_divisors_int
thf(fact_4940_not__finite__existsD,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ~ ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
     => ? [X_12: A] : ( P3 @ X_12 ) ) ).

% not_finite_existsD
thf(fact_4941_pigeonhole__infinite__rel,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B5: set @ B,R3: A > B > $o] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ B5 )
       => ( ! [X7: A] :
              ( ( member @ A @ X7 @ A3 )
             => ? [Xa3: B] :
                  ( ( member @ B @ Xa3 @ B5 )
                  & ( R3 @ X7 @ Xa3 ) ) )
         => ? [X7: B] :
              ( ( member @ B @ X7 @ B5 )
              & ~ ( finite_finite2 @ A
                  @ ( collect @ A
                    @ ^ [A5: A] :
                        ( ( member @ A @ A5 @ A3 )
                        & ( R3 @ A5 @ X7 ) ) ) ) ) ) ) ) ).

% pigeonhole_infinite_rel
thf(fact_4942_finite__psubset__induct,axiom,
    ! [A: $tType,A3: set @ A,P3: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [A8: set @ A] :
            ( ( finite_finite2 @ A @ A8 )
           => ( ! [B10: set @ A] :
                  ( ( ord_less @ ( set @ A ) @ B10 @ A8 )
                 => ( P3 @ B10 ) )
             => ( P3 @ A8 ) ) )
       => ( P3 @ A3 ) ) ) ).

% finite_psubset_induct
thf(fact_4943_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X6: nat,Y: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X6 @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X6 @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X6 @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X6 @ Y ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_4944_bezw_Oelims,axiom,
    ! [X2: nat,Xa: nat,Y2: product_prod @ int @ int] :
      ( ( ( bezw @ X2 @ Xa )
        = Y2 )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y2
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y2
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_4945_sum__count__set,axiom,
    ! [A: $tType,Xs: list @ A,X15: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X15 )
     => ( ( finite_finite2 @ A @ X15 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs ) @ X15 )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% sum_count_set
thf(fact_4946_count__notin,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X2 )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_4947_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_mod_numeral
thf(fact_4948_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_4949_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs )
        = ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) )
     => ( ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs )
          = ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Ys ) )
       => ( Xs = Ys ) ) ) ).

% pair_list_eqI
thf(fact_4950_snd__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_snd @ A @ B )
      = ( product_case_prod @ A @ B @ B
        @ ^ [X1: A,X22: B] : X22 ) ) ).

% snd_def
thf(fact_4951_split__comp__eq,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,F3: A > B > C,G: D > A] :
      ( ( ^ [U2: product_prod @ D @ B] : ( F3 @ ( G @ ( product_fst @ D @ B @ U2 ) ) @ ( product_snd @ D @ B @ U2 ) ) )
      = ( product_case_prod @ D @ B @ C
        @ ^ [X6: D] : ( F3 @ ( G @ X6 ) ) ) ) ).

% split_comp_eq
thf(fact_4952_case__prod__beta_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [F5: A > B > C,X6: product_prod @ A @ B] : ( F5 @ ( product_fst @ A @ B @ X6 ) @ ( product_snd @ A @ B @ X6 ) ) ) ) ).

% case_prod_beta'
thf(fact_4953_case__prod__unfold,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [C4: A > B > C,P4: product_prod @ A @ B] : ( C4 @ ( product_fst @ A @ B @ P4 ) @ ( product_snd @ A @ B @ P4 ) ) ) ) ).

% case_prod_unfold
thf(fact_4954_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_4955_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% snd_divmod
thf(fact_4956_quotient__of__denom__pos_H,axiom,
    ! [R: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R ) ) ) ).

% quotient_of_denom_pos'
thf(fact_4957_Eps__case__prod,axiom,
    ! [B: $tType,A: $tType,P3: A > B > $o] :
      ( ( fChoice @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P3 ) )
      = ( fChoice @ ( product_prod @ A @ B )
        @ ^ [Xy: product_prod @ A @ B] : ( P3 @ ( product_fst @ A @ B @ Xy ) @ ( product_snd @ A @ B @ Xy ) ) ) ) ).

% Eps_case_prod
thf(fact_4958_The__case__prod,axiom,
    ! [B: $tType,A: $tType,P3: A > B > $o] :
      ( ( the @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P3 ) )
      = ( the @ ( product_prod @ A @ B )
        @ ^ [Xy: product_prod @ A @ B] : ( P3 @ ( product_fst @ A @ B @ Xy ) @ ( product_snd @ A @ B @ Xy ) ) ) ) ).

% The_case_prod
thf(fact_4959_count__le__length,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs @ X2 ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% count_le_length
thf(fact_4960_bezw__non__0,axiom,
    ! [Y2: nat,X2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y2 )
     => ( ( bezw @ X2 @ Y2 )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Y2 ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_4961_one__mod__minus__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_4962_minus__one__mod__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_4963_minus__numeral__mod__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_mod_numeral
thf(fact_4964_snd__divmod__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( product_snd @ nat @ nat @ ( divmod_nat @ M @ N ) )
      = ( modulo_modulo @ nat @ M @ N ) ) ).

% snd_divmod_nat
thf(fact_4965_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_4966_numeral__mod__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ) ).

% numeral_mod_minus_numeral
thf(fact_4967_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L3: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L3 @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_4968_exE__realizer,axiom,
    ! [C: $tType,A: $tType,B: $tType,P3: A > B > $o,P5: product_prod @ B @ A,Q: C > $o,F3: B > A > C] :
      ( ( P3 @ ( product_snd @ B @ A @ P5 ) @ ( product_fst @ B @ A @ P5 ) )
     => ( ! [X7: B,Y5: A] :
            ( ( P3 @ Y5 @ X7 )
           => ( Q @ ( F3 @ X7 @ Y5 ) ) )
       => ( Q @ ( product_case_prod @ B @ A @ C @ F3 @ P5 ) ) ) ) ).

% exE_realizer
thf(fact_4969_infinite__int__iff__unbounded,axiom,
    ! [S3: set @ int] :
      ( ( ~ ( finite_finite2 @ int @ S3 ) )
      = ( ! [M4: int] :
          ? [N2: int] :
            ( ( ord_less @ int @ M4 @ ( abs_abs @ int @ N2 ) )
            & ( member @ int @ N2 @ S3 ) ) ) ) ).

% infinite_int_iff_unbounded
thf(fact_4970_bezw_Opelims,axiom,
    ! [X2: nat,Xa: nat,Y2: product_prod @ int @ int] :
      ( ( ( bezw @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y2
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y2
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_4971_infinite__nat__iff__unbounded,axiom,
    ! [S3: set @ nat] :
      ( ( ~ ( finite_finite2 @ nat @ S3 ) )
      = ( ! [M4: nat] :
          ? [N2: nat] :
            ( ( ord_less @ nat @ M4 @ N2 )
            & ( member @ nat @ N2 @ S3 ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_4972_unbounded__k__infinite,axiom,
    ! [K: nat,S3: set @ nat] :
      ( ! [M5: nat] :
          ( ( ord_less @ nat @ K @ M5 )
         => ? [N9: nat] :
              ( ( ord_less @ nat @ M5 @ N9 )
              & ( member @ nat @ N9 @ S3 ) ) )
     => ~ ( finite_finite2 @ nat @ S3 ) ) ).

% unbounded_k_infinite
thf(fact_4973_prod__decode__aux_Opelims,axiom,
    ! [X2: nat,Xa: nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa @ X2 )
               => ( Y2
                  = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X2 @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa @ X2 )
               => ( Y2
                  = ( nat_prod_decode_aux @ ( suc @ X2 ) @ ( minus_minus @ nat @ Xa @ ( suc @ X2 ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_4974_in__set__enumerate__eq,axiom,
    ! [A: $tType,P5: product_prod @ nat @ A,N: nat,Xs: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P5 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) )
      = ( ( ord_less_eq @ nat @ N @ ( product_fst @ nat @ A @ P5 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P5 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
        & ( ( nth @ A @ Xs @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P5 ) @ N ) )
          = ( product_snd @ nat @ A @ P5 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_4975_normalize__def,axiom,
    ( normalize
    = ( ^ [P4: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P4 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P4 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P4 ) @ ( product_snd @ int @ int @ P4 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P4 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P4 ) @ ( product_snd @ int @ int @ P4 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P4 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P4 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P4 ) @ ( product_snd @ int @ int @ P4 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P4 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P4 ) @ ( product_snd @ int @ int @ P4 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_4976_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% gcd_eq_0_iff
thf(fact_4977_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M @ N ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add1
thf(fact_4978_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ M @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add2
thf(fact_4979_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N ) ) ) ).

% gcd_exp
thf(fact_4980_length__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_enumerate
thf(fact_4981_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_4982_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_4983_map__snd__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ A @ ( product_snd @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) )
      = Xs ) ).

% map_snd_enumerate
thf(fact_4984_gcd__pos__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_4985_gcd__neg__numeral__1__int,axiom,
    ! [N: num,X2: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ X2 )
      = ( gcd_gcd @ int @ ( numeral_numeral @ int @ N ) @ X2 ) ) ).

% gcd_neg_numeral_1_int
thf(fact_4986_gcd__neg__numeral__2__int,axiom,
    ! [X2: int,N: num] :
      ( ( gcd_gcd @ int @ X2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( gcd_gcd @ int @ X2 @ ( numeral_numeral @ int @ N ) ) ) ).

% gcd_neg_numeral_2_int
thf(fact_4987_gcd__0__left__int,axiom,
    ! [X2: int] :
      ( ( gcd_gcd @ int @ ( zero_zero @ int ) @ X2 )
      = ( abs_abs @ int @ X2 ) ) ).

% gcd_0_left_int
thf(fact_4988_gcd__0__int,axiom,
    ! [X2: int] :
      ( ( gcd_gcd @ int @ X2 @ ( zero_zero @ int ) )
      = ( abs_abs @ int @ X2 ) ) ).

% gcd_0_int
thf(fact_4989_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) )
      = ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% map_fst_enumerate
thf(fact_4990_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,K: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ ( times_times @ A @ K @ M ) @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add_mult
thf(fact_4991_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_4992_gcd__ge__0__int,axiom,
    ! [X2: int,Y2: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ).

% gcd_ge_0_int
thf(fact_4993_bezout__int,axiom,
    ! [X2: int,Y2: int] :
    ? [U3: int,V3: int] :
      ( ( plus_plus @ int @ ( times_times @ int @ U3 @ X2 ) @ ( times_times @ int @ V3 @ Y2 ) )
      = ( gcd_gcd @ int @ X2 @ Y2 ) ) ).

% bezout_int
thf(fact_4994_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N: int] :
      ( ( times_times @ int @ ( abs_abs @ int @ K ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( gcd_gcd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) ) ) ).

% gcd_mult_distrib_int
thf(fact_4995_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_4996_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_4997_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_4998_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_4999_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_5000_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_5001_gcd__cases__int,axiom,
    ! [X2: int,Y2: int,P3: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
         => ( P3 @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
         => ( ( ord_less_eq @ int @ Y2 @ ( zero_zero @ int ) )
           => ( P3 @ ( gcd_gcd @ int @ X2 @ ( uminus_uminus @ int @ Y2 ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X2 @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
             => ( P3 @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X2 ) @ Y2 ) ) ) )
         => ( ( ( ord_less_eq @ int @ X2 @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y2 @ ( zero_zero @ int ) )
               => ( P3 @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X2 ) @ ( uminus_uminus @ int @ Y2 ) ) ) ) )
           => ( P3 @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_5002_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ D2 @ A2 )
        & ( dvd_dvd @ int @ D2 @ B2 )
        & ! [E3: int] :
            ( ( ( dvd_dvd @ int @ E3 @ A2 )
              & ( dvd_dvd @ int @ E3 @ B2 ) )
           => ( dvd_dvd @ int @ E3 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ int @ A2 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_5003_gcd__non__0__int,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( gcd_gcd @ int @ X2 @ Y2 )
        = ( gcd_gcd @ int @ Y2 @ ( modulo_modulo @ int @ X2 @ Y2 ) ) ) ) ).

% gcd_non_0_int
thf(fact_5004_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K2: int,L3: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L3
              = ( zero_zero @ int ) )
            @ K2
            @ ( gcd_gcd @ int @ L3 @ ( modulo_modulo @ int @ ( abs_abs @ int @ K2 ) @ ( abs_abs @ int @ L3 ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_5005_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F3: nat > A,M: nat] :
      ( ( enumerate @ A @ N @ ( map @ nat @ A @ F3 @ ( upt @ N @ M ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K2: nat] : ( product_Pair @ nat @ A @ K2 @ ( F3 @ K2 ) )
        @ ( upt @ N @ M ) ) ) ).

% enumerate_map_upt
thf(fact_5006_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M: nat,A2: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A2 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_5007_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M ) @ ( nth @ A @ Xs @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_5008_set__encode__insert,axiom,
    ! [A3: set @ nat,N: nat] :
      ( ( finite_finite2 @ nat @ A3 )
     => ( ~ ( member @ nat @ N @ A3 )
       => ( ( nat_set_encode @ ( insert @ nat @ N @ A3 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( nat_set_encode @ A3 ) ) ) ) ) ).

% set_encode_insert
thf(fact_5009_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list @ A,X15: set @ A,F3: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X15 )
     => ( ( finite_finite2 @ A @ X15 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F3 @ Xs ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X6: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X6 ) @ ( F3 @ X6 ) )
            @ X15 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_5010_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A5: B] :
                      ( ( member @ B @ A5 @ A3 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F3 @ A5 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_5011_gcd__0__left__nat,axiom,
    ! [X2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ X2 )
      = X2 ) ).

% gcd_0_left_nat
thf(fact_5012_gcd__0__nat,axiom,
    ! [X2: nat] :
      ( ( gcd_gcd @ nat @ X2 @ ( zero_zero @ nat ) )
      = X2 ) ).

% gcd_0_nat
thf(fact_5013_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% gcd_nat.right_neutral
thf(fact_5014_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( gcd_gcd @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.neutr_eq_iff
thf(fact_5015_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% gcd_nat.left_neutral
thf(fact_5016_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( gcd_gcd @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.eq_neutr_iff
thf(fact_5017_card__Collect__less__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I: nat] : ( ord_less @ nat @ I @ N ) ) )
      = N ) ).

% card_Collect_less_nat
thf(fact_5018_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_5019_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_5020_card__atMost,axiom,
    ! [U: nat] :
      ( ( finite_card @ nat @ ( set_ord_atMost @ nat @ U ) )
      = ( suc @ U ) ) ).

% card_atMost
thf(fact_5021_card__Collect__le__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I: nat] : ( ord_less_eq @ nat @ I @ N ) ) )
      = ( suc @ N ) ) ).

% card_Collect_le_nat
thf(fact_5022_card_Oinfinite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) ) ) ).

% card.infinite
thf(fact_5023_card__atLeastAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or1337092689740270186AtMost @ nat @ L @ U ) )
      = ( minus_minus @ nat @ ( suc @ U ) @ L ) ) ).

% card_atLeastAtMost
thf(fact_5024_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X6: A] :
                ( ( member @ A @ X6 @ ( set2 @ A @ Ns ) )
               => ( X6
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_5025_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y2: A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X6: B] : Y2
            @ A3 )
          = ( power_power @ A @ Y2 @ ( finite_card @ B @ A3 ) ) ) ) ).

% prod_constant
thf(fact_5026_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X6: B] : ( zero_zero @ A )
              @ Xs ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_5027_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ~ ( member @ B @ X2 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
              = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum.insert
thf(fact_5028_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ~ ( member @ B @ X2 @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
              = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod.insert
thf(fact_5029_card__insert__disjoint,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ~ ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
          = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_insert_disjoint
thf(fact_5030_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y2: A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X6: B] : Y2
            @ A3 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ Y2 ) ) ) ).

% sum_constant
thf(fact_5031_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X6: nat] : X6
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum_list_upt
thf(fact_5032_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M @ N ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_5033_insert__compr,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A5: A,B8: set @ A] :
            ( collect @ A
            @ ^ [X6: A] :
                ( ( X6 = A5 )
                | ( member @ A @ X6 @ B8 ) ) ) ) ) ).

% insert_compr
thf(fact_5034_insert__Collect,axiom,
    ! [A: $tType,A2: A,P3: A > $o] :
      ( ( insert @ A @ A2 @ ( collect @ A @ P3 ) )
      = ( collect @ A
        @ ^ [U2: A] :
            ( ( U2 != A2 )
           => ( P3 @ U2 ) ) ) ) ).

% insert_Collect
thf(fact_5035_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A3: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( finite_card @ A @ A3 ) )
      = ( ? [A5: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ A5 @ B8 ) )
            & ~ ( member @ A @ A5 @ B8 )
            & ( ord_less_eq @ nat @ N @ ( finite_card @ A @ B8 ) )
            & ( finite_finite2 @ A @ B8 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_5036_card__Suc__eq__finite,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B4: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ B4 @ B8 ) )
            & ~ ( member @ A @ B4 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( finite_finite2 @ A @ B8 ) ) ) ) ).

% card_Suc_eq_finite
thf(fact_5037_card__insert__if,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ( member @ A @ X2 @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( finite_card @ A @ A3 ) ) )
        & ( ~ ( member @ A @ X2 @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_insert_if
thf(fact_5038_n__subsets,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B8: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B8 @ A3 )
                & ( ( finite_card @ A @ B8 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A3 ) @ K ) ) ) ).

% n_subsets
thf(fact_5039_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_5040_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_5041_gcd__non__0__nat,axiom,
    ! [Y2: nat,X2: nat] :
      ( ( Y2
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X2 @ Y2 )
        = ( gcd_gcd @ nat @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) ) ).

% gcd_non_0_nat
thf(fact_5042_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X6: nat,Y: nat] :
          ( if @ nat
          @ ( Y
            = ( zero_zero @ nat ) )
          @ X6
          @ ( gcd_gcd @ nat @ Y @ ( modulo_modulo @ nat @ X6 @ Y ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_5043_gcd__nat_Oelims,axiom,
    ! [X2: nat,Xa: nat,Y2: nat] :
      ( ( ( gcd_gcd @ nat @ X2 @ Xa )
        = Y2 )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y2 = X2 ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y2
            = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_5044_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Xs: list @ A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ A @ X2 @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% member_le_sum_list
thf(fact_5045_lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( insert @ nat @ K @ ( set_ord_lessThan @ nat @ K ) ) ) ).

% lessThan_Suc
thf(fact_5046_atMost__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ K ) )
      = ( insert @ nat @ ( suc @ K ) @ ( set_ord_atMost @ nat @ K ) ) ) ).

% atMost_Suc
thf(fact_5047_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_5048_gcd__code__integer,axiom,
    ( ( gcd_gcd @ code_integer )
    = ( ^ [K2: code_integer,L3: code_integer] :
          ( abs_abs @ code_integer
          @ ( if @ code_integer
            @ ( L3
              = ( zero_zero @ code_integer ) )
            @ K2
            @ ( gcd_gcd @ code_integer @ L3 @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K2 ) @ ( abs_abs @ code_integer @ L3 ) ) ) ) ) ) ) ).

% gcd_code_integer
thf(fact_5049_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y2: set @ A,X2: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y2 ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert @ A @ X2 @ Y2 ) ) @ N ) ) ) ).

% card_insert_le_m1
thf(fact_5050_sum__multicount__gen,axiom,
    ! [A: $tType,B: $tType,S: set @ A,T3: set @ B,R3: A > B > $o,K: B > nat] :
      ( ( finite_finite2 @ A @ S )
     => ( ( finite_finite2 @ B @ T3 )
       => ( ! [X7: B] :
              ( ( member @ B @ X7 @ T3 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I: A] :
                        ( ( member @ A @ I @ S )
                        & ( R3 @ I @ X7 ) ) ) )
                = ( K @ X7 ) ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J4: B] :
                        ( ( member @ B @ J4 @ T3 )
                        & ( R3 @ I @ J4 ) ) ) )
              @ S )
            = ( groups7311177749621191930dd_sum @ B @ nat @ K @ T3 ) ) ) ) ) ).

% sum_multicount_gen
thf(fact_5051_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs2 )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A3 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_5052_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F3: B > A,C2: A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X6: B] : ( times_times @ A @ ( F3 @ X6 ) @ C2 )
              @ Xs ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_5053_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F3: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X6: B] : ( times_times @ A @ C2 @ ( F3 @ X6 ) )
              @ Xs ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_5054_card__eq__sum,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X6: A] : ( one_one @ nat ) ) ) ).

% card_eq_sum
thf(fact_5055_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: B > A,G: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X6: B] : ( plus_plus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ Xs ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum_list_addf
thf(fact_5056_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: B > A,G: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X6: B] : ( minus_minus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ Xs ) )
          = ( minus_minus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum_list_subtractf
thf(fact_5057_card__length__sum__list__rec,axiom,
    ! [M: nat,N5: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L3: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L3 )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L3 )
                  = N5 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L3: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L3 )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L3 )
                    = N5 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L3: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L3 )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L3 ) @ ( one_one @ nat ) )
                    = N5 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_5058_card__length__sum__list,axiom,
    ! [M: nat,N5: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L3: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L3 )
                = M )
              & ( ( groups8242544230860333062m_list @ nat @ L3 )
                = N5 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N5 @ M ) @ ( one_one @ nat ) ) @ N5 ) ) ).

% card_length_sum_list
thf(fact_5059_card__2__iff_H,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X6: A] :
            ( ( member @ A @ X6 @ S3 )
            & ? [Y: A] :
                ( ( member @ A @ Y @ S3 )
                & ( X6 != Y )
                & ! [Z6: A] :
                    ( ( member @ A @ Z6 @ S3 )
                   => ( ( Z6 = X6 )
                      | ( Z6 = Y ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_5060_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
     => ( finite_finite2 @ A @ A3 ) ) ).

% card_ge_0_finite
thf(fact_5061_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X7: nat,Y5: nat] :
          ( ( times_times @ nat @ A2 @ X7 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y5 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_5062_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X7: nat,Y5: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y5 ) @ ( times_times @ nat @ A2 @ X7 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X7 ) @ ( times_times @ nat @ B2 @ Y5 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y5 ) @ ( times_times @ nat @ B2 @ X7 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X7 ) @ ( times_times @ nat @ A2 @ Y5 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_5063_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ B5 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B5 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B5 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B5 @ A3 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_5064_card__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% card_length
thf(fact_5065_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite2 @ A @ M7 )
     => ? [H3: A > nat] : ( bij_betw @ A @ nat @ H3 @ M7 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) ) ) ).

% ex_bij_betw_finite_nat
thf(fact_5066_psubset__card__mono,axiom,
    ! [A: $tType,B5: set @ A,A3: set @ A] :
      ( ( finite_finite2 @ A @ B5 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
       => ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B5 ) ) ) ) ).

% psubset_card_mono
thf(fact_5067_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( ( member @ B @ X2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_5068_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( ( member @ B @ X2 @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X2 @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_5069_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X7 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_5070_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X7 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs )
              = ( zero_zero @ A ) )
            = ( ! [X6: A] :
                  ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
                 => ( X6
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_5071_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X7 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_5072_atLeast0__atMost__Suc,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_5073_atLeast0__lessThan__Suc,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_5074_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N )
        = ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_5075_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) )
        = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_5076_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ).

% atLeastAtMost_insertL
thf(fact_5077_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs ) ) ) ) ).

% sum_list_abs
thf(fact_5078_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_5079_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_5080_card__less__Suc2,axiom,
    ! [M7: set @ nat,I3: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ ( suc @ K2 ) @ M7 )
                & ( ord_less @ nat @ K2 @ I3 ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_5081_card__less__Suc,axiom,
    ! [M7: set @ nat,I3: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K2: nat] :
                  ( ( member @ nat @ ( suc @ K2 ) @ M7 )
                  & ( ord_less @ nat @ K2 @ I3 ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_5082_card__less,axiom,
    ! [M7: set @ nat,I3: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I3 ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_5083_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_5084_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) )
      = ( nat2 @ U ) ) ).

% card_atLeastZeroLessThan_int
thf(fact_5085_sum__constant__scaleR,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Y2: A,A3: set @ C] :
          ( ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [X6: C] : Y2
            @ A3 )
          = ( real_V8093663219630862766scaleR @ A @ ( semiring_1_of_nat @ real @ ( finite_card @ C @ A3 ) ) @ Y2 ) ) ) ).

% sum_constant_scaleR
thf(fact_5086_sum__Suc,axiom,
    ! [A: $tType,F3: A > nat,A3: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X6: A] : ( suc @ ( F3 @ X6 ) )
        @ A3 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( finite_card @ A @ A3 ) ) ) ).

% sum_Suc
thf(fact_5087_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S3: set @ A,T5: set @ B,R3: A > B > $o,K: nat] :
      ( ( finite_finite2 @ A @ S3 )
     => ( ( finite_finite2 @ B @ T5 )
       => ( ! [X7: B] :
              ( ( member @ B @ X7 @ T5 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I: A] :
                        ( ( member @ A @ I @ S3 )
                        & ( R3 @ I @ X7 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J4: B] :
                        ( ( member @ B @ J4 @ T5 )
                        & ( R3 @ I @ J4 ) ) ) )
              @ S3 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T5 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_5088_subset__card__intvl__is__intvl,axiom,
    ! [A3: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) )
     => ( A3
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_5089_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs: list @ A,F3: A > B,G: A > B] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F3 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ).

% sum_list_mono
thf(fact_5090_real__of__card,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A3 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X6: A] : ( one_one @ real )
        @ A3 ) ) ).

% real_of_card
thf(fact_5091_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F3: B > A,K5: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_5092_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,K5: A,F3: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ K5 @ ( F3 @ I2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) ) ) ) ).

% sum_bounded_below
thf(fact_5093_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X6: A] :
              ( ( member @ A @ X6 @ A3 )
             => ! [Y: A] :
                  ( ( member @ A @ Y @ A3 )
                 => ( X6 = Y ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_5094_card__psubset,axiom,
    ! [A: $tType,B5: set @ A,A3: set @ A] :
      ( ( finite_finite2 @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B5 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B5 ) )
         => ( ord_less @ ( set @ A ) @ A3 @ B5 ) ) ) ) ).

% card_psubset
thf(fact_5095_card__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A3 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_5096_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite2 @ A @ M7 )
     => ? [H3: nat > A] : ( bij_betw @ nat @ A @ H3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite
thf(fact_5097_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_5098_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( power_power @ A @ Z6 @ N )
                    = ( one_one @ A ) ) ) )
            @ N ) ) ) ).

% card_roots_unity
thf(fact_5099_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N5 ) @ N ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_5100_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F5: B > nat,Xs2: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F5 @ Xs2 ) ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_5101_card__sum__le__nat__sum,axiom,
    ! [S3: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X6: nat] : X6
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S3 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X6: nat] : X6
        @ S3 ) ) ).

% card_sum_le_nat_sum
thf(fact_5102_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X6: C] : R
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R ) ) ) ).

% sum_list_triv
thf(fact_5103_sum__list__Suc,axiom,
    ! [A: $tType,F3: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X6: A] : ( suc @ ( F3 @ X6 ) )
          @ Xs ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F3 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% sum_list_Suc
thf(fact_5104_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z6: complex] :
                  ( ( power_power @ complex @ Z6 @ N )
                  = C2 ) ) )
          = N ) ) ) ).

% card_nth_roots
thf(fact_5105_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) ) )
        = N ) ) ).

% card_roots_unity_eq
thf(fact_5106_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S3: set @ B,F3: B > A,K5: real] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ S3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ X7 ) ) @ K5 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S3 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S3 ) ) @ K5 ) ) ) ) ).

% sum_norm_bound
thf(fact_5107_interv__sum__list__conv__sum__set__nat,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [F3: nat > B,M: nat,N: nat] :
          ( ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F3 @ ( upt @ M @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ B @ F3 @ ( set2 @ nat @ ( upt @ M @ N ) ) ) ) ) ).

% interv_sum_list_conv_sum_set_nat
thf(fact_5108_sum__set__upt__conv__sum__list__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set2 @ nat @ ( upt @ M @ N ) ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ nat @ A @ F3 @ ( upt @ M @ N ) ) ) ) ) ).

% sum_set_upt_conv_sum_list_nat
thf(fact_5109_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A,N: A,K: nat] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) )
                & ( ord_less_eq @ A @ ( F3 @ I2 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_5110_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F3: B > A,K5: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less @ A @ ( F3 @ I2 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A3 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_5111_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs2: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_5112_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F3: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F3 @ Xs ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X6: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X6 ) @ ( F3 @ X6 ) )
        @ ( set2 @ A @ Xs ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_5113_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z6 @ I ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              @ N ) ) ) ) ).

% polyfun_roots_card
thf(fact_5114_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ C2 )
                  @ S3 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S3 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ C2 )
                  @ S3 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S3 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_5115_set__decode__plus__power__2,axiom,
    ! [N: nat,Z: nat] :
      ( ~ ( member @ nat @ N @ ( nat_set_decode @ Z ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ Z ) )
        = ( insert @ nat @ N @ ( nat_set_decode @ Z ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_5116_bezw__aux,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X2 @ Y2 ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X2 @ Y2 ) ) @ ( semiring_1_of_nat @ int @ X2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X2 @ Y2 ) ) @ ( semiring_1_of_nat @ int @ Y2 ) ) ) ) ).

% bezw_aux
thf(fact_5117_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( finite_finite2 @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z6 @ I ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z6: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z6 @ I ) )
                          @ ( set_ord_atMost @ nat @ N ) )
                        = ( zero_zero @ A ) ) ) )
                @ N ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_5118_gcd__nat_Opelims,axiom,
    ! [X2: nat,Xa: nat,Y2: nat] :
      ( ( ( gcd_gcd @ nat @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y2 = X2 ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y2
                  = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_5119_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A3 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs2: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = K )
                  & ( distinct @ A @ Xs2 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X6: nat] : X6
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_5120_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A3 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = K )
                & ( distinct @ A @ Xs2 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X6: nat] : X6
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_5121_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = N )
              & ( distinct @ A @ Xs2 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_5122_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( set @ A ) @ ( map @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% distinct_set_subseqs
thf(fact_5123_distinct__upt,axiom,
    ! [I3: nat,J2: nat] : ( distinct @ nat @ ( upt @ I3 @ J2 ) ) ).

% distinct_upt
thf(fact_5124_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( distinct @ A @ Xs ) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
thf(fact_5125_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ B @ Ys )
       => ( distinct @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ) ).

% distinct_product
thf(fact_5126_distinct__take,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( take @ A @ I3 @ Xs ) ) ) ).

% distinct_take
thf(fact_5127_distinct__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( distinct @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ).

% distinct_enumerate
thf(fact_5128_finite__distinct__list,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ? [Xs3: list @ A] :
          ( ( ( set2 @ A @ Xs3 )
            = A3 )
          & ( distinct @ A @ Xs3 ) ) ) ).

% finite_distinct_list
thf(fact_5129_subseqs__distinctD,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( ( distinct @ A @ Xs )
       => ( distinct @ A @ Ys ) ) ) ).

% subseqs_distinctD
thf(fact_5130_distinct__card,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% distinct_card
thf(fact_5131_card__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( distinct @ A @ Xs ) ) ).

% card_distinct
thf(fact_5132_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,J2: nat] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( ( nth @ A @ Xs @ I3 )
              = ( nth @ A @ Xs @ J2 ) )
            = ( I3 = J2 ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_5133_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs2: list @ A] :
          ! [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ! [J4: nat] :
                ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( I != J4 )
                 => ( ( nth @ A @ Xs2 @ I )
                   != ( nth @ A @ Xs2 @ J4 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_5134_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( ( groups8242544230860333062m_list @ A @ Xs )
            = ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X6: A] : X6
              @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_sum_list_conv_Sum
thf(fact_5135_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ? [X7: nat] :
            ( ( ord_less @ nat @ X7 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ X7 )
              = X2 )
            & ! [Y3: nat] :
                ( ( ( ord_less @ nat @ Y3 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( ( nth @ A @ Xs @ Y3 )
                    = X2 ) )
               => ( Y3 = X7 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_5136_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comm_monoid_add @ C )
     => ! [Xs: list @ B,F3: B > C] :
          ( ( distinct @ B @ Xs )
         => ( ( groups8242544230860333062m_list @ C @ ( map @ B @ C @ F3 @ Xs ) )
            = ( groups7311177749621191930dd_sum @ B @ C @ F3 @ ( set2 @ B @ Xs ) ) ) ) ) ).

% sum_list_distinct_conv_sum_set
thf(fact_5137_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ B,G: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum.distinct_set_conv_list
thf(fact_5138_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list @ A,A3: set @ nat,B5: set @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( A3
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( ( B5
            = ( set2 @ A @ Xs ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs ) @ A3 @ B5 ) ) ) ) ).

% bij_betw_nth
thf(fact_5139_eq__key__imp__eq__value,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ A @ B ),K: A,V1: B,V22: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V1 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
       => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V22 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
         => ( V1 = V22 ) ) ) ) ).

% eq_key_imp_eq_value
thf(fact_5140_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L3: int] :
          ( if @ int
          @ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_5141_and__int_Oelims,axiom,
    ! [X2: int,Xa: int,Y2: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X2 @ Xa )
        = Y2 )
     => ( ( ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y2
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y2
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_5142_singleton__conv,axiom,
    ! [A: $tType,A2: A] :
      ( ( collect @ A
        @ ^ [X6: A] : ( X6 = A2 ) )
      = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% singleton_conv
thf(fact_5143_singleton__conv2,axiom,
    ! [A: $tType,A2: A] :
      ( ( collect @ A
        @ ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 )
          @ A2 ) )
      = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% singleton_conv2
thf(fact_5144_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_5145_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_5146_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_5147_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_5148_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_5149_card__0__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ( finite_card @ A @ A3 )
          = ( zero_zero @ nat ) )
        = ( A3
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_5150_set__replicate,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X2 ) )
        = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_5151_Collect__conv__if,axiom,
    ! [A: $tType,P3: A > $o,A2: A] :
      ( ( ( P3 @ A2 )
       => ( ( collect @ A
            @ ^ [X6: A] :
                ( ( X6 = A2 )
                & ( P3 @ X6 ) ) )
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P3 @ A2 )
       => ( ( collect @ A
            @ ^ [X6: A] :
                ( ( X6 = A2 )
                & ( P3 @ X6 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_conv_if
thf(fact_5152_Collect__conv__if2,axiom,
    ! [A: $tType,P3: A > $o,A2: A] :
      ( ( ( P3 @ A2 )
       => ( ( collect @ A
            @ ^ [X6: A] :
                ( ( A2 = X6 )
                & ( P3 @ X6 ) ) )
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P3 @ A2 )
       => ( ( collect @ A
            @ ^ [X6: A] :
                ( ( A2 = X6 )
                & ( P3 @ X6 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_conv_if2
thf(fact_5153_some__in__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( member @ A
        @ ( fChoice @ A
          @ ^ [X6: A] : ( member @ A @ X6 @ A3 ) )
        @ A3 )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% some_in_eq
thf(fact_5154_empty__def,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X6: A] : $false ) ) ).

% empty_def
thf(fact_5155_not__psubset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ~ ( ord_less @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ).

% not_psubset_empty
thf(fact_5156_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_5157_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_5158_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S3: set @ A] :
          ( ( finite_finite2 @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X7: A] :
                ( ( member @ A @ X7 @ S3 )
                & ~ ? [Xa3: A] :
                      ( ( member @ A @ Xa3 @ S3 )
                      & ( ord_less @ A @ Xa3 @ X7 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_5159_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X15: set @ A] :
          ( ( X15
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ X15 )
               => ? [Xa3: A] :
                    ( ( member @ A @ Xa3 @ X15 )
                    & ( ord_less @ A @ X7 @ Xa3 ) ) )
           => ~ ( finite_finite2 @ A @ X15 ) ) ) ) ).

% infinite_growing
thf(fact_5160_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P3: ( set @ A ) > $o] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( P3 @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B3: A,A8: set @ A] :
                  ( ( finite_finite2 @ A @ A8 )
                 => ( ! [X: A] :
                        ( ( member @ A @ X @ A8 )
                       => ( ord_less @ A @ X @ B3 ) )
                   => ( ( P3 @ A8 )
                     => ( P3 @ ( insert @ A @ B3 @ A8 ) ) ) ) )
             => ( P3 @ A3 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_5161_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P3: ( set @ A ) > $o] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( P3 @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B3: A,A8: set @ A] :
                  ( ( finite_finite2 @ A @ A8 )
                 => ( ! [X: A] :
                        ( ( member @ A @ X @ A8 )
                       => ( ord_less @ A @ B3 @ X ) )
                   => ( ( P3 @ A8 )
                     => ( P3 @ ( insert @ A @ B3 @ A8 ) ) ) ) )
             => ( P3 @ A3 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_5162_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ A3 )
                 => ( ord_less @ A @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_5163_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite2 @ A @ A3 ) ) ) ).

% card_eq_0_iff
thf(fact_5164_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ I6 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ I6 ) ) ) ) ) ) ).

% sum_pos
thf(fact_5165_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,F3: A > B] :
          ( ( finite_finite2 @ A @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I6 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F3 @ I2 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ I6 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_5166_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite2 @ A @ A3 ) ) ) ).

% card_gt_0_iff
thf(fact_5167_card__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B4: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ B4 @ B8 ) )
            & ~ ( member @ A @ B4 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B8
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_5168_card__eq__SucD,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
     => ? [B3: A,B9: set @ A] :
          ( ( A3
            = ( insert @ A @ B3 @ B9 ) )
          & ~ ( member @ A @ B3 @ B9 )
          & ( ( finite_card @ A @ B9 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B9
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_5169_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X6: A] :
            ( A3
            = ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_5170_finite__induct__select,axiom,
    ! [A: $tType,S3: set @ A,P3: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ S3 )
     => ( ( P3 @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S3 )
             => ( ( P3 @ T7 )
               => ? [X: A] :
                    ( ( member @ A @ X @ ( minus_minus @ ( set @ A ) @ S3 @ T7 ) )
                    & ( P3 @ ( insert @ A @ X @ T7 ) ) ) ) )
         => ( P3 @ S3 ) ) ) ) ).

% finite_induct_select
thf(fact_5171_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X2: A,B5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B5 ) )
      = ( ( ( member @ A @ X2 @ B5 )
         => ( ord_less @ ( set @ A ) @ A3 @ B5 ) )
        & ( ~ ( member @ A @ X2 @ B5 )
         => ( ( ( member @ A @ X2 @ A3 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B5 ) )
            & ( ~ ( member @ A @ X2 @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ A3 @ B5 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_5172_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X2 ) )
      = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_5173_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X2 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X2 ) )
          = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_5174_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I: int,J4: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J4 @ I ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J4 ) ) ) ) ) ).

% simp_from_to
thf(fact_5175_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A3 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) )
                  & ( ord_less @ A @ ( F3 @ I2 ) @ ( G @ I2 ) ) ) )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_5176_card__2__iff,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X6: A,Y: A] :
            ( ( S3
              = ( insert @ A @ X6 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X6 != Y ) ) ) ) ).

% card_2_iff
thf(fact_5177_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( member @ B @ X2 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_5178_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,X2: B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
            = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_5179_card__3__iff,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X6: A,Y: A,Z6: A] :
            ( ( S3
              = ( insert @ A @ X6 @ ( insert @ A @ Y @ ( insert @ A @ Z6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X6 != Y )
            & ( Y != Z6 )
            & ( X6 != Z6 ) ) ) ) ).

% card_3_iff
thf(fact_5180_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) )
     => ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_5181_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,X2: B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
            = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_5182_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( member @ B @ X2 @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_5183_card_Oremove,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ A3 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_5184_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_5185_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_5186_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) )
      = ( ( finite_finite2 @ A @ A3 )
        & ( member @ A @ X2 @ A3 ) ) ) ).

% card_Diff1_less_iff
thf(fact_5187_card__Diff2__less,axiom,
    ! [A: $tType,A3: set @ A,X2: A,Y2: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( member @ A @ Y2 @ A3 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_5188_card__Diff1__less,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff1_less
thf(fact_5189_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S3 )
                = ( plus_plus @ A @ ( B2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_5190_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S3 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S3 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_5191_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I3: C,A3: set @ C,F3: C > B] :
          ( ( member @ C @ I3 @ A3 )
         => ( ! [X7: C] :
                ( ( member @ C @ X7 @ ( minus_minus @ ( set @ C ) @ A3 @ ( insert @ C @ I3 @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F3 @ X7 ) ) )
           => ( ( finite_finite2 @ C @ A3 )
             => ( ord_less_eq @ B @ ( F3 @ I3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ F3 @ A3 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_5192_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: set @ B,F3: B > A,K5: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) ) ) )
         => ( ( finite_finite2 @ B @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_5193_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: set @ B,F3: B > A,A2: B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( F3 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_5194_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sinh @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X2 ) @ ( insert @ A @ ( one_one @ A ) @ ( insert @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_5195_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_5196_and__int_Opelims,axiom,
    ! [X2: int,Xa: int,Y2: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X2 @ Xa ) )
       => ~ ( ( ( ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y2
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y2
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X2 @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_5197_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F3: nat > B,Ns: list @ nat] :
          ( ! [X7: nat,Y5: nat] :
              ( ( ord_less_eq @ nat @ X7 @ Y5 )
             => ( ord_less_eq @ B @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F3 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_5198_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_5199_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_5200_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_5201_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_5202_atLeastLessThan__singleton,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ M ) )
      = ( insert @ nat @ M @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atLeastLessThan_singleton
thf(fact_5203_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_5204_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R3: A > A > $o,F3: B > A,Xs: list @ B] :
      ( ( sorted_wrt @ A @ R3 @ ( map @ B @ A @ F3 @ Xs ) )
      = ( sorted_wrt @ B
        @ ^ [X6: B,Y: B] : ( R3 @ ( F3 @ X6 ) @ ( F3 @ Y ) )
        @ Xs ) ) ).

% sorted_wrt_map
thf(fact_5205_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_5206_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_5207_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% bot_empty_eq2
thf(fact_5208_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N @ Xs ) ) ) ) ).

% sorted_take
thf(fact_5209_sorted__wrt__take,axiom,
    ! [A: $tType,F3: A > A > $o,Xs: list @ A,N: nat] :
      ( ( sorted_wrt @ A @ F3 @ Xs )
     => ( sorted_wrt @ A @ F3 @ ( take @ A @ N @ Xs ) ) ) ).

% sorted_wrt_take
thf(fact_5210_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu3: A,Uv3: A] : $true
      @ Xs ) ).

% sorted_wrt_true
thf(fact_5211_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_5212_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys )
           => ( ( ( set2 @ A @ Ys )
                = ( set2 @ A @ Xs ) )
             => ( Ys = Xs ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_5213_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > A > $o,Q: A > A > $o] :
      ( ! [X7: A,Y5: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y5 @ ( set2 @ A @ Xs ) )
           => ( ( P3 @ X7 @ Y5 )
             => ( Q @ X7 @ Y5 ) ) ) )
     => ( ( sorted_wrt @ A @ P3 @ Xs )
       => ( sorted_wrt @ A @ Q @ Xs ) ) ) ).

% sorted_wrt_mono_rel
thf(fact_5214_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: nat,X2: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N @ X2 ) ) ) ).

% sorted_replicate
thf(fact_5215_sorted__wrt__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_wrt_upt
thf(fact_5216_sorted__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_upt
thf(fact_5217_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X6: B,Y: B] : ( ord_less_eq @ A @ ( F3 @ X6 ) @ ( F3 @ Y ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_5218_atLeastLessThan0,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_5219_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( ( set_ord_lessThan @ nat @ N )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_5220_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_5221_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_5222_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P3 @ Xs ) ) ).

% sorted_wrt01
thf(fact_5223_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P2: A > A > $o,Xs2: list @ A] :
          ! [I: nat,J4: nat] :
            ( ( ord_less @ nat @ I @ J4 )
           => ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P2 @ ( nth @ A @ Xs2 @ I ) @ ( nth @ A @ Xs2 @ J4 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_5224_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P3: A > A > $o,Xs: list @ A,I3: nat,J2: nat] :
      ( ( sorted_wrt @ A @ P3 @ Xs )
     => ( ( ord_less @ nat @ I3 @ J2 )
       => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P3 @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Xs @ J2 ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_5225_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted01
thf(fact_5226_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I: nat,J4: nat] :
                ( ( ord_less @ nat @ I @ J4 )
               => ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ J4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_5227_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ? [X7: list @ A] :
              ( ( ( set2 @ A @ X7 )
                = A3 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X7 )
              & ( distinct @ A @ X7 )
              & ! [Y3: list @ A] :
                  ( ( ( ( set2 @ A @ Y3 )
                      = A3 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y3 )
                    & ( distinct @ A @ Y3 ) )
                 => ( Y3 = X7 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_5228_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I: nat] :
                ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ ( suc @ I ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_5229_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ~ ! [L2: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
               => ( ( ( set2 @ A @ L2 )
                    = A3 )
                 => ( ( size_size @ ( list @ A ) @ L2 )
                   != ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_5230_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I: nat,J4: nat] :
                ( ( ord_less_eq @ nat @ I @ J4 )
               => ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ J4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_5231_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I3: nat,J2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( ord_less_eq @ nat @ I3 @ J2 )
           => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Xs @ J2 ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_5232_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_5233_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I3 @ ( nth @ nat @ Ns @ I3 ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_5234_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ) ).

% sorted_enumerate
thf(fact_5235_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_5236_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_5237_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_5238_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P3: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [K3: int,L2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K3 @ L2 ) )
           => ( ( ~ ( ( member @ int @ K3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P3 @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P3 @ K3 @ L2 ) ) )
       => ( P3 @ A0 @ A1 ) ) ) ).

% and_int.pinduct
thf(fact_5239_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P3: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [I2: int,J: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J ) )
           => ( ( ( ord_less_eq @ int @ I2 @ J )
               => ( P3 @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) )
             => ( P3 @ I2 @ J ) ) )
       => ( P3 @ A0 @ A1 ) ) ) ).

% upto.pinduct
thf(fact_5240_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite2 @ B @ A3 )
         => ~ ! [L2: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F3 @ L2 ) )
               => ( ( ( set2 @ B @ L2 )
                    = A3 )
                 => ( ( size_size @ ( list @ B ) @ L2 )
                   != ( finite_card @ B @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_5241_the__elem__def,axiom,
    ! [A: $tType] :
      ( ( the_elem @ A )
      = ( ^ [X8: set @ A] :
            ( the @ A
            @ ^ [X6: A] :
                ( X8
                = ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% the_elem_def
thf(fact_5242_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( distinct @ A @ ( map @ B @ A @ F3 @ Xs ) )
       => ( distinct @ B @ Xs ) ) ) ).

% folding_insort_key.distinct_if_distinct_map
thf(fact_5243_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B,L: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F3 @ L ) )
              & ( ( set2 @ B @ L )
                = A3 )
              & ( ( size_size @ ( list @ B ) @ L )
                = ( finite_card @ B @ A3 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 )
              = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_5244_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs ) @ S3 )
       => ( ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F3 @ Xs ) )
         => ( ( distinct @ B @ Xs )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( set2 @ B @ Xs ) )
              = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_5245_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F4: set @ A,I6: set @ A,F3: A > B,I3: A] :
          ( ( finite_finite2 @ A @ F4 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I: A] :
                    ( ( member @ A @ I @ I6 )
                    & ( ( F3 @ I )
                     != ( zero_zero @ B ) ) ) )
              @ F4 )
           => ( ( ( member @ A @ I3 @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F3 @ I6 ) @ ( F3 @ I3 ) ) ) )
              & ( ~ ( member @ A @ I3 @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F3 @ I6 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_5246_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P5: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P5 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_5247_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,P5: B > A,I3: B] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X6: B] :
                  ( ( member @ B @ X6 @ I6 )
                  & ( ( P5 @ X6 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I3 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P5 @ ( insert @ B @ I3 @ I6 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P5 @ I6 ) ) )
            & ( ~ ( member @ B @ I3 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P5 @ ( insert @ B @ I3 @ I6 ) )
                = ( plus_plus @ A @ ( P5 @ I3 ) @ ( groups1027152243600224163dd_sum @ B @ A @ P5 @ I6 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_5248_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( sorted8670434370408473282of_set @ A @ B )
      = ( sorted8670434370408473282of_set @ A @ B ) ) ).

% linorder.sorted_key_list_of_set.cong
thf(fact_5249_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,I6: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G
            @ ( collect @ B
              @ ^ [X6: B] :
                  ( ( member @ B @ X6 @ I6 )
                  & ( ( G @ X6 )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G @ I6 ) ) ) ).

% sum.non_neutral'
thf(fact_5250_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite2 @ B @ I6 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I: B] : ( plus_plus @ A @ ( G @ I ) @ ( H @ I ) )
              @ I6 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H @ I6 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_5251_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T5 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
               => ( ( G @ X7 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_5252_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T5 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
               => ( ( G @ X7 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_5253_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T5: set @ B,H: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T5 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
               => ( ( H @ I2 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ S3 )
                 => ( ( G @ X7 )
                    = ( H @ X7 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H @ T5 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_5254_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T5: set @ B,G: B > A,H: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T5 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
               => ( ( G @ X7 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ S3 )
                 => ( ( G @ X7 )
                    = ( H @ X7 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H @ S3 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_5255_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X6: B] :
                  ( ( member @ B @ X6 @ I6 )
                  & ( ( G @ X6 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [X6: B] :
                    ( ( member @ B @ X6 @ I6 )
                    & ( ( H @ X6 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I: B] : ( plus_plus @ A @ ( G @ I ) @ ( H @ I ) )
                @ I6 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H @ I6 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_5256_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P4: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite2 @ B
                @ ( collect @ B
                  @ ^ [X6: B] :
                      ( ( member @ B @ X6 @ I7 )
                      & ( ( P4 @ X6 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P4
                @ ( collect @ B
                  @ ^ [X6: B] :
                      ( ( member @ B @ X6 @ I7 )
                      & ( ( P4 @ X6 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_5257_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B,B5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( ord_less_eq @ ( set @ B ) @ B5 @ S3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ B5 ) )
           => ( ( finite_finite2 @ B @ A3 )
             => ( ( finite_finite2 @ B @ B5 )
               => ( A3 = B5 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_5258_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) )
            = A3 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_5259_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) )
          = ( finite_card @ B @ A3 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_5260_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( distinct @ A @ ( map @ B @ A @ F3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_5261_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_5262_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_5263_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I6: set @ A,F3: A > B,I3: A] :
          ( ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [I: A] :
                  ( ( member @ A @ I @ I6 )
                  & ( ( F3 @ I )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I3 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F3 @ I6 ) @ ( F3 @ I3 ) ) ) )
            & ( ~ ( member @ A @ I3 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F3 @ I6 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_5264_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,X2: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( insert @ B @ X2 @ A3 ) )
            = ( insort_key @ A @ B @ Less_eq @ F3 @ X2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_5265_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,X2: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ~ ( member @ B @ X2 @ A3 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( insert @ B @ X2 @ A3 ) )
              = ( insort_key @ A @ B @ Less_eq @ F3 @ X2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_5266_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,X2: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_5267_in__set__remove1,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( A2 != B2 )
     => ( ( member @ A @ A2 @ ( set2 @ A @ ( remove1 @ A @ B2 @ Xs ) ) )
        = ( member @ A @ A2 @ ( set2 @ A @ Xs ) ) ) ) ).

% in_set_remove1
thf(fact_5268_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X2 @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_5269_remove1__idem,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( remove1 @ A @ X2 @ Xs )
        = Xs ) ) ).

% remove1_idem
thf(fact_5270_notin__set__remove1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ~ ( member @ A @ X2 @ ( set2 @ A @ ( remove1 @ A @ Y2 @ Xs ) ) ) ) ).

% notin_set_remove1
thf(fact_5271_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( insort_key @ A @ B )
      = ( insort_key @ A @ B ) ) ).

% linorder.insort_key.cong
thf(fact_5272_remove1__commute,axiom,
    ! [A: $tType,X2: A,Y2: A,Zs: list @ A] :
      ( ( remove1 @ A @ X2 @ ( remove1 @ A @ Y2 @ Zs ) )
      = ( remove1 @ A @ Y2 @ ( remove1 @ A @ X2 @ Zs ) ) ) ).

% remove1_commute
thf(fact_5273_distinct__remove1,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( remove1 @ A @ X2 @ Xs ) ) ) ).

% distinct_remove1
thf(fact_5274_set__remove1__subset,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X2 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_remove1_subset
thf(fact_5275_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs ) ) ) ) ).

% sorted_remove1
thf(fact_5276_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs: list @ B,X2: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ ( remove1 @ B @ X2 @ Xs ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_5277_length__remove1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X2 @ Xs ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X2 @ Xs ) )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_remove1
thf(fact_5278_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X2: B,Xs: list @ B,F3: B > A] :
          ( ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs ) )
            = ( plus_plus @ A @ ( F3 @ X2 ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ ( remove1 @ B @ X2 @ Xs ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_5279_distinct__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys ) )
      = ( distinct @ A @ Ys ) ) ).

% distinct_union
thf(fact_5280_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N @ X2 ) )
          = ( insert @ A @ X2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_5281_map__of__eq__Some__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list @ ( product_prod @ A @ B ),X2: A,Y2: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys ) )
     => ( ( ( map_of @ A @ B @ Xys @ X2 )
          = ( some @ B @ Y2 ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys ) ) ) ) ).

% map_of_eq_Some_iff
thf(fact_5282_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,X2: A,Y2: A] :
      ( ( list_update @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ I3 @ Y2 )
      = ( list_update @ A @ Xs @ I3 @ Y2 ) ) ).

% list_update_overwrite
thf(fact_5283_length__list__update,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,X2: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs @ I3 @ X2 ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_list_update
thf(fact_5284_nth__list__update__neq,axiom,
    ! [A: $tType,I3: nat,J2: nat,Xs: list @ A,X2: A] :
      ( ( I3 != J2 )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ J2 )
        = ( nth @ A @ Xs @ J2 ) ) ) ).

% nth_list_update_neq
thf(fact_5285_list__update__id,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat] :
      ( ( list_update @ A @ Xs @ I3 @ ( nth @ A @ Xs @ I3 ) )
      = Xs ) ).

% list_update_id
thf(fact_5286_list__update__beyond,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,X2: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I3 )
     => ( ( list_update @ A @ Xs @ I3 @ X2 )
        = Xs ) ) ).

% list_update_beyond
thf(fact_5287_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A,Y2: A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( take @ A @ N @ ( list_update @ A @ Xs @ M @ Y2 ) )
        = ( take @ A @ N @ Xs ) ) ) ).

% take_update_cancel
thf(fact_5288_nth__list__update__eq,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,X2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ I3 )
        = X2 ) ) ).

% nth_list_update_eq
thf(fact_5289_set__swap,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,J2: nat] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I3 @ ( nth @ A @ Xs @ J2 ) ) @ J2 @ ( nth @ A @ Xs @ I3 ) ) )
          = ( set2 @ A @ Xs ) ) ) ) ).

% set_swap
thf(fact_5290_distinct__swap,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,J2: nat] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I3 @ ( nth @ A @ Xs @ J2 ) ) @ J2 @ ( nth @ A @ Xs @ I3 ) ) )
          = ( distinct @ A @ Xs ) ) ) ) ).

% distinct_swap
thf(fact_5291_map__of__is__SomeI,axiom,
    ! [A: $tType,B: $tType,Xys: list @ ( product_prod @ A @ B ),X2: A,Y2: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys ) )
       => ( ( map_of @ A @ B @ Xys @ X2 )
          = ( some @ B @ Y2 ) ) ) ) ).

% map_of_is_SomeI
thf(fact_5292_Some__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list @ ( product_prod @ A @ B ),Y2: B,X2: A] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys ) )
     => ( ( ( some @ B @ Y2 )
          = ( map_of @ A @ B @ Xys @ X2 ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys ) ) ) ) ).

% Some_eq_map_of_iff
thf(fact_5293_map__update,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B,K: nat,Y2: B] :
      ( ( map @ B @ A @ F3 @ ( list_update @ B @ Xs @ K @ Y2 ) )
      = ( list_update @ A @ ( map @ B @ A @ F3 @ Xs ) @ K @ ( F3 @ Y2 ) ) ) ).

% map_update
thf(fact_5294_list__update__swap,axiom,
    ! [A: $tType,I3: nat,I8: nat,Xs: list @ A,X2: A,X10: A] :
      ( ( I3 != I8 )
     => ( ( list_update @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ I8 @ X10 )
        = ( list_update @ A @ ( list_update @ A @ Xs @ I8 @ X10 ) @ I3 @ X2 ) ) ) ).

% list_update_swap
thf(fact_5295_take__update__swap,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat,X2: A] :
      ( ( take @ A @ M @ ( list_update @ A @ Xs @ N @ X2 ) )
      = ( list_update @ A @ ( take @ A @ M @ Xs ) @ N @ X2 ) ) ).

% take_update_swap
thf(fact_5296_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list @ A,A3: set @ A,X2: A,I3: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) ) @ A3 ) ) ) ).

% set_update_subsetI
thf(fact_5297_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,X2: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) ) @ ( insert @ A @ X2 @ ( set2 @ A @ Xs ) ) ) ).

% set_update_subset_insert
thf(fact_5298_set__update__memI,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,X2: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ X2 @ ( set2 @ A @ ( list_update @ A @ Xs @ N @ X2 ) ) ) ) ).

% set_update_memI
thf(fact_5299_list__update__same__conv,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,X2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( list_update @ A @ Xs @ I3 @ X2 )
          = Xs )
        = ( ( nth @ A @ Xs @ I3 )
          = X2 ) ) ) ).

% list_update_same_conv
thf(fact_5300_nth__list__update,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,J2: nat,X2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( I3 = J2 )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ J2 )
            = X2 ) )
        & ( ( I3 != J2 )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ J2 )
            = ( nth @ A @ Xs @ J2 ) ) ) ) ) ).

% nth_list_update
thf(fact_5301_weak__map__of__SomeI,axiom,
    ! [A: $tType,B: $tType,K: A,X2: B,L: list @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ X2 ) @ ( set2 @ ( product_prod @ A @ B ) @ L ) )
     => ? [X7: B] :
          ( ( map_of @ A @ B @ L @ K )
          = ( some @ B @ X7 ) ) ) ).

% weak_map_of_SomeI
thf(fact_5302_map__of__SomeD,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ B @ A ),K: B,Y2: A] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ Y2 ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ Y2 ) @ ( set2 @ ( product_prod @ B @ A ) @ Xs ) ) ) ).

% map_of_SomeD
thf(fact_5303_map__of__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
        = ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) ) )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
           => ( ( map_of @ A @ B @ Xs @ X7 )
              = ( map_of @ A @ B @ Ys @ X7 ) ) )
       => ( ( map_of @ A @ B @ Xs )
          = ( map_of @ A @ B @ Ys ) ) ) ) ).

% map_of_eqI
thf(fact_5304_map__of__inject__set,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) )
       => ( ( ( map_of @ A @ B @ Xs )
            = ( map_of @ A @ B @ Ys ) )
          = ( ( set2 @ ( product_prod @ A @ B ) @ Xs )
            = ( set2 @ ( product_prod @ A @ B ) @ Ys ) ) ) ) ) ).

% map_of_inject_set
thf(fact_5305_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs: list @ A,X2: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs @ K @ X2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ X2 ) @ ( nth @ A @ Xs @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_5306_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A2: A,I3: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member @ A @ A2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ I3 ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I3 @ A2 ) ) ) ) ).

% distinct_list_update
thf(fact_5307_set__map__of__compr,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( set2 @ ( product_prod @ A @ B ) @ Xs )
        = ( collect @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [K2: A,V5: B] :
                ( ( map_of @ A @ B @ Xs @ K2 )
                = ( some @ B @ V5 ) ) ) ) ) ) ).

% set_map_of_compr
thf(fact_5308_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,L: list @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
              & ( ( set2 @ A @ L )
                = A3 )
              & ( ( size_size @ ( list @ A ) @ L )
                = ( finite_card @ A @ A3 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A3 )
              = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_5309_card__Pow,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A3 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Pow
thf(fact_5310_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F5: A > nat,G2: B > nat,P4: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F5 @ ( product_fst @ A @ B @ P4 ) ) @ ( G2 @ ( product_snd @ A @ B @ P4 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_5311_sorted__list__of__set__range,axiom,
    ! [M: nat,N: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% sorted_list_of_set_range
thf(fact_5312_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( set2 @ A @ ( linord4507533701916653071of_set @ A @ A3 ) )
            = A3 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
thf(fact_5313_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) )
          = ( finite_card @ A @ A3 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_5314_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% Pow_def
thf(fact_5315_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B5: set @ A] :
          ( ( ( linord4507533701916653071of_set @ A @ A3 )
            = ( linord4507533701916653071of_set @ A @ B5 ) )
         => ( ( finite_finite2 @ A @ A3 )
           => ( ( finite_finite2 @ A @ B5 )
             => ( A3 = B5 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
thf(fact_5316_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( distinct @ A @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
thf(fact_5317_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_5318_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_5319_binomial__def,axiom,
    ( binomial
    = ( ^ [N2: nat,K2: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K6: set @ nat] :
                ( ( member @ ( set @ nat ) @ K6 @ ( pow2 @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
                & ( ( finite_card @ nat @ K6 )
                  = K2 ) ) ) ) ) ) ).

% binomial_def
thf(fact_5320_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
              = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_5321_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X2 @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_5322_nat__descend__induct,axiom,
    ! [N: nat,P3: nat > $o,M: nat] :
      ( ! [K3: nat] :
          ( ( ord_less @ nat @ N @ K3 )
         => ( P3 @ K3 ) )
     => ( ! [K3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ! [I4: nat] :
                  ( ( ord_less @ nat @ K3 @ I4 )
                 => ( P3 @ I4 ) )
             => ( P3 @ K3 ) ) )
       => ( P3 @ M ) ) ) ).

% nat_descend_induct
thf(fact_5323_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_5324_finite__enumerate,axiom,
    ! [S3: set @ nat] :
      ( ( finite_finite2 @ nat @ S3 )
     => ? [R2: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R2 @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S3 ) ) )
          & ! [N9: nat] :
              ( ( ord_less @ nat @ N9 @ ( finite_card @ nat @ S3 ) )
             => ( member @ nat @ ( R2 @ N9 ) @ S3 ) ) ) ) ).

% finite_enumerate
thf(fact_5325_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L3: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L3
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K2 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L3
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K2 )
                  = ( sgn_sgn @ code_integer @ L3 ) )
                @ ( code_divmod_abs @ K2 @ L3 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S4: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S4
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L3 ) @ S4 ) ) )
                  @ ( code_divmod_abs @ K2 @ L3 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_5326_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: C > B,G: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F3 ) @ ( map @ A @ C @ G ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F3 @ G ) ) ) ).

% map_comp_map
thf(fact_5327_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: B > C,G: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F3 ) @ ( map @ A @ B @ G ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F3 @ G ) ) ) ).

% List.map.comp
thf(fact_5328_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: B > A,G: C > B,Xs: list @ C] :
      ( ( map @ B @ A @ F3 @ ( map @ C @ B @ G @ Xs ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F3 @ G ) @ Xs ) ) ).

% map_map
thf(fact_5329_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: B > C,G: A > B,List: list @ A] :
      ( ( map @ B @ C @ F3 @ ( map @ A @ B @ G @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F3 @ G ) @ List ) ) ).

% List.map.compositionality
thf(fact_5330_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F3: A > B,V: list @ A] :
      ( ( map @ B @ C @ G @ ( map @ A @ B @ F3 @ V ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G @ F3 ) @ V ) ) ).

% list.map_comp
thf(fact_5331_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_5332_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_5333_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_5334_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_5335_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_5336_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_5337_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_5338_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_5339_drop__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_5340_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_5341_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_5342_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_5343_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_5344_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_5345_drop__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_5346_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_5347_drop__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_5348_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_drop_bit
thf(fact_5349_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_5350_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_5351_drop__bit__push__bit__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_5352_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_5353_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_5354_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H: B > A,G: C > B,A3: set @ C] :
          ( ( ( H @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X7: B,Y5: B] :
                ( ( H @ ( plus_plus @ B @ X7 @ Y5 ) )
                = ( plus_plus @ A @ ( H @ X7 ) @ ( H @ Y5 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H @ G ) @ A3 )
              = ( H @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A3 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_5355_uminus__sum__list__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: B > A,Xs: list @ B] :
          ( ( uminus_uminus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ ( comp @ A @ A @ B @ ( uminus_uminus @ A ) @ F3 ) @ Xs ) ) ) ) ).

% uminus_sum_list_map
thf(fact_5356_case__prod__comp,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F3: D > C > A,G: B > D,X2: product_prod @ B @ C] :
      ( ( product_case_prod @ B @ C @ A @ ( comp @ D @ ( C > A ) @ B @ F3 @ G ) @ X2 )
      = ( F3 @ ( G @ ( product_fst @ B @ C @ X2 ) ) @ ( product_snd @ B @ C @ X2 ) ) ) ).

% case_prod_comp
thf(fact_5357_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_5358_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A5 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_5359_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_5360_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_5361_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = A2 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_5362_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( divide_divide @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% drop_bit_int_def
thf(fact_5363_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( divide_divide @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_5364_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_5365_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A5 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_5366_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_5367_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_5368_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ A5
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_5369_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F5: A > B,A7: set @ A] :
            ! [R5: A,S4: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S4 @ A7 )
                & ( ord_less @ A @ R5 @ S4 ) )
             => ( ord_less @ B @ ( F5 @ R5 ) @ ( F5 @ S4 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_5370_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A3: set @ A,F3: A > B] :
          ( ! [R2: A,S2: A] :
              ( ( member @ A @ R2 @ A3 )
             => ( ( member @ A @ S2 @ A3 )
               => ( ( ord_less @ A @ R2 @ S2 )
                 => ( ord_less @ B @ ( F3 @ R2 ) @ ( F3 @ S2 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F3 @ A3 ) ) ) ).

% strict_mono_onI
thf(fact_5371_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F3: A > B,A3: set @ A,R: A,S: A] :
          ( ( strict_mono_on @ A @ B @ F3 @ A3 )
         => ( ( member @ A @ R @ A3 )
           => ( ( member @ A @ S @ A3 )
             => ( ( ord_less @ A @ R @ S )
               => ( ord_less @ B @ ( F3 @ R ) @ ( F3 @ S ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_5372_size__list__map,axiom,
    ! [A: $tType,B: $tType,F3: A > nat,G: B > A,Xs: list @ B] :
      ( ( size_list @ A @ F3 @ ( map @ B @ A @ G @ Xs ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F3 @ G ) @ Xs ) ) ).

% size_list_map
thf(fact_5373_drop__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_5374_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F3: B > nat,G: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F3 ) @ ( map @ A @ B @ G ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F3 @ G ) ) ) ).

% list.size_gen_o_map
thf(fact_5375_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X6: A] : ( product_Pair @ A @ A @ X6 @ X6 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% snd_diag_fst
thf(fact_5376_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_fst @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X6: B] : ( product_Pair @ B @ B @ X6 @ X6 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% fst_diag_snd
thf(fact_5377_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X6: B] : ( product_Pair @ B @ B @ X6 @ X6 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% snd_diag_snd
thf(fact_5378_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X6: A] : ( product_Pair @ A @ A @ X6 @ X6 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% fst_diag_fst
thf(fact_5379_card_Ocomp__fun__commute__on,axiom,
    ( ( comp @ nat @ nat @ nat @ suc @ suc )
    = ( comp @ nat @ nat @ nat @ suc @ suc ) ) ).

% card.comp_fun_commute_on
thf(fact_5380_drop__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_5381_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,X2: B,Y2: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( member @ B @ X2 @ S3 )
       => ( ( member @ B @ Y2 @ S3 )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F3 @ Y2 ) @ ( insort_key @ A @ B @ Less_eq @ F3 @ X2 ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F3 @ X2 ) @ ( insort_key @ A @ B @ Less_eq @ F3 @ Y2 ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_5382_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
thf(fact_5383_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
thf(fact_5384_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_5385_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_5386_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
thf(fact_5387_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
thf(fact_5388_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_5389_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_5390_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_5391_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F3 ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ C2 @ ( F3 @ N2 ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_5392_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_5393_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_5394_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_5395_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_5396_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_5397_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_5398_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_5399_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_5400_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_5401_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_5402_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N2: nat,M4: nat] : ( divide_divide @ nat @ M4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% drop_bit_nat_def
thf(fact_5403_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_5404_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_5405_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ B @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ B @ A )
        @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
          @ ^ [X6: A,Y: B] : ( product_Pair @ B @ A @ Y @ X6 ) ) ) ) ).

% fst_snd_flip
thf(fact_5406_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ A @ B ) @ A @ ( product_prod @ B @ A ) @ ( product_fst @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [X6: B,Y: A] : ( product_Pair @ A @ B @ Y @ X6 ) ) ) ) ).

% snd_fst_flip
thf(fact_5407_Code__Target__Int_Onegative__def,axiom,
    ( code_Target_negative
    = ( comp @ int @ int @ num @ ( uminus_uminus @ int ) @ ( numeral_numeral @ int ) ) ) ).

% Code_Target_Int.negative_def
thf(fact_5408_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate1
thf(fact_5409_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J2: nat,I3: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J2 @ ( suc @ I3 ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I3 @ J2 ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I3 @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_5410_xor__minus__numerals_I1_J,axiom,
    ! [N: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_5411_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,L: A,U: A] :
          ( ( member @ A @ I3 @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I3 )
            & ( ord_less @ A @ I3 @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_5412_set__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate1
thf(fact_5413_length__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate1
thf(fact_5414_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct1_rotate
thf(fact_5415_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite2 @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_5416_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_5417_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% diff_numeral_simps(1)
thf(fact_5418_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(6)
thf(fact_5419_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(9)
thf(fact_5420_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_5421_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_5422_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V @ W ) @ Y2 ) ) ) ).

% semiring_norm(166)
thf(fact_5423_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V ) @ Y2 ) ) ) ).

% semiring_norm(167)
thf(fact_5424_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_5425_rotate1__length01,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs )
        = Xs ) ) ).

% rotate1_length01
thf(fact_5426_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(7)
thf(fact_5427_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(8)
thf(fact_5428_card__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or5935395276787703475ssThan @ nat @ L @ U ) )
      = ( minus_minus @ nat @ U @ ( suc @ L ) ) ) ).

% card_greaterThanLessThan
thf(fact_5429_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_5430_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_5431_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_5432_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_5433_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_5434_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_5435_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_5436_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_5437_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_5438_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_5439_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_5440_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_5441_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_5442_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_5443_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_5444_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( rotate1 @ A @ ( map @ B @ A @ F3 @ Xs ) )
      = ( map @ B @ A @ F3 @ ( rotate1 @ B @ Xs ) ) ) ).

% rotate1_map
thf(fact_5445_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite2 @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_5446_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ L ) @ U )
      = ( set_or5935395276787703475ssThan @ nat @ L @ U ) ) ).

% atLeastSucLessThan_greaterThanLessThan
thf(fact_5447_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K2: num,L3: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K2 ) @ ( numeral_numeral @ A @ L3 ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_5448_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_5449_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% sub_non_positive
thf(fact_5450_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% sub_non_negative
thf(fact_5451_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% sub_negative
thf(fact_5452_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% sub_positive
thf(fact_5453_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N ) @ one2 )
          = ( numeral_numeral @ A @ N ) ) ) ).

% sub_inc_One_eq
thf(fact_5454_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N2: nat,M4: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ M4 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_5455_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_5456_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_5457_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_5458_sub__BitM__One__eq,axiom,
    ! [N: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_5459_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X2: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_5460_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X2: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_5461_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ? [K8: real] :
            ! [X7: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X7 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X7 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F3 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_5462_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X2 @ Y2 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_5463_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X2 @ Y2 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X2 @ Y2 ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_5464_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X2: B,Y2: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_5465_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X2: B,Y2: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_5466_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X2: B,Y2: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_5467_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X2: B,Y2: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_5468_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ).

% power_minus'
thf(fact_5469_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X2 @ Y2 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X2 )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_5470_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X2 @ Y2 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X2 )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_5471_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F5: A > B] :
            ? [K6: real] :
            ! [X6: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X6 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X6 ) @ K6 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_5472_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A5: A,Xs2: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( times_times @ A @ A5 ) @ ( F5 @ ( nth @ B @ Xs2 @ N2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_5473_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X6: A] : X6
              @ X2
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_5474_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X6: nat,Y: nat] : ( ord_less_eq @ nat @ Y @ X6 )
    @ ^ [X6: nat,Y: nat] : ( ord_less @ nat @ Y @ X6 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_5475_Suc__funpow,axiom,
    ! [N: nat] :
      ( ( compow @ ( nat > nat ) @ N @ suc )
      = ( plus_plus @ nat @ N ) ) ).

% Suc_funpow
thf(fact_5476_funpow__0,axiom,
    ! [A: $tType,F3: A > A,X2: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F3 @ X2 )
      = X2 ) ).

% funpow_0
thf(fact_5477_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [X2: B,F3: B > A,Xs: list @ B] :
          ( ( remove1 @ B @ X2 @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) )
          = Xs ) ) ).

% remove1_insort_key
thf(fact_5478_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X2: B,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% length_insort
thf(fact_5479_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X2 @ A3 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X6: A] : X6
                @ X2
                @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_5480_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F3: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N @ ( comp @ A @ A @ B @ F3 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N @ F3 ) ) ) ).

% comp_funpow
thf(fact_5481_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F3: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F3 )
      = ( comp @ A @ A @ A @ F3 @ ( compow @ ( A > A ) @ N @ F3 ) ) ) ).

% funpow.simps(2)
thf(fact_5482_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F3: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F3 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ F3 ) ) ).

% funpow_Suc_right
thf(fact_5483_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F3: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N ) @ F3 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F3 ) @ ( compow @ ( A > A ) @ N @ F3 ) ) ) ).

% funpow_add
thf(fact_5484_funpow__mod__eq,axiom,
    ! [A: $tType,N: nat,F3: A > A,X2: A,M: nat] :
      ( ( ( compow @ ( A > A ) @ N @ F3 @ X2 )
        = X2 )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M @ N ) @ F3 @ X2 )
        = ( compow @ ( A > A ) @ M @ F3 @ X2 ) ) ) ).

% funpow_mod_eq
thf(fact_5485_bij__betw__funpow,axiom,
    ! [A: $tType,F3: A > A,S3: set @ A,N: nat] :
      ( ( bij_betw @ A @ A @ F3 @ S3 @ S3 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ S3 @ S3 ) ) ).

% bij_betw_funpow
thf(fact_5486_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Xs: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X6: A] : X6
            @ X2
            @ ( linorder_insort_key @ A @ A
              @ ^ [X6: A] : X6
              @ Y2
              @ Xs ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X6: A] : X6
            @ Y2
            @ ( linorder_insort_key @ A @ A
              @ ^ [X6: A] : X6
              @ X2
              @ Xs ) ) ) ) ).

% insort_left_comm
thf(fact_5487_funpow__swap1,axiom,
    ! [A: $tType,F3: A > A,N: nat,X2: A] :
      ( ( F3 @ ( compow @ ( A > A ) @ N @ F3 @ X2 ) )
      = ( compow @ ( A > A ) @ N @ F3 @ ( F3 @ X2 ) ) ) ).

% funpow_swap1
thf(fact_5488_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X2: B,Y2: B,Xs: list @ B] :
          ( ( ( F3 @ X2 )
           != ( F3 @ Y2 ) )
         => ( ( linorder_insort_key @ B @ A @ F3 @ Y2 @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) )
            = ( linorder_insort_key @ B @ A @ F3 @ X2 @ ( linorder_insort_key @ B @ A @ F3 @ Y2 @ Xs ) ) ) ) ) ).

% insort_key_left_comm
thf(fact_5489_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F3: A > A] :
      ( ( compow @ ( A > A ) @ N @ ( compow @ ( A > A ) @ M @ F3 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N ) @ F3 ) ) ).

% funpow_mult
thf(fact_5490_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F3: A > nat,X2: A] :
          ( ( compow @ ( A > A ) @ ( F3 @ X2 ) @ ( times_times @ A @ X2 ) )
          = ( times_times @ A @ ( power_power @ A @ X2 @ ( F3 @ X2 ) ) ) ) ) ).

% funpow_times_power
thf(fact_5491_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X2: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X6: A] : X6
              @ Y2 )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X6: A] : X6
              @ X2 ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X6: A] : X6
              @ X2 )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X6: A] : X6
              @ Y2 ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_5492_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X2: B,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) )
          = ( insert @ B @ X2 @ ( set2 @ B @ Xs ) ) ) ) ).

% set_insort_key
thf(fact_5493_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X2: B,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) )
          = ( ~ ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
            & ( distinct @ B @ Xs ) ) ) ) ).

% distinct_insort
thf(fact_5494_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X6: A] : X6
              @ X2
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_5495_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X2: B,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs ) ) ) ) ).

% sorted_insort_key
thf(fact_5496_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_5497_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_5498_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K2: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K2 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_5499_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X6: A] : X6
                @ A2
                @ ( remove1 @ A @ A2 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_5500_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M4: nat,N2: nat] :
        ( ( dvd_dvd @ nat @ M4 @ N2 )
        & ( M4 != N2 ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_5501_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X6: A] : X6
                @ X2
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_5502_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_5503_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N2: nat,P2: A > A > $o,X6: A,Y: A] :
          ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = X6 )
            & ( ( F5 @ N2 )
              = Y )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ N2 )
               => ( P2 @ ( F5 @ I ) @ ( F5 @ ( suc @ I ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_5504_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_5505_relpowp__Suc__I2,axiom,
    ! [A: $tType,P3: A > A > $o,X2: A,Y2: A,N: nat,Z: A] :
      ( ( P3 @ X2 @ Y2 )
     => ( ( compow @ ( A > A > $o ) @ N @ P3 @ Y2 @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P3 @ X2 @ Z ) ) ) ).

% relpowp_Suc_I2
thf(fact_5506_relpowp__Suc__E2,axiom,
    ! [A: $tType,N: nat,P3: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P3 @ X2 @ Z )
     => ~ ! [Y5: A] :
            ( ( P3 @ X2 @ Y5 )
           => ~ ( compow @ ( A > A > $o ) @ N @ P3 @ Y5 @ Z ) ) ) ).

% relpowp_Suc_E2
thf(fact_5507_relpowp__Suc__D2,axiom,
    ! [A: $tType,N: nat,P3: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P3 @ X2 @ Z )
     => ? [Y5: A] :
          ( ( P3 @ X2 @ Y5 )
          & ( compow @ ( A > A > $o ) @ N @ P3 @ Y5 @ Z ) ) ) ).

% relpowp_Suc_D2
thf(fact_5508_relpowp__Suc__I,axiom,
    ! [A: $tType,N: nat,P3: A > A > $o,X2: A,Y2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P3 @ X2 @ Y2 )
     => ( ( P3 @ Y2 @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P3 @ X2 @ Z ) ) ) ).

% relpowp_Suc_I
thf(fact_5509_relpowp__Suc__E,axiom,
    ! [A: $tType,N: nat,P3: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P3 @ X2 @ Z )
     => ~ ! [Y5: A] :
            ( ( compow @ ( A > A > $o ) @ N @ P3 @ X2 @ Y5 )
           => ~ ( P3 @ Y5 @ Z ) ) ) ).

% relpowp_Suc_E
thf(fact_5510_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R3: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ R3 )
      = ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 ) ) ) ).

% relpowp.simps(1)
thf(fact_5511_relpowp__0__E,axiom,
    ! [A: $tType,P3: A > A > $o,X2: A,Y2: A] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P3 @ X2 @ Y2 )
     => ( X2 = Y2 ) ) ).

% relpowp_0_E
thf(fact_5512_relpowp__0__I,axiom,
    ! [A: $tType,P3: A > A > $o,X2: A] : ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P3 @ X2 @ X2 ) ).

% relpowp_0_I
thf(fact_5513_relpowp__E2,axiom,
    ! [A: $tType,N: nat,P3: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P3 @ X2 @ Z )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y5: A,M5: nat] :
              ( ( N
                = ( suc @ M5 ) )
             => ( ( P3 @ X2 @ Y5 )
               => ~ ( compow @ ( A > A > $o ) @ M5 @ P3 @ Y5 @ Z ) ) ) ) ) ).

% relpowp_E2
thf(fact_5514_relpowp__E,axiom,
    ! [A: $tType,N: nat,P3: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P3 @ X2 @ Z )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y5: A,M5: nat] :
              ( ( N
                = ( suc @ M5 ) )
             => ( ( compow @ ( A > A > $o ) @ M5 @ P3 @ X2 @ Y5 )
               => ~ ( P3 @ Y5 @ Z ) ) ) ) ) ).

% relpowp_E
thf(fact_5515_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J2: nat,I3: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J2 @ I3 ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I3 @ J2 ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I3 @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_5516_set__removeAll,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X2 @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_5517_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_5518_removeAll__id,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( removeAll @ A @ X2 @ Xs )
        = Xs ) ) ).

% removeAll_id
thf(fact_5519_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,L: A,U: A] :
          ( ( member @ A @ I3 @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I3 )
            & ( ord_less_eq @ A @ I3 @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_5520_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_5521_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_5522_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite2 @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_5523_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( removeAll @ A @ X2 @ Xs ) ) ) ).

% distinct_removeAll
thf(fact_5524_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ L ) @ U )
      = ( set_or3652927894154168847AtMost @ nat @ L @ U ) ) ).

% atLeastSucAtMost_greaterThanAtMost
thf(fact_5525_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite2 @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_5526_length__removeAll__less__eq,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_removeAll_less_eq
thf(fact_5527_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X2 @ Xs )
        = ( removeAll @ A @ X2 @ Xs ) ) ) ).

% distinct_remove1_removeAll
thf(fact_5528_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N2: nat,M4: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ ( suc @ M4 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_5529_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.head
thf(fact_5530_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_5531_length__removeAll__less,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_removeAll_less
thf(fact_5532_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_5533_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_5534_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_5535_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X6: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X6 @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X6 @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) )
          @ Xa
          @ X2 ) ) ) ).

% times_int.abs_eq
thf(fact_5536_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S3: set @ A,F3: A > B] :
          ( ( finite_finite2 @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X: A] :
                  ( ( member @ A @ X @ S3 )
                  & ( ord_less @ B @ ( F3 @ X ) @ ( F3 @ ( lattic7623131987881927897min_on @ A @ B @ F3 @ S3 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_5537_Gcd__remove0__nat,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite2 @ nat @ M7 )
     => ( ( gcd_Gcd @ nat @ M7 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M7 @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_5538_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_5539_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( gcd_Gcd @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_5540_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_5541_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N2: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N2 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_5542_uminus__int_Oabs__eq,axiom,
    ! [X2: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X6: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X6 )
          @ X2 ) ) ) ).

% uminus_int.abs_eq
thf(fact_5543_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5544_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X2 ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I: nat,J4: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J4 ) )
            @ X2 ) ) ) ).

% of_int.abs_eq
thf(fact_5545_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X6: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X6 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) )
        @ Xa
        @ X2 ) ) ).

% less_int.abs_eq
thf(fact_5546_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X6: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X6 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) )
        @ Xa
        @ X2 ) ) ).

% less_eq_int.abs_eq
thf(fact_5547_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X6: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X6 @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) )
          @ Xa
          @ X2 ) ) ) ).

% plus_int.abs_eq
thf(fact_5548_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X6: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X6 @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) )
          @ Xa
          @ X2 ) ) ) ).

% minus_int.abs_eq
thf(fact_5549_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu4: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N2: nat] :
                    ( ( semiring_1_of_nat @ A @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_5550_graph__map__of__if__distinct__dom,axiom,
    ! [B: $tType,A: $tType,Al: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Al ) )
     => ( ( graph @ A @ B @ ( map_of @ A @ B @ Al ) )
        = ( set2 @ ( product_prod @ A @ B ) @ Al ) ) ) ).

% graph_map_of_if_distinct_dom
thf(fact_5551_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L ) )
        = ( set2 @ A @ ( take @ A @ L @ Xs ) ) ) ) ).

% nth_image
thf(fact_5552_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N5: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N5 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N5 ) ) ).

% bij_betw_Suc
thf(fact_5553_image__ident,axiom,
    ! [A: $tType,Y6: set @ A] :
      ( ( image @ A @ A
        @ ^ [X6: A] : X6
        @ Y6 )
      = Y6 ) ).

% image_ident
thf(fact_5554_image__Suc__atLeastAtMost,axiom,
    ! [I3: nat,J2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ I3 @ J2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( suc @ I3 ) @ ( suc @ J2 ) ) ) ).

% image_Suc_atLeastAtMost
thf(fact_5555_image__Suc__atLeastLessThan,axiom,
    ! [I3: nat,J2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ I3 @ J2 ) )
      = ( set_or7035219750837199246ssThan @ nat @ ( suc @ I3 ) @ ( suc @ J2 ) ) ) ).

% image_Suc_atLeastLessThan
thf(fact_5556_Gcd__int__eq,axiom,
    ! [N5: set @ nat] :
      ( ( gcd_Gcd @ int @ ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ N5 ) )
      = ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ N5 ) ) ) ).

% Gcd_int_eq
thf(fact_5557_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S3 )
          = S3 ) ) ).

% image_add_0
thf(fact_5558_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I3 @ J2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_5559_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I3 @ J2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_5560_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A2 ) ) ) ) ).

% image_add_atMost
thf(fact_5561_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A,B5: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 @ B5 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 )
            = B5 ) ) ) ).

% bij_betw_add
thf(fact_5562_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F3: A > B,V: list @ A] :
      ( ( set2 @ B @ ( map @ A @ B @ F3 @ V ) )
      = ( image @ A @ B @ F3 @ ( set2 @ A @ V ) ) ) ).

% list.set_map
thf(fact_5563_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_5564_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J2: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I3 @ J2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_5565_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( image @ A @ A
            @ ^ [T2: A] : ( minus_minus @ A @ T2 @ D2 )
            @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ).

% image_minus_const_atLeastAtMost'
thf(fact_5566_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J2: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I3 @ J2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_5567_graph__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B
        @ ^ [X6: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% graph_empty
thf(fact_5568_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_5569_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C4: A] : ( divide_divide @ A @ C4 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_5570_image__set,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( image @ B @ A @ F3 @ ( set2 @ B @ Xs ) )
      = ( set2 @ A @ ( map @ B @ A @ F3 @ Xs ) ) ) ).

% image_set
thf(fact_5571_zero__notin__Suc__image,axiom,
    ! [A3: set @ nat] :
      ~ ( member @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A3 ) ) ).

% zero_notin_Suc_image
thf(fact_5572_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T3: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( minus_minus @ ( set @ A ) @ S @ T3 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T3 ) ) ) ) ).

% translation_diff
thf(fact_5573_imageE,axiom,
    ! [A: $tType,B: $tType,B2: A,F3: B > A,A3: set @ B] :
      ( ( member @ A @ B2 @ ( image @ B @ A @ F3 @ A3 ) )
     => ~ ! [X7: B] :
            ( ( B2
              = ( F3 @ X7 ) )
           => ~ ( member @ B @ X7 @ A3 ) ) ) ).

% imageE
thf(fact_5574_image__image,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: B > A,G: C > B,A3: set @ C] :
      ( ( image @ B @ A @ F3 @ ( image @ C @ B @ G @ A3 ) )
      = ( image @ C @ A
        @ ^ [X6: C] : ( F3 @ ( G @ X6 ) )
        @ A3 ) ) ).

% image_image
thf(fact_5575_Compr__image__eq,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B,P3: A > $o] :
      ( ( collect @ A
        @ ^ [X6: A] :
            ( ( member @ A @ X6 @ ( image @ B @ A @ F3 @ A3 ) )
            & ( P3 @ X6 ) ) )
      = ( image @ B @ A @ F3
        @ ( collect @ B
          @ ^ [X6: B] :
              ( ( member @ B @ X6 @ A3 )
              & ( P3 @ ( F3 @ X6 ) ) ) ) ) ) ).

% Compr_image_eq
thf(fact_5576_pigeonhole__infinite,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F3: A > B] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ ( image @ A @ B @ F3 @ A3 ) )
       => ? [X7: A] :
            ( ( member @ A @ X7 @ A3 )
            & ~ ( finite_finite2 @ A
                @ ( collect @ A
                  @ ^ [A5: A] :
                      ( ( member @ A @ A5 @ A3 )
                      & ( ( F3 @ A5 )
                        = ( F3 @ X7 ) ) ) ) ) ) ) ) ).

% pigeonhole_infinite
thf(fact_5577_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T3: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ T3 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T3 ) ) ) ) ).

% translation_Compl
thf(fact_5578_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A7: set @ A] :
          ? [N2: nat,F5: nat > A] :
            ( A7
            = ( image @ nat @ A @ F5
              @ ( collect @ nat
                @ ^ [I: nat] : ( ord_less @ nat @ I @ N2 ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_5579_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set @ A,F3: nat > A,N: nat] :
      ( ( A3
        = ( image @ nat @ A @ F3
          @ ( collect @ nat
            @ ^ [I: nat] : ( ord_less @ nat @ I @ N ) ) ) )
     => ( finite_finite2 @ A @ A3 ) ) ).

% nat_seg_image_imp_finite
thf(fact_5580_image__constant,axiom,
    ! [A: $tType,B: $tType,X2: A,A3: set @ A,C2: B] :
      ( ( member @ A @ X2 @ A3 )
     => ( ( image @ A @ B
          @ ^ [X6: A] : C2
          @ A3 )
        = ( insert @ B @ C2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ).

% image_constant
thf(fact_5581_image__constant__conv,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,C2: A] :
      ( ( ( A3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image @ B @ A
            @ ^ [X6: B] : C2
            @ A3 )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image @ B @ A
            @ ^ [X6: B] : C2
            @ A3 )
          = ( insert @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_constant_conv
thf(fact_5582_sum_Oimage__gen,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,H: B > A,G: B > C] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ H @ S3 )
            = ( groups7311177749621191930dd_sum @ C @ A
              @ ^ [Y: C] :
                  ( groups7311177749621191930dd_sum @ B @ A @ H
                  @ ( collect @ B
                    @ ^ [X6: B] :
                        ( ( member @ B @ X6 @ S3 )
                        & ( ( G @ X6 )
                          = Y ) ) ) )
              @ ( image @ B @ C @ G @ S3 ) ) ) ) ) ).

% sum.image_gen
thf(fact_5583_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T3: set @ A] :
          ( ( image @ A @ A
            @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
            @ ( minus_minus @ ( set @ A ) @ S @ T3 ) )
          = ( minus_minus @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
              @ S )
            @ ( image @ A @ A
              @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
              @ T3 ) ) ) ) ).

% translation_subtract_diff
thf(fact_5584_prod_Oimage__gen,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,H: B > A,G: B > C] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ H @ S3 )
            = ( groups7121269368397514597t_prod @ C @ A
              @ ^ [Y: C] :
                  ( groups7121269368397514597t_prod @ B @ A @ H
                  @ ( collect @ B
                    @ ^ [X6: B] :
                        ( ( member @ B @ X6 @ S3 )
                        & ( ( G @ X6 )
                          = Y ) ) ) )
              @ ( image @ B @ C @ G @ S3 ) ) ) ) ) ).

% prod.image_gen
thf(fact_5585_Gcd__int__greater__eq__0,axiom,
    ! [K5: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K5 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_5586_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T3: set @ A] :
          ( ( image @ A @ A
            @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
            @ ( uminus_uminus @ ( set @ A ) @ T3 ) )
          = ( uminus_uminus @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
              @ T3 ) ) ) ) ).

% translation_subtract_Compl
thf(fact_5587_Gcd__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( dvd_dvd @ A @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
         => ( dvd_dvd @ A @ ( gcd_Gcd @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( gcd_Gcd @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% Gcd_mono
thf(fact_5588_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T5: set @ C,G: B > C,H: B > A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( finite_finite2 @ C @ T5 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S3 ) @ T5 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H
                      @ ( collect @ B
                        @ ^ [X6: B] :
                            ( ( member @ B @ X6 @ S3 )
                            & ( ( G @ X6 )
                              = Y ) ) ) )
                  @ T5 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H @ S3 ) ) ) ) ) ) ).

% sum.group
thf(fact_5589_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T5: set @ C,G: B > C,H: B > A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( finite_finite2 @ C @ T5 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S3 ) @ T5 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H
                      @ ( collect @ B
                        @ ^ [X6: B] :
                            ( ( member @ B @ X6 @ S3 )
                            & ( ( G @ X6 )
                              = Y ) ) ) )
                  @ T5 )
                = ( groups7121269368397514597t_prod @ B @ A @ H @ S3 ) ) ) ) ) ) ).

% prod.group
thf(fact_5590_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,H: B > C,G: C > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [X7: B,Y5: B] :
                ( ( member @ B @ X7 @ A3 )
               => ( ( member @ B @ Y5 @ A3 )
                 => ( ( X7 != Y5 )
                   => ( ( ( H @ X7 )
                        = ( H @ Y5 ) )
                     => ( ( G @ ( H @ X7 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image @ B @ C @ H @ A3 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H ) @ A3 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_5591_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X2: A,Y2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y2 ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_5592_image__Suc__lessThan,axiom,
    ! [N: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ).

% image_Suc_lessThan
thf(fact_5593_image__Suc__atMost,axiom,
    ! [N: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N ) ) ) ).

% image_Suc_atMost
thf(fact_5594_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_5595_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_5596_lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_5597_atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_5598_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X2: B,Xs: list @ B] :
          ( ( distinct @ A @ ( map @ B @ A @ F3 @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) ) )
          = ( ~ ( member @ A @ ( F3 @ X2 ) @ ( image @ B @ A @ F3 @ ( set2 @ B @ Xs ) ) )
            & ( distinct @ A @ ( map @ B @ A @ F3 @ Xs ) ) ) ) ) ).

% distinct_insort_key
thf(fact_5599_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I6: set @ C,G: A > B,F3: C > A] :
          ( ( finite_finite2 @ C @ I6 )
         => ( ! [I2: C] :
                ( ( member @ C @ I2 @ I6 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F3 @ I2 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F3 @ I6 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F3 ) @ I6 ) ) ) ) ) ).

% sum_image_le
thf(fact_5600_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X2 ) @ ( times_times @ A @ C2 @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X2 @ Y2 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y2 ) @ ( times_times @ A @ C2 @ X2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_5601_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( times_times @ A @ X6 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X2 @ C2 ) @ ( times_times @ A @ Y2 @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( times_times @ A @ X6 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y2 @ C2 ) @ ( times_times @ A @ X2 @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( image @ A @ A
                @ ^ [X6: A] : ( times_times @ A @ X6 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_5602_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X6: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X6 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X6 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X6 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_5603_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X6: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X6 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X6 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X6 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_5604_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X6: A] : ( plus_plus @ A @ ( divide_divide @ A @ X6 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( plus_plus @ A @ ( divide_divide @ A @ X6 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( plus_plus @ A @ ( divide_divide @ A @ X6 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_5605_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X6: A] : ( minus_minus @ A @ ( divide_divide @ A @ X6 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( minus_minus @ A @ ( divide_divide @ A @ X6 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X6: A] : ( minus_minus @ A @ ( divide_divide @ A @ X6 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_5606_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S3: set @ A,R3: set @ B,G: A > B,F3: B > C] :
          ( ( finite_finite2 @ A @ S3 )
         => ( ( finite_finite2 @ B @ R3 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S3 ) @ R3 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X6: A] : ( F3 @ ( G @ X6 ) )
                  @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X6: A] :
                                ( ( member @ A @ X6 @ S3 )
                                & ( ( G @ X6 )
                                  = Y ) ) ) ) )
                      @ ( F3 @ Y ) )
                  @ R3 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_5607_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_5608_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y2: nat,X2: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y2 )
       => ( ( image @ nat @ nat
            @ ^ [I: nat] : ( minus_minus @ nat @ I @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X2 @ C2 ) @ ( minus_minus @ nat @ Y2 @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y2 )
       => ( ( ( ord_less @ nat @ X2 @ Y2 )
           => ( ( image @ nat @ nat
                @ ^ [I: nat] : ( minus_minus @ nat @ I @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X2 @ Y2 )
           => ( ( image @ nat @ nat
                @ ^ [I: nat] : ( minus_minus @ nat @ I @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_5609_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F3: A > B,B5: set @ B] :
      ( ! [X7: A] :
          ( ( P3 @ X7 )
         => ( member @ B @ ( F3 @ X7 ) @ B5 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ ( collect @ A @ P3 ) ) @ B5 ) ) ).

% image_Collect_subsetI
thf(fact_5610_empty__natural,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F3: A > C,G: D > B] :
      ( ( comp @ C @ ( set @ B ) @ A
        @ ^ [Uu3: C] : ( bot_bot @ ( set @ B ) )
        @ F3 )
      = ( comp @ ( set @ D ) @ ( set @ B ) @ A @ ( image @ D @ B @ G )
        @ ^ [Uu3: A] : ( bot_bot @ ( set @ D ) ) ) ) ).

% empty_natural
thf(fact_5611_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X6: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X6 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5612_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A2: A,B2: B,A3: set @ ( product_prod @ A @ B ),F3: A > B > C] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ A3 )
     => ( member @ C @ ( F3 @ A2 @ B2 ) @ ( image @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F3 ) @ A3 ) ) ) ).

% pair_imageI
thf(fact_5613_Gcd__abs__eq,axiom,
    ! [K5: set @ int] :
      ( ( gcd_Gcd @ int @ ( image @ int @ int @ ( abs_abs @ int ) @ K5 ) )
      = ( gcd_Gcd @ int @ K5 ) ) ).

% Gcd_abs_eq
thf(fact_5614_Gcd__nat__abs__eq,axiom,
    ! [K5: set @ int] :
      ( ( gcd_Gcd @ nat
        @ ( image @ int @ nat
          @ ^ [K2: int] : ( nat2 @ ( abs_abs @ int @ K2 ) )
          @ K5 ) )
      = ( nat2 @ ( gcd_Gcd @ int @ K5 ) ) ) ).

% Gcd_nat_abs_eq
thf(fact_5615_None__notin__image__Some,axiom,
    ! [A: $tType,A3: set @ A] :
      ~ ( member @ ( option @ A ) @ ( none @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ) ).

% None_notin_image_Some
thf(fact_5616_map__of__eq__dom,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( map_of @ A @ B @ Xs )
        = ( map_of @ A @ B @ Ys ) )
     => ( ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
        = ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( set2 @ ( product_prod @ A @ B ) @ Ys ) ) ) ) ).

% map_of_eq_dom
thf(fact_5617_map__of__eq__None__iff,axiom,
    ! [A: $tType,B: $tType,Xys: list @ ( product_prod @ B @ A ),X2: B] :
      ( ( ( map_of @ B @ A @ Xys @ X2 )
        = ( none @ A ) )
      = ( ~ ( member @ B @ X2 @ ( image @ ( product_prod @ B @ A ) @ B @ ( product_fst @ B @ A ) @ ( set2 @ ( product_prod @ B @ A ) @ Xys ) ) ) ) ) ).

% map_of_eq_None_iff
thf(fact_5618_subset__subseqs,axiom,
    ! [A: $tType,X15: set @ A,Xs: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X15 @ ( set2 @ A @ Xs ) )
     => ( member @ ( set @ A ) @ X15 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ) ).

% subset_subseqs
thf(fact_5619_subseqs__powset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
      = ( pow2 @ A @ ( set2 @ A @ Xs ) ) ) ).

% subseqs_powset
thf(fact_5620_conj__subset__def,axiom,
    ! [A: $tType,A3: set @ A,P3: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3
        @ ( collect @ A
          @ ^ [X6: A] :
              ( ( P3 @ X6 )
              & ( Q @ X6 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ P3 ) )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_5621_prop__restrict,axiom,
    ! [A: $tType,X2: A,Z8: set @ A,X15: set @ A,P3: A > $o] :
      ( ( member @ A @ X2 @ Z8 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z8
          @ ( collect @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ X15 )
                & ( P3 @ X6 ) ) ) )
       => ( P3 @ X2 ) ) ) ).

% prop_restrict
thf(fact_5622_Collect__restrict,axiom,
    ! [A: $tType,X15: set @ A,P3: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X6: A] :
            ( ( member @ A @ X6 @ X15 )
            & ( P3 @ X6 ) ) )
      @ X15 ) ).

% Collect_restrict
thf(fact_5623_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] :
      ( ( image @ int @ int
        @ ^ [X6: int] : ( plus_plus @ int @ X6 @ L )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U @ L ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L @ U ) ) ).

% image_add_int_atLeastLessThan
thf(fact_5624_Gcd__int__def,axiom,
    ( ( gcd_Gcd @ int )
    = ( ^ [K6: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ ( image @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K6 ) ) ) ) ) ).

% Gcd_int_def
thf(fact_5625_conj__comp__iff,axiom,
    ! [B: $tType,A: $tType,P3: B > $o,Q: B > $o,G: A > B] :
      ( ( comp @ B @ $o @ A
        @ ^ [X6: B] :
            ( ( P3 @ X6 )
            & ( Q @ X6 ) )
        @ G )
      = ( ^ [X6: A] :
            ( ( comp @ B @ $o @ A @ P3 @ G @ X6 )
            & ( comp @ B @ $o @ A @ Q @ G @ X6 ) ) ) ) ).

% conj_comp_iff
thf(fact_5626_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X6: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I: nat,J4: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J4 ) )
              @ ( rep_Integ @ X6 ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_5627_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X6: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X6 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5628_ran__distinct,axiom,
    ! [B: $tType,A: $tType,Al: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Al ) )
     => ( ( ran @ A @ B @ ( map_of @ A @ B @ Al ) )
        = ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ ( set2 @ ( product_prod @ A @ B ) @ Al ) ) ) ) ).

% ran_distinct
thf(fact_5629_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X6: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X6 ) ) ) ) ).

% uminus_int_def
thf(fact_5630_lex__take__index,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) )
     => ~ ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys ) )
             => ( ( ( take @ A @ I2 @ Xs )
                  = ( take @ A @ I2 @ Ys ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Ys @ I2 ) ) @ R ) ) ) ) ) ).

% lex_take_index
thf(fact_5631_ran__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ B @ A
        @ ^ [X6: B] : ( none @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% ran_empty
thf(fact_5632_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X6: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X6 @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X6 @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_5633_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X6: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X6 @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_5634_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X6: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X6 @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_5635_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
      = ( ? [Y: A,N2: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N2 ) @ Y ) @ R )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys
              = ( list_update @ A @ Xs @ N2 @ Y ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_5636_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = ( inc @ ( num_of_nat @ N ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_5637_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_5638_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q2 ) )
      = Q2 ) ).

% num_of_nat_numeral_eq
thf(fact_5639_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_5640_listrel1__mono,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R ) @ ( listrel1 @ A @ S ) ) ) ).

% listrel1_mono
thf(fact_5641_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_5642_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z6: A] :
              ( Z6
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_5643_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_5644_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_5645_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 ) )
        = ( ^ [X6: A,Y: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X6 @ Y ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_5646_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% listrel1_eq_len
thf(fact_5647_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_5648_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_5649_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_5650_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_5651_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_5652_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X2 @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_5653_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N ) )
        = N ) ) ).

% numeral_num_of_nat
thf(fact_5654_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_5655_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_5656_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_5657_num__of__nat__One,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_5658_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_5659_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_5660_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y2 @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_5661_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_5662_num__of__nat__double,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N @ N ) )
        = ( bit0 @ ( num_of_nat @ N ) ) ) ) ).

% num_of_nat_double
thf(fact_5663_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_5664_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_5665_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X2 @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_5666_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_5667_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R5: A > A > $o,Xs2: list @ A,Ys2: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_5668_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F3: A > B,Ks: list @ A] :
      ( ( map_of @ A @ B
        @ ( map @ A @ ( product_prod @ A @ B )
          @ ^ [K2: A] : ( product_Pair @ A @ B @ K2 @ ( F3 @ K2 ) )
          @ Ks ) )
      = ( restrict_map @ A @ B @ ( comp @ B @ ( option @ B ) @ A @ ( some @ B ) @ F3 ) @ ( set2 @ A @ Ks ) ) ) ).

% map_of_map_restrict
thf(fact_5669_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,P5: B > A,I3: B] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X6: B] :
                  ( ( member @ B @ X6 @ I6 )
                  & ( ( P5 @ X6 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I3 @ I6 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P5 @ ( insert @ B @ I3 @ I6 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P5 @ I6 ) ) )
            & ( ~ ( member @ B @ I3 @ I6 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P5 @ ( insert @ B @ I3 @ I6 ) )
                = ( times_times @ A @ ( P5 @ I3 ) @ ( groups1962203154675924110t_prod @ B @ A @ P5 @ I6 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_5670_restrict__out,axiom,
    ! [A: $tType,B: $tType,X2: A,A3: set @ A,M: A > ( option @ B )] :
      ( ~ ( member @ A @ X2 @ A3 )
     => ( ( restrict_map @ A @ B @ M @ A3 @ X2 )
        = ( none @ B ) ) ) ).

% restrict_out
thf(fact_5671_restrict__map__empty,axiom,
    ! [B: $tType,A: $tType,D4: set @ A] :
      ( ( restrict_map @ A @ B
        @ ^ [X6: A] : ( none @ B )
        @ D4 )
      = ( ^ [X6: A] : ( none @ B ) ) ) ).

% restrict_map_empty
thf(fact_5672_restrict__map__to__empty,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B )] :
      ( ( restrict_map @ A @ B @ M @ ( bot_bot @ ( set @ A ) ) )
      = ( ^ [X6: A] : ( none @ B ) ) ) ).

% restrict_map_to_empty
thf(fact_5673_restrict__map__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( restrict_map @ A @ B )
      = ( ^ [M4: A > ( option @ B ),A7: set @ A,X6: A] : ( if @ ( option @ B ) @ ( member @ A @ X6 @ A7 ) @ ( M4 @ X6 ) @ ( none @ B ) ) ) ) ).

% restrict_map_def
thf(fact_5674_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,I6: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G
            @ ( collect @ B
              @ ^ [X6: B] :
                  ( ( member @ B @ X6 @ I6 )
                  & ( ( G @ X6 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) ) ) ).

% prod.non_neutral'
thf(fact_5675_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite2 @ B @ I6 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I: B] : ( times_times @ A @ ( G @ I ) @ ( H @ I ) )
              @ I6 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) @ ( groups1962203154675924110t_prod @ B @ A @ H @ I6 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_5676_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X6: B] :
                  ( ( member @ B @ X6 @ I6 )
                  & ( ( G @ X6 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [X6: B] :
                    ( ( member @ B @ X6 @ I6 )
                    & ( ( H @ X6 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I: B] : ( times_times @ A @ ( G @ I ) @ ( H @ I ) )
                @ I6 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) @ ( groups1962203154675924110t_prod @ B @ A @ H @ I6 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_5677_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P4: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite2 @ B
                @ ( collect @ B
                  @ ^ [X6: B] :
                      ( ( member @ B @ X6 @ I7 )
                      & ( ( P4 @ X6 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P4
                @ ( collect @ B
                  @ ^ [X6: B] :
                      ( ( member @ B @ X6 @ I7 )
                      & ( ( P4 @ X6 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_5678_restrict__map__upds,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,D4: set @ A,M: A > ( option @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ D4 )
       => ( ( restrict_map @ A @ B @ ( map_upds @ A @ B @ M @ Xs @ Ys ) @ D4 )
          = ( map_upds @ A @ B @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D4 @ ( set2 @ A @ Xs ) ) ) @ Xs @ Ys ) ) ) ) ).

% restrict_map_upds
thf(fact_5679_pow_Osimps_I3_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( pow @ X2 @ ( bit1 @ Y2 ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X2 @ Y2 ) ) @ X2 ) ) ).

% pow.simps(3)
thf(fact_5680_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss ) ) ) ).

% in_set_product_lists_length
thf(fact_5681_map__upds__apply__nontin,axiom,
    ! [B: $tType,A: $tType,X2: A,Xs: list @ A,F3: A > ( option @ B ),Ys: list @ B] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( map_upds @ A @ B @ F3 @ Xs @ Ys @ X2 )
        = ( F3 @ X2 ) ) ) ).

% map_upds_apply_nontin
thf(fact_5682_map__upds__list__update2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I3: nat,M: A > ( option @ B ),Ys: list @ B,Y2: B] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I3 )
     => ( ( map_upds @ A @ B @ M @ Xs @ ( list_update @ B @ Ys @ I3 @ Y2 ) )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% map_upds_list_update2_drop
thf(fact_5683_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_5684_sqr_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N ) ) ) ) ).

% sqr.simps(2)
thf(fact_5685_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X6: num] : ( times_times @ num @ X6 @ X6 ) ) ) ).

% sqr_conv_mult
thf(fact_5686_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5687_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ! [X7: list @ A] :
          ( ( member @ ( list @ A ) @ X7 @ ( set2 @ ( list @ A ) @ Xss ) )
         => ( distinct @ A @ X7 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) ) ).

% distinct_product_lists
thf(fact_5688_pow_Osimps_I2_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( pow @ X2 @ ( bit0 @ Y2 ) )
      = ( sqr @ ( pow @ X2 @ Y2 ) ) ) ).

% pow.simps(2)
thf(fact_5689_sqr_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N ) @ N ) ) ) ) ).

% sqr.simps(3)
thf(fact_5690_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_5691_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X6: A] : X6 ) ) ) ).

% sorted_list_of_set_def
thf(fact_5692_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys2: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys2 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs2 )
                      = ( size_size @ ( list @ A ) @ Ys2 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_5693_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F3: B > A > A,N: nat,X2: B] :
      ( ( foldr @ B @ A @ F3 @ ( replicate @ B @ N @ X2 ) )
      = ( compow @ ( A > A ) @ N @ ( F3 @ X2 ) ) ) ).

% foldr_replicate
thf(fact_5694_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,L: list @ B,K: list @ B,F3: B > A > A,G: B > A > A] :
      ( ( A2 = B2 )
     => ( ( L = K )
       => ( ! [A4: A,X7: B] :
              ( ( member @ B @ X7 @ ( set2 @ B @ L ) )
             => ( ( F3 @ X7 @ A4 )
                = ( G @ X7 @ A4 ) ) )
         => ( ( foldr @ B @ A @ F3 @ L @ A2 )
            = ( foldr @ B @ A @ G @ K @ B2 ) ) ) ) ) ).

% foldr_cong
thf(fact_5695_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: B > A > A,F3: C > B,Xs: list @ C,A2: A] :
      ( ( foldr @ B @ A @ G @ ( map @ C @ B @ F3 @ Xs ) @ A2 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F3 ) @ Xs @ A2 ) ) ).

% foldr_map
thf(fact_5696_lenlex__irreflexive,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X7: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X7 @ X7 ) @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lenlex @ A @ R ) ) ) ).

% lenlex_irreflexive
thf(fact_5697_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs2: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs2 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_5698_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_5699_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A5: A,Xs2: list @ B] :
              ( foldr @ B @ A
              @ ^ [X6: B,B4: A] : ( plus_plus @ A @ ( F5 @ X6 ) @ ( times_times @ A @ A5 @ B4 ) )
              @ Xs2
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_5700_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys4: list @ A] :
            ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys4 ) )
       => ( ! [Ys4: list @ A,Zs2: list @ A] :
              ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys4 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_5701_Some__image__these__eq,axiom,
    ! [A: $tType,A3: set @ ( option @ A )] :
      ( ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( these @ A @ A3 ) )
      = ( collect @ ( option @ A )
        @ ^ [X6: option @ A] :
            ( ( member @ ( option @ A ) @ X6 @ A3 )
            & ( X6
             != ( none @ A ) ) ) ) ) ).

% Some_image_these_eq
thf(fact_5702_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P3: B > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X6: B] : ( zero_neq_one_of_bool @ A @ ( P3 @ X6 ) )
                @ A3 )
              = ( semiring_1_of_nat @ A @ ( finite_card @ B @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P3 ) ) ) ) ) ) ) ) ).

% sum_of_bool_eq
thf(fact_5703_these__empty,axiom,
    ! [A: $tType] :
      ( ( these @ A @ ( bot_bot @ ( set @ ( option @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% these_empty
thf(fact_5704_these__insert__None,axiom,
    ! [A: $tType,A3: set @ ( option @ A )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( none @ A ) @ A3 ) )
      = ( these @ A @ A3 ) ) ).

% these_insert_None
thf(fact_5705_these__insert__Some,axiom,
    ! [A: $tType,X2: A,A3: set @ ( option @ A )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( some @ A @ X2 ) @ A3 ) )
      = ( insert @ A @ X2 @ ( these @ A @ A3 ) ) ) ).

% these_insert_Some
thf(fact_5706_these__image__Some__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( these @ A @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) )
      = A3 ) ).

% these_image_Some_eq
thf(fact_5707_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P3: B > $o,F3: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X6: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P3 @ X6 ) ) @ ( F3 @ X6 ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P3 ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_5708_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,F3: B > A,P3: B > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X6: B] : ( times_times @ A @ ( F3 @ X6 ) @ ( zero_neq_one_of_bool @ A @ ( P3 @ X6 ) ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P3 ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_5709_Int__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( collect @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ A7 )
                & ( member @ A @ X6 @ B8 ) ) ) ) ) ).

% Int_def
thf(fact_5710_Int__Collect,axiom,
    ! [A: $tType,X2: A,A3: set @ A,P3: A > $o] :
      ( ( member @ A @ X2 @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P3 ) ) )
      = ( ( member @ A @ X2 @ A3 )
        & ( P3 @ X2 ) ) ) ).

% Int_Collect
thf(fact_5711_Collect__conj__eq,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o] :
      ( ( collect @ A
        @ ^ [X6: A] :
            ( ( P3 @ X6 )
            & ( Q @ X6 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q ) ) ) ).

% Collect_conj_eq
thf(fact_5712_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% less_infI1
thf(fact_5713_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% less_infI2
thf(fact_5714_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_5715_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_5716_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_5717_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( inf_inf @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_5718_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_5719_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_5720_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T3: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( inf_inf @ ( set @ A ) @ S @ T3 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T3 ) ) ) ) ).

% translation_Int
thf(fact_5721_in__these__eq,axiom,
    ! [A: $tType,X2: A,A3: set @ ( option @ A )] :
      ( ( member @ A @ X2 @ ( these @ A @ A3 ) )
      = ( member @ ( option @ A ) @ ( some @ A @ X2 ) @ A3 ) ) ).

% in_these_eq
thf(fact_5722_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T3: set @ A] :
          ( ( image @ A @ A
            @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
            @ ( inf_inf @ ( set @ A ) @ S @ T3 ) )
          = ( inf_inf @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
              @ S )
            @ ( image @ A @ A
              @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
              @ T3 ) ) ) ) ).

% translation_subtract_Int
thf(fact_5723_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B5: set @ B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X6: B] : ( if @ A @ ( member @ B @ X6 @ B5 ) @ ( G @ X6 ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_restrict
thf(fact_5724_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B5: set @ B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X6: B] : ( if @ A @ ( member @ B @ X6 @ B5 ) @ ( G @ X6 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_restrict
thf(fact_5725_these__empty__eq,axiom,
    ! [A: $tType,B5: set @ ( option @ A )] :
      ( ( ( these @ A @ B5 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( B5
          = ( bot_bot @ ( set @ ( option @ A ) ) ) )
        | ( B5
          = ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_empty_eq
thf(fact_5726_these__not__empty__eq,axiom,
    ! [A: $tType,B5: set @ ( option @ A )] :
      ( ( ( ( these @ A @ B5 )
         != ( bot_bot @ ( set @ A ) ) ) )
      = ( ( B5
         != ( bot_bot @ ( set @ ( option @ A ) ) ) )
        & ( B5
         != ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_not_empty_eq
thf(fact_5727_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S3: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ T5 )
         => ( ( finite_finite2 @ B @ S3 )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T5 @ S3 ) )
                 => ( ( H @ I2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ S3 @ T5 ) )
                   => ( ( G @ I2 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X7: B] :
                      ( ( member @ B @ X7 @ ( inf_inf @ ( set @ B ) @ S3 @ T5 ) )
                     => ( ( G @ X7 )
                        = ( H @ X7 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H @ T5 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_5728_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,K: A] :
          ( ( ( ord_less @ A @ X2 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X2 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_5729_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B5: set @ B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B5 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_5730_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B5: set @ B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B5 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_5731_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,P3: B > $o,H: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X6: B] : ( if @ A @ ( P3 @ X6 ) @ ( H @ X6 ) @ ( G @ X6 ) )
              @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P3 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P3 ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_5732_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,P3: B > $o,H: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X6: B] : ( if @ A @ ( P3 @ X6 ) @ ( H @ X6 ) @ ( G @ X6 ) )
              @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P3 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P3 ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_5733_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: set @ B,F3: B > A,B2: A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A5: B] : ( divide_divide @ A @ ( F3 @ A5 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A3
                  @ ( collect @ B
                    @ ^ [A5: B] : ( dvd_dvd @ A @ B2 @ ( F3 @ A5 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F3
                  @ ( inf_inf @ ( set @ B ) @ A3
                    @ ( collect @ B
                      @ ^ [A5: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F3 @ A5 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_5734_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys2: list @ A] :
            ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys2 ) )
        & ! [Ys2: list @ A,Zs3: list @ A] :
            ( ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys2 != Zs3 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys2 ) @ ( set2 @ A @ Zs3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_5735_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_5736_card__partition,axiom,
    ! [A: $tType,C6: set @ ( set @ A ),K: nat] :
      ( ( finite_finite2 @ ( set @ A ) @ C6 )
     => ( ( finite_finite2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) )
       => ( ! [C3: set @ A] :
              ( ( member @ ( set @ A ) @ C3 @ C6 )
             => ( ( finite_card @ A @ C3 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C6 )
               => ( ( member @ ( set @ A ) @ C22 @ C6 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C6 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_5737_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( ( map @ B @ A @ F3 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% map_is_Nil_conv
thf(fact_5738_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F3 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% Nil_is_map_conv
thf(fact_5739_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A2: list @ A] :
      ( ( ( map @ A @ B @ F3 @ A2 )
        = ( nil @ B ) )
      = ( A2
        = ( nil @ A ) ) ) ).

% list.map_disc_iff
thf(fact_5740_upt__conv__Nil,axiom,
    ! [J2: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I3 )
     => ( ( upt @ I3 @ J2 )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_5741_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X2: A] :
      ( ( ( list_update @ A @ Xs @ K @ X2 )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_update_nonempty
thf(fact_5742_concat__replicate__trivial,axiom,
    ! [A: $tType,I3: nat] :
      ( ( concat @ A @ ( replicate @ ( list @ A ) @ I3 @ ( nil @ A ) ) )
      = ( nil @ A ) ) ).

% concat_replicate_trivial
thf(fact_5743_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_in_shuffles
thf(fact_5744_map__of__eq__empty__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list @ ( product_prod @ A @ B )] :
      ( ( ( map_of @ A @ B @ Xys )
        = ( ^ [X6: A] : ( none @ B ) ) )
      = ( Xys
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% map_of_eq_empty_iff
thf(fact_5745_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N: nat] :
      ( ( enumerate @ A @ N @ ( nil @ A ) )
      = ( nil @ ( product_prod @ nat @ A ) ) ) ).

% enumerate_simps(1)
thf(fact_5746_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate1_is_Nil_conv
thf(fact_5747_empty__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X6: A] : ( none @ B ) )
        = ( map_of @ A @ B @ Xys ) )
      = ( Xys
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% empty_eq_map_of_iff
thf(fact_5748_finite__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] : ( finite_finite2 @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ).

% finite_shuffles
thf(fact_5749_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_5750_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_5751_length__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( zero_zero @ nat ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_5752_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_atLeastLessThan
thf(fact_5753_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_5754_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_5755_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs2: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_5756_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_5757_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N @ Xs ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_5758_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_5759_empty__replicate,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X2 ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_5760_replicate__empty,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( ( replicate @ A @ N @ X2 )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_5761_upt__eq__Nil__conv,axiom,
    ! [I3: nat,J2: nat] :
      ( ( ( upt @ I3 @ J2 )
        = ( nil @ nat ) )
      = ( ( J2
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J2 @ I3 ) ) ) ).

% upt_eq_Nil_conv
thf(fact_5762_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_5763_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite2 @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ A3 )
            = ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
thf(fact_5764_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F3: B > A,A2: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_5765_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_5766_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( nil @ A )
        = ( concat @ A @ Xss ) )
      = ( ! [X6: list @ A] :
            ( ( member @ ( list @ A ) @ X6 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X6
              = ( nil @ A ) ) ) ) ) ).

% Nil_eq_concat_conv
thf(fact_5767_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xss )
        = ( nil @ A ) )
      = ( ! [X6: list @ A] :
            ( ( member @ ( list @ A ) @ X6 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X6
              = ( nil @ A ) ) ) ) ) ).

% concat_eq_Nil_conv
thf(fact_5768_finite__UN__I,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B5: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [A4: A] :
            ( ( member @ A @ A4 @ A3 )
           => ( finite_finite2 @ B @ ( B5 @ A4 ) ) )
       => ( finite_finite2 @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) ) ) ) ).

% finite_UN_I
thf(fact_5769_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( Xs
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_5770_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( nil @ A ) )
            = ( A3
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5771_set__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs ) ) ) ) ).

% set_concat
thf(fact_5772_inf__set__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( collect @ A
            @ ( inf_inf @ ( A > $o )
              @ ^ [X6: A] : ( member @ A @ X6 @ A7 )
              @ ^ [X6: A] : ( member @ A @ X6 @ B8 ) ) ) ) ) ).

% inf_set_def
thf(fact_5773_inf__Int__eq,axiom,
    ! [A: $tType,R3: set @ A,S3: set @ A] :
      ( ( inf_inf @ ( A > $o )
        @ ^ [X6: A] : ( member @ A @ X6 @ R3 )
        @ ^ [X6: A] : ( member @ A @ X6 @ S3 ) )
      = ( ^ [X6: A] : ( member @ A @ X6 @ ( inf_inf @ ( set @ A ) @ R3 @ S3 ) ) ) ) ).

% inf_Int_eq
thf(fact_5774_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( inf_inf @ ( A > B > $o )
        @ ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ R3 )
        @ ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ S3 ) )
      = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S3 ) ) ) ) ).

% inf_Int_eq2
thf(fact_5775_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X2: A] :
      ( ( removeAll @ A @ X2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% removeAll.simps(1)
thf(fact_5776_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,A2: B,Xs: list @ B] :
          ( ( linorder_insort_key @ B @ A @ F3 @ A2 @ Xs )
         != ( nil @ B ) ) ) ).

% insort_not_Nil
thf(fact_5777_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rotate1.simps(1)
thf(fact_5778_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X2: A] :
      ( ( remove1 @ A @ X2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remove1.simps(1)
thf(fact_5779_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_5780_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys )
      = ( insert @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_5781_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P3: A > A > $o] : ( sorted_wrt @ A @ P3 @ ( nil @ A ) ) ).

% sorted_wrt.simps(1)
thf(fact_5782_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F3: A > B] :
      ( ( map @ A @ B @ F3 @ ( nil @ A ) )
      = ( nil @ B ) ) ).

% list.simps(8)
thf(fact_5783_concat_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( concat @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ A ) ) ).

% concat.simps(1)
thf(fact_5784_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu: list @ B] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% product.simps(1)
thf(fact_5785_shuffles__commutes,axiom,
    ! [A: $tType] :
      ( ( shuffles @ A )
      = ( ^ [Xs2: list @ A,Ys2: list @ A] : ( shuffles @ A @ Ys2 @ Xs2 ) ) ) ).

% shuffles_commutes
thf(fact_5786_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( Ys
          = ( nil @ A ) )
       => ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% Nil_in_shufflesI
thf(fact_5787_take__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( take @ A @ N @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% take_Nil
thf(fact_5788_list__update__code_I1_J,axiom,
    ! [A: $tType,I3: nat,Y2: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I3 @ Y2 )
      = ( nil @ A ) ) ).

% list_update_code(1)
thf(fact_5789_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I3: nat,V: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I3 @ V )
      = ( nil @ A ) ) ).

% list_update.simps(1)
thf(fact_5790_in__Union__o__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,X2: A,Gset: B > ( set @ ( set @ A ) ),Gmap: C > B,A3: C] :
      ( ( member @ A @ X2 @ ( comp @ B @ ( set @ A ) @ C @ ( comp @ ( set @ ( set @ A ) ) @ ( set @ A ) @ B @ ( complete_Sup_Sup @ ( set @ A ) ) @ Gset ) @ Gmap @ A3 ) )
     => ( member @ A @ X2 @ ( comp @ ( set @ ( set @ A ) ) @ ( set @ A ) @ C @ ( complete_Sup_Sup @ ( set @ A ) ) @ ( comp @ B @ ( set @ ( set @ A ) ) @ C @ Gset @ Gmap ) @ A3 ) ) ) ).

% in_Union_o_assoc
thf(fact_5791_Union__natural,axiom,
    ! [B: $tType,A: $tType,F3: A > B] :
      ( ( comp @ ( set @ ( set @ B ) ) @ ( set @ B ) @ ( set @ ( set @ A ) ) @ ( complete_Sup_Sup @ ( set @ B ) ) @ ( image @ ( set @ A ) @ ( set @ B ) @ ( image @ A @ B @ F3 ) ) )
      = ( comp @ ( set @ A ) @ ( set @ B ) @ ( set @ ( set @ A ) ) @ ( image @ A @ B @ F3 ) @ ( complete_Sup_Sup @ ( set @ A ) ) ) ) ).

% Union_natural
thf(fact_5792_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : ( distinct @ A @ ( nil @ A ) ) ).

% distinct.simps(1)
thf(fact_5793_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_5794_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_5795_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_5796_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_5797_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ) ).

% length_shuffles
thf(fact_5798_take__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs )
      = ( nil @ A ) ) ).

% take_0
thf(fact_5799_replicate__0,axiom,
    ! [A: $tType,X2: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X2 )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_5800_upt__0,axiom,
    ! [I3: nat] :
      ( ( upt @ I3 @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_5801_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F3: B > A,B5: set @ B,A2: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ B5 ) ) @ A2 )
          = ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [B4: B] : ( inf_inf @ A @ ( F3 @ B4 ) @ A2 )
              @ B5 ) ) ) ) ).

% SUP_inf
thf(fact_5802_Sup__inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B5: set @ A,A2: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B5 ) @ A2 )
          = ( complete_Sup_Sup @ A
            @ ( image @ A @ A
              @ ^ [B4: A] : ( inf_inf @ A @ B4 @ A2 )
              @ B5 ) ) ) ) ).

% Sup_inf
thf(fact_5803_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A2: A,F3: B > A,B5: set @ B] :
          ( ( inf_inf @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ B5 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [B4: B] : ( inf_inf @ A @ A2 @ ( F3 @ B4 ) )
              @ B5 ) ) ) ) ).

% inf_SUP
thf(fact_5804_SUP__inf__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F3: B > A,A3: set @ B,G: C > A,B5: set @ C] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B5 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [A5: B] :
                  ( complete_Sup_Sup @ A
                  @ ( image @ C @ A
                    @ ^ [B4: C] : ( inf_inf @ A @ ( F3 @ A5 ) @ ( G @ B4 ) )
                    @ B5 ) )
              @ A3 ) ) ) ) ).

% SUP_inf_distrib2
thf(fact_5805_map__of_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_of @ A @ B @ ( nil @ ( product_prod @ A @ B ) ) )
      = ( ^ [X6: A] : ( none @ B ) ) ) ).

% map_of.simps(1)
thf(fact_5806_map__of__Cons__code_I1_J,axiom,
    ! [B: $tType,A: $tType,K: B] :
      ( ( map_of @ B @ A @ ( nil @ ( product_prod @ B @ A ) ) @ K )
      = ( none @ A ) ) ).

% map_of_Cons_code(1)
thf(fact_5807_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R ) ) ).

% not_listrel1_Nil
thf(fact_5808_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R ) ) ).

% not_Nil_listrel1
thf(fact_5809_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X2: A > nat] :
      ( ( size_list @ A @ X2 @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_5810_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F3: B > ( set @ A ),G: C > ( set @ B ),X2: C,X15: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ ( G @ X2 ) ) ) @ X15 )
      = ( ord_less_eq @ ( set @ B ) @ ( G @ X2 )
        @ ( collect @ B
          @ ^ [X6: B] : ( ord_less_eq @ ( set @ A ) @ ( F3 @ X6 ) @ X15 ) ) ) ) ).

% UN_image_subset
thf(fact_5811_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) @ ( lex @ A @ R ) ) ).

% Nil_notin_lex
thf(fact_5812_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( lex @ A @ R ) ) ).

% Nil2_notin_lex
thf(fact_5813_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R ) ) ).

% Nil_lenlex_iff2
thf(fact_5814_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y2: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y2 )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_5815_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B5: set @ ( set @ B ),G: B > A] :
          ( ! [X7: set @ B] :
              ( ( member @ ( set @ B ) @ X7 @ B5 )
             => ( finite_finite2 @ B @ X7 ) )
         => ( ! [A13: set @ B] :
                ( ( member @ ( set @ B ) @ A13 @ B5 )
               => ! [A24: set @ B] :
                    ( ( member @ ( set @ B ) @ A24 @ B5 )
                   => ( ( A13 != A24 )
                     => ! [X7: B] :
                          ( ( member @ B @ X7 @ A13 )
                         => ( ( member @ B @ X7 @ A24 )
                           => ( ( G @ X7 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B5 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ B5 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_5816_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_5817_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I: nat] : ( M7 @ ( plus_plus @ nat @ I @ K ) )
          @ ( set_ord_lessThan @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_5818_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I: nat] : ( M7 @ ( plus_plus @ nat @ I @ K ) )
          @ ( set_ord_atMost @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_5819_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_5820_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F3: A > B,G: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F3 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_5821_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_5822_sum_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,A3: B > ( set @ C ),G: C > A] :
          ( ( finite_finite2 @ B @ I6 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ I6 )
               => ( finite_finite2 @ C @ ( A3 @ X7 ) ) )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ I6 )
                 => ! [Xa2: B] :
                      ( ( member @ B @ Xa2 @ I6 )
                     => ( ( X7 != Xa2 )
                       => ( ( inf_inf @ ( set @ C ) @ ( A3 @ X7 ) @ ( A3 @ Xa2 ) )
                          = ( bot_bot @ ( set @ C ) ) ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ B @ ( set @ C ) @ A3 @ I6 ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [X6: B] : ( groups7311177749621191930dd_sum @ C @ A @ G @ ( A3 @ X6 ) )
                  @ I6 ) ) ) ) ) ) ).

% sum.UNION_disjoint
thf(fact_5823_prod_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,A3: B > ( set @ C ),G: C > A] :
          ( ( finite_finite2 @ B @ I6 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ I6 )
               => ( finite_finite2 @ C @ ( A3 @ X7 ) ) )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ I6 )
                 => ! [Xa2: B] :
                      ( ( member @ B @ Xa2 @ I6 )
                     => ( ( X7 != Xa2 )
                       => ( ( inf_inf @ ( set @ C ) @ ( A3 @ X7 ) @ ( A3 @ Xa2 ) )
                          = ( bot_bot @ ( set @ C ) ) ) ) ) )
             => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ B @ ( set @ C ) @ A3 @ I6 ) ) )
                = ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [X6: B] : ( groups7121269368397514597t_prod @ C @ A @ G @ ( A3 @ X6 ) )
                  @ I6 ) ) ) ) ) ) ).

% prod.UNION_disjoint
thf(fact_5824_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ I6 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I: A] : ( finite_card @ B @ ( A3 @ I ) )
          @ I6 ) ) ) ).

% card_UN_le
thf(fact_5825_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 )
              = ( nil @ B ) )
            = ( A3
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5826_card__UN__disjoint,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ I6 )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ I6 )
           => ( finite_finite2 @ B @ ( A3 @ X7 ) ) )
       => ( ! [X7: A] :
              ( ( member @ A @ X7 @ I6 )
             => ! [Xa2: A] :
                  ( ( member @ A @ Xa2 @ I6 )
                 => ( ( X7 != Xa2 )
                   => ( ( inf_inf @ ( set @ B ) @ ( A3 @ X7 ) @ ( A3 @ Xa2 ) )
                      = ( bot_bot @ ( set @ B ) ) ) ) ) )
         => ( ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I: A] : ( finite_card @ B @ ( A3 @ I ) )
              @ I6 ) ) ) ) ) ).

% card_UN_disjoint
thf(fact_5827_UN__singleton,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ A @ ( set @ A )
          @ ^ [X6: A] : ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) )
          @ A3 ) )
      = A3 ) ).

% UN_singleton
thf(fact_5828_UN__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C6: set @ B,A2: A,B5: B > ( set @ A )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [X6: B] : ( insert @ A @ A2 @ ( B5 @ X6 ) )
              @ C6 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [X6: B] : ( insert @ A @ A2 @ ( B5 @ X6 ) )
              @ C6 ) )
          = ( insert @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ C6 ) ) ) ) ) ) ).

% UN_simps(1)
thf(fact_5829_ccSUP__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [F3: B > A] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ ( bot_bot @ ( set @ B ) ) ) )
          = ( bot_bot @ A ) ) ) ).

% ccSUP_empty
thf(fact_5830_Sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup @ B )
     => ( ( complete_Sup_Sup @ ( A > B ) )
        = ( ^ [A7: set @ ( A > B ),X6: A] :
              ( complete_Sup_Sup @ B
              @ ( image @ ( A > B ) @ B
                @ ^ [F5: A > B] : ( F5 @ X6 )
                @ A7 ) ) ) ) ) ).

% Sup_apply
thf(fact_5831_SUP__identity__eq,axiom,
    ! [A: $tType] :
      ( ( complete_Sup @ A )
     => ! [A3: set @ A] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ A @ A
              @ ^ [X6: A] : X6
              @ A3 ) )
          = ( complete_Sup_Sup @ A @ A3 ) ) ) ).

% SUP_identity_eq
thf(fact_5832_SUP__apply,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( complete_Sup @ A )
     => ! [F3: C > B > A,A3: set @ C,X2: B] :
          ( ( complete_Sup_Sup @ ( B > A ) @ ( image @ C @ ( B > A ) @ F3 @ A3 ) @ X2 )
          = ( complete_Sup_Sup @ A
            @ ( image @ C @ A
              @ ^ [Y: C] : ( F3 @ Y @ X2 )
              @ A3 ) ) ) ) ).

% SUP_apply
thf(fact_5833_UN__I,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B2: B,B5: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( member @ B @ B2 @ ( B5 @ A2 ) )
       => ( member @ B @ B2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) ) ) ) ).

% UN_I
thf(fact_5834_UN__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,B5: B > ( set @ A ),A3: set @ B] :
      ( ( member @ A @ B2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
      = ( ? [X6: B] :
            ( ( member @ B @ X6 @ A3 )
            & ( member @ A @ B2 @ ( B5 @ X6 ) ) ) ) ) ).

% UN_iff
thf(fact_5835_ccSUP__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [X6: B] : ( bot_bot @ A )
              @ A3 ) )
          = ( bot_bot @ A ) ) ) ).

% ccSUP_bot
thf(fact_5836_SUP__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [X6: B] : ( bot_bot @ A )
              @ A3 ) )
          = ( bot_bot @ A ) ) ) ).

% SUP_bot
thf(fact_5837_SUP__bot__conv_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: B > A,A3: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ B5 @ A3 ) )
            = ( bot_bot @ A ) )
          = ( ! [X6: B] :
                ( ( member @ B @ X6 @ A3 )
               => ( ( B5 @ X6 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% SUP_bot_conv(1)
thf(fact_5838_SUP__bot__conv_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: B > A,A3: set @ B] :
          ( ( ( bot_bot @ A )
            = ( complete_Sup_Sup @ A @ ( image @ B @ A @ B5 @ A3 ) ) )
          = ( ! [X6: B] :
                ( ( member @ B @ X6 @ A3 )
               => ( ( B5 @ X6 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% SUP_bot_conv(2)
thf(fact_5839_ccSUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,F3: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image @ B @ A
                @ ^ [I: B] : F3
                @ A3 ) )
            = F3 ) ) ) ).

% ccSUP_const
thf(fact_5840_SUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F3: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image @ B @ A
                @ ^ [I: B] : F3
                @ A3 ) )
            = F3 ) ) ) ).

% SUP_const
thf(fact_5841_UN__constant,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,C2: set @ A] :
      ( ( ( A3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [Y: B] : C2
              @ A3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [Y: B] : C2
              @ A3 ) )
          = C2 ) ) ) ).

% UN_constant
thf(fact_5842_Sup__set__def,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) )
      = ( ^ [A7: set @ ( set @ A )] :
            ( collect @ A
            @ ^ [X6: A] : ( complete_Sup_Sup @ $o @ ( image @ ( set @ A ) @ $o @ ( member @ A @ X6 ) @ A7 ) ) ) ) ) ).

% Sup_set_def
thf(fact_5843_SUP__Sup__eq,axiom,
    ! [A: $tType,S3: set @ ( set @ A )] :
      ( ( complete_Sup_Sup @ ( A > $o )
        @ ( image @ ( set @ A ) @ ( A > $o )
          @ ^ [I: set @ A,X6: A] : ( member @ A @ X6 @ I )
          @ S3 ) )
      = ( ^ [X6: A] : ( member @ A @ X6 @ ( complete_Sup_Sup @ ( set @ A ) @ S3 ) ) ) ) ).

% SUP_Sup_eq
thf(fact_5844_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I: set @ ( product_prod @ A @ B ),X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ I )
          @ S3 ) )
      = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ S3 ) ) ) ) ).

% SUP_Sup_eq2
thf(fact_5845_SUP__UN__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R: C > ( set @ ( product_prod @ A @ B ) ),S3: set @ C] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image @ C @ ( A > B > $o )
          @ ^ [I: C,X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( R @ I ) )
          @ S3 ) )
      = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ C @ ( set @ ( product_prod @ A @ B ) ) @ R @ S3 ) ) ) ) ) ).

% SUP_UN_eq2
thf(fact_5846_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup_Sup @ ( A > B > $o ) )
      = ( ^ [S6: set @ ( A > B > $o ),X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S6 ) ) ) ) ) ) ).

% Sup_SUP_eq2
thf(fact_5847_SUP__UN__eq,axiom,
    ! [B: $tType,A: $tType,R: B > ( set @ A ),S3: set @ B] :
      ( ( complete_Sup_Sup @ ( A > $o )
        @ ( image @ B @ ( A > $o )
          @ ^ [I: B,X6: A] : ( member @ A @ X6 @ ( R @ I ) )
          @ S3 ) )
      = ( ^ [X6: A] : ( member @ A @ X6 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ R @ S3 ) ) ) ) ) ).

% SUP_UN_eq
thf(fact_5848_Sup_OSUP__identity__eq,axiom,
    ! [A: $tType,Sup: ( set @ A ) > A,A3: set @ A] :
      ( ( Sup
        @ ( image @ A @ A
          @ ^ [X6: A] : X6
          @ A3 ) )
      = ( Sup @ A3 ) ) ).

% Sup.SUP_identity_eq
thf(fact_5849_Inf_OINF__identity__eq,axiom,
    ! [A: $tType,Inf: ( set @ A ) > A,A3: set @ A] :
      ( ( Inf
        @ ( image @ A @ A
          @ ^ [X6: A] : X6
          @ A3 ) )
      = ( Inf @ A3 ) ) ).

% Inf.INF_identity_eq
thf(fact_5850_Sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup @ B )
     => ( ( complete_Sup_Sup @ ( A > B ) )
        = ( ^ [A7: set @ ( A > B ),X6: A] :
              ( complete_Sup_Sup @ B
              @ ( image @ ( A > B ) @ B
                @ ^ [F5: A > B] : ( F5 @ X6 )
                @ A7 ) ) ) ) ) ).

% Sup_fun_def
thf(fact_5851_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S3: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S3 ) )
          = ( ? [X6: A] :
                ( ( member @ A @ X6 @ S3 )
                & ( ord_less @ A @ A2 @ X6 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_5852_SUP__commute,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > C > A,B5: set @ C,A3: set @ B] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [I: B] : ( complete_Sup_Sup @ A @ ( image @ C @ A @ ( F3 @ I ) @ B5 ) )
              @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ C @ A
              @ ^ [J4: C] :
                  ( complete_Sup_Sup @ A
                  @ ( image @ B @ A
                    @ ^ [I: B] : ( F3 @ I @ J4 )
                    @ A3 ) )
              @ B5 ) ) ) ) ).

% SUP_commute
thf(fact_5853_image__Union,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S3: set @ ( set @ B )] :
      ( ( image @ B @ A @ F3 @ ( complete_Sup_Sup @ ( set @ B ) @ S3 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F3 ) @ S3 ) ) ) ).

% image_Union
thf(fact_5854_Int__Union2,axiom,
    ! [A: $tType,B5: set @ ( set @ A ),A3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ B5 ) @ A3 )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ ( set @ A ) @ ( set @ A )
          @ ^ [C7: set @ A] : ( inf_inf @ ( set @ A ) @ C7 @ A3 )
          @ B5 ) ) ) ).

% Int_Union2
thf(fact_5855_Int__Union,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ B5 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( set @ A ) @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 ) @ B5 ) ) ) ).

% Int_Union
thf(fact_5856_UN__extend__simps_I9_J,axiom,
    ! [S7: $tType,R6: $tType,Q7: $tType,C6: R6 > ( set @ S7 ),B5: Q7 > ( set @ R6 ),A3: set @ Q7] :
      ( ( complete_Sup_Sup @ ( set @ S7 )
        @ ( image @ Q7 @ ( set @ S7 )
          @ ^ [X6: Q7] : ( complete_Sup_Sup @ ( set @ S7 ) @ ( image @ R6 @ ( set @ S7 ) @ C6 @ ( B5 @ X6 ) ) )
          @ A3 ) )
      = ( complete_Sup_Sup @ ( set @ S7 ) @ ( image @ R6 @ ( set @ S7 ) @ C6 @ ( complete_Sup_Sup @ ( set @ R6 ) @ ( image @ Q7 @ ( set @ R6 ) @ B5 @ A3 ) ) ) ) ) ).

% UN_extend_simps(9)
thf(fact_5857_UN__extend__simps_I8_J,axiom,
    ! [P8: $tType,O2: $tType,B5: O2 > ( set @ P8 ),A3: set @ ( set @ O2 )] :
      ( ( complete_Sup_Sup @ ( set @ P8 )
        @ ( image @ ( set @ O2 ) @ ( set @ P8 )
          @ ^ [Y: set @ O2] : ( complete_Sup_Sup @ ( set @ P8 ) @ ( image @ O2 @ ( set @ P8 ) @ B5 @ Y ) )
          @ A3 ) )
      = ( complete_Sup_Sup @ ( set @ P8 ) @ ( image @ O2 @ ( set @ P8 ) @ B5 @ ( complete_Sup_Sup @ ( set @ O2 ) @ A3 ) ) ) ) ).

% UN_extend_simps(8)
thf(fact_5858_UN__E,axiom,
    ! [A: $tType,B: $tType,B2: A,B5: B > ( set @ A ),A3: set @ B] :
      ( ( member @ A @ B2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
     => ~ ! [X7: B] :
            ( ( member @ B @ X7 @ A3 )
           => ~ ( member @ A @ B2 @ ( B5 @ X7 ) ) ) ) ).

% UN_E
thf(fact_5859_UN__UN__flatten,axiom,
    ! [A: $tType,B: $tType,C: $tType,C6: B > ( set @ A ),B5: C > ( set @ B ),A3: set @ C] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ C6 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ C @ ( set @ B ) @ B5 @ A3 ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ C @ ( set @ A )
          @ ^ [Y: C] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ C6 @ ( B5 @ Y ) ) )
          @ A3 ) ) ) ).

% UN_UN_flatten
thf(fact_5860_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ Y @ X2 )
               => ? [X6: A] :
                    ( ( member @ A @ X6 @ A3 )
                    & ( ord_less @ A @ Y @ X6 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5861_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,U: A,F3: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ( ord_less_eq @ A @ U @ ( F3 @ I3 ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_5862_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,A3: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U )
          = ( ! [X6: B] :
                ( ( member @ B @ X6 @ A3 )
               => ( ord_less_eq @ A @ ( F3 @ X6 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_5863_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F3: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ord_less_eq @ A @ ( F3 @ I3 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ).

% SUP_upper
thf(fact_5864_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ! [X7: B] : ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( G @ X7 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% SUP_mono'
thf(fact_5865_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F3: B > A,U: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_5866_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B5: set @ C,F3: B > A,G: C > A] :
          ( ! [N3: B] :
              ( ( member @ B @ N3 @ A3 )
             => ? [X: C] :
                  ( ( member @ C @ X @ B5 )
                  & ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( G @ X ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B5 ) ) ) ) ) ).

% SUP_mono
thf(fact_5867_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F3: B > A,X2: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ X2 ) )
         => ( ! [Y5: A] :
                ( ! [I4: B] :
                    ( ( member @ B @ I4 @ A3 )
                   => ( ord_less_eq @ A @ ( F3 @ I4 ) @ Y5 ) )
               => ( ord_less_eq @ A @ X2 @ Y5 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) )
              = X2 ) ) ) ) ).

% SUP_eqI
thf(fact_5868_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,A3: set @ B,Y2: A,I3: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ Y2 )
         => ( ( member @ B @ I3 @ A3 )
           => ( ord_less @ A @ ( F3 @ I3 ) @ Y2 ) ) ) ) ).

% SUP_lessD
thf(fact_5869_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F3: B > A,A3: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
          = ( ? [X6: B] :
                ( ( member @ B @ X6 @ A3 )
                & ( ord_less @ A @ A2 @ ( F3 @ X6 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_5870_UN__extend__simps_I10_J,axiom,
    ! [V6: $tType,U4: $tType,T: $tType,B5: U4 > ( set @ V6 ),F3: T > U4,A3: set @ T] :
      ( ( complete_Sup_Sup @ ( set @ V6 )
        @ ( image @ T @ ( set @ V6 )
          @ ^ [A5: T] : ( B5 @ ( F3 @ A5 ) )
          @ A3 ) )
      = ( complete_Sup_Sup @ ( set @ V6 ) @ ( image @ U4 @ ( set @ V6 ) @ B5 @ ( image @ T @ U4 @ F3 @ A3 ) ) ) ) ).

% UN_extend_simps(10)
thf(fact_5871_image__UN,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: B > A,B5: C > ( set @ B ),A3: set @ C] :
      ( ( image @ B @ A @ F3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ C @ ( set @ B ) @ B5 @ A3 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ C @ ( set @ A )
          @ ^ [X6: C] : ( image @ B @ A @ F3 @ ( B5 @ X6 ) )
          @ A3 ) ) ) ).

% image_UN
thf(fact_5872_UN__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X6: B] : ( bot_bot @ ( set @ A ) )
          @ A3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% UN_empty2
thf(fact_5873_UN__empty,axiom,
    ! [B: $tType,A: $tType,B5: B > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% UN_empty
thf(fact_5874_UNION__empty__conv_I1_J,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ A3 )
           => ( ( B5 @ X6 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% UNION_empty_conv(1)
thf(fact_5875_UNION__empty__conv_I2_J,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ A3 )
           => ( ( B5 @ X6 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% UNION_empty_conv(2)
thf(fact_5876_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I6: set @ B,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) @ B5 )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ ( A3 @ X6 ) @ B5 ) ) ) ) ).

% UN_subset_iff
thf(fact_5877_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B5: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( B5 @ A2 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) ) ) ).

% UN_upper
thf(fact_5878_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B5: A > ( set @ B ),C6: set @ B] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ ( B5 @ X7 ) @ C6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) @ C6 ) ) ).

% UN_least
thf(fact_5879_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B5: set @ A,F3: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B5 )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ B5 ) ) ) ) ) ).

% UN_mono
thf(fact_5880_UN__insert__distrib,axiom,
    ! [B: $tType,A: $tType,U: A,A3: set @ A,A2: B,B5: A > ( set @ B )] :
      ( ( member @ A @ U @ A3 )
     => ( ( complete_Sup_Sup @ ( set @ B )
          @ ( image @ A @ ( set @ B )
            @ ^ [X6: A] : ( insert @ B @ A2 @ ( B5 @ X6 ) )
            @ A3 ) )
        = ( insert @ B @ A2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) ) ) ) ).

% UN_insert_distrib
thf(fact_5881_Int__UN__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A3: B > ( set @ A ),I6: set @ B,B5: C > ( set @ A ),J5: set @ C] :
      ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B5 @ J5 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [I: B] :
              ( complete_Sup_Sup @ ( set @ A )
              @ ( image @ C @ ( set @ A )
                @ ^ [J4: C] : ( inf_inf @ ( set @ A ) @ ( A3 @ I ) @ ( B5 @ J4 ) )
                @ J5 ) )
          @ I6 ) ) ) ).

% Int_UN_distrib2
thf(fact_5882_Int__UN__distrib,axiom,
    ! [A: $tType,B: $tType,B5: set @ A,A3: B > ( set @ A ),I6: set @ B] :
      ( ( inf_inf @ ( set @ A ) @ B5 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [I: B] : ( inf_inf @ ( set @ A ) @ B5 @ ( A3 @ I ) )
          @ I6 ) ) ) ).

% Int_UN_distrib
thf(fact_5883_UN__extend__simps_I4_J,axiom,
    ! [H4: $tType,G3: $tType,A3: G3 > ( set @ H4 ),C6: set @ G3,B5: set @ H4] :
      ( ( inf_inf @ ( set @ H4 ) @ ( complete_Sup_Sup @ ( set @ H4 ) @ ( image @ G3 @ ( set @ H4 ) @ A3 @ C6 ) ) @ B5 )
      = ( complete_Sup_Sup @ ( set @ H4 )
        @ ( image @ G3 @ ( set @ H4 )
          @ ^ [X6: G3] : ( inf_inf @ ( set @ H4 ) @ ( A3 @ X6 ) @ B5 )
          @ C6 ) ) ) ).

% UN_extend_simps(4)
thf(fact_5884_UN__extend__simps_I5_J,axiom,
    ! [I5: $tType,J6: $tType,A3: set @ I5,B5: J6 > ( set @ I5 ),C6: set @ J6] :
      ( ( inf_inf @ ( set @ I5 ) @ A3 @ ( complete_Sup_Sup @ ( set @ I5 ) @ ( image @ J6 @ ( set @ I5 ) @ B5 @ C6 ) ) )
      = ( complete_Sup_Sup @ ( set @ I5 )
        @ ( image @ J6 @ ( set @ I5 )
          @ ^ [X6: J6] : ( inf_inf @ ( set @ I5 ) @ A3 @ ( B5 @ X6 ) )
          @ C6 ) ) ) ).

% UN_extend_simps(5)
thf(fact_5885_UN__extend__simps_I6_J,axiom,
    ! [L4: $tType,K9: $tType,A3: K9 > ( set @ L4 ),C6: set @ K9,B5: set @ L4] :
      ( ( minus_minus @ ( set @ L4 ) @ ( complete_Sup_Sup @ ( set @ L4 ) @ ( image @ K9 @ ( set @ L4 ) @ A3 @ C6 ) ) @ B5 )
      = ( complete_Sup_Sup @ ( set @ L4 )
        @ ( image @ K9 @ ( set @ L4 )
          @ ^ [X6: K9] : ( minus_minus @ ( set @ L4 ) @ ( A3 @ X6 ) @ B5 )
          @ C6 ) ) ) ).

% UN_extend_simps(6)
thf(fact_5886_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ord_less_eq @ ( set @ ( set @ A ) )
      @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
        @ ( image @ B @ ( set @ ( set @ A ) )
          @ ^ [X6: B] : ( pow2 @ A @ ( B5 @ X6 ) )
          @ A3 ) )
      @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) ) ) ).

% UN_Pow_subset
thf(fact_5887_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X2: A,F3: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ Y @ X2 )
               => ? [X6: B] :
                    ( ( member @ B @ X6 @ A3 )
                    & ( ord_less @ A @ Y @ ( F3 @ X6 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_5888_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B5: set @ B,F3: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A3 @ B5 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ A3 )
               => ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B5 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_5889_SUP__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ ( bot_bot @ ( set @ B ) ) ) )
          = ( bot_bot @ A ) ) ) ).

% SUP_empty
thf(fact_5890_SUP__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( ( A3
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Sup_Sup @ A
                @ ( image @ B @ A
                  @ ^ [Y: B] : C2
                  @ A3 ) )
              = ( bot_bot @ A ) ) )
          & ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Sup_Sup @ A
                @ ( image @ B @ A
                  @ ^ [Y: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% SUP_constant
thf(fact_5891_SUP__UNION,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,G: C > ( set @ B ),A3: set @ C] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ C @ ( set @ B ) @ G @ A3 ) ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ C @ A
              @ ^ [Y: C] : ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ ( G @ Y ) ) )
              @ A3 ) ) ) ) ).

% SUP_UNION
thf(fact_5892_UN__extend__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C6: set @ B,A2: A,B5: B > ( set @ A )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( insert @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ C6 ) ) )
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( insert @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ C6 ) ) )
          = ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [X6: B] : ( insert @ A @ A2 @ ( B5 @ X6 ) )
              @ C6 ) ) ) ) ) ).

% UN_extend_simps(1)
thf(fact_5893_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B ),F3: B > C,A9: A > ( set @ C )] :
      ( ! [I2: A,J: A] :
          ( ( member @ A @ I2 @ I6 )
         => ( ( member @ A @ J @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I2 ) @ ( A3 @ J ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J ) @ ( A3 @ I2 ) ) ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( bij_betw @ B @ C @ F3 @ ( A3 @ I2 ) @ ( A9 @ I2 ) ) )
       => ( bij_betw @ B @ C @ F3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A9 @ I6 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_5894_UNION__singleton__eq__range,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X6: B] : ( insert @ A @ ( F3 @ X6 ) @ ( bot_bot @ ( set @ A ) ) )
          @ A3 ) )
      = ( image @ B @ A @ F3 @ A3 ) ) ).

% UNION_singleton_eq_range
thf(fact_5895_cSUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image @ B @ A
                @ ^ [X6: B] : C2
                @ A3 ) )
            = C2 ) ) ) ).

% cSUP_const
thf(fact_5896_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_5897_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_5898_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_5899_SUP2__I,axiom,
    ! [B: $tType,A: $tType,C: $tType,A2: A,A3: set @ A,B5: A > B > C > $o,B2: B,C2: C] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( B5 @ A2 @ B2 @ C2 )
       => ( complete_Sup_Sup @ ( B > C > $o ) @ ( image @ A @ ( B > C > $o ) @ B5 @ A3 ) @ B2 @ C2 ) ) ) ).

% SUP2_I
thf(fact_5900_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_atLeastLessThan
thf(fact_5901_SUP1__I,axiom,
    ! [A: $tType,B: $tType,A2: A,A3: set @ A,B5: A > B > $o,B2: B] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( B5 @ A2 @ B2 )
       => ( complete_Sup_Sup @ ( B > $o ) @ ( image @ A @ ( B > $o ) @ B5 @ A3 ) @ B2 ) ) ) ).

% SUP1_I
thf(fact_5902_SUP2__E,axiom,
    ! [A: $tType,C: $tType,B: $tType,B5: C > A > B > $o,A3: set @ C,B2: A,C2: B] :
      ( ( complete_Sup_Sup @ ( A > B > $o ) @ ( image @ C @ ( A > B > $o ) @ B5 @ A3 ) @ B2 @ C2 )
     => ~ ! [X7: C] :
            ( ( member @ C @ X7 @ A3 )
           => ~ ( B5 @ X7 @ B2 @ C2 ) ) ) ).

% SUP2_E
thf(fact_5903_SUP1__E,axiom,
    ! [B: $tType,A: $tType,B5: B > A > $o,A3: set @ B,B2: A] :
      ( ( complete_Sup_Sup @ ( A > $o ) @ ( image @ B @ ( A > $o ) @ B5 @ A3 ) @ B2 )
     => ~ ! [X7: B] :
            ( ( member @ B @ X7 @ A3 )
           => ~ ( B5 @ X7 @ B2 ) ) ) ).

% SUP1_E
thf(fact_5904_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
          | ( ord_less @ A @ B3 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_5905_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P3: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P3 @ A2 )
           => ( ~ ( P3 @ B2 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A2 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B2 )
                  & ! [X: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X )
                        & ( ord_less @ A @ X @ C3 ) )
                     => ( P3 @ X ) )
                  & ! [D6: A] :
                      ( ! [X7: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X7 )
                            & ( ord_less @ A @ X7 @ D6 ) )
                         => ( P3 @ X7 ) )
                     => ( ord_less_eq @ A @ D6 @ C3 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_5906_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y2: A,X15: set @ A] :
          ( ( ord_less @ A @ Y2 @ ( complete_Sup_Sup @ A @ X15 ) )
         => ( ( X15
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X7: A] :
                  ( ( member @ A @ X7 @ X15 )
                 => ~ ( ord_less @ A @ Y2 @ X7 ) ) ) ) ) ).

% less_cSupE
thf(fact_5907_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X15: set @ A,Z: A] :
          ( ( X15
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z @ ( complete_Sup_Sup @ A @ X15 ) )
           => ? [X7: A] :
                ( ( member @ A @ X7 @ X15 )
                & ( ord_less @ A @ Z @ X7 ) ) ) ) ) ).

% less_cSupD
thf(fact_5908_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X15: set @ A,X2: A,A2: A] :
          ( ( finite_finite2 @ A @ X15 )
         => ( ( member @ A @ X2 @ X15 )
           => ( ! [X7: A] :
                  ( ( member @ A @ X7 @ X15 )
                 => ( ord_less @ A @ X7 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X15 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_5909_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X15: set @ A,A2: A] :
          ( ( finite_finite2 @ A @ X15 )
         => ( ( X15
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X15 ) @ A2 )
              = ( ! [X6: A] :
                    ( ( member @ A @ X6 @ X15 )
                   => ( ord_less @ A @ X6 @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_5910_card__UNION,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( finite_finite2 @ ( set @ A ) @ A3 )
     => ( ! [X7: set @ A] :
            ( ( member @ ( set @ A ) @ X7 @ A3 )
           => ( finite_finite2 @ A @ X7 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I7: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I7 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I7 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I7 @ A3 )
                    & ( I7
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_5911_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I2 ) )
              = N ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I: nat] :
                ( map @ nat @ A
                @ ^ [J4: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J4 ) @ I )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_5912_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_5913_remdups__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( remdups @ nat @ ( upt @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% remdups_upt
thf(fact_5914_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X2: list @ A] :
      ( ( ( remdups @ A @ X2 )
        = ( nil @ A ) )
      = ( X2
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_iff
thf(fact_5915_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X2: list @ A] :
      ( ( ( nil @ A )
        = ( remdups @ A @ X2 ) )
      = ( X2
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_right_iff
thf(fact_5916_set__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_remdups
thf(fact_5917_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% length_remdups_eq
thf(fact_5918_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups @ A @ Xs )
        = Xs )
      = ( distinct @ A @ Xs ) ) ).

% remdups_id_iff_distinct
thf(fact_5919_distinct__remdups,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct @ A @ ( remdups @ A @ Xs ) ) ).

% distinct_remdups
thf(fact_5920_INF__identity__eq,axiom,
    ! [A: $tType] :
      ( ( complete_Inf @ A )
     => ! [A3: set @ A] :
          ( ( complete_Inf_Inf @ A
            @ ( image @ A @ A
              @ ^ [X6: A] : X6
              @ A3 ) )
          = ( complete_Inf_Inf @ A @ A3 ) ) ) ).

% INF_identity_eq
thf(fact_5921_INT__I,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: B,B5: A > ( set @ B )] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ A3 )
         => ( member @ B @ B2 @ ( B5 @ X7 ) ) )
     => ( member @ B @ B2 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) ) ) ).

% INT_I
thf(fact_5922_INT__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,B5: B > ( set @ A ),A3: set @ B] :
      ( ( member @ A @ B2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ A3 )
           => ( member @ A @ B2 @ ( B5 @ X6 ) ) ) ) ) ).

% INT_iff
thf(fact_5923_Inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf @ B )
     => ( ( complete_Inf_Inf @ ( A > B ) )
        = ( ^ [A7: set @ ( A > B ),X6: A] :
              ( complete_Inf_Inf @ B
              @ ( image @ ( A > B ) @ B
                @ ^ [F5: A > B] : ( F5 @ X6 )
                @ A7 ) ) ) ) ) ).

% Inf_apply
thf(fact_5924_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X6: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X6 )
               => ? [Y: A] :
                    ( ( member @ A @ Y @ A3 )
                    & ( ord_less @ A @ Y @ X6 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_5925_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_atLeastLessThan
thf(fact_5926_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_atLeastLessThan
thf(fact_5927_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_5928_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_5929_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_5930_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_5931_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_remdups_leq
thf(fact_5932_INF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F3: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image @ B @ A
                @ ^ [I: B] : F3
                @ A3 ) )
            = F3 ) ) ) ).

% INF_const
thf(fact_5933_ccINF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,F3: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image @ B @ A
                @ ^ [I: B] : F3
                @ A3 ) )
            = F3 ) ) ) ).

% ccINF_const
thf(fact_5934_cINF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image @ B @ A
                @ ^ [X6: B] : C2
                @ A3 ) )
            = C2 ) ) ) ).

% cINF_const
thf(fact_5935_finite__INT,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B )] :
      ( ? [X: A] :
          ( ( member @ A @ X @ I6 )
          & ( finite_finite2 @ B @ ( A3 @ X ) ) )
     => ( finite_finite2 @ B @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) ) ) ).

% finite_INT
thf(fact_5936_INF__apply,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( complete_Inf @ A )
     => ! [F3: C > B > A,A3: set @ C,X2: B] :
          ( ( complete_Inf_Inf @ ( B > A ) @ ( image @ C @ ( B > A ) @ F3 @ A3 ) @ X2 )
          = ( complete_Inf_Inf @ A
            @ ( image @ C @ A
              @ ^ [Y: C] : ( F3 @ Y @ X2 )
              @ A3 ) ) ) ) ).

% INF_apply
thf(fact_5937_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F3: B > A,A3: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) )
            = ( bot_bot @ A ) )
          = ( ! [X6: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X6 )
               => ? [Y: B] :
                    ( ( member @ B @ Y @ A3 )
                    & ( ord_less @ A @ ( F3 @ Y ) @ X6 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_5938_INT__insert,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A2: B,A3: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ ( insert @ B @ A2 @ A3 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( B5 @ A2 ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) ) ) ).

% INT_insert
thf(fact_5939_Compl__INT,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ( uminus_uminus @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X6: B] : ( uminus_uminus @ ( set @ A ) @ ( B5 @ X6 ) )
          @ A3 ) ) ) ).

% Compl_INT
thf(fact_5940_Compl__UN,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ( uminus_uminus @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X6: B] : ( uminus_uminus @ ( set @ A ) @ ( B5 @ X6 ) )
          @ A3 ) ) ) ).

% Compl_UN
thf(fact_5941_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X15: set @ A,Z: A] :
          ( ( X15
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X15 ) @ Z )
           => ? [X7: A] :
                ( ( member @ A @ X7 @ X15 )
                & ( ord_less @ A @ X7 @ Z ) ) ) ) ) ).

% cInf_lessD
thf(fact_5942_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X2 )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ X2 @ Y )
               => ? [X6: A] :
                    ( ( member @ A @ X6 @ A3 )
                    & ( ord_less @ A @ X6 @ Y ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5943_INF__commute,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > C > A,B5: set @ C,A3: set @ B] :
          ( ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [I: B] : ( complete_Inf_Inf @ A @ ( image @ C @ A @ ( F3 @ I ) @ B5 ) )
              @ A3 ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ C @ A
              @ ^ [J4: C] :
                  ( complete_Inf_Inf @ A
                  @ ( image @ B @ A
                    @ ^ [I: B] : ( F3 @ I @ J4 )
                    @ A3 ) )
              @ B5 ) ) ) ) ).

% INF_commute
thf(fact_5944_INT__D,axiom,
    ! [A: $tType,B: $tType,B2: A,B5: B > ( set @ A ),A3: set @ B,A2: B] :
      ( ( member @ A @ B2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
     => ( ( member @ B @ A2 @ A3 )
       => ( member @ A @ B2 @ ( B5 @ A2 ) ) ) ) ).

% INT_D
thf(fact_5945_INT__E,axiom,
    ! [A: $tType,B: $tType,B2: A,B5: B > ( set @ A ),A3: set @ B,A2: B] :
      ( ( member @ A @ B2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
     => ( ~ ( member @ A @ B2 @ ( B5 @ A2 ) )
       => ~ ( member @ B @ A2 @ A3 ) ) ) ).

% INT_E
thf(fact_5946_Inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf @ B )
     => ( ( complete_Inf_Inf @ ( A > B ) )
        = ( ^ [A7: set @ ( A > B ),X6: A] :
              ( complete_Inf_Inf @ B
              @ ( image @ ( A > B ) @ B
                @ ^ [F5: A > B] : ( F5 @ X6 )
                @ A7 ) ) ) ) ) ).

% Inf_fun_def
thf(fact_5947_Pow__INT__eq,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ( pow2 @ A @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
      = ( complete_Inf_Inf @ ( set @ ( set @ A ) )
        @ ( image @ B @ ( set @ ( set @ A ) )
          @ ^ [X6: B] : ( pow2 @ A @ ( B5 @ X6 ) )
          @ A3 ) ) ) ).

% Pow_INT_eq
thf(fact_5948_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X15: set @ A,X2: A,A2: A] :
          ( ( finite_finite2 @ A @ X15 )
         => ( ( member @ A @ X2 @ X15 )
           => ( ! [X7: A] :
                  ( ( member @ A @ X7 @ X15 )
                 => ( ord_less @ A @ A2 @ X7 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X15 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_5949_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% distinct_remdups_id
thf(fact_5950_remdups__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups @ A @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ Xs ) ) ).

% remdups_remdups
thf(fact_5951_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( remdups @ A @ ( map @ B @ A @ F3 @ ( remdups @ B @ Xs ) ) )
      = ( remdups @ A @ ( map @ B @ A @ F3 @ Xs ) ) ) ).

% remdups_map_remdups
thf(fact_5952_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S3: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S3 ) @ A2 )
          = ( ? [X6: A] :
                ( ( member @ A @ X6 @ S3 )
                & ( ord_less @ A @ X6 @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_5953_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups.simps(1)
thf(fact_5954_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ ( list @ A ) ) ) ).

% transpose.simps(1)
thf(fact_5955_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,U: A,F3: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ U @ ( F3 @ I2 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ).

% INF_greatest
thf(fact_5956_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F3: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
          = ( ! [X6: B] :
                ( ( member @ B @ X6 @ A3 )
               => ( ord_less_eq @ A @ U @ ( F3 @ X6 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_5957_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F3: B > A,U: A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ( ord_less_eq @ A @ ( F3 @ I3 ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_5958_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ! [X7: B] : ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( G @ X7 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% INF_mono'
thf(fact_5959_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F3: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( F3 @ I3 ) ) ) ) ).

% INF_lower
thf(fact_5960_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: set @ B,A3: set @ C,F3: C > A,G: B > A] :
          ( ! [M5: B] :
              ( ( member @ B @ M5 @ B5 )
             => ? [X: C] :
                  ( ( member @ C @ X @ A3 )
                  & ( ord_less_eq @ A @ ( F3 @ X ) @ ( G @ M5 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B5 ) ) ) ) ) ).

% INF_mono
thf(fact_5961_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,X2: A,F3: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ X2 @ ( F3 @ I2 ) ) )
         => ( ! [Y5: A] :
                ( ! [I4: B] :
                    ( ( member @ B @ I4 @ A3 )
                   => ( ord_less_eq @ A @ Y5 @ ( F3 @ I4 ) ) )
               => ( ord_less_eq @ A @ Y5 @ X2 ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) )
              = X2 ) ) ) ) ).

% INF_eqI
thf(fact_5962_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y2: A,F3: B > A,A3: set @ B,I3: B] :
          ( ( ord_less @ A @ Y2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
         => ( ( member @ B @ I3 @ A3 )
           => ( ord_less @ A @ Y2 @ ( F3 @ I3 ) ) ) ) ) ).

% less_INF_D
thf(fact_5963_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F3: B > A,A3: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ A2 )
          = ( ? [X6: B] :
                ( ( member @ B @ X6 @ A3 )
                & ( ord_less @ A @ ( F3 @ X6 ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_5964_INF__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [K: B,I6: set @ B,A3: B > A] :
          ( ( member @ B @ K @ I6 )
         => ( ( inf_inf @ A @ ( A3 @ K ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ A3 @ I6 ) ) )
            = ( complete_Inf_Inf @ A @ ( image @ B @ A @ A3 @ I6 ) ) ) ) ) ).

% INF_absorb
thf(fact_5965_INF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,A3: set @ B,G: B > A] :
          ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A3 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [A5: B] : ( inf_inf @ A @ ( F3 @ A5 ) @ ( G @ A5 ) )
              @ A3 ) ) ) ) ).

% INF_inf_distrib
thf(fact_5966_INT__extend__simps_I10_J,axiom,
    ! [V6: $tType,U4: $tType,T: $tType,B5: U4 > ( set @ V6 ),F3: T > U4,A3: set @ T] :
      ( ( complete_Inf_Inf @ ( set @ V6 )
        @ ( image @ T @ ( set @ V6 )
          @ ^ [A5: T] : ( B5 @ ( F3 @ A5 ) )
          @ A3 ) )
      = ( complete_Inf_Inf @ ( set @ V6 ) @ ( image @ U4 @ ( set @ V6 ) @ B5 @ ( image @ T @ U4 @ F3 @ A3 ) ) ) ) ).

% INT_extend_simps(10)
thf(fact_5967_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B5: set @ A,A3: B > ( set @ A ),I6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ B5 @ ( A3 @ X6 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_5968_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B5: set @ A,F3: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B5 )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F3 @ B5 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ A3 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_5969_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C6: set @ B,B5: A > ( set @ B )] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ C6 @ ( B5 @ X7 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C6 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) ) ) ).

% INT_greatest
thf(fact_5970_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B5: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) @ ( B5 @ A2 ) ) ) ).

% INT_lower
thf(fact_5971_INT__extend__simps_I5_J,axiom,
    ! [I5: $tType,J6: $tType,A2: I5,B5: J6 > ( set @ I5 ),C6: set @ J6] :
      ( ( insert @ I5 @ A2 @ ( complete_Inf_Inf @ ( set @ I5 ) @ ( image @ J6 @ ( set @ I5 ) @ B5 @ C6 ) ) )
      = ( complete_Inf_Inf @ ( set @ I5 )
        @ ( image @ J6 @ ( set @ I5 )
          @ ^ [X6: J6] : ( insert @ I5 @ A2 @ ( B5 @ X6 ) )
          @ C6 ) ) ) ).

% INT_extend_simps(5)
thf(fact_5972_INT__insert__distrib,axiom,
    ! [B: $tType,A: $tType,U: A,A3: set @ A,A2: B,B5: A > ( set @ B )] :
      ( ( member @ A @ U @ A3 )
     => ( ( complete_Inf_Inf @ ( set @ B )
          @ ( image @ A @ ( set @ B )
            @ ^ [X6: A] : ( insert @ B @ A2 @ ( B5 @ X6 ) )
            @ A3 ) )
        = ( insert @ B @ A2 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A3 ) ) ) ) ) ).

% INT_insert_distrib
thf(fact_5973_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_remdups
thf(fact_5974_INT__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I6: set @ A,A3: A > ( set @ B )] :
      ( ( member @ A @ K @ I6 )
     => ( ( inf_inf @ ( set @ B ) @ ( A3 @ K ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) )
        = ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) ) ) ).

% INT_absorb
thf(fact_5975_INT__Int__distrib,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),B5: B > ( set @ A ),I6: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [I: B] : ( inf_inf @ ( set @ A ) @ ( A3 @ I ) @ ( B5 @ I ) )
          @ I6 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ I6 ) ) ) ) ).

% INT_Int_distrib
thf(fact_5976_Int__Inter__image,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),B5: B > ( set @ A ),C6: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X6: B] : ( inf_inf @ ( set @ A ) @ ( A3 @ X6 ) @ ( B5 @ X6 ) )
          @ C6 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ C6 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ C6 ) ) ) ) ).

% Int_Inter_image
thf(fact_5977_INT__extend__simps_I9_J,axiom,
    ! [S7: $tType,R6: $tType,Q7: $tType,C6: R6 > ( set @ S7 ),B5: Q7 > ( set @ R6 ),A3: set @ Q7] :
      ( ( complete_Inf_Inf @ ( set @ S7 )
        @ ( image @ Q7 @ ( set @ S7 )
          @ ^ [X6: Q7] : ( complete_Inf_Inf @ ( set @ S7 ) @ ( image @ R6 @ ( set @ S7 ) @ C6 @ ( B5 @ X6 ) ) )
          @ A3 ) )
      = ( complete_Inf_Inf @ ( set @ S7 ) @ ( image @ R6 @ ( set @ S7 ) @ C6 @ ( complete_Sup_Sup @ ( set @ R6 ) @ ( image @ Q7 @ ( set @ R6 ) @ B5 @ A3 ) ) ) ) ) ).

% INT_extend_simps(9)
thf(fact_5978_remove1__remdups,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X2 @ ( remdups @ A @ Xs ) )
        = ( remdups @ A @ ( remove1 @ A @ X2 @ Xs ) ) ) ) ).

% remove1_remdups
thf(fact_5979_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F3: B > A,A3: set @ B,X2: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ X2 )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ X2 @ Y )
               => ? [X6: B] :
                    ( ( member @ B @ X6 @ A3 )
                    & ( ord_less @ A @ ( F3 @ X6 ) @ Y ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_5980_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X15: set @ A,A2: A] :
          ( ( finite_finite2 @ A @ X15 )
         => ( ( X15
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X15 ) )
              = ( ! [X6: A] :
                    ( ( member @ A @ X6 @ X15 )
                   => ( ord_less @ A @ A2 @ X6 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_5981_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ ( list @ B )] :
      ( ( transpose @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F3 ) @ Xs ) )
      = ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F3 ) @ ( transpose @ B @ Xs ) ) ) ).

% transpose_map_map
thf(fact_5982_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: set @ B,A3: set @ B,F3: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B5 @ A3 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ B5 )
               => ( ord_less_eq @ A @ ( F3 @ X7 ) @ ( G @ X7 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B5 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_5983_uminus__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple489889107523837845lgebra @ A )
     => ! [B5: B > A,A3: set @ B] :
          ( ( uminus_uminus @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ B5 @ A3 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [X6: B] : ( uminus_uminus @ A @ ( B5 @ X6 ) )
              @ A3 ) ) ) ) ).

% uminus_SUP
thf(fact_5984_uminus__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple489889107523837845lgebra @ A )
     => ! [B5: B > A,A3: set @ B] :
          ( ( uminus_uminus @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ B5 @ A3 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [X6: B] : ( uminus_uminus @ A @ ( B5 @ X6 ) )
              @ A3 ) ) ) ) ).

% uminus_INF
thf(fact_5985_INF__inf__const2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,F3: B > A,X2: A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image @ B @ A
                @ ^ [I: B] : ( inf_inf @ A @ ( F3 @ I ) @ X2 )
                @ I6 ) )
            = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ I6 ) ) @ X2 ) ) ) ) ).

% INF_inf_const2
thf(fact_5986_INF__inf__const1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,X2: A,F3: B > A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image @ B @ A
                @ ^ [I: B] : ( inf_inf @ A @ X2 @ ( F3 @ I ) )
                @ I6 ) )
            = ( inf_inf @ A @ X2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ I6 ) ) ) ) ) ) ).

% INF_inf_const1
thf(fact_5987_INF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,A2: B,A3: set @ B] :
          ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ ( insert @ B @ A2 @ A3 ) ) )
          = ( inf_inf @ A @ ( F3 @ A2 ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ).

% INF_insert
thf(fact_5988_INT__extend__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,C6: set @ A,A3: A > ( set @ B ),B5: set @ B] :
      ( ( ( C6
          = ( bot_bot @ ( set @ A ) ) )
       => ( ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ C6 ) ) @ B5 )
          = B5 ) )
      & ( ( C6
         != ( bot_bot @ ( set @ A ) ) )
       => ( ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ C6 ) ) @ B5 )
          = ( complete_Inf_Inf @ ( set @ B )
            @ ( image @ A @ ( set @ B )
              @ ^ [X6: A] : ( inf_inf @ ( set @ B ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) ) ) ) ) ).

% INT_extend_simps(1)
thf(fact_5989_INT__extend__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C6: set @ D,A3: set @ C,B5: D > ( set @ C )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ D ) ) )
       => ( ( inf_inf @ ( set @ C ) @ A3 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image @ D @ ( set @ C ) @ B5 @ C6 ) ) )
          = A3 ) )
      & ( ( C6
         != ( bot_bot @ ( set @ D ) ) )
       => ( ( inf_inf @ ( set @ C ) @ A3 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image @ D @ ( set @ C ) @ B5 @ C6 ) ) )
          = ( complete_Inf_Inf @ ( set @ C )
            @ ( image @ D @ ( set @ C )
              @ ^ [X6: D] : ( inf_inf @ ( set @ C ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) ) ) ) ) ).

% INT_extend_simps(2)
thf(fact_5990_UN__extend__simps_I7_J,axiom,
    ! [M11: $tType,N10: $tType,A3: set @ M11,B5: N10 > ( set @ M11 ),C6: set @ N10] :
      ( ( minus_minus @ ( set @ M11 ) @ A3 @ ( complete_Inf_Inf @ ( set @ M11 ) @ ( image @ N10 @ ( set @ M11 ) @ B5 @ C6 ) ) )
      = ( complete_Sup_Sup @ ( set @ M11 )
        @ ( image @ N10 @ ( set @ M11 )
          @ ^ [X6: N10] : ( minus_minus @ ( set @ M11 ) @ A3 @ ( B5 @ X6 ) )
          @ C6 ) ) ) ).

% UN_extend_simps(7)
thf(fact_5991_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs ) ) ) ).

% length_remdups_card_conv
thf(fact_5992_INT__extend__simps_I8_J,axiom,
    ! [P8: $tType,O2: $tType,B5: O2 > ( set @ P8 ),A3: set @ ( set @ O2 )] :
      ( ( complete_Inf_Inf @ ( set @ P8 )
        @ ( image @ ( set @ O2 ) @ ( set @ P8 )
          @ ^ [Y: set @ O2] : ( complete_Inf_Inf @ ( set @ P8 ) @ ( image @ O2 @ ( set @ P8 ) @ B5 @ Y ) )
          @ A3 ) )
      = ( complete_Inf_Inf @ ( set @ P8 ) @ ( image @ O2 @ ( set @ P8 ) @ B5 @ ( complete_Sup_Sup @ ( set @ O2 ) @ A3 ) ) ) ) ).

% INT_extend_simps(8)
thf(fact_5993_Int__Inter__eq_I1_J,axiom,
    ! [A: $tType,B11: set @ ( set @ A ),A3: set @ A] :
      ( ( ( B11
          = ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ A3 @ ( complete_Inf_Inf @ ( set @ A ) @ B11 ) )
          = A3 ) )
      & ( ( B11
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ A3 @ ( complete_Inf_Inf @ ( set @ A ) @ B11 ) )
          = ( complete_Inf_Inf @ ( set @ A ) @ ( image @ ( set @ A ) @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 ) @ B11 ) ) ) ) ) ).

% Int_Inter_eq(1)
thf(fact_5994_Int__Inter__eq_I2_J,axiom,
    ! [A: $tType,B11: set @ ( set @ A ),A3: set @ A] :
      ( ( ( B11
          = ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B11 ) @ A3 )
          = A3 ) )
      & ( ( B11
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B11 ) @ A3 )
          = ( complete_Inf_Inf @ ( set @ A )
            @ ( image @ ( set @ A ) @ ( set @ A )
              @ ^ [B8: set @ A] : ( inf_inf @ ( set @ A ) @ B8 @ A3 )
              @ B11 ) ) ) ) ) ).

% Int_Inter_eq(2)
thf(fact_5995_transpose__empty,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( ( transpose @ A @ Xs )
        = ( nil @ ( list @ A ) ) )
      = ( ! [X6: list @ A] :
            ( ( member @ ( list @ A ) @ X6 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( X6
              = ( nil @ A ) ) ) ) ) ).

% transpose_empty
thf(fact_5996_INT__extend__simps_I4_J,axiom,
    ! [G3: $tType,H4: $tType,C6: set @ H4,A3: set @ G3,B5: H4 > ( set @ G3 )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ H4 ) ) )
       => ( ( minus_minus @ ( set @ G3 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image @ H4 @ ( set @ G3 ) @ B5 @ C6 ) ) )
          = A3 ) )
      & ( ( C6
         != ( bot_bot @ ( set @ H4 ) ) )
       => ( ( minus_minus @ ( set @ G3 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image @ H4 @ ( set @ G3 ) @ B5 @ C6 ) ) )
          = ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image @ H4 @ ( set @ G3 )
              @ ^ [X6: H4] : ( minus_minus @ ( set @ G3 ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) ) ) ) ) ).

% INT_extend_simps(4)
thf(fact_5997_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,Xs: list @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ ( remdups @ B @ Xs ) ) ) ) ) ).

% sum_code
thf(fact_5998_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs2: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_5999_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B5: A] :
          ( ( inf_inf @ A @ A3
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X6: nat] : B5
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A3 @ B5 ) ) ) ).

% INF_nat_binary
thf(fact_6000_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ( Xs
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_6001_UN__UN__split__split__eq,axiom,
    ! [A: $tType,E4: $tType,D: $tType,C: $tType,B: $tType,A3: B > C > D > E4 > ( set @ A ),Y6: set @ ( product_prod @ D @ E4 ),X15: set @ ( product_prod @ B @ C )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ ( product_prod @ B @ C ) @ ( set @ A )
          @ ( product_case_prod @ B @ C @ ( set @ A )
            @ ^ [X1: B,X22: C] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( product_prod @ D @ E4 ) @ ( set @ A ) @ ( product_case_prod @ D @ E4 @ ( set @ A ) @ ( A3 @ X1 @ X22 ) ) @ Y6 ) ) )
          @ X15 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ ( product_prod @ B @ C ) @ ( set @ A )
          @ ^ [X6: product_prod @ B @ C] :
              ( complete_Sup_Sup @ ( set @ A )
              @ ( image @ ( product_prod @ D @ E4 ) @ ( set @ A )
                @ ^ [Y: product_prod @ D @ E4] :
                    ( product_case_prod @ B @ C @ ( set @ A )
                    @ ^ [X1: B,X22: C] : ( product_case_prod @ D @ E4 @ ( set @ A ) @ ( A3 @ X1 @ X22 ) @ Y )
                    @ X6 )
                @ Y6 ) )
          @ X15 ) ) ) ).

% UN_UN_split_split_eq
thf(fact_6002_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys ) )
      = ( Xs = Ys ) ) ).

% rev_is_rev_conv
thf(fact_6003_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) ).

% rev_rev_ident
thf(fact_6004_INF2__I,axiom,
    ! [B: $tType,A: $tType,C: $tType,A3: set @ A,B5: A > B > C > $o,B2: B,C2: C] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ A3 )
         => ( B5 @ X7 @ B2 @ C2 ) )
     => ( complete_Inf_Inf @ ( B > C > $o ) @ ( image @ A @ ( B > C > $o ) @ B5 @ A3 ) @ B2 @ C2 ) ) ).

% INF2_I
thf(fact_6005_INF1__I,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B5: A > B > $o,B2: B] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ A3 )
         => ( B5 @ X7 @ B2 ) )
     => ( complete_Inf_Inf @ ( B > $o ) @ ( image @ A @ ( B > $o ) @ B5 @ A3 ) @ B2 ) ) ).

% INF1_I
thf(fact_6006_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rev_is_Nil_conv
thf(fact_6007_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% Nil_is_rev_conv
thf(fact_6008_set__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rev @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rev
thf(fact_6009_length__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rev
thf(fact_6010_distinct__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rev @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rev
thf(fact_6011_rev__replicate,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( rev @ A @ ( replicate @ A @ N @ X2 ) )
      = ( replicate @ A @ N @ X2 ) ) ).

% rev_replicate
thf(fact_6012_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X8: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X8 ) ) ) ) ) ).

% Inf_real_def
thf(fact_6013_INF1__D,axiom,
    ! [B: $tType,A: $tType,B5: B > A > $o,A3: set @ B,B2: A,A2: B] :
      ( ( complete_Inf_Inf @ ( A > $o ) @ ( image @ B @ ( A > $o ) @ B5 @ A3 ) @ B2 )
     => ( ( member @ B @ A2 @ A3 )
       => ( B5 @ A2 @ B2 ) ) ) ).

% INF1_D
thf(fact_6014_INF1__E,axiom,
    ! [A: $tType,B: $tType,B5: B > A > $o,A3: set @ B,B2: A,A2: B] :
      ( ( complete_Inf_Inf @ ( A > $o ) @ ( image @ B @ ( A > $o ) @ B5 @ A3 ) @ B2 )
     => ( ~ ( B5 @ A2 @ B2 )
       => ~ ( member @ B @ A2 @ A3 ) ) ) ).

% INF1_E
thf(fact_6015_INF2__D,axiom,
    ! [A: $tType,C: $tType,B: $tType,B5: C > A > B > $o,A3: set @ C,B2: A,C2: B,A2: C] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) @ ( image @ C @ ( A > B > $o ) @ B5 @ A3 ) @ B2 @ C2 )
     => ( ( member @ C @ A2 @ A3 )
       => ( B5 @ A2 @ B2 @ C2 ) ) ) ).

% INF2_D
thf(fact_6016_INF2__E,axiom,
    ! [B: $tType,A: $tType,C: $tType,B5: C > A > B > $o,A3: set @ C,B2: A,C2: B,A2: C] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) @ ( image @ C @ ( A > B > $o ) @ B5 @ A3 ) @ B2 @ C2 )
     => ( ~ ( B5 @ A2 @ B2 @ C2 )
       => ~ ( member @ C @ A2 @ A3 ) ) ) ).

% INF2_E
thf(fact_6017_rev__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( rev @ A @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ ( rev @ ( list @ A ) @ Xs ) ) ) ) ).

% rev_concat
thf(fact_6018_rev__map,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( rev @ A @ ( map @ B @ A @ F3 @ Xs ) )
      = ( map @ B @ A @ F3 @ ( rev @ B @ Xs ) ) ) ).

% rev_map
thf(fact_6019_rev_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rev.simps(1)
thf(fact_6020_sorted__wrt__rev,axiom,
    ! [A: $tType,P3: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P3 @ ( rev @ A @ Xs ) )
      = ( sorted_wrt @ A
        @ ^ [X6: A,Y: A] : ( P3 @ Y @ X6 )
        @ Xs ) ) ).

% sorted_wrt_rev
thf(fact_6021_rev__swap,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = Ys )
      = ( Xs
        = ( rev @ A @ Ys ) ) ) ).

% rev_swap
thf(fact_6022_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I: set @ ( product_prod @ A @ B ),X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ I )
          @ S3 ) )
      = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ S3 ) ) ) ) ).

% INF_Int_eq2
thf(fact_6023_INF__Int__eq,axiom,
    ! [A: $tType,S3: set @ ( set @ A )] :
      ( ( complete_Inf_Inf @ ( A > $o )
        @ ( image @ ( set @ A ) @ ( A > $o )
          @ ^ [I: set @ A,X6: A] : ( member @ A @ X6 @ I )
          @ S3 ) )
      = ( ^ [X6: A] : ( member @ A @ X6 @ ( complete_Inf_Inf @ ( set @ A ) @ S3 ) ) ) ) ).

% INF_Int_eq
thf(fact_6024_INF__INT__eq,axiom,
    ! [B: $tType,A: $tType,R: B > ( set @ A ),S3: set @ B] :
      ( ( complete_Inf_Inf @ ( A > $o )
        @ ( image @ B @ ( A > $o )
          @ ^ [I: B,X6: A] : ( member @ A @ X6 @ ( R @ I ) )
          @ S3 ) )
      = ( ^ [X6: A] : ( member @ A @ X6 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ R @ S3 ) ) ) ) ) ).

% INF_INT_eq
thf(fact_6025_Inf__set__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( set @ A ) )
      = ( ^ [A7: set @ ( set @ A )] :
            ( collect @ A
            @ ^ [X6: A] : ( complete_Inf_Inf @ $o @ ( image @ ( set @ A ) @ $o @ ( member @ A @ X6 ) @ A7 ) ) ) ) ) ).

% Inf_set_def
thf(fact_6026_INF__INT__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R: C > ( set @ ( product_prod @ A @ B ) ),S3: set @ C] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image @ C @ ( A > B > $o )
          @ ^ [I: C,X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( R @ I ) )
          @ S3 ) )
      = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ C @ ( set @ ( product_prod @ A @ B ) ) @ R @ S3 ) ) ) ) ) ).

% INF_INT_eq2
thf(fact_6027_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rev @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( suc @ N ) ) ) ) ) ).

% rev_nth
thf(fact_6028_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Y2: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs @ K @ Y2 ) )
        = ( list_update @ A @ ( rev @ A @ Xs ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ K ) @ ( one_one @ nat ) ) @ Y2 ) ) ) ).

% rev_update
thf(fact_6029_sorted__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) ) ) ).

% sorted_transpose
thf(fact_6030_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I: nat] :
                ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ ( suc @ I ) ) @ ( nth @ A @ Xs @ I ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_6031_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I: nat,J4: nat] :
                ( ( ord_less_eq @ nat @ I @ J4 )
               => ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J4 ) @ ( nth @ A @ Xs @ I ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_6032_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I3: nat,J2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ord_less_eq @ nat @ I3 @ J2 )
           => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J2 ) @ ( nth @ A @ Xs @ I3 ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_6033_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) )
      = ( ^ [S6: set @ ( A > B > $o ),X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S6 ) ) ) ) ) ) ).

% Inf_INT_eq2
thf(fact_6034_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y2 )
                = Y2 ) )
            & ( ( Xs
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y2 )
                = ( ord_max @ A @ ( nth @ A @ Xs @ ( zero_zero @ nat ) ) @ Y2 ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_6035_UN__constant__eq,axiom,
    ! [A: $tType,B: $tType,A2: A,A3: set @ A,F3: A > ( set @ B ),C2: set @ B] :
      ( ( member @ A @ A2 @ A3 )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ A3 )
           => ( ( F3 @ X7 )
              = C2 ) )
       => ( ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F3 @ A3 ) )
          = C2 ) ) ) ).

% UN_constant_eq
thf(fact_6036_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat,J2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J2
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I3 ) @ J2 )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J2 ) @ I3 ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_6037_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys2: list @ A] : ( nth @ A @ Ys2 @ I3 )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I3 ) ) ) ) ).

% transpose_column
thf(fact_6038_filter__filter,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o,Xs: list @ A] :
      ( ( filter2 @ A @ P3 @ ( filter2 @ A @ Q @ Xs ) )
      = ( filter2 @ A
        @ ^ [X6: A] :
            ( ( Q @ X6 )
            & ( P3 @ X6 ) )
        @ Xs ) ) ).

% filter_filter
thf(fact_6039_filter__True,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( P3 @ X7 ) )
     => ( ( filter2 @ A @ P3 @ Xs )
        = Xs ) ) ).

% filter_True
thf(fact_6040_remove1__filter__not,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A] :
      ( ~ ( P3 @ X2 )
     => ( ( remove1 @ A @ X2 @ ( filter2 @ A @ P3 @ Xs ) )
        = ( filter2 @ A @ P3 @ Xs ) ) ) ).

% remove1_filter_not
thf(fact_6041_removeAll__filter__not,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A] :
      ( ~ ( P3 @ X2 )
     => ( ( removeAll @ A @ X2 @ ( filter2 @ A @ P3 @ Xs ) )
        = ( filter2 @ A @ P3 @ Xs ) ) ) ).

% removeAll_filter_not
thf(fact_6042_set__filter,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( set2 @ A @ ( filter2 @ A @ P3 @ Xs ) )
      = ( collect @ A
        @ ^ [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
            & ( P3 @ X6 ) ) ) ) ).

% set_filter
thf(fact_6043_filter__False,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ~ ( P3 @ X7 ) )
     => ( ( filter2 @ A @ P3 @ Xs )
        = ( nil @ A ) ) ) ).

% filter_False
thf(fact_6044_length__concat__rev,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) ) ) ).

% length_concat_rev
thf(fact_6045_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F3: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P3 @ ( map @ B @ A @ F3 @ Xs ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P3 @ F3 ) @ Xs ) ) ) ).

% length_filter_map
thf(fact_6046_remdups__filter,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( remdups @ A @ ( filter2 @ A @ P3 @ Xs ) )
      = ( filter2 @ A @ P3 @ ( remdups @ A @ Xs ) ) ) ).

% remdups_filter
thf(fact_6047_rev__filter,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( rev @ A @ ( filter2 @ A @ P3 @ Xs ) )
      = ( filter2 @ A @ P3 @ ( rev @ A @ Xs ) ) ) ).

% rev_filter
thf(fact_6048_filter__shuffles,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( image @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P3 ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( shuffles @ A @ ( filter2 @ A @ P3 @ Xs ) @ ( filter2 @ A @ P3 @ Ys ) ) ) ).

% filter_shuffles
thf(fact_6049_replicate__length__filter,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 )
              @ X2 )
            @ Xs ) )
        @ X2 )
      = ( filter2 @ A
        @ ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 )
          @ X2 )
        @ Xs ) ) ).

% replicate_length_filter
thf(fact_6050_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X6: A] :
                ( X6
                = ( G @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_6051_filter__is__subset,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P3 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% filter_is_subset
thf(fact_6052_length__filter__le,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P3 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_filter_le
thf(fact_6053_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X6: A] :
            ( filter2 @ A
            @ ^ [Y: A] : ( X6 != Y ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_6054_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( member @ ( list @ A ) @ Xs
      @ ( shuffles @ A @ ( filter2 @ A @ P3 @ Xs )
        @ ( filter2 @ A
          @ ^ [X6: A] :
              ~ ( P3 @ X6 )
          @ Xs ) ) ) ).

% partition_in_shuffles
thf(fact_6055_distinct__filter,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( filter2 @ A @ P3 @ Xs ) ) ) ).

% distinct_filter
thf(fact_6056_filter__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P3: A > $o,Q: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ Ys ) )
           => ( ( P3 @ X7 )
              = ( Q @ X7 ) ) )
       => ( ( filter2 @ A @ P3 @ Xs )
          = ( filter2 @ A @ Q @ Ys ) ) ) ) ).

% filter_cong
thf(fact_6057_filter__id__conv,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P3 @ Xs )
        = Xs )
      = ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
           => ( P3 @ X6 ) ) ) ) ).

% filter_id_conv
thf(fact_6058_sorted__wrt__filter,axiom,
    ! [A: $tType,F3: A > A > $o,Xs: list @ A,P3: A > $o] :
      ( ( sorted_wrt @ A @ F3 @ Xs )
     => ( sorted_wrt @ A @ F3 @ ( filter2 @ A @ P3 @ Xs ) ) ) ).

% sorted_wrt_filter
thf(fact_6059_filter__remove1,axiom,
    ! [A: $tType,Q: A > $o,X2: A,Xs: list @ A] :
      ( ( filter2 @ A @ Q @ ( remove1 @ A @ X2 @ Xs ) )
      = ( remove1 @ A @ X2 @ ( filter2 @ A @ Q @ Xs ) ) ) ).

% filter_remove1
thf(fact_6060_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P3: B > $o,X2: B,F3: B > A,Xs: list @ B] :
          ( ~ ( P3 @ X2 )
         => ( ( filter2 @ B @ P3 @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) )
            = ( filter2 @ B @ P3 @ Xs ) ) ) ) ).

% filter_insort_triv
thf(fact_6061_inter__set__filter,axiom,
    ! [A: $tType,A3: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X6: A] : ( member @ A @ X6 @ A3 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_6062_sum__length__filter__compl,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P3 @ Xs ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X6: A] :
                ~ ( P3 @ X6 )
            @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% sum_length_filter_compl
thf(fact_6063_empty__filter__conv,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( filter2 @ A @ P3 @ Xs ) )
      = ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
           => ~ ( P3 @ X6 ) ) ) ) ).

% empty_filter_conv
thf(fact_6064_filter__empty__conv,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P3 @ Xs )
        = ( nil @ A ) )
      = ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
           => ~ ( P3 @ X6 ) ) ) ) ).

% filter_empty_conv
thf(fact_6065_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( filter2 @ A @ P3 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% filter.simps(1)
thf(fact_6066_filter__replicate,axiom,
    ! [A: $tType,P3: A > $o,X2: A,N: nat] :
      ( ( ( P3 @ X2 )
       => ( ( filter2 @ A @ P3 @ ( replicate @ A @ N @ X2 ) )
          = ( replicate @ A @ N @ X2 ) ) )
      & ( ~ ( P3 @ X2 )
       => ( ( filter2 @ A @ P3 @ ( replicate @ A @ N @ X2 ) )
          = ( nil @ A ) ) ) ) ).

% filter_replicate
thf(fact_6067_filter__map,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F3: B > A,Xs: list @ B] :
      ( ( filter2 @ A @ P3 @ ( map @ B @ A @ F3 @ Xs ) )
      = ( map @ B @ A @ F3 @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P3 @ F3 ) @ Xs ) ) ) ).

% filter_map
thf(fact_6068_filter__concat,axiom,
    ! [A: $tType,P5: A > $o,Xs: list @ ( list @ A )] :
      ( ( filter2 @ A @ P5 @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P5 ) @ Xs ) ) ) ).

% filter_concat
thf(fact_6069_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B,P3: B > $o] :
      ( ( distinct @ A @ ( map @ B @ A @ F3 @ Xs ) )
     => ( distinct @ A @ ( map @ B @ A @ F3 @ ( filter2 @ B @ P3 @ Xs ) ) ) ) ).

% distinct_map_filter
thf(fact_6070_length__filter__less,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P3: A > $o] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P3 @ X2 )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P3 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_filter_less
thf(fact_6071_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs: list @ B,P3: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ ( filter2 @ B @ P3 @ Xs ) ) ) ) ) ).

% sorted_filter
thf(fact_6072_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,G: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F3
            @ ( filter2 @ B
              @ ^ [X6: B] :
                  ( ( F3 @ X6 )
                  = ( G @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_6073_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F3: B > A,P3: B > $o,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ ( filter2 @ B @ P3 @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X6: B] : ( if @ A @ ( P3 @ X6 ) @ ( F3 @ X6 ) @ ( zero_zero @ A ) )
              @ Xs ) ) ) ) ).

% sum_list_map_filter'
thf(fact_6074_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B,P3: B > $o,F3: B > A] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ ( set2 @ B @ Xs ) )
             => ( ~ ( P3 @ X7 )
               => ( ( F3 @ X7 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ ( filter2 @ B @ P3 @ Xs ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_6075_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs: list @ B,P3: B > $o,X2: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs ) )
         => ( ( P3 @ X2 )
           => ( ( filter2 @ B @ P3 @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs ) )
              = ( linorder_insort_key @ B @ A @ F3 @ X2 @ ( filter2 @ B @ P3 @ Xs ) ) ) ) ) ) ).

% filter_insort
thf(fact_6076_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y2: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X6: A] : ( X6 != Y2 )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_6077_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X6: A] :
                ~ ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_6078_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X6: A] : ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_6079_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X6: A] :
                ~ ( member @ A @ X6 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_6080_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X6: A] : ( member @ A @ X6 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_6081_length__filter__conv__card,axiom,
    ! [A: $tType,P5: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P5 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I: nat] :
              ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P5 @ ( nth @ A @ Xs @ I ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_6082_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P3 @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_6083_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs2: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs2 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X6: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X6 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys2: list @ B] :
                  ( Ys2
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_6084_nth__transpose,axiom,
    ! [A: $tType,I3: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I3 )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs2: list @ A] : ( nth @ A @ Xs2 @ I3 )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_6085_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs2: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X6: list @ A] :
              ( X6
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_6086_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I3 ) ) ) ) ) ).

% transpose_column_length
thf(fact_6087_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F3: B > A,P3: B > $o,Xs: list @ B] :
      ( ( map @ B @ A @ F3 @ ( filter2 @ B @ P3 @ Xs ) )
      = ( map_filter @ B @ A
        @ ^ [X6: B] : ( if @ ( option @ A ) @ ( P3 @ X6 ) @ ( some @ A @ ( F3 @ X6 ) ) @ ( none @ A ) )
        @ Xs ) ) ).

% map_filter_map_filter
thf(fact_6088_suminf__eq__SUP__real,axiom,
    ! [X15: nat > real] :
      ( ( summable @ real @ X15 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X15 @ I2 ) )
       => ( ( suminf @ real @ X15 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X15 @ ( set_ord_lessThan @ nat @ I ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_6089_finite__option__UNIV,axiom,
    ! [A: $tType] :
      ( ( finite_finite2 @ ( option @ A ) @ ( top_top @ ( set @ ( option @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% finite_option_UNIV
thf(fact_6090_Collect__const,axiom,
    ! [A: $tType,P3: $o] :
      ( ( P3
       => ( ( collect @ A
            @ ^ [S4: A] : P3 )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ~ P3
       => ( ( collect @ A
            @ ^ [S4: A] : P3 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_const
thf(fact_6091_finite__Collect__not,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
     => ( ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [X6: A] :
                ~ ( P3 @ X6 ) ) )
        = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_Collect_not
thf(fact_6092_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_6093_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_6094_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A3 )
            = ( top_top @ A ) )
          = ( ! [X6: A] :
                ( ( ord_less @ A @ X6 @ ( top_top @ A ) )
               => ? [Y: A] :
                    ( ( member @ A @ Y @ A3 )
                    & ( ord_less @ A @ X6 @ Y ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_6095_surj__fn,axiom,
    ! [A: $tType,F3: A > A,N: nat] :
      ( ( ( image @ A @ A @ F3 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_6096_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A
            @ ^ [X6: A] : ( minus_minus @ A @ X6 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_diff_right
thf(fact_6097_ccINF__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B] :
          ( ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [X6: B] : ( top_top @ A )
              @ A3 ) )
          = ( top_top @ A ) ) ) ).

% ccINF_top
thf(fact_6098_INF__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B] :
          ( ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [X6: B] : ( top_top @ A )
              @ A3 ) )
          = ( top_top @ A ) ) ) ).

% INF_top
thf(fact_6099_INF__top__conv_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: B > A,A3: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ B5 @ A3 ) )
            = ( top_top @ A ) )
          = ( ! [X6: B] :
                ( ( member @ B @ X6 @ A3 )
               => ( ( B5 @ X6 )
                  = ( top_top @ A ) ) ) ) ) ) ).

% INF_top_conv(1)
thf(fact_6100_INF__top__conv_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: B > A,A3: set @ B] :
          ( ( ( top_top @ A )
            = ( complete_Inf_Inf @ A @ ( image @ B @ A @ B5 @ A3 ) ) )
          = ( ! [X6: B] :
                ( ( member @ B @ X6 @ A3 )
               => ( ( B5 @ X6 )
                  = ( top_top @ A ) ) ) ) ) ) ).

% INF_top_conv(2)
thf(fact_6101_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F3: B > A,A3: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) )
            = ( top_top @ A ) )
          = ( ! [X6: A] :
                ( ( ord_less @ A @ X6 @ ( top_top @ A ) )
               => ? [Y: B] :
                    ( ( member @ B @ Y @ A3 )
                    & ( ord_less @ A @ X6 @ ( F3 @ Y ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_6102_range__constant,axiom,
    ! [B: $tType,A: $tType,X2: A] :
      ( ( image @ B @ A
        @ ^ [Uu3: B] : X2
        @ ( top_top @ ( set @ B ) ) )
      = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% range_constant
thf(fact_6103_ccINF__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [F3: B > A] :
          ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ ( bot_bot @ ( set @ B ) ) ) )
          = ( top_top @ A ) ) ) ).

% ccINF_empty
thf(fact_6104_INT__constant,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,C2: set @ A] :
      ( ( ( A3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Inf_Inf @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [Y: B] : C2
              @ A3 ) )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Inf_Inf @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [Y: B] : C2
              @ A3 ) )
          = C2 ) ) ) ).

% INT_constant
thf(fact_6105_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X2 ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_6106_INT__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C6: set @ D,A3: set @ C,B5: D > ( set @ C )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ D ) ) )
       => ( ( complete_Inf_Inf @ ( set @ C )
            @ ( image @ D @ ( set @ C )
              @ ^ [X6: D] : ( inf_inf @ ( set @ C ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) )
          = ( top_top @ ( set @ C ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ D ) ) )
       => ( ( complete_Inf_Inf @ ( set @ C )
            @ ( image @ D @ ( set @ C )
              @ ^ [X6: D] : ( inf_inf @ ( set @ C ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) )
          = ( inf_inf @ ( set @ C ) @ A3 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image @ D @ ( set @ C ) @ B5 @ C6 ) ) ) ) ) ) ).

% INT_simps(2)
thf(fact_6107_INT__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C6: set @ A,A3: A > ( set @ B ),B5: set @ B] :
      ( ( ( C6
          = ( bot_bot @ ( set @ A ) ) )
       => ( ( complete_Inf_Inf @ ( set @ B )
            @ ( image @ A @ ( set @ B )
              @ ^ [X6: A] : ( inf_inf @ ( set @ B ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) )
          = ( top_top @ ( set @ B ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ A ) ) )
       => ( ( complete_Inf_Inf @ ( set @ B )
            @ ( image @ A @ ( set @ B )
              @ ^ [X6: A] : ( inf_inf @ ( set @ B ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) )
          = ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ C6 ) ) @ B5 ) ) ) ) ).

% INT_simps(1)
thf(fact_6108_INT__simps_I3_J,axiom,
    ! [E4: $tType,F: $tType,C6: set @ E4,A3: E4 > ( set @ F ),B5: set @ F] :
      ( ( ( C6
          = ( bot_bot @ ( set @ E4 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X6: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) )
          = ( top_top @ ( set @ F ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ E4 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X6: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) )
          = ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C6 ) ) @ B5 ) ) ) ) ).

% INT_simps(3)
thf(fact_6109_INT__simps_I4_J,axiom,
    ! [G3: $tType,H4: $tType,C6: set @ H4,A3: set @ G3,B5: H4 > ( set @ G3 )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ H4 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image @ H4 @ ( set @ G3 )
              @ ^ [X6: H4] : ( minus_minus @ ( set @ G3 ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) )
          = ( top_top @ ( set @ G3 ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ H4 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image @ H4 @ ( set @ G3 )
              @ ^ [X6: H4] : ( minus_minus @ ( set @ G3 ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) )
          = ( minus_minus @ ( set @ G3 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image @ H4 @ ( set @ G3 ) @ B5 @ C6 ) ) ) ) ) ) ).

% INT_simps(4)
thf(fact_6110_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( sums @ A @ F3
          @ ( complete_Sup_Sup @ A
            @ ( image @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% sums_SUP
thf(fact_6111_UN__atMost__UNIV,axiom,
    ( ( complete_Sup_Sup @ ( set @ nat ) @ ( image @ nat @ ( set @ nat ) @ ( set_ord_atMost @ nat ) @ ( top_top @ ( set @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% UN_atMost_UNIV
thf(fact_6112_UN__lessThan__UNIV,axiom,
    ( ( complete_Sup_Sup @ ( set @ nat ) @ ( image @ nat @ ( set @ nat ) @ ( set_ord_lessThan @ nat ) @ ( top_top @ ( set @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% UN_lessThan_UNIV
thf(fact_6113_rangeE,axiom,
    ! [A: $tType,B: $tType,B2: A,F3: B > A] :
      ( ( member @ A @ B2 @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) )
     => ~ ! [X7: B] :
            ( B2
           != ( F3 @ X7 ) ) ) ).

% rangeE
thf(fact_6114_range__composition,axiom,
    ! [A: $tType,C: $tType,B: $tType,F3: C > A,G: B > C] :
      ( ( image @ B @ A
        @ ^ [X6: B] : ( F3 @ ( G @ X6 ) )
        @ ( top_top @ ( set @ B ) ) )
      = ( image @ C @ A @ F3 @ ( image @ B @ C @ G @ ( top_top @ ( set @ B ) ) ) ) ) ).

% range_composition
thf(fact_6115_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_6116_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_6117_UNIV__def,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X6: A] : $true ) ) ).

% UNIV_def
thf(fact_6118_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite2 @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_6119_bij__fn,axiom,
    ! [A: $tType,F3: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F3 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_6120_SUP__INF,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [P3: C > B > A] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [Y: B] :
                  ( complete_Inf_Inf @ A
                  @ ( image @ C @ A
                    @ ^ [X6: C] : ( P3 @ X6 @ Y )
                    @ ( top_top @ ( set @ C ) ) ) )
              @ ( top_top @ ( set @ B ) ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ ( B > C ) @ A
              @ ^ [X6: B > C] :
                  ( complete_Sup_Sup @ A
                  @ ( image @ B @ A
                    @ ^ [Y: B] : ( P3 @ ( X6 @ Y ) @ Y )
                    @ ( top_top @ ( set @ B ) ) ) )
              @ ( top_top @ ( set @ ( B > C ) ) ) ) ) ) ) ).

% SUP_INF
thf(fact_6121_INF__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [P3: C > B > A] :
          ( ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [Y: B] :
                  ( complete_Sup_Sup @ A
                  @ ( image @ C @ A
                    @ ^ [X6: C] : ( P3 @ X6 @ Y )
                    @ ( top_top @ ( set @ C ) ) ) )
              @ ( top_top @ ( set @ B ) ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ ( B > C ) @ A
              @ ^ [F5: B > C] :
                  ( complete_Inf_Inf @ A
                  @ ( image @ B @ A
                    @ ^ [X6: B] : ( P3 @ ( F5 @ X6 ) @ X6 )
                    @ ( top_top @ ( set @ B ) ) ) )
              @ ( top_top @ ( set @ ( B > C ) ) ) ) ) ) ) ).

% INF_SUP
thf(fact_6122_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F3: B > ( option @ A )] :
      ( ( map_filter @ B @ A @ F3 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% map_filter_simps(2)
thf(fact_6123_UNIV__option__conv,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( set @ ( option @ A ) ) )
      = ( insert @ ( option @ A ) @ ( none @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% UNIV_option_conv
thf(fact_6124_finite__range__imageI,axiom,
    ! [C: $tType,A: $tType,B: $tType,G: B > A,F3: A > C] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ G @ ( top_top @ ( set @ B ) ) ) )
     => ( finite_finite2 @ C
        @ ( image @ B @ C
          @ ^ [X6: B] : ( F3 @ ( G @ X6 ) )
          @ ( top_top @ ( set @ B ) ) ) ) ) ).

% finite_range_imageI
thf(fact_6125_INTER__UNIV__conv_I1_J,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ( ( top_top @ ( set @ A ) )
        = ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ A3 )
           => ( ( B5 @ X6 )
              = ( top_top @ ( set @ A ) ) ) ) ) ) ).

% INTER_UNIV_conv(1)
thf(fact_6126_INTER__UNIV__conv_I2_J,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ( ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [X6: B] :
            ( ( member @ B @ X6 @ A3 )
           => ( ( B5 @ X6 )
              = ( top_top @ ( set @ A ) ) ) ) ) ) ).

% INTER_UNIV_conv(2)
thf(fact_6127_INF__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( ( A3
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Inf_Inf @ A
                @ ( image @ B @ A
                  @ ^ [Y: B] : C2
                  @ A3 ) )
              = ( top_top @ A ) ) )
          & ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Inf_Inf @ A
                @ ( image @ B @ A
                  @ ^ [Y: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% INF_constant
thf(fact_6128_INF__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A] :
          ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ ( bot_bot @ ( set @ B ) ) ) )
          = ( top_top @ A ) ) ) ).

% INF_empty
thf(fact_6129_finite__range__Some,axiom,
    ! [A: $tType] :
      ( ( finite_finite2 @ ( option @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% finite_range_Some
thf(fact_6130_notin__range__Some,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( ~ ( member @ ( option @ A ) @ X2 @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) ) )
      = ( X2
        = ( none @ A ) ) ) ).

% notin_range_Some
thf(fact_6131_INT__empty,axiom,
    ! [B: $tType,A: $tType,B5: B > ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% INT_empty
thf(fact_6132_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X6: A] : X6 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_6133_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_6134_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_6135_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_6136_INT__extend__simps_I3_J,axiom,
    ! [F: $tType,E4: $tType,C6: set @ E4,A3: E4 > ( set @ F ),B5: set @ F] :
      ( ( ( C6
          = ( bot_bot @ ( set @ E4 ) ) )
       => ( ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C6 ) ) @ B5 )
          = ( minus_minus @ ( set @ F ) @ ( top_top @ ( set @ F ) ) @ B5 ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ E4 ) ) )
       => ( ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C6 ) ) @ B5 )
          = ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X6: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) ) ) ) ) ).

% INT_extend_simps(3)
thf(fact_6137_bij__image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: A > B,B5: C > ( set @ A ),A3: set @ C] :
      ( ( bij_betw @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( image @ A @ B @ F3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B5 @ A3 ) ) )
        = ( complete_Inf_Inf @ ( set @ B )
          @ ( image @ C @ ( set @ B )
            @ ^ [X6: C] : ( image @ A @ B @ F3 @ ( B5 @ X6 ) )
            @ A3 ) ) ) ) ).

% bij_image_INT
thf(fact_6138_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [N2: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_6139_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F3: B > A] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_6140_UN__finite__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),C6: set @ A] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ C6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ C6 ) ) ).

% UN_finite_subset
thf(fact_6141_UN__finite2__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B5: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B5 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_6142_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F5: nat > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP
thf(fact_6143_range__mod,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( image @ nat @ nat
          @ ^ [M4: nat] : ( modulo_modulo @ nat @ M4 @ N )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% range_mod
thf(fact_6144_UN__finite2__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B5: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B5 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_6145_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F3: nat > ( set @ A ),S3: set @ A] :
      ( ! [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( F3 @ I2 ) @ S3 )
     => ( ( finite_finite2 @ A @ S3 )
       => ( ? [N7: nat] :
              ( ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N3 @ N7 )
                 => ! [M5: nat] :
                      ( ( ord_less_eq @ nat @ M5 @ N7 )
                     => ( ( ord_less @ nat @ M5 @ N3 )
                       => ( ord_less @ ( set @ A ) @ ( F3 @ M5 ) @ ( F3 @ N3 ) ) ) ) )
              & ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N3 )
                 => ( ( F3 @ N7 )
                    = ( F3 @ N3 ) ) ) )
         => ( ( F3 @ ( finite_card @ A @ S3 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F3 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_6146_cclfp__def,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ( ( order_532582986084564980_cclfp @ A )
        = ( ^ [F5: A > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [I: nat] : ( compow @ ( A > A ) @ I @ F5 @ ( bot_bot @ A ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% cclfp_def
thf(fact_6147_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X6: list @ A] :
              ( X6
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_6148_takeWhile__idem,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( takeWhile @ A @ P3 @ ( takeWhile @ A @ P3 @ Xs ) )
      = ( takeWhile @ A @ P3 @ Xs ) ) ).

% takeWhile_idem
thf(fact_6149_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P3 @ Xs )
        = Xs )
      = ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
           => ( P3 @ X6 ) ) ) ) ).

% takeWhile_eq_all_conv
thf(fact_6150_Collect__const__case__prod,axiom,
    ! [B: $tType,A: $tType,P3: $o] :
      ( ( P3
       => ( ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : P3 ) )
          = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )
      & ( ~ P3
       => ( ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : P3 ) )
          = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% Collect_const_case_prod
thf(fact_6151_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_6152_takeWhile__replicate,axiom,
    ! [A: $tType,P3: A > $o,X2: A,N: nat] :
      ( ( ( P3 @ X2 )
       => ( ( takeWhile @ A @ P3 @ ( replicate @ A @ N @ X2 ) )
          = ( replicate @ A @ N @ X2 ) ) )
      & ( ~ ( P3 @ X2 )
       => ( ( takeWhile @ A @ P3 @ ( replicate @ A @ N @ X2 ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile_replicate
thf(fact_6153_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_6154_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% top_empty_eq2
thf(fact_6155_top__enat__def,axiom,
    ( ( top_top @ extended_enat )
    = ( extend4730790105801354508finity @ extended_enat ) ) ).

% top_enat_def
thf(fact_6156_infinite__UNIV__listI,axiom,
    ! [A: $tType] :
      ~ ( finite_finite2 @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% infinite_UNIV_listI
thf(fact_6157_length__takeWhile__le,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_takeWhile_le
thf(fact_6158_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P3: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P3 @ Xs ) ) ) ) ).

% sorted_takeWhile
thf(fact_6159_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( takeWhile @ A @ P3 @ Xs ) ) ) ).

% distinct_takeWhile
thf(fact_6160_set__takeWhileD,axiom,
    ! [A: $tType,X2: A,P3: A > $o,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( takeWhile @ A @ P3 @ Xs ) ) )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
        & ( P3 @ X2 ) ) ) ).

% set_takeWhileD
thf(fact_6161_takeWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P3: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ L ) )
           => ( ( P3 @ X7 )
              = ( Q @ X7 ) ) )
       => ( ( takeWhile @ A @ P3 @ L )
          = ( takeWhile @ A @ Q @ K ) ) ) ) ).

% takeWhile_cong
thf(fact_6162_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( takeWhile @ A @ P3 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% takeWhile.simps(1)
thf(fact_6163_takeWhile__eq__take,axiom,
    ! [A: $tType] :
      ( ( takeWhile @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] : ( take @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs2 ) ) @ Xs2 ) ) ) ).

% takeWhile_eq_take
thf(fact_6164_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F3: B > A,Xs: list @ B] :
      ( ( takeWhile @ A @ P3 @ ( map @ B @ A @ F3 @ Xs ) )
      = ( map @ B @ A @ F3 @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P3 @ F3 ) @ Xs ) ) ) ).

% takeWhile_map
thf(fact_6165_INF__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: $o > A] :
          ( ( complete_Inf_Inf @ A @ ( image @ $o @ A @ A3 @ ( top_top @ ( set @ $o ) ) ) )
          = ( inf_inf @ A @ ( A3 @ $true ) @ ( A3 @ $false ) ) ) ) ).

% INF_UNIV_bool_expand
thf(fact_6166_INT__bool__eq,axiom,
    ! [A: $tType,A3: $o > ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image @ $o @ ( set @ A ) @ A3 @ ( top_top @ ( set @ $o ) ) ) )
      = ( inf_inf @ ( set @ A ) @ ( A3 @ $true ) @ ( A3 @ $false ) ) ) ).

% INT_bool_eq
thf(fact_6167_takeWhile__nth,axiom,
    ! [A: $tType,J2: nat,P3: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P3 @ Xs ) @ J2 )
        = ( nth @ A @ Xs @ J2 ) ) ) ).

% takeWhile_nth
thf(fact_6168_nth__length__takeWhile,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ~ ( P3 @ ( nth @ A @ Xs @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_6169_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J2: nat,P3: A > $o,Xs: list @ A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ J2 )
         => ( P3 @ ( nth @ A @ Xs @ I2 ) ) )
     => ( ( ord_less_eq @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ord_less_eq @ nat @ J2 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_6170_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P3: A > $o] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P3 @ ( nth @ A @ Xs @ I2 ) ) ) )
     => ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
         => ~ ( P3 @ ( nth @ A @ Xs @ N ) ) )
       => ( ( takeWhile @ A @ P3 @ Xs )
          = ( take @ A @ N @ Xs ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_6171_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs: list @ B,T3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F3 @ Xs ) ) )
         => ( ( filter2 @ B
              @ ^ [X6: B] : ( ord_less @ A @ T3 @ ( F3 @ X6 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X6: B] : ( ord_less @ A @ T3 @ ( F3 @ X6 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_6172_root__def,axiom,
    ( root
    = ( ^ [N2: nat,X6: real] :
          ( if @ real
          @ ( N2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N2 ) )
            @ X6 ) ) ) ) ).

% root_def
thf(fact_6173_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_6174_the__inv__into__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( the_inv_into @ A @ B )
      = ( ^ [A7: set @ A,F5: A > B,X6: B] :
            ( the @ A
            @ ^ [Y: A] :
                ( ( member @ A @ Y @ A7 )
                & ( ( F5 @ Y )
                  = X6 ) ) ) ) ) ).

% the_inv_into_def
thf(fact_6175_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_6176_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N ) ) ) ).

% char_of_mod_256
thf(fact_6177_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: A,N: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M )
            = ( unique5772411509450598832har_of @ A @ N ) )
          = ( ( modulo_modulo @ A @ M @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_6178_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_6179_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A2: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_6180_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N2: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_6181_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_6182_char_Osize_I2_J,axiom,
    ! [X17: $o,X23: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_size @ char @ ( char2 @ X17 @ X23 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size(2)
thf(fact_6183_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_6184_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_6185_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_6186_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_6187_char_Osize__gen,axiom,
    ! [X17: $o,X23: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_char @ ( char2 @ X17 @ X23 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size_gen
thf(fact_6188_char__of__integer__code,axiom,
    ( char_of_integer
    = ( ^ [K2: code_integer] :
          ( product_case_prod @ code_integer @ $o @ char
          @ ^ [Q0: code_integer,B02: $o] :
              ( product_case_prod @ code_integer @ $o @ char
              @ ^ [Q1: code_integer,B12: $o] :
                  ( product_case_prod @ code_integer @ $o @ char
                  @ ^ [Q22: code_integer,B23: $o] :
                      ( product_case_prod @ code_integer @ $o @ char
                      @ ^ [Q32: code_integer,B33: $o] :
                          ( product_case_prod @ code_integer @ $o @ char
                          @ ^ [Q42: code_integer,B43: $o] :
                              ( product_case_prod @ code_integer @ $o @ char
                              @ ^ [Q52: code_integer,B53: $o] :
                                  ( product_case_prod @ code_integer @ $o @ char
                                  @ ^ [Q62: code_integer,B63: $o] :
                                      ( product_case_prod @ code_integer @ $o @ char
                                      @ ^ [Uu3: code_integer] : ( char2 @ B02 @ B12 @ B23 @ B33 @ B43 @ B53 @ B63 )
                                      @ ( code_bit_cut_integer @ Q62 ) )
                                  @ ( code_bit_cut_integer @ Q52 ) )
                              @ ( code_bit_cut_integer @ Q42 ) )
                          @ ( code_bit_cut_integer @ Q32 ) )
                      @ ( code_bit_cut_integer @ Q22 ) )
                  @ ( code_bit_cut_integer @ Q1 ) )
              @ ( code_bit_cut_integer @ Q0 ) )
          @ ( code_bit_cut_integer @ K2 ) ) ) ) ).

% char_of_integer_code
thf(fact_6189_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_6190_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_6191_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_6192_list_Oinject,axiom,
    ! [A: $tType,X21: A,X222: list @ A,Y21: A,Y222: list @ A] :
      ( ( ( cons @ A @ X21 @ X222 )
        = ( cons @ A @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% list.inject
thf(fact_6193_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( set2 @ A @ ( cons @ A @ X21 @ X222 ) )
      = ( insert @ A @ X21 @ ( set2 @ A @ X222 ) ) ) ).

% list.simps(15)
thf(fact_6194_nth__Cons__Suc,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ ( suc @ N ) )
      = ( nth @ A @ Xs @ N ) ) ).

% nth_Cons_Suc
thf(fact_6195_nth__Cons__0,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ ( zero_zero @ nat ) )
      = X2 ) ).

% nth_Cons_0
thf(fact_6196_take__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( take @ A @ ( suc @ N ) @ ( cons @ A @ X2 @ Xs ) )
      = ( cons @ A @ X2 @ ( take @ A @ N @ Xs ) ) ) ).

% take_Suc_Cons
thf(fact_6197_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X2: A,Xs: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( plus_plus @ A @ X2 @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% sum_list.Cons
thf(fact_6198_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X2 @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% rev_singleton_conv
thf(fact_6199_singleton__rev__conv,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( ( cons @ A @ X2 @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( ( cons @ A @ X2 @ ( nil @ A ) )
        = Xs ) ) ).

% singleton_rev_conv
thf(fact_6200_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R )
          & ( Xs = Ys ) )
        | ( ( X2 = Y2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_6201_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F3: B > A,A2: A,X2: B,Xs: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ ( cons @ B @ X2 @ Xs ) )
          = ( plus_plus @ A @ ( F3 @ X2 ) @ ( times_times @ A @ A2 @ ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ Xs ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_6202_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X2: B,Xs: list @ B] :
      ( ( enumerate @ B @ N @ ( cons @ B @ X2 @ Xs ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N @ X2 ) @ ( enumerate @ B @ ( suc @ N ) @ Xs ) ) ) ).

% enumerate_simps(2)
thf(fact_6203_nth__Cons__numeral,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,V: num] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ ( numeral_numeral @ nat @ V ) )
      = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_6204_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X2: A,Xs: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X2 @ Xs ) )
      = ( cons @ A @ X2 @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% take_Cons_numeral
thf(fact_6205_Cons__in__lex,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( lex @ A @ R ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R )
          & ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) ) )
        | ( ( X2 = Y2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) ) ) ) ) ).

% Cons_in_lex
thf(fact_6206_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X6: B] : ( cons @ A @ ( F3 @ X6 ) @ ( nil @ A ) )
          @ Xs ) )
      = ( map @ B @ A @ F3 @ Xs ) ) ).

% concat_map_singleton
thf(fact_6207_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_6208_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P3 @ X2 )
       => ( ( takeWhile @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ ( takeWhile @ A @ P3 @ Xs ) ) ) )
      & ( ~ ( P3 @ X2 )
       => ( ( takeWhile @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile.simps(2)
thf(fact_6209_listrel1I2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),X2: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ X2 @ Ys ) ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1I2
thf(fact_6210_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P3 @ X2 )
       => ( ( filter2 @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ ( filter2 @ A @ P3 @ Xs ) ) ) )
      & ( ~ ( P3 @ X2 )
       => ( ( filter2 @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( filter2 @ A @ P3 @ Xs ) ) ) ) ).

% filter.simps(2)
thf(fact_6211_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( remdups @ A @ Xs ) ) )
      & ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ ( remdups @ A @ Xs ) ) ) ) ) ).

% remdups.simps(2)
thf(fact_6212_list__update__code_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,I3: nat,Y2: A] :
      ( ( list_update @ A @ ( cons @ A @ X2 @ Xs ) @ ( suc @ I3 ) @ Y2 )
      = ( cons @ A @ X2 @ ( list_update @ A @ Xs @ I3 @ Y2 ) ) ) ).

% list_update_code(3)
thf(fact_6213_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X2: B,Y2: B,Ys: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F3 @ X2 ) @ ( F3 @ Y2 ) )
           => ( ( linorder_insort_key @ B @ A @ F3 @ X2 @ ( cons @ B @ Y2 @ Ys ) )
              = ( cons @ B @ X2 @ ( cons @ B @ Y2 @ Ys ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F3 @ X2 ) @ ( F3 @ Y2 ) )
           => ( ( linorder_insort_key @ B @ A @ F3 @ X2 @ ( cons @ B @ Y2 @ Ys ) )
              = ( cons @ B @ Y2 @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Ys ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_6214_list__update__code_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A] :
      ( ( list_update @ A @ ( cons @ A @ X2 @ Xs ) @ ( zero_zero @ nat ) @ Y2 )
      = ( cons @ A @ Y2 @ Xs ) ) ).

% list_update_code(2)
thf(fact_6215_shufflesE,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( ( Zs = Xs )
         => ( Ys
           != ( nil @ A ) ) )
       => ( ( ( Zs = Ys )
           => ( Xs
             != ( nil @ A ) ) )
         => ( ! [X7: A,Xs4: list @ A] :
                ( ( Xs
                  = ( cons @ A @ X7 @ Xs4 ) )
               => ! [Z2: A,Zs4: list @ A] :
                    ( ( Zs
                      = ( cons @ A @ Z2 @ Zs4 ) )
                   => ( ( X7 = Z2 )
                     => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs4 @ Ys ) ) ) ) )
           => ~ ! [Y5: A,Ys5: list @ A] :
                  ( ( Ys
                    = ( cons @ A @ Y5 @ Ys5 ) )
                 => ! [Z2: A,Zs4: list @ A] :
                      ( ( Zs
                        = ( cons @ A @ Z2 @ Zs4 ) )
                     => ( ( Y5 = Z2 )
                       => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs @ Ys5 ) ) ) ) ) ) ) ) ) ).

% shufflesE
thf(fact_6216_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X2 @ Xs ) ) ) ).

% set_subset_Cons
thf(fact_6217_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X2 @ Y2 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y2 @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_6218_distinct__singleton,axiom,
    ! [A: $tType,X2: A] : ( distinct @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ).

% distinct_singleton
thf(fact_6219_sorted__wrt1,axiom,
    ! [A: $tType,P3: A > A > $o,X2: A] : ( sorted_wrt @ A @ P3 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ).

% sorted_wrt1
thf(fact_6220_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) ).

% distinct.simps(2)
thf(fact_6221_replicate__Suc,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( replicate @ A @ ( suc @ N ) @ X2 )
      = ( cons @ A @ X2 @ ( replicate @ A @ N @ X2 ) ) ) ).

% replicate_Suc
thf(fact_6222_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( removeAll @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) )
          = ( removeAll @ A @ X2 @ Xs ) ) )
      & ( ( X2 != Y2 )
       => ( ( removeAll @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) )
          = ( cons @ A @ Y2 @ ( removeAll @ A @ X2 @ Xs ) ) ) ) ) ).

% removeAll.simps(2)
thf(fact_6223_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Z @ Ys ) ) ) ) ).

% Cons_in_shuffles_rightI
thf(fact_6224_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ ( cons @ A @ Z @ Xs ) @ Ys ) ) ) ).

% Cons_in_shuffles_leftI
thf(fact_6225_distinct__length__2__or__more,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ A2 @ ( cons @ A @ B2 @ Xs ) ) )
      = ( ( A2 != B2 )
        & ( distinct @ A @ ( cons @ A @ A2 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs ) ) ) ) ).

% distinct_length_2_or_more
thf(fact_6226_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,I3: nat,V: A] :
      ( ( list_update @ A @ ( cons @ A @ X2 @ Xs ) @ I3 @ V )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V @ Xs )
        @ ^ [J4: nat] : ( cons @ A @ X2 @ ( list_update @ A @ Xs @ J4 @ V ) )
        @ I3 ) ) ).

% list_update.simps(2)
thf(fact_6227_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y2: A,X222: list @ A,X21: A] :
      ( ( member @ A @ Y2 @ ( set2 @ A @ X222 ) )
     => ( member @ A @ Y2 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ) ).

% list.set_intros(2)
thf(fact_6228_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] : ( member @ A @ X21 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ).

% list.set_intros(1)
thf(fact_6229_list_Oset__cases,axiom,
    ! [A: $tType,E2: A,A2: list @ A] :
      ( ( member @ A @ E2 @ ( set2 @ A @ A2 ) )
     => ( ! [Z23: list @ A] :
            ( A2
           != ( cons @ A @ E2 @ Z23 ) )
       => ~ ! [Z12: A,Z23: list @ A] :
              ( ( A2
                = ( cons @ A @ Z12 @ Z23 ) )
             => ~ ( member @ A @ E2 @ ( set2 @ A @ Z23 ) ) ) ) ) ).

% list.set_cases
thf(fact_6230_set__ConsD,axiom,
    ! [A: $tType,Y2: A,X2: A,Xs: list @ A] :
      ( ( member @ A @ Y2 @ ( set2 @ A @ ( cons @ A @ X2 @ Xs ) ) )
     => ( ( Y2 = X2 )
        | ( member @ A @ Y2 @ ( set2 @ A @ Xs ) ) ) ) ).

% set_ConsD
thf(fact_6231_not__Cons__self2,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( cons @ A @ X2 @ Xs )
     != Xs ) ).

% not_Cons_self2
thf(fact_6232_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( remove1 @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) )
          = Xs ) )
      & ( ( X2 != Y2 )
       => ( ( remove1 @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) )
          = ( cons @ A @ Y2 @ ( remove1 @ A @ X2 @ Xs ) ) ) ) ) ).

% remove1.simps(2)
thf(fact_6233_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X2: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F6: A > B,Bs2: list @ B] :
          ( X2
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F6 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F6: A > B,A4: A,As: list @ A,Bs2: list @ B] :
            ( X2
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F6 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A4 @ As ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_6234_shuffles_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X2
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ( ! [Xs3: list @ A] :
            ( X2
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ ( nil @ A ) ) )
       => ~ ! [X7: A,Xs3: list @ A,Y5: A,Ys4: list @ A] :
              ( X2
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X7 @ Xs3 ) @ ( cons @ A @ Y5 @ Ys4 ) ) ) ) ) ).

% shuffles.cases
thf(fact_6235_splice_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X2
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ~ ! [X7: A,Xs3: list @ A,Ys4: list @ A] :
            ( X2
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X7 @ Xs3 ) @ Ys4 ) ) ) ).

% splice.cases
thf(fact_6236_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X222 ) ) ).

% list.distinct(1)
thf(fact_6237_list_OdiscI,axiom,
    ! [A: $tType,List: list @ A,X21: A,X222: list @ A] :
      ( ( List
        = ( cons @ A @ X21 @ X222 ) )
     => ( List
       != ( nil @ A ) ) ) ).

% list.discI
thf(fact_6238_list_Oexhaust,axiom,
    ! [A: $tType,Y2: list @ A] :
      ( ( Y2
       != ( nil @ A ) )
     => ~ ! [X212: A,X223: list @ A] :
            ( Y2
           != ( cons @ A @ X212 @ X223 ) ) ) ).

% list.exhaust
thf(fact_6239_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X2: list @ A] :
          ( ! [X7: A,Xs3: list @ A] :
              ( X2
             != ( cons @ A @ X7 @ Xs3 ) )
         => ( X2
            = ( nil @ A ) ) ) ) ).

% min_list.cases
thf(fact_6240_transpose_Ocases,axiom,
    ! [A: $tType,X2: list @ ( list @ A )] :
      ( ( X2
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss2: list @ ( list @ A )] :
            ( X2
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
       => ~ ! [X7: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
              ( X2
             != ( cons @ ( list @ A ) @ ( cons @ A @ X7 @ Xs3 ) @ Xss2 ) ) ) ) ).

% transpose.cases
thf(fact_6241_remdups__adj_Ocases,axiom,
    ! [A: $tType,X2: list @ A] :
      ( ( X2
       != ( nil @ A ) )
     => ( ! [X7: A] :
            ( X2
           != ( cons @ A @ X7 @ ( nil @ A ) ) )
       => ~ ! [X7: A,Y5: A,Xs3: list @ A] :
              ( X2
             != ( cons @ A @ X7 @ ( cons @ A @ Y5 @ Xs3 ) ) ) ) ) ).

% remdups_adj.cases
thf(fact_6242_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
         != ( nil @ A ) ) )
      = ( ? [Y: A,Ys2: list @ A] :
            ( Xs
            = ( cons @ A @ Y @ Ys2 ) ) ) ) ).

% neq_Nil_conv
thf(fact_6243_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P3: ( list @ A ) > ( list @ B ) > $o,Xs: list @ A,Ys: list @ B] :
      ( ( P3 @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X7: A,Xs3: list @ A] : ( P3 @ ( cons @ A @ X7 @ Xs3 ) @ ( nil @ B ) )
       => ( ! [Y5: B,Ys4: list @ B] : ( P3 @ ( nil @ A ) @ ( cons @ B @ Y5 @ Ys4 ) )
         => ( ! [X7: A,Xs3: list @ A,Y5: B,Ys4: list @ B] :
                ( ( P3 @ Xs3 @ Ys4 )
               => ( P3 @ ( cons @ A @ X7 @ Xs3 ) @ ( cons @ B @ Y5 @ Ys4 ) ) )
           => ( P3 @ Xs @ Ys ) ) ) ) ) ).

% list_induct2'
thf(fact_6244_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P3: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X7: A] : ( P3 @ ( cons @ A @ X7 @ ( nil @ A ) ) )
       => ( ! [X7: A,Xs3: list @ A] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P3 @ Xs3 )
               => ( P3 @ ( cons @ A @ X7 @ Xs3 ) ) ) )
         => ( P3 @ Xs ) ) ) ) ).

% list_nonempty_induct
thf(fact_6245_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P9: A > A > $o] :
          ( X2
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P9 @ ( nil @ A ) ) )
     => ~ ! [P9: A > A > $o,X7: A,Ys4: list @ A] :
            ( X2
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P9 @ ( cons @ A @ X7 @ Ys4 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_6246_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X2: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F6: A > B,X7: A] :
              ( X2
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F6 @ ( cons @ A @ X7 @ ( nil @ A ) ) ) )
         => ( ! [F6: A > B,X7: A,Y5: A,Zs2: list @ A] :
                ( X2
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F6 @ ( cons @ A @ X7 @ ( cons @ A @ Y5 @ Zs2 ) ) ) )
           => ~ ! [A4: A > B] :
                  ( X2
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A4 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_6247_successively_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P9: A > A > $o] :
          ( X2
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P9 @ ( nil @ A ) ) )
     => ( ! [P9: A > A > $o,X7: A] :
            ( X2
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P9 @ ( cons @ A @ X7 @ ( nil @ A ) ) ) )
       => ~ ! [P9: A > A > $o,X7: A,Y5: A,Xs3: list @ A] :
              ( X2
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P9 @ ( cons @ A @ X7 @ ( cons @ A @ Y5 @ Xs3 ) ) ) ) ) ) ).

% successively.cases
thf(fact_6248_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X2: B] :
          ( ( linorder_insort_key @ B @ A @ F3 @ X2 @ ( nil @ B ) )
          = ( cons @ B @ X2 @ ( nil @ B ) ) ) ) ).

% insort_key.simps(1)
thf(fact_6249_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F3: A > B,X21: A,X222: list @ A] :
      ( ( map @ A @ B @ F3 @ ( cons @ A @ X21 @ X222 ) )
      = ( cons @ B @ ( F3 @ X21 ) @ ( map @ A @ B @ F3 @ X222 ) ) ) ).

% list.simps(9)
thf(fact_6250_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list @ A,F3: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( map @ B @ A @ F3 @ Ys ) )
     => ? [Z2: B,Zs2: list @ B] :
          ( ( Ys
            = ( cons @ B @ Z2 @ Zs2 ) )
          & ( X2
            = ( F3 @ Z2 ) )
          & ( Xs
            = ( map @ B @ A @ F3 @ Zs2 ) ) ) ) ).

% Cons_eq_map_D
thf(fact_6251_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F3: B > A,Xs: list @ B,Y2: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F3 @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
     => ? [Z2: B,Zs2: list @ B] :
          ( ( Xs
            = ( cons @ B @ Z2 @ Zs2 ) )
          & ( ( F3 @ Z2 )
            = Y2 )
          & ( ( map @ B @ A @ F3 @ Zs2 )
            = Ys ) ) ) ).

% map_eq_Cons_D
thf(fact_6252_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list @ A,F3: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( map @ B @ A @ F3 @ Ys ) )
      = ( ? [Z6: B,Zs3: list @ B] :
            ( ( Ys
              = ( cons @ B @ Z6 @ Zs3 ) )
            & ( X2
              = ( F3 @ Z6 ) )
            & ( Xs
              = ( map @ B @ A @ F3 @ Zs3 ) ) ) ) ) ).

% Cons_eq_map_conv
thf(fact_6253_map__eq__Cons__conv,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B,Y2: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F3 @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( ? [Z6: B,Zs3: list @ B] :
            ( ( Xs
              = ( cons @ B @ Z6 @ Zs3 ) )
            & ( ( F3 @ Z6 )
              = Y2 )
            & ( ( map @ B @ A @ F3 @ Zs3 )
              = Ys ) ) ) ) ).

% map_eq_Cons_conv
thf(fact_6254_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs @ Xss ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X6: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X6 ) @ ( product_lists @ A @ Xss ) )
          @ Xs ) ) ) ).

% product_lists.simps(2)
thf(fact_6255_foldr__Cons,axiom,
    ! [B: $tType,A: $tType,F3: A > B > B,X2: A,Xs: list @ A] :
      ( ( foldr @ A @ B @ F3 @ ( cons @ A @ X2 @ Xs ) )
      = ( comp @ B @ B @ B @ ( F3 @ X2 ) @ ( foldr @ A @ B @ F3 @ Xs ) ) ) ).

% foldr_Cons
thf(fact_6256_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,Ws: list @ D,P3: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws ) )
         => ( ( P3 @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X7: A,Xs3: list @ A,Y5: B,Ys4: list @ B,Z2: C,Zs2: list @ C,W2: D,Ws2: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ B ) @ Ys4 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws2 ) )
                     => ( ( P3 @ Xs3 @ Ys4 @ Zs2 @ Ws2 )
                       => ( P3 @ ( cons @ A @ X7 @ Xs3 ) @ ( cons @ B @ Y5 @ Ys4 ) @ ( cons @ C @ Z2 @ Zs2 ) @ ( cons @ D @ W2 @ Ws2 ) ) ) ) ) )
             => ( P3 @ Xs @ Ys @ Zs @ Ws ) ) ) ) ) ) ).

% list_induct4
thf(fact_6257_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,P3: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P3 @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X7: A,Xs3: list @ A,Y5: B,Ys4: list @ B,Z2: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = ( size_size @ ( list @ B ) @ Ys4 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P3 @ Xs3 @ Ys4 @ Zs2 )
                   => ( P3 @ ( cons @ A @ X7 @ Xs3 ) @ ( cons @ B @ Y5 @ Ys4 ) @ ( cons @ C @ Z2 @ Zs2 ) ) ) ) )
           => ( P3 @ Xs @ Ys @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_6258_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P3: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( P3 @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X7: A,Xs3: list @ A,Y5: B,Ys4: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs3 )
                = ( size_size @ ( list @ B ) @ Ys4 ) )
             => ( ( P3 @ Xs3 @ Ys4 )
               => ( P3 @ ( cons @ A @ X7 @ Xs3 ) @ ( cons @ B @ Y5 @ Ys4 ) ) ) )
         => ( P3 @ Xs @ Ys ) ) ) ) ).

% list_induct2
thf(fact_6259_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y: A,Ys2: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y @ Ys2 ) )
            & ( ( size_size @ ( list @ A ) @ Ys2 )
              = N ) ) ) ) ).

% length_Suc_conv
thf(fact_6260_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y: A,Ys2: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y @ Ys2 ) )
            & ( ( size_size @ ( list @ A ) @ Ys2 )
              = N ) ) ) ) ).

% Suc_length_conv
thf(fact_6261_length__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_Cons
thf(fact_6262_impossible__Cons,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,X2: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs
       != ( cons @ A @ X2 @ Ys ) ) ) ).

% impossible_Cons
thf(fact_6263_take__Cons,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( take @ A @ N @ ( cons @ A @ X2 @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( nil @ A )
        @ ^ [M4: nat] : ( cons @ A @ X2 @ ( take @ A @ M4 @ Xs ) )
        @ N ) ) ).

% take_Cons
thf(fact_6264_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y2: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) ) ).

% Cons_shuffles_subset2
thf(fact_6265_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs ) @ Ys ) ) ).

% Cons_shuffles_subset1
thf(fact_6266_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y2: A,Ys: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Y2 @ Ys ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% Cons_in_subseqsD
thf(fact_6267_nth__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N )
      = ( case_nat @ A @ X2 @ ( nth @ A @ Xs ) @ N ) ) ).

% nth_Cons
thf(fact_6268_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [X6: A,Ys2: list @ A] :
            ( ( Xs
              = ( cons @ A @ X6 @ Ys2 ) )
            & ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_6269_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_6270_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ Ys ) )
          = ( ! [X6: A] :
                ( ( member @ A @ X6 @ ( set2 @ A @ Ys ) )
               => ( ord_less_eq @ A @ X2 @ X6 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys ) ) ) ) ).

% sorted_simps(2)
thf(fact_6271_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X2 @ Ys ) )
          = ( ! [X6: A] :
                ( ( member @ A @ X6 @ ( set2 @ A @ Ys ) )
               => ( ord_less @ A @ X2 @ X6 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_6272_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F3: B > A,A2: B] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ ( set2 @ B @ Xs ) )
             => ( ord_less_eq @ A @ ( F3 @ A2 ) @ ( F3 @ X7 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F3 @ A2 @ Xs )
            = ( cons @ B @ A2 @ Xs ) ) ) ) ).

% insort_is_Cons
thf(fact_6273_listrel1I1,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Xs ) ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1I1
thf(fact_6274_Cons__listrel1E1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ! [Y5: A] :
            ( ( Ys
              = ( cons @ A @ Y5 @ Xs ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Ys
                = ( cons @ A @ X2 @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs2 ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_6275_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list @ A,Y2: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y2 @ Ys ) ) @ ( listrel1 @ A @ R ) )
     => ( ! [X7: A] :
            ( ( Xs
              = ( cons @ A @ X7 @ Ys ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X7 @ Y2 ) @ R ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Xs
                = ( cons @ A @ Y2 @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_6276_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( count_list @ A @ ( cons @ A @ X2 @ Xs ) @ Y2 )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs @ Y2 ) @ ( one_one @ nat ) ) ) )
      & ( ( X2 != Y2 )
       => ( ( count_list @ A @ ( cons @ A @ X2 @ Xs ) @ Y2 )
          = ( count_list @ A @ Xs @ Y2 ) ) ) ) ).

% count_list.simps(2)
thf(fact_6277_the__elem__set,axiom,
    ! [A: $tType,X2: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = X2 ) ).

% the_elem_set
thf(fact_6278_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_6279_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( n_lists @ A @ ( suc @ N ) @ Xs )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys2: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y: A] : ( cons @ A @ Y @ Ys2 )
              @ Xs )
          @ ( n_lists @ A @ N @ Xs ) ) ) ) ).

% n_lists.simps(2)
thf(fact_6280_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N )
          = X2 ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N )
          = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_6281_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X2 @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X2 @ X21 ) @ ( size_list @ A @ X2 @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_6282_map__upt__Suc,axiom,
    ! [A: $tType,F3: nat > A,N: nat] :
      ( ( map @ nat @ A @ F3 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F3 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I: nat] : ( F3 @ ( suc @ I ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_6283_nth__equal__first__eq,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,N: nat] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N )
            = X2 )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_6284_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A,N: nat] :
      ( ( X2 != Y2 )
     => ( ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N )
          = Y2 )
        = ( ( ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            = Y2 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_6285_take__Cons_H,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X2 @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ) ).

% take_Cons'
thf(fact_6286_Cons__replicate__eq,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,N: nat,Y2: A] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( replicate @ A @ N @ Y2 ) )
      = ( ( X2 = Y2 )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
        & ( Xs
          = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X2 ) ) ) ) ).

% Cons_replicate_eq
thf(fact_6287_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N: A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N @ Ns ) ) @ ( lenlex @ A @ R ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N ) @ R ) )
        | ( ( M = N )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_6288_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( set_Cons @ A @ A3 @ ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image @ A @ ( list @ A )
        @ ^ [X6: A] : ( cons @ A @ X6 @ ( nil @ A ) )
        @ A3 ) ) ).

% set_Cons_sing_Nil
thf(fact_6289_concat__inth,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( append @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X2 ) ).

% concat_inth
thf(fact_6290_same__append__eq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) ).

% same_append_eq
thf(fact_6291_append__same__eq,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) ).

% append_same_eq
thf(fact_6292_append__assoc,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) ).

% append_assoc
thf(fact_6293_append_Oassoc,axiom,
    ! [A: $tType,A2: list @ A,B2: list @ A,C2: list @ A] :
      ( ( append @ A @ ( append @ A @ A2 @ B2 ) @ C2 )
      = ( append @ A @ A2 @ ( append @ A @ B2 @ C2 ) ) ) ).

% append.assoc
thf(fact_6294_append_Oright__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ A2 @ ( nil @ A ) )
      = A2 ) ).

% append.right_neutral
thf(fact_6295_append__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% append_Nil2
thf(fact_6296_append__self__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) ).

% append_self_conv
thf(fact_6297_self__append__conv,axiom,
    ! [A: $tType,Y2: list @ A,Ys: list @ A] :
      ( ( Y2
        = ( append @ A @ Y2 @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) ).

% self_append_conv
thf(fact_6298_append__self__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) ).

% append_self_conv2
thf(fact_6299_self__append__conv2,axiom,
    ! [A: $tType,Y2: list @ A,Xs: list @ A] :
      ( ( Y2
        = ( append @ A @ Xs @ Y2 ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% self_append_conv2
thf(fact_6300_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_is_append_conv
thf(fact_6301_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% append_is_Nil_conv
thf(fact_6302_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_6303_map__append,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( map @ B @ A @ F3 @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F3 @ Xs ) @ ( map @ B @ A @ F3 @ Ys ) ) ) ).

% map_append
thf(fact_6304_filter__append,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( filter2 @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( filter2 @ A @ P3 @ Xs ) @ ( filter2 @ A @ P3 @ Ys ) ) ) ).

% filter_append
thf(fact_6305_rev__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs ) ) ) ).

% rev_append
thf(fact_6306_concat__append,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( concat @ A @ ( append @ ( list @ A ) @ Xs @ Ys ) )
      = ( append @ A @ ( concat @ A @ Xs ) @ ( concat @ A @ Ys ) ) ) ).

% concat_append
thf(fact_6307_foldr__append,axiom,
    ! [B: $tType,A: $tType,F3: B > A > A,Xs: list @ B,Ys: list @ B,A2: A] :
      ( ( foldr @ B @ A @ F3 @ ( append @ B @ Xs @ Ys ) @ A2 )
      = ( foldr @ B @ A @ F3 @ Xs @ ( foldr @ B @ A @ F3 @ Ys @ A2 ) ) ) ).

% foldr_append
thf(fact_6308_removeAll__append,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] :
      ( ( removeAll @ A @ X2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( removeAll @ A @ X2 @ Xs ) @ ( removeAll @ A @ X2 @ Ys ) ) ) ).

% removeAll_append
thf(fact_6309_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A,Y2: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X2 = Y2 ) ) ) ).

% append1_eq_conv
thf(fact_6310_length__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_append
thf(fact_6311_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( groups8242544230860333062m_list @ A @ Ys ) ) ) ) ).

% sum_list_append
thf(fact_6312_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o,Ys: list @ A] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( P3 @ X7 ) )
     => ( ( takeWhile @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ Xs @ ( takeWhile @ A @ P3 @ Ys ) ) ) ) ).

% takeWhile_append2
thf(fact_6313_takeWhile__append1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P3: A > $o,Ys: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P3 @ X2 )
       => ( ( takeWhile @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P3 @ Xs ) ) ) ) ).

% takeWhile_append1
thf(fact_6314_fun__upds__append2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),Zs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ Xs @ ( append @ B @ Ys @ Zs ) )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% fun_upds_append2_drop
thf(fact_6315_fun__upds__append__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),Zs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs @ Zs ) @ Ys )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% fun_upds_append_drop
thf(fact_6316_size__list__append,axiom,
    ! [A: $tType,F3: A > nat,Xs: list @ A,Ys: list @ A] :
      ( ( size_list @ A @ F3 @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F3 @ Xs ) @ ( size_list @ A @ F3 @ Ys ) ) ) ).

% size_list_append
thf(fact_6317_nth__append__length,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X2 ) ).

% nth_append_length
thf(fact_6318_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,N: nat] :
      ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
      = ( nth @ A @ Ys @ N ) ) ).

% nth_append_length_plus
thf(fact_6319_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys ) @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% rev_eq_Cons_iff
thf(fact_6320_take__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A] :
      ( ( take @ A @ N @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( take @ A @ N @ Xs ) @ ( take @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% take_append
thf(fact_6321_list__update__length,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A,Y2: A] :
      ( ( list_update @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) @ Y2 )
      = ( append @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) ) ).

% list_update_length
thf(fact_6322_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_6323_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_6324_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_6325_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_6326_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_6327_takeWhile__tail,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A,L: list @ A] :
      ( ~ ( P3 @ X2 )
     => ( ( takeWhile @ A @ P3 @ ( append @ A @ Xs @ ( cons @ A @ X2 @ L ) ) )
        = ( takeWhile @ A @ P3 @ Xs ) ) ) ).

% takeWhile_tail
thf(fact_6328_concat__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( concat @ A )
      = ( ^ [Xss3: list @ ( list @ A )] : ( foldr @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss3 @ ( nil @ A ) ) ) ) ).

% concat_conv_foldr
thf(fact_6329_upt__Suc__append,axiom,
    ! [I3: nat,J2: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( upt @ I3 @ ( suc @ J2 ) )
        = ( append @ nat @ ( upt @ I3 @ J2 ) @ ( cons @ nat @ J2 @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_6330_upt__Suc,axiom,
    ! [I3: nat,J2: nat] :
      ( ( ( ord_less_eq @ nat @ I3 @ J2 )
       => ( ( upt @ I3 @ ( suc @ J2 ) )
          = ( append @ nat @ ( upt @ I3 @ J2 ) @ ( cons @ nat @ J2 @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I3 @ J2 )
       => ( ( upt @ I3 @ ( suc @ J2 ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_6331_split__list,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( Xs
          = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) ) ) ).

% split_list
thf(fact_6332_split__list__last,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ~ ( member @ A @ X2 @ ( set2 @ A @ Zs2 ) ) ) ) ).

% split_list_last
thf(fact_6333_split__list__prop,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P3 @ X ) )
     => ? [Ys4: list @ A,X7: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X7 @ Zs2 ) ) )
          & ( P3 @ X7 ) ) ) ).

% split_list_prop
thf(fact_6334_split__list__first,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ~ ( member @ A @ X2 @ ( set2 @ A @ Ys4 ) ) ) ) ).

% split_list_first
thf(fact_6335_split__list__propE,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P3 @ X ) )
     => ~ ! [Ys4: list @ A,X7: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X7 @ Zs2 ) ) )
           => ~ ( P3 @ X7 ) ) ) ).

% split_list_propE
thf(fact_6336_append__Cons__eq__iff,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A,Xs5: list @ A,Ys6: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ~ ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
       => ( ( ( append @ A @ Xs @ ( cons @ A @ X2 @ Ys ) )
            = ( append @ A @ Xs5 @ ( cons @ A @ X2 @ Ys6 ) ) )
          = ( ( Xs = Xs5 )
            & ( Ys = Ys6 ) ) ) ) ) ).

% append_Cons_eq_iff
thf(fact_6337_in__set__conv__decomp,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys2: list @ A,Zs3: list @ A] :
            ( Xs
            = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp
thf(fact_6338_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P3 @ X ) )
     => ? [Ys4: list @ A,X7: A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X7 @ Zs2 ) ) )
          & ( P3 @ X7 )
          & ! [Xa3: A] :
              ( ( member @ A @ Xa3 @ ( set2 @ A @ Zs2 ) )
             => ~ ( P3 @ Xa3 ) ) ) ) ).

% split_list_last_prop
thf(fact_6339_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P3 @ X ) )
     => ? [Ys4: list @ A,X7: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X7 @ Zs2 ) ) )
          & ( P3 @ X7 )
          & ! [Xa3: A] :
              ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
             => ~ ( P3 @ Xa3 ) ) ) ) ).

% split_list_first_prop
thf(fact_6340_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P3 @ X ) )
     => ~ ! [Ys4: list @ A,X7: A,Zs2: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X7 @ Zs2 ) ) )
           => ( ( P3 @ X7 )
             => ~ ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ ( set2 @ A @ Zs2 ) )
                   => ~ ( P3 @ Xa3 ) ) ) ) ) ).

% split_list_last_propE
thf(fact_6341_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P3 @ X ) )
     => ~ ! [Ys4: list @ A,X7: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X7 @ Zs2 ) ) )
           => ( ( P3 @ X7 )
             => ~ ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                   => ~ ( P3 @ Xa3 ) ) ) ) ) ).

% split_list_first_propE
thf(fact_6342_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys2: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ~ ( member @ A @ X2 @ ( set2 @ A @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp_last
thf(fact_6343_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys2: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ~ ( member @ A @ X2 @ ( set2 @ A @ Ys2 ) ) ) ) ) ).

% in_set_conv_decomp_first
thf(fact_6344_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ( ? [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
            & ( P3 @ X6 ) ) )
      = ( ? [Ys2: list @ A,X6: A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X6 @ Zs3 ) ) )
            & ( P3 @ X6 )
            & ! [Y: A] :
                ( ( member @ A @ Y @ ( set2 @ A @ Zs3 ) )
               => ~ ( P3 @ Y ) ) ) ) ) ).

% split_list_last_prop_iff
thf(fact_6345_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ( ? [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
            & ( P3 @ X6 ) ) )
      = ( ? [Ys2: list @ A,X6: A] :
            ( ? [Zs3: list @ A] :
                ( Xs
                = ( append @ A @ Ys2 @ ( cons @ A @ X6 @ Zs3 ) ) )
            & ( P3 @ X6 )
            & ! [Y: A] :
                ( ( member @ A @ Y @ ( set2 @ A @ Ys2 ) )
               => ~ ( P3 @ Y ) ) ) ) ) ).

% split_list_first_prop_iff
thf(fact_6346_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A3: set @ A,As2: list @ ( set @ A )] :
      ( ( listset @ A @ ( cons @ ( set @ A ) @ A3 @ As2 ) )
      = ( set_Cons @ A @ A3 @ ( listset @ A @ As2 ) ) ) ).

% listset.simps(2)
thf(fact_6347_append__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] :
      ( ( append @ A @ ( cons @ A @ X2 @ Xs ) @ Ys )
      = ( cons @ A @ X2 @ ( append @ A @ Xs @ Ys ) ) ) ).

% append_Cons
thf(fact_6348_Cons__eq__appendI,axiom,
    ! [A: $tType,X2: A,Xs1: list @ A,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X2 @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X2 @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) ).

% Cons_eq_appendI
thf(fact_6349_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X2: list @ A,Xs: list @ ( list @ A )] :
      ( ( concat @ A @ ( cons @ ( list @ A ) @ X2 @ Xs ) )
      = ( append @ A @ X2 @ ( concat @ A @ Xs ) ) ) ).

% concat.simps(2)
thf(fact_6350_replicate__app__Cons__same,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( append @ A @ ( replicate @ A @ N @ X2 ) @ ( cons @ A @ X2 @ Xs ) )
      = ( cons @ A @ X2 @ ( append @ A @ ( replicate @ A @ N @ X2 ) @ Xs ) ) ) ).

% replicate_app_Cons_same
thf(fact_6351_append__Nil,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% append_Nil
thf(fact_6352_append_Oleft__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ A2 )
      = A2 ) ).

% append.left_neutral
thf(fact_6353_rev__induct,axiom,
    ! [A: $tType,P3: ( list @ A ) > $o,Xs: list @ A] :
      ( ( P3 @ ( nil @ A ) )
     => ( ! [X7: A,Xs3: list @ A] :
            ( ( P3 @ Xs3 )
           => ( P3 @ ( append @ A @ Xs3 @ ( cons @ A @ X7 @ ( nil @ A ) ) ) ) )
       => ( P3 @ Xs ) ) ) ).

% rev_induct
thf(fact_6354_rev__exhaust,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ! [Ys4: list @ A,Y5: A] :
            ( Xs
           != ( append @ A @ Ys4 @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) ) ) ).

% rev_exhaust
thf(fact_6355_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) ).

% eq_Nil_appendI
thf(fact_6356_Cons__eq__append__conv,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X2 @ Xs )
            = Zs ) )
        | ? [Ys7: list @ A] :
            ( ( ( cons @ A @ X2 @ Ys7 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys7 @ Zs ) ) ) ) ) ).

% Cons_eq_append_conv
thf(fact_6357_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,X2: A,Xs: list @ A] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X2 @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X2 @ Xs ) ) )
        | ? [Ys7: list @ A] :
            ( ( Ys
              = ( cons @ A @ X2 @ Ys7 ) )
            & ( ( append @ A @ Ys7 @ Zs )
              = Xs ) ) ) ) ).

% append_eq_Cons_conv
thf(fact_6358_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P3: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X7: A] : ( P3 @ ( cons @ A @ X7 @ ( nil @ A ) ) )
       => ( ! [X7: A,Xs3: list @ A] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P3 @ Xs3 )
               => ( P3 @ ( append @ A @ Xs3 @ ( cons @ A @ X7 @ ( nil @ A ) ) ) ) ) )
         => ( P3 @ Xs ) ) ) ) ).

% rev_nonempty_induct
thf(fact_6359_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
     => ( ( Xss
         != ( nil @ ( list @ A ) ) )
       => ? [Xss1: list @ ( list @ A ),Xs3: list @ A,Xs4: list @ A,Xss22: list @ ( list @ A )] :
            ( ( Xss
              = ( append @ ( list @ A ) @ Xss1 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs3 @ Xs4 ) @ Xss22 ) ) )
            & ( Ys
              = ( append @ A @ ( concat @ A @ Xss1 ) @ Xs3 ) )
            & ( Zs
              = ( append @ A @ Xs4 @ ( concat @ A @ Xss22 ) ) ) ) ) ) ).

% concat_eq_appendD
thf(fact_6360_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Xss
            = ( nil @ ( list @ A ) ) )
         => ( ( Ys
              = ( nil @ A ) )
            & ( Zs
              = ( nil @ A ) ) ) )
        & ( ( Xss
           != ( nil @ ( list @ A ) ) )
         => ? [Xss12: list @ ( list @ A ),Xs2: list @ A,Xs6: list @ A,Xss23: list @ ( list @ A )] :
              ( ( Xss
                = ( append @ ( list @ A ) @ Xss12 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs2 @ Xs6 ) @ Xss23 ) ) )
              & ( Ys
                = ( append @ A @ ( concat @ A @ Xss12 ) @ Xs2 ) )
              & ( Zs
                = ( append @ A @ Xs6 @ ( concat @ A @ Xss23 ) ) ) ) ) ) ) ).

% concat_eq_append_conv
thf(fact_6361_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N: nat,Ns: list @ nat,Q2: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N @ Ns ) )
        = ( upt @ M @ Q2 ) )
      = ( ( cons @ nat @ N @ Ns )
        = ( upt @ ( suc @ M ) @ Q2 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_6362_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
      = ( transpose @ A @ Xss ) ) ).

% transpose.simps(2)
thf(fact_6363_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A] :
      ( ( enumerate @ A @ N @ ( append @ A @ Xs @ Ys ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ ( enumerate @ A @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% enumerate_append_eq
thf(fact_6364_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) ) ) ).

% lex_append_leftI
thf(fact_6365_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B,Ys: list @ A,Zs: list @ A] :
      ( ( ( map @ B @ A @ F3 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( Ys
              = ( map @ B @ A @ F3 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F3 @ Vs2 ) ) ) ) ) ).

% map_eq_append_conv
thf(fact_6366_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ A,Zs: list @ A,F3: B > A,Xs: list @ B] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( map @ B @ A @ F3 @ Xs ) )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( Ys
              = ( map @ B @ A @ F3 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F3 @ Vs2 ) ) ) ) ) ).

% append_eq_map_conv
thf(fact_6367_append__replicate__commute,axiom,
    ! [A: $tType,N: nat,X2: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N @ X2 ) @ ( replicate @ A @ K @ X2 ) )
      = ( append @ A @ ( replicate @ A @ K @ X2 ) @ ( replicate @ A @ N @ X2 ) ) ) ).

% append_replicate_commute
thf(fact_6368_replicate__add,axiom,
    ! [A: $tType,N: nat,M: nat,X2: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N @ M ) @ X2 )
      = ( append @ A @ ( replicate @ A @ N @ X2 ) @ ( replicate @ A @ M @ X2 ) ) ) ).

% replicate_add
thf(fact_6369_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,Ts: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: list @ A] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) ).

% append_eq_append_conv2
thf(fact_6370_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Xs1: list @ A,Zs: list @ A,Ys: list @ A,Us: list @ A] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) ).

% append_eq_appendI
thf(fact_6371_sorted__wrt__append,axiom,
    ! [A: $tType,P3: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
      = ( ( sorted_wrt @ A @ P3 @ Xs )
        & ( sorted_wrt @ A @ P3 @ Ys )
        & ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
           => ! [Y: A] :
                ( ( member @ A @ Y @ ( set2 @ A @ Ys ) )
               => ( P3 @ X6 @ Y ) ) ) ) ) ).

% sorted_wrt_append
thf(fact_6372_append__listrel1I,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R ) ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( listrel1 @ A @ R ) ) ) ).

% append_listrel1I
thf(fact_6373_remove1__append,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] :
      ( ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X2 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( remove1 @ A @ X2 @ Xs ) @ Ys ) ) )
      & ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X2 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( remove1 @ A @ X2 @ Ys ) ) ) ) ) ).

% remove1_append
thf(fact_6374_remdups__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( remdups @ A @ ( append @ A @ Xs @ ( remdups @ A @ Ys ) ) )
      = ( remdups @ A @ ( append @ A @ Xs @ Ys ) ) ) ).

% remdups_append2
thf(fact_6375_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Ys @ Xs ) )
     => ? [M5: nat,N3: nat,Zs2: list @ A] :
          ( ( ( concat @ A @ ( replicate @ ( list @ A ) @ M5 @ Zs2 ) )
            = Xs )
          & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
            = Ys ) ) ) ).

% comm_append_are_replicate
thf(fact_6376_same__length__different,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs != Ys )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ? [Pre: list @ A,X7: A,Xs4: list @ A,Y5: A,Ys5: list @ A] :
            ( ( X7 != Y5 )
            & ( Xs
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X7 @ ( nil @ A ) ) @ Xs4 ) ) )
            & ( Ys
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y5 @ ( nil @ A ) ) @ Ys5 ) ) ) ) ) ) ).

% same_length_different
thf(fact_6377_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ Ys ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
            & ! [X6: A] :
                ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
               => ! [Y: A] :
                    ( ( member @ A @ Y @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X6 @ Y ) ) ) ) ) ) ).

% sorted_append
thf(fact_6378_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list @ A] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs3: list @ A,Ys4: list @ A,Zs2: list @ A,Y5: A] :
          ( Ws
          = ( append @ A @ Xs3 @ ( append @ A @ ( cons @ A @ Y5 @ ( nil @ A ) ) @ ( append @ A @ Ys4 @ ( append @ A @ ( cons @ A @ Y5 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_decomp
thf(fact_6379_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As3: list @ A] :
      ( ( ~ ( distinct @ A @ As3 ) )
      = ( ? [Xs2: list @ A,Y: A,Ys2: list @ A] :
            ( ( member @ A @ Y @ ( set2 @ A @ Xs2 ) )
            & ( distinct @ A @ Xs2 )
            & ( As3
              = ( append @ A @ Xs2 @ ( cons @ A @ Y @ Ys2 ) ) ) ) ) ) ).

% not_distinct_conv_prefix
thf(fact_6380_Cons__eq__filterD,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P3: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( filter2 @ A @ P3 @ Ys ) )
     => ? [Us3: list @ A,Vs3: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X2 @ Vs3 ) ) )
          & ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Us3 ) )
             => ~ ( P3 @ X ) )
          & ( P3 @ X2 )
          & ( Xs
            = ( filter2 @ A @ P3 @ Vs3 ) ) ) ) ).

% Cons_eq_filterD
thf(fact_6381_filter__eq__ConsD,axiom,
    ! [A: $tType,P3: A > $o,Ys: list @ A,X2: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P3 @ Ys )
        = ( cons @ A @ X2 @ Xs ) )
     => ? [Us3: list @ A,Vs3: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X2 @ Vs3 ) ) )
          & ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Us3 ) )
             => ~ ( P3 @ X ) )
          & ( P3 @ X2 )
          & ( Xs
            = ( filter2 @ A @ P3 @ Vs3 ) ) ) ) ).

% filter_eq_ConsD
thf(fact_6382_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P3: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( filter2 @ A @ P3 @ Ys ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X2 @ Vs2 ) ) )
            & ! [X6: A] :
                ( ( member @ A @ X6 @ ( set2 @ A @ Us2 ) )
               => ~ ( P3 @ X6 ) )
            & ( P3 @ X2 )
            & ( Xs
              = ( filter2 @ A @ P3 @ Vs2 ) ) ) ) ) ).

% Cons_eq_filter_iff
thf(fact_6383_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P3: A > $o,Ys: list @ A,X2: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P3 @ Ys )
        = ( cons @ A @ X2 @ Xs ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X2 @ Vs2 ) ) )
            & ! [X6: A] :
                ( ( member @ A @ X6 @ ( set2 @ A @ Us2 ) )
               => ~ ( P3 @ X6 ) )
            & ( P3 @ X2 )
            & ( Xs
              = ( filter2 @ A @ P3 @ Vs2 ) ) ) ) ) ).

% filter_eq_Cons_iff
thf(fact_6384_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( rev @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% rev.simps(2)
thf(fact_6385_replicate__append__same,axiom,
    ! [A: $tType,I3: nat,X2: A] :
      ( ( append @ A @ ( replicate @ A @ I3 @ X2 ) @ ( cons @ A @ X2 @ ( nil @ A ) ) )
      = ( cons @ A @ X2 @ ( replicate @ A @ I3 @ X2 ) ) ) ).

% replicate_append_same
thf(fact_6386_upt__add__eq__append,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( upt @ I3 @ ( plus_plus @ nat @ J2 @ K ) )
        = ( append @ nat @ ( upt @ I3 @ J2 ) @ ( upt @ J2 @ ( plus_plus @ nat @ J2 @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_6387_list__update__append1,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,Ys: list @ A,X2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ I3 @ X2 )
        = ( append @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ Ys ) ) ) ).

% list_update_append1
thf(fact_6388_remove1__split,axiom,
    ! [A: $tType,A2: A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
     => ( ( ( remove1 @ A @ A2 @ Xs )
          = Ys )
        = ( ? [Ls: list @ A,Rs: list @ A] :
              ( ( Xs
                = ( append @ A @ Ls @ ( cons @ A @ A2 @ Rs ) ) )
              & ~ ( member @ A @ A2 @ ( set2 @ A @ Ls ) )
              & ( Ys
                = ( append @ A @ Ls @ Rs ) ) ) ) ) ) ).

% remove1_split
thf(fact_6389_upt__conv__Cons,axiom,
    ! [I3: nat,J2: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ( upt @ I3 @ J2 )
        = ( cons @ nat @ I3 @ ( upt @ ( suc @ I3 ) @ J2 ) ) ) ) ).

% upt_conv_Cons
thf(fact_6390_lex__append__leftD,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X7: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X7 @ X7 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_leftD
thf(fact_6391_lex__append__left__iff,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X7: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X7 @ X7 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_left_iff
thf(fact_6392_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( rotate1 @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% rotate1.simps(2)
thf(fact_6393_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_rightI
thf(fact_6394_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs: list @ A,R3: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs ) @ ( lenlex @ A @ R3 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs @ Ys ) ) @ ( lenlex @ A @ R3 ) ) ) ) ).

% lenlex_append1
thf(fact_6395_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( subseqs @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% subseqs.simps(1)
thf(fact_6396_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% product_lists.simps(1)
thf(fact_6397_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y: A,Ys2: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys2 )
              = N ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_6398_length__append__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_append_singleton
thf(fact_6399_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( subseqs @ A @ Xs ) ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs.simps(2)
thf(fact_6400_nth__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N )
          = ( nth @ A @ Xs @ N ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N )
          = ( nth @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nth_append
thf(fact_6401_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A,X2: A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N @ X2 )
          = ( append @ A @ ( list_update @ A @ Xs @ N @ X2 ) @ Ys ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N @ X2 )
          = ( append @ A @ Xs @ ( list_update @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ X2 ) ) ) ) ) ).

% list_update_append
thf(fact_6402_listrel1E,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ~ ! [X7: A,Y5: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X7 @ Y5 ) @ R )
           => ! [Us3: list @ A,Vs3: list @ A] :
                ( ( Xs
                  = ( append @ A @ Us3 @ ( cons @ A @ X7 @ Vs3 ) ) )
               => ( Ys
                 != ( append @ A @ Us3 @ ( cons @ A @ Y5 @ Vs3 ) ) ) ) ) ) ).

% listrel1E
thf(fact_6403_listrel1I,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Us: list @ A,Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X2 @ Vs ) ) )
       => ( ( Ys
            = ( append @ A @ Us @ ( cons @ A @ Y2 @ Vs ) ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% listrel1I
thf(fact_6404_upt__eq__Cons__conv,axiom,
    ! [I3: nat,J2: nat,X2: nat,Xs: list @ nat] :
      ( ( ( upt @ I3 @ J2 )
        = ( cons @ nat @ X2 @ Xs ) )
      = ( ( ord_less @ nat @ I3 @ J2 )
        & ( I3 = X2 )
        & ( ( upt @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) @ J2 )
          = Xs ) ) ) ).

% upt_eq_Cons_conv
thf(fact_6405_upt__rec,axiom,
    ( upt
    = ( ^ [I: nat,J4: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I @ J4 ) @ ( cons @ nat @ I @ ( upt @ ( suc @ I ) @ J4 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_6406_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list @ A,Ys: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X2 @ Xs ) @ Ys )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ).

% product.simps(2)
thf(fact_6407_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_6408_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I3: nat,J2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I3 ) @ J2 )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I3 @ J2 ) )
        = ( cons @ nat @ ( suc @ I3 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I3 ) @ J2 ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_6409_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I3: nat,J2: nat] :
      ( ( ord_less @ nat @ ( suc @ I3 ) @ J2 )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I3 @ J2 ) )
        = ( cons @ nat @ ( suc @ I3 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I3 ) @ J2 ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_6410_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A,Y2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) @ ( append @ A @ Ys @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( X2 = Y2 ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_6411_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F3: B > A,A2: A,Xs: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ ( append @ B @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_6412_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs @ Ys )
            = ( append @ A @ Ys @ Xs ) )
         => ? [N3: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N3 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
                = ( append @ A @ Xs @ Ys ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_6413_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X7 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X6: A] : X6
                @ A2
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_6414_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ ( suc @ I3 ) @ Xs )
        = ( append @ A @ ( take @ A @ I3 @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I3 ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_6415_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat,X2: A] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( M != N )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N @ Xs ) @ ( append @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) @ M )
            = ( nth @ A @ Xs @ M ) ) ) ) ) ).

% nth_repl
thf(fact_6416_pos__n__replace,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Y2: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N @ Xs ) @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N ) @ Xs ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_6417_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X6: list @ A] : X6 ) ) ).

% drop0
thf(fact_6418_drop__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( drop @ A @ M @ Xs ) )
      = ( drop @ A @ ( plus_plus @ nat @ N @ M ) @ Xs ) ) ).

% drop_drop
thf(fact_6419_drop__upt,axiom,
    ! [M: nat,I3: nat,J2: nat] :
      ( ( drop @ nat @ M @ ( upt @ I3 @ J2 ) )
      = ( upt @ ( plus_plus @ nat @ I3 @ M ) @ J2 ) ) ).

% drop_upt
thf(fact_6420_drop__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ ( cons @ A @ X2 @ Xs ) )
      = ( drop @ A @ N @ Xs ) ) ).

% drop_Suc_Cons
thf(fact_6421_length__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_drop
thf(fact_6422_append__take__drop__id,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( drop @ A @ N @ Xs ) )
      = Xs ) ).

% append_take_drop_id
thf(fact_6423_drop__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A,X2: A] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N @ X2 ) )
        = ( drop @ A @ M @ Xs ) ) ) ).

% drop_update_cancel
thf(fact_6424_drop__replicate,axiom,
    ! [A: $tType,I3: nat,K: nat,X2: A] :
      ( ( drop @ A @ I3 @ ( replicate @ A @ K @ X2 ) )
      = ( replicate @ A @ ( minus_minus @ nat @ K @ I3 ) @ X2 ) ) ).

% drop_replicate
thf(fact_6425_drop__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_6426_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil
thf(fact_6427_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N @ Xs ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil2
thf(fact_6428_drop__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A] :
      ( ( drop @ A @ N @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( drop @ A @ N @ Xs ) @ ( drop @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% drop_append
thf(fact_6429_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X2: A,Xs: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X2 @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs ) ) ).

% drop_Cons_numeral
thf(fact_6430_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,I3: nat] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( drop @ A @ N @ Xs ) @ I3 )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ N @ I3 ) ) ) ) ).

% nth_drop
thf(fact_6431_nth__via__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
     => ( ( nth @ A @ Xs @ N )
        = Y2 ) ) ).

% nth_via_drop
thf(fact_6432_drop__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F3: B > A,Xs: list @ B] :
      ( ( drop @ A @ N @ ( map @ B @ A @ F3 @ Xs ) )
      = ( map @ B @ A @ F3 @ ( drop @ B @ N @ Xs ) ) ) ).

% drop_map
thf(fact_6433_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N @ Xs ) ) ) ) ).

% sorted_drop
thf(fact_6434_set__drop__subset,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_drop_subset
thf(fact_6435_distinct__drop,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( drop @ A @ I3 @ Xs ) ) ) ).

% distinct_drop
thf(fact_6436_drop__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( take @ A @ M @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ M @ N ) @ ( drop @ A @ N @ Xs ) ) ) ).

% drop_take
thf(fact_6437_take__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( drop @ A @ M @ Xs ) )
      = ( drop @ A @ M @ ( take @ A @ ( plus_plus @ nat @ N @ M ) @ Xs ) ) ) ).

% take_drop
thf(fact_6438_in__set__dropD,axiom,
    ! [A: $tType,X2: A,N: nat,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) )
     => ( member @ A @ X2 @ ( set2 @ A @ Xs ) ) ) ).

% in_set_dropD
thf(fact_6439_drop__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs )
      = Xs ) ).

% drop_0
thf(fact_6440_sorted__wrt__drop,axiom,
    ! [A: $tType,F3: A > A > $o,Xs: list @ A,N: nat] :
      ( ( sorted_wrt @ A @ F3 @ Xs )
     => ( sorted_wrt @ A @ F3 @ ( drop @ A @ N @ Xs ) ) ) ).

% sorted_wrt_drop
thf(fact_6441_drop__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( drop @ A @ N @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% drop_Nil
thf(fact_6442_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M @ Xs ) ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_6443_take__add,axiom,
    ! [A: $tType,I3: nat,J2: nat,Xs: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I3 @ J2 ) @ Xs )
      = ( append @ A @ ( take @ A @ I3 @ Xs ) @ ( take @ A @ J2 @ ( drop @ A @ I3 @ Xs ) ) ) ) ).

% take_add
thf(fact_6444_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Zs )
      = ( ( Xs
          = ( take @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) )
        & ( Ys
          = ( drop @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% append_eq_conv_conj
thf(fact_6445_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A,X2: A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N @ X2 ) )
        = ( list_update @ A @ ( drop @ A @ M @ Xs ) @ ( minus_minus @ nat @ N @ M ) @ X2 ) ) ) ).

% drop_update_swap
thf(fact_6446_drop__Cons,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( drop @ A @ N @ ( cons @ A @ X2 @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ X2 @ Xs )
        @ ^ [M4: nat] : ( drop @ A @ M4 @ Xs )
        @ N ) ) ).

% drop_Cons
thf(fact_6447_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ Xs ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X2 @ Xs ) )
          = ( drop @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ).

% drop_Cons'
thf(fact_6448_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_6449_take__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ) ).

% take_rev
thf(fact_6450_rev__take,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A] :
      ( ( rev @ A @ ( take @ A @ I3 @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I3 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_take
thf(fact_6451_rev__drop,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I3 @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I3 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_drop
thf(fact_6452_drop__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ) ).

% drop_rev
thf(fact_6453_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( cons @ A @ ( nth @ A @ Xs @ I3 ) @ ( drop @ A @ ( suc @ I3 ) @ Xs ) )
        = ( drop @ A @ I3 @ Xs ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_6454_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I3: nat,J2: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I3 @ J2 )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I3 @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J2 @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_6455_id__take__nth__drop,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( Xs
        = ( append @ A @ ( take @ A @ I3 @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I3 ) @ ( drop @ A @ ( suc @ I3 ) @ Xs ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_6456_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,A2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ Xs @ I3 @ A2 )
        = ( append @ A @ ( take @ A @ I3 @ Xs ) @ ( cons @ A @ A2 @ ( drop @ A @ ( suc @ I3 ) @ Xs ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_6457_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),X2: A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) @ Ys )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ Xs @ Ys ) @ X2 @ ( some @ B @ ( nth @ B @ Ys @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% map_upds_append1
thf(fact_6458_empty__upd__none,axiom,
    ! [B: $tType,A: $tType,X2: A] :
      ( ( fun_upd @ A @ ( option @ B )
        @ ^ [X6: A] : ( none @ B )
        @ X2
        @ ( none @ B ) )
      = ( ^ [X6: A] : ( none @ B ) ) ) ).

% empty_upd_none
thf(fact_6459_map__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y2: A,Xs: list @ A,F3: A > B,V: B] :
      ( ~ ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
     => ( ( map @ A @ B @ ( fun_upd @ A @ B @ F3 @ Y2 @ V ) @ Xs )
        = ( map @ A @ B @ F3 @ Xs ) ) ) ).

% map_fun_upd
thf(fact_6460_map__upds__twist,axiom,
    ! [A: $tType,B: $tType,A2: A,As3: list @ A,M: A > ( option @ B ),B2: B,Bs: list @ B] :
      ( ~ ( member @ A @ A2 @ ( set2 @ A @ As3 ) )
     => ( ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ B2 ) ) @ As3 @ Bs )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ As3 @ Bs ) @ A2 @ ( some @ B @ B2 ) ) ) ) ).

% map_upds_twist
thf(fact_6461_graph__map__upd,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),K: A,V: B] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( some @ B @ V ) ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) ) ) ) ) ).

% graph_map_upd
thf(fact_6462_ran__map__upd,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( none @ A ) )
     => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M @ A2 @ ( some @ A @ B2 ) ) )
        = ( insert @ A @ B2 @ ( ran @ B @ A @ M ) ) ) ) ).

% ran_map_upd
thf(fact_6463_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,X2: A,D4: set @ A,M: A > ( option @ B )] :
      ( ( ( member @ A @ X2 @ D4 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D4 ) @ X2 @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D4 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )
      & ( ~ ( member @ A @ X2 @ D4 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D4 ) @ X2 @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M @ D4 ) ) ) ) ).

% fun_upd_None_restrict
thf(fact_6464_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F2: A > ( list @ A ) > B,X21: A,X222: list @ A] :
      ( ( case_list @ B @ A @ F1 @ F2 @ ( cons @ A @ X21 @ X222 ) )
      = ( F2 @ X21 @ X222 ) ) ).

% list.simps(5)
thf(fact_6465_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F2: A > ( list @ A ) > B] :
      ( ( case_list @ B @ A @ F1 @ F2 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(4)
thf(fact_6466_finite__update__induct,axiom,
    ! [B: $tType,A: $tType,F3: A > B,C2: B,P3: ( A > B ) > $o] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [A5: A] :
              ( ( F3 @ A5 )
             != C2 ) ) )
     => ( ( P3
          @ ^ [A5: A] : C2 )
       => ( ! [A4: A,B3: B,F6: A > B] :
              ( ( finite_finite2 @ A
                @ ( collect @ A
                  @ ^ [C4: A] :
                      ( ( F6 @ C4 )
                     != C2 ) ) )
             => ( ( ( F6 @ A4 )
                  = C2 )
               => ( ( B3 != C2 )
                 => ( ( P3 @ F6 )
                   => ( P3 @ ( fun_upd @ A @ B @ F6 @ A4 @ B3 ) ) ) ) ) )
         => ( P3 @ F3 ) ) ) ) ).

% finite_update_induct
thf(fact_6467_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H: B > C,F1: B,F2: A > ( list @ A ) > B,List: list @ A] :
      ( ( H @ ( case_list @ B @ A @ F1 @ F2 @ List ) )
      = ( case_list @ C @ A @ ( H @ F1 )
        @ ^ [X1: A,X22: list @ A] : ( H @ ( F2 @ X1 @ X22 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_6468_map__upd__nonempty,axiom,
    ! [B: $tType,A: $tType,T3: A > ( option @ B ),K: A,X2: B] :
      ( ( fun_upd @ A @ ( option @ B ) @ T3 @ K @ ( some @ B @ X2 ) )
     != ( ^ [X6: A] : ( none @ B ) ) ) ).

% map_upd_nonempty
thf(fact_6469_graph__fun__upd__None,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),K: A] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [E3: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ E3 @ ( graph @ A @ B @ M ) )
            & ( ( product_fst @ A @ B @ E3 )
             != K ) ) ) ) ).

% graph_fun_upd_None
thf(fact_6470_restrict__complement__singleton__eq,axiom,
    ! [A: $tType,B: $tType,F3: A > ( option @ B ),X2: A] :
      ( ( restrict_map @ A @ B @ F3 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ F3 @ X2 @ ( none @ B ) ) ) ).

% restrict_complement_singleton_eq
thf(fact_6471_map__upd__upds__conv__if,axiom,
    ! [A: $tType,B: $tType,X2: A,Ys: list @ B,Xs: list @ A,F3: A > ( option @ B ),Y2: B] :
      ( ( ( member @ A @ X2 @ ( set2 @ A @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) ) )
       => ( ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F3 @ X2 @ ( some @ B @ Y2 ) ) @ Xs @ Ys )
          = ( map_upds @ A @ B @ F3 @ Xs @ Ys ) ) )
      & ( ~ ( member @ A @ X2 @ ( set2 @ A @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) ) )
       => ( ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F3 @ X2 @ ( some @ B @ Y2 ) ) @ Xs @ Ys )
          = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ F3 @ Xs @ Ys ) @ X2 @ ( some @ B @ Y2 ) ) ) ) ) ).

% map_upd_upds_conv_if
thf(fact_6472_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Xss ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X2
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H2: A,T2: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
              @ Xss ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H2: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                @ Xss ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_6473_transpose_Oelims,axiom,
    ! [A: $tType,X2: list @ ( list @ A ),Y2: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( nil @ ( list @ A ) ) )
         => ( Y2
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( X2
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( Y2
               != ( transpose @ A @ Xss2 ) ) )
         => ~ ! [X7: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                ( ( X2
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X7 @ Xs3 ) @ Xss2 ) )
               => ( Y2
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X7
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H2: A,T2: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
                          @ Xss2 ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs3
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H2: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss2 ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_6474_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H2: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys2: list @ A] :
              ( Ys2
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_tail
thf(fact_6475_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H2: A,T2: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys2: list @ A] :
              ( Ys2
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_head
thf(fact_6476_tl__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( tl @ nat @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ N ) ) ).

% tl_upt
thf(fact_6477_hd__upt,axiom,
    ! [I3: nat,J2: nat] :
      ( ( ord_less @ nat @ I3 @ J2 )
     => ( ( hd @ nat @ ( upt @ I3 @ J2 ) )
        = I3 ) ) ).

% hd_upt
thf(fact_6478_hd__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_append2
thf(fact_6479_tl__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys ) ) ) ).

% tl_append2
thf(fact_6480_hd__replicate,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X2 ) )
        = X2 ) ) ).

% hd_replicate
thf(fact_6481_hd__take,axiom,
    ! [A: $tType,J2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J2 )
     => ( ( hd @ A @ ( take @ A @ J2 @ Xs ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_take
thf(fact_6482_length__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_6483_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) ).

% hd_Cons_tl
thf(fact_6484_list_Ocollapse,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) ).

% list.collapse
thf(fact_6485_tl__replicate,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( tl @ A @ ( replicate @ A @ N @ X2 ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X2 ) ) ).

% tl_replicate
thf(fact_6486_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P3: B > $o,F1: B,F2: A > ( list @ A ) > B,List: list @ A] :
      ( ( P3 @ ( case_list @ B @ A @ F1 @ F2 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P3 @ F1 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P3 @ ( F2 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ).

% list.split_sel
thf(fact_6487_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P3: B > $o,F1: B,F2: A > ( list @ A ) > B,List: list @ A] :
      ( ( P3 @ ( case_list @ B @ A @ F1 @ F2 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P3 @ F1 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P3 @ ( F2 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) ).

% list.split_sel_asm
thf(fact_6488_tl__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( tl @ A @ ( drop @ A @ N @ Xs ) )
      = ( drop @ A @ N @ ( tl @ A @ Xs ) ) ) ).

% tl_drop
thf(fact_6489_drop__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ Xs )
      = ( drop @ A @ N @ ( tl @ A @ Xs ) ) ) ).

% drop_Suc
thf(fact_6490_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu3: A,Uv3: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_6491_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu3: A,Uv3: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_6492_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F12: B,F22: A > ( list @ A ) > B,List2: list @ A] :
            ( if @ B
            @ ( List2
              = ( nil @ A ) )
            @ F12
            @ ( F22 @ ( hd @ A @ List2 ) @ ( tl @ A @ List2 ) ) ) ) ) ).

% list.case_eq_if
thf(fact_6493_hd__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( Xs
       != ( nil @ ( list @ A ) ) )
     => ( ( ( hd @ ( list @ A ) @ Xs )
         != ( nil @ A ) )
       => ( ( hd @ A @ ( concat @ A @ Xs ) )
          = ( hd @ A @ ( hd @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_concat
thf(fact_6494_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F3: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F3 @ A2 ) )
        = ( map @ A @ B @ F3 @ ( tl @ A @ A2 ) ) ) ) ).

% list.map_sel(2)
thf(fact_6495_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F3: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F3 @ Xs ) )
        = ( F3 @ ( hd @ A @ Xs ) ) ) ) ).

% hd_map
thf(fact_6496_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F3: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F3 @ A2 ) )
        = ( F3 @ ( hd @ A @ A2 ) ) ) ) ).

% list.map_sel(1)
thf(fact_6497_map__tl,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F3 @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F3 @ Xs ) ) ) ).

% map_tl
thf(fact_6498_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs ) ) ) ) ).

% sorted_tl
thf(fact_6499_take__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_tl
thf(fact_6500_distinct__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( tl @ A @ Xs ) ) ) ).

% distinct_tl
thf(fact_6501_list_Oexpand,axiom,
    ! [A: $tType,List: list @ A,List3: list @ A] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List3
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List3
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List3 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List3 ) ) ) ) )
       => ( List = List3 ) ) ) ).

% list.expand
thf(fact_6502_list_Osel_I2_J,axiom,
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% list.sel(2)
thf(fact_6503_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( A2
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ A2 ) @ ( set2 @ A @ A2 ) ) ) ).

% list.set_sel(1)
thf(fact_6504_hd__in__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ Xs ) @ ( set2 @ A @ Xs ) ) ) ).

% hd_in_set
thf(fact_6505_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A2: list @ A,X2: A] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( member @ A @ X2 @ ( set2 @ A @ ( tl @ A @ A2 ) ) )
       => ( member @ A @ X2 @ ( set2 @ A @ A2 ) ) ) ) ).

% list.set_sel(2)
thf(fact_6506_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P3 @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P3 @ ( hd @ A @ Xs ) ) ) ) ).

% takeWhile_eq_Nil_iff
thf(fact_6507_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) ).

% rotate1_hd_tl
thf(fact_6508_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
    ? [Ps: list @ A,Xs4: list @ A,Ys5: list @ A] :
      ( ( Xs
        = ( append @ A @ Ps @ Xs4 ) )
      & ( Ys
        = ( append @ A @ Ps @ Ys5 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys5 ) ) ) ) ).

% longest_common_prefix
thf(fact_6509_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z: A,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( ( Xs
           != ( nil @ A ) )
          & ( ( hd @ A @ Xs )
            = Z )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ ( tl @ A @ Xs ) @ Ys ) ) )
        | ( ( Ys
           != ( nil @ A ) )
          & ( ( hd @ A @ Ys )
            = Z )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ ( tl @ A @ Ys ) ) ) ) ) ) ).

% Cons_in_shuffles_iff
thf(fact_6510_hd__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Ys ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Xs ) ) ) ) ).

% hd_append
thf(fact_6511_tl__Nil,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X6: A] :
            ( Xs
            = ( cons @ A @ X6 @ ( nil @ A ) ) ) ) ) ).

% tl_Nil
thf(fact_6512_Nil__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X6: A] :
            ( Xs
            = ( cons @ A @ X6 @ ( nil @ A ) ) ) ) ) ).

% Nil_tl
thf(fact_6513_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ).

% list.exhaust_sel
thf(fact_6514_take__Suc,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N ) @ Xs )
        = ( cons @ A @ ( hd @ A @ Xs ) @ ( take @ A @ N @ ( tl @ A @ Xs ) ) ) ) ) ).

% take_Suc
thf(fact_6515_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X222 ) )
      = X21 ) ).

% list.sel(1)
thf(fact_6516_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X222 ) )
      = X222 ) ).

% list.sel(3)
thf(fact_6517_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F5: A > nat,Xs2: list @ A] :
            ( if @ nat
            @ ( Xs2
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F5 @ ( hd @ A @ Xs2 ) ) @ ( size_list @ A @ F5 @ ( tl @ A @ Xs2 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_6518_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X213: A,X224: list @ A] : X224 ) ) ).

% tl_def
thf(fact_6519_tl__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys )
        @ ^ [Z6: A,Zs3: list @ A] : ( append @ A @ Zs3 @ Ys )
        @ Xs ) ) ).

% tl_append
thf(fact_6520_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs )
        = ( nth @ A @ Xs @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_6521_tl__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( tl @ A @ ( take @ A @ N @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( tl @ A @ Xs ) ) ) ).

% tl_take
thf(fact_6522_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs2: list @ A] :
            ( if @ nat
            @ ( Xs2
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_6523_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( suc @ N ) ) ) ) ).

% nth_tl
thf(fact_6524_hd__drop__conv__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( hd @ A @ ( drop @ A @ N @ Xs ) )
        = ( nth @ A @ Xs @ N ) ) ) ).

% hd_drop_conv_nth
thf(fact_6525_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs: list @ B,F3: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X6: B] :
                        ( ( F3 @ A2 )
                        = ( F3 @ X6 ) )
                    @ Xs ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F3 @ A2 @ ( remove1 @ B @ A2 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_6526_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N @ Xs ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_hd_drop
thf(fact_6527_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Xss ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X2
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H2: A,T2: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
                @ Xss ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H2: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_6528_transpose_Opelims,axiom,
    ! [A: $tType,X2: list @ ( list @ A ),Y2: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X2 )
        = Y2 )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X2 )
       => ( ( ( X2
              = ( nil @ ( list @ A ) ) )
           => ( ( Y2
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss2: list @ ( list @ A )] :
                ( ( X2
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
               => ( ( Y2
                    = ( transpose @ A @ Xss2 ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
           => ~ ! [X7: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                  ( ( X2
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X7 @ Xs3 ) @ Xss2 ) )
                 => ( ( Y2
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X7
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H2: A,T2: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
                              @ Xss2 ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs3
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H2: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X7 @ Xs3 ) @ Xss2 ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_6529_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
        = ( transpose @ A @ Xss ) ) ) ).

% transpose.psimps(2)
thf(fact_6530_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
     => ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
        = ( nil @ ( list @ A ) ) ) ) ).

% transpose.psimps(1)
thf(fact_6531_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P3: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P3 @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( ( P3 @ Xss2 )
               => ( P3 @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
         => ( ! [X7: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X7 @ Xs3 ) @ Xss2 ) )
               => ( ( P3
                    @ ( cons @ ( list @ A ) @ Xs3
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H2: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss2 ) ) ) )
                 => ( P3 @ ( cons @ ( list @ A ) @ ( cons @ A @ X7 @ Xs3 ) @ Xss2 ) ) ) )
           => ( P3 @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_6532_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I: int,J4: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J4 @ I ) @ Js @ ( upto_aux @ I @ ( minus_minus @ int @ J4 @ ( one_one @ int ) ) @ ( cons @ int @ J4 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_6533_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys ) ) ) ) ).

% set_relcomp
thf(fact_6534_relcomp__UNION__distrib2,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R: D > ( set @ ( product_prod @ A @ C ) ),I6: set @ D,S: set @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ C ) ) @ ( image @ D @ ( set @ ( product_prod @ A @ C ) ) @ R @ I6 ) ) @ S )
      = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( image @ D @ ( set @ ( product_prod @ A @ B ) )
          @ ^ [I: D] : ( relcomp @ A @ C @ B @ ( R @ I ) @ S )
          @ I6 ) ) ) ).

% relcomp_UNION_distrib2
thf(fact_6535_relcomp__UNION__distrib,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,S: set @ ( product_prod @ A @ C ),R: D > ( set @ ( product_prod @ C @ B ) ),I6: set @ D] :
      ( ( relcomp @ A @ C @ B @ S @ ( complete_Sup_Sup @ ( set @ ( product_prod @ C @ B ) ) @ ( image @ D @ ( set @ ( product_prod @ C @ B ) ) @ R @ I6 ) ) )
      = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( image @ D @ ( set @ ( product_prod @ A @ B ) )
          @ ^ [I: D] : ( relcomp @ A @ C @ B @ S @ ( R @ I ) )
          @ I6 ) ) ) ).

% relcomp_UNION_distrib
thf(fact_6536_upto_Opelims,axiom,
    ! [X2: int,Xa: int,Y2: list @ int] :
      ( ( ( upto @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X2 @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X2 @ Xa )
               => ( Y2
                  = ( cons @ int @ X2 @ ( upto @ ( plus_plus @ int @ X2 @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X2 @ Xa )
               => ( Y2
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X2 @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_6537_upto_Opsimps,axiom,
    ! [I3: int,J2: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I3 @ J2 ) )
     => ( ( ( ord_less_eq @ int @ I3 @ J2 )
         => ( ( upto @ I3 @ J2 )
            = ( cons @ int @ I3 @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I3 @ J2 )
         => ( ( upto @ I3 @ J2 )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_6538_upto__empty,axiom,
    ! [J2: int,I3: int] :
      ( ( ord_less @ int @ J2 @ I3 )
     => ( ( upto @ I3 @ J2 )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_6539_upto__Nil2,axiom,
    ! [I3: int,J2: int] :
      ( ( ( nil @ int )
        = ( upto @ I3 @ J2 ) )
      = ( ord_less @ int @ J2 @ I3 ) ) ).

% upto_Nil2
thf(fact_6540_upto__Nil,axiom,
    ! [I3: int,J2: int] :
      ( ( ( upto @ I3 @ J2 )
        = ( nil @ int ) )
      = ( ord_less @ int @ J2 @ I3 ) ) ).

% upto_Nil
thf(fact_6541_upto__single,axiom,
    ! [I3: int] :
      ( ( upto @ I3 @ I3 )
      = ( cons @ int @ I3 @ ( nil @ int ) ) ) ).

% upto_single
thf(fact_6542_nth__upto,axiom,
    ! [I3: int,K: nat,J2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I3 @ ( semiring_1_of_nat @ int @ K ) ) @ J2 )
     => ( ( nth @ int @ ( upto @ I3 @ J2 ) @ K )
        = ( plus_plus @ int @ I3 @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_6543_length__upto,axiom,
    ! [I3: int,J2: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I3 @ J2 ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J2 @ I3 ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_6544_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_6545_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_6546_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_6547_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_6548_upto__code,axiom,
    ( upto
    = ( ^ [I: int,J4: int] : ( upto_aux @ I @ J4 @ ( nil @ int ) ) ) ) ).

% upto_code
thf(fact_6549_upto__aux__def,axiom,
    ( upto_aux
    = ( ^ [I: int,J4: int] : ( append @ int @ ( upto @ I @ J4 ) ) ) ) ).

% upto_aux_def
thf(fact_6550_sorted__wrt__upto,axiom,
    ! [I3: int,J2: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I3 @ J2 ) ) ).

% sorted_wrt_upto
thf(fact_6551_atLeastAtMost__upto,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I: int,J4: int] : ( set2 @ int @ ( upto @ I @ J4 ) ) ) ) ).

% atLeastAtMost_upto
thf(fact_6552_distinct__upto,axiom,
    ! [I3: int,J2: int] : ( distinct @ int @ ( upto @ I3 @ J2 ) ) ).

% distinct_upto
thf(fact_6553_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I: int,J4: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J4 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_6554_sorted__upto,axiom,
    ! [M: int,N: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N ) ) ).

% sorted_upto
thf(fact_6555_sum__set__upto__conv__sum__list__int,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: int > A,I3: int,J2: int] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ F3 @ ( set2 @ int @ ( upto @ I3 @ J2 ) ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ int @ A @ F3 @ ( upto @ I3 @ J2 ) ) ) ) ) ).

% sum_set_upto_conv_sum_list_int
thf(fact_6556_interv__sum__list__conv__sum__set__int,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [F3: int > B,K: int,L: int] :
          ( ( groups8242544230860333062m_list @ B @ ( map @ int @ B @ F3 @ ( upto @ K @ L ) ) )
          = ( groups7311177749621191930dd_sum @ int @ B @ F3 @ ( set2 @ int @ ( upto @ K @ L ) ) ) ) ) ).

% interv_sum_list_conv_sum_set_int
thf(fact_6557_upto__split2,axiom,
    ! [I3: int,J2: int,K: int] :
      ( ( ord_less_eq @ int @ I3 @ J2 )
     => ( ( ord_less_eq @ int @ J2 @ K )
       => ( ( upto @ I3 @ K )
          = ( append @ int @ ( upto @ I3 @ J2 ) @ ( upto @ ( plus_plus @ int @ J2 @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_6558_upto__split1,axiom,
    ! [I3: int,J2: int,K: int] :
      ( ( ord_less_eq @ int @ I3 @ J2 )
     => ( ( ord_less_eq @ int @ J2 @ K )
       => ( ( upto @ I3 @ K )
          = ( append @ int @ ( upto @ I3 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) @ ( upto @ J2 @ K ) ) ) ) ) ).

% upto_split1
thf(fact_6559_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I: int,J4: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ ( minus_minus @ int @ J4 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_6560_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I: int,J4: int] : ( set2 @ int @ ( upto @ I @ ( minus_minus @ int @ J4 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_6561_upto_Oelims,axiom,
    ! [X2: int,Xa: int,Y2: list @ int] :
      ( ( ( upto @ X2 @ Xa )
        = Y2 )
     => ( ( ( ord_less_eq @ int @ X2 @ Xa )
         => ( Y2
            = ( cons @ int @ X2 @ ( upto @ ( plus_plus @ int @ X2 @ ( one_one @ int ) ) @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X2 @ Xa )
         => ( Y2
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_6562_upto_Osimps,axiom,
    ( upto
    = ( ^ [I: int,J4: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I @ J4 ) @ ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J4 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_6563_upto__rec1,axiom,
    ! [I3: int,J2: int] :
      ( ( ord_less_eq @ int @ I3 @ J2 )
     => ( ( upto @ I3 @ J2 )
        = ( cons @ int @ I3 @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J2 ) ) ) ) ).

% upto_rec1
thf(fact_6564_upto__rec2,axiom,
    ! [I3: int,J2: int] :
      ( ( ord_less_eq @ int @ I3 @ J2 )
     => ( ( upto @ I3 @ J2 )
        = ( append @ int @ ( upto @ I3 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) @ ( cons @ int @ J2 @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_6565_upto__split3,axiom,
    ! [I3: int,J2: int,K: int] :
      ( ( ord_less_eq @ int @ I3 @ J2 )
     => ( ( ord_less_eq @ int @ J2 @ K )
       => ( ( upto @ I3 @ K )
          = ( append @ int @ ( upto @ I3 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) @ ( cons @ int @ J2 @ ( upto @ ( plus_plus @ int @ J2 @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_6566_extract__Some__iff,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A,Ys: list @ A,Y2: A,Zs: list @ A] :
      ( ( ( extract @ A @ P3 @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs ) ) ) )
      = ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y2 @ Zs ) ) )
        & ( P3 @ Y2 )
        & ~ ? [X6: A] :
              ( ( member @ A @ X6 @ ( set2 @ A @ Ys ) )
              & ( P3 @ X6 ) ) ) ) ).

% extract_Some_iff
thf(fact_6567_extract__SomeE,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A,Ys: list @ A,Y2: A,Zs: list @ A] :
      ( ( ( extract @ A @ P3 @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs ) ) ) )
     => ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y2 @ Zs ) ) )
        & ( P3 @ Y2 )
        & ~ ? [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Ys ) )
              & ( P3 @ X ) ) ) ) ).

% extract_SomeE
thf(fact_6568_extract__Nil__code,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( extract @ A @ P3 @ ( nil @ A ) )
      = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

% extract_Nil_code
thf(fact_6569_extract__None__iff,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( extract @ A @ P3 @ Xs )
        = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) )
      = ( ~ ? [X6: A] :
              ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
              & ( P3 @ X6 ) ) ) ) ).

% extract_None_iff
thf(fact_6570_extract__Cons__code,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P3 @ X2 )
       => ( ( extract @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X2 @ Xs ) ) ) ) )
      & ( ~ ( P3 @ X2 )
       => ( ( extract @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys2: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y: A,Zs3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X2 @ Ys2 ) @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs3 ) ) ) ) )
            @ ( extract @ A @ P3 @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_6571_INF__filter__not__bot,axiom,
    ! [I5: $tType,A: $tType,B5: set @ I5,F4: I5 > ( filter @ A )] :
      ( ! [X18: set @ I5] :
          ( ( ord_less_eq @ ( set @ I5 ) @ X18 @ B5 )
         => ( ( finite_finite2 @ I5 @ X18 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I5 @ ( filter @ A ) @ F4 @ X18 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I5 @ ( filter @ A ) @ F4 @ B5 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_6572_option_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F2: A > B,X23: A] :
      ( ( case_option @ B @ A @ F1 @ F2 @ ( some @ A @ X23 ) )
      = ( F2 @ X23 ) ) ).

% option.simps(5)
thf(fact_6573_disjE__realizer2,axiom,
    ! [B: $tType,A: $tType,P3: $o,Q: A > $o,X2: option @ A,R3: B > $o,F3: B,G: A > B] :
      ( ( case_option @ $o @ A @ P3 @ Q @ X2 )
     => ( ( P3
         => ( R3 @ F3 ) )
       => ( ! [Q3: A] :
              ( ( Q @ Q3 )
             => ( R3 @ ( G @ Q3 ) ) )
         => ( R3 @ ( case_option @ B @ A @ F3 @ G @ X2 ) ) ) ) ) ).

% disjE_realizer2
thf(fact_6574_option_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F2: A > B] :
      ( ( case_option @ B @ A @ F1 @ F2 @ ( none @ A ) )
      = F1 ) ).

% option.simps(4)
thf(fact_6575_option_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,H: B > C,F1: B,F2: A > B,Option: option @ A] :
      ( ( H @ ( case_option @ B @ A @ F1 @ F2 @ Option ) )
      = ( case_option @ C @ A @ ( H @ F1 )
        @ ^ [X6: A] : ( H @ ( F2 @ X6 ) )
        @ Option ) ) ).

% option.case_distrib
thf(fact_6576_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,F4: A > ( filter @ B )] :
      ( ! [I2: A] :
          ( ( member @ A @ I2 @ I6 )
         => ! [J: A] :
              ( ( member @ A @ J @ I6 )
             => ? [X: A] :
                  ( ( member @ A @ X @ I6 )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ I2 ) @ ( F4 @ J ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ I6 ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X6: A] :
              ( ( member @ A @ X6 @ I6 )
              & ( ( F4 @ X6 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_6577_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y: A,Ys2: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P2 ) @ Xs2 ) @ ( product_Pair @ A @ ( list @ A ) @ Y @ Ys2 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P2 ) @ Xs2 ) ) ) ) ).

% extract_def
thf(fact_6578_Id__on__def,axiom,
    ! [A: $tType] :
      ( ( id_on @ A )
      = ( ^ [A7: set @ A] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ A @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [X6: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ X6 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
              @ A7 ) ) ) ) ).

% Id_on_def
thf(fact_6579_dropWhile__idem,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( dropWhile @ A @ P3 @ ( dropWhile @ A @ P3 @ Xs ) )
      = ( dropWhile @ A @ P3 @ Xs ) ) ).

% dropWhile_idem
thf(fact_6580_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P3 @ Xs )
        = ( nil @ A ) )
      = ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
           => ( P3 @ X6 ) ) ) ) ).

% dropWhile_eq_Nil_conv
thf(fact_6581_dropWhile__append1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P3: A > $o,Ys: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P3 @ X2 )
       => ( ( dropWhile @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P3 @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append1
thf(fact_6582_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o,Ys: list @ A] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( P3 @ X7 ) )
     => ( ( dropWhile @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
        = ( dropWhile @ A @ P3 @ Ys ) ) ) ).

% dropWhile_append2
thf(fact_6583_dropWhile__replicate,axiom,
    ! [A: $tType,P3: A > $o,X2: A,N: nat] :
      ( ( ( P3 @ X2 )
       => ( ( dropWhile @ A @ P3 @ ( replicate @ A @ N @ X2 ) )
          = ( nil @ A ) ) )
      & ( ~ ( P3 @ X2 )
       => ( ( dropWhile @ A @ P3 @ ( replicate @ A @ N @ X2 ) )
          = ( replicate @ A @ N @ X2 ) ) ) ) ).

% dropWhile_replicate
thf(fact_6584_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( append @ A @ ( takeWhile @ A @ P3 @ Xs ) @ ( dropWhile @ A @ P3 @ Xs ) )
      = Xs ) ).

% takeWhile_dropWhile_id
thf(fact_6585_option_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
        = ( none @ A ) )
      = ( case_option @ $o @ A @ $true
        @ ^ [Uu3: A] : $false
        @ Option ) ) ).

% option.disc_eq_case(1)
thf(fact_6586_option_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( ( Option
         != ( none @ A ) ) )
      = ( case_option @ $o @ A @ $false
        @ ^ [Uu3: A] : $true
        @ Option ) ) ).

% option.disc_eq_case(2)
thf(fact_6587_Id__on__def_H,axiom,
    ! [A: $tType,A3: A > $o] :
      ( ( id_on @ A @ ( collect @ A @ A3 ) )
      = ( collect @ ( product_prod @ A @ A )
        @ ( product_case_prod @ A @ A @ $o
          @ ^ [X6: A,Y: A] :
              ( ( X6 = Y )
              & ( A3 @ X6 ) ) ) ) ) ).

% Id_on_def'
thf(fact_6588_less__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( filter @ A ) )
      = ( ^ [F7: filter @ A,F8: filter @ A] :
            ( ( ord_less_eq @ ( filter @ A ) @ F7 @ F8 )
            & ~ ( ord_less_eq @ ( filter @ A ) @ F8 @ F7 ) ) ) ) ).

% less_filter_def
thf(fact_6589_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( dropWhile @ A @ P3 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% dropWhile.simps(1)
thf(fact_6590_hd__dropWhile,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P3 @ Xs )
       != ( nil @ A ) )
     => ~ ( P3 @ ( hd @ A @ ( dropWhile @ A @ P3 @ Xs ) ) ) ) ).

% hd_dropWhile
thf(fact_6591_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P3 @ Xs )
        = Xs )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P3 @ ( hd @ A @ Xs ) ) ) ) ).

% dropWhile_eq_self_iff
thf(fact_6592_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P3 @ X2 )
       => ( ( dropWhile @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( dropWhile @ A @ P3 @ Xs ) ) )
      & ( ~ ( P3 @ X2 )
       => ( ( dropWhile @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ Xs ) ) ) ) ).

% dropWhile.simps(2)
thf(fact_6593_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F3: B > A,Xs: list @ B] :
      ( ( dropWhile @ A @ P3 @ ( map @ B @ A @ F3 @ Xs ) )
      = ( map @ B @ A @ F3 @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P3 @ F3 ) @ Xs ) ) ) ).

% dropWhile_map
thf(fact_6594_dropWhile__append3,axiom,
    ! [A: $tType,P3: A > $o,Y2: A,Xs: list @ A,Ys: list @ A] :
      ( ~ ( P3 @ Y2 )
     => ( ( dropWhile @ A @ P3 @ ( append @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) )
        = ( append @ A @ ( dropWhile @ A @ P3 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) ) ) ).

% dropWhile_append3
thf(fact_6595_set__dropWhileD,axiom,
    ! [A: $tType,X2: A,P3: A > $o,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( dropWhile @ A @ P3 @ Xs ) ) )
     => ( member @ A @ X2 @ ( set2 @ A @ Xs ) ) ) ).

% set_dropWhileD
thf(fact_6596_dropWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P3: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ L ) )
           => ( ( P3 @ X7 )
              = ( Q @ X7 ) ) )
       => ( ( dropWhile @ A @ P3 @ L )
          = ( dropWhile @ A @ Q @ K ) ) ) ) ).

% dropWhile_cong
thf(fact_6597_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( dropWhile @ A @ P3 @ Xs ) ) ) ).

% distinct_dropWhile
thf(fact_6598_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P3: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P3 @ Xs ) ) ) ) ).

% sorted_dropWhile
thf(fact_6599_length__dropWhile__le,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P3 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_dropWhile_le
thf(fact_6600_case__optionE,axiom,
    ! [A: $tType,P3: $o,Q: A > $o,X2: option @ A] :
      ( ( case_option @ $o @ A @ P3 @ Q @ X2 )
     => ( ( ( X2
            = ( none @ A ) )
         => ~ P3 )
       => ~ ! [Y5: A] :
              ( ( X2
                = ( some @ A @ Y5 ) )
             => ~ ( Q @ Y5 ) ) ) ) ).

% case_optionE
thf(fact_6601_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( ( dropWhile @ A @ P3 @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( ( Xs
          = ( append @ A @ ( takeWhile @ A @ P3 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) )
        & ~ ( P3 @ Y2 ) ) ) ).

% dropWhile_eq_Cons_conv
thf(fact_6602_takeWhile__eq__filter,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ! [X7: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ ( dropWhile @ A @ P3 @ Xs ) ) )
         => ~ ( P3 @ X7 ) )
     => ( ( takeWhile @ A @ P3 @ Xs )
        = ( filter2 @ A @ P3 @ Xs ) ) ) ).

% takeWhile_eq_filter
thf(fact_6603_dropWhile__eq__drop,axiom,
    ! [A: $tType] :
      ( ( dropWhile @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] : ( drop @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs2 ) ) @ Xs2 ) ) ) ).

% dropWhile_eq_drop
thf(fact_6604_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F3: B > ( option @ A ),X2: B,Xs: list @ B] :
      ( ( map_filter @ B @ A @ F3 @ ( cons @ B @ X2 @ Xs ) )
      = ( case_option @ ( list @ A ) @ A @ ( map_filter @ B @ A @ F3 @ Xs )
        @ ^ [Y: A] : ( cons @ A @ Y @ ( map_filter @ B @ A @ F3 @ Xs ) )
        @ ( F3 @ X2 ) ) ) ).

% map_filter_simps(1)
thf(fact_6605_dropWhile__nth,axiom,
    ! [A: $tType,J2: nat,P3: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P3 @ Xs ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P3 @ Xs ) @ J2 )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ J2 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_6606_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( dropWhile @ A
            @ ^ [Y: A] : ( Y != X2 )
            @ ( rev @ A @ Xs ) )
          = ( cons @ A @ X2
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y: A] : ( Y != X2 )
                @ Xs ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_6607_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( takeWhile @ A
            @ ^ [Y: A] : ( Y != X2 )
            @ ( rev @ A @ Xs ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y: A] : ( Y != X2 )
                @ Xs ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_6608_Id__on__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X6: A] : ( product_Pair @ A @ A @ X6 @ X6 )
          @ Xs ) ) ) ).

% Id_on_set
thf(fact_6609_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_6610_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X6: A,Xa4: list @ A] : ( some @ A @ X6 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P2 ) @ Xs2 ) ) ) ) ).

% find_dropWhile
thf(fact_6611_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_6612_take__bit__num__simps_I2_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_6613_take__bit__num__simps_I5_J,axiom,
    ! [R: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_6614_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ N @ M ) ) ) ).

% take_bit_num_simps(3)
thf(fact_6615_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_6616_take__bit__num__simps_I6_J,axiom,
    ! [R: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M ) ) ) ).

% take_bit_num_simps(6)
thf(fact_6617_take__bit__num__simps_I7_J,axiom,
    ! [R: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_6618_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_6619_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ N @ ( bit0 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] :
            ( case_option @ ( option @ num ) @ num @ ( none @ num )
            @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
            @ ( bit_take_bit_num @ N2 @ M ) )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
thf(fact_6620_find__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P3: A > $o,Q: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ Ys ) )
           => ( ( P3 @ X7 )
              = ( Q @ X7 ) ) )
       => ( ( find @ A @ P3 @ Xs )
          = ( find @ A @ Q @ Ys ) ) ) ) ).

% find_cong
thf(fact_6621_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ N @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] : ( some @ num @ one2 )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_6622_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num,Q2: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( some @ num @ Q2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_6623_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ N @ ( bit1 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N2 @ M ) ) )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
thf(fact_6624_find_Osimps_I2_J,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P3 @ X2 )
       => ( ( find @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( some @ A @ X2 ) ) )
      & ( ~ ( P3 @ X2 )
       => ( ( find @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
          = ( find @ A @ P3 @ Xs ) ) ) ) ).

% find.simps(2)
thf(fact_6625_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: A > $o] :
      ( ( find @ A @ Uu @ ( nil @ A ) )
      = ( none @ A ) ) ).

% find.simps(1)
thf(fact_6626_find__None__iff,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( find @ A @ P3 @ Xs )
        = ( none @ A ) )
      = ( ~ ? [X6: A] :
              ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
              & ( P3 @ X6 ) ) ) ) ).

% find_None_iff
thf(fact_6627_find__None__iff2,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( ( none @ A )
        = ( find @ A @ P3 @ Xs ) )
      = ( ~ ? [X6: A] :
              ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
              & ( P3 @ X6 ) ) ) ) ).

% find_None_iff2
thf(fact_6628_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_6629_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N2: nat,M4: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M4 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M4 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_6630_find__Some__iff2,axiom,
    ! [A: $tType,X2: A,P3: A > $o,Xs: list @ A] :
      ( ( ( some @ A @ X2 )
        = ( find @ A @ P3 @ Xs ) )
      = ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P3 @ ( nth @ A @ Xs @ I ) )
            & ( X2
              = ( nth @ A @ Xs @ I ) )
            & ! [J4: nat] :
                ( ( ord_less @ nat @ J4 @ I )
               => ~ ( P3 @ ( nth @ A @ Xs @ J4 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_6631_find__Some__iff,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A,X2: A] :
      ( ( ( find @ A @ P3 @ Xs )
        = ( some @ A @ X2 ) )
      = ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P3 @ ( nth @ A @ Xs @ I ) )
            & ( X2
              = ( nth @ A @ Xs @ I ) )
            & ! [J4: nat] :
                ( ( ord_less @ nat @ J4 @ I )
               => ~ ( P3 @ ( nth @ A @ Xs @ J4 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_6632_and__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_6633_and__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_6634_and__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_6635_and__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_6636_and__not__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_and_not_num @ one2 @ ( bit1 @ N ) )
      = ( none @ num ) ) ).

% and_not_num.simps(3)
thf(fact_6637_and__not__num_Osimps_I1_J,axiom,
    ( ( bit_and_not_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% and_not_num.simps(1)
thf(fact_6638_and__not__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_and_not_num @ one2 @ ( bit0 @ N ) )
      = ( some @ num @ one2 ) ) ).

% and_not_num.simps(2)
thf(fact_6639_and__not__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(4)
thf(fact_6640_and__not__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(7)
thf(fact_6641_and__not__num__eq__Some__iff,axiom,
    ! [M: num,N: num,Q2: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( some @ num @ Q2 ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( numeral_numeral @ int @ Q2 ) ) ) ).

% and_not_num_eq_Some_iff
thf(fact_6642_and__not__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N11: num] : ( some @ num @ ( bit1 @ N11 ) )
        @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(8)
thf(fact_6643_and__not__num__eq__None__iff,axiom,
    ! [M: num,N: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_6644_int__numeral__not__and__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_6645_int__numeral__and__not__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N ) ) ) ).

% int_numeral_and_not_num
thf(fact_6646_Bit__Operations_Otake__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N2: nat,M4: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A5: nat,X6: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P4: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
                      @ ( bit_take_bit_num @ O @ P4 ) )
                  @ ^ [P4: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P4 ) ) )
                  @ X6 )
              @ A5 )
          @ ( product_Pair @ nat @ num @ N2 @ M4 ) ) ) ) ).

% Bit_Operations.take_bit_num_code
thf(fact_6647_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F5: A > $o,Xs2: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ F5 @ Xs2 ) @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ F5 ) @ Xs2 ) ) ) ) ).

% partition_filter_conv
thf(fact_6648_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F2: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F2 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_6649_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: A > B,F1: A,F2: num > A,F32: num > A,Num: num] :
      ( ( H @ ( case_num @ A @ F1 @ F2 @ F32 @ Num ) )
      = ( case_num @ B @ ( H @ F1 )
        @ ^ [X6: num] : ( H @ ( F2 @ X6 ) )
        @ ^ [X6: num] : ( H @ ( F32 @ X6 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_6650_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F2: num > A,F32: num > A,X23: num] :
      ( ( case_num @ A @ F1 @ F2 @ F32 @ ( bit0 @ X23 ) )
      = ( F2 @ X23 ) ) ).

% verit_eq_simplify(17)
thf(fact_6651_partition__filter1,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P3 @ Xs ) )
      = ( filter2 @ A @ P3 @ Xs ) ) ).

% partition_filter1
thf(fact_6652_verit__eq__simplify_I18_J,axiom,
    ! [A: $tType,F1: A,F2: num > A,F32: num > A,X32: num] :
      ( ( case_num @ A @ F1 @ F2 @ F32 @ ( bit1 @ X32 ) )
      = ( F32 @ X32 ) ) ).

% verit_eq_simplify(18)
thf(fact_6653_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( partition @ A @ P3 @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_6654_partition__P,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A,Yes: list @ A,No: list @ A] :
      ( ( ( partition @ A @ P3 @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
     => ( ! [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ Yes ) )
           => ( P3 @ X ) )
        & ! [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ No ) )
           => ~ ( P3 @ X ) ) ) ) ).

% partition_P
thf(fact_6655_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P3: A > $o,X2: A,Xs: list @ A] :
      ( ( partition @ A @ P3 @ ( cons @ A @ X2 @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes2: list @ A,No2: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P3 @ X2 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Yes2 ) @ No2 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ ( cons @ A @ X2 @ No2 ) ) )
        @ ( partition @ A @ P3 @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_6656_partition__filter2,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P3 @ Xs ) )
      = ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs ) ) ).

% partition_filter2
thf(fact_6657_DERIV__real__root__generic,axiom,
    ! [N: nat,X2: real,D4: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( X2
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
             => ( D4
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X2 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
             => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
               => ( D4
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X2 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
               => ( D4
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X2 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N ) @ D4 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_6658_DERIV__even__real__root,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
       => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ ( power_power @ real @ ( root @ N @ X2 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_6659_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X7: real] :
            ( ( ord_less_eq @ real @ A2 @ X7 )
           => ( ( ord_less_eq @ real @ X7 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y3 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_6660_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X7: real] :
            ( ( ord_less_eq @ real @ A2 @ X7 )
           => ( ( ord_less_eq @ real @ X7 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y3 ) ) ) )
       => ( ord_less @ real @ ( F3 @ A2 ) @ ( F3 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_6661_MVT2,axiom,
    ! [A2: real,B2: real,F3: real > real,F9: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X7: real] :
            ( ( ord_less_eq @ real @ A2 @ X7 )
           => ( ( ord_less_eq @ real @ X7 @ B2 )
             => ( has_field_derivative @ real @ F3 @ ( F9 @ X7 ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z2: real] :
            ( ( ord_less @ real @ A2 @ Z2 )
            & ( ord_less @ real @ Z2 @ B2 )
            & ( ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F9 @ Z2 ) ) ) ) ) ) ).

% MVT2
thf(fact_6662_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X2: real,Y2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
       => ( ( member @ real @ Y2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ! [X7: real] :
                ( ( member @ real @ X7 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
               => ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F3 @ X2 )
              = ( F3 @ Y2 ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_6663_has__real__derivative__pos__inc__left,axiom,
    ! [F3: real > real,L: real,X2: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ S3 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X2 @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D3 )
                   => ( ord_less @ real @ ( F3 @ ( minus_minus @ real @ X2 @ H5 ) ) @ ( F3 @ X2 ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_6664_has__real__derivative__neg__dec__left,axiom,
    ! [F3: real > real,L: real,X2: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ S3 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X2 @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D3 )
                   => ( ord_less @ real @ ( F3 @ X2 ) @ ( F3 @ ( minus_minus @ real @ X2 @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_6665_has__real__derivative__pos__inc__right,axiom,
    ! [F3: real > real,L: real,X2: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ S3 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X2 @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D3 )
                   => ( ord_less @ real @ ( F3 @ X2 ) @ ( F3 @ ( plus_plus @ real @ X2 @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_6666_has__real__derivative__neg__dec__right,axiom,
    ! [F3: real > real,L: real,X2: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ S3 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X2 @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D3 )
                   => ( ord_less @ real @ ( F3 @ ( plus_plus @ real @ X2 @ H5 ) ) @ ( F3 @ X2 ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_6667_DERIV__neg__dec__right,axiom,
    ! [F3: real > real,L: real,X2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D3 )
                 => ( ord_less @ real @ ( F3 @ ( plus_plus @ real @ X2 @ H5 ) ) @ ( F3 @ X2 ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_6668_DERIV__pos__inc__right,axiom,
    ! [F3: real > real,L: real,X2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D3 )
                 => ( ord_less @ real @ ( F3 @ X2 ) @ ( F3 @ ( plus_plus @ real @ X2 @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_6669_DERIV__pos__inc__left,axiom,
    ! [F3: real > real,L: real,X2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D3 )
                 => ( ord_less @ real @ ( F3 @ ( minus_minus @ real @ X2 @ H5 ) ) @ ( F3 @ X2 ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_6670_DERIV__neg__dec__left,axiom,
    ! [F3: real > real,L: real,X2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D3 )
                 => ( ord_less @ real @ ( F3 @ X2 ) @ ( F3 @ ( minus_minus @ real @ X2 @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_6671_DERIV__ln,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_6672_DERIV__local__const,axiom,
    ! [F3: real > real,L: real,X2: real,D2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y5: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y5 ) ) @ D2 )
             => ( ( F3 @ X2 )
                = ( F3 @ Y5 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_6673_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Y2: A,Z: A,X2: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X2 ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S3 ) ) )
          = ( has_field_derivative @ A
            @ ^ [X6: A] : ( F3 @ ( plus_plus @ A @ Z @ X6 ) )
            @ Y2
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_6674_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F3: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X7: real] : ( has_field_derivative @ real @ F3 @ K @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_6675_DERIV__mirror,axiom,
    ! [F3: real > real,Y2: real,X2: real] :
      ( ( has_field_derivative @ real @ F3 @ Y2 @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ X2 ) @ ( top_top @ ( set @ real ) ) ) )
      = ( has_field_derivative @ real
        @ ^ [X6: real] : ( F3 @ ( uminus_uminus @ real @ X6 ) )
        @ ( uminus_uminus @ real @ Y2 )
        @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_mirror
thf(fact_6676_DERIV__isconst__all,axiom,
    ! [F3: real > real,X2: real,Y2: real] :
      ( ! [X7: real] : ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( F3 @ X2 )
        = ( F3 @ Y2 ) ) ) ).

% DERIV_isconst_all
thf(fact_6677_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Y2: A,X2: A,Z: A] :
          ( ( has_field_derivative @ A @ F3 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X2 @ Z ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X6: A] : ( F3 @ ( plus_plus @ A @ X6 @ Z ) )
            @ Y2
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_6678_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ ( F3 @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
              @ ( times_times @ A @ E5 @ D4 )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_chain'
thf(fact_6679_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Da: A,G: A > A,X2: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( F3 @ ( G @ X6 ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_chain2
thf(fact_6680_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G: A > A,G4: A > A,F3: A > A,F9: A,X2: A] :
          ( ! [X7: A] : ( has_field_derivative @ A @ G @ ( G4 @ X7 ) @ ( topolo174197925503356063within @ A @ X7 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
              @ ( times_times @ A @ F9 @ ( G4 @ ( F3 @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_6681_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S: set @ A,G: A > A,G4: A > A,F3: A > A,F9: A,X2: A] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ S )
             => ( has_field_derivative @ A @ G @ ( G4 @ X7 ) @ ( topolo174197925503356063within @ A @ X7 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member @ A @ ( F3 @ X2 ) @ S )
             => ( has_field_derivative @ A
                @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
                @ ( times_times @ A @ F9 @ ( G4 @ ( F3 @ X2 ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_6682_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( exp @ A @ ( G @ X6 ) )
            @ ( times_times @ A @ ( exp @ A @ ( G @ X2 ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_6683_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( sin @ A @ ( G @ X6 ) )
            @ ( times_times @ A @ ( cos @ A @ ( G @ X2 ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_6684_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( divide_divide @ A @ ( F3 @ X6 ) @ C2 )
            @ ( divide_divide @ A @ D4 @ C2 )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_cdivide
thf(fact_6685_has__field__derivative__sinh,axiom,
    ! [A10: $tType] :
      ( ( ( real_Vector_banach @ A10 )
        & ( real_V3459762299906320749_field @ A10 ) )
     => ! [G: A10 > A10,Db: A10,X2: A10,S: set @ A10] :
          ( ( has_field_derivative @ A10 @ G @ Db @ ( topolo174197925503356063within @ A10 @ X2 @ S ) )
         => ( has_field_derivative @ A10
            @ ^ [X6: A10] : ( sinh @ A10 @ ( G @ X6 ) )
            @ ( times_times @ A10 @ ( cosh @ A10 @ ( G @ X2 ) ) @ Db )
            @ ( topolo174197925503356063within @ A10 @ X2 @ S ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_6686_has__field__derivative__cosh,axiom,
    ! [A10: $tType] :
      ( ( ( real_Vector_banach @ A10 )
        & ( real_V3459762299906320749_field @ A10 ) )
     => ! [G: A10 > A10,Db: A10,X2: A10,S: set @ A10] :
          ( ( has_field_derivative @ A10 @ G @ Db @ ( topolo174197925503356063within @ A10 @ X2 @ S ) )
         => ( has_field_derivative @ A10
            @ ^ [X6: A10] : ( cosh @ A10 @ ( G @ X6 ) )
            @ ( times_times @ A10 @ ( sinh @ A10 @ ( G @ X2 ) ) @ Db )
            @ ( topolo174197925503356063within @ A10 @ X2 @ S ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_6687_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F3 @ X2 ) @ E5 ) @ ( times_times @ A @ D4 @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_mult'
thf(fact_6688_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Da: A,X2: A,S: set @ A,G: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F3 @ Da @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G @ X2 ) ) @ ( times_times @ A @ Db @ ( F3 @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_mult
thf(fact_6689_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( times_times @ A @ ( F3 @ X6 ) @ C2 )
            @ ( times_times @ A @ D4 @ C2 )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_cmult_right
thf(fact_6690_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( times_times @ A @ C2 @ ( F3 @ X6 ) )
            @ ( times_times @ A @ C2 @ D4 )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_cmult
thf(fact_6691_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,F9: A,F4: filter @ A,G: A > A,G4: A] :
          ( ( has_field_derivative @ A @ F3 @ F9 @ F4 )
         => ( ( has_field_derivative @ A @ G @ G4 @ F4 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] : ( plus_plus @ A @ ( F3 @ Z6 ) @ ( G @ Z6 ) )
              @ ( plus_plus @ A @ F9 @ G4 )
              @ F4 ) ) ) ) ).

% field_differentiable_add
thf(fact_6692_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( plus_plus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( plus_plus @ A @ D4 @ E5 )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_add
thf(fact_6693_DERIV__ident,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X6: A] : X6
          @ ( one_one @ A )
          @ F4 ) ) ).

% DERIV_ident
thf(fact_6694_has__field__derivative__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,F4: filter @ A,C2: real] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ F4 )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( real_V8093663219630862766scaleR @ A @ C2 @ ( F3 @ X6 ) )
            @ ( real_V8093663219630862766scaleR @ A @ C2 @ D4 )
            @ F4 ) ) ) ).

% has_field_derivative_scaleR_right
thf(fact_6695_DERIV__const,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [K: A,F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X6: A] : K
          @ ( zero_zero @ A )
          @ F4 ) ) ).

% DERIV_const
thf(fact_6696_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X2: A,S: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ).

% DERIV_cmult_Id
thf(fact_6697_DERIV__minus,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( uminus_uminus @ A @ ( F3 @ X6 ) )
            @ ( uminus_uminus @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_minus
thf(fact_6698_field__differentiable__minus,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,F9: A,F4: filter @ A] :
          ( ( has_field_derivative @ A @ F3 @ F9 @ F4 )
         => ( has_field_derivative @ A
            @ ^ [Z6: A] : ( uminus_uminus @ A @ ( F3 @ Z6 ) )
            @ ( uminus_uminus @ A @ F9 )
            @ F4 ) ) ) ).

% field_differentiable_minus
thf(fact_6699_DERIV__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( minus_minus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( minus_minus @ A @ D4 @ E5 )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_diff
thf(fact_6700_field__differentiable__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,F9: A,F4: filter @ A,G: A > A,G4: A] :
          ( ( has_field_derivative @ A @ F3 @ F9 @ F4 )
         => ( ( has_field_derivative @ A @ G @ G4 @ F4 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] : ( minus_minus @ A @ ( F3 @ Z6 ) @ ( G @ Z6 ) )
              @ ( minus_minus @ A @ F9 @ G4 )
              @ F4 ) ) ) ) ).

% field_differentiable_diff
thf(fact_6701_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X6: A] : ( divide_divide @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D4 @ ( G @ X2 ) ) @ ( times_times @ A @ ( F3 @ X2 ) @ E5 ) ) @ ( times_times @ A @ ( G @ X2 ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_6702_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( ( F3 @ X2 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( inverse_inverse @ A @ ( F3 @ X6 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F3 @ X2 ) ) @ D4 ) @ ( inverse_inverse @ A @ ( F3 @ X2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_6703_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa: A] :
          ( has_field_derivative @ A
          @ ^ [X6: A] : ( cos @ A @ ( plus_plus @ A @ X6 @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_6704_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( cos @ A @ ( G @ X6 ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G @ X2 ) ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_6705_DERIV__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ B )
     => ! [S3: set @ A,F3: B > A > B,F9: C > A > B,X2: C,F4: filter @ B] :
          ( ! [N3: A] :
              ( ( member @ A @ N3 @ S3 )
             => ( has_field_derivative @ B
                @ ^ [X6: B] : ( F3 @ X6 @ N3 )
                @ ( F9 @ X2 @ N3 )
                @ F4 ) )
         => ( has_field_derivative @ B
            @ ^ [X6: B] : ( groups7311177749621191930dd_sum @ A @ B @ ( F3 @ X6 ) @ S3 )
            @ ( groups7311177749621191930dd_sum @ A @ B @ ( F9 @ X2 ) @ S3 )
            @ F4 ) ) ) ).

% DERIV_sum
thf(fact_6706_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Da: A,G: A > A,X2: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F3 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_chain
thf(fact_6707_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X7: real] :
            ( ( ord_less_eq @ real @ A2 @ X7 )
           => ( ( ord_less_eq @ real @ X7 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y3 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_6708_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X7: real] :
            ( ( ord_less_eq @ real @ A2 @ X7 )
           => ( ( ord_less_eq @ real @ X7 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 ) ) ) )
       => ( ord_less_eq @ real @ ( F3 @ A2 ) @ ( F3 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_6709_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: real > real,G4: real > real] :
      ( ! [X7: real] :
          ( ( member @ real @ X7 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G4 @ X7 ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X7: real] :
            ( ( member @ real @ X7 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G4 @ X7 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A2 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_6710_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Da: A,G: A > A,X2: A,S: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F3 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( image @ A @ A @ G @ S ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F3 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_6711_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Y2: A,Z: A,X2: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X2 ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S3 ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F3 @ ( plus_plus @ A @ Z ) ) @ Y2 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_6712_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( power_power @ A @ ( F3 @ X6 ) @ ( suc @ N ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) @ ( times_times @ A @ D4 @ ( power_power @ A @ ( F3 @ X2 ) @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_power_Suc
thf(fact_6713_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X7: real] : ( has_field_derivative @ real @ V @ K @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V @ A2 ) @ ( V @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_6714_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,S: set @ A] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_inverse
thf(fact_6715_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] : ( power_power @ A @ ( F3 @ X6 ) @ N )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( times_times @ A @ D4 @ ( power_power @ A @ ( F3 @ X2 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_power
thf(fact_6716_DERIV__local__min,axiom,
    ! [F3: real > real,L: real,X2: real,D2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y5: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y5 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F3 @ X2 ) @ ( F3 @ Y5 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_6717_DERIV__local__max,axiom,
    ! [F3: real > real,L: real,X2: real,D2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y5: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y5 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F3 @ Y5 ) @ ( F3 @ X2 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_6718_DERIV__ln__divide,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_6719_DERIV__pow,axiom,
    ! [N: nat,X2: real,S: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X6: real] : ( power_power @ real @ X6 @ N )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ X2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X2 @ S ) ) ).

% DERIV_pow
thf(fact_6720_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [Y5: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y5 @ N2 ) ) )
         => ( has_field_derivative @ A
            @ ^ [X6: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X6 @ N2 ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_6721_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ( ord_less @ A @ X2 @ B2 )
           => ( ( topolo174197925503356063within @ A @ X2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_6722_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X2: real,N: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X6: real] : ( power_power @ real @ ( G @ X6 ) @ N )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( G @ X2 ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_6723_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_6724_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D2: A,X2: A,S: set @ A,G: A > A,E2: A] :
          ( ( has_field_derivative @ A @ F3 @ D2 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E2 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y: A] : ( divide_divide @ A @ ( F3 @ Y ) @ ( G @ Y ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G @ X2 ) ) @ ( times_times @ A @ E2 @ ( F3 @ X2 ) ) ) @ ( power_power @ A @ ( G @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_6725_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D2: A,X2: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D2 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( ( F3 @ X2 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] : ( inverse_inverse @ A @ ( F3 @ X6 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F3 @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_6726_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,F3: A > A,F9: A,Z: A] :
          ( ! [Z2: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) )
                @ ( F3 @ Z2 ) ) )
         => ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) )
                @ F9 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_6727_has__real__derivative__powr,axiom,
    ! [Z: real,R: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z )
     => ( has_field_derivative @ real
        @ ^ [Z6: real] : ( powr @ real @ Z6 @ R )
        @ ( times_times @ real @ R @ ( powr @ real @ Z @ ( minus_minus @ real @ R @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_6728_DERIV__series_H,axiom,
    ! [F3: real > nat > real,F9: real > nat > real,X0: real,A2: real,B2: real,L5: nat > real] :
      ( ! [N3: nat] :
          ( has_field_derivative @ real
          @ ^ [X6: real] : ( F3 @ X6 @ N3 )
          @ ( F9 @ X0 @ N3 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X7: real] :
            ( ( member @ real @ X7 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F3 @ X7 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F9 @ X0 ) )
           => ( ( summable @ real @ L5 )
             => ( ! [N3: nat,X7: real,Y5: real] :
                    ( ( member @ real @ X7 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F3 @ X7 @ N3 ) @ ( F3 @ Y5 @ N3 ) ) ) @ ( times_times @ real @ ( L5 @ N3 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X7 @ Y5 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X6: real] : ( suminf @ real @ ( F3 @ X6 ) )
                  @ ( suminf @ real @ ( F9 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_6729_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,Z: A] :
          ( ! [Z2: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
             => ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z6 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_6730_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( has_field_derivative @ A
              @ ^ [X6: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X6 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_6731_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
           => ( ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
               => ( has_field_derivative @ A
                  @ ^ [X6: A] :
                      ( suminf @ A
                      @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X6 @ N2 ) ) )
                  @ ( suminf @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
                  @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_6732_DERIV__log,axiom,
    ! [X2: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X2 ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_6733_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X2: real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
       => ( has_field_derivative @ real
          @ ^ [X6: real] : ( powr @ real @ ( G @ X6 ) @ R )
          @ ( times_times @ real @ ( times_times @ real @ R @ ( powr @ real @ ( G @ X2 ) @ ( minus_minus @ real @ R @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_6734_DERIV__powr,axiom,
    ! [G: real > real,M: real,X2: real,F3: real > real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
       => ( ( has_field_derivative @ real @ F3 @ R @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X6: real] : ( powr @ real @ ( G @ X6 ) @ ( F3 @ X6 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X2 ) @ ( F3 @ X2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ R @ ( ln_ln @ real @ ( G @ X2 ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F3 @ X2 ) ) @ ( G @ X2 ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_6735_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_6736_DERIV__real__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_6737_DERIV__arctan,axiom,
    ! [X2: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_6738_arsinh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_6739_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_6740_has__field__derivative__tanh,axiom,
    ! [A10: $tType] :
      ( ( ( real_Vector_banach @ A10 )
        & ( real_V3459762299906320749_field @ A10 ) )
     => ! [G: A10 > A10,X2: A10,Db: A10,S: set @ A10] :
          ( ( ( cosh @ A10 @ ( G @ X2 ) )
           != ( zero_zero @ A10 ) )
         => ( ( has_field_derivative @ A10 @ G @ Db @ ( topolo174197925503356063within @ A10 @ X2 @ S ) )
           => ( has_field_derivative @ A10
              @ ^ [X6: A10] : ( tanh @ A10 @ ( G @ X6 ) )
              @ ( times_times @ A10 @ ( minus_minus @ A10 @ ( one_one @ A10 ) @ ( power_power @ A10 @ ( tanh @ A10 @ ( G @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A10 @ X2 @ S ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_6741_DERIV__real__sqrt__generic,axiom,
    ! [X2: real,D4: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( D4
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
           => ( D4
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D4 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_6742_arcosh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_6743_artanh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_6744_DERIV__power__series_H,axiom,
    ! [R3: real,F3: nat > real,X0: real] :
      ( ! [X7: real] :
          ( ( member @ real @ X7 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R3 ) @ R3 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F3 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X7 @ N2 ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R3 ) @ R3 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
         => ( has_field_derivative @ real
            @ ^ [X6: real] :
                ( suminf @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( F3 @ N2 ) @ ( power_power @ real @ X6 @ ( suc @ N2 ) ) ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F3 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X0 @ N2 ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_6745_DERIV__real__root,axiom,
    ! [N: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X2 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_6746_DERIV__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_6747_DERIV__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_6748_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F3: real > real,X2: real,N: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
        & ! [M5: nat,X7: real] : ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ X7 ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
          & ( ( F3 @ X2 )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ X2 @ M4 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_6749_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F3: real > real,X2: real,N: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F3 )
     => ( ! [M5: nat,X7: real] : ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ X7 ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( F3 @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ X2 @ M4 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_6750_DERIV__odd__real__root,axiom,
    ! [N: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( X2
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X2 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_6751_Maclaurin,axiom,
    ! [H: real,N: nat,Diff: nat > real > real,F3: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F3 )
         => ( ! [M5: nat,T4: real] :
                ( ( ( ord_less @ nat @ M5 @ N )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                  & ( ord_less_eq @ real @ T4 @ H ) )
               => ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less @ real @ T4 @ H )
                & ( ( F3 @ H )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ H @ M4 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_6752_Maclaurin2,axiom,
    ! [H: real,Diff: nat > real > real,F3: real > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
       => ( ! [M5: nat,T4: real] :
              ( ( ( ord_less @ nat @ M5 @ N )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less_eq @ real @ T4 @ H ) )
             => ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ H )
              & ( ( F3 @ H )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ H @ M4 ) )
                    @ ( set_ord_lessThan @ nat @ N ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_6753_Maclaurin__minus,axiom,
    ! [H: real,N: nat,Diff: nat > real > real,F3: real > real] :
      ( ( ord_less @ real @ H @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F3 )
         => ( ! [M5: nat,T4: real] :
                ( ( ( ord_less @ nat @ M5 @ N )
                  & ( ord_less_eq @ real @ H @ T4 )
                  & ( ord_less_eq @ real @ T4 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ H @ T4 )
                & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
                & ( ( F3 @ H )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ H @ M4 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_6754_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F3: real > real,N: nat,X2: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( X2
           != ( zero_zero @ real ) )
         => ( ! [M5: nat,X7: real] : ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ X7 ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
                & ( ( F3 @ X2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ X2 @ M4 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_6755_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F3: real > real,N: nat,X2: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F3 )
     => ( ! [M5: nat,T4: real] :
            ( ( ( ord_less @ nat @ M5 @ N )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( F3 @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ X2 @ M4 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X2 @ N ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_6756_Taylor__down,axiom,
    ! [N: nat,Diff: nat > real > real,F3: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
       => ( ! [M5: nat,T4: real] :
              ( ( ( ord_less @ nat @ M5 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ A2 @ T4 )
                  & ( ord_less @ real @ T4 @ C2 )
                  & ( ( F3 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ C2 ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M4 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_6757_Taylor__up,axiom,
    ! [N: nat,Diff: nat > real > real,F3: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
       => ( ! [M5: nat,T4: real] :
              ( ( ( ord_less @ nat @ M5 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ C2 @ T4 )
                  & ( ord_less @ real @ T4 @ B2 )
                  & ( ( F3 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ C2 ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M4 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_6758_Taylor,axiom,
    ! [N: nat,Diff: nat > real > real,F3: real > real,A2: real,B2: real,C2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
       => ( ! [M5: nat,T4: real] :
              ( ( ( ord_less @ nat @ M5 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X2 )
               => ( ( ord_less_eq @ real @ X2 @ B2 )
                 => ( ( X2 != C2 )
                   => ? [T4: real] :
                        ( ( ( ord_less @ real @ X2 @ C2 )
                         => ( ( ord_less @ real @ X2 @ T4 )
                            & ( ord_less @ real @ T4 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X2 @ C2 )
                         => ( ( ord_less @ real @ C2 @ T4 )
                            & ( ord_less @ real @ T4 @ X2 ) ) )
                        & ( ( F3 @ X2 )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M4 @ C2 ) @ ( semiring_char_0_fact @ real @ M4 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ C2 ) @ M4 ) )
                              @ ( set_ord_lessThan @ nat @ N ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_6759_Maclaurin__lemma2,axiom,
    ! [N: nat,H: real,Diff: nat > real > real,K: nat,B5: real] :
      ( ! [M5: nat,T4: real] :
          ( ( ( ord_less @ nat @ M5 @ N )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ H ) )
         => ( has_field_derivative @ real @ ( Diff @ M5 ) @ ( Diff @ ( suc @ M5 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N
          = ( suc @ K ) )
       => ! [M2: nat,T8: real] :
            ( ( ( ord_less @ nat @ M2 @ N )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M2 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M2 @ P4 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) @ ( power_power @ real @ U2 @ P4 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ M2 ) ) )
                    @ ( times_times @ real @ B5 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N @ M2 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M2 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M2 ) @ P4 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) @ ( power_power @ real @ T8 @ P4 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) )
                  @ ( times_times @ real @ B5 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_6760_DERIV__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X9: real] :
            ( suminf @ real
            @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X9 @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( power_power @ real @ X2 @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_6761_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X2 ) )
         => ( ( ord_less @ real @ ( G @ X2 ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X6: A] : ( arcsin @ ( G @ X6 ) )
                @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_6762_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X2 ) )
         => ( ( ord_less @ real @ ( G @ X2 ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X6: A] : ( arccos @ ( G @ X6 ) )
                @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_6763_has__derivative__in__compose,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F3: A > B,F9: A > B,X2: A,S: set @ A,G: B > C,G4: B > C] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_derivative @ B @ C @ G @ G4 @ ( topolo174197925503356063within @ B @ ( F3 @ X2 ) @ ( image @ A @ B @ F3 @ S ) ) )
           => ( has_derivative @ A @ C
              @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
              @ ^ [X6: A] : ( G4 @ ( F9 @ X6 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivative_in_compose
thf(fact_6764_has__derivative__compose,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F3: A > B,F9: A > B,X2: A,S: set @ A,G: B > C,G4: B > C] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( has_derivative @ B @ C @ G @ G4 @ ( topolo174197925503356063within @ B @ ( F3 @ X2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( has_derivative @ A @ C
              @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
              @ ^ [X6: A] : ( G4 @ ( F9 @ X6 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivative_compose
thf(fact_6765_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F3: D > real,F9: D > real,X2: D,S: set @ D,G: D > C,G4: D > C] :
          ( ( has_derivative @ D @ real @ F3 @ F9 @ ( topolo174197925503356063within @ D @ X2 @ S ) )
         => ( ( has_derivative @ D @ C @ G @ G4 @ ( topolo174197925503356063within @ D @ X2 @ S ) )
           => ( has_derivative @ D @ C
              @ ^ [X6: D] : ( real_V8093663219630862766scaleR @ C @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ^ [H2: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F3 @ X2 ) @ ( G4 @ H2 ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F9 @ H2 ) @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ D @ X2 @ S ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_6766_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,F4: filter @ A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ F4 )
         => ( has_derivative @ A @ A @ F3 @ ( times_times @ A @ D4 ) @ F4 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_6767_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A > A,F4: filter @ A,D7: A] :
          ( ( has_derivative @ A @ A @ F3 @ D4 @ F4 )
         => ( ! [X7: A] :
                ( ( times_times @ A @ X7 @ D7 )
                = ( D4 @ X7 ) )
           => ( has_field_derivative @ A @ F3 @ D7 @ F4 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_6768_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F5: A > A,D8: A] : ( has_derivative @ A @ A @ F5 @ ( times_times @ A @ D8 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_6769_has__derivative__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [I6: set @ A,F3: A > B > C,F9: A > B > C,F4: filter @ B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( has_derivative @ B @ C @ ( F3 @ I2 ) @ ( F9 @ I2 ) @ F4 ) )
         => ( has_derivative @ B @ C
            @ ^ [X6: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ I6 )
            @ ^ [X6: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I: A] : ( F9 @ I @ X6 )
                @ I6 )
            @ F4 ) ) ) ).

% has_derivative_sum
thf(fact_6770_has__derivative__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,F4: filter @ A,G: A > B,G4: A > B] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ F4 )
         => ( ( has_derivative @ A @ B @ G @ G4 @ F4 )
           => ( has_derivative @ A @ B
              @ ^ [X6: A] : ( minus_minus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ^ [X6: A] : ( minus_minus @ B @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
              @ F4 ) ) ) ) ).

% has_derivative_diff
thf(fact_6771_has__derivative__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,F4: filter @ A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ F4 )
         => ( has_derivative @ A @ B
            @ ^ [X6: A] : ( uminus_uminus @ B @ ( F3 @ X6 ) )
            @ ^ [X6: A] : ( uminus_uminus @ B @ ( F9 @ X6 ) )
            @ F4 ) ) ) ).

% has_derivative_minus
thf(fact_6772_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [C2: B,F4: filter @ A] :
          ( has_derivative @ A @ B
          @ ^ [X6: A] : C2
          @ ^ [X6: A] : ( zero_zero @ B )
          @ F4 ) ) ).

% has_derivative_const
thf(fact_6773_has__derivative__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [G: C > real,G4: C > real,F4: filter @ C] :
          ( ( has_derivative @ C @ real @ G @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X6: C] : ( real_Vector_of_real @ A @ ( G @ X6 ) )
            @ ^ [X6: C] : ( real_Vector_of_real @ A @ ( G4 @ X6 ) )
            @ F4 ) ) ) ).

% has_derivative_of_real
thf(fact_6774_has__derivative__ident,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F4: filter @ A] :
          ( has_derivative @ A @ A
          @ ^ [X6: A] : X6
          @ ^ [X6: A] : X6
          @ F4 ) ) ).

% has_derivative_ident
thf(fact_6775_has__derivative__scaleR__right,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [G: C > B,G4: C > B,F4: filter @ C,R: real] :
          ( ( has_derivative @ C @ B @ G @ G4 @ F4 )
         => ( has_derivative @ C @ B
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ B @ R @ ( G @ X6 ) )
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ B @ R @ ( G4 @ X6 ) )
            @ F4 ) ) ) ).

% has_derivative_scaleR_right
thf(fact_6776_has__derivative__scaleR__left,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [G: C > real,G4: C > real,F4: filter @ C,X2: B] :
          ( ( has_derivative @ C @ real @ G @ G4 @ F4 )
         => ( has_derivative @ C @ B
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ B @ ( G @ X6 ) @ X2 )
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ B @ ( G4 @ X6 ) @ X2 )
            @ F4 ) ) ) ).

% has_derivative_scaleR_left
thf(fact_6777_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,F4: filter @ A,G: A > B,G4: A > B] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ F4 )
         => ( ( has_derivative @ A @ B @ G @ G4 @ F4 )
           => ( has_derivative @ A @ B
              @ ^ [X6: A] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ^ [X6: A] : ( plus_plus @ B @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
              @ F4 ) ) ) ) ).

% has_derivative_add
thf(fact_6778_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G4: C > A,F4: filter @ C,X2: A] :
          ( ( has_derivative @ C @ A @ G @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X6: C] : ( times_times @ A @ X2 @ ( G @ X6 ) )
            @ ^ [X6: C] : ( times_times @ A @ X2 @ ( G4 @ X6 ) )
            @ F4 ) ) ) ).

% has_derivative_mult_right
thf(fact_6779_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G4: C > A,F4: filter @ C,Y2: A] :
          ( ( has_derivative @ C @ A @ G @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X6: C] : ( times_times @ A @ ( G @ X6 ) @ Y2 )
            @ ^ [X6: C] : ( times_times @ A @ ( G4 @ X6 ) @ Y2 )
            @ F4 ) ) ) ).

% has_derivative_mult_left
thf(fact_6780_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F3: D > A,F9: D > A,X2: D,S: set @ D,G: D > A,G4: D > A] :
          ( ( has_derivative @ D @ A @ F3 @ F9 @ ( topolo174197925503356063within @ D @ X2 @ S ) )
         => ( ( has_derivative @ D @ A @ G @ G4 @ ( topolo174197925503356063within @ D @ X2 @ S ) )
           => ( has_derivative @ D @ A
              @ ^ [X6: D] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ^ [H2: D] : ( plus_plus @ A @ ( times_times @ A @ ( F3 @ X2 ) @ ( G4 @ H2 ) ) @ ( times_times @ A @ ( F9 @ H2 ) @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ D @ X2 @ S ) ) ) ) ) ).

% has_derivative_mult
thf(fact_6781_has__derivative__zero__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: A > B,X2: A] :
          ( ( has_derivative @ A @ B
            @ ^ [X6: A] : ( zero_zero @ B )
            @ F4
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( F4
            = ( ^ [H2: A] : ( zero_zero @ B ) ) ) ) ) ).

% has_derivative_zero_unique
thf(fact_6782_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T3: set @ A,G: A > B,G4: A > A > B,F3: C > A,S: set @ C,X2: C,F9: C > A] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ T3 )
             => ( has_derivative @ A @ B @ G @ ( G4 @ X7 ) @ ( topolo174197925503356063within @ A @ X7 @ T3 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F3 @ S ) @ T3 )
           => ( ( member @ C @ X2 @ S )
             => ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X2 @ S ) )
               => ( has_derivative @ C @ B
                  @ ^ [X6: C] : ( G @ ( F3 @ X6 ) )
                  @ ^ [Y: C] : ( G4 @ ( F3 @ X2 ) @ ( F9 @ Y ) )
                  @ ( topolo174197925503356063within @ C @ X2 @ S ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_6783_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X6: A] : ( exp @ real @ ( G @ X6 ) )
            @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( exp @ real @ ( G @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_exp
thf(fact_6784_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X6: A] : ( sin @ real @ ( G @ X6 ) )
            @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( cos @ real @ ( G @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_sin
thf(fact_6785_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X6: A] : ( cosh @ A @ ( G @ X6 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G @ X2 ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_cosh
thf(fact_6786_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X6: A] : ( sinh @ A @ ( G @ X6 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G @ X2 ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_sinh
thf(fact_6787_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,F9: C > A,X2: C,S3: set @ C,G: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
         => ( ( has_derivative @ C @ A @ G @ G4 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X6: C] : ( divide_divide @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ^ [H2: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F9 @ H2 ) @ ( G @ X2 ) ) @ ( times_times @ A @ ( F3 @ X2 ) @ ( G4 @ H2 ) ) ) @ ( times_times @ A @ ( G @ X2 ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ C @ X2 @ S3 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_6788_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: C > A,X2: C,F9: C > A,S3: set @ C] :
          ( ( ( F3 @ X2 )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
           => ( has_derivative @ C @ A
              @ ^ [X6: C] : ( inverse_inverse @ A @ ( F3 @ X6 ) )
              @ ^ [H2: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F3 @ X2 ) ) @ ( F9 @ H2 ) ) @ ( inverse_inverse @ A @ ( F3 @ X2 ) ) ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S3 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_6789_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,S3: set @ A] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H2: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X2 ) @ H2 ) @ ( inverse_inverse @ A @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_6790_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: real > real,F9: real,G: A > real,X2: A,G4: A > real,S: set @ A] :
          ( ( has_field_derivative @ real @ F3 @ F9 @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X6: A] : ( F3 @ ( G @ X6 ) )
              @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ F9 )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_6791_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X6: A] : ( cos @ real @ ( G @ X6 ) )
            @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G @ X2 ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_cos
thf(fact_6792_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,F9: A > B,X2: A,S3: set @ A,N: nat] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( has_derivative @ A @ B
            @ ^ [X6: A] : ( power_power @ B @ ( F3 @ X6 ) @ N )
            @ ^ [Y: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N ) @ ( F9 @ Y ) ) @ ( power_power @ B @ ( F3 @ X2 ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_derivative_power
thf(fact_6793_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X6: A] : ( ln_ln @ real @ ( G @ X6 ) )
              @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( inverse_inverse @ real @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivative_ln
thf(fact_6794_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: C > A,F9: C > A,X2: C,S3: set @ C,G: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
         => ( ( has_derivative @ C @ A @ G @ G4 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X6: C] : ( divide_divide @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ^ [H2: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F3 @ X2 ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X2 ) ) @ ( G4 @ H2 ) ) @ ( inverse_inverse @ A @ ( G @ X2 ) ) ) ) @ ( divide_divide @ A @ ( F9 @ H2 ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ C @ X2 @ S3 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_6795_has__derivative__prod,axiom,
    ! [B: $tType,I5: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I6: set @ I5,F3: I5 > A > B,F9: I5 > A > B,X2: A,S3: set @ A] :
          ( ! [I2: I5] :
              ( ( member @ I5 @ I2 @ I6 )
             => ( has_derivative @ A @ B @ ( F3 @ I2 ) @ ( F9 @ I2 ) @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X6: A] :
                ( groups7121269368397514597t_prod @ I5 @ B
                @ ^ [I: I5] : ( F3 @ I @ X6 )
                @ I6 )
            @ ^ [Y: A] :
                ( groups7311177749621191930dd_sum @ I5 @ B
                @ ^ [I: I5] :
                    ( times_times @ B @ ( F9 @ I @ Y )
                    @ ( groups7121269368397514597t_prod @ I5 @ B
                      @ ^ [J4: I5] : ( F3 @ J4 @ X2 )
                      @ ( minus_minus @ ( set @ I5 ) @ I6 @ ( insert @ I5 @ I @ ( bot_bot @ ( set @ I5 ) ) ) ) ) )
                @ I6 )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_derivative_prod
thf(fact_6796_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X2: A,X15: set @ A,F3: A > real,F9: A > real] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ X15 ) )
         => ( ( has_derivative @ A @ real @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ X15 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
             => ( ( member @ A @ X2 @ X15 )
               => ( has_derivative @ A @ real
                  @ ^ [X6: A] : ( powr @ real @ ( G @ X6 ) @ ( F3 @ X6 ) )
                  @ ^ [H2: A] : ( times_times @ real @ ( powr @ real @ ( G @ X2 ) @ ( F3 @ X2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F9 @ H2 ) @ ( ln_ln @ real @ ( G @ X2 ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G4 @ H2 ) @ ( F3 @ X2 ) ) @ ( G @ X2 ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X2 @ X15 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_6797_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X6: A] : ( sqrt @ ( G @ X6 ) )
              @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_6798_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X6: A] : ( arctan @ ( G @ X6 ) )
            @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_arctan
thf(fact_6799_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G4: A > real,S: set @ A] :
          ( ( ( cos @ real @ ( G @ X2 ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X6: A] : ( tan @ real @ ( G @ X6 ) )
              @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivative_tan
thf(fact_6800_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X2: A,F3: real > Aa,G4: A > real,S: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ F3 )
         => ( ~ ( member @ Aa @ ( F3 @ ( G @ X2 ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X6: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F3 @ ( G @ X6 ) ) ) )
                @ ^ [X6: A] : ( times_times @ real @ ( G4 @ X6 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_6801_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( filterlim @ A @ A
              @ ^ [H2: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X2 @ H2 ) @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X2 @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_6802_tendsto__const,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [K: A,F4: filter @ B] :
          ( filterlim @ B @ A
          @ ^ [X6: B] : K
          @ ( topolo7230453075368039082e_nhds @ A @ K )
          @ F4 ) ) ).

% tendsto_const
thf(fact_6803_tendsto__ident__at,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A2: A,S: set @ A] :
          ( filterlim @ A @ A
          @ ^ [X6: A] : X6
          @ ( topolo7230453075368039082e_nhds @ A @ A2 )
          @ ( topolo174197925503356063within @ A @ A2 @ S ) ) ) ).

% tendsto_ident_at
thf(fact_6804_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F3: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X6: B] : ( times_times @ A @ C2 @ ( F3 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
              @ F4 )
            = ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_6805_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F3: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X6: B] : ( times_times @ A @ ( F3 @ X6 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_6806_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F3: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real
          @ ^ [X6: A] : ( power_power @ real @ ( F3 @ X6 ) @ N )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 )
        = ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% power_tendsto_0_iff
thf(fact_6807_isCont__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F3: A > B,G: A > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( product_Pair @ B @ C @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% isCont_Pair
thf(fact_6808_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F3: A > B,G: B > C,L: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L ) @ ( topolo174197925503356063within @ B @ ( F3 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X7: A] :
                      ( ( ( X7 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X7 @ A2 ) ) @ D6 ) )
                     => ( ( F3 @ X7 )
                       != ( F3 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_6809_continuous__within__compose2,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topological_t2_space @ B ) )
     => ! [X2: A,S: set @ A,F3: A > B,G: B > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ S ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ B @ C @ ( topolo174197925503356063within @ B @ ( F3 @ X2 ) @ ( image @ A @ B @ F3 @ S ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ X2 @ S )
              @ ^ [X6: A] : ( G @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_within_compose2
thf(fact_6810_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F3: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F3 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H2: A] : ( F3 @ ( plus_plus @ A @ A2 @ H2 ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L5 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_6811_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,L5: B,A2: A,K: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X6: A] : ( F3 @ ( plus_plus @ A @ X6 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_6812_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,A2: A,L5: B] :
          ( ( filterlim @ A @ B
            @ ^ [H2: A] : ( F3 @ ( plus_plus @ A @ A2 @ H2 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_6813_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H2: A] : ( F3 @ ( plus_plus @ A @ A2 @ H2 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_6814_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H2: A] : ( F3 @ ( plus_plus @ A @ A2 @ H2 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_6815_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
          = ( filterlim @ A @ B
            @ ^ [H2: A] : ( F3 @ ( plus_plus @ A @ X2 @ H2 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ X2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_6816_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( zero @ Aa )
        & ( topological_t2_space @ Aa ) )
     => ! [K: Aa,A2: A] :
          ( ( K
           != ( zero_zero @ Aa ) )
         => ~ ( filterlim @ A @ Aa
              @ ^ [X6: A] : K
              @ ( topolo7230453075368039082e_nhds @ Aa @ ( zero_zero @ Aa ) )
              @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_not_zero
thf(fact_6817_isCont__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) ) ) ) ) ).

% isCont_norm
thf(fact_6818_isCont__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [A2: C,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
         => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
            @ ^ [X6: C] : ( real_Vector_of_real @ A @ ( G @ X6 ) ) ) ) ) ).

% isCont_of_real
thf(fact_6819_continuous__within__compose3,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topological_t2_space @ A ) )
     => ! [F3: C > A,X2: C,G: A > B,S: set @ C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ ( F3 @ X2 ) @ ( top_top @ ( set @ A ) ) ) @ G )
         => ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X2 @ S ) @ F3 )
           => ( topolo3448309680560233919inuous @ C @ B @ ( topolo174197925503356063within @ C @ X2 @ S )
              @ ^ [X6: C] : ( G @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_within_compose3
thf(fact_6820_isCont__tendsto__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topological_t2_space @ A ) )
     => ! [L: A,G: A > B,F3: C > A,F4: filter @ C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ L @ ( top_top @ ( set @ A ) ) ) @ G )
         => ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X6: C] : ( G @ ( F3 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( G @ L ) )
              @ F4 ) ) ) ) ).

% isCont_tendsto_compose
thf(fact_6821_LIM__const__not__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( topological_t2_space @ B ) )
     => ! [K: B,L5: B,A2: A] :
          ( ( K != L5 )
         => ~ ( filterlim @ A @ B
              @ ^ [X6: A] : K
              @ ( topolo7230453075368039082e_nhds @ B @ L5 )
              @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_const_not_eq
thf(fact_6822_tendsto__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: A > B,L: A,F3: C > A,F4: filter @ C] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( G @ L ) ) @ ( topolo174197925503356063within @ A @ L @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X6: C] : ( G @ ( F3 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( G @ L ) )
              @ F4 ) ) ) ) ).

% tendsto_compose
thf(fact_6823_LIM__const__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( topolo8386298272705272623_space @ A ) )
     => ! [K: B,L5: B,A2: A] :
          ( ( filterlim @ A @ B
            @ ^ [X6: A] : K
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( K = L5 ) ) ) ).

% LIM_const_eq
thf(fact_6824_isCont__o2,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topological_t2_space @ B ) )
     => ! [A2: A,F3: A > B,G: B > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ B @ C @ ( topolo174197925503356063within @ B @ ( F3 @ A2 ) @ ( top_top @ ( set @ B ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( G @ ( F3 @ X6 ) ) ) ) ) ) ).

% isCont_o2
thf(fact_6825_filterlim__at__If,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: A > B,G5: filter @ B,X2: A,P3: A > $o,G: A > B] :
          ( ( filterlim @ A @ B @ F3 @ G5 @ ( topolo174197925503356063within @ A @ X2 @ ( collect @ A @ P3 ) ) )
         => ( ( filterlim @ A @ B @ G @ G5
              @ ( topolo174197925503356063within @ A @ X2
                @ ( collect @ A
                  @ ^ [X6: A] :
                      ~ ( P3 @ X6 ) ) ) )
           => ( filterlim @ A @ B
              @ ^ [X6: A] : ( if @ B @ ( P3 @ X6 ) @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ G5
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% filterlim_at_If
thf(fact_6826_isCont__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [A2: D,F3: D > real,G: D > C] :
          ( ( topolo3448309680560233919inuous @ D @ real @ ( topolo174197925503356063within @ D @ A2 @ ( top_top @ ( set @ D ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ C @ ( topolo174197925503356063within @ D @ A2 @ ( top_top @ ( set @ D ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ D @ C @ ( topolo174197925503356063within @ D @ A2 @ ( top_top @ ( set @ D ) ) )
              @ ^ [X6: D] : ( real_V8093663219630862766scaleR @ C @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% isCont_scaleR
thf(fact_6827_isCont__fst,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F3: A > ( product_prod @ B @ C )] :
          ( ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] : ( product_fst @ B @ C @ ( F3 @ X6 ) ) ) ) ) ).

% isCont_fst
thf(fact_6828_isCont__snd,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F3: A > ( product_prod @ B @ C )] :
          ( ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] : ( product_snd @ B @ C @ ( F3 @ X6 ) ) ) ) ) ).

% isCont_snd
thf(fact_6829_continuous__ident,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X2: A,S3: set @ A] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S3 )
          @ ^ [X6: A] : X6 ) ) ).

% continuous_ident
thf(fact_6830_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( filterlim @ A @ A
            @ ^ [Y: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ Y ) @ ( F3 @ X2 ) ) @ ( minus_minus @ A @ Y @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_field_derivativeD
thf(fact_6831_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
          = ( filterlim @ A @ A
            @ ^ [Y: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ Y ) @ ( F3 @ X2 ) ) @ ( minus_minus @ A @ Y @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_field_derivative_iff
thf(fact_6832_filterlim__at__within__If,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: A > B,G5: filter @ B,X2: A,A3: set @ A,P3: A > $o,G: A > B] :
          ( ( filterlim @ A @ B @ F3 @ G5 @ ( topolo174197925503356063within @ A @ X2 @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P3 ) ) ) )
         => ( ( filterlim @ A @ B @ G @ G5
              @ ( topolo174197925503356063within @ A @ X2
                @ ( inf_inf @ ( set @ A ) @ A3
                  @ ( collect @ A
                    @ ^ [X6: A] :
                        ~ ( P3 @ X6 ) ) ) ) )
           => ( filterlim @ A @ B
              @ ^ [X6: A] : ( if @ B @ ( P3 @ X6 ) @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ G5
              @ ( topolo174197925503356063within @ A @ X2 @ A3 ) ) ) ) ) ).

% filterlim_at_within_If
thf(fact_6833_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: A > real,A2: A,G: A > real] :
          ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X7: A] :
                ( ( X7 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X7 ) ) )
           => ( ! [X7: A] :
                  ( ( X7 != A2 )
                 => ( ord_less_eq @ real @ ( G @ X7 ) @ ( F3 @ X7 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_6834_has__derivative__Im,axiom,
    ! [C: $tType] :
      ( ( real_V822414075346904944vector @ C )
     => ! [G: C > complex,G4: C > complex,F4: filter @ C] :
          ( ( has_derivative @ C @ complex @ G @ G4 @ F4 )
         => ( has_derivative @ C @ real
            @ ^ [X6: C] : ( im @ ( G @ X6 ) )
            @ ^ [X6: C] : ( im @ ( G4 @ X6 ) )
            @ F4 ) ) ) ).

% has_derivative_Im
thf(fact_6835_has__derivative__Re,axiom,
    ! [C: $tType] :
      ( ( real_V822414075346904944vector @ C )
     => ! [G: C > complex,G4: C > complex,F4: filter @ C] :
          ( ( has_derivative @ C @ complex @ G @ G4 @ F4 )
         => ( has_derivative @ C @ real
            @ ^ [X6: C] : ( re @ ( G @ X6 ) )
            @ ^ [X6: C] : ( re @ ( G4 @ X6 ) )
            @ F4 ) ) ) ).

% has_derivative_Re
thf(fact_6836_has__derivative__cnj,axiom,
    ! [C: $tType] :
      ( ( real_V822414075346904944vector @ C )
     => ! [G: C > complex,G4: C > complex,F4: filter @ C] :
          ( ( has_derivative @ C @ complex @ G @ G4 @ F4 )
         => ( has_derivative @ C @ complex
            @ ^ [X6: C] : ( cnj @ ( G @ X6 ) )
            @ ^ [X6: C] : ( cnj @ ( G4 @ X6 ) )
            @ F4 ) ) ) ).

% has_derivative_cnj
thf(fact_6837_continuous__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F4: filter @ A,F3: A > B,G: A > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ C @ F4 @ G )
           => ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ F4
              @ ^ [X6: A] : ( product_Pair @ B @ C @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_Pair
thf(fact_6838_tendsto__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: A > B,A2: B,F4: filter @ A,G: A > C,B2: C] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ B2 ) @ F4 )
           => ( filterlim @ A @ ( product_prod @ B @ C )
              @ ^ [X6: A] : ( product_Pair @ B @ C @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_Pair
thf(fact_6839_tendsto__log,axiom,
    ! [A: $tType,F3: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X6: A] : ( log @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_6840_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F3: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X6: A] : ( power_power @ B @ ( F3 @ X6 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_null_power
thf(fact_6841_tendsto__arcosh,axiom,
    ! [B: $tType,F3: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X6: B] : ( arcosh @ real @ ( F3 @ X6 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_arcosh
thf(fact_6842_tendsto__artanh,axiom,
    ! [A: $tType,F3: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( artanh @ real @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_artanh
thf(fact_6843_filterlim__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: A > B,G5: C > ( filter @ B ),B5: set @ C,F4: filter @ A] :
      ( ( filterlim @ A @ B @ F3 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ C @ ( filter @ B ) @ G5 @ B5 ) ) @ F4 )
      = ( ! [X6: C] :
            ( ( member @ C @ X6 @ B5 )
           => ( filterlim @ A @ B @ F3 @ ( G5 @ X6 ) @ F4 ) ) ) ) ).

% filterlim_INF
thf(fact_6844_filterlim__INF_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,X2: A,A3: set @ A,F3: B > C,F4: filter @ C,G5: A > ( filter @ B )] :
      ( ( member @ A @ X2 @ A3 )
     => ( ( filterlim @ B @ C @ F3 @ F4 @ ( G5 @ X2 ) )
       => ( filterlim @ B @ C @ F3 @ F4 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ G5 @ A3 ) ) ) ) ) ).

% filterlim_INF'
thf(fact_6845_filterlim__ident,axiom,
    ! [A: $tType,F4: filter @ A] :
      ( filterlim @ A @ A
      @ ^ [X6: A] : X6
      @ F4
      @ F4 ) ).

% filterlim_ident
thf(fact_6846_filterlim__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: A > B,F33: filter @ B,F23: filter @ A,F3: C > A,F13: filter @ C] :
      ( ( filterlim @ A @ B @ G @ F33 @ F23 )
     => ( ( filterlim @ C @ A @ F3 @ F23 @ F13 )
       => ( filterlim @ C @ B
          @ ^ [X6: C] : ( G @ ( F3 @ X6 ) )
          @ F33
          @ F13 ) ) ) ).

% filterlim_compose
thf(fact_6847_tendsto__const__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ B,A2: A,B2: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A
              @ ^ [X6: B] : A2
              @ ( topolo7230453075368039082e_nhds @ A @ B2 )
              @ F4 )
            = ( A2 = B2 ) ) ) ) ).

% tendsto_const_iff
thf(fact_6848_continuous__max,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F4: filter @ A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X6: A] : ( ord_max @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_max
thf(fact_6849_tendsto__max,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X15: B > A,X2: A,Net: filter @ B,Y6: B > A,Y2: A] :
          ( ( filterlim @ B @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ Net )
         => ( ( filterlim @ B @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ Net )
           => ( filterlim @ B @ A
              @ ^ [X6: B] : ( ord_max @ A @ ( X15 @ X6 ) @ ( Y6 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( ord_max @ A @ X2 @ Y2 ) )
              @ Net ) ) ) ) ).

% tendsto_max
thf(fact_6850_tendsto__of__int__ceiling,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( ring_1 @ C )
        & ( topolo4958980785337419405_space @ C )
        & ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( filterlim @ A @ C
              @ ^ [X6: A] : ( ring_1_of_int @ C @ ( archimedean_ceiling @ B @ ( F3 @ X6 ) ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( ring_1_of_int @ C @ ( archimedean_ceiling @ B @ L ) ) )
              @ F4 ) ) ) ) ).

% tendsto_of_int_ceiling
thf(fact_6851_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,A2: A,F4: filter @ C] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( cosh @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ C @ A
              @ ^ [X6: C] : ( tanh @ A @ ( F3 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tanh @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_tanh
thf(fact_6852_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X6: A] : ( abs_abs @ real @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
     => ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_cancel
thf(fact_6853_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X6: A] : ( abs_abs @ real @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
      = ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_iff
thf(fact_6854_tendsto__rabs__zero,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X6: A] : ( abs_abs @ real @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_rabs_zero
thf(fact_6855_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X6: B] : ( divide_divide @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ).

% tendsto_divide
thf(fact_6856_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: B > A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X6: B] : ( divide_divide @ A @ ( F3 @ X6 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_divide_zero
thf(fact_6857_tendsto__rabs,axiom,
    ! [A: $tType,F3: A > real,L: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X6: A] : ( abs_abs @ real @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( abs_abs @ real @ L ) )
        @ F4 ) ) ).

% tendsto_rabs
thf(fact_6858_tendsto__of__int__floor,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( ring_1 @ C )
        & ( topolo4958980785337419405_space @ C )
        & ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( filterlim @ A @ C
              @ ^ [X6: A] : ( ring_1_of_int @ C @ ( archim6421214686448440834_floor @ B @ ( F3 @ X6 ) ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( ring_1_of_int @ C @ ( archim6421214686448440834_floor @ B @ L ) ) )
              @ F4 ) ) ) ) ).

% tendsto_of_int_floor
thf(fact_6859_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F3: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X6: D] : ( times_times @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_one
thf(fact_6860_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F3: B > A,L: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X6: B] : ( times_times @ A @ ( F3 @ X6 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
            @ F4 ) ) ) ).

% tendsto_mult_right
thf(fact_6861_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F3: B > A,L: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X6: B] : ( times_times @ A @ C2 @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
            @ F4 ) ) ) ).

% tendsto_mult_left
thf(fact_6862_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X6: B] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_mult
thf(fact_6863_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F3: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X6: B] : ( times_times @ A @ ( F3 @ X6 ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_6864_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F3: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X6: B] : ( times_times @ A @ C2 @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_mult_left
thf(fact_6865_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F4: filter @ D,F3: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X6: D] : ( times_times @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_6866_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ D,F3: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ A @ F4
              @ ^ [X6: D] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_mult
thf(fact_6867_tendsto__cnj,axiom,
    ! [C: $tType,G: C > complex,A2: complex,F4: filter @ C] :
      ( ( filterlim @ C @ complex @ G @ ( topolo7230453075368039082e_nhds @ complex @ A2 ) @ F4 )
     => ( filterlim @ C @ complex
        @ ^ [X6: C] : ( cnj @ ( G @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ complex @ ( cnj @ A2 ) )
        @ F4 ) ) ).

% tendsto_cnj
thf(fact_6868_tendsto__Re,axiom,
    ! [C: $tType,G: C > complex,A2: complex,F4: filter @ C] :
      ( ( filterlim @ C @ complex @ G @ ( topolo7230453075368039082e_nhds @ complex @ A2 ) @ F4 )
     => ( filterlim @ C @ real
        @ ^ [X6: C] : ( re @ ( G @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( re @ A2 ) )
        @ F4 ) ) ).

% tendsto_Re
thf(fact_6869_lim__cnj,axiom,
    ! [A: $tType,F3: A > complex,L: complex,F4: filter @ A] :
      ( ( filterlim @ A @ complex
        @ ^ [X6: A] : ( cnj @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ complex @ ( cnj @ L ) )
        @ F4 )
      = ( filterlim @ A @ complex @ F3 @ ( topolo7230453075368039082e_nhds @ complex @ L ) @ F4 ) ) ).

% lim_cnj
thf(fact_6870_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F3: B > A,D2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X6: B] : ( plus_plus @ A @ C2 @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D2 ) )
            @ F4 )
          = ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ D2 ) @ F4 ) ) ) ).

% tendsto_add_const_iff
thf(fact_6871_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X6: B] : ( plus_plus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_add
thf(fact_6872_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F4: filter @ D,F3: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X6: D] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_add
thf(fact_6873_continuous__sinh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ C @ A @ F4
            @ ^ [X6: C] : ( sinh @ A @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_sinh
thf(fact_6874_tendsto__cosh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,A2: A,F4: filter @ C] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( filterlim @ C @ A
            @ ^ [X6: C] : ( cosh @ A @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( cosh @ A @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_cosh
thf(fact_6875_tendsto__sinh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,A2: A,F4: filter @ C] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( filterlim @ C @ A
            @ ^ [X6: C] : ( sinh @ A @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( sinh @ A @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_sinh
thf(fact_6876_tendsto__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( real_V822414075346904944vector @ C )
     => ! [F3: D > real,A2: real,F4: filter @ D,G: D > C,B2: C] :
          ( ( filterlim @ D @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
         => ( ( filterlim @ D @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ B2 ) @ F4 )
           => ( filterlim @ D @ C
              @ ^ [X6: D] : ( real_V8093663219630862766scaleR @ C @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( real_V8093663219630862766scaleR @ C @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_scaleR
thf(fact_6877_continuous__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F4: filter @ D,F3: D > real,G: D > C] :
          ( ( topolo3448309680560233919inuous @ D @ real @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ C @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ C @ F4
              @ ^ [X6: D] : ( real_V8093663219630862766scaleR @ C @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_scaleR
thf(fact_6878_continuous__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X6: A] : ( cos @ B @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_cos
thf(fact_6879_continuous__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X6: A] : ( sin @ B @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_sin
thf(fact_6880_continuous__exp,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ C @ A @ F4
            @ ^ [X6: C] : ( exp @ A @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_exp
thf(fact_6881_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F4: filter @ A,F3: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X6: A] : ( power_power @ B @ ( F3 @ X6 ) @ N ) ) ) ) ).

% continuous_power
thf(fact_6882_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F4: filter @ C,F3: C > B,G: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F4 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X6: C] : ( power_power @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_6883_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F3: C > B,A2: B,F4: filter @ C,G: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ C @ nat @ G @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X6: C] : ( power_power @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_power_strong
thf(fact_6884_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F3: A > B,A2: B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X6: A] : ( power_power @ B @ ( F3 @ X6 ) @ N )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N ) )
            @ F4 ) ) ) ).

% tendsto_power
thf(fact_6885_tendsto__exp,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,A2: A,F4: filter @ C] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( filterlim @ C @ A
            @ ^ [X6: C] : ( exp @ A @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( exp @ A @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_exp
thf(fact_6886_tendsto__arsinh,axiom,
    ! [B: $tType,F3: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( filterlim @ B @ real
        @ ^ [X6: B] : ( arsinh @ real @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( arsinh @ real @ A2 ) )
        @ F4 ) ) ).

% tendsto_arsinh
thf(fact_6887_tendsto__arctan,axiom,
    ! [A: $tType,F3: A > real,X2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ X2 ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X6: A] : ( arctan @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( arctan @ X2 ) )
        @ F4 ) ) ).

% tendsto_arctan
thf(fact_6888_tendsto__real__sqrt,axiom,
    ! [A: $tType,F3: A > real,X2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ X2 ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X6: A] : ( sqrt @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( sqrt @ X2 ) )
        @ F4 ) ) ).

% tendsto_real_sqrt
thf(fact_6889_tendsto__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,A2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X6: A] : ( sin @ B @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( sin @ B @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_sin
thf(fact_6890_tendsto__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,A2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X6: A] : ( cos @ B @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( cos @ B @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_cos
thf(fact_6891_continuous__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F4: filter @ A,C2: B] :
          ( topolo3448309680560233919inuous @ A @ B @ F4
          @ ^ [X6: A] : C2 ) ) ).

% continuous_const
thf(fact_6892_tendsto__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [G: C > real,A2: real,F4: filter @ C] :
          ( ( filterlim @ C @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
         => ( filterlim @ C @ A
            @ ^ [X6: C] : ( real_Vector_of_real @ A @ ( G @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( real_Vector_of_real @ A @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_of_real
thf(fact_6893_continuous__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F4: filter @ C,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ F4 @ G )
         => ( topolo3448309680560233919inuous @ C @ A @ F4
            @ ^ [X6: C] : ( real_Vector_of_real @ A @ ( G @ X6 ) ) ) ) ) ).

% continuous_of_real
thf(fact_6894_tendsto__of__real__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: B > real,C2: real,F4: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X6: B] : ( real_Vector_of_real @ A @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( real_Vector_of_real @ A @ C2 ) )
            @ F4 )
          = ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 ) ) ) ).

% tendsto_of_real_iff
thf(fact_6895_tendsto__Complex,axiom,
    ! [A: $tType,F3: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( filterlim @ A @ complex
          @ ^ [X6: A] : ( complex2 @ ( F3 @ X6 ) @ ( G @ X6 ) )
          @ ( topolo7230453075368039082e_nhds @ complex @ ( complex2 @ A2 @ B2 ) )
          @ F4 ) ) ) ).

% tendsto_Complex
thf(fact_6896_tendsto__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,A2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( real_V7770717601297561774m_norm @ B @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_norm
thf(fact_6897_continuous__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_norm
thf(fact_6898_continuous__cosh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ C @ A @ F4
            @ ^ [X6: C] : ( cosh @ A @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_cosh
thf(fact_6899_tendsto__real__root,axiom,
    ! [A: $tType,F3: A > real,X2: real,F4: filter @ A,N: nat] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ X2 ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X6: A] : ( root @ N @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( root @ N @ X2 ) )
        @ F4 ) ) ).

% tendsto_real_root
thf(fact_6900_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: A > A,A2: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( cos @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X6: A] : ( tan @ A @ ( F3 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tan @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_tan
thf(fact_6901_tendsto__Im,axiom,
    ! [C: $tType,G: C > complex,A2: complex,F4: filter @ C] :
      ( ( filterlim @ C @ complex @ G @ ( topolo7230453075368039082e_nhds @ complex @ A2 ) @ F4 )
     => ( filterlim @ C @ real
        @ ^ [X6: C] : ( im @ ( G @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( im @ A2 ) )
        @ F4 ) ) ).

% tendsto_Im
thf(fact_6902_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_cancel
thf(fact_6903_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
          = ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_iff
thf(fact_6904_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_norm_zero
thf(fact_6905_tendsto__ln,axiom,
    ! [A: $tType,F3: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( A2
         != ( zero_zero @ real ) )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( ln_ln @ real @ ( F3 @ X6 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( ln_ln @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_ln
thf(fact_6906_tendsto__powr,axiom,
    ! [A: $tType,F3: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( A2
           != ( zero_zero @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr
thf(fact_6907_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( L
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X6: B] : ( sgn_sgn @ A @ ( F3 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( sgn_sgn @ A @ L ) )
              @ F4 ) ) ) ) ).

% tendsto_sgn
thf(fact_6908_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X6: B] : ( inverse_inverse @ A @ ( F3 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( inverse_inverse @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_inverse
thf(fact_6909_tendsto__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( real_V4412858255891104859lgebra @ C )
        & ( comm_ring_1 @ C ) )
     => ! [S3: set @ A,F3: A > B > C,L5: A > C,F4: filter @ B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ S3 )
             => ( filterlim @ B @ C @ ( F3 @ I2 ) @ ( topolo7230453075368039082e_nhds @ C @ ( L5 @ I2 ) ) @ F4 ) )
         => ( filterlim @ B @ C
            @ ^ [X6: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ S3 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( groups7121269368397514597t_prod @ A @ C @ L5 @ S3 ) )
            @ F4 ) ) ) ).

% tendsto_prod
thf(fact_6910_tendsto__prod_H,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I6: set @ A,F3: A > B > C,A2: A > C,F4: filter @ B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( filterlim @ B @ C @ ( F3 @ I2 ) @ ( topolo7230453075368039082e_nhds @ C @ ( A2 @ I2 ) ) @ F4 ) )
         => ( filterlim @ B @ C
            @ ^ [X6: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( groups7121269368397514597t_prod @ A @ C @ A2 @ I6 ) )
            @ F4 ) ) ) ).

% tendsto_prod'
thf(fact_6911_continuous__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ C )
        & ( comm_ring_1 @ C ) )
     => ! [S3: set @ A,F4: filter @ B,F3: A > B > C] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ S3 )
             => ( topolo3448309680560233919inuous @ B @ C @ F4 @ ( F3 @ I2 ) ) )
         => ( topolo3448309680560233919inuous @ B @ C @ F4
            @ ^ [X6: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ S3 ) ) ) ) ).

% continuous_prod
thf(fact_6912_continuous__prod_H,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( topolo4987421752381908075d_mult @ C ) )
     => ! [I6: set @ A,F4: filter @ B,F3: A > B > C] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( topolo3448309680560233919inuous @ B @ C @ F4 @ ( F3 @ I2 ) ) )
         => ( topolo3448309680560233919inuous @ B @ C @ F4
            @ ^ [X6: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ I6 ) ) ) ) ).

% continuous_prod'
thf(fact_6913_tendsto__one__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I6: set @ B,F3: A > B > C,F4: filter @ A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ I6 )
             => ( filterlim @ A @ C
                @ ^ [X6: A] : ( F3 @ X6 @ I2 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I: A] : ( groups7121269368397514597t_prod @ B @ C @ ( F3 @ I ) @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
            @ F4 ) ) ) ).

% tendsto_one_prod'
thf(fact_6914_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F3: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X6: D] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_add_zero
thf(fact_6915_tendsto__complex__iff,axiom,
    ! [A: $tType,F3: A > complex,X2: complex,F4: filter @ A] :
      ( ( filterlim @ A @ complex @ F3 @ ( topolo7230453075368039082e_nhds @ complex @ X2 ) @ F4 )
      = ( ( filterlim @ A @ real
          @ ^ [X6: A] : ( re @ ( F3 @ X6 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( re @ X2 ) )
          @ F4 )
        & ( filterlim @ A @ real
          @ ^ [X6: A] : ( im @ ( F3 @ X6 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( im @ X2 ) )
          @ F4 ) ) ) ).

% tendsto_complex_iff
thf(fact_6916_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X6: D] : ( times_times @ A @ C2 @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_6917_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X6: D] : ( times_times @ A @ ( F3 @ X6 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_6918_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: D > A,F4: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ A
              @ ^ [X6: D] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_6919_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: A > A,A2: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( sin @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X6: A] : ( cot @ A @ ( F3 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( cot @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_cot
thf(fact_6920_continuous__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [F4: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X6: A] : ( uminus_uminus @ B @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_minus
thf(fact_6921_tendsto__minus__cancel__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1633459387980952147up_add @ B )
     => ! [F3: A > B,Y2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( uminus_uminus @ B @ Y2 ) ) @ F4 )
          = ( filterlim @ A @ B
            @ ^ [X6: A] : ( uminus_uminus @ B @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ Y2 )
            @ F4 ) ) ) ).

% tendsto_minus_cancel_left
thf(fact_6922_tendsto__minus__cancel,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X6: B] : ( uminus_uminus @ A @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( uminus_uminus @ A @ A2 ) )
            @ F4 )
         => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ).

% tendsto_minus_cancel
thf(fact_6923_tendsto__minus,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X6: B] : ( uminus_uminus @ A @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( uminus_uminus @ A @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_minus
thf(fact_6924_continuous__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [F4: filter @ A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X6: A] : ( minus_minus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_diff
thf(fact_6925_tendsto__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X6: B] : ( minus_minus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( minus_minus @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_diff
thf(fact_6926_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X6: A] : ( minus_minus @ B @ ( F3 @ X6 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 ) ) ) ).

% LIM_zero
thf(fact_6927_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X6: A] : ( minus_minus @ B @ ( F3 @ X6 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
          = ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_iff
thf(fact_6928_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: B > A,A2: A,F4: filter @ B,F3: B > A] :
          ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X6: B] : ( minus_minus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform
thf(fact_6929_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X6: B] : ( minus_minus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform2
thf(fact_6930_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X6: A] : ( minus_minus @ B @ ( F3 @ X6 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_cancel
thf(fact_6931_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: B > A,G: B > A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A
            @ ^ [X6: B] : ( minus_minus @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 )
         => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform_eq
thf(fact_6932_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I6: set @ B,F3: A > B > C,F4: filter @ A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ I6 )
             => ( filterlim @ A @ C
                @ ^ [X6: A] : ( F3 @ X6 @ I2 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I: A] : ( groups7311177749621191930dd_sum @ B @ C @ ( F3 @ I ) @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
            @ F4 ) ) ) ).

% tendsto_null_sum
thf(fact_6933_continuous__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( topolo5987344860129210374id_add @ C ) )
     => ! [I6: set @ A,F4: filter @ B,F3: A > B > C] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( topolo3448309680560233919inuous @ B @ C @ F4 @ ( F3 @ I2 ) ) )
         => ( topolo3448309680560233919inuous @ B @ C @ F4
            @ ^ [X6: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ I6 ) ) ) ) ).

% continuous_sum
thf(fact_6934_tendsto__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I6: set @ A,F3: A > B > C,A2: A > C,F4: filter @ B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( filterlim @ B @ C @ ( F3 @ I2 ) @ ( topolo7230453075368039082e_nhds @ C @ ( A2 @ I2 ) ) @ F4 ) )
         => ( filterlim @ B @ C
            @ ^ [X6: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( groups7311177749621191930dd_sum @ A @ C @ A2 @ I6 ) )
            @ F4 ) ) ) ).

% tendsto_sum
thf(fact_6935_filterlim__inf,axiom,
    ! [B: $tType,A: $tType,F3: A > B,F23: filter @ B,F33: filter @ B,F13: filter @ A] :
      ( ( filterlim @ A @ B @ F3 @ ( inf_inf @ ( filter @ B ) @ F23 @ F33 ) @ F13 )
      = ( ( filterlim @ A @ B @ F3 @ F23 @ F13 )
        & ( filterlim @ A @ B @ F3 @ F33 @ F13 ) ) ) ).

% filterlim_inf
thf(fact_6936_continuous__fst,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F4: filter @ A,F3: A > ( product_prod @ B @ C )] :
          ( ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X6: A] : ( product_fst @ B @ C @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_fst
thf(fact_6937_tendsto__fst,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > ( product_prod @ B @ C ),A2: product_prod @ B @ C,F4: filter @ A] :
          ( ( filterlim @ A @ ( product_prod @ B @ C ) @ F3 @ ( topolo7230453075368039082e_nhds @ ( product_prod @ B @ C ) @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X6: A] : ( product_fst @ B @ C @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( product_fst @ B @ C @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_fst
thf(fact_6938_continuous__snd,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F4: filter @ A,F3: A > ( product_prod @ B @ C )] :
          ( ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ C @ F4
            @ ^ [X6: A] : ( product_snd @ B @ C @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_snd
thf(fact_6939_tendsto__snd,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > ( product_prod @ B @ C ),A2: product_prod @ B @ C,F4: filter @ A] :
          ( ( filterlim @ A @ ( product_prod @ B @ C ) @ F3 @ ( topolo7230453075368039082e_nhds @ ( product_prod @ B @ C ) @ A2 ) @ F4 )
         => ( filterlim @ A @ C
            @ ^ [X6: A] : ( product_snd @ B @ C @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ C @ ( product_snd @ B @ C @ A2 ) )
            @ F4 ) ) ) ).

% tendsto_snd
thf(fact_6940_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R3: real,A2: A,F3: A > B,G: A > B,L: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
         => ( ! [X7: A] :
                ( ( X7 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X7 @ A2 ) ) @ R3 )
                 => ( ( F3 @ X7 )
                    = ( G @ X7 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_6941_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S4 )
                    & ! [X6: A] :
                        ( ( ( X6 != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X6 @ A2 ) ) @ S4 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F3 @ X6 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_6942_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F3: A > B,L5: B] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [S8: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S8 )
                  & ! [X7: A] :
                      ( ( ( X7 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X7 @ A2 ) ) @ S8 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F3 @ X7 ) @ L5 ) ) @ R2 ) ) ) )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_6943_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,L5: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
                & ! [X: A] :
                    ( ( ( X != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ A2 ) ) @ S2 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F3 @ X ) @ L5 ) ) @ R ) ) ) ) ) ) ).

% LIM_D
thf(fact_6944_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > A,A2: A,D4: A] :
          ( ( filterlim @ A @ A
            @ ^ [H2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ A2 @ H2 ) ) @ ( F3 @ A2 ) ) @ H2 )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ X6 ) @ ( F3 @ A2 ) ) @ ( minus_minus @ A @ X6 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_6945_LIM__fun__gt__zero,axiom,
    ! [F3: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R2 ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_6946_LIM__fun__not__zero,axiom,
    ! [F3: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L
         != ( zero_zero @ real ) )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R2 ) )
               => ( ( F3 @ X )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_6947_LIM__fun__less__zero,axiom,
    ! [F3: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R2 ) )
               => ( ord_less @ real @ ( F3 @ X ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_6948_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X7: A] :
                      ( ( ( X7 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X7 @ A2 ) ) @ D6 ) )
                     => ( ( F3 @ X7 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_6949_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S: set @ A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
                @ ^ [X6: A] : ( divide_divide @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_6950_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( times_times @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% isCont_mult
thf(fact_6951_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A2: A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% isCont_add
thf(fact_6952_isCont__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( minus_minus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% isCont_diff
thf(fact_6953_isCont__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] : ( uminus_uminus @ B @ ( F3 @ X6 ) ) ) ) ) ).

% isCont_minus
thf(fact_6954_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F3: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] : ( power_power @ B @ ( F3 @ X6 ) @ N ) ) ) ) ).

% isCont_power
thf(fact_6955_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S: set @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X6: A] : ( inverse_inverse @ B @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_at_within_inverse
thf(fact_6956_isCont__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( topolo5987344860129210374id_add @ C ) )
     => ! [A3: set @ A,A2: B,F3: A > B > C] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ A3 )
             => ( topolo3448309680560233919inuous @ B @ C @ ( topolo174197925503356063within @ B @ A2 @ ( top_top @ ( set @ B ) ) ) @ ( F3 @ X7 ) ) )
         => ( topolo3448309680560233919inuous @ B @ C @ ( topolo174197925503356063within @ B @ A2 @ ( top_top @ ( set @ B ) ) )
            @ ^ [X6: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ A3 ) ) ) ) ).

% isCont_sum
thf(fact_6957_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,S: set @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X6: A] : ( sgn_sgn @ B @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_at_within_sgn
thf(fact_6958_isCont__cos_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] : ( cos @ B @ ( F3 @ X6 ) ) ) ) ) ).

% isCont_cos'
thf(fact_6959_isCont__sin_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] : ( sin @ B @ ( F3 @ X6 ) ) ) ) ) ).

% isCont_sin'
thf(fact_6960_isCont__exp_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
            @ ^ [X6: C] : ( exp @ A @ ( F3 @ X6 ) ) ) ) ) ).

% isCont_exp'
thf(fact_6961_isCont__pochhammer,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Z: A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) )
          @ ^ [Z6: A] : ( comm_s3205402744901411588hammer @ A @ Z6 @ N ) ) ) ).

% isCont_pochhammer
thf(fact_6962_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ X2 @ H2 ) ) @ ( F3 @ X2 ) ) @ H2 )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_6963_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A] :
          ( ( has_field_derivative @ A @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ X2 @ H2 ) ) @ ( F3 @ X2 ) ) @ H2 )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_6964_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( one_one @ A ) ) @ Z6 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_6965_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F3: A > B,K5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H3: A] :
                ( ( H3
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H3 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ H3 ) ) @ ( times_times @ real @ K5 @ ( real_V7770717601297561774m_norm @ A @ H3 ) ) ) ) )
           => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_6966_isCont__inverse__function2,axiom,
    ! [A2: real,X2: real,B2: real,G: real > real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ( ! [Z2: real] :
              ( ( ord_less_eq @ real @ A2 @ Z2 )
             => ( ( ord_less_eq @ real @ Z2 @ B2 )
               => ( ( G @ ( F3 @ Z2 ) )
                  = Z2 ) ) )
         => ( ! [Z2: real] :
                ( ( ord_less_eq @ real @ A2 @ Z2 )
               => ( ( ord_less_eq @ real @ Z2 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) @ F3 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F3 @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_6967_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D4: A,X2: A] :
          ( ( has_derivative @ A @ A @ F3 @ ( times_times @ A @ D4 ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ X2 @ H2 ) ) @ ( F3 @ X2 ) ) @ H2 )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_6968_isCont__ln,axiom,
    ! [X2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( ln_ln @ real ) ) ) ).

% isCont_ln
thf(fact_6969_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X6: A] : ( divide_divide @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_6970_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( sgn_sgn @ B @ ( F3 @ X6 ) ) ) ) ) ) ).

% isCont_sgn
thf(fact_6971_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: A > B,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X6: A] : ( F3 @ ( plus_plus @ A @ X6 @ A2 ) )
            @ F4
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_6972_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,S: set @ A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S ) @ F3 )
         => ( ( ( cos @ A @ ( F3 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S )
              @ ^ [X6: A] : ( tan @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_within_tan
thf(fact_6973_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,S: set @ A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S ) @ F3 )
         => ( ( ( sin @ A @ ( F3 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S )
              @ ^ [X6: A] : ( cot @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_within_cot
thf(fact_6974_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: C,A3: set @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X2 @ A3 ) @ F3 )
         => ( ( ( cosh @ A @ ( F3 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X2 @ A3 )
              @ ^ [X6: C] : ( tanh @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_at_within_tanh
thf(fact_6975_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,L: A,X2: A] :
          ( ( has_field_derivative @ A @ F3 @ L @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G2: A > A] :
                ( ! [Z6: A] :
                    ( ( minus_minus @ A @ ( F3 @ Z6 ) @ ( F3 @ X2 ) )
                    = ( times_times @ A @ ( G2 @ Z6 ) @ ( minus_minus @ A @ Z6 @ X2 ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ G2 )
                & ( ( G2 @ X2 )
                  = L ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_6976_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F3: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X7: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X7 )
                  & ( ord_less_eq @ real @ X7 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
           => ? [M8: A] :
                ( ! [X: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X )
                      & ( ord_less_eq @ real @ X @ B2 ) )
                   => ( ord_less_eq @ A @ ( F3 @ X ) @ M8 ) )
                & ! [N7: A] :
                    ( ( ord_less @ A @ N7 @ M8 )
                   => ? [X7: real] :
                        ( ( ord_less_eq @ real @ A2 @ X7 )
                        & ( ord_less_eq @ real @ X7 @ B2 )
                        & ( ord_less @ A @ N7 @ ( F3 @ X7 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_6977_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( tan @ A ) ) ) ) ).

% isCont_tan
thf(fact_6978_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: A > B,D2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F3 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F3 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_6979_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: A > B,F4: filter @ B,A2: A,D2: A] :
          ( ( filterlim @ A @ B @ F3 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F3 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_6980_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( cot @ A ) ) ) ) ).

% isCont_cot
thf(fact_6981_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cosh @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( tanh @ A ) ) ) ) ).

% isCont_tanh
thf(fact_6982_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F3: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X7: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X7 ) @ S )
               => ( sums @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ X7 @ N2 ) )
                  @ ( F3 @ X7 ) ) )
           => ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_6983_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F3: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X7: A] :
                ( ( X7
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X7 ) @ S )
                 => ( sums @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ X7 @ N2 ) )
                    @ ( F3 @ X7 ) ) ) )
           => ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_6984_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F3: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F3 )
           => ( ! [H3: A,N3: nat] :
                  ( ( H3
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H3 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H3 @ N3 ) ) @ ( times_times @ real @ ( F3 @ N3 ) @ ( real_V7770717601297561774m_norm @ A @ H3 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H2: A] : ( suminf @ B @ ( G @ H2 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_6985_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( ( cos @ A @ ( F3 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( tan @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% isCont_tan'
thf(fact_6986_isCont__arcosh,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_6987_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X6: real] : ( divide_divide @ real @ ( cos @ real @ X6 ) @ ( sin @ real @ X6 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_6988_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( ( sin @ A @ ( F3 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( cot @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% isCont_cot'
thf(fact_6989_DERIV__inverse__function,axiom,
    ! [F3: real > real,D4: real,G: real > real,X2: real,A2: real,B2: real] :
      ( ( has_field_derivative @ real @ F3 @ D4 @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D4
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A2 @ X2 )
         => ( ( ord_less @ real @ X2 @ B2 )
           => ( ! [Y5: real] :
                  ( ( ord_less @ real @ A2 @ Y5 )
                 => ( ( ord_less @ real @ Y5 @ B2 )
                   => ( ( F3 @ ( G @ Y5 ) )
                      = Y5 ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ G )
               => ( has_field_derivative @ real @ G @ ( inverse_inverse @ real @ D4 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_6990_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ W3 @ I ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% isCont_polynom
thf(fact_6991_isCont__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_6992_isCont__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_6993_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [Y5: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y5 @ N2 ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X6 @ N2 ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_6994_LIM__less__bound,axiom,
    ! [B2: real,X2: real,F3: real > real] :
      ( ( ord_less @ real @ B2 @ X2 )
     => ( ! [X7: real] :
            ( ( member @ real @ X7 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X7 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F3 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X2 ) ) ) ) ) ).

% LIM_less_bound
thf(fact_6995_isCont__artanh,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_6996_isCont__inverse__function,axiom,
    ! [D2: real,X2: real,G: real > real,F3: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z2: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z2 @ X2 ) ) @ D2 )
           => ( ( G @ ( F3 @ Z2 ) )
              = Z2 ) )
       => ( ! [Z2: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z2 @ X2 ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F3 @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_6997_GMVT_H,axiom,
    ! [A2: real,B2: real,F3: real > real,G: real > real,G4: real > real,F9: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z2: real] :
            ( ( ord_less_eq @ real @ A2 @ Z2 )
           => ( ( ord_less_eq @ real @ Z2 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) @ F3 ) ) )
       => ( ! [Z2: real] :
              ( ( ord_less_eq @ real @ A2 @ Z2 )
             => ( ( ord_less_eq @ real @ Z2 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z2: real] :
                ( ( ord_less @ real @ A2 @ Z2 )
               => ( ( ord_less @ real @ Z2 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G4 @ Z2 ) @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z2: real] :
                  ( ( ord_less @ real @ A2 @ Z2 )
                 => ( ( ord_less @ real @ Z2 @ B2 )
                   => ( has_field_derivative @ real @ F3 @ ( F9 @ Z2 ) @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C3: real] :
                  ( ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) @ ( G4 @ C3 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ ( F9 @ C3 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_6998_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A ) )
     => ! [X2: real,F3: real > A] :
          ( ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F3 )
         => ( ~ ( member @ A @ ( F3 @ X2 ) @ ( ring_1_Ints @ A ) )
           => ( has_field_derivative @ real
              @ ^ [X6: real] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ A @ ( F3 @ X6 ) ) )
              @ ( zero_zero @ real )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% floor_has_real_derivative
thf(fact_6999_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X6 @ N2 ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_7000_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F3: A > Aa,C2: nat > Aa,K5: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( summable @ Aa
              @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ K5 @ N2 ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F3 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K5 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X6: A] :
                    ( suminf @ Aa
                    @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ ( F3 @ X6 ) @ N2 ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_7001_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N9: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_7002_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N9: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_7003_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( A2 @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_7004_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_7005_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( A2 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_7006_isCont__Im,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,G: C > complex] :
          ( ( topolo3448309680560233919inuous @ C @ complex @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
         => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
            @ ^ [X6: C] : ( im @ ( G @ X6 ) ) ) ) ) ).

% isCont_Im
thf(fact_7007_isCont__Re,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,G: C > complex] :
          ( ( topolo3448309680560233919inuous @ C @ complex @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
         => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
            @ ^ [X6: C] : ( re @ ( G @ X6 ) ) ) ) ) ).

% isCont_Re
thf(fact_7008_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ? [U3: nat > A] :
              ( ! [N9: nat] : ( ord_less @ A @ ( U3 @ N9 ) @ X2 )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_7009_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [U3: nat > A] :
              ( ! [N9: nat] : ( ord_less @ A @ X2 @ ( U3 @ N9 ) )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_7010_filterlim__Suc,axiom,
    filterlim @ nat @ nat @ suc @ ( at_top @ nat ) @ ( at_top @ nat ) ).

% filterlim_Suc
thf(fact_7011_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F3: nat > A,F4: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X6: nat] : ( F3 @ ( suc @ X6 ) )
        @ F4
        @ ( at_top @ nat ) )
      = ( filterlim @ nat @ A @ F3 @ F4 @ ( at_top @ nat ) ) ) ).

% filterlim_sequentially_Suc
thf(fact_7012_continuous__rabs,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X6: A] : ( abs_abs @ real @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_rabs
thf(fact_7013_continuous__cnj,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [F4: filter @ C,G: C > complex] :
          ( ( topolo3448309680560233919inuous @ C @ complex @ F4 @ G )
         => ( topolo3448309680560233919inuous @ C @ complex @ F4
            @ ^ [X6: C] : ( cnj @ ( G @ X6 ) ) ) ) ) ).

% continuous_cnj
thf(fact_7014_continuous__Re,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [F4: filter @ C,G: C > complex] :
          ( ( topolo3448309680560233919inuous @ C @ complex @ F4 @ G )
         => ( topolo3448309680560233919inuous @ C @ real @ F4
            @ ^ [X6: C] : ( re @ ( G @ X6 ) ) ) ) ) ).

% continuous_Re
thf(fact_7015_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,A2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_7016_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,K: nat,A2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_7017_LIMSEQ__const__iff,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [K: A,L: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : K
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) )
          = ( K = L ) ) ) ).

% LIMSEQ_const_iff
thf(fact_7018_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,L: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_imp_Suc
thf(fact_7019_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,L: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_Suc
thf(fact_7020_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X6: A] : ( sqrt @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_real_sqrt
thf(fact_7021_continuous__arctan,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X6: A] : ( arctan @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_arctan
thf(fact_7022_continuous__real__root,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X6: A] : ( root @ N @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_real_root
thf(fact_7023_continuous__Im,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [F4: filter @ C,G: C > complex] :
          ( ( topolo3448309680560233919inuous @ C @ complex @ F4 @ G )
         => ( topolo3448309680560233919inuous @ C @ real @ F4
            @ ^ [X6: C] : ( im @ ( G @ X6 ) ) ) ) ) ).

% continuous_Im
thf(fact_7024_continuous__complex__iff,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( ( topolo3448309680560233919inuous @ A @ complex )
        = ( ^ [F7: filter @ A,F5: A > complex] :
              ( ( topolo3448309680560233919inuous @ A @ real @ F7
                @ ^ [X6: A] : ( re @ ( F5 @ X6 ) ) )
              & ( topolo3448309680560233919inuous @ A @ real @ F7
                @ ^ [X6: A] : ( im @ ( F5 @ X6 ) ) ) ) ) ) ) ).

% continuous_complex_iff
thf(fact_7025_continuous__arsinh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X6: A] : ( arsinh @ real @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_arsinh
thf(fact_7026_seq__offset__neg,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,L: A,K: nat] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [I: nat] : ( F3 @ ( minus_minus @ nat @ I @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% seq_offset_neg
thf(fact_7027_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ_zero
thf(fact_7028_isCont__rabs,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X6: A] : ( abs_abs @ real @ ( F3 @ X6 ) ) ) ) ) ).

% isCont_rabs
thf(fact_7029_isCont__cnj,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,G: C > complex] :
          ( ( topolo3448309680560233919inuous @ C @ complex @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
         => ( topolo3448309680560233919inuous @ C @ complex @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
            @ ^ [X6: C] : ( cnj @ ( G @ X6 ) ) ) ) ) ).

% isCont_cnj
thf(fact_7030_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,S: set @ C,F3: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S ) @ G )
           => ( ( ( F3 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S )
                @ ^ [X6: C] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% continuous_at_within_powr
thf(fact_7031_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X2: A,S: set @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ S ) @ F3 )
         => ( ( ( F3 @ X2 )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ S )
              @ ^ [X6: A] : ( ln_ln @ real @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_within_ln
thf(fact_7032_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X6: nat] : ( times_times @ nat @ X6 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_7033_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_7034_LIMSEQ__lessThan__iff__atMost,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: ( set @ nat ) > A,X2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( set_ord_lessThan @ nat @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ X2 )
            @ ( at_top @ nat ) )
          = ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( set_ord_atMost @ nat @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ X2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_lessThan_iff_atMost
thf(fact_7035_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( root @ N2 @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_7036_isCont__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,F3: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( ( ( F3 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
                @ ^ [X6: C] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% isCont_powr
thf(fact_7037_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X2: A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( ( F3 @ X2 )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( ln_ln @ real @ ( F3 @ X6 ) ) ) ) ) ) ).

% isCont_ln'
thf(fact_7038_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N2: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_7039_LIMSEQ__SEQ__conv,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,X15: A > B,L5: B] :
          ( ( ! [S6: nat > A] :
                ( ( ! [N2: nat] :
                      ( ( S6 @ N2 )
                     != A2 )
                  & ( filterlim @ nat @ A @ S6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) )
               => ( filterlim @ nat @ B
                  @ ^ [N2: nat] : ( X15 @ ( S6 @ N2 ) )
                  @ ( topolo7230453075368039082e_nhds @ B @ L5 )
                  @ ( at_top @ nat ) ) ) )
          = ( filterlim @ A @ B @ X15 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIMSEQ_SEQ_conv
thf(fact_7040_LIMSEQ__SEQ__conv1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,L: B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ! [S9: nat > A] :
              ( ( ! [N3: nat] :
                    ( ( S9 @ N3 )
                   != A2 )
                & ( filterlim @ nat @ A @ S9 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) )
             => ( filterlim @ nat @ B
                @ ^ [N2: nat] : ( F3 @ ( S9 @ N2 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ L )
                @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_SEQ_conv1
thf(fact_7041_LIMSEQ__SEQ__conv2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,F3: A > B,L: B] :
          ( ! [S10: nat > A] :
              ( ( ! [N9: nat] :
                    ( ( S10 @ N9 )
                   != A2 )
                & ( filterlim @ nat @ A @ S10 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) )
             => ( filterlim @ nat @ B
                @ ^ [N2: nat] : ( F3 @ ( S10 @ N2 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ L )
                @ ( at_top @ nat ) ) )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIMSEQ_SEQ_conv2
thf(fact_7042_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_inverse_n
thf(fact_7043_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X15: nat > A,X2: A,L: nat] :
          ( ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L )
           => ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( X15 @ ( times_times @ nat @ N2 @ L ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X2 )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_7044_telescope__summable,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ N2 ) ) @ ( F3 @ N2 ) ) ) ) ) ).

% telescope_summable
thf(fact_7045_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) ) ) ) ) ).

% telescope_summable'
thf(fact_7046_nested__sequence__unique,axiom,
    ! [F3: nat > real,G: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N3 ) ) @ ( G @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F3 @ N3 ) @ ( G @ N3 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N2: nat] : ( minus_minus @ real @ ( F3 @ N2 ) @ ( G @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L2: real] :
                ( ! [N9: nat] : ( ord_less_eq @ real @ ( F3 @ N9 ) @ L2 )
                & ( filterlim @ nat @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) )
                & ! [N9: nat] : ( ord_less_eq @ real @ L2 @ ( G @ N9 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_7047_LIMSEQ__inverse__zero,axiom,
    ! [X15: nat > real] :
      ( ! [R2: real] :
        ? [N7: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N7 @ N3 )
         => ( ord_less @ real @ R2 @ ( X15 @ N3 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( X15 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_7048_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_7049_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( root @ N2 @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_7050_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_7051_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( plus_plus @ real @ R @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_7052_sums__def,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F5: nat > A,S4: A] :
              ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S4 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def
thf(fact_7053_sums__def__le,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F5: nat > A,S4: A] :
              ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S4 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def_le
thf(fact_7054_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S: set @ A,F3: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ A2 ) )
             => ( ( ( F3 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S )
                    @ ^ [X6: A] : ( log @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_7055_increasing__LIMSEQ,axiom,
    ! [F3: nat > real,L: real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F3 @ N3 ) @ L )
       => ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [N9: nat] : ( ord_less_eq @ real @ L @ ( plus_plus @ real @ ( F3 @ N9 ) @ E ) ) )
         => ( filterlim @ nat @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_7056_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_7057_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_7058_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_7059_LIMSEQ__realpow__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_7060_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) )
            @ ( minus_minus @ A @ ( F3 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_7061_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ N2 ) ) @ ( F3 @ N2 ) )
            @ ( minus_minus @ A @ C2 @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_7062_LIMSEQ__divide__realpow__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X2 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_7063_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_7064_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_7065_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X2 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_7066_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F5: nat > A,S4: A] :
              ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S4 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def'
thf(fact_7067_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,X2: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N2: nat] : ( root @ N2 @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X2 )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% root_test_convergence
thf(fact_7068_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( plus_plus @ real @ R @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_7069_summable__LIMSEQ,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( suminf @ A @ F3 ) )
            @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ
thf(fact_7070_summable__LIMSEQ_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_atMost @ nat @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( suminf @ A @ F3 ) )
            @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ'
thf(fact_7071_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F3: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ A2 ) )
             => ( ( ( F3 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X6: A] : ( log @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_7072_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A,L5: A,R: real] :
          ( ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No3: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N9 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X15 @ N9 ) @ L5 ) ) @ R ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_7073_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A,L5: A] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [No4: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No4 @ N3 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X15 @ N3 ) @ L5 ) ) @ R2 ) ) )
         => ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_7074_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No2: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No2 @ N2 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X15 @ N2 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_7075_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X2 ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_7076_tendsto__exp__limit__sequentially,axiom,
    ! [X2: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_7077_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F3: B > nat,F4: filter @ B,X2: A] :
          ( ( filterlim @ B @ nat @ F3 @ ( at_top @ nat ) @ F4 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y: B] : ( power_power @ A @ X2 @ ( F3 @ Y ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_power_zero
thf(fact_7078_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( times_times @ real @ R @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_7079_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
         => ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_7080_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A2 @ N2 ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_7081_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Df: A,Z: A,S: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F3 @ Df @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N3: nat] :
                  ( ( S @ N3 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N2: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ Z @ ( S @ N2 ) ) ) @ ( F3 @ Z ) ) @ ( S @ N2 ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_7082_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X2 @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_7083_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X2 @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_7084_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A2 @ N2 ) ) ) ) ) ) ).

% summable
thf(fact_7085_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J4: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J4 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K3: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J4: nat] : ( minus_minus @ real @ ( Theta @ J4 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K3 @ J4 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_7086_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J4: nat] : ( cos @ real @ ( Theta @ J4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K3: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J4: nat] : ( minus_minus @ real @ ( Theta @ J4 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K3 @ J4 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_7087_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_7088_zeroseq__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_7089_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( suminf @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_7090_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_7091_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L2: real] :
              ( ! [N9: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) )
                  @ L2 )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L2 )
                @ ( at_top @ nat ) )
              & ! [N9: nat] :
                  ( ord_less_eq @ real @ L2
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L2 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_7092_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_7093_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_7094_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_7095_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) ) @ ( minus_minus @ B @ ( F3 @ Y ) @ ( plus_plus @ B @ ( F3 @ X2 ) @ ( F9 @ ( minus_minus @ A @ Y @ X2 ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_7096_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,D4: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F3 @ D4 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D4 )
            & ( filterlim @ A @ real
              @ ^ [H2: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ ( plus_plus @ A @ X2 @ H2 ) ) @ ( F3 @ X2 ) ) @ ( D4 @ H2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_7097_bounded__linear_Ohas__derivative,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: C > A,G4: C > A,F4: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( has_derivative @ C @ A @ G @ G4 @ F4 )
           => ( has_derivative @ C @ B
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) )
              @ ^ [X6: C] : ( F3 @ ( G4 @ X6 ) )
              @ F4 ) ) ) ) ).

% bounded_linear.has_derivative
thf(fact_7098_bounded__linear_Otendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > B,G: C > A,A2: A,F4: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ A2 ) )
              @ F4 ) ) ) ) ).

% bounded_linear.tendsto
thf(fact_7099_bounded__linear_Ocontinuous,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > B,F4: filter @ C,G: C > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) ) ) ) ) ) ).

% bounded_linear.continuous
thf(fact_7100_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Y2: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X6: A] : ( divide_divide @ A @ X6 @ Y2 ) ) ) ).

% bounded_linear_divide
thf(fact_7101_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X2 ) ) ) ).

% bounded_linear_mult_right
thf(fact_7102_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,Y2: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X6: C] : ( times_times @ A @ ( G @ X6 ) @ Y2 ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_7103_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,X2: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X6: C] : ( times_times @ A @ X2 @ ( G @ X6 ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_7104_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y2: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X6: A] : ( times_times @ A @ X6 @ Y2 ) ) ) ).

% bounded_linear_mult_left
thf(fact_7105_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X6: A] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_7106_bounded__linear_Osummable,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > B,X15: nat > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( summable @ A @ X15 )
           => ( summable @ B
              @ ^ [N2: nat] : ( F3 @ ( X15 @ N2 ) ) ) ) ) ) ).

% bounded_linear.summable
thf(fact_7107_bounded__linear__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real] : ( real_V3181309239436604168linear @ A @ A @ ( real_V8093663219630862766scaleR @ A @ R ) ) ) ).

% bounded_linear_scaleR_right
thf(fact_7108_bounded__linear__const__scaleR,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [G: C > B,R: real] :
          ( ( real_V3181309239436604168linear @ C @ B @ G )
         => ( real_V3181309239436604168linear @ C @ B
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ B @ R @ ( G @ X6 ) ) ) ) ) ).

% bounded_linear_const_scaleR
thf(fact_7109_bounded__linear__scaleR__const,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [G: C > real,X2: B] :
          ( ( real_V3181309239436604168linear @ C @ real @ G )
         => ( real_V3181309239436604168linear @ C @ B
            @ ^ [X6: C] : ( real_V8093663219630862766scaleR @ B @ ( G @ X6 ) @ X2 ) ) ) ) ).

% bounded_linear_scaleR_const
thf(fact_7110_bounded__linear__ident,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( real_V3181309239436604168linear @ A @ A
        @ ^ [X6: A] : X6 ) ) ).

% bounded_linear_ident
thf(fact_7111_bounded__linear__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > B,G: C > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( real_V3181309239436604168linear @ C @ A @ G )
           => ( real_V3181309239436604168linear @ C @ B
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) ) ) ) ) ) ).

% bounded_linear_compose
thf(fact_7112_bounded__linear__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( real_V3181309239436604168linear @ real @ A
          @ ^ [R5: real] : ( real_V8093663219630862766scaleR @ A @ R5 @ X2 ) ) ) ).

% bounded_linear_scaleR_left
thf(fact_7113_bounded__linear__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ( real_V3181309239436604168linear @ real @ A @ ( real_Vector_of_real @ A ) ) ) ).

% bounded_linear_of_real
thf(fact_7114_bounded__linear_Osums,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,X15: nat > A,A2: A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( sums @ A @ X15 @ A2 )
           => ( sums @ B
              @ ^ [N2: nat] : ( F3 @ ( X15 @ N2 ) )
              @ ( F3 @ A2 ) ) ) ) ) ).

% bounded_linear.sums
thf(fact_7115_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( real_V3181309239436604168linear @ A @ B
        @ ^ [X6: A] : ( zero_zero @ B ) ) ) ).

% bounded_linear_zero
thf(fact_7116_bounded__linear_OCauchy,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > B,X15: nat > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( topolo3814608138187158403Cauchy @ A @ X15 )
           => ( topolo3814608138187158403Cauchy @ B
              @ ^ [N2: nat] : ( F3 @ ( X15 @ N2 ) ) ) ) ) ) ).

% bounded_linear.Cauchy
thf(fact_7117_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F5: real > real] :
        ? [C4: real] :
          ( F5
          = ( ^ [X6: real] : ( times_times @ real @ X6 @ C4 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_7118_bounded__linear__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( real_V3181309239436604168linear @ A @ B
            @ ^ [X6: A] : ( uminus_uminus @ B @ ( F3 @ X6 ) ) ) ) ) ).

% bounded_linear_minus
thf(fact_7119_bounded__linear__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X6: A] : ( minus_minus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% bounded_linear_sub
thf(fact_7120_bounded__linear_Osuminf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > B,X15: nat > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( summable @ A @ X15 )
           => ( ( F3 @ ( suminf @ A @ X15 ) )
              = ( suminf @ B
                @ ^ [N2: nat] : ( F3 @ ( X15 @ N2 ) ) ) ) ) ) ) ).

% bounded_linear.suminf
thf(fact_7121_bounded__linear__sum,axiom,
    ! [I5: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [I6: set @ I5,F3: I5 > A > B] :
          ( ! [I2: I5] :
              ( ( member @ I5 @ I2 @ I6 )
             => ( real_V3181309239436604168linear @ A @ B @ ( F3 @ I2 ) ) )
         => ( real_V3181309239436604168linear @ A @ B
            @ ^ [X6: A] :
                ( groups7311177749621191930dd_sum @ I5 @ B
                @ ^ [I: I5] : ( F3 @ I @ X6 )
                @ I6 ) ) ) ) ).

% bounded_linear_sum
thf(fact_7122_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ? [K10: real] :
            ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K10 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_7123_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: C > A,F4: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% bounded_linear.tendsto_zero
thf(fact_7124_bounded__linear_OisCont,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > B,A2: C,G: C > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) ) ) ) ) ) ).

% bounded_linear.isCont
thf(fact_7125_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ? [K10: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K10 )
              & ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K10 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_7126_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K10 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_7127_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,K5: real] :
          ( ! [X7: A,Y5: A] :
              ( ( F3 @ ( plus_plus @ A @ X7 @ Y5 ) )
              = ( plus_plus @ B @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) )
         => ( ! [R2: real,X7: A] :
                ( ( F3 @ ( real_V8093663219630862766scaleR @ A @ R2 @ X7 ) )
                = ( real_V8093663219630862766scaleR @ B @ R2 @ ( F3 @ X7 ) ) )
           => ( ! [X7: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X7 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X7 ) @ K5 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F3 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_7128_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ( filterlim @ A @ real
              @ ^ [Y: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ Y ) @ ( F3 @ X2 ) ) @ ( F9 @ ( minus_minus @ A @ Y @ X2 ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_7129_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F9: A > B,X2: A,F3: A > B,S: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F9 )
         => ( ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ Y ) @ ( F3 @ X2 ) ) @ ( F9 @ ( minus_minus @ A @ Y @ X2 ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivativeI
thf(fact_7130_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ Y ) @ ( F3 @ X2 ) ) @ ( F9 @ ( minus_minus @ A @ Y @ X2 ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_7131_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ? [E3: A > B] :
                ( ! [H2: A] :
                    ( ( F3 @ ( plus_plus @ A @ X2 @ H2 ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F3 @ X2 ) @ ( F9 @ H2 ) ) @ ( E3 @ H2 ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H2: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H2 ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_7132_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X2: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) ) @ ( minus_minus @ B @ ( F3 @ Y ) @ ( plus_plus @ B @ ( F3 @ X2 ) @ ( F9 @ ( minus_minus @ A @ Y @ X2 ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% has_derivative_within
thf(fact_7133_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F5: A > B,F10: A > B,F7: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F10 )
              & ( filterlim @ A @ B
                @ ^ [Y: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F7
                            @ ^ [X6: A] : X6 ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F5 @ Y )
                        @ ( F5
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F7
                            @ ^ [X6: A] : X6 ) ) )
                      @ ( F10
                        @ ( minus_minus @ A @ Y
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F7
                            @ ^ [X6: A] : X6 ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F7 ) ) ) ) ) ).

% has_derivative_def
thf(fact_7134_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X2: A,S3: set @ A,F3: A > B,F9: A > B] :
          ( ( member @ A @ X2 @ S3 )
         => ( ( topolo1002775350975398744n_open @ A @ S3 )
           => ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
                & ? [E3: A > B] :
                    ( ! [H2: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X2 @ H2 ) @ S3 )
                       => ( ( F3 @ ( plus_plus @ A @ X2 @ H2 ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F3 @ X2 ) @ ( F9 @ H2 ) ) @ ( E3 @ H2 ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H2: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H2 ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_7135_lim__const,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A] :
          ( ( topolo3827282254853284352ce_Lim @ nat @ A @ ( at_top @ nat )
            @ ^ [M4: nat] : A2 )
          = A2 ) ) ).

% lim_const
thf(fact_7136_open__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A3: set @ B,B5: B > ( set @ A )] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( topolo1002775350975398744n_open @ A @ ( B5 @ X7 ) ) )
         => ( topolo1002775350975398744n_open @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) ) ) ) ).

% open_UN
thf(fact_7137_open__INT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A3: set @ B,B5: B > ( set @ A )] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ A3 )
               => ( topolo1002775350975398744n_open @ A @ ( B5 @ X7 ) ) )
           => ( topolo1002775350975398744n_open @ A @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) ) ) ) ) ).

% open_INT
thf(fact_7138_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A,X2: A,Y2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S3 )
         => ( ( member @ A @ X2 @ S3 )
           => ( ( ord_less @ A @ X2 @ Y2 )
             => ? [B3: A] :
                  ( ( ord_less @ A @ X2 @ B3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X2 @ B3 ) @ S3 ) ) ) ) ) ) ).

% open_right
thf(fact_7139_open__Collect__const,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: $o] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [X6: A] : P3 ) ) ) ).

% open_Collect_const
thf(fact_7140_open__Collect__disj,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o,Q: A > $o] :
          ( ( topolo1002775350975398744n_open @ A @ ( collect @ A @ P3 ) )
         => ( ( topolo1002775350975398744n_open @ A @ ( collect @ A @ Q ) )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ( ( P3 @ X6 )
                    | ( Q @ X6 ) ) ) ) ) ) ) ).

% open_Collect_disj
thf(fact_7141_open__Collect__conj,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o,Q: A > $o] :
          ( ( topolo1002775350975398744n_open @ A @ ( collect @ A @ P3 ) )
         => ( ( topolo1002775350975398744n_open @ A @ ( collect @ A @ Q ) )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ( ( P3 @ X6 )
                    & ( Q @ X6 ) ) ) ) ) ) ) ).

% open_Collect_conj
thf(fact_7142_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ A3 )
               => ( ord_less @ A @ X2 @ X7 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A3 ) @ A3 ) ) ) ) ).

% Inf_notin_open
thf(fact_7143_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ A3 )
               => ( ord_less @ A @ X7 @ X2 ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A3 ) @ A3 ) ) ) ) ).

% Sup_notin_open
thf(fact_7144_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A,X2: A,Y2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S3 )
         => ( ( member @ A @ X2 @ S3 )
           => ( ( ord_less @ A @ Y2 @ X2 )
             => ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ X2 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B3 @ X2 ) @ S3 ) ) ) ) ) ) ).

% open_left
thf(fact_7145_Lim__ident__at,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X2: A,S: set @ A] :
          ( ( ( topolo174197925503356063within @ A @ X2 @ S )
           != ( bot_bot @ ( filter @ A ) ) )
         => ( ( topolo3827282254853284352ce_Lim @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S )
              @ ^ [X6: A] : X6 )
            = X2 ) ) ) ).

% Lim_ident_at
thf(fact_7146_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X6: A] : X6 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F4
                @ ^ [X6: A] : ( divide_divide @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_7147_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( ( ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X6: A] : X6 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X6: A] : ( inverse_inverse @ B @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_inverse
thf(fact_7148_continuous__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ( ( topolo3448309680560233919inuous @ A @ B )
        = ( ^ [F7: filter @ A,F5: A > B] :
              ( filterlim @ A @ B @ F5
              @ ( topolo7230453075368039082e_nhds @ B
                @ ( F5
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F7
                    @ ^ [X6: A] : X6 ) ) )
              @ F7 ) ) ) ) ).

% continuous_def
thf(fact_7149_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( ( ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X6: A] : X6 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X6: A] : ( sgn_sgn @ B @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_sgn
thf(fact_7150_t2__space__class_OLim__def,axiom,
    ! [A: $tType,F: $tType] :
      ( ( topological_t2_space @ A )
     => ( ( topolo3827282254853284352ce_Lim @ F @ A )
        = ( ^ [A7: filter @ F,F5: F > A] :
              ( the @ A
              @ ^ [L3: A] : ( filterlim @ F @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ L3 ) @ A7 ) ) ) ) ) ).

% t2_space_class.Lim_def
thf(fact_7151_continuous__powr,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ( F3
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X6: A] : X6 ) )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ A @ real @ F4
                @ ^ [X6: A] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% continuous_powr
thf(fact_7152_continuous__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( ( ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X6: A] : X6 ) )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X6: A] : ( ln_ln @ real @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_ln
thf(fact_7153_suminf__eq__lim,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F5: nat > A] :
              ( topolo3827282254853284352ce_Lim @ nat @ A @ ( at_top @ nat )
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% suminf_eq_lim
thf(fact_7154_lim__def,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X15: nat > A] :
          ( ( topolo3827282254853284352ce_Lim @ nat @ A @ ( at_top @ nat ) @ X15 )
          = ( the @ A
            @ ^ [L6: A] : ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) ) ) ) ) ).

% lim_def
thf(fact_7155_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F3 )
         => ( ( ( cos @ A
                @ ( F3
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X6: A] : X6 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X6: A] : ( tan @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_tan
thf(fact_7156_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F3 )
         => ( ( ( sin @ A
                @ ( F3
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X6: A] : X6 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X6: A] : ( cot @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_cot
thf(fact_7157_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ F3 )
         => ( ( ( cosh @ A
                @ ( F3
                  @ ( topolo3827282254853284352ce_Lim @ C @ C @ F4
                    @ ^ [X6: C] : X6 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ F4
              @ ^ [X6: C] : ( tanh @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_tanh
thf(fact_7158_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X6: A] : X6 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X6: A] : ( arcosh @ real @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_7159_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S3: set @ A,F3: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S3 )
           => ( ( topolo1002775350975398744n_open @ A @ S3 )
             => ( ( filterlim @ A @ D @ F3 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
                = ( filterlim @ A @ D
                  @ ^ [H2: A] : ( F3 @ ( plus_plus @ A @ A2 @ H2 ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L5 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_7160_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F3
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X6: A] : X6 ) ) )
             => ( ( ( F3
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                      @ ^ [X6: A] : X6 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                        @ ^ [X6: A] : X6 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F4
                    @ ^ [X6: A] : ( log @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_7161_continuous__artanh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( ( member @ real
              @ ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X6: A] : X6 ) )
              @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X6: A] : ( artanh @ real @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_artanh
thf(fact_7162_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E2: real,F9: A > B,S: set @ A,X2: A,F3: A > B,H6: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ F9 )
           => ( ! [Y5: A] :
                  ( ( member @ A @ Y5 @ S )
                 => ( ( Y5 != X2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X2 ) @ E2 )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ Y5 ) @ ( F3 @ X2 ) ) @ ( F9 @ ( minus_minus @ A @ Y5 @ X2 ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X2 ) ) ) @ ( H6 @ Y5 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H6 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X2 @ S ) )
               => ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_7163_tendsto__exp__limit__at__right,axiom,
    ! [X2: real] :
      ( filterlim @ real @ real
      @ ^ [Y: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X2 @ Y ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_7164_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,K: A] :
          ( ( member @ A @ I3 @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I3 ) ) ) ).

% greaterThan_iff
thf(fact_7165_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_7166_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A2 ) @ ( plus_plus @ A @ C2 @ A2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_7167_dist__self,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A] :
          ( ( real_V557655796197034286t_dist @ A @ X2 @ X2 )
          = ( zero_zero @ real ) ) ) ).

% dist_self
thf(fact_7168_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( real_V557655796197034286t_dist @ A @ X2 @ Y2 )
            = ( zero_zero @ real ) )
          = ( X2 = Y2 ) ) ) ).

% dist_eq_0_iff
thf(fact_7169_dist__0__norm,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( zero_zero @ A ) @ X2 )
          = ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ).

% dist_0_norm
thf(fact_7170_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) )
          = ( ( X2 != Y2 ) ) ) ) ).

% zero_less_dist_iff
thf(fact_7171_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( zero_zero @ real ) )
          = ( X2 = Y2 ) ) ) ).

% dist_le_zero_iff
thf(fact_7172_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X2 ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_7173_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: real,A2: A,Y2: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ A2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y2 ) ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% dist_scaleR
thf(fact_7174_open__ball,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,D2: real] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y ) @ D2 ) ) ) ) ).

% open_ball
thf(fact_7175_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S6: set @ A] :
            ! [X6: A] :
              ( ( member @ A @ X6 @ S6 )
             => ? [E3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                  & ! [Y: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X6 ) @ E3 )
                     => ( member @ A @ Y @ S6 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_7176_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y2: A,X2: A,E2: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X2 ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ E2 ) ) ) ).

% dist_commute_lessI
thf(fact_7177_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L3: A] : ( collect @ A @ ( ord_less @ A @ L3 ) ) ) ) ) ).

% greaterThan_def
thf(fact_7178_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_7179_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) ) ) ) ).

% dist_pos_lt
thf(fact_7180_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X17: A,Y2: A,E1: real,X23: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ Y2 ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X23 @ Y2 ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X23 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_7181_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Z: A,Y2: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ E2 ) ) ) ).

% dist_triangle_lt
thf(fact_7182_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A )
        = ( ^ [X6: A] : ( real_V557655796197034286t_dist @ A @ X6 @ ( zero_zero @ A ) ) ) ) ) ).

% norm_conv_dist
thf(fact_7183_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) ) ) ).

% zero_le_dist
thf(fact_7184_continuous__dist,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F4: filter @ D,F3: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ real @ F4
              @ ^ [X6: D] : ( real_V557655796197034286t_dist @ A @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_dist
thf(fact_7185_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_7186_filterlim__at__left__to__right,axiom,
    ! [A: $tType,F3: real > A,F4: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F3 @ F4 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X6: real] : ( F3 @ ( uminus_uminus @ real @ X6 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ A2 ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ A2 ) ) ) ) ) ).

% filterlim_at_left_to_right
thf(fact_7187_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,F9: A,A2: A,S3: set @ A,D2: real,G: A > A] :
          ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ A2 @ S3 )
             => ( ! [X7: A] :
                    ( ( member @ A @ X7 @ S3 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X7 @ A2 ) @ D2 )
                     => ( ( F3 @ X7 )
                        = ( G @ X7 ) ) ) )
               => ( has_field_derivative @ A @ G @ F9 @ ( topolo174197925503356063within @ A @ A2 @ S3 ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_7188_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X2: A,S: set @ A,D2: real,G: A > B] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ X2 @ S )
             => ( ! [X19: A] :
                    ( ( member @ A @ X19 @ S )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X19 @ X2 ) @ D2 )
                     => ( ( F3 @ X19 )
                        = ( G @ X19 ) ) ) )
               => ( has_derivative @ A @ B @ G @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_7189_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_7190_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S4: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S4 @ N2 ) @ ( S4 @ N6 ) ) @ E3 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_7191_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X15 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M8: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M2 )
               => ! [N9: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N9 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X15 @ M2 ) @ ( X15 @ N9 ) ) @ E2 ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_7192_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M5: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M5 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X15 @ M5 ) @ ( X15 @ N3 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X15 ) ) ) ).

% metric_CauchyI
thf(fact_7193_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [A4: A,B3: A] :
              ( ( member @ A @ X2 @ ( set_ord_lessThan @ A @ A4 ) )
              & ( member @ A @ Y2 @ ( set_ord_greaterThan @ A @ B3 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A4 ) @ ( set_ord_greaterThan @ A @ B3 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_7194_tendsto__dist,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F3: B > A,L: A,F4: filter @ B,G: B > A,M: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ M ) @ F4 )
           => ( filterlim @ B @ real
              @ ^ [X6: B] : ( real_V557655796197034286t_dist @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( real_V557655796197034286t_dist @ A @ L @ M ) )
              @ F4 ) ) ) ) ).

% tendsto_dist
thf(fact_7195_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F3: real > A,F4: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F3 @ F4 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X6: real] : ( F3 @ ( plus_plus @ real @ X6 @ A2 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_7196_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,L: B,X2: A,S3: set @ A,D2: real,G: A > B] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ! [X19: A] :
                  ( ( member @ A @ X19 @ S3 )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X19 @ X2 ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X19 @ X2 ) @ D2 )
                     => ( ( F3 @ X19 )
                        = ( G @ X19 ) ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_7197_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X17: A,Y2: A,E2: real,X23: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ Y2 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X23 @ Y2 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X23 ) @ E2 ) ) ) ) ).

% dist_triangle_half_l
thf(fact_7198_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y2: A,X17: A,E2: real,X23: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X17 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X23 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X23 ) @ E2 ) ) ) ) ).

% dist_triangle_half_r
thf(fact_7199_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X17: A,X23: A,E2: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X23 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X23 @ X32 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X42 ) @ E2 ) ) ) ) ) ).

% dist_triangle_third
thf(fact_7200_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G5: filter @ B,X2: A,S3: set @ A,F4: filter @ B,D2: real,F3: A > B] :
          ( ( filterlim @ A @ B @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G5 @ F4 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X19: A] :
                    ( ( member @ A @ X19 @ S3 )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X19 @ X2 ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X19 @ X2 ) @ D2 )
                       => ( ( F3 @ X19 )
                          = ( G @ X19 ) ) ) ) )
               => ( filterlim @ A @ B @ F3 @ F4 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_7201_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F5: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less @ nat @ M4 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F5 @ M4 ) @ ( F5 @ N2 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_7202_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M5: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M5 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M5 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X15 @ M5 ) @ ( X15 @ N3 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X15 ) ) ) ).

% CauchyI'
thf(fact_7203_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
          = ( filterlim @ A @ real
            @ ^ [X6: A] : ( real_V557655796197034286t_dist @ B @ ( F3 @ X6 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_dist_iff
thf(fact_7204_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: B > A,P5: A,F13: filter @ B,C2: A,L: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo174197925503356063within @ A @ P5 @ ( set_ord_greaterThan @ A @ P5 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L
                = ( times_times @ A @ C2 @ P5 ) )
             => ( filterlim @ B @ A
                @ ^ [X6: B] : ( times_times @ A @ C2 @ ( F3 @ X6 ) )
                @ ( topolo174197925503356063within @ A @ L @ ( set_ord_greaterThan @ A @ L ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_7205_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F3: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S4 )
                    & ! [X6: A] :
                        ( ( ( X6 != A2 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ A2 ) @ S4 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X6 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_7206_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F3: A > B,L5: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
                & ! [X: A] :
                    ( ( ( X != A2 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ A2 ) @ S2 ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X ) @ L5 ) @ R ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_7207_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A2: A,F3: A > B,L5: B] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [S8: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S8 )
                  & ! [X7: A] :
                      ( ( ( X7 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X7 @ A2 ) @ S8 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X7 ) @ L5 ) @ R2 ) ) ) )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_7208_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,L: B,A2: A,R3: real,F3: A > B] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ( ! [X7: A] :
                  ( ( X7 != A2 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X7 @ A2 ) @ R3 )
                   => ( ( F3 @ X7 )
                      = ( G @ X7 ) ) ) )
             => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_7209_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No2: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No2 @ N2 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X15 @ N2 ) @ L5 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_7210_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A,L5: A] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [No4: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No4 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X15 @ N3 ) @ L5 ) @ R2 ) ) )
         => ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_7211_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A,L5: A,R: real] :
          ( ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No3: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N9 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X15 @ N9 ) @ L5 ) @ R ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_7212_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [J4: nat] :
            ? [M9: nat] :
            ! [M4: nat] :
              ( ( ord_less_eq @ nat @ M9 @ M4 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J4 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_7213_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X7: A] :
                      ( ( ( X7 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X7 @ A2 ) @ D6 ) )
                     => ( ( F3 @ X7 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_7214_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_7215_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A2: A,F3: A > C,G: C > D,L: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( filterlim @ C @ D @ G @ ( topolo7230453075368039082e_nhds @ D @ L ) @ ( topolo174197925503356063within @ C @ ( F3 @ A2 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X7: A] :
                      ( ( ( X7 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X7 @ A2 ) @ D6 ) )
                     => ( ( F3 @ X7 )
                       != ( F3 @ A2 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_7216_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G: A > B,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G )
         => ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X6: A] : ( if @ B @ ( ord_less_eq @ A @ X6 @ A2 ) @ ( G @ X6 ) @ ( F3 @ X6 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_7217_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No2: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No2 )
                    & ! [N2: nat] :
                        ( ( ord_less_eq @ nat @ No2 @ N2 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X15 @ N2 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_7218_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S6: set @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [K2: set @ A] :
                  ( ( finite_finite2 @ A @ K2 )
                  & ( ord_less_eq @ ( set @ A ) @ S6
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X6: A] :
                            ( collect @ A
                            @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ Y ) @ E3 ) )
                        @ K2 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_7219_at__within__order,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X2: A,S: set @ A] :
          ( ( ( top_top @ ( set @ A ) )
           != ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ( topolo174197925503356063within @ A @ X2 @ S )
            = ( inf_inf @ ( filter @ A )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A5: A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A5 ) @ S ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  @ ( set_ord_greaterThan @ A @ X2 ) ) )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A5: A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A5 ) @ S ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  @ ( set_ord_lessThan @ A @ X2 ) ) ) ) ) ) ) ).

% at_within_order
thf(fact_7220_SUP__principal,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I6: set @ B] :
      ( ( complete_Sup_Sup @ ( filter @ A )
        @ ( image @ B @ ( filter @ A )
          @ ^ [I: B] : ( principal @ A @ ( A3 @ I ) )
          @ I6 ) )
      = ( principal @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) ) ) ).

% SUP_principal
thf(fact_7221_filterlim__If,axiom,
    ! [B: $tType,A: $tType,F3: A > B,G5: filter @ B,F4: filter @ A,P3: A > $o,G: A > B] :
      ( ( filterlim @ A @ B @ F3 @ G5 @ ( inf_inf @ ( filter @ A ) @ F4 @ ( principal @ A @ ( collect @ A @ P3 ) ) ) )
     => ( ( filterlim @ A @ B @ G @ G5
          @ ( inf_inf @ ( filter @ A ) @ F4
            @ ( principal @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ~ ( P3 @ X6 ) ) ) ) )
       => ( filterlim @ A @ B
          @ ^ [X6: A] : ( if @ B @ ( P3 @ X6 ) @ ( F3 @ X6 ) @ ( G @ X6 ) )
          @ G5
          @ F4 ) ) ) ).

% filterlim_If
thf(fact_7222_nhds__def,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [A5: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ ( set @ A ) @ ( filter @ A ) @ ( principal @ A )
                @ ( collect @ ( set @ A )
                  @ ^ [S6: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S6 )
                      & ( member @ A @ A5 @ S6 ) ) ) ) ) ) ) ) ).

% nhds_def
thf(fact_7223_filterlim__base,axiom,
    ! [B: $tType,A: $tType,E4: $tType,D: $tType,C: $tType,J5: set @ A,I3: A > C,I6: set @ C,F4: C > ( set @ D ),F3: D > E4,G5: A > ( set @ E4 )] :
      ( ! [M5: A,X7: B] :
          ( ( member @ A @ M5 @ J5 )
         => ( member @ C @ ( I3 @ M5 ) @ I6 ) )
     => ( ! [M5: A,X7: D] :
            ( ( member @ A @ M5 @ J5 )
           => ( ( member @ D @ X7 @ ( F4 @ ( I3 @ M5 ) ) )
             => ( member @ E4 @ ( F3 @ X7 ) @ ( G5 @ M5 ) ) ) )
       => ( filterlim @ D @ E4 @ F3
          @ ( complete_Inf_Inf @ ( filter @ E4 )
            @ ( image @ A @ ( filter @ E4 )
              @ ^ [J4: A] : ( principal @ E4 @ ( G5 @ J4 ) )
              @ J5 ) )
          @ ( complete_Inf_Inf @ ( filter @ D )
            @ ( image @ C @ ( filter @ D )
              @ ^ [I: C] : ( principal @ D @ ( F4 @ I ) )
              @ I6 ) ) ) ) ) ).

% filterlim_base
thf(fact_7224_INT__greaterThan__UNIV,axiom,
    ( ( complete_Inf_Inf @ ( set @ nat ) @ ( image @ nat @ ( set @ nat ) @ ( set_ord_greaterThan @ nat ) @ ( top_top @ ( set @ nat ) ) ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% INT_greaterThan_UNIV
thf(fact_7225_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_7226_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_7227_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I6: set @ A,F4: A > ( set @ B ),F3: B > C,G5: D > ( set @ C ),J5: set @ D] :
      ( ( I6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ! [J: A] :
                ( ( member @ A @ J @ I6 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F4 @ I2 ) @ ( F4 @ J ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F4 @ J ) @ ( F4 @ I2 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F3
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image @ D @ ( filter @ C )
                @ ^ [J4: D] : ( principal @ C @ ( G5 @ J4 ) )
                @ J5 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image @ A @ ( filter @ B )
                @ ^ [I: A] : ( principal @ B @ ( F4 @ I ) )
                @ I6 ) ) )
          = ( ! [X6: D] :
                ( ( member @ D @ X6 @ J5 )
               => ? [Y: A] :
                    ( ( member @ A @ Y @ I6 )
                    & ! [Z6: B] :
                        ( ( member @ B @ Z6 @ ( F4 @ Y ) )
                       => ( member @ C @ ( F3 @ Z6 ) @ ( G5 @ X6 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_7228_INF__principal__finite,axiom,
    ! [B: $tType,A: $tType,X15: set @ A,F3: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ X15 )
     => ( ( complete_Inf_Inf @ ( filter @ B )
          @ ( image @ A @ ( filter @ B )
            @ ^ [X6: A] : ( principal @ B @ ( F3 @ X6 ) )
            @ X15 ) )
        = ( principal @ B @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F3 @ X15 ) ) ) ) ) ).

% INF_principal_finite
thf(fact_7229_nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X6: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ real @ ( filter @ A )
                @ ^ [E3: real] :
                    ( principal @ A
                    @ ( collect @ A
                      @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X6 ) @ E3 ) ) )
                @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% nhds_metric
thf(fact_7230_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( topolo174197925503356063within @ A @ X2 @ ( set_ord_lessThan @ A @ X2 ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A5: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A5 @ X2 ) )
                @ ( set_ord_lessThan @ A @ X2 ) ) ) ) ) ) ).

% at_left_eq
thf(fact_7231_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A5: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ A5 ) )
                @ ( set_ord_greaterThan @ A @ X2 ) ) ) ) ) ) ).

% at_right_eq
thf(fact_7232_nhds__order,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X6: A] :
              ( inf_inf @ ( filter @ A )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A5: A] : ( principal @ A @ ( set_ord_lessThan @ A @ A5 ) )
                  @ ( set_ord_greaterThan @ A @ X6 ) ) )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A5: A] : ( principal @ A @ ( set_ord_greaterThan @ A @ A5 ) )
                  @ ( set_ord_lessThan @ A @ X6 ) ) ) ) ) ) ) ).

% nhds_order
thf(fact_7233_at__within__eq,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo174197925503356063within @ A )
        = ( ^ [X6: A,S4: set @ A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ ( set @ A ) @ ( filter @ A )
                @ ^ [S6: set @ A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S6 @ S4 ) @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) )
                @ ( collect @ ( set @ A )
                  @ ^ [S6: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S6 )
                      & ( member @ A @ X6 @ S6 ) ) ) ) ) ) ) ) ).

% at_within_eq
thf(fact_7234_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_7235_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_7236_exp__at__bot,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_bot @ real ) ).

% exp_at_bot
thf(fact_7237_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F3: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( times_times @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_7238_ln__at__0,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% ln_at_0
thf(fact_7239_tendsto__at__botI__sequentially,axiom,
    ! [B: $tType] :
      ( ( topolo3112930676232923870pology @ B )
     => ! [F3: real > B,Y2: B] :
          ( ! [X18: nat > real] :
              ( ( filterlim @ nat @ real @ X18 @ ( at_bot @ real ) @ ( at_top @ nat ) )
             => ( filterlim @ nat @ B
                @ ^ [N2: nat] : ( F3 @ ( X18 @ N2 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ Y2 )
                @ ( at_top @ nat ) ) )
         => ( filterlim @ real @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ Y2 ) @ ( at_bot @ real ) ) ) ) ).

% tendsto_at_botI_sequentially
thf(fact_7240_filterlim__inverse__at__bot__neg,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_lessThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_bot_neg
thf(fact_7241_at__bot__sub,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( ( at_bot @ A )
          = ( complete_Inf_Inf @ ( filter @ A )
            @ ( image @ A @ ( filter @ A )
              @ ^ [K2: A] : ( principal @ A @ ( set_ord_atMost @ A @ K2 ) )
              @ ( set_ord_atMost @ A @ C2 ) ) ) ) ) ).

% at_bot_sub
thf(fact_7242_at__bot__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( at_bot @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ A @ ( filter @ A )
            @ ^ [K2: A] : ( principal @ A @ ( set_ord_atMost @ A @ K2 ) )
            @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% at_bot_def
thf(fact_7243_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F3: real > real,Flim: real] :
      ( ! [X7: real] :
          ( ( ord_less_eq @ real @ X7 @ B2 )
         => ? [Y3: real] :
              ( ( has_field_derivative @ real @ F3 @ Y3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y3 ) ) )
     => ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F3 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_7244_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F3: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F3 @ ( at_bot @ real ) @ F4 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X6: real] : ( power_power @ real @ ( F3 @ X6 ) @ N )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_7245_Gcd__eq__Max,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite2 @ nat @ M7 )
     => ( ( M7
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
         => ( ( gcd_Gcd @ nat @ M7 )
            = ( lattic643756798349783984er_Max @ nat
              @ ( complete_Inf_Inf @ ( set @ nat )
                @ ( image @ nat @ ( set @ nat )
                  @ ^ [M4: nat] :
                      ( collect @ nat
                      @ ^ [D5: nat] : ( dvd_dvd @ nat @ D5 @ M4 ) )
                  @ M7 ) ) ) ) ) ) ) ).

% Gcd_eq_Max
thf(fact_7246_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F3: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F3 @ ( at_bot @ real ) @ F4 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X6: real] : ( power_power @ real @ ( F3 @ X6 ) @ N )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_7247_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D5: nat] : ( dvd_dvd @ nat @ D5 @ N ) ) )
        = N ) ) ).

% Max_divisors_self_nat
thf(fact_7248_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X2 )
              = ( ! [X6: A] :
                    ( ( member @ A @ X6 @ A3 )
                   => ( ord_less @ A @ X6 @ X2 ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_7249_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% Max_const
thf(fact_7250_sqrt__at__top,axiom,
    filterlim @ real @ real @ sqrt @ ( at_top @ real ) @ ( at_top @ real ) ).

% sqrt_at_top
thf(fact_7251_ln__at__top,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% ln_at_top
thf(fact_7252_exp__at__top,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% exp_at_top
thf(fact_7253_filterlim__at__top__add__at__top,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( plus_plus @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_add_at_top
thf(fact_7254_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( times_times @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_7255_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ? [X6: A] :
                    ( ( member @ A @ X6 @ A3 )
                    & ( ord_less @ A @ X2 @ X6 ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_7256_filterlim__tendsto__add__at__top,axiom,
    ! [A: $tType,F3: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( plus_plus @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_tendsto_add_at_top
thf(fact_7257_filterlim__real__sequentially,axiom,
    filterlim @ nat @ real @ ( semiring_1_of_nat @ real ) @ ( at_top @ real ) @ ( at_top @ nat ) ).

% filterlim_real_sequentially
thf(fact_7258_filterlim__uminus__at__bot,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( at_bot @ real ) @ F4 )
      = ( filterlim @ A @ real
        @ ^ [X6: A] : ( uminus_uminus @ real @ ( F3 @ X6 ) )
        @ ( at_top @ real )
        @ F4 ) ) ).

% filterlim_uminus_at_bot
thf(fact_7259_filterlim__uminus__at__top,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F4 )
      = ( filterlim @ A @ real
        @ ^ [X6: A] : ( uminus_uminus @ real @ ( F3 @ X6 ) )
        @ ( at_bot @ real )
        @ F4 ) ) ).

% filterlim_uminus_at_top
thf(fact_7260_filterlim__at__bot__mirror,axiom,
    ! [A: $tType,F3: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F3 @ F4 @ ( at_bot @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X6: real] : ( F3 @ ( uminus_uminus @ real @ X6 ) )
        @ F4
        @ ( at_top @ real ) ) ) ).

% filterlim_at_bot_mirror
thf(fact_7261_filterlim__at__top__mirror,axiom,
    ! [A: $tType,F3: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F3 @ F4 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X6: real] : ( F3 @ ( uminus_uminus @ real @ X6 ) )
        @ F4
        @ ( at_bot @ real ) ) ) ).

% filterlim_at_top_mirror
thf(fact_7262_filterlim__uminus__at__bot__at__top,axiom,
    filterlim @ real @ real @ ( uminus_uminus @ real ) @ ( at_bot @ real ) @ ( at_top @ real ) ).

% filterlim_uminus_at_bot_at_top
thf(fact_7263_filterlim__uminus__at__top__at__bot,axiom,
    filterlim @ real @ real @ ( uminus_uminus @ real ) @ ( at_top @ real ) @ ( at_bot @ real ) ).

% filterlim_uminus_at_top_at_bot
thf(fact_7264_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F3: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( power_power @ real @ ( F3 @ X6 ) @ N )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_pow_at_top
thf(fact_7265_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F3: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_7266_card__le__Suc__Max,axiom,
    ! [S3: set @ nat] :
      ( ( finite_finite2 @ nat @ S3 )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ S3 ) @ ( suc @ ( lattic643756798349783984er_Max @ nat @ S3 ) ) ) ) ).

% card_le_Suc_Max
thf(fact_7267_Sup__nat__def,axiom,
    ( ( complete_Sup_Sup @ nat )
    = ( ^ [X8: set @ nat] :
          ( if @ nat
          @ ( X8
            = ( bot_bot @ ( set @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat @ X8 ) ) ) ) ).

% Sup_nat_def
thf(fact_7268_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X6: A] : ( inverse_inverse @ real @ ( F3 @ X6 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_inverse_0_at_top
thf(fact_7269_divide__nat__def,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M4: nat,N2: nat] :
          ( if @ nat
          @ ( N2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat
            @ ( collect @ nat
              @ ^ [K2: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ K2 @ N2 ) @ M4 ) ) ) ) ) ) ).

% divide_nat_def
thf(fact_7270_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S3: set @ B,F3: B > A,K: A] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [X6: B] : ( plus_plus @ A @ ( F3 @ X6 ) @ K )
                  @ S3 ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image @ B @ A @ F3 @ S3 ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_7271_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( gcd_gcd @ nat @ M @ N )
        = ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D5: nat] :
                ( ( dvd_dvd @ nat @ D5 @ M )
                & ( dvd_dvd @ nat @ D5 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_nat
thf(fact_7272_filterlim__sequentially__iff__filterlim__real,axiom,
    ! [A: $tType,F3: A > nat,F4: filter @ A] :
      ( ( filterlim @ A @ nat @ F3 @ ( at_top @ nat ) @ F4 )
      = ( filterlim @ A @ real
        @ ^ [X6: A] : ( semiring_1_of_nat @ real @ ( F3 @ X6 ) )
        @ ( at_top @ real )
        @ F4 ) ) ).

% filterlim_sequentially_iff_filterlim_real
thf(fact_7273_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F3: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( times_times @ real @ ( G @ X6 ) @ ( F3 @ X6 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_7274_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F3: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( times_times @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_7275_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F3: A > real,F4: filter @ A] :
      ( ( ord_less @ real @ S @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( powr @ real @ ( F3 @ X6 ) @ S )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% tendsto_neg_powr
thf(fact_7276_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X6: real] : ( divide_divide @ real @ ( ln_ln @ real @ X6 ) @ X6 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_7277_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F3: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F3 @ F4 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X6: real] : ( F3 @ ( inverse_inverse @ real @ X6 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_top_to_right
thf(fact_7278_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F3: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F3 @ F4 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( filterlim @ real @ A
        @ ^ [X6: real] : ( F3 @ ( inverse_inverse @ real @ X6 ) )
        @ F4
        @ ( at_top @ real ) ) ) ).

% filterlim_at_right_to_top
thf(fact_7279_filterlim__inverse__at__top__right,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_top_right
thf(fact_7280_filterlim__inverse__at__right__top,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) @ ( at_top @ real ) ).

% filterlim_inverse_at_right_top
thf(fact_7281_tendsto__at__topI__sequentially,axiom,
    ! [B: $tType] :
      ( ( topolo3112930676232923870pology @ B )
     => ! [F3: real > B,Y2: B] :
          ( ! [X18: nat > real] :
              ( ( filterlim @ nat @ real @ X18 @ ( at_top @ real ) @ ( at_top @ nat ) )
             => ( filterlim @ nat @ B
                @ ^ [N2: nat] : ( F3 @ ( X18 @ N2 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ Y2 )
                @ ( at_top @ nat ) ) )
         => ( filterlim @ real @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ Y2 ) @ ( at_top @ real ) ) ) ) ).

% tendsto_at_topI_sequentially
thf(fact_7282_sum__le__card__Max,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ord_less_eq @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( lattic643756798349783984er_Max @ nat @ ( image @ A @ nat @ F3 @ A3 ) ) ) ) ) ).

% sum_le_card_Max
thf(fact_7283_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F3: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( times_times @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_7284_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X6: real] : ( divide_divide @ real @ ( power_power @ real @ X6 @ K ) @ ( exp @ real @ X6 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_7285_tendsto__exp__limit__at__top,axiom,
    ! [X2: real] :
      ( filterlim @ real @ real
      @ ^ [Y: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ Y ) ) @ Y )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_7286_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F3: real > real,Flim: real] :
      ( ! [X7: real] :
          ( ( ord_less_eq @ real @ B2 @ X7 )
         => ? [Y3: real] :
              ( ( has_field_derivative @ real @ F3 @ Y3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y3 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F3 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_7287_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_7288_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_7289_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X6: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X6 ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_7290_lhopital__left__at__top,axiom,
    ! [G: real > real,X2: real,G4: real > real,F3: real > real,F9: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
     => ( ( eventually @ real
          @ ^ [X6: real] :
              ( ( G4 @ X6 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_7291_eventually__const,axiom,
    ! [A: $tType,F4: filter @ A,P3: $o] :
      ( ( F4
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ A
          @ ^ [X6: A] : P3
          @ F4 )
        = P3 ) ) ).

% eventually_const
thf(fact_7292_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D5: int] : ( dvd_dvd @ int @ D5 @ N ) ) )
        = ( abs_abs @ int @ N ) ) ) ).

% Max_divisors_self_int
thf(fact_7293_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X6: A] : ( ord_less @ real @ ( F3 @ X6 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real @ F3 @ ( at_bot @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_7294_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X6: A] : ( ord_less @ A @ X6 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_7295_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P3: A > $o] :
          ( ( eventually @ A @ P3 @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less @ A @ N2 @ N6 )
               => ( P3 @ N2 ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_7296_eventually__at__bot__not__equal,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X6: A] : ( X6 != C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_at_bot_not_equal
thf(fact_7297_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X6: A] : ( ord_less_eq @ A @ X6 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_7298_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_7299_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P3: A > $o] :
          ( ( eventually @ A @ P3 @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less @ A @ N6 @ N2 )
               => ( P3 @ N2 ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_7300_eventually__at__top__not__equal,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X6: A] : ( X6 != C2 )
          @ ( at_top @ A ) ) ) ).

% eventually_at_top_not_equal
thf(fact_7301_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_7302_sequentially__imp__eventually__nhds__within,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [S: set @ A,A2: A,P3: A > $o] :
          ( ! [F6: nat > A] :
              ( ( ! [N9: nat] : ( member @ A @ ( F6 @ N9 ) @ S )
                & ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) )
             => ( eventually @ nat
                @ ^ [N2: nat] : ( P3 @ ( F6 @ N2 ) )
                @ ( at_top @ nat ) ) )
         => ( eventually @ A @ P3 @ ( inf_inf @ ( filter @ A ) @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( principal @ A @ S ) ) ) ) ) ).

% sequentially_imp_eventually_nhds_within
thf(fact_7303_eventually__nhds__within__iff__sequentially,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [P3: A > $o,A2: A,S: set @ A] :
          ( ( eventually @ A @ P3 @ ( inf_inf @ ( filter @ A ) @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( principal @ A @ S ) ) )
          = ( ! [F5: nat > A] :
                ( ( ! [N2: nat] : ( member @ A @ ( F5 @ N2 ) @ S )
                  & ( filterlim @ nat @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) )
               => ( eventually @ nat
                  @ ^ [N2: nat] : ( P3 @ ( F5 @ N2 ) )
                  @ ( at_top @ nat ) ) ) ) ) ) ).

% eventually_nhds_within_iff_sequentially
thf(fact_7304_eventually__nhds__iff__sequentially,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [P3: A > $o,A2: A] :
          ( ( eventually @ A @ P3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ! [F5: nat > A] :
                ( ( filterlim @ nat @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
               => ( eventually @ nat
                  @ ^ [N2: nat] : ( P3 @ ( F5 @ N2 ) )
                  @ ( at_top @ nat ) ) ) ) ) ) ).

% eventually_nhds_iff_sequentially
thf(fact_7305_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X6: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X6 ) )
          @ F4 )
       => ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_7306_sequentially__imp__eventually__within,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [S: set @ A,A2: A,P3: A > $o] :
          ( ! [F6: nat > A] :
              ( ( ! [N9: nat] :
                    ( ( member @ A @ ( F6 @ N9 ) @ S )
                    & ( ( F6 @ N9 )
                     != A2 ) )
                & ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) )
             => ( eventually @ nat
                @ ^ [N2: nat] : ( P3 @ ( F6 @ N2 ) )
                @ ( at_top @ nat ) ) )
         => ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ S ) ) ) ) ).

% sequentially_imp_eventually_within
thf(fact_7307_sequentially__imp__eventually__at,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [A2: A,P3: A > $o] :
          ( ! [F6: nat > A] :
              ( ( ! [N9: nat] :
                    ( ( F6 @ N9 )
                   != A2 )
                & ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) )
             => ( eventually @ nat
                @ ^ [N2: nat] : ( P3 @ ( F6 @ N2 ) )
                @ ( at_top @ nat ) ) )
         => ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% sequentially_imp_eventually_at
thf(fact_7308_filterlim__at__within__not__equal,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space @ B )
     => ! [F3: A > B,A2: B,S: set @ B,F4: filter @ A,B2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo174197925503356063within @ B @ A2 @ S ) @ F4 )
         => ( eventually @ A
            @ ^ [W3: A] :
                ( ( member @ B @ ( F3 @ W3 ) @ S )
                & ( ( F3 @ W3 )
                 != B2 ) )
            @ F4 ) ) ) ).

% filterlim_at_within_not_equal
thf(fact_7309_filterlim__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( filterlim @ A @ B )
      = ( ^ [F5: A > B,F24: filter @ B,F14: filter @ A] :
          ! [P2: B > $o] :
            ( ( eventually @ B @ P2 @ F24 )
           => ( eventually @ A
              @ ^ [X6: A] : ( P2 @ ( F5 @ X6 ) )
              @ F14 ) ) ) ) ).

% filterlim_iff
thf(fact_7310_filterlim__cong,axiom,
    ! [A: $tType,B: $tType,F13: filter @ A,F15: filter @ A,F23: filter @ B,F25: filter @ B,F3: B > A,G: B > A] :
      ( ( F13 = F15 )
     => ( ( F23 = F25 )
       => ( ( eventually @ B
            @ ^ [X6: B] :
                ( ( F3 @ X6 )
                = ( G @ X6 ) )
            @ F23 )
         => ( ( filterlim @ B @ A @ F3 @ F13 @ F23 )
            = ( filterlim @ B @ A @ G @ F15 @ F25 ) ) ) ) ) ).

% filterlim_cong
thf(fact_7311_filterlim__principal,axiom,
    ! [B: $tType,A: $tType,F3: A > B,S3: set @ B,F4: filter @ A] :
      ( ( filterlim @ A @ B @ F3 @ ( principal @ B @ S3 ) @ F4 )
      = ( eventually @ A
        @ ^ [X6: A] : ( member @ B @ ( F3 @ X6 ) @ S3 )
        @ F4 ) ) ).

% filterlim_principal
thf(fact_7312_eventually__compose__filterlim,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F4: filter @ A,F3: B > A,G5: filter @ B] :
      ( ( eventually @ A @ P3 @ F4 )
     => ( ( filterlim @ B @ A @ F3 @ F4 @ G5 )
       => ( eventually @ B
          @ ^ [X6: B] : ( P3 @ ( F3 @ X6 ) )
          @ G5 ) ) ) ).

% eventually_compose_filterlim
thf(fact_7313_Lim__transform__eventually,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ B )
     => ! [F3: A > B,L: B,F4: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X6: A] :
                  ( ( F3 @ X6 )
                  = ( G @ X6 ) )
              @ F4 )
           => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ) ).

% Lim_transform_eventually
thf(fact_7314_filterlim__at__infinity__imp__eventually__ne,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_infinity @ B ) @ F4 )
         => ( eventually @ A
            @ ^ [Z6: A] :
                ( ( F3 @ Z6 )
               != C2 )
            @ F4 ) ) ) ).

% filterlim_at_infinity_imp_eventually_ne
thf(fact_7315_tendsto__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: B > A,G: B > A,F4: filter @ B,C2: A] :
          ( ( eventually @ B
            @ ^ [X6: B] :
                ( ( F3 @ X6 )
                = ( G @ X6 ) )
            @ F4 )
         => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 ) ) ) ) ).

% tendsto_cong
thf(fact_7316_tendsto__discrete,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo8865339358273720382pology @ A )
     => ! [F3: B > A,Y2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 )
          = ( eventually @ B
            @ ^ [X6: B] :
                ( ( F3 @ X6 )
                = Y2 )
            @ F4 ) ) ) ).

% tendsto_discrete
thf(fact_7317_tendsto__imp__eventually__ne,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topological_t1_space @ A )
     => ! [F3: B > A,C2: A,F4: filter @ B,C8: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2 != C8 )
           => ( eventually @ B
              @ ^ [Z6: B] :
                  ( ( F3 @ Z6 )
                 != C8 )
              @ F4 ) ) ) ) ).

% tendsto_imp_eventually_ne
thf(fact_7318_tendsto__eventually,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: B > A,L: A,Net: filter @ B] :
          ( ( eventually @ B
            @ ^ [X6: B] :
                ( ( F3 @ X6 )
                = L )
            @ Net )
         => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ Net ) ) ) ).

% tendsto_eventually
thf(fact_7319_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F3: A > B,F4: filter @ B,G5: filter @ A,F11: filter @ B,G6: filter @ A,F9: A > B] :
      ( ( filterlim @ A @ B @ F3 @ F4 @ G5 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
       => ( ( ord_less_eq @ ( filter @ A ) @ G6 @ G5 )
         => ( ( eventually @ A
              @ ^ [X6: A] :
                  ( ( F3 @ X6 )
                  = ( F9 @ X6 ) )
              @ G6 )
           => ( filterlim @ A @ B @ F9 @ F11 @ G6 ) ) ) ) ) ).

% filterlim_mono_eventually
thf(fact_7320_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F3: C > A,F4: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F3 @ ( at_infinity @ A ) @ F4 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X6: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ X6 ) ) )
                    @ F4 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_7321_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P3: A > $o,X2: A] :
          ( ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_lessThan @ A @ X2 ) ) )
          = ( ? [B4: A] :
                ( ( ord_less @ A @ B4 @ X2 )
                & ! [Y: A] :
                    ( ( ord_less @ A @ B4 @ Y )
                   => ( ( ord_less @ A @ Y @ X2 )
                     => ( P3 @ Y ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_7322_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y2: A,X2: A,P3: A > $o] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_lessThan @ A @ X2 ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ X2 )
                  & ! [Y: A] :
                      ( ( ord_less @ A @ B4 @ Y )
                     => ( ( ord_less @ A @ Y @ X2 )
                       => ( P3 @ Y ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_7323_eventually__inf__principal,axiom,
    ! [A: $tType,P3: A > $o,F4: filter @ A,S: set @ A] :
      ( ( eventually @ A @ P3 @ ( inf_inf @ ( filter @ A ) @ F4 @ ( principal @ A @ S ) ) )
      = ( eventually @ A
        @ ^ [X6: A] :
            ( ( member @ A @ X6 @ S )
           => ( P3 @ X6 ) )
        @ F4 ) ) ).

% eventually_inf_principal
thf(fact_7324_le__principal,axiom,
    ! [A: $tType,F4: filter @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ ( principal @ A @ A3 ) )
      = ( eventually @ A
        @ ^ [X6: A] : ( member @ A @ X6 @ A3 )
        @ F4 ) ) ).

% le_principal
thf(fact_7325_eventually__nhds__in__open,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,X2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S )
         => ( ( member @ A @ X2 @ S )
           => ( eventually @ A
              @ ^ [Y: A] : ( member @ A @ Y @ S )
              @ ( topolo7230453075368039082e_nhds @ A @ X2 ) ) ) ) ) ).

% eventually_nhds_in_open
thf(fact_7326_has__derivative__transform__eventually,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X2: A,S: set @ A,G: A > B] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( eventually @ A
              @ ^ [X9: A] :
                  ( ( F3 @ X9 )
                  = ( G @ X9 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( ( ( F3 @ X2 )
                = ( G @ X2 ) )
             => ( ( member @ A @ X2 @ S )
               => ( has_derivative @ A @ B @ G @ F9 @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ) ).

% has_derivative_transform_eventually
thf(fact_7327_eventually__at__filter,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o,A2: A,S: set @ A] :
          ( ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ S ) )
          = ( eventually @ A
            @ ^ [X6: A] :
                ( ( X6 != A2 )
               => ( ( member @ A @ X6 @ S )
                 => ( P3 @ X6 ) ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 ) ) ) ) ).

% eventually_at_filter
thf(fact_7328_t1__space__nhds,axiom,
    ! [A: $tType] :
      ( ( topological_t1_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( eventually @ A
            @ ^ [X6: A] : ( X6 != Y2 )
            @ ( topolo7230453075368039082e_nhds @ A @ X2 ) ) ) ) ).

% t1_space_nhds
thf(fact_7329_eventually__eventually,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o,X2: A] :
          ( ( eventually @ A
            @ ^ [Y: A] : ( eventually @ A @ P3 @ ( topolo7230453075368039082e_nhds @ A @ Y ) )
            @ ( topolo7230453075368039082e_nhds @ A @ X2 ) )
          = ( eventually @ A @ P3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) ) ) ) ).

% eventually_eventually
thf(fact_7330_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P3: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P3 @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ ( top_top @ A ) )
                  & ! [Z6: A] :
                      ( ( ord_less @ A @ B4 @ Z6 )
                     => ( P3 @ Z6 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_7331_has__field__derivative__cong__eventually,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,G: A > A,X2: A,S3: set @ A,U: A] :
          ( ( eventually @ A
            @ ^ [X6: A] :
                ( ( F3 @ X6 )
                = ( G @ X6 ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( ( ( F3 @ X2 )
              = ( G @ X2 ) )
           => ( ( has_field_derivative @ A @ F3 @ U @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
              = ( has_field_derivative @ A @ G @ U @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ) ) ).

% has_field_derivative_cong_eventually
thf(fact_7332_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P5: A > $o] :
          ( ( eventually @ A @ P5 @ ( at_infinity @ A ) )
          = ( ? [B4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B4 )
                & ! [X6: A] :
                    ( ( ord_less_eq @ real @ B4 @ ( real_V7770717601297561774m_norm @ A @ X6 ) )
                   => ( P5 @ X6 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_7333_eventually__frequently__const__simps_I6_J,axiom,
    ! [A: $tType,C6: $o,P3: A > $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] :
            ( C6
           => ( P3 @ X6 ) )
        @ F4 )
      = ( C6
       => ( eventually @ A @ P3 @ F4 ) ) ) ).

% eventually_frequently_const_simps(6)
thf(fact_7334_eventually__frequently__const__simps_I4_J,axiom,
    ! [A: $tType,C6: $o,P3: A > $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] :
            ( C6
            | ( P3 @ X6 ) )
        @ F4 )
      = ( C6
        | ( eventually @ A @ P3 @ F4 ) ) ) ).

% eventually_frequently_const_simps(4)
thf(fact_7335_eventually__frequently__const__simps_I3_J,axiom,
    ! [A: $tType,P3: A > $o,C6: $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] :
            ( ( P3 @ X6 )
            | C6 )
        @ F4 )
      = ( ( eventually @ A @ P3 @ F4 )
        | C6 ) ) ).

% eventually_frequently_const_simps(3)
thf(fact_7336_eventually__mp,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] :
            ( ( P3 @ X6 )
           => ( Q @ X6 ) )
        @ F4 )
     => ( ( eventually @ A @ P3 @ F4 )
       => ( eventually @ A @ Q @ F4 ) ) ) ).

% eventually_mp
thf(fact_7337_eventually__True,axiom,
    ! [A: $tType,F4: filter @ A] :
      ( eventually @ A
      @ ^ [X6: A] : $true
      @ F4 ) ).

% eventually_True
thf(fact_7338_eventually__conj,axiom,
    ! [A: $tType,P3: A > $o,F4: filter @ A,Q: A > $o] :
      ( ( eventually @ A @ P3 @ F4 )
     => ( ( eventually @ A @ Q @ F4 )
       => ( eventually @ A
          @ ^ [X6: A] :
              ( ( P3 @ X6 )
              & ( Q @ X6 ) )
          @ F4 ) ) ) ).

% eventually_conj
thf(fact_7339_eventually__elim2,axiom,
    ! [A: $tType,P3: A > $o,F4: filter @ A,Q: A > $o,R3: A > $o] :
      ( ( eventually @ A @ P3 @ F4 )
     => ( ( eventually @ A @ Q @ F4 )
       => ( ! [I2: A] :
              ( ( P3 @ I2 )
             => ( ( Q @ I2 )
               => ( R3 @ I2 ) ) )
         => ( eventually @ A @ R3 @ F4 ) ) ) ) ).

% eventually_elim2
thf(fact_7340_eventually__subst,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [N2: A] :
            ( ( P3 @ N2 )
            = ( Q @ N2 ) )
        @ F4 )
     => ( ( eventually @ A @ P3 @ F4 )
        = ( eventually @ A @ Q @ F4 ) ) ) ).

% eventually_subst
thf(fact_7341_eventually__rev__mp,axiom,
    ! [A: $tType,P3: A > $o,F4: filter @ A,Q: A > $o] :
      ( ( eventually @ A @ P3 @ F4 )
     => ( ( eventually @ A
          @ ^ [X6: A] :
              ( ( P3 @ X6 )
             => ( Q @ X6 ) )
          @ F4 )
       => ( eventually @ A @ Q @ F4 ) ) ) ).

% eventually_rev_mp
thf(fact_7342_eventually__conj__iff,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] :
            ( ( P3 @ X6 )
            & ( Q @ X6 ) )
        @ F4 )
      = ( ( eventually @ A @ P3 @ F4 )
        & ( eventually @ A @ Q @ F4 ) ) ) ).

% eventually_conj_iff
thf(fact_7343_not__eventually__impI,axiom,
    ! [A: $tType,P3: A > $o,F4: filter @ A,Q: A > $o] :
      ( ( eventually @ A @ P3 @ F4 )
     => ( ~ ( eventually @ A @ Q @ F4 )
       => ~ ( eventually @ A
            @ ^ [X6: A] :
                ( ( P3 @ X6 )
               => ( Q @ X6 ) )
            @ F4 ) ) ) ).

% not_eventually_impI
thf(fact_7344_trivial__limit__def,axiom,
    ! [A: $tType,F4: filter @ A] :
      ( ( F4
        = ( bot_bot @ ( filter @ A ) ) )
      = ( eventually @ A
        @ ^ [X6: A] : $false
        @ F4 ) ) ).

% trivial_limit_def
thf(fact_7345_eventually__const__iff,axiom,
    ! [A: $tType,P3: $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] : P3
        @ F4 )
      = ( P3
        | ( F4
          = ( bot_bot @ ( filter @ A ) ) ) ) ) ).

% eventually_const_iff
thf(fact_7346_False__imp__not__eventually,axiom,
    ! [A: $tType,P3: A > $o,Net: filter @ A] :
      ( ! [X7: A] :
          ~ ( P3 @ X7 )
     => ( ( Net
         != ( bot_bot @ ( filter @ A ) ) )
       => ~ ( eventually @ A @ P3 @ Net ) ) ) ).

% False_imp_not_eventually
thf(fact_7347_eventually__not__equal__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A] :
          ( eventually @ A
          @ ^ [X6: A] : ( X6 != A2 )
          @ ( at_infinity @ A ) ) ) ).

% eventually_not_equal_at_infinity
thf(fact_7348_eventually__Lim__ident__at,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [P3: A > A > $o,X2: A,X15: set @ A] :
          ( ( eventually @ A
            @ ( P3
              @ ( topolo3827282254853284352ce_Lim @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ X15 )
                @ ^ [X6: A] : X6 ) )
            @ ( topolo174197925503356063within @ A @ X2 @ X15 ) )
          = ( eventually @ A @ ( P3 @ X2 ) @ ( topolo174197925503356063within @ A @ X2 @ X15 ) ) ) ) ).

% eventually_Lim_ident_at
thf(fact_7349_eventually__INF1,axiom,
    ! [B: $tType,A: $tType,I3: A,I6: set @ A,P3: B > $o,F4: A > ( filter @ B )] :
      ( ( member @ A @ I3 @ I6 )
     => ( ( eventually @ B @ P3 @ ( F4 @ I3 ) )
       => ( eventually @ B @ P3 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ I6 ) ) ) ) ) ).

% eventually_INF1
thf(fact_7350_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X2: A,Y2: A,P3: A > $o] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ X2 @ B4 )
                  & ! [Y: A] :
                      ( ( ord_less @ A @ X2 @ Y )
                     => ( ( ord_less @ A @ Y @ B4 )
                       => ( P3 @ Y ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_7351_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P3: A > $o,X2: A] :
          ( ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) )
          = ( ? [B4: A] :
                ( ( ord_less @ A @ X2 @ B4 )
                & ! [Y: A] :
                    ( ( ord_less @ A @ X2 @ Y )
                   => ( ( ord_less @ A @ Y @ B4 )
                     => ( P3 @ Y ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_7352_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F3: B > A,G: B > A,Net: filter @ B,H: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F3 @ N2 ) @ ( G @ N2 ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N2: B] : ( ord_less_eq @ A @ ( G @ N2 ) @ ( H @ N2 ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_7353_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F3: B > A,X2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F4 )
          = ( ! [L3: A] :
                ( ( ord_less @ A @ L3 @ X2 )
               => ( eventually @ B
                  @ ^ [X6: B] : ( ord_less @ A @ L3 @ ( F3 @ X6 ) )
                  @ F4 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X2 @ U2 )
               => ( eventually @ B
                  @ ^ [X6: B] : ( ord_less @ A @ ( F3 @ X6 ) @ U2 )
                  @ F4 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_7354_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y2: A,F3: B > A,F4: filter @ B] :
          ( ! [A4: A] :
              ( ( ord_less @ A @ A4 @ Y2 )
             => ( eventually @ B
                @ ^ [X6: B] : ( ord_less @ A @ A4 @ ( F3 @ X6 ) )
                @ F4 ) )
         => ( ! [A4: A] :
                ( ( ord_less @ A @ Y2 @ A4 )
               => ( eventually @ B
                  @ ^ [X6: B] : ( ord_less @ A @ ( F3 @ X6 ) @ A4 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 ) ) ) ) ).

% order_tendstoI
thf(fact_7355_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F3: B > A,Y2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 )
         => ( ( ord_less @ A @ A2 @ Y2 )
           => ( eventually @ B
              @ ^ [X6: B] : ( ord_less @ A @ A2 @ ( F3 @ X6 ) )
              @ F4 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_7356_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F3: B > A,Y2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 )
         => ( ( ord_less @ A @ Y2 @ A2 )
           => ( eventually @ B
              @ ^ [X6: B] : ( ord_less @ A @ ( F3 @ X6 ) @ A2 )
              @ F4 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_7357_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F3 @ ( at_top @ A ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X6: B] : ( ord_less_eq @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F4 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_7358_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F3: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X6: A] : ( ord_less_eq @ B @ Z9 @ ( F3 @ X6 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_7359_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X6: A] : ( ord_less_eq @ B @ Z9 @ ( F3 @ X6 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top
thf(fact_7360_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X6: A] : ( ord_less @ B @ Z9 @ ( F3 @ X6 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_7361_filterlim__at,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: B > A,B2: A,S: set @ A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo174197925503356063within @ A @ B2 @ S ) @ F4 )
          = ( ( eventually @ B
              @ ^ [X6: B] :
                  ( ( member @ A @ ( F3 @ X6 ) @ S )
                  & ( ( F3 @ X6 )
                   != B2 ) )
              @ F4 )
            & ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 ) ) ) ) ).

% filterlim_at
thf(fact_7362_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X2: A] : ( eventually @ A @ ( ord_less @ A @ X2 ) @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) ) ) ).

% eventually_at_right_less
thf(fact_7363_has__field__derivative__cong__ev,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,Y2: A,S3: set @ A,F3: A > A,G: A > A,U: A,V: A,T3: set @ A] :
          ( ( X2 = Y2 )
         => ( ( eventually @ A
              @ ^ [X6: A] :
                  ( ( member @ A @ X6 @ S3 )
                 => ( ( F3 @ X6 )
                    = ( G @ X6 ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X2 ) )
           => ( ( U = V )
             => ( ( S3 = T3 )
               => ( ( member @ A @ X2 @ S3 )
                 => ( ( has_field_derivative @ A @ F3 @ U @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
                    = ( has_field_derivative @ A @ G @ V @ ( topolo174197925503356063within @ A @ Y2 @ T3 ) ) ) ) ) ) ) ) ) ).

% has_field_derivative_cong_ev
thf(fact_7364_topological__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [L: A,F3: B > A,F4: filter @ B] :
          ( ! [S10: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ S10 )
             => ( ( member @ A @ L @ S10 )
               => ( eventually @ B
                  @ ^ [X6: B] : ( member @ A @ ( F3 @ X6 ) @ S10 )
                  @ F4 ) ) )
         => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ).

% topological_tendstoI
thf(fact_7365_topological__tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: B > A,L: A,F4: filter @ B,S3: set @ A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( topolo1002775350975398744n_open @ A @ S3 )
           => ( ( member @ A @ L @ S3 )
             => ( eventually @ B
                @ ^ [X6: B] : ( member @ A @ ( F3 @ X6 ) @ S3 )
                @ F4 ) ) ) ) ) ).

% topological_tendstoD
thf(fact_7366_tendsto__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
          = ( ! [S6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S6 )
               => ( ( member @ A @ L @ S6 )
                 => ( eventually @ B
                    @ ^ [X6: B] : ( member @ A @ ( F3 @ X6 ) @ S6 )
                    @ F4 ) ) ) ) ) ) ).

% tendsto_def
thf(fact_7367_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X6: A] : ( ord_less_eq @ B @ ( F3 @ X6 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot
thf(fact_7368_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F3: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X6: A] : ( ord_less_eq @ B @ ( F3 @ X6 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_7369_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X6: A] : ( ord_less @ B @ ( F3 @ X6 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_7370_real__tendsto__sandwich,axiom,
    ! [B: $tType,F3: B > real,G: B > real,Net: filter @ B,H: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N2: B] : ( ord_less_eq @ real @ ( F3 @ N2 ) @ ( G @ N2 ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N2: B] : ( ord_less_eq @ real @ ( G @ N2 ) @ ( H @ N2 ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_7371_eventually__INF__finite,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,P3: B > $o,F4: A > ( filter @ B )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( eventually @ B @ P3 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ A3 ) ) )
        = ( ? [Q8: A > B > $o] :
              ( ! [X6: A] :
                  ( ( member @ A @ X6 @ A3 )
                 => ( eventually @ B @ ( Q8 @ X6 ) @ ( F4 @ X6 ) ) )
              & ! [Y: B] :
                  ( ! [X6: A] :
                      ( ( member @ A @ X6 @ A3 )
                     => ( Q8 @ X6 @ Y ) )
                 => ( P3 @ Y ) ) ) ) ) ) ).

% eventually_INF_finite
thf(fact_7372_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P3: A > $o,A2: A,S3: set @ A] :
          ( ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
          = ( ? [D5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                & ! [X6: A] :
                    ( ( member @ A @ X6 @ S3 )
                   => ( ( ( X6 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ A2 ) @ D5 ) )
                     => ( P3 @ X6 ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_7373_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( gcd_gcd @ int @ M @ N )
        = ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D5: int] :
                ( ( dvd_dvd @ int @ D5 @ M )
                & ( dvd_dvd @ int @ D5 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_int
thf(fact_7374_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P3: A > $o,A2: A] :
          ( ( eventually @ A @ P3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ? [D5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                & ! [X6: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ A2 ) @ D5 )
                   => ( P3 @ X6 ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_7375_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P3: A > $o] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P3 @ X7 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_7376_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P3: A > $o] :
          ( ! [X7: A] :
              ( ( member @ A @ X7 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P3 @ X7 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_7377_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P3: A > $o,A2: A] :
          ( ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X6: A] : ( P3 @ ( plus_plus @ A @ X6 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_7378_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F3: B > A,L: A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F3 @ N2 ) @ L )
            @ F4 )
         => ( ! [X7: A] :
                ( ( ord_less @ A @ X7 @ L )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ X7 @ ( F3 @ N2 ) )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% increasing_tendsto
thf(fact_7379_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L: A,F3: B > A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ L @ ( F3 @ N2 ) )
            @ F4 )
         => ( ! [X7: A] :
                ( ( ord_less @ A @ L @ X7 )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ ( F3 @ N2 ) @ X7 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% decreasing_tendsto
thf(fact_7380_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F3: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X6: A] : ( ord_less_eq @ B @ Z9 @ ( F3 @ X6 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_7381_tendsto__compose__eventually,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,M: B,L: A,F3: C > A,F4: filter @ C] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ A @ L @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
           => ( ( eventually @ C
                @ ^ [X6: C] :
                    ( ( F3 @ X6 )
                   != L )
                @ F4 )
             => ( filterlim @ C @ B
                @ ^ [X6: C] : ( G @ ( F3 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ M )
                @ F4 ) ) ) ) ) ).

% tendsto_compose_eventually
thf(fact_7382_LIM__compose__eventually,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ( eventually @ A
                @ ^ [X6: A] :
                    ( ( F3 @ X6 )
                   != B2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X6: A] : ( G @ ( F3 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose_eventually
thf(fact_7383_filterlim__atI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: B > A,C2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X6: B] :
                  ( ( F3 @ X6 )
                 != C2 )
              @ F4 )
           => ( filterlim @ B @ A @ F3 @ ( topolo174197925503356063within @ A @ C2 @ ( top_top @ ( set @ A ) ) ) @ F4 ) ) ) ) ).

% filterlim_atI
thf(fact_7384_isCont__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,G: A > B,X2: A] :
          ( ( eventually @ A
            @ ^ [X6: A] :
                ( ( F3 @ X6 )
                = ( G @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ X2 ) )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
            = ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ G ) ) ) ) ).

% isCont_cong
thf(fact_7385_DERIV__cong__ev,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,Y2: A,F3: A > A,G: A > A,U: A,V: A] :
          ( ( X2 = Y2 )
         => ( ( eventually @ A
              @ ^ [X6: A] :
                  ( ( F3 @ X6 )
                  = ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X2 ) )
           => ( ( U = V )
             => ( ( has_field_derivative @ A @ F3 @ U @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
                = ( has_field_derivative @ A @ G @ V @ ( topolo174197925503356063within @ A @ Y2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% DERIV_cong_ev
thf(fact_7386_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F3: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X6: A] : ( ord_less_eq @ B @ ( F3 @ X6 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_7387_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: B > A,X2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I: B] : ( ord_less_eq @ A @ ( F3 @ I ) @ A2 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X2 @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_7388_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: B > A,X2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I: B] : ( ord_less_eq @ A @ A2 @ ( F3 @ I ) )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X2 ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_7389_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F4: filter @ B,F3: B > A,X2: A,G: B > A,Y2: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F4 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 )
             => ( ( eventually @ B
                  @ ^ [X6: B] : ( ord_less_eq @ A @ ( G @ X6 ) @ ( F3 @ X6 ) )
                  @ F4 )
               => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) ) ).

% tendsto_le
thf(fact_7390_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F3: C > A,A2: A,F4: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( eventually @ C
              @ ^ [X6: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X6 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X6 ) @ A2 ) )
              @ F4 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F4 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_7391_eventually__floor__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X6: A] :
                  ( ( archim6421214686448440834_floor @ B @ ( F3 @ X6 ) )
                  = ( archim6421214686448440834_floor @ B @ L ) )
              @ F4 ) ) ) ) ).

% eventually_floor_eq
thf(fact_7392_eventually__ceiling__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X6: A] :
                  ( ( archimedean_ceiling @ B @ ( F3 @ X6 ) )
                  = ( archimedean_ceiling @ B @ L ) )
              @ F4 ) ) ) ) ).

% eventually_ceiling_eq
thf(fact_7393_eventually__at__right__to__0,axiom,
    ! [P3: real > $o,A2: real] :
      ( ( eventually @ real @ P3 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X6: real] : ( P3 @ ( plus_plus @ real @ X6 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_7394_Sup__enat__def,axiom,
    ( ( complete_Sup_Sup @ extended_enat )
    = ( ^ [A7: set @ extended_enat] :
          ( if @ extended_enat
          @ ( A7
            = ( bot_bot @ ( set @ extended_enat ) ) )
          @ ( zero_zero @ extended_enat )
          @ ( if @ extended_enat @ ( finite_finite2 @ extended_enat @ A7 ) @ ( lattic643756798349783984er_Max @ extended_enat @ A7 ) @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) ).

% Sup_enat_def
thf(fact_7395_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F4: B > ( filter @ A ),B5: set @ B] :
      ( ( eventually @ A @ P3 @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ B5 ) ) )
      = ( ? [X8: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X8 @ B5 )
            & ( finite_finite2 @ B @ X8 )
            & ( eventually @ A @ P3 @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ X8 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_7396_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F4: filter @ A,G: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_infinity @ B ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X6: A] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_7397_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,C2: B,F4: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X6: A] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_7398_eventually__at__left__to__right,axiom,
    ! [P3: real > $o,A2: real] :
      ( ( eventually @ real @ P3 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X6: real] : ( P3 @ ( uminus_uminus @ real @ X6 ) )
        @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ A2 ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ A2 ) ) ) ) ) ).

% eventually_at_left_to_right
thf(fact_7399_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F3 )
         => ( ( eventually @ A
              @ ^ [X6: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F3 @ X6 ) )
              @ F4 )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X6: A] : ( arcosh @ real @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_7400_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( eventually @ real
        @ ^ [X6: real] : ( member @ real @ X6 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ).

% eventually_at_right_real
thf(fact_7401_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( ( ord_less @ real @ B2 @ A2 )
     => ( eventually @ real
        @ ^ [X6: real] : ( member @ real @ X6 @ ( set_or5935395276787703475ssThan @ real @ B2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ).

% eventually_at_left_real
thf(fact_7402_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P3: A > $o,A2: A,S3: set @ A] :
          ( ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
          = ( ? [D5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                & ! [X6: A] :
                    ( ( member @ A @ X6 @ S3 )
                   => ( ( ( X6 != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ A2 ) @ D5 ) )
                     => ( P3 @ X6 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_7403_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N: nat,B5: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N )
             => ( eventually @ A
                @ ^ [Z6: A] :
                    ( ord_less_eq @ real @ B5
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z6 @ I ) )
                        @ ( set_ord_atMost @ nat @ N ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_7404_tendsto__compose__at,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: A > B,Y2: B,F4: filter @ A,G: B > C,Z: C] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ Y2 ) @ F4 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ Z ) @ ( topolo174197925503356063within @ B @ Y2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ( eventually @ A
                @ ^ [W3: A] :
                    ( ( ( F3 @ W3 )
                      = Y2 )
                   => ( ( G @ Y2 )
                      = Z ) )
                @ F4 )
             => ( filterlim @ A @ C @ ( comp @ B @ C @ A @ G @ F3 ) @ ( topolo7230453075368039082e_nhds @ C @ Z ) @ F4 ) ) ) ) ) ).

% tendsto_compose_at
thf(fact_7405_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F3: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X6: A] : ( ord_less @ B @ ( F3 @ X6 ) @ L5 )
              @ F4 )
           => ( filterlim @ A @ B @ F3 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_lessThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_7406_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F3: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X6: A] : ( ord_less @ B @ L5 @ ( F3 @ X6 ) )
              @ F4 )
           => ( filterlim @ A @ B @ F3 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_greaterThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_7407_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F3: B > A,L: A,F4: filter @ B,E2: real] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ( eventually @ B
              @ ^ [X6: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X6 ) @ L ) @ E2 )
              @ F4 ) ) ) ) ).

% tendstoD
thf(fact_7408_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F3: B > A,L: A,F4: filter @ B] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ( eventually @ B
                @ ^ [X6: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X6 ) @ L ) @ E )
                @ F4 ) )
         => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ).

% tendstoI
thf(fact_7409_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F3: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ( eventually @ B
                  @ ^ [X6: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X6 ) @ L ) @ E3 )
                  @ F4 ) ) ) ) ) ).

% tendsto_iff
thf(fact_7410_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_infinity @ A ) ) ) ).

% tendsto_inverse_0
thf(fact_7411_eventually__at__top__to__right,axiom,
    ! [P3: real > $o] :
      ( ( eventually @ real @ P3 @ ( at_top @ real ) )
      = ( eventually @ real
        @ ^ [X6: real] : ( P3 @ ( inverse_inverse @ real @ X6 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_top_to_right
thf(fact_7412_eventually__at__right__to__top,axiom,
    ! [P3: real > $o] :
      ( ( eventually @ real @ P3 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( eventually @ real
        @ ^ [X6: real] : ( P3 @ ( inverse_inverse @ real @ X6 ) )
        @ ( at_top @ real ) ) ) ).

% eventually_at_right_to_top
thf(fact_7413_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F3: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X6: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F3 @ X6 ) )
            @ F4 )
         => ( filterlim @ B @ real
            @ ^ [X6: B] : ( arcosh @ real @ ( F3 @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_7414_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F3: A > B,P3: B > $o,G: B > A,A2: A] :
          ( ! [X7: A,Y5: A] :
              ( ( Q @ X7 )
             => ( ( Q @ Y5 )
               => ( ( ord_less_eq @ A @ X7 @ Y5 )
                 => ( ord_less_eq @ B @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) ) ) )
         => ( ! [X7: B] :
                ( ( P3 @ X7 )
               => ( ( F3 @ ( G @ X7 ) )
                  = X7 ) )
           => ( ! [X7: B] :
                  ( ( P3 @ X7 )
                 => ( Q @ ( G @ X7 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B3: A] :
                      ( ( Q @ B3 )
                     => ( ord_less @ A @ B3 @ A2 ) )
                 => ( ( eventually @ B @ P3 @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_7415_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: B > A,C2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F4 )
             => ( filterlim @ B @ A
                @ ^ [X6: B] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_7416_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: C > A,C2: A,F4: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F4 )
           => ( filterlim @ C @ A
              @ ^ [X6: C] : ( divide_divide @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_divide_0
thf(fact_7417_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F3: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F3 @ ( at_infinity @ B ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X6: A] : ( power_power @ B @ ( F3 @ X6 ) @ N )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_7418_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B5: set @ A,F4: A > ( filter @ B ),P3: B > $o] :
      ( ( B5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A4: A] :
            ( ( member @ A @ A4 @ B5 )
           => ! [B3: A] :
                ( ( member @ A @ B3 @ B5 )
               => ? [X: A] :
                    ( ( member @ A @ X @ B5 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ A4 ) @ ( F4 @ B3 ) ) ) ) ) )
       => ( ( eventually @ B @ P3 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ B5 ) ) )
          = ( ? [X6: A] :
                ( ( member @ A @ X6 @ B5 )
                & ( eventually @ B @ P3 @ ( F4 @ X6 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_7419_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F3: A > B,P3: B > $o,G: B > A,A2: A] :
          ( ! [X7: A,Y5: A] :
              ( ( Q @ X7 )
             => ( ( Q @ Y5 )
               => ( ( ord_less_eq @ A @ X7 @ Y5 )
                 => ( ord_less_eq @ B @ ( F3 @ X7 ) @ ( F3 @ Y5 ) ) ) ) )
         => ( ! [X7: B] :
                ( ( P3 @ X7 )
               => ( ( F3 @ ( G @ X7 ) )
                  = X7 ) )
           => ( ! [X7: B] :
                  ( ( P3 @ X7 )
                 => ( Q @ ( G @ X7 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B3: A] :
                      ( ( Q @ B3 )
                     => ( ord_less @ A @ A2 @ B3 ) )
                 => ( ( eventually @ B @ P3 @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_7420_filterlim__at__infinity__imp__norm__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( at_infinity @ B ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ).

% filterlim_at_infinity_imp_norm_at_top
thf(fact_7421_filterlim__norm__at__top__imp__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) )
            @ ( at_top @ real )
            @ F4 )
         => ( filterlim @ A @ B @ F3 @ ( at_infinity @ B ) @ F4 ) ) ) ).

% filterlim_norm_at_top_imp_at_infinity
thf(fact_7422_filterlim__at__infinity__conv__norm__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,G5: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( at_infinity @ B ) @ G5 )
          = ( filterlim @ A @ real
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) )
            @ ( at_top @ real )
            @ G5 ) ) ) ).

% filterlim_at_infinity_conv_norm_at_top
thf(fact_7423_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F4: filter @ A,G: A > C,K5: real] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X6: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X6 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) ) @ K5 ) )
              @ F4 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F4 ) ) ) ) ).

% tendsto_0_le
thf(fact_7424_filterlim__at__withinI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: B > A,C2: A,F4: filter @ B,A3: set @ A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X6: B] : ( member @ A @ ( F3 @ X6 ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ) )
              @ F4 )
           => ( filterlim @ B @ A @ F3 @ ( topolo174197925503356063within @ A @ C2 @ A3 ) @ F4 ) ) ) ) ).

% filterlim_at_withinI
thf(fact_7425_tendsto__powr_H,axiom,
    ! [A: $tType,F3: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X6: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X6 ) )
                @ F4 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X6: A] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr'
thf(fact_7426_tendsto__powr2,axiom,
    ! [A: $tType,F3: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X6: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X6 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X6: A] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F4 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_7427_tendsto__zero__powrI,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X6: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X6 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X6: A] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F4 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_7428_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X6: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L ) ) @ ( F3 @ X6 ) )
              @ F4 ) ) ) ) ).

% eventually_floor_less
thf(fact_7429_LIM__at__top__divide,axiom,
    ! [A: $tType,F3: A > real,A2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X6: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X6 ) )
              @ F4 )
           => ( filterlim @ A @ real
              @ ^ [X6: A] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( at_top @ real )
              @ F4 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_7430_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X6: A] : ( ord_less @ B @ ( F3 @ X6 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L ) ) )
              @ F4 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_7431_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X6 ) )
        @ F4 )
     => ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F4 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F3 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_7432_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X6 ) )
        @ F4 )
     => ( ( filterlim @ A @ real
          @ ^ [X6: A] : ( inverse_inverse @ real @ ( F3 @ X6 ) )
          @ ( at_top @ real )
          @ F4 )
        = ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_7433_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X6: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X6 ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( inverse_inverse @ real @ ( F3 @ X6 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_7434_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F3: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X6: A] : ( ord_less @ real @ ( F3 @ X6 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X6: A] : ( inverse_inverse @ real @ ( F3 @ X6 ) )
          @ ( at_bot @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_7435_lhopital__at__top__at__top,axiom,
    ! [F3: real > real,A2: real,G: real > real,F9: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F3 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_top
thf(fact_7436_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filterlim_inverse_at_infinity
thf(fact_7437_lim__infinity__imp__sequentially,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: real > A,L: A] :
          ( ( filterlim @ real @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( semiring_1_of_nat @ real @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% lim_infinity_imp_sequentially
thf(fact_7438_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [G: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X6: A] : ( inverse_inverse @ B @ ( G @ X6 ) )
            @ ( topolo174197925503356063within @ B @ ( zero_zero @ B ) @ ( top_top @ ( set @ B ) ) )
            @ F4 )
          = ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 ) ) ) ).

% filterlim_inverse_at_iff
thf(fact_7439_lhopital,axiom,
    ! [F3: real > real,X2: real,G: real > real,G4: real > real,F9: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] :
                ( ( G @ X6 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] :
                  ( ( G4 @ X6 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_7440_lhopital__right__at__top__at__top,axiom,
    ! [F3: real > real,A2: real,G: real > real,F9: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F3 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
thf(fact_7441_lhopital__at__top__at__bot,axiom,
    ! [F3: real > real,A2: real,G: real > real,F9: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F3 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_bot
thf(fact_7442_lhopital__left__at__top__at__top,axiom,
    ! [F3: real > real,A2: real,G: real > real,F9: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F3 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
thf(fact_7443_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,C2: A,F4: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F4 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X6: A] : ( divide_divide @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_7444_lhospital__at__top__at__top,axiom,
    ! [G: real > real,G4: real > real,F3: real > real,F9: real > real,X2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X6: real] :
              ( ( G4 @ X6 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_7445_lhopital__at__top,axiom,
    ! [G: real > real,X2: real,G4: real > real,F3: real > real,F9: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X6: real] :
              ( ( G4 @ X6 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_7446_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G4: real > real,F9: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] :
                ( ( G0 @ X6 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] :
                  ( ( G4 @ X6 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X6: real] : ( has_field_derivative @ real @ F0 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X6: real] : ( has_field_derivative @ real @ G0 @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X6: real] : ( divide_divide @ real @ ( F0 @ X6 ) @ ( G0 @ X6 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_7447_lhopital__right,axiom,
    ! [F3: real > real,X2: real,G: real > real,G4: real > real,F9: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] :
                ( ( G @ X6 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] :
                  ( ( G4 @ X6 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
           => ( ( eventually @ real
                @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
             => ( ( eventually @ real
                  @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_7448_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X2 ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_7449_lhopital__left,axiom,
    ! [F3: real > real,X2: real,G: real > real,G4: real > real,F9: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] :
                ( ( G @ X6 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] :
                  ( ( G4 @ X6 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
           => ( ( eventually @ real
                @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
             => ( ( eventually @ real
                  @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_7450_lhopital__right__at__top__at__bot,axiom,
    ! [F3: real > real,A2: real,G: real > real,F9: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F3 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
thf(fact_7451_lhopital__left__at__top__at__bot,axiom,
    ! [F3: real > real,A2: real,G: real > real,F9: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F3 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
thf(fact_7452_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,L: A] :
          ( ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) )
          = ( filterlim @ A @ A @ ( comp @ A @ A @ A @ F3 @ ( inverse_inverse @ A ) ) @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% lim_at_infinity_0
thf(fact_7453_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,L: A] :
          ( ( filterlim @ A @ A
            @ ^ [X6: A] : ( F3 @ ( divide_divide @ A @ ( one_one @ A ) @ X6 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_7454_lhopital__right__0__at__top,axiom,
    ! [G: real > real,G4: real > real,F3: real > real,F9: real > real,X2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X6: real] :
              ( ( G4 @ X6 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_7455_lhopital__right__at__top,axiom,
    ! [G: real > real,X2: real,G4: real > real,F3: real > real,F9: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
     => ( ( eventually @ real
          @ ^ [X6: real] :
              ( ( G4 @ X6 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X6: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X6: real] : ( has_field_derivative @ real @ G @ ( G4 @ X6 ) @ ( topolo174197925503356063within @ real @ X6 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F9 @ X6 ) @ ( G4 @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X6: real] : ( divide_divide @ real @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_7456_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F7: filter @ A] :
            ? [Y: B,K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X6: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F5 @ X6 ) @ Y ) @ K6 )
                @ F7 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_7457_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F7: filter @ A] :
            ? [K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X6: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X6 ) ) @ K6 )
                @ F7 ) ) ) ) ) ).

% Bfun_def
thf(fact_7458_eventually__sequentially__Suc,axiom,
    ! [P3: nat > $o] :
      ( ( eventually @ nat
        @ ^ [I: nat] : ( P3 @ ( suc @ I ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P3 @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_Suc
thf(fact_7459_eventually__sequentially__seg,axiom,
    ! [P3: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N2: nat] : ( P3 @ ( plus_plus @ nat @ N2 @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P3 @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_7460_eventually__False__sequentially,axiom,
    ~ ( eventually @ nat
      @ ^ [N2: nat] : $false
      @ ( at_top @ nat ) ) ).

% eventually_False_sequentially
thf(fact_7461_sequentially__offset,axiom,
    ! [P3: nat > $o,K: nat] :
      ( ( eventually @ nat @ P3 @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I: nat] : ( P3 @ ( plus_plus @ nat @ I @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_7462_summable__cong,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > A] :
          ( ( eventually @ nat
            @ ^ [X6: nat] :
                ( ( F3 @ X6 )
                = ( G @ X6 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ A @ F3 )
            = ( summable @ A @ G ) ) ) ) ).

% summable_cong
thf(fact_7463_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N2 ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_7464_le__sequentially,axiom,
    ! [F4: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F4 @ ( at_top @ nat ) )
      = ( ! [N6: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N6 ) @ F4 ) ) ) ).

% le_sequentially
thf(fact_7465_Bfun__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [C2: B,F4: filter @ A] :
          ( bfun @ A @ B
          @ ^ [Uu3: A] : C2
          @ F4 ) ) ).

% Bfun_const
thf(fact_7466_Bseq__minus__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( uminus_uminus @ A @ ( X15 @ N2 ) )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) ) ) ) ).

% Bseq_minus_iff
thf(fact_7467_Bseq__subseq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > nat] :
          ( ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X6: nat] : ( F3 @ ( G @ X6 ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_subseq
thf(fact_7468_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ).

% Bseq_Suc_iff
thf(fact_7469_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X15 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_7470_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X15 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_7471_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X6: nat] : ( plus_plus @ A @ ( F3 @ X6 ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_7472_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X6: nat] : ( plus_plus @ A @ ( F3 @ X6 ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_7473_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: nat > A,G: nat > A] :
          ( ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X6: nat] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_7474_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X2: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I4: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I4 ) )
             => ( ! [I4: nat] : ( member @ A @ X2 @ ( A8 @ I4 ) )
               => ~ ! [S9: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S9 )
                     => ( ( member @ A @ X2 @ S9 )
                       => ( eventually @ nat
                          @ ^ [I: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I ) @ S9 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_7475_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F3: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X6: nat] : ( times_times @ A @ C2 @ ( F3 @ X6 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_7476_filterlim__int__of__nat__at__topD,axiom,
    ! [A: $tType,F3: int > A,F4: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X6: nat] : ( F3 @ ( semiring_1_of_nat @ int @ X6 ) )
        @ F4
        @ ( at_top @ nat ) )
     => ( filterlim @ int @ A @ F3 @ F4 @ ( at_top @ int ) ) ) ).

% filterlim_int_of_nat_at_topD
thf(fact_7477_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) @ ( G @ N2 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_7478_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [N9: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X15 @ N9 ) ) @ K10 ) ) ) ) ).

% BseqD
thf(fact_7479_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
         => ~ ! [K10: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
               => ~ ! [N9: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X15 @ N9 ) ) @ K10 ) ) ) ) ).

% BseqE
thf(fact_7480_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K5: real,X15: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
         => ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X15 @ N3 ) ) @ K5 )
           => ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_7481_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
          = ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X15 @ N2 ) ) @ K6 ) ) ) ) ) ).

% Bseq_def
thf(fact_7482_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X15 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_7483_Bseq__realpow,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X2 ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_7484_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X15 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_7485_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,K5: real,F4: filter @ A] :
          ( ( eventually @ A
            @ ^ [X6: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) ) @ K5 )
            @ F4 )
         => ( bfun @ A @ B @ F3 @ F4 ) ) ) ).

% BfunI
thf(fact_7486_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
          = ( ? [K2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K2 )
                & ? [N6: nat] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X15 @ N2 ) @ ( uminus_uminus @ A @ ( X15 @ N6 ) ) ) ) @ K2 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_7487_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
          = ( ? [K2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K2 )
                & ? [X6: A] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X15 @ N2 ) @ ( uminus_uminus @ A @ X6 ) ) ) @ K2 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_7488_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( bfun @ B @ A
              @ ^ [X6: B] : ( inverse_inverse @ A @ ( F3 @ X6 ) )
              @ F4 ) ) ) ) ).

% Bfun_inverse
thf(fact_7489_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( bfun @ A @ B @ F3 @ F4 )
         => ~ ! [B9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B9 )
               => ~ ( eventually @ A
                    @ ^ [X6: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) ) @ B9 )
                    @ F4 ) ) ) ) ).

% BfunE
thf(fact_7490_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A5: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A5 )
               => ! [B4: nat] :
                    ( ( ord_less @ nat @ A5 @ B4 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or3652927894154168847AtMost @ nat @ A5 @ B4 ) ) ) @ ( G @ A5 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_bounded_partials
thf(fact_7491_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M4: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ M4 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N2 ) ) ) @ ( G @ M4 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_Cauchy'
thf(fact_7492_eventually__all__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ B )
     => ! [P3: A > B > $o,Net: filter @ A] :
          ( ! [Y5: B] :
              ( eventually @ A
              @ ^ [X6: A] : ( P3 @ X6 @ Y5 )
              @ Net )
         => ( eventually @ A
            @ ^ [X6: A] :
              ! [X8: B] : ( P3 @ X6 @ X8 )
            @ Net ) ) ) ).

% eventually_all_finite
thf(fact_7493_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P3: A > $o] :
          ( ( eventually @ A @ P3 @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X6: A] :
              ! [Y: A] :
                ( ( ord_less_eq @ A @ X6 @ Y )
               => ( P3 @ Y ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_7494_Collect__all__eq,axiom,
    ! [A: $tType,B: $tType,P3: A > B > $o] :
      ( ( collect @ A
        @ ^ [X6: A] :
          ! [X8: B] : ( P3 @ X6 @ X8 ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [Y: B] :
              ( collect @ A
              @ ^ [X6: A] : ( P3 @ X6 @ Y ) )
          @ ( top_top @ ( set @ B ) ) ) ) ) ).

% Collect_all_eq
thf(fact_7495_finite__set__of__finite__funs,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B5: set @ B,D2: B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ B5 )
       => ( finite_finite2 @ ( A > B )
          @ ( collect @ ( A > B )
            @ ^ [F5: A > B] :
              ! [X6: A] :
                ( ( ( member @ A @ X6 @ A3 )
                 => ( member @ B @ ( F5 @ X6 ) @ B5 ) )
                & ( ~ ( member @ A @ X6 @ A3 )
                 => ( ( F5 @ X6 )
                    = D2 ) ) ) ) ) ) ) ).

% finite_set_of_finite_funs
thf(fact_7496_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P2: A > $o] :
              ( the @ A
              @ ^ [X6: A] :
                  ( ( P2 @ X6 )
                  & ! [Y: A] :
                      ( ( P2 @ Y )
                     => ( ord_less_eq @ A @ Y @ X6 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_7497_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P3: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F6: nat > A] :
                ( ! [N9: nat] : ( ord_less @ A @ A2 @ ( F6 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ A @ ( F6 @ N9 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F6 )
                   => ( ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N2: nat] : ( P3 @ ( F6 @ N2 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_7498_decseq__const,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [K: A] :
          ( order_antimono @ nat @ A
          @ ^ [X6: nat] : K ) ) ).

% decseq_const
thf(fact_7499_GreatestI__nat,axiom,
    ! [P3: nat > $o,K: nat,B2: nat] :
      ( ( P3 @ K )
     => ( ! [Y5: nat] :
            ( ( P3 @ Y5 )
           => ( ord_less_eq @ nat @ Y5 @ B2 ) )
       => ( P3 @ ( order_Greatest @ nat @ P3 ) ) ) ) ).

% GreatestI_nat
thf(fact_7500_Greatest__le__nat,axiom,
    ! [P3: nat > $o,K: nat,B2: nat] :
      ( ( P3 @ K )
     => ( ! [Y5: nat] :
            ( ( P3 @ Y5 )
           => ( ord_less_eq @ nat @ Y5 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P3 ) ) ) ) ).

% Greatest_le_nat
thf(fact_7501_GreatestI__ex__nat,axiom,
    ! [P3: nat > $o,B2: nat] :
      ( ? [X_1: nat] : ( P3 @ X_1 )
     => ( ! [Y5: nat] :
            ( ( P3 @ Y5 )
           => ( ord_less_eq @ nat @ Y5 @ B2 ) )
       => ( P3 @ ( order_Greatest @ nat @ P3 ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_7502_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I3: nat] :
          ( ( order_antimono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ ( suc @ I3 ) ) @ ( A3 @ I3 ) ) ) ) ).

% decseq_SucD
thf(fact_7503_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X15: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X15 @ ( suc @ N3 ) ) @ ( X15 @ N3 ) )
         => ( order_antimono @ nat @ A @ X15 ) ) ) ).

% decseq_SucI
thf(fact_7504_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F5 @ ( suc @ N2 ) ) @ ( F5 @ N2 ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_7505_nhds__countable,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X2: A] :
          ~ ! [X18: nat > ( set @ A )] :
              ( ( order_antimono @ nat @ ( set @ A ) @ X18 )
             => ( ! [N9: nat] : ( topolo1002775350975398744n_open @ A @ ( X18 @ N9 ) )
               => ( ! [N9: nat] : ( member @ A @ X2 @ ( X18 @ N9 ) )
                 => ( ( topolo7230453075368039082e_nhds @ A @ X2 )
                   != ( complete_Inf_Inf @ ( filter @ A )
                      @ ( image @ nat @ ( filter @ A )
                        @ ^ [N2: nat] : ( principal @ A @ ( X18 @ N2 ) )
                        @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ) ).

% nhds_countable
thf(fact_7506_LIMSEQ__INF,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X15: nat > A] :
          ( ( order_antimono @ nat @ A @ X15 )
         => ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ ( complete_Inf_Inf @ A @ ( image @ nat @ A @ X15 @ ( top_top @ ( set @ nat ) ) ) ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_INF
thf(fact_7507_INF__Lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X15: nat > A,L: A] :
          ( ( order_antimono @ nat @ A @ X15 )
         => ( ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ nat @ A @ X15 @ ( top_top @ ( set @ nat ) ) ) )
              = L ) ) ) ) ).

% INF_Lim
thf(fact_7508_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X15: B > C,L5: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S10: nat > B] :
                ( ! [N9: nat] : ( ord_less @ B @ A2 @ ( S10 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ B @ ( S10 @ N9 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S10 )
                   => ( ( filterlim @ nat @ B @ S10 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N2: nat] : ( X15 @ ( S10 @ N2 ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X15 @ ( topolo7230453075368039082e_nhds @ C @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_7509_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X2 @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
             => ( ( Deg2 = Xa )
                & ! [X7: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                   => ( vEBT_VEBT_valid @ X7 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                    & ! [X6: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi2: nat,Ma3: nat] :
                        ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                        & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I: nat] :
                            ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X8 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                        & ( ( Mi2 = Ma3 )
                         => ! [X6: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                        & ( ( Mi2 != Ma3 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                            & ! [X6: nat] :
                                ( ( ord_less @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X6 )
                                 => ( ( ord_less @ nat @ Mi2 @ X6 )
                                    & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_7510_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X2 @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
             => ~ ( ( Deg2 = Xa )
                  & ! [X: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                      & ! [X6: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi2: nat,Ma3: nat] :
                          ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                          & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I: nat] :
                              ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X8 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                          & ( ( Mi2 = Ma3 )
                           => ! [X6: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                               => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                          & ( ( Mi2 != Ma3 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                              & ! [X6: nat] :
                                  ( ( ord_less @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X6 )
                                   => ( ( ord_less @ nat @ Mi2 @ X6 )
                                      & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_7511_finite__Collect__bounded__ex,axiom,
    ! [B: $tType,A: $tType,P3: A > $o,Q: B > A > $o] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
     => ( ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [X6: B] :
              ? [Y: A] :
                ( ( P3 @ Y )
                & ( Q @ X6 @ Y ) ) ) )
        = ( ! [Y: A] :
              ( ( P3 @ Y )
             => ( finite_finite2 @ B
                @ ( collect @ B
                  @ ^ [X6: B] : ( Q @ X6 @ Y ) ) ) ) ) ) ) ).

% finite_Collect_bounded_ex
thf(fact_7512_INF__bool__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [A7: set @ A,F5: A > $o] : ( complete_Inf_Inf @ $o @ ( image @ A @ $o @ F5 @ A7 ) ) )
      = ( ball @ A ) ) ).

% INF_bool_eq
thf(fact_7513_Ball__def__raw,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P2: A > $o] :
          ! [X6: A] :
            ( ( member @ A @ X6 @ A7 )
           => ( P2 @ X6 ) ) ) ) ).

% Ball_def_raw
thf(fact_7514_eventually__ball__finite,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,P3: B > A > $o,Net: filter @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ A3 )
           => ( eventually @ B
              @ ^ [Y: B] : ( P3 @ Y @ X7 )
              @ Net ) )
       => ( eventually @ B
          @ ^ [X6: B] :
            ! [Y: A] :
              ( ( member @ A @ Y @ A3 )
             => ( P3 @ X6 @ Y ) )
          @ Net ) ) ) ).

% eventually_ball_finite
thf(fact_7515_eventually__ball__finite__distrib,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,P3: B > A > $o,Net: filter @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( eventually @ B
          @ ^ [X6: B] :
            ! [Y: A] :
              ( ( member @ A @ Y @ A3 )
             => ( P3 @ X6 @ Y ) )
          @ Net )
        = ( ! [X6: A] :
              ( ( member @ A @ X6 @ A3 )
             => ( eventually @ B
                @ ^ [Y: B] : ( P3 @ Y @ X6 )
                @ Net ) ) ) ) ) ).

% eventually_ball_finite_distrib
thf(fact_7516_eventually__ex,axiom,
    ! [B: $tType,A: $tType,P3: A > B > $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X6: A] :
          ? [X8: B] : ( P3 @ X6 @ X8 )
        @ F4 )
      = ( ? [Y8: A > B] :
            ( eventually @ A
            @ ^ [X6: A] : ( P3 @ X6 @ ( Y8 @ X6 ) )
            @ F4 ) ) ) ).

% eventually_ex
thf(fact_7517_Union__SetCompr__eq,axiom,
    ! [B: $tType,A: $tType,F3: B > ( set @ A ),P3: B > $o] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [Uu3: set @ A] :
            ? [X6: B] :
              ( ( Uu3
                = ( F3 @ X6 ) )
              & ( P3 @ X6 ) ) ) )
      = ( collect @ A
        @ ^ [A5: A] :
          ? [X6: B] :
            ( ( P3 @ X6 )
            & ( member @ A @ A5 @ ( F3 @ X6 ) ) ) ) ) ).

% Union_SetCompr_eq
thf(fact_7518_Ball__comp__iff,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: B > ( set @ C ),F3: C > $o,G: A > B] :
      ( ( comp @ B @ $o @ A
        @ ^ [X6: B] :
          ! [Y: C] :
            ( ( member @ C @ Y @ ( A3 @ X6 ) )
           => ( F3 @ Y ) )
        @ G )
      = ( ^ [X6: A] :
          ! [Y: C] :
            ( ( member @ C @ Y @ ( comp @ B @ ( set @ C ) @ A @ A3 @ G @ X6 ) )
           => ( F3 @ Y ) ) ) ) ).

% Ball_comp_iff
thf(fact_7519_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa: list @ A] :
      ( ~ ( sorted_wrt @ A @ X2 @ Xa )
     => ~ ! [X7: A,Ys4: list @ A] :
            ( ( Xa
              = ( cons @ A @ X7 @ Ys4 ) )
           => ( ! [Xa2: A] :
                  ( ( member @ A @ Xa2 @ ( set2 @ A @ Ys4 ) )
                 => ( X2 @ X7 @ Xa2 ) )
              & ( sorted_wrt @ A @ X2 @ Ys4 ) ) ) ) ).

% sorted_wrt.elims(3)
thf(fact_7520_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P3: A > A > $o,X2: A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P3 @ ( cons @ A @ X2 @ Ys ) )
      = ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Ys ) )
           => ( P3 @ X2 @ X6 ) )
        & ( sorted_wrt @ A @ P3 @ Ys ) ) ) ).

% sorted_wrt.simps(2)
thf(fact_7521_open__Collect__ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: B > A > $o] :
          ( ! [I2: B] : ( topolo1002775350975398744n_open @ A @ ( collect @ A @ ( P3 @ I2 ) ) )
         => ( topolo1002775350975398744n_open @ A
            @ ( collect @ A
              @ ^ [X6: A] :
                ? [I: B] : ( P3 @ I @ X6 ) ) ) ) ) ).

% open_Collect_ex
thf(fact_7522_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X6: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X6 @ Y ) )
              & ( ord_less @ A @ Y @ X6 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_7523_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X6: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X6 @ Y ) )
              & ( ord_less @ A @ X6 @ Y ) ) ) ) ) ).

% open_subdiagonal
thf(fact_7524_open__diagonal__complement,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X6: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X6 @ Y ) )
              & ( X6 != Y ) ) ) ) ) ).

% open_diagonal_complement
thf(fact_7525_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys2: list @ A] :
                ? [Us2: list @ A,Z6: A,Z5: A,Vs2: list @ A] :
                  ( ( Xs2
                    = ( append @ A @ Us2 @ ( cons @ A @ Z6 @ Vs2 ) ) )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z6 @ Z5 ) @ R5 )
                  & ( Ys2
                    = ( append @ A @ Us2 @ ( cons @ A @ Z5 @ Vs2 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_7526_ran__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ A @ B )
      = ( ^ [M4: A > ( option @ B )] :
            ( collect @ B
            @ ^ [B4: B] :
              ? [A5: A] :
                ( ( M4 @ A5 )
                = ( some @ B @ B4 ) ) ) ) ) ).

% ran_def
thf(fact_7527_finite__image__set2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P3: A > $o,Q: B > $o,F3: A > B > C] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
     => ( ( finite_finite2 @ B @ ( collect @ B @ Q ) )
       => ( finite_finite2 @ C
          @ ( collect @ C
            @ ^ [Uu3: C] :
              ? [X6: A,Y: B] :
                ( ( Uu3
                  = ( F3 @ X6 @ Y ) )
                & ( P3 @ X6 )
                & ( Q @ Y ) ) ) ) ) ) ).

% finite_image_set2
thf(fact_7528_finite__image__set,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F3: A > B] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
     => ( finite_finite2 @ B
        @ ( collect @ B
          @ ^ [Uu3: B] :
            ? [X6: A] :
              ( ( Uu3
                = ( F3 @ X6 ) )
              & ( P3 @ X6 ) ) ) ) ) ).

% finite_image_set
thf(fact_7529_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A7: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z6: list @ A] :
              ? [X6: A,Xs2: list @ A] :
                ( ( Z6
                  = ( cons @ A @ X6 @ Xs2 ) )
                & ( member @ A @ X6 @ A7 )
                & ( member @ ( list @ A ) @ Xs2 @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_7530_INTER__eq,axiom,
    ! [B: $tType,A: $tType,B5: B > ( set @ A ),A3: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) )
      = ( collect @ A
        @ ^ [Y: A] :
          ! [X6: B] :
            ( ( member @ B @ X6 @ A3 )
           => ( member @ A @ Y @ ( B5 @ X6 ) ) ) ) ) ).

% INTER_eq
thf(fact_7531_Collect__ball__eq,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,P3: A > B > $o] :
      ( ( collect @ A
        @ ^ [X6: A] :
          ! [Y: B] :
            ( ( member @ B @ Y @ A3 )
           => ( P3 @ X6 @ Y ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [Y: B] :
              ( collect @ A
              @ ^ [X6: A] : ( P3 @ X6 @ Y ) )
          @ A3 ) ) ) ).

% Collect_ball_eq
thf(fact_7532_full__SetCompr__eq,axiom,
    ! [A: $tType,B: $tType,F3: B > A] :
      ( ( collect @ A
        @ ^ [U2: A] :
          ? [X6: B] :
            ( U2
            = ( F3 @ X6 ) ) )
      = ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) ) ).

% full_SetCompr_eq
thf(fact_7533_Setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B] :
      ( ( collect @ A
        @ ^ [Uu3: A] :
          ? [X6: B] :
            ( ( Uu3
              = ( F3 @ X6 ) )
            & ( member @ B @ X6 @ A3 ) ) )
      = ( image @ B @ A @ F3 @ A3 ) ) ).

% Setcompr_eq_image
thf(fact_7534_setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F3: B > A,P3: B > $o] :
      ( ( collect @ A
        @ ^ [Uu3: A] :
          ? [X6: B] :
            ( ( Uu3
              = ( F3 @ X6 ) )
            & ( P3 @ X6 ) ) )
      = ( image @ B @ A @ F3 @ ( collect @ B @ P3 ) ) ) ).

% setcompr_eq_image
thf(fact_7535_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X6: A] :
                    ( ( member @ A @ X6 @ A7 )
                   => ( ord_less_eq @ A @ X6 @ B4 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_7536_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X6: A] :
                    ( ( member @ A @ X6 @ A7 )
                   => ( ord_less_eq @ A @ B4 @ X6 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_7537_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys2: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = ( size_size @ ( list @ A ) @ Ys2 ) )
                  & ? [Xys2: list @ A,X6: A,Y: A,Xs6: list @ A,Ys7: list @ A] :
                      ( ( Xs2
                        = ( append @ A @ Xys2 @ ( cons @ A @ X6 @ Xs6 ) ) )
                      & ( Ys2
                        = ( append @ A @ Xys2 @ ( cons @ A @ Y @ Ys7 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Y ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_7538_Collect__ex__eq,axiom,
    ! [A: $tType,B: $tType,P3: A > B > $o] :
      ( ( collect @ A
        @ ^ [X6: A] :
          ? [X8: B] : ( P3 @ X6 @ X8 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [Y: B] :
              ( collect @ A
              @ ^ [X6: A] : ( P3 @ X6 @ Y ) )
          @ ( top_top @ ( set @ B ) ) ) ) ) ).

% Collect_ex_eq
thf(fact_7539_relcomp__unfold,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcomp @ A @ C @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ C ),S4: set @ ( product_prod @ C @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [X6: A,Z6: B] :
                ? [Y: C] :
                  ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X6 @ Y ) @ R5 )
                  & ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y @ Z6 ) @ S4 ) ) ) ) ) ) ).

% relcomp_unfold
thf(fact_7540_takeWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o,Ys: list @ A] :
      ( ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
           => ( P3 @ X7 ) )
       => ( ( takeWhile @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( takeWhile @ A @ P3 @ Ys ) ) ) )
      & ( ~ ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
             => ( P3 @ X ) )
       => ( ( takeWhile @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P3 @ Xs ) ) ) ) ).

% takeWhile_append
thf(fact_7541_dropWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P3: A > $o,Ys: list @ A] :
      ( ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
           => ( P3 @ X7 ) )
       => ( ( dropWhile @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
          = ( dropWhile @ A @ P3 @ Ys ) ) )
      & ( ~ ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
             => ( P3 @ X ) )
       => ( ( dropWhile @ A @ P3 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P3 @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append
thf(fact_7542_graph__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M4: A > ( option @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A5: A,B4: B] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ A5 @ B4 ) )
                & ( ( M4 @ A5 )
                  = ( some @ B @ B4 ) ) ) ) ) ) ).

% graph_def
thf(fact_7543_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa: list @ A,Y2: $o] :
      ( ( ( sorted_wrt @ A @ X2 @ Xa )
        = Y2 )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ~ Y2 )
       => ~ ! [X7: A,Ys4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X7 @ Ys4 ) )
             => ( Y2
                = ( ~ ( ! [Y: A] :
                          ( ( member @ A @ Y @ ( set2 @ A @ Ys4 ) )
                         => ( X2 @ X7 @ Y ) )
                      & ( sorted_wrt @ A @ X2 @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.elims(1)
thf(fact_7544_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa: list @ A] :
      ( ( sorted_wrt @ A @ X2 @ Xa )
     => ( ( Xa
         != ( nil @ A ) )
       => ~ ! [X7: A,Ys4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X7 @ Ys4 ) )
             => ~ ( ! [Xa3: A] :
                      ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                     => ( X2 @ X7 @ Xa3 ) )
                  & ( sorted_wrt @ A @ X2 @ Ys4 ) ) ) ) ) ).

% sorted_wrt.elims(2)
thf(fact_7545_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs2: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs2 @ I ) )
                & ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_7546_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X6: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList ) )
           => ( vEBT_VEBT_valid @ X6 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
            & ! [X6: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList ) )
               => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi2: nat,Ma3: nat] :
                ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I: nat] :
                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I ) ) )
                & ( ( Mi2 = Ma3 )
                 => ! [X6: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                & ( ( Mi2 != Ma3 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma3 )
                    & ! [X6: nat] :
                        ( ( ord_less @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X6 )
                         => ( ( ord_less @ nat @ Mi2 @ X6 )
                            & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_7547_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_valid @ X2 @ Xa )
        = Y2 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Y2
            = ( ( Xa
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
             => ( Y2
                = ( ~ ( ( Deg2 = Xa )
                      & ! [X6: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ( vEBT_VEBT_valid @ X6 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                          & ! [X6: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I: nat] :
                                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                              & ( ( Mi2 = Ma3 )
                               => ! [X6: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                              & ( ( Mi2 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                                  & ! [X6: nat] :
                                      ( ( ord_less @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X6 )
                                       => ( ( ord_less @ nat @ Mi2 @ X6 )
                                          & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_7548_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) @ Xa ) )
                 => ( ( Deg2 = Xa )
                    & ! [X7: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X7 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ( vEBT_VEBT_valid @ X7 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                        & ! [X6: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                           => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi2: nat,Ma3: nat] :
                            ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                            & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I: nat] :
                                ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X8 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                            & ( ( Mi2 = Ma3 )
                             => ! [X6: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                            & ( ( Mi2 != Ma3 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                                & ! [X6: nat] :
                                    ( ( ord_less @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X6 )
                                     => ( ( ord_less @ nat @ Mi2 @ X6 )
                                        & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_7549_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) @ Xa ) )
                 => ~ ( ( Deg2 = Xa )
                      & ! [X: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                          & ! [X6: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I: nat] :
                                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                              & ( ( Mi2 = Ma3 )
                               => ! [X6: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                              & ( ( Mi2 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                                  & ! [X6: nat] :
                                      ( ( ord_less @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X6 )
                                       => ( ( ord_less @ nat @ Mi2 @ X6 )
                                          & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_7550_Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X6: set @ A] :
                        ( ( member @ ( set @ A ) @ X6 @ A3 )
                       => ( member @ A @ ( F5 @ X6 ) @ X6 ) ) ) ) ) ) ) ) ).

% Inf_Sup
thf(fact_7551_SUP__INF__set,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [G: B > A,A3: set @ ( set @ B )] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ ( set @ B ) @ A
              @ ^ [X6: set @ B] : ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ X6 ) )
              @ A3 ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ ( set @ B ) @ A
              @ ^ [X6: set @ B] : ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ X6 ) )
              @ ( collect @ ( set @ B )
                @ ^ [Uu3: set @ B] :
                  ? [F5: ( set @ B ) > B] :
                    ( ( Uu3
                      = ( image @ ( set @ B ) @ B @ F5 @ A3 ) )
                    & ! [X6: set @ B] :
                        ( ( member @ ( set @ B ) @ X6 @ A3 )
                       => ( member @ B @ ( F5 @ X6 ) @ X6 ) ) ) ) ) ) ) ) ).

% SUP_INF_set
thf(fact_7552_INF__SUP__set,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [G: B > A,A3: set @ ( set @ B )] :
          ( ( complete_Inf_Inf @ A
            @ ( image @ ( set @ B ) @ A
              @ ^ [B8: set @ B] : ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B8 ) )
              @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ ( set @ B ) @ A
              @ ^ [B8: set @ B] : ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B8 ) )
              @ ( collect @ ( set @ B )
                @ ^ [Uu3: set @ B] :
                  ? [F5: ( set @ B ) > B] :
                    ( ( Uu3
                      = ( image @ ( set @ B ) @ B @ F5 @ A3 ) )
                    & ! [X6: set @ B] :
                        ( ( member @ ( set @ B ) @ X6 @ A3 )
                       => ( member @ B @ ( F5 @ X6 ) @ X6 ) ) ) ) ) ) ) ) ).

% INF_SUP_set
thf(fact_7553_Sup__Inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ( complete_Sup_Sup @ A @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A ) @ A3 ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X6: set @ A] :
                        ( ( member @ ( set @ A ) @ X6 @ A3 )
                       => ( member @ A @ ( F5 @ X6 ) @ X6 ) ) ) ) ) ) ) ) ).

% Sup_Inf
thf(fact_7554_Pow__Compl,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( pow2 @ A @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( collect @ ( set @ A )
        @ ^ [Uu3: set @ A] :
          ? [B8: set @ A] :
            ( ( Uu3
              = ( uminus_uminus @ ( set @ A ) @ B8 ) )
            & ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B8 ) ) ) ) ) ).

% Pow_Compl
thf(fact_7555_Inter__eq,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( set @ A ) )
      = ( ^ [A7: set @ ( set @ A )] :
            ( collect @ A
            @ ^ [X6: A] :
              ! [Y: set @ A] :
                ( ( member @ ( set @ A ) @ Y @ A7 )
               => ( member @ A @ X6 @ Y ) ) ) ) ) ).

% Inter_eq
thf(fact_7556_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X6: set @ A] :
                        ( ( member @ ( set @ A ) @ X6 @ A3 )
                       => ( member @ A @ ( F5 @ X6 ) @ X6 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_7557_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X6: set @ A] :
                        ( ( member @ ( set @ A ) @ X6 @ A3 )
                       => ( member @ A @ ( F5 @ X6 ) @ X6 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) ) ) ) ).

% Sup_Inf_le
thf(fact_7558_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X8: set @ int] :
          ( the @ int
          @ ^ [X6: int] :
              ( ( member @ int @ X6 @ X8 )
              & ! [Y: int] :
                  ( ( member @ int @ Y @ X8 )
                 => ( ord_less_eq @ int @ Y @ X6 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_7559_Union__maximal__sets,axiom,
    ! [A: $tType,F16: set @ ( set @ A )] :
      ( ( finite_finite2 @ ( set @ A ) @ F16 )
     => ( ( complete_Sup_Sup @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [T9: set @ A] :
                ( ( member @ ( set @ A ) @ T9 @ F16 )
                & ! [X6: set @ A] :
                    ( ( member @ ( set @ A ) @ X6 @ F16 )
                   => ~ ( ord_less @ ( set @ A ) @ T9 @ X6 ) ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ F16 ) ) ) ).

% Union_maximal_sets
thf(fact_7560_Inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( filter @ A ) )
      = ( ^ [S6: set @ ( filter @ A )] :
            ( complete_Sup_Sup @ ( filter @ A )
            @ ( collect @ ( filter @ A )
              @ ^ [F7: filter @ A] :
                ! [X6: filter @ A] :
                  ( ( member @ ( filter @ A ) @ X6 @ S6 )
                 => ( ord_less_eq @ ( filter @ A ) @ F7 @ X6 ) ) ) ) ) ) ).

% Inf_filter_def
thf(fact_7561_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_valid @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( Y2
                  = ( Xa
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( Y2
                    = ( ( Deg2 = Xa )
                      & ! [X6: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ( vEBT_VEBT_valid @ X6 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                          & ! [X6: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I: nat] :
                                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                              & ( ( Mi2 = Ma3 )
                               => ! [X6: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X8 ) ) )
                              & ( ( Mi2 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                                  & ! [X6: nat] :
                                      ( ( ord_less @ nat @ X6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X6 )
                                       => ( ( ord_less @ nat @ Mi2 @ X6 )
                                          & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) @ Xa ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_7562_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X6: set @ A] :
                        ( ( member @ ( set @ A ) @ X6 @ A3 )
                       => ( member @ A @ ( F5 @ X6 ) @ X6 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_7563_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N2: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys2: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = N2 )
                  & ( ( size_size @ ( list @ A ) @ Ys2 )
                    = N2 )
                  & ? [Xys2: list @ A,X6: A,Y: A,Xs6: list @ A,Ys7: list @ A] :
                      ( ( Xs2
                        = ( append @ A @ Xys2 @ ( cons @ A @ X6 @ Xs6 ) ) )
                      & ( Ys2
                        = ( append @ A @ Xys2 @ ( cons @ A @ Y @ Ys7 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Y ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_7564_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_7565_lexn__length,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexn @ A @ R @ N ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = N )
        & ( ( size_size @ ( list @ A ) @ Ys )
          = N ) ) ) ).

% lexn_length
thf(fact_7566_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R5 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_7567_finite__inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( inf_inf @ A @ A2 @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( collect @ A
              @ ^ [Uu3: A] :
                ? [B4: A] :
                  ( ( Uu3
                    = ( inf_inf @ A @ A2 @ B4 ) )
                  & ( member @ A @ B4 @ A3 ) ) ) ) ) ) ).

% finite_inf_Sup
thf(fact_7568_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F5: A > nat,R7: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X6: A,Y: A] :
                  ( ( ord_less @ nat @ ( F5 @ X6 ) @ ( F5 @ Y ) )
                  | ( ( ord_less_eq @ nat @ ( F5 @ X6 ) @ ( F5 @ Y ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Y ) @ R7 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_7569_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y6: set @ B,X15: set @ A,F4: filter @ B,F3: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ Y6 ) @ X15 )
     => ( ( eventually @ B
          @ ^ [X6: B] : ( member @ B @ X6 @ Y6 )
          @ F4 )
       => ( ( map_filter_on @ A @ C @ X15 @ F3 @ ( map_filter_on @ B @ A @ Y6 @ G @ F4 ) )
          = ( map_filter_on @ B @ C @ Y6 @ ( comp @ A @ C @ B @ F3 @ G ) @ F4 ) ) ) ) ).

% map_filter_on_comp
thf(fact_7570_eventually__map__filter__on,axiom,
    ! [B: $tType,A: $tType,X15: set @ A,F4: filter @ A,P3: B > $o,F3: A > B] :
      ( ( eventually @ A
        @ ^ [X6: A] : ( member @ A @ X6 @ X15 )
        @ F4 )
     => ( ( eventually @ B @ P3 @ ( map_filter_on @ A @ B @ X15 @ F3 @ F4 ) )
        = ( eventually @ A
          @ ^ [X6: A] :
              ( ( P3 @ ( F3 @ X6 ) )
              & ( member @ A @ X6 @ X15 ) )
          @ F4 ) ) ) ).

% eventually_map_filter_on
thf(fact_7571_mlex__iff,axiom,
    ! [A: $tType,X2: A,Y2: A,F3: A > nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( mlex_prod @ A @ F3 @ R3 ) )
      = ( ( ord_less @ nat @ ( F3 @ X2 ) @ ( F3 @ Y2 ) )
        | ( ( ( F3 @ X2 )
            = ( F3 @ Y2 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ).

% mlex_iff
thf(fact_7572_mlex__less,axiom,
    ! [A: $tType,F3: A > nat,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F3 @ X2 ) @ ( F3 @ Y2 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( mlex_prod @ A @ F3 @ R3 ) ) ) ).

% mlex_less
thf(fact_7573_in__measure,axiom,
    ! [A: $tType,X2: A,Y2: A,F3: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( measure @ A @ F3 ) )
      = ( ord_less @ nat @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) ) ).

% in_measure
thf(fact_7574_in__finite__psubset,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A3 @ B5 ) @ ( finite_psubset @ A ) )
      = ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
        & ( finite_finite2 @ A @ B5 ) ) ) ).

% in_finite_psubset
thf(fact_7575_finite__psubset__def,axiom,
    ! [A: $tType] :
      ( ( finite_psubset @ A )
      = ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
        @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
          @ ^ [A7: set @ A,B8: set @ A] :
              ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
              & ( finite_finite2 @ A @ B8 ) ) ) ) ) ).

% finite_psubset_def
thf(fact_7576_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F7: filter @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [P2: A > $o] :
                  ( ( eventually @ A @ P2 @ F7 )
                  & ! [X6: A,Y: A] :
                      ( ( ( P2 @ X6 )
                        & ( P2 @ Y ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ Y ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_7577_GMVT,axiom,
    ! [A2: real,B2: real,F3: real > real,G: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X7: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X7 )
              & ( ord_less_eq @ real @ X7 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
       => ( ! [X7: real] :
              ( ( ( ord_less @ real @ A2 @ X7 )
                & ( ord_less @ real @ X7 @ B2 ) )
             => ( differentiable @ real @ real @ F3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X7: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X7 )
                  & ( ord_less_eq @ real @ X7 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X7: real] :
                  ( ( ( ord_less @ real @ A2 @ X7 )
                    & ( ord_less @ real @ X7 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F3 @ F_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_7578_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q2: B > A,T3: B] :
          ( ( differentiable @ B @ A
            @ ^ [T2: B] : ( times_times @ A @ C2 @ ( Q2 @ T2 ) )
            @ ( topolo174197925503356063within @ B @ T3 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T3 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_7579_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q2: B > A,C2: A,T3: B] :
          ( ( differentiable @ B @ A
            @ ^ [T2: B] : ( times_times @ A @ ( Q2 @ T2 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T3 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T3 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_7580_differentiable__in__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: C > A,X2: C,S: set @ C] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( image @ C @ A @ G @ S ) ) )
         => ( ( differentiable @ C @ A @ G @ ( topolo174197925503356063within @ C @ X2 @ S ) )
           => ( differentiable @ C @ B
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S ) ) ) ) ) ).

% differentiable_in_compose
thf(fact_7581_differentiable__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > real,X2: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ real @ F3 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( differentiable @ A @ B
              @ ^ [X6: A] : ( real_V8093663219630862766scaleR @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% differentiable_scaleR
thf(fact_7582_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F3: A > B,X2: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( differentiable @ A @ B
              @ ^ [X6: A] : ( times_times @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% differentiable_mult
thf(fact_7583_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F4: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F3 @ F4 )
         => ( ( differentiable @ A @ B @ G @ F4 )
           => ( differentiable @ A @ B
              @ ^ [X6: A] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ F4 ) ) ) ) ).

% differentiable_add
thf(fact_7584_differentiable__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: B,F4: filter @ A] :
          ( differentiable @ A @ B
          @ ^ [Z6: A] : A2
          @ F4 ) ) ).

% differentiable_const
thf(fact_7585_differentiable__ident,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F4: filter @ A] :
          ( differentiable @ A @ A
          @ ^ [X6: A] : X6
          @ F4 ) ) ).

% differentiable_ident
thf(fact_7586_differentiable__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F4: filter @ A] :
          ( ( differentiable @ A @ B @ F3 @ F4 )
         => ( differentiable @ A @ B
            @ ^ [X6: A] : ( uminus_uminus @ B @ ( F3 @ X6 ) )
            @ F4 ) ) ) ).

% differentiable_minus
thf(fact_7587_differentiable__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F4: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F3 @ F4 )
         => ( ( differentiable @ A @ B @ G @ F4 )
           => ( differentiable @ A @ B
              @ ^ [X6: A] : ( minus_minus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ F4 ) ) ) ) ).

% differentiable_diff
thf(fact_7588_differentiable__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [S: set @ A,F3: A > B > C,Net: filter @ B] :
          ( ( finite_finite2 @ A @ S )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ S )
               => ( differentiable @ B @ C @ ( F3 @ X7 ) @ Net ) )
           => ( differentiable @ B @ C
              @ ^ [X6: B] :
                  ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [A5: A] : ( F3 @ A5 @ X6 )
                  @ S )
              @ Net ) ) ) ) ).

% differentiable_sum
thf(fact_7589_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,X2: A,S: set @ A,N: nat] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( differentiable @ A @ B
            @ ^ [X6: A] : ( power_power @ B @ ( F3 @ X6 ) @ N )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% differentiable_power
thf(fact_7590_differentiable__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: C > A,X2: C,S: set @ C] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( differentiable @ C @ A @ G @ ( topolo174197925503356063within @ C @ X2 @ S ) )
           => ( differentiable @ C @ B
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S ) ) ) ) ) ).

% differentiable_compose
thf(fact_7591_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,X2: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X2 @ S ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X6: A] : ( divide_divide @ B @ ( F3 @ X6 ) @ ( G @ X6 ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_7592_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,X2: A,S: set @ A] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( ( F3 @ X2 )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X6: A] : ( inverse_inverse @ B @ ( F3 @ X6 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ).

% differentiable_inverse
thf(fact_7593_nhds__generated__topology,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [T5: set @ ( set @ A ),X2: A] :
          ( ( ( topolo1002775350975398744n_open @ A )
            = ( topolo8378437560675496660pology @ A @ T5 ) )
         => ( ( topolo7230453075368039082e_nhds @ A @ X2 )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ ( set @ A ) @ ( filter @ A ) @ ( principal @ A )
                @ ( collect @ ( set @ A )
                  @ ^ [S6: set @ A] :
                      ( ( member @ ( set @ A ) @ S6 @ T5 )
                      & ( member @ A @ X2 @ S6 ) ) ) ) ) ) ) ) ).

% nhds_generated_topology
thf(fact_7594_continuous__at__Sup__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( topolo1944317154257567458pology @ A )
        & ( condit6923001295902523014norder @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F3: A > B,S3: set @ A] :
          ( ( order_antimono @ A @ B @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ ( complete_Sup_Sup @ A @ S3 ) @ ( set_ord_lessThan @ A @ ( complete_Sup_Sup @ A @ S3 ) ) ) @ F3 )
           => ( ( S3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit941137186595557371_above @ A @ S3 )
               => ( ( F3 @ ( complete_Sup_Sup @ A @ S3 ) )
                  = ( complete_Inf_Inf @ B @ ( image @ A @ B @ F3 @ S3 ) ) ) ) ) ) ) ) ).

% continuous_at_Sup_antimono
thf(fact_7595_bdd__above__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [I6: set @ B,A3: B > ( set @ A )] :
          ( ( finite_finite2 @ B @ I6 )
         => ( ( condit941137186595557371_above @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) )
            = ( ! [X6: B] :
                  ( ( member @ B @ X6 @ I6 )
                 => ( condit941137186595557371_above @ A @ ( A3 @ X6 ) ) ) ) ) ) ) ).

% bdd_above_UN
thf(fact_7596_differentiable__cnj__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: A > complex,X2: A,A3: set @ A] :
          ( ( differentiable @ A @ complex
            @ ^ [Z6: A] : ( cnj @ ( F3 @ Z6 ) )
            @ ( topolo174197925503356063within @ A @ X2 @ A3 ) )
          = ( differentiable @ A @ complex @ F3 @ ( topolo174197925503356063within @ A @ X2 @ A3 ) ) ) ) ).

% differentiable_cnj_iff
thf(fact_7597_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X15: set @ A,Y2: A] :
          ( ( X15
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X15 )
           => ( ( ord_less @ A @ Y2 @ ( complete_Sup_Sup @ A @ X15 ) )
              = ( ? [X6: A] :
                    ( ( member @ A @ X6 @ X15 )
                    & ( ord_less @ A @ Y2 @ X6 ) ) ) ) ) ) ) ).

% less_cSup_iff
thf(fact_7598_cSUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F3: B > A,A3: set @ B,Y2: A,I3: B] :
          ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F3 @ A3 ) )
         => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ Y2 )
           => ( ( member @ B @ I3 @ A3 )
             => ( ord_less @ A @ ( F3 @ I3 ) @ Y2 ) ) ) ) ) ).

% cSUP_lessD
thf(fact_7599_generate__topology__Union,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,S3: set @ ( set @ B ),K5: A > ( set @ B )] :
      ( ! [K3: A] :
          ( ( member @ A @ K3 @ I6 )
         => ( topolo8378437560675496660pology @ B @ S3 @ ( K5 @ K3 ) ) )
     => ( topolo8378437560675496660pology @ B @ S3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ K5 @ I6 ) ) ) ) ).

% generate_topology_Union
thf(fact_7600_less__cSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A3: set @ B,F3: B > A,A2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F3 @ A3 ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
              = ( ? [X6: B] :
                    ( ( member @ B @ X6 @ A3 )
                    & ( ord_less @ A @ A2 @ ( F3 @ X6 ) ) ) ) ) ) ) ) ).

% less_cSUP_iff
thf(fact_7601_cSup__cInf,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S3: set @ A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S3 )
           => ( ( complete_Sup_Sup @ A @ S3 )
              = ( complete_Inf_Inf @ A
                @ ( collect @ A
                  @ ^ [X6: A] :
                    ! [Y: A] :
                      ( ( member @ A @ Y @ S3 )
                     => ( ord_less_eq @ A @ Y @ X6 ) ) ) ) ) ) ) ) ).

% cSup_cInf
thf(fact_7602_cSUP__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A3: set @ C,B5: C > ( set @ D ),F3: D > B] :
          ( ( A3
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X7: C] :
                ( ( member @ C @ X7 @ A3 )
               => ( ( B5 @ X7 )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit941137186595557371_above @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image @ C @ ( set @ B )
                    @ ^ [X6: C] : ( image @ D @ B @ F3 @ ( B5 @ X6 ) )
                    @ A3 ) ) )
             => ( ( complete_Sup_Sup @ B @ ( image @ D @ B @ F3 @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ B5 @ A3 ) ) ) )
                = ( complete_Sup_Sup @ B
                  @ ( image @ C @ B
                    @ ^ [X6: C] : ( complete_Sup_Sup @ B @ ( image @ D @ B @ F3 @ ( B5 @ X6 ) ) )
                    @ A3 ) ) ) ) ) ) ) ).

% cSUP_UNION
thf(fact_7603_Bseq__bdd__above_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X15: nat > A] :
          ( ( bfun @ nat @ A @ X15 @ ( at_top @ nat ) )
         => ( condit941137186595557371_above @ real
            @ ( image @ nat @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( X15 @ N2 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% Bseq_bdd_above'
thf(fact_7604_continuous__at__Inf__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( topolo1944317154257567458pology @ A )
        & ( condit6923001295902523014norder @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F3: A > B,S3: set @ A] :
          ( ( order_antimono @ A @ B @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ ( complete_Inf_Inf @ A @ S3 ) @ ( set_ord_greaterThan @ A @ ( complete_Inf_Inf @ A @ S3 ) ) ) @ F3 )
           => ( ( S3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit1013018076250108175_below @ A @ S3 )
               => ( ( F3 @ ( complete_Inf_Inf @ A @ S3 ) )
                  = ( complete_Sup_Sup @ B @ ( image @ A @ B @ F3 @ S3 ) ) ) ) ) ) ) ) ).

% continuous_at_Inf_antimono
thf(fact_7605_MVT,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ( ! [X7: real] :
              ( ( ord_less @ real @ A2 @ X7 )
             => ( ( ord_less @ real @ X7 @ B2 )
               => ( differentiable @ real @ real @ F3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L2: real,Z2: real] :
              ( ( ord_less @ real @ A2 @ Z2 )
              & ( ord_less @ real @ Z2 @ B2 )
              & ( has_field_derivative @ real @ F3 @ L2 @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L2 ) ) ) ) ) ) ).

% MVT
thf(fact_7606_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ( condit1013018076250108175_below @ A
            @ ( image @ B @ A
              @ ^ [X6: B] : ( inf_inf @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ A3 ) )
          = ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) )
            & ( condit1013018076250108175_below @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% bdd_below_image_inf
thf(fact_7607_bdd__below__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [I6: set @ B,A3: B > ( set @ A )] :
          ( ( finite_finite2 @ B @ I6 )
         => ( ( condit1013018076250108175_below @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) )
            = ( ! [X6: B] :
                  ( ( member @ B @ X6 @ I6 )
                 => ( condit1013018076250108175_below @ A @ ( A3 @ X6 ) ) ) ) ) ) ) ).

% bdd_below_UN
thf(fact_7608_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F3: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ S )
               => ( ( cos @ A @ ( F3 @ X7 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X6: A] : ( tan @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_on_tan
thf(fact_7609_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ? [A8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ A8 )
                & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                  = ( collect @ A
                    @ ^ [X6: A] :
                        ( ( member @ A @ X6 @ S )
                        & ( ord_less @ real @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ) ) ).

% open_Collect_less_Int
thf(fact_7610_continuous__on__open__UN,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [S3: set @ A,A3: A > ( set @ B ),F3: B > C] :
          ( ! [S2: A] :
              ( ( member @ A @ S2 @ S3 )
             => ( topolo1002775350975398744n_open @ B @ ( A3 @ S2 ) ) )
         => ( ! [S2: A] :
                ( ( member @ A @ S2 @ S3 )
               => ( topolo81223032696312382ous_on @ B @ C @ ( A3 @ S2 ) @ F3 ) )
           => ( topolo81223032696312382ous_on @ B @ C @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ S3 ) ) @ F3 ) ) ) ) ).

% continuous_on_open_UN
thf(fact_7611_continuous__on__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [S: set @ A,F3: A > B,G: A > C] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ C @ S @ G )
           => ( topolo81223032696312382ous_on @ A @ ( product_prod @ B @ C ) @ S
              @ ^ [X6: A] : ( product_Pair @ B @ C @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_Pair
thf(fact_7612_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T3: set @ A,G: A > B,S: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T3 @ G )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ F3 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F3 @ S ) @ T3 )
             => ( topolo81223032696312382ous_on @ C @ B @ S
                @ ^ [X6: C] : ( G @ ( F3 @ X6 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_7613_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X15: set @ A,Y2: A] :
          ( ( X15
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X15 )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X15 ) @ Y2 )
              = ( ? [X6: A] :
                    ( ( member @ A @ X6 @ X15 )
                    & ( ord_less @ A @ X6 @ Y2 ) ) ) ) ) ) ) ).

% cInf_less_iff
thf(fact_7614_open__Collect__neq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topological_t2_space @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ( ( F3 @ X6 )
                   != ( G @ X6 ) ) ) ) ) ) ) ).

% open_Collect_neq
thf(fact_7615_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X6: A] : ( ord_less @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_7616_bounded__linear_Ocontinuous__on,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > B,S: set @ C,G: C > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ S
              @ ^ [X6: C] : ( F3 @ ( G @ X6 ) ) ) ) ) ) ).

% bounded_linear.continuous_on
thf(fact_7617_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F3: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X7: C] :
                  ( ( member @ C @ X7 @ S )
                 => ( ( F3 @ X7 )
                   != ( zero_zero @ real ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X6: C] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% continuous_on_powr
thf(fact_7618_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ S )
               => ( ( F3 @ X7 )
                 != ( zero_zero @ real ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X6: A] : ( ln_ln @ real @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_on_ln
thf(fact_7619_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ S )
               => ( ( F3 @ X7 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X6: A] : ( sgn_sgn @ B @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_on_sgn
thf(fact_7620_continuous__on__max,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A3: set @ A,F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ A3 @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ A3 @ G )
           => ( topolo81223032696312382ous_on @ A @ B @ A3
              @ ^ [X6: A] : ( ord_max @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_max
thf(fact_7621_continuous__on__rabs,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X6: A] : ( abs_abs @ real @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_rabs
thf(fact_7622_continuous__on__arsinh_H,axiom,
    ! [A3: set @ real,F3: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F3 )
     => ( topolo81223032696312382ous_on @ real @ real @ A3
        @ ^ [X6: real] : ( arsinh @ real @ ( F3 @ X6 ) ) ) ) ).

% continuous_on_arsinh'
thf(fact_7623_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F3: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F3 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X6: B] : ( times_times @ A @ ( F3 @ X6 ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_7624_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F3: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F3 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X6: B] : ( times_times @ A @ C2 @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_7625_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A3: set @ D,F3: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ A3
              @ ^ [X6: D] : ( times_times @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_7626_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ D,F3: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ A @ S
              @ ^ [X6: D] : ( times_times @ A @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_7627_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S: set @ D,F3: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X6: D] : ( plus_plus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_7628_continuous__on__arctan,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X6: A] : ( arctan @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_arctan
thf(fact_7629_continuous__on__pochhammer_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ C,F3: C > A,N: nat] :
          ( ( topolo81223032696312382ous_on @ C @ A @ S @ F3 )
         => ( topolo81223032696312382ous_on @ C @ A @ S
            @ ^ [X6: C] : ( comm_s3205402744901411588hammer @ A @ ( F3 @ X6 ) @ N ) ) ) ) ).

% continuous_on_pochhammer'
thf(fact_7630_continuous__on__pochhammer,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A3: set @ A,N: nat] :
          ( topolo81223032696312382ous_on @ A @ A @ A3
          @ ^ [Z6: A] : ( comm_s3205402744901411588hammer @ A @ Z6 @ N ) ) ) ).

% continuous_on_pochhammer
thf(fact_7631_continuous__on__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [S: set @ D,F3: D > real,G: D > C] :
          ( ( topolo81223032696312382ous_on @ D @ real @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ C @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ C @ S
              @ ^ [X6: D] : ( real_V8093663219630862766scaleR @ C @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_scaleR
thf(fact_7632_continuous__on__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ B @ S
            @ ^ [X6: A] : ( cos @ B @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_cos
thf(fact_7633_continuous__on__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ B @ S
            @ ^ [X6: A] : ( sin @ B @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_sin
thf(fact_7634_continuous__on__exp,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ S @ F3 )
         => ( topolo81223032696312382ous_on @ C @ A @ S
            @ ^ [X6: C] : ( exp @ A @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_exp
thf(fact_7635_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X6: A] : ( sqrt @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_real_sqrt
thf(fact_7636_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A3: set @ C,F3: C > B,G: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A3 @ F3 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A3 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ A3
              @ ^ [X6: C] : ( power_power @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_7637_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S: set @ C,F3: C > B,N: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S @ F3 )
         => ( topolo81223032696312382ous_on @ C @ B @ S
            @ ^ [X6: C] : ( power_power @ B @ ( F3 @ X6 ) @ N ) ) ) ) ).

% continuous_on_power
thf(fact_7638_continuous__on__id,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A] :
          ( topolo81223032696312382ous_on @ A @ A @ S
          @ ^ [X6: A] : X6 ) ) ).

% continuous_on_id
thf(fact_7639_continuous__on__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,C2: B] :
          ( topolo81223032696312382ous_on @ A @ B @ S
          @ ^ [X6: A] : C2 ) ) ).

% continuous_on_const
thf(fact_7640_continuous__on__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [S: set @ C,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
         => ( topolo81223032696312382ous_on @ C @ A @ S
            @ ^ [X6: C] : ( real_Vector_of_real @ A @ ( G @ X6 ) ) ) ) ) ).

% continuous_on_of_real
thf(fact_7641_continuous__on__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X6: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_norm
thf(fact_7642_continuous__on__cosh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A3 @ F3 )
         => ( topolo81223032696312382ous_on @ C @ A @ A3
            @ ^ [X6: C] : ( cosh @ A @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_cosh
thf(fact_7643_continuous__on__sinh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A3 @ F3 )
         => ( topolo81223032696312382ous_on @ C @ A @ A3
            @ ^ [X6: C] : ( sinh @ A @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_sinh
thf(fact_7644_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real,N: nat] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X6: A] : ( root @ N @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_real_root
thf(fact_7645_continuous__on__prod,axiom,
    ! [A: $tType,C: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ C )
        & ( comm_ring_1 @ C ) )
     => ! [S3: set @ A,S: set @ D,F3: A > D > C] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ S3 )
             => ( topolo81223032696312382ous_on @ D @ C @ S @ ( F3 @ I2 ) ) )
         => ( topolo81223032696312382ous_on @ D @ C @ S
            @ ^ [X6: D] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ S3 ) ) ) ) ).

% continuous_on_prod
thf(fact_7646_continuous__on__prod_H,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4987421752381908075d_mult @ C ) )
     => ! [I6: set @ A,S3: set @ B,F3: A > B > C] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( topolo81223032696312382ous_on @ B @ C @ S3 @ ( F3 @ I2 ) ) )
         => ( topolo81223032696312382ous_on @ B @ C @ S3
            @ ^ [X6: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ I6 ) ) ) ) ).

% continuous_on_prod'
thf(fact_7647_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_7648_continuous__on__minus,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [S: set @ C,F3: C > B] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S @ F3 )
         => ( topolo81223032696312382ous_on @ C @ B @ S
            @ ^ [X6: C] : ( uminus_uminus @ B @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_minus
thf(fact_7649_continuous__on__diff,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [S: set @ D,F3: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X6: D] : ( minus_minus @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_diff
thf(fact_7650_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S @ G )
           => ( ! [X7: A] :
                  ( ( member @ A @ X7 @ S )
                 => ( ( G @ X7 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S
                @ ^ [X6: A] : ( divide_divide @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_7651_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ S )
               => ( ( F3 @ X7 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X6: A] : ( inverse_inverse @ B @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_on_inverse
thf(fact_7652_continuous__on__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo5987344860129210374id_add @ C ) )
     => ! [I6: set @ A,S3: set @ B,F3: A > B > C] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( topolo81223032696312382ous_on @ B @ C @ S3 @ ( F3 @ I2 ) ) )
         => ( topolo81223032696312382ous_on @ B @ C @ S3
            @ ^ [X6: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I: A] : ( F3 @ I @ X6 )
                @ I6 ) ) ) ) ).

% continuous_on_sum
thf(fact_7653_continuous__on__fst,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [S: set @ A,F3: A > ( product_prod @ B @ C )] :
          ( ( topolo81223032696312382ous_on @ A @ ( product_prod @ B @ C ) @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ B @ S
            @ ^ [X6: A] : ( product_fst @ B @ C @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_fst
thf(fact_7654_continuous__on__snd,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [S: set @ A,F3: A > ( product_prod @ B @ C )] :
          ( ( topolo81223032696312382ous_on @ A @ ( product_prod @ B @ C ) @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ C @ S
            @ ^ [X6: A] : ( product_snd @ B @ C @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_snd
thf(fact_7655_continuous__on__dist,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [S: set @ D,F3: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ real @ S
              @ ^ [X6: D] : ( real_V557655796197034286t_dist @ A @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_dist
thf(fact_7656_continuous__on__tendsto__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [S: set @ A,F3: A > B,G: C > A,L: A,F4: filter @ C] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
           => ( ( member @ A @ L @ S )
             => ( ( eventually @ C
                  @ ^ [X6: C] : ( member @ A @ ( G @ X6 ) @ S )
                  @ F4 )
               => ( filterlim @ C @ B
                  @ ^ [X6: C] : ( F3 @ ( G @ X6 ) )
                  @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ L ) )
                  @ F4 ) ) ) ) ) ) ).

% continuous_on_tendsto_compose
thf(fact_7657_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F3: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ S )
               => ( ( sin @ A @ ( F3 @ X7 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X6: A] : ( cot @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_on_cot
thf(fact_7658_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A3 @ F3 )
         => ( ! [X7: C] :
                ( ( member @ C @ X7 @ A3 )
               => ( ( cosh @ A @ ( F3 @ X7 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ C @ A @ A3
              @ ^ [X6: C] : ( tanh @ A @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_on_tanh
thf(fact_7659_less__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F3: B > A,A3: set @ B,Y2: A,I3: B] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) )
         => ( ( ord_less @ A @ Y2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
           => ( ( member @ B @ I3 @ A3 )
             => ( ord_less @ A @ Y2 @ ( F3 @ I3 ) ) ) ) ) ) ).

% less_cINF_D
thf(fact_7660_continuous__on__arcosh_H,axiom,
    ! [A3: set @ real,F3: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F3 )
     => ( ! [X7: real] :
            ( ( member @ real @ X7 @ A3 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F3 @ X7 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X6: real] : ( arcosh @ real @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_7661_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                = ( collect @ A
                  @ ^ [X6: A] :
                      ( ( member @ A @ X6 @ S )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X6 ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_7662_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F3: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X7: C] :
                  ( ( member @ C @ X7 @ S )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X7 ) )
                    & ( ( ( F3 @ X7 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X7 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X6: C] : ( powr @ real @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_7663_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ( ! [X7: A] :
                  ( ( member @ A @ X7 @ S )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X7 ) ) )
             => ( ! [X7: A] :
                    ( ( member @ A @ X7 @ S )
                   => ( ( F3 @ X7 )
                     != ( one_one @ real ) ) )
               => ( ! [X7: A] :
                      ( ( member @ A @ X7 @ S )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X7 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S
                    @ ^ [X6: A] : ( log @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_7664_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F3 @ X7 ) )
                  & ( ord_less_eq @ real @ ( F3 @ X7 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X6: A] : ( arccos @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_7665_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ! [X7: A] :
                ( ( member @ A @ X7 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F3 @ X7 ) )
                  & ( ord_less_eq @ real @ ( F3 @ X7 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X6: A] : ( arcsin @ ( F3 @ X6 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_7666_cINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A3: set @ B,F3: B > A,A2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ A2 )
              = ( ? [X6: B] :
                    ( ( member @ B @ X6 @ A3 )
                    & ( ord_less @ A @ ( F3 @ X6 ) @ A2 ) ) ) ) ) ) ) ).

% cINF_less_iff
thf(fact_7667_cINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) )
           => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ G @ A3 ) )
             => ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A3 ) ) )
                = ( complete_Inf_Inf @ A
                  @ ( image @ B @ A
                    @ ^ [A5: B] : ( inf_inf @ A @ ( F3 @ A5 ) @ ( G @ A5 ) )
                    @ A3 ) ) ) ) ) ) ) ).

% cINF_inf_distrib
thf(fact_7668_cSUP__eq__cINF__D,axiom,
    ! [B: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F3: C > B,A3: set @ C,A2: C] :
          ( ( ( complete_Sup_Sup @ B @ ( image @ C @ B @ F3 @ A3 ) )
            = ( complete_Inf_Inf @ B @ ( image @ C @ B @ F3 @ A3 ) ) )
         => ( ( condit941137186595557371_above @ B @ ( image @ C @ B @ F3 @ A3 ) )
           => ( ( condit1013018076250108175_below @ B @ ( image @ C @ B @ F3 @ A3 ) )
             => ( ( member @ C @ A2 @ A3 )
               => ( ( F3 @ A2 )
                  = ( complete_Inf_Inf @ B @ ( image @ C @ B @ F3 @ A3 ) ) ) ) ) ) ) ) ).

% cSUP_eq_cINF_D
thf(fact_7669_continuous__on__artanh_H,axiom,
    ! [A3: set @ real,F3: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F3 )
     => ( ! [X7: real] :
            ( ( member @ real @ X7 @ A3 )
           => ( member @ real @ ( F3 @ X7 ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X6: real] : ( artanh @ real @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_artanh'
thf(fact_7670_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F3: real > real,F9: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F3 @ A2 )
          = ( F3 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
         => ( ! [X7: real] :
                ( ( ord_less @ real @ A2 @ X7 )
               => ( ( ord_less @ real @ X7 @ B2 )
                 => ( has_derivative @ real @ real @ F3 @ ( F9 @ X7 ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z2: real] :
                ( ( ord_less @ real @ A2 @ Z2 )
                & ( ord_less @ real @ Z2 @ B2 )
                & ( ( F9 @ Z2 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_7671_mvt,axiom,
    ! [A2: real,B2: real,F3: real > real,F9: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ( ! [X7: real] :
              ( ( ord_less @ real @ A2 @ X7 )
             => ( ( ord_less @ real @ X7 @ B2 )
               => ( has_derivative @ real @ real @ F3 @ ( F9 @ X7 ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) )
                   != ( F9 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_7672_continuous__on__of__int__floor,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A )
        & ( ring_1 @ B )
        & ( topolo4958980785337419405_space @ B ) )
     => ( topolo81223032696312382ous_on @ A @ B @ ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( ring_1_Ints @ A ) )
        @ ^ [X6: A] : ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ A @ X6 ) ) ) ) ).

% continuous_on_of_int_floor
thf(fact_7673_continuous__on__of__int__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A )
        & ( ring_1 @ B )
        & ( topolo4958980785337419405_space @ B ) )
     => ( topolo81223032696312382ous_on @ A @ B @ ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( ring_1_Ints @ A ) )
        @ ^ [X6: A] : ( ring_1_of_int @ B @ ( archimedean_ceiling @ A @ X6 ) ) ) ) ).

% continuous_on_of_int_ceiling
thf(fact_7674_cInf__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S3: set @ A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S3 )
           => ( ( complete_Inf_Inf @ A @ S3 )
              = ( complete_Sup_Sup @ A
                @ ( collect @ A
                  @ ^ [X6: A] :
                    ! [Y: A] :
                      ( ( member @ A @ Y @ S3 )
                     => ( ord_less_eq @ A @ X6 @ Y ) ) ) ) ) ) ) ) ).

% cInf_cSup
thf(fact_7675_cINF__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A3: set @ C,B5: C > ( set @ D ),F3: D > B] :
          ( ( A3
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X7: C] :
                ( ( member @ C @ X7 @ A3 )
               => ( ( B5 @ X7 )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit1013018076250108175_below @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image @ C @ ( set @ B )
                    @ ^ [X6: C] : ( image @ D @ B @ F3 @ ( B5 @ X6 ) )
                    @ A3 ) ) )
             => ( ( complete_Inf_Inf @ B @ ( image @ D @ B @ F3 @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ B5 @ A3 ) ) ) )
                = ( complete_Inf_Inf @ B
                  @ ( image @ C @ B
                    @ ^ [X6: C] : ( complete_Inf_Inf @ B @ ( image @ D @ B @ F3 @ ( B5 @ X6 ) ) )
                    @ A3 ) ) ) ) ) ) ) ).

% cINF_UNION
thf(fact_7676_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F3 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_7677_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F3 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_7678_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X7: real] :
            ( ( ord_less @ real @ A2 @ X7 )
           => ( ( ord_less @ real @ X7 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y3 ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
         => ( ord_less @ real @ ( F3 @ A2 ) @ ( F3 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_7679_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X7: real] :
            ( ( ord_less @ real @ A2 @ X7 )
           => ( ( ord_less @ real @ X7 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y3 @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
         => ( ord_less @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_7680_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ( ! [X7: real] :
              ( ( ord_less @ real @ A2 @ X7 )
             => ( ( ord_less @ real @ X7 @ B2 )
               => ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F3 @ B2 )
            = ( F3 @ A2 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_7681_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F3: real > real,X2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ( ! [X7: real] :
              ( ( ord_less @ real @ A2 @ X7 )
             => ( ( ord_less @ real @ X7 @ B2 )
               => ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ( ( F3 @ X2 )
                = ( F3 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_7682_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X7: A] :
                  ( ( ord_less @ A @ A2 @ X7 )
                 => ( ( ord_less @ A @ X7 @ B2 )
                   => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ X7 ) ) @ ( topolo174197925503356063within @ A @ X7 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F3 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_7683_Rolle,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F3 @ A2 )
          = ( F3 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
         => ( ! [X7: real] :
                ( ( ord_less @ real @ A2 @ X7 )
               => ( ( ord_less @ real @ X7 @ B2 )
                 => ( differentiable @ real @ real @ F3 @ ( topolo174197925503356063within @ real @ X7 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z2: real] :
                ( ( ord_less @ real @ A2 @ Z2 )
                & ( ord_less @ real @ Z2 @ B2 )
                & ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_7684_LIMSEQ__decseq__INF,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X15: nat > A] :
          ( ( condit1013018076250108175_below @ A @ ( image @ nat @ A @ X15 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_antimono @ nat @ A @ X15 )
           => ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ ( complete_Inf_Inf @ A @ ( image @ nat @ A @ X15 @ ( top_top @ ( set @ nat ) ) ) ) ) @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_decseq_INF
thf(fact_7685_ord_OLeast__def,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( ^ [Less_eq2: A > A > $o,P2: A > $o] :
            ( the @ A
            @ ^ [X6: A] :
                ( ( P2 @ X6 )
                & ! [Y: A] :
                    ( ( P2 @ Y )
                   => ( Less_eq2 @ X6 @ Y ) ) ) ) ) ) ).

% ord.Least_def
thf(fact_7686_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X6: list @ A,Y: list @ A] :
                ? [A5: A,V5: list @ A] :
                  ( ( Y
                    = ( append @ A @ X6 @ ( cons @ A @ A5 @ V5 ) ) )
                  | ? [U2: list @ A,B4: A,C4: A,W3: list @ A,Z6: list @ A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C4 ) @ R5 )
                      & ( X6
                        = ( append @ A @ U2 @ ( cons @ A @ B4 @ W3 ) ) )
                      & ( Y
                        = ( append @ A @ U2 @ ( cons @ A @ C4 @ Z6 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_7687_continuous__on__of__real__o__iff,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ complex @ S3
            @ ^ [X6: A] : ( real_Vector_of_real @ complex @ ( G @ X6 ) ) )
          = ( topolo81223032696312382ous_on @ A @ real @ S3 @ G ) ) ) ).

% continuous_on_of_real_o_iff
thf(fact_7688_lexord__cons__cons,axiom,
    ! [A: $tType,A2: A,X2: list @ A,B2: A,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A2 @ X2 ) @ ( cons @ A @ B2 @ Y2 ) ) @ ( lexord @ A @ R ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
        | ( ( A2 = B2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lexord @ A @ R ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_7689_lexord__Nil__left,axiom,
    ! [A: $tType,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y2 ) @ ( lexord @ A @ R ) )
      = ( ? [A5: A,X6: list @ A] :
            ( Y2
            = ( cons @ A @ A5 @ X6 ) ) ) ) ).

% lexord_Nil_left
thf(fact_7690_continuous__on__cnj,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,G: C > complex] :
          ( ( topolo81223032696312382ous_on @ C @ complex @ S @ G )
         => ( topolo81223032696312382ous_on @ C @ complex @ S
            @ ^ [X6: C] : ( cnj @ ( G @ X6 ) ) ) ) ) ).

% continuous_on_cnj
thf(fact_7691_continuous__on__Re,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,G: C > complex] :
          ( ( topolo81223032696312382ous_on @ C @ complex @ S @ G )
         => ( topolo81223032696312382ous_on @ C @ real @ S
            @ ^ [X6: C] : ( re @ ( G @ X6 ) ) ) ) ) ).

% continuous_on_Re
thf(fact_7692_continuous__on__cis,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A3: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ A3 @ F3 )
         => ( topolo81223032696312382ous_on @ A @ complex @ A3
            @ ^ [X6: A] : ( cis @ ( F3 @ X6 ) ) ) ) ) ).

% continuous_on_cis
thf(fact_7693_continuous__on__Im,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,G: C > complex] :
          ( ( topolo81223032696312382ous_on @ C @ complex @ S @ G )
         => ( topolo81223032696312382ous_on @ C @ real @ S
            @ ^ [X6: C] : ( im @ ( G @ X6 ) ) ) ) ) ).

% continuous_on_Im
thf(fact_7694_lexord__Nil__right,axiom,
    ! [A: $tType,X2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ ( nil @ A ) ) @ ( lexord @ A @ R ) ) ).

% lexord_Nil_right
thf(fact_7695_lexord__irreflexive,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X7: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X7 @ X7 ) @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R ) ) ) ).

% lexord_irreflexive
thf(fact_7696_lexord__linear,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X2: list @ A,Y2: list @ A] :
      ( ! [A4: A,B3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R )
          | ( A4 = B3 )
          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ A4 ) @ R ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lexord @ A @ R ) )
        | ( X2 = Y2 )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y2 @ X2 ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_linear
thf(fact_7697_lexord__append__leftI,axiom,
    ! [A: $tType,U: list @ A,V: list @ A,R: set @ ( product_prod @ A @ A ),X2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V ) @ ( lexord @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X2 @ U ) @ ( append @ A @ X2 @ V ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_leftI
thf(fact_7698_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A ),Ys: list @ A,Zs: list @ A] :
      ( ! [X7: A,Y5: A,Z2: A] :
          ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X7 @ Y5 ) @ R )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z2 ) @ R )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X7 @ Z2 ) @ R ) ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R ) )
       => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( lexord @ A @ R ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_7699_lexord__append__leftD,axiom,
    ! [A: $tType,X2: list @ A,U: list @ A,V: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X2 @ U ) @ ( append @ A @ X2 @ V ) ) @ ( lexord @ A @ R ) )
     => ( ! [A4: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A4 ) @ R )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_append_leftD
thf(fact_7700_lexord__append__rightI,axiom,
    ! [A: $tType,Y2: list @ A,X2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ? [B13: A,Z4: list @ A] :
          ( Y2
          = ( cons @ A @ B13 @ Z4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ ( append @ A @ X2 @ Y2 ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_rightI
thf(fact_7701_lexord__sufE,axiom,
    ! [A: $tType,Xs: list @ A,Zs: list @ A,Ys: list @ A,Qs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Zs ) @ ( append @ A @ Ys @ Qs ) ) @ ( lexord @ A @ R ) )
     => ( ( Xs != Ys )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_7702_lexord__lex,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lex @ A @ R ) )
      = ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lexord @ A @ R ) )
        & ( ( size_size @ ( list @ A ) @ X2 )
          = ( size_size @ ( list @ A ) @ Y2 ) ) ) ) ).

% lexord_lex
thf(fact_7703_lexord__append__left__rightI,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),U: list @ A,X2: list @ A,Y2: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A2 @ X2 ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y2 ) ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_left_rightI
thf(fact_7704_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R ) )
      = ( ? [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Xs ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ X6 ) @ R ) )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_7705_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W: list @ A,R: set @ ( product_prod @ A @ A ),V: list @ A,Z: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W ) @ ( lexord @ A @ R ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V ) @ ( append @ A @ W @ Z ) ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_sufI
thf(fact_7706_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R5: A > A > $o,Xs2: list @ A,Ys2: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_7707_lex__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: set @ ( product_prod @ A @ A ),Rb: set @ ( product_prod @ B @ B )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A5: A,B4: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A11: A,B14: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ A11 ) @ Ra )
                        | ( ( A5 = A11 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B4 @ B14 ) @ Rb ) ) ) ) ) ) ) ) ) ).

% lex_prod_def
thf(fact_7708_same__fst__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P2: A > $o,R7: A > ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X9: A,Y7: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X6: A,Y: B] :
                        ( ( X9 = X6 )
                        & ( P2 @ X6 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y7 @ Y ) @ ( R7 @ X6 ) ) ) ) ) ) ) ) ) ).

% same_fst_def
thf(fact_7709_dual__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Min @ A
          @ ^ [X6: A,Y: A] : ( ord_less_eq @ A @ Y @ X6 ) )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% dual_Min
thf(fact_7710_Succ__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Greatest_Succ @ A )
      = ( ^ [Kl: set @ ( list @ A ),Kl2: list @ A] :
            ( collect @ A
            @ ^ [K2: A] : ( member @ ( list @ A ) @ ( append @ A @ Kl2 @ ( cons @ A @ K2 @ ( nil @ A ) ) ) @ Kl ) ) ) ) ).

% Succ_def
thf(fact_7711_uniformity__dist,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ A ) )
          @ ( image @ real @ ( filter @ ( product_prod @ A @ A ) )
            @ ^ [E3: real] :
                ( principal @ ( product_prod @ A @ A )
                @ ( collect @ ( product_prod @ A @ A )
                  @ ( product_case_prod @ A @ A @ $o
                    @ ^ [X6: A,Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ Y ) @ E3 ) ) ) )
            @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ).

% uniformity_dist
thf(fact_7712_uniformity__sym,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [E5: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ E5 @ ( topolo7806501430040627800ormity @ A ) )
         => ( eventually @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X6: A,Y: A] : ( E5 @ ( product_Pair @ A @ A @ Y @ X6 ) ) )
            @ ( topolo7806501430040627800ormity @ A ) ) ) ) ).

% uniformity_sym
thf(fact_7713_open__uniformity,axiom,
    ! [A: $tType] :
      ( ( topolo569519726778239578ormity @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [U5: set @ A] :
            ! [X6: A] :
              ( ( member @ A @ X6 @ U5 )
             => ( eventually @ ( product_prod @ A @ A )
                @ ( product_case_prod @ A @ A @ $o
                  @ ^ [X9: A,Y: A] :
                      ( ( X9 = X6 )
                     => ( member @ A @ Y @ U5 ) ) )
                @ ( topolo7806501430040627800ormity @ A ) ) ) ) ) ) ).

% open_uniformity
thf(fact_7714_uniformity__real__def,axiom,
    ( ( topolo7806501430040627800ormity @ real )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ real @ real ) )
      @ ( image @ real @ ( filter @ ( product_prod @ real @ real ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ real @ real )
            @ ( collect @ ( product_prod @ real @ real )
              @ ( product_case_prod @ real @ real @ $o
                @ ^ [X6: real,Y: real] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ real @ X6 @ Y ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_real_def
thf(fact_7715_uniformity__complex__def,axiom,
    ( ( topolo7806501430040627800ormity @ complex )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ complex @ complex ) )
      @ ( image @ real @ ( filter @ ( product_prod @ complex @ complex ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ complex @ complex )
            @ ( collect @ ( product_prod @ complex @ complex )
              @ ( product_case_prod @ complex @ complex @ $o
                @ ^ [X6: complex,Y: complex] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ complex @ X6 @ Y ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_complex_def
thf(fact_7716_eventually__nhds__uniformity,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [P3: A > $o,X2: A] :
          ( ( eventually @ A @ P3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) )
          = ( eventually @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X9: A,Y: A] :
                  ( ( X9 = X2 )
                 => ( P3 @ Y ) ) )
            @ ( topolo7806501430040627800ormity @ A ) ) ) ) ).

% eventually_nhds_uniformity
thf(fact_7717_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ! [P3: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ P3 @ ( topolo7806501430040627800ormity @ A ) )
          = ( ? [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                & ! [X6: A,Y: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ Y ) @ E3 )
                   => ( P3 @ ( product_Pair @ A @ A @ X6 @ Y ) ) ) ) ) ) ) ).

% eventually_uniformity_metric
thf(fact_7718_tendsto__iff__uniformity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo7287701948861334536_space @ B )
     => ! [F3: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
          = ( ! [E6: ( product_prod @ B @ B ) > $o] :
                ( ( eventually @ ( product_prod @ B @ B ) @ E6 @ ( topolo7806501430040627800ormity @ B ) )
               => ( eventually @ A
                  @ ^ [X6: A] : ( E6 @ ( product_Pair @ B @ B @ ( F3 @ X6 ) @ L ) )
                  @ F4 ) ) ) ) ) ).

% tendsto_iff_uniformity
thf(fact_7719_relpow__finite__bounded1,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R3 )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 )
              @ ( collect @ nat
                @ ^ [N2: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
                    & ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_7720_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A,C6: set @ B,F3: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ! [T7: B] :
                ( ( member @ B @ T7 @ C6 )
               => ( topolo1002775350975398744n_open @ A @ ( F3 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ C6 ) ) )
             => ~ ! [C9: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C9 @ C6 )
                   => ( ( finite_finite2 @ B @ C9 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ C9 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_7721_finite__relpow,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( finite_finite2 @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) ) ) ) ).

% finite_relpow
thf(fact_7722_open__complex__def,axiom,
    ( ( topolo1002775350975398744n_open @ complex )
    = ( ^ [U5: set @ complex] :
        ! [X6: complex] :
          ( ( member @ complex @ X6 @ U5 )
         => ( eventually @ ( product_prod @ complex @ complex )
            @ ( product_case_prod @ complex @ complex @ $o
              @ ^ [X9: complex,Y: complex] :
                  ( ( X9 = X6 )
                 => ( member @ complex @ Y @ U5 ) ) )
            @ ( topolo7806501430040627800ormity @ complex ) ) ) ) ) ).

% open_complex_def
thf(fact_7723_open__real__def,axiom,
    ( ( topolo1002775350975398744n_open @ real )
    = ( ^ [U5: set @ real] :
        ! [X6: real] :
          ( ( member @ real @ X6 @ U5 )
         => ( eventually @ ( product_prod @ real @ real )
            @ ( product_case_prod @ real @ real @ $o
              @ ^ [X9: real,Y: real] :
                  ( ( X9 = X6 )
                 => ( member @ real @ Y @ U5 ) ) )
            @ ( topolo7806501430040627800ormity @ real ) ) ) ) ) ).

% open_real_def
thf(fact_7724_relpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R3 )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) @ R3 ) ) ).

% relpow.simps(2)
thf(fact_7725_relpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( plus_plus @ nat @ M @ N ) @ R3 )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M @ R3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) ) ) ).

% relpow_add
thf(fact_7726_relpow__0__I,axiom,
    ! [A: $tType,X2: A,R3: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R3 ) ) ).

% relpow_0_I
thf(fact_7727_relpow__0__E,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R3 ) )
     => ( X2 = Y2 ) ) ).

% relpow_0_E
thf(fact_7728_relpow__Suc__I2,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A ),Z: A,N: nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R3 ) ) ) ) ).

% relpow_Suc_I2
thf(fact_7729_relpow__Suc__E2,axiom,
    ! [A: $tType,X2: A,Z: A,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R3 ) )
     => ~ ! [Y5: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R3 )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) ) ) ) ).

% relpow_Suc_E2
thf(fact_7730_relpow__Suc__D2,axiom,
    ! [A: $tType,X2: A,Z: A,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R3 ) )
     => ? [Y5: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R3 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) ) ) ) ).

% relpow_Suc_D2
thf(fact_7731_relpow__Suc__I,axiom,
    ! [A: $tType,X2: A,Y2: A,N: nat,R3: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z ) @ R3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R3 ) ) ) ) ).

% relpow_Suc_I
thf(fact_7732_relpow__Suc__E,axiom,
    ! [A: $tType,X2: A,Z: A,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R3 ) )
     => ~ ! [Y5: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z ) @ R3 ) ) ) ).

% relpow_Suc_E
thf(fact_7733_relpowp__relpow__eq,axiom,
    ! [A: $tType,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( A > A > $o ) @ N
        @ ^ [X6: A,Y: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Y ) @ R3 ) )
      = ( ^ [X6: A,Y: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) ) ) ) ).

% relpowp_relpow_eq
thf(fact_7734_relpow__E2,axiom,
    ! [A: $tType,X2: A,Z: A,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y5: A,M5: nat] :
              ( ( N
                = ( suc @ M5 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R3 )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M5 @ R3 ) ) ) ) ) ) ).

% relpow_E2
thf(fact_7735_relpow__E,axiom,
    ! [A: $tType,X2: A,Z: A,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y5: A,M5: nat] :
              ( ( N
                = ( suc @ M5 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M5 @ R3 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z ) @ R3 ) ) ) ) ) ).

% relpow_E
thf(fact_7736_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_7737_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) )
      = ( ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = A2 )
            & ( ( F5 @ N )
              = B2 )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ N )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F5 @ I ) @ ( F5 @ ( suc @ I ) ) ) @ R3 ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_7738_relpow__finite__bounded,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R3 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R3 )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 )
            @ ( collect @ nat
              @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_7739_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N2: nat,R7: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I @ R7 )
              @ ( collect @ nat
                @ ^ [I: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I )
                    & ( ord_less_eq @ nat @ I @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_7740_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R3 )
     => ( ( transitive_trancl @ A @ R3 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 )
            @ ( collect @ nat
              @ ^ [N2: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
                  & ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_7741_ntrancl__Zero,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( transitive_ntrancl @ A @ ( zero_zero @ nat ) @ R3 )
      = R3 ) ).

% ntrancl_Zero
thf(fact_7742_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) ) ).

% trancl_set_ntrancl
thf(fact_7743_trancl__power,axiom,
    ! [A: $tType,P5: product_prod @ A @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P5 @ ( transitive_trancl @ A @ R3 ) )
      = ( ? [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            & ( member @ ( product_prod @ A @ A ) @ P5 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 ) ) ) ) ) ).

% trancl_power
thf(fact_7744_uniformity__trans_H,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [E5: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ E5 @ ( topolo7806501430040627800ormity @ A ) )
         => ( eventually @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) )
            @ ( product_case_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) @ $o
              @ ( product_case_prod @ A @ A @ ( ( product_prod @ A @ A ) > $o )
                @ ^ [X6: A,Y: A] :
                    ( product_case_prod @ A @ A @ $o
                    @ ^ [Y7: A,Z6: A] :
                        ( ( Y = Y7 )
                       => ( E5 @ ( product_Pair @ A @ A @ X6 @ Z6 ) ) ) ) ) )
            @ ( prod_filter @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) @ ( topolo7806501430040627800ormity @ A ) @ ( topolo7806501430040627800ormity @ A ) ) ) ) ) ).

% uniformity_trans'
thf(fact_7745_prod__filter__INF2,axiom,
    ! [B: $tType,C: $tType,A: $tType,J5: set @ A,A3: filter @ B,B5: A > ( filter @ C )] :
      ( ( J5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( prod_filter @ B @ C @ A3 @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image @ A @ ( filter @ C ) @ B5 @ J5 ) ) )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ B @ C ) )
          @ ( image @ A @ ( filter @ ( product_prod @ B @ C ) )
            @ ^ [I: A] : ( prod_filter @ B @ C @ A3 @ ( B5 @ I ) )
            @ J5 ) ) ) ) ).

% prod_filter_INF2
thf(fact_7746_filterlim__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: A > B,G5: filter @ B,F4: filter @ A,G: A > C,H6: filter @ C] :
      ( ( filterlim @ A @ B @ F3 @ G5 @ F4 )
     => ( ( filterlim @ A @ C @ G @ H6 @ F4 )
       => ( filterlim @ A @ ( product_prod @ B @ C )
          @ ^ [X6: A] : ( product_Pair @ B @ C @ ( F3 @ X6 ) @ ( G @ X6 ) )
          @ ( prod_filter @ B @ C @ G5 @ H6 )
          @ F4 ) ) ) ).

% filterlim_Pair
thf(fact_7747_tendsto__mult__Pair,axiom,
    ! [A: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [A2: A,B2: A] :
          ( filterlim @ ( product_prod @ A @ A ) @ A
          @ ^ [X6: product_prod @ A @ A] : ( times_times @ A @ ( product_fst @ A @ A @ X6 ) @ ( product_snd @ A @ A @ X6 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
          @ ( prod_filter @ A @ A @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( topolo7230453075368039082e_nhds @ A @ B2 ) ) ) ) ).

% tendsto_mult_Pair
thf(fact_7748_tendsto__add__Pair,axiom,
    ! [A: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [A2: A,B2: A] :
          ( filterlim @ ( product_prod @ A @ A ) @ A
          @ ^ [X6: product_prod @ A @ A] : ( plus_plus @ A @ ( product_fst @ A @ A @ X6 ) @ ( product_snd @ A @ A @ X6 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          @ ( prod_filter @ A @ A @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( topolo7230453075368039082e_nhds @ A @ B2 ) ) ) ) ).

% tendsto_add_Pair
thf(fact_7749_eventually__prodI,axiom,
    ! [A: $tType,B: $tType,P3: A > $o,F4: filter @ A,Q: B > $o,G5: filter @ B] :
      ( ( eventually @ A @ P3 @ F4 )
     => ( ( eventually @ B @ Q @ G5 )
       => ( eventually @ ( product_prod @ A @ B )
          @ ^ [X6: product_prod @ A @ B] :
              ( ( P3 @ ( product_fst @ A @ B @ X6 ) )
              & ( Q @ ( product_snd @ A @ B @ X6 ) ) )
          @ ( prod_filter @ A @ B @ F4 @ G5 ) ) ) ) ).

% eventually_prodI
thf(fact_7750_eventually__prod1,axiom,
    ! [A: $tType,B: $tType,B5: filter @ A,P3: B > $o,A3: filter @ B] :
      ( ( B5
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ ( product_prod @ B @ A )
          @ ( product_case_prod @ B @ A @ $o
            @ ^ [X6: B,Y: A] : ( P3 @ X6 ) )
          @ ( prod_filter @ B @ A @ A3 @ B5 ) )
        = ( eventually @ B @ P3 @ A3 ) ) ) ).

% eventually_prod1
thf(fact_7751_eventually__prod2,axiom,
    ! [A: $tType,B: $tType,A3: filter @ A,P3: B > $o,B5: filter @ B] :
      ( ( A3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [X6: A] : P3 )
          @ ( prod_filter @ A @ B @ A3 @ B5 ) )
        = ( eventually @ B @ P3 @ B5 ) ) ) ).

% eventually_prod2
thf(fact_7752_prod__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( prod_filter @ A @ B )
      = ( ^ [F7: filter @ A,G7: filter @ B] :
            ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ B ) )
            @ ( image @ ( product_prod @ ( A > $o ) @ ( B > $o ) ) @ ( filter @ ( product_prod @ A @ B ) )
              @ ( product_case_prod @ ( A > $o ) @ ( B > $o ) @ ( filter @ ( product_prod @ A @ B ) )
                @ ^ [P2: A > $o,Q8: B > $o] :
                    ( principal @ ( product_prod @ A @ B )
                    @ ( collect @ ( product_prod @ A @ B )
                      @ ( product_case_prod @ A @ B @ $o
                        @ ^ [X6: A,Y: B] :
                            ( ( P2 @ X6 )
                            & ( Q8 @ Y ) ) ) ) ) )
              @ ( collect @ ( product_prod @ ( A > $o ) @ ( B > $o ) )
                @ ( product_case_prod @ ( A > $o ) @ ( B > $o ) @ $o
                  @ ^ [P2: A > $o,Q8: B > $o] :
                      ( ( eventually @ A @ P2 @ F7 )
                      & ( eventually @ B @ Q8 @ G7 ) ) ) ) ) ) ) ) ).

% prod_filter_def
thf(fact_7753_prod__filter__INF,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,I6: set @ A,J5: set @ B,A3: A > ( filter @ C ),B5: B > ( filter @ D )] :
      ( ( I6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( J5
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( prod_filter @ C @ D @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image @ A @ ( filter @ C ) @ A3 @ I6 ) ) @ ( complete_Inf_Inf @ ( filter @ D ) @ ( image @ B @ ( filter @ D ) @ B5 @ J5 ) ) )
          = ( complete_Inf_Inf @ ( filter @ ( product_prod @ C @ D ) )
            @ ( image @ A @ ( filter @ ( product_prod @ C @ D ) )
              @ ^ [I: A] :
                  ( complete_Inf_Inf @ ( filter @ ( product_prod @ C @ D ) )
                  @ ( image @ B @ ( filter @ ( product_prod @ C @ D ) )
                    @ ^ [J4: B] : ( prod_filter @ C @ D @ ( A3 @ I ) @ ( B5 @ J4 ) )
                    @ J5 ) )
              @ I6 ) ) ) ) ) ).

% prod_filter_INF
thf(fact_7754_prod__filter__INF1,axiom,
    ! [B: $tType,C: $tType,A: $tType,I6: set @ A,A3: A > ( filter @ B ),B5: filter @ C] :
      ( ( I6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( prod_filter @ B @ C @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ A3 @ I6 ) ) @ B5 )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ B @ C ) )
          @ ( image @ A @ ( filter @ ( product_prod @ B @ C ) )
            @ ^ [I: A] : ( prod_filter @ B @ C @ ( A3 @ I ) @ B5 )
            @ I6 ) ) ) ) ).

% prod_filter_INF1
thf(fact_7755_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P3: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F6: nat > A] :
                ( ! [N9: nat] : ( ord_less @ A @ B2 @ ( F6 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ A @ ( F6 @ N9 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F6 )
                   => ( ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N2: nat] : ( P3 @ ( F6 @ N2 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P3 @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_7756_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( bNF_Greatest_image2 @ C @ A @ B )
      = ( ^ [A7: set @ C,F5: C > A,G2: C > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A5: C] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ ( F5 @ A5 ) @ ( G2 @ A5 ) ) )
                & ( member @ C @ A5 @ A7 ) ) ) ) ) ).

% image2_def
thf(fact_7757_incseq__const,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [K: A] :
          ( order_mono @ nat @ A
          @ ^ [X6: nat] : K ) ) ).

% incseq_const
thf(fact_7758_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F3 @ A3 ) ) @ ( F3 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% mono_Sup
thf(fact_7759_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F3: A > B,A3: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X6: C] : ( F3 @ ( A3 @ X6 ) )
                @ I6 ) )
            @ ( F3 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I6 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_7760_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F3 @ A3 ) ) ) ) ) ).

% mono_Inf
thf(fact_7761_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F3: A > B,A3: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I6 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X6: C] : ( F3 @ ( A3 @ X6 ) )
                @ I6 ) ) ) ) ) ).

% mono_INF
thf(fact_7762_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F3: A > B,M: A,N: A,M6: B,N4: B] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( ( image @ A @ B @ F3 @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
              = ( set_or7035219750837199246ssThan @ B @ M6 @ N4 ) )
           => ( ( ord_less @ A @ M @ N )
             => ( ( F3 @ M )
                = M6 ) ) ) ) ) ).

% mono_image_least
thf(fact_7763_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: A > A,A3: A,B5: A,N: nat] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ A @ A3 @ B5 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F3 @ A3 ) @ ( compow @ ( A > A ) @ N @ F3 @ B5 ) ) ) ) ) ).

% funpow_mono
thf(fact_7764_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: A > A,I3: nat,J2: nat,X2: A,Y2: A] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ nat @ I3 @ J2 )
           => ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ( ord_less_eq @ A @ X2 @ ( F3 @ X2 ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I3 @ F3 @ X2 ) @ ( compow @ ( A > A ) @ J2 @ F3 @ Y2 ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_7765_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F3: A > A,P5: A,K: nat] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ A @ P5 @ ( F3 @ P5 ) )
           => ( ord_less_eq @ A @ P5 @ ( compow @ ( A > A ) @ K @ F3 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_7766_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F3 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) ) ) ) ).

% mono_pow
thf(fact_7767_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I: nat] : ( compow @ ( A > A ) @ I @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_7768_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F3: A > A,P5: A,K: nat] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ A @ ( F3 @ P5 ) @ P5 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F3 @ ( bot_bot @ A ) ) @ P5 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_7769_decseq__eq__incseq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X8: nat > A] :
              ( order_mono @ nat @ A
              @ ^ [N2: nat] : ( uminus_uminus @ A @ ( X8 @ N2 ) ) ) ) ) ) ).

% decseq_eq_incseq
thf(fact_7770_mono__times__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N ) ) ) ).

% mono_times_nat
thf(fact_7771_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F3: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( ord_less @ B @ ( F3 @ X2 ) @ ( F3 @ Y2 ) )
           => ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% mono_strict_invE
thf(fact_7772_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_7773_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_7774_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I3: nat] :
          ( ( order_mono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ I3 ) @ ( A3 @ ( suc @ I3 ) ) ) ) ) ).

% incseq_SucD
thf(fact_7775_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X15: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X15 @ N3 ) @ ( X15 @ ( suc @ N3 ) ) )
         => ( order_mono @ nat @ A @ X15 ) ) ) ).

% incseq_SucI
thf(fact_7776_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F5 @ N2 ) @ ( F5 @ ( suc @ N2 ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_7777_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F3: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( ord_less @ B @ ( F3 @ X2 ) @ ( F3 @ Y2 ) )
           => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mono_invE
thf(fact_7778_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_7779_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I: nat] : ( compow @ ( A > A ) @ I @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_7780_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N: nat,F3: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F3 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F3 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F3 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_7781_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N: nat,F3: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F3 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F3 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F3 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_7782_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F3: A > B,A3: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ A3 @ I6 ) )
           => ( ( I6
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image @ C @ B
                    @ ^ [X6: C] : ( F3 @ ( A3 @ X6 ) )
                    @ I6 ) )
                @ ( F3 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I6 ) ) ) ) ) ) ) ) ).

% mono_cSUP
thf(fact_7783_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F3 @ A3 ) ) @ ( F3 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ) ).

% mono_cSup
thf(fact_7784_mono__cINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F3: A > B,A3: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( condit1013018076250108175_below @ A @ ( image @ C @ A @ A3 @ I6 ) )
           => ( ( I6
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I6 ) ) )
                @ ( complete_Inf_Inf @ B
                  @ ( image @ C @ B
                    @ ^ [X6: C] : ( F3 @ ( A3 @ X6 ) )
                    @ I6 ) ) ) ) ) ) ) ).

% mono_cINF
thf(fact_7785_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( condit1013018076250108175_below @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F3 @ A3 ) ) ) ) ) ) ) ).

% mono_cInf
thf(fact_7786_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M4: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M4 ) @ M4 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_7787_LIMSEQ__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X15: nat > A] :
          ( ( order_mono @ nat @ A @ X15 )
         => ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ ( complete_Sup_Sup @ A @ ( image @ nat @ A @ X15 @ ( top_top @ ( set @ nat ) ) ) ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_SUP
thf(fact_7788_SUP__Lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X15: nat > A,L: A] :
          ( ( order_mono @ nat @ A @ X15 )
         => ( ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ nat @ A @ X15 @ ( top_top @ ( set @ nat ) ) ) )
              = L ) ) ) ) ).

% SUP_Lim
thf(fact_7789_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A] :
          ( ( finite_finite2 @ A @ ( image @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F3 )
           => ( ! [N3: nat] :
                  ( ( ( F3 @ N3 )
                    = ( F3 @ ( suc @ N3 ) ) )
                 => ( ( F3 @ ( suc @ N3 ) )
                    = ( F3 @ ( suc @ ( suc @ N3 ) ) ) ) )
             => ? [N8: nat] :
                  ( ! [N9: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N8 )
                     => ! [M2: nat] :
                          ( ( ord_less_eq @ nat @ M2 @ N8 )
                         => ( ( ord_less @ nat @ M2 @ N9 )
                           => ( ord_less @ A @ ( F3 @ M2 ) @ ( F3 @ N9 ) ) ) ) )
                  & ! [N9: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ N9 )
                     => ( ( F3 @ N8 )
                        = ( F3 @ N9 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_7790_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X15: B > A,L5: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S10: nat > B] :
                ( ! [N9: nat] : ( ord_less @ B @ ( S10 @ N9 ) @ A2 )
               => ( ! [N9: nat] : ( ord_less @ B @ B2 @ ( S10 @ N9 ) )
                 => ( ( order_mono @ nat @ B @ S10 )
                   => ( ( filterlim @ nat @ B @ S10 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N2: nat] : ( X15 @ ( S10 @ N2 ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_7791_LIMSEQ__incseq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X15: nat > A] :
          ( ( condit941137186595557371_above @ A @ ( image @ nat @ A @ X15 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ X15 )
           => ( filterlim @ nat @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ ( complete_Sup_Sup @ A @ ( image @ nat @ A @ X15 @ ( top_top @ ( set @ nat ) ) ) ) ) @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_incseq_SUP
thf(fact_7792_continuous__at__Sup__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( topolo1944317154257567458pology @ A )
        & ( condit6923001295902523014norder @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F3: A > B,S3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ ( complete_Sup_Sup @ A @ S3 ) @ ( set_ord_lessThan @ A @ ( complete_Sup_Sup @ A @ S3 ) ) ) @ F3 )
           => ( ( S3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit941137186595557371_above @ A @ S3 )
               => ( ( F3 @ ( complete_Sup_Sup @ A @ S3 ) )
                  = ( complete_Sup_Sup @ B @ ( image @ A @ B @ F3 @ S3 ) ) ) ) ) ) ) ) ).

% continuous_at_Sup_mono
thf(fact_7793_continuous__at__Inf__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( topolo1944317154257567458pology @ A )
        & ( condit6923001295902523014norder @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F3: A > B,S3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ ( complete_Inf_Inf @ A @ S3 ) @ ( set_ord_greaterThan @ A @ ( complete_Inf_Inf @ A @ S3 ) ) ) @ F3 )
           => ( ( S3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit1013018076250108175_below @ A @ S3 )
               => ( ( F3 @ ( complete_Inf_Inf @ A @ S3 ) )
                  = ( complete_Inf_Inf @ B @ ( image @ A @ B @ F3 @ S3 ) ) ) ) ) ) ) ) ).

% continuous_at_Inf_mono
thf(fact_7794_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = Ys )
      = ( ? [F5: nat > nat] :
            ( ( order_mono @ nat @ nat @ F5 )
            & ( ( image @ nat @ nat @ F5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys ) ) )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I )
                  = ( nth @ A @ Ys @ ( F5 @ I ) ) ) )
            & ! [I: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( ( nth @ A @ Xs @ I )
                    = ( nth @ A @ Xs @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) ) )
                  = ( ( F5 @ I )
                    = ( F5 @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_7795_and__not__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_and_not_num @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y2
             != ( none @ num ) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N3: num] :
                  ( Xa
                  = ( bit0 @ N3 ) )
             => ( Y2
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N3: num] :
                    ( Xa
                    = ( bit1 @ N3 ) )
               => ( Y2
                 != ( none @ num ) ) ) )
           => ( ! [M5: num] :
                  ( ( X2
                    = ( bit0 @ M5 ) )
                 => ( ( Xa = one2 )
                   => ( Y2
                     != ( some @ num @ ( bit0 @ M5 ) ) ) ) )
             => ( ! [M5: num] :
                    ( ( X2
                      = ( bit0 @ M5 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M5 @ N3 ) ) ) ) )
               => ( ! [M5: num] :
                      ( ( X2
                        = ( bit0 @ M5 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M5 @ N3 ) ) ) ) )
                 => ( ! [M5: num] :
                        ( ( X2
                          = ( bit1 @ M5 ) )
                       => ( ( Xa = one2 )
                         => ( Y2
                           != ( some @ num @ ( bit0 @ M5 ) ) ) ) )
                   => ( ! [M5: num] :
                          ( ( X2
                            = ( bit1 @ M5 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N11: num] : ( some @ num @ ( bit1 @ N11 ) )
                                  @ ( bit_and_not_num @ M5 @ N3 ) ) ) ) )
                     => ~ ! [M5: num] :
                            ( ( X2
                              = ( bit1 @ M5 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M5 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_7796_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% remdups_adj_Nil_iff
thf(fact_7797_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups_adj @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% remdups_adj_set
thf(fact_7798_option_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A2: option @ A] :
      ( ( ( map_option @ A @ B @ F3 @ A2 )
        = ( none @ B ) )
      = ( A2
        = ( none @ A ) ) ) ).

% option.map_disc_iff
thf(fact_7799_map__option__is__None,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Opt: option @ B] :
      ( ( ( map_option @ B @ A @ F3 @ Opt )
        = ( none @ A ) )
      = ( Opt
        = ( none @ B ) ) ) ).

% map_option_is_None
thf(fact_7800_None__eq__map__option__iff,axiom,
    ! [A: $tType,B: $tType,F3: B > A,X2: option @ B] :
      ( ( ( none @ A )
        = ( map_option @ B @ A @ F3 @ X2 ) )
      = ( X2
        = ( none @ B ) ) ) ).

% None_eq_map_option_iff
thf(fact_7801_map__option__eq__Some,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xo: option @ B,Y2: A] :
      ( ( ( map_option @ B @ A @ F3 @ Xo )
        = ( some @ A @ Y2 ) )
      = ( ? [Z6: B] :
            ( ( Xo
              = ( some @ B @ Z6 ) )
            & ( ( F3 @ Z6 )
              = Y2 ) ) ) ) ).

% map_option_eq_Some
thf(fact_7802_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_rev
thf(fact_7803_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% hd_remdups_adj
thf(fact_7804_map__option__o__empty,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: C > B] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F3 )
        @ ^ [X6: A] : ( none @ C ) )
      = ( ^ [X6: A] : ( none @ B ) ) ) ).

% map_option_o_empty
thf(fact_7805_case__map__option,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: A,H: B > A,F3: C > B,X2: option @ C] :
      ( ( case_option @ A @ B @ G @ H @ ( map_option @ C @ B @ F3 @ X2 ) )
      = ( case_option @ A @ C @ G @ ( comp @ B @ A @ C @ H @ F3 ) @ X2 ) ) ).

% case_map_option
thf(fact_7806_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( cons @ A @ X2 @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) ) ) ).

% remdups_adj_Cons_alt
thf(fact_7807_ran__map__option,axiom,
    ! [A: $tType,C: $tType,B: $tType,F3: C > A,M: B > ( option @ C )] :
      ( ( ran @ B @ A
        @ ^ [X6: B] : ( map_option @ C @ A @ F3 @ ( M @ X6 ) ) )
      = ( image @ C @ A @ F3 @ ( ran @ B @ C @ M ) ) ) ).

% ran_map_option
thf(fact_7808_rtranclp_Omono,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( order_mono @ ( A > A > $o ) @ ( A > A > $o )
      @ ^ [P4: A > A > $o,X1: A,X22: A] :
          ( ? [A5: A] :
              ( ( X1 = A5 )
              & ( X22 = A5 ) )
          | ? [A5: A,B4: A,C4: A] :
              ( ( X1 = A5 )
              & ( X22 = C4 )
              & ( P4 @ A5 @ B4 )
              & ( R @ B4 @ C4 ) ) ) ) ).

% rtranclp.mono
thf(fact_7809_tranclp_Omono,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( order_mono @ ( A > A > $o ) @ ( A > A > $o )
      @ ^ [P4: A > A > $o,X1: A,X22: A] :
          ( ? [A5: A,B4: A] :
              ( ( X1 = A5 )
              & ( X22 = B4 )
              & ( R @ A5 @ B4 ) )
          | ? [A5: A,B4: A,C4: A] :
              ( ( X1 = A5 )
              & ( X22 = C4 )
              & ( P4 @ A5 @ B4 )
              & ( R @ B4 @ C4 ) ) ) ) ).

% tranclp.mono
thf(fact_7810_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% remdups_adj_length
thf(fact_7811_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7812_and__not__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(9)
thf(fact_7813_and__not__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(6)
thf(fact_7814_option_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F3: A > B] :
      ( ( map_option @ A @ B @ F3 @ ( none @ A ) )
      = ( none @ B ) ) ).

% option.simps(8)
thf(fact_7815_and__not__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(5)
thf(fact_7816_option_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F3: A > B,X23: A] :
      ( ( map_option @ A @ B @ F3 @ ( some @ A @ X23 ) )
      = ( some @ B @ ( F3 @ X23 ) ) ) ).

% option.simps(9)
thf(fact_7817_map__option__cong,axiom,
    ! [B: $tType,A: $tType,X2: option @ A,Y2: option @ A,F3: A > B,G: A > B] :
      ( ( X2 = Y2 )
     => ( ! [A4: A] :
            ( ( Y2
              = ( some @ A @ A4 ) )
           => ( ( F3 @ A4 )
              = ( G @ A4 ) ) )
       => ( ( map_option @ A @ B @ F3 @ X2 )
          = ( map_option @ A @ B @ G @ Y2 ) ) ) ) ).

% map_option_cong
thf(fact_7818_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups_adj @ A @ Xs )
        = Xs ) ) ).

% remdups_adj_distinct
thf(fact_7819_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( remdups_adj @ A @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) ) ) )
      & ( ( X2 != Y2 )
       => ( ( remdups_adj @ A @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) ) )
          = ( cons @ A @ X2 @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs ) ) ) ) ) ) ).

% remdups_adj.simps(3)
thf(fact_7820_option_Omap__ident,axiom,
    ! [A: $tType,T3: option @ A] :
      ( ( map_option @ A @ A
        @ ^ [X6: A] : X6
        @ T3 )
      = T3 ) ).

% option.map_ident
thf(fact_7821_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups_adj.simps(1)
thf(fact_7822_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) )
      = ( cons @ A @ X2 @ ( nil @ A ) ) ) ).

% remdups_adj.simps(2)
thf(fact_7823_remdups__adj_Oelims,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A] :
      ( ( ( remdups_adj @ A @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( nil @ A ) )
         => ( Y2
           != ( nil @ A ) ) )
       => ( ! [X7: A] :
              ( ( X2
                = ( cons @ A @ X7 @ ( nil @ A ) ) )
             => ( Y2
               != ( cons @ A @ X7 @ ( nil @ A ) ) ) )
         => ~ ! [X7: A,Y5: A,Xs3: list @ A] :
                ( ( X2
                  = ( cons @ A @ X7 @ ( cons @ A @ Y5 @ Xs3 ) ) )
               => ~ ( ( ( X7 = Y5 )
                     => ( Y2
                        = ( remdups_adj @ A @ ( cons @ A @ X7 @ Xs3 ) ) ) )
                    & ( ( X7 != Y5 )
                     => ( Y2
                        = ( cons @ A @ X7 @ ( remdups_adj @ A @ ( cons @ A @ Y5 @ Xs3 ) ) ) ) ) ) ) ) ) ) ).

% remdups_adj.elims
thf(fact_7824_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( cons @ A @ X2
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y: A] : ( Y = X2 )
            @ Xs ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_7825_option_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F3: B > nat,G: A > B] :
      ( ( comp @ ( option @ B ) @ nat @ ( option @ A ) @ ( size_option @ B @ F3 ) @ ( map_option @ A @ B @ G ) )
      = ( size_option @ A @ ( comp @ B @ nat @ A @ F3 @ G ) ) ) ).

% option.size_gen_o_map
thf(fact_7826_map__option_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: B > C,G: A > B] :
      ( ( comp @ ( option @ B ) @ ( option @ C ) @ ( option @ A ) @ ( map_option @ B @ C @ F3 ) @ ( map_option @ A @ B @ G ) )
      = ( map_option @ A @ C @ ( comp @ B @ C @ A @ F3 @ G ) ) ) ).

% map_option.comp
thf(fact_7827_option_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F3: A > B,V: option @ A] :
      ( ( map_option @ B @ C @ G @ ( map_option @ A @ B @ F3 @ V ) )
      = ( map_option @ A @ C @ ( comp @ B @ C @ A @ G @ F3 ) @ V ) ) ).

% option.map_comp
thf(fact_7828_map__option_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: B > C,G: A > B,Option: option @ A] :
      ( ( map_option @ B @ C @ F3 @ ( map_option @ A @ B @ G @ Option ) )
      = ( map_option @ A @ C @ ( comp @ B @ C @ A @ F3 @ G ) @ Option ) ) ).

% map_option.compositionality
thf(fact_7829_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Y2: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X2 = Y2 ) @ ( nil @ A ) @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_append_two
thf(fact_7830_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: C > B,Xs: list @ ( product_prod @ A @ C )] :
      ( ( map_of @ A @ B
        @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
            @ ^ [K2: A,V5: C] : ( product_Pair @ A @ B @ K2 @ ( F3 @ V5 ) ) )
          @ Xs ) )
      = ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F3 ) @ ( map_of @ A @ C @ Xs ) ) ) ).

% map_of_map
thf(fact_7831_map__option__case,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map_option @ B @ A )
      = ( ^ [F5: B > A] :
            ( case_option @ ( option @ A ) @ B @ ( none @ A )
            @ ^ [X6: B] : ( some @ A @ ( F5 @ X6 ) ) ) ) ) ).

% map_option_case
thf(fact_7832_remdups__adj__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X2 @ ( nil @ A ) )
        @ ^ [Y: A,Xs2: list @ A] : ( if @ ( list @ A ) @ ( X2 = Y ) @ ( cons @ A @ Y @ Xs2 ) @ ( cons @ A @ X2 @ ( cons @ A @ Y @ Xs2 ) ) )
        @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_Cons
thf(fact_7833_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P4: ( list @ A ) > ( list @ A ) > $o,X1: list @ A,X22: list @ A] :
          ( ? [Y: A,Ys2: list @ A] :
              ( ( X1
                = ( nil @ A ) )
              & ( X22
                = ( cons @ A @ Y @ Ys2 ) ) )
          | ? [X6: A,Y: A,Xs2: list @ A,Ys2: list @ A] :
              ( ( X1
                = ( cons @ A @ X6 @ Xs2 ) )
              & ( X22
                = ( cons @ A @ Y @ Ys2 ) )
              & ( Less @ X6 @ Y ) )
          | ? [X6: A,Y: A,Xs2: list @ A,Ys2: list @ A] :
              ( ( X1
                = ( cons @ A @ X6 @ Xs2 ) )
              & ( X22
                = ( cons @ A @ Y @ Ys2 ) )
              & ~ ( Less @ X6 @ Y )
              & ~ ( Less @ Y @ X6 )
              & ( P4 @ Xs2 @ Ys2 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_7834_finite_Omono,axiom,
    ! [A: $tType] :
      ( order_mono @ ( ( set @ A ) > $o ) @ ( ( set @ A ) > $o )
      @ ^ [P4: ( set @ A ) > $o,X6: set @ A] :
          ( ( X6
            = ( bot_bot @ ( set @ A ) ) )
          | ? [A7: set @ A,A5: A] :
              ( ( X6
                = ( insert @ A @ A5 @ A7 ) )
              & ( P4 @ A7 ) ) ) ) ).

% finite.mono
thf(fact_7835_remdups__adj__adjacent,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs ) @ I3 )
       != ( nth @ A @ ( remdups_adj @ A @ Xs ) @ ( suc @ I3 ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_7836_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X2 ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X2 ) )
          = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_7837_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( cons @ A @ X2 @ ( nil @ A ) ) )
     => ( Xs
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X2 ) ) ) ).

% remdups_adj_singleton
thf(fact_7838_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list @ A,X2: A,Xs_2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X2 @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs_2 ) ) ) ) ) ).

% remdups_adj_append
thf(fact_7839_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X6: A] : ( X6 = Y2 )
            @ Ys ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_7840_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P4: ( list @ A ) > ( list @ A ) > $o,X1: list @ A,X22: list @ A] :
            ( ? [Y: A,Ys2: list @ A] :
                ( ( X1
                  = ( nil @ A ) )
                & ( X22
                  = ( cons @ A @ Y @ Ys2 ) ) )
            | ? [X6: A,Y: A,Xs2: list @ A,Ys2: list @ A] :
                ( ( X1
                  = ( cons @ A @ X6 @ Xs2 ) )
                & ( X22
                  = ( cons @ A @ Y @ Ys2 ) )
                & ( ord_less @ A @ X6 @ Y ) )
            | ? [X6: A,Y: A,Xs2: list @ A,Ys2: list @ A] :
                ( ( X1
                  = ( cons @ A @ X6 @ Xs2 ) )
                & ( X22
                  = ( cons @ A @ Y @ Ys2 ) )
                & ~ ( ord_less @ A @ X6 @ Y )
                & ~ ( ord_less @ A @ Y @ X6 )
                & ( P4 @ Xs2 @ Ys2 ) ) ) ) ) ).

% lexordp.mono
thf(fact_7841_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X6: A] :
                ( X6
                = ( hd @ A @ Ys ) )
            @ ( tl @ A @ Ys ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_7842_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_7843_tendsto__at__topI__sequentially__real,axiom,
    ! [F3: real > real,Y2: real] :
      ( ( order_mono @ real @ real @ F3 )
     => ( ( filterlim @ nat @ real
          @ ^ [N2: nat] : ( F3 @ ( semiring_1_of_nat @ real @ N2 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
          @ ( at_top @ nat ) )
       => ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ Y2 ) @ ( at_top @ real ) ) ) ) ).

% tendsto_at_topI_sequentially_real
thf(fact_7844_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs
         != ( nil @ A ) )
        & ( Xs
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ ( hd @ A @ Xs ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_7845_remdups__adj_Opelims,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A] :
      ( ( ( remdups_adj @ A @ X2 )
        = Y2 )
     => ( ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ X2 )
       => ( ( ( X2
              = ( nil @ A ) )
           => ( ( Y2
                = ( nil @ A ) )
             => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( nil @ A ) ) ) )
         => ( ! [X7: A] :
                ( ( X2
                  = ( cons @ A @ X7 @ ( nil @ A ) ) )
               => ( ( Y2
                    = ( cons @ A @ X7 @ ( nil @ A ) ) )
                 => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X7 @ ( nil @ A ) ) ) ) )
           => ~ ! [X7: A,Y5: A,Xs3: list @ A] :
                  ( ( X2
                    = ( cons @ A @ X7 @ ( cons @ A @ Y5 @ Xs3 ) ) )
                 => ( ( ( ( X7 = Y5 )
                       => ( Y2
                          = ( remdups_adj @ A @ ( cons @ A @ X7 @ Xs3 ) ) ) )
                      & ( ( X7 != Y5 )
                       => ( Y2
                          = ( cons @ A @ X7 @ ( remdups_adj @ A @ ( cons @ A @ Y5 @ Xs3 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X7 @ ( cons @ A @ Y5 @ Xs3 ) ) ) ) ) ) ) ) ) ).

% remdups_adj.pelims
thf(fact_7846_and__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y2
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N3: num] :
                  ( Xa
                  = ( bit0 @ N3 ) )
             => ( Y2
               != ( none @ num ) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N3: num] :
                    ( Xa
                    = ( bit1 @ N3 ) )
               => ( Y2
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M5: num] :
                    ( X2
                    = ( bit0 @ M5 ) )
               => ( ( Xa = one2 )
                 => ( Y2
                   != ( none @ num ) ) ) )
             => ( ! [M5: num] :
                    ( ( X2
                      = ( bit0 @ M5 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M5 @ N3 ) ) ) ) )
               => ( ! [M5: num] :
                      ( ( X2
                        = ( bit0 @ M5 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M5 @ N3 ) ) ) ) )
                 => ( ( ? [M5: num] :
                          ( X2
                          = ( bit1 @ M5 ) )
                     => ( ( Xa = one2 )
                       => ( Y2
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M5: num] :
                          ( ( X2
                            = ( bit1 @ M5 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M5 @ N3 ) ) ) ) )
                     => ~ ! [M5: num] :
                            ( ( X2
                              = ( bit1 @ M5 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N11: num] : ( some @ num @ ( bit1 @ N11 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M5 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_7847_mono__compose,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ C ) )
     => ! [Q: A > B > C,F3: D > B] :
          ( ( order_mono @ A @ ( B > C ) @ Q )
         => ( order_mono @ A @ ( D > C )
            @ ^ [I: A,X6: D] : ( Q @ I @ ( F3 @ X6 ) ) ) ) ) ).

% mono_compose
thf(fact_7848_and__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(5)
thf(fact_7849_and__num_Osimps_I1_J,axiom,
    ( ( bit_un7362597486090784418nd_num @ one2 @ one2 )
    = ( some @ num @ one2 ) ) ).

% and_num.simps(1)
thf(fact_7850_and__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit1 @ N ) )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(3)
thf(fact_7851_and__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(7)
thf(fact_7852_and__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit0 @ N ) )
      = ( none @ num ) ) ).

% and_num.simps(2)
thf(fact_7853_and__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ one2 )
      = ( none @ num ) ) ).

% and_num.simps(4)
thf(fact_7854_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num,Q2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% and_num_eq_Some_iff
thf(fact_7855_and__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(8)
thf(fact_7856_and__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(6)
thf(fact_7857_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_7858_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ) ).

% numeral_and_num
thf(fact_7859_and__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N11: num] : ( some @ num @ ( bit1 @ N11 ) )
        @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(9)
thf(fact_7860_xor__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y2
             != ( none @ num ) ) ) )
       => ( ( ( X2 = one2 )
           => ! [N3: num] :
                ( ( Xa
                  = ( bit0 @ N3 ) )
               => ( Y2
                 != ( some @ num @ ( bit1 @ N3 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit1 @ N3 ) )
                 => ( Y2
                   != ( some @ num @ ( bit0 @ N3 ) ) ) ) )
           => ( ! [M5: num] :
                  ( ( X2
                    = ( bit0 @ M5 ) )
                 => ( ( Xa = one2 )
                   => ( Y2
                     != ( some @ num @ ( bit1 @ M5 ) ) ) ) )
             => ( ! [M5: num] :
                    ( ( X2
                      = ( bit0 @ M5 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M5 @ N3 ) ) ) ) )
               => ( ! [M5: num] :
                      ( ( X2
                        = ( bit0 @ M5 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M5 @ N3 ) ) ) ) ) )
                 => ( ! [M5: num] :
                        ( ( X2
                          = ( bit1 @ M5 ) )
                       => ( ( Xa = one2 )
                         => ( Y2
                           != ( some @ num @ ( bit0 @ M5 ) ) ) ) )
                   => ( ! [M5: num] :
                          ( ( X2
                            = ( bit1 @ M5 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M5 @ N3 ) ) ) ) ) )
                     => ~ ! [M5: num] :
                            ( ( X2
                              = ( bit1 @ M5 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M5 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
thf(fact_7861_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
thf(fact_7862_xor__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ).

% xor_num.simps(5)
thf(fact_7863_xor__num_Osimps_I1_J,axiom,
    ( ( bit_un2480387367778600638or_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% xor_num.simps(1)
thf(fact_7864_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num,Q2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% xor_num_eq_Some_iff
thf(fact_7865_xor__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ).

% xor_num.simps(9)
thf(fact_7866_xor__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit0 @ N ) )
      = ( some @ num @ ( bit1 @ N ) ) ) ).

% xor_num.simps(2)
thf(fact_7867_xor__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit1 @ N ) )
      = ( some @ num @ ( bit0 @ N ) ) ) ).

% xor_num.simps(3)
thf(fact_7868_xor__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit1 @ M ) ) ) ).

% xor_num.simps(4)
thf(fact_7869_xor__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% xor_num.simps(7)
thf(fact_7870_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_7871_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% numeral_xor_num
thf(fact_7872_xor__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% xor_num.simps(6)
thf(fact_7873_xor__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% xor_num.simps(8)
thf(fact_7874_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
thf(fact_7875_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F5: A > ( option @ B ),Xs2: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F5 )
            @ ( filter2 @ A
              @ ^ [X6: A] :
                  ( ( F5 @ X6 )
                 != ( none @ B ) )
              @ Xs2 ) ) ) ) ).

% map_filter_def
thf(fact_7876_option_Ocollapse,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
       != ( none @ A ) )
     => ( ( some @ A @ ( the2 @ A @ Option ) )
        = Option ) ) ).

% option.collapse
thf(fact_7877_option_Osel,axiom,
    ! [A: $tType,X23: A] :
      ( ( the2 @ A @ ( some @ A @ X23 ) )
      = X23 ) ).

% option.sel
thf(fact_7878_option_Oexpand,axiom,
    ! [A: $tType,Option: option @ A,Option2: option @ A] :
      ( ( ( Option
          = ( none @ A ) )
        = ( Option2
          = ( none @ A ) ) )
     => ( ( ( Option
           != ( none @ A ) )
         => ( ( Option2
             != ( none @ A ) )
           => ( ( the2 @ A @ Option )
              = ( the2 @ A @ Option2 ) ) ) )
       => ( Option = Option2 ) ) ) ).

% option.expand
thf(fact_7879_option_Oexhaust__sel,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
       != ( none @ A ) )
     => ( Option
        = ( some @ A @ ( the2 @ A @ Option ) ) ) ) ).

% option.exhaust_sel
thf(fact_7880_Option_Othese__def,axiom,
    ! [A: $tType] :
      ( ( these @ A )
      = ( ^ [A7: set @ ( option @ A )] :
            ( image @ ( option @ A ) @ A @ ( the2 @ A )
            @ ( collect @ ( option @ A )
              @ ^ [X6: option @ A] :
                  ( ( member @ ( option @ A ) @ X6 @ A7 )
                  & ( X6
                   != ( none @ A ) ) ) ) ) ) ) ).

% Option.these_def
thf(fact_7881_option_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_option @ B @ A )
      = ( ^ [F12: B,F22: A > B,Option3: option @ A] :
            ( if @ B
            @ ( Option3
              = ( none @ A ) )
            @ F12
            @ ( F22 @ ( the2 @ A @ Option3 ) ) ) ) ) ).

% option.case_eq_if
thf(fact_7882_option_Omap__sel,axiom,
    ! [B: $tType,A: $tType,A2: option @ A,F3: A > B] :
      ( ( A2
       != ( none @ A ) )
     => ( ( the2 @ B @ ( map_option @ A @ B @ F3 @ A2 ) )
        = ( F3 @ ( the2 @ A @ A2 ) ) ) ) ).

% option.map_sel
thf(fact_7883_Max_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite2 @ A @ A3 )
         => ( ( lattic643756798349783984er_Max @ A @ A3 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Max.infinite
thf(fact_7884_option_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P3: B > $o,F1: B,F2: A > B,Option: option @ A] :
      ( ( P3 @ ( case_option @ B @ A @ F1 @ F2 @ Option ) )
      = ( ( ( Option
            = ( none @ A ) )
         => ( P3 @ F1 ) )
        & ( ( Option
            = ( some @ A @ ( the2 @ A @ Option ) ) )
         => ( P3 @ ( F2 @ ( the2 @ A @ Option ) ) ) ) ) ) ).

% option.split_sel
thf(fact_7885_option_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P3: B > $o,F1: B,F2: A > B,Option: option @ A] :
      ( ( P3 @ ( case_option @ B @ A @ F1 @ F2 @ Option ) )
      = ( ~ ( ( ( Option
                = ( none @ A ) )
              & ~ ( P3 @ F1 ) )
            | ( ( Option
                = ( some @ A @ ( the2 @ A @ Option ) ) )
              & ~ ( P3 @ ( F2 @ ( the2 @ A @ Option ) ) ) ) ) ) ) ).

% option.split_sel_asm
thf(fact_7886_option_Orec__o__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: C,Ga: B > C,F3: A > B] :
      ( ( comp @ ( option @ B ) @ C @ ( option @ A ) @ ( rec_option @ C @ B @ G @ Ga ) @ ( map_option @ A @ B @ F3 ) )
      = ( rec_option @ C @ A @ G
        @ ^ [X6: A] : ( Ga @ ( F3 @ X6 ) ) ) ) ).

% option.rec_o_map
thf(fact_7887_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,I6: set @ B,F3: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I6 )
               => ( topolo7761053866217962861closed @ A @ ( F3 @ I2 ) ) )
           => ( ! [I9: set @ B] :
                  ( ( finite_finite2 @ B @ I9 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I9 @ I6 )
                   => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ I9 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ I6 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_7888_closed__INT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A3: set @ B,B5: B > ( set @ A )] :
          ( ! [X7: B] :
              ( ( member @ B @ X7 @ A3 )
             => ( topolo7761053866217962861closed @ A @ ( B5 @ X7 ) ) )
         => ( topolo7761053866217962861closed @ A @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) ) ) ) ).

% closed_INT
thf(fact_7889_closed__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A3: set @ B,B5: B > ( set @ A )] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [X7: B] :
                ( ( member @ B @ X7 @ A3 )
               => ( topolo7761053866217962861closed @ A @ ( B5 @ X7 ) ) )
           => ( topolo7761053866217962861closed @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) ) ) ) ) ).

% closed_UN
thf(fact_7890_open__Collect__imp,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o,Q: A > $o] :
          ( ( topolo7761053866217962861closed @ A @ ( collect @ A @ P3 ) )
         => ( ( topolo1002775350975398744n_open @ A @ ( collect @ A @ Q ) )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ( ( P3 @ X6 )
                   => ( Q @ X6 ) ) ) ) ) ) ) ).

% open_Collect_imp
thf(fact_7891_open__Collect__neg,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o] :
          ( ( topolo7761053866217962861closed @ A @ ( collect @ A @ P3 ) )
         => ( topolo1002775350975398744n_open @ A
            @ ( collect @ A
              @ ^ [X6: A] :
                  ~ ( P3 @ X6 ) ) ) ) ) ).

% open_Collect_neg
thf(fact_7892_closed__Collect__imp,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o,Q: A > $o] :
          ( ( topolo1002775350975398744n_open @ A @ ( collect @ A @ P3 ) )
         => ( ( topolo7761053866217962861closed @ A @ ( collect @ A @ Q ) )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ( ( P3 @ X6 )
                   => ( Q @ X6 ) ) ) ) ) ) ) ).

% closed_Collect_imp
thf(fact_7893_closed__Collect__neg,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o] :
          ( ( topolo1002775350975398744n_open @ A @ ( collect @ A @ P3 ) )
         => ( topolo7761053866217962861closed @ A
            @ ( collect @ A
              @ ^ [X6: A] :
                  ~ ( P3 @ X6 ) ) ) ) ) ).

% closed_Collect_neg
thf(fact_7894_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X6: A] : ( ord_less_eq @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_7895_closed__Collect__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topological_t2_space @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ( ( F3 @ X6 )
                    = ( G @ X6 ) ) ) ) ) ) ) ).

% closed_Collect_eq
thf(fact_7896_closed__Collect__const,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: $o] :
          ( topolo7761053866217962861closed @ A
          @ ( collect @ A
            @ ^ [X6: A] : P3 ) ) ) ).

% closed_Collect_const
thf(fact_7897_closed__Collect__disj,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o,Q: A > $o] :
          ( ( topolo7761053866217962861closed @ A @ ( collect @ A @ P3 ) )
         => ( ( topolo7761053866217962861closed @ A @ ( collect @ A @ Q ) )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ( ( P3 @ X6 )
                    | ( Q @ X6 ) ) ) ) ) ) ) ).

% closed_Collect_disj
thf(fact_7898_closed__Collect__conj,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: A > $o,Q: A > $o] :
          ( ( topolo7761053866217962861closed @ A @ ( collect @ A @ P3 ) )
         => ( ( topolo7761053866217962861closed @ A @ ( collect @ A @ Q ) )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X6: A] :
                    ( ( P3 @ X6 )
                    & ( Q @ X6 ) ) ) ) ) ) ) ).

% closed_Collect_conj
thf(fact_7899_option_Osimps_I7_J,axiom,
    ! [C: $tType,A: $tType,F1: C,F2: A > C,X23: A] :
      ( ( rec_option @ C @ A @ F1 @ F2 @ ( some @ A @ X23 ) )
      = ( F2 @ X23 ) ) ).

% option.simps(7)
thf(fact_7900_option_Osimps_I6_J,axiom,
    ! [A: $tType,C: $tType,F1: C,F2: A > C] :
      ( ( rec_option @ C @ A @ F1 @ F2 @ ( none @ A ) )
      = F1 ) ).

% option.simps(6)
thf(fact_7901_closed__Collect__all,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P3: B > A > $o] :
          ( ! [I2: B] : ( topolo7761053866217962861closed @ A @ ( collect @ A @ ( P3 @ I2 ) ) )
         => ( topolo7761053866217962861closed @ A
            @ ( collect @ A
              @ ^ [X6: A] :
                ! [I: B] : ( P3 @ I @ X6 ) ) ) ) ) ).

% closed_Collect_all
thf(fact_7902_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X6: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X6 @ Y ) )
              & ( ord_less_eq @ A @ X6 @ Y ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_7903_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X6: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X6 @ Y ) )
              & ( ord_less_eq @ A @ Y @ X6 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_7904_closed__diagonal,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Y: product_prod @ A @ A] :
            ? [X6: A] :
              ( Y
              = ( product_Pair @ A @ A @ X6 @ X6 ) ) ) ) ) ).

% closed_diagonal
thf(fact_7905_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( member @ A @ X2 @ A3 )
         => ( ( topolo1002775350975398744n_open @ A @ A3 )
           => ? [A14: set @ A] :
                ( ( member @ A @ X2 @ A14 )
                & ( topolo7761053866217962861closed @ A @ A14 )
                & ( ord_less_eq @ ( set @ A ) @ A14 @ A3 )
                & ( eventually @ A
                  @ ^ [Y: A] : ( member @ A @ Y @ A14 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X2 ) ) ) ) ) ) ).

% nhds_closed
thf(fact_7906_continuous__on__closed__Union,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [I6: set @ A,U6: A > ( set @ B ),F3: B > C] :
          ( ( finite_finite2 @ A @ I6 )
         => ( ! [I2: A] :
                ( ( member @ A @ I2 @ I6 )
               => ( topolo7761053866217962861closed @ B @ ( U6 @ I2 ) ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I6 )
                 => ( topolo81223032696312382ous_on @ B @ C @ ( U6 @ I2 ) @ F3 ) )
             => ( topolo81223032696312382ous_on @ B @ C @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ U6 @ I6 ) ) @ F3 ) ) ) ) ) ).

% continuous_on_closed_Union
thf(fact_7907_Lim__in__closed__set,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A,F3: B > A,F4: filter @ B,L: A] :
          ( ( topolo7761053866217962861closed @ A @ S3 )
         => ( ( eventually @ B
              @ ^ [X6: B] : ( member @ A @ ( F3 @ X6 ) @ S3 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
               => ( member @ A @ L @ S3 ) ) ) ) ) ) ).

% Lim_in_closed_set
thf(fact_7908_lenlex__append2,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),Us: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( irrefl @ A @ R3 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs ) @ ( append @ A @ Us @ Ys ) ) @ ( lenlex @ A @ R3 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lenlex @ A @ R3 ) ) ) ) ).

% lenlex_append2
thf(fact_7909_inj__sgn__power,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( inj_on @ real @ real
        @ ^ [Y: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_7910_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F3: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map @ A @ B @ F3 @ Xs )
          = ( map @ A @ B @ F3 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_map_eq_map
thf(fact_7911_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_7912_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B4: A] : ( divide_divide @ A @ B4 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_7913_inj__map,axiom,
    ! [B: $tType,A: $tType,F3: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F3 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
      = ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_map
thf(fact_7914_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F3: A > B] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F3 ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ) ).

% inj_mapI
thf(fact_7915_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( irrefl @ A @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_7916_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ ( list @ A )] :
      ( ( inj_on @ A @ B @ F3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ A3 ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F3 ) @ A3 ) ) ).

% inj_on_mapI
thf(fact_7917_inj__on__INTER,axiom,
    ! [C: $tType,B: $tType,A: $tType,I6: set @ A,F3: B > C,A3: A > ( set @ B )] :
      ( ( I6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( inj_on @ B @ C @ F3 @ ( A3 @ I2 ) ) )
       => ( inj_on @ B @ C @ F3 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) ) ) ) ).

% inj_on_INTER
thf(fact_7918_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( finite_card @ B @ A3 ) )
     => ~ ( inj_on @ B @ A @ F3 @ A3 ) ) ).

% pigeonhole
thf(fact_7919_prod_Oimage__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( inj_on @ B @ A @ G @ A3 )
         => ( ( groups7121269368397514597t_prod @ A @ A
              @ ^ [X6: A] : X6
              @ ( image @ B @ A @ G @ A3 ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.image_eq
thf(fact_7920_sum_Oimage__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( inj_on @ B @ A @ G @ A3 )
         => ( ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X6: A] : X6
              @ ( image @ B @ A @ G @ A3 ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum.image_eq
thf(fact_7921_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F3: A > B,B5: set @ A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ B5 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
       => ( ord_less @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ ( image @ A @ B @ F3 @ B5 ) ) ) ) ).

% inj_on_strict_subset
thf(fact_7922_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B ),F3: B > C] :
      ( ! [I2: A,J: A] :
          ( ( member @ A @ I2 @ I6 )
         => ( ( member @ A @ J @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I2 ) @ ( A3 @ J ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J ) @ ( A3 @ I2 ) ) ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( inj_on @ B @ C @ F3 @ ( A3 @ I2 ) ) )
       => ( inj_on @ B @ C @ F3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_7923_finite__inverse__image__gen,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F3: B > A,D4: set @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( inj_on @ B @ A @ F3 @ D4 )
       => ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [J4: B] :
                ( ( member @ B @ J4 @ D4 )
                & ( member @ A @ ( F3 @ J4 ) @ A3 ) ) ) ) ) ) ).

% finite_inverse_image_gen
thf(fact_7924_inj__fn,axiom,
    ! [A: $tType,F3: A > A,N: nat] :
      ( ( inj_on @ A @ A @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_7925_finite__inverse__image,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F3: B > A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( inj_on @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [J4: B] : ( member @ A @ ( F3 @ J4 ) @ A3 ) ) ) ) ) ).

% finite_inverse_image
thf(fact_7926_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F3: A > B,Y2: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( insert @ A @ Y2 @ ( set2 @ A @ Xs ) ) )
     => ( ( filter2 @ A
          @ ^ [X6: A] :
              ( ( F3 @ Y2 )
              = ( F3 @ X6 ) )
          @ Xs )
        = ( filter2 @ A
          @ ( ^ [Y4: A,Z3: A] : ( Y4 = Z3 )
            @ Y2 )
          @ Xs ) ) ) ).

% inj_on_filter_key_eq
thf(fact_7927_lexord__irrefl,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R3 )
     => ( irrefl @ ( list @ A ) @ ( lexord @ A @ R3 ) ) ) ).

% lexord_irrefl
thf(fact_7928_injective__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C2: real] :
          ( ( C2
           != ( zero_zero @ real ) )
         => ( inj_on @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% injective_scaleR
thf(fact_7929_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F3: A > B] :
          ( ! [X7: A,Y5: A] :
              ( ( ord_less @ A @ X7 @ Y5 )
             => ( ( F3 @ X7 )
               != ( F3 @ Y5 ) ) )
         => ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_7930_inj__fun,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: A > B] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ ( C > B )
        @ ^ [X6: A,Y: C] : ( F3 @ X6 )
        @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fun
thf(fact_7931_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_7932_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( inj_on @ A @ A
          @ ^ [B4: A] : ( minus_minus @ A @ B4 @ A2 )
          @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_diff_right
thf(fact_7933_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X6: A] : X6
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_7934_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A3 ) ) ) ).

% inj_on_mult
thf(fact_7935_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F3: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F3 )
     => ( inj_on @ B @ A @ F3 @ S3 ) ) ).

% folding_insort_key.inj_on
thf(fact_7936_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 ) ) ).

% inj_on_add
thf(fact_7937_inj__on__id2,axiom,
    ! [A: $tType,A3: set @ A] :
      ( inj_on @ A @ A
      @ ^ [X6: A] : X6
      @ A3 ) ).

% inj_on_id2
thf(fact_7938_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B4: A] : ( plus_plus @ A @ B4 @ A2 )
          @ A3 ) ) ).

% inj_on_add'
thf(fact_7939_irrefl__lex,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R )
     => ( irrefl @ ( list @ A ) @ ( lex @ A @ R ) ) ) ).

% irrefl_lex
thf(fact_7940_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,F3: A > B] :
          ( ! [X7: A,Y5: A] :
              ( ( ord_less @ A @ X7 @ Y5 )
             => ( ( member @ A @ X7 @ A3 )
               => ( ( member @ A @ Y5 @ A3 )
                 => ( ( F3 @ X7 )
                   != ( F3 @ Y5 ) ) ) ) )
         => ( ! [X7: A,Y5: A] :
                ( ( member @ A @ X7 @ A3 )
               => ( ( member @ A @ Y5 @ A3 )
                 => ( ( ord_less_eq @ A @ X7 @ Y5 )
                    | ( ord_less_eq @ A @ Y5 @ X7 ) ) ) )
           => ( inj_on @ A @ B @ F3 @ A3 ) ) ) ) ).

% linorder_inj_onI
thf(fact_7941_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X2: A,B2: A,F3: A > B] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ( ord_less @ A @ X2 @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F3 )
             => ( ( inj_on @ A @ B @ F3 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F3 @ A2 ) @ ( F3 @ X2 ) )
                    & ( ord_less @ B @ ( F3 @ X2 ) @ ( F3 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F3 @ B2 ) @ ( F3 @ X2 ) )
                    & ( ord_less @ B @ ( F3 @ X2 ) @ ( F3 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_7942_irrefl__distinct,axiom,
    ! [A: $tType] :
      ( ( irrefl @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [X6: product_prod @ A @ A] :
            ( ( member @ ( product_prod @ A @ A ) @ X6 @ R5 )
           => ( product_case_prod @ A @ A @ $o
              @ ^ [A5: A,B4: A] : ( A5 != B4 )
              @ X6 ) ) ) ) ).

% irrefl_distinct
thf(fact_7943_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F3: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F3 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
     => ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_mapD
thf(fact_7944_map__injective,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F3 @ Xs )
        = ( map @ B @ A @ F3 @ Ys ) )
     => ( ( inj_on @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
       => ( Xs = Ys ) ) ) ).

% map_injective
thf(fact_7945_distinct__map,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B] :
      ( ( distinct @ A @ ( map @ B @ A @ F3 @ Xs ) )
      = ( ( distinct @ B @ Xs )
        & ( inj_on @ B @ A @ F3 @ ( set2 @ B @ Xs ) ) ) ) ).

% distinct_map
thf(fact_7946_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F3: A > B,X2: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( map @ A @ B @ F3 @ ( removeAll @ A @ X2 @ Xs ) )
        = ( removeAll @ B @ ( F3 @ X2 ) @ ( map @ A @ B @ F3 @ Xs ) ) ) ) ).

% map_removeAll_inj
thf(fact_7947_option_Oinj__map,axiom,
    ! [B: $tType,A: $tType,F3: A > B] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( option @ A ) @ ( option @ B ) @ ( map_option @ A @ B @ F3 ) @ ( top_top @ ( set @ ( option @ A ) ) ) ) ) ).

% option.inj_map
thf(fact_7948_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F3: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( remdups_adj @ B @ ( map @ A @ B @ F3 @ Xs ) )
        = ( map @ A @ B @ F3 @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_map_injective
thf(fact_7949_lexl__not__refl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X2: list @ A] :
      ( ( irrefl @ A @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ X2 ) @ ( lex @ A @ R ) ) ) ).

% lexl_not_refl
thf(fact_7950_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F3: A > B,X2: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( insert @ A @ X2 @ ( set2 @ A @ Xs ) ) )
     => ( ( map @ A @ B @ F3 @ ( removeAll @ A @ X2 @ Xs ) )
        = ( removeAll @ B @ ( F3 @ X2 ) @ ( map @ A @ B @ F3 @ Xs ) ) ) ) ).

% map_removeAll_inj_on
thf(fact_7951_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: A > B,C6: set @ A,A3: set @ C,B5: C > ( set @ A ),J2: C] :
      ( ( inj_on @ A @ B @ F3 @ C6 )
     => ( ! [X7: C] :
            ( ( member @ C @ X7 @ A3 )
           => ( ord_less_eq @ ( set @ A ) @ ( B5 @ X7 ) @ C6 ) )
       => ( ( member @ C @ J2 @ A3 )
         => ( ( image @ A @ B @ F3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B5 @ A3 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X6: C] : ( image @ A @ B @ F3 @ ( B5 @ X6 ) )
                @ A3 ) ) ) ) ) ) ).

% image_INT
thf(fact_7952_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_7953_funpow__inj__finite,axiom,
    ! [A: $tType,P5: A > A,X2: A] :
      ( ( inj_on @ A @ A @ P5 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [Y: A] :
              ? [N2: nat] :
                ( Y
                = ( compow @ ( A > A ) @ N2 @ P5 @ X2 ) ) ) )
       => ~ ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( compow @ ( A > A ) @ N3 @ P5 @ X2 )
               != X2 ) ) ) ) ).

% funpow_inj_finite
thf(fact_7954_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: A > B,T3: list @ ( product_prod @ A @ C ),K: A,X2: C] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map_of @ A @ C @ T3 @ K )
          = ( some @ C @ X2 ) )
       => ( ( map_of @ B @ C
            @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C )
              @ ( product_case_prod @ A @ C @ ( product_prod @ B @ C )
                @ ^ [K2: A] : ( product_Pair @ B @ C @ ( F3 @ K2 ) ) )
              @ T3 )
            @ ( F3 @ K ) )
          = ( some @ C @ X2 ) ) ) ) ).

% map_of_mapk_SomeI
thf(fact_7955_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R3 )
     => ( ( transitive_rtrancl @ A @ R3 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 )
            @ ( collect @ nat
              @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_7956_uniformly__continuous__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo7287701948861334536_space @ A )
        & ( topolo7287701948861334536_space @ B ) )
     => ! [S: set @ A,F3: A > B,E5: ( product_prod @ B @ B ) > $o] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ S @ F3 )
         => ( ( eventually @ ( product_prod @ B @ B ) @ E5 @ ( topolo7806501430040627800ormity @ B ) )
           => ( eventually @ ( product_prod @ A @ A )
              @ ( product_case_prod @ A @ A @ $o
                @ ^ [X6: A,Y: A] :
                    ( ( member @ A @ X6 @ S )
                   => ( ( member @ A @ Y @ S )
                     => ( E5 @ ( product_Pair @ B @ B @ ( F3 @ X6 ) @ ( F3 @ Y ) ) ) ) ) )
              @ ( topolo7806501430040627800ormity @ A ) ) ) ) ) ).

% uniformly_continuous_onD
thf(fact_7957_inj__on__rev,axiom,
    ! [A: $tType,A3: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ A3 ) ).

% inj_on_rev
thf(fact_7958_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ? [F6: A > nat,N3: nat] :
          ( ( ( image @ A @ nat @ F6 @ A3 )
            = ( collect @ nat
              @ ^ [I: nat] : ( ord_less @ nat @ I @ N3 ) ) )
          & ( inj_on @ A @ nat @ F6 @ A3 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_7959_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ? [N3: nat,F6: nat > A] :
          ( ( A3
            = ( image @ nat @ A @ F6
              @ ( collect @ nat
                @ ^ [I: nat] : ( ord_less @ nat @ I @ N3 ) ) ) )
          & ( inj_on @ nat @ A @ F6
            @ ( collect @ nat
              @ ^ [I: nat] : ( ord_less @ nat @ I @ N3 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_7960_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F3: A > B,X15: set @ A] :
      ( inj_on @ A @ ( product_prod @ A @ B )
      @ ^ [X6: A] : ( product_Pair @ A @ B @ X6 @ ( F3 @ X6 ) )
      @ X15 ) ).

% inj_on_convol_ident
thf(fact_7961_inj__singleton,axiom,
    ! [A: $tType,A3: set @ A] :
      ( inj_on @ A @ ( set @ A )
      @ ^ [X6: A] : ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) )
      @ A3 ) ).

% inj_singleton
thf(fact_7962_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_7963_inj__Suc,axiom,
    ! [N5: set @ nat] : ( inj_on @ nat @ nat @ suc @ N5 ) ).

% inj_Suc
thf(fact_7964_inj__on__Cons1,axiom,
    ! [A: $tType,X2: A,A3: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ A3 ) ).

% inj_on_Cons1
thf(fact_7965_inj__Some,axiom,
    ! [A: $tType,A3: set @ A] : ( inj_on @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ).

% inj_Some
thf(fact_7966_inj__on__diff__nat,axiom,
    ! [N5: set @ nat,K: nat] :
      ( ! [N3: nat] :
          ( ( member @ nat @ N3 @ N5 )
         => ( ord_less_eq @ nat @ K @ N3 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ K )
        @ N5 ) ) ).

% inj_on_diff_nat
thf(fact_7967_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( product_prod @ A @ B )] :
      ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A )
      @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
        @ ^ [I: A,J4: B] : ( product_Pair @ B @ A @ J4 @ I ) )
      @ A3 ) ).

% swap_inj_on
thf(fact_7968_inj__graph,axiom,
    ! [B: $tType,A: $tType] :
      ( inj_on @ ( A > B ) @ ( set @ ( product_prod @ A @ B ) )
      @ ^ [F5: A > B] :
          ( collect @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [X6: A,Y: B] :
                ( Y
                = ( F5 @ X6 ) ) ) )
      @ ( top_top @ ( set @ ( A > B ) ) ) ) ).

% inj_graph
thf(fact_7969_inj__split__Cons,axiom,
    ! [A: $tType,X15: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs2: list @ A,N2: A] : ( cons @ A @ N2 @ Xs2 ) )
      @ X15 ) ).

% inj_split_Cons
thf(fact_7970_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ ( transitive_rtrancl @ A @ R ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
thf(fact_7971_uniformly__continuous__on__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo7287701948861334536_space @ A )
        & ( topolo7287701948861334536_space @ B ) )
     => ! [S: set @ A,C2: B] :
          ( topolo6026614971017936543ous_on @ A @ B @ S
          @ ^ [X6: A] : C2 ) ) ).

% uniformly_continuous_on_const
thf(fact_7972_uniformly__continuous__on__id,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S: set @ A] :
          ( topolo6026614971017936543ous_on @ A @ A @ S
          @ ^ [X6: A] : X6 ) ) ).

% uniformly_continuous_on_id
thf(fact_7973_uniformly__continuous__on__Cauchy,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [S3: set @ A,F3: A > B,X15: nat > A] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ S3 @ F3 )
         => ( ( topolo3814608138187158403Cauchy @ A @ X15 )
           => ( ! [N3: nat] : ( member @ A @ ( X15 @ N3 ) @ S3 )
             => ( topolo3814608138187158403Cauchy @ B
                @ ^ [N2: nat] : ( F3 @ ( X15 @ N2 ) ) ) ) ) ) ) ).

% uniformly_continuous_on_Cauchy
thf(fact_7974_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),X2: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ X2 @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_7975_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_7976_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
     => ( ( size_size @ ( list @ A ) @ X2 )
        = ( size_size @ ( list @ A ) @ Y2 ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_7977_uniformly__continuous__on__compose,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo7287701948861334536_space @ A )
        & ( topolo7287701948861334536_space @ C )
        & ( topolo7287701948861334536_space @ B ) )
     => ! [S: set @ A,G: A > B,F3: B > C] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ S @ G )
         => ( ( topolo6026614971017936543ous_on @ B @ C @ ( image @ A @ B @ G @ S ) @ F3 )
           => ( topolo6026614971017936543ous_on @ A @ C @ S
              @ ^ [X6: A] : ( F3 @ ( G @ X6 ) ) ) ) ) ) ).

% uniformly_continuous_on_compose
thf(fact_7978_inj__on__nth,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ! [X7: nat] :
            ( ( member @ nat @ X7 @ I6 )
           => ( ord_less @ nat @ X7 @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs ) @ I6 ) ) ) ).

% inj_on_nth
thf(fact_7979_isUCont__Cauchy,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F3: A > B,X15: nat > A] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F3 )
         => ( ( topolo3814608138187158403Cauchy @ A @ X15 )
           => ( topolo3814608138187158403Cauchy @ B
              @ ^ [N2: nat] : ( F3 @ ( X15 @ N2 ) ) ) ) ) ) ).

% isUCont_Cauchy
thf(fact_7980_summable__reindex,axiom,
    ! [F3: nat > real,G: nat > nat] :
      ( ( summable @ real @ F3 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X7: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X7 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F3 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_7981_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F3: A > A,S: A] :
      ( ( ( compow @ ( A > A ) @ N @ F3 @ S )
        = S )
     => ( ! [M5: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M5 )
           => ( ( ord_less @ nat @ M5 @ N )
             => ( ( compow @ ( A > A ) @ M5 @ F3 @ S )
               != S ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K2: nat] : ( compow @ ( A > A ) @ K2 @ F3 @ S )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% inj_on_funpow_least
thf(fact_7982_uniformly__continuous__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ( ( topolo6026614971017936543ous_on @ A @ B )
        = ( ^ [S4: set @ A,F5: A > B] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [D5: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                  & ! [X6: A] :
                      ( ( member @ A @ X6 @ S4 )
                     => ! [Y: A] :
                          ( ( member @ A @ Y @ S4 )
                         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X6 ) @ D5 )
                           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F5 @ Y ) @ ( F5 @ X6 ) ) @ E3 ) ) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
thf(fact_7983_rtrancl__is__UN__relpow,axiom,
    ! [A: $tType] :
      ( ( transitive_rtrancl @ A )
      = ( ^ [R7: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R7 )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% rtrancl_is_UN_relpow
thf(fact_7984_rtrancl__imp__UN__relpow,axiom,
    ! [A: $tType,P5: product_prod @ A @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P5 @ ( transitive_rtrancl @ A @ R3 ) )
     => ( member @ ( product_prod @ A @ A ) @ P5
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 )
            @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% rtrancl_imp_UN_relpow
thf(fact_7985_suminf__reindex__mono,axiom,
    ! [F3: nat > real,G: nat > nat] :
      ( ( summable @ real @ F3 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X7: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X7 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F3 @ G ) ) @ ( suminf @ real @ F3 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_7986_isUCont__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F3: A > B] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F3 )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S4 )
                    & ! [X6: A,Y: A] :
                        ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ Y ) @ S4 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X6 ) @ ( F3 @ Y ) ) @ R5 ) ) ) ) ) ) ) ).

% isUCont_def
thf(fact_7987_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_7988_suminf__reindex,axiom,
    ! [F3: nat > real,G: nat > nat] :
      ( ( summable @ real @ F3 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X7: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X7 ) )
         => ( ! [X7: nat] :
                ( ~ ( member @ nat @ X7 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F3 @ X7 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F3 @ G ) )
              = ( suminf @ real @ F3 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_7989_shuffles_Oelims,axiom,
    ! [A: $tType,X2: list @ A,Xa: list @ A,Y2: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2
            = ( nil @ A ) )
         => ( Y2
           != ( insert @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y2
             != ( insert @ ( list @ A ) @ X2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X7: A,Xs3: list @ A] :
                ( ( X2
                  = ( cons @ A @ X7 @ Xs3 ) )
               => ! [Y5: A,Ys4: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ Y5 @ Ys4 ) )
                   => ( Y2
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X7 ) @ ( shuffles @ A @ Xs3 @ ( cons @ A @ Y5 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y5 ) @ ( shuffles @ A @ ( cons @ A @ X7 @ Xs3 ) @ Ys4 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_7990_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,F3: B > ( list @ A )] :
      ( ( set2 @ A @ ( bind @ B @ A @ Xs @ F3 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X6: B] : ( set2 @ A @ ( F3 @ X6 ) )
          @ ( set2 @ B @ Xs ) ) ) ) ).

% set_list_bind
thf(fact_7991_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F3: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F3 )
      = ( nil @ A ) ) ).

% bind_simps(1)
thf(fact_7992_set__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( append @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_append
thf(fact_7993_if__image__distrib,axiom,
    ! [A: $tType,B: $tType,P3: B > $o,F3: B > A,G: B > A,S3: set @ B] :
      ( ( image @ B @ A
        @ ^ [X6: B] : ( if @ A @ ( P3 @ X6 ) @ ( F3 @ X6 ) @ ( G @ X6 ) )
        @ S3 )
      = ( sup_sup @ ( set @ A ) @ ( image @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ S3 @ ( collect @ B @ P3 ) ) )
        @ ( image @ B @ A @ G
          @ ( inf_inf @ ( set @ B ) @ S3
            @ ( collect @ B
              @ ^ [X6: B] :
                  ~ ( P3 @ X6 ) ) ) ) ) ) ).

% if_image_distrib
thf(fact_7994_UN__Un,axiom,
    ! [A: $tType,B: $tType,M7: B > ( set @ A ),A3: set @ B,B5: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ M7 @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ M7 @ A3 ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ M7 @ B5 ) ) ) ) ).

% UN_Un
thf(fact_7995_bdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ( condit941137186595557371_above @ A
            @ ( image @ B @ A
              @ ^ [X6: B] : ( sup_sup @ A @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ A3 ) )
          = ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F3 @ A3 ) )
            & ( condit941137186595557371_above @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% bdd_above_image_sup
thf(fact_7996_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X2: B,Xs: list @ B,F3: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( cons @ B @ X2 @ Xs ) @ F3 )
      = ( append @ A @ ( F3 @ X2 ) @ ( bind @ B @ A @ Xs @ F3 ) ) ) ).

% bind_simps(2)
thf(fact_7997_set__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( union @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_union
thf(fact_7998_UN__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C6: set @ C,A3: C > ( set @ D ),B5: set @ D] :
      ( ( ( C6
          = ( bot_bot @ ( set @ C ) ) )
       => ( ( complete_Sup_Sup @ ( set @ D )
            @ ( image @ C @ ( set @ D )
              @ ^ [X6: C] : ( sup_sup @ ( set @ D ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) )
          = ( bot_bot @ ( set @ D ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ C ) ) )
       => ( ( complete_Sup_Sup @ ( set @ D )
            @ ( image @ C @ ( set @ D )
              @ ^ [X6: C] : ( sup_sup @ ( set @ D ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) )
          = ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ A3 @ C6 ) ) @ B5 ) ) ) ) ).

% UN_simps(2)
thf(fact_7999_UN__simps_I3_J,axiom,
    ! [E4: $tType,F: $tType,C6: set @ F,A3: set @ E4,B5: F > ( set @ E4 )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ F ) ) )
       => ( ( complete_Sup_Sup @ ( set @ E4 )
            @ ( image @ F @ ( set @ E4 )
              @ ^ [X6: F] : ( sup_sup @ ( set @ E4 ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) )
          = ( bot_bot @ ( set @ E4 ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ F ) ) )
       => ( ( complete_Sup_Sup @ ( set @ E4 )
            @ ( image @ F @ ( set @ E4 )
              @ ^ [X6: F] : ( sup_sup @ ( set @ E4 ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) )
          = ( sup_sup @ ( set @ E4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ E4 ) @ ( image @ F @ ( set @ E4 ) @ B5 @ C6 ) ) ) ) ) ) ).

% UN_simps(3)
thf(fact_8000_UN__insert,axiom,
    ! [A: $tType,B: $tType,B5: B > ( set @ A ),A2: B,A3: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ ( insert @ B @ A2 @ A3 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( B5 @ A2 ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ A3 ) ) ) ) ).

% UN_insert
thf(fact_8001_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F3: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) )
     => ( ( ( map @ A @ B @ F3 @ Xs )
          = ( map @ A @ B @ F3 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_on_map_eq_map
thf(fact_8002_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F3: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F3 @ Xs )
        = ( map @ B @ A @ F3 @ Ys ) )
     => ( ( inj_on @ B @ A @ F3 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
       => ( Xs = Ys ) ) ) ).

% map_inj_on
thf(fact_8003_INF__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F3: B > A,B5: set @ B,A2: A] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ B5 ) ) @ A2 )
          = ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [B4: B] : ( sup_sup @ A @ ( F3 @ B4 ) @ A2 )
              @ B5 ) ) ) ) ).

% INF_sup
thf(fact_8004_Inf__sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B5: set @ A,A2: A] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ B5 ) @ A2 )
          = ( complete_Inf_Inf @ A
            @ ( image @ A @ A
              @ ^ [B4: A] : ( sup_sup @ A @ B4 @ A2 )
              @ B5 ) ) ) ) ).

% Inf_sup
thf(fact_8005_sup__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A2: A,F3: B > A,B5: set @ B] :
          ( ( sup_sup @ A @ A2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ B5 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [B4: B] : ( sup_sup @ A @ A2 @ ( F3 @ B4 ) )
              @ B5 ) ) ) ) ).

% sup_INF
thf(fact_8006_INF__sup__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F3: B > A,A3: set @ B,G: C > A,B5: set @ C] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B5 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [A5: B] :
                  ( complete_Inf_Inf @ A
                  @ ( image @ C @ A
                    @ ^ [B4: C] : ( sup_sup @ A @ ( F3 @ A5 ) @ ( G @ B4 ) )
                    @ B5 ) )
              @ A3 ) ) ) ) ).

% INF_sup_distrib2
thf(fact_8007_Un__INT__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A3: B > ( set @ A ),I6: set @ B,B5: C > ( set @ A ),J5: set @ C] :
      ( ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B5 @ J5 ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [I: B] :
              ( complete_Inf_Inf @ ( set @ A )
              @ ( image @ C @ ( set @ A )
                @ ^ [J4: C] : ( sup_sup @ ( set @ A ) @ ( A3 @ I ) @ ( B5 @ J4 ) )
                @ J5 ) )
          @ I6 ) ) ) ).

% Un_INT_distrib2
thf(fact_8008_Un__INT__distrib,axiom,
    ! [A: $tType,B: $tType,B5: set @ A,A3: B > ( set @ A ),I6: set @ B] :
      ( ( sup_sup @ ( set @ A ) @ B5 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [I: B] : ( sup_sup @ ( set @ A ) @ B5 @ ( A3 @ I ) )
          @ I6 ) ) ) ).

% Un_INT_distrib
thf(fact_8009_INT__extend__simps_I6_J,axiom,
    ! [L4: $tType,K9: $tType,A3: K9 > ( set @ L4 ),C6: set @ K9,B5: set @ L4] :
      ( ( sup_sup @ ( set @ L4 ) @ ( complete_Inf_Inf @ ( set @ L4 ) @ ( image @ K9 @ ( set @ L4 ) @ A3 @ C6 ) ) @ B5 )
      = ( complete_Inf_Inf @ ( set @ L4 )
        @ ( image @ K9 @ ( set @ L4 )
          @ ^ [X6: K9] : ( sup_sup @ ( set @ L4 ) @ ( A3 @ X6 ) @ B5 )
          @ C6 ) ) ) ).

% INT_extend_simps(6)
thf(fact_8010_INT__extend__simps_I7_J,axiom,
    ! [M11: $tType,N10: $tType,A3: set @ M11,B5: N10 > ( set @ M11 ),C6: set @ N10] :
      ( ( sup_sup @ ( set @ M11 ) @ A3 @ ( complete_Inf_Inf @ ( set @ M11 ) @ ( image @ N10 @ ( set @ M11 ) @ B5 @ C6 ) ) )
      = ( complete_Inf_Inf @ ( set @ M11 )
        @ ( image @ N10 @ ( set @ M11 )
          @ ^ [X6: N10] : ( sup_sup @ ( set @ M11 ) @ A3 @ ( B5 @ X6 ) )
          @ C6 ) ) ) ).

% INT_extend_simps(7)
thf(fact_8011_Un__Inter,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( complete_Inf_Inf @ ( set @ A ) @ B5 ) )
      = ( complete_Inf_Inf @ ( set @ A ) @ ( image @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 ) @ B5 ) ) ) ).

% Un_Inter
thf(fact_8012_Un__Union__image,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),B5: B > ( set @ A ),C6: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X6: B] : ( sup_sup @ ( set @ A ) @ ( A3 @ X6 ) @ ( B5 @ X6 ) )
          @ C6 ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ C6 ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ C6 ) ) ) ) ).

% Un_Union_image
thf(fact_8013_UN__Un__distrib,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),B5: B > ( set @ A ),I6: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [I: B] : ( sup_sup @ ( set @ A ) @ ( A3 @ I ) @ ( B5 @ I ) )
          @ I6 ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B5 @ I6 ) ) ) ) ).

% UN_Un_distrib
thf(fact_8014_UN__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I6: set @ A,A3: A > ( set @ B )] :
      ( ( member @ A @ K @ I6 )
     => ( ( sup_sup @ ( set @ B ) @ ( A3 @ K ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) )
        = ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) ) ) ).

% UN_absorb
thf(fact_8015_SUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [M7: B > A,A3: set @ B,B5: set @ B] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ M7 @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) ) )
          = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ M7 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ M7 @ B5 ) ) ) ) ) ).

% SUP_union
thf(fact_8016_SUP__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [K: B,I6: set @ B,A3: B > A] :
          ( ( member @ B @ K @ I6 )
         => ( ( sup_sup @ A @ ( A3 @ K ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ A3 @ I6 ) ) )
            = ( complete_Sup_Sup @ A @ ( image @ B @ A @ A3 @ I6 ) ) ) ) ) ).

% SUP_absorb
thf(fact_8017_complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,A3: set @ B,G: B > A] :
          ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A3 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [A5: B] : ( sup_sup @ A @ ( F3 @ A5 ) @ ( G @ A5 ) )
              @ A3 ) ) ) ) ).

% complete_lattice_class.SUP_sup_distrib
thf(fact_8018_SUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,A2: B,A3: set @ B] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ ( insert @ B @ A2 @ A3 ) ) )
          = ( sup_sup @ A @ ( F3 @ A2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ).

% SUP_insert
thf(fact_8019_card__Un__le,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B5 ) ) ) ).

% card_Un_le
thf(fact_8020_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_8021_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_8022_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( sup_sup @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_8023_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_8024_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_8025_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_8026_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X2 @ B2 )
         => ( ord_less @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_8027_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X2 @ A2 )
         => ( ord_less @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_8028_Un__def,axiom,
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( collect @ A
            @ ^ [X6: A] :
                ( ( member @ A @ X6 @ A7 )
                | ( member @ A @ X6 @ B8 ) ) ) ) ) ).

% Un_def
thf(fact_8029_Collect__disj__eq,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o] :
      ( ( collect @ A
        @ ^ [X6: A] :
            ( ( P3 @ X6 )
            | ( Q @ X6 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q ) ) ) ).

% Collect_disj_eq
thf(fact_8030_Collect__imp__eq,axiom,
    ! [A: $tType,P3: A > $o,Q: A > $o] :
      ( ( collect @ A
        @ ^ [X6: A] :
            ( ( P3 @ X6 )
           => ( Q @ X6 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( collect @ A @ P3 ) ) @ ( collect @ A @ Q ) ) ) ).

% Collect_imp_eq
thf(fact_8031_insert__def,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A5: A] :
            ( sup_sup @ ( set @ A )
            @ ( collect @ A
              @ ^ [X6: A] : ( X6 = A5 ) ) ) ) ) ).

% insert_def
thf(fact_8032_set__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( set2 @ A @ Zs )
        = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ) ).

% set_shuffles
thf(fact_8033_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F3: A > ( list @ B ),G: A > ( list @ B )] :
      ( ( Xs = Ys )
     => ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( set2 @ A @ Xs ) )
           => ( ( F3 @ X7 )
              = ( G @ X7 ) ) )
       => ( ( bind @ A @ B @ Xs @ F3 )
          = ( bind @ A @ B @ Ys @ G ) ) ) ) ).

% list_bind_cong
thf(fact_8034_continuous__on__cases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,T3: set @ A,F3: A > B,G: A > B,P3: A > $o] :
          ( ( topolo7761053866217962861closed @ A @ S )
         => ( ( topolo7761053866217962861closed @ A @ T3 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ T3 @ G )
               => ( ! [X7: A] :
                      ( ( ( ( member @ A @ X7 @ S )
                          & ~ ( P3 @ X7 ) )
                        | ( ( member @ A @ X7 @ T3 )
                          & ( P3 @ X7 ) ) )
                     => ( ( F3 @ X7 )
                        = ( G @ X7 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ B @ ( sup_sup @ ( set @ A ) @ S @ T3 )
                    @ ^ [X6: A] : ( if @ B @ ( P3 @ X6 ) @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ) ) ).

% continuous_on_cases
thf(fact_8035_continuous__on__If,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,T3: set @ A,F3: A > B,G: A > B,P3: A > $o] :
          ( ( topolo7761053866217962861closed @ A @ S )
         => ( ( topolo7761053866217962861closed @ A @ T3 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ T3 @ G )
               => ( ! [X7: A] :
                      ( ( member @ A @ X7 @ S )
                     => ( ~ ( P3 @ X7 )
                       => ( ( F3 @ X7 )
                          = ( G @ X7 ) ) ) )
                 => ( ! [X7: A] :
                        ( ( member @ A @ X7 @ T3 )
                       => ( ( P3 @ X7 )
                         => ( ( F3 @ X7 )
                            = ( G @ X7 ) ) ) )
                   => ( topolo81223032696312382ous_on @ A @ B @ ( sup_sup @ ( set @ A ) @ S @ T3 )
                      @ ^ [X6: A] : ( if @ B @ ( P3 @ X6 ) @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ) ) ) ) ).

% continuous_on_If
thf(fact_8036_INF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [M7: B > A,A3: set @ B,B5: set @ B] :
          ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ M7 @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) ) )
          = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ M7 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ M7 @ B5 ) ) ) ) ) ).

% INF_union
thf(fact_8037_UN__extend__simps_I2_J,axiom,
    ! [D: $tType,C: $tType,C6: set @ C,A3: C > ( set @ D ),B5: set @ D] :
      ( ( ( C6
          = ( bot_bot @ ( set @ C ) ) )
       => ( ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ A3 @ C6 ) ) @ B5 )
          = B5 ) )
      & ( ( C6
         != ( bot_bot @ ( set @ C ) ) )
       => ( ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ A3 @ C6 ) ) @ B5 )
          = ( complete_Sup_Sup @ ( set @ D )
            @ ( image @ C @ ( set @ D )
              @ ^ [X6: C] : ( sup_sup @ ( set @ D ) @ ( A3 @ X6 ) @ B5 )
              @ C6 ) ) ) ) ) ).

% UN_extend_simps(2)
thf(fact_8038_UN__extend__simps_I3_J,axiom,
    ! [E4: $tType,F: $tType,C6: set @ F,A3: set @ E4,B5: F > ( set @ E4 )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ F ) ) )
       => ( ( sup_sup @ ( set @ E4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ E4 ) @ ( image @ F @ ( set @ E4 ) @ B5 @ C6 ) ) )
          = A3 ) )
      & ( ( C6
         != ( bot_bot @ ( set @ F ) ) )
       => ( ( sup_sup @ ( set @ E4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ E4 ) @ ( image @ F @ ( set @ E4 ) @ B5 @ C6 ) ) )
          = ( complete_Sup_Sup @ ( set @ E4 )
            @ ( image @ F @ ( set @ E4 )
              @ ^ [X6: F] : ( sup_sup @ ( set @ E4 ) @ A3 @ ( B5 @ X6 ) )
              @ C6 ) ) ) ) ) ).

% UN_extend_simps(3)
thf(fact_8039_bij__betw__disjoint__Un,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ A,C6: set @ B,G: A > B,B5: set @ A,D4: set @ B] :
      ( ( bij_betw @ A @ B @ F3 @ A3 @ C6 )
     => ( ( bij_betw @ A @ B @ G @ B5 @ D4 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B5 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( ( inf_inf @ ( set @ B ) @ C6 @ D4 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( bij_betw @ A @ B
              @ ^ [X6: A] : ( if @ B @ ( member @ A @ X6 @ A3 ) @ ( F3 @ X6 ) @ ( G @ X6 ) )
              @ ( sup_sup @ ( set @ A ) @ A3 @ B5 )
              @ ( sup_sup @ ( set @ B ) @ C6 @ D4 ) ) ) ) ) ) ).

% bij_betw_disjoint_Un
thf(fact_8040_partition__set,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A,Yes: list @ A,No: list @ A] :
      ( ( ( partition @ A @ P3 @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes ) @ ( set2 @ A @ No ) )
        = ( set2 @ A @ Xs ) ) ) ).

% partition_set
thf(fact_8041_INT__Un,axiom,
    ! [A: $tType,B: $tType,M7: B > ( set @ A ),A3: set @ B,B5: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ M7 @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ M7 @ A3 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ M7 @ B5 ) ) ) ) ).

% INT_Un
thf(fact_8042_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( shuffles @ A @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) )
      = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs ) @ Ys ) ) ) ) ).

% shuffles.simps(3)
thf(fact_8043_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_8044_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B5: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B5 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_8045_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B5: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B5 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_8046_card__Un__Int,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ B5 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B5 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B5 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_8047_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_8048_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_8049_SUP__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: $o > A] :
          ( ( complete_Sup_Sup @ A @ ( image @ $o @ A @ A3 @ ( top_top @ ( set @ $o ) ) ) )
          = ( sup_sup @ A @ ( A3 @ $true ) @ ( A3 @ $false ) ) ) ) ).

% SUP_UNIV_bool_expand
thf(fact_8050_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_8051_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_8052_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_8053_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B5: A] :
          ( ( sup_sup @ A @ A3
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X6: nat] : B5
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A3 @ B5 ) ) ) ).

% SUP_nat_binary
thf(fact_8054_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F3 @ A3 ) )
           => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ G @ A3 ) )
             => ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A3 ) ) )
                = ( complete_Sup_Sup @ A
                  @ ( image @ B @ A
                    @ ^ [A5: B] : ( sup_sup @ A @ ( F3 @ A5 ) @ ( G @ A5 ) )
                    @ A3 ) ) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
thf(fact_8055_inj__on__disjoint__Un,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A,G: A > B,B5: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( ( inj_on @ A @ B @ G @ B5 )
       => ( ( ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ ( image @ A @ B @ G @ B5 ) )
            = ( bot_bot @ ( set @ B ) ) )
         => ( inj_on @ A @ B
            @ ^ [X6: A] : ( if @ B @ ( member @ A @ X6 @ A3 ) @ ( F3 @ X6 ) @ ( G @ X6 ) )
            @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) ) ) ) ) ).

% inj_on_disjoint_Un
thf(fact_8056_Un__eq__UN,axiom,
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ $o @ ( set @ A )
              @ ^ [B4: $o] : ( if @ ( set @ A ) @ B4 @ A7 @ B8 )
              @ ( top_top @ ( set @ $o ) ) ) ) ) ) ).

% Un_eq_UN
thf(fact_8057_UN__bool__eq,axiom,
    ! [A: $tType,A3: $o > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ $o @ ( set @ A ) @ A3 @ ( top_top @ ( set @ $o ) ) ) )
      = ( sup_sup @ ( set @ A ) @ ( A3 @ $true ) @ ( A3 @ $false ) ) ) ).

% UN_bool_eq
thf(fact_8058_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X6: A,Y: A] : ( ord_less_eq @ A @ Y @ X6 )
        @ ^ [X6: A,Y: A] : ( ord_less @ A @ Y @ X6 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_8059_List_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bind @ A @ B )
      = ( ^ [Xs2: list @ A,F5: A > ( list @ B )] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F5 @ Xs2 ) ) ) ) ).

% List.bind_def
thf(fact_8060_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B5: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) )
                 => ( ( G @ X7 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B5 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_8061_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B5: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_8062_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B5: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B5 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B5 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_8063_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B5: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) )
                 => ( ( G @ X7 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B5 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_8064_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B5: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B5 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B5 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_8065_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A3: set @ A,B5: set @ A,F3: A > B] :
          ( ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F3 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ B5 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ ( inf_inf @ ( set @ A ) @ A3 @ B5 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_8066_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B5: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B5 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_8067_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B5: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B5 @ A3 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_8068_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ B5 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B5 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B5 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_8069_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_8070_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_8071_sum__Un__nat,axiom,
    ! [A: $tType,A3: set @ A,B5: set @ A,F3: A > nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ B5 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ ( inf_inf @ ( set @ A ) @ A3 @ B5 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_8072_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_8073_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_8074_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A3: set @ B,B5: set @ B,F3: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B5 )
           => ( ! [X7: B] :
                  ( ( member @ B @ X7 @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) )
                 => ( ( F3 @ X7 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ ( sup_sup @ ( set @ B ) @ A3 @ B5 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ B5 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_8075_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs: list @ B,Ys: list @ B] :
          ( ( inj_on @ B @ A @ F3 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F3 @ Xs ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Ys ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F3 @ Ys ) )
                 => ( ( ( set2 @ B @ Xs )
                      = ( set2 @ B @ Ys ) )
                   => ( Xs = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_8076_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_8077_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C6: set @ A,B5: set @ A,X2: A] :
      ( ( inj_on @ A @ B @ G @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ B5 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I: B] : ( if @ A @ ( member @ B @ I @ ( image @ A @ B @ G @ C6 ) ) @ ( the_inv_into @ A @ B @ C6 @ G @ I ) @ X2 )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B5 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_8078_lexord__take__index__conv,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lexord @ A @ R ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X2 ) @ ( size_size @ ( list @ A ) @ Y2 ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X2 ) @ Y2 )
            = X2 ) )
        | ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X2 ) @ ( size_size @ ( list @ A ) @ Y2 ) ) )
            & ( ( take @ A @ I @ X2 )
              = ( take @ A @ I @ Y2 ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X2 @ I ) @ ( nth @ A @ Y2 @ I ) ) @ R ) ) ) ) ).

% lexord_take_index_conv
thf(fact_8079_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb3
thf(fact_8080_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_8081_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ Z @ ( ord_min @ A @ X2 @ Y2 ) )
          = ( ( ord_less @ A @ Z @ X2 )
            & ( ord_less @ A @ Z @ Y2 ) ) ) ) ).

% min_less_iff_conj
thf(fact_8082_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_Suc_Suc
thf(fact_8083_min__0L,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_8084_min__0R,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ N @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_8085_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A2 ) ) ) ).

% take_bit_take_bit
thf(fact_8086_take__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( take @ A @ M @ Xs ) )
      = ( take @ A @ ( ord_min @ nat @ N @ M ) @ Xs ) ) ).

% take_take
thf(fact_8087_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
          = ( bit_ri4674362597316999326ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A2 ) ) ) ).

% signed_take_bit_signed_take_bit
thf(fact_8088_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(1)
thf(fact_8089_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X2 ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_8090_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_8091_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_8092_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_8093_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_8094_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_8095_length__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( take @ A @ N @ Xs ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_take
thf(fact_8096_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ ( ord_min @ nat @ M @ N ) ) ) ) ).

% take_bit_of_mask
thf(fact_8097_take__replicate,axiom,
    ! [A: $tType,I3: nat,K: nat,X2: A] :
      ( ( take @ A @ I3 @ ( replicate @ A @ K @ X2 ) )
      = ( replicate @ A @ ( ord_min @ nat @ I3 @ K ) @ X2 ) ) ).

% take_replicate
thf(fact_8098_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_8099_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(3)
thf(fact_8100_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_8101_min__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% min_numeral_Suc
thf(fact_8102_min__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_8103_open__bool__def,axiom,
    ( ( topolo1002775350975398744n_open @ $o )
    = ( topolo8378437560675496660pology @ $o @ ( sup_sup @ ( set @ ( set @ $o ) ) @ ( image @ $o @ ( set @ $o ) @ ( set_ord_lessThan @ $o ) @ ( top_top @ ( set @ $o ) ) ) @ ( image @ $o @ ( set @ $o ) @ ( set_ord_greaterThan @ $o ) @ ( top_top @ ( set @ $o ) ) ) ) ) ) ).

% open_bool_def
thf(fact_8104_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( sup_sup @ ( A > B > $o )
        @ ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ R3 )
        @ ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ S3 ) )
      = ( ^ [X6: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X6 @ Y ) @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S3 ) ) ) ) ).

% sup_Un_eq2
thf(fact_8105_atLeastLessThan__add__Un,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J2 )
     => ( ( set_or7035219750837199246ssThan @ nat @ I3 @ ( plus_plus @ nat @ J2 @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I3 @ J2 ) @ ( set_or7035219750837199246ssThan @ nat @ J2 @ ( plus_plus @ nat @ J2 @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_8106_sup__enat__def,axiom,
    ( ( sup_sup @ extended_enat )
    = ( ord_max @ extended_enat ) ) ).

% sup_enat_def
thf(fact_8107_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_8108_sup__set__def,axiom,
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( collect @ A
            @ ( sup_sup @ ( A > $o )
              @ ^ [X6: A] : ( member @ A @ X6 @ A7 )
              @ ^ [X6: A] : ( member @ A @ X6 @ B8 ) ) ) ) ) ).

% sup_set_def
thf(fact_8109_sup__Un__eq,axiom,
    ! [A: $tType,R3: set @ A,S3: set @ A] :
      ( ( sup_sup @ ( A > $o )
        @ ^ [X6: A] : ( member @ A @ X6 @ R3 )
        @ ^ [X6: A] : ( member @ A @ X6 @ S3 ) )
      = ( ^ [X6: A] : ( member @ A @ X6 @ ( sup_sup @ ( set @ A ) @ R3 @ S3 ) ) ) ) ).

% sup_Un_eq
thf(fact_8110_tendsto__min,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X15: B > A,X2: A,Net: filter @ B,Y6: B > A,Y2: A] :
          ( ( filterlim @ B @ A @ X15 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ Net )
         => ( ( filterlim @ B @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ Net )
           => ( filterlim @ B @ A
              @ ^ [X6: B] : ( ord_min @ A @ ( X15 @ X6 ) @ ( Y6 @ X6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( ord_min @ A @ X2 @ Y2 ) )
              @ Net ) ) ) ) ).

% tendsto_min
thf(fact_8111_continuous__on__min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A3: set @ A,F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ A3 @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ A3 @ G )
           => ( topolo81223032696312382ous_on @ A @ B @ A3
              @ ^ [X6: A] : ( ord_min @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_on_min
thf(fact_8112_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ A5 @ B4 ) ) ) ) ).

% min_def_raw
thf(fact_8113_continuous__min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F4: filter @ A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X6: A] : ( ord_min @ B @ ( F3 @ X6 ) @ ( G @ X6 ) ) ) ) ) ) ).

% continuous_min
thf(fact_8114_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_8115_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X2 @ Y2 ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% minus_min_eq_max
thf(fact_8116_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X2 @ Y2 ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% minus_max_eq_min
thf(fact_8117_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X2 @ Y2 ) @ Z )
          = ( ord_min @ A @ ( minus_minus @ A @ X2 @ Z ) @ ( minus_minus @ A @ Y2 @ Z ) ) ) ) ).

% min_diff_distrib_left
thf(fact_8118_min__diff,axiom,
    ! [M: nat,I3: nat,N: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I3 ) @ ( minus_minus @ nat @ N @ I3 ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N ) @ I3 ) ) ).

% min_diff
thf(fact_8119_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N @ Q2 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_min_right
thf(fact_8120_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N ) @ Q2 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N @ Q2 ) ) ) ).

% nat_mult_min_left
thf(fact_8121_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X2 @ Y2 ) @ Z )
          = ( ord_min @ A @ ( plus_plus @ A @ X2 @ Z ) @ ( plus_plus @ A @ Y2 @ Z ) ) ) ) ).

% min_add_distrib_left
thf(fact_8122_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ X2 @ ( ord_min @ A @ Y2 @ Z ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( plus_plus @ A @ X2 @ Z ) ) ) ) ).

% min_add_distrib_right
thf(fact_8123_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: nat,Y2: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X2 @ Y2 ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( semiring_1_of_nat @ A @ Y2 ) ) ) ) ).

% of_nat_min
thf(fact_8124_concat__bit__assoc__sym,axiom,
    ! [M: nat,N: nat,K: int,L: int,R: int] :
      ( ( bit_concat_bit @ M @ ( bit_concat_bit @ N @ K @ L ) @ R )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M @ N ) @ L @ R ) ) ) ).

% concat_bit_assoc_sym
thf(fact_8125_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X2 @ Y2 ) @ Z )
          = ( ( ord_less @ A @ X2 @ Z )
            | ( ord_less @ A @ Y2 @ Z ) ) ) ) ).

% min_less_iff_disj
thf(fact_8126_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_8127_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( ord_min @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_8128_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_8129_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_8130_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M @ ( bit_concat_bit @ N @ K @ L ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M @ N ) @ L ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_8131_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P5: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ ( ord_min @ A @ X2 @ Y2 ) @ P5 )
              = ( ord_min @ A @ ( times_times @ A @ X2 @ P5 ) @ ( times_times @ A @ Y2 @ P5 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ ( ord_min @ A @ X2 @ Y2 ) @ P5 )
              = ( ord_max @ A @ ( times_times @ A @ X2 @ P5 ) @ ( times_times @ A @ Y2 @ P5 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_8132_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P5: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ ( ord_max @ A @ X2 @ Y2 ) @ P5 )
              = ( ord_max @ A @ ( times_times @ A @ X2 @ P5 ) @ ( times_times @ A @ Y2 @ P5 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ ( ord_max @ A @ X2 @ Y2 ) @ P5 )
              = ( ord_min @ A @ ( times_times @ A @ X2 @ P5 ) @ ( times_times @ A @ Y2 @ P5 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_8133_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P5: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ P5 @ ( ord_min @ A @ X2 @ Y2 ) )
              = ( ord_min @ A @ ( times_times @ A @ P5 @ X2 ) @ ( times_times @ A @ P5 @ Y2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ P5 @ ( ord_min @ A @ X2 @ Y2 ) )
              = ( ord_max @ A @ ( times_times @ A @ P5 @ X2 ) @ ( times_times @ A @ P5 @ Y2 ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_8134_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P5: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ P5 @ ( ord_max @ A @ X2 @ Y2 ) )
              = ( ord_max @ A @ ( times_times @ A @ P5 @ X2 ) @ ( times_times @ A @ P5 @ Y2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ P5 @ ( ord_max @ A @ X2 @ Y2 ) )
              = ( ord_min @ A @ ( times_times @ A @ P5 @ X2 ) @ ( times_times @ A @ P5 @ Y2 ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_8135_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P5: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X2 @ Y2 ) @ P5 )
              = ( ord_min @ A @ ( divide_divide @ A @ X2 @ P5 ) @ ( divide_divide @ A @ Y2 @ P5 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X2 @ Y2 ) @ P5 )
              = ( ord_max @ A @ ( divide_divide @ A @ X2 @ P5 ) @ ( divide_divide @ A @ Y2 @ P5 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_8136_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P5: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X2 @ Y2 ) @ P5 )
              = ( ord_max @ A @ ( divide_divide @ A @ X2 @ P5 ) @ ( divide_divide @ A @ Y2 @ P5 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X2 @ Y2 ) @ P5 )
              = ( ord_min @ A @ ( divide_divide @ A @ X2 @ P5 ) @ ( divide_divide @ A @ Y2 @ P5 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_8137_min__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M3: nat] : ( suc @ ( ord_min @ nat @ N @ M3 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_8138_min__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M3: nat] : ( suc @ ( ord_min @ nat @ M3 @ N ) )
        @ M ) ) ).

% min_Suc2
thf(fact_8139_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) ) ) ) ).

% mod_exp_eq
thf(fact_8140_rtrancl__insert,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X6: A,Y: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ A2 ) @ ( transitive_rtrancl @ A @ R ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ) ).

% rtrancl_insert
thf(fact_8141_trancl__insert2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X6: A,Y: A] :
                ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ A2 ) @ ( transitive_trancl @ A @ R ) )
                  | ( X6 = A2 ) )
                & ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y ) @ ( transitive_trancl @ A @ R ) )
                  | ( Y = B2 ) ) ) ) ) ) ) ).

% trancl_insert2
thf(fact_8142_open__nat__def,axiom,
    ( ( topolo1002775350975398744n_open @ nat )
    = ( topolo8378437560675496660pology @ nat @ ( sup_sup @ ( set @ ( set @ nat ) ) @ ( image @ nat @ ( set @ nat ) @ ( set_ord_lessThan @ nat ) @ ( top_top @ ( set @ nat ) ) ) @ ( image @ nat @ ( set @ nat ) @ ( set_ord_greaterThan @ nat ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% open_nat_def
thf(fact_8143_Pow__set_I2_J,axiom,
    ! [B: $tType,X2: B,Xs: list @ B] :
      ( ( pow2 @ B @ ( set2 @ B @ ( cons @ B @ X2 @ Xs ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) @ ( image @ ( set @ B ) @ ( set @ B ) @ ( insert @ B @ X2 ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) ) ) ) ).

% Pow_set(2)
thf(fact_8144_trancl__insert,axiom,
    ! [A: $tType,Y2: A,X2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [A5: A,B4: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ Y2 ) @ ( transitive_rtrancl @ A @ R ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ B4 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ) ).

% trancl_insert
thf(fact_8145_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_8146_open__generated__order,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( topolo8378437560675496660pology @ A @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( image @ A @ ( set @ A ) @ ( set_ord_lessThan @ A ) @ ( top_top @ ( set @ A ) ) ) @ ( image @ A @ ( set @ A ) @ ( set_ord_greaterThan @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% open_generated_order
thf(fact_8147_Pow__fold,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( pow2 @ A @ A3 )
        = ( finite_fold @ A @ ( set @ ( set @ A ) )
          @ ^ [X6: A,A7: set @ ( set @ A )] : ( sup_sup @ ( set @ ( set @ A ) ) @ A7 @ ( image @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ X6 ) @ A7 ) )
          @ ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
          @ A3 ) ) ) ).

% Pow_fold
thf(fact_8148_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X2: A,Xs: list @ A] :
          ( ( min_list @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( case_list @ A @ A @ X2
            @ ^ [A5: A,List2: list @ A] : ( ord_min @ A @ X2 @ ( min_list @ A @ Xs ) )
            @ Xs ) ) ) ).

% min_list.simps
thf(fact_8149_min__enat__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = Q2 ) ).

% min_enat_simps(5)
thf(fact_8150_min__enat__simps_I4_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = Q2 ) ).

% min_enat_simps(4)
thf(fact_8151_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_8152_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_8153_min__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_enat_simps(1)
thf(fact_8154_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_8155_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G2 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_8156_image__fold__insert,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F3: A > B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( image @ A @ B @ F3 @ A3 )
        = ( finite_fold @ A @ ( set @ B )
          @ ^ [K2: A] : ( insert @ B @ ( F3 @ K2 ) )
          @ ( bot_bot @ ( set @ B ) )
          @ A3 ) ) ) ).

% image_fold_insert
thf(fact_8157_Set__filter__fold,axiom,
    ! [A: $tType,A3: set @ A,P3: A > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( filter3 @ A @ P3 @ A3 )
        = ( finite_fold @ A @ ( set @ A )
          @ ^ [X6: A,A15: set @ A] : ( if @ ( set @ A ) @ ( P3 @ X6 ) @ ( insert @ A @ X6 @ A15 ) @ A15 )
          @ ( bot_bot @ ( set @ A ) )
          @ A3 ) ) ) ).

% Set_filter_fold
thf(fact_8158_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set @ ( product_prod @ A @ B ),X2: product_prod @ C @ A,X15: set @ ( product_prod @ C @ B )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ S3 )
     => ( ( sup_sup @ ( set @ ( product_prod @ C @ B ) ) @ ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X2 @ ( bot_bot @ ( set @ ( product_prod @ C @ A ) ) ) ) @ S3 ) @ X15 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z6: B,A15: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X2 )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X2 ) @ Z6 ) @ A15 )
                @ A15 ) )
          @ X15
          @ S3 ) ) ) ).

% insert_relcomp_union_fold
thf(fact_8159_inf__enat__def,axiom,
    ( ( inf_inf @ extended_enat )
    = ( ord_min @ extended_enat ) ) ).

% inf_enat_def
thf(fact_8160_card_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( finite_fold @ A @ nat
        @ ^ [Uu3: A] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card.eq_fold
thf(fact_8161_Ball__fold,axiom,
    ! [A: $tType,A3: set @ A,P3: A > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ! [X6: A] :
              ( ( member @ A @ X6 @ A3 )
             => ( P3 @ X6 ) ) )
        = ( finite_fold @ A @ $o
          @ ^ [K2: A,S4: $o] :
              ( S4
              & ( P3 @ K2 ) )
          @ $true
          @ A3 ) ) ) ).

% Ball_fold
thf(fact_8162_Set_Ofilter__def,axiom,
    ! [A: $tType] :
      ( ( filter3 @ A )
      = ( ^ [P2: A > $o,A7: set @ A] :
            ( collect @ A
            @ ^ [A5: A] :
                ( ( member @ A @ A5 @ A7 )
                & ( P2 @ A5 ) ) ) ) ) ).

% Set.filter_def
thf(fact_8163_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( finite_fold @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X6: A] : X6 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
thf(fact_8164_filter__set,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( filter3 @ A @ P3 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A @ ( filter2 @ A @ P3 @ Xs ) ) ) ).

% filter_set
thf(fact_8165_inter__Set__filter,axiom,
    ! [A: $tType,B5: set @ A,A3: set @ A] :
      ( ( finite_finite2 @ A @ B5 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B5 )
        = ( filter3 @ A
          @ ^ [X6: A] : ( member @ A @ X6 @ A3 )
          @ B5 ) ) ) ).

% inter_Set_filter
thf(fact_8166_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ B @ C )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ R3 )
     => ( ( finite_finite2 @ ( product_prod @ B @ C ) @ S3 )
       => ( ( relcomp @ A @ B @ C @ R3 @ S3 )
          = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ A @ C ) )
            @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
              @ ^ [X6: A,Y: B,A7: set @ ( product_prod @ A @ C )] :
                  ( finite_fold @ ( product_prod @ B @ C ) @ ( set @ ( product_prod @ A @ C ) )
                  @ ( product_case_prod @ B @ C @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
                    @ ^ [W3: B,Z6: C,A15: set @ ( product_prod @ A @ C )] : ( if @ ( set @ ( product_prod @ A @ C ) ) @ ( Y = W3 ) @ ( insert @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X6 @ Z6 ) @ A15 ) @ A15 ) )
                  @ A7
                  @ S3 ) )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ C ) ) )
            @ R3 ) ) ) ) ).

% relcomp_fold
thf(fact_8167_Id__on__fold,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( id_on @ A @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ A @ A ) )
          @ ^ [X6: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ X6 ) )
          @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) )
          @ A3 ) ) ) ).

% Id_on_fold
thf(fact_8168_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set @ ( product_prod @ A @ B ),X2: product_prod @ C @ A,R3: set @ ( product_prod @ C @ A )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ S3 )
     => ( ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X2 @ R3 ) @ S3 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z6: B,A15: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X2 )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X2 ) @ Z6 ) @ A15 )
                @ A15 ) )
          @ ( relcomp @ C @ A @ B @ R3 @ S3 )
          @ S3 ) ) ) ).

% insert_relcomp_fold
thf(fact_8169_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798349783984er_Max @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X6: A,Y: option @ A] : ( some @ A @ ( case_option @ A @ A @ X6 @ ( ord_max @ A @ X6 ) @ Y ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Max.eq_fold'
thf(fact_8170_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B5: set @ A,X2: B,A3: set @ ( product_prod @ B @ A )] :
      ( ( finite_finite2 @ A @ B5 )
     => ( ( sup_sup @ ( set @ ( product_prod @ B @ A ) )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) )
            @ ( image @ A @ ( set @ ( product_prod @ B @ A ) )
              @ ^ [Y: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y ) @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
              @ B5 ) )
          @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
          @ ^ [Y: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y ) )
          @ A3
          @ B5 ) ) ) ).

% fold_union_pair
thf(fact_8171_comp__fun__commute__relcomp__fold,axiom,
    ! [A: $tType,B: $tType,C: $tType,S3: set @ ( product_prod @ A @ B )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ S3 )
     => ( finite6289374366891150609ommute @ ( product_prod @ C @ A ) @ ( set @ ( product_prod @ C @ B ) )
        @ ( product_case_prod @ C @ A @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
          @ ^ [X6: C,Y: A,A7: set @ ( product_prod @ C @ B )] :
              ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
              @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
                @ ^ [W3: A,Z6: B,A15: set @ ( product_prod @ C @ B )] : ( if @ ( set @ ( product_prod @ C @ B ) ) @ ( Y = W3 ) @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ X6 @ Z6 ) @ A15 ) @ A15 ) )
              @ A7
              @ S3 ) ) ) ) ).

% comp_fun_commute_relcomp_fold
thf(fact_8172_comp__fun__commute__product__fold,axiom,
    ! [A: $tType,B: $tType,B5: set @ A] :
      ( ( finite_finite2 @ A @ B5 )
     => ( finite6289374366891150609ommute @ B @ ( set @ ( product_prod @ B @ A ) )
        @ ^ [X6: B,Z6: set @ ( product_prod @ B @ A )] :
            ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
            @ ^ [Y: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X6 @ Y ) )
            @ Z6
            @ B5 ) ) ) ).

% comp_fun_commute_product_fold
thf(fact_8173_comp__fun__commute_Ocomp__fun__commute__funpow,axiom,
    ! [B: $tType,A: $tType,F3: A > B > B,G: A > nat] :
      ( ( finite6289374366891150609ommute @ A @ B @ F3 )
     => ( finite6289374366891150609ommute @ A @ B
        @ ^ [X6: A] : ( compow @ ( B > B ) @ ( G @ X6 ) @ ( F3 @ X6 ) ) ) ) ).

% comp_fun_commute.comp_fun_commute_funpow
thf(fact_8174_comp__fun__commute__const,axiom,
    ! [B: $tType,A: $tType,F3: B > B] :
      ( finite6289374366891150609ommute @ A @ B
      @ ^ [Uu3: A] : F3 ) ).

% comp_fun_commute_const
thf(fact_8175_comp__fun__commute__filter__fold,axiom,
    ! [A: $tType,P3: A > $o] :
      ( finite6289374366891150609ommute @ A @ ( set @ A )
      @ ^ [X6: A,A15: set @ A] : ( if @ ( set @ A ) @ ( P3 @ X6 ) @ ( insert @ A @ X6 @ A15 ) @ A15 ) ) ).

% comp_fun_commute_filter_fold
thf(fact_8176_comp__fun__commute__Image__fold,axiom,
    ! [B: $tType,A: $tType,S3: set @ A] :
      ( finite6289374366891150609ommute @ ( product_prod @ A @ B ) @ ( set @ B )
      @ ( product_case_prod @ A @ B @ ( ( set @ B ) > ( set @ B ) )
        @ ^ [X6: A,Y: B,A7: set @ B] : ( if @ ( set @ B ) @ ( member @ A @ X6 @ S3 ) @ ( insert @ B @ Y @ A7 ) @ A7 ) ) ) ).

% comp_fun_commute_Image_fold
thf(fact_8177_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X6: A,Y: option @ A] : ( some @ A @ ( case_option @ A @ A @ X6 @ ( sup_sup @ A @ X6 ) @ Y ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Sup_fin.eq_fold'
thf(fact_8178_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X6: A,Y: option @ A] : ( some @ A @ ( case_option @ A @ A @ X6 @ ( inf_inf @ A @ X6 ) @ Y ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_8179_comp__fun__commute__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite6289374366891150609ommute @ A @ ( list @ A )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X6: A] : X6 ) ) ) ).

% comp_fun_commute_insort
thf(fact_8180_Sup__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite2 @ A @ A3 )
         => ( ( lattic5882676163264333800up_fin @ A @ A3 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Sup_fin.infinite
thf(fact_8181_Inf__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite2 @ A @ A3 )
         => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Inf_fin.infinite

% Type constructors (787)
thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_1,axiom,
    ! [A10: $tType] : ( bounded_lattice @ ( filter @ A10 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_2,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_3,axiom,
    ! [A10: $tType] : ( bounded_lattice @ ( set @ A10 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_4,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bounded_lattice @ A16 )
     => ( bounded_lattice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple6319245703460814977attice @ A16 )
     => ( condit1219197933456340205attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( counta3822494911875563373attice @ A16 )
     => ( counta3822494911875563373attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple592849572758109894attice @ A16 )
     => ( comple592849572758109894attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__boolean__algebra,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple489889107523837845lgebra @ A16 )
     => ( comple489889107523837845lgebra @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bounded_lattice @ A16 )
     => ( bounde4967611905675639751up_bot @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bounded_lattice @ A16 )
     => ( bounde4346867609351753570nf_top @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple6319245703460814977attice @ A16 )
     => ( comple6319245703460814977attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( boolea8198339166811842893lgebra @ A16 )
     => ( boolea8198339166811842893lgebra @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( semilattice_sup @ A16 )
     => ( semilattice_sup @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( semilattice_inf @ A16 )
     => ( semilattice_inf @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Complete__Lattices_OSup,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( complete_Sup @ A16 )
     => ( complete_Sup @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Complete__Lattices_OInf,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( complete_Inf @ A16 )
     => ( complete_Inf @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( order_top @ A16 )
     => ( order_top @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( order_bot @ A16 )
     => ( order_bot @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( preorder @ A16 )
     => ( preorder @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Finite__Set_Ofinite,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ( finite_finite @ A10 )
        & ( finite_finite @ A16 ) )
     => ( finite_finite @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( lattice @ A16 )
     => ( lattice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( order @ A16 )
     => ( order @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ord @ A16 )
     => ( ord @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( uminus @ A16 )
     => ( uminus @ ( A10 > A16 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_5,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Odiscrete__topology,axiom,
    topolo8865339358273720382pology @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot1__space,axiom,
    topological_t1_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_6,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_7,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Complete__Lattices_OSup_8,axiom,
    complete_Sup @ int ).

thf(tcon_Int_Oint___Complete__Lattices_OInf_9,axiom,
    complete_Inf @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_10,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_11,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_12,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom @ int ).

thf(tcon_Int_Oint___Orderings_Oord_13,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_14,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_15,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_16,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_17,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_18,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_19,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_20,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_21,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_22,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_23,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_24,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_25,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_26,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_27,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_28,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_29,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_30,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_31,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_32,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_33,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_34,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Odiscrete__topology_35,axiom,
    topolo8865339358273720382pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_36,axiom,
    topolo4987421752381908075d_mult @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_37,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_38,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_39,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_40,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_41,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_42,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_43,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_44,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_45,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_46,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_47,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_48,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_49,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_50,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_51,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_52,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_53,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_54,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot1__space_55,axiom,
    topological_t1_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_56,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_57,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_58,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_59,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_60,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_61,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_62,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_63,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_64,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_65,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_66,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_67,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_68,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_69,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_70,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_71,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_72,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_73,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_74,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Complete__Lattices_OSup_75,axiom,
    complete_Sup @ nat ).

thf(tcon_Nat_Onat___Complete__Lattices_OInf_76,axiom,
    complete_Inf @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_77,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_78,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_79,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_80,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_81,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_82,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_83,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_84,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_85,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_86,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_87,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_88,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_89,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_90,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_91,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_92,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_93,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_94,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_95,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_96,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_97,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_98,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom_99,axiom,
    semidom @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_100,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Power_Opower_101,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_102,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_103,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_104,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_105,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_106,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_107,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_108,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_109,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_110,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_111,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_112,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_113,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_114,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_115,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_116,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_117,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_118,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_119,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_120,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_121,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_122,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_123,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_124,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_125,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_126,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_127,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_128,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_129,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_130,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_131,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_132,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_133,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_134,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_135,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_136,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_137,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_138,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_139,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_140,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_141,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_142,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_143,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_144,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_145,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_146,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_147,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_148,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_149,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_150,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_151,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_152,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_153,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_154,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_155,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_156,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_157,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_158,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_159,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_160,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_161,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_162,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_163,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_164,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_165,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_166,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_167,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_168,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_169,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_170,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_171,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_172,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_173,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_174,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_175,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_176,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_177,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_178,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_179,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_180,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_181,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_182,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_183,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_184,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_185,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom_186,axiom,
    semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_187,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_188,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_189,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_190,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_191,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_192,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_193,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_194,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_195,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_196,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_197,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_198,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_199,axiom,
    ! [A10: $tType] : ( condit1219197933456340205attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_200,axiom,
    ! [A10: $tType] : ( counta3822494911875563373attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_201,axiom,
    ! [A10: $tType] : ( comple592849572758109894attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__boolean__algebra_202,axiom,
    ! [A10: $tType] : ( comple489889107523837845lgebra @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_203,axiom,
    ! [A10: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_204,axiom,
    ! [A10: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_205,axiom,
    ! [A10: $tType] : ( comple6319245703460814977attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_206,axiom,
    ! [A10: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_207,axiom,
    ! [A10: $tType] : ( semilattice_sup @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_208,axiom,
    ! [A10: $tType] : ( semilattice_inf @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_OSup_209,axiom,
    ! [A10: $tType] : ( complete_Sup @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_OInf_210,axiom,
    ! [A10: $tType] : ( complete_Inf @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_211,axiom,
    ! [A10: $tType] : ( order_top @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_212,axiom,
    ! [A10: $tType] : ( order_bot @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_213,axiom,
    ! [A10: $tType] : ( preorder @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Finite__Set_Ofinite_214,axiom,
    ! [A10: $tType] :
      ( ( finite_finite @ A10 )
     => ( finite_finite @ ( set @ A10 ) ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_215,axiom,
    ! [A10: $tType] : ( lattice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_216,axiom,
    ! [A10: $tType] : ( order @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_217,axiom,
    ! [A10: $tType] : ( ord @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_218,axiom,
    ! [A10: $tType] : ( uminus @ ( set @ A10 ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_219,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_220,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_221,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__boolean__algebra_222,axiom,
    comple489889107523837845lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_223,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_224,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Odiscrete__topology_225,axiom,
    topolo8865339358273720382pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_226,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_227,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_228,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_229,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_230,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_231,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot1__space_232,axiom,
    topological_t1_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_233,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_234,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_OSup_235,axiom,
    complete_Sup @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_OInf_236,axiom,
    complete_Inf @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_237,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_238,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_239,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_240,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_241,axiom,
    finite_finite @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_242,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_243,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_244,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_245,axiom,
    uminus @ $o ).

thf(tcon_List_Olist___Nat_Osize_246,axiom,
    ! [A10: $tType] : ( size @ ( list @ A10 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_247,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_248,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_249,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_250,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_251,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_252,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_253,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_254,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_255,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_256,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_257,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_258,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_259,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_260,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oopen__uniformity,axiom,
    topolo569519726778239578ormity @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_261,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_262,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_263,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_264,axiom,
    linord4140545234300271783up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_265,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_266,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_267,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_268,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_269,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_270,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_271,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_272,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_273,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_274,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_275,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_276,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_277,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_278,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_279,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_280,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_281,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_282,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot1__space_283,axiom,
    topological_t1_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_284,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_285,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_286,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_287,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_288,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_289,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_290,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_291,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_292,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_293,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_294,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_295,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_296,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_297,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_298,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_299,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_300,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_301,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_302,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_303,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_304,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_305,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_306,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_307,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Complete__Lattices_OSup_308,axiom,
    complete_Sup @ real ).

thf(tcon_Real_Oreal___Complete__Lattices_OInf_309,axiom,
    complete_Inf @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_310,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_311,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_312,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_313,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_314,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_315,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_316,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_317,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_318,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_319,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_320,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_321,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_322,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_323,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_324,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_325,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_326,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_327,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_328,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_329,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_330,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_331,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_332,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_333,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_334,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_335,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_336,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_337,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_338,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_339,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_340,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_341,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom_342,axiom,
    semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_343,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_344,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_345,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_346,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_347,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_348,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_349,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_350,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_351,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_352,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_353,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_354,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_355,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Finite__Set_Ofinite_356,axiom,
    finite_finite @ char ).

thf(tcon_String_Ochar___Nat_Osize_357,axiom,
    size @ char ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_358,axiom,
    ! [A10: $tType] : ( condit1219197933456340205attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_359,axiom,
    ! [A10: $tType] : ( counta3822494911875563373attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_360,axiom,
    ! [A10: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_361,axiom,
    ! [A10: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_362,axiom,
    ! [A10: $tType] : ( comple6319245703460814977attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_363,axiom,
    ! [A10: $tType] : ( semilattice_sup @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_364,axiom,
    ! [A10: $tType] : ( semilattice_inf @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_OSup_365,axiom,
    ! [A10: $tType] : ( complete_Sup @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_OInf_366,axiom,
    ! [A10: $tType] : ( complete_Inf @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_367,axiom,
    ! [A10: $tType] : ( order_top @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_368,axiom,
    ! [A10: $tType] : ( order_bot @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_369,axiom,
    ! [A10: $tType] : ( preorder @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_370,axiom,
    ! [A10: $tType] : ( lattice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_371,axiom,
    ! [A10: $tType] : ( order @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_372,axiom,
    ! [A10: $tType] : ( ord @ ( filter @ A10 ) ) ).

thf(tcon_Option_Ooption___Finite__Set_Ofinite_373,axiom,
    ! [A10: $tType] :
      ( ( finite_finite @ A10 )
     => ( finite_finite @ ( option @ A10 ) ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_374,axiom,
    ! [A10: $tType] : ( size @ ( option @ A10 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_375,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_376,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_377,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_378,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_379,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_380,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_381,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_382,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_383,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_384,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Oopen__uniformity_385,axiom,
    topolo569519726778239578ormity @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_386,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_387,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_388,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_389,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_390,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_391,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_392,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_393,axiom,
    topolo8386298272705272623_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_394,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_395,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_396,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_397,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_398,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_399,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_400,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_401,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_402,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_403,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_404,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_405,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_406,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot1__space_407,axiom,
    topological_t1_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_408,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_409,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_410,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_411,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_412,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_413,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_414,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_415,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_416,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_417,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_418,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_419,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_420,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_421,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_422,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_423,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_424,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_425,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_426,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_427,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_428,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_429,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_430,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_431,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_432,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_433,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_434,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_435,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_436,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_437,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_438,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_439,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_440,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_441,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom_442,axiom,
    semidom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_443,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_444,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_445,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_446,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_447,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_448,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_449,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_450,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_451,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_452,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_453,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_454,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_455,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_456,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_457,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_458,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_459,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_460,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_461,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_462,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_463,axiom,
    linord4140545234300271783up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_464,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_465,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_466,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_467,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_468,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_469,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_470,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_471,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_472,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_473,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_474,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_475,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_476,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_477,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_478,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_479,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_OSup_480,axiom,
    complete_Sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_OInf_481,axiom,
    complete_Inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_482,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_483,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_484,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_485,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_486,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_487,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_488,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_489,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_490,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_491,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_492,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_493,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_494,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_495,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_496,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_497,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_498,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_499,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_500,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_501,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_502,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_503,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_504,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_505,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_506,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_507,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_508,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ( topolo4958980785337419405_space @ A10 )
        & ( topolo4958980785337419405_space @ A16 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A10 @ A16 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_509,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ( topological_t2_space @ A10 )
        & ( topological_t2_space @ A16 ) )
     => ( topological_t2_space @ ( product_prod @ A10 @ A16 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot1__space_510,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ( topological_t1_space @ A10 )
        & ( topological_t1_space @ A16 ) )
     => ( topological_t1_space @ ( product_prod @ A10 @ A16 ) ) ) ).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_511,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ( finite_finite @ A10 )
        & ( finite_finite @ A16 ) )
     => ( finite_finite @ ( product_prod @ A10 @ A16 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_512,axiom,
    ! [A10: $tType,A16: $tType] : ( size @ ( product_prod @ A10 @ A16 ) ) ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_513,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_514,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_515,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_516,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_517,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_518,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_519,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_520,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_521,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_522,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_523,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_524,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_525,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_526,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_527,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_528,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_529,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_530,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_531,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_532,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_533,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_534,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_535,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_536,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_537,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_538,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_539,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_540,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_541,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_542,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_543,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_544,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_545,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_546,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_547,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_548,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_549,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_550,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_551,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_552,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_553,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_554,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_555,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_556,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_557,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_558,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_559,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_560,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_561,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_562,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_563,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_564,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_565,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_566,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_567,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_568,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_569,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_570,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_571,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_572,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_573,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_574,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_575,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_576,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_577,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_578,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_579,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_580,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_581,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_582,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_583,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_584,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_585,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_586,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_587,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_588,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_589,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_590,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_591,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_592,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_593,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_594,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_595,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_596,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_597,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_598,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom_599,axiom,
    semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_600,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_601,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_602,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_603,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_604,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_605,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_606,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_607,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_608,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_609,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_610,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_611,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_612,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P3: $o] :
      ( ( P3 = $true )
      | ( P3 = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $false @ X2 @ Y2 )
      = Y2 ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $true @ X2 @ Y2 )
      = X2 ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P3: A > $o] :
      ( ( P3 @ ( fChoice @ A @ P3 ) )
      = ( ? [X8: A] : ( P3 @ X8 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ dega @ treeLista @ summarya ) @ ( extend4730790105801354508finity @ extended_enat ) )
    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ dega @ treeLista @ summarya ) ) ).

%------------------------------------------------------------------------------
